/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(V){for(var t=[],D=0,F=V.length;D<F;D++)t[D]=ne[V[D]];return t};const je=this,Ce=typeof global=="object"?global:{};var fe;(function(V){V.global=je;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof V.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}V.Environment=t})(fe||(fe={}));var fe;(function(V){class t{constructor(o,N,f){this.type=o,this.detail=N,this.timestamp=f}}V.LoaderEvent=t;class D{constructor(o){this._events=[new t(1,"",o)]}record(o,N){this._events.push(new t(o,N,V.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}V.LoaderEventRecorder=D;class F{record(o,N){}getEvents(){return[]}}F.INSTANCE=new F,V.NullLoaderEventRecorder=F})(fe||(fe={}));var fe;(function(V){class t{static fileUriToFilePath(F,r){if(r=decodeURI(r).replace(/%23/g,"#"),F){if(/^file:\/\/\//.test(r))return r.substr(8);if(/^file:\/\//.test(r))return r.substr(5)}else if(/^file:\/\//.test(r))return r.substr(7);return r}static startsWith(F,r){return F.length>=r.length&&F.substr(0,r.length)===r}static endsWith(F,r){return F.length>=r.length&&F.substr(F.length-r.length)===r}static containsQueryString(F){return/^[^\#]*\?/gi.test(F)}static isAbsolutePath(F){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(F)}static forEachProperty(F,r){if(F){let o;for(o in F)F.hasOwnProperty(o)&&r(o,F[o])}}static isEmpty(F){let r=!0;return t.forEachProperty(F,()=>{r=!1}),r}static recursiveClone(F){if(!F||typeof F!="object"||F instanceof RegExp||!Array.isArray(F)&&Object.getPrototypeOf(F)!==Object.prototype)return F;let r=Array.isArray(F)?[]:{};return t.forEachProperty(F,(o,N)=>{N&&typeof N=="object"?r[o]=t.recursiveClone(N):r[o]=N}),r}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(F){return t.startsWith(F,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=V.global.performance&&typeof V.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?V.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,V.Utilities=t})(fe||(fe={}));var fe;(function(V){function t(r){if(r instanceof Error)return r;const o=new Error(r.message||String(r)||"Unknown Error");return r.stack&&(o.stack=r.stack),o}V.ensureError=t;class D{static validateConfigurationOptions(o){function N(f){if(f.phase==="loading"){console.error('Loading "'+f.moduleId+'" failed'),console.error(f),console.error("Here are the modules that depend on it:"),console.error(f.neededBy);return}if(f.phase==="factory"){console.error('The factory function of "'+f.moduleId+'" has thrown an exception'),console.error(f),console.error("Here are the modules that depend on it:"),console.error(f.neededBy);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError>"u"&&(o.catchError=!1),typeof o.recordStats>"u"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=N),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(V.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags>"u"&&(o.preferScriptTags=!1),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){const f=t(new Error("INVALID cached data configuration, 'path' MUST be set"));f.phase="configuration",o.onError(f),o.nodeCachedData=void 0}return o}static mergeConfigurationOptions(o=null,N=null){let f=V.Utilities.recursiveClone(N||{});return V.Utilities.forEachProperty(o,(a,s)=>{a==="ignoreDuplicateModules"&&typeof f.ignoreDuplicateModules<"u"?f.ignoreDuplicateModules=f.ignoreDuplicateModules.concat(s):a==="paths"&&typeof f.paths<"u"?V.Utilities.forEachProperty(s,(h,A)=>f.paths[h]=A):a==="config"&&typeof f.config<"u"?V.Utilities.forEachProperty(s,(h,A)=>f.config[h]=A):f[a]=V.Utilities.recursiveClone(s)}),D.validateConfigurationOptions(f)}}V.ConfigurationOptionsUtil=D;class F{constructor(o,N){if(this._env=o,this.options=D.mergeConfigurationOptions(N),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let f=this.options.nodeRequire.main.filename,a=Math.max(f.lastIndexOf("/"),f.lastIndexOf("\\"));this.options.baseUrl=f.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],V.Utilities.forEachProperty(this.options.paths,(o,N)=>{Array.isArray(N)?this.sortedPathsRules.push({from:o,to:N}):this.sortedPathsRules.push({from:o,to:[N]})}),this.sortedPathsRules.sort((o,N)=>N.from.length-o.from.length)}cloneAndMerge(o){return new F(this._env,D.mergeConfigurationOptions(o,this.options))}getOptionsLiteral(){return this.options}_applyPaths(o){let N;for(let f=0,a=this.sortedPathsRules.length;f<a;f++)if(N=this.sortedPathsRules[f],V.Utilities.startsWith(o,N.from)){let s=[];for(let h=0,A=N.to.length;h<A;h++)s.push(N.to[h]+o.substr(N.from.length));return s}return[o]}_addUrlArgsToUrl(o){return V.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o}_addUrlArgsIfNecessaryToUrls(o){if(this.options.urlArgs)for(let N=0,f=o.length;N<f;N++)o[N]=this._addUrlArgsToUrl(o[N]);return o}moduleIdToPaths(o){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o))return this.isBuild()?["empty:"]:["node|"+o];let N=o,f;if(!V.Utilities.endsWith(N,".js")&&!V.Utilities.isAbsolutePath(N)){f=this._applyPaths(N);for(let a=0,s=f.length;a<s;a++)this.isBuild()&&f[a]==="empty:"||(V.Utilities.isAbsolutePath(f[a])||(f[a]=this.options.baseUrl+f[a]),!V.Utilities.endsWith(f[a],".js")&&!V.Utilities.containsQueryString(f[a])&&(f[a]=f[a]+".js"))}else!V.Utilities.endsWith(N,".js")&&!V.Utilities.containsQueryString(N)&&(N=N+".js"),f=[N];return this._addUrlArgsIfNecessaryToUrls(f)}requireToUrl(o){let N=o;return V.Utilities.isAbsolutePath(N)||(N=this._applyPaths(N)[0],V.Utilities.isAbsolutePath(N)||(N=this.options.baseUrl+N)),this._addUrlArgsIfNecessaryToUrl(N)}isBuild(){return this.options.isBuild}shouldInvokeFactory(o){return!!(!this.options.isBuild||V.Utilities.isAnonymousModule(o)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[o])}isDuplicateMessageIgnoredFor(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)}getConfigForModule(o){if(this.options.config)return this.options.config[o]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(o){this.options.onError(o)}}V.Configuration=F})(fe||(fe={}));var fe;(function(V){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,h,A,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new D:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new D;let g={callback:A,errorback:b};if(this._callbackMap.hasOwnProperty(h)){this._callbackMap[h].push(g);return}this._callbackMap[h]=[g],this._scriptLoader.load(s,h,()=>this.triggerCallback(h),e=>this.triggerErrorback(h,e))}triggerCallback(s){let h=this._callbackMap[s];delete this._callbackMap[s];for(let A=0;A<h.length;A++)h[A].callback()}triggerErrorback(s,h){let A=this._callbackMap[s];delete this._callbackMap[s];for(let b=0;b<A.length;b++)A[b].errorback(h)}}class D{attachListeners(s,h,A){let b=()=>{s.removeEventListener("load",g),s.removeEventListener("error",e)},g=E=>{b(),h()},e=E=>{b(),A(E)};s.addEventListener("load",g),s.addEventListener("error",e)}load(s,h,A,b){if(/^node\|/.test(h)){let g=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),g.nodeRequire||V.global.nodeRequire),E=h.split("|"),R=null;try{R=e(E[1])}catch(L){b(L);return}s.enqueueDefineAnonymousModule([],()=>R),A()}else{let g=document.createElement("script");g.setAttribute("async","async"),g.setAttribute("type","text/javascript"),this.attachListeners(g,A,b);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(h=e.createScriptURL(h)),g.setAttribute("src",h);const{cspNonce:E}=s.getConfig().getOptionsLiteral();E&&g.setAttribute("nonce",E),document.getElementsByTagName("head")[0].appendChild(g)}}}function F(a){const{trustedTypesPolicy:s}=a.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class r{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=F(s)),this._cachedCanUseEval}load(s,h,A,b){if(/^node\|/.test(h)){const g=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),g.nodeRequire||V.global.nodeRequire),E=h.split("|");let R=null;try{R=e(E[1])}catch(L){b(L);return}s.enqueueDefineAnonymousModule([],function(){return R}),A()}else{const{trustedTypesPolicy:g}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(h).then(E=>{if(E.status!==200)throw new Error(E.statusText);return E.text()}).then(E=>{E=`${E}
//# sourceURL=${h}`,(g?self.eval(g.createScript("",E)):new Function(E)).call(self),A()}).then(void 0,b);return}try{g&&(h=g.createScriptURL(h)),importScripts(h),A()}catch(E){b(E)}}}}class o{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,h){const{nodeCachedData:A}=h.getConfig().getOptionsLiteral();if(!A||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,g=s("module");function e(E){const R=E.constructor;let L=function(m){try{return E.require(m)}finally{}};return L.resolve=function(m,u){return R._resolveFilename(m,E,!1,u)},L.resolve.paths=function(m){return R._resolveLookupPaths(m,E)},L.main=process.mainModule,L.extensions=R._extensions,L.cache=R._cache,L}g.prototype._compile=function(E,R){const L=g.wrap(E.replace(/^#!.*/,"")),$=h.getRecorder(),m=b._getCachedDataPath(A,R),u={filename:R};let c;try{const p=b._fs.readFileSync(m);c=p.slice(0,16),u.cachedData=p.slice(16),$.record(60,m)}catch{$.record(61,m)}const i=new b._vm.Script(L,u),l=i.runInThisContext(u),v=b._path.dirname(R),d=e(this),w=[this.exports,d,this,R,v,process,Ce,Buffer],M=l.apply(this.exports,w);return b._handleCachedData(i,L,m,!u.cachedData,h),b._verifyCachedData(i,L,m,c,h),M}}load(s,h,A,b){const g=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),g.nodeRequire||V.global.nodeRequire),E=g.nodeInstrumenter||function(L){return L};this._init(e),this._initNodeRequire(e,s);let R=s.getRecorder();if(/^node\|/.test(h)){let L=h.split("|"),$=null;try{$=e(L[1])}catch(m){b(m);return}s.enqueueDefineAnonymousModule([],()=>$),A()}else{h=V.Utilities.fileUriToFilePath(this._env.isWindows,h);const L=this._path.normalize(h),$=this._getElectronRendererScriptPathOrUri(L),m=!!g.nodeCachedData,u=m?this._getCachedDataPath(g.nodeCachedData,h):void 0;this._readSourceAndCachedData(L,u,R,(c,i,l,v)=>{if(c){b(c);return}let d;i.charCodeAt(0)===o._BOM?d=o._PREFIX+i.substring(1)+o._SUFFIX:d=o._PREFIX+i+o._SUFFIX,d=E(d,L);const w={filename:$,cachedData:l},M=this._createAndEvalScript(s,d,w,A,b);this._handleCachedData(M,d,u,m&&!l,s),this._verifyCachedData(M,d,u,v,s)})}}_createAndEvalScript(s,h,A,b,g){const e=s.getRecorder();e.record(31,A.filename);const E=new this._vm.Script(h,A),R=E.runInThisContext(A),L=s.getGlobalAMDDefineFunc();let $=!1;const m=function(){return $=!0,L.apply(null,arguments)};return m.amd=L.amd,R.call(V.global,s.getGlobalAMDRequireFunc(),m,A.filename,this._path.dirname(A.filename)),e.record(32,A.filename),$?b():g(new Error(`Didn't receive define call in ${A.filename}!`)),E}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let h=s.match(/^([a-z])\:(.*)/i);return h?`file:///${(h[1].toUpperCase()+":"+h[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,h){const A=this._crypto.createHash("md5").update(h,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(h).replace(/\.js$/,"");return this._path.join(s.path,`${b}-${A}.code`)}_handleCachedData(s,h,A,b,g){s.cachedDataRejected?this._fs.unlink(A,e=>{g.getRecorder().record(62,A),this._createAndWriteCachedData(s,h,A,g),e&&g.getConfig().onError(e)}):b&&this._createAndWriteCachedData(s,h,A,g)}_createAndWriteCachedData(s,h,A,b){let g=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,E=0,R;const L=()=>{setTimeout(()=>{R||(R=this._crypto.createHash("md5").update(h,"utf8").digest());const $=s.createCachedData();if(!($.length===0||$.length===e||E>=5)){if($.length<e){L();return}e=$.length,this._fs.writeFile(A,Buffer.concat([R,$]),m=>{m&&b.getConfig().onError(m),b.getRecorder().record(63,A),L()})}},g*Math.pow(4,E++))};L()}_readSourceAndCachedData(s,h,A,b){if(!h)this._fs.readFile(s,{encoding:"utf8"},b);else{let g,e,E,R=2;const L=$=>{$?b($):--R===0&&b(void 0,g,e,E)};this._fs.readFile(s,{encoding:"utf8"},($,m)=>{g=m,L($)}),this._fs.readFile(h,($,m)=>{!$&&m&&m.length>0?(E=m.slice(0,16),e=m.slice(16),A.record(60,h)):A.record(61,h),L()})}}_verifyCachedData(s,h,A,b,g){b&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(h,"utf8").digest();b.equals(e)||(g.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${A}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(A,E=>{E&&g.getConfig().onError(E)}))},Math.ceil(5e3*(1+Math.random()))))}}o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`;function N(a,s){if(s.__$__isRecorded)return s;const h=function(b){a.record(33,b);try{return s(b)}finally{a.record(34,b)}};return h.__$__isRecorded=!0,h}V.ensureRecordedNodeRequire=N;function f(a){return new t(a)}V.createScriptLoader=f})(fe||(fe={}));var fe;(function(V){class t{constructor(a){let s=a.lastIndexOf("/");s!==-1?this.fromModulePath=a.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(a){let s=a,h;for(h=/\/\.\//;h.test(s);)s=s.replace(h,"/");for(s=s.replace(/^\.\//g,""),h=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;h.test(s);)s=s.replace(h,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(a){let s=a;return V.Utilities.isAbsolutePath(s)||(V.Utilities.startsWith(s,"./")||V.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),V.ModuleIdResolver=t;class D{constructor(a,s,h,A,b,g){this.id=a,this.strId=s,this.dependencies=h,this._callback=A,this._errorback=b,this.moduleIdResolver=g,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,s){try{return{returnedValue:a.apply(V.global,s),producedError:null}}catch(h){return{returnedValue:null,producedError:h}}}static _invokeFactory(a,s,h,A){return a.shouldInvokeFactory(s)?a.shouldCatchError()?this._safeInvokeFunction(h,A):{returnedValue:h.apply(V.global,A),producedError:null}:{returnedValue:null,producedError:null}}complete(a,s,h,A){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let g=D._invokeFactory(s,this.strId,this._callback,h);b=g.producedError,a.record(22,this.strId),!b&&typeof g.returnedValue<"u"&&(!this.exportsPassedIn||V.Utilities.isEmpty(this.exports))&&(this.exports=g.returnedValue)}else this.exports=this._callback;if(b){let g=V.ensureError(b);g.phase="factory",g.moduleId=this.strId,g.neededBy=A(this.id),this.error=g,s.onError(g)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}V.Module=D;class F{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let s=this._strModuleIdToIntModuleId.get(a);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(a,s),this._intModuleIdToStrModuleId[s]=a),s}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class r{constructor(a){this.id=a}}r.EXPORTS=new r(0),r.MODULE=new r(1),r.REQUIRE=new r(2),V.RegularDependency=r;class o{constructor(a,s,h){this.id=a,this.pluginId=s,this.pluginParam=h}}V.PluginDependency=o;class N{constructor(a,s,h,A,b=0){this._env=a,this._scriptLoader=s,this._loaderAvailableTimestamp=b,this._defineFunc=h,this._requireFunc=A,this._moduleIdProvider=new F,this._config=new V.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new N(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,s){let h=g=>g.replace(/\\/g,"/"),A=h(a),b=s.split(/\n/);for(let g=0;g<b.length;g++){let e=b[g].match(/(.*):(\d+):(\d+)\)?$/);if(e){let E=e[1],R=e[2],L=e[3],$=Math.max(E.lastIndexOf(" ")+1,E.lastIndexOf("(")+1);if(E=E.substr($),E=h(E),E===A){let m={line:parseInt(R,10),col:parseInt(L,10)};return m.line===1&&(m.col-=53),m}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],s=0;for(let h=0,A=this._modules2.length;h<A;h++){let b=this._modules2[h];if(!b)continue;let g=this._buildInfoPath[b.id]||null,e=this._buildInfoDefineStack[b.id]||null,E=this._buildInfoDependencies[b.id];a[s++]={id:b.strId,path:g,defineLocation:g&&e?N._findRelevantLocationInStack(g,e):null,dependencies:E,shim:null,exports:b.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new V.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=V.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let h=null;this._config.isBuild()&&(h=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:h,dependencies:a,callback:s}}defineModule(a,s,h,A,b,g=new t(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let E=new D(e,a,this._normalizeDependencies(s,g),h,A,g);this._modules2[e]=E,this._config.isBuild()&&(this._buildInfoDefineStack[e]=b,this._buildInfoDependencies[e]=(E.dependencies||[]).map(R=>this._moduleIdProvider.getStrModuleId(R.id))),this._resolve(E)}_normalizeDependency(a,s){if(a==="exports")return r.EXPORTS;if(a==="module")return r.MODULE;if(a==="require")return r.REQUIRE;let h=a.indexOf("!");if(h>=0){let A=s.resolveModule(a.substr(0,h)),b=s.resolveModule(a.substr(h+1)),g=this._moduleIdProvider.getModuleId(A+"!"+b),e=this._moduleIdProvider.getModuleId(A);return new o(g,e,b)}return new r(this._moduleIdProvider.getModuleId(s.resolveModule(a)))}_normalizeDependencies(a,s){let h=[],A=0;for(let b=0,g=a.length;b<g;b++)h[A++]=this._normalizeDependency(a[b],s);return h}_relativeRequire(a,s,h,A){if(typeof s=="string")return this.synchronousRequire(s,a);this.defineModule(V.Utilities.generateAnonymousModule(),s,h,A,null,a)}synchronousRequire(a,s=new t(a)){let h=this._normalizeDependency(a,s),A=this._modules2[h.id];if(!A)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!A.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(A.error)throw A.error;return A.exports}configure(a,s){let h=this._config.shouldRecordStats();s?this._config=new V.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!h&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),s.dependencies,s.callback,null,s.stack)}}_createLoadError(a,s){let h=this._moduleIdProvider.getStrModuleId(a),A=(this._inverseDependencies2[a]||[]).map(g=>this._moduleIdProvider.getStrModuleId(g));const b=V.ensureError(s);return b.phase="loading",b.moduleId=h,b.neededBy=A,b}_onLoadError(a,s){const h=this._createLoadError(a,s);this._modules2[a]||(this._modules2[a]=new D(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let A=[];for(let e=0,E=this._moduleIdProvider.getMaxModuleId();e<E;e++)A[e]=!1;let b=!1,g=[];for(g.push(a),A[a]=!0;g.length>0;){let e=g.shift(),E=this._modules2[e];E&&(b=E.onDependencyError(h)||b);let R=this._inverseDependencies2[e];if(R)for(let L=0,$=R.length;L<$;L++){let m=R[L];A[m]||(g.push(m),A[m]=!0)}}b||this._config.onError(h)}_hasDependencyPath(a,s){let h=this._modules2[a];if(!h)return!1;let A=[];for(let g=0,e=this._moduleIdProvider.getMaxModuleId();g<e;g++)A[g]=!1;let b=[];for(b.push(h),A[a]=!0;b.length>0;){let e=b.shift().dependencies;if(e)for(let E=0,R=e.length;E<R;E++){let L=e[E];if(L.id===s)return!0;let $=this._modules2[L.id];$&&!A[L.id]&&(A[L.id]=!0,b.push($))}}return!1}_findCyclePath(a,s,h){if(a===s||h===50)return[a];let A=this._modules2[a];if(!A)return null;let b=A.dependencies;if(b)for(let g=0,e=b.length;g<e;g++){let E=this._findCyclePath(b[g].id,s,h+1);if(E!==null)return E.push(a),E}return null}_createRequire(a){let s=(h,A,b)=>this._relativeRequire(a,h,A,b);return s.toUrl=h=>this._config.requireToUrl(a.resolveModule(h)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(h,A=!1)=>{this.configure(h,A)},s.__$__nodeRequire=V.global.nodeRequire,s}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let s=this._moduleIdProvider.getStrModuleId(a),h=this._config.moduleIdToPaths(s),A=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||A.test(s))&&h.push("node|"+s);let b=-1,g=e=>{if(b++,b>=h.length)this._onLoadError(a,e);else{let E=h[b],R=this.getRecorder();if(this._config.isBuild()&&E==="empty:"){this._buildInfoPath[a]=E,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}R.record(10,E),this._scriptLoader.load(this,E,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=E),R.record(11,E),this._onLoad(a)},L=>{R.record(12,E),g(L)})}};g(null)}_loadPluginDependency(a,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let h=A=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],A,null,null)};h.error=A=>{this._config.onError(this._createLoadError(s.id,A))},a.load(s.pluginParam,this._createRequire(t.ROOT),h,this._config.getOptionsLiteral())}_resolve(a){let s=a.dependencies;if(s)for(let h=0,A=s.length;h<A;h++){let b=s[h];if(b===r.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(b===r.MODULE){a.unresolvedDependenciesCount--;continue}if(b===r.REQUIRE){a.unresolvedDependenciesCount--;continue}let g=this._modules2[b.id];if(g&&g.isComplete()){if(g.error){a.onDependencyError(g.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(b.id,a.id,0)||[];e.reverse(),e.push(b.id),console.warn(e.map(E=>this._moduleIdProvider.getStrModuleId(E)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(a.id),b instanceof o){let e=this._modules2[b.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,b);continue}let E=this._inversePluginDependencies2.get(b.pluginId);E||(E=[],this._inversePluginDependencies2.set(b.pluginId,E)),E.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let s=this.getRecorder();if(a.isComplete())return;let h=a.dependencies,A=[];if(h)for(let E=0,R=h.length;E<R;E++){let L=h[E];if(L===r.EXPORTS){A[E]=a.exports;continue}if(L===r.MODULE){A[E]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(L===r.REQUIRE){A[E]=this._createRequire(a.moduleIdResolver);continue}let $=this._modules2[L.id];if($){A[E]=$.exports;continue}A[E]=null}const b=E=>(this._inverseDependencies2[E]||[]).map(R=>this._moduleIdProvider.getStrModuleId(R));a.complete(s,this._config,A,b);let g=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,g)for(let E=0,R=g.length;E<R;E++){let L=g[E],$=this._modules2[L];$.unresolvedDependenciesCount--,$.unresolvedDependenciesCount===0&&this._onModuleComplete($)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let E=0,R=e.length;E<R;E++)this._loadPluginDependency(a.exports,e[E])}}}V.ModuleManager=N})(fe||(fe={}));var te,fe;(function(V){const t=new V.Environment;let D=null;const F=function(f,a,s){typeof f!="string"&&(s=a,a=f,f=null),(typeof a!="object"||!Array.isArray(a))&&(s=a,a=null),a||(a=["require","exports","module"]),f?D.defineModule(f,a,s,null,null):D.enqueueDefineAnonymousModule(a,s)};F.amd={jQuery:!0};const r=function(f,a=!1){D.configure(f,a)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){r(arguments[0]);return}if(typeof arguments[0]=="string")return D.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){D.defineModule(V.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=r,o.getConfig=function(){return D.getConfig().getOptionsLiteral()},o.reset=function(){D=D.reset()},o.getBuildInfo=function(){return D.getBuildInfo()},o.getStats=function(){return D.getLoaderEvents()},o.define=F;function N(){if(typeof V.global.require<"u"||typeof require<"u"){const f=V.global.require||require;if(typeof f=="function"&&typeof f.resolve=="function"){const a=V.ensureRecordedNodeRequire(D.getRecorder(),f);V.global.nodeRequire=a,o.nodeRequire=a,o.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=o:(t.isElectronRenderer||(V.global.define=F),V.global.require=o)}V.init=N,(typeof V.global.define!="function"||!V.global.define.amd)&&(D=new V.ModuleManager(t,V.createScriptLoader(t),F,o,V.Utilities.getHighPerformanceTimestamp()),typeof V.global.require<"u"&&typeof V.global.require!="function"&&o.config(V.global.require),te=function(){return F.apply(null,arguments)},te.amd=F.amd,typeof doNotInitLoader>"u"&&N())})(fe||(fe={})),te(ne[69],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function D(f,a,s,h){if(h=h||{},(h["vs/css"]||{}).disabled){s({});return}const b=a.toUrl(f+".css");F(f,b,()=>{s({})},g=>{typeof s.error=="function"&&s.error("Could not find "+b+".")})}t.load=D;function F(f,a,s,h){if(r(f,a)){s();return}o(f,a,s,h)}function r(f,a){const s=window.document.getElementsByTagName("link");for(let h=0,A=s.length;h<A;h++){const b=s[h].getAttribute("data-name"),g=s[h].getAttribute("href");if(b===f||g===a)return!0}return!1}function o(f,a,s,h){const A=document.createElement("link");A.setAttribute("rel","stylesheet"),A.setAttribute("type","text/css"),A.setAttribute("data-name",f),N(f,A,s,h),A.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(A)}function N(f,a,s,h){const A=()=>{a.removeEventListener("load",b),a.removeEventListener("error",g)},b=e=>{A(),s()},g=e=>{A(),h(e)};a.addEventListener("load",b),a.addEventListener("error",g)}}),te("vs/nls",["require","exports"],function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize2=t.localize=void 0;let D=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const F="i-default";function r(R,L){let $;return L.length===0?$=R:$=R.replace(/\{(\d+)\}/g,(m,u)=>{const c=u[0],i=L[c];let l=m;return typeof i=="string"?l=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(l=String(i)),l}),D&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),$}function o(R,L){let $=R[L];return $||($=R["*"],$)?$:null}function N(R){return R.charAt(R.length-1)==="/"?R:R+"/"}async function f(R,L,$){const m=N(R)+N(L)+"vscode/"+N($),u=await fetch(m);if(u.ok)return await u.json();throw new Error(`${u.status} - ${u.statusText}`)}function a(R){return function(L,$){const m=Array.prototype.slice.call(arguments,2);return r(R[L],m)}}function s(R){return(L,$,...m)=>({value:r(R[L],m),original:r($,m)})}function h(R,L,...$){return r(L,$)}t.localize=h;function A(R,L,...$){const m=r(L,$);return{value:m,original:m}}t.localize2=A;function b(R){}t.getConfiguredDefaultLocale=b;function g(R){D=R}t.setPseudoTranslation=g;function e(R,L){return{localize:a(L[R]),localize2:s(L[R]),getConfiguredDefaultLocale:L.getConfiguredDefaultLocale??($=>{})}}t.create=e;function E(R,L,$,m){const u=m["vs/nls"]??{};if(!R||R.length===0)return $({localize:h,localize2:A,getConfiguredDefaultLocale:()=>u.availableLanguages?.["*"]});const c=u.availableLanguages?o(u.availableLanguages,R):null,i=c===null||c===F;let l=".nls";i||(l=l+"."+c);const v=d=>{Array.isArray(d)?(d.localize=a(d),d.localize2=s(d)):(d.localize=a(d[R]),d.localize2=s(d[R])),d.getConfiguredDefaultLocale=()=>u.availableLanguages?.["*"],$(d)};typeof u.loadBundle=="function"?u.loadBundle(R,c,(d,w)=>{d?L([R+".nls"],v):v(w)}):u.translationServiceUrl&&!i?(async()=>{try{const d=await f(u.translationServiceUrl,c,R);return v(d)}catch(d){if(!c.includes("-"))return console.error(d),L([R+".nls"],v);try{const w=c.split("-")[0],M=await f(u.translationServiceUrl,w,R);return u.availableLanguages??={},u.availableLanguages["*"]=w,v(M)}catch(w){return console.error(w),L([R+".nls"],v)}}})():L([R+l],v,d=>{if(l===".nls"){console.error("Failed trying to load default language strings",d);return}console.error(`Failed to load message bundle for language ${c}. Falling back to the default language:`,d),L([R+".nls"],v)})}t.load=E}),function(){const V=globalThis.MonacoEnvironment,t=V&&V.baseUrl?V.baseUrl:"../../../";function D(h,A){if(V?.createTrustedTypesPolicy)try{return V.createTrustedTypesPolicy(h,A)}catch(b){console.warn(b);return}try{return self.trustedTypes?.createPolicy(h,A)}catch(b){console.warn(b);return}}const F=D("amdLoader",{createScriptURL:h=>h,createScript:(h,...A)=>{const b=A.slice(0,-1).join(","),g=A.pop().toString();return`(function anonymous(${b}) { ${g}
})`}});function r(){try{return(F?globalThis.eval(F.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function o(){return new Promise((h,A)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return h();const b=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch(b).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${b}`,(F?globalThis.eval(F.createScript("",e)):new Function(e)).call(globalThis),h()}).then(void 0,A);return}F?importScripts(F.createScriptURL(b)):importScripts(b),h()})}function N(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:F,amdModulesPattern:/^vs\//})}function f(h){o().then(()=>{N(),require([h],function(A){setTimeout(function(){const b=A.create((g,e)=>{globalThis.postMessage(g,e)},null);for(globalThis.onmessage=g=>b.onmessage(g.data,g.ports);s.length>0;){const g=s.shift();b.onmessage(g.data,g.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&N();let a=!0;const s=[];globalThis.onmessage=h=>{if(!a){s.push(h);return}a=!1,f(h.data)}}(),te(ne[9],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function D(E,R,L){const $=F(E,R);if($!==-1)return E[$]}t.$fb=D;function F(E,R,L=E.length-1){for(let $=L;$>=0;$--){const m=E[$];if(R(m))return $}return-1}t.$gb=F;function r(E,R){const L=o(E,R);return L===-1?void 0:E[L]}t.$hb=r;function o(E,R,L=0,$=E.length){let m=L,u=$;for(;m<u;){const c=Math.floor((m+u)/2);R(E[c])?m=c+1:u=c}return m-1}t.$ib=o;function N(E,R){const L=f(E,R);return L===E.length?void 0:E[L]}t.$jb=N;function f(E,R,L=0,$=E.length){let m=L,u=$;for(;m<u;){const c=Math.floor((m+u)/2);R(E[c])?u=c:m=c+1}return m}t.$kb=f;function a(E,R,L=0,$=E.length){const m=f(E,R,L,$);return m===E.length?-1:m}t.$lb=a;class s{static{this.assertInvariants=!1}constructor(R){this.e=R,this.c=0}findLastMonotonous(R){if(s.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!R($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=R}const L=o(this.e,R,this.c);return this.c=L+1,L===-1?void 0:this.e[L]}}t.$mb=s;function h(E,R){if(E.length===0)return;let L=E[0];for(let $=1;$<E.length;$++){const m=E[$];R(m,L)>0&&(L=m)}return L}t.$nb=h;function A(E,R){if(E.length===0)return;let L=E[0];for(let $=1;$<E.length;$++){const m=E[$];R(m,L)>=0&&(L=m)}return L}t.$ob=A;function b(E,R){return h(E,(L,$)=>-R(L,$))}t.$pb=b;function g(E,R){if(E.length===0)return-1;let L=0;for(let $=1;$<E.length;$++){const m=E[$];R(m,E[L])>0&&(L=$)}return L}t.$qb=g;function e(E,R){for(const L of E){const $=R(L);if($!==void 0)return $}}t.$rb=e}),te(ne[34],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N=t.$M=t.$L=t.$K=void 0;function D(N,f){const a=Object.create(null);for(const s of N){const h=f(s);let A=a[h];A||(A=a[h]=[]),A.push(s)}return a}t.$K=D;function F(N,f){const a=[],s=[];for(const h of N)f.has(h)||a.push(h);for(const h of f)N.has(h)||s.push(h);return{removed:a,added:s}}t.$L=F;function r(N,f){const a=[],s=[];for(const[h,A]of N)f.has(h)||a.push(A);for(const[h,A]of f)N.has(h)||s.push(A);return{removed:a,added:s}}t.$M=r;function o(N,f){const a=new Set;for(const s of f)N.has(s)&&a.add(s);return a}t.$N=o}),te(ne[35],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ot=t.$nt=t.$mt=t.$lt=void 0;function D(f,a){const s=Math.pow(10,a);return Math.round(f*s)/s}class F{constructor(a,s,h,A=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,h))|0,this.a=D(Math.max(Math.min(1,A),0),3)}static equals(a,s){return a.r===s.r&&a.g===s.g&&a.b===s.b&&a.a===s.a}}t.$lt=F;class r{constructor(a,s,h,A){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=D(Math.max(Math.min(1,s),0),3),this.l=D(Math.max(Math.min(1,h),0),3),this.a=D(Math.max(Math.min(1,A),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.l===s.l&&a.a===s.a}static fromRGBA(a){const s=a.r/255,h=a.g/255,A=a.b/255,b=a.a,g=Math.max(s,h,A),e=Math.min(s,h,A);let E=0,R=0;const L=(e+g)/2,$=g-e;if($>0){switch(R=Math.min(L<=.5?$/(2*L):$/(2-2*L),1),g){case s:E=(h-A)/$+(h<A?6:0);break;case h:E=(A-s)/$+2;break;case A:E=(s-h)/$+4;break}E*=60,E=Math.round(E)}return new r(E,R,L,b)}static i(a,s,h){return h<0&&(h+=1),h>1&&(h-=1),h<1/6?a+(s-a)*6*h:h<1/2?s:h<2/3?a+(s-a)*(2/3-h)*6:a}static toRGBA(a){const s=a.h/360,{s:h,l:A,a:b}=a;let g,e,E;if(h===0)g=e=E=A;else{const R=A<.5?A*(1+h):A+h-A*h,L=2*A-R;g=r.i(L,R,s+1/3),e=r.i(L,R,s),E=r.i(L,R,s-1/3)}return new F(Math.round(g*255),Math.round(e*255),Math.round(E*255),b)}}t.$mt=r;class o{constructor(a,s,h,A){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=D(Math.max(Math.min(1,s),0),3),this.v=D(Math.max(Math.min(1,h),0),3),this.a=D(Math.max(Math.min(1,A),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.v===s.v&&a.a===s.a}static fromRGBA(a){const s=a.r/255,h=a.g/255,A=a.b/255,b=Math.max(s,h,A),g=Math.min(s,h,A),e=b-g,E=b===0?0:e/b;let R;return e===0?R=0:b===s?R=((h-A)/e%6+6)%6:b===h?R=(A-s)/e+2:R=(s-h)/e+4,new o(Math.round(R*60),E,b,a.a)}static toRGBA(a){const{h:s,s:h,v:A,a:b}=a,g=A*h,e=g*(1-Math.abs(s/60%2-1)),E=A-g;let[R,L,$]=[0,0,0];return s<60?(R=g,L=e):s<120?(R=e,L=g):s<180?(L=g,$=e):s<240?(L=e,$=g):s<300?(R=e,$=g):s<=360&&(R=g,$=e),R=Math.round((R+E)*255),L=Math.round((L+E)*255),$=Math.round(($+E)*255),new F(R,L,$,b)}}t.$nt=o;class N{static fromHex(a){return N.Format.CSS.parseHex(a)||N.red}static equals(a,s){return!a&&!s?!0:!a||!s?!1:a.equals(s)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:o.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof F)this.rgba=a;else if(a instanceof r)this.i=a,this.rgba=r.toRGBA(a);else if(a instanceof o)this.j=a,this.rgba=o.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&F.equals(this.rgba,a.rgba)&&r.equals(this.hsla,a.hsla)&&o.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=N.k(this.rgba.r),s=N.k(this.rgba.g),h=N.k(this.rgba.b),A=.2126*a+.7152*s+.0722*h;return D(A,4)}static k(a){const s=a/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(a){const s=this.getRelativeLuminance(),h=a.getRelativeLuminance();return s>h?(s+.05)/(h+.05):(h+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const s=this.getRelativeLuminance(),h=a.getRelativeLuminance();return s>h}isDarkerThan(a){const s=this.getRelativeLuminance(),h=a.getRelativeLuminance();return s<h}lighten(a){return new N(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new N(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:s,g:h,b:A,a:b}=this.rgba;return new N(new F(s,h,A,b*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new N(new F(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const s=a.rgba,h=this.rgba.a,A=s.a,b=h+A*(1-h);if(b<1e-6)return N.transparent;const g=this.rgba.r*h/b+s.r*A*(1-h)/b,e=this.rgba.g*h/b+s.g*A*(1-h)/b,E=this.rgba.b*h/b+s.b*A*(1-h)/b;return new N(new F(g,e,E,b))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:s,g:h,b:A,a:b}=this.rgba;return new N(new F(a.rgba.r-b*(a.rgba.r-s),a.rgba.g-b*(a.rgba.g-h),a.rgba.b-b*(a.rgba.b-A),1))}flatten(...a){const s=a.reduceRight((h,A)=>N.o(A,h));return N.o(this,s)}static o(a,s){const h=1-a.rgba.a;return new N(new F(h*s.rgba.r+a.rgba.a*a.rgba.r,h*s.rgba.g+a.rgba.a*a.rgba.g,h*s.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this.u||(this.u=N.Format.CSS.format(this)),this.u}static getLighterColor(a,s,h){if(a.isLighterThan(s))return a;h=h||.5;const A=a.getRelativeLuminance(),b=s.getRelativeLuminance();return h=h*(b-A)/b,a.lighten(h)}static getDarkerColor(a,s,h){if(a.isDarkerThan(s))return a;h=h||.5;const A=a.getRelativeLuminance(),b=s.getRelativeLuminance();return h=h*(A-b)/A,a.darken(h)}static{this.white=new N(new F(255,255,255,1))}static{this.black=new N(new F(0,0,0,1))}static{this.red=new N(new F(255,0,0,1))}static{this.blue=new N(new F(0,0,255,1))}static{this.green=new N(new F(0,255,0,1))}static{this.cyan=new N(new F(0,255,255,1))}static{this.lightgrey=new N(new F(211,211,211,1))}static{this.transparent=new N(new F(0,0,0,0))}}t.$ot=N,function(f){let a;(function(s){let h;(function(A){function b(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:f.Format.CSS.formatRGBA(i)}A.formatRGB=b;function g(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}A.formatRGBA=g;function e(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:f.Format.CSS.formatHSLA(i)}A.formatHSL=e;function E(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}A.formatHSLA=E;function R(i){const l=i.toString(16);return l.length!==2?"0"+l:l}function L(i){return`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}`}A.formatHex=L;function $(i,l=!1){return l&&i.rgba.a===1?f.Format.CSS.formatHex(i):`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}${R(Math.round(i.rgba.a*255))}`}A.formatHexA=$;function m(i){return i.isOpaque()?f.Format.CSS.formatHex(i):f.Format.CSS.formatRGBA(i)}A.format=m;function u(i){const l=i.length;if(l===0||i.charCodeAt(0)!==35)return null;if(l===7){const v=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),d=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),w=16*c(i.charCodeAt(5))+c(i.charCodeAt(6));return new f(new F(v,d,w,1))}if(l===9){const v=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),d=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),w=16*c(i.charCodeAt(5))+c(i.charCodeAt(6)),M=16*c(i.charCodeAt(7))+c(i.charCodeAt(8));return new f(new F(v,d,w,M/255))}if(l===4){const v=c(i.charCodeAt(1)),d=c(i.charCodeAt(2)),w=c(i.charCodeAt(3));return new f(new F(16*v+v,16*d+d,16*w+w))}if(l===5){const v=c(i.charCodeAt(1)),d=c(i.charCodeAt(2)),w=c(i.charCodeAt(3)),M=c(i.charCodeAt(4));return new f(new F(16*v+v,16*d+d,16*w+w,(16*M+M)/255))}return null}A.parseHex=u;function c(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(h=s.CSS||(s.CSS={}))})(a=f.Format||(f.Format={}))}(N||(t.$ot=N={}))}),te(ne[36],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zs=void 0;class D{constructor(r,o,N,f){this.originalStart=r,this.originalLength=o,this.modifiedStart=N,this.modifiedLength=f}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Zs=D}),te(ne[3],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class D{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?m.isErrorNoTelemetry(i)?new m(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(l=>{l(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}t.$W=D,t.$X=new D;function F(c){t.$X.setUnexpectedErrorHandler(c)}t.setUnexpectedErrorHandler=F;function r(c){if(!c||typeof c!="object")return!1;const i=c;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}t.$Z=r;function o(c){s(c)||t.$X.onUnexpectedError(c)}t.$1=o;function N(c){s(c)||t.$X.onUnexpectedExternalError(c)}t.$2=N;function f(c){if(c instanceof Error){const{name:i,message:l}=c,v=c.stacktrace||c.stack;return{$isError:!0,name:i,message:l,stack:v,noTelemetry:m.isErrorNoTelemetry(c)}}return c}t.$3=f;const a="Canceled";function s(c){return c instanceof h?!0:c instanceof Error&&c.name===a&&c.message===a}t.$4=s;class h extends Error{constructor(){super(a),this.name=this.message}}t.$5=h;function A(){const c=new Error(a);return c.name=c.message,c}t.$6=A;function b(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}t.$7=b;function g(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}t.$8=g;class e extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function E(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}t.$0=E;class R extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}t.$$=R;class L extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}t.$_=L;class $ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=$;class m extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof m)return i;const l=new m;return l.message=i.message,l.stack=i.stack,l}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}t.$bb=m;class u extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}t.$cb=u}),te(ne[6],re([0,1,3,9]),function(V,t,D,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function r(U,C=0){return U[U.length-(1+C)]}t.$sb=r;function o(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}t.$tb=o;function N(U,C,j=(X,z)=>X===z){if(U===C)return!0;if(!U||!C||U.length!==C.length)return!1;for(let X=0,z=U.length;X<z;X++)if(!j(U[X],C[X]))return!1;return!0}t.$ub=N;function f(U,C){const j=U.length-1;C<j&&(U[C]=U[j]),U.pop()}t.$vb=f;function a(U,C,j){return s(U.length,X=>j(U[X],C))}t.$wb=a;function s(U,C){let j=0,X=U-1;for(;j<=X;){const z=(j+X)/2|0,H=C(z);if(H<0)j=z+1;else if(H>0)X=z-1;else return z}return-(j+1)}t.$xb=s;function h(U,C,j){if(U=U|0,U>=C.length)throw new TypeError("invalid index");const X=C[Math.floor(C.length*Math.random())],z=[],H=[],J=[];for(const K of C){const ie=j(K,X);ie<0?z.push(K):ie>0?H.push(K):J.push(K)}return U<z.length?h(U,z,j):U<z.length+J.length?J[0]:h(U-(z.length+J.length),H,j)}t.$yb=h;function A(U,C){const j=[];let X;for(const z of U.slice(0).sort(C))!X||C(X[0],z)!==0?(X=[z],j.push(X)):X.push(z);return j}t.$zb=A;function*b(U,C){let j,X;for(const z of U)X!==void 0&&C(X,z)?j.push(z):(j&&(yield j),j=[z]),X=z;j&&(yield j)}t.$Ab=b;function g(U,C){for(let j=0;j<=U.length;j++)C(j===0?void 0:U[j-1],j===U.length?void 0:U[j])}t.$Bb=g;function e(U,C){for(let j=0;j<U.length;j++)C(j===0?void 0:U[j-1],U[j],j+1===U.length?void 0:U[j+1])}t.$Cb=e;function E(U,C,j){const X=[];function z(K,ie,ue){if(ie===0&&ue.length===0)return;const ae=X[X.length-1];ae&&ae.start+ae.deleteCount===K?(ae.deleteCount+=ie,ae.toInsert.push(...ue)):X.push({start:K,deleteCount:ie,toInsert:ue})}let H=0,J=0;for(;;){if(H===U.length){z(H,0,C.slice(J));break}if(J===C.length){z(H,U.length-H,[]);break}const K=U[H],ie=C[J],ue=j(K,ie);ue===0?(H+=1,J+=1):ue<0?(z(H,1,[]),H+=1):ue>0&&(z(H,0,[ie]),J+=1)}return X}t.$Db=E;function R(U,C,j){const X=E(U,C,j),z=[],H=[];for(const J of X)z.push(...U.slice(J.start,J.start+J.deleteCount)),H.push(...J.toInsert);return{removed:z,added:H}}t.$Eb=R;function L(U,C,j){if(j===0)return[];const X=U.slice(0,j).sort(C);return m(U,C,X,j,U.length),X}t.top=L;function $(U,C,j,X,z){return j===0?Promise.resolve([]):new Promise((H,J)=>{(async()=>{const K=U.length,ie=U.slice(0,j).sort(C);for(let ue=j,ae=Math.min(j+X,K);ue<K;ue=ae,ae=Math.min(ae+X,K)){if(ue>j&&await new Promise(oe=>setTimeout(oe)),z&&z.isCancellationRequested)throw new D.$5;m(U,C,ie,ue,ae)}return ie})().then(H,J)})}t.$Gb=$;function m(U,C,j,X,z){for(const H=j.length;X<z;X++){const J=U[X];if(C(J,j[H-1])<0){j.pop();const K=(0,F.$kb)(j,ie=>C(J,ie)<0);j.splice(K,0,J)}}}function u(U){return U.filter(C=>!!C)}t.$Hb=u;function c(U){let C=0;for(let j=0;j<U.length;j++)U[j]&&(U[C]=U[j],C+=1);U.length=C}t.$Ib=c;function i(U,C,j){U.splice(j,0,U.splice(C,1)[0])}t.$Jb=i;function l(U){return!Array.isArray(U)||U.length===0}t.$Kb=l;function v(U){return Array.isArray(U)&&U.length>0}t.$Lb=v;function d(U,C=j=>j){const j=new Set;return U.filter(X=>{const z=C(X);return j.has(z)?!1:(j.add(z),!0)})}t.$Mb=d;function w(U){const C=new Set;return j=>{const X=U(j);return C.has(X)?!1:(C.add(X),!0)}}t.$Nb=w;function M(U,C){return U.length>0?U[0]:C}t.$Ob=M;function p(U,C){return U.length>0?U[U.length-1]:C}t.$Pb=p;function y(U,C,j=(X,z)=>X===z){let X=0;for(let z=0,H=Math.min(U.length,C.length);z<H&&j(U[z],C[z]);z++)X++;return X}t.$Qb=y;function _(U){return[].concat(...U)}t.$Rb=_;function k(U,C){let j=typeof C=="number"?U:0;typeof C=="number"?j=U:(j=0,C=U);const X=[];if(j<=C)for(let z=j;z<C;z++)X.push(z);else for(let z=j;z>C;z--)X.push(z);return X}t.$Sb=k;function S(U,C,j){return U.reduce((X,z)=>(X[C(z)]=j?j(z):z,X),Object.create(null))}t.$Tb=S;function T(U,C){return U.push(C),()=>q(U,C)}t.$Ub=T;function q(U,C){const j=U.indexOf(C);if(j>-1)return U.splice(j,1),C}t.$Vb=q;function O(U,C,j){const X=U.slice(0,C),z=U.slice(C);return X.concat(j,z)}t.$Wb=O;function P(U,C){let j;if(typeof C=="number"){let X=C;j=()=>{const z=Math.sin(X++)*179426549;return z-Math.floor(z)}}else j=Math.random;for(let X=U.length-1;X>0;X-=1){const z=Math.floor(j()*(X+1)),H=U[X];U[X]=U[z],U[z]=H}}t.$Xb=P;function W(U,C){const j=U.indexOf(C);j>-1&&(U.splice(j,1),U.unshift(C))}t.$Yb=W;function G(U,C){const j=U.indexOf(C);j>-1&&(U.splice(j,1),U.push(C))}t.$Zb=G;function x(U,C){for(const j of C)U.push(j)}t.$1b=x;function Q(U,C){return Array.isArray(U)?U.map(C):C(U)}t.$2b=Q;function ee(U){return Array.isArray(U)?U:[U]}t.$3b=ee;function n(U){return U[Math.floor(Math.random()*U.length)]}t.$4b=n;function le(U,C,j){const X=be(U,C),z=U.length,H=j.length;U.length=z+H;for(let J=z-1;J>=X;J--)U[J+H]=U[J];for(let J=0;J<H;J++)U[J+X]=j[J]}t.$5b=le;function he(U,C,j,X){const z=be(U,C);let H=U.splice(z,j);return H===void 0&&(H=[]),le(U,z,X),H}t.$6b=he;function be(U,C){return C<0?Math.max(C+U.length,0):Math.min(C,U.length)}var ve;(function(U){function C(H){return H<0}U.isLessThan=C;function j(H){return H<=0}U.isLessThanOrEqual=j;function X(H){return H>0}U.isGreaterThan=X;function z(H){return H===0}U.isNeitherLessOrGreaterThan=z,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(ve||(t.CompareResult=ve={}));function ke(U,C){return(j,X)=>C(U(j),U(X))}t.$7b=ke;function $e(...U){return(C,j)=>{for(const X of U){const z=X(C,j);if(!ve.isNeitherLessOrGreaterThan(z))return z}return ve.neitherLessOrGreaterThan}}t.$8b=$e;const Ae=(U,C)=>U-C;t.$9b=Ae;const _e=(U,C)=>(0,t.$9b)(U?1:0,C?1:0);t.$0b=_e;function Te(U){return(C,j)=>-U(C,j)}t.$$b=Te;class Se{constructor(C){this.g=C,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(C){let j=this.c;for(;j<this.g.length&&C(this.g[j]);)j++;const X=j===this.c?null:this.g.slice(this.c,j);return this.c=j,X}takeFromEndWhile(C){let j=this.d;for(;j>=0&&C(this.g[j]);)j--;const X=j===this.d?null:this.g.slice(j+1,this.d+1);return this.d=j,X}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const C=this.g[this.c];return this.c++,C}removeLast(){const C=this.g[this.d];return this.d--,C}takeCount(C){const j=this.g.slice(this.c,this.c+C);return this.c+=C,j}}t.$_b=Se;class Re{static{this.empty=new Re(C=>{})}constructor(C){this.iterate=C}forEach(C){this.iterate(j=>(C(j),!0))}toArray(){const C=[];return this.iterate(j=>(C.push(j),!0)),C}filter(C){return new Re(j=>this.iterate(X=>C(X)?j(X):!0))}map(C){return new Re(j=>this.iterate(X=>j(C(X))))}some(C){let j=!1;return this.iterate(X=>(j=C(X),!j)),j}findFirst(C){let j;return this.iterate(X=>C(X)?(j=X,!1):!0),j}findLast(C){let j;return this.iterate(X=>(C(X)&&(j=X),!0)),j}findLastMaxBy(C){let j,X=!0;return this.iterate(z=>((X||ve.isGreaterThan(C(z,j)))&&(X=!1,j=z),!0)),j}}t.$ac=Re}),te(ne[13],re([0,1,3]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0c=t.$9c=t.$8c=t.$7c=t.$6c=t.ok=void 0;function F(s,h){if(!s)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}t.ok=F;function r(s,h="Unreachable"){throw new Error(h)}t.$6c=r;function o(s){if(!s)throw new D.$cb("Assertion Failed")}t.$7c=o;function N(s){s||(0,D.$1)(new D.$cb("Assertion Failed"))}t.$8c=N;function f(s){if(!s()){debugger;s(),(0,D.$1)(new D.$cb("Assertion Failed"))}}t.$9c=f;function a(s,h){let A=0;for(;A<s.length-1;){const b=s[A],g=s[A+1];if(!h(b,g))return!1;A++}return!0}t.$0c=a}),te(ne[19],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function D(F,r){const o=this;let N=!1,f;return function(){if(N)return f;if(N=!0,r)try{f=F.apply(o,arguments)}finally{r()}else f=F.apply(o,arguments);return f}}t.$db=D}),te(ne[20],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var D;(function(F){function r(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}F.is=r;const o=Object.freeze([]);function N(){return o}F.empty=N;function*f(i){yield i}F.single=f;function a(i){return r(i)?i:f(i)}F.wrap=a;function s(i){return i||o}F.from=s;function*h(i){for(let l=i.length-1;l>=0;l--)yield i[l]}F.reverse=h;function A(i){return!i||i[Symbol.iterator]().next().done===!0}F.isEmpty=A;function b(i){return i[Symbol.iterator]().next().value}F.first=b;function g(i,l){for(const v of i)if(l(v))return!0;return!1}F.some=g;function e(i,l){for(const v of i)if(l(v))return v}F.find=e;function*E(i,l){for(const v of i)l(v)&&(yield v)}F.filter=E;function*R(i,l){let v=0;for(const d of i)yield l(d,v++)}F.map=R;function*L(...i){for(const l of i)yield*l}F.concat=L;function $(i,l,v){let d=v;for(const w of i)d=l(d,w);return d}F.reduce=$;function*m(i,l,v=i.length){for(l<0&&(l+=i.length),v<0?v+=i.length:v>i.length&&(v=i.length);l<v;l++)yield i[l]}F.slice=m;function u(i,l=Number.POSITIVE_INFINITY){const v=[];if(l===0)return[v,i];const d=i[Symbol.iterator]();for(let w=0;w<l;w++){const M=d.next();if(M.done)return[v,F.empty()];v.push(M.value)}return[v,{[Symbol.iterator](){return d}}]}F.consume=u;async function c(i){const l=[];for await(const v of i)l.push(v);return Promise.resolve(l)}F.asyncToArray=c})(D||(t.Iterable=D={}))}),te(ne[37],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9q=t.KeyMod=t.KeyCodeUtils=t.$8q=t.$7q=t.$6q=t.$5q=t.$4q=t.ScanCode=t.KeyCode=void 0;var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(D||(t.KeyCode=D={}));var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(F||(t.ScanCode=F={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(E,R){this._keyCodeToStr[E]=R,this._strToKeyCode[R.toLowerCase()]=E}keyCodeToStr(E){return this._keyCodeToStr[E]}strToKeyCode(E){return this._strToKeyCode[E.toLowerCase()]||0}}const o=new r,N=new r,f=new r;t.$4q=new Array(230),t.$5q={};const a=[],s=Object.create(null),h=Object.create(null);t.$6q={lowerCaseToEnum:e=>h[e]||0,toEnum:e=>s[e]||0,toString:e=>a[e]||"None"},t.$7q=[],t.$8q=[];for(let e=0;e<=193;e++)t.$7q[e]=-1;for(let e=0;e<=132;e++)t.$8q[e]=-1;(function(){const e="",E=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],R=[],L=[];for(const $ of E){const[m,u,c,i,l,v,d,w,M]=$;if(L[u]||(L[u]=!0,a[u]=c,s[c]=u,h[c.toLowerCase()]=u,m&&(t.$7q[u]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(t.$8q[i]=u))),!R[i]){if(R[i]=!0,!l)throw new Error(`String representation missing for key code ${i} around scan code ${c}`);o.define(i,l),N.define(i,w||l),f.define(i,M||w||l)}v&&(t.$4q[v]=i),d&&(t.$5q[d]=i)}t.$8q[3]=46})();var A;(function(e){function E(c){return o.keyCodeToStr(c)}e.toString=E;function R(c){return o.strToKeyCode(c)}e.fromString=R;function L(c){return N.keyCodeToStr(c)}e.toUserSettingsUS=L;function $(c){return f.keyCodeToStr(c)}e.toUserSettingsGeneral=$;function m(c){return N.strToKeyCode(c)||f.strToKeyCode(c)}e.fromUserSettings=m;function u(c){if(c>=98&&c<=113)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return o.keyCodeToStr(c)}e.toElectronAccelerator=u})(A||(t.KeyCodeUtils=A={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function g(e,E){const R=(E&65535)<<16>>>0;return(e|R)>>>0}t.$9q=g}),te(ne[38],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class D{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=D}),te(ne[21],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(o){this.element=o,this.next=D.Undefined,this.prev=D.Undefined}}class F{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let o=this.a;for(;o!==D.Undefined;){const N=o.next;o.prev=D.Undefined,o.next=D.Undefined,o=N}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(o){return this.d(o,!1)}push(o){return this.d(o,!0)}d(o,N){const f=new D(o);if(this.a===D.Undefined)this.a=f,this.b=f;else if(N){const s=this.b;this.b=f,f.prev=s,s.next=f}else{const s=this.a;this.a=f,f.next=s,s.prev=f}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(f))}}shift(){if(this.a!==D.Undefined){const o=this.a.element;return this.e(this.a),o}}pop(){if(this.b!==D.Undefined){const o=this.b.element;return this.e(this.b),o}}e(o){if(o.prev!==D.Undefined&&o.next!==D.Undefined){const N=o.prev;N.next=o.next,o.next.prev=N}else o.prev===D.Undefined&&o.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):o.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):o.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let o=this.a;for(;o!==D.Undefined;)yield o.element,o=o.next}}t.$4c=F}),te(ne[22],re([0,1]),function(V,t){"use strict";var D,F,r;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function o(m,u,c){let i=m.get(u);return i===void 0&&(i=c,m.set(u,i)),i}t.$xc=o;function N(m){const u=[];return m.forEach((c,i)=>{u.push(`${i} => ${c}`)}),`Map(${m.size}) {${u.join(", ")}}`}t.$yc=N;function f(m){const u=[];return m.forEach(c=>{u.push(c)}),`Set(${m.size}) {${u.join(", ")}}`}t.$zc=f;class a{constructor(u,c){this.uri=u,this.value=c}}function s(m){return Array.isArray(m)}class h{static{this.c=u=>u.toString()}constructor(u,c){if(this[D]="ResourceMap",u instanceof h)this.d=new Map(u.d),this.e=c??h.c;else if(s(u)){this.d=new Map,this.e=c??h.c;for(const[i,l]of u)this.set(i,l)}else this.d=new Map,this.e=u??h.c}set(u,c){return this.d.set(this.e(u),new a(u,c)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,c){typeof c<"u"&&(u=u.bind(c));for(const[i,l]of this.d)u(l.value,l.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}t.$Ac=h;class A{constructor(u,c){this[F]="ResourceSet",!u||typeof u=="function"?this.c=new h(u):(this.c=new h(c),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,c){this.c.forEach((i,l)=>u.call(c,l,l,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=A;var b;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(b||(t.Touch=b={}));class g{constructor(){this[r]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,c=0){const i=this.c.get(u);if(i)return c!==0&&this.l(i,c),i.value}set(u,c,i=0){let l=this.c.get(u);if(l)l.value=c,i!==0&&this.l(l,i);else{switch(l={key:u,value:c,next:void 0,previous:void 0},i){case 0:this.j(l);break;case 1:this.i(l);break;case 2:this.j(l);break;default:this.j(l);break}this.c.set(u,l),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const c=this.c.get(u);if(c)return this.c.delete(u),this.k(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.k(u),this.f--,u.value}forEach(u,c){const i=this.g;let l=this.d;for(;l;){if(c?u.bind(c)(l.value,l.key,this):u(l.value,l.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const u=this,c=this.g;let i=this.d;const l={[Symbol.iterator](){return l},next(){if(u.g!==c)throw new Error("LinkedMap got modified during iteration.");if(i){const v={value:i.key,done:!1};return i=i.next,v}else return{value:void 0,done:!0}}};return l}values(){const u=this,c=this.g;let i=this.d;const l={[Symbol.iterator](){return l},next(){if(u.g!==c)throw new Error("LinkedMap got modified during iteration.");if(i){const v={value:i.value,done:!1};return i=i.next,v}else return{value:void 0,done:!0}}};return l}entries(){const u=this,c=this.g;let i=this.d;const l={[Symbol.iterator](){return l},next(){if(u.g!==c)throw new Error("LinkedMap got modified during iteration.");if(i){const v={value:[i.key,i.value],done:!1};return i=i.next,v}else return{value:void 0,done:!0}}};return l}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let c=this.d,i=this.size;for(;c&&i>u;)this.c.delete(c.key),c=c.next,i--;this.d=c,this.f=i,c&&(c.previous=void 0),this.g++}i(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}j(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}k(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const c=u.next,i=u.previous;if(!c||!i)throw new Error("Invalid list");c.previous=i,i.next=c}u.next=void 0,u.previous=void 0,this.g++}l(u,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(u===this.d)return;const i=u.next,l=u.previous;u===this.e?(l.next=void 0,this.e=l):(i.previous=l,l.next=i),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(c===2){if(u===this.e)return;const i=u.next,l=u.previous;u===this.d?(i.previous=void 0,this.d=i):(i.previous=l,l.next=i),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((c,i)=>{u.push([i,c])}),u}fromJSON(u){this.clear();for(const[c,i]of u)this.set(c,i)}}t.$Cc=g;class e extends g{constructor(u,c=1){super(),this.m=u,this.n=Math.min(Math.max(0,c),1)}get limit(){return this.m}set limit(u){this.m=u,this.o()}get ratio(){return this.n}set ratio(u){this.n=Math.min(Math.max(0,u),1),this.o()}get(u,c=2){return super.get(u,c)}peek(u){return super.get(u,0)}set(u,c){return super.set(u,c,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Dc=e;class E{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let c=this.c.get(u)||0;return c===0?!1:(c--,c===0?this.c.delete(u):this.c.set(u,c),!0)}has(u){return this.c.has(u)}}t.$Ec=E;class R{constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[c,i]of u)this.set(c,i)}clear(){this.c.clear(),this.d.clear()}set(u,c){this.c.set(u,c),this.d.set(c,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const c=this.c.get(u);return c===void 0?!1:(this.c.delete(u),this.d.delete(c),!0)}forEach(u,c){this.c.forEach((i,l)=>{u.call(c,i,l,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=R;class L{constructor(){this.c=new Map}add(u,c){let i=this.c.get(u);i||(i=new Set,this.c.set(u,i)),i.add(c)}delete(u,c){const i=this.c.get(u);i&&(i.delete(c),i.size===0&&this.c.delete(u))}forEach(u,c){const i=this.c.get(u);i&&i.forEach(c)}get(u){const c=this.c.get(u);return c||new Set}}t.$Gc=L;function $(m,u){if(m===u)return!0;if(m.size!==u.size)return!1;for(const[c,i]of m)if(!u.has(c)||u.get(c)!==i)return!1;for(const[c]of u)if(!m.has(c))return!1;return!0}t.$Hc=$}),te(ne[10],re([0,1,6,34,22,19,20]),function(V,t,D,F,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=void 0;const f=!1;let a=null;class s{constructor(){this.b=new Map}static{this.a=0}c(T){let q=this.b.get(T);return q||(q={parent:null,source:null,isSingleton:!1,value:T,idx:s.a++},this.b.set(T,q)),q}trackDisposable(T){const q=this.c(T);q.source||(q.source=new Error().stack)}setParent(T,q){const O=this.c(T);O.parent=q}markAsDisposed(T){this.b.delete(T)}markAsSingleton(T){this.c(T).isSingleton=!0}f(T,q){const O=q.get(T);if(O)return O;const P=T.parent?this.f(this.c(T.parent),q):T;return q.set(T,P),P}getTrackedDisposables(){const T=new Map;return[...this.b.entries()].filter(([,O])=>O.source!==null&&!this.f(O,T).isSingleton).flatMap(([O])=>O)}computeLeakingDisposables(T=10,q){let O;if(q)O=q;else{const Q=new Map,ee=[...this.b.values()].filter(le=>le.source!==null&&!this.f(le,Q).isSingleton);if(ee.length===0)return;const n=new Set(ee.map(le=>le.value));if(O=ee.filter(le=>!(le.parent&&n.has(le.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function P(Q){function ee(le,he){for(;le.length>0&&he.some(be=>typeof be=="string"?be===le[0]:le[0].match(be));)le.shift()}const n=Q.source.split(`
`).map(le=>le.trim().replace("at ","")).filter(le=>le!=="");return ee(n,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),n.reverse()}const W=new r.$Gc;for(const Q of O){const ee=P(Q);for(let n=0;n<=ee.length;n++)W.add(ee.slice(0,n).join(`
`),Q)}O.sort((0,D.$7b)(Q=>Q.idx,D.$9b));let G="",x=0;for(const Q of O.slice(0,T)){x++;const ee=P(Q),n=[];for(let le=0;le<ee.length;le++){let he=ee[le];he=`(shared with ${W.get(ee.slice(0,le+1).join(`
`)).size}/${O.length} leaks) at ${he}`;const ve=W.get(ee.slice(0,le).join(`
`)),ke=(0,F.$K)([...ve].map($e=>P($e)[le]),$e=>$e);delete ke[ee[le]];for(const[$e,Ae]of Object.entries(ke))n.unshift(`    - stacktraces of ${Ae.length} other leaks continue with ${$e}`);n.unshift(he)}G+=`


==================== Leaking disposable ${x}/${O.length}: ${Q.value.constructor.name} ====================
${n.join(`
`)}
============================================================

`}return O.length>T&&(G+=`


... and ${O.length-T} more leaking disposables

`),{leaks:O,details:G}}}t.$Ic=s;function h(S){a=S}if(t.$Jc=h,f){const S="__is_disposable_tracked__";h(new class{trackDisposable(T){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{T[S]||console.log(q)},3e3)}setParent(T,q){if(T&&T!==i.None)try{T[S]=!0}catch{}}markAsDisposed(T){if(T&&T!==i.None)try{T[S]=!0}catch{}}markAsSingleton(T){}})}function A(S){return a?.trackDisposable(S),S}t.$Kc=A;function b(S){a?.markAsDisposed(S)}t.$Lc=b;function g(S,T){a?.setParent(S,T)}function e(S,T){if(a)for(const q of S)a.setParent(q,T)}function E(S){return a?.markAsSingleton(S),S}t.$Mc=E;function R(S){return typeof S.dispose=="function"&&S.dispose.length===0}t.$Nc=R;function L(S){if(N.Iterable.is(S)){const T=[];for(const q of S)if(q)try{q.dispose()}catch(O){T.push(O)}if(T.length===1)throw T[0];if(T.length>1)throw new AggregateError(T,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}t.$Oc=L;function $(S){for(const T of S)R(T)&&T.dispose();return[]}t.$Pc=$;function m(...S){const T=u(()=>L(S));return e(S,T),T}t.$Qc=m;function u(S){const T=A({dispose:(0,o.$db)(()=>{b(T),S()})});return T}t.$Rc=u;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{L(this.f)}finally{this.f.clear()}}add(T){if(!T)return T;if(T===this)throw new Error("Cannot register a disposable on itself!");return g(T,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(T),T}delete(T){if(T){if(T===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(T),T.dispose()}}deleteAndLeak(T){T&&this.f.has(T)&&(this.f.delete(T),g(T,null))}}t.$Sc=c;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,A(this),g(this.q,this)}dispose(){b(this),this.q.dispose()}B(T){if(T===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(T)}}t.$Tc=i;class l{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(T){this.b||T===this.a||(this.a?.dispose(),T&&g(T,this),this.a=T)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const T=this.a;return this.a=void 0,T&&g(T,null),T}}t.$Uc=l;class v{constructor(T){this.a=new l,this.b=!1,this.a.value=T}get value(){return this.a.value}set value(T){this.b||T===this.a.value||(this.a.value=T)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=v;class d{constructor(T){this.b=T,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=d;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(T){let q=T;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,b(this))},this}}t.$Xc=w;class M{constructor(){this.a=new Map}acquire(T,...q){let O=this.a.get(T);O||(O={counter:0,object:this.b(T,...q)},this.a.set(T,O));const{object:P}=O,W=(0,o.$db)(()=>{--O.counter===0&&(this.c(T,O.object),this.a.delete(T))});return O.counter++,{object:P,dispose:W}}}t.$Yc=M;class p{constructor(T){this.a=T}async acquire(T,...q){const O=this.a.acquire(T,...q);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(P){throw O.dispose(),P}}}t.$Zc=p;class y{constructor(T){this.object=T}dispose(){}}t.$1c=y;function _(S){const T=new c;try{S(T)}finally{T.dispose()}}t.$2c=_;class k{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{L(this.a.values())}finally{this.a.clear()}}has(T){return this.a.has(T)}get size(){return this.a.size}get(T){return this.a.get(T)}set(T,q,O=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this.a.get(T)?.dispose(),this.a.set(T,q)}deleteAndDispose(T){this.a.get(T)?.dispose(),this.a.delete(T)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=k}),te(ne[23],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(o){return new F(o)}constructor(o){this.c=D&&o===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Sd=F}),te(ne[11],re([0,1,3,19,10,21,23]),function(V,t,D,F,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.Event=void 0;const f=!1,a=!1;var s;(function(_){_.None=()=>r.$Tc.None;function k(z){if(a){const{onDidAddListener:H}=z,J=e.create();let K=0;z.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),J.print()),H?.()}}}function S(z,H){return n(z,()=>{},0,void 0,!0,void 0,H)}_.defer=S;function T(z){return(H,J=null,K)=>{let ie=!1,ue;return ue=z(ae=>{if(!ie)return ue?ue.dispose():ie=!0,H.call(J,ae)},null,K),ie&&ue.dispose(),ue}}_.once=T;function q(z,H,J){return Q((K,ie=null,ue)=>z(ae=>K.call(ie,H(ae)),null,ue),J)}_.map=q;function O(z,H,J){return Q((K,ie=null,ue)=>z(ae=>{H(ae),K.call(ie,ae)},null,ue),J)}_.forEach=O;function P(z,H,J){return Q((K,ie=null,ue)=>z(ae=>H(ae)&&K.call(ie,ae),null,ue),J)}_.filter=P;function W(z){return z}_.signal=W;function G(...z){return(H,J=null,K)=>{const ie=(0,r.$Qc)(...z.map(ue=>ue(ae=>H.call(J,ae))));return ee(ie,K)}}_.any=G;function x(z,H,J,K){let ie=J;return q(z,ue=>(ie=H(ie,ue),ie),K)}_.reduce=x;function Q(z,H){let J;const K={onWillAddFirstListener(){J=z(ie.fire,ie)},onDidRemoveLastListener(){J?.dispose()}};H||k(K);const ie=new m(K);return H?.add(ie),ie.event}function ee(z,H){return H instanceof Array?H.push(z):H&&H.add(z),z}function n(z,H,J=100,K=!1,ie=!1,ue,ae){let oe,de,ye,Fe=0,Pe;const Ie={leakWarningThreshold:ue,onWillAddFirstListener(){oe=z(Be=>{Fe++,de=H(de,Be),K&&!ye&&(we.fire(de),de=void 0),Pe=()=>{const Oe=de;de=void 0,ye=void 0,(!K||Fe>1)&&we.fire(Oe),Fe=0},typeof J=="number"?(clearTimeout(ye),ye=setTimeout(Pe,J)):ye===void 0&&(ye=0,queueMicrotask(Pe))})},onWillRemoveListener(){ie&&Fe>0&&Pe?.()},onDidRemoveLastListener(){Pe=void 0,oe.dispose()}};ae||k(Ie);const we=new m(Ie);return ae?.add(we),we.event}_.debounce=n;function le(z,H=0,J){return _.debounce(z,(K,ie)=>K?(K.push(ie),K):[ie],H,void 0,!0,void 0,J)}_.accumulate=le;function he(z,H=(K,ie)=>K===ie,J){let K=!0,ie;return P(z,ue=>{const ae=K||!H(ue,ie);return K=!1,ie=ue,ae},J)}_.latch=he;function be(z,H,J){return[_.filter(z,H,J),_.filter(z,K=>!H(K),J)]}_.split=be;function ve(z,H=!1,J=[],K){let ie=J.slice(),ue=z(de=>{ie?ie.push(de):oe.fire(de)});K&&K.add(ue);const ae=()=>{ie?.forEach(de=>oe.fire(de)),ie=null},oe=new m({onWillAddFirstListener(){ue||(ue=z(de=>oe.fire(de)),K&&K.add(ue))},onDidAddFirstListener(){ie&&(H?setTimeout(ae):ae())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return K&&K.add(oe),oe.event}_.buffer=ve;function ke(z,H){return(K,ie,ue)=>{const ae=H(new Ae);return z(function(oe){const de=ae.evaluate(oe);de!==$e&&K.call(ie,de)},void 0,ue)}}_.chain=ke;const $e=Symbol("HaltChainable");class Ae{constructor(){this.f=[]}map(H){return this.f.push(H),this}forEach(H){return this.f.push(J=>(H(J),J)),this}filter(H){return this.f.push(J=>H(J)?J:$e),this}reduce(H,J){let K=J;return this.f.push(ie=>(K=H(K,ie),K)),this}latch(H=(J,K)=>J===K){let J=!0,K;return this.f.push(ie=>{const ue=J||!H(ie,K);return J=!1,K=ie,ue?ie:$e}),this}evaluate(H){for(const J of this.f)if(H=J(H),H===$e)break;return H}}function _e(z,H,J=K=>K){const K=(...oe)=>ae.fire(J(...oe)),ie=()=>z.on(H,K),ue=()=>z.removeListener(H,K),ae=new m({onWillAddFirstListener:ie,onDidRemoveLastListener:ue});return ae.event}_.fromNodeEventEmitter=_e;function Te(z,H,J=K=>K){const K=(...oe)=>ae.fire(J(...oe)),ie=()=>z.addEventListener(H,K),ue=()=>z.removeEventListener(H,K),ae=new m({onWillAddFirstListener:ie,onDidRemoveLastListener:ue});return ae.event}_.fromDOMEventEmitter=Te;function Se(z){return new Promise(H=>T(z)(H))}_.toPromise=Se;function Re(z){const H=new m;return z.then(J=>{H.fire(J)},()=>{H.fire(void 0)}).finally(()=>{H.dispose()}),H.event}_.fromPromise=Re;function U(z,H,J){return H(J),z(K=>H(K))}_.runAndSubscribe=U;class C{constructor(H,J){this._observable=H,this.f=0,this.g=!1;const K={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};J||k(K),this.emitter=new m(K),J&&J.add(this.emitter)}beginUpdate(H){this.f++}handlePossibleChange(H){}handleChange(H,J){this.g=!0}endUpdate(H){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function j(z,H){return new C(z,H).emitter.event}_.fromObservable=j;function X(z){return(H,J,K)=>{let ie=0,ue=!1;const ae={beginUpdate(){ie++},endUpdate(){ie--,ie===0&&(z.reportChanges(),ue&&(ue=!1,H.call(J)))},handlePossibleChange(){},handleChange(){ue=!0}};z.addObserver(ae),z.reportChanges();const oe={dispose(){z.removeObserver(ae)}};return K instanceof r.$Sc?K.add(oe):Array.isArray(K)&&K.push(oe),oe}}_.fromObservableLight=X})(s||(t.Event=s={}));class h{static{this.all=new Set}static{this.f=0}constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${h.f++}`,h.all.add(this)}start(k){this.g=new N.$Sd,this.listenerCount=k}stop(){if(this.g){const k=this.g.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this.g=void 0}}}t.$Ud=h;let A=-1;function b(_){const k=A;return A=_,{dispose(){A=k}}}t.$Vd=b;class g{constructor(k,S=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=S,this.g=0}dispose(){this.f?.clear()}check(k,S){const T=this.threshold;if(T<=0||S<T)return;this.f||(this.f=new Map);const q=this.f.get(k.value)||0;if(this.f.set(k.value,q+1),this.g-=1,this.g<=0){this.g=T*.5;let O,P=0;for(const[W,G]of this.f)(!O||P<G)&&(O=W,P=G);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${P}):`),console.warn(O)}return()=>{const O=this.f.get(k.value)||0;this.f.set(k.value,O-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let E=0;class R{constructor(k){this.value=k,this.id=E++}}const L=2,$=(_,k)=>{if(_ instanceof R)k(_);else for(let S=0;S<_.length;S++){const T=_[S];T&&k(T)}};class m{constructor(k){this.w=0,this.f=k,this.g=A>0||this.f?.leakWarningThreshold?new g(this.f?.leakWarningThreshold??A):void 0,this.j=this.f?._profName?new h(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(f){const k=this.t;queueMicrotask(()=>{$(k,S=>S.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(k,S,T)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Tc.None;if(this.m)return r.$Tc.None;S&&(k=k.bind(S));const q=new R(k);let O,P;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(q.stack=e.create(),O=this.g.check(q.stack,this.w+1)),f&&(q.stack=P??e.create()),this.t?this.t instanceof R?(this.u??=new c,this.t=[this.t,q]):this.t.push(q):(this.f?.onWillAddFirstListener?.(this),this.t=q,this.f?.onDidAddFirstListener?.(this)),this.w++;const W=(0,r.$Rc)(()=>{O?.(),this.x(q)});return T instanceof r.$Sc?T.add(W):Array.isArray(T)&&T.push(W),W},this.q}x(k){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const S=this.t,T=S.indexOf(k);if(T===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,S[T]=void 0;const q=this.u.current===this;if(this.w*L<=S.length){let O=0;for(let P=0;P<S.length;P++)S[P]?S[O++]=S[P]:q&&(this.u.end--,O<this.u.i&&this.u.i--);S.length=O}}y(k,S){if(!k)return;const T=this.f?.onListenerError||D.$1;if(!T){k.value(S);return}try{k.value(S)}catch(q){T(q)}}z(k){const S=k.current.t;for(;k.i<k.end;)this.y(S[k.i++],k.value);k.reset()}fire(k){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof R)this.y(this.t,k);else{const S=this.u;S.enqueue(this,k,this.t.length),this.z(S)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Wd=m;const u=()=>new c;t.$Xd=u;class c{constructor(){this.i=-1,this.end=0}enqueue(k,S,T){this.i=0,this.end=T,this.current=k,this.value=S}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends m{async fireAsync(k,S,T){if(this.t)for(this.h||(this.h=new o.$4c),$(this.t,q=>this.h.push([q.value,k]));this.h.size>0&&!S.isCancellationRequested;){const[q,O]=this.h.shift(),P=[],W={...O,token:S,waitUntil:G=>{if(Object.isFrozen(P))throw new Error("waitUntil can NOT be called asynchronous");T&&(G=T(G,q)),P.push(G)}};try{q(W)}catch(G){(0,D.$1)(G);continue}Object.freeze(P),await Promise.allSettled(P).then(G=>{for(const x of G)x.status==="rejected"&&(0,D.$1)(x.reason)})}}}t.$Yd=i;class l extends m{get isPaused(){return this.h!==0}constructor(k){super(k),this.h=0,this.s=new o.$4c,this.A=k?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const k=Array.from(this.s);this.s.clear(),super.fire(this.A(k))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(k){this.w&&(this.h!==0?this.s.push(k):super.fire(k))}}t.$Zd=l;class v extends l{constructor(k){super(k),this.k=k.delay??100}fire(k){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(k)}}t.$1d=v;class d extends m{constructor(k){super(k),this.h=[],this.k=k?.merge}fire(k){this.hasListeners()&&(this.h.push(k),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(S=>super.fire(S)),this.h=[]}))}}t.$2d=d;class w{constructor(){this.g=!1,this.h=[],this.f=new m({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(k){const S={event:k,listener:null};this.h.push(S),this.g&&this.m(S);const T=()=>{this.g&&this.o(S);const q=this.h.indexOf(S);this.h.splice(q,1)};return(0,r.$Rc)((0,F.$db)(T))}j(){this.g=!0,this.h.forEach(k=>this.m(k))}k(){this.g=!1,this.h.forEach(k=>this.o(k))}m(k){k.listener=k.event(S=>this.f.fire(S))}o(k){k.listener?.dispose(),k.listener=null}dispose(){this.f.dispose();for(const k of this.h)k.listener?.dispose();this.h=[]}}t.$3d=w;class M{constructor(k,S,T,q){this.f=new r.$Sc;const O=this.f.add(new w),P=this.f.add(new r.$3c);function W(G){P.set(G,O.add(q(G)))}for(const G of k)W(G);this.f.add(S(G=>{W(G)})),this.f.add(T(G=>{P.deleteAndDispose(G)})),this.event=O.event}dispose(){this.f.dispose()}}t.$4d=M;class p{constructor(){this.f=[]}wrapEvent(k){return(S,T,q)=>k(O=>{const P=this.f[this.f.length-1];P?P.push(()=>S.call(T,O)):S.call(T,O)},void 0,q)}bufferEvents(k){const S=[];this.f.push(S);const T=k();return this.f.pop(),S.forEach(q=>q()),T}}t.$5d=p;class y{constructor(){this.f=!1,this.g=s.None,this.h=r.$Tc.None,this.j=new m({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(k){this.g=k,this.f&&(this.h.dispose(),this.h=k(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$6d=y}),te(ne[24],re([0,1,11]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7d=t.CancellationToken=void 0;const F=Object.freeze(function(f,a){const s=setTimeout(f.bind(a),0);return{dispose(){clearTimeout(s)}}});var r;(function(f){function a(s){return s===f.None||s===f.Cancelled||s instanceof o?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}f.isCancellationToken=a,f.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),f.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(r||(t.CancellationToken=r={}));class o{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new D.$Wd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(a){this.f=void 0,this.g=void 0,this.g=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new o),this.f}cancel(){this.f?this.f instanceof o&&this.f.cancel():this.f=r.Cancelled}dispose(a=!1){a&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof o&&this.f.dispose():this.f=r.None}}t.$7d=N}),te(ne[39],re([0,1,24]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$He=t.$Ge=t.$Fe=void 0;class F{constructor(f){this.b=f,this.a=null}get(){if(this.a)return this.a;const f=new D.$7d,a=this.b(f.token);return this.a={promise:a,dispose:()=>{this.a=null,f.cancel(),f.dispose()}},this.a}}t.$Fe=F;class r{constructor(f){this.c=f,this.a=void 0,this.b=void 0}get(f){const a=JSON.stringify(f);return this.b!==a&&(this.b=a,this.a=this.c(f)),this.a}}t.$Ge=r;class o{get cachedValues(){return this.a}constructor(f){this.b=f,this.a=new Map}get(f){if(this.a.has(f))return this.a.get(f);const a=this.b(f);return this.a.set(f,a),a}}t.$He=o}),te(ne[7],re([0,1,39,38]),function(V,t,D,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$If=t.$Hf=t.$Gf=t.$Ff=t.GraphemeBreakType=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=void 0;function r(I){return!I||typeof I!="string"?!0:I.trim().length===0}t.$Ke=r;const o=/{(\d+)}/g;function N(I,...B){return B.length===0?I:I.replace(o,function(Z,Y){const se=parseInt(Y,10);return isNaN(se)||se<0||se>=B.length?Z:B[se]})}t.$Le=N;const f=/{([^}]+)}/g;function a(I,B){return Object.keys(B).length===0?I:I.replace(f,(Z,Y)=>B[Y]??Z)}t.$Me=a;function s(I){return I.replace(/[<>"'&]/g,B=>{switch(B){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return B})}t.$Ne=s;function h(I){return I.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.$Oe=h;function A(I){return I.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Pe=A;function b(I,B){let Z=0;const Y=B.charCodeAt(0);for(let se=I.length-1;se>=0;se--)I.charCodeAt(se)===Y&&Z++;return Z}t.$Qe=b;function g(I,B,Z="\u2026"){return I.length<=B?I:`${I.substr(0,B)}${Z}`}t.$Re=g;function e(I,B,Z="\u2026"){if(I.length<=B)return I;const Y=Math.ceil(B/2)-Z.length/2,se=Math.floor(B/2)-Z.length/2;return`${I.substr(0,Y)}${Z}${I.substr(I.length-se)}`}t.$Se=e;function E(I,B=" "){const Z=R(I,B);return L(Z,B)}t.$Te=E;function R(I,B){if(!I||!B)return I;const Z=B.length;if(Z===0||I.length===0)return I;let Y=0;for(;I.indexOf(B,Y)===Y;)Y=Y+Z;return I.substring(Y)}t.$Ue=R;function L(I,B){if(!I||!B)return I;const Z=B.length,Y=I.length;if(Z===0||Y===0)return I;let se=Y,ce=-1;for(;ce=I.lastIndexOf(B,se-1),!(ce===-1||ce+Z!==se);){if(ce===0)return"";se=ce}return I.substring(0,se)}t.$Ve=L;function $(I){return I.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$We=$;function m(I){return I.replace(/\*/g,"")}t.$Xe=m;function u(I,B,Z={}){if(!I)throw new Error("Cannot create regex from empty string");B||(I=A(I)),Z.wholeWord&&(/\B/.test(I.charAt(0))||(I="\\b"+I),/\B/.test(I.charAt(I.length-1))||(I=I+"\\b"));let Y="";return Z.global&&(Y+="g"),Z.matchCase||(Y+="i"),Z.multiline&&(Y+="m"),Z.unicode&&(Y+="u"),new RegExp(I,Y)}t.$Ye=u;function c(I){return I.source==="^"||I.source==="^$"||I.source==="$"||I.source==="^\\s*$"?!1:!!(I.exec("")&&I.lastIndex===0)}t.$Ze=c;function i(I){return I.split(/\r\n|\r|\n/)}t.$1e=i;function l(I){for(let B=0,Z=I.length;B<Z;B++){const Y=I.charCodeAt(B);if(Y!==32&&Y!==9)return B}return-1}t.$2e=l;function v(I,B=0,Z=I.length){for(let Y=B;Y<Z;Y++){const se=I.charCodeAt(Y);if(se!==32&&se!==9)return I.substring(B,Y)}return I.substring(B,Z)}t.$3e=v;function d(I,B=I.length-1){for(let Z=B;Z>=0;Z--){const Y=I.charCodeAt(Z);if(Y!==32&&Y!==9)return Z}return-1}t.$4e=d;function w(I,B,Z){const Y=[];let se=0;for(const ce of I.matchAll(B)){if(Y.push(I.slice(se,ce.index)),ce.index===void 0)throw new Error("match.index should be defined");se=ce.index+ce[0].length,Y.push(Z(ce[0],...ce.slice(1),ce.index,I,ce.groups))}return Y.push(I.slice(se)),Promise.all(Y).then(ce=>ce.join(""))}t.$5e=w;function M(I,B){return I<B?-1:I>B?1:0}t.$6e=M;function p(I,B,Z=0,Y=I.length,se=0,ce=B.length){for(;Z<Y&&se<ce;Z++,se++){const Le=I.charCodeAt(Z),Ne=B.charCodeAt(se);if(Le<Ne)return-1;if(Le>Ne)return 1}const ge=Y-Z,Me=ce-se;return ge<Me?-1:ge>Me?1:0}t.$7e=p;function y(I,B){return _(I,B,0,I.length,0,B.length)}t.$8e=y;function _(I,B,Z=0,Y=I.length,se=0,ce=B.length){for(;Z<Y&&se<ce;Z++,se++){let Le=I.charCodeAt(Z),Ne=B.charCodeAt(se);if(Le===Ne)continue;if(Le>=128||Ne>=128)return p(I.toLowerCase(),B.toLowerCase(),Z,Y,se,ce);S(Le)&&(Le-=32),S(Ne)&&(Ne-=32);const me=Le-Ne;if(me!==0)return me}const ge=Y-Z,Me=ce-se;return ge<Me?-1:ge>Me?1:0}t.$9e=_;function k(I){return I>=48&&I<=57}t.$0e=k;function S(I){return I>=97&&I<=122}t.$$e=S;function T(I){return I>=65&&I<=90}t.$_e=T;function q(I,B){return I.length===B.length&&_(I,B)===0}t.$af=q;function O(I,B){const Z=B.length;return B.length>I.length?!1:_(I,B,0,Z)===0}t.$bf=O;function P(I,B){const Z=Math.min(I.length,B.length);let Y;for(Y=0;Y<Z;Y++)if(I.charCodeAt(Y)!==B.charCodeAt(Y))return Y;return Z}t.$cf=P;function W(I,B){const Z=Math.min(I.length,B.length);let Y;const se=I.length-1,ce=B.length-1;for(Y=0;Y<Z;Y++)if(I.charCodeAt(se-Y)!==B.charCodeAt(ce-Y))return Y;return Z}t.$df=W;function G(I){return 55296<=I&&I<=56319}t.$ef=G;function x(I){return 56320<=I&&I<=57343}t.$ff=x;function Q(I,B){return(I-55296<<10)+(B-56320)+65536}t.$gf=Q;function ee(I,B,Z){const Y=I.charCodeAt(Z);if(G(Y)&&Z+1<B){const se=I.charCodeAt(Z+1);if(x(se))return Q(Y,se)}return Y}t.$hf=ee;function n(I,B){const Z=I.charCodeAt(B-1);if(x(Z)&&B>1){const Y=I.charCodeAt(B-2);if(G(Y))return Q(Y,Z)}return Z}class le{get offset(){return this.e}constructor(B,Z=0){this.c=B,this.d=B.length,this.e=Z}setOffset(B){this.e=B}prevCodePoint(){const B=n(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=ee(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}t.$if=le;class he{get offset(){return this.c.offset}constructor(B,Z=0){this.c=new le(B,Z)}nextGraphemeLength(){const B=we.getInstance(),Z=this.c,Y=Z.offset;let se=B.getGraphemeBreakType(Z.nextCodePoint());for(;!Z.eol();){const ce=Z.offset,ge=B.getGraphemeBreakType(Z.nextCodePoint());if(Pe(se,ge)){Z.setOffset(ce);break}se=ge}return Z.offset-Y}prevGraphemeLength(){const B=we.getInstance(),Z=this.c,Y=Z.offset;let se=B.getGraphemeBreakType(Z.prevCodePoint());for(;Z.offset>0;){const ce=Z.offset,ge=B.getGraphemeBreakType(Z.prevCodePoint());if(Pe(ge,se)){Z.setOffset(ce);break}se=ge}return Y-Z.offset}eol(){return this.c.eol()}}t.$jf=he;function be(I,B){return new he(I,B).nextGraphemeLength()}t.$kf=be;function ve(I,B){return new he(I,B).prevGraphemeLength()}t.$lf=ve;function ke(I,B){B>0&&x(I.charCodeAt(B))&&B--;const Z=B+be(I,B);return[Z-ve(I,Z),Z]}t.$mf=ke;function $e(I){const B=new he(I);let Z=0;for(;!B.eol();)Z++,B.nextGraphemeLength();return Z}t.$nf=$e;let Ae;function _e(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Te(I){return Ae||(Ae=_e()),Ae.test(I)}t.$of=Te;const Se=/^[\t\n\r\x20-\x7E]*$/;function Re(I){return Se.test(I)}t.$pf=Re,t.$qf=/[\u2028\u2029]/;function U(I){return t.$qf.test(I)}t.$rf=U;function C(I){return I>=11904&&I<=55215||I>=63744&&I<=64255||I>=65281&&I<=65374}t.$sf=C;function j(I){return I>=127462&&I<=127487||I===8986||I===8987||I===9200||I===9203||I>=9728&&I<=10175||I===11088||I===11093||I>=127744&&I<=128591||I>=128640&&I<=128764||I>=128992&&I<=129008||I>=129280&&I<=129535||I>=129648&&I<=129782}t.$tf=j;function X(I,B,Z=""){const Y=I.trimStart();if(Y.length<B)return Y;const se=/\b/g;let ce=0;for(;se.test(Y)&&!(Y.length-se.lastIndex<B);)ce=se.lastIndex,se.lastIndex+=1;return ce===0?Y:Z+Y.substring(ce).trimStart()}t.$uf=X;const z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,H=/\x1b\].*?\x07/g;function J(I){return I&&(I=I.replace(z,"").replace(H,"")),I}t.$vf=J,t.$wf=String.fromCharCode(65279);function K(I){return!!(I&&I.length>0&&I.charCodeAt(0)===65279)}t.$xf=K;function ie(I){return K(I)?I.substr(1):I}t.$yf=ie;function ue(I,B){if(!I||!B||I.length<B.length)return!1;const Z=B.length,Y=I.toLowerCase();let se=0,ce=-1;for(;se<Z;){const ge=Y.indexOf(B[se],ce+1);if(ge<0)return!1;ce=ge,se++}return!0}t.$zf=ue;function ae(I,B=!1){return I?(B&&(I=I.replace(/\\./g,"")),I.toLowerCase()!==I):!1}t.$Af=ae;function oe(I){return I.charAt(0).toUpperCase()+I.slice(1)}t.$Bf=oe;function de(I,B=1){if(B===0)return"";let Z=-1;do Z=I.indexOf(`
`,Z+1),B--;while(B>0&&Z>=0);return Z===-1?I:(I[Z-1]==="\r"&&Z--,I.substr(0,Z))}t.$Cf=de;function ye(I){return I=I%(2*26),I<26?String.fromCharCode(97+I):String.fromCharCode(65+I-26)}t.$Df=ye;function Fe(I){return we.getInstance().getGraphemeBreakType(I)}t.$Ef=Fe;function Pe(I,B){return I===0?B!==5&&B!==7:I===2&&B===3?!1:I===4||I===2||I===3||B===4||B===2||B===3?!0:!(I===8&&(B===8||B===9||B===11||B===12)||(I===11||I===9)&&(B===9||B===10)||(I===12||I===10)&&B===10||B===5||B===13||B===7||I===1||I===13&&B===14||I===6&&B===6)}var Ie;(function(I){I[I.Other=0]="Other",I[I.Prepend=1]="Prepend",I[I.CR=2]="CR",I[I.LF=3]="LF",I[I.Control=4]="Control",I[I.Extend=5]="Extend",I[I.Regional_Indicator=6]="Regional_Indicator",I[I.SpacingMark=7]="SpacingMark",I[I.L=8]="L",I[I.V=9]="V",I[I.T=10]="T",I[I.LV=11]="LV",I[I.LVT=12]="LVT",I[I.ZWJ=13]="ZWJ",I[I.Extended_Pictographic=14]="Extended_Pictographic"})(Ie||(t.GraphemeBreakType=Ie={}));class we{static{this.c=null}static getInstance(){return we.c||(we.c=new we),we.c}constructor(){this.d=Be()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const Z=this.d,Y=Z.length/3;let se=1;for(;se<=Y;)if(B<Z[3*se])se=2*se;else if(B>Z[3*se+1])se=2*se+1;else return Z[3*se+2];return 0}}function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Oe(I,B){if(I===0)return 0;const Z=xe(I,B);if(Z!==void 0)return Z;const Y=new le(B,I);return Y.prevCodePoint(),Y.offset}t.$Ff=Oe;function xe(I,B){const Z=new le(B,I);let Y=Z.prevCodePoint();for(;ze(Y)||Y===65039||Y===8419;){if(Z.offset===0)return;Y=Z.prevCodePoint()}if(!j(Y))return;let se=Z.offset;return se>0&&Z.prevCodePoint()===8205&&(se=Z.offset),se}function ze(I){return 127995<=I&&I<=127999}var We;(function(I){I[I.zwj=8205]="zwj",I[I.emojiVariantSelector=65039]="emojiVariantSelector",I[I.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),t.$Gf="\xA0";class De{static{this.c=new F.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Ge(B=>{function Z(me){const pe=new Map;for(let Ee=0;Ee<me.length;Ee+=2)pe.set(me[Ee],me[Ee+1]);return pe}function Y(me,pe){const Ee=new Map(me);for(const[Ue,Ve]of pe)Ee.set(Ue,Ve);return Ee}function se(me,pe){if(!me)return pe;const Ee=new Map;for(const[Ue,Ve]of me)pe.has(Ue)&&Ee.set(Ue,Ve);return Ee}const ce=this.c.value;let ge=B.filter(me=>!me.startsWith("_")&&me in ce);ge.length===0&&(ge=["_default"]);let Me;for(const me of ge){const pe=Z(ce[me]);Me=se(Me,pe)}const Le=Z(ce._common),Ne=Y(Le,Me);return new De(Ne)})}static getInstance(B){return De.d.get(Array.from(B))}static{this.e=new F.$V(()=>Object.keys(De.c.value).filter(B=>!B.startsWith("_")))}static getLocales(){return De.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Hf=De;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter(B){return qe.e().has(B)}static get codePoints(){return qe.e()}}t.$If=qe}),te(ne[40],re([0,1,7]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2i=t.$1i=t.$Zi=t.$Yi=t.$Xi=t.$Wi=t.$Vi=void 0;function F(L){return r(L,0)}t.$Vi=F;function r(L,$){switch(typeof L){case"object":return L===null?o(349,$):Array.isArray(L)?a(L,$):s(L,$);case"string":return f(L,$);case"boolean":return N(L,$);case"number":return o(L,$);case"undefined":return o(937,$);default:return o(617,$)}}t.$Wi=r;function o(L,$){return($<<5)-$+L|0}t.$Xi=o;function N(L,$){return o(L?433:863,$)}function f(L,$){$=o(149417,$);for(let m=0,u=L.length;m<u;m++)$=o(L.charCodeAt(m),$);return $}t.$Yi=f;function a(L,$){return $=o(104579,$),L.reduce((m,u)=>r(u,m),$)}function s(L,$){return $=o(181387,$),Object.keys(L).sort().reduce((m,u)=>(m=f(u,m),r(L[u],m)),$)}class h{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=r($,this.g),this.g}}t.$Zi=h;var A;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function b(L,$,m=32){const u=m-$,c=~((1<<u)-1);return(L<<$|(c&L)>>>u)>>>0}function g(L,$=0,m=L.byteLength,u=0){for(let c=0;c<m;c++)L[$+c]=u}function e(L,$,m="0"){for(;L.length<$;)L=m+L;return L}function E(L,$=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(m=>m.toString(16).padStart(2,"0")).join(""):e((L>>>0).toString(16),$/4)}t.$1i=E;class R{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const m=$.length;if(m===0)return;const u=this.p;let c=this.r,i=this.u,l,v;for(i!==0?(l=i,v=-1,i=0):(l=$.charCodeAt(0),v=0);;){let d=l;if(D.$ef(l))if(v+1<m){const w=$.charCodeAt(v+1);D.$ff(w)?(v++,d=D.$gf(l,w)):d=65533}else{i=l;break}else D.$ff(l)&&(d=65533);if(c=this.w(u,c,d),v++,v<m)l=$.charCodeAt(v);else break}this.r=c,this.u=i}w($,m,u){return u<128?$[m++]=u:u<2048?($[m++]=192|(u&1984)>>>6,$[m++]=128|(u&63)>>>0):u<65536?($[m++]=224|(u&61440)>>>12,$[m++]=128|(u&4032)>>>6,$[m++]=128|(u&63)>>>0):($[m++]=240|(u&1835008)>>>18,$[m++]=128|(u&258048)>>>12,$[m++]=128|(u&4032)>>>6,$[m++]=128|(u&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,$[0]=$[64+0],$[1]=$[64+1],$[2]=$[64+2]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=R.g,m=this.q;for(let p=0;p<64;p+=4)$.setUint32(p,m.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)$.setUint32(p,b($.getUint32(p-12,!1)^$.getUint32(p-32,!1)^$.getUint32(p-56,!1)^$.getUint32(p-64,!1),1),!1);let u=this.h,c=this.l,i=this.m,l=this.n,v=this.o,d,w,M;for(let p=0;p<80;p++)p<20?(d=c&i|~c&l,w=1518500249):p<40?(d=c^i^l,w=1859775393):p<60?(d=c&i|c&l|i&l,w=2400959708):(d=c^i^l,w=3395469782),M=b(u,5)+d+v+w+$.getUint32(p*4,!1)&4294967295,v=l,l=i,i=b(c,30),c=u,u=M;this.h=this.h+u&4294967295,this.l=this.l+c&4294967295,this.m=this.m+i&4294967295,this.n=this.n+l&4294967295,this.o=this.o+v&4294967295}}t.$2i=R}),te(ne[25],re([0,1,36,40]),function(V,t,D,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3s=t.$2s=t.$1s=void 0;class r{constructor(b){this.a=b}getElements(){const b=this.a,g=new Int32Array(b.length);for(let e=0,E=b.length;e<E;e++)g[e]=b.charCodeAt(e);return g}}t.$1s=r;function o(A,b,g){return new h(new r(A),new r(b)).ComputeDiff(g).changes}t.$2s=o;class N{static Assert(b,g){if(!b)throw new Error(g)}}class f{static Copy(b,g,e,E,R){for(let L=0;L<R;L++)e[E+L]=b[g+L]}static Copy2(b,g,e,E,R){for(let L=0;L<R;L++)e[E+L]=b[g+L]}}var a;(function(A){A[A.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class s{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new D.$Zs(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(b,g){this.b=Math.min(this.b,b),this.c=Math.min(this.c,g),this.d++}AddModifiedElement(b,g){this.b=Math.min(this.b,b),this.c=Math.min(this.c,g),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class h{constructor(b,g,e=null){this.a=e,this.b=b,this.c=g;const[E,R,L]=h.o(b),[$,m,u]=h.o(g);this.d=L&&u,this.e=E,this.f=R,this.g=$,this.h=m,this.k=[],this.m=[]}static n(b){return b.length>0&&typeof b[0]=="string"}static o(b){const g=b.getElements();if(h.n(g)){const e=new Int32Array(g.length);for(let E=0,R=g.length;E<R;E++)e[E]=(0,F.$Yi)(g[E],0);return[g,e,!0]}return g instanceof Int32Array?[[],g,!1]:[[],new Int32Array(g),!1]}p(b,g){return this.f[b]!==this.h[g]?!1:this.d?this.e[b]===this.g[g]:!0}q(b,g){if(!this.p(b,g))return!1;const e=h.r(this.b,b),E=h.r(this.c,g);return e===E}static r(b,g){return typeof b.getStrictElement=="function"?b.getStrictElement(g):null}s(b,g){return this.f[b]!==this.f[g]?!1:this.d?this.e[b]===this.e[g]:!0}u(b,g){return this.h[b]!==this.h[g]?!1:this.d?this.g[b]===this.g[g]:!0}ComputeDiff(b){return this.v(0,this.f.length-1,0,this.h.length-1,b)}v(b,g,e,E,R){const L=[!1];let $=this.w(b,g,e,E,L);return R&&($=this.z($)),{quitEarly:L[0],changes:$}}w(b,g,e,E,R){for(R[0]=!1;b<=g&&e<=E&&this.p(b,e);)b++,e++;for(;g>=b&&E>=e&&this.p(g,E);)g--,E--;if(b>g||e>E){let i;return e<=E?(N.Assert(b===g+1,"originalStart should only be one more than originalEnd"),i=[new D.$Zs(b,0,e,E-e+1)]):b<=g?(N.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),i=[new D.$Zs(b,g-b+1,e,0)]):(N.Assert(b===g+1,"originalStart should only be one more than originalEnd"),N.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const L=[0],$=[0],m=this.y(b,g,e,E,L,$,R),u=L[0],c=$[0];if(m!==null)return m;if(!R[0]){const i=this.w(b,u,e,c,R);let l=[];return R[0]?l=[new D.$Zs(u+1,g-(u+1)+1,c+1,E-(c+1)+1)]:l=this.w(u+1,g,c+1,E,R),this.H(i,l)}return[new D.$Zs(b,g-b+1,e,E-e+1)]}x(b,g,e,E,R,L,$,m,u,c,i,l,v,d,w,M,p,y){let _=null,k=null,S=new s,T=g,q=e,O=v[0]-M[0]-E,P=-1073741824,W=this.k.length-1;do{const G=O+b;G===T||G<q&&u[G-1]<u[G+1]?(i=u[G+1],d=i-O-E,i<P&&S.MarkNextChange(),P=i,S.AddModifiedElement(i+1,d),O=G+1-b):(i=u[G-1]+1,d=i-O-E,i<P&&S.MarkNextChange(),P=i-1,S.AddOriginalElement(i,d+1),O=G-1-b),W>=0&&(u=this.k[W],b=u[0],T=1,q=u.length-1)}while(--W>=-1);if(_=S.getReverseChanges(),y[0]){let G=v[0]+1,x=M[0]+1;if(_!==null&&_.length>0){const Q=_[_.length-1];G=Math.max(G,Q.getOriginalEnd()),x=Math.max(x,Q.getModifiedEnd())}k=[new D.$Zs(G,l-G+1,x,w-x+1)]}else{S=new s,T=L,q=$,O=v[0]-M[0]-m,P=1073741824,W=p?this.m.length-1:this.m.length-2;do{const G=O+R;G===T||G<q&&c[G-1]>=c[G+1]?(i=c[G+1]-1,d=i-O-m,i>P&&S.MarkNextChange(),P=i+1,S.AddOriginalElement(i+1,d+1),O=G+1-R):(i=c[G-1],d=i-O-m,i>P&&S.MarkNextChange(),P=i,S.AddModifiedElement(i+1,d+1),O=G-1-R),W>=0&&(c=this.m[W],R=c[0],T=1,q=c.length-1)}while(--W>=-1);k=S.getChanges()}return this.H(_,k)}y(b,g,e,E,R,L,$){let m=0,u=0,c=0,i=0,l=0,v=0;b--,e--,R[0]=0,L[0]=0,this.k=[],this.m=[];const d=g-b+(E-e),w=d+1,M=new Int32Array(w),p=new Int32Array(w),y=E-e,_=g-b,k=b-e,S=g-E,q=(_-y)%2===0;M[y]=b,p[_]=g,$[0]=!1;for(let O=1;O<=d/2+1;O++){let P=0,W=0;c=this.J(y-O,O,y,w),i=this.J(y+O,O,y,w);for(let x=c;x<=i;x+=2){x===c||x<i&&M[x-1]<M[x+1]?m=M[x+1]:m=M[x-1]+1,u=m-(x-y)-k;const Q=m;for(;m<g&&u<E&&this.p(m+1,u+1);)m++,u++;if(M[x]=m,m+u>P+W&&(P=m,W=u),!q&&Math.abs(x-_)<=O-1&&m>=p[x])return R[0]=m,L[0]=u,Q<=p[x]&&1447>0&&O<=1447+1?this.x(y,c,i,k,_,l,v,S,M,p,m,g,R,u,E,L,q,$):null}const G=(P-b+(W-e)-O)/2;if(this.a!==null&&!this.a(P,G))return $[0]=!0,R[0]=P,L[0]=W,G>0&&1447>0&&O<=1447+1?this.x(y,c,i,k,_,l,v,S,M,p,m,g,R,u,E,L,q,$):(b++,e++,[new D.$Zs(b,g-b+1,e,E-e+1)]);l=this.J(_-O,O,_,w),v=this.J(_+O,O,_,w);for(let x=l;x<=v;x+=2){x===l||x<v&&p[x-1]>=p[x+1]?m=p[x+1]-1:m=p[x-1],u=m-(x-_)-S;const Q=m;for(;m>b&&u>e&&this.p(m,u);)m--,u--;if(p[x]=m,q&&Math.abs(x-y)<=O&&m<=M[x])return R[0]=m,L[0]=u,Q>=M[x]&&1447>0&&O<=1447+1?this.x(y,c,i,k,_,l,v,S,M,p,m,g,R,u,E,L,q,$):null}if(O<=1447){let x=new Int32Array(i-c+2);x[0]=y-c+1,f.Copy2(M,c,x,1,i-c+1),this.k.push(x),x=new Int32Array(v-l+2),x[0]=_-l+1,f.Copy2(p,l,x,1,v-l+1),this.m.push(x)}}return this.x(y,c,i,k,_,l,v,S,M,p,m,g,R,u,E,L,q,$)}z(b){for(let g=0;g<b.length;g++){const e=b[g],E=g<b.length-1?b[g+1].originalStart:this.f.length,R=g<b.length-1?b[g+1].modifiedStart:this.h.length,L=e.originalLength>0,$=e.modifiedLength>0;for(;e.originalStart+e.originalLength<E&&e.modifiedStart+e.modifiedLength<R&&(!L||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!$||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const u=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!u)break;e.originalStart++,e.modifiedStart++}const m=[null];if(g<b.length-1&&this.I(b[g],b[g+1],m)){b[g]=m[0],b.splice(g+1,1),g--;continue}}for(let g=b.length-1;g>=0;g--){const e=b[g];let E=0,R=0;if(g>0){const i=b[g-1];E=i.originalStart+i.originalLength,R=i.modifiedStart+i.modifiedLength}const L=e.originalLength>0,$=e.modifiedLength>0;let m=0,u=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const l=e.originalStart-i,v=e.modifiedStart-i;if(l<E||v<R||L&&!this.s(l,l+e.originalLength)||$&&!this.u(v,v+e.modifiedLength))break;const w=(l===E&&v===R?5:0)+this.G(l,e.originalLength,v,e.modifiedLength);w>u&&(u=w,m=i)}e.originalStart-=m,e.modifiedStart-=m;const c=[null];if(g>0&&this.I(b[g-1],b[g],c)){b[g-1]=c[0],b.splice(g,1),g++;continue}}if(this.d)for(let g=1,e=b.length;g<e;g++){const E=b[g-1],R=b[g],L=R.originalStart-E.originalStart-E.originalLength,$=E.originalStart,m=R.originalStart+R.originalLength,u=m-$,c=E.modifiedStart,i=R.modifiedStart+R.modifiedLength,l=i-c;if(L<5&&u<20&&l<20){const v=this.A($,u,c,l,L);if(v){const[d,w]=v;(d!==E.originalStart+E.originalLength||w!==E.modifiedStart+E.modifiedLength)&&(E.originalLength=d-E.originalStart,E.modifiedLength=w-E.modifiedStart,R.originalStart=d+L,R.modifiedStart=w+L,R.originalLength=m-R.originalStart,R.modifiedLength=i-R.modifiedStart)}}}return b}A(b,g,e,E,R){if(g<R||E<R)return null;const L=b+g-R+1,$=e+E-R+1;let m=0,u=0,c=0;for(let i=b;i<L;i++)for(let l=e;l<$;l++){const v=this.B(i,l,R);v>0&&v>m&&(m=v,u=i,c=l)}return m>0?[u,c]:null}B(b,g,e){let E=0;for(let R=0;R<e;R++){if(!this.p(b+R,g+R))return 0;E+=this.e[b+R].length}return E}C(b){return b<=0||b>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[b])}D(b,g){if(this.C(b)||this.C(b-1))return!0;if(g>0){const e=b+g;if(this.C(e-1)||this.C(e))return!0}return!1}E(b){return b<=0||b>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[b])}F(b,g){if(this.E(b)||this.E(b-1))return!0;if(g>0){const e=b+g;if(this.E(e-1)||this.E(e))return!0}return!1}G(b,g,e,E){const R=this.D(b,g)?1:0,L=this.F(e,E)?1:0;return R+L}H(b,g){const e=[];if(b.length===0||g.length===0)return g.length>0?g:b;if(this.I(b[b.length-1],g[0],e)){const E=new Array(b.length+g.length-1);return f.Copy(b,0,E,0,b.length-1),E[b.length-1]=e[0],f.Copy(g,1,E,b.length,g.length-1),E}else{const E=new Array(b.length+g.length);return f.Copy(b,0,E,0,b.length),f.Copy(g,0,E,b.length,g.length),E}}I(b,g,e){if(N.Assert(b.originalStart<=g.originalStart,"Left change is not less than or equal to right change"),N.Assert(b.modifiedStart<=g.modifiedStart,"Left change is not less than or equal to right change"),b.originalStart+b.originalLength>=g.originalStart||b.modifiedStart+b.modifiedLength>=g.modifiedStart){const E=b.originalStart;let R=b.originalLength;const L=b.modifiedStart;let $=b.modifiedLength;return b.originalStart+b.originalLength>=g.originalStart&&(R=g.originalStart+g.originalLength-b.originalStart),b.modifiedStart+b.modifiedLength>=g.modifiedStart&&($=g.modifiedStart+g.modifiedLength-b.modifiedStart),e[0]=new D.$Zs(E,R,L,$),!0}else return e[0]=null,!1}J(b,g,e,E){if(b>=0&&b<E)return b;const R=e,L=E-e-1,$=g%2===0;if(b<0){const m=R%2===0;return $===m?0:1}else{const m=L%2===0;return $===m?E-1:E-2}}}t.$3s=h}),te(ne[26],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=void 0;function D(c){return typeof c=="string"}t.$Jf=D;function F(c){return Array.isArray(c)&&c.every(i=>D(i))}t.$Kf=F;function r(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}t.$Lf=r;function o(c){const i=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof i}t.$Mf=o;function N(c){return typeof c=="number"&&!isNaN(c)}t.$Nf=N;function f(c){return!!c&&typeof c[Symbol.iterator]=="function"}t.$Of=f;function a(c){return c===!0||c===!1}t.$Pf=a;function s(c){return typeof c>"u"}t.$Qf=s;function h(c){return!A(c)}t.$Rf=h;function A(c){return s(c)||c===null}t.$Sf=A;function b(c,i){if(!c)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}t.$Tf=b;function g(c){if(A(c))throw new Error("Assertion Failed: argument is undefined or null");return c}t.$Uf=g;function e(...c){const i=[];for(let l=0;l<c.length;l++){const v=c[l];if(A(v))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);i.push(v)}return i}t.$Vf=e;const E=Object.prototype.hasOwnProperty;function R(c){if(!r(c))return!1;for(const i in c)if(E.call(c,i))return!1;return!0}t.$Wf=R;function L(c){return typeof c=="function"}t.$Xf=L;function $(...c){return c.length>0&&c.every(L)}t.$Yf=$;function m(c,i){const l=Math.min(c.length,i.length);for(let v=0;v<l;v++)u(c[v],i[v])}t.$Zf=m;function u(c,i){if(D(i)){if(typeof c!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(L(i)){try{if(c instanceof i)return}catch{}if(!A(c)&&c.constructor===i||i.length===1&&i.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$1f=u}),te(ne[41],re([0,1,26]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bk=t.$ak=t.$_j=void 0;const F=Object.create(null);function r(f,a){if((0,D.$Jf)(a)){const s=F[a];if(s===void 0)throw new Error(`${f} references an unknown codicon: ${a}`);a=s}return F[f]=a,{id:f}}function o(){return F}t.$_j=o;function N(){return Object.values(t.$bk)}t.$ak=N,t.$bk={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugBreakpointPending:r("debug-breakpoint-pending",60377),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),lightbulbSparkle:r("lightbulb-sparkle",60447),lightbulbSparkleAutofix:r("lightbulb-sparkle-autofix",60447),robot:r("robot",60448),sparkleFilled:r("sparkle-filled",60449),diffSingle:r("diff-single",60450),diffMultiple:r("diff-multiple",60451),surroundWith:r("surround-with",60452),gitStash:r("git-stash",60454),gitStashApply:r("git-stash-apply",60455),gitStashPop:r("git-stash-pop",60456),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),te(ne[14],re([0,1,26]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jn=t.$In=t.$Hn=t.$Gn=t.$Fn=t.$En=t.$Dn=t.$Cn=t.$Bn=t.$An=t.$zn=t.$yn=void 0;function F(L){if(!L||typeof L!="object"||L instanceof RegExp)return L;const $=Array.isArray(L)?[]:{};return Object.entries(L).forEach(([m,u])=>{$[m]=u&&typeof u=="object"?F(u):u}),$}t.$yn=F;function r(L){if(!L||typeof L!="object")return L;const $=[L];for(;$.length>0;){const m=$.shift();Object.freeze(m);for(const u in m)if(o.call(m,u)){const c=m[u];typeof c=="object"&&!Object.isFrozen(c)&&!(0,D.$Mf)(c)&&$.push(c)}}return L}t.$zn=r;const o=Object.prototype.hasOwnProperty;function N(L,$){return f(L,$,new Set)}t.$An=N;function f(L,$,m){if((0,D.$Sf)(L))return L;const u=$(L);if(typeof u<"u")return u;if(Array.isArray(L)){const c=[];for(const i of L)c.push(f(i,$,m));return c}if((0,D.$Lf)(L)){if(m.has(L))throw new Error("Cannot clone recursive data-structure");m.add(L);const c={};for(const i in L)o.call(L,i)&&(c[i]=f(L[i],$,m));return m.delete(L),c}return L}function a(L,$,m=!0){return(0,D.$Lf)(L)?((0,D.$Lf)($)&&Object.keys($).forEach(u=>{u in L?m&&((0,D.$Lf)(L[u])&&(0,D.$Lf)($[u])?a(L[u],$[u],m):L[u]=$[u]):L[u]=$[u]}),L):$}t.$Bn=a;function s(L,$){if(L===$)return!0;if(L==null||$===null||$===void 0||typeof L!=typeof $||typeof L!="object"||Array.isArray(L)!==Array.isArray($))return!1;let m,u;if(Array.isArray(L)){if(L.length!==$.length)return!1;for(m=0;m<L.length;m++)if(!s(L[m],$[m]))return!1}else{const c=[];for(u in L)c.push(u);c.sort();const i=[];for(u in $)i.push(u);if(i.sort(),!s(c,i))return!1;for(m=0;m<c.length;m++)if(!s(L[c[m]],$[c[m]]))return!1}return!0}t.$Cn=s;function h(L){const $=new Set;return JSON.stringify(L,(m,u)=>{if((0,D.$Lf)(u)||Array.isArray(u)){if($.has(u))return"[Circular]";$.add(u)}return u})}t.$Dn=h;function A(L,$){const m=Object.create(null);return!L||!$||Object.keys($).forEach(c=>{const i=L[c],l=$[c];s(i,l)||(m[c]=l)}),m}t.$En=A;function b(L,$){const m=$.toLowerCase(),u=Object.keys(L).find(c=>c.toLowerCase()===m);return u?L[u]:L[$]}t.$Fn=b;function g(L,$){const m=Object.create(null);for(const[u,c]of Object.entries(L))$(u,c)&&(m[u]=c);return m}t.$Gn=g;function e(L){let $=[];for(;Object.prototype!==L;)$=$.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return $}t.$Hn=e;function E(L){const $=[];for(const m of e(L))typeof L[m]=="function"&&$.push(m);return $}t.$In=E;function R(L,$){const m=c=>function(){const i=Array.prototype.slice.call(arguments,0);return $(c,i)},u={};for(const c of L)u[c]=m(c);return u}t.$Jn=R}),te(ne[27],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Je=t.$Ie=t.Constants=void 0;var D;(function(o){o[o.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",o[o.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",o[o.MAX_UINT_8=255]="MAX_UINT_8",o[o.MAX_UINT_16=65535]="MAX_UINT_16",o[o.MAX_UINT_32=4294967295]="MAX_UINT_32",o[o.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(t.Constants=D={}));function F(o){return o<0?0:o>255?255:o|0}t.$Ie=F;function r(o){return o<0?0:o>4294967295?4294967295:o|0}t.$Je=r}),te(ne[28],re([0,1,27]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$it=t.$ht=void 0;class F{constructor(f){const a=(0,D.$Ie)(f);this.c=a,this.a=F.d(a),this.b=new Map}static d(f){const a=new Uint8Array(256);return a.fill(f),a}set(f,a){const s=(0,D.$Ie)(a);f>=0&&f<256?this.a[f]=s:this.b.set(f,s)}get(f){return f>=0&&f<256?this.a[f]:this.b.get(f)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$ht=F;var r;(function(N){N[N.False=0]="False",N[N.True=1]="True"})(r||(r={}));class o{constructor(){this.a=new F(0)}add(f){this.a.set(f,1)}has(f){return this.a.get(f)===1}clear(){return this.a.clear()}}t.$it=o}),te(ne[4],re([0,1,3]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5s=t.$4s=void 0;class F{static addRange(N,f){let a=0;for(;a<f.length&&f[a].endExclusive<N.start;)a++;let s=a;for(;s<f.length&&f[s].start<=N.endExclusive;)s++;if(a===s)f.splice(a,0,N);else{const h=Math.min(N.start,f[a].start),A=Math.max(N.endExclusive,f[s-1].endExclusive);f.splice(a,s-a,new F(h,A))}}static tryCreate(N,f){if(!(N>f))return new F(N,f)}static ofLength(N){return new F(0,N)}static ofStartAndLength(N,f){return new F(N,N+f)}constructor(N,f){if(this.start=N,this.endExclusive=f,N>f)throw new D.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(N){return new F(this.start+N,this.endExclusive+N)}deltaStart(N){return new F(this.start+N,this.endExclusive)}deltaEnd(N){return new F(this.start,this.endExclusive+N)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(N){return this.start===N.start&&this.endExclusive===N.endExclusive}containsRange(N){return this.start<=N.start&&N.endExclusive<=this.endExclusive}contains(N){return this.start<=N&&N<this.endExclusive}join(N){return new F(Math.min(this.start,N.start),Math.max(this.endExclusive,N.endExclusive))}intersect(N){const f=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);if(f<=a)return new F(f,a)}intersects(N){const f=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);return f<a}intersectsOrTouches(N){const f=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);return f<=a}isBefore(N){return this.endExclusive<=N.start}isAfter(N){return this.start>=N.endExclusive}slice(N){return N.slice(this.start,this.endExclusive)}substring(N){return N.substring(this.start,this.endExclusive)}clip(N){if(this.isEmpty)throw new D.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,N))}clipCyclic(N){if(this.isEmpty)throw new D.$cb(`Invalid clipping range: ${this.toString()}`);return N<this.start?this.endExclusive-(this.start-N)%this.length:N>=this.endExclusive?this.start+(N-this.start)%this.length:N}map(N){const f=[];for(let a=this.start;a<this.endExclusive;a++)f.push(N(a));return f}forEach(N){for(let f=this.start;f<this.endExclusive;f++)N(f)}}t.$4s=F;class r{constructor(){this.a=[]}addRange(N){let f=0;for(;f<this.a.length&&this.a[f].endExclusive<N.start;)f++;let a=f;for(;a<this.a.length&&this.a[a].start<=N.endExclusive;)a++;if(f===a)this.a.splice(f,0,N);else{const s=Math.min(N.start,this.a[f].start),h=Math.max(N.endExclusive,this.a[a-1].endExclusive);this.a.splice(f,a-f,new F(s,h))}}toString(){return this.a.map(N=>N.toString()).join(", ")}intersectsStrict(N){let f=0;for(;f<this.a.length&&this.a[f].endExclusive<=N.start;)f++;return f<this.a.length&&this.a[f].start<N.endExclusive}intersectWithRange(N){const f=new r;for(const a of this.a){const s=a.intersect(N);s&&f.addRange(s)}return f}intersectWithRangeLength(N){return this.intersectWithRange(N).length}get length(){return this.a.reduce((N,f)=>N+f.length,0)}}t.$5s=r}),te(ne[5],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vs=void 0;class D{constructor(r,o){this.lineNumber=r,this.column=o}with(r=this.lineNumber,o=this.column){return r===this.lineNumber&&o===this.column?this:new D(r,o)}delta(r=0,o=0){return this.with(this.lineNumber+r,this.column+o)}equals(r){return D.equals(this,r)}static equals(r,o){return!r&&!o?!0:!!r&&!!o&&r.lineNumber===o.lineNumber&&r.column===o.column}isBefore(r){return D.isBefore(this,r)}static isBefore(r,o){return r.lineNumber<o.lineNumber?!0:o.lineNumber<r.lineNumber?!1:r.column<o.column}isBeforeOrEqual(r){return D.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,o){return r.lineNumber<o.lineNumber?!0:o.lineNumber<r.lineNumber?!1:r.column<=o.column}static compare(r,o){const N=r.lineNumber|0,f=o.lineNumber|0;if(N===f){const a=r.column|0,s=o.column|0;return a-s}return N-f}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new D(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$Vs=D}),te(ne[2],re([0,1,5]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ws=void 0;class F{constructor(o,N,f,a){o>f||o===f&&N>a?(this.startLineNumber=f,this.startColumn=a,this.endLineNumber=o,this.endColumn=N):(this.startLineNumber=o,this.startColumn=N,this.endLineNumber=f,this.endColumn=a)}isEmpty(){return F.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return F.containsPosition(this,o)}static containsPosition(o,N){return!(N.lineNumber<o.startLineNumber||N.lineNumber>o.endLineNumber||N.lineNumber===o.startLineNumber&&N.column<o.startColumn||N.lineNumber===o.endLineNumber&&N.column>o.endColumn)}static strictContainsPosition(o,N){return!(N.lineNumber<o.startLineNumber||N.lineNumber>o.endLineNumber||N.lineNumber===o.startLineNumber&&N.column<=o.startColumn||N.lineNumber===o.endLineNumber&&N.column>=o.endColumn)}containsRange(o){return F.containsRange(this,o)}static containsRange(o,N){return!(N.startLineNumber<o.startLineNumber||N.endLineNumber<o.startLineNumber||N.startLineNumber>o.endLineNumber||N.endLineNumber>o.endLineNumber||N.startLineNumber===o.startLineNumber&&N.startColumn<o.startColumn||N.endLineNumber===o.endLineNumber&&N.endColumn>o.endColumn)}strictContainsRange(o){return F.strictContainsRange(this,o)}static strictContainsRange(o,N){return!(N.startLineNumber<o.startLineNumber||N.endLineNumber<o.startLineNumber||N.startLineNumber>o.endLineNumber||N.endLineNumber>o.endLineNumber||N.startLineNumber===o.startLineNumber&&N.startColumn<=o.startColumn||N.endLineNumber===o.endLineNumber&&N.endColumn>=o.endColumn)}plusRange(o){return F.plusRange(this,o)}static plusRange(o,N){let f,a,s,h;return N.startLineNumber<o.startLineNumber?(f=N.startLineNumber,a=N.startColumn):N.startLineNumber===o.startLineNumber?(f=N.startLineNumber,a=Math.min(N.startColumn,o.startColumn)):(f=o.startLineNumber,a=o.startColumn),N.endLineNumber>o.endLineNumber?(s=N.endLineNumber,h=N.endColumn):N.endLineNumber===o.endLineNumber?(s=N.endLineNumber,h=Math.max(N.endColumn,o.endColumn)):(s=o.endLineNumber,h=o.endColumn),new F(f,a,s,h)}intersectRanges(o){return F.intersectRanges(this,o)}static intersectRanges(o,N){let f=o.startLineNumber,a=o.startColumn,s=o.endLineNumber,h=o.endColumn;const A=N.startLineNumber,b=N.startColumn,g=N.endLineNumber,e=N.endColumn;return f<A?(f=A,a=b):f===A&&(a=Math.max(a,b)),s>g?(s=g,h=e):s===g&&(h=Math.min(h,e)),f>s||f===s&&a>h?null:new F(f,a,s,h)}equalsRange(o){return F.equalsRange(this,o)}static equalsRange(o,N){return!o&&!N?!0:!!o&&!!N&&o.startLineNumber===N.startLineNumber&&o.startColumn===N.startColumn&&o.endLineNumber===N.endLineNumber&&o.endColumn===N.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(o){return new D.$Vs(o.endLineNumber,o.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(o){return new D.$Vs(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,N){return new F(this.startLineNumber,this.startColumn,o,N)}setStartPosition(o,N){return new F(o,N,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(o){return new F(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(o){return new F(o.endLineNumber,o.endColumn,o.endLineNumber,o.endColumn)}delta(o){return new F(this.startLineNumber+o,this.startColumn,this.endLineNumber+o,this.endColumn)}static fromPositions(o,N=o){return new F(o.lineNumber,o.column,N.lineNumber,N.column)}static lift(o){return o?new F(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,N){return!(o.endLineNumber<N.startLineNumber||o.endLineNumber===N.startLineNumber&&o.endColumn<N.startColumn||N.endLineNumber<o.startLineNumber||N.endLineNumber===o.startLineNumber&&N.endColumn<o.startColumn)}static areIntersecting(o,N){return!(o.endLineNumber<N.startLineNumber||o.endLineNumber===N.startLineNumber&&o.endColumn<=N.startColumn||N.endLineNumber<o.startLineNumber||N.endLineNumber===o.startLineNumber&&N.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,N){if(o&&N){const s=o.startLineNumber|0,h=N.startLineNumber|0;if(s===h){const A=o.startColumn|0,b=N.startColumn|0;if(A===b){const g=o.endLineNumber|0,e=N.endLineNumber|0;if(g===e){const E=o.endColumn|0,R=N.endColumn|0;return E-R}return g-e}return A-b}return s-h}return(o?1:0)-(N?1:0)}static compareRangesUsingEnds(o,N){return o.endLineNumber===N.endLineNumber?o.endColumn===N.endColumn?o.startLineNumber===N.startLineNumber?o.startColumn-N.startColumn:o.startLineNumber-N.startLineNumber:o.endColumn-N.endColumn:o.endLineNumber-N.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}toJSON(){return this}}t.$Ws=F}),te(ne[42],re([0,1,2]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xs=void 0;class F{static insert(o,N){return{range:new D.$Ws(o.lineNumber,o.column,o.lineNumber,o.column),text:N,forceMoveMarkers:!0}}static delete(o){return{range:o,text:null}}static replace(o,N){return{range:o,text:N}}static replaceMove(o,N){return{range:o,text:N,forceMoveMarkers:!0}}}t.$Xs=F}),te(ne[12],re([0,1,3,4,2,9]),function(V,t,D,F,r,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7s=t.$6s=void 0;class N{static fromRange(s){return new N(s.startLineNumber,s.endLineNumber)}static fromRangeInclusive(s){return new N(s.startLineNumber,s.endLineNumber+1)}static subtract(s,h){return h?s.startLineNumber<h.startLineNumber&&h.endLineNumberExclusive<s.endLineNumberExclusive?[new N(s.startLineNumber,h.startLineNumber),new N(h.endLineNumberExclusive,s.endLineNumberExclusive)]:h.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=h.endLineNumberExclusive?[]:h.endLineNumberExclusive<s.endLineNumberExclusive?[new N(Math.max(h.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new N(s.startLineNumber,Math.min(h.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let h=new f(s[0].slice());for(let A=1;A<s.length;A++)h=h.getUnion(new f(s[A].slice()));return h.ranges}static ofLength(s,h){return new N(s,s+h)}static deserialize(s){return new N(s[0],s[1])}constructor(s,h){if(s>h)throw new D.$cb(`startLineNumber ${s} cannot be after endLineNumberExclusive ${h}`);this.startLineNumber=s,this.endLineNumberExclusive=h}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new N(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new N(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new N(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const h=Math.max(this.startLineNumber,s.startLineNumber),A=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(h<=A)return new N(h,A)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new r.$Ws(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new r.$Ws(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const h=[];for(let A=this.startLineNumber;A<this.endLineNumberExclusive;A++)h.push(s(A));return h}forEach(s){for(let h=this.startLineNumber;h<this.endLineNumberExclusive;h++)s(h)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new F.$4s(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$6s=N;class f{constructor(s=[]){this.c=s}get ranges(){return this.c}addRange(s){if(s.length===0)return;const h=(0,o.$kb)(this.c,b=>b.endLineNumberExclusive>=s.startLineNumber),A=(0,o.$ib)(this.c,b=>b.startLineNumber<=s.endLineNumberExclusive)+1;if(h===A)this.c.splice(h,0,s);else if(h===A-1){const b=this.c[h];this.c[h]=b.join(s)}else{const b=this.c[h].join(this.c[A-1]).join(s);this.c.splice(h,A-h,b)}}contains(s){const h=(0,o.$hb)(this.c,A=>A.startLineNumber<=s);return!!h&&h.endLineNumberExclusive>s}intersects(s){const h=(0,o.$hb)(this.c,A=>A.startLineNumber<s.endLineNumberExclusive);return!!h&&h.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this.c.length===0)return s;if(s.c.length===0)return this;const h=[];let A=0,b=0,g=null;for(;A<this.c.length||b<s.c.length;){let e=null;if(A<this.c.length&&b<s.c.length){const E=this.c[A],R=s.c[b];E.startLineNumber<R.startLineNumber?(e=E,A++):(e=R,b++)}else A<this.c.length?(e=this.c[A],A++):(e=s.c[b],b++);g===null?g=e:g.endLineNumberExclusive>=e.startLineNumber?g=new N(g.startLineNumber,Math.max(g.endLineNumberExclusive,e.endLineNumberExclusive)):(h.push(g),g=e)}return g!==null&&h.push(g),new f(h)}subtractFrom(s){const h=(0,o.$kb)(this.c,e=>e.endLineNumberExclusive>=s.startLineNumber),A=(0,o.$ib)(this.c,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(h===A)return new f([s]);const b=[];let g=s.startLineNumber;for(let e=h;e<A;e++){const E=this.c[e];E.startLineNumber>g&&b.push(new N(g,E.startLineNumber)),g=E.endLineNumberExclusive}return g<s.endLineNumberExclusive&&b.push(new N(g,s.endLineNumberExclusive)),new f(b)}toString(){return this.c.map(s=>s.toString()).join(", ")}getIntersection(s){const h=[];let A=0,b=0;for(;A<this.c.length&&b<s.c.length;){const g=this.c[A],e=s.c[b],E=g.intersect(e);E&&!E.isEmpty&&h.push(E),g.endLineNumberExclusive<e.endLineNumberExclusive?A++:b++}return new f(h)}getWithDelta(s){return new f(this.c.map(h=>h.delta(s)))}}t.$7s=f}),te(ne[43],re([0,1,5,2]),function(V,t,D,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ys=t.SelectionDirection=void 0;var r;(function(N){N[N.LTR=0]="LTR",N[N.RTL=1]="RTL"})(r||(t.SelectionDirection=r={}));class o extends F.$Ws{constructor(f,a,s,h){super(f,a,s,h),this.selectionStartLineNumber=f,this.selectionStartColumn=a,this.positionLineNumber=s,this.positionColumn=h}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(f){return o.selectionsEqual(this,f)}static selectionsEqual(f,a){return f.selectionStartLineNumber===a.selectionStartLineNumber&&f.selectionStartColumn===a.selectionStartColumn&&f.positionLineNumber===a.positionLineNumber&&f.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(f,a){return this.getDirection()===0?new o(this.startLineNumber,this.startColumn,f,a):new o(f,a,this.startLineNumber,this.startColumn)}getPosition(){return new D.$Vs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$Vs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(f,a){return this.getDirection()===0?new o(f,a,this.endLineNumber,this.endColumn):new o(this.endLineNumber,this.endColumn,f,a)}static fromPositions(f,a=f){return new o(f.lineNumber,f.column,a.lineNumber,a.column)}static fromRange(f,a){return a===0?new o(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):new o(f.endLineNumber,f.endColumn,f.startLineNumber,f.startColumn)}static liftSelection(f){return new o(f.selectionStartLineNumber,f.selectionStartColumn,f.positionLineNumber,f.positionColumn)}static selectionsArrEqual(f,a){if(f&&!a||!f&&a)return!1;if(!f&&!a)return!0;if(f.length!==a.length)return!1;for(let s=0,h=f.length;s<h;s++)if(!this.selectionsEqual(f[s],a[s]))return!1;return!0}static isISelection(f){return f&&typeof f.selectionStartLineNumber=="number"&&typeof f.selectionStartColumn=="number"&&typeof f.positionLineNumber=="number"&&typeof f.positionColumn=="number"}static createWithDirection(f,a,s,h,A){return A===0?new o(f,a,s,h):new o(s,h,f,a)}}t.$Ys=o}),te(ne[44],re([0,1,28]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kt=t.$jt=t.WordCharacterClass=void 0;var F;(function(N){N[N.Regular=0]="Regular",N[N.Whitespace=1]="Whitespace",N[N.WordSeparator=2]="WordSeparator"})(F||(t.WordCharacterClass=F={}));class r extends D.$ht{constructor(f){super(0);for(let a=0,s=f.length;a<s;a++)this.set(f.charCodeAt(a),2);this.set(32,1),this.set(9,1)}}t.$jt=r;function o(N){const f={};return a=>(f.hasOwnProperty(a)||(f[a]=N(a)),f[a])}t.$kt=o(N=>new r(N))}),te(ne[29],re([0,1,20,10,21]),function(V,t,D,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zs=t.$ys=t.$xs=t.$ws=t.$vs=void 0,t.$vs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function o(A=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const g of t.$vs)A.indexOf(g)>=0||(b+="\\"+g);return b+="\\s]+)",new RegExp(b,"g")}t.$ws=o();function N(A){let b=t.$ws;if(A&&A instanceof RegExp)if(A.global)b=A;else{let g="g";A.ignoreCase&&(g+="i"),A.multiline&&(g+="m"),A.unicode&&(g+="u"),b=new RegExp(A.source,g)}return b.lastIndex=0,b}t.$xs=N;const f=new r.$4c;f.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(A){const b=f.unshift(A);return(0,F.$Rc)(b)}t.$ys=a;function s(A,b,g,e,E){if(b=N(b),E||(E=D.Iterable.first(f)),g.length>E.maxLen){let u=A-E.maxLen/2;return u<0?u=0:e+=u,g=g.substring(u,A+E.maxLen/2),s(A,b,g,e,E)}const R=Date.now(),L=A-1-e;let $=-1,m=null;for(let u=1;!(Date.now()-R>=E.timeBudget);u++){const c=L-E.windowSize*u;b.lastIndex=Math.max(0,c);const i=h(b,g,L,$);if(!i&&m||(m=i,c<=0))break;$=c}if(m){const u={word:m[0],startColumn:e+1+m.index,endColumn:e+1+m.index+m[0].length};return b.lastIndex=0,u}return null}t.$zs=s;function h(A,b,g,e){let E;for(;E=A.exec(b);){const R=E.index||0;if(R<=g&&A.lastIndex>=g)return E;if(e>0&&R>e)return null}return null}}),te(ne[8],re([0,1,6,3,4]),function(V,t,D,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WZ=t.$VZ=t.$UZ=t.$TZ=t.$SZ=void 0;class o{static trivial(A,b){return new o([new N(r.$4s.ofLength(A.length),r.$4s.ofLength(b.length))],!1)}static trivialTimedOut(A,b){return new o([new N(r.$4s.ofLength(A.length),r.$4s.ofLength(b.length))],!0)}constructor(A,b){this.diffs=A,this.hitTimeout=b}}t.$SZ=o;class N{static invert(A,b){const g=[];return(0,D.$Bb)(A,(e,E)=>{g.push(N.fromOffsetPairs(e?e.getEndExclusives():f.zero,E?E.getStarts():new f(b,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+b)))}),g}static fromOffsetPairs(A,b){return new N(new r.$4s(A.offset1,b.offset1),new r.$4s(A.offset2,b.offset2))}constructor(A,b){this.seq1Range=A,this.seq2Range=b}swap(){return new N(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(A){return new N(this.seq1Range.join(A.seq1Range),this.seq2Range.join(A.seq2Range))}delta(A){return A===0?this:new N(this.seq1Range.delta(A),this.seq2Range.delta(A))}deltaStart(A){return A===0?this:new N(this.seq1Range.deltaStart(A),this.seq2Range.deltaStart(A))}deltaEnd(A){return A===0?this:new N(this.seq1Range.deltaEnd(A),this.seq2Range.deltaEnd(A))}intersectsOrTouches(A){return this.seq1Range.intersectsOrTouches(A.seq1Range)||this.seq2Range.intersectsOrTouches(A.seq2Range)}intersect(A){const b=this.seq1Range.intersect(A.seq1Range),g=this.seq2Range.intersect(A.seq2Range);if(!(!b||!g))return new N(b,g)}getStarts(){return new f(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new f(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$TZ=N;class f{static{this.zero=new f(0,0)}static{this.max=new f(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(A,b){this.offset1=A,this.offset2=b}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(A){return A===0?this:new f(this.offset1+A,this.offset2+A)}equals(A){return this.offset1===A.offset1&&this.offset2===A.offset2}}t.$UZ=f;class a{static{this.instance=new a}isValid(){return!0}}t.$VZ=a;class s{constructor(A){if(this.e=A,this.c=Date.now(),this.d=!0,A<=0)throw new F.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$WZ=s}),te(ne[30],re([0,1,4,8]),function(V,t,D,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2Z=void 0;class r{compute(s,h,A=F.$VZ.instance){if(s.length===0||h.length===0)return F.$SZ.trivial(s,h);const b=s,g=h;function e(l,v){for(;l<b.length&&v<g.length&&b.getElement(l)===g.getElement(v);)l++,v++;return l}let E=0;const R=new N;R.set(0,e(0,0));const L=new f;L.set(0,R.get(0)===0?null:new o(null,0,0,R.get(0)));let $=0;e:for(;;){if(E++,!A.isValid())return F.$SZ.trivialTimedOut(b,g);const l=-Math.min(E,g.length+E%2),v=Math.min(E,b.length+E%2);for($=l;$<=v;$+=2){let d=0;const w=$===v?-1:R.get($+1),M=$===l?-1:R.get($-1)+1;d++;const p=Math.min(Math.max(w,M),b.length),y=p-$;if(d++,p>b.length||y>g.length)continue;const _=e(p,y);R.set($,_);const k=p===w?L.get($+1):L.get($-1);if(L.set($,_!==p?new o(k,p,y,_-p):k),R.get($)===b.length&&R.get($)-$===g.length)break e}}let m=L.get($);const u=[];let c=b.length,i=g.length;for(;;){const l=m?m.x+m.length:0,v=m?m.y+m.length:0;if((l!==c||v!==i)&&u.push(new F.$TZ(new D.$4s(l,c),new D.$4s(v,i))),!m)break;c=m.x,i=m.y,m=m.prev}return u.reverse(),new F.$SZ(u,!1)}}t.$2Z=r;class o{constructor(s,h,A,b){this.prev=s,this.x=h,this.y=A,this.length=b}}class N{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,h){if(s<0){if(s=-s-1,s>=this.b.length){const A=this.b;this.b=new Int32Array(A.length*2),this.b.set(A)}this.b[s]=h}else{if(s>=this.a.length){const A=this.a;this.a=new Int32Array(A.length*2),this.a.set(A)}this.a[s]=h}}}class f{constructor(){this.a=[],this.b=[]}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,h){s<0?(s=-s-1,this.b[s]=h):this.a[s]=h}}}),te(ne[45],re([0,1,6,4,8]),function(V,t,D,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0Z=t.$9Z=t.$8Z=t.$7Z=t.$6Z=void 0;function o(e,E,R){let L=R;return L=N(e,E,L),L=N(e,E,L),L=f(e,E,L),L}t.$6Z=o;function N(e,E,R){if(R.length===0)return R;const L=[];L.push(R[0]);for(let m=1;m<R.length;m++){const u=L[L.length-1];let c=R[m];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const i=c.seq1Range.start-u.seq1Range.endExclusive;let l;for(l=1;l<=i&&!(e.getElement(c.seq1Range.start-l)!==e.getElement(c.seq1Range.endExclusive-l)||E.getElement(c.seq2Range.start-l)!==E.getElement(c.seq2Range.endExclusive-l));l++);if(l--,l===i){L[L.length-1]=new r.$TZ(new F.$4s(u.seq1Range.start,c.seq1Range.endExclusive-i),new F.$4s(u.seq2Range.start,c.seq2Range.endExclusive-i));continue}c=c.delta(-l)}L.push(c)}const $=[];for(let m=0;m<L.length-1;m++){const u=L[m+1];let c=L[m];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const i=u.seq1Range.start-c.seq1Range.endExclusive;let l;for(l=0;l<i&&!(!e.isStronglyEqual(c.seq1Range.start+l,c.seq1Range.endExclusive+l)||!E.isStronglyEqual(c.seq2Range.start+l,c.seq2Range.endExclusive+l));l++);if(l===i){L[m+1]=new r.$TZ(new F.$4s(c.seq1Range.start+i,u.seq1Range.endExclusive),new F.$4s(c.seq2Range.start+i,u.seq2Range.endExclusive));continue}l>0&&(c=c.delta(l))}$.push(c)}return L.length>0&&$.push(L[L.length-1]),$}function f(e,E,R){if(!e.getBoundaryScore||!E.getBoundaryScore)return R;for(let L=0;L<R.length;L++){const $=L>0?R[L-1]:void 0,m=R[L],u=L+1<R.length?R[L+1]:void 0,c=new F.$4s($?$.seq1Range.endExclusive+1:0,u?u.seq1Range.start-1:e.length),i=new F.$4s($?$.seq2Range.endExclusive+1:0,u?u.seq2Range.start-1:E.length);m.seq1Range.isEmpty?R[L]=a(m,e,E,c,i):m.seq2Range.isEmpty&&(R[L]=a(m.swap(),E,e,i,c).swap())}return R}function a(e,E,R,L,$){let u=1;for(;e.seq1Range.start-u>=L.start&&e.seq2Range.start-u>=$.start&&R.isStronglyEqual(e.seq2Range.start-u,e.seq2Range.endExclusive-u)&&u<100;)u++;u--;let c=0;for(;e.seq1Range.start+c<L.endExclusive&&e.seq2Range.endExclusive+c<$.endExclusive&&R.isStronglyEqual(e.seq2Range.start+c,e.seq2Range.endExclusive+c)&&c<100;)c++;if(u===0&&c===0)return e;let i=0,l=-1;for(let v=-u;v<=c;v++){const d=e.seq2Range.start+v,w=e.seq2Range.endExclusive+v,M=e.seq1Range.start+v,p=E.getBoundaryScore(M)+R.getBoundaryScore(d)+R.getBoundaryScore(w);p>l&&(l=p,i=v)}return e.delta(i)}function s(e,E,R){const L=[];for(const $ of R){const m=L[L.length-1];if(!m){L.push($);continue}$.seq1Range.start-m.seq1Range.endExclusive<=2||$.seq2Range.start-m.seq2Range.endExclusive<=2?L[L.length-1]=new r.$TZ(m.seq1Range.join($.seq1Range),m.seq2Range.join($.seq2Range)):L.push($)}return L}t.$7Z=s;function h(e,E,R){const L=r.$TZ.invert(R,e.length),$=[];let m=new r.$UZ(0,0);function u(i,l){if(i.offset1<m.offset1||i.offset2<m.offset2)return;const v=e.findWordContaining(i.offset1),d=E.findWordContaining(i.offset2);if(!v||!d)return;let w=new r.$TZ(v,d);const M=w.intersect(l);let p=M.seq1Range.length,y=M.seq2Range.length;for(;L.length>0;){const _=L[0];if(!(_.seq1Range.intersects(v)||_.seq2Range.intersects(d)))break;const S=e.findWordContaining(_.seq1Range.start),T=E.findWordContaining(_.seq2Range.start),q=new r.$TZ(S,T),O=q.intersect(_);if(p+=O.seq1Range.length,y+=O.seq2Range.length,w=w.join(q),w.seq1Range.endExclusive>=_.seq1Range.endExclusive)L.shift();else break}p+y<(w.seq1Range.length+w.seq2Range.length)*2/3&&$.push(w),m=w.getEndExclusives()}for(;L.length>0;){const i=L.shift();i.seq1Range.isEmpty||(u(i.getStarts(),i),u(i.getEndExclusives().delta(-1),i))}return A(R,$)}t.$8Z=h;function A(e,E){const R=[];for(;e.length>0||E.length>0;){const L=e[0],$=E[0];let m;L&&(!$||L.seq1Range.start<$.seq1Range.start)?m=e.shift():m=E.shift(),R.length>0&&R[R.length-1].seq1Range.endExclusive>=m.seq1Range.start?R[R.length-1]=R[R.length-1].join(m):R.push(m)}return R}function b(e,E,R){let L=R;if(L.length===0)return L;let $=0,m;do{m=!1;const u=[L[0]];for(let c=1;c<L.length;c++){let v=function(w,M){const p=new F.$4s(l.seq1Range.endExclusive,i.seq1Range.start);return e.getText(p).replace(/\s/g,"").length<=4&&(w.seq1Range.length+w.seq2Range.length>5||M.seq1Range.length+M.seq2Range.length>5)};const i=L[c],l=u[u.length-1];v(l,i)?(m=!0,u[u.length-1]=u[u.length-1].join(i)):u.push(i)}L=u}while($++<10&&m);return L}t.$9Z=b;function g(e,E,R){let L=R;if(L.length===0)return L;let $=0,m;do{m=!1;const c=[L[0]];for(let i=1;i<L.length;i++){let d=function(M,p){const y=new F.$4s(v.seq1Range.endExclusive,l.seq1Range.start);if(e.countLinesIn(y)>5||y.length>500)return!1;const k=e.getText(y).trim();if(k.length>20||k.split(/\r\n|\r|\n/).length>1)return!1;const S=e.countLinesIn(M.seq1Range),T=M.seq1Range.length,q=E.countLinesIn(M.seq2Range),O=M.seq2Range.length,P=e.countLinesIn(p.seq1Range),W=p.seq1Range.length,G=E.countLinesIn(p.seq2Range),x=p.seq2Range.length,Q=2*40+50;function ee(n){return Math.min(n,Q)}return Math.pow(Math.pow(ee(S*40+T),1.5)+Math.pow(ee(q*40+O),1.5),1.5)+Math.pow(Math.pow(ee(P*40+W),1.5)+Math.pow(ee(G*40+x),1.5),1.5)>(Q**1.5)**1.5*1.3};const l=L[i],v=c[c.length-1];d(v,l)?(m=!0,c[c.length-1]=c[c.length-1].join(l)):c.push(l)}L=c}while($++<10&&m);const u=[];return(0,D.$Cb)(L,(c,i,l)=>{let v=i;function d(k){return k.length>0&&k.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const w=e.extendToFullLines(i.seq1Range),M=e.getText(new F.$4s(w.start,i.seq1Range.start));d(M)&&(v=v.deltaStart(-M.length));const p=e.getText(new F.$4s(i.seq1Range.endExclusive,w.endExclusive));d(p)&&(v=v.deltaEnd(p.length));const y=r.$TZ.fromOffsetPairs(c?c.getEndExclusives():r.$UZ.zero,l?l.getStarts():r.$UZ.max),_=v.intersect(y);u.length>0&&_.getStarts().equals(u[u.length-1].getEndExclusives())?u[u.length-1]=u[u.length-1].join(_):u.push(_)}),u}t.$0Z=g}),te(ne[46],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5Z=void 0;class D{constructor(o,N){this.a=o,this.b=N}getElement(o){return this.a[o]}get length(){return this.a.length}getBoundaryScore(o){const N=o===0?0:F(this.b[o-1]),f=o===this.b.length?0:F(this.b[o]);return 1e3-(N+f)}getText(o){return this.b.slice(o.start,o.endExclusive).join(`
`)}isStronglyEqual(o,N){return this.b[o]===this.b[N]}}t.$5Z=D;function F(r){let o=0;for(;o<r.length&&(r.charCodeAt(o)===32||r.charCodeAt(o)===9);)o++;return o}}),te(ne[15],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZZ=t.$YZ=t.$XZ=void 0;class D{constructor(N,f){this.width=N,this.height=f,this.a=[],this.a=new Array(N*f)}get(N,f){return this.a[N+f*this.width]}set(N,f,a){this.a[N+f*this.width]=a}}t.$XZ=D;function F(o){return o===32||o===9}t.$YZ=F;class r{static{this.a=new Map}static b(N){let f=this.a.get(N);return f===void 0&&(f=this.a.size,this.a.set(N,f)),f}constructor(N,f,a){this.range=N,this.lines=f,this.source=a,this.d=[];let s=0;for(let h=N.startLineNumber-1;h<N.endLineNumberExclusive-1;h++){const A=f[h];for(let g=0;g<A.length;g++){s++;const e=A[g],E=r.b(e);this.d[E]=(this.d[E]||0)+1}s++;const b=r.b(`
`);this.d[b]=(this.d[b]||0)+1}this.c=s}computeSimilarity(N){let f=0;const a=Math.max(this.d.length,N.d.length);for(let s=0;s<a;s++)f+=Math.abs((this.d[s]??0)-(N.d[s]??0));return 1-f/(this.c+N.c)}}t.$ZZ=r}),te(ne[47],re([0,1,4,8,15]),function(V,t,D,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1Z=void 0;class o{compute(f,a,s=F.$VZ.instance,h){if(f.length===0||a.length===0)return F.$SZ.trivial(f,a);const A=new r.$XZ(f.length,a.length),b=new r.$XZ(f.length,a.length),g=new r.$XZ(f.length,a.length);for(let u=0;u<f.length;u++)for(let c=0;c<a.length;c++){if(!s.isValid())return F.$SZ.trivialTimedOut(f,a);const i=u===0?0:A.get(u-1,c),l=c===0?0:A.get(u,c-1);let v;f.getElement(u)===a.getElement(c)?(u===0||c===0?v=0:v=A.get(u-1,c-1),u>0&&c>0&&b.get(u-1,c-1)===3&&(v+=g.get(u-1,c-1)),v+=h?h(u,c):1):v=-1;const d=Math.max(i,l,v);if(d===v){const w=u>0&&c>0?g.get(u-1,c-1):0;g.set(u,c,w+1),b.set(u,c,3)}else d===i?(g.set(u,c,0),b.set(u,c,1)):d===l&&(g.set(u,c,0),b.set(u,c,2));A.set(u,c,d)}const e=[];let E=f.length,R=a.length;function L(u,c){(u+1!==E||c+1!==R)&&e.push(new F.$TZ(new D.$4s(u+1,E),new D.$4s(c+1,R))),E=u,R=c}let $=f.length-1,m=a.length-1;for(;$>=0&&m>=0;)b.get($,m)===3?(L($,m),$--,m--):b.get($,m)===1?$--:m--;return L(-1,-1),e.reverse(),new F.$SZ(e,!1)}}t.$1Z=o}),te(ne[31],re([0,1,9,4,5,2,15]),function(V,t,D,F,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3Z=void 0;class f{constructor(e,E,R){this.lines=e,this.considerWhitespaceChanges=R,this.b=[],this.c=[],this.d=[];let L=!1;E.start>0&&E.endExclusive>=e.length&&(E=new F.$4s(E.start-1,E.endExclusive),L=!0),this.lineRange=E,this.c[0]=0;for(let $=this.lineRange.start;$<this.lineRange.endExclusive;$++){let m=e[$],u=0;if(L)u=m.length,m="",L=!1;else if(!R){const c=m.trimStart();u=m.length-c.length,m=c.trimEnd()}this.d.push(u);for(let c=0;c<m.length;c++)this.b.push(m.charCodeAt(c));$<e.length-1&&(this.b.push(`
`.charCodeAt(0)),this.c[$-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new F.$4s(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(E=>String.fromCharCode(E)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const E=b(e>0?this.b[e-1]:-1),R=b(e<this.b.length?this.b[e]:-1);if(E===7&&R===8)return 0;if(E===8)return 150;let L=0;return E!==R&&(L+=10,E===0&&R===1&&(L+=1)),L+=A(E),L+=A(R),L}translateOffset(e){if(this.lineRange.isEmpty)return new r.$Vs(this.lineRange.start+1,1);const E=(0,D.$ib)(this.c,R=>R<=e);return new r.$Vs(this.lineRange.start+E+1,e-this.c[E]+this.d[E]+1)}translateRange(e){return o.$Ws.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!a(this.b[e]))return;let E=e;for(;E>0&&a(this.b[E-1]);)E--;let R=e;for(;R<this.b.length&&a(this.b[R]);)R++;return new F.$4s(E,R)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,E){return this.b[e]===this.b[E]}extendToFullLines(e){const E=(0,D.$hb)(this.c,L=>L<=e.start)??0,R=(0,D.$jb)(this.c,L=>e.endExclusive<=L)??this.b.length;return new F.$4s(E,R)}}t.$3Z=f;function a(g){return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57}var s;(function(g){g[g.WordLower=0]="WordLower",g[g.WordUpper=1]="WordUpper",g[g.WordNumber=2]="WordNumber",g[g.End=3]="End",g[g.Other=4]="Other",g[g.Separator=5]="Separator",g[g.Space=6]="Space",g[g.LineBreakCR=7]="LineBreakCR",g[g.LineBreakLF=8]="LineBreakLF"})(s||(s={}));const h={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:30,[6]:3,[7]:10,[8]:10};function A(g){return h[g]}function b(g){return g===10?8:g===13?7:(0,N.$YZ)(g)?6:g>=97&&g<=122?0:g>=65&&g<=90?1:g>=48&&g<=57?2:g===-1?3:g===44||g===59?5:4}}),te(ne[32],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_s=t.$$s=void 0;class D{constructor(o,N,f){this.changes=o,this.moves=N,this.hitTimeout=f}}t.$$s=D;class F{constructor(o,N){this.lineRangeMapping=o,this.changes=N}flip(){return new F(this.lineRangeMapping.flip(),this.changes.map(o=>o.flip()))}}t.$_s=F}),te(ne[16],re([0,1,12]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0s=t.$9s=t.$8s=void 0;class F{static inverse(f,a,s){const h=[];let A=1,b=1;for(const e of f){const E=new F(new D.$6s(A,e.original.startLineNumber),new D.$6s(b,e.modified.startLineNumber));E.modified.isEmpty||h.push(E),A=e.original.endLineNumberExclusive,b=e.modified.endLineNumberExclusive}const g=new F(new D.$6s(A,a+1),new D.$6s(b,s+1));return g.modified.isEmpty||h.push(g),h}static clip(f,a,s){const h=[];for(const A of f){const b=A.original.intersect(a),g=A.modified.intersect(s);b&&!b.isEmpty&&g&&!g.isEmpty&&h.push(new F(b,g))}return h}constructor(f,a){this.original=f,this.modified=a}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new F(this.modified,this.original)}join(f){return new F(this.original.join(f.original),this.modified.join(f.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$8s=F;class r extends F{constructor(f,a,s){super(f,a),this.innerChanges=s}flip(){return new r(this.modified,this.original,this.innerChanges?.map(f=>f.flip()))}}t.$9s=r;class o{constructor(f,a){this.originalRange=f,this.modifiedRange=a}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new o(this.modifiedRange,this.originalRange)}}t.$0s=o}),te(ne[48],re([0,1,8,16,6,9,22,12,4,31,15,30]),function(V,t,D,F,r,o,N,f,a,s,h,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4Z=void 0;function b(m,u,c,i,l,v){let{moves:d,excludedChanges:w}=e(m,u,c,v);if(!v.isValid())return[];const M=m.filter(y=>!w.has(y)),p=E(M,i,l,u,c,v);return(0,r.$1b)(d,p),d=L(d),d=d.filter(y=>{const _=y.original.toOffsetRange().slice(u).map(S=>S.trim());return _.join(`
`).length>=15&&g(_,S=>S.length>=2)>=2}),d=$(m,d),d}t.$4Z=b;function g(m,u){let c=0;for(const i of m)u(i)&&c++;return c}function e(m,u,c,i){const l=[],v=m.filter(M=>M.modified.isEmpty&&M.original.length>=3).map(M=>new h.$ZZ(M.original,u,M)),d=new Set(m.filter(M=>M.original.isEmpty&&M.modified.length>=3).map(M=>new h.$ZZ(M.modified,c,M))),w=new Set;for(const M of v){let p=-1,y;for(const _ of d){const k=M.computeSimilarity(_);k>p&&(p=k,y=_)}if(p>.9&&y&&(d.delete(y),l.push(new F.$8s(M.range,y.range)),w.add(M.source),w.add(y.source)),!i.isValid())return{moves:l,excludedChanges:w}}return{moves:l,excludedChanges:w}}function E(m,u,c,i,l,v){const d=[],w=new N.$Gc;for(const k of m)for(let S=k.original.startLineNumber;S<k.original.endLineNumberExclusive-2;S++){const T=`${u[S-1]}:${u[S+1-1]}:${u[S+2-1]}`;w.add(T,{range:new f.$6s(S,S+3)})}const M=[];m.sort((0,r.$7b)(k=>k.modified.startLineNumber,r.$9b));for(const k of m){let S=[];for(let T=k.modified.startLineNumber;T<k.modified.endLineNumberExclusive-2;T++){const q=`${c[T-1]}:${c[T+1-1]}:${c[T+2-1]}`,O=new f.$6s(T,T+3),P=[];w.forEach(q,({range:W})=>{for(const x of S)if(x.originalLineRange.endLineNumberExclusive+1===W.endLineNumberExclusive&&x.modifiedLineRange.endLineNumberExclusive+1===O.endLineNumberExclusive){x.originalLineRange=new f.$6s(x.originalLineRange.startLineNumber,W.endLineNumberExclusive),x.modifiedLineRange=new f.$6s(x.modifiedLineRange.startLineNumber,O.endLineNumberExclusive),P.push(x);return}const G={modifiedLineRange:O,originalLineRange:W};M.push(G),P.push(G)}),S=P}if(!v.isValid())return[]}M.sort((0,r.$$b)((0,r.$7b)(k=>k.modifiedLineRange.length,r.$9b)));const p=new f.$7s,y=new f.$7s;for(const k of M){const S=k.modifiedLineRange.startLineNumber-k.originalLineRange.startLineNumber,T=p.subtractFrom(k.modifiedLineRange),q=y.subtractFrom(k.originalLineRange).getWithDelta(S),O=T.getIntersection(q);for(const P of O.ranges){if(P.length<3)continue;const W=P,G=P.delta(-S);d.push(new F.$8s(G,W)),p.addRange(W),y.addRange(G)}}d.sort((0,r.$7b)(k=>k.original.startLineNumber,r.$9b));const _=new o.$mb(m);for(let k=0;k<d.length;k++){const S=d[k],T=_.findLastMonotonous(ee=>ee.original.startLineNumber<=S.original.startLineNumber),q=(0,o.$hb)(m,ee=>ee.modified.startLineNumber<=S.modified.startLineNumber),O=Math.max(S.original.startLineNumber-T.original.startLineNumber,S.modified.startLineNumber-q.modified.startLineNumber),P=_.findLastMonotonous(ee=>ee.original.startLineNumber<S.original.endLineNumberExclusive),W=(0,o.$hb)(m,ee=>ee.modified.startLineNumber<S.modified.endLineNumberExclusive),G=Math.max(P.original.endLineNumberExclusive-S.original.endLineNumberExclusive,W.modified.endLineNumberExclusive-S.modified.endLineNumberExclusive);let x;for(x=0;x<O;x++){const ee=S.original.startLineNumber-x-1,n=S.modified.startLineNumber-x-1;if(ee>i.length||n>l.length||p.contains(n)||y.contains(ee)||!R(i[ee-1],l[n-1],v))break}x>0&&(y.addRange(new f.$6s(S.original.startLineNumber-x,S.original.startLineNumber)),p.addRange(new f.$6s(S.modified.startLineNumber-x,S.modified.startLineNumber)));let Q;for(Q=0;Q<G;Q++){const ee=S.original.endLineNumberExclusive+Q,n=S.modified.endLineNumberExclusive+Q;if(ee>i.length||n>l.length||p.contains(n)||y.contains(ee)||!R(i[ee-1],l[n-1],v))break}Q>0&&(y.addRange(new f.$6s(S.original.endLineNumberExclusive,S.original.endLineNumberExclusive+Q)),p.addRange(new f.$6s(S.modified.endLineNumberExclusive,S.modified.endLineNumberExclusive+Q))),(x>0||Q>0)&&(d[k]=new F.$8s(new f.$6s(S.original.startLineNumber-x,S.original.endLineNumberExclusive+Q),new f.$6s(S.modified.startLineNumber-x,S.modified.endLineNumberExclusive+Q)))}return d}function R(m,u,c){if(m.trim()===u.trim())return!0;if(m.length>300&&u.length>300)return!1;const l=new A.$2Z().compute(new s.$3Z([m],new a.$4s(0,1),!1),new s.$3Z([u],new a.$4s(0,1),!1),c);let v=0;const d=D.$TZ.invert(l.diffs,m.length);for(const y of d)y.seq1Range.forEach(_=>{(0,h.$YZ)(m.charCodeAt(_))||v++});function w(y){let _=0;for(let k=0;k<m.length;k++)(0,h.$YZ)(y.charCodeAt(k))||_++;return _}const M=w(m.length>u.length?m:u);return v/M>.6&&M>10}function L(m){if(m.length===0)return m;m.sort((0,r.$7b)(c=>c.original.startLineNumber,r.$9b));const u=[m[0]];for(let c=1;c<m.length;c++){const i=u[u.length-1],l=m[c],v=l.original.startLineNumber-i.original.endLineNumberExclusive,d=l.modified.startLineNumber-i.modified.endLineNumberExclusive;if(v>=0&&d>=0&&v+d<=2){u[u.length-1]=i.join(l);continue}u.push(l)}return u}function $(m,u){const c=new o.$mb(m);return u=u.filter(i=>{const l=c.findLastMonotonous(w=>w.original.startLineNumber<i.original.endLineNumberExclusive)||new F.$8s(new f.$6s(1,1),new f.$6s(1,1)),v=(0,o.$hb)(m,w=>w.modified.startLineNumber<i.modified.endLineNumberExclusive);return l!==v}),u}}),te(ne[49],re([0,1,6,13,12,4,2,8,47,30,48,45,32,16,31,46]),function(V,t,D,F,r,o,N,f,a,s,h,A,b,g,e,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$a1=t.$_Z=t.$$Z=void 0;class R{constructor(){this.e=new a.$1Z,this.f=new s.$2Z}computeDiff(u,c,i){if(u.length<=1&&(0,D.$ub)(u,c,(Q,ee)=>Q===ee))return new b.$$s([],[],!1);if(u.length===1&&u[0].length===0||c.length===1&&c[0].length===0)return new b.$$s([new g.$9s(new r.$6s(1,u.length+1),new r.$6s(1,c.length+1),[new g.$0s(new N.$Ws(1,1,u.length,u[0].length+1),new N.$Ws(1,1,c.length,c[0].length+1))])],[],!1);const l=i.maxComputationTimeMs===0?f.$VZ.instance:new f.$WZ(i.maxComputationTimeMs),v=!i.ignoreTrimWhitespace,d=new Map;function w(Q){let ee=d.get(Q);return ee===void 0&&(ee=d.size,d.set(Q,ee)),ee}const M=u.map(Q=>w(Q.trim())),p=c.map(Q=>w(Q.trim())),y=new E.$5Z(M,u),_=new E.$5Z(p,c),k=(()=>y.length+_.length<1700?this.e.compute(y,_,l,(Q,ee)=>u[Q]===c[ee]?c[ee].length===0?.1:1+Math.log(1+c[ee].length):.99):this.f.compute(y,_))();let S=k.diffs,T=k.hitTimeout;S=(0,A.$6Z)(y,_,S),S=(0,A.$9Z)(y,_,S);const q=[],O=Q=>{if(v)for(let ee=0;ee<Q;ee++){const n=P+ee,le=W+ee;if(u[n]!==c[le]){const he=this.j(u,c,new f.$TZ(new o.$4s(n,n+1),new o.$4s(le,le+1)),l,v);for(const be of he.mappings)q.push(be);he.hitTimeout&&(T=!0)}}};let P=0,W=0;for(const Q of S){(0,F.$9c)(()=>Q.seq1Range.start-P===Q.seq2Range.start-W);const ee=Q.seq1Range.start-P;O(ee),P=Q.seq1Range.endExclusive,W=Q.seq2Range.endExclusive;const n=this.j(u,c,Q,l,v);n.hitTimeout&&(T=!0);for(const le of n.mappings)q.push(le)}O(u.length-P);const G=L(q,u,c);let x=[];return i.computeMoves&&(x=this.h(G,u,c,M,p,l,v)),(0,F.$9c)(()=>{function Q(n,le){if(n.lineNumber<1||n.lineNumber>le.length)return!1;const he=le[n.lineNumber-1];return!(n.column<1||n.column>he.length+1)}function ee(n,le){return!(n.startLineNumber<1||n.startLineNumber>le.length+1||n.endLineNumberExclusive<1||n.endLineNumberExclusive>le.length+1)}for(const n of G){if(!n.innerChanges)return!1;for(const le of n.innerChanges)if(!(Q(le.modifiedRange.getStartPosition(),c)&&Q(le.modifiedRange.getEndPosition(),c)&&Q(le.originalRange.getStartPosition(),u)&&Q(le.originalRange.getEndPosition(),u)))return!1;if(!ee(n.modified,c)||!ee(n.original,u))return!1}return!0}),new b.$$s(G,x,T)}h(u,c,i,l,v,d,w){return(0,h.$4Z)(u,c,i,l,v,d).map(y=>{const _=this.j(c,i,new f.$TZ(y.original.toOffsetRange(),y.modified.toOffsetRange()),d,w),k=L(_.mappings,c,i,!0);return new b.$_s(y,k)})}j(u,c,i,l,v){const d=new e.$3Z(u,i.seq1Range,v),w=new e.$3Z(c,i.seq2Range,v),M=d.length+w.length<500?this.e.compute(d,w,l):this.f.compute(d,w,l);let p=M.diffs;return p=(0,A.$6Z)(d,w,p),p=(0,A.$8Z)(d,w,p),p=(0,A.$7Z)(d,w,p),p=(0,A.$0Z)(d,w,p),{mappings:p.map(_=>new g.$0s(d.translateRange(_.seq1Range),w.translateRange(_.seq2Range))),hitTimeout:M.hitTimeout}}}t.$$Z=R;function L(m,u,c,i=!1){const l=[];for(const v of(0,D.$Ab)(m.map(d=>$(d,u,c)),(d,w)=>d.original.overlapOrTouch(w.original)||d.modified.overlapOrTouch(w.modified))){const d=v[0],w=v[v.length-1];l.push(new g.$9s(d.original.join(w.original),d.modified.join(w.modified),v.map(M=>M.innerChanges[0])))}return(0,F.$9c)(()=>!i&&l.length>0&&l[0].original.startLineNumber!==l[0].modified.startLineNumber?!1:(0,F.$0c)(l,(v,d)=>d.original.startLineNumber-v.original.endLineNumberExclusive===d.modified.startLineNumber-v.modified.endLineNumberExclusive&&v.original.endLineNumberExclusive<d.original.startLineNumber&&v.modified.endLineNumberExclusive<d.modified.startLineNumber)),l}t.$_Z=L;function $(m,u,c){let i=0,l=0;m.modifiedRange.endColumn===1&&m.originalRange.endColumn===1&&m.originalRange.startLineNumber+i<=m.originalRange.endLineNumber&&m.modifiedRange.startLineNumber+i<=m.modifiedRange.endLineNumber&&(l=-1),m.modifiedRange.startColumn-1>=c[m.modifiedRange.startLineNumber-1].length&&m.originalRange.startColumn-1>=u[m.originalRange.startLineNumber-1].length&&m.originalRange.startLineNumber<=m.originalRange.endLineNumber+l&&m.modifiedRange.startLineNumber<=m.modifiedRange.endLineNumber+l&&(i=1);const v=new r.$6s(m.originalRange.startLineNumber+i,m.originalRange.endLineNumber+1+l),d=new r.$6s(m.modifiedRange.startLineNumber+i,m.modifiedRange.endLineNumber+1+l);return new g.$9s(v,d,[m])}t.$a1=$}),te(ne[33],re([0,1,25,32,16,7,2,13,12]),function(V,t,D,F,r,o,N,f,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bt=t.$at=void 0;const s=3;class h{computeDiff(i,l,v){const w=new L(i,l,{maxComputationTime:v.maxComputationTimeMs,shouldIgnoreTrimWhitespace:v.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),M=[];let p=null;for(const y of w.changes){let _;y.originalEndLineNumber===0?_=new a.$6s(y.originalStartLineNumber+1,y.originalStartLineNumber+1):_=new a.$6s(y.originalStartLineNumber,y.originalEndLineNumber+1);let k;y.modifiedEndLineNumber===0?k=new a.$6s(y.modifiedStartLineNumber+1,y.modifiedStartLineNumber+1):k=new a.$6s(y.modifiedStartLineNumber,y.modifiedEndLineNumber+1);let S=new r.$9s(_,k,y.charChanges?.map(T=>new r.$0s(new N.$Ws(T.originalStartLineNumber,T.originalStartColumn,T.originalEndLineNumber,T.originalEndColumn),new N.$Ws(T.modifiedStartLineNumber,T.modifiedStartColumn,T.modifiedEndLineNumber,T.modifiedEndColumn))));p&&(p.modified.endLineNumberExclusive===S.modified.startLineNumber||p.original.endLineNumberExclusive===S.original.startLineNumber)&&(S=new r.$9s(p.original.join(S.original),p.modified.join(S.modified),p.innerChanges&&S.innerChanges?p.innerChanges.concat(S.innerChanges):void 0),M.pop()),M.push(S),p=S}return(0,f.$9c)(()=>(0,f.$0c)(M,(y,_)=>_.original.startLineNumber-y.original.endLineNumberExclusive===_.modified.startLineNumber-y.modified.endLineNumberExclusive&&y.original.endLineNumberExclusive<_.original.startLineNumber&&y.modified.endLineNumberExclusive<_.modified.startLineNumber)),new F.$$s(M,[],w.quitEarly)}}t.$at=h;function A(c,i,l,v){return new D.$3s(c,i,l).ComputeDiff(v)}class b{constructor(i){const l=[],v=[];for(let d=0,w=i.length;d<w;d++)l[d]=$(i[d],1),v[d]=m(i[d],1);this.lines=i,this.a=l,this.b=v}getElements(){const i=[];for(let l=0,v=this.lines.length;l<v;l++)i[l]=this.lines[l].substring(this.a[l]-1,this.b[l]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,l,v){const d=[],w=[],M=[];let p=0;for(let y=l;y<=v;y++){const _=this.lines[y],k=i?this.a[y]:1,S=i?this.b[y]:_.length+1;for(let T=k;T<S;T++)d[p]=_.charCodeAt(T-1),w[p]=y+1,M[p]=T,p++;!i&&y<v&&(d[p]=10,w[p]=y+1,M[p]=_.length+1,p++)}return new g(d,w,M)}}class g{constructor(i,l,v){this.a=i,this.b=l,this.d=v}toString(){return"["+this.a.map((i,l)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this.b[l]},${this.d[l]})`).join(", ")+"]"}e(i,l){if(i<0||i>=l.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(i){return i>0&&i===this.b.length?this.getEndLineNumber(i-1):(this.e(i,this.b),this.b[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this.e(i,this.b),this.a[i]===10?this.b[i]+1:this.b[i])}getStartColumn(i){return i>0&&i===this.d.length?this.getEndColumn(i-1):(this.e(i,this.d),this.d[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this.e(i,this.d),this.a[i]===10?1:this.d[i]+1)}}class e{constructor(i,l,v,d,w,M,p,y){this.originalStartLineNumber=i,this.originalStartColumn=l,this.originalEndLineNumber=v,this.originalEndColumn=d,this.modifiedStartLineNumber=w,this.modifiedStartColumn=M,this.modifiedEndLineNumber=p,this.modifiedEndColumn=y}static createFromDiffChange(i,l,v){const d=l.getStartLineNumber(i.originalStart),w=l.getStartColumn(i.originalStart),M=l.getEndLineNumber(i.originalStart+i.originalLength-1),p=l.getEndColumn(i.originalStart+i.originalLength-1),y=v.getStartLineNumber(i.modifiedStart),_=v.getStartColumn(i.modifiedStart),k=v.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),S=v.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new e(d,w,M,p,y,_,k,S)}}function E(c){if(c.length<=1)return c;const i=[c[0]];let l=i[0];for(let v=1,d=c.length;v<d;v++){const w=c[v],M=w.originalStart-(l.originalStart+l.originalLength),p=w.modifiedStart-(l.modifiedStart+l.modifiedLength);Math.min(M,p)<s?(l.originalLength=w.originalStart+w.originalLength-l.originalStart,l.modifiedLength=w.modifiedStart+w.modifiedLength-l.modifiedStart):(i.push(w),l=w)}return i}class R{constructor(i,l,v,d,w){this.originalStartLineNumber=i,this.originalEndLineNumber=l,this.modifiedStartLineNumber=v,this.modifiedEndLineNumber=d,this.charChanges=w}static createFromDiffResult(i,l,v,d,w,M,p){let y,_,k,S,T;if(l.originalLength===0?(y=v.getStartLineNumber(l.originalStart)-1,_=0):(y=v.getStartLineNumber(l.originalStart),_=v.getEndLineNumber(l.originalStart+l.originalLength-1)),l.modifiedLength===0?(k=d.getStartLineNumber(l.modifiedStart)-1,S=0):(k=d.getStartLineNumber(l.modifiedStart),S=d.getEndLineNumber(l.modifiedStart+l.modifiedLength-1)),M&&l.originalLength>0&&l.originalLength<20&&l.modifiedLength>0&&l.modifiedLength<20&&w()){const q=v.createCharSequence(i,l.originalStart,l.originalStart+l.originalLength-1),O=d.createCharSequence(i,l.modifiedStart,l.modifiedStart+l.modifiedLength-1);if(q.getElements().length>0&&O.getElements().length>0){let P=A(q,O,w,!0).changes;p&&(P=E(P)),T=[];for(let W=0,G=P.length;W<G;W++)T.push(e.createFromDiffChange(P[W],q,O))}}return new R(y,_,k,S,T)}}class L{constructor(i,l,v){this.a=v.shouldComputeCharChanges,this.b=v.shouldPostProcessCharChanges,this.d=v.shouldIgnoreTrimWhitespace,this.e=v.shouldMakePrettyDiff,this.f=i,this.g=l,this.h=new b(i),this.j=new b(l),this.k=u(v.maxComputationTime),this.l=u(v.maxComputationTime===0?0:Math.min(v.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=A(this.h,this.j,this.k,this.e),l=i.changes,v=i.quitEarly;if(this.d){const p=[];for(let y=0,_=l.length;y<_;y++)p.push(R.createFromDiffResult(this.d,l[y],this.h,this.j,this.l,this.a,this.b));return{quitEarly:v,changes:p}}const d=[];let w=0,M=0;for(let p=-1,y=l.length;p<y;p++){const _=p+1<y?l[p+1]:null,k=_?_.originalStart:this.f.length,S=_?_.modifiedStart:this.g.length;for(;w<k&&M<S;){const T=this.f[w],q=this.g[M];if(T!==q){{let O=$(T,1),P=$(q,1);for(;O>1&&P>1;){const W=T.charCodeAt(O-2),G=q.charCodeAt(P-2);if(W!==G)break;O--,P--}(O>1||P>1)&&this.m(d,w+1,1,O,M+1,1,P)}{let O=m(T,1),P=m(q,1);const W=T.length+1,G=q.length+1;for(;O<W&&P<G;){const x=T.charCodeAt(O-1),Q=T.charCodeAt(P-1);if(x!==Q)break;O++,P++}(O<W||P<G)&&this.m(d,w+1,O,W,M+1,P,G)}}w++,M++}_&&(d.push(R.createFromDiffResult(this.d,_,this.h,this.j,this.l,this.a,this.b)),w+=_.originalLength,M+=_.modifiedLength)}return{quitEarly:v,changes:d}}m(i,l,v,d,w,M,p){if(this.n(i,l,v,d,w,M,p))return;let y;this.a&&(y=[new e(l,v,l,d,w,M,w,p)]),i.push(new R(l,l,w,w,y))}n(i,l,v,d,w,M,p){const y=i.length;if(y===0)return!1;const _=i[y-1];return _.originalEndLineNumber===0||_.modifiedEndLineNumber===0?!1:_.originalEndLineNumber===l&&_.modifiedEndLineNumber===w?(this.a&&_.charChanges&&_.charChanges.push(new e(l,v,l,d,w,M,w,p)),!0):_.originalEndLineNumber+1===l&&_.modifiedEndLineNumber+1===w?(_.originalEndLineNumber=l,_.modifiedEndLineNumber=w,this.a&&_.charChanges&&_.charChanges.push(new e(l,v,l,d,w,M,w,p)),!0):!1}}t.$bt=L;function $(c,i){const l=o.$2e(c);return l===-1?i:l+1}function m(c,i){const l=o.$4e(c);return l===-1?i:l+2}function u(c){if(c===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<c}}),te(ne[50],re([0,1,33,49]),function(V,t,D,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$b1=void 0,t.$b1={getLegacy:()=>new D.$at,getDefault:()=>new F.$$Z}}),te(ne[51],re([0,1,35]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$c1=void 0;function F(b){const g=[];for(const e of b){const E=Number(e);(E||E===0&&e.replace(/\s/g,"")!=="")&&g.push(E)}return g}function r(b,g,e,E){return{red:b/255,blue:e/255,green:g/255,alpha:E}}function o(b,g){const e=g.index,E=g[0].length;if(!e)return;const R=b.positionAt(e);return{startLineNumber:R.lineNumber,startColumn:R.column,endLineNumber:R.lineNumber,endColumn:R.column+E}}function N(b,g){if(!b)return;const e=D.$ot.Format.CSS.parseHex(g);if(e)return{range:b,color:r(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function f(b,g,e){if(!b||g.length!==1)return;const R=g[0].values(),L=F(R);return{range:b,color:r(L[0],L[1],L[2],e?L[3]:1)}}function a(b,g,e){if(!b||g.length!==1)return;const R=g[0].values(),L=F(R),$=new D.$ot(new D.$mt(L[0],L[1]/100,L[2]/100,e?L[3]:1));return{range:b,color:r($.rgba.r,$.rgba.g,$.rgba.b,$.rgba.a)}}function s(b,g){return typeof b=="string"?[...b.matchAll(g)]:b.findMatches(g)}function h(b){const g=[],E=s(b,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(E.length>0)for(const R of E){const L=R.filter(c=>c!==void 0),$=L[1],m=L[2];if(!m)continue;let u;if($==="rgb"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;u=f(o(b,R),s(m,c),!1)}else if($==="rgba"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;u=f(o(b,R),s(m,c),!0)}else if($==="hsl"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;u=a(o(b,R),s(m,c),!1)}else if($==="hsla"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;u=a(o(b,R),s(m,c),!0)}else $==="#"&&(u=N(o(b,R),$+m));u&&g.push(u)}return g}function A(b){return!b||typeof b.getValue!="function"||typeof b.positionAt!="function"?[]:h(b)}t.$c1=A}),te(ne[52],re([0,1,28]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OZ=t.$NZ=t.$MZ=t.State=void 0;var F;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(F||(t.State=F={}));class r{constructor(e,E,R){const L=new Uint8Array(e*E);for(let $=0,m=e*E;$<m;$++)L[$]=R;this.a=L,this.rows=e,this.cols=E}get(e,E){return this.a[e*this.cols+E]}set(e,E,R){this.a[e*this.cols+E]=R}}class o{constructor(e){let E=0,R=0;for(let $=0,m=e.length;$<m;$++){const[u,c,i]=e[$];c>E&&(E=c),u>R&&(R=u),i>R&&(R=i)}E++,R++;const L=new r(R,E,0);for(let $=0,m=e.length;$<m;$++){const[u,c,i]=e[$];L.set(u,c,i)}this.a=L,this.b=E}nextState(e,E){return E<0||E>=this.b?0:this.a.get(e,E)}}t.$MZ=o;let N=null;function f(){return N===null&&(N=new o([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),N}var a;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let s=null;function h(){if(s===null){s=new D.$ht(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<g.length;E++)s.set(g.charCodeAt(E),1);const e=".,;:";for(let E=0;E<e.length;E++)s.set(e.charCodeAt(E),2)}return s}class A{static a(e,E,R,L,$){let m=$-1;do{const u=E.charCodeAt(m);if(e.get(u)!==2)break;m--}while(m>L);if(L>0){const u=E.charCodeAt(L-1),c=E.charCodeAt(m);(u===40&&c===41||u===91&&c===93||u===123&&c===125)&&m--}return{range:{startLineNumber:R,startColumn:L+1,endLineNumber:R,endColumn:m+2},url:E.substring(L,m+1)}}static computeLinks(e,E=f()){const R=h(),L=[];for(let $=1,m=e.getLineCount();$<=m;$++){const u=e.getLineContent($),c=u.length;let i=0,l=0,v=0,d=1,w=!1,M=!1,p=!1,y=!1;for(;i<c;){let _=!1;const k=u.charCodeAt(i);if(d===13){let S;switch(k){case 40:w=!0,S=0;break;case 41:S=w?0:1;break;case 91:p=!0,M=!0,S=0;break;case 93:p=!1,S=M?0:1;break;case 123:y=!0,S=0;break;case 125:S=y?0:1;break;case 39:case 34:case 96:v===k?S=1:v===39||v===34||v===96?S=0:S=1;break;case 42:S=v===42?1:0;break;case 124:S=v===124?1:0;break;case 32:S=p?0:1;break;default:S=R.get(k)}S===1&&(L.push(A.a(R,u,$,l,i)),_=!0)}else if(d===12){let S;k===91?(M=!0,S=0):S=R.get(k),S===1?_=!0:d=13}else d=E.nextState(d,k),d===0&&(_=!0);_&&(d=1,w=!1,M=!1,y=!1,l=i+1,v=k),i++}d===13&&L.push(A.a(R,u,$,l,c))}return L}}t.$NZ=A;function b(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:A.computeLinks(g)}t.$OZ=b}),te(ne[53],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PZ=void 0;class D{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new D}navigateValueSet(r,o,N,f,a){if(r&&o){const s=this.a(o,a);if(s)return{range:r,value:s}}if(N&&f){const s=this.a(f,a);if(s)return{range:N,value:s}}return null}a(r,o){const N=this.b(r,o);return N!==null?N:this.d(r,o)}b(r,o){const N=Math.pow(10,r.length-(r.lastIndexOf(".")+1));let f=Number(r);const a=parseFloat(r);return!isNaN(f)&&!isNaN(a)&&f===a?f===0&&!o?null:(f=Math.floor(f*N),f+=o?N:-N,String(f/N)):null}d(r,o){return this.e(this.c,r,o)}e(r,o,N){let f=null;for(let a=0,s=r.length;f===null&&a<s;a++)f=this.f(r[a],o,N);return f}f(r,o,N){let f=r.indexOf(o);return f>=0?(f+=N?1:-1,f<0?f=r.length-1:f%=r.length,r[f]):null}}t.$PZ=D}),te(ne[54],re([0,1,14]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hv=t.$gv=t.$fv=t.$ev=t.ModelConstants=t.PositionAffinity=t.$dv=t.TrackedRangeStickiness=t.$cv=t.$bv=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var F;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(F||(t.OverviewRulerLane=F={}));var r;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=3]="Right"})(r||(t.GlyphMarginLane=r={}));var o;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(o||(t.MinimapPosition=o={}));var N;(function(u){u[u.Both=0]="Both",u[u.Right=1]="Right",u[u.Left=2]="Left",u[u.None=3]="None"})(N||(t.InjectedTextCursorStops=N={}));var f;(function(u){u[u.TextDefined=0]="TextDefined",u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(f||(t.EndOfLinePreference=f={}));var a;(function(u){u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(a||(t.DefaultEndOfLine=a={}));var s;(function(u){u[u.LF=0]="LF",u[u.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class h{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),c.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,c.indentSize|0),this.a=!1),this.insertSpaces=!!c.insertSpaces,this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=!!c.trimAutoWhitespace,this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.a===c.a&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,D.$Cn)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}t.$bv=h;class A{constructor(c,i){this._findMatchBrand=void 0,this.range=c,this.matches=i}}t.$cv=A;var b;(function(u){u[u.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",u[u.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",u[u.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",u[u.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(t.TrackedRangeStickiness=b={}));function g(u){return u&&typeof u.read=="function"}t.$dv=g;var e;(function(u){u[u.Left=0]="Left",u[u.Right=1]="Right",u[u.None=2]="None",u[u.LeftOfInjectedText=3]="LeftOfInjectedText",u[u.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var E;(function(u){u[u.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E||(t.ModelConstants=E={}));class R{constructor(c,i,l,v,d,w){this.identifier=c,this.range=i,this.text=l,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=d,this._isTracked=w}}t.$ev=R;class L{constructor(c,i,l){this.regex=c,this.wordSeparators=i,this.simpleSearch=l}}t.$fv=L;class ${constructor(c,i,l){this.reverseEdits=c,this.changes=i,this.trimAutoWhitespaceLineNumbers=l}}t.$gv=$;function m(u){return!u.isTooLargeForSyncing()&&!u.isForSimpleWidget}t.$hv=m}),te(ne[55],re([0,1,6,27]),function(V,t,D,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mv=t.$lv=t.$kv=void 0;class r{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,s){a=(0,F.$Je)(a);const h=this.a,A=this.b,b=s.length;return b===0?!1:(this.a=new Uint32Array(h.length+b),this.a.set(h.subarray(0,a),0),this.a.set(h.subarray(a),a+b),this.a.set(s,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}setValue(a,s){return a=(0,F.$Je)(a),s=(0,F.$Je)(s),this.a[a]===s?!1:(this.a[a]=s,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,s){a=(0,F.$Je)(a),s=(0,F.$Je)(s);const h=this.a,A=this.b;if(a>=h.length)return!1;const b=h.length-a;return s>=b&&(s=b),s===0?!1:(this.a=new Uint32Array(h.length-s),this.a.set(h.subarray(0,a),0),this.a.set(h.subarray(a+s),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,F.$Je)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let s=this.c[0]+1;s===0&&(this.b[0]=this.a[0],s++),a>=this.a.length&&(a=this.a.length-1);for(let h=s;h<=a;h++)this.b[h]=this.b[h-1]+this.a[h];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let s=0,h=this.a.length-1,A=0,b=0,g=0;for(;s<=h;)if(A=s+(h-s)/2|0,b=this.b[A],g=b-this.a[A],a<g)h=A-1;else if(a>=b)s=A+1;else break;return new N(A,a-g)}}t.$kv=r;class o{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const s=this.e[a],h=s>0?this.d[s-1]:0;return new N(s,a-h)}removeValues(a,s){this.a.splice(a,s),this.f(a)}insertValues(a,s){this.a=(0,D.$Wb)(this.a,a,s),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,s=this.a.length;a<s;a++){const h=this.a[a],A=a>0?this.d[a-1]:0;this.d[a]=A+h;for(let b=0;b<h;b++)this.e[A+b]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,s){this.a[a]!==s&&(this.a[a]=s,this.f(a))}}t.$lv=o;class N{constructor(a,s){this.index=a,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=s}}t.$mv=N}),te(ne[56],re([0,1,7,5,55]),function(V,t,D,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nv=void 0;class o{constructor(f,a,s,h){this.d=f,this.f=a,this.g=s,this.h=h,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(f){f.eol&&f.eol!==this.g&&(this.g=f.eol,this.j=null);const a=f.changes;for(const s of a)this.o(s.range),this.p(new F.$Vs(s.range.startLineNumber,s.range.startColumn),s.text);this.h=f.versionId,this.k=null}l(){if(!this.j){const f=this.g.length,a=this.f.length,s=new Uint32Array(a);for(let h=0;h<a;h++)s[h]=this.f[h].length+f;this.j=new r.$kv(s)}}n(f,a){this.f[f]=a,this.j&&this.j.setValue(f,this.f[f].length+this.g.length)}o(f){if(f.startLineNumber===f.endLineNumber){if(f.startColumn===f.endColumn)return;this.n(f.startLineNumber-1,this.f[f.startLineNumber-1].substring(0,f.startColumn-1)+this.f[f.startLineNumber-1].substring(f.endColumn-1));return}this.n(f.startLineNumber-1,this.f[f.startLineNumber-1].substring(0,f.startColumn-1)+this.f[f.endLineNumber-1].substring(f.endColumn-1)),this.f.splice(f.startLineNumber,f.endLineNumber-f.startLineNumber),this.j&&this.j.removeValues(f.startLineNumber,f.endLineNumber-f.startLineNumber)}p(f,a){if(a.length===0)return;const s=(0,D.$1e)(a);if(s.length===1){this.n(f.lineNumber-1,this.f[f.lineNumber-1].substring(0,f.column-1)+s[0]+this.f[f.lineNumber-1].substring(f.column-1));return}s[s.length-1]+=this.f[f.lineNumber-1].substring(f.column-1),this.n(f.lineNumber-1,this.f[f.lineNumber-1].substring(0,f.column-1)+s[0]);const h=new Uint32Array(s.length-1);for(let A=1;A<s.length;A++)this.f.splice(f.lineNumber+A-1,0,s[A]),h[A-1]=s[A].length+this.g.length;this.j&&this.j.insertValues(f.lineNumber,h)}}t.$nv=o}),te(ne[57],re([0,1,7,44,5,2,54]),function(V,t,D,F,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0B=t.$9B=t.$8B=t.$7B=t.$6B=t.$5B=void 0;const f=999;class a{constructor($,m,u,c){this.searchString=$,this.isRegex=m,this.matchCase=u,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let $;this.isRegex?$=s(this.searchString):$=this.searchString.indexOf(`
`)>=0;let m=null;try{m=D.$Ye(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:$,global:!0,unicode:!0})}catch{return null}if(!m)return null;let u=!this.isRegex&&!$;return u&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(u=this.matchCase),new N.$fv(m,this.wordSeparators?(0,F.$kt)(this.wordSeparators):null,u?this.searchString:null)}}t.$5B=a;function s(L){if(!L||L.length===0)return!1;for(let $=0,m=L.length;$<m;$++){const u=L.charCodeAt($);if(u===10)return!0;if(u===92){if($++,$>=m)break;const c=L.charCodeAt($);if(c===110||c===114||c===87)return!0}}return!1}t.$6B=s;function h(L,$,m){if(!m)return new N.$cv(L,null);const u=[];for(let c=0,i=$.length;c<i;c++)u[c]=$[c];return new N.$cv(L,u)}t.$7B=h;class A{constructor($){const m=[];let u=0;for(let c=0,i=$.length;c<i;c++)$.charCodeAt(c)===10&&(m[u++]=c);this.a=m}findLineFeedCountBeforeOffset($){const m=this.a;let u=0,c=m.length-1;if(c===-1||$<=m[0])return 0;for(;u<c;){const i=u+((c-u)/2>>0);m[i]>=$?c=i-1:m[i+1]>=$?(u=i,c=i):u=i+1}return u+1}}class b{static findMatches($,m,u,c,i){const l=m.parseSearchRequest();return l?l.regex.multiline?this.b($,u,new R(l.wordSeparators,l.regex),c,i):this.c($,u,l,c,i):[]}static a($,m,u,c,i,l){let v,d=0;c?(d=c.findLineFeedCountBeforeOffset(i),v=m+i+d):v=m+i;let w;if(c){const _=c.findLineFeedCountBeforeOffset(i+l.length)-d;w=v+l.length+_}else w=v+l.length;const M=$.getPositionAt(v),p=$.getPositionAt(w);return new o.$Ws(M.lineNumber,M.column,p.lineNumber,p.column)}static b($,m,u,c,i){const l=$.getOffsetAt(m.getStartPosition()),v=$.getValueInRange(m,1),d=$.getEOL()===`\r
`?new A(v):null,w=[];let M=0,p;for(u.reset(0);p=u.next(v);)if(w[M++]=h(this.a($,l,v,d,p.index,p[0]),p,c),M>=i)return w;return w}static c($,m,u,c,i){const l=[];let v=0;if(m.startLineNumber===m.endLineNumber){const w=$.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return v=this.d(u,w,m.startLineNumber,m.startColumn-1,v,l,c,i),l}const d=$.getLineContent(m.startLineNumber).substring(m.startColumn-1);v=this.d(u,d,m.startLineNumber,m.startColumn-1,v,l,c,i);for(let w=m.startLineNumber+1;w<m.endLineNumber&&v<i;w++)v=this.d(u,$.getLineContent(w),w,0,v,l,c,i);if(v<i){const w=$.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);v=this.d(u,w,m.endLineNumber,0,v,l,c,i)}return l}static d($,m,u,c,i,l,v,d){const w=$.wordSeparators;if(!v&&$.simpleSearch){const y=$.simpleSearch,_=y.length,k=m.length;let S=-_;for(;(S=m.indexOf(y,S+_))!==-1;)if((!w||E(w,m,k,S,_))&&(l[i++]=new N.$cv(new o.$Ws(u,S+1+c,u,S+1+_+c),null),i>=d))return i;return i}const M=new R($.wordSeparators,$.regex);let p;M.reset(0);do if(p=M.next(m),p&&(l[i++]=h(new o.$Ws(u,p.index+1+c,u,p.index+1+p[0].length+c),p,v),i>=d))return i;while(p);return i}static findNextMatch($,m,u,c){const i=m.parseSearchRequest();if(!i)return null;const l=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.e($,u,l,c):this.f($,u,l,c)}static e($,m,u,c){const i=new r.$Vs(m.lineNumber,1),l=$.getOffsetAt(i),v=$.getLineCount(),d=$.getValueInRange(new o.$Ws(i.lineNumber,i.column,v,$.getLineMaxColumn(v)),1),w=$.getEOL()===`\r
`?new A(d):null;u.reset(m.column-1);const M=u.next(d);return M?h(this.a($,l,d,w,M.index,M[0]),M,c):m.lineNumber!==1||m.column!==1?this.e($,new r.$Vs(1,1),u,c):null}static f($,m,u,c){const i=$.getLineCount(),l=m.lineNumber,v=$.getLineContent(l),d=this.g(u,v,l,m.column,c);if(d)return d;for(let w=1;w<=i;w++){const M=(l+w-1)%i,p=$.getLineContent(M+1),y=this.g(u,p,M+1,1,c);if(y)return y}return null}static g($,m,u,c,i){$.reset(c-1);const l=$.next(m);return l?h(new o.$Ws(u,l.index+1,u,l.index+1+l[0].length),l,i):null}static findPreviousMatch($,m,u,c){const i=m.parseSearchRequest();if(!i)return null;const l=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.h($,u,l,c):this.j($,u,l,c)}static h($,m,u,c){const i=this.b($,new o.$Ws(1,1,m.lineNumber,m.column),u,c,10*f);if(i.length>0)return i[i.length-1];const l=$.getLineCount();return m.lineNumber!==l||m.column!==$.getLineMaxColumn(l)?this.h($,new r.$Vs(l,$.getLineMaxColumn(l)),u,c):null}static j($,m,u,c){const i=$.getLineCount(),l=m.lineNumber,v=$.getLineContent(l).substring(0,m.column-1),d=this.k(u,v,l,c);if(d)return d;for(let w=1;w<=i;w++){const M=(i+l-w-1)%i,p=$.getLineContent(M+1),y=this.k(u,p,M+1,c);if(y)return y}return null}static k($,m,u,c){let i=null,l;for($.reset(0);l=$.next(m);)i=h(new o.$Ws(u,l.index+1,u,l.index+1+l[0].length),l,c);return i}}t.$8B=b;function g(L,$,m,u,c){if(u===0)return!0;const i=$.charCodeAt(u-1);if(L.get(i)!==0||i===13||i===10)return!0;if(c>0){const l=$.charCodeAt(u);if(L.get(l)!==0)return!0}return!1}function e(L,$,m,u,c){if(u+c===m)return!0;const i=$.charCodeAt(u+c);if(L.get(i)!==0||i===13||i===10)return!0;if(c>0){const l=$.charCodeAt(u+c-1);if(L.get(l)!==0)return!0}return!1}function E(L,$,m,u,c){return g(L,$,m,u,c)&&e(L,$,m,u,c)}t.$9B=E;class R{constructor($,m){this._wordSeparators=$,this.a=m,this.b=-1,this.c=0}reset($){this.a.lastIndex=$,this.b=-1,this.c=0}next($){const m=$.length;let u;do{if(this.b+this.c===m||(u=this.a.exec($),!u))return null;const c=u.index,i=u[0].length;if(c===this.b&&i===this.c){if(i===0){D.$hf($,m,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=c,this.c=i,!this._wordSeparators||E(this._wordSeparators,$,m,c,i))return u}while(u);return null}}t.$0B=R}),te(ne[58],re([0,1,2,57,7,13,29]),function(V,t,D,F,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$LZ=void 0;class f{static computeUnicodeHighlights(e,E,R){const L=R?R.startLineNumber:1,$=R?R.endLineNumber:e.getLineCount(),m=new h(E),u=m.getCandidateCodePoints();let c;u==="allNonBasicAscii"?c=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):c=new RegExp(`${a(Array.from(u))}`,"g");const i=new F.$0B(null,c),l=[];let v=!1,d,w=0,M=0,p=0;e:for(let y=L,_=$;y<=_;y++){const k=e.getLineContent(y),S=k.length;i.reset(0);do if(d=i.next(k),d){let T=d.index,q=d.index+d[0].length;if(T>0){const G=k.charCodeAt(T-1);r.$ef(G)&&T--}if(q+1<S){const G=k.charCodeAt(q-1);r.$ef(G)&&q++}const O=k.substring(T,q);let P=(0,N.$zs)(T+1,N.$ws,k,0);P&&P.endColumn<=T+1&&(P=null);const W=m.shouldHighlightNonBasicASCII(O,P?P.word:null);if(W!==0){W===3?w++:W===2?M++:W===1?p++:(0,o.$6c)(W);const G=1e3;if(l.length>=G){v=!0;break e}l.push(new D.$Ws(y,T+1,y,q+1))}}while(d)}return{ranges:l,hasMore:v,ambiguousCharacterCount:w,invisibleCharacterCount:M,nonBasicAsciiCharacterCount:p}}static computeUnicodeHighlightReason(e,E){const R=new h(E);switch(R.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const $=e.codePointAt(0),m=R.ambiguousCharacters.getPrimaryConfusable($),u=r.$Hf.getLocales().filter(c=>!r.$Hf.getInstance(new Set([...E.allowedLocales,c])).isAmbiguous($));return{kind:0,confusableWith:String.fromCodePoint(m),notAmbiguousInLocales:u}}case 1:return{kind:2}}}}t.$LZ=f;function a(g,e){return`[${r.$Pe(g.map(R=>String.fromCodePoint(R)).join(""))}]`}var s;(function(g){g[g.Ambiguous=0]="Ambiguous",g[g.Invisible=1]="Invisible",g[g.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class h{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=r.$Hf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const E of r.$If.codePoints)A(String.fromCodePoint(E))||e.add(E);if(this.b.ambiguousCharacters)for(const E of this.ambiguousCharacters.getConfusableCodePoints())e.add(E);for(const E of this.a)e.delete(E);return e}shouldHighlightNonBasicASCII(e,E){const R=e.codePointAt(0);if(this.a.has(R))return 0;if(this.b.nonBasicASCII)return 1;let L=!1,$=!1;if(E)for(const m of E){const u=m.codePointAt(0),c=r.$pf(m);L=L||c,!c&&!this.ambiguousCharacters.isAmbiguous(u)&&!r.$If.isInvisibleCharacter(u)&&($=!0)}return!L&&$?0:this.b.invisibleCharacters&&!A(e)&&r.$If.isInvisibleCharacter(R)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(R)?3:0}}function A(g){return g===" "||g===`
`||g==="	"}var b;(function(g){g[g.None=0]="None",g[g.NonBasicASCII=1]="NonBasicASCII",g[g.Invisible=2]="Invisible",g[g.Ambiguous=3]="Ambiguous"})(b||(b={}))}),te(ne[59],re([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var D;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(D||(t.AccessibilitySupport=D={}));var F;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(F||(t.CodeActionTriggerType=F={}));var r;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(r||(t.CompletionItemInsertTextRule=r={}));var o;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(o||(t.CompletionItemKind=o={}));var N;(function(n){n[n.Deprecated=1]="Deprecated"})(N||(t.CompletionItemTag=N={}));var f;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f||(t.CompletionTriggerKind=f={}));var a;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(a||(t.ContentWidgetPositionPreference=a={}));var s;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var h;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(h||(t.DefaultEndOfLine=h={}));var A;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(A||(t.DocumentHighlightKind=A={}));var b;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(b||(t.EditorAutoIndentStrategy=b={}));var g;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.letterSpacing=63]="letterSpacing",n[n.lightbulb=64]="lightbulb",n[n.lineDecorationsWidth=65]="lineDecorationsWidth",n[n.lineHeight=66]="lineHeight",n[n.lineNumbers=67]="lineNumbers",n[n.lineNumbersMinChars=68]="lineNumbersMinChars",n[n.linkedEditing=69]="linkedEditing",n[n.links=70]="links",n[n.matchBrackets=71]="matchBrackets",n[n.minimap=72]="minimap",n[n.mouseStyle=73]="mouseStyle",n[n.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=75]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",n[n.multiCursorModifier=77]="multiCursorModifier",n[n.multiCursorPaste=78]="multiCursorPaste",n[n.multiCursorLimit=79]="multiCursorLimit",n[n.occurrencesHighlight=80]="occurrencesHighlight",n[n.overviewRulerBorder=81]="overviewRulerBorder",n[n.overviewRulerLanes=82]="overviewRulerLanes",n[n.padding=83]="padding",n[n.pasteAs=84]="pasteAs",n[n.parameterHints=85]="parameterHints",n[n.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",n[n.quickSuggestions=88]="quickSuggestions",n[n.quickSuggestionsDelay=89]="quickSuggestionsDelay",n[n.readOnly=90]="readOnly",n[n.readOnlyMessage=91]="readOnlyMessage",n[n.renameOnType=92]="renameOnType",n[n.renderControlCharacters=93]="renderControlCharacters",n[n.renderFinalNewline=94]="renderFinalNewline",n[n.renderLineHighlight=95]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=97]="renderValidationDecorations",n[n.renderWhitespace=98]="renderWhitespace",n[n.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",n[n.roundedSelection=100]="roundedSelection",n[n.rulers=101]="rulers",n[n.scrollbar=102]="scrollbar",n[n.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=104]="scrollBeyondLastLine",n[n.scrollPredominantAxis=105]="scrollPredominantAxis",n[n.selectionClipboard=106]="selectionClipboard",n[n.selectionHighlight=107]="selectionHighlight",n[n.selectOnLineNumbers=108]="selectOnLineNumbers",n[n.showFoldingControls=109]="showFoldingControls",n[n.showUnused=110]="showUnused",n[n.snippetSuggestions=111]="snippetSuggestions",n[n.smartSelect=112]="smartSelect",n[n.smoothScrolling=113]="smoothScrolling",n[n.stickyScroll=114]="stickyScroll",n[n.stickyTabStops=115]="stickyTabStops",n[n.stopRenderingLineAfter=116]="stopRenderingLineAfter",n[n.suggest=117]="suggest",n[n.suggestFontSize=118]="suggestFontSize",n[n.suggestLineHeight=119]="suggestLineHeight",n[n.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",n[n.suggestSelection=121]="suggestSelection",n[n.tabCompletion=122]="tabCompletion",n[n.tabIndex=123]="tabIndex",n[n.unicodeHighlighting=124]="unicodeHighlighting",n[n.unusualLineTerminators=125]="unusualLineTerminators",n[n.useShadowDOM=126]="useShadowDOM",n[n.useTabStops=127]="useTabStops",n[n.wordBreak=128]="wordBreak",n[n.wordSeparators=129]="wordSeparators",n[n.wordWrap=130]="wordWrap",n[n.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=133]="wordWrapColumn",n[n.wordWrapOverride1=134]="wordWrapOverride1",n[n.wordWrapOverride2=135]="wordWrapOverride2",n[n.wrappingIndent=136]="wrappingIndent",n[n.wrappingStrategy=137]="wrappingStrategy",n[n.showDeprecated=138]="showDeprecated",n[n.inlayHints=139]="inlayHints",n[n.editorClassName=140]="editorClassName",n[n.pixelRatio=141]="pixelRatio",n[n.tabFocusMode=142]="tabFocusMode",n[n.layoutInfo=143]="layoutInfo",n[n.wrappingInfo=144]="wrappingInfo",n[n.defaultColorDecorators=145]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(g||(t.EditorOption=g={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var E;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(E||(t.EndOfLineSequence=E={}));var R;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(R||(t.GlyphMarginLane=R={}));var L;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(L||(t.IndentAction=L={}));var $;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})($||(t.InjectedTextCursorStops=$={}));var m;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(m||(t.InlayHintKind=m={}));var u;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(u||(t.InlineCompletionTriggerKind=u={}));var c;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(c||(t.KeyCode=c={}));var i;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(i||(t.MarkerSeverity=i={}));var l;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(l||(t.MarkerTag=l={}));var v;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(v||(t.MinimapPosition=v={}));var d;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(d||(t.MouseTargetType=d={}));var w;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(w||(t.OverlayWidgetPositionPreference=w={}));var M;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(M||(t.OverviewRulerLane=M={}));var p;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(p||(t.PositionAffinity=p={}));var y;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(y||(t.RenderLineNumbersType=y={}));var _;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(_||(t.RenderMinimap=_={}));var k;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(k||(t.ScrollType=k={}));var S;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(S||(t.ScrollbarVisibility=S={}));var T;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(T||(t.SelectionDirection=T={}));var q;(function(n){n.Off="off",n.OnCode="onCode",n.On="on"})(q||(t.ShowLightbulbIconMode=q={}));var O;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(O||(t.SignatureHelpTriggerKind=O={}));var P;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(P||(t.SymbolKind=P={}));var W;(function(n){n[n.Deprecated=1]="Deprecated"})(W||(t.SymbolTag=W={}));var G;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(G||(t.TextEditorCursorBlinkingStyle=G={}));var x;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(x||(t.TextEditorCursorStyle=x={}));var Q;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(Q||(t.TrackedRangeStickiness=Q={}));var ee;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(ee||(t.WrappingIndent=ee={}))}),te(ne[60],re([0,1,11,10]),function(V,t,D,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vt=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Wd,this.onDidChange=this.c.event,this.d=null}handleChange(f){this.c.fire({changedLanguages:f,changedColorMap:!1})}register(f,a){return this.a.set(f,a),this.handleChange([f]),(0,F.$Rc)(()=>{this.a.get(f)===a&&(this.a.delete(f),this.handleChange([f]))})}get(f){return this.a.get(f)||null}registerFactory(f,a){this.b.get(f)?.dispose();const s=new o(this,f,a);return this.b.set(f,s),(0,F.$Rc)(()=>{const h=this.b.get(f);!h||h!==s||(this.b.delete(f),h.dispose())})}async getOrCreate(f){const a=this.get(f);if(a)return a;const s=this.b.get(f);return!s||s.isResolved?null:(await s.resolve(),this.get(f))}isResolved(f){if(this.get(f))return!0;const s=this.b.get(f);return!!(!s||s.isResolved)}setColorMap(f){this.d=f,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$vt=r;class o extends F.$Tc{get isResolved(){return this.c}constructor(f,a,s){super(),this.f=f,this.g=a,this.h=s,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const f=await this.h.tokenizationSupport;this.c=!0,f&&!this.a&&this.B(this.f.register(this.g,f))}}}),te(ne[61],re([62,63]),function(V,t){return V.create("vs/base/common/platform",t)}),te(ne[17],re([0,1,61]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let F=!1,r=!1,o=!1,N=!1,f=!1,a=!1,s=!1,h=!1,A=!1,b=!1,g,e=t.$g,E=t.$g,R,L;const $=globalThis;let m;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?m=$.vscode.process:typeof process<"u"&&(m=process);const u=typeof m?.versions?.electron=="string",c=u&&m?.type==="renderer";if(typeof m=="object"){F=m.platform==="win32",r=m.platform==="darwin",o=m.platform==="linux",N=o&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,s=u,A=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=t.$g,e=t.$g;const k=m.env.VSCODE_NLS_CONFIG;if(k)try{const S=JSON.parse(k),T=S.availableLanguages["*"];g=S.locale,E=S.osLocale,e=T||t.$g,R=S._translationsConfigFile}catch{}f=!0}else typeof navigator=="object"&&!c?(L=navigator.userAgent,F=L.indexOf("Windows")>=0,r=L.indexOf("Macintosh")>=0,h=(L.indexOf("Macintosh")>=0||L.indexOf("iPad")>=0||L.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,o=L.indexOf("Linux")>=0,b=L?.indexOf("Mobi")>=0,a=!0,g=D.getConfiguredDefaultLocale(D.localize(0,null))||t.$g,e=g,E=navigator.language):console.error("Unable to resolve platform.");var i;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(i||(t.Platform=i={}));function l(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=l;let v=0;r?v=1:F?v=3:o&&(v=2),t.$i=F,t.$j=r,t.$k=o,t.$l=N,t.$m=f,t.$n=s,t.$o=a,t.$p=a&&typeof $.importScripts=="function",t.$q=t.$p?$.origin:void 0,t.$r=h,t.$s=b,t.$t=A,t.$u=v,t.$v=L,t.$w=e;var d;(function(k){function S(){return t.$w}k.value=S;function T(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}k.isDefaultVariant=T;function q(){return t.$w==="en"}k.isDefault=q})(d||(t.Language=d={})),t.$x=g,t.$y=E,t.$z=R,t.$A=typeof $.postMessage=="function"&&!$.importScripts,t.$B=(()=>{if(t.$A){const k=[];$.addEventListener("message",T=>{if(T.data&&T.data.vscodeScheduleAsyncWork)for(let q=0,O=k.length;q<O;q++){const P=k[q];if(P.id===T.data.vscodeScheduleAsyncWork){k.splice(q,1),P.callback();return}}});let S=0;return T=>{const q=++S;k.push({id:q,callback:T}),$.postMessage({vscodeScheduleAsyncWork:q},"*")}}return k=>setTimeout(k)})();var w;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(w||(t.OperatingSystem=w={})),t.OS=r||h?2:F?1:3;let M=!0,p=!1;function y(){if(!p){p=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,M=new Uint16Array(k.buffer)[0]===(2<<8)+1}return M}t.$D=y,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function _(k){return parseFloat(k)>=20}t.$J=_}),te(ne[64],re([0,1,17]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let F;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.process<"u"){const o=r.process;F={get platform(){return o.platform},get arch(){return o.arch},get env(){return o.env},cwd(){return o.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=F.cwd,t.env=F.env,t.$dc=F.platform,t.$ec=F.arch}),te(ne[65],re([0,1,64]),function(V,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const F=65,r=97,o=90,N=122,f=46,a=47,s=92,h=58,A=63;class b extends Error{constructor(l,v,d){let w;typeof v=="string"&&v.indexOf("not ")===0?(w="must not be",v=v.replace(/^not /,"")):w="must be";const M=l.indexOf(".")!==-1?"property":"argument";let p=`The "${l}" ${M} ${w} of type ${v}`;p+=`. Received type ${typeof d}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function g(i,l){if(i===null||typeof i!="object")throw new b(l,"Object",i)}function e(i,l){if(typeof i!="string")throw new b(l,"string",i)}const E=D.$dc==="win32";function R(i){return i===a||i===s}function L(i){return i===a}function $(i){return i>=F&&i<=o||i>=r&&i<=N}function m(i,l,v,d){let w="",M=0,p=-1,y=0,_=0;for(let k=0;k<=i.length;++k){if(k<i.length)_=i.charCodeAt(k);else{if(d(_))break;_=a}if(d(_)){if(!(p===k-1||y===1))if(y===2){if(w.length<2||M!==2||w.charCodeAt(w.length-1)!==f||w.charCodeAt(w.length-2)!==f){if(w.length>2){const S=w.lastIndexOf(v);S===-1?(w="",M=0):(w=w.slice(0,S),M=w.length-1-w.lastIndexOf(v)),p=k,y=0;continue}else if(w.length!==0){w="",M=0,p=k,y=0;continue}}l&&(w+=w.length>0?`${v}..`:"..",M=2)}else w.length>0?w+=`${v}${i.slice(p+1,k)}`:w=i.slice(p+1,k),M=k-p-1;p=k,y=0}else _===f&&y!==-1?++y:y=-1}return w}function u(i,l){g(l,"pathObject");const v=l.dir||l.root,d=l.base||`${l.name||""}${l.ext||""}`;return v?v===l.root?`${v}${d}`:`${v}${i}${d}`:d}t.$fc={resolve(...i){let l="",v="",d=!1;for(let w=i.length-1;w>=-1;w--){let M;if(w>=0){if(M=i[w],e(M,"path"),M.length===0)continue}else l.length===0?M=D.cwd():(M=D.env[`=${l}`]||D.cwd(),(M===void 0||M.slice(0,2).toLowerCase()!==l.toLowerCase()&&M.charCodeAt(2)===s)&&(M=`${l}\\`));const p=M.length;let y=0,_="",k=!1;const S=M.charCodeAt(0);if(p===1)R(S)&&(y=1,k=!0);else if(R(S))if(k=!0,R(M.charCodeAt(1))){let T=2,q=T;for(;T<p&&!R(M.charCodeAt(T));)T++;if(T<p&&T!==q){const O=M.slice(q,T);for(q=T;T<p&&R(M.charCodeAt(T));)T++;if(T<p&&T!==q){for(q=T;T<p&&!R(M.charCodeAt(T));)T++;(T===p||T!==q)&&(_=`\\\\${O}\\${M.slice(q,T)}`,y=T)}}}else y=1;else $(S)&&M.charCodeAt(1)===h&&(_=M.slice(0,2),y=2,p>2&&R(M.charCodeAt(2))&&(k=!0,y=3));if(_.length>0)if(l.length>0){if(_.toLowerCase()!==l.toLowerCase())continue}else l=_;if(d){if(l.length>0)break}else if(v=`${M.slice(y)}\\${v}`,d=k,k&&l.length>0)break}return v=m(v,!d,"\\",R),d?`${l}\\${v}`:`${l}${v}`||"."},normalize(i){e(i,"path");const l=i.length;if(l===0)return".";let v=0,d,w=!1;const M=i.charCodeAt(0);if(l===1)return L(M)?"\\":i;if(R(M))if(w=!0,R(i.charCodeAt(1))){let y=2,_=y;for(;y<l&&!R(i.charCodeAt(y));)y++;if(y<l&&y!==_){const k=i.slice(_,y);for(_=y;y<l&&R(i.charCodeAt(y));)y++;if(y<l&&y!==_){for(_=y;y<l&&!R(i.charCodeAt(y));)y++;if(y===l)return`\\\\${k}\\${i.slice(_)}\\`;y!==_&&(d=`\\\\${k}\\${i.slice(_,y)}`,v=y)}}}else v=1;else $(M)&&i.charCodeAt(1)===h&&(d=i.slice(0,2),v=2,l>2&&R(i.charCodeAt(2))&&(w=!0,v=3));let p=v<l?m(i.slice(v),!w,"\\",R):"";return p.length===0&&!w&&(p="."),p.length>0&&R(i.charCodeAt(l-1))&&(p+="\\"),d===void 0?w?`\\${p}`:p:w?`${d}\\${p}`:`${d}${p}`},isAbsolute(i){e(i,"path");const l=i.length;if(l===0)return!1;const v=i.charCodeAt(0);return R(v)||l>2&&$(v)&&i.charCodeAt(1)===h&&R(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let l,v;for(let M=0;M<i.length;++M){const p=i[M];e(p,"path"),p.length>0&&(l===void 0?l=v=p:l+=`\\${p}`)}if(l===void 0)return".";let d=!0,w=0;if(typeof v=="string"&&R(v.charCodeAt(0))){++w;const M=v.length;M>1&&R(v.charCodeAt(1))&&(++w,M>2&&(R(v.charCodeAt(2))?++w:d=!1))}if(d){for(;w<l.length&&R(l.charCodeAt(w));)w++;w>=2&&(l=`\\${l.slice(w)}`)}return t.$fc.normalize(l)},relative(i,l){if(e(i,"from"),e(l,"to"),i===l)return"";const v=t.$fc.resolve(i),d=t.$fc.resolve(l);if(v===d||(i=v.toLowerCase(),l=d.toLowerCase(),i===l))return"";let w=0;for(;w<i.length&&i.charCodeAt(w)===s;)w++;let M=i.length;for(;M-1>w&&i.charCodeAt(M-1)===s;)M--;const p=M-w;let y=0;for(;y<l.length&&l.charCodeAt(y)===s;)y++;let _=l.length;for(;_-1>y&&l.charCodeAt(_-1)===s;)_--;const k=_-y,S=p<k?p:k;let T=-1,q=0;for(;q<S;q++){const P=i.charCodeAt(w+q);if(P!==l.charCodeAt(y+q))break;P===s&&(T=q)}if(q!==S){if(T===-1)return d}else{if(k>S){if(l.charCodeAt(y+q)===s)return d.slice(y+q+1);if(q===2)return d.slice(y+q)}p>S&&(i.charCodeAt(w+q)===s?T=q:q===2&&(T=3)),T===-1&&(T=0)}let O="";for(q=w+T+1;q<=M;++q)(q===M||i.charCodeAt(q)===s)&&(O+=O.length===0?"..":"\\..");return y+=T,O.length>0?`${O}${d.slice(y,_)}`:(d.charCodeAt(y)===s&&++y,d.slice(y,_))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const l=t.$fc.resolve(i);if(l.length<=2)return i;if(l.charCodeAt(0)===s){if(l.charCodeAt(1)===s){const v=l.charCodeAt(2);if(v!==A&&v!==f)return`\\\\?\\UNC\\${l.slice(2)}`}}else if($(l.charCodeAt(0))&&l.charCodeAt(1)===h&&l.charCodeAt(2)===s)return`\\\\?\\${l}`;return i},dirname(i){e(i,"path");const l=i.length;if(l===0)return".";let v=-1,d=0;const w=i.charCodeAt(0);if(l===1)return R(w)?i:".";if(R(w)){if(v=d=1,R(i.charCodeAt(1))){let y=2,_=y;for(;y<l&&!R(i.charCodeAt(y));)y++;if(y<l&&y!==_){for(_=y;y<l&&R(i.charCodeAt(y));)y++;if(y<l&&y!==_){for(_=y;y<l&&!R(i.charCodeAt(y));)y++;if(y===l)return i;y!==_&&(v=d=y+1)}}}}else $(w)&&i.charCodeAt(1)===h&&(v=l>2&&R(i.charCodeAt(2))?3:2,d=v);let M=-1,p=!0;for(let y=l-1;y>=d;--y)if(R(i.charCodeAt(y))){if(!p){M=y;break}}else p=!1;if(M===-1){if(v===-1)return".";M=v}return i.slice(0,M)},basename(i,l){l!==void 0&&e(l,"ext"),e(i,"path");let v=0,d=-1,w=!0,M;if(i.length>=2&&$(i.charCodeAt(0))&&i.charCodeAt(1)===h&&(v=2),l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let p=l.length-1,y=-1;for(M=i.length-1;M>=v;--M){const _=i.charCodeAt(M);if(R(_)){if(!w){v=M+1;break}}else y===-1&&(w=!1,y=M+1),p>=0&&(_===l.charCodeAt(p)?--p===-1&&(d=M):(p=-1,d=y))}return v===d?d=y:d===-1&&(d=i.length),i.slice(v,d)}for(M=i.length-1;M>=v;--M)if(R(i.charCodeAt(M))){if(!w){v=M+1;break}}else d===-1&&(w=!1,d=M+1);return d===-1?"":i.slice(v,d)},extname(i){e(i,"path");let l=0,v=-1,d=0,w=-1,M=!0,p=0;i.length>=2&&i.charCodeAt(1)===h&&$(i.charCodeAt(0))&&(l=d=2);for(let y=i.length-1;y>=l;--y){const _=i.charCodeAt(y);if(R(_)){if(!M){d=y+1;break}continue}w===-1&&(M=!1,w=y+1),_===f?v===-1?v=y:p!==1&&(p=1):v!==-1&&(p=-1)}return v===-1||w===-1||p===0||p===1&&v===w-1&&v===d+1?"":i.slice(v,w)},format:u.bind(null,"\\"),parse(i){e(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const v=i.length;let d=0,w=i.charCodeAt(0);if(v===1)return R(w)?(l.root=l.dir=i,l):(l.base=l.name=i,l);if(R(w)){if(d=1,R(i.charCodeAt(1))){let T=2,q=T;for(;T<v&&!R(i.charCodeAt(T));)T++;if(T<v&&T!==q){for(q=T;T<v&&R(i.charCodeAt(T));)T++;if(T<v&&T!==q){for(q=T;T<v&&!R(i.charCodeAt(T));)T++;T===v?d=T:T!==q&&(d=T+1)}}}}else if($(w)&&i.charCodeAt(1)===h){if(v<=2)return l.root=l.dir=i,l;if(d=2,R(i.charCodeAt(2))){if(v===3)return l.root=l.dir=i,l;d=3}}d>0&&(l.root=i.slice(0,d));let M=-1,p=d,y=-1,_=!0,k=i.length-1,S=0;for(;k>=d;--k){if(w=i.charCodeAt(k),R(w)){if(!_){p=k+1;break}continue}y===-1&&(_=!1,y=k+1),w===f?M===-1?M=k:S!==1&&(S=1):M!==-1&&(S=-1)}return y!==-1&&(M===-1||S===0||S===1&&M===y-1&&M===p+1?l.base=l.name=i.slice(p,y):(l.name=i.slice(p,M),l.base=i.slice(p,y),l.ext=i.slice(M,y))),p>0&&p!==d?l.dir=i.slice(0,p-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(E){const i=/\\/g;return()=>{const l=D.cwd().replace(i,"/");return l.slice(l.indexOf("/"))}}return()=>D.cwd()})();t.$gc={resolve(...i){let l="",v=!1;for(let d=i.length-1;d>=-1&&!v;d--){const w=d>=0?i[d]:c();e(w,"path"),w.length!==0&&(l=`${w}/${l}`,v=w.charCodeAt(0)===a)}return l=m(l,!v,"/",L),v?`/${l}`:l.length>0?l:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===a,v=i.charCodeAt(i.length-1)===a;return i=m(i,!l,"/",L),i.length===0?l?"/":v?"./":".":(v&&(i+="/"),l?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===a},join(...i){if(i.length===0)return".";let l;for(let v=0;v<i.length;++v){const d=i[v];e(d,"path"),d.length>0&&(l===void 0?l=d:l+=`/${d}`)}return l===void 0?".":t.$gc.normalize(l)},relative(i,l){if(e(i,"from"),e(l,"to"),i===l||(i=t.$gc.resolve(i),l=t.$gc.resolve(l),i===l))return"";const v=1,d=i.length,w=d-v,M=1,p=l.length-M,y=w<p?w:p;let _=-1,k=0;for(;k<y;k++){const T=i.charCodeAt(v+k);if(T!==l.charCodeAt(M+k))break;T===a&&(_=k)}if(k===y)if(p>y){if(l.charCodeAt(M+k)===a)return l.slice(M+k+1);if(k===0)return l.slice(M+k)}else w>y&&(i.charCodeAt(v+k)===a?_=k:k===0&&(_=0));let S="";for(k=v+_+1;k<=d;++k)(k===d||i.charCodeAt(k)===a)&&(S+=S.length===0?"..":"/..");return`${S}${l.slice(M+_)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===a;let v=-1,d=!0;for(let w=i.length-1;w>=1;--w)if(i.charCodeAt(w)===a){if(!d){v=w;break}}else d=!1;return v===-1?l?"/":".":l&&v===1?"//":i.slice(0,v)},basename(i,l){l!==void 0&&e(l,"ext"),e(i,"path");let v=0,d=-1,w=!0,M;if(l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let p=l.length-1,y=-1;for(M=i.length-1;M>=0;--M){const _=i.charCodeAt(M);if(_===a){if(!w){v=M+1;break}}else y===-1&&(w=!1,y=M+1),p>=0&&(_===l.charCodeAt(p)?--p===-1&&(d=M):(p=-1,d=y))}return v===d?d=y:d===-1&&(d=i.length),i.slice(v,d)}for(M=i.length-1;M>=0;--M)if(i.charCodeAt(M)===a){if(!w){v=M+1;break}}else d===-1&&(w=!1,d=M+1);return d===-1?"":i.slice(v,d)},extname(i){e(i,"path");let l=-1,v=0,d=-1,w=!0,M=0;for(let p=i.length-1;p>=0;--p){const y=i.charCodeAt(p);if(y===a){if(!w){v=p+1;break}continue}d===-1&&(w=!1,d=p+1),y===f?l===-1?l=p:M!==1&&(M=1):l!==-1&&(M=-1)}return l===-1||d===-1||M===0||M===1&&l===d-1&&l===v+1?"":i.slice(l,d)},format:u.bind(null,"/"),parse(i){e(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const v=i.charCodeAt(0)===a;let d;v?(l.root="/",d=1):d=0;let w=-1,M=0,p=-1,y=!0,_=i.length-1,k=0;for(;_>=d;--_){const S=i.charCodeAt(_);if(S===a){if(!y){M=_+1;break}continue}p===-1&&(y=!1,p=_+1),S===f?w===-1?w=_:k!==1&&(k=1):w!==-1&&(k=-1)}if(p!==-1){const S=M===0&&v?1:M;w===-1||k===0||k===1&&w===p-1&&w===M+1?l.base=l.name=i.slice(S,p):(l.name=i.slice(S,w),l.base=i.slice(S,p),l.ext=i.slice(w,p))}return M>0?l.dir=i.slice(0,M-1):v&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=E?t.$fc.normalize:t.$gc.normalize,t.$ic=E?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=E?t.$fc.join:t.$gc.join,t.$kc=E?t.$fc.resolve:t.$gc.resolve,t.$lc=E?t.$fc.relative:t.$gc.relative,t.$mc=E?t.$fc.dirname:t.$gc.dirname,t.$nc=E?t.$fc.basename:t.$gc.basename,t.$oc=E?t.$fc.extname:t.$gc.extname,t.$pc=E?t.$fc.format:t.$gc.format,t.$qc=E?t.$fc.parse:t.$gc.parse,t.$rc=E?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=E?t.$fc.sep:t.$gc.sep,t.$tc=E?t.$fc.delimiter:t.$gc.delimiter}),te(ne[18],re([0,1,65,17]),function(V,t,D,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,o=/^\//,N=/^\/\//;function f(d,w){if(!d.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!r.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!o.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(d,w){return!d&&!w?"file":d}function s(d,w){switch(d){case"https":case"http":case"file":w?w[0]!==A&&(w=A+w):w=A;break}return w}const h="",A="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(w){return w instanceof g?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,M,p,y,_,k=!1){typeof w=="object"?(this.scheme=w.scheme||h,this.authority=w.authority||h,this.path=w.path||h,this.query=w.query||h,this.fragment=w.fragment||h):(this.scheme=a(w,k),this.authority=M||h,this.path=s(this.scheme,p||h),this.query=y||h,this.fragment=_||h,f(this,k))}get fsPath(){return u(this,!1)}with(w){if(!w)return this;let{scheme:M,authority:p,path:y,query:_,fragment:k}=w;return M===void 0?M=this.scheme:M===null&&(M=h),p===void 0?p=this.authority:p===null&&(p=h),y===void 0?y=this.path:y===null&&(y=h),_===void 0?_=this.query:_===null&&(_=h),k===void 0?k=this.fragment:k===null&&(k=h),M===this.scheme&&p===this.authority&&y===this.path&&_===this.query&&k===this.fragment?this:new R(M,p,y,_,k)}static parse(w,M=!1){const p=b.exec(w);return p?new R(p[2]||h,v(p[4]||h),v(p[5]||h),v(p[7]||h),v(p[9]||h),M):new R(h,h,h,h,h)}static file(w){let M=h;if(F.$i&&(w=w.replace(/\\/g,A)),w[0]===A&&w[1]===A){const p=w.indexOf(A,2);p===-1?(M=w.substring(2),w=A):(M=w.substring(2,p),w=w.substring(p)||A)}return new R("file",M,w,h,h)}static from(w,M){return new R(w.scheme,w.authority,w.path,w.query,w.fragment,M)}static joinPath(w,...M){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return F.$i&&w.scheme==="file"?p=g.file(D.$fc.join(u(w,!0),...M)).path:p=D.$gc.join(w.path,...M),w.with({path:p})}toString(w=!1){return c(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof g)return w;{const M=new R(w);return M._formatted=w.external??null,M._fsPath=w._sep===E?w.fsPath??null:null,M}}else return w}}t.URI=g;function e(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}t.$vc=e;const E=F.$i?1:void 0;class R extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(w=!1){return w?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=E),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const L={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function $(d,w,M){let p,y=-1;for(let _=0;_<d.length;_++){const k=d.charCodeAt(_);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||w&&k===47||M&&k===91||M&&k===93||M&&k===58)y!==-1&&(p+=encodeURIComponent(d.substring(y,_)),y=-1),p!==void 0&&(p+=d.charAt(_));else{p===void 0&&(p=d.substr(0,_));const S=L[k];S!==void 0?(y!==-1&&(p+=encodeURIComponent(d.substring(y,_)),y=-1),p+=S):y===-1&&(y=_)}}return y!==-1&&(p+=encodeURIComponent(d.substring(y))),p!==void 0?p:d}function m(d){let w;for(let M=0;M<d.length;M++){const p=d.charCodeAt(M);p===35||p===63?(w===void 0&&(w=d.substr(0,M)),w+=L[p]):w!==void 0&&(w+=d[M])}return w!==void 0?w:d}function u(d,w){let M;return d.authority&&d.path.length>1&&d.scheme==="file"?M=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?w?M=d.path.substr(1):M=d.path[1].toLowerCase()+d.path.substr(2):M=d.path,F.$i&&(M=M.replace(/\//g,"\\")),M}t.$wc=u;function c(d,w){const M=w?m:$;let p="",{scheme:y,authority:_,path:k,query:S,fragment:T}=d;if(y&&(p+=y,p+=":"),(_||y==="file")&&(p+=A,p+=A),_){let q=_.indexOf("@");if(q!==-1){const O=_.substr(0,q);_=_.substr(q+1),q=O.lastIndexOf(":"),q===-1?p+=M(O,!1,!1):(p+=M(O.substr(0,q),!1,!1),p+=":",p+=M(O.substr(q+1),!1,!0)),p+="@"}_=_.toLowerCase(),q=_.lastIndexOf(":"),q===-1?p+=M(_,!1,!0):(p+=M(_.substr(0,q),!1,!0),p+=_.substr(q))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const q=k.charCodeAt(1);q>=65&&q<=90&&(k=`/${String.fromCharCode(q+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const q=k.charCodeAt(0);q>=65&&q<=90&&(k=`${String.fromCharCode(q+32)}:${k.substr(2)}`)}p+=M(k,!0,!1)}return S&&(p+="?",p+=M(S,!1,!1)),T&&(p+="#",p+=w?T:$(T,!1,!1)),p}function i(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+i(d.substr(3)):d}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function v(d){return d.match(l)?d.replace(l,w=>i(w)):d}}),te(ne[70],re([0,1,3,11,10,14,17,7]),function(V,t,D,F,r,o,N,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const a="$initialize";let s=!1;function h(v){N.$o&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(v.message))}t.logOnceWebWorkerWarning=h;var A;(function(v){v[v.Request=0]="Request",v[v.Reply=1]="Reply",v[v.SubscribeEvent=2]="SubscribeEvent",v[v.Event=3]="Event",v[v.UnsubscribeEvent=4]="UnsubscribeEvent"})(A||(A={}));class b{constructor(d,w,M,p){this.vsWorker=d,this.req=w,this.method=M,this.args=p,this.type=0}}class g{constructor(d,w,M,p){this.vsWorker=d,this.seq=w,this.res=M,this.err=p,this.type=1}}class e{constructor(d,w,M,p){this.vsWorker=d,this.req=w,this.eventName=M,this.arg=p,this.type=2}}class E{constructor(d,w,M){this.vsWorker=d,this.req=w,this.event=M,this.type=3}}class R{constructor(d,w){this.vsWorker=d,this.req=w,this.type=4}}class L{constructor(d){this.a=-1,this.g=d,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(d){this.a=d}sendMessage(d,w){const M=String(++this.b);return new Promise((p,y)=>{this.c[M]={resolve:p,reject:y},this.o(new b(this.a,M,d,w))})}listen(d,w){let M=null;const p=new F.$Wd({onWillAddFirstListener:()=>{M=String(++this.b),this.d.set(M,p),this.o(new e(this.a,M,d,w))},onDidRemoveLastListener:()=>{this.d.delete(M),this.o(new R(this.a,M)),M=null}});return p.event}handleMessage(d){!d||!d.vsWorker||this.a!==-1&&d.vsWorker!==this.a||this.h(d)}h(d){switch(d.type){case 1:return this.j(d);case 0:return this.k(d);case 2:return this.l(d);case 3:return this.m(d);case 4:return this.n(d)}}j(d){if(!this.c[d.seq]){console.warn("Got reply to unknown seq");return}const w=this.c[d.seq];if(delete this.c[d.seq],d.err){let M=d.err;d.err.$isError&&(M=new Error,M.name=d.err.name,M.message=d.err.message,M.stack=d.err.stack),w.reject(M);return}w.resolve(d.res)}k(d){const w=d.req;this.g.handleMessage(d.method,d.args).then(p=>{this.o(new g(this.a,w,p,void 0))},p=>{p.detail instanceof Error&&(p.detail=(0,D.$3)(p.detail)),this.o(new g(this.a,w,void 0,(0,D.$3)(p)))})}l(d){const w=d.req,M=this.g.handleEvent(d.eventName,d.arg)(p=>{this.o(new E(this.a,w,p))});this.f.set(w,M)}m(d){if(!this.d.has(d.req)){console.warn("Got event for unknown req");return}this.d.get(d.req).fire(d.event)}n(d){if(!this.f.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(d.req).dispose(),this.f.delete(d.req)}o(d){const w=[];if(d.type===0)for(let M=0;M<d.args.length;M++)d.args[M]instanceof ArrayBuffer&&w.push(d.args[M]);else d.type===1&&d.res instanceof ArrayBuffer&&w.push(d.res);this.g.sendMessage(d,w)}}class $ extends r.$Tc{constructor(d,w,M){super();let p=null;this.a=this.B(d.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{p?.(q)})),this.c=new L({sendMessage:(q,O)=>{this.a.postMessage(q,O)},handleMessage:(q,O)=>{if(typeof M[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(M[q].apply(M,O))}catch(P){return Promise.reject(P)}},handleEvent:(q,O)=>{if(u(q)){const P=M[q].call(M,O);if(typeof P!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return P}if(m(q)){const P=M[q];if(typeof P!="function")throw new Error(`Missing event ${q} on main thread host.`);return P}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let y=null;const _=globalThis.require;typeof _<"u"&&typeof _.getConfig=="function"?y=_.getConfig():typeof globalThis.requirejs<"u"&&(y=globalThis.requirejs.s.contexts._.config);const k=(0,o.$In)(M);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(y)),w,k]);const S=(q,O)=>this.g(q,O),T=(q,O)=>this.c.listen(q,O);this.f=new Promise((q,O)=>{p=O,this.b.then(P=>{q(c(P,S,T))},P=>{O(P),this.h("Worker failed to load "+w,P)})})}getProxyObject(){return this.f}g(d,w){return new Promise((M,p)=>{this.b.then(()=>{this.c.sendMessage(d,w).then(M,p)},p)})}h(d,w){console.error(d),console.info(w)}}t.SimpleWorkerClient=$;function m(v){return v[0]==="o"&&v[1]==="n"&&f.$_e(v.charCodeAt(2))}function u(v){return/^onDynamic/.test(v)&&f.$_e(v.charCodeAt(9))}function c(v,d,w){const M=_=>function(){const k=Array.prototype.slice.call(arguments,0);return d(_,k)},p=_=>function(k){return w(_,k)},y={};for(const _ of v){if(u(_)){y[_]=p(_);continue}if(m(_)){y[_]=w(_,void 0);continue}y[_]=M(_)}return y}class i{constructor(d,w){this.a=w,this.b=null,this.c=new L({sendMessage:(M,p)=>{d(M,p)},handleMessage:(M,p)=>this.d(M,p),handleEvent:(M,p)=>this.f(M,p)})}onmessage(d){this.c.handleMessage(d)}d(d,w){if(d===a)return this.g(w[0],w[1],w[2],w[3]);if(!this.b||typeof this.b[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this.b[d].apply(this.b,w))}catch(M){return Promise.reject(M)}}f(d,w){if(!this.b)throw new Error("Missing requestHandler");if(u(d)){const M=this.b[d].call(this.b,w);if(typeof M!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return M}if(m(d)){const M=this.b[d];if(typeof M!="function")throw new Error(`Missing event ${d} on request handler.`);return M}throw new Error(`Malformed event name ${d}`)}g(d,w,M,p){this.c.setWorkerId(d);const k=c(p,(S,T)=>this.c.sendMessage(S,T),(S,T)=>this.c.listen(S,T));return this.a?(this.b=this.a(k),Promise.resolve((0,o.$In)(this.b))):(w&&(typeof w.baseUrl<"u"&&delete w.baseUrl,typeof w.paths<"u"&&typeof w.paths.vs<"u"&&delete w.paths.vs,typeof w.trustedTypesPolicy<"u"&&delete w.trustedTypesPolicy,w.catchError=!0,globalThis.require.config(w)),new Promise((S,T)=>{(globalThis.require||V)([M],O=>{if(this.b=O.create(k),!this.b){T(new Error("No RequestHandler!"));return}S((0,o.$In)(this.b))},T)}))}}t.SimpleWorkerServer=i;function l(v){return new i(v,null)}t.create=l}),te(ne[66],re([62,63]),function(V,t){return V.create("vs/editor/common/languages",t)}),te(ne[67],re([0,1,41,18,42,2,60,66]),function(V,t,D,F,r,o,N,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.$Ot=t.$Nt=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.$Mt=t.$Lt=t.SymbolKinds=t.SymbolTag=t.$Kt=t.$Jt=t.SymbolKind=t.$It=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$Ht=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$Gt=t.$Ft=t.$Et=void 0;class a{constructor(W,G,x){this.offset=W,this.type=G,this.language=x,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$Et=a;class s{constructor(W,G){this.tokens=W,this.endState=G,this._tokenizationResultBrand=void 0}}t.$Ft=s;class h{constructor(W,G){this.tokens=W,this.endState=G,this._encodedTokenizationResultBrand=void 0}}t.$Gt=h;var A;(function(P){P[P.Method=0]="Method",P[P.Function=1]="Function",P[P.Constructor=2]="Constructor",P[P.Field=3]="Field",P[P.Variable=4]="Variable",P[P.Class=5]="Class",P[P.Struct=6]="Struct",P[P.Interface=7]="Interface",P[P.Module=8]="Module",P[P.Property=9]="Property",P[P.Event=10]="Event",P[P.Operator=11]="Operator",P[P.Unit=12]="Unit",P[P.Value=13]="Value",P[P.Constant=14]="Constant",P[P.Enum=15]="Enum",P[P.EnumMember=16]="EnumMember",P[P.Keyword=17]="Keyword",P[P.Text=18]="Text",P[P.Color=19]="Color",P[P.File=20]="File",P[P.Reference=21]="Reference",P[P.Customcolor=22]="Customcolor",P[P.Folder=23]="Folder",P[P.TypeParameter=24]="TypeParameter",P[P.User=25]="User",P[P.Issue=26]="Issue",P[P.Snippet=27]="Snippet"})(A||(t.CompletionItemKind=A={}));var b;(function(P){const W=new Map;W.set(0,D.$bk.symbolMethod),W.set(1,D.$bk.symbolFunction),W.set(2,D.$bk.symbolConstructor),W.set(3,D.$bk.symbolField),W.set(4,D.$bk.symbolVariable),W.set(5,D.$bk.symbolClass),W.set(6,D.$bk.symbolStruct),W.set(7,D.$bk.symbolInterface),W.set(8,D.$bk.symbolModule),W.set(9,D.$bk.symbolProperty),W.set(10,D.$bk.symbolEvent),W.set(11,D.$bk.symbolOperator),W.set(12,D.$bk.symbolUnit),W.set(13,D.$bk.symbolValue),W.set(15,D.$bk.symbolEnum),W.set(14,D.$bk.symbolConstant),W.set(15,D.$bk.symbolEnum),W.set(16,D.$bk.symbolEnumMember),W.set(17,D.$bk.symbolKeyword),W.set(27,D.$bk.symbolSnippet),W.set(18,D.$bk.symbolText),W.set(19,D.$bk.symbolColor),W.set(20,D.$bk.symbolFile),W.set(21,D.$bk.symbolReference),W.set(22,D.$bk.symbolCustomColor),W.set(23,D.$bk.symbolFolder),W.set(24,D.$bk.symbolTypeParameter),W.set(25,D.$bk.account),W.set(26,D.$bk.issues);function G(ee){let n=W.get(ee);return n||(console.info("No codicon found for CompletionItemKind "+ee),n=D.$bk.symbolProperty),n}P.toIcon=G;const x=new Map;x.set("method",0),x.set("function",1),x.set("constructor",2),x.set("field",3),x.set("variable",4),x.set("class",5),x.set("struct",6),x.set("interface",7),x.set("module",8),x.set("property",9),x.set("event",10),x.set("operator",11),x.set("unit",12),x.set("value",13),x.set("constant",14),x.set("enum",15),x.set("enum-member",16),x.set("enumMember",16),x.set("keyword",17),x.set("snippet",27),x.set("text",18),x.set("color",19),x.set("file",20),x.set("reference",21),x.set("customcolor",22),x.set("folder",23),x.set("type-parameter",24),x.set("typeParameter",24),x.set("account",25),x.set("issue",26);function Q(ee,n){let le=x.get(ee);return typeof le>"u"&&!n&&(le=9),le}P.fromString=Q})(b||(t.CompletionItemKinds=b={}));var g;(function(P){P[P.Deprecated=1]="Deprecated"})(g||(t.CompletionItemTag=g={}));var e;(function(P){P[P.None=0]="None",P[P.KeepWhitespace=1]="KeepWhitespace",P[P.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var E;(function(P){P[P.Invoke=0]="Invoke",P[P.TriggerCharacter=1]="TriggerCharacter",P[P.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E||(t.CompletionTriggerKind=E={}));var R;(function(P){P[P.Automatic=0]="Automatic",P[P.Explicit=1]="Explicit"})(R||(t.InlineCompletionTriggerKind=R={}));class L{constructor(W,G,x,Q){this.range=W,this.text=G,this.completionKind=x,this.isSnippetText=Q}equals(W){return o.$Ws.lift(this.range).equalsRange(W.range)&&this.text===W.text&&this.completionKind===W.completionKind&&this.isSnippetText===W.isSnippetText}}t.$Ht=L;var $;(function(P){P[P.Invoke=1]="Invoke",P[P.Auto=2]="Auto"})($||(t.CodeActionTriggerType=$={}));var m;(function(P){P[P.Invoke=1]="Invoke",P[P.TriggerCharacter=2]="TriggerCharacter",P[P.ContentChange=3]="ContentChange"})(m||(t.SignatureHelpTriggerKind=m={}));var u;(function(P){P[P.Text=0]="Text",P[P.Read=1]="Read",P[P.Write=2]="Write"})(u||(t.DocumentHighlightKind=u={}));function c(P){return P&&F.URI.isUri(P.uri)&&o.$Ws.isIRange(P.range)&&(o.$Ws.isIRange(P.originSelectionRange)||o.$Ws.isIRange(P.targetSelectionRange))}t.$It=c;var i;(function(P){P[P.File=0]="File",P[P.Module=1]="Module",P[P.Namespace=2]="Namespace",P[P.Package=3]="Package",P[P.Class=4]="Class",P[P.Method=5]="Method",P[P.Property=6]="Property",P[P.Field=7]="Field",P[P.Constructor=8]="Constructor",P[P.Enum=9]="Enum",P[P.Interface=10]="Interface",P[P.Function=11]="Function",P[P.Variable=12]="Variable",P[P.Constant=13]="Constant",P[P.String=14]="String",P[P.Number=15]="Number",P[P.Boolean=16]="Boolean",P[P.Array=17]="Array",P[P.Object=18]="Object",P[P.Key=19]="Key",P[P.Null=20]="Null",P[P.EnumMember=21]="EnumMember",P[P.Struct=22]="Struct",P[P.Event=23]="Event",P[P.Operator=24]="Operator",P[P.TypeParameter=25]="TypeParameter"})(i||(t.SymbolKind=i={})),t.$Jt={[17]:(0,f.localize)(0,null),[16]:(0,f.localize)(1,null),[4]:(0,f.localize)(2,null),[13]:(0,f.localize)(3,null),[8]:(0,f.localize)(4,null),[9]:(0,f.localize)(5,null),[21]:(0,f.localize)(6,null),[23]:(0,f.localize)(7,null),[7]:(0,f.localize)(8,null),[0]:(0,f.localize)(9,null),[11]:(0,f.localize)(10,null),[10]:(0,f.localize)(11,null),[19]:(0,f.localize)(12,null),[5]:(0,f.localize)(13,null),[1]:(0,f.localize)(14,null),[2]:(0,f.localize)(15,null),[20]:(0,f.localize)(16,null),[15]:(0,f.localize)(17,null),[18]:(0,f.localize)(18,null),[24]:(0,f.localize)(19,null),[3]:(0,f.localize)(20,null),[6]:(0,f.localize)(21,null),[14]:(0,f.localize)(22,null),[22]:(0,f.localize)(23,null),[25]:(0,f.localize)(24,null),[12]:(0,f.localize)(25,null)};function l(P,W){return(0,f.localize)(26,null,P,t.$Jt[W])}t.$Kt=l;var v;(function(P){P[P.Deprecated=1]="Deprecated"})(v||(t.SymbolTag=v={}));var d;(function(P){const W=new Map;W.set(0,D.$bk.symbolFile),W.set(1,D.$bk.symbolModule),W.set(2,D.$bk.symbolNamespace),W.set(3,D.$bk.symbolPackage),W.set(4,D.$bk.symbolClass),W.set(5,D.$bk.symbolMethod),W.set(6,D.$bk.symbolProperty),W.set(7,D.$bk.symbolField),W.set(8,D.$bk.symbolConstructor),W.set(9,D.$bk.symbolEnum),W.set(10,D.$bk.symbolInterface),W.set(11,D.$bk.symbolFunction),W.set(12,D.$bk.symbolVariable),W.set(13,D.$bk.symbolConstant),W.set(14,D.$bk.symbolString),W.set(15,D.$bk.symbolNumber),W.set(16,D.$bk.symbolBoolean),W.set(17,D.$bk.symbolArray),W.set(18,D.$bk.symbolObject),W.set(19,D.$bk.symbolKey),W.set(20,D.$bk.symbolNull),W.set(21,D.$bk.symbolEnumMember),W.set(22,D.$bk.symbolStruct),W.set(23,D.$bk.symbolEvent),W.set(24,D.$bk.symbolOperator),W.set(25,D.$bk.symbolTypeParameter);function G(x){let Q=W.get(x);return Q||(console.info("No codicon found for SymbolKind "+x),Q=D.$bk.symbolProperty),Q}P.toIcon=G})(d||(t.SymbolKinds=d={}));class w{static asEditOperation(W){return r.$Xs.replace(o.$Ws.lift(W.range),W.text)}}t.$Lt=w;class M{static{this.Comment=new M("comment")}static{this.Imports=new M("imports")}static{this.Region=new M("region")}static fromValue(W){switch(W){case"comment":return M.Comment;case"imports":return M.Imports;case"region":return M.Region}return new M(W)}constructor(W){this.value=W}}t.$Mt=M;var p;(function(P){function W(G){return!G||typeof G!="object"?!1:typeof G.id=="string"&&typeof G.title=="string"}P.is=W})(p||(t.Command=p={}));var y;(function(P){P[P.Collapsed=0]="Collapsed",P[P.Expanded=1]="Expanded"})(y||(t.CommentThreadCollapsibleState=y={}));var _;(function(P){P[P.Unresolved=0]="Unresolved",P[P.Resolved=1]="Resolved"})(_||(t.CommentThreadState=_={}));var k;(function(P){P[P.Editing=0]="Editing",P[P.Preview=1]="Preview"})(k||(t.CommentMode=k={}));var S;(function(P){P[P.Published=0]="Published",P[P.Draft=1]="Draft"})(S||(t.CommentState=S={}));var T;(function(P){P[P.Type=1]="Type",P[P.Parameter=2]="Parameter"})(T||(t.InlayHintKind=T={}));class q{constructor(W){this.b=W,this.a=null}dispose(){this.a&&this.a.then(W=>{W&&W.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$Nt=q,t.$Ot=new N.$vt;var O;(function(P){P[P.None=0]="None",P[P.Option=1]="Option",P[P.Default=2]="Default",P[P.Preferred=3]="Preferred"})(O||(t.ExternalUriOpenerPriority=O={}))}),te(ne[68],re([0,1,24,11,37,18,5,2,43,67,59]),function(V,t,D,F,r,o,N,f,a,s,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RZ=t.$QZ=void 0;class A{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,E){return(0,r.$9q)(e,E)}}t.$QZ=A;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:D.$7d,Emitter:F.$Wd,KeyCode:h.KeyCode,KeyMod:A,Position:N.$Vs,Range:f.$Ws,Selection:a.$Ys,SelectionDirection:h.SelectionDirection,MarkerSeverity:h.MarkerSeverity,MarkerTag:h.MarkerTag,Uri:o.URI,Token:s.$Et}}t.$RZ=b}),te(ne[71],re([0,1,25,18,5,2,56,29,52,53,68,23,58,33,50,14,3,51]),function(V,t,D,F,r,o,N,f,a,s,h,A,b,g,e,E,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class $ extends N.$nv{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(i){const l=[];for(let v=0;v<this.f.length;v++){const d=this.f[v],w=this.offsetAt(new r.$Vs(v+1,1)),M=d.matchAll(i);for(const p of M)(p.index||p.index===0)&&(p.index=p.index+w),l.push(p)}return l}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(i){return this.f[i-1]}getWordAtPosition(i,l){const v=(0,f.$zs)(i.column,(0,f.$xs)(l),this.f[i.lineNumber-1],0);return v?new o.$Ws(i.lineNumber,v.startColumn,i.lineNumber,v.endColumn):null}getWordUntilPosition(i,l){const v=this.getWordAtPosition(i,l);return v?{word:this.f[i.lineNumber-1].substring(v.startColumn-1,i.column-1),startColumn:v.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const l=this.f,v=this.q.bind(this);let d=0,w="",M=0,p=[];return{*[Symbol.iterator](){for(;;)if(M<p.length){const y=w.substring(p[M].start,p[M].end);M+=1,yield y}else if(d<l.length)w=l[d],p=v(w,i),M=0,d+=1;else break}}}getLineWords(i,l){const v=this.f[i-1],d=this.q(v,l),w=[];for(const M of d)w.push({word:v.substring(M.start,M.end),startColumn:M.start+1,endColumn:M.end+1});return w}q(i,l){const v=[];let d;for(l.lastIndex=0;(d=l.exec(i))&&d[0].length!==0;)v.push({start:d.index,end:d.index+d[0].length});return v}getValueInRange(i){if(i=this.r(i),i.startLineNumber===i.endLineNumber)return this.f[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const l=this.g,v=i.startLineNumber-1,d=i.endLineNumber-1,w=[];w.push(this.f[v].substring(i.startColumn-1));for(let M=v+1;M<d;M++)w.push(this.f[M]);return w.push(this.f[d].substring(0,i.endColumn-1)),w.join(l)}offsetAt(i){return i=this.s(i),this.l(),this.j.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this.l();const l=this.j.getIndexOf(i),v=this.f[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,v)}}r(i){const l=this.s({lineNumber:i.startLineNumber,column:i.startColumn}),v=this.s({lineNumber:i.endLineNumber,column:i.endColumn});return l.lineNumber!==i.startLineNumber||l.column!==i.startColumn||v.lineNumber!==i.endLineNumber||v.column!==i.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:v.lineNumber,endColumn:v.column}:i}s(i){if(!r.$Vs.isIPosition(i))throw new Error("bad position");let{lineNumber:l,column:v}=i,d=!1;if(l<1)l=1,v=1,d=!0;else if(l>this.f.length)l=this.f.length,v=this.f[l-1].length+1,d=!0;else{const w=this.f[l-1].length+1;v<1?(v=1,d=!0):v>w&&(v=w,d=!0)}return d?{lineNumber:l,column:v}:i}}class m{constructor(i,l){this.d=i,this.f=Object.create(null),this.g=l,this.h=null}dispose(){this.f=Object.create(null)}j(i){return this.f[i]}k(){const i=[];return Object.keys(this.f).forEach(l=>i.push(this.f[l])),i}acceptNewModel(i){this.f[i.url]=new $(F.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,l){if(!this.f[i])return;this.f[i].onEvents(l)}acceptRemovedModel(i){this.f[i]&&delete this.f[i]}async computeUnicodeHighlights(i,l,v){const d=this.j(i);return d?b.$LZ.computeUnicodeHighlights(d,l,v):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,l,v,d){const w=this.j(i),M=this.j(l);return!w||!M?null:m.l(w,M,v,d)}static l(i,l,v,d){const w=d==="advanced"?e.$b1.getDefault():e.$b1.getLegacy(),M=i.getLinesContent(),p=l.getLinesContent(),y=w.computeDiff(M,p,v),_=y.changes.length>0?!1:this.n(i,l);function k(S){return S.map(T=>[T.original.startLineNumber,T.original.endLineNumberExclusive,T.modified.startLineNumber,T.modified.endLineNumberExclusive,T.innerChanges?.map(q=>[q.originalRange.startLineNumber,q.originalRange.startColumn,q.originalRange.endLineNumber,q.originalRange.endColumn,q.modifiedRange.startLineNumber,q.modifiedRange.startColumn,q.modifiedRange.endLineNumber,q.modifiedRange.endColumn])])}return{identical:_,quitEarly:y.hitTimeout,changes:k(y.changes),moves:y.moves.map(S=>[S.lineRangeMapping.original.startLineNumber,S.lineRangeMapping.original.endLineNumberExclusive,S.lineRangeMapping.modified.startLineNumber,S.lineRangeMapping.modified.endLineNumberExclusive,k(S.changes)])}}static n(i,l){const v=i.getLineCount(),d=l.getLineCount();if(v!==d)return!1;for(let w=1;w<=v;w++){const M=i.getLineContent(w),p=l.getLineContent(w);if(M!==p)return!1}return!0}async computeDirtyDiff(i,l,v){const d=this.j(i),w=this.j(l);if(!d||!w)return null;const M=d.getLinesContent(),p=w.getLinesContent();return new g.$bt(M,p,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:v,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(i,l,v){const d=this.j(i);if(!d)return l;const w=[];let M;l=l.slice(0).sort((y,_)=>{if(y.range&&_.range)return o.$Ws.compareRangesUsingStarts(y.range,_.range);const k=y.range?0:1,S=_.range?0:1;return k-S});let p=0;for(let y=1;y<l.length;y++)o.$Ws.getEndPosition(l[p].range).equals(o.$Ws.getStartPosition(l[y].range))?(l[p].range=o.$Ws.fromPositions(o.$Ws.getStartPosition(l[p].range),o.$Ws.getEndPosition(l[y].range)),l[p].text+=l[y].text):(p++,l[p]=l[y]);l.length=p+1;for(let{range:y,text:_,eol:k}of l){if(typeof k=="number"&&(M=k),o.$Ws.isEmpty(y)&&!_)continue;const S=d.getValueInRange(y);if(_=_.replace(/\r\n|\n|\r/g,d.eol),S===_)continue;if(Math.max(_.length,S.length)>m.o){w.push({range:y,text:_});continue}const T=(0,D.$2s)(S,_,v),q=d.offsetAt(o.$Ws.lift(y).getStartPosition());for(const O of T){const P=d.positionAt(q+O.originalStart),W=d.positionAt(q+O.originalStart+O.originalLength),G={text:_.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:P.lineNumber,startColumn:P.column,endLineNumber:W.lineNumber,endColumn:W.column}};d.getValueInRange(G.range)!==G.text&&w.push(G)}}return typeof M=="number"&&w.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}computeHumanReadableDiff(i,l,v){const d=this.j(i);if(!d)return l;const w=[];let M;l=l.slice(0).sort((p,y)=>{if(p.range&&y.range)return o.$Ws.compareRangesUsingStarts(p.range,y.range);const _=p.range?0:1,k=y.range?0:1;return _-k});for(let{range:p,text:y,eol:_}of l){let P=function(G,x){return new r.$Vs(G.lineNumber+x.lineNumber-1,x.lineNumber===1?G.column+x.column-1:x.column)},W=function(G,x){const Q=[];for(let ee=x.startLineNumber;ee<=x.endLineNumber;ee++){const n=G[ee-1];ee===x.startLineNumber&&ee===x.endLineNumber?Q.push(n.substring(x.startColumn-1,x.endColumn-1)):ee===x.startLineNumber?Q.push(n.substring(x.startColumn-1)):ee===x.endLineNumber?Q.push(n.substring(0,x.endColumn-1)):Q.push(n)}return Q};if(typeof _=="number"&&(M=_),o.$Ws.isEmpty(p)&&!y)continue;const k=d.getValueInRange(p);if(y=y.replace(/\r\n|\n|\r/g,d.eol),k===y)continue;if(Math.max(y.length,k.length)>m.o){w.push({range:p,text:y});continue}const S=k.split(/\r\n|\n|\r/),T=y.split(/\r\n|\n|\r/),q=e.$b1.getDefault().computeDiff(S,T,v),O=o.$Ws.lift(p).getStartPosition();for(const G of q.changes)if(G.innerChanges)for(const x of G.innerChanges)w.push({range:o.$Ws.fromPositions(P(O,x.originalRange.getStartPosition()),P(O,x.originalRange.getEndPosition())),text:W(T,x.modifiedRange).join(d.eol)});else throw new R.$cb("The experimental diff algorithm always produces inner changes")}return typeof M=="number"&&w.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeLinks(i){const l=this.j(i);return l?(0,a.$OZ)(l):null}async computeDefaultDocumentColors(i){const l=this.j(i);return l?(0,L.$c1)(l):null}static{this.p=1e4}async textualSuggest(i,l,v,d){const w=new A.$Sd,M=new RegExp(v,d),p=new Set;e:for(const y of i){const _=this.j(y);if(_){for(const k of _.words(M))if(!(k===l||!isNaN(Number(k)))&&(p.add(k),p.size>m.p))break e}}return{words:Array.from(p),duration:w.elapsed()}}async computeWordRanges(i,l,v,d){const w=this.j(i);if(!w)return Object.create(null);const M=new RegExp(v,d),p=Object.create(null);for(let y=l.startLineNumber;y<l.endLineNumber;y++){const _=w.getLineWords(y,M);for(const k of _){if(!isNaN(Number(k.word)))continue;let S=p[k.word];S||(S=[],p[k.word]=S),S.push({startLineNumber:y,startColumn:k.startColumn,endLineNumber:y,endColumn:k.endColumn})}}return p}async navigateValueSet(i,l,v,d,w){const M=this.j(i);if(!M)return null;const p=new RegExp(d,w);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const y=M.getValueInRange(l),_=M.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},p);if(!_)return null;const k=M.getValueInRange(_);return s.$PZ.INSTANCE.navigateValueSet(l,y,_,k,v)}loadForeignModule(i,l,v){const d=(p,y)=>this.d.fhr(p,y),M={host:(0,E.$Jn)(v,d),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(M,l),Promise.resolve((0,E.$In)(this.h))):new Promise((p,y)=>{V([i],_=>{this.h=_.create(M,l),p((0,E.$In)(this.h))},y)})}fmr(i,l){if(!this.h||typeof this.h[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this.h[i].apply(this.h,l))}catch(v){return Promise.reject(v)}}}t.EditorSimpleWorker=m;function u(c){return new m(c,null)}t.create=u,typeof importScripts=="function"&&(globalThis.monaco=(0,h.$RZ)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2af613979f646fc4dcebfeaedc7d14f138c7b072/core/vs/base/worker/workerMain.js.map
