/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/platform/log/common/log","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/base/common/errors","vs/nls","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain"],ne=function(J){for(var e=[],N=0,D=J.length;N<D;N++)e[N]=ie[J[N]];return e};define(ie[70],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class N{static get(){const R=new Map,L=new Map,A=new Map,k=new Map;function h($,w){$.has(w.detail)||$.set(w.detail,-w.timestamp)}function a($,w){const P=$.get(w.detail);P&&(P>=0||$.set(w.detail,P+w.timestamp))}let y=[];typeof J=="function"&&typeof J.getStats=="function"&&(y=J.getStats().slice(0).sort(($,w)=>$.timestamp-w.timestamp));for(const $ of y)switch($.type){case 10:h(R,$);break;case 11:case 12:a(R,$);break;case 21:h(L,$);break;case 22:a(L,$);break;case 33:h(A,$);break;case 34:a(A,$);break;case 31:h(k,$);break;case 32:a(k,$);break}let E=0;A.forEach($=>E+=$);function d($){const w=[];return $.forEach((P,b)=>w.push([b,P])),w}return{amdLoad:d(R),amdInvoke:d(L),nodeRequire:d(A),nodeEval:d(k),nodeRequireTotal:E}}static toMarkdownTable(R,L){let A="";const k=[];return R.forEach((h,a)=>{k[a]=h.length}),L.forEach(h=>{h.forEach((a,y)=>{typeof a>"u"&&(a=h[y]="-");const E=a.toString().length;k[y]=Math.max(E,k[y])})}),R.forEach((h,a)=>{A+=`| ${h+" ".repeat(k[a]-h.toString().length)} `}),A+=`|
`,R.forEach((h,a)=>{A+=`| ${"-".repeat(k[a])} `}),A+=`|
`,L.forEach(h=>{h.forEach((a,y)=>{typeof a<"u"&&(A+=`| ${a+" ".repeat(k[y]-a.toString().length)} `)}),A+=`|
`}),A}}e.$U=N}),define(ie[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=void 0;function N(A){return(k,h,a)=>{let y=null,E=null;if(typeof a.value=="function"?(y="value",E=a.value):typeof a.get=="function"&&(y="get",E=a.get),!E)throw new Error("not supported");a[y]=A(E,h)}}function D(A,k,h){let a=null,y=null;if(typeof h.value=="function"?(a="value",y=h.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(a="get",y=h.get),!y)throw new Error("not supported");const E=`$memoize$${k}`;h[a]=function(...d){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,d)}),this[E]}}e.$zh=D;function R(A,k,h){return N((a,y)=>{const E=`$debounce$${y}`,d=`$debounce$result$${y}`;return function(...$){this[d]||(this[d]=h?h():void 0),clearTimeout(this[E]),k&&(this[d]=k(this[d],...$),$=[this[d]]),this[E]=setTimeout(()=>{a.apply(this,$),this[d]=h?h():void 0},A)}})}e.$Ah=R;function L(A,k,h){return N((a,y)=>{const E=`$throttle$timer$${y}`,d=`$throttle$result$${y}`,$=`$throttle$lastRun$${y}`,w=`$throttle$pending$${y}`;return function(...P){if(this[d]||(this[d]=h?h():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),k&&(this[d]=k(this[d],...P)),this[w])return;const b=this[$]+A;b<=Date.now()?(this[$]=Date.now(),a.apply(this,[this[d]]),this[d]=h?h():void 0):(this[w]=!0,this[E]=setTimeout(()=>{this[w]=!1,this[$]=Date.now(),a.apply(this,[this[d]]),this[d]=h?h():void 0},b-Date.now()))}})}e.$Bh=L}),define(ie[71],ne([0,1,7]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function D(a,y){if(!a)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=D;function R(a,y="Unreachable"){throw new Error(y)}e.$6c=R;function L(a){if(!a)throw new N.$cb("Assertion Failed")}e.$7c=L;function A(a){a||(0,N.$1)(new N.$cb("Assertion Failed"))}e.$8c=A;function k(a){if(!a()){debugger;a(),(0,N.$1)(new N.$cb("Assertion Failed"))}}e.$9c=k;function h(a,y){let E=0;for(;E<a.length-1;){const d=a[E],$=a[E+1];if(!y(d,$))return!1;E++}return!0}e.$0c=h}),define(ie[38],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var N;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(N||(e.ScanError=N={}));var D;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var R;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(i,r=!1){let t=0;const n=i.length;let s="",o=0,l=16,O=0;function I(re){let he=0,de=0;for(;he<re;){const ae=i.charCodeAt(t);if(ae>=48&&ae<=57)de=de*16+ae-48;else if(ae>=65&&ae<=70)de=de*16+ae-65+10;else if(ae>=97&&ae<=102)de=de*16+ae-97+10;else break;t++,he++}return he<re&&(de=-1),de}function v(re){t=re,s="",o=0,l=16,O=0}function j(){const re=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&a(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&a(i.charCodeAt(t)))for(t++;t<i.length&&a(i.charCodeAt(t));)t++;else return O=3,i.substring(re,t);let he=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&a(i.charCodeAt(t))){for(t++;t<i.length&&a(i.charCodeAt(t));)t++;he=t}else O=3;return i.substring(re,he)}function q(){let re="",he=t;for(;;){if(t>=n){re+=i.substring(he,t),O=2;break}const de=i.charCodeAt(t);if(de===34){re+=i.substring(he,t),t++;break}if(de===92){if(re+=i.substring(he,t),t++,t>=n){O=2;break}switch(i.charCodeAt(t++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const B=I(4);B>=0?re+=String.fromCharCode(B):O=4;break}default:O=5}he=t;continue}if(de>=0&&de<=31)if(h(de)){re+=i.substring(he,t),O=2;break}else O=6;t++}return re}function Q(){if(s="",O=0,o=t,t>=n)return o=n,l=17;let re=i.charCodeAt(t);if(k(re)){do t++,s+=String.fromCharCode(re),re=i.charCodeAt(t);while(k(re));return l=15}if(h(re))return t++,s+=String.fromCharCode(re),re===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),l=14;switch(re){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,s=q(),l=10;case 47:{const he=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!h(i.charCodeAt(t));)t++;return s=i.substring(he,t),l=12}if(i.charCodeAt(t+1)===42){t+=2;const de=n-1;let ae=!1;for(;t<de;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,ae=!0;break}t++}return ae||(t++,O=1),s=i.substring(he,t),l=13}return s+=String.fromCharCode(re),t++,l=16}case 45:if(s+=String.fromCharCode(re),t++,t===n||!a(i.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=j(),l=11;default:for(;t<n&&Y(re);)t++,re=i.charCodeAt(t);if(o!==t){switch(s=i.substring(o,t),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(re),t++,l=16}}function Y(re){if(k(re)||h(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let re;do re=Q();while(re>=12&&re<=15);return re}return{setPosition:v,getPosition:()=>t,scan:r?oe:Q,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>O}}e.$dn=A;function k(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function h(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var y;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(y||(y={}));function E(i,r){const t=[],n=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function O(I,v,j,q){o.value=I,o.offset=v,o.length=j,o.type=q,o.colonOffset=void 0,s=o}try{m(i,{onObjectBegin:(I,v)=>{if(r<=I)throw n;s=void 0,l=r>I,t.push("")},onObjectProperty:(I,v,j)=>{if(r<v||(O(I,v,j,"property"),t[t.length-1]=I,r<=v+j))throw n},onObjectEnd:(I,v)=>{if(r<=I)throw n;s=void 0,t.pop()},onArrayBegin:(I,v)=>{if(r<=I)throw n;s=void 0,t.push(0)},onArrayEnd:(I,v)=>{if(r<=I)throw n;s=void 0,t.pop()},onLiteralValue:(I,v,j)=>{if(r<v||(O(I,v,j,g(I)),r<=v+j))throw n},onSeparator:(I,v,j)=>{if(r<=v)throw n;if(I===":"&&s&&s.type==="property")s.colonOffset=v,l=!1,s=void 0;else if(I===","){const q=t[t.length-1];typeof q=="number"?t[t.length-1]=q+1:(l=!0,t[t.length-1]=""),s=void 0}}})}catch(I){if(I!==n)throw I}return{path:t,previousNode:s,isAtPropertyKey:l,matches:I=>{let v=0;for(let j=0;v<I.length&&j<t.length;j++)if(I[v]===t[j]||I[v]==="*")v++;else if(I[v]!=="**")return!1;return v===I.length}}}e.$en=E;function d(i,r=[],t=L.DEFAULT){let n=null,s=[];const o=[];function l(I){Array.isArray(s)?s.push(I):n!==null&&(s[n]=I)}return m(i,{onObjectBegin:()=>{const I={};l(I),o.push(s),s=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const I=[];l(I),o.push(s),s=I,n=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:l,onError:(I,v,j)=>{r.push({error:I,offset:v,length:j})}},t),s[0]}e.$fn=d;function $(i,r=[],t=L.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(I){n.type==="property"&&(n.length=I-n.offset,n=n.parent)}function o(I){return n.children.push(I),I}m(i,{onObjectBegin:I=>{n=o({type:"object",offset:I,length:-1,parent:n,children:[]})},onObjectProperty:(I,v,j)=>{n=o({type:"property",offset:v,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:I,offset:v,length:j,parent:n})},onObjectEnd:(I,v)=>{n.length=I+v-n.offset,n=n.parent,s(I+v)},onArrayBegin:(I,v)=>{n=o({type:"array",offset:I,length:-1,parent:n,children:[]})},onArrayEnd:(I,v)=>{n.length=I+v-n.offset,n=n.parent,s(I+v)},onLiteralValue:(I,v,j)=>{o({type:g(I),offset:v,length:j,parent:n,value:I}),s(v+j)},onSeparator:(I,v,j)=>{n.type==="property"&&(I===":"?n.colonOffset=v:I===","&&s(v))},onError:(I,v,j)=>{r.push({error:I,offset:v,length:j})}},t);const O=n.children[0];return O&&delete O.parent,O}e.$gn=$;function w(i,r){if(!i)return;let t=i;for(const n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===n){t=o.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.$hn=w;function P(i){if(!i.parent||!i.parent.children)return[];const r=P(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;r.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&r.push(t)}return r}e.$in=P;function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const r=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(r[t.children[0].value]=b(n))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$jn=b;function c(i,r,t=!1){return r>=i.offset&&r<i.offset+i.length||t&&r===i.offset+i.length}e.$kn=c;function p(i,r,t=!1){if(c(i,r,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const o=p(n[s],r,t);if(o)return o}return i}}e.$ln=p;function m(i,r,t=L.DEFAULT){const n=A(i,!1);function s(K){return K?()=>K(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(K){return K?_=>K(_,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=s(r.onObjectBegin),O=o(r.onObjectProperty),I=s(r.onObjectEnd),v=s(r.onArrayBegin),j=s(r.onArrayEnd),q=o(r.onLiteralValue),Q=o(r.onSeparator),Y=s(r.onComment),oe=o(r.onError),re=t&&t.disallowComments,he=t&&t.allowTrailingComma;function de(){for(;;){const K=n.scan();switch(n.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:re||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(K){case 12:case 13:re?ae(10):Y();break;case 16:ae(1);break;case 15:case 14:break;default:return K}}}function ae(K,_=[],F=[]){if(oe(K),_.length+F.length>0){let C=n.getToken();for(;C!==17;){if(_.indexOf(C)!==-1){de();break}else if(F.indexOf(C)!==-1)break;C=de()}}}function B(K){const _=n.getTokenValue();return K?q(_):O(_),de(),!0}function X(){switch(n.getToken()){case 11:{let K=0;try{K=JSON.parse(n.getTokenValue()),typeof K!="number"&&(ae(2),K=0)}catch{ae(2)}q(K);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return de(),!0}function M(){return n.getToken()!==10?(ae(3,[],[2,5]),!1):(B(!1),n.getToken()===6?(Q(":"),de(),Z()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function T(){l(),de();let K=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(K||ae(4,[],[]),Q(","),de(),n.getToken()===2&&he)break}else K&&ae(6,[],[]);M()||ae(4,[],[2,5]),K=!0}return I(),n.getToken()!==2?ae(7,[2],[]):de(),!0}function W(){v(),de();let K=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(K||ae(4,[],[]),Q(","),de(),n.getToken()===4&&he)break}else K&&ae(6,[],[]);Z()||ae(4,[],[4,5]),K=!0}return j(),n.getToken()!==4?ae(8,[4],[]):de(),!0}function Z(){switch(n.getToken()){case 3:return W();case 1:return T();case 10:return B(!0);default:return X()}}return de(),n.getToken()===17?t.allowEmptyContent?!0:(ae(4,[],[]),!1):Z()?(n.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.$mn=m;function u(i,r){const t=A(i),n=[];let s,o=0,l;do switch(l=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==l&&n.push(i.substring(o,l)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return n.join("")}e.$nn=u;function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$on=g}),define(ie[72],ne([0,1,38]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=e.$rn=e.$qn=e.$pn=void 0;function D(a,y,E){let d,$,w,P,b;if(y){for(P=y.offset,b=P+y.length,w=P;w>0&&!h(a,w-1);)w--;let l=b;for(;l<a.length&&!h(a,l);)l++;$=a.substring(w,l),d=A($,E)}else $=a,d=0,w=0,P=0,b=a.length;const c=k(E,a);let p=!1,m=0,u;E.insertSpaces?u=L(" ",E.tabSize||4):u="	";const g=(0,N.$dn)($,!1);let i=!1;function r(){return c+L(u,d+m)}function t(){let l=g.scan();for(p=!1;l===15||l===14;)p=p||l===14,l=g.scan();return i=l===16||g.getTokenError()!==0,l}const n=[];function s(l,O,I){!i&&O<b&&I>P&&a.substring(O,I)!==l&&n.push({offset:O,length:I-O,content:l})}let o=t();if(o!==17){const l=g.getTokenOffset()+w,O=L(u,d);s(O,w,l)}for(;o!==17;){let l=g.getTokenOffset()+g.getTokenLength()+w,O=t(),I="";for(;!p&&(O===12||O===13);){const j=g.getTokenOffset()+w;s(" ",l,j),l=g.getTokenOffset()+g.getTokenLength()+w,I=O===12?r():"",O=t()}if(O===2)o!==1&&(m--,I=r());else if(O===4)o!==3&&(m--,I=r());else{switch(o){case 3:case 1:m++,I=r();break;case 5:case 12:I=r();break;case 13:p?I=r():I=" ";break;case 6:I=" ";break;case 10:if(O===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:O===12||O===13?I=" ":O!==5&&O!==17&&(i=!0);break;case 16:i=!0;break}p&&(O===12||O===13)&&(I=r())}const v=g.getTokenOffset()+w;s(I,l,v),o=O}return n}e.$pn=D;function R(a,y){const E=JSON.stringify(a,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?E.replace(/\r\n|\r|\n/g,y.eol):E}e.$qn=R;function L(a,y){let E="";for(let d=0;d<y;d++)E+=a;return E}function A(a,y){let E=0,d=0;const $=y.tabSize||4;for(;E<a.length;){const w=a.charAt(E);if(w===" ")d++;else if(w==="	")d+=$;else break;E++}return Math.floor(d/$)}function k(a,y){for(let E=0;E<y.length;E++){const d=y.charAt(E);if(d==="\r")return E+1<y.length&&y.charAt(E+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return a&&a.eol||`
`}e.$rn=k;function h(a,y){return`\r
`.indexOf(a.charAt(y))!==-1}e.$sn=h}),define(ie[73],ne([0,1,38,72]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=void 0;function R(a,y,E){return L(a,y,void 0,E)}e.$tn=R;function L(a,y,E,d,$){const w=y.slice(),P=[],b=(0,N.$gn)(a,P);let c,p;for(;w.length>0&&(p=w.pop(),c=(0,N.$hn)(b,w),c===void 0&&E!==void 0);)typeof p=="string"?E={[p]:E}:E=[E];if(c)if(c.type==="object"&&typeof p=="string"&&Array.isArray(c.children)){const m=(0,N.$hn)(c,[p]);if(m!==void 0)if(E===void 0){if(!m.parent)throw new Error("Malformed AST");const u=c.children.indexOf(m.parent);let g,i=m.parent.offset+m.parent.length;if(u>0){const r=c.children[u-1];g=r.offset+r.length}else g=c.offset+1,c.children.length>1&&(i=c.children[1].offset);return A(a,{offset:g,length:i-g,content:""},d)}else return A(a,{offset:m.offset,length:m.length,content:JSON.stringify(E)},d);else{if(E===void 0)return[];const u=`${JSON.stringify(p)}: ${JSON.stringify(E)}`,g=$?$(c.children.map(r=>r.children[0].value)):c.children.length;let i;if(g>0){const r=c.children[g-1];i={offset:r.offset+r.length,length:0,content:","+u}}else c.children.length===0?i={offset:c.offset+1,length:0,content:u}:i={offset:c.offset+1,length:0,content:u+","};return A(a,i,d)}}else if(c.type==="array"&&typeof p=="number"&&Array.isArray(c.children))if(E!==void 0){const m=`${JSON.stringify(E)}`;let u;if(c.children.length===0||p===0)u={offset:c.offset+1,length:0,content:c.children.length===0?m:m+","};else{const g=p===-1||p>c.children.length?c.children.length:p,i=c.children[g-1];u={offset:i.offset+i.length,length:0,content:","+m}}return A(a,u,d)}else{const m=p,u=c.children[m];let g;if(c.children.length===1)g={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===m){const i=c.children[m-1],r=i.offset+i.length,t=c.offset+c.length;g={offset:r,length:t-2-r,content:""}}else g={offset:u.offset,length:c.children[m+1].offset-u.offset,content:""};return A(a,g,d)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${c.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return A(a,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(E)},d)}}e.$un=L;function A(a,y,E){let d=k(a,y),$=y.offset,w=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;$>0&&!(0,D.$sn)(d,$-1);)$--;for(;w<d.length&&!(0,D.$sn)(d,w);)w++}const P=(0,D.$pn)(d,{offset:$,length:w-$},E);for(let c=P.length-1;c>=0;c--){const p=P[c];d=k(d,p),$=Math.min($,p.offset),w=Math.max(w,p.offset+p.length),w+=p.content.length-p.length}const b=a.length-(d.length-w)-$;return[{offset:$,length:b,content:d.substring($,w)}]}e.$vn=A;function k(a,y){return a.substring(0,y.offset)+y.content+a.substring(y.offset+y.length)}e.$wn=k;function h(a,y){const E=y.slice(0).sort(($,w)=>{const P=$.offset-w.offset;return P===0?$.length-w.length:P});let d=a.length;for(let $=E.length-1;$>=0;$--){const w=E[$];if(w.offset+w.length<=d)a=k(a,w);else throw new Error("Overlapping edit");d=w.offset}return a}e.$xn=h}),define(ie[74],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.rot=e.$9l=void 0;function N(k,h,a){return Math.min(Math.max(k,h),a)}e.$9l=N;function D(k,h){return(h+k%h)%h}e.rot=D;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$$l=R;class L{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$_l=L;class A{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const a=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$am=A}),function(){function J(R){const L=[];typeof R=="number"&&L.push("code/timeOrigin",R);function A(h){L.push(h,Date.now())}function k(){const h=[];for(let a=0;a<L.length;a+=2)h.push({name:L[a],startTime:L[a+1]});return h}return{mark:A,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(R+A.startTime)});return L}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function N(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return N(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=N(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=N(D))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var N=e();for(var D in N)(typeof exports=="object"?exports:J)[D]=N[D]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function N(D){if(e[D])return e[D].exports;var R=e[D]={i:D,l:!1,exports:{}};return J[D].call(R.exports,R,R.exports,N),R.l=!0,R.exports}return N.m=J,N.c=e,N.d=function(D,R,L){N.o(D,R)||Object.defineProperty(D,R,{enumerable:!0,get:L})},N.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},N.t=function(D,R){if(1&R&&(D=N(D)),8&R||4&R&&typeof D=="object"&&D&&D.__esModule)return D;var L=Object.create(null);if(N.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:D}),2&R&&typeof D!="string")for(var A in D)N.d(L,A,function(k){return D[k]}.bind(null,A));return L},N.n=function(D){var R=D&&D.__esModule?function(){return D.default}:function(){return D};return N.d(R,"a",R),R},N.o=function(D,R){return Object.prototype.hasOwnProperty.call(D,R)},N.p="",N(N.s=0)}([function(J,e,N){(function(D){var R;e=J.exports=F,R=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],h=e.src=[],a=0,y=a++;h[y]="0|[1-9]\\d*";var E=a++;h[E]="[0-9]+";var d=a++;h[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=a++;h[$]="("+h[y]+")\\.("+h[y]+")\\.("+h[y]+")";var w=a++;h[w]="("+h[E]+")\\.("+h[E]+")\\.("+h[E]+")";var P=a++;h[P]="(?:"+h[y]+"|"+h[d]+")";var b=a++;h[b]="(?:"+h[E]+"|"+h[d]+")";var c=a++;h[c]="(?:-("+h[P]+"(?:\\."+h[P]+")*))";var p=a++;h[p]="(?:-?("+h[b]+"(?:\\."+h[b]+")*))";var m=a++;h[m]="[0-9A-Za-z-]+";var u=a++;h[u]="(?:\\+("+h[m]+"(?:\\."+h[m]+")*))";var g=a++,i="v?"+h[$]+h[c]+"?"+h[u]+"?";h[g]="^"+i+"$";var r="[v=\\s]*"+h[w]+h[p]+"?"+h[u]+"?",t=a++;h[t]="^"+r+"$";var n=a++;h[n]="((?:<|>)?=?)";var s=a++;h[s]=h[E]+"|x|X|\\*";var o=a++;h[o]=h[y]+"|x|X|\\*";var l=a++;h[l]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[c]+")?"+h[u]+"?)?)?";var O=a++;h[O]="[v=\\s]*("+h[s]+")(?:\\.("+h[s]+")(?:\\.("+h[s]+")(?:"+h[p]+")?"+h[u]+"?)?)?";var I=a++;h[I]="^"+h[n]+"\\s*"+h[l]+"$";var v=a++;h[v]="^"+h[n]+"\\s*"+h[O]+"$";var j=a++;h[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=a++;h[q]="(?:~>?)";var Q=a++;h[Q]="(\\s*)"+h[q]+"\\s+",k[Q]=new RegExp(h[Q],"g");var Y=a++;h[Y]="^"+h[q]+h[l]+"$";var oe=a++;h[oe]="^"+h[q]+h[O]+"$";var re=a++;h[re]="(?:\\^)";var he=a++;h[he]="(\\s*)"+h[re]+"\\s+",k[he]=new RegExp(h[he],"g");var de=a++;h[de]="^"+h[re]+h[l]+"$";var ae=a++;h[ae]="^"+h[re]+h[O]+"$";var B=a++;h[B]="^"+h[n]+"\\s*("+r+")$|^$";var X=a++;h[X]="^"+h[n]+"\\s*("+i+")$|^$";var M=a++;h[M]="(\\s*)"+h[n]+"\\s*("+r+"|"+h[l]+")",k[M]=new RegExp(h[M],"g");var T=a++;h[T]="^\\s*("+h[l]+")\\s+-\\s+("+h[l]+")\\s*$";var W=a++;h[W]="^\\s*("+h[O]+")\\s+-\\s+("+h[O]+")\\s*$";var Z=a++;h[Z]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)R(K,h[K]),k[K]||(k[K]=new RegExp(h[K]));function _(V,x){if(V instanceof F)return V;if(typeof V!="string"||V.length>L||!(x?k[t]:k[g]).test(V))return null;try{return new F(V,x)}catch{return null}}function F(V,x){if(V instanceof F){if(V.loose===x)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof F))return new F(V,x);R("SemVer",V,x),this.loose=x;var ee=V.trim().match(x?k[t]:k[g]);if(!ee)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ye=+ge;if(ye>=0&&ye<A)return ye}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=_,e.valid=function(V,x){var ee=_(V,x);return ee?ee.version:null},e.clean=function(V,x){var ee=_(V.trim().replace(/^[=v]+/,""),x);return ee?ee.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(V){return R("SemVer.compare",this.version,this.loose,V),V instanceof F||(V=new F(V,this.loose)),this.compareMain(V)||this.comparePre(V)},F.prototype.compareMain=function(V){return V instanceof F||(V=new F(V,this.loose)),f(this.major,V.major)||f(this.minor,V.minor)||f(this.patch,V.patch)},F.prototype.comparePre=function(V){if(V instanceof F||(V=new F(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var x=0;do{var ee=this.prerelease[x],ge=V.prerelease[x];if(R("prerelease compare",x,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return f(ee,ge)}while(++x)},F.prototype.inc=function(V,x){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,x,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new F(V,ee).inc(x,ge).version}catch{return null}},e.diff=function(V,x){if(H(V,x))return null;var ee=_(V),ge=_(x);if(ee.prerelease.length||ge.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==ge[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==ge[ye])return ye},e.compareIdentifiers=f;var C=/^[0-9]+$/;function f(V,x){var ee=C.test(V),ge=C.test(x);return ee&&ge&&(V=+V,x=+x),ee&&!ge?-1:ge&&!ee?1:V<x?-1:V>x?1:0}function S(V,x,ee){return new F(V,ee).compare(new F(x,ee))}function z(V,x,ee){return S(V,x,ee)>0}function U(V,x,ee){return S(V,x,ee)<0}function H(V,x,ee){return S(V,x,ee)===0}function G(V,x,ee){return S(V,x,ee)!==0}function te(V,x,ee){return S(V,x,ee)>=0}function le(V,x,ee){return S(V,x,ee)<=0}function ue(V,x,ee,ge){var ye;switch(x){case"===":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V===ee;break;case"!==":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V!==ee;break;case"":case"=":case"==":ye=H(V,ee,ge);break;case"!=":ye=G(V,ee,ge);break;case">":ye=z(V,ee,ge);break;case">=":ye=te(V,ee,ge);break;case"<":ye=U(V,ee,ge);break;case"<=":ye=le(V,ee,ge);break;default:throw new TypeError("Invalid operator: "+x)}return ye}function me(V,x){if(V instanceof me){if(V.loose===x)return V;V=V.value}if(!(this instanceof me))return new me(V,x);R("comparator",V,x),this.loose=x,this.parse(V),this.semver===we?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(V,x){return f(x,V)},e.major=function(V,x){return new F(V,x).major},e.minor=function(V,x){return new F(V,x).minor},e.patch=function(V,x){return new F(V,x).patch},e.compare=S,e.compareLoose=function(V,x){return S(V,x,!0)},e.rcompare=function(V,x,ee){return S(x,V,ee)},e.sort=function(V,x){return V.sort(function(ee,ge){return e.compare(ee,ge,x)})},e.rsort=function(V,x){return V.sort(function(ee,ge){return e.rcompare(ee,ge,x)})},e.gt=z,e.lt=U,e.eq=H,e.neq=G,e.gte=te,e.lte=le,e.cmp=ue,e.Comparator=me;var we={};function fe(V,x){if(V instanceof fe)return V.loose===x?V:new fe(V.raw,x);if(V instanceof me)return new fe(V.value,x);if(!(this instanceof fe))return new fe(V,x);if(this.loose=x,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function ce(V){return!V||V.toLowerCase()==="x"||V==="*"}function pe(V,x,ee,ge,ye,De,Se,ze,Ie,Ne,Ue,Oe,Ae){return((x=ce(ee)?"":ce(ge)?">="+ee+".0.0":ce(ye)?">="+ee+"."+ge+".0":">="+x)+" "+(ze=ce(Ie)?"":ce(Ne)?"<"+(+Ie+1)+".0.0":ce(Ue)?"<"+Ie+"."+(+Ne+1)+".0":Oe?"<="+Ie+"."+Ne+"."+Ue+"-"+Oe:"<="+ze)).trim()}function be(V,x){for(var ee=0;ee<V.length;ee++)if(!V[ee].test(x))return!1;if(x.prerelease.length){for(ee=0;ee<V.length;ee++)if(R(V[ee].semver),V[ee].semver!==we&&V[ee].semver.prerelease.length>0){var ge=V[ee].semver;if(ge.major===x.major&&ge.minor===x.minor&&ge.patch===x.patch)return!0}return!1}return!0}function ke(V,x,ee){try{x=new fe(x,ee)}catch{return!1}return x.test(V)}function je(V,x,ee,ge){var ye,De,Se,ze,Ie;switch(V=new F(V,ge),x=new fe(x,ge),ee){case">":ye=z,De=le,Se=U,ze=">",Ie=">=";break;case"<":ye=U,De=te,Se=z,ze="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(V,x,ge))return!1;for(var Ne=0;Ne<x.set.length;++Ne){var Ue=x.set[Ne],Oe=null,Ae=null;if(Ue.forEach(function(Ce){Ce.semver===we&&(Ce=new me(">=0.0.0")),Oe=Oe||Ce,Ae=Ae||Ce,ye(Ce.semver,Oe.semver,ge)?Oe=Ce:Se(Ce.semver,Ae.semver,ge)&&(Ae=Ce)}),Oe.operator===ze||Oe.operator===Ie||(!Ae.operator||Ae.operator===ze)&&De(V,Ae.semver)||Ae.operator===Ie&&Se(V,Ae.semver))return!1}return!0}me.prototype.parse=function(V){var x=this.loose?k[B]:k[X],ee=V.match(x);if(!ee)throw new TypeError("Invalid comparator: "+V);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new F(ee[2],this.loose):this.semver=we},me.prototype.toString=function(){return this.value},me.prototype.test=function(V){return R("Comparator.test",V,this.loose),this.semver===we||(typeof V=="string"&&(V=new F(V,this.loose)),ue(V,this.operator,this.semver,this.loose))},me.prototype.intersects=function(V,x){if(!(V instanceof me))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(V.value,x),ke(this.value,ee,x);if(V.operator==="")return ee=new fe(this.value,x),ke(V.semver,ee,x);var ge=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),De=this.semver.version===V.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),ze=ue(this.semver,"<",V.semver,x)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=ue(this.semver,">",V.semver,x)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return ge||ye||De&&Se||ze||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var x=this.loose;V=V.trim(),R("range",V,x);var ee=x?k[W]:k[T];V=V.replace(ee,pe),R("hyphen replace",V),V=V.replace(k[M],"$1$2$3"),R("comparator trim",V,k[M]),V=(V=(V=V.replace(k[Q],"$1~")).replace(k[he],"$1^")).split(/\s+/).join(" ");var ge=x?k[B]:k[X],ye=V.split(" ").map(function(De){return function(Se,ze){return R("comp",Se),Se=function(Ie,Ne){return Ie.trim().split(/\s+/).map(function(Ue){return function(Oe,Ae){R("caret",Oe,Ae);var Ce=Ae?k[ae]:k[de];return Oe.replace(Ce,function(Le,ve,Ee,Pe,Re){var Fe;return R("caret",Oe,Le,ve,Ee,Pe,Re),ce(ve)?Fe="":ce(Ee)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":ce(Pe)?Fe=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Re?(R("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Fe=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+Re+" <"+(+ve+1)+".0.0"):(R("no pr"),Fe=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+" <"+(+ve+1)+".0.0"),R("caret return",Fe),Fe})}(Ue,Ne)}).join(" ")}(Se,ze),R("caret",Se),Se=function(Ie,Ne){return Ie.trim().split(/\s+/).map(function(Ue){return function(Oe,Ae){var Ce=Ae?k[oe]:k[Y];return Oe.replace(Ce,function(Le,ve,Ee,Pe,Re){var Fe;return R("tilde",Oe,Le,ve,Ee,Pe,Re),ce(ve)?Fe="":ce(Ee)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":ce(Pe)?Fe=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Re?(R("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Fe=">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+(+Ee+1)+".0"):Fe=">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0",R("tilde return",Fe),Fe})}(Ue,Ne)}).join(" ")}(Se,ze),R("tildes",Se),Se=function(Ie,Ne){return R("replaceXRanges",Ie,Ne),Ie.split(/\s+/).map(function(Ue){return function(Oe,Ae){Oe=Oe.trim();var Ce=Ae?k[v]:k[I];return Oe.replace(Ce,function(Le,ve,Ee,Pe,Re,Fe){R("xRange",Oe,Le,ve,Ee,Pe,Re,Fe);var qe=ce(Ee),Te=qe||ce(Pe),Me=Te||ce(Re);return ve==="="&&Me&&(ve=""),qe?Le=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Me?(Te&&(Pe=0),Me&&(Re=0),ve===">"?(ve=">=",Te?(Ee=+Ee+1,Pe=0,Re=0):Me&&(Pe=+Pe+1,Re=0)):ve==="<="&&(ve="<",Te?Ee=+Ee+1:Pe=+Pe+1),Le=ve+Ee+"."+Pe+"."+Re):Te?Le=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Me&&(Le=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),R("xRange return",Le),Le})}(Ue,Ne)}).join(" ")}(Se,ze),R("xrange",Se),Se=function(Ie,Ne){return R("replaceStars",Ie,Ne),Ie.trim().replace(k[Z],"")}(Se,ze),R("stars",Se),Se}(De,x)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(De){return!!De.match(ge)})),ye=ye.map(function(De){return new me(De,x)})},fe.prototype.intersects=function(V,x){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return V.set.some(function(ye){return ye.every(function(De){return ge.intersects(De,x)})})})})},e.toComparators=function(V,x){return new fe(V,x).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new F(V,this.loose));for(var x=0;x<this.set.length;x++)if(be(this.set[x],V))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(V,x,ee){var ge=null,ye=null;try{var De=new fe(x,ee)}catch{return null}return V.forEach(function(Se){De.test(Se)&&(ge&&ye.compare(Se)!==-1||(ye=new F(ge=Se,ee)))}),ge},e.minSatisfying=function(V,x,ee){var ge=null,ye=null;try{var De=new fe(x,ee)}catch{return null}return V.forEach(function(Se){De.test(Se)&&(ge&&ye.compare(Se)!==1||(ye=new F(ge=Se,ee)))}),ge},e.validRange=function(V,x){try{return new fe(V,x).range||"*"}catch{return null}},e.ltr=function(V,x,ee){return je(V,x,"<",ee)},e.gtr=function(V,x,ee){return je(V,x,">",ee)},e.outside=je,e.prerelease=function(V,x){var ee=_(V,x);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(V,x,ee){return V=new fe(V,ee),x=new fe(x,ee),V.intersects(x)},e.coerce=function(V){if(V instanceof F)return V;if(typeof V!="string")return null;var x=V.match(k[j]);return x==null?null:_((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,N(1))},function(J,e){var N,D,R=J.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function k(b){if(N===setTimeout)return setTimeout(b,0);if((N===L||!N)&&setTimeout)return N=setTimeout,setTimeout(b,0);try{return N(b,0)}catch{try{return N.call(null,b,0)}catch{return N.call(this,b,0)}}}(function(){try{N=typeof setTimeout=="function"?setTimeout:L}catch{N=L}try{D=typeof clearTimeout=="function"?clearTimeout:A}catch{D=A}})();var h,a=[],y=!1,E=-1;function d(){y&&h&&(y=!1,h.length?a=h.concat(a):E=-1,a.length&&$())}function $(){if(!y){var b=k(d);y=!0;for(var c=a.length;c;){for(h=a,a=[];++E<c;)h&&h[E].run();E=-1,c=a.length}h=null,y=!1,function(p){if(D===clearTimeout)return clearTimeout(p);if((D===A||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(p);try{D(p)}catch{try{return D.call(null,p)}catch{return D.call(this,p)}}}(b)}}function w(b,c){this.fun=b,this.array=c}function P(){}R.nextTick=function(b){var c=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)c[p-1]=arguments[p];a.push(new w(b,c)),a.length!==1||y||k($)},w.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=P,R.addListener=P,R.once=P,R.off=P,R.removeListener=P,R.removeAllListeners=P,R.emit=P,R.prependListener=P,R.prependOnceListener=P,R.listeners=function(b){return[]},R.binding=function(b){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(b){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ie[75],ne([0,1]),function(J,e){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;class D{constructor(k,h,a){this.level=k,this.key=h,this.value=a,this.forward=[]}}const R=void 0;class L{constructor(k,h=2**16){this.comparator=k,this[N]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new D(this.c,R,R)}get size(){return this.f}clear(){this.e=new D(this.c,R,R),this.f=0}has(k){return!!L.g(this,k,this.comparator)}get(k){return L.g(this,k,this.comparator)?.value}set(k,h){return L.h(this,k,h,this.comparator)&&(this.f+=1),this}delete(k){const h=L.k(this,k,this.comparator);return h&&(this.f-=1),h}forEach(k,h){let a=this.e.forward[0];for(;a;)k.call(h,a.value,a.key,this),a=a.forward[0]}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",h=this.e.forward[0];for(;h;)k+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return k}static g(k,h,a){let y=k.e;for(let E=k.d-1;E>=0;E--)for(;y.forward[E]&&a(y.forward[E].key,h)<0;)y=y.forward[E];if(y=y.forward[0],y&&a(y.key,h)===0)return y}static h(k,h,a,y){const E=[];let d=k.e;for(let $=k.d-1;$>=0;$--){for(;d.forward[$]&&y(d.forward[$].key,h)<0;)d=d.forward[$];E[$]=d}if(d=d.forward[0],d&&y(d.key,h)===0)return d.value=a,!1;{const $=L.j(k);if($>k.d){for(let w=k.d;w<$;w++)E[w]=k.e;k.d=$}d=new D($,h,a);for(let w=0;w<$;w++)d.forward[w]=E[w].forward[w],E[w].forward[w]=d;return!0}}static j(k,h=.5){let a=1;for(;Math.random()<h&&a<k.c;)a+=1;return a}static k(k,h,a){const y=[];let E=k.e;for(let d=k.d-1;d>=0;d--){for(;E.forward[d]&&a(E.forward[d].key,h)<0;)E=E.forward[d];y[d]=E}if(E=E.forward[0],!E||a(E.key,h)!==0)return!1;for(let d=0;d<k.d&&y[d].forward[d]===E;d++)y[d].forward[d]=E.forward[d];for(;k.d>0&&k.e.forward[k.d-1]===R;)k.d-=1;return!0}}e.$3r=L}),define(ie[46],ne([0,1,7,2]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function R(u){const g=u;return g?typeof g.read=="function":!1}e.$8d=R;function L(u){const g=u;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}e.$9d=L;function A(u){const g=u;return g?L(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.$0d=A;function k(u,g){return new h(u,g)}e.$$d=k;class h{constructor(g,i){this.e=g,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(i=>i(g))}h(g){this.c.error.length===0?(0,N.$1)(g):this.c.error.slice(0).forEach(i=>i(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,i){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(g,i){if(this.a.destroyed)return;let r;switch(g){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(i);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(u,g){const i=[];let r;for(;(r=u.read())!==null;)i.push(r);return g(i)}e.$_d=a;function y(u,g,i){const r=[];let t;for(;(t=u.read())!==null&&r.length<i;)r.push(t);return t===null&&r.length>0?g(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return u.read()}}}e.$ae=y;function E(u,g){return new Promise((i,r)=>{const t=[];d(u,{onData:n=>{g&&t.push(n)},onError:n=>{g?r(n):i(void 0)},onEnd:()=>{i(g?g(t):void 0)}})})}e.$be=E;function d(u,g,i){u.on("error",r=>{i?.isCancellationRequested||g.onError(r)}),u.on("end",()=>{i?.isCancellationRequested||g.onEnd()}),u.on("data",r=>{i?.isCancellationRequested||g.onData(r)})}e.$ce=d;function $(u,g){return new Promise((i,r)=>{const t=new D.$Sc,n=[],s=O=>{if(n.push(O),n.length>g)return t.dispose(),u.pause(),i({stream:u,buffer:n,ended:!1})},o=O=>(t.dispose(),r(O)),l=()=>(t.dispose(),i({stream:u,buffer:n,ended:!0}));t.add((0,D.$Rc)(()=>u.removeListener("error",o))),u.on("error",o),t.add((0,D.$Rc)(()=>u.removeListener("end",l))),u.on("end",l),t.add((0,D.$Rc)(()=>u.removeListener("data",s))),u.on("data",s)})}e.$de=$;function w(u,g){const i=k(g);return i.end(u),i}e.$ee=w;function P(){const u=k(()=>{throw new Error("not supported")});return u.end(),u}e.$fe=P;function b(u){let g=!1;return{read:()=>g?null:(g=!0,u)}}e.$ge=b;function c(u,g,i){const r=k(i);return d(u,{onData:t=>r.write(g.data(t)),onError:t=>r.error(g.error?g.error(t):t),onEnd:()=>r.end()}),r}e.$he=c;function p(u,g,i){let r=!1;return{read:()=>{const t=g.read();return r?t:(r=!0,t!==null?i([u,t]):u)}}}e.$ie=p;function m(u,g,i){let r=!1;const t=k(i);return d(g,{onData:n=>r?t.write(n):(r=!0,t.write(i([u,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(u)),t.end()}}),t}e.$je=m}),define(ie[14],ne([0,1,166,46]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const R=typeof Buffer<"u",L=new N.$V(()=>new Uint8Array(256));let A,k;class h{static alloc(j){return R?new h(Buffer.allocUnsafe(j)):new h(new Uint8Array(j))}static wrap(j){return R&&!Buffer.isBuffer(j)&&(j=Buffer.from(j.buffer,j.byteOffset,j.byteLength)),new h(j)}static fromString(j,q){return!(q?.dontUseNodeBuffer||!1)&&R?new h(Buffer.from(j)):(A||(A=new TextEncoder),new h(A.encode(j)))}static fromByteArray(j){const q=h.alloc(j.length);for(let Q=0,Y=j.length;Q<Y;Q++)q.buffer[Q]=j[Q];return q}static concat(j,q){if(typeof q>"u"){q=0;for(let oe=0,re=j.length;oe<re;oe++)q+=j[oe].byteLength}const Q=h.alloc(q);let Y=0;for(let oe=0,re=j.length;oe<re;oe++){const he=j[oe];Q.set(he,Y),Y+=he.byteLength}return Q}constructor(j){this.buffer=j,this.byteLength=this.buffer.byteLength}clone(){const j=h.alloc(this.byteLength);return j.set(this),j}toString(){return R?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(j,q){return new h(this.buffer.subarray(j,q))}set(j,q){if(j instanceof h)this.buffer.set(j.buffer,q);else if(j instanceof Uint8Array)this.buffer.set(j,q);else if(j instanceof ArrayBuffer)this.buffer.set(new Uint8Array(j),q);else if(ArrayBuffer.isView(j))this.buffer.set(new Uint8Array(j.buffer,j.byteOffset,j.byteLength),q);else throw new Error("Unknown argument 'array'")}readUInt32BE(j){return d(this.buffer,j)}writeUInt32BE(j,q){$(this.buffer,j,q)}readUInt32LE(j){return w(this.buffer,j)}writeUInt32LE(j,q){P(this.buffer,j,q)}readUInt8(j){return b(this.buffer,j)}writeUInt8(j,q){c(this.buffer,j,q)}indexOf(j,q=0){return a(this.buffer,j instanceof h?j.buffer:j,q)}}e.$ke=h;function a(v,j,q=0){const Q=j.byteLength,Y=v.byteLength;if(Q===0)return 0;if(Q===1)return v.indexOf(j[0]);if(Q>Y-q)return-1;const oe=L.value;oe.fill(j.length);for(let ae=0;ae<j.length;ae++)oe[j[ae]]=j.length-ae-1;let re=q+j.length-1,he=re,de=-1;for(;re<Y;)if(v[re]===j[he]){if(he===0){de=re;break}re--,he--}else re+=Math.max(j.length-he,oe[v[re]]),he=j.length-1;return de}e.$le=a;function y(v,j){return v[j+0]<<0>>>0|v[j+1]<<8>>>0}e.$me=y;function E(v,j,q){v[q+0]=j&255,j=j>>>8,v[q+1]=j&255}e.$ne=E;function d(v,j){return v[j]*2**24+v[j+1]*2**16+v[j+2]*2**8+v[j+3]}e.$oe=d;function $(v,j,q){v[q+3]=j,j=j>>>8,v[q+2]=j,j=j>>>8,v[q+1]=j,j=j>>>8,v[q]=j}e.$pe=$;function w(v,j){return v[j+0]<<0>>>0|v[j+1]<<8>>>0|v[j+2]<<16>>>0|v[j+3]<<24>>>0}e.$qe=w;function P(v,j,q){v[q+0]=j&255,j=j>>>8,v[q+1]=j&255,j=j>>>8,v[q+2]=j&255,j=j>>>8,v[q+3]=j&255}e.$re=P;function b(v,j){return v[j]}e.$se=b;function c(v,j,q){v[q]=j}e.$te=c;function p(v){return D.$_d(v,j=>h.concat(j))}e.$ue=p;function m(v){return D.$ge(v)}e.$ve=m;function u(v){return D.$be(v,j=>h.concat(j))}e.$we=u;async function g(v){return v.ended?h.concat(v.buffer):h.concat([...v.buffer,await u(v.stream)])}e.$xe=g;function i(v){return D.$ee(v,j=>h.concat(j))}e.$ye=i;function r(v){return D.$he(v,{data:j=>typeof j=="string"?h.fromString(j):h.wrap(j)},j=>h.concat(j))}e.$ze=r;function t(v){return D.$$d(j=>h.concat(j),v)}e.$Ae=t;function n(v,j){return D.$ie(v,j,q=>h.concat(q))}e.$Be=n;function s(v,j){return D.$je(v,j,q=>h.concat(q))}e.$Ce=s;function o(v){let j=0,q=0,Q=0;const Y=new Uint8Array(Math.floor(v.length/4*3)),oe=he=>{switch(q){case 3:Y[Q++]=j|he,q=0;break;case 2:Y[Q++]=j|he>>>2,j=he<<6,q=3;break;case 1:Y[Q++]=j|he>>>4,j=he<<4,q=2;break;default:j=he<<2,q=1}};for(let he=0;he<v.length;he++){const de=v.charCodeAt(he);if(de>=65&&de<=90)oe(de-65);else if(de>=97&&de<=122)oe(de-97+26);else if(de>=48&&de<=57)oe(de-48+52);else if(de===43||de===45)oe(62);else if(de===47||de===95)oe(63);else{if(de===61)break;throw new SyntaxError(`Unexpected base64 character ${v[he]}`)}}const re=Q;for(;q>0;)oe(0);return h.wrap(Y).slice(0,re)}e.$De=o;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:v},j=!0,q=!1){const Q=q?O:l;let Y="";const oe=v.byteLength%3;let re=0;for(;re<v.byteLength-oe;re+=3){const he=v[re+0],de=v[re+1],ae=v[re+2];Y+=Q[he>>>2],Y+=Q[(he<<4|de>>>4)&63],Y+=Q[(de<<2|ae>>>6)&63],Y+=Q[ae&63]}if(oe===1){const he=v[re+0];Y+=Q[he>>>2],Y+=Q[he<<4&63],j&&(Y+="==")}else if(oe===2){const he=v[re+0],de=v[re+1];Y+=Q[he>>>2],Y+=Q[(he<<4|de>>>4)&63],Y+=Q[de<<2&63],j&&(Y+="=")}return Y}e.$Ee=I}),define(ie[43],ne([0,1,30]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=void 0;function D(c){return R(c,0)}e.$Vi=D;function R(c,p){switch(typeof c){case"object":return c===null?L(349,p):Array.isArray(c)?h(c,p):a(c,p);case"string":return k(c,p);case"boolean":return A(c,p);case"number":return L(c,p);case"undefined":return L(937,p);default:return L(617,p)}}e.$Wi=R;function L(c,p){return(p<<5)-p+c|0}e.$Xi=L;function A(c,p){return L(c?433:863,p)}function k(c,p){p=L(149417,p);for(let m=0,u=c.length;m<u;m++)p=L(c.charCodeAt(m),p);return p}e.$Yi=k;function h(c,p){return p=L(104579,p),c.reduce((m,u)=>R(u,m),p)}function a(c,p){return p=L(181387,p),Object.keys(c).sort().reduce((m,u)=>(m=k(u,m),R(c[u],m)),p)}class y{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=R(p,this.g),this.g}}e.$Zi=y;var E;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function d(c,p,m=32){const u=m-p,g=~((1<<u)-1);return(c<<p|(g&c)>>>u)>>>0}function $(c,p=0,m=c.byteLength,u=0){for(let g=0;g<m;g++)c[p+g]=u}function w(c,p,m="0"){for(;c.length<p;)c=m+c;return c}function P(c,p=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(m=>m.toString(16).padStart(2,"0")).join(""):w((c>>>0).toString(16),p/4)}e.$1i=P;class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const m=p.length;if(m===0)return;const u=this.p;let g=this.r,i=this.u,r,t;for(i!==0?(r=i,t=-1,i=0):(r=p.charCodeAt(0),t=0);;){let n=r;if(N.$ef(r))if(t+1<m){const s=p.charCodeAt(t+1);N.$ff(s)?(t++,n=N.$gf(r,s)):n=65533}else{i=r;break}else N.$ff(r)&&(n=65533);if(g=this.w(u,g,n),t++,t<m)r=p.charCodeAt(t);else break}this.r=g,this.u=i}w(p,m,u){return u<128?p[m++]=u:u<2048?(p[m++]=192|(u&1984)>>>6,p[m++]=128|(u&63)>>>0):u<65536?(p[m++]=224|(u&61440)>>>12,p[m++]=128|(u&4032)>>>6,p[m++]=128|(u&63)>>>0):(p[m++]=240|(u&1835008)>>>18,p[m++]=128|(u&258048)>>>12,p[m++]=128|(u&4032)>>>6,p[m++]=128|(u&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),P(this.h)+P(this.l)+P(this.m)+P(this.n)+P(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=b.g,m=this.q;for(let l=0;l<64;l+=4)p.setUint32(l,m.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)p.setUint32(l,d(p.getUint32(l-12,!1)^p.getUint32(l-32,!1)^p.getUint32(l-56,!1)^p.getUint32(l-64,!1),1),!1);let u=this.h,g=this.l,i=this.m,r=this.n,t=this.o,n,s,o;for(let l=0;l<80;l++)l<20?(n=g&i|~g&r,s=1518500249):l<40?(n=g^i^r,s=1859775393):l<60?(n=g&i|g&r|i&r,s=2400959708):(n=g^i^r,s=3395469782),o=d(u,5)+n+t+s+p.getUint32(l*4,!1)&4294967295,t=r,r=i,i=d(g,30),g=u,u=o;this.h=this.h+u&4294967295,this.l=this.l+g&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$2i=b}),define(ie[54],ne([0,1,30]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(D||(D={})),function(R){const L="error",A="warning",k="warn",h="info",a="ignore";function y(d){return d?N.$af(L,d)?R.Error:N.$af(A,d)||N.$af(k,d)?R.Warning:N.$af(h,d)?R.Info:R.Ignore:R.Ignore}R.fromValue=y;function E(d){switch(d){case R.Error:return L;case R.Warning:return A;case R.Info:return h;default:return a}}R.toString=E}(D||(D={})),e.default=D}),define(ie[27],ne([0,1,3]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=void 0;function D(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const p=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([m,u])=>{p[m]=u&&typeof u=="object"?D(u):u}),p}e.$yn=D;function R(c){if(!c||typeof c!="object")return c;const p=[c];for(;p.length>0;){const m=p.shift();Object.freeze(m);for(const u in m)if(L.call(m,u)){const g=m[u];typeof g=="object"&&!Object.isFrozen(g)&&!(0,N.$Mf)(g)&&p.push(g)}}return c}e.$zn=R;const L=Object.prototype.hasOwnProperty;function A(c,p){return k(c,p,new Set)}e.$An=A;function k(c,p,m){if((0,N.$Sf)(c))return c;const u=p(c);if(typeof u<"u")return u;if(Array.isArray(c)){const g=[];for(const i of c)g.push(k(i,p,m));return g}if((0,N.$Lf)(c)){if(m.has(c))throw new Error("Cannot clone recursive data-structure");m.add(c);const g={};for(const i in c)L.call(c,i)&&(g[i]=k(c[i],p,m));return m.delete(c),g}return c}function h(c,p,m=!0){return(0,N.$Lf)(c)?((0,N.$Lf)(p)&&Object.keys(p).forEach(u=>{u in c?m&&((0,N.$Lf)(c[u])&&(0,N.$Lf)(p[u])?h(c[u],p[u],m):c[u]=p[u]):c[u]=p[u]}),c):p}e.$Bn=h;function a(c,p){if(c===p)return!0;if(c==null||p===null||p===void 0||typeof c!=typeof p||typeof c!="object"||Array.isArray(c)!==Array.isArray(p))return!1;let m,u;if(Array.isArray(c)){if(c.length!==p.length)return!1;for(m=0;m<c.length;m++)if(!a(c[m],p[m]))return!1}else{const g=[];for(u in c)g.push(u);g.sort();const i=[];for(u in p)i.push(u);if(i.sort(),!a(g,i))return!1;for(m=0;m<g.length;m++)if(!a(c[g[m]],p[g[m]]))return!1}return!0}e.$Cn=a;function y(c){const p=new Set;return JSON.stringify(c,(m,u)=>{if((0,N.$Lf)(u)||Array.isArray(u)){if(p.has(u))return"[Circular]";p.add(u)}return u})}e.$Dn=y;function E(c,p){const m=Object.create(null);return!c||!p||Object.keys(p).forEach(g=>{const i=c[g],r=p[g];a(i,r)||(m[g]=r)}),m}e.$En=E;function d(c,p){const m=p.toLowerCase(),u=Object.keys(c).find(g=>g.toLowerCase()===m);return u?c[u]:c[p]}e.$Fn=d;function $(c,p){const m=Object.create(null);for(const[u,g]of Object.entries(c))p(u,g)&&(m[u]=g);return m}e.$Gn=$;function w(c){let p=[];for(;Object.prototype!==c;)p=p.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return p}e.$Hn=w;function P(c){const p=[];for(const m of w(c))typeof c[m]=="function"&&p.push(m);return p}e.$In=P;function b(c,p){const m=g=>function(){const i=Array.prototype.slice.call(arguments,0);return p(g,i)},u={};for(const g of c)u[g]=m(g);return u}e.$Jn=b}),define(ie[28],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=void 0;const N=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(R){return N.test(R)}e.$qg=D,e.$rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(k){for(let h=0;h<k.length;h++)k[h]=Math.floor(Math.random()*256);return k};const L=new Uint8Array(16),A=[];for(let k=0;k<256;k++)A.push(k.toString(16).padStart(2,"0"));return function(){R(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let h=0,a="";return a+=A[L[h++]],a+=A[L[h++]],a+=A[L[h++]],a+=A[L[h++]],a+="-",a+=A[L[h++]],a+=A[L[h++]],a+="-",a+=A[L[h++]],a+=A[L[h++]],a+="-",a+=A[L[h++]],a+=A[L[h++]],a+="-",a+=A[L[h++]],a+=A[L[h++]],a+=A[L[h++]],a+=A[L[h++]],a+=A[L[h++]],a+=A[L[h++]],a}}()}),define(ie[76],ne([0,1,33]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(A){const k=A.replace(/\-/g,":").toLowerCase();return!D.has(k)}function L(){const A=(0,N.networkInterfaces)();for(const k in A){const h=A[k];if(h){for(const{mac:a}of h)if(R(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$_m=L}),define(ie[77],ne([8,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(ie[78],ne([0,1,77]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0;const D=60,R=D*60,L=R*24,A=L*7,k=L*30,h=L*365;function a(d,$,w,P){typeof d!="number"&&(d=d.getTime());const b=Math.round((new Date().getTime()-d)/1e3);if(b<-30)return(0,N.localize)(0,null,a(new Date().getTime()+b*1e3,!1));if(!P&&b<30)return(0,N.localize)(1,null);let c;return b<D?(c=b,$?c===1?w?(0,N.localize)(2,null,c):(0,N.localize)(3,null,c):w?(0,N.localize)(4,null,c):(0,N.localize)(5,null,c):c===1?w?(0,N.localize)(6,null,c):(0,N.localize)(7,null,c):w?(0,N.localize)(8,null,c):(0,N.localize)(9,null,c)):b<R?(c=Math.floor(b/D),$?c===1?w?(0,N.localize)(10,null,c):(0,N.localize)(11,null,c):w?(0,N.localize)(12,null,c):(0,N.localize)(13,null,c):c===1?w?(0,N.localize)(14,null,c):(0,N.localize)(15,null,c):w?(0,N.localize)(16,null,c):(0,N.localize)(17,null,c)):b<L?(c=Math.floor(b/R),$?c===1?w?(0,N.localize)(18,null,c):(0,N.localize)(19,null,c):w?(0,N.localize)(20,null,c):(0,N.localize)(21,null,c):c===1?w?(0,N.localize)(22,null,c):(0,N.localize)(23,null,c):w?(0,N.localize)(24,null,c):(0,N.localize)(25,null,c)):b<A?(c=Math.floor(b/L),$?c===1?(0,N.localize)(26,null,c):(0,N.localize)(27,null,c):c===1?(0,N.localize)(28,null,c):(0,N.localize)(29,null,c)):b<k?(c=Math.floor(b/A),$?c===1?w?(0,N.localize)(30,null,c):(0,N.localize)(31,null,c):w?(0,N.localize)(32,null,c):(0,N.localize)(33,null,c):c===1?w?(0,N.localize)(34,null,c):(0,N.localize)(35,null,c):w?(0,N.localize)(36,null,c):(0,N.localize)(37,null,c)):b<h?(c=Math.floor(b/k),$?c===1?w?(0,N.localize)(38,null,c):(0,N.localize)(39,null,c):w?(0,N.localize)(40,null,c):(0,N.localize)(41,null,c):c===1?w?(0,N.localize)(42,null,c):(0,N.localize)(43,null,c):w?(0,N.localize)(44,null,c):(0,N.localize)(45,null,c)):(c=Math.floor(b/h),$?c===1?w?(0,N.localize)(46,null,c):(0,N.localize)(47,null,c):w?(0,N.localize)(48,null,c):(0,N.localize)(49,null,c):c===1?w?(0,N.localize)(50,null,c):(0,N.localize)(51,null,c):w?(0,N.localize)(52,null,c):(0,N.localize)(53,null,c))}e.$xm=a;function y(d,$){const w=Math.abs(d/1e3);return w<1?$?(0,N.localize)(54,null,d):(0,N.localize)(55,null,d):w<D?$?(0,N.localize)(56,null,Math.round(d)/1e3):(0,N.localize)(57,null,Math.round(d)/1e3):w<R?$?(0,N.localize)(58,null,Math.round(d/(1e3*D))):(0,N.localize)(59,null,Math.round(d/(1e3*D))):w<L?$?(0,N.localize)(60,null,Math.round(d/(1e3*R))):(0,N.localize)(61,null,Math.round(d/(1e3*R))):(0,N.localize)(62,null,Math.round(d/(1e3*L)))}e.$ym=y;function E(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$zm=E}),define(ie[79],ne([8,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ie[34],ne([0,1,19,3,79]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=void 0;function L(E,d){return d&&(E.stack||E.stacktrace)?R.localize(0,null,k(E),A(E.stack)||A(E.stacktrace)):k(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function k(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?R.localize(1,null,E.message):E.message||R.localize(2,null)}function h(E=null,d=!1){if(!E)return R.localize(3,null);if(Array.isArray(E)){const $=N.$Hb(E),w=h($[0],d);return $.length>1?R.localize(4,null,w,$.length):w}if(D.$Jf(E))return E;if(E.detail){const $=E.detail;if($.error)return L($.error,d);if($.exception)return L($.exception,d)}return E.stack?L(E,d):E.message?E.message:R.localize(5,null)}e.$Si=h;function a(E){const d=E;return d instanceof Error&&Array.isArray(d.actions)}e.$Ti=a;function y(E,d){let $;return typeof E=="string"?$=new Error(E):$=E,$.actions=d,$}e.$Ui=y}),define(ie[80],ne([8,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ie[81],ne([0,1,80]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;function D(R){switch(R){case 1:return(0,N.localize)(0,null);case 2:return(0,N.localize)(1,null);case 3:return(0,N.localize)(2,null);case 4:return(0,N.localize)(3,null);case 5:return(0,N.localize)(4,null);case 6:return(0,N.localize)(5,null);case 7:return(0,N.localize)(6,null);case 8:return(0,N.localize)(7,null);case 9:return(0,N.localize)(8,null);default:return""}}e.$Zp=D}),define(ie[55],ne([0,1,12]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0;var D;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(D||(e.Source=D={}));var R;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function L(k,...h){const a=h.reduce((d,$)=>(d[$]=!0,d),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(d=>!a[d]).forEach(d=>{for(let $=0;$<y.length;$++)if(d.search(y[$])!==-1){delete k[d];break}})}e.$Tl=L;function A(k){k&&(delete k.DEBUG,N.$j&&delete k.DYLD_LIBRARY_PATH,N.$k&&delete k.LD_PRELOAD)}e.$Ul=A}),define(ie[82],ne([0,1,11]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$qq=e.$pq=e.$oq=void 0;function D(a){const y=a;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.$oq=D;function R(a){const y=[];let E;try{const d=JSON.parse(a.arguments),$=d[d.length-1];$&&$.__$stack&&(d.pop(),E=$.__$stack),y.push(...d)}catch{y.push("Unable to log remote console arguments",a.arguments)}return{args:y,stack:E}}e.$pq=R;function L(a){if(typeof a!="string")return L(R(a).stack);const y=a;if(y){const E=A(y),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(d&&d.length===4)return{uri:N.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.$qq=L;function A(a){if(!a)return a;const y=a.indexOf(`
`);return y===-1?a:a.substring(0,y)}function k(a,y){const{args:E,stack:d}=R(a),$=typeof E[0]=="string"&&E.length===1;let w=A(d);w&&(w=`(${w.trim()})`);let P=[];if(typeof E[0]=="string"?w&&$?P=[`%c[${y}] %c${E[0]} %c${w}`,h("blue"),h(""),h("grey")]:P=[`%c[${y}] %c${E[0]}`,h("blue"),h(""),...E.slice(1)]:P=[`%c[${y}]%`,h("blue"),...E],w&&!$&&P.push(w),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,P)}e.log=k;function h(a){return`color: ${a}`}}),define(ie[47],ne([0,1,14,11]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=void 0;function R(h){return JSON.stringify(h,A)}e.$Ch=R;function L(h){let a=JSON.parse(h);return a=k(a),a}e.$Dh=L;function A(h,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function k(h,a=0){if(!h||a>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return D.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof N.$ke||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let y=0;y<h.length;++y)h[y]=k(h[y],a+1);else for(const y in h)Object.hasOwnProperty.call(h,y)&&(h[y]=k(h[y],a+1))}return h}e.$Eh=k}),define(ie[83],ne([0,1,70,15,12,11]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jD=void 0;class A{constructor(d,$,w){this.id=d,this.dependencies=$,this.callback=w}}class k{static{this.INSTANCE=new k}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,$,w)=>{typeof d!="string"&&(w=$,$=d,d=null),(typeof $!="object"||!Array.isArray($))&&(w=$,$=null),this.c.push(new A(d,$,w))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const $=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!$)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray($.dependencies)&&$.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${$.dependencies.join(", ")}`);return typeof $.callback=="function"?$.callback([]):$.callback}h(d){return new Promise(($,w)=>{const P=document.createElement("script");P.setAttribute("async","async"),P.setAttribute("type","text/javascript");const b=()=>{P.removeEventListener("load",c),P.removeEventListener("error",p)},c=m=>{b(),$(this.c.pop())},p=m=>{b(),w(m)};P.addEventListener("load",c),P.addEventListener("error",p),this.f&&(d=this.f.createScriptURL(d)),P.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(P)})}i(d){return new Promise(($,w)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),$(this.c.pop())}catch(P){w(P)}})}async j(d){try{const $=globalThis._VSCODE_NODE_MODULES.fs,w=globalThis._VSCODE_NODE_MODULES.vm,P=globalThis._VSCODE_NODE_MODULES.module,b=L.URI.parse(d).fsPath,c=$.readFileSync(b).toString(),p=P.wrap(c.replace(/^#!.*/,""));return new w.Script(p).runInThisContext().apply(),this.c.pop()}catch($){throw $}}}const h=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function y(E,d,$){if(N.$T){$===void 0&&($=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[E]&&(E=a[E]);const w=`${E}/${d}`;if(h.has(w))return h.get(w);let P;if(/^\w[\w\d+.-]*:\/\//.test(w))P=w;else{const m=`${$&&!R.$o?D.$mg:D.$lg}/${w}`;P=D.$pg.asBrowserUri(m).toString(!0)}const b=k.INSTANCE.load(P);return h.set(w,b),b}else return await new Promise((w,P)=>{J([E],w,P)})}e.$jD=y}),define(ie[84],ne([0,1,33,48,28,76,12]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=void 0,e.$an=new class{c(d){return this.a||(this.a=D.$bi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,$=0;const w=(0,N.networkInterfaces)();for(const P in w){const b=w[P];if(b)for(const{mac:c,internal:p}of b)p||($+=1,this.c(c.toUpperCase())&&(d+=1))}this.b=$>0?d/$:0}return this.b}};let k;async function h(d){return k||(k=(async()=>await a(d)||R.$rg())()),k}e.$bn=h;async function a(d){try{const $=await new Promise((P,b)=>{J(["crypto"],P,b)}),w=(0,L.$_m)();return $.createHash("sha256").update(w,"utf8").digest("hex")}catch($){d($);return}}const y="Software\\Microsoft\\SQMClient";async function E(d){if(A.$i){const $=await new Promise((w,P)=>{J(["@vscode/windows-registry"],w,P)});try{return $.GetStringRegKey("HKEY_LOCAL_MACHINE",y,"MachineId")||""}catch(w){return d(w),""}}return""}e.$cn=E}),define(ie[85],ne([0,1,33,16,24]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=void 0;const L=/^\d+$/,A=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var h;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(h||(h={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class E{constructor(g,i,r){this.exePath=g,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:u=!1}={}){return u?a===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function $({useAlternateBitness:u=!1,findPreview:g=!1}={}){const i=d({useAlternateBitness:u});if(!i)return null;const r=D.$jc(i,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const l of await R.Promises.readdir(r)){let O=-1;if(g){const v=l.indexOf("-");if(v<0)continue;const j=l.substring(0,v);if(!L.test(j)||l.substring(v+1)!=="preview")continue;O=parseInt(j,10)}else{if(!L.test(l))continue;O=parseInt(l,10)}if(O<=t)continue;const I=D.$jc(r,l,"pwsh.exe");await R.SymlinkSupport.existsFile(I)&&(n=I,t=O)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",o=g?" Preview":"";return new E(n,`PowerShell${o}${s}`,!0)}async function w({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const g=D.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(g))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=u?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(g))if(i.test(t)){const n=D.$jc(g,t,"pwsh.exe");return new E(n,r)}return null}function P(){const u=D.$jc(N.homedir(),".dotnet","tools","pwsh.exe");return new E(u,".NET Core PowerShell Global Tool")}function b(){const u=D.$jc(process.env.windir,a===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(u,"Windows PowerShell",!0)}async function*c(){let u=await $();u&&(yield u),u=await $({useAlternateBitness:!0}),u&&(yield u),u=await w(),u&&(yield u),u=P(),u&&(yield u),u=await $({findPreview:!0}),u&&(yield u),u=await w({findPreview:!0}),u&&(yield u),u=await $({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=b(),u&&(yield u)}async function*p(){for await(const u of c())await u.exists()&&(yield u)}e.$Rl=p;async function m(){for await(const u of p())return u;return null}e.$Sl=m}),define(ie[56],ne([0,1,16,12,35,55,3,24]),function(J,e,N,D,R,L,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Wl=e.$Vl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function h(E=R.env){return E.comspec||"cmd.exe"}e.$Vl=h;function a(E){let d=[],$=!1;const w=function(P){if($){d.push(P);return}(!E.send(P,c=>{if(c&&console.error(c),$=!1,d.length>0){const p=d.slice(0);d=[],p.forEach(m=>w(m))}})||D.$i)&&($=!0)};return{send:w}}e.$Wl=a;var y;(function(E){async function d($,w,P){if(N.$ic($))return $;if(w===void 0&&(w=R.cwd()),N.$mc($)!=="."||(P===void 0&&A.$Jf(R.env.PATH)&&(P=R.env.PATH.split(N.$tc)),P===void 0||P.length===0))return N.$jc(w,$);async function c(p){if(await k.Promises.exists(p)){let m;try{m=await k.Promises.stat(p)}catch(u){u.message.startsWith("EACCES")&&(m=await k.Promises.lstat(p))}return m?!m.isDirectory():!1}return!1}for(const p of P){let m;if(N.$ic(p)?m=N.$jc(p,$):m=N.$jc(w,p,$),await c(m))return m;let u=m+".com";if(await c(u)||(u=m+".exe",await c(u)))return u}return N.$jc(w,$)}E.findExecutable=d})(y||(e.win32=y={}))}),define(ie[86],ne([0,1,33,12,85,56]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=void 0;async function A(E,d){return E===1?D.$i?y():L.$Vl(d):h(E,d)}e.$Xl=A;let k=null;function h(E,d){if(D.$k&&E===2||D.$j&&E===3)return"/bin/bash";if(!k){let $;if(D.$i)$="/bin/bash";else{if($=d.SHELL,!$)try{$=(0,N.userInfo)().shell}catch{}$||($="sh"),$==="/bin/false"&&($="/bin/bash")}k=$}return k}let a=null;async function y(){return a||(a=(await(0,R.$Sl)()).exePath),a}});var $e=this&&this.__decorate||function(J,e,N,D){var R=arguments.length,L=R<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,N):D,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(J,e,N,D);else for(var k=J.length-1;k>=0;k--)(A=J[k])&&(L=(R<3?A(L):R>3?A(e,N,L):A(e,N))||L);return R>3&&L&&Object.defineProperty(e,N,L),L};define(ie[57],ne([0,1,19,9,14,20,53,7,6,2,47,30,3]),function(J,e,N,D,R,L,A,k,h,a,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.ProxyChannel=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.RequestInitiator=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=void 0;var $;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})($||($={}));function w(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var P;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(P||(P={}));function b(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(c||(c={}));function p(M){let T=0;for(let W=0;;W+=7){const Z=M.read(1);if(T|=(Z.buffer[0]&127)<<W,!(Z.buffer[0]&128))return T}}const m=t(0);function u(M,T){if(T===0){M.write(m);return}let W=0;for(let K=T;K!==0;K=K>>>7)W++;const Z=R.$ke.alloc(W);for(let K=0;T!==0;K++)Z.buffer[K]=T&127,T=T>>>7,T>0&&(Z.buffer[K]|=128);M.write(Z)}class g{constructor(T){this.b=T,this.a=0}read(T){const W=this.b.slice(this.a,this.a+T);return this.a+=W.byteLength,W}}e.$Fh=g;class i{constructor(){this.a=[]}get buffer(){return R.$ke.concat(this.a)}write(T){this.a.push(T)}}e.$Gh=i;var r;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(r||(r={}));function t(M){const T=R.$ke.alloc(1);return T.writeUInt8(M,0),T}const n={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(M,T){if(typeof T>"u")M.write(n.Undefined);else if(typeof T=="string"){const W=R.$ke.fromString(T);M.write(n.String),u(M,W.byteLength),M.write(W)}else if(s&&Buffer.isBuffer(T)){const W=R.$ke.wrap(T);M.write(n.Buffer),u(M,W.byteLength),M.write(W)}else if(T instanceof R.$ke)M.write(n.VSBuffer),u(M,T.byteLength),M.write(T);else if(Array.isArray(T)){M.write(n.Array),u(M,T.length);for(const W of T)o(M,W)}else if(typeof T=="number"&&(T|0)===T)M.write(n.Uint),u(M,T);else{const W=R.$ke.fromString(JSON.stringify(T));M.write(n.Object),u(M,W.byteLength),M.write(W)}}e.$Hh=o;function l(M){switch(M.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return M.read(p(M)).toString();case r.Buffer:return M.read(p(M)).buffer;case r.VSBuffer:return M.read(p(M));case r.Array:{const W=p(M),Z=[];for(let K=0;K<W;K++)Z.push(l(M));return Z}case r.Object:return JSON.parse(M.read(p(M)).toString());case r.Int:return p(M)}}e.$Ih=l;class O{constructor(T,W,Z=null,K=1e3){this.h=T,this.j=W,this.k=Z,this.l=K,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(T,W){this.b.set(T,W),setTimeout(()=>this.w(T),0)}m(T){switch(T.type){case 200:{const W=this.o([T.type]);this.k?.logOutgoing(W,0,1,b(T.type));return}case 201:case 202:case 204:case 203:{const W=this.o([T.type,T.id],T.data);this.k?.logOutgoing(W,T.id,1,b(T.type),T.data);return}}}o(T,W=void 0){const Z=new i;return o(Z,T),o(Z,W),this.p(Z.buffer)}p(T){try{return this.h.send(T),T.byteLength}catch{return 0}}q(T){const W=new g(T),Z=l(W),K=l(W),_=Z[0];switch(_){case 100:return this.k?.logIncoming(T.byteLength,Z[1],1,`${w(_)}: ${Z[2]}.${Z[3]}`,K),this.s({type:_,id:Z[1],channelName:Z[2],name:Z[3],arg:K});case 102:return this.k?.logIncoming(T.byteLength,Z[1],1,`${w(_)}: ${Z[2]}.${Z[3]}`,K),this.t({type:_,id:Z[1],channelName:Z[2],name:Z[3],arg:K});case 101:return this.k?.logIncoming(T.byteLength,Z[1],1,`${w(_)}`),this.u({type:_,id:Z[1]});case 103:return this.k?.logIncoming(T.byteLength,Z[1],1,`${w(_)}`),this.u({type:_,id:Z[1]})}}s(T){const W=this.b.get(T.channelName);if(!W){this.v(T);return}const Z=new L.$7d;let K;try{K=W.call(this.j,T.name,T.arg,Z.token)}catch(C){K=Promise.reject(C)}const _=T.id;K.then(C=>{this.m({id:_,data:C,type:201})},C=>{C instanceof Error?this.m({id:_,data:{message:C.message,name:C.name,stack:C.stack?C.stack.split?C.stack.split(`
`):C.stack:void 0},type:202}):this.m({id:_,data:C,type:203})}).finally(()=>{F.dispose(),this.d.delete(T.id)});const F=(0,a.$Rc)(()=>Z.cancel());this.d.set(T.id,F)}t(T){const W=this.b.get(T.channelName);if(!W){this.v(T);return}const Z=T.id,_=W.listen(this.j,T.name,T.arg)(F=>this.m({id:Z,data:F,type:204}));this.d.set(T.id,_)}u(T){const W=this.d.get(T.id);W&&(W.dispose(),this.d.delete(T.id))}v(T){let W=this.g.get(T.channelName);W||(W=[],this.g.set(T.channelName,W));const Z=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.m({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:T,timeoutTimer:Z})}w(T){const W=this.g.get(T);if(W){for(const Z of W)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(T)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Jh=O;var I;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class v{constructor(T,W=null){this.l=T,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$Wd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=W}getChannel(T){const W=this;return{call(Z,K,_){return W.a?Promise.reject(new k.$5):W.m(T,Z,K,_)},listen(Z,K){return W.a?h.Event.None:W.o(T,Z,K)}}}m(T,W,Z,K=L.CancellationToken.None){const _=this.g++,C={id:_,type:100,channelName:T,name:W,arg:Z};if(K.isCancellationRequested)return Promise.reject(new k.$5);let f;return new Promise((z,U)=>{if(K.isCancellationRequested)return U(new k.$5);const H=()=>{const ue=me=>{switch(me.type){case 201:this.f.delete(_),z(me.data);break;case 202:{this.f.delete(_);const we=new Error(me.data.message);we.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,we.name=me.data.name,U(we);break}case 203:this.f.delete(_),U(me.data);break}};this.f.set(_,ue),this.p(C)};let G=null;this.b===c.Idle?H():(G=(0,D.$Ug)(ue=>this.u()),G.then(()=>{G=null,H()}));const te=()=>{G?(G.cancel(),G=null):this.p({id:_,type:101}),U(new k.$5)},le=K.onCancellationRequested(te);f=(0,a.$Qc)((0,a.$Rc)(te),le),this.d.add(f)}).finally(()=>{f.dispose(),this.d.delete(f)})}o(T,W,Z){const K=this.g++,F={id:K,type:102,channelName:T,name:W,arg:Z};let C=null;const f=new h.$Wd({onWillAddFirstListener:()=>{C=(0,D.$Ug)(z=>this.u()),C.then(()=>{C=null,this.d.add(f),this.p(F)})},onDidRemoveLastListener:()=>{C?(C.cancel(),C=null):(this.d.delete(f),this.p({id:K,type:103}))}}),S=z=>f.fire(z.data);return this.f.set(K,S),f.event}p(T){switch(T.type){case 100:case 102:{const W=this.q([T.type,T.id,T.channelName,T.name],T.arg);this.j?.logOutgoing(W,T.id,0,`${w(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const W=this.q([T.type,T.id]);this.j?.logOutgoing(W,T.id,0,w(T.type));return}}}q(T,W=void 0){const Z=new i;return o(Z,T),o(Z,W),this.r(Z.buffer)}r(T){try{return this.l.send(T),T.byteLength}catch{return 0}}s(T){const W=new g(T),Z=l(W),K=l(W),_=Z[0];switch(_){case 200:return this.j?.logIncoming(T.byteLength,0,0,b(_)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(T.byteLength,Z[1],0,b(_),K),this.t({type:Z[0],id:Z[1],data:K})}}t(T){if(T.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(T.id)?.(T)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Kh=v,$e([A.$zh],v.prototype,"onDidInitializePromise",null);class j{get connections(){const T=[];return this.f.forEach(W=>T.push(W)),T}constructor(T){this.a=new Map,this.f=new Set,this.g=new h.$Wd,this.onDidAddConnection=this.g.event,this.h=new h.$Wd,this.onDidRemoveConnection=this.h.event,this.j=new a.$Sc,this.j.add(T(({protocol:W,onDidClientDisconnect:Z})=>{const K=h.Event.once(W.onMessage);this.j.add(K(_=>{const F=new g(_),C=l(F),f=new O(W,C),S=new v(W);this.a.forEach((U,H)=>f.registerChannel(H,U));const z={channelServer:f,channelClient:S,ctx:C};this.f.add(z),this.g.fire(z),this.j.add(Z(()=>{f.dispose(),S.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(T,W){const Z=this;return{call(K,_,F){let C;if((0,d.$Xf)(W)){const S=(0,N.$4b)(Z.connections.filter(W));C=S?Promise.resolve(S):h.Event.toPromise(h.Event.filter(Z.onDidAddConnection,W))}else C=W.routeCall(Z,K,_);const f=C.then(S=>S.channelClient.getChannel(T));return Q(f).call(K,_,F)},listen(K,_){if((0,d.$Xf)(W))return Z.k(T,W,K,_);const F=W.routeEvent(Z,K,_).then(C=>C.channelClient.getChannel(T));return Q(F).listen(K,_)}}}k(T,W,Z,K){const _=this;let F;const C=new h.$Wd({onWillAddFirstListener:()=>{F=new a.$Sc;const f=new h.$3d,S=new Map,z=H=>{const te=H.channelClient.getChannel(T).listen(Z,K),le=f.add(te);S.set(H,le)},U=H=>{const G=S.get(H);G&&(G.dispose(),S.delete(H))};_.connections.filter(W).forEach(z),h.Event.filter(_.onDidAddConnection,W)(z,void 0,F),_.onDidRemoveConnection(U,void 0,F),f.event(C.fire,C,F),F.add(f)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return C.event}registerChannel(T,W){this.a.set(T,W);for(const Z of this.f)Z.channelServer.registerChannel(T,W)}dispose(){this.j.dispose();for(const T of this.f)T.channelClient.dispose(),T.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Lh=j;class q{constructor(T,W,Z=null){const K=new i;o(K,W),T.send(K.buffer),this.a=new v(T,Z),this.d=new O(T,W,Z)}getChannel(T){return this.a.getChannel(T)}registerChannel(T,W){this.d.registerChannel(T,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Mh=q;function Q(M){return{call(T,W,Z){return M.then(K=>K.call(T,W,Z))},listen(T,W){const Z=new h.$6d;return M.then(K=>Z.input=K.listen(T,W)),Z.event}}}e.$Nh=Q;function Y(M){let T=!1;return{call(W,Z,K){return T?M.call(W,Z,K):(0,D.$9g)(0).then(()=>T=!0).then(()=>M.call(W,Z,K))},listen(W,Z){if(T)return M.listen(W,Z);const K=new h.$6d;return(0,D.$9g)(0).then(()=>T=!0).then(()=>K.input=M.listen(W,Z)),K.event}}}e.$Oh=Y;class oe{constructor(T){this.a=T}routeCall(T){return this.b(T)}routeEvent(T){return this.b(T)}async b(T){for(const W of T.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await h.Event.toPromise(T.onDidAddConnection),await this.b(T)}}e.$Ph=oe;var re;(function(M){function T(_,F,C){const f=_,S=C&&C.disableMarshalling,z=new Map;for(const U in f)Z(U)&&z.set(U,h.Event.buffer(f[U],!0,void 0,F));return new class{listen(U,H,G){const te=z.get(H);if(te)return te;if(K(H)){const le=f[H];if(typeof le=="function")return le.call(f,G)}throw new k.$bb(`Event not found: ${H}`)}call(U,H,G){const te=f[H];if(typeof te=="function"){if(!S&&Array.isArray(G))for(let ue=0;ue<G.length;ue++)G[ue]=(0,y.$Eh)(G[ue]);let le=te.apply(f,G);return le instanceof Promise||(le=Promise.resolve(le)),le}throw new k.$bb(`Method not found: ${H}`)}}}M.fromService=T;function W(_,F){const C=F&&F.disableMarshalling;return new Proxy({},{get(f,S){if(typeof S=="string")return F?.properties?.has(S)?F.properties.get(S):K(S)?function(z){return _.listen(S,z)}:Z(S)?_.listen(S):async function(...z){let U;F&&!(0,d.$Sf)(F.context)?U=[F.context,...z]:U=z;const H=await _.call(S,U);return C?H:(0,y.$Eh)(H)};throw new k.$bb(`Property not found: ${String(S)}`)}})}M.toService=W;function Z(_){return _[0]==="o"&&_[1]==="n"&&E.$_e(_.charCodeAt(2))}function K(_){return/^onDynamic/.test(_)&&E.$_e(_.charCodeAt(9))}})(re||(e.ProxyChannel=re={}));const he=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function de(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const T=M.toString();if(T!=="[object Object]")return T}return M}function ae(M){return Array.isArray(M)?M.map(de):de(M)}function B(M,T,W,Z,K,_,F){F=ae(F);const C=he[K],f=C[Z%C.length];let S=[`%c[${M}]%c[${String(T).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${f}`];/\($/.test(_)?(S=S.concat(F),S.push(")")):S.push(F),console.log.apply(console,S)}class X{constructor(T,W){this.d=T,this.f=W,this.a=0,this.b=0}logOutgoing(T,W,Z,K,_){this.b+=T,B(this.d,this.b,T,W,Z,K,_)}logIncoming(T,W,Z,K,_){this.a+=T,B(this.f,this.a,T,W,Z,K,_)}}e.$Qh=X}),define(ie[87],ne([0,1,58,9,14,20,82,7,6,2,27,56,55,57]),function(J,e,N,D,R,L,A,k,h,a,y,E,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=void 0;class w extends $.$Jh{constructor(c){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",p=>R.$ke.wrap(Buffer.from(p,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$sq=w;class P{constructor(c,p){this.i=c,this.j=p,this.c=new Set,this.g=new Map,this.h=new h.$Wd,this.onDidProcessExit=this.h.event;const m=p&&p.timeout?p.timeout:6e4;this.b=new D.$5g(m),this.d=null,this.f=null}getChannel(c){const p=this;return{call(m,u,g){return p.k(c,m,u,g)},listen(m,u){return p.l(c,m,u)}}}k(c,p,m,u=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(k.$6());this.b.cancel();const g=this.n(c),i=(0,D.$Ug)(n=>g.call(p,m,n)),r=u.onCancellationRequested(()=>i.cancel()),t=(0,a.$Rc)(()=>i.cancel());return this.c.add(t),i.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(c,p,m){if(!this.b)return h.Event.None;this.b.cancel();let u;const g=new h.$Wd({onWillAddFirstListener:()=>{u=this.n(c).listen(p,m)(g.fire,g),this.c.add(u)},onDidRemoveLastListener:()=>{this.c.delete(u),u.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return g.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,y.$yn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,d.$Ul)(p.env),this.d=(0,N.fork)(this.i,c,p);const m=new h.$Wd;h.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,A.$oq)(s)){(0,A.log)(s,`IPC Library: ${this.j.serverName}`);return}m.fire(R.$ke.wrap(Buffer.from(s,"base64")))});const g=this.j.useQueue?(0,E.$Wl)(this.d):this.d,i=s=>this.d&&this.d.connected&&g.send(s.buffer.toString("base64")),r=m.event,t={send:i,onMessage:r};this.f=new $.$Kh(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,o)=>{process.removeListener("exit",n),this.c.forEach(l=>(0,a.$Oc)(l)),this.c.clear(),s!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:o})})}return this.f}n(c){let p=this.g.get(c);return p||(p=this.m.getChannel(c),this.g.set(c,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$tq=P}),define(ie[88],ne([0,1,9,6,2,47,3]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.StorageState=e.$rp=e.StorageHint=void 0;var k;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k||(e.StorageHint=k={}));function h(d){const $=d;return $?.changed instanceof Map||$?.deleted instanceof Set}e.$rp=h;var a;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(a||(e.StorageState=a={}));class y extends R.$Tc{static{this.a=100}constructor($,w=Object.create(null)){super(),this.r=$,this.s=w,this.b=this.B(new D.$Zd),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new N.$6g(y.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((w,P)=>this.w(P,w)),$.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w($,w){if(this.c===a.Closed)return;let P=!1;(0,A.$Sf)(w)?P=this.f.delete($):this.f.get($)!==w&&(this.f.set($,w),P=!0),P&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,w){const P=this.f.get($);return(0,A.$Sf)(P)?w:P}getBoolean($,w){const P=this.get($);return(0,A.$Sf)(P)?w:P==="true"}getNumber($,w){const P=this.get($);return(0,A.$Sf)(P)?w:parseInt(P,10)}getObject($,w){const P=this.get($);return(0,A.$Sf)(P)?w:(0,L.$Dh)(P)}async set($,w,P=!1){if(this.c===a.Closed)return;if((0,A.$Sf)(w))return this.delete($,P);const b=(0,A.$Lf)(w)||Array.isArray(w)?(0,L.$Ch)(w):String(w);if(this.f.get($)!==b)return this.f.set($,b),this.j.set($,b),this.h.delete($),this.b.fire({key:$,external:P}),this.D()}async delete($,w=!1){if(!(this.c===a.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:w}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(this.z)return this.D($)}async D($){return this.s.hint===k.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===k.STORAGE_IN_MEMORY}}e.$sp=y;class E{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((w,P)=>this.a.set(P,w)),$.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$tp=E}),define(ie[89],ne([8,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ie[49],ne([0,1,90,9,16,3,24,89]),function(J,e,N,D,R,L,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.zip=e.$Op=e.$Np=void 0,e.$Np="end of central directory record signature not found";const h=new RegExp(e.$Np);class a extends Error{constructor(g,i){let r=i.message;switch(g){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=g,this.cause=i}}e.$Op=a;function y(u){const g=u.externalFileAttributes>>16||33188;return[448,56,7].map(i=>g&i).reduce((i,r)=>i+r,g&61440)}function E(u){if(u instanceof a)return u;let g;return h.test(u.message)&&(g="CorruptZip"),new a(g,u)}function d(u,g,i,r,t,n){const s=R.$mc(g),o=R.$jc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(k.localize(0,null,g)));const l=R.$jc(r,g);let O;return n.onCancellationRequested(()=>{O?.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((I,v)=>{if(!n.isCancellationRequested)try{O=(0,N.createWriteStream)(l,{mode:i}),O.once("close",()=>I()),O.once("error",v),u.once("error",v),u.pipe(O)}catch(j){v(j)}}))}function $(u,g,i,r){let t=(0,D.$Ug)(()=>Promise.resolve()),n=0;const s=r.onCancellationRequested(()=>{t.cancel(),u.close()});return new Promise((o,l)=>{const O=new D.$3g,I=v=>{v.isCancellationRequested||(n++,u.readEntry())};u.once("error",l),u.once("close",()=>t.then(()=>{r.isCancellationRequested||u.entryCount===n?o():l(new a("Incomplete",new Error(k.localize(1,null,n,u.entryCount))))},l)),u.readEntry(),u.on("entry",v=>{if(r.isCancellationRequested)return;if(!i.sourcePathRegex.test(v.fileName)){I(r);return}const j=v.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(j)){const Y=R.$jc(g,j);t=(0,D.$Ug)(oe=>A.Promises.mkdir(Y,{recursive:!0}).then(()=>I(oe)).then(void 0,l));return}const q=P(u,v),Q=y(v);t=(0,D.$Ug)(Y=>O.queue(()=>q.then(oe=>d(oe,j,Q,g,i,Y).then(()=>I(Y)))).then(null,l))})}).finally(()=>s.dispose())}async function w(u,g=!1){const{open:i}=await new Promise((r,t)=>{J(["yauzl"],r,t)});return new Promise((r,t)=>{i(u,g?{lazyEntries:!0}:void 0,(n,s)=>{n?t(E(n)):r((0,L.$Uf)(s))})})}function P(u,g){return new Promise((i,r)=>{u.openReadStream(g,(t,n)=>{t?r(E(t)):i((0,L.$Uf)(n))})})}async function b(u,g){const{ZipFile:i}=await new Promise((r,t)=>{J(["yazl"],r,t)});return new Promise((r,t)=>{const n=new i;g.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const s=(0,N.createWriteStream)(u);n.outputStream.pipe(s),n.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(u))})}e.zip=b;function c(u,g,i={},r){const t=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let n=w(u,!0);return i.overwrite&&(n=n.then(s=>A.Promises.rm(g).then(()=>s))),n.then(s=>$(s,g,{sourcePathRegex:t},r))}e.$Qp=c;function p(u,g){return w(u).then(i=>new Promise((r,t)=>{i.on("entry",n=>{n.fileName===g&&P(i,n).then(s=>r(s),s=>t(s))}),i.once("close",()=>t(new Error(k.localize(2,null,g))))}))}function m(u,g){return p(u,g).then(i=>new Promise((r,t)=>{const n=[];i.once("error",t),i.on("data",s=>n.push(s)),i.on("end",()=>r(Buffer.concat(n)))}))}e.$Rp=m}),define(ie[91],ne([8,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[92],ne([8,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[93],ne([8,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ie[94],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ie[95],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[96],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ie[97],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[98],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[99],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ie[100],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ie[101],ne([8,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[102],ne([8,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ie[103],ne([8,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ie[104],ne([8,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[105],ne([8,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ie[106],ne([8,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ie[107],ne([8,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ie[108],ne([8,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[109],ne([8,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[110],ne([8,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ie[111],ne([0,1,7,93]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.TokenType=void 0;var R;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(R||(e.TokenType=R={}));function L(...a){switch(a.length){case 1:return(0,D.localize)(0,null,a[0]);case 2:return(0,D.localize)(1,null,a[0],a[1]);case 3:return(0,D.localize)(2,null,a[0],a[1],a[2]);default:return}}const A=(0,D.localize)(3,null),k=(0,D.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,N.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const E=this.d,d=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:d};this.g.push({offset:E,lexeme:d,additionalInfo:y}),this.f.push($)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const E=this.c.substring(this.d,this.e),d=h.b.get(E);d?this.k(d):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,E=!1,d=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(k);return}const w=this.c.charCodeAt(y);if(E)E=!1;else if(w===47&&!d){y++;break}else w===91?d=!0:w===92?E=!0:w===93&&(d=!1);y++}for(;y<this.c.length&&h.a.has(this.c.charCodeAt(y));)y++;this.e=y;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$3i=h}),define(ie[112],ne([0,1,78,53,15,16,35,17,11]),function(J,e,N,D,R,L,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=void 0,e.$Am=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,L.$mc)(R.$pg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,L.$jc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,k.$Ig)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$Ig)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,N.$zm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$jc)(this.userDataPath,"logs",$)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$Ig)(h.URI.file((0,L.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$Ig)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$Ig)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$Ig)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=A.env.VSCODE_PORTABLE;return $?h.URI.file((0,L.$jc)($,"argv.json")):(0,k.$Ig)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,L.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,L.$kc)($):(0,L.$hc)((0,L.$jc)(R.$pg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?h.URI.file((0,L.$kc)($)):h.URI.file((0,L.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,L.$kc)($);const w=A.env.VSCODE_EXTENSIONS;if(w)return w;const P=A.env.VSCODE_PORTABLE;return P?(0,L.$jc)(P,"extensions"):(0,k.$Ig)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(w=>/^[^:/?#]+?:\/\//.test(w)?h.URI.parse(w):h.URI.file((0,L.$hc)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?h.URI.parse($):h.URI.file((0,L.$hc)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$Am.test($))}get extensionLogLevel(){const $=[];for(const w of this.args.log||[]){const P=e.$Am.exec(w);P&&P[1]&&P[2]&&$.push([P[1],P[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,k.$Ig)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=A.env.VSCODE_PORTABLE;return $?h.URI.file((0,L.$jc)($,"policy.json")):(0,k.$Ig)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,w,P){this.a=$,this.b=w,this.c=P,this.editSessionId=this.args.editSessionId}}e.$Bm=a,$e([D.$zh],a.prototype,"appRoot",null),$e([D.$zh],a.prototype,"userHome",null),$e([D.$zh],a.prototype,"userDataPath",null),$e([D.$zh],a.prototype,"appSettingsHome",null),$e([D.$zh],a.prototype,"tmpDir",null),$e([D.$zh],a.prototype,"cacheHome",null),$e([D.$zh],a.prototype,"stateResource",null),$e([D.$zh],a.prototype,"userRoamingDataHome",null),$e([D.$zh],a.prototype,"userDataSyncHome",null),$e([D.$zh],a.prototype,"sync",null),$e([D.$zh],a.prototype,"machineSettingsResource",null),$e([D.$zh],a.prototype,"workspaceStorageHome",null),$e([D.$zh],a.prototype,"localHistoryHome",null),$e([D.$zh],a.prototype,"keyboardLayoutResource",null),$e([D.$zh],a.prototype,"argvResource",null),$e([D.$zh],a.prototype,"isExtensionDevelopment",null),$e([D.$zh],a.prototype,"untitledWorkspacesHome",null),$e([D.$zh],a.prototype,"builtinExtensionsPath",null),$e([D.$zh],a.prototype,"extensionsPath",null),$e([D.$zh],a.prototype,"extensionDevelopmentLocationURI",null),$e([D.$zh],a.prototype,"extensionDevelopmentKind",null),$e([D.$zh],a.prototype,"extensionTestsLocationURI",null),$e([D.$zh],a.prototype,"debugExtensionHost",null),$e([D.$zh],a.prototype,"logLevel",null),$e([D.$zh],a.prototype,"extensionLogLevel",null),$e([D.$zh],a.prototype,"serviceMachineIdResource",null),$e([D.$zh],a.prototype,"disableTelemetry",null),$e([D.$zh],a.prototype,"disableWorkspaceTrust",null),$e([D.$zh],a.prototype,"useInMemorySecretStorage",null),$e([D.$zh],a.prototype,"policyFile",null);function y(d,$){return E(d["inspect-extensions"],d["inspect-brk-extensions"],5870,$,d.debugId,d.extensionEnvironment)}e.$Cm=y;function E(d,$,w,P,b,c){const m=Number($||d)||(P?null:w),u=m?!!$:!1;let g;if(c)try{g=JSON.parse(c)}catch{}return{port:m,break:u,debugId:b,env:g}}e.$Dm=E}),function(){"use strict";function J(e,N,D){function R(A,k){const h=L(A,k),a=[h];return e.isAbsolute(h)||a.unshift(D),e.resolve(...a)}function L(A,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,k);const y=A["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(E,"AppData","Roaming")}break;case"darwin":a=e.join(N.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(N.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,k)}return{getUserDataPath:R}}if(typeof define=="function")define(ie[113],ne([167,33,35]),function(e,N,D){return J(e,N,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),N=require("os");module.exports=J(e,N,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[114],ne([0,1,33,112,113]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=void 0;class L extends D.$Bm{constructor(a,y){super(a,{homeDir:(0,N.homedir)(),tmpDir:(0,N.tmpdir)(),userDataDir:(0,R.getUserDataPath)(a,y.nameShort)},y)}}e.$Em=L;function A(h,a){return(0,D.$Dm)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,a,h.extensionEnvironment)}e.$Fm=A;function k(h,a){return(0,D.$Dm)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,a,h.extensionEnvironment)}e.$Gm=k}),define(ie[115],ne([0,1,3,97]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;function R(A,k,h,a){try{L(A,k,h,a)}catch(y){A.error(y?.message??y)}return k}e.$1p=R;function L(A,k,h,a){const y=(E,d,$)=>{const w=E[d];if((0,N.$Jf)(w)){const P=w,b=P.length;if(b>1&&P[0]==="%"&&P[b-1]==="%"){const c=P.substr(1,b-2);let p=h[c];p===void 0&&a&&(p=a[c]);const m=typeof p=="string"?p:p?.message,u=a?.[c],g=typeof u=="string"?u:u?.message;if(!m){g||A.warn(`[${k.name}]: ${(0,D.localize)(0,null,c)}`);return}if($&&(d==="title"||d==="category")&&g&&g!==m){const i={value:m,original:g};E[d]=i}else E[d]=m}}else if((0,N.$Lf)(w))for(const P in w)w.hasOwnProperty(P)&&(P==="commands"?y(w,P,!0):y(w,P,$));else if(Array.isArray(w))for(let P=0;P<w.length;P++)y(w,P,$)};for(const E in k)k.hasOwnProperty(E)&&y(k,E)}}),define(ie[116],ne([0,1,49,100]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;function R(L){return(0,N.$Rp)(L,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$9p=R}),define(ie[50],ne([0,1,17,54,101,44]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function h(c){return c=c.trim(),c==="*"||A.test(c)}e.$cp=h;function a(c){if(!h(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=c.match(A);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.$dp=a;function y(c){if(!c)return null;const p=c.majorBase,m=c.majorMustEqual,u=c.minorBase;let g=c.minorMustEqual;const i=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&(p===0||(g=!1),r=!1);let t=0;if(c.preRelease){const n=k.exec(c.preRelease);if(n){const[,s,o,l]=n;t=Date.UTC(Number(s),Number(o)-1,Number(l))}}return{majorBase:p,majorMustEqual:m,minorBase:u,minorMustEqual:g,patchBase:i,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:t}}e.$ep=y;function E(c,p,m){let u;typeof c=="string"?u=y(a(c)):u=c;let g;p instanceof Date?g=p.getTime():typeof p=="string"&&(g=new Date(p).getTime());let i;if(typeof m=="string"?i=y(a(m)):i=m,!u||!i)return!1;const r=u.majorBase,t=u.minorBase,n=u.patchBase;let s=i.majorBase,o=i.minorBase,l=i.patchBase;const O=i.notBefore;let I=i.majorMustEqual,v=i.minorMustEqual,j=i.patchMustEqual;return i.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||g&&g<O?!1:n>=l:(r===1&&s===0&&(!I||!v||!j)&&(s=1,o=0,l=0,I=!0,v=!1,j=!1),r<s?!1:r>s?!I:t<o?!1:t>o?!v:n<l?!1:n>l?!j:!(g&&g<O))}e.$fp=E;function d(c,p,m,u,g){const i=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return i.push([D.default.Error,R.localize(0,null)]),i;if(typeof u.name!="string")return i.push([D.default.Error,R.localize(1,null,"name")]),i;if(typeof u.version!="string")return i.push([D.default.Error,R.localize(2,null,"version")]),i;if(!u.engines)return i.push([D.default.Error,R.localize(3,null,"engines")]),i;if(typeof u.engines.vscode!="string")return i.push([D.default.Error,R.localize(4,null,"engines.vscode")]),i;if(typeof u.extensionDependencies<"u"&&!b(u.extensionDependencies))return i.push([D.default.Error,R.localize(5,null,"extensionDependencies")]),i;if(typeof u.activationEvents<"u"){if(!b(u.activationEvents))return i.push([D.default.Error,R.localize(6,null,"activationEvents")]),i;if(typeof u.main>"u"&&typeof u.browser>"u")return i.push([D.default.Error,R.localize(7,null,"activationEvents","main","browser")]),i}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&i.push([D.default.Warning,R.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return i.push([D.default.Error,R.localize(9,null,"main")]),i;{const n=(0,N.$Ig)(m,u.main);(0,N.$Cg)(n,m)||i.push([D.default.Warning,R.localize(10,null,n.path,m.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return i.push([D.default.Error,R.localize(11,null,"browser")]),i;{const n=(0,N.$Ig)(m,u.browser);(0,N.$Cg)(n,m)||i.push([D.default.Warning,R.localize(12,null,n.path,m.path)])}}if(!L.valid(u.version))return i.push([D.default.Error,R.localize(13,null)]),i;const r=[];if(!$(c,p,u,g,r))for(const n of r)i.push([D.default.Error,n]);return i}e.$gp=d;function $(c,p,m,u,g){return u||typeof m.main>"u"&&typeof m.browser>"u"?!0:P(c,p,m.engines.vscode,g)}e.$hp=$;function w(c,p,m){return c==="*"||P(p,m,c)}e.$ip=w;function P(c,p,m,u=[]){const g=y(a(m));if(!g)return u.push(R.localize(14,null,m)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return u.push(R.localize(15,null,m)),!1}else if(!g.majorMustEqual)return u.push(R.localize(16,null,m)),!1;return E(c,p,g)?!0:(u.push(R.localize(17,null,c,m)),!1)}function b(c){if(!Array.isArray(c))return!1;for(let p=0,m=c.length;p<m;p++)if(typeof c[p]!="string")return!1;return!0}}),define(ie[117],ne([0,1,14,28]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;async function R(L,A,k){let h=k&&k.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const y=(await A.readFile(L.serviceMachineIdResource)).value.toString();h=(0,D.$qg)(y)?y:null}catch{h=null}if(!h){h=(0,D.$rg)();try{await A.writeFile(L.serviceMachineIdResource,N.$ke.fromString(h))}catch{}}return k?.store("storage.serviceMachineId",h,-1,1),h}e.$Cp=R}),define(ie[51],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=void 0;class N{constructor(R,L=[],A=!1){this.ctor=R,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$5h=N}),define(ie[118],ne([0,1,51]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.InstantiationType=void 0;const D=[];var R;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function L(k,h,a){h instanceof N.$5h||(h=new N.$5h(h,[],!!a)),D.push([k,h])}e.$1r=L;function A(){return D}e.$2r=A}),define(ie[119],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;class N{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Eq=N;class D{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const k=this.lookupOrInsertNode(L),h=this.lookupOrInsertNode(A);k.outgoing.set(h.key,h),h.incoming.set(k.key,k)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const k of this.a.values())k.outgoing.delete(A),k.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let k=this.a.get(A);return k||(k=new N(A,L),this.a.set(A,k)),k}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,k]of this.a)L.push(`${A}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const k=new Set([L]),h=this.c(A,k);if(h)return h}}c(L,A){for(const[k,h]of L.outgoing){if(A.has(k))return[...A,k].join(" -> ");A.add(k);const a=this.c(h,A);if(a)return a;A.delete(k)}}}e.$Fq=D}),define(ie[29],ne([0,1,3,11,10]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.ConfigurationTarget=e.$Di=e.$Ci=e.$Bi=void 0,e.$Bi=(0,R.$8h)("configurationService");function L(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof D.URI)}e.$Ci=L;function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof D.URI)}e.$Di=A;var k;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function h(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ei=h;function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$Fi=a;function y(c,p){const m=Object.create(null);for(const u in c)E(m,u,c[u],p);return m}e.$Gi=y;function E(c,p,m,u){const g=p.split("."),i=g.pop();let r=c;for(let t=0;t<g.length;t++){const n=g[t];let s=r[n];switch(typeof s){case"undefined":s=r[n]=Object.create(null);break;case"object":break;default:u(`Ignoring ${p} as ${g.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[i]=m}catch{u(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(r)}`)}else u(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(r)}`)}e.$Hi=E;function d(c,p){const m=p.split(".");$(c,m)}e.$Ii=d;function $(c,p){const m=p.shift();if(p.length===0){delete c[m];return}if(Object.keys(c).indexOf(m)!==-1){const u=c[m];typeof u=="object"&&!Array.isArray(u)&&($(u,p),Object.keys(u).length===0&&delete c[m])}}function w(c,p,m){function u(r,t){let n=r;for(const s of t){if(typeof n!="object"||n===null)return;n=n[s]}return n}const g=p.split("."),i=u(c,g);return typeof i>"u"?m:i}e.$Ji=w;function P(c,p,m){Object.keys(p).forEach(u=>{u!=="__proto__"&&(u in c?N.$Lf(c[u])&&N.$Lf(p[u])?P(c[u],p[u],m):m&&(c[u]=p[u]):c[u]=p[u])})}e.$Ki=P;function b(c){return c.replace(/[\[\]]/g,"")}e.$Li=b}),define(ie[120],ne([0,1,12,30,111,10,92,7]),function(J,e,N,D,R,L,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.ContextKeyExprType=e.$4i=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",N.$j),h.set("isLinux",N.$k),h.set("isWindows",N.$i),h.set("isWeb",N.$o),h.set("isMacNative",N.$j&&!N.$o),h.set("isEdge",N.$H),h.set("isFirefox",N.$F),h.set("isChrome",N.$E),h.set("isSafari",N.$G);function a(C,f){if(h.get(C)!==void 0)throw(0,k.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(C,f)}e.$4i=a;const y=Object.prototype.hasOwnProperty;var E;(function(C){C[C.False=0]="False",C[C.True=1]="True",C[C.Defined=2]="Defined",C[C.Not=3]="Not",C[C.Equals=4]="Equals",C[C.NotEquals=5]="NotEquals",C[C.And=6]="And",C[C.Regex=7]="Regex",C[C.NotRegex=8]="NotRegex",C[C.Or=9]="Or",C[C.In=10]="In",C[C.NotIn=11]="NotIn",C[C.Greater=12]="Greater",C[C.GreaterEquals=13]="GreaterEquals",C[C.Smaller=14]="Smaller",C[C.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const d={regexParsingWithErrorRecovery:!0},$=(0,A.localize)(0,null),w=(0,A.localize)(1,null),P=(0,A.localize)(2,null),b=(0,A.localize)(3,null),c=(0,A.localize)(4,null),p=(0,A.localize)(5,null),m=(0,A.localize)(6,null),u=(0,A.localize)(7,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(f=d){this.k=f,this.d=new R.$3i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(f){if(f===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:w});return}this.f=this.d.reset(f).scan(),this.g=0,this.h=[];try{const S=this.l();if(!this.E()){const z=this.D(),U=z.type===17?p:void 0;throw this.h.push({message:c,offset:z.offset,lexeme:R.$3i.getLexeme(z),additionalInfo:U}),g.c}return S}catch(S){if(S!==g.c)throw S;return}}l(){return this.m()}m(){const f=[this.o()];for(;this.y(16);){const S=this.o();f.push(S)}return f.length===1?f[0]:i.or(...f)}o(){const f=[this.s()];for(;this.y(15);){const S=this.s();f.push(S)}return f.length===1?f[0]:i.and(...f)}s(){if(this.y(2)){const f=this.D();switch(f.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const S=this.l();return this.A(1,b),S?.negate()}case 17:return this.z(),q.create(f.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",f)}}return this.t()}t(){const f=this.D();switch(f.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const S=this.l();return this.A(1,b),S}case 17:{const S=f.lexeme;if(this.z(),this.y(9)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==10)throw this.B("REGEX",U);const H=U.lexeme,G=H.lastIndexOf("/"),te=G===H.length-1?void 0:this.w(H.substring(G+1));let le;try{le=new RegExp(H.substring(1,G),te)}catch{throw this.B("REGEX",U)}return de.create(S,le)}switch(U.type){case 10:case 19:{const H=[U.lexeme];this.z();let G=this.D(),te=0;for(let fe=0;fe<U.lexeme.length;fe++)U.lexeme.charCodeAt(fe)===40?te++:U.lexeme.charCodeAt(fe)===41&&te--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let fe=0;fe<G.lexeme.length;fe++)G.lexeme.charCodeAt(fe)===40?te++:U.lexeme.charCodeAt(fe)===41&&te--}if(te<0)break;H.push(R.$3i.getLexeme(G)),this.z(),G=this.D()}const le=H.join(""),ue=le.lastIndexOf("/"),me=ue===le.length-1?void 0:this.w(le.substring(ue+1));let we;try{we=new RegExp(le.substring(1,ue),me)}catch{throw this.B("REGEX",U)}return i.regex(S,we)}case 18:{const H=U.lexeme;this.z();let G=null;if(!(0,D.$Ke)(H)){const te=H.indexOf("/"),le=H.lastIndexOf("/");if(te!==le&&te>=0){const ue=H.slice(te+1,le),me=H[le+1]==="i"?"i":"";try{G=new RegExp(ue,me)}catch{throw this.B("REGEX",U)}}}if(G===null)throw this.B("REGEX",U);return de.create(S,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,P);const U=this.u();return i.notIn(S,U)}switch(this.D().type){case 3:{this.z();const U=this.u();if(this.x().type===18)return i.equals(S,U);switch(U){case"true":return i.has(S);case"false":return i.not(S);default:return i.equals(S,U)}}case 4:{this.z();const U=this.u();if(this.x().type===18)return i.notEquals(S,U);switch(U){case"true":return i.not(S);case"false":return i.has(S);default:return i.notEquals(S,U)}}case 5:return this.z(),re.create(S,this.u());case 6:return this.z(),he.create(S,this.u());case 7:return this.z(),Y.create(S,this.u());case 8:return this.z(),oe.create(S,this.u());case 13:return this.z(),i.in(S,this.u());default:return i.has(S)}}case 20:throw this.h.push({message:m,offset:f.offset,lexeme:"",additionalInfo:u}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const f=this.D();switch(f.type){case 17:case 18:return this.z(),f.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(f){return f.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(f){return this.C(f)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(f,S){if(this.C(f))return this.z();throw this.B(S,this.D())}B(f,S,z){const U=(0,A.localize)(8,null,f,R.$3i.getLexeme(S)),H=S.offset,G=R.$3i.getLexeme(S);return this.h.push({message:U,offset:H,lexeme:G,additionalInfo:z}),g.c}C(f){return this.D().type===f}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$5i=g;class i{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(f){return l.create(f)}static equals(f,S){return O.create(f,S)}static notEquals(f,S){return j.create(f,S)}static regex(f,S){return de.create(f,S)}static in(f,S){return I.create(f,S)}static notIn(f,S){return v.create(f,S)}static not(f){return q.create(f)}static and(...f){return X.create(f,null,!0)}static or(...f){return M.create(f,null,!0)}static greater(f,S){return Y.create(f,S)}static greaterEquals(f,S){return oe.create(f,S)}static smaller(f,S){return re.create(f,S)}static smallerEquals(f,S){return he.create(f,S)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(f){return f==null?void 0:this.c.parse(f)}}e.$6i=i;function r(C){const f=new g({regexParsingWithErrorRecovery:!1});return C.map(S=>(f.parse(S),f.lexingErrors.length>0?f.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,A.localize)(9,null,z.additionalInfo):(0,A.localize)(10,null),offset:z.offset,length:z.lexeme.length})):f.parsingErrors.length>0?f.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$7i=r;function t(C,f){const S=C?C.substituteConstants():void 0,z=f?f.substituteConstants():void 0;return!S&&!z?!0:!S||!z?!1:S.equals(z)}e.$8i=t;function n(C,f){return C.cmp(f)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return o.INSTANCE}}e.$9i=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return s.INSTANCE}}e.$0i=o;class l{static create(f,S=null){const z=h.get(f);return typeof z=="boolean"?z?o.INSTANCE:s.INSTANCE:new l(f,S)}constructor(f,S){this.key=f,this.c=S,this.type=2}cmp(f){return f.type!==this.type?this.type-f.type:W(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}substituteConstants(){const f=h.get(this.key);return typeof f=="boolean"?f?o.INSTANCE:s.INSTANCE:this}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return this.c||(this.c=q.create(this.key,this)),this.c}}e.$$i=l;class O{static create(f,S,z=null){if(typeof S=="boolean")return S?l.create(f,z):q.create(f,z);const U=h.get(f);return typeof U=="boolean"?S===(U?"true":"false")?o.INSTANCE:s.INSTANCE:new O(f,S,z)}constructor(f,S,z){this.c=f,this.d=S,this.f=z,this.type=4}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=h.get(this.c);if(typeof f=="boolean"){const S=f?"true":"false";return this.d===S?o.INSTANCE:s.INSTANCE}return this}evaluate(f){return f.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(f){return f.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$_i=O;class I{static create(f,S){return new I(f,S)}constructor(f,S){this.d=f,this.f=S,this.type=10,this.c=null}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.d,this.f,f.d,f.f)}equals(f){return f.type===this.type?this.d===f.d&&this.f===f.f:!1}substituteConstants(){return this}evaluate(f){const S=f.getValue(this.f),z=f.getValue(this.d);return Array.isArray(S)?S.includes(z):typeof z=="string"&&typeof S=="object"&&S!==null?y.call(S,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(f){return f.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$aj=I;class v{static create(f,S){return new v(f,S)}constructor(f,S){this.d=f,this.f=S,this.type=11,this.c=I.create(f,S)}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(f){return f.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$bj=v;class j{static create(f,S,z=null){if(typeof S=="boolean")return S?q.create(f,z):l.create(f,z);const U=h.get(f);return typeof U=="boolean"?S===(U?"true":"false")?s.INSTANCE:o.INSTANCE:new j(f,S,z)}constructor(f,S,z){this.c=f,this.d=S,this.f=z,this.type=5}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=h.get(this.c);if(typeof f=="boolean"){const S=f?"true":"false";return this.d===S?s.INSTANCE:o.INSTANCE}return this}evaluate(f){return f.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(f){return f.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$cj=j;class q{static create(f,S=null){const z=h.get(f);return typeof z=="boolean"?z?s.INSTANCE:o.INSTANCE:new q(f,S)}constructor(f,S){this.c=f,this.d=S,this.type=3}cmp(f){return f.type!==this.type?this.type-f.type:W(this.c,f.c)}equals(f){return f.type===this.type?this.c===f.c:!1}substituteConstants(){const f=h.get(this.c);return typeof f=="boolean"?f?s.INSTANCE:o.INSTANCE:this}evaluate(f){return!f.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(f){return f.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$dj=q;function Q(C,f){if(typeof C=="string"){const S=parseFloat(C);isNaN(S)||(C=S)}return typeof C=="string"||typeof C=="number"?f(C):s.INSTANCE}class Y{static create(f,S,z=null){return Q(S,U=>new Y(f,U,z))}constructor(f,S,z){this.c=f,this.d=S,this.f=z,this.type=12}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=he.create(this.c,this.d,this)),this.f}}e.$ej=Y;class oe{static create(f,S,z=null){return Q(S,U=>new oe(f,U,z))}constructor(f,S,z){this.c=f,this.d=S,this.f=z,this.type=13}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$fj=oe;class re{static create(f,S,z=null){return Q(S,U=>new re(f,U,z))}constructor(f,S,z){this.c=f,this.d=S,this.f=z,this.type=14}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.$gj=re;class he{static create(f,S,z=null){return Q(S,U=>new he(f,U,z))}constructor(f,S,z){this.c=f,this.d=S,this.f=z,this.type=15}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$hj=he;class de{static create(f,S){return new de(f,S)}constructor(f,S){this.d=f,this.f=S,this.type=7,this.c=null}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.d<f.d)return-1;if(this.d>f.d)return 1;const S=this.f?this.f.source:"",z=f.f?f.f.source:"";return S<z?-1:S>z?1:0}equals(f){if(f.type===this.type){const S=this.f?this.f.source:"",z=f.f?f.f.source:"";return this.d===f.d&&S===z}return!1}substituteConstants(){return this}evaluate(f){const S=f.getValue(this.d);return this.f?this.f.test(S):!1}serialize(){const f=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${f}`}keys(){return[this.d]}map(f){return f.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$ij=de;class ae{static create(f){return new ae(f)}constructor(f){this.c=f,this.type=8}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(f){return new ae(this.c.map(f))}negate(){return this.c}}e.$jj=ae;function B(C){let f=null;for(let S=0,z=C.length;S<z;S++){const U=C[S].substituteConstants();if(C[S]!==U&&f===null){f=[];for(let H=0;H<S;H++)f[H]=C[H]}f!==null&&(f[S]=U)}return f===null?C:f}class X{static create(f,S,z){return X.d(f,S,z)}constructor(f,S){this.expr=f,this.c=S,this.type=6}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let S=0,z=this.expr.length;S<z;S++){const U=n(this.expr[S],f.expr[S]);if(U!==0)return U}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let S=0,z=this.expr.length;S<z;S++)if(!this.expr[S].equals(f.expr[S]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:X.create(f,this.c,!1)}evaluate(f){for(let S=0,z=this.expr.length;S<z;S++)if(!this.expr[S].evaluate(f))return!1;return!0}static d(f,S,z){const U=[];let H=!1;for(const G of f)if(G){if(G.type===1){H=!0;continue}if(G.type===0)return s.INSTANCE;if(G.type===6){U.push(...G.expr);continue}U.push(G)}if(U.length===0&&H)return o.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(n);for(let G=1;G<U.length;G++)U[G-1].equals(U[G])&&(U.splice(G,1),G--);if(U.length===1)return U[0];for(;U.length>1;){const G=U[U.length-1];if(G.type!==9)break;U.pop();const te=U.pop(),le=U.length===0,ue=M.create(G.expr.map(me=>X.create([me,te],null,z)),null,le);ue&&(U.push(ue),U.sort(n))}if(U.length===1)return U[0];if(z){for(let G=0;G<U.length;G++)for(let te=G+1;te<U.length;te++)if(U[G].negate().equals(U[te]))return s.INSTANCE;if(U.length===1)return U[0]}return new X(U,S)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(const S of this.expr)f.push(...S.keys());return f}map(f){return new X(this.expr.map(S=>S.map(f)),null)}negate(){if(!this.c){const f=[];for(const S of this.expr)f.push(S.negate());this.c=M.create(f,this,!0)}return this.c}}e.$kj=X;class M{static create(f,S,z){return M.d(f,S,z)}constructor(f,S){this.expr=f,this.c=S,this.type=9}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let S=0,z=this.expr.length;S<z;S++){const U=n(this.expr[S],f.expr[S]);if(U!==0)return U}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let S=0,z=this.expr.length;S<z;S++)if(!this.expr[S].equals(f.expr[S]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:M.create(f,this.c,!1)}evaluate(f){for(let S=0,z=this.expr.length;S<z;S++)if(this.expr[S].evaluate(f))return!0;return!1}static d(f,S,z){let U=[],H=!1;if(f){for(let G=0,te=f.length;G<te;G++){const le=f[G];if(le){if(le.type===0){H=!0;continue}if(le.type===1)return o.INSTANCE;if(le.type===9){U=U.concat(le.expr);continue}U.push(le)}}if(U.length===0&&H)return s.INSTANCE;U.sort(n)}if(U.length!==0){if(U.length===1)return U[0];for(let G=1;G<U.length;G++)U[G-1].equals(U[G])&&(U.splice(G,1),G--);if(U.length===1)return U[0];if(z){for(let G=0;G<U.length;G++)for(let te=G+1;te<U.length;te++)if(U[G].negate().equals(U[te]))return o.INSTANCE;if(U.length===1)return U[0]}return new M(U,S)}}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(const S of this.expr)f.push(...S.keys());return f}map(f){return new M(this.expr.map(S=>S.map(f)),null)}negate(){if(!this.c){const f=[];for(const S of this.expr)f.push(S.negate());for(;f.length>1;){const S=f.shift(),z=f.shift(),U=[];for(const H of F(S))for(const G of F(z))U.push(X.create([H,G],null,!1));f.unshift(M.create(U,null,!1))}this.c=M.create(f,this,!0)}return this.c}}e.$lj=M;class T extends l{static{this.d=[]}static all(){return T.d.values()}constructor(f,S,z){super(f,null),this.f=S,typeof z=="object"?T.d.push({...z,key:f}):z!==!0&&T.d.push({key:f,description:z,type:S!=null?typeof S:void 0})}bindTo(f){return f.createKey(this.key,this.f)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(f){return O.create(this.key,f)}notEqualsTo(f){return j.create(this.key,f)}}e.$mj=T,e.$nj=(0,L.$8h)("contextKeyService");function W(C,f){return C<f?-1:C>f?1:0}function Z(C,f,S,z){return C<S?-1:C>S?1:f<z?-1:f>z?1:0}function K(C,f){if(C.type===0||f.type===1)return!0;if(C.type===9)return f.type===9?_(C.expr,f.expr):!1;if(f.type===9){for(const S of f.expr)if(K(C,S))return!0;return!1}if(C.type===6){if(f.type===6)return _(f.expr,C.expr);for(const S of C.expr)if(K(S,f))return!0;return!1}return C.equals(f)}e.$oj=K;function _(C,f){let S=0,z=0;for(;S<C.length&&z<f.length;){const U=C[S].cmp(f[z]);if(U<0)return!1;U===0&&S++,z++}return S===C.length}function F(C){return C.type===9?C.expr:[C]}}),define(ie[59],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=void 0,e.$go=(0,N.$8h)("downloadService")}),define(ie[18],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=void 0,e.$ci=(0,N.$8h)("environmentService"),e.$di=(0,N.$9h)(e.$ci)}),define(ie[21],ne([0,1,95,10]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ExtensionGalleryErrorCode=e.$Co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0,e.$po="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$qo=new RegExp(e.$po),e.$ro="__web_extension",e.$so="skipWalkthrough",e.$to="extensionsSync",e.$uo="dependecyOrPackExtensionInstall";function R(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$vo=R;function L(m){switch(m){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$wo=L;function A(m,u){switch(m){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$xo=A;function k(m,u){return u==="web"&&!m.includes("web")}e.$yo=k;function h(m,u,g){return k(u,g)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===g}e.$zo=h;function a(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.$Ao=a;var y;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var E;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var d;(function(m){m.Install="install",m.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var $;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$Bo=(0,D.$8h)("extensionGalleryService");var w;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.DownloadSignature="DownloadSignature",m.UpdateMetadata="UpdateMetadata",m.Extract="Extract",m.Scanning="Scanning",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Signature="Signature",m.NotAllowed="NotAllowed",m.Gallery="Gallery",m.Unknown="Unknown",m.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var P;(function(m){m.UnknownError="UnknownError",m.PackageIsInvalidZip="PackageIsInvalidZip",m.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(P||(e.ExtensionSignaturetErrorCode=P={}));class b extends Error{constructor(u,g){super(u),this.code=g,this.name=g}}e.$Co=b;var c;(function(m){m.Timeout="Timeout",m.Cancelled="Cancelled",m.Failed="Failed"})(c||(e.ExtensionGalleryErrorCode=c={}));class p extends Error{constructor(u,g){super(u),this.code=g,this.name=g}}e.$Do=p,e.$Eo=(0,D.$8h)("extensionManagementService"),e.$Fo="extensionsIdentifiers/disabled",e.$Go="extensionsIdentifiers/enabled",e.$Ho=(0,D.$8h)("IGlobalExtensionEnablementService"),e.$Io=(0,D.$8h)("IExtensionTipsService"),e.$Jo=(0,N.localize2)(0,"Extensions"),e.$Ko=(0,N.localize2)(1,"Preferences")}),define(ie[60],ne([0,1,14,7,103,13]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;async function A(y,E,d,$,w,P){let b;try{await k(y,E,d,$,w,P)}catch(c){b=c}finally{b&&w.errorTransformer&&(b=w.errorTransformer(b)),typeof b<"u"&&d.error(b),d.end()}}e.$dq=A;async function k(y,E,d,$,w,P){h(P);const b=await y.open(E,{create:!1});try{h(P);let c=0,p=0,m=w&&typeof w.length=="number"?w.length:void 0,u=N.$ke.alloc(Math.min(w.bufferSize,typeof m=="number"?m:w.bufferSize)),g=w&&typeof w.position=="number"?w.position:0,i=0;do p=await y.read(b,g,u.buffer,i,u.byteLength-i),g+=p,i+=p,c+=p,typeof m=="number"&&(m-=p),i===u.byteLength&&(await d.write($(u)),u=N.$ke.alloc(Math.min(w.bufferSize,typeof m=="number"?m:w.bufferSize)),i=0);while(p>0&&(typeof m!="number"||m>0)&&h(P)&&a(c,w));if(i>0){let r=i;typeof m=="number"&&(r=Math.min(i,m)),d.write($(u.slice(0,r)))}}catch(c){throw(0,L.$Gk)(c)}finally{await y.close(b)}}function h(y){if(y.isCancellationRequested)throw(0,D.$6)();return!0}function a(y,E){if(typeof E?.limits?.size=="number"&&y>E.limits.size)throw(0,L.$Fk)((0,R.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ie[121],ne([0,1,6,168,2,12,169]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class k extends R.$Tc{constructor(){super(...arguments),this.a=this.B(new N.$Wd),this.onDidChangeFile=this.a.event,this.b=this.B(new N.$Wd),this.onDidLogMessage=this.b.event,this.onDidError=N.Event.None,this.c=new Map,this.f=!1}async watch(a){const y=this.j(a),E=y.filter($=>{const w=this.c.get($.path);return w?!(0,D.$Sj)(w.request.excludes,$.excludes)||!(0,D.$Sj)(w.request.includes,$.includes):!0}),d=Array.from(this.c.values()).filter(({request:$})=>!y.find(w=>w.path===$.path&&(0,D.$Sj)(w.excludes,$.excludes)&&(0,D.$Sj)(w.includes,$.includes))).map(({request:$})=>$.path);E.length&&this.m(`Request to start watching: ${E.map($=>`${$.path} (excludes: ${$.excludes.length>0?$.excludes:"<none>"}, includes: ${$.includes&&$.includes.length>0?JSON.stringify($.includes):"<all>"}, correlationId: ${typeof $.correlationId=="number"?$.correlationId:"<none>"})`).join(",")}`),d.length&&this.m(`Request to stop watching: ${d.join(",")}`);for(const $ of d)this.h($);for(const $ of E)this.g($)}g(a){const y=new A.$zq(a,d=>this.a.fire(d),d=>this.b.fire(d),this.f),E={request:a,instance:y};this.c.set(a.path,E)}async stop(){for(const[a]of this.c)this.h(a);this.c.clear()}h(a){const y=this.c.get(a);y&&(this.c.delete(a),y.instance.dispose())}j(a){const y=new Map;for(const E of a){const d=L.$k?E.path:E.path.toLowerCase();let $=y.get(E.correlationId);$||($=new Map,y.set(E.correlationId,$)),$.set(d,E)}return Array.from(y.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(a){this.f=a;for(const[,y]of this.c)y.instance.setVerboseLogging(a)}m(a){this.f&&this.b.fire({type:"trace",message:this.n(a)})}n(a,y){return y?`[File Watcher (node.js)] ${a} (path: ${y.request.path})`:`[File Watcher (node.js)] ${a}`}}e.$Bq=k}),define(ie[122],ne([0,1,61,121]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class R extends N.$hq{constructor(A,k,h){super(A,k,h),this.s()}r(A){return A.add(new D.$Bq)}}e.$Cq=R}),define(ie[123],ne([0,1,15,57,87,61]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;class A extends L.$iq{constructor(h,a,y){super(h,a,y),this.s()}r(h){const a=h.add(new R.$tq(N.$pg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(a.onDidProcessExit(({code:y,signal:E})=>this.t(`terminated by itself with code ${y}, signal: ${E}`))),D.ProxyChannel.toService((0,D.$Oh)(a.getChannel("watcher")))}}e.$uq=A}),define(ie[62],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=void 0;class N{constructor(...R){this.a=new Map;for(const[L,A]of R)this.set(L,A)}set(R,L){const A=this.a.get(R);return this.a.set(R,L),A}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$6h=N}),define(ie[124],ne([0,1,9,7,2,51,119,10,62,170]),function(J,e,N,D,R,L,A,k,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;const y=!1;class E extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class d{constructor(b=new h.$6h,c=!1,p,m=y){this.f=b,this.g=c,this.h=p,this.i=m,this.o=new Set,this.f.set(k.$7h,this),this._globalGraph=m?p?._globalGraph??new A.$Fq(u=>u):void 0}createChild(b){return new d(b,this.g,this,this.i)}invokeFunction(b,...c){const p=w.traceInvocation(this.i,b);let m=!1;try{return b({get:g=>{if(m)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(g,p);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...c)}finally{m=!0,p.stop()}}createInstance(b,...c){let p,m;return b instanceof L.$5h?(p=w.traceCreation(this.i,b.ctor),m=this.j(b.ctor,b.staticArguments.concat(c),p)):(p=w.traceCreation(this.i,b),m=this.j(b,c,p)),p.stop(),m}j(b,c=[],p){const m=k._util.getServiceDependencies(b).sort((i,r)=>i.index-r.index),u=[];for(const i of m){const r=this.m(i.id,p);r||this.u(`[createInstance] ${b.name} depends on UNKNOWN service ${i.id}.`,!1),u.push(r)}const g=m.length>0?m[0].index:c.length;if(c.length!==g){console.trace(`[createInstance] First service dependency of ${b.name} at position ${g+1} conflicts with ${c.length} static arguments`);const i=g-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,g)}return Reflect.construct(b,c.concat(u))}k(b,c){if(this.f.get(b)instanceof L.$5h)this.f.set(b,c);else if(this.h)this.h.k(b,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(b){const c=this.f.get(b);return!c&&this.h?this.h.l(b):c}m(b,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const p=this.l(b);return p instanceof L.$5h?this.q(b,p,c.branch(b,!0)):(c.branch(b,!1),p)}q(b,c,p){if(this.o.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.o.add(b);try{return this.r(b,c,p)}finally{this.o.delete(b)}}r(b,c,p){const m=new A.$Fq(i=>i.id.toString());let u=0;const g=[{id:b,desc:c,_trace:p}];for(;g.length;){const i=g.pop();if(m.lookupOrInsertNode(i),u++>1e3)throw new E(m);for(const r of k._util.getServiceDependencies(i.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${b} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),t instanceof L.$5h){const n={id:r.id,desc:t,_trace:i._trace.branch(r.id,!0)};m.insertEdge(i,n),g.push(n)}}}for(;;){const i=m.roots();if(i.length===0){if(!m.isEmpty())throw new E(m);break}for(const{data:r}of i){if(this.l(r.id)instanceof L.$5h){const n=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,n)}m.removeNode(r)}}return this.l(b)}s(b,c,p=[],m,u){if(this.f.get(b)instanceof L.$5h)return this.t(b,c,p,m,u);if(this.h)return this.h.s(b,c,p,m,u);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(b,c,p=[],m,u){if(m){const g=new d(void 0,this.g,this,this.i);g.c=String(b);const i=new Map,r=new N.$oh(()=>{const t=g.j(c,p,u);for(const[n,s]of i){const o=t[n];if(typeof o=="function")for(const l of s)l.disposable=o.apply(t,l.listener)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let l=i.get(n);return l||(l=new a.$4c,i.set(n,l)),(I,v,j)=>{if(r.isInitialized)return r.value[n](I,v,j);{const q={listener:[I,v,j],disposable:void 0},Q=l.push(q);return(0,R.$Rc)(()=>{Q(),q.disposable?.dispose()})}}}if(n in t)return t[n];const s=r.value;let o=s[n];return typeof o!="function"||(o=o.bind(s),t[n]=o),o},set(t,n,s){return r.value[n]=s,!0},getPrototypeOf(t){return c.prototype}})}else return this.j(c,p,u)}u(b,c){if(c&&console.warn(b),this.g)throw new Error(b)}}e.$Gq=d;var $;(function(P){P[P.None=0]="None",P[P.Creation=1]="Creation",P[P.Invocation=2]="Invocation",P[P.Branch=3]="Branch"})($||($={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(b,c){return b?new w(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(b,c){return b?new w(1,c.name):w.c}static{this.f=0}constructor(b,c){this.type=b,this.name=c,this.g=Date.now(),this.h=[]}branch(b,c){const p=new w(3,b.toString());return this.h.push([b,c,p]),p}stop(){const b=Date.now()-this.g;w.f+=b;let c=!1;function p(u,g){const i=[],r=new Array(u+1).join("	");for(const[t,n,s]of g.h)if(n&&s){c=!0,i.push(`${r}CREATES -> ${t}`);const o=p(u+1,s);o&&i.push(o)}else i.push(`${r}uses -> ${t}`);return i.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(b>2||c)&&w.all.add(m.join(`
`))}}e.$Hq=w});var se=this&&this.__param||function(J,e){return function(N,D){e(N,D,J)}};define(ie[63],ne([0,1,20,2,12,105,21,10]),function(J,e,N,D,R,L,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=e.$ir=void 0;function h(y){return y.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$ir=h,e.$jr=(0,k.$8h)("languagePackService");let a=class extends D.$Tc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new N.$7d;setTimeout(()=>E.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const w=d.firstPage.filter(P=>P.properties.localizedLanguages?.length&&P.tags.some(b=>b.startsWith("lp-"))).map(P=>{const b=P.properties.localizedLanguages?.[0],c=h(P);return{...this.f(c,b,P),extensionId:P.identifier.id,galleryExtension:P}});return w.push(this.f("en","English")),w}f(E,d,$){const w=d??E;let P;if(w!==E&&(P=`(${E})`),E.toLowerCase()===R.$w.toLowerCase()&&(P??="",P+=(0,L.localize)(0,null)),$?.installCount){P??="";const b=$.installCount;let c;b>1e6?c=`${Math.floor(b/1e5)/10}M`:b>1e3?c=`${Math.floor(b/1e3)}K`:c=String(b),P+=` $(cloud-download) ${c}`}return{id:E,label:w,description:P}}};e.$kr=a,e.$kr=a=$e([se(0,A.$Bo)],a)}),define(ie[4],ne([0,1,34,6,43,2,31,12,17,3,11,120,10]),function(J,e,N,D,R,L,A,k,h,a,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.log=e.$sj=e.LogLevel=e.$rj=e.$qj=e.$pj=void 0,e.$pj=(0,d.$8h)("logService"),e.$qj=(0,d.$8h)("loggerService");function $(){return new Date().toISOString()}function w(I){return(0,a.$Nf)(I)}e.$rj=w;var P;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(P||(e.LogLevel=P={})),e.$sj=P.Info;function b(I,v,j){switch(v){case P.Trace:I.trace(j);break;case P.Debug:I.debug(j);break;case P.Info:I.info(j);break;case P.Warning:I.warn(j);break;case P.Error:I.error(j);break;case P.Off:break;default:throw new Error(`Invalid log level ${v}`)}}e.log=b;function c(I,v=!1){let j="";for(let q=0;q<I.length;q++){let Q=I[q];if(Q instanceof Error&&(Q=(0,N.$Si)(Q,v)),typeof Q=="object")try{Q=JSON.stringify(Q)}catch{}j+=(q>0?" ":"")+Q}return j}class p extends L.$Tc{constructor(){super(...arguments),this.b=e.$sj,this.c=this.B(new D.$Wd),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==P.Off&&this.b<=v}}e.$uj=p;class m extends p{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...j){this.f(P.Trace)&&this.g(P.Trace,c([v,...j],!0))}debug(v,...j){this.f(P.Debug)&&this.g(P.Debug,c([v,...j]))}info(v,...j){this.f(P.Info)&&this.g(P.Info,c([v,...j]))}warn(v,...j){this.f(P.Warning)&&this.g(P.Warning,c([v,...j]))}error(v,...j){if(this.f(P.Error))if(v instanceof Error){const q=Array.prototype.slice.call(arguments);q[0]=v.stack,this.g(P.Error,c(q))}else this.g(P.Error,c([v,...j]))}flush(){}}e.$vj=m;class u extends p{constructor(v=e.$sj){super(),this.setLevel(v),this.g=!k.$i}trace(v,...j){this.f(P.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,v,...j):console.log(`[main ${$()}]`,v,...j))}debug(v,...j){this.f(P.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,v,...j):console.log(`[main ${$()}]`,v,...j))}info(v,...j){this.f(P.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,v,...j):console.log(`[main ${$()}]`,v,...j))}warn(v,...j){this.f(P.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,v,...j):console.warn(`[main ${$()}]`,v,...j))}error(v,...j){this.f(P.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,v,...j):console.error(`[main ${$()}]`,v,...j))}flush(){}}e.$wj=u;class g extends p{constructor(v=e.$sj,j=!0){super(),this.g=j,this.setLevel(v)}trace(v,...j){this.f(P.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...j):console.log(v,...j))}debug(v,...j){this.f(P.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...j):console.log(v,...j))}info(v,...j){this.f(P.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...j):console.log(v,...j))}warn(v,...j){this.f(P.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...j):console.log(v,...j))}error(v,...j){this.f(P.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...j):console.error(v,...j))}flush(){}}e.$xj=g;class i extends p{constructor(v,j=e.$sj){super(),this.g=v,this.setLevel(j)}trace(v,...j){this.f(P.Trace)&&this.g.log(P.Trace,[this.h(v),...j])}debug(v,...j){this.f(P.Debug)&&this.g.log(P.Debug,[this.h(v),...j])}info(v,...j){this.f(P.Info)&&this.g.log(P.Info,[this.h(v),...j])}warn(v,...j){this.f(P.Warning)&&this.g.log(P.Warning,[this.h(v),...j])}error(v,...j){this.f(P.Error)&&this.g.log(P.Error,[this.h(v),...j])}h(v){return typeof v=="string"?v:(0,N.$Si)(v,this.f(P.Trace))}flush(){}}e.$yj=i;class r extends p{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const j of this.g)j.setLevel(v);super.setLevel(v)}trace(v,...j){for(const q of this.g)q.trace(v,...j)}debug(v,...j){for(const q of this.g)q.debug(v,...j)}info(v,...j){for(const q of this.g)q.info(v,...j)}warn(v,...j){for(const q of this.g)q.warn(v,...j)}error(v,...j){for(const q of this.g)q.error(v,...j)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$zj=r;class t extends L.$Tc{constructor(v,j,q){if(super(),this.h=v,this.j=j,this.b=new A.$Ac,this.c=this.B(new D.$Wd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$Wd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$Wd),this.onDidChangeVisibility=this.g.event,q)for(const Q of q)this.b.set(Q.resource,{logger:void 0,info:Q})}m(v){return(0,a.$Jf)(v)?[...this.b.values()].find(j=>j.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,j){const q=this.n(v),Q=(0,a.$Jf)(v)?v:j?.id??(0,R.$Vi)(q.toString()).toString(16);let Y=this.b.get(q)?.logger;const oe=j?.logLevel==="always"?P.Trace:j?.logLevel;Y||(Y=this.s(q,oe??this.getLogLevel(q)??this.h,{...j,id:Q}));const re={logger:Y,info:{resource:q,id:Q,logLevel:oe,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(re.info),this.b.set(q,re),Y}n(v){return(0,a.$Jf)(v)?(0,h.$Ig)(this.j,`${v}.log`):v}setLogLevel(v,j){if(y.URI.isUri(v)){const q=v,Q=j,Y=this.b.get(q);Y&&Q!==Y.info.logLevel&&(Y.info.logLevel=Q===this.h?void 0:Q,Y.logger?.setLevel(Q),this.b.set(Y.info.resource,Y),this.f.fire([q,Q]))}else{this.h=v;for(const[q,Q]of this.b.entries())this.b.get(q)?.info.logLevel===void 0&&Q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,j){const q=this.m(v);q&&j!==!q.info.hidden&&(q.info.hidden=!j,this.b.set(q.info.resource,q),this.g.fire([q.info.resource,j]))}getLogLevel(v){let j;return v&&(j=this.b.get(v)?.info.logLevel),j??this.h}registerLogger(v){const j=this.b.get(v.resource);j?j.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const j=this.b.get(v);j&&(j.logger&&j.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Aj=t;class n{constructor(){this.onDidChangeLogLevel=new D.$Wd().event}setLevel(v){}getLevel(){return P.Info}trace(v,...j){}debug(v,...j){}info(v,...j){}warn(v,...j){}error(v,...j){}critical(v,...j){}dispose(){}flush(){}}e.$Bj=n;class s extends n{}e.$Cj=s;function o(I){if(I.verbose)return P.Trace;if(typeof I.logLevel=="string"){const v=O(I.logLevel.toLowerCase());if(v!==void 0)return v}return e.$sj}e.$Dj=o;function l(I){switch(I){case P.Trace:return"trace";case P.Debug:return"debug";case P.Info:return"info";case P.Warning:return"warn";case P.Error:return"error";case P.Off:return"off"}}e.$Ej=l;function O(I){switch(I){case"trace":return P.Trace;case"debug":return P.Debug;case"info":return P.Info;case"warn":return P.Warning;case"error":return P.Error;case"critical":return P.Error;case"off":return P.Off}}e.$Fj=O,e.$Gj=new E.$mj("logLevel",l(P.Info))}),define(ie[64],ne([0,1,7,10,4]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=void 0,e.$Hp=(0,D.$8h)("IExtensionSignatureVerificationService");let L=class{constructor(k){this.b=k}c(){return this.a||(this.a=new Promise((k,h)=>J(["node-vsce-sign"],async a=>k(a),h))),this.a}async verify(k,h,a){let y;try{y=await this.c()}catch(E){return this.b.error("Could not load vsce-sign module",(0,N.$0)(E)),!1}return y.verify(k,h,a)}};e.$Ip=L,e.$Ip=L=$e([se(0,R.$pj)],L)}),define(ie[125],ne([0,1,19,9,7,6,2,16,61,4]),function(J,e,N,D,R,L,A,k,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class y extends A.$Tc{constructor(d,$){super(),this.a=d,this.b=$,this.c=this.B(new L.$Wd),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Wd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$6g(0)),this.w=[],this.y=this.B(new D.$6g(0))}watch(d,$){return $.recursive||this.b?.watcher?.forceUniversal?this.n(d,$):this.z(d,$)}n(d,$){const w={path:this.H(d),excludes:$.excludes,includes:$.includes,recursive:$.recursive,correlationId:$.correlationId},P=(0,N.$Ub)(this.j,w);return this.r(),(0,A.$Rc)(()=>{P(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,R.$1)(d))}s(){this.h||(this.h=this.B(this.t($=>this.c.fire((0,h.$jq)($)),$=>this.G($),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const $ of this.j)(0,h.$fq)($)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const $ of this.j)(0,h.$fq)($)&&d.includes($.path)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,$){const w={path:this.H(d),excludes:$.excludes,includes:$.includes,recursive:!1,correlationId:$.correlationId},P=(0,N.$Ub)(this.w,w);return this.C(),(0,A.$Rc)(()=>{P(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,R.$1)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,h.$jq)(d)),d=>this.G(d),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,k.$hc)(d.fsPath)}}e.$nq=y}),define(ie[126],ne([0,1,19,9,14,20,6,43,65,2,48,15,127,17,46,102,13,60,4,7]),function(J,e,N,D,R,L,A,k,h,a,y,E,d,$,w,P,b,c,p,m){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;let g=class extends a.$Tc{static{u=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new A.$Wd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$Wd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$Wd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$Wd),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$Wd),this.Y=this.B(new A.$Wd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$Wd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$eh)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${r}`);const n=new a.$Sc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),n.add(t.onDidChangeFile(s=>{const o=new b.$Lk(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),n.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Rc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Oc)(n)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(n){t.push(n)}}),!this.h.has(r)&&await D.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const n=this.h.get(r.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return h.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,$.$Mg)(r))throw new b.$Nk((0,P.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const n=new m.$bb;throw n.message=(0,P.localize)(1,null,r.toString()),n}return t}async m(r){const t=await this.j(r);if((0,b.$yk)(t)||(0,b.$vk)(t)||(0,b.$zk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,b.$yk)(t)||(0,b.$vk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(n){throw(0,b.$Ik)(n)===b.FileSystemProviderErrorCode.FileNotFound?new b.$Nk((0,P.localize)(2,null,this.sb(r)),1):(0,b.$Gk)(n)}}async s(r,t){const n=await this.j(r),s=this.S(n),o=t?.resolveTo,l=t?.resolveSingleChildDescendants,O=t?.resolveMetadata,I=await n.stat(r);let v;return this.t(n,r,I,void 0,!!O,(j,q)=>(v||(v=y.$bi.forUris(()=>!s),v.set(r,!0),o&&v.fill(!0,o)),v.get(j.resource)||v.findSuperstr(j.resource.with({query:null,fragment:null}))?!0:j.isDirectory&&l?q===1:!1))}async t(r,t,n,s,o,l){const{providerExtUri:O}=this.R(r),I={resource:t,name:O.basename(t),isFile:(n.type&b.FileType.File)!==0,isDirectory:(n.type&b.FileType.Directory)!==0,isSymbolicLink:(n.type&b.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&b.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((n.permissions??0)&b.FilePermission.Locked),etag:(0,b.$Yk)({mtime:n.mtime,size:n.size}),children:void 0};if(I.isDirectory&&l(I,s)){try{const v=await r.readdir(t),j=await D.Promises.settled(v.map(async([q,Q])=>{try{const Y=O.joinPath(t,q),oe=o?await r.stat(Y):{type:Q};return await this.t(r,Y,oe,v.length,o,l)}catch(Y){return this.b.trace(Y),null}}));I.children=(0,N.$Hb)(j)}catch(v){this.b.trace(v),I.children=[]}return I}return I}async resolveAll(r){return D.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),n=await t.stat(r);return this.t(t,r,n,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(n){return n}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new b.$Nk((0,P.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=R.$ke.fromString(""),n){await this.u(r,n);const s=await this.writeFile(r,t);return this.r.fire(new b.$Kk(r,0,s)),s}async writeFile(r,t,n){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let l=n;if((0,b.$Bk)(s)&&!l?.atomic){const O=s.enforceAtomicWriteFile?.(r);O&&(l={...n,atomic:O})}try{await this.w(s,r,l)||await this.U(s,o.dirname(r));let I;if((0,b.$vk)(s)&&!(t instanceof R.$ke))if((0,w.$9d)(t)){const v=await(0,w.$de)(t,3);v.ended?I=R.$ke.concat(v.buffer):I=v}else I=(0,w.$ae)(t,v=>R.$ke.concat(v),3);else I=t;!(0,b.$yk)(s)||(0,b.$vk)(s)&&I instanceof R.$ke||(0,b.$vk)(s)&&(0,b.$Bk)(s)&&l?.atomic?await this.hb(s,r,l,I):await this.db(s,r,l,I instanceof R.$ke?(0,R.$ve)(I):I),this.r.fire(new b.$Kk(r,4))}catch(O){throw new b.$Nk((0,P.localize)(4,null,this.sb(r),(0,b.$Gk)(O).toString()),(0,b.$Jk)(O),l)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,n){const s=!!n?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,P.localize)(5,null,this.sb(t)));if(!!n?.atomic){if(!(r.capabilities&32768))throw new Error((0,P.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,P.localize)(7,null,this.sb(t)));if(s)throw new Error((0,P.localize)(8,null,this.sb(t)))}let l;try{l=await r.stat(t)}catch{return}if(l.type&b.FileType.Directory)throw new b.$Nk((0,P.localize)(9,null,this.sb(t)),0,n);if(this.rb(t,l),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==b.$Xk&&typeof l.mtime=="number"&&typeof l.size=="number"&&n.mtime<l.mtime&&n.etag!==(0,b.$Yk)({mtime:n.mtime,size:l.size}))throw new b.$Nk((0,P.localize)(10,null),3,n);return l}async readFile(r,t,n){const s=await this.m(r);return t?.atomic?this.z(s,r,t,n):this.C(s,r,t,n)}async z(r,t,n,s){return new Promise((o,l)=>{this.cb.queueFor(t,async()=>{try{const O=await this.C(r,t,n,s);o(O)}catch(O){l(O)}},this.R(r).providerExtUri)})}async C(r,t,n,s){const o=await this.D(r,t,{...n,preferUnbuffered:!0},s);return{...o,value:await(0,R.$we)(o.value)}}async readFileStream(r,t,n){const s=await this.m(r);return this.D(s,r,t,n)}async D(r,t,n,s){const o=new L.$7d(s);let l=n;(0,b.$Ak)(r)&&r.enforceAtomicReadFile?.(t)&&(l={...n,atomic:!0});const O=this.J(t,l).then(v=>v,v=>{throw o.dispose(!0),v});let I;try{return typeof l?.etag=="string"&&l.etag!==b.$Xk&&await O,l?.atomic&&(0,b.$Ak)(r)||!((0,b.$yk)(r)||(0,b.$zk)(r))||(0,b.$vk)(r)&&l?.preferUnbuffered?I=this.I(r,t,l):(0,b.$zk)(r)?I=this.G(r,t,o.token,l):I=this.H(r,t,o.token,l),I.on("end",()=>o.dispose()),I.on("error",()=>o.dispose()),{...await O,value:I}}catch(v){throw I&&await(0,w.$be)(I),this.F(v,t,l)}}F(r,t,n){const s=(0,P.localize)(11,null,this.sb(t),(0,b.$Gk)(r).toString());return r instanceof b.$Pk?new b.$Pk(s,r.stat,n):r instanceof b.$Ok?new b.$Ok(s,r.fileOperationResult,r.size,r.options):new b.$Nk(s,(0,b.$Jk)(r),n)}G(r,t,n,s=Object.create(null)){const o=r.readFileStream(t,s,n);return(0,w.$he)(o,{data:l=>l instanceof R.$ke?l:R.$ke.wrap(l),error:l=>this.F(l,t,s)},l=>R.$ke.concat(l))}H(r,t,n,s=Object.create(null)){const o=(0,R.$Ae)();return(0,c.$dq)(r,t,o,l=>l,{...s,bufferSize:this.a,errorTransformer:l=>this.F(l,t,s)},n),o}I(r,t,n){const s=(0,w.$$d)(o=>R.$ke.concat(o));return(async()=>{try{let o;n?.atomic&&(0,b.$Ak)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.L(t,o.byteLength,n),s.end(R.$ke.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const n=await this.resolve(r,{resolveMetadata:!0});if(n.isDirectory)throw new b.$Nk((0,P.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==b.$Xk&&t.etag===n.etag)throw new b.$Pk((0,P.localize)(13,null),n,t);return this.L(r,n.size,t),n}L(r,t,n){if(typeof n?.limits?.size=="number"&&t>n.limits.size)throw new b.$Ok((0,P.localize)(14,null,this.sb(r)),7,t,n)}async canMove(r,t,n){return this.M(r,t,"move",n)}async canCopy(r,t,n){return this.M(r,t,"copy",n)}async M(r,t,n,s){if(r.toString()!==t.toString())try{const o=n==="move"?this.qb(await this.n(r),r):await this.m(r),l=this.qb(await this.n(t),t);await this.Q(o,r,l,t,n,s)}catch(o){return o}return!0}async move(r,t,n){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"move",!!n),O=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new b.$Kk(r,l==="move"?2:3,O)),O}async copy(r,t,n){const s=await this.m(r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"copy",!!n),O=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new b.$Kk(r,l==="copy"?3:2,O)),O}async N(r,t,n,s,o,l){if(t.toString()===s.toString())return o;const{exists:O,isSameResourceWithDifferentPathCase:I}=await this.Q(r,t,n,s,o,l);if(O&&!I&&l&&await this.del(s,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(s)),o==="copy"){if(r===n&&(0,b.$wk)(r))await r.copy(t,s,{overwrite:l});else{const v=await this.resolve(t);v.isDirectory?await this.P(r,v,n,s):await this.O(r,t,n,s)}return o}else return r===n?(await r.rename(t,s,{overwrite:l}),o):(await this.N(r,t,n,s,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(r,t,n,s){if((0,b.$yk)(r)&&(0,b.$yk)(n))return this.jb(r,t,n,s);if((0,b.$yk)(r)&&(0,b.$vk)(n))return this.pb(r,t,n,s);if((0,b.$vk)(r)&&(0,b.$yk)(n))return this.nb(r,t,n,s);if((0,b.$vk)(r)&&(0,b.$vk)(n))return this.lb(r,t,n,s)}async P(r,t,n,s){await n.mkdir(s),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async o=>{const l=this.R(n).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),n,l):this.O(r,o.resource,n,l)}))}async Q(r,t,n,s,o,l){let O=!1;if(r===n){const{providerExtUri:v,isPathCaseSensitive:j}=this.R(r);if(j||(O=v.isEqual(t,s)),O&&o==="copy")throw new Error((0,P.localize)(15,null,this.sb(t),this.sb(s)));if(!O&&v.isEqualOrParent(s,t))throw new Error((0,P.localize)(16,null,this.sb(t),this.sb(s)))}const I=await this.exists(s);if(I&&!O){if(!l)throw new b.$Nk((0,P.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===n){const{providerExtUri:v}=this.R(r);if(v.isEqualOrParent(t,s))throw new Error((0,P.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:I,isSameResourceWithDifferentPathCase:O}}R(r){const t=this.S(r);return{providerExtUri:t?$.$yg:$.$Ag,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const n=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$Kk(r,0,n)),n}async U(r,t){const n=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&b.FileType.Directory))throw new Error((0,P.localize)(19,null,this.sb(t)));break}catch(o){if((0,b.$Ik)(o)!==b.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(t)),t=s.dirname(t)}for(let o=n.length-1;o>=0;o--){t=s.joinPath(t,n[o]);try{await r.mkdir(t)}catch(l){if((0,b.$Ik)(l)!==b.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(r,t){try{await this.W(r,t)}catch(n){return n}return!0}async W(r,t){const n=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,P.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,P.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,P.localize)(22,null,this.sb(r)));let l;try{l=await n.stat(r)}catch{}if(l)this.rb(r,l);else throw new b.$Nk((0,P.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const I=await this.resolve(r);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,P.localize)(24,null,this.sb(r)))}return n}async del(r,t){const n=await this.W(r,t);let s=t;if((0,b.$Ck)(n)&&!s?.atomic){const I=n.enforceAtomicDelete?.(r);I&&(s={...t,atomic:I})}const o=!!s?.useTrash,l=!!s?.recursive,O=s?.atomic??!1;await n.delete(r,{recursive:l,useTrash:o,atomic:O}),this.r.fire(new b.$Kk(r,1))}async cloneFile(r,t){const n=await this.j(r),s=this.qb(await this.n(t),t);if(!(n===s&&this.R(n).providerExtUri.isEqual(r,t)))return n===s&&(0,b.$xk)(n)?n.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),n===s&&(0,b.$wk)(n)?this.cb.queueFor(r,()=>n.copy(r,t,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(r,()=>this.O(n,r,s,t),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:u.ab++})}watch(r,t={recursive:!1,excludes:[]}){const n=new a.$Sc;let s=!1,o=()=>{s=!0};n.add((0,a.$Rc)(()=>o())),(async()=>{try{const O=await this.bb(r,t);s?(0,a.$Oc)(O):o=()=>(0,a.$Oc)(O)}catch(O){this.b.error(O)}})();const l=t.correlationId;if(typeof l=="number"){const O=n.add(new A.$Wd);return n.add(this.X.event(v=>{v.correlates(l)&&O.fire(v)})),{onDidChange:O.event,dispose:()=>n.dispose()}}return n}async bb(r,t){const n=await this.j(r),s=(0,k.$Vi)([this.R(n).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:n.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Rc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Oc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Oc)(r.disposable);this.$.clear()}async db(r,t,n,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,w.$9d)(s)||(0,w.$0d)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(l){throw(0,b.$Gk)(l)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,n){let s=0,o;if((0,w.$0d)(n)){if(n.buffer.length>0){const l=R.$ke.concat(n.buffer);await this.gb(r,t,l,l.byteLength,s,0),s+=l.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((l,O)=>{(0,w.$ce)(o,{onData:async I=>{o.pause();try{await this.gb(r,t,I,I.byteLength,s,0)}catch(v){return O(v)}s+=I.byteLength,setTimeout(()=>o.resume())},onError:I=>O(I),onEnd:()=>l()})})}async fb(r,t,n){let s=0,o;for(;(o=n.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,n,s,o,l){let O=0;for(;O<s;){const I=await r.write(t,o+O,n.buffer,l+O,s-O);O+=I}}async hb(r,t,n,s){return this.cb.queueFor(t,()=>this.ib(r,t,n,s),this.R(r).providerExtUri)}async ib(r,t,n,s){let o;s instanceof R.$ke?o=s:(0,w.$9d)(s)?o=await(0,R.$we)(s):(0,w.$0d)(s)?o=await(0,R.$xe)(s):o=(0,R.$ue)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(r,t,n,s){return this.cb.queueFor(s,()=>this.kb(r,t,n,s),this.R(n).providerExtUri)}async kb(r,t,n,s){let o,l;try{o=await r.open(t,{create:!1}),l=await n.open(s,{create:!0,unlock:!1});const O=R.$ke.alloc(this.a);let I=0,v=0,j=0;do j=await r.read(o,I,O.buffer,v,O.byteLength-v),await this.gb(n,l,O,j,I,v),I+=j,v+=j,v===O.byteLength&&(v=0);while(j>0)}catch(O){throw(0,b.$Gk)(O)}finally{await D.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof l=="number"?n.close(l):Promise.resolve()])}}async lb(r,t,n,s){return this.cb.queueFor(s,()=>this.mb(r,t,n,s),this.R(n).providerExtUri)}async mb(r,t,n,s){return n.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,n,s){return this.cb.queueFor(s,()=>this.ob(r,t,n,s),this.R(n).providerExtUri)}async ob(r,t,n,s){const o=await n.open(s,{create:!0,unlock:!1});try{const l=await r.readFile(t);await this.gb(n,o,R.$ke.wrap(l),l.byteLength,0,0)}catch(l){throw(0,b.$Gk)(l)}finally{await n.close(o)}}async pb(r,t,n,s){const o=await(0,R.$we)(this.H(r,t,L.CancellationToken.None));await this.hb(n,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new b.$Nk((0,P.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&b.FilePermission.Readonly)throw new b.$Nk((0,P.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===E.Schemas.file?r.fsPath:r.toString(!0)}};e.$eq=g,e.$eq=g=u=$e([se(0,p.$pj)],g)}),define(ie[128],ne([0,1,90,171,9,31,14,6,172,2,16,12,17,46,24,104,13,60,125,34,123,122]),function(J,e,N,D,R,L,A,k,h,a,y,E,d,$,w,P,b,c,p,m,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0,(()=>{try{(0,D.gracefulify)(N)}catch(r){console.error(`Error enabling graceful-fs: ${(0,m.$Si)(r)}`)}})();class i extends p.$nq{static{this.I=!1}constructor(t,n){super(t,n),this.onDidChangeCapabilities=k.Event.None,this.N=new L.$Ac(s=>d.$zg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$k&&(this.J|=1024)),this.J}async stat(t){try{const{stat:n,symbolicLink:s}=await w.SymlinkSupport.stat(this.H(t));return{type:this.M(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:b.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const n=await w.Promises.readdir(this.H(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,d.$Ig)(t,o.name))).type:l=this.M(o),s.push([o.name,l])}catch(l){this.a.trace(l)}})),s}catch(n){throw this.fb(n)}}M(t,n){let s;return n?.dangling?s=b.FileType.Unknown:t.isFile()?s=b.FileType.File:t.isDirectory()?s=b.FileType.Directory:s=b.FileType.Unknown,n&&(s|=b.FileType.SymbolicLink),s}async O(t){const n=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const o=new R.$7g;return this.N.set(t,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,a.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(t)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),s=await this.O(t));const o=this.H(t);return await w.Promises.readFile(o)}catch(o){throw this.fb(o)}finally{s?.dispose()}}P(t){i.I&&this.a.trace(t)}readFileStream(t,n,s){const o=(0,$.$$d)(l=>A.$ke.concat(l.map(O=>A.$ke.wrap(O))).buffer);return(0,c.$dq)(this,t,o,l=>l.buffer,{...n,bufferSize:256*1024},s),o}async writeFile(t,n,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,d.$Ig)((0,d.$Hg)(t),`${(0,d.$Fg)(t)}${s.atomic.postfix}`),n,s):this.S(t,n,s)}async Q(t){try{const n=this.H(t),{symbolicLink:s}=await w.SymlinkSupport.stat(n);if(s)return!1}catch{}return!0}async R(t,n,s,o){const l=new a.$Sc;try{l.add(await this.O(t)),l.add(await this.O(n)),await this.S(n,s,o,!0);try{await this.rename(n,t,{overwrite:!0})}catch(O){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw O}}finally{l.dispose()}}async S(t,n,s,o){let l;try{const O=this.H(t);if(!s.create||!s.overwrite){if(await w.Promises.exists(O)){if(!s.overwrite)throw(0,b.$Fk)((0,P.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,b.$Fk)((0,P.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(l,0,n,0,n.byteLength)}catch(O){throw await this.gb(t,O)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){i.Y=t}async open(t,n,s){const o=this.H(t);let l;(0,b.$tk)(n)&&!s&&(l=await this.O(t));let O;try{if((0,b.$tk)(n)&&n.unlock)try{const{stat:v}=await w.SymlinkSupport.stat(o);v.mode&128||await w.Promises.chmod(o,v.mode|128)}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}let I;if((0,b.$tk)(n)){if(E.$i)try{await w.Promises.truncate(o,0),I="r+"}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}I||(I="w")}else I="r";O=await w.Promises.open(o,I)}catch(I){throw l?.dispose(),(0,b.$tk)(n)?await this.gb(t,I):this.fb(I)}if(this.U.set(O,0),(0,b.$tk)(n)&&this.X.set(O,t),l){const I=this.W.get(O);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${O} (${o})`),this.W.set(O,l),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${O} (${o})`),I.dispose())}return O}async close(t){const n=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&i.Y)try{await w.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await w.Promises.close(t)}catch(s){throw this.fb(s)}finally{n&&(this.W.get(t)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,o,l){const O=this.Z(t,n);let I=null;try{I=(await w.Promises.read(t,s,o,l,O)).bytesRead}catch(v){throw this.fb(v)}finally{this.$(t,O,I)}return I}Z(t,n){return n===this.U.get(t)?null:n}$(t,n,s){const o=this.U.get(t);typeof o=="number"&&(typeof n=="number"||(typeof s=="number"?this.U.set(t,o+s):this.U.delete(t)))}async write(t,n,s,o,l){return(0,R.$ph)(()=>this.ab(t,n,s,o,l),100,3)}async ab(t,n,s,o,l){const O=this.Z(t,n);let I=null;try{I=(await w.Promises.write(t,s,o,l,O)).bytesWritten}catch(v){throw await this.gb(this.X.get(t),v)}finally{this.$(t,O,I)}return I}async mkdir(t){try{await w.Promises.mkdir(this.H(t))}catch(n){throw this.fb(n)}}async delete(t,n){try{const s=this.H(t);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,y.$jc)((0,y.$mc)(s),`${(0,y.$nc)(s)}${n.atomic.postfix}`)),await w.Promises.rm(s,w.RimRafMode.MOVE,o)}else try{await w.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let l=!1;try{const{stat:O,symbolicLink:I}=await w.SymlinkSupport.stat(s);l=O.isDirectory()&&!I}catch{}if(l)await w.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.fb(s)}}async rename(t,n,s){const o=this.H(t),l=this.H(n);if(o!==l)try{await this.bb(t,n,"move",s.overwrite),await w.Promises.rename(o,l)}catch(O){throw(O.code==="EINVAL"||O.code==="EBUSY"||O.code==="ENAMETOOLONG")&&(O=new Error((0,P.localize)(2,null,(0,y.$nc)(o),(0,y.$nc)((0,y.$mc)(l)),O.toString()))),this.fb(O)}}async copy(t,n,s){const o=this.H(t),l=this.H(n);if(o!==l)try{await this.bb(t,n,"copy",s.overwrite),await w.Promises.copy(o,l,{preserveSymlinks:!0})}catch(O){throw(O.code==="EINVAL"||O.code==="EBUSY"||O.code==="ENAMETOOLONG")&&(O=new Error((0,P.localize)(3,null,(0,y.$nc)(o),(0,y.$nc)((0,y.$mc)(l)),O.toString()))),this.fb(O)}}async bb(t,n,s,o){const l=this.H(t),O=this.H(n);let I=!1;if(!!(this.capabilities&1024)||(I=(0,h.$8f)(l,O,!0)),I){if(s==="copy")throw(0,b.$Fk)((0,P.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const j=await this.L(t);if(!j)throw(0,b.$Fk)((0,P.localize)(5,null),b.FileSystemProviderErrorCode.FileNotFound);const q=await this.L(n);if(q){if(!o)throw(0,b.$Fk)((0,P.localize)(6,null),b.FileSystemProviderErrorCode.FileExists);j.type&b.FileType.File&&q.type&b.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,n){return this.cb(t,n,!1)}async cb(t,n,s){const o=this.H(t),l=this.H(n),O=!!(this.capabilities&1024);if((0,h.$8f)(o,l,!O))return;const I=new a.$Sc;try{I.add(await this.O(t)),I.add(await this.O(n)),s&&await w.Promises.mkdir((0,y.$mc)(l),{recursive:!0}),await w.Promises.copyFile(o,l)}catch(v){if(v.code==="ENOENT"&&!s)return this.cb(t,n,!0);throw this.fb(v)}finally{I.dispose()}}t(t,n,s){return new u.$uq(o=>t(o),o=>n(o),s)}F(t,n,s){return new g.$Cq(o=>t(o),o=>n(o),s)}fb(t){if(t instanceof b.$Ek)return t;let n=t,s;switch(t.code){case"ENOENT":s=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=b.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=b.FileSystemProviderErrorCode.Unknown;break;default:s=b.FileSystemProviderErrorCode.Unknown}return(0,b.$Fk)(n,s)}async gb(t,n){let s=this.fb(n);if(t&&s.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await w.SymlinkSupport.stat(this.H(t));o.mode&128||(s=(0,b.$Fk)(n,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$Dq=i}),define(ie[129],ne([0,1,2,4]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=void 0;class R extends N.$Tc{constructor(A,k=[]){super(),this.a=new D.$zj([A,...k]),this.B(A.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...k){this.a.trace(A,...k)}debug(A,...k){this.a.debug(A,...k)}info(A,...k){this.a.info(A,...k)}warn(A,...k){this.a.warn(A,...k)}error(A,...k){this.a.error(A,...k)}flush(){this.a.flush()}}e.$LO=R}),define(ie[130],ne([0,1,13,4]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AO=void 0;var R;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(R||(R={}));async function L(a,y,E,d,$){try{const w=await new Promise((b,c)=>{J(["@vscode/spdlog"],b,c)});w.setFlushOn(R.Trace);const P=await w.createAsyncRotatingLogger(a,y,E,d);return $?P.clearFormatters():P.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),P}catch(w){console.error(w)}return null}function A(a,y,E){switch(y){case D.LogLevel.Trace:a.trace(E);break;case D.LogLevel.Debug:a.debug(E);break;case D.LogLevel.Info:a.info(E);break;case D.LogLevel.Warning:a.warn(E);break;case D.LogLevel.Error:a.error(E);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function k(a,y){switch(y){case D.LogLevel.Trace:a.setLevel(R.Trace);break;case D.LogLevel.Debug:a.setLevel(R.Debug);break;case D.LogLevel.Info:a.setLevel(R.Info);break;case D.LogLevel.Warning:a.setLevel(R.Warning);break;case D.LogLevel.Error:a.setLevel(R.Error);break;case D.LogLevel.Off:a.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class h extends D.$vj{constructor(y,E,d,$,w){super(),this.m=[],this.setLevel(w),this.n=this.s(y,E,d,$),this.B(this.onDidChangeLogLevel(P=>{this.r&&k(this.r,P)}))}async s(y,E,d,$){const w=d?6:1,P=30/w*N.$1k.MB,b=await L(y,E,P,w,$);if(b){this.r=b,k(this.r,this.getLevel());for(const{level:c,message:p}of this.m)A(this.r,c,p);this.m=[]}}g(y,E){this.r?A(this.r,y,E):this.getLevel()<=y&&this.m.push({level:y,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$AO=h}),define(ie[131],ne([0,1,28,4,130]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=void 0;class L extends D.$Aj{s(k,h,a){return new R.$AO((0,N.$rg)(),k.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,h)}}e.$BO=L}),define(ie[39],ne([0,1,6,65,2,10]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=e.$Mn=void 0,e.$Mn=(0,L.$8h)("policy");class A extends R.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new N.$Wd),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const y=Object.keys(this.f).length;return this.f={...a,...this.f},y!==Object.keys(this.f).length&&await this.j(a),D.Iterable.reduce(this.g.entries(),(E,[d,$])=>({...E,[d]:$}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(a,[y,E])=>({...a,[y]:{definition:E,value:this.g.get(y)}}),{})}}e.$Nn=A;class k{constructor(){this.onDidChange=N.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$On=k}),define(ie[132],ne([0,1,9,6,65,3,13,4,39]),function(J,e,N,D,R,L,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z$b=void 0;function a(E,d){const $=[];for(const w of new Set(R.Iterable.concat(E.keys(),d.keys())))E.get(w)!==d.get(w)&&$.push(w);return $}let y=class extends h.$Nn{constructor(d,$,w){super(),this.m=d,this.n=$,this.s=w,this.c=this.B(new N.$6g(500));const P=D.Event.filter($.onDidFilesChange,b=>b.affects(d));this.B($.watch(d)),this.B(P(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const $=await this.n.readFile(this.m),w=JSON.parse($.value.toString());if(!(0,L.$Lf)(w))throw new Error("Policy file isn't a JSON object");for(const P of Object.keys(w))this.f[P]&&d.set(P,w[P])}catch($){$.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",$)}return d}async w(){const d=await this.u(),$=a(this.g,d);this.g=d,$.length>0&&this.h.fire($)}};e.$Z$b=y,e.$Z$b=y=$e([se(1,A.$sk),se(2,k.$pj)],y)}),define(ie[133],ne([0,1,39,9,2,4]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y$b=void 0;let A=class extends N.$Nn{constructor(h,a){super(),this.m=h,this.n=a,this.a=new D.$2g,this.b=this.B(new R.$Uc)}async j(h){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`);const{createWatcher:a}=await new Promise((y,E)=>{J(["@vscode/policy-watcher"],y,E)});await this.a.queue(()=>new Promise((y,E)=>{try{this.b.value=a(this.n,h,d=>{this.t(d),y()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),E(d)}}))}t(h){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const a in h){const y=h[a];y===void 0?this.g.delete(a):this.g.set(a,y)}this.h.fire(Object.keys(h))}};e.$Y$b=A,e.$Y$b=A=$e([se(0,L.$pj)],A)}),define(ie[32],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=void 0,e.$Hj=(0,N.$8h)("productService"),e.$Ij="vscode://schemas/vscode-product"}),define(ie[36],ne([0,1,71,3]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class R{constructor(){this.a=new Map}add(A,k){N.ok(D.$Jf(A)),N.ok(D.$Lf(k)),N.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,k)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Kn=new R}),define(ie[134],ne([0,1,6,36]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=void 0,e.$Ln={JSONContribution:"base.contributions.json"};function R(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class L{constructor(){this.b=new N.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,a){this.a[R(h)]=a,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;D.$Kn.add(e.$Ln.JSONContribution,A)}),define(ie[40],ne([0,1,19,6,3,91,29,134,36]),function(J,e,N,D,R,L,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.ConfigurationScope=e.$Pn=e.EditPresentationTypes=void 0;var a;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$Pn={Configuration:"base.contributions.configuration"};var y;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y||(e.ConfigurationScope=y={})),e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn={properties:{},patternProperties:{}},e.$Un={properties:{},patternProperties:{}},e.$Vn={properties:{},patternProperties:{}},e.$Wn="vscode://schemas/settings/resourceLanguage",e.$Xn="vscode://schemas/settings/configurationDefaults";const E=h.$Kn.as(k.$Ln.JSONContribution);class d{constructor(){this.h=new Set,this.i=new D.$Wd,this.onDidSchemaChange=this.i.event,this.j=new D.$Wd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$Wn,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const t=new Set;this.n(i,r,t),E.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const r=new Set;this.o(i,r),E.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const t=new Set;this.o(r,t),this.n(i,!1,t),E.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const t=[];for(const{overrides:n,source:s}of i)for(const o in n)if(r.add(o),e.$Zn.test(o)){const l=this.a.get(o),O=l?.valuesSources??new Map;if(s)for(const q of Object.keys(n[o]))O.set(q,s);const I={...l?.value||{},...n[o]};this.a.set(o,{source:s,value:I,valuesSources:O});const v=(0,A.$Li)(o),j={type:"object",default:I,description:L.localize(1,null,v),$ref:e.$Wn,defaultDefaultValue:I,source:R.$Jf(s)?void 0:s,defaultValueSource:s};t.push(...P(o)),this.d[o]=j,this.b.properties[o]=j}else{this.a.set(o,{value:n[o],source:s});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(t)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:t,source:n}of i)for(const s in t){const o=this.a.get(s),l=R.$Jf(n)?n:n?.id,O=R.$Jf(o?.source)?o?.source:o?.source?.id;if(l===O)if(r.add(s),this.a.delete(s),e.$Zn.test(s))delete this.d[s],delete this.b.properties[s];else{const I=this.d[s];I&&(this.w(s,I),this.r(s,I))}}this.u()}deltaConfiguration(i){let r=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,t){i.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(i,r){const t=n=>{if(n.properties)for(const s in n.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(i,r=!0,t,n,s=3,o){s=R.$Sf(i.scope)?s:i.scope;const l=i.properties;if(l)for(const I in l){const v=l[I];if(r&&m(I,v)){delete l[I];continue}if(v.source=t,v.defaultDefaultValue=l[I].default,this.w(I,v),e.$Zn.test(I)?v.scope=void 0:(v.scope=R.$Sf(v.scope)?s:v.scope,v.restricted=R.$Sf(v.restricted)?!!n?.includes(I):v.restricted),l[I].hasOwnProperty("included")&&!l[I].included){this.f[I]=l[I],delete l[I];continue}else this.d[I]=l[I],l[I].policy?.name&&this.e.set(l[I].policy.name,I);!l[I].deprecationMessage&&l[I].markdownDeprecationMessage&&(l[I].deprecationMessage=l[I].markdownDeprecationMessage),o.add(I)}const O=i.allOf;if(O)for(const I of O)this.p(I,r,t,n,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=t=>{const n=t.properties;if(n)for(const o in n)this.r(o,n[o]);t.allOf?.forEach(r)};r(i)}r(i,r){switch(e.$Qn.properties[i]=r,r.scope){case 1:e.$Rn.properties[i]=r;break;case 2:e.$Sn.properties[i]=r;break;case 6:e.$Tn.properties[i]=r;break;case 3:e.$Un.properties[i]=r;break;case 4:e.$Vn.properties[i]=r;break;case 5:e.$Vn.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.$Qn.properties[i],r.scope){case 1:delete e.$Rn.properties[i];break;case 2:delete e.$Sn.properties[i];break;case 6:delete e.$Tn.properties[i];break;case 3:delete e.$Un.properties[i];break;case 4:case 5:delete e.$Vn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$Wn};this.w(r,t),e.$Qn.properties[r]=t,e.$Rn.properties[r]=t,e.$Sn.properties[r]=t,e.$Tn.properties[r]=t,e.$Un.properties[r]=t,e.$Vn.properties[r]=t}}v(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$Wn};e.$Qn.patternProperties[e.$Yn]=i,e.$Rn.patternProperties[e.$Yn]=i,e.$Sn.patternProperties[e.$Yn]=i,e.$Tn.patternProperties[e.$Yn]=i,e.$Un.patternProperties[e.$Yn]=i,e.$Vn.patternProperties[e.$Yn]=i,this.i.fire()}w(i,r){const t=this.a.get(i);let n=t?.value,s=t?.source;R.$Qf(n)&&(n=r.defaultDefaultValue,s=void 0),R.$Qf(n)&&(n=c(r.type)),r.default=n,r.defaultValueSource=s}}const $="\\[([^\\]]+)\\]",w=new RegExp($,"g");e.$Yn=`^(${$})+$`,e.$Zn=new RegExp(e.$Yn);function P(g){const i=[];if(e.$Zn.test(g)){let r=w.exec(g);for(;r?.length;){const t=r[1].trim();t&&i.push(t),r=w.exec(g)}}return(0,N.$Mb)(i)}e.$1n=P;function b(g){return g.reduce((i,r)=>`${i}[${r}]`,"")}e.$2n=b;function c(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$3n=c;const p=new d;h.$Kn.add(e.$Pn.Configuration,p);function m(g,i){return g.trim()?e.$Zn.test(g)?L.localize(7,null,g):p.getConfigurationProperties()[g]!==void 0?L.localize(8,null,g):i.policy?.name&&p.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,g,i.policy?.name,p.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.$4n=m;function u(){const g=[],i=p.getConfigurationProperties();for(const r of Object.keys(i))g.push([r,i[r].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.$5n=u}),define(ie[66],ne([0,1,19,6,38,2,31,27,3,11,29,40,36]),function(J,e,N,D,R,L,A,k,h,a,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=void 0;function $(r){return Object.isFrozen(r)?r:k.$zn(r)}class w{constructor(t={},n=[],s=[],o){this.b=t,this.c=n,this.d=s,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof w)return n;const s=new P("");return s.parseRaw(n),s.configurationModel});this.f=t.reduce((n,s)=>s===n?s:n.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,y.$Ji)(this.contents,t):this.contents}inspect(t,n){const s=this;return{get value(){return $(s.rawConfiguration.getValue(t))},get override(){return n?$(s.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return $(n?s.rawConfiguration.override(n).getValue(t):s.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:l,identifiers:O,keys:I}of s.rawConfiguration.overrides){const v=new w(l,I).getValue(t);v!==void 0&&o.push({identifiers:O,value:v})}return o.length?$(o):void 0}}}getOverrideValue(t,n){const s=this.i(n);return s?t?(0,y.$Ji)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const s of this.overrides)s.identifiers.includes(t)&&n.push(...s.keys);return N.$Mb(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return N.$Mb(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=k.$yn(this.contents),s=k.$yn(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const O of t)if(l.push(...O.raw?.length?O.raw:[O]),!O.isEmpty()){this.h(n,O.contents);for(const I of O.overrides){const[v]=s.filter(j=>N.$ub(j.identifiers,I.identifiers));v?(this.h(v.contents,I.contents),v.keys.push(...I.keys),v.keys=N.$Mb(v.keys)):s.push(k.$yn(I))}for(const I of O.keys)o.indexOf(I)===-1&&o.push(I)}return new w(n,o,s,l.every(O=>O instanceof w)?void 0:l)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const o of N.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[o];const O=n[o];O&&(typeof l=="object"&&typeof O=="object"?(l=k.$yn(l),this.h(l,O)):l=O),s[o]=l}return new w(s,this.keys,this.overrides)}h(t,n){for(const s of Object.keys(n)){if(s in t&&h.$Lf(t[s])&&h.$Lf(n[s])){this.h(t[s],n[s]);continue}t[s]=k.$yn(n[s])}}i(t){let n=null,s=null;const o=l=>{l&&(s?this.h(s,l):s=k.$yn(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?n=l.contents:l.identifiers.includes(t)&&o(l.contents);return o(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,y.$Ii)(this.contents,t),E.$Zn.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>N.$ub(s.identifiers,(0,E.$1n)(t))),1))}j(t,n,s){(0,y.$Hi)(this.contents,t,n,o=>console.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),E.$Zn.test(t)&&this.overrides.push({identifiers:(0,E.$1n)(t),keys:Object.keys(this.contents[t]),contents:(0,y.$Gi)(this.contents[t],o=>console.error(o))})}}e.$6n=w;class P{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new w}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!h.$Sf(t)){const s=this.g(t);this.parseRaw(s,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:s,keys:o,overrides:l,restricted:O,hasExcludedProperties:I}=this.h(t,n);this.b=new w(s,o,l,I?[t]:void 0),this.c=O||[]}g(t){let n={},s=null,o=[];const l=[],O=[];function I(j){Array.isArray(o)?o.push(j):s!==null&&(o[s]=j)}const v={onObjectBegin:()=>{const j={};I(j),l.push(o),o=j,s=null},onObjectProperty:j=>{s=j},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const j=[];I(j),l.push(o),o=j,s=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:I,onError:(j,q,Q)=>{O.push({error:j,offset:q,length:Q})}};if(t)try{R.$mn(t,v),n=o[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return n}h(t,n){const s=d.$Kn.as(E.$Pn.Configuration).getConfigurationProperties(),o=this.i(t,s,!0,n);t=o.raw;const l=(0,y.$Gi)(t,v=>console.error(`Conflict in settings file ${this.f}: ${v}`)),O=Object.keys(t),I=this.j(t,v=>console.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:l,keys:O,overrides:I,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(t,n,s,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const O={},I=[];for(const v in t)if(E.$Zn.test(v)&&s){const j=this.i(t[v],n,!1,o);O[v]=j.raw,l=l||j.hasExcludedProperties,I.push(...j.restricted)}else{const j=n[v],q=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&I.push(v),!o.exclude?.includes(v)&&(o.include?.includes(v)||(q===void 0||o.scopes===void 0||o.scopes.includes(q))&&!(o.skipRestricted&&j?.restricted))?O[v]=t[v]:l=!0}return{raw:O,restricted:I,hasExcludedProperties:l}}j(t,n){const s=[];for(const o of Object.keys(t))if(E.$Zn.test(o)){const l={};for(const O in t[o])l[O]=t[o][O];s.push({identifiers:(0,E.$1n)(o),keys:Object.keys(l),contents:(0,y.$Gi)(l,n)})}return s}}e.$7n=P;class b extends L.$Tc{constructor(t,n,s,o){super(),this.c=t,this.f=n,this.g=o,this.b=this.B(new D.$Wd),this.onDidChange=this.b.event,this.a=new P(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new w}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$8n=b;class c{constructor(t,n,s,o,l,O,I,v,j,q,Q,Y,oe){this.a=t,this.b=n,this.c=s,this.overrideIdentifiers=o,this.d=l,this.f=O,this.g=I,this.h=v,this.i=j,this.j=q,this.k=Q,this.l=Y,this.m=oe}get value(){return $(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class p{constructor(t,n,s,o,l=new w,O=new w,I=new A.$Ac,v=new w,j=new A.$Ac){this.c=t,this.d=n,this.f=s,this.g=o,this.h=l,this.i=O,this.j=I,this.l=v,this.m=j,this.a=null,this.b=new A.$Ac,this.n=null}getValue(t,n,s){return this.p(t,n,s).getValue(t)}updateValue(t,n,s={}){let o;s.resource?(o=this.m.get(s.resource),o||(o=new w,this.m.set(s.resource,o))):o=this.l,n===void 0?o.removeValue(t):o.setValue(t,n),s.resource||(this.a=null)}inspect(t,n,s){const o=this.p(t,n,s),l=this.t(n.resource,s),O=n.resource?this.m.get(n.resource)||this.l:this.l,I=new Set;for(const v of o.overrides)for(const j of v.identifiers)o.getOverrideValue(t,j)!==void 0&&I.add(j);return new c(t,n,o.getValue(t),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,l||void 0,O)}keys(t){const n=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=[];if(!n){const{added:o,updated:l,removed:O}=g(this.c,t);n=[...o,...l,...O]}for(const o of n)for(const l of(0,E.$1n)(o)){const O=this.c.getKeysForOverrideIdentifier(l),I=t.getKeysForOverrideIdentifier(l),v=[...I.filter(j=>O.indexOf(j)===-1),...O.filter(j=>I.indexOf(j)===-1),...O.filter(j=>!k.$Cn(this.c.override(l).getValue(j),t.override(l).getValue(j)))];s.push([l,v])}return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:s,removed:o}=g(this.d,t),l=[...n,...s,...o];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.applicationConfiguration,t),O=[...n,...s,...o];return O.length&&this.updateApplicationConfiguration(t),{keys:O,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.localUserConfiguration,t),O=[...n,...s,...o];return O.length&&this.updateLocalUserConfiguration(t),{keys:O,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.remoteUserConfiguration,t),O=[...n,...s,...o];return O.length&&this.updateRemoteUserConfiguration(t),{keys:O,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.workspaceConfiguration,t),O=[...n,...s,...o];return O.length&&this.updateWorkspaceConfiguration(t),{keys:O,overrides:l}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:o,updated:l,removed:O,overrides:I}=g(s,n),v=[...o,...l,...O];return(v.length||!s)&&this.updateFolderConfiguration(t,n),{keys:v,overrides:I}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:l,overrides:O}=g(n,void 0);return{keys:[...s,...o,...l],overrides:O}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,n,s){let o=this.q(n,s);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(o=o.merge(this.d)),o}q({resource:t},n){let s=this.r();if(n&&t){const o=n.getFolder(t);o&&(s=this.s(o.uri)||s);const l=this.m.get(t);l&&(s=s.merge(l))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let n=this.b.get(t);if(!n){const s=this.r(),o=this.j.get(t);o?(n=s.merge(o),this.b.set(t,n)):n=s}return n}t(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:s,overrides:o,keys:l}=this.j.get(n);return t.push([n,{contents:s,overrides:o,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(s=>t.add(s))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}v(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.w(t.defaults),s=this.w(t.policy),o=this.w(t.application),l=this.w(t.user),O=this.w(t.workspace),I=t.folders.reduce((v,j)=>(v.set(a.URI.revive(j[0]),this.w(j[1])),v),new A.$Ac);return new p(n,s,o,l,new w,O,I,new w,new A.$Ac)}static w(t){return new w(t.contents,t.keys,t.overrides)}}e.$9n=p;function m(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const o of r)o.keys.forEach(l=>t.add(l)),o.overrides.forEach(([l,O])=>{const I=(0,A.$xc)(n,l,new Set);O.forEach(v=>I.add(v))});const s=[];return n.forEach((o,l)=>s.push([l,[...o.values()]])),{keys:[...t.values()],overrides:s}}e.$0n=m;class u{constructor(t,n,s,o){this.change=t,this.f=n,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const O of l)this.affectedKeys.add(O);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(t,n){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const l=o+s.length;if(l>=this.d.length)return!1;const O=this.d.charCodeAt(l);if(O!==this.b&&O!==this.c)return!1;if(n){const I=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,v=this.g.getValue(t,n,this.h);return!k.$Cn(I,v)}return!0}}e.$$n=u;function g(r,t){const{added:n,removed:s,updated:o}=i(t?.rawConfiguration,r?.rawConfiguration),l=[],O=r?.getAllOverrideIdentifiers()||[],I=t?.getAllOverrideIdentifiers()||[];if(t){const v=I.filter(j=>!O.includes(j));for(const j of v)l.push([j,t.getKeysForOverrideIdentifier(j)])}if(r){const v=O.filter(j=>!I.includes(j));for(const j of v)l.push([j,r.getKeysForOverrideIdentifier(j)])}if(t&&r){for(const v of O)if(I.includes(v)){const j=i({contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)},{contents:t.getOverrideValue(void 0,v)||{},keys:t.getKeysForOverrideIdentifier(v)});l.push([v,[...j.added,...j.removed,...j.updated]])}}return{added:n,removed:s,updated:o,overrides:l}}function i(r,t){const n=r?t?r.keys.filter(l=>t.keys.indexOf(l)===-1):[...r.keys]:[],s=t?r?t.keys.filter(l=>r.keys.indexOf(l)===-1):[...t.keys]:[],o=[];if(r&&t){for(const l of t.keys)if(r.keys.indexOf(l)!==-1){const O=(0,y.$Ji)(t.contents,l),I=(0,y.$Ji)(r.contents,l);k.$Cn(O,I)||o.push(l)}}return{added:n,removed:s,updated:o}}}),define(ie[135],ne([0,1,19,6,2,27,3,66,40,4,39,36]),function(J,e,N,D,R,L,A,k,h,a,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=void 0;class d extends R.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$Wd),this.onDidChangeConfiguration=this.a.event,this.b=new k.$6n}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$Kn.as(h.$Pn.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:c})=>this.c(Array.from(b),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(b,c){this.h(b,E.$Kn.as(h.$Pn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}f(){return{}}g(){this.b=new k.$6n;const b=E.$Kn.as(h.$Pn.Configuration).getConfigurationProperties();this.h(Object.keys(b),b)}h(b,c){const p=this.f();for(const m of b){const u=p[m],g=c[m];u!==void 0?this.b.addValue(m,u):g?this.b.addValue(m,g.default):this.b.removeValue(m)}}}e.$_n=d;class ${constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new k.$6n}async initialize(){return this.configurationModel}}e.$ao=$;let w=class extends R.$Tc{get configurationModel(){return this.b}constructor(b,c,p){super(),this.c=b,this.f=c,this.g=p,this.a=this.B(new D.$Wd),this.onDidChangeConfiguration=this.a.event,this.b=new k.$6n}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const c={},p=[],m=E.$Kn.as(h.$Pn.Configuration).getConfigurationProperties();for(const u of b){const g=m[u];if(!g){p.push(u);continue}if(g.policy){if(g.type!=="string"&&g.type!=="number"){this.g.warn(`Policy ${g.policy.name} has unsupported type ${g.type}`);continue}p.push(u),c[g.policy.name]={type:g.type}}}return(0,A.$Wf)(c)||await this.f.updatePolicyDefinitions(c),p}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const c=E.$Kn.as(h.$Pn.Configuration).getPolicyConfigurations(),p=(0,N.$Hb)(b.map(m=>c.get(m)));this.m(p,!0)}m(b,c){this.g.trace("PolicyConfiguration#update",b);const p=E.$Kn.as(h.$Pn.Configuration).getConfigurationProperties(),m=[],u=this.b.isEmpty();for(const g of b){const i=p[g]?.policy?.name;if(i){const r=this.f.getPolicyValue(i);(u?r!==void 0:!(0,L.$Cn)(this.b.getValue(g),r))&&m.push([g,r])}else this.b.getValue(g)!==void 0&&m.push([g,void 0])}if(m.length){this.g.trace("PolicyConfiguration#changed",m);const g=this.b;this.b=new k.$6n;for(const i of g.keys)this.b.setValue(i,g.getValue(i));for(const[i,r]of m)r===void 0?this.b.removeValue(i):this.b.setValue(i,r);c&&this.a.fire(this.b)}}};e.$bo=w,e.$bo=w=$e([se(1,y.$Mn),se(2,a.$pj)],w)}),define(ie[136],ne([0,1,19,9,14,6,38,73,2,27,12,17,29,66,40,135,39]),function(J,e,N,D,R,L,A,k,h,a,y,E,d,$,w,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class c extends h.$Tc{constructor(u,g,i,r){super(),this.m=u,this.h=this.B(new L.$Wd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new P.$_n),this.c=i instanceof b.$On?new P.$ao:this.B(new P.$bo(this.b,i,r)),this.f=this.B(new $.$8n(this.m,{},E.$zg,g)),this.a=new $.$9n(this.b.configurationModel,this.c.configurationModel,new $.$6n,new $.$6n),this.j=new p(u,g,this),this.g=this.B(new D.$hh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:t,properties:n})=>this.r(t,n))),this.B(this.c.onDidChangeConfiguration(t=>this.s(t))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[u,g,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new $.$9n(u,g,new $.$6n,i)}getConfigurationData(){return this.a.toData()}getValue(u,g){const i=typeof u=="string"?u:void 0,r=(0,d.$Ci)(u)?u:(0,d.$Ci)(g)?g:{};return this.a.getValue(i,r,void 0)}async updateValue(u,g,i,r,t){const n=(0,d.$Di)(i)?i:(0,d.$Ci)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,s=n?r:i;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${u} to target ${s}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,N.$Mb)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const o=this.inspect(u,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(o.policyValue!==void 0)throw new Error(`Unable to write ${u} because it is configured in system policy.`);if((0,a.$Cn)(g,o.defaultValue)&&(g=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const O=n.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(v=>(0,N.$ub)([...v.identifiers].sort(),O));I&&(n.overrideIdentifiers=I.identifiers)}const l=n?.overrideIdentifiers?.length?[(0,w.$2n)(n.overrideIdentifiers),u]:[u];await this.j.write(l,g),await this.reloadConfiguration()}inspect(u,g={}){return this.a.inspect(u,g,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const u=await this.f.loadConfiguration();this.n(u)}n(u){const g=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(u);this.t(i,g,2)}r(u,g){const i=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(u,g);this.t(r,i,7)}s(u){const g=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(u);this.t(i,g,7)}t(u,g,i){const r=new $.$$n(u,{data:g},this.a);r.source=i,this.h.fire(r)}}e.$co=c;class p{constructor(u,g,i){this.b=u,this.c=g,this.d=i,this.a=new D.$ch}write(u,g){return this.a.queue(()=>this.e(u,g))}async e(u,g){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(n){if(n.fileOperationResult===1)i="{}";else throw n}const r=[];if((0,A.$fn)(i,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const t=this.f(i,u,g);i=(0,k.$xn)(i,t),await this.c.writeFile(this.b,R.$ke.fromString(i))}f(u,g,i){const{tabSize:r,insertSpaces:t,eol:n}=this.h;if(!g.length){const s=JSON.stringify(i,null,t?" ".repeat(r):"	");return[{content:s,length:s.length,offset:0}]}return(0,k.$un)(u,g,i,{tabSize:r,insertSpaces:t,eol:n})}get h(){if(!this.g){let u=y.OS===3||y.OS===2?`
`:`\r
`;const g=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});g&&typeof g=="string"&&g!=="auto"&&(u=g),this.g={eol:u,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ie[67],ne([0,1,15]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0;function D(a){return a.scheme===N.Schemas.vscodeRemote?a.authority:void 0}e.$cl=D;function R(a){if(!a)return;const y=a.indexOf("+");return y<0?a:a.substr(0,y)}e.$dl=R;function L(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.$el=L;function A(a){const{host:y,port:E}=h(a);if(typeof E>"u")throw new Error(`Invalid remote authority: ${a}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:y,port:E}}e.$fl=A;function k(a,y){let{host:E,port:d}=h(a);return typeof d>"u"&&(d=y),{host:E,port:d}}e.$gl=k;function h(a){const y=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const E=a.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const d=a.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:a,port:void 0}}}),define(ie[37],ne([0,1,30,10,67]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.TargetPlatform=e.ExtensionType=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=void 0,e.$hm="extensions.user.cache",e.$im="extensions.builtin.cache",e.$jm="undefined_publisher",e.$km=["ui","workspace","web"];function L(P){if(typeof P=="object"&&P!==null&&P.supported!==!0)return P.description}e.$lm=L,e.$mm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(P){P[P.System=0]="System",P[P.User=1]="User"})(A||(e.ExtensionType=A={}));var k;(function(P){P.WIN32_X64="win32-x64",P.WIN32_ARM64="win32-arm64",P.LINUX_X64="linux-x64",P.LINUX_ARM64="linux-arm64",P.LINUX_ARMHF="linux-armhf",P.ALPINE_X64="alpine-x64",P.ALPINE_ARM64="alpine-arm64",P.DARWIN_X64="darwin-x64",P.DARWIN_ARM64="darwin-arm64",P.WEB="web",P.UNIVERSAL="universal",P.UNKNOWN="unknown",P.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class h{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,c){if(typeof b>"u"||b===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof b=="string"||typeof c=="string"){const p=typeof b=="string"?b:b.value,m=typeof c=="string"?c:c.value;return N.$af(p,m)}return b._lower===c._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.$nm=h;class a{get size(){return this.c.size}constructor(b){if(this.c=new Set,b)for(const c of b)this.add(c)}add(b){this.c.add(h.toKey(b))}delete(b){return this.c.delete(h.toKey(b))}has(b){return this.c.has(h.toKey(b))}}e.$om=a;class y{constructor(){this.c=new Map}clear(){this.c.clear()}delete(b){this.c.delete(h.toKey(b))}get(b){return this.c.get(h.toKey(b))}has(b){return this.c.has(h.toKey(b))}set(b,c){this.c.set(h.toKey(b),c)}values(){return this.c.values()}forEach(b){this.c.forEach(b)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pm=y;function E(P){return d(P)}e.$qm=E;function d(P){return P.contributes&&P.contributes.localizations?P.contributes.localizations.length>0:!1}e.$rm=d;function $(P){return P.contributes&&P.contributes.authentication?P.contributes.authentication.length>0:!1}e.$sm=$;function w(P,b){if(b){const c=`onResolveRemoteAuthority:${(0,R.$dl)(b)}`;return!!P.activationEvents?.includes(c)}return!1}e.$tm=w,e.$um=(0,D.$8h)("IBuiltinExtensionsScannerService")}),define(ie[137],ne([0,1,2,37,13]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class L extends N.$Tc{constructor(k,h,a,y,E){super(),this.a=k,this.b=h,this.c=a,this.f=E,this.B(y.onDidInstallExtensions(d=>this.g(d))),this.B(y.onDidUninstallExtension(d=>this.h(d)))}g(k){for(const h of k)h.local&&this.invalidate(h.profileLocation)}h(k){k.error||this.invalidate(k.profileLocation)}async invalidate(k){if(k)for(const h of this.a.profiles)this.c.extUri.isEqual(h.extensionsResource,k)&&await this.j(h);else await this.j(this.a.defaultProfile)}async j(k){try{await this.b.del(this.c.extUri.joinPath(k.cacheHome,D.$hm))}catch(h){(0,R.$Jk)(h)!==1&&this.f.error(h)}}}e.$0p=L}),define(ie[45],ne([0,1,14,7,2,106,40,10,4,36]),function(J,e,N,D,R,L,A,k,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=void 0,e.$jp=(0,k.$8h)("requestService");class y{constructor(g){this.b=g}toJSON(){if(!this.a){const g=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?g[i]="*****":g[i]=this.b[i];this.a=g}return this.a}}class E extends R.$Tc{constructor(g){super(),this.b=0,this.a=g.createLogger("network",{name:(0,L.localize)(0,null),when:h.$Gj.isEqualTo((0,h.$Ej)(h.LogLevel.Trace)).serialize()})}async c(g,i,r){const t=`${g} #${++this.b}: ${i.url}`;this.a.trace(`${t} - begin`,i.type,new y(i.headers??{}));try{const n=await r();return this.a.trace(`${t} - end`,i.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${t} - error`,i.type,(0,D.$0)(n)),n}}}e.$kp=E;function d(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.$lp=d;function $(u){return u.res.statusCode===204}e.$mp=$;async function w(u){return $(u)?null:(await(0,N.$we)(u.stream)).toString()}e.$np=w;async function P(u){if(!d(u))throw new Error("Server returned "+u.res.statusCode);return w(u)}e.$op=P;async function b(u){if(!d(u))throw new Error("Server returned "+u.res.statusCode);if($(u))return null;const i=(await(0,N.$we)(u.stream)).toString();try{return JSON.parse(i)}catch(r){throw r.message+=`:
`+i,r}}e.$pp=b;function c(u){m(u)}e.$qp=c;let p;function m(u){const g=a.$Kn.as(A.$Pn.Configuration),i=p;p={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},g.updateConfigurations({add:[p],remove:i?[i]:[]})}m(1)}),define(ie[138],ne([0,1,20,15,13,45]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1O=void 0;let A=class{constructor(h,a){this.a=h,this.b=a}async download(h,a,y=N.CancellationToken.None){if(h.scheme===D.Schemas.file||h.scheme===D.Schemas.vscodeRemote){await this.b.copy(h,a);return}const E={type:"GET",url:h.toString(!0)},d=await this.a.request(E,y);if(d.res.statusCode===200)await this.b.writeFile(a,d.stream);else{const $=await(0,L.$op)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${$}`)}}};e.$1O=A,e.$1O=A=$e([se(0,L.$jp),se(1,R.$sk)],A)}),define(ie[139],ne([0,1,140,3]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;function R(A,k){return A.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:A.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function L(A,k,h={}){const a=(0,N.parse)(A),y=h.proxyUrl||R(a,k);if(!y)return null;const E=(0,N.parse)(y);if(!/^https?:$/.test(E.protocol||""))return null;const d={host:E.hostname||"",port:(E.port?+E.port:0)||(E.protocol==="https"?443:80),auth:E.auth,rejectUnauthorized:(0,D.$Pf)(h.strictSSL)?h.strictSSL:!0};return a.protocol==="http:"?new(await new Promise(($,w)=>{J(["http-proxy-agent"],$,w)})).HttpProxyAgent(y,d):new(await new Promise(($,w)=>{J(["https-proxy-agent"],$,w)})).HttpsProxyAgent(y,d)}e.$or=L}),define(ie[141],ne([0,1,58,16,107,20,34,7,12,28,86,173,9,74]),function(J,e,N,D,R,L,A,k,h,a,y,E,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=void 0;let w;async function P(c,p,m,u){return m["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.$8l)(u)&&!m["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.$8l)(u)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=d.Promises.withAsyncBody(async(g,i)=>{const r=new L.$7d;let t=1e4;const n=c.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,$.$9l)(n,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),i(new Error((0,R.localize)(0,null)))},t);try{g(await b(p,r.token))}catch(o){!(0,k.$4)(o)&&!r.token.isCancellationRequested?i(new Error((0,R.localize)(1,null,(0,A.$Si)(o)))):g({})}finally{clearTimeout(s),r.dispose()}})),w)}e.$bm=P;async function b(c,p){const m=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",m);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",u);const g=(0,a.$rg)().replace(/-/g,"").substr(0,12),i=new RegExp(g+"({.*})"+g),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",r);const t=await(0,y.$Xl)(h.OS,r);return c.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(p.isCancellationRequested)return s(new k.$5);const o=(0,D.$nc)(t);let l,O;const I="";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${I} -p '''${g}'' + JSON.stringify(process.env) + ''${g}'''`,O=["-Login","-Command"]):o==="nu"?(l=`^'${process.execPath}' ${I} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,O=["-i","-l","-c"]):o==="xonsh"?(l=`import os, json; print("${g}", json.dumps(dict(os.environ)), "${g}")`,O=["-i","-l","-c"]):(l=`'${process.execPath}' ${I} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,o==="tcsh"||o==="csh"?O=["-ic"]:O=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(O),l);const v=(0,N.spawn)(t,[...O,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});p.onCancellationRequested(()=>(v.kill(),s(new k.$5))),v.on("error",Q=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,A.$Si)(Q)),s(Q)});const j=[];v.stdout.on("data",Q=>j.push(Q));const q=[];v.stderr.on("data",Q=>q.push(Q)),v.on("close",(Q,Y)=>{const oe=Buffer.concat(j).toString("utf8");c.trace("getUnixShellEnvironment#raw",oe);const re=Buffer.concat(q).toString("utf8");if(re.trim()&&c.trace("getUnixShellEnvironment#stderr",re),Q||Y)return s(new Error((0,R.localize)(2,null,Q,Y)));const he=i.exec(oe),de=he?he[1]:"{}";try{const ae=JSON.parse(de);m?ae.ELECTRON_RUN_AS_NODE=m:delete ae.ELECTRON_RUN_AS_NODE,u?ae.ELECTRON_NO_ATTACH_CONSOLE=u:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ae),n(ae)}catch(ae){c.error("getUnixShellEnvironment#errorCaught",(0,A.$Si)(ae)),s(ae)}})})}}),define(ie[142],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DO=e.$CO=void 0,e.$CO=(0,N.$8h)("stateReadService"),e.$DO=(0,N.$8h)("stateService")}),define(ie[68],ne([0,1,9,14,2,3,18,13,4]),function(J,e,N,D,R,L,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=e.$FO=e.$EO=e.SaveStrategy=void 0;var a;(function($){$[$.IMMEDIATE=0]="IMMEDIATE",$[$.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class y extends R.$Tc{constructor(w,P,b,c){super(),this.h=w,this.j=P,this.m=b,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new N.$6g(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(w){w.fileOperationResult!==1&&this.m.error(w)}}getItem(w,P){const b=this.a[w];return(0,L.$Sf)(b)?P:b}setItem(w,P){this.setItems([{key:w,data:P}])}setItems(w){let P=!1;for(const{key:b,data:c}of w)this.a[b]!==c&&((0,L.$Sf)(c)?(0,L.$Qf)(this.a[b])||(this.a[b]=void 0,P=!0):(this.a[b]=c,P=!0));P&&this.s()}removeItem(w){(0,L.$Qf)(this.a[w])||(this.a[w]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const w=JSON.stringify(this.a,null,4);if(w!==this.b)try{await this.n.writeFile(this.h,D.$ke.fromString(w),{atomic:{postfix:".vsctmp"}}),this.b=w}catch(P){this.m.error(P)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$EO=y;let E=class extends R.$Tc{constructor(w,P,b,c){super(),this.a=this.B(new y(P.stateResource,w,b,c))}async init(){await this.a.init()}getItem(w,P){return this.a.getItem(w,P)}};e.$FO=E,e.$FO=E=$e([se(1,A.$ci),se(2,h.$pj),se(3,k.$sk)],E);class d extends E{setItem(w,P){this.a.setItem(w,P)}setItems(w){this.a.setItems(w)}removeItem(w){this.a.removeItem(w)}close(){return this.a.close()}}e.$GO=d}),define(ie[69],ne([0,1,12,35,28]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=void 0;function L(h){if(N.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function A(h,a,y,E,d,$,w,P,b){const c=Object.create(null);c["common.machineId"]=$,c["common.sqmId"]=w,c.sessionID=(0,R.$rg)()+Date.now(),c.commitHash=E,c.version=d,c["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,N.$h)(N.$u),c["common.nodePlatform"]=D.$dc,c["common.nodeArch"]=y,c["common.product"]=b||"desktop",P&&(c["common.msftInternal"]=P);let p=0;const m=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),N.$l&&(c["common.snap"]="true");const u=L(a);return u&&(c["common.platformDetail"]=u),c}e.$Lo=A;function k(h){const a=D.env.USERDNSDOMAIN;if(!a)return!1;const y=a.toLowerCase();return h.some(E=>y===E)}e.$Mo=k}),define(ie[25],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=void 0,e.$wl=(0,N.$8h)("telemetryService"),e.$xl=(0,N.$8h)("customEndpointTelemetryService"),e.$yl="telemetry.currentSessionDate",e.$zl="telemetry.firstSessionDate",e.$Al="telemetry.lastSessionDate",e.$Bl="telemetry.machineId",e.$Cl="telemetry.sqmId",e.$Dl="telemetry",e.$El="telemetry.telemetryLevel",e.$Fl="telemetry.enableCrashReporter",e.$Gl="telemetry.enableTelemetry";var D;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var R;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(ie[41],ne([0,1,27,3,67,69,25]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;class k{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$No=k;class h{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Oo=h,e.$Po=new h;class a{async publicLog(r,t,n){}async publicLogError(r,t,n){}}e.$Qo=a,e.$Ro="telemetry",e.$So="extensionTelemetryLog",e.$To={log:()=>null,flush:()=>Promise.resolve(null)};function y(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry)}e.$Uo=y;function E(i,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$Vo=E;function d(i){const r=i.getValue(A.$El),t=i.getValue(A.$Fl);if(i.getValue(A.$Gl)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Wo=d;function $(i){const r={},t={},n={};b(i,n);for(let s in n){s=s.length>150?s.substr(s.length-149):s;const o=n[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}e.$Xo=$;const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function P(i){if(!i)return"none";const r=(0,R.$dl)(i);return w.has(r)?r:"other"}e.$Yo=P;function b(i,r,t=0,n){if(i)for(const s of Object.getOwnPropertyNames(i)){const o=i[s],l=n?n+s:s;Array.isArray(o)?r[l]=(0,N.$Dn)(o):o instanceof Date?r[l]=o.toISOString():(0,D.$Lf)(o)?t<2?b(o,r,t+1,l+"."):r[l]=(0,N.$Dn)(o):r[l]=o}}function c(i,r){const t=i.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,L.$Mo)(t)||n}e.$Zo=c;function p(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$1o=p;function m(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let t=i;const n=[];for(const O of r)for(;;){const I=O.exec(i);if(!I)break;n.push([I.index,O.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(t="";;){const O=o.exec(i);if(!O)break;const I=n.some(([v,j])=>O.index<j&&v<o.lastIndex);!s.test(O[0])&&!I&&(t+=i.substring(l,O.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<i.length&&(t+=i.substr(l)),t}function u(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(i))return`<REDACTED: ${t.label}>`;return i}function g(i,r){return(0,N.$An)(i,t=>{if(t instanceof k||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let n=t.replaceAll("%20"," ");n=m(n,r);for(const s of r)n=n.replace(s,"");return n=u(n),n}})}e.$2o=g}),define(ie[26],ne([0,1,30,21,37,12,11,7,35,41]),function(J,e,N,D,R,L,A,k,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0;function y(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,N.$8e)(t.id,n.id)===0}e.$3o=y;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const s=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,s,o)}static parse(n){const s=E.exec(n);return s&&s[1]&&s[2]?new d({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?y(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$4o=d;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(t){const n=$.exec(t);return n&&n[1]?[b(n[1]),n[2]]:[b(t),void 0]}e.$5o=w;function P(t,n){return`${t}.${n}`}e.$6o=P;function b(t){return t.toLowerCase()}e.$7o=b;function c(t,n){return b(P(t??R.$jm,n))}e.$8o=c;function p(t,n){const s=[],o=l=>{for(const O of s)if(O.some(I=>y(n(I),n(l))))return O;return null};for(const l of t){const O=o(l);O?O.push(l):s.push([l])}return s}e.$9o=p;function m(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$0o=m;function u(t){return{id:new a.$No(t.identifier.id),name:new a.$No(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$$o=u,e.$_o=new R.$nm("pprice.better-merge");function g(t,n){const s=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&s.every(O=>!y(O.identifier,{id:l}))){const O=t.filter(I=>y(I.identifier,{id:l}));O.length===1&&(s.push(O[0]),o.push(...O[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.$ap=g;async function i(t,n){if(!L.$k)return!1;let s;try{s=(await t.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,k.$0)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,n){const s=await i(t,n),o=(0,D.$xo)(s?"alpine":L.$u,h.$ec);return n.debug("ComputeTargetPlatform:",o),o}e.$bp=r}),define(ie[143],ne([0,1,20,7,15,17,44,11,96,21,26,37]),function(J,e,N,D,R,L,A,k,h,a,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;const d=P=>(0,h.localize)(0,null,P),$=(0,h.localize)(1,null,"ms-dotnettools.csharp");let w=class{constructor(b,c,p){this.a=b,this.b=c,this.d=p}get f(){}async listExtensions(b,c,p){let m=await this.b.getInstalled(1,p);const u=E.$mm.map(i=>i.toLowerCase());if(c&&c!==""){if(u.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}m=m.filter(i=>i.manifest.categories?i.manifest.categories.map(t=>t.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),u.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,h.localize)(2,null,this.f)),m=m.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let g;for(const i of m)g!==i.identifier.id&&(g=i.identifier.id,this.a.info(b?`${g}@${i.manifest.version}`:g))}async installExtensions(b,c,p,m){const u=[];try{b.length&&this.a.info(this.f?(0,h.localize)(3,null,this.f):(0,h.localize)(4,null));const g=[],i=[],r=(n,s,o)=>{i.push({id:n,version:s!=="prerelease"?s:void 0,installOptions:{...p,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||p.installPreReleaseVersion}})};for(const n of b)if(n instanceof k.URI)g.push({vsix:n,installOptions:p});else{const[s,o]=(0,y.$5o)(n);r(s,o,!1)}for(const n of c)if(n instanceof k.URI)g.push({vsix:n,installOptions:{...p,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,y.$5o)(n);r(s,o,!0)}const t=await this.b.getInstalled(1,p.profileLocation);if(g.length&&await Promise.all(g.map(async({vsix:n,installOptions:s})=>{try{await this.h(n,s,m,t)}catch(o){this.a.error(o),u.push(n.toString())}})),i.length){const n=await this.g(i,t,m);u.push(...n)}}catch(g){throw this.a.error((0,h.localize)(5,null,(0,D.$0)(g))),g}if(u.length)throw new Error((0,h.localize)(6,null,u.join(", ")))}async updateExtensions(b){const c=await this.b.getInstalled(1,b),p=[];for(const i of c)i.identifier.uuid&&p.push({...i.identifier,preRelease:i.preRelease});this.a.trace((0,h.localize)(7,null,p.length));const m=await this.d.getExtensions(p,{compatible:!0},N.CancellationToken.None),u=[];for(const i of m)for(const r of c)(0,y.$3o)(r.identifier,i.identifier)&&(0,A.gt)(i.version,r.manifest.version)&&u.push({extension:i,options:{operation:3,installPreReleaseVersion:r.isPreReleaseVersion}});if(!u.length){this.a.info((0,h.localize)(8,null));return}this.a.info((0,h.localize)(9,null,u.map(i=>i.extension.identifier.id).join(", ")));const g=await this.b.installGalleryExtensions(u);for(const i of g)i.error?this.a.error((0,h.localize)(10,null,i.identifier.id,(0,D.$0)(i.error))):this.a.info((0,h.localize)(11,null,i.identifier.id,i.local?.manifest.version))}async g(b,c,p){if(b=b.filter(({id:i,version:r})=>{const t=c.find(n=>(0,y.$3o)(n.identifier,{id:i}));if(t){if(!p&&(!r||r==="prerelease"&&t.preRelease))return this.a.info((0,h.localize)(12,null,i,t.manifest.version,i)),!1;if(r&&t.manifest.version===r)return this.a.info((0,h.localize)(13,null,`${i}@${r}`)),!1}return!0}),!b.length)return[];const m=[],u=[],g=await this.j(b);if(await Promise.all(b.map(async({id:i,version:r,installOptions:t})=>{const n=g.get(i.toLowerCase());if(!n){this.a.error(`${d(r?`${i}@${r}`:i)}
${$}`),m.push(i);return}try{const o=await this.d.getManifest(n,N.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),m.push(i);return}const s=c.find(o=>(0,y.$3o)(o.identifier,n.identifier));if(s){if(n.version===s.manifest.version){this.a.info((0,h.localize)(14,null,r?`${i}@${r}`:i));return}this.a.info((0,h.localize)(15,null,i,n.version))}t.isBuiltin?this.a.info(r?(0,h.localize)(16,null,i,r):(0,h.localize)(17,null,i)):this.a.info(r?(0,h.localize)(18,null,i,r):(0,h.localize)(19,null,i)),u.push({extension:n,options:{...t,installGivenVersion:!!r}})})),u.length){const i=await this.b.installGalleryExtensions(u);for(const r of i)r.error?(this.a.error((0,h.localize)(20,null,r.identifier.id,(0,D.$0)(r.error))),m.push(r.identifier.id)):this.a.info((0,h.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return m}async h(b,c,p,m){const u=await this.b.getManifest(b);if(!u)throw new Error("Invalid vsix");if(await this.l(u,p,c.profileLocation,m))try{await this.b.install(b,c),this.a.info((0,h.localize)(22,null,(0,L.$Fg)(b)))}catch(i){if((0,D.$4)(i))this.a.info((0,h.localize)(23,null,(0,L.$Fg)(b)));else throw i}}async j(b){const c=new Map,p=b.some(g=>g.installOptions.installPreReleaseVersion),m=await this.b.getTargetPlatform(),u=[];for(const g of b)a.$qo.test(g.id)&&u.push({...g,preRelease:p});if(u.length){const g=await this.d.getExtensions(u,{targetPlatform:m},N.CancellationToken.None);for(const i of g)c.set(i.identifier.id.toLowerCase(),i)}return c}k(b){return!0}async l(b,c,p,m){if(!c){const u={id:(0,y.$8o)(b.publisher,b.name)},g=m.find(i=>(0,y.$3o)(u,i.identifier)&&(0,A.gt)(i.manifest.version,b.version));if(g)return this.a.info((0,h.localize)(24,null,g.identifier.id,g.manifest.version,b.version)),!1}return this.k(b)}async uninstallExtensions(b,c,p){const m=async g=>{if(g instanceof k.URI){const i=await this.b.getManifest(g);return(0,y.$6o)(i.publisher,i.name)}return g},u=[];for(const g of b){const i=await m(g),t=(await this.b.getInstalled(void 0,p)).filter(n=>(0,y.$3o)(n.identifier,{id:i}));if(!t.length)throw new Error(`${this.m(i)}
${$}`);if(t.some(n=>n.type===0)){this.a.info((0,h.localize)(25,null,i));return}if(!c&&t.some(n=>n.isBuiltin)){this.a.info((0,h.localize)(26,null,i));return}this.a.info((0,h.localize)(27,null,i));for(const n of t)await this.b.uninstall(n,{profileLocation:p}),u.push(n);this.f?this.a.info((0,h.localize)(28,null,i,this.f)):this.a.info((0,h.localize)(29,null,i))}}async locateExtension(b){const c=await this.b.getInstalled();b.forEach(p=>{c.forEach(m=>{if(m.identifier.id===p&&m.location.scheme===R.Schemas.file){this.a.info(m.location.fsPath);return}})})}m(b){return this.f?(0,h.localize)(30,null,b,this.f):(0,h.localize)(31,null,b)}};e.$Jp=w,e.$Jp=w=$e([se(1,a.$Eo),se(2,a.$Bo)],w)}),define(ie[144],ne([0,1,9,7,2,15,17,44,3,28,24,49,29,18,21,26,64,13,4]),function(J,e,N,D,R,L,A,k,h,a,y,E,d,$,w,P,b,c,p){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;let u=class extends R.$Tc{static{m=this}static{this.c=".sigzip"}constructor(i,r,t,n,s,o){super(),this.h=r,this.j=t,this.m=n,this.n=s,this.r=o,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,r,t){await this.g;const n=(0,A.$Ig)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,n,o=>this.j.download(i,o,r))}catch(o){throw new w.$Co(o.message,w.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.t(i)){const o=await this.u(i);try{s=await this.n.verify(n.fsPath,o.fsPath,this.r.getLevel()===p.LogLevel.Trace)}catch(l){const O=l;if(s=O.code,O.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${O.output}`),s===w.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===w.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(n)}catch(I){this.r.error(I)}throw new w.$Co(E.$Np,w.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(l){this.r.error(l)}}}return s===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):s===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${s}': ${i.identifier.id}`),{location:n,verificationStatus:s}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,h.$Pf)(r)?r:!0}async u(i){await this.g;const r=(0,A.$Ig)(this.extensionsDownloadDir,`${this.z(i)}${m.c}`);try{await this.w(i,r,t=>this.j.downloadSignatureArchive(i,t))}catch(t){throw new w.$Co(t.message,w.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(i,r,t){if(await this.h.exists(r))return;if(r.scheme!==L.Schemas.file){await t(r);return}const n=(0,A.$Ig)(this.extensionsDownloadDir,`.${(0,a.$rg)()}`);await this.h.exists(n)||await t(n);try{await y.Promises.rename(n.fsPath,r.fsPath,2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,D.$0)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const r=[],t=[],n=[];for(const l of i.children)if(l.name.endsWith(m.c))n.push(l.resource);else{const O=P.$4o.parse(l.name);O&&t.push([O,l])}const s=(0,P.$9o)(t,([l])=>l),o=[];for(const l of s)l.sort((O,I)=>k.rcompare(O[0].version,I[0].version)),r.push(...l.slice(1).map(O=>O[1].resource)),o.push(l[0][1]);o.sort((l,O)=>l.mtime-O.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(l=>l.resource)),r.push(...n),await N.Promises.settled(r.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(i){this.r.error(i)}}z(i){return this.f?P.$4o.create(i).toString().toLowerCase():(0,a.$rg)()}};e.$7p=u,e.$7p=u=m=$e([se(0,$.$di),se(1,c.$sk),se(2,w.$Bo),se(3,d.$Bi),se(4,b.$Hp),se(5,p.$pj)],u)}),define(ie[145],ne([0,1,6,2,31,26,37]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=void 0;class k extends D.$Tc{constructor(a,y,E,d,$,w,P){super(),this.f=a,this.g=y,this.h=E,this.j=d,this.m=$,this.n=w,this.r=P,this.a=this.B(new N.$Wd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$3c),this.s().then(null,b=>P.error(b))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(y=>(this.c.set(y.id,(0,D.$Qc)(this.n.watch(this.m.extUri.dirname(y.extensionsResource)),this.n.watch(y.extensionsResource))),this.G(y.extensionsResource))))}catch(y){throw this.r.error(y),y}}async w(a){for(const y of a.extensions)this.I(this.L(y.identifier,y.version),a.profileLocation)}async y(a){for(const y of a.extensions){const E=this.L(y.identifier,y.version);a.error?this.J(E,a.profileLocation):this.I(E,a.profileLocation)}}async z(a){for(const y of a.extensions)this.J(this.L(y.identifier,y.version),a.profileLocation)}async C(a){const y=[],E=[];for(const d of a.extensions){const $=this.L(d.identifier,d.version);a.error?this.I($,a.profileLocation):(this.J($,a.profileLocation),this.b.has($)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),E.push(this.f.scanInstalledExtensionAtLocation(d.location).then(w=>{w?y.push(w):this.r.info("Extension not found at the location",d.location.toString())},w=>this.r.error(w)))))}try{await Promise.all(E),y.length&&await this.H(y)}catch(d){this.r.error(d)}}D(a){for(const y of this.h.profiles)a.contains(y.extensionsResource,0,1)&&this.F(y.extensionsResource)}async F(a){const y=[],E=[],d=await this.j.scanProfileExtensions(a),$=new Set,w=new Set;for(const[P,b]of this.b)b.has(a)&&w.add(P);for(const P of d){const b=this.L(P.identifier,P.version);$.add(b),w.has(b)||(y.push(P.identifier),this.I(b,a))}for(const P of w)if(!$.has(P)){const b=this.M(P);b&&(E.push(b.identifier),this.J(P,a))}(y.length||E.length)&&this.a.fire({added:y.length?{extensions:y,profileLocation:a}:void 0,removed:E.length?{extensions:E,profileLocation:a}:void 0})}async G(a){const y=await this.j.scanProfileExtensions(a);for(const E of y)this.I(this.L(E.identifier,E.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,y){let E=this.b.get(a);E||this.b.set(a,E=new R.$Bc(d=>this.m.extUri.getComparisonKey(d))),E.add(y)}J(a,y){const E=this.b.get(a);E&&E.delete(y),E?.size||this.b.delete(a)}L(a,y){return`${A.$nm.toKey(a.id)}@${y}`}M(a){const[y,E]=(0,L.$5o)(a);return E?{identifier:{id:y},version:E}:void 0}}e.$$p=k}),define(ie[146],ne([0,1,117,41]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;async function R(L,A,k,h,a,y,E){const d={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${A.nameShort})`};if((0,D.$Uo)(A,k)&&(0,D.$Wo)(h)===3){const $=await(0,N.$Cp)(k,a,y);d["X-Market-User-Id"]=$,d["VSCode-SessionId"]=E.machineId||$}return d}e.$Dp=R}),define(ie[147],ne([0,1,174,19,9,2,15,16,24,18,21,26,4,63,11]),function(J,e,N,D,R,L,A,k,h,a,y,E,d,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;let P=class extends $.$kr{constructor(m,u,g,i){super(g),this.h=m,this.j=i,this.g=this.B(new b(u,i)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(m,u){const i=(await this.g.getLanguagePacks())[u];if(!i){this.j.warn(`No language pack found for ${u}`);return}const r=i.translations[m];return r?w.URI.file(r):void 0}async getInstalledLanguages(){const m=await this.g.getLanguagePacks(),u=Object.keys(m).map(g=>{const i=m[g];return{...this.f(g,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return u.push(this.f("en","English")),u.sort((g,i)=>g.label.localeCompare(i.label)),u}async m(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",m.identifier.id),await this.update())}async n(m){const u=await this.g.getLanguagePacks();Object.keys(u).some(g=>u[g]&&u[g].extensions.some(i=>(0,E.$3o)(i.extensionIdentifier,m.identifier)))&&(this.j.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,u]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),g=await this.g.update(u);return!(0,D.$ub)(Object.keys(m),Object.keys(g))}};e.$lr=P,e.$lr=P=$e([se(0,y.$Eo),se(1,a.$di),se(2,y.$Bo),se(3,d.$pj)],P);let b=class extends L.$Tc{constructor(m,u){super(),this.j=u,this.c={},this.f=(0,k.$jc)(m.userDataPath,"languagepacks.json"),this.g=new R.$ch}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(m){return this.s(u=>{Object.keys(u).forEach(g=>delete u[g]),this.m(u,...m)}).then(()=>this.c)}m(m,...u){for(const g of u)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.n(m,g);Object.keys(m).forEach(g=>this.r(m[g]))}n(m,u){const g=u.identifier,i=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const r of i)if(u.location.scheme===A.Schemas.file&&c(r)){let t=m[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},m[r.languageId]=t);const n=t.extensions.filter(s=>(0,E.$3o)(s.extensionIdentifier,g))[0];n?n.version=u.manifest.version:t.extensions.push({extensionIdentifier:g,version:u.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,k.$jc)(u.location.fsPath,s.path)}}r(m){if(m){const u=(0,N.createHash)("md5");for(const g of m.extensions)u.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);m.hash=u.digest("hex")}}s(m=()=>null){return this.g.queue(()=>{let u=null;return h.Promises.readFile(this.f,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(u=m(g),g)).then(g=>{for(const r of Object.keys(g))g[r]||delete g[r];this.c=g,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),h.Promises.writeFile(this.f,i)}).then(()=>u,g=>this.j.error(g))})}};b=$e([se(0,a.$di),se(1,d.$pj)],b);function c(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const m of p.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(ie[148],ne([0,1,83,7,27,41]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function h(y,E,d){const $=await(0,N.$jD)("@microsoft/1ds-core-js","dist/ms.core.js"),w=await(0,N.$jD)("@microsoft/1ds-post-js","dist/ms.post.js"),P=new $.AppInsightsCore,b=new w.PostChannel,c={instrumentationKey:y,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(d){c.extensionConfig={};const p={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};c.extensionConfig[b.identifier]=p}return P.initialize(c,[]),P.addTelemetryInitializer(p=>{p.ext=p.ext??{},p.ext.web=p.ext.web??{},p.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',E&&(p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),P}class a{constructor(E,d,$,w,P){this.e=E,this.f=d,this.g=$,this.h=P,this.c=A,this.d=k,this.g||(this.g={}),typeof w=="function"?this.a=w():this.a=w,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=h(this.a,this.e,this.h)),this.b.then(d=>{E(d)},d=>{(0,D.$1)(d),console.error(d)})}}log(E,d){if(!this.a)return;d=(0,R.$Bn)(d,this.g),d=(0,L.$Xo)(d);const $=this.f+"/"+E;try{this.i(w=>{w.pluginVersionString=d?.properties.version??"Unknown",w.track({name:$,baseData:{name:$,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$yO=a}),define(ie[149],ne([0,1,2,27,12,30,108,29,40,150,32,36,25,41]),function(J,e,N,D,R,L,A,k,h,a,y,E,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;let w=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,p,m){this.k=p,this.l=m,this.d={},this.i=new N.$Sc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const u of this.f)this.j.push(new RegExp((0,L.$Pe)(u),"gi")),u.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$Pe)(u.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(u=>{(u.affectsConfiguration(d.$El)||u.affectsConfiguration(d.$Gl)||u.affectsConfiguration(d.$Fl))&&this.m()}))}setExperimentProperty(c,p){this.d[c]=p}m(){let c=(0,$.$Wo)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const m=p.usage?3:p.error?2:0;c=Math.min(c,m)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,p,m){this.g<p||(m=(0,D.$Bn)(m,this.d),m=(0,$.$2o)(m,this.j),m=(0,D.$Bn)(m,this.c),this.b.forEach(u=>u.log(c,m)))}publicLog(c,p){this.n(c,3,p)}publicLog2(c,p){this.publicLog(c,p)}publicLogError(c,p){this.h&&this.n(c,2,p)}publicLogError2(c,p){this.publicLogError(c,p)}};e.$rr=w,e.$rr=w=$e([se(1,k.$Bi),se(2,y.$Hj)],w);function P(){const b=(0,A.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=R.$o?"":(0,A.localize)(3,null),m=(0,A.localize)(4,null),u=(0,A.localize)(5,null),g=(0,A.localize)(6,null),i=(0,A.localize)(7,null),r=`
|       | ${m} | ${u} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,A.localize)(8,null);return`
${b} ${c} ${p}

&nbsp;

${i}
${r}

&nbsp;

${t}
`}E.$Kn.as(h.$Pn.Configuration).registerConfiguration({id:d.$Dl,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[d.$El]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:P(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$Kn.as(h.$Pn.Configuration).registerConfiguration({id:d.$Dl,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[d.$Gl]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,A.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,A.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${d.$El}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[151],ne([0,1,14,20,175,148]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zO=void 0;async function A(y,E){const d=await E.request(y,D.CancellationToken.None),$=(await(0,N.$we)(d.stream)).toString(),w=d.res.statusCode??200;return{headers:d.res.headers,statusCode:w,responseData:$}}async function k(y){const E={method:y.type,headers:y.headers};return new Promise(($,w)=>{const P=R.request(y.url??"",E,b=>{b.on("data",function(c){$({headers:b.headers,statusCode:b.statusCode??200,responseData:c.toString()})}),b.on("error",function(c){w(c)})});P.write(y.data,b=>{b&&w(b)}),P.end()})}async function h(y,E,d){const $=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),w={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:$};try{const P=y?await A(w,y):await k(w);d(P.statusCode,P.headers,P.responseData)}catch{d(0,{})}}class a extends L.$yO{constructor(E,d,$,w,P){const b={sendPOST:(c,p)=>{h(E,c,p)}};super(d,$,w,P,b)}}e.$zO=a}),define(ie[152],ne([0,1,16,24]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m_b=void 0;async function R(L,A){const k=Object.create(null),h=(y,E)=>{const d=JSON.parse(y);k[E]=d};if(A){const y=[],E=await D.Promises.readdir(A);for(const $ of E)try{(await D.Promises.stat((0,N.$jc)(A,$))).isDirectory()&&y.push($)}catch{}const d=[];for(const $ of y)(await D.Promises.readdir((0,N.$jc)(A,$))).filter(P=>P==="telemetry.json").length===1&&d.push($);for(const $ of d){const w=(await D.Promises.readFile((0,N.$jc)(A,$,"telemetry.json"))).toString();h(w,$)}}let a=(await D.Promises.readFile((0,N.$jc)(L,"telemetry-core.json"))).toString();return h(a,"vscode-core"),a=(await D.Promises.readFile((0,N.$jc)(L,"telemetry-extensions.json"))).toString(),h(a,"vscode-extensions"),JSON.stringify(k,null,4)}e.$m_b=R}),define(ie[153],ne([0,1,12,84,25]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D$b=e.$C$b=void 0;async function L(k,h){let a=k.getItem(R.$Bl);return(typeof a!="string"||N.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,D.$bn)(h.error.bind(h))),a}e.$C$b=L;async function A(k,h){let a=k.getItem(R.$Cl);return typeof a!="string"&&(a=await(0,D.$cn)(h.error.bind(h))),a}e.$D$b=A}),define(ie[22],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=void 0,e.$3k=(0,N.$8h)("IUriIdentityService")}),define(ie[154],ne([0,1,22,118,13,17,75,6,2]),function(J,e,N,D,R,L,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0;class a{static{this._clock=0}constructor(d){this.uri=d,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let y=class{constructor(d){this.g=d,this.c=new h.$Sc,this.f=2**16;const $=new Map,w=P=>{let b=$.get(P.scheme);return b===void 0&&(b=d.hasProvider(P)&&!this.g.hasCapability(P,1024),$.set(P.scheme,b)),b};this.c.add(k.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(P=>{$.delete(P.scheme)})),this.extUri=new L.$xg(w),this.d=new A.$3r((P,b)=>this.extUri.compare(P,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,L.$Jg)(d));const $=this.d.get(d);return $?$.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new a(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((w,P)=>w[1].time<P[1].time?1:w[1].time>P[1].time?-1:0);a._clock=0,this.d.clear();const $=this.f*.5;for(let w=0;w<$;w++)this.d.set(d[w][0],d[w][1].touch())}};e.$4r=y,e.$4r=y=$e([se(0,R.$sk)],y),(0,D.$1r)(N.$3k,y,1)}),define(ie[155],ne([0,1,6,2,13,48,31]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1$b=void 0;class k extends D.$Tc{constructor(a,y,E,d,$,w){super(),this.f=a,this.g=y,this.h=E,this.j=d,this.m=$,this.n=w,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new N.$Wd),this.onDidChangeFile=this.a.event,this.b=L.$bi.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Bc(P=>this.m.extUri.getComparisonKey(this.t(P))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(P=>this.s(P)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,y){return this.g.open(this.t(a),y)}close(a){return this.g.close(a)}read(a,y,E,d,$){return this.g.read(a,y,E,d,$)}write(a,y,E,d,$){return this.g.write(a,y,E,d,$)}watch(a,y){this.b.set(a,a);const E=this.g.watch(this.t(a),y);return(0,D.$Rc)(()=>{this.b.delete(a),E.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,y,E){return this.g.rename(this.t(a),this.t(y),E)}readFile(a,y){return this.g.readFile(this.t(a),y)}readFileStream(a,y,E){return this.g.readFileStream(this.t(a),y,E)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,y,E){return this.g.writeFile(this.t(a),y,E)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,y){return this.g.delete(this.t(a),y)}copy(a,y,E){if((0,R.$wk)(this.g))return this.g.copy(this.t(a),this.t(y),E);throw new Error("copy not supported")}cloneFile(a,y){if((0,R.$xk)(this.g))return this.g.cloneFile(this.t(a),this.t(y));throw new Error("clone not supported")}s(a){const y=[];for(const E of a){if(E.resource.scheme!==this.f)continue;const d=this.u(E.resource);this.b.findSubstr(d)&&y.push({resource:d,type:E.type,cId:E.cId})}y.length&&(this.n.debug("User data changed"),this.a.fire(y))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$1$b=k}),define(ie[156],ne([0,1,110,16,48,17,11,10,15]),function(J,e,N,D,R,L,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.WorkbenchState=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0,e.$ei=(0,k.$8h)("contextService");function a(n){const s=n;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}e.$fi=a;function y(n){return typeof n?.id=="string"&&!a(n)&&!d(n)}e.$gi=y,e.$hi={id:"ext-dev"},e.$ii={id:"empty-window"};function E(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,D.$nc)(n)}:s?e.$hi:e.$ii;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$ji=E;function d(n){const s=n;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}e.$ki=d;function $(n){const s=n;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}e.$li=$;var w;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function P(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.$mi=P;function b(n){const s=n;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.$ni=b;class c{constructor(s,o,l,O,I){this.h=s,this.j=l,this.k=O,this.l=I,this.c=R.$bi.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=R.$bi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$oi=c;class p{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,L.$Ig)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$pi=p;function m(n){return new p({uri:n,index:0,name:(0,L.$Eg)(n)},{uri:n.toString()})}e.$qi=m,e.$ri="code-workspace",e.$si=`.${e.$ri}`,e.$ti=[{name:(0,N.localize)(0,null),extensions:[e.$ri]}],e.$ui="workspace.json";function u(n,s){return L.$zg.isEqualOrParent(n,s.untitledWorkspacesHome)}e.$vi=u;function g(n){let s;return A.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===h.Schemas.tmp}e.$wi=g,e.$xi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.$xi}e.$yi=i;function r(n,s){return!u(n,s)&&!g(n)}e.$zi=r;function t(n){return(typeof n=="string"?(0,D.$oc)(n):(0,L.$Gg)(n))===e.$si}e.$Ai=t}),define(ie[23],ne([0,1,43,6,2,17,11,109,18,13,10,4,156,31,22,9,28,30,3]),function(J,e,N,D,R,L,A,k,h,a,y,E,d,$,w,P,b,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.ProfileResourceType=void 0;var m;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(m||(e.ProfileResourceType=m={}));function u(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&A.URI.isUri(s.location)&&A.URI.isUri(s.globalStorageHome)&&A.URI.isUri(s.settingsResource)&&A.URI.isUri(s.keybindingsResource)&&A.URI.isUri(s.tasksResource)&&A.URI.isUri(s.snippetsHome)&&A.URI.isUri(s.extensionsResource))}e.$4k=u,e.$5k=(0,y.$8h)("IUserDataProfilesService");function g(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:A.URI.revive(n.location).with({scheme:s}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:A.URI.revive(n.extensionsResource).with({scheme:s}),cacheHome:A.URI.revive(n.cacheHome).with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$6k=g;function i(n,s,o,l,O,I){return{id:n,name:s,location:o,isDefault:!1,shortName:O?.shortName,icon:O?.icon,globalStorageHome:I&&O?.useDefaultFlags?.globalState?I.globalStorageHome:(0,L.$Ig)(o,"globalStorage"),settingsResource:I&&O?.useDefaultFlags?.settings?I.settingsResource:(0,L.$Ig)(o,"settings.json"),keybindingsResource:I&&O?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,L.$Ig)(o,"keybindings.json"),tasksResource:I&&O?.useDefaultFlags?.tasks?I.tasksResource:(0,L.$Ig)(o,"tasks.json"),snippetsHome:I&&O?.useDefaultFlags?.snippets?I.snippetsHome:(0,L.$Ig)(o,"snippets"),extensionsResource:I&&O?.useDefaultFlags?.extensions?I.extensionsResource:(0,L.$Ig)(o,"extensions.json"),cacheHome:(0,L.$Ig)(l,n),useDefaultFlags:O?.useDefaultFlags,isTransient:O?.transient}}e.$7k=i;let r=class extends R.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,l,O){super(),this.t=s,this.u=o,this.w=l,this.y=O,this.f=!0,this.h=this.B(new D.$Wd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$Wd),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$Wd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$Wd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new $.$Ac,emptyWindows:new Map},this.profilesHome=(0,L.$Ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$Ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,p.$Jf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}o.push(i((0,L.$Fg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},s))}}catch(I){this.y.error(I)}const l=new $.$Ac,O=new Map;if(o.length)try{const I=this.Q();if(I.workspaces)for(const[v,j]of Object.entries(I.workspaces)){const q=A.URI.parse(v),Q=o.find(Y=>Y.id===j);Q&&l.set(q,Q)}if(I.emptyWindows)for(const[v,j]of Object.entries(I.emptyWindows)){const q=o.find(Q=>Q.id===j);q&&O.set(v,q)}}catch(I){this.y.error(I)}this.z={profiles:o,workspaces:l,emptyWindows:O}}return this.z}D(){const s=i("__default__profile__",(0,k.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",l=new RegExp(`${(0,c.$Pe)(o)}\\s(\\d+)`);let O=0;for(const v of this.profiles){const j=l.exec(v.name),q=j?parseInt(j[1]):0;O=q>O?q:O}const I=`${o} ${O+1}`;return this.createProfile((0,N.$Vi)((0,b.$rg)()).toString(16),I,{transient:!0},s)}async createNamedProfile(s,o,l){return this.createProfile((0,N.$Vi)((0,b.$rg)()).toString(16),s,o,l)}async createProfile(s,o,l,O){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(s,o,l);return O&&await this.setProfileForWorkspace(O,I),I}async F(s,o,l){if(!(0,p.$Jf)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let O=this.r.get(o);return O||(O=(async()=>{try{const I=this.profiles.find(q=>q.name===o||q.id===s);if(I)return I;const v=i(s,o,(0,L.$Ig)(this.profilesHome,s),this.g,l,this.defaultProfile);await this.u.createFolder(v.location);const j=[];return this.j.fire({profile:v,join(q){j.push(q)}}),await P.Promises.settled(j),this.I([v],[],[]),v}finally{this.r.delete(o)}})(),this.r.set(o,O)),O}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(O=>O.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);return l=i(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(O=>O.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const l=[];this.m.fire({profile:o,join(O){l.push(O)}});try{await Promise.allSettled(l)}catch(O){this.y.error(O)}for(const O of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(O)?.id&&this.C.emptyWindows.delete(O);for(const O of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(O)?.id&&this.C.workspaces.delete(O);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(O){(0,a.$Jk)(O)!==1&&this.y.error(O)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(O=>O.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,l)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return A.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,d.$fi)(s)?s.uri:(0,d.$ki)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,l){const O=[...this.profiles,...s],I=[];this.s.profiles=[];for(let v of O)v.isDefault||o.some(j=>v.id===j.id)||(v=l.find(j=>v.id===j.id)??v,v.isTransient?this.s.profiles.push(v):I.push({location:v.location,name:v.name,shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags}));this.P(I),this.z=void 0,this.J(s,o,l)}J(s,o,l){this.h.fire({added:s,removed:o,updated:l,all:this.profiles})}L(s,o,l){l=o?.isTransient?!0:l,l||this.L(s,void 0,!0);const O=this.G(s),I=l?this.s:this.C;A.URI.isUri(O)?(I.workspaces.delete(O),o&&I.workspaces.set(O,o)):(I.emptyWindows.delete(O),o&&I.emptyWindows.set(O,o)),l||this.M()}M(){const s={};for(const[l,O]of this.C.workspaces.entries())s[l.toString()]=O.id;const o={};for(const[l,O]of this.C.emptyWindows.entries())o[l.toString()]=O.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},l=this.D();if(s.workspaces)for(const[I,v]of Object.entries(s.workspaces)){const j=A.URI.parse(v);o[I]=this.w.extUri.isEqual(j,l.location)?l.id:this.w.extUri.basename(j)}const O={};if(s.emptyWindows)for(const[I,v]of Object.entries(s.emptyWindows)){const j=A.URI.parse(v);O[I]=this.w.extUri.isEqual(j,l.location)?l.id:this.w.extUri.basename(j)}return{workspaces:o,emptyWindows:O}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$8k=r,e.$8k=r=$e([se(0,h.$ci),se(1,a.$sk),se(2,w.$3k),se(3,E.$pj)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$9k=t}),define(ie[157],ne([0,1,19,9,20,7,6,2,12,3,11,94,21,26,37,4,32,25,22,23]),function(J,e,N,D,R,L,A,k,h,a,y,E,d,$,w,P,b,c,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=e.$Tp=e.$Sp=void 0;let u=class extends k.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,o,l,O,I,v){super(),this.z=s,this.C=o,this.D=l,this.F=O,this.G=I,this.H=v,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$Wd),this.s=this.B(new A.$Wd),this.t=this.B(new A.$Wd),this.u=this.B(new A.$Wd),this.w=this.B(new A.$Wd),this.y=[],this.B((0,k.$Rc)(()=>{this.j.forEach(({task:j})=>j.cancel()),this.m.forEach(j=>j.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(l=>(0,d.$zo)(l,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const O=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:I})=>(0,$.$3o)(I,s.identifier));if(O?.local)return O?.local;throw O?.error?O.error:new d.$Co(`Unknown error while installing extension ${s.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch(l){throw i(l)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new d.$Co(E.localize(0,null),d.ExtensionManagementErrorCode.NotAllowed);const o=[],l=[];await Promise.allSettled(s.map(async({extension:O,options:I})=>{try{const v=await this.N(O,!!I?.installGivenVersion,!!I?.installPreReleaseVersion);l.push({...v,options:I})}catch(v){o.push({identifier:O.identifier,operation:2,source:O,error:v})}})),l.length&&o.push(...await this.I(l));for(const O of o)O.error&&(this.F.error("Failed to install extension.",O.identifier.id),this.F.error(O.error),O.source&&!y.URI.isUri(O.source)&&r(this.C,"extensionGallery:install",{extensionData:(0,$.$$o)(O.source),error:O.error}));return o}async uninstall(s,o={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,o)}async toggleAppliationScope(s,o){if((0,w.$qm)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let l=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(l=await this.$(s,this.H.defaultProfile.extensionsResource,o));for(const O of this.H.profiles){const I=(await this.getInstalled(1,O.extensionsResource)).find(v=>(0,$.$3o)(v.identifier,s.identifier));I?this.w.fire(I):this.u.fire({identifier:s.identifier,profileLocation:O.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const o=[],l=new Map,O=[],I=[],v=(q,Q)=>`${$.$4o.create(q).toString()}-${Q.toString()}`,j=(q,Q,Y)=>{const oe=this.Y(q,Q,Y),re=y.URI.isUri(Q)?Q.path:`${Q.identifier.id.toLowerCase()}-${Y.profileLocation.toString()}`;l.set(re,{task:oe,manifest:q}),this.n.fire({identifier:oe.identifier,source:Q,profileLocation:Y.profileLocation}),this.F.info("Installing extension:",oe.identifier.id),y.URI.isUri(Q)||this.j.set(v(Q,Y.profileLocation),{task:oe,waitingTasks:[]})};try{for(const{manifest:q,extension:Q,options:Y}of s){const oe=Y.isApplicationScoped||Y.isBuiltin||(0,w.$qm)(q),re={...Y,installOnlyNewlyAddedFromExtensionPack:y.URI.isUri(Q)?Y.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:oe,profileLocation:oe?this.H.defaultProfile.extensionsResource:Y.profileLocation??this.X()},he=y.URI.isUri(Q)?void 0:this.j.get(v(Q,re.profileLocation));he?(this.F.info("Extension is already requested to install",he.task.identifier.id),O.push(he.task.waitUntilTaskIsFinished())):j(q,Q,re)}await Promise.all([...l.values()].map(async({task:q,manifest:Q})=>{if(q.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",q.identifier.id);else try{const Y=await this.M(q.identifier,Q,!!q.options.installOnlyNewlyAddedFromExtensionPack,!!q.options.installPreReleaseVersion,q.options.profileLocation),oe=await this.getInstalled(void 0,q.options.profileLocation),re={...q.options,donotIncludePackAndDependencies:!0,context:{...q.options.context,[d.$uo]:!0}};for(const{gallery:he,manifest:de}of(0,N.$Mb)(Y,({gallery:ae})=>ae.identifier.id)){if(l.has(`${he.identifier.id.toLowerCase()}-${re.profileLocation.toString()}`))continue;const ae=this.j.get(v(he,re.profileLocation));if(ae){if(this.J(q,ae.task)){const B=ae.task.identifier;this.F.info("Waiting for already requested installing extension",B.id,q.identifier.id),ae.waitingTasks.push(q),O.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,X=>X.some(M=>(0,$.$3o)(M.identifier,B)))).then(X=>{if(this.F.info("Finished waiting for already requested installing extension",B.id,q.identifier.id),!X.find(T=>(0,$.$3o)(T.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else oe.some(({identifier:B})=>(0,$.$3o)(B,he.identifier))||j(de,he,re)}}catch(Y){if(y.URI.isUri(q.source))(0,N.$Lb)(Q.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",q.identifier.id,Y.message),(0,N.$Lb)(Q.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",q.identifier.id,Y.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",q.identifier.id),Y}})),await this.L([...l.values()].map(async({task:q})=>{const Q=new Date().getTime();try{const Y=await q.run();if(await this.L(this.y.map(oe=>oe.postInstall(Y,q.source,q.options,R.CancellationToken.None))),!y.URI.isUri(q.source)){const oe=q.operation===3,re=oe?void 0:(new Date().getTime()-q.source.lastUpdated)/1e3;if(r(this.C,oe?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$$o)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-Q,durationSinceUpdate:re}),h.$o&&q.operation!==3)try{await this.z.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,"install")}catch{}}I.push({local:Y,identifier:q.identifier,operation:q.operation,source:q.source,context:q.options.context,profileLocation:q.profileLocation,applicationScoped:Y.isApplicationScoped})}catch(Y){throw this.F.error("Error while installing the extension",q.identifier.id,(0,L.$0)(Y)),Y}})),O.length&&await this.L(O);for(const q of I)this.F.info("Extension installed successfully:",q.identifier.id),o.push(q);return o}catch(q){I.length&&await Promise.allSettled(I.map(async({local:Q,profileLocation:Y})=>{try{await this.Z(Q,{versionOnly:!0,profileLocation:Y}).run(),this.F.info("Rollback: Uninstalled extension",Q.identifier.id)}catch(oe){this.F.warn("Rollback: Error while uninstalling extension",Q.identifier.id,(0,L.$0)(oe))}}));for(const{task:Q}of l.values())Q.cancel(),o.push({identifier:Q.identifier,operation:2,source:Q.source,context:Q.options.context,profileLocation:Q.profileLocation,error:q});throw q}finally{for(const{task:q}of l.values())q.source&&!y.URI.isUri(q.source)&&this.j.delete(v(q.source,q.profileLocation));o.length&&this.s.fire(o)}}J(s,o){for(const[,{task:l,waitingTasks:O}]of this.j.entries())if(l===s&&(O.includes(o)||O.some(I=>this.J(I,o)))||l===o&&O[0]&&!this.J(s,O[0]))return!1;return!0}async L(s){const o=[],l=[],O=await Promise.allSettled(s);for(const I of O)I.status==="fulfilled"?o.push(I.value):l.push(I.reason);if(l.length)throw g(l);return o}async M(s,o,l,O,I){if(!this.z.isEnabled())return[];const v=await this.getInstalled(void 0,I),j=[],q=[],Q=async(Y,oe)=>{j.push(Y);const re=oe.extensionDependencies||[],he=[...re];if(oe.extensionPack){const de=l?v.find(ae=>(0,$.$3o)(ae.identifier,Y)):void 0;for(const ae of oe.extensionPack)de&&de.manifest.extensionPack&&de.manifest.extensionPack.some(B=>(0,$.$3o)({id:B},{id:ae}))||he.every(B=>!(0,$.$3o)({id:B},{id:ae}))&&he.push(ae)}if(he.length){const de=he.filter(ae=>j.every(B=>!(0,$.$3o)(B,{id:ae})));if(de.length){const ae=await this.z.getExtensions(de.map(B=>({id:B,preRelease:O})),R.CancellationToken.None);for(const B of ae){if(j.find(T=>(0,$.$3o)(T,B.identifier)))continue;const X=re.some(T=>(0,$.$3o)({id:T},B.identifier));let M;try{M=await this.N(B,!1,O)}catch(T){if(X)throw T;this.F.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,L.$0)(T));continue}q.push({gallery:M.extension,manifest:M.manifest}),await Q(M.extension.identifier,M.manifest)}}}};return await Q(s,o),q}async N(s,o,l){let O;const I=await this.getExtensionsControlManifest();if(I.malicious.some(q=>(0,$.$3o)(s.identifier,q)))throw new d.$Co(E.localize(1,null,s.identifier.id),d.ExtensionManagementErrorCode.Malicious);const v=I.deprecated[s.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),O=(await this.z.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!O)throw new d.$Co(E.localize(2,null,s.identifier.id,v.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const q=await this.getTargetPlatform();throw new d.$Co(E.localize(3,null,s.identifier.id,this.G.nameLong,(0,d.$vo)(q)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(O=await this.O(s,o,l),!O)throw!l&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],R.CancellationToken.None))[0]?new d.$Co(E.localize(4,null,s.displayName??s.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$Co(E.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",O.identifier.id);const j=await this.z.getManifest(O,R.CancellationToken.None);if(j===null)throw new d.$Co(`Missing manifest for extension ${O.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(j.version!==O.version)throw new d.$Co(`Cannot install '${O.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:O,manifest:j}}async O(s,o,l){const O=await this.getTargetPlatform();let I=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==l&&(I=(await this.z.getExtensions([{...s.identifier,preRelease:l}],{targetPlatform:O,compatible:!0},R.CancellationToken.None))[0]||null),!I&&await this.z.isExtensionCompatible(s,l,O)&&(I=s),I||(o?I=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:O,compatible:!0},R.CancellationToken.None))[0]||null:I=await this.z.getCompatibleExtension(s,l,O)),I}async P(s,o){const l={...o,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.X()},O=Y=>`${Y.id.toLowerCase()}${l.versionOnly?`-${s.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,I=this.m.get(O(s.identifier));if(I)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),I.waitUntilTaskIsFinished();const v=Y=>{const oe=this.Z(Y,l);return this.m.set(O(oe.extension.identifier),oe),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${Y.identifier.id}@${Y.manifest.version}`),this.t.fire({identifier:Y.identifier,profileLocation:l.profileLocation,applicationScoped:Y.isApplicationScoped}),oe},j=(Y,oe)=>{oe?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,l.profileLocation.toString(),oe.message):this.F.error("Failed to uninstall extension:",`${Y.identifier.id}@${Y.manifest.version}`,oe.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${Y.identifier.id}@${Y.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${Y.identifier.id}@${Y.manifest.version}`),r(this.C,"extensionGallery:uninstall",{extensionData:(0,$.$0o)(Y),error:oe}),this.u.fire({identifier:Y.identifier,error:oe?.code,profileLocation:l.profileLocation,applicationScoped:Y.isApplicationScoped})},q=[],Q=[];try{q.push(v(s));const Y=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const oe=this.S(s,Y);for(const re of oe)this.m.has(O(re.identifier))?this.F.info("Extensions is already requested to uninstall",re.identifier.id):q.push(v(re))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(q.map(oe=>oe.extension),Y,s),await this.L(q.map(async oe=>{try{if(await oe.run(),await this.L(this.y.map(re=>re.postUninstall(oe.extension,l,R.CancellationToken.None))),oe.extension.identifier.uuid)try{await this.z.reportStatistic(oe.extension.manifest.publisher,oe.extension.manifest.name,oe.extension.manifest.version,"uninstall")}catch{}j(oe.extension)}catch(re){const he=re instanceof d.$Co?re:new d.$Co((0,L.$0)(re),d.ExtensionManagementErrorCode.Internal);throw j(oe.extension,he),he}finally{Q.push(oe)}}))}catch(Y){const oe=Y instanceof d.$Co?Y:new d.$Co((0,L.$0)(Y),d.ExtensionManagementErrorCode.Internal);for(const re of q){try{re.cancel()}catch{}Q.includes(re)||j(re.extension,oe)}throw oe}finally{for(const Y of q)this.m.delete(O(Y.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",Y.extension.identifier.id)}}Q(s,o,l){for(const O of s){const I=this.U(O,o);if(I.length){const v=I.filter(j=>!s.some(q=>(0,$.$3o)(q.identifier,j.identifier)));if(v.length)throw new Error(this.R(O,v,l))}}}R(s,o,l){return l===s?o.length===1?E.localize(6,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(7,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(8,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?E.localize(9,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(10,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(11,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}S(s,o,l=[]){if(l.indexOf(s)!==-1)return[];l.push(s);const O=s.manifest.extensionPack?s.manifest.extensionPack:[];if(O.length){const I=o.filter(j=>!j.isBuiltin&&O.some(q=>(0,$.$3o)({id:q},j.identifier))),v=[];for(const j of I)v.push(...this.S(j,o,l));return[...I,...v]}return[]}U(s,o){return o.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(O=>(0,$.$3o)({id:O},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,L.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$Sp=u,e.$Sp=u=$e([se(0,d.$Bo),se(1,c.$wl),se(2,p.$3k),se(3,P.$pj),se(4,b.$Hj),se(5,m.$5k)],u);function g(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,l)=>new Error(`${o.message}${o.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$Tp=g;function i(n){if(n instanceof d.$Co)return n;if(n instanceof d.$Do){const o=new d.$Co(n.message,d.ExtensionManagementErrorCode.Gallery);return o.stack=n.stack,o}const s=new d.$Co(n.message,d.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}e.$Up=i;function r(n,s,{extensionData:o,verificationStatus:l,duration:O,error:I,durationSinceUpdate:v}){let j,q;(0,a.$Rf)(l)&&(l===!0?l="Verified":(l===!1||(j=d.ExtensionManagementErrorCode.Signature,q=l),l="Unverified")),I&&(I instanceof d.$Co||I instanceof d.$Do?(j=I.code,I.code===d.ExtensionManagementErrorCode.Signature&&(q=I.message)):j=d.ExtensionManagementErrorCode.Internal),n.publicLog(s,{...o,verificationStatus:l,success:!I,duration:O,errorcode:j,errorcodeDetail:q,durationSinceUpdate:v})}class t{constructor(){this.d=new D.$7g}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$Ug)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$Ug)(s=>new Promise((o,l)=>{const O=s.onCancellationRequested(()=>{O.dispose(),l(new L.$5)})})),this.d.open()),this.g.cancel()}}e.$Vp=t}),define(ie[42],ne([0,1,9,14,2,6,31,11,21,26,13,10,4,23,22,3,7,25]),function(J,e,N,D,R,L,A,k,h,a,y,E,d,$,w,P,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.$Wp=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class m extends Error{constructor(t,n){super(t),this.code=n}}e.$Wp=m,e.$Xp=(0,E.$8h)("IExtensionsProfileScannerService");let u=class extends R.$Tc{constructor(t,n,s,o,l,O){super(),this.j=t,this.m=n,this.n=s,this.r=o,this.s=l,this.t=O,this.b=this.B(new L.$Wd),this.onAddExtensions=this.b.event,this.c=this.B(new L.$Wd),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$Wd),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$Wd),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(t,n){return this.u(t,void 0,n)}async addExtensionsToProfile(t,n){const s=[],o=[];try{return await this.u(n,l=>{const O=[];for(const I of l)t.some(([v])=>(0,a.$3o)(v.identifier,I.identifier)&&v.manifest.version!==I.version)?s.push(I):O.push(I);for(const[I,v]of t){const j=O.findIndex(Q=>(0,a.$3o)(Q.identifier,I.identifier)&&Q.version===I.manifest.version),q={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:v};j===-1?(o.push(q),O.push(q)):O.splice(j,1,q)}return o.length&&this.b.fire({extensions:o,profileLocation:n}),s.length&&this.f.fire({extensions:s,profileLocation:n}),O}),o.length&&this.c.fire({extensions:o,profileLocation:n}),s.length&&this.g.fire({extensions:s,profileLocation:n}),o}catch(l){throw o.length&&this.c.fire({extensions:o,error:l,profileLocation:n}),s.length&&this.g.fire({extensions:s,error:l,profileLocation:n}),l}}async updateMetadata(t,n){const s=[];return await this.u(n,o=>{const l=[];for(const O of o){const I=t.find(([v])=>(0,a.$3o)(v.identifier,O.identifier)&&v.manifest.version===O.version);I&&(O.metadata={...O.metadata,...I[1]},s.push(O)),l.push(O)}return l}),s}async removeExtensionFromProfile(t,n){const s=[];try{await this.u(n,o=>{const l=[];for(const O of o)(0,a.$3o)(O.identifier,t.identifier)?s.push(O):l.push(O);return s.length&&this.f.fire({extensions:s,profileLocation:n}),l}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:n}),o}}async u(t,n,s){return this.F(t).queue(async()=>{let o=[],l;try{const O=await this.m.readFile(t);l=JSON.parse(O.value.toString().trim()||"[]")}catch(O){if((0,y.$Jk)(O)!==1)throw O;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&s?.bailOutWhenFileNotFound)throw new m((0,b.$0)(O),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let O=!1;for(const I of l){g(I)||this.w(t);let v;if((0,P.$Jf)(I.relativeLocation)&&I.relativeLocation)v=this.z(I.relativeLocation);else if((0,P.$Jf)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{v=k.URI.revive(I.location);const j=this.y(v);j&&(O=!0,I.relativeLocation=j)}(0,P.$Qf)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(O=!0,I.metadata.hasPreReleaseVersion=!0),o.push({identifier:I.identifier,location:v,version:I.version,metadata:I.metadata})}O&&await this.m.writeFile(t,D.$ke.fromString(JSON.stringify(l)))}if(n){o=n(o);const O=o.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(t,D.$ke.fromString(JSON.stringify(O)))}return o})}w(t){const n=new m(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(l){if((0,y.$Jk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(O=>g(O))?o=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$ke.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,y.$Jk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,y.$Jk)(l)!==1&&this.t.error(l)}try{await this.m.del(n)}catch(l){(0,y.$Jk)(l)!==1&&this.t.error(l)}return o})()),this.C}F(t){let n=this.h.get(t);return n||(n=new N.$ch,this.h.set(t,n)),n}};e.$Yp=u,e.$Yp=u=$e([se(1,y.$sk),se(2,$.$5k),se(3,w.$3k),se(4,c.$wl),se(5,d.$pj)],u);function g(r){return(0,P.$Lf)(r)&&(0,h.$Ao)(r.identifier)&&(i(r.location)||(0,P.$Jf)(r.location)&&r.location)&&((0,P.$Qf)(r.relativeLocation)||(0,P.$Jf)(r.relativeLocation))&&r.version&&(0,P.$Jf)(r.version)}function i(r){return r?(0,P.$Jf)(r.path)&&(0,P.$Jf)(r.scheme):!1}}),define(ie[52],ne([0,1,19,9,27,14,7,38,81,2,15,16,12,17,44,54,3,11,98,18,26,37,50,13,10,4,32,6,47,42,23,22,115]),function(J,e,N,D,R,L,A,k,h,a,y,E,d,$,w,P,b,c,p,m,u,g,i,r,t,n,s,o,l,O,I,v,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.Translations=void 0;var q;(function(ae){function B(X,M){if(X===M)return!0;const T=Object.keys(X),W=new Set;for(const Z of Object.keys(M))W.add(Z);if(T.length!==W.size)return!1;for(const Z of T){if(X[Z]!==M[Z])return!1;W.delete(Z)}return W.size===0}ae.equals=B})(q||(e.Translations=q={})),e.$2p=(0,t.$8h)("IExtensionsScannerService");let Q=class extends a.$Tc{constructor(B,X,M,T,W,Z,K,_,F,C,f,S){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=X,this.r=M,this.s=T,this.t=W,this.u=Z,this.w=K,this.y=_,this.z=F,this.C=C,this.D=f,this.F=S,this.g=this.B(new o.$Wd),this.onDidChangeCache=this.g.event,this.h=(0,$.$Ig)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(re,this.s,this.h)),this.m=this.B(this.F.createInstance(re,this.s,this.h)),this.n=this.B(this.F.createInstance(oe,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,u.$bp)(this.w,this.y)),this.G}async scanAllExtensions(B,X,M){const[T,W]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(X)]),Z=M?await this.scanExtensionsUnderDevelopment(B,[...T,...W]):[];return this.L(T,W,Z,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const X=[];X.push(this.M(!!B.useCache,B.language)),X.push(this.N(B.language,!!B.checkControlFile));const[M,T]=await Promise.all(X);return this.J([...M,...T],0,B,!1)}async scanUserExtensions(B){const X=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const M=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,T=await this.P(X,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,M),W=B.useCache&&!T.devMode&&T.excludeObsolete?this.m:this.n;let Z;try{Z=await W.scanExtensions(T)}catch(K){if(K instanceof O.$Wp&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),Z=await W.scanExtensions(T);else throw K}return Z=await this.J(Z,1,B,!0),this.y.trace("Scanned user extensions:",Z.length),Z}async scanExtensionsUnderDevelopment(B,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const M=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(T=>T.scheme===y.Schemas.file).map(async T=>{const W=await this.P(T,!1,1,!0,B.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(W)).map(K=>(K.type=X.find(_=>(0,u.$3o)(_.identifier,K.identifier))?.type??K.type,this.n.validate(K,W)))}))).flat();return this.J(M,"development",B,!0)}return[]}async scanExistingExtension(B,X,M){const T=await this.P(B,!1,X,!0,M.language,!0,void 0),W=await this.n.scanExtension(T);return!W||!M.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(B,X,M){const T=await this.P(B,!1,X,!0,M.language,!0,void 0),W=await this.n.scanOneOrMultipleExtensions(T);return this.J(W,X,M,!0)}async scanMetadata(B){const X=(0,$.$Ig)(B,"package.json"),M=(await this.w.readFile(X)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(B,X){const M=(0,$.$Ig)(B,"package.json"),T=(await this.w.readFile(M)).value.toString(),W=JSON.parse(T);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,W.__metadata={...W.__metadata,...X},await this.w.writeFile((0,$.$Ig)(B,"package.json"),L.$ke.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof O.$Wp&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$ke.fromString(JSON.stringify([])))}catch(X){(0,r.$Jk)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,X,M,T){return M.includeAllVersions||(B=this.L(X===0?B:void 0,X===1?B:void 0,X==="development"?B:void 0,await this.getTargetPlatform(),T)),M.includeInvalid||(B=B.filter(W=>W.isValid)),B.sort((W,Z)=>{const K=E.$nc(W.location.fsPath),_=E.$nc(Z.location.fsPath);return K<_?-1:K>_?1:0})}L(B,X,M,T,W){const Z=(_,F,C)=>{if(_.isValid&&!F.isValid)return!1;if(_.isValid===F.isValid){if(W&&w.gt(_.manifest.version,F.manifest.version))return this.y.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${_.location.path} with version ${_.manifest.version}`),!1;if(w.eq(_.manifest.version,F.manifest.version)){if(_.type===0)return this.y.debug(`Skipping extension ${F.location.path} in favour of system extension ${_.location.path} with same version`),!1;if(_.targetPlatform===T)return this.y.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return C?this.y.warn(`Overwriting user extension ${_.location.path} with ${F.location.path}.`):this.y.debug(`Overwriting user extension ${_.location.path} with ${F.location.path}.`),!0},K=new g.$pm;return B?.forEach(_=>{const F=K.get(_.identifier.id);(!F||Z(F,_,!1))&&K.set(_.identifier.id,_)}),X?.forEach(_=>{const F=K.get(_.identifier.id);if(!F&&B&&_.type===0){this.y.debug(`Skipping obsolete system extension ${_.location.path}.`);return}(!F||Z(F,_,!1))&&K.set(_.identifier.id,_)}),M?.forEach(_=>{const F=K.get(_.identifier.id);(!F||Z(F,_,!0))&&K.set(_.identifier.id,_),K.set(_.identifier.id,_)}),[...K.values()]}async M(B,X){this.y.trace("Started scanning system extensions");const M=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),W=await(B&&!M.devMode?this.j:this.n).scanExtensions(M);return this.y.trace("Scanned system extensions:",W.length),W}async N(B,X){const M=this.z.isBuilt?[]:this.C.builtInExtensions;if(!M?.length)return[];this.y.trace("Started scanning dev system extensions");const T=X?await this.O():{},W=[],Z=c.URI.file(E.$hc(E.$jc(y.$pg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const _ of M){const F=T[_.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":W.push((0,$.$Ig)(Z,_.name));break;default:W.push(c.URI.file(F));break}}const K=await Promise.all(W.map(async _=>this.n.scanExtension(await this.P(_,!1,0,!0,B,!0,void 0))));return this.y.trace("Scanned dev system extensions:",K.length),(0,N.$Hb)(K)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,X,M,T,W,Z,K){const _=await this.f(W??d.$w),F=await this.Q(B),C=X&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,f=C?await this.Q(C):void 0;return new Y(B,F,C,f,X,K,M,T,Z,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,W,_)}async Q(B){try{const X=await this.w.stat(B);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$3p=Q,e.$3p=Q=$e([se(4,I.$5k),se(5,O.$Xp),se(6,r.$sk),se(7,n.$pj),se(8,m.$ci),se(9,s.$Hj),se(10,v.$3k),se(11,t.$7h)],Q);class Y{constructor(B,X,M,T,W,Z,K,_,F,C,f,S,z,U,H){this.location=B,this.mtime=X,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=T,this.profile=W,this.profileScanOptions=Z,this.type=K,this.excludeObsolete=_,this.validate=F,this.productVersion=C,this.productDate=f,this.productCommit=S,this.devMode=z,this.language=U,this.translations=H}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,X){return(0,$.$Bg)(B.location,X.location)&&B.mtime===X.mtime&&(0,$.$Bg)(B.applicationExtensionslocation,X.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&B.profile===X.profile&&R.$Cn(B.profileScanOptions,X.profileScanOptions)&&B.type===X.type&&B.excludeObsolete===X.excludeObsolete&&B.validate===X.validate&&B.productVersion===X.productVersion&&B.productDate===X.productDate&&B.productCommit===X.productCommit&&B.devMode===X.devMode&&B.language===X.language&&q.equals(B.translations,X.translations)}}e.$4p=Y;let oe=class extends a.$Tc{constructor(B,X,M,T,W){super(),this.f=B,this.g=X,this.h=M,this.j=T,this.m=W}async scanExtensions(B){const X=B.profile?await this.r(B):await this.n(B);let M={};if(B.excludeObsolete&&B.type===1)try{const T=(await this.j.readFile(this.f)).value.toString();M=JSON.parse(T)}catch{}return(0,b.$Wf)(M)?X:X.filter(T=>!M[u.$4o.create(T).toString()])}async n(B){const X=await this.j.resolve(B.location);if(!X.children?.length)return[];const M=await Promise.all(X.children.map(async T=>{if(!T.isDirectory||B.type===1&&(0,$.$Fg)(T.resource).indexOf(".")===0)return null;const W=new Y(T.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(W)}));return(0,N.$Hb)(M).sort((T,W)=>T.location.path<W.location.path?-1:1)}async r(B){let X=await this.s(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){X=X.filter(T=>!T.metadata?.isApplicationScoped);const M=await this.s(B.applicationExtensionslocation,T=>!!T.metadata?.isBuiltin||!!T.metadata?.isApplicationScoped,B);X.push(...M)}return X}async s(B,X,M){const T=await this.g.scanProfileExtensions(B,M.profileScanOptions);if(!T.length)return[];const W=await Promise.all(T.map(async Z=>{if(X(Z)){const K=new Y(Z.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(K,Z.metadata)}return null}));return(0,N.$Hb)(W)}async scanOneOrMultipleExtensions(B){try{if(await this.j.exists((0,$.$Ig)(B.location,"package.json"))){const X=await this.scanExtension(B);return X?[X]:[]}else return await this.scanExtensions(B)}catch(X){return this.m.error(`Error scanning extensions at ${B.location.path}:`,(0,A.$0)(X)),[]}}async scanExtension(B,X){try{let M=await this.scanExtensionManifest(B.location);if(M){M.publisher||(M.publisher=g.$jm),X=X??M.__metadata,delete M.__metadata;const T=(0,u.$8o)(M.publisher,M.name),W=X?.id?{id:T,uuid:X.id}:{id:T},Z=X?.isSystem?0:B.type,K=Z===0||!!X?.isBuiltin;M=await this.t(B.location,M,Y.createNlsConfiguration(B));const _={type:Z,identifier:W,manifest:M,location:B.location,isBuiltin:K,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return B.validate?this.validate(_,B):_}}catch(M){B.type!==0&&this.m.error(M)}return null}validate(B,X){let M=!0;const T=(0,i.$gp)(X.productVersion,X.productDate,X.location,B.manifest,B.isBuiltin);for(const[W,Z]of T)W===P.default.Error&&(M=!1,this.m.error(this.z(X.location,Z)));return B.isValid=M,B.validations=T,B}async scanExtensionManifest(B){const X=(0,$.$Ig)(B,"package.json");let M;try{M=(await this.j.readFile(X)).value.toString()}catch(W){return(0,r.$Jk)(W)!==1&&this.m.error(this.z(B,(0,p.localize)(0,null,X.path,W.message))),null}let T;try{T=JSON.parse(M)}catch{const Z=[];(0,k.$fn)(M,Z);for(const K of Z)this.m.error(this.z(B,(0,p.localize)(1,null,X.path,K.offset,K.length,(0,h.$Zp)(K.error))));return null}return(0,k.$on)(T)!=="object"?(this.m.error(this.z(B,(0,p.localize)(2,null,X.path))),null):T}async t(B,X,M){const T=await this.u(B,X,M);if(T)try{const W=[],Z=await this.w(T.default,W);if(W.length>0)return W.forEach(_=>{this.m.error(this.z(B,(0,p.localize)(3,null,T.default?.path,(0,h.$Zp)(_.error))))}),X;if((0,k.$on)(T)!=="object")return this.m.error(this.z(B,(0,p.localize)(4,null,T.default?.path))),X;const K=T.values||Object.create(null);return(0,j.$1p)(this.m,X,K,Z)}catch{}return X}async u(B,X,M){const T=(0,$.$Ig)(B,"package.nls.json"),W=(F,C)=>{C.forEach(f=>{this.m.error(this.z(B,(0,p.localize)(5,null,F?.path,(0,h.$Zp)(f.error))))})},Z=F=>{this.m.error(this.z(B,(0,p.localize)(6,null,F?.path)))},K=`${X.publisher}.${X.name}`,_=M.translations[K];if(_)try{const F=c.URI.file(_),C=(await this.j.readFile(F)).value.toString(),f=[],S=(0,k.$fn)(C,f);return f.length>0?(W(F,f),{values:void 0,default:T}):(0,k.$on)(S)!=="object"?(Z(F),{values:void 0,default:T}):{values:S.contents?S.contents.package:void 0,default:T}}catch{return{values:void 0,default:T}}else{if(!await this.j.exists(T))return;let C;try{C=await this.y(B,M)}catch{return}if(!C.localized)return{values:void 0,default:C.original};try{const f=(await this.j.readFile(C.localized)).value.toString(),S=[],z=(0,k.$fn)(f,S);return S.length>0?(W(C.localized,S),{values:void 0,default:C.original}):(0,k.$on)(z)!=="object"?(Z(C.localized),{values:void 0,default:C.original}):{values:z,default:C.original}}catch{return{values:void 0,default:C.original}}}}async w(B,X){if(B)try{const M=(await this.j.readFile(B)).value.toString();return(0,k.$fn)(M,X)}catch{}}y(B,X){return new Promise((M,T)=>{const W=Z=>{const K=(0,$.$Ig)(B,`package.nls.${Z}.json`);this.j.exists(K).then(_=>{_&&M({localized:K,original:(0,$.$Ig)(B,"package.nls.json")});const F=Z.lastIndexOf("-");F===-1?M({localized:(0,$.$Ig)(B,"package.nls.json"),original:null}):(Z=Z.substring(0,F),W(Z))})};if(X.devMode||X.pseudo||!X.language)return M({localized:(0,$.$Ig)(B,"package.nls.json"),original:null});W(X.language)})}z(B,X){return`[${B.path}]: ${X}`}};oe=$e([se(1,O.$Xp),se(2,v.$3k),se(3,r.$sk),se(4,n.$pj)],oe);let re=class extends oe{constructor(B,X,M,T,W,Z,K){super(X,T,W,Z,K),this.G=B,this.H=M,this.D=this.B(new D.$6g(3e3)),this.F=this.B(new o.$Wd),this.onDidChangeCache=this.F.event}async scanExtensions(B){const X=this.M(B),M=await this.I(X);if(this.C=B,M&&M.input&&Y.equals(M.input,this.C))return this.m.debug("Using cached extensions scan result",B.location.toString()),this.D.trigger(()=>this.L()),M.result.map(W=>(W.location=c.URI.revive(W.location),W));const T=await super.scanExtensions(B);return await this.J(X,{input:B,result:T}),T}async I(B){try{const X=await this.j.readFile(B),M=JSON.parse(X.value.toString());return{result:M.result,input:(0,l.$Eh)(M.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",B.path,(0,A.$0)(X))}return null}async J(B,X){try{await this.j.writeFile(B,L.$ke.fromString(JSON.stringify(X)))}catch(M){this.m.debug("Error while writing the extension cache file:",B.path,(0,A.$0)(M))}}async L(){if(!this.C)return;const B=this.M(this.C),X=await this.I(B);if(!X)return;const M=X.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!R.$Cn(T,M))try{this.m.info("Invalidating Cache",M,T),await this.j.del(B),this.F.fire()}catch(W){this.m.error(W)}}M(B){const X=this.N(B);return this.h.extUri.joinPath(X.cacheHome,B.type===0?g.$im:g.$hm)}N(B){return B.type===0?this.H.defaultProfile:B.profile?this.h.extUri.isEqual(B.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(B.location,X.extensionsResource))??this.G:this.H.defaultProfile}};re=$e([se(2,I.$5k),se(3,O.$Xp),se(4,v.$3k),se(5,r.$sk),se(6,n.$pj)],re);function he(ae,B){const X=(0,u.$6o)(ae.manifest.publisher,ae.manifest.name);return{id:X,identifier:new g.$nm(X),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:B,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}e.$5p=he;class de extends Q{constructor(B,X,M,T,W,Z,K,_,F,C,f,S){super(B,X,(0,$.$Ig)(M,".vscode-oss-dev","extensions","control.json"),T,W,Z,K,_,F,C,f,S),this.R=(async()=>{if(d.$z)try{const z=await this.w.readFile(c.URI.file(d.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(B){return this.R}}e.$6p=de}),define(ie[158],ne([0,1,58,9,34,6,2,15,16,24,4,23]),function(J,e,N,D,R,L,A,k,h,a,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;let d=class extends A.$Tc{constructor(w,P){super(),this.b=w,this.f=P,this.a=new D.$bh(5)}async postUninstall(w){const P=this.g(w,"uninstall");P&&(this.f.info(w.identifier.id,w.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(P.script,"uninstall",P.args,!0,w),this.f.info("Finished running post uninstall script",w.identifier.id,w.manifest.version)}catch(b){this.f.error("Failed to run post uninstall script",w.identifier.id,w.manifest.version),this.f.error(b)}}));try{await a.Promises.rm(this.m(w))}catch(b){this.f.error("Error while removing extension storage path",w.identifier.id),this.f.error(b)}}g(w,P){const b=`vscode:${P}`;if(w.location.scheme===k.Schemas.file&&w.manifest&&w.manifest.scripts&&typeof w.manifest.scripts[b]=="string"){const c=w.manifest.scripts[b].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(w.identifier.id,w.manifest.version,`${b} should be a node script`),null):{script:(0,h.$jc)(w.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(w,P,b,c,p){return new Promise((m,u)=>{const g=this.j(w,P,b,p);let i;const r=t=>{i&&(clearTimeout(i),i=null),t?u(t):m(void 0)};g.on("error",t=>{r((0,R.$Si)(t)||"Unknown")}),g.on("exit",(t,n)=>{r(t?`post-${P} process exited with code ${t}`:void 0)}),c&&(i=setTimeout(()=>{i=null,g.kill(),u("timed out")},5e3))})}j(w,P,b,c){const p={silent:!0,execArgv:void 0},m=(0,N.fork)(w,[`--type=extension-post-${P}`,...b],p);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const u=L.Event.fromNodeEventEmitter(m.stdout,"data"),g=L.Event.fromNodeEventEmitter(m.stderr,"data");u(t=>this.f.info(c.identifier.id,c.manifest.version,`post-${P}`,t)),g(t=>this.f.error(c.identifier.id,c.manifest.version,`post-${P}`,t));const i=L.Event.any(L.Event.map(u,t=>({data:`%c${t}`,format:[""]})),L.Event.map(g,t=>({data:`%c${t}`,format:["color: red"]})));return L.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),m}m(w){return(0,h.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,w.identifier.id.toLowerCase())}};e.$8p=d,e.$8p=d=$e([se(0,E.$5k),se(1,y.$pj)],d)}),define(ie[159],ne([0,1,9,14,20,34,7,6,43,2,31,15,16,17,44,3,11,28,24,49,99,59,18,157,21,26,42,52,144,158,116,137,145,50,13,10,4,32,25,22,23]),function(J,e,N,D,R,L,A,k,h,a,y,E,d,$,w,P,b,c,p,m,u,g,i,r,t,n,s,o,l,O,I,v,j,q,Q,Y,oe,re,he,de,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.$aq=e.$_p=void 0,e.$_p=(0,Y.$9h)(t.$Eo);const B=".vsctmp";let X=class extends r.$Sp{constructor(F,C,f,S,z,U,H,G,te,le,ue,me){super(F,C,ue,f,le,me),this.eb=z,this.fb=U,this.gb=H,this.hb=te,this.db=new Map,this.qb=new y.$Bc;const we=this.B(G.createInstance(O.$8p));this.ab=this.B(G.createInstance(M,ce=>we.postUninstall(ce))),this.bb=this.B(new v.$0p(me,te,ue,this,this.F)),this.cb=this.B(G.createInstance(l.$7p));const fe=this.B(new j.$$p(this,this.eb,me,U,ue,te,f));this.B(fe.onDidChangeExtensionsByAnotherSource(ce=>this.pb(ce))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,n.$bp)(this.hb,this.F)),this.ib}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const C=await this.ob(F),f=await(0,m.zip)((0,$.$Ig)(this.cb.extensionsDownloadDir,(0,c.$rg)()).fsPath,C);return b.URI.file(f)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:C,cleanup:f}=await this.kb(F),S=d.$kc(C.fsPath);try{return await(0,I.$9p)(S)}finally{await f()}}getInstalled(F,C=this.H.defaultProfile.extensionsResource){return this.ab.scanExtensions(F??null,C)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.ab.scanUserExtensionAtLocation(F)}async install(F,C={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:f,cleanup:S}=await this.kb(F);try{const z=await(0,I.$9p)(d.$kc(f.fsPath)),U=(0,n.$8o)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,q.$ip)(z.engines.vscode,this.G.version,this.G.date))throw new Error(u.localize(0,null,U,this.G.version));const G=(await this.I([{manifest:z,extension:f,options:C}])).find(({identifier:te})=>(0,n.$3o)(te,{id:U}));if(G?.local)return G.local;throw G?.error?G.error:(0,r.$Up)(new Error(`Unknown error while installing extension ${U}`))}finally{await S()}}async installFromLocation(F,C){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const f=await this.ab.scanUserExtensionAtLocation(F);if(!f||!f.manifest.name||!f.manifest.version)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.tb([[f,void 0]],C),this.F.info("Successfully installed extension",f.identifier.id,C.toString()),f}async installExtensionsFromProfile(F,C,f){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,C.toString(),f.toString());const S=(await this.ab.scanExtensions(1,C)).filter(z=>F.some(U=>(0,n.$3o)(U,z.identifier)));if(S.length){const z=await Promise.all(S.map(U=>this.ab.scanMetadata(U,C)));await this.tb(S.map((U,H)=>[U,z[H]]),f),this.F.info("Successfully installed extensions",S.map(U=>U.identifier.id),f.toString())}return S}async updateMetadata(F,C,f=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),C.isPreReleaseVersion&&(C.preRelease=!0,C.hasPreReleaseVersion=!0),C.isMachineScoped===!1&&(C.isMachineScoped=void 0),C.isBuiltin===!1&&(C.isBuiltin=void 0),C.pinned===!1&&(C.pinned=void 0),F=await this.ab.updateMetadata(F,C,f),this.bb.invalidate(f),this.w.fire(F),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(u.localize(1,null));const C=await this.getTargetPlatform(),[f]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:C,compatible:!0},R.CancellationToken.None);if(!f)throw new Error(u.localize(2,null));await this.ab.setUninstalled(F);try{await this.ab.removeUninstalledExtension(F)}catch(S){throw new Error(u.localize(3,null,(0,L.$Si)(S)))}return this.installFromGallery(f)}$(F,C,f,S){return this.ab.copyExtension(F,C,f,S)}copyExtensions(F,C){return this.ab.copyExtensions(F,C)}markAsUninstalled(...F){return this.ab.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(F){this.F.error(F)}}async download(F,C,f){const{location:S}=await this.cb.download(F,C,!f);return S}async kb(F){if(F.scheme===E.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const C=(0,$.$Ig)(this.cb.extensionsDownloadDir,(0,c.$rg)());return await this.gb.download(F,C),this.F.info("Downloaded extension to",C.toString()),{location:C,cleanup:async()=>{try{await this.hb.del(C)}catch(S){this.F.error(S)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(F,C,f){if(b.URI.isUri(C))return new Z(F,C,f,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const S=n.$4o.create(C).toString();let z=this.db.get(S);return z||(this.db.set(S,z=new W(F,C,f,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.db.delete(S))),z}Z(F,C){return new K(F,C.profileLocation,this.fb)}async ob(F){const C=async S=>{let z=await p.Promises.readdir(S);z=z.map(G=>d.$jc(S,G));const U=await Promise.all(z.map(G=>p.Promises.stat(G)));let H=Promise.resolve([]);return U.forEach((G,te)=>{const le=z[te];G.isFile()&&(H=H.then(ue=>[...ue,le])),G.isDirectory()&&(H=H.then(ue=>C(le).then(me=>[...ue,...me])))}),H};return(await C(F.location.fsPath)).map(S=>({path:`extension/${d.$lc(F.location.fsPath,S)}`,localPath:S}))}async pb({added:F,removed:C}){if(C){const f=F&&this.D.extUri.isEqual(C.profileLocation,F.profileLocation)?C.extensions.filter(S=>F.extensions.every(z=>!(0,n.$3o)(z,S))):C.extensions;for(const S of f)this.F.info("Extensions removed from another source",S.id,C.profileLocation.toString()),this.u.fire({identifier:S,profileLocation:C.profileLocation})}if(F){const S=(await this.ab.scanExtensions(1,F.profileLocation)).filter(z=>F.extensions.some(U=>(0,n.$3o)(U,z.identifier)));this.s.fire(S.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,F.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:F.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(C=>this.qb.add(C)));const F=await this.hb.resolve(this.eb.userExtensionsLocation);for(const C of F.children??[])C.isDirectory&&this.qb.add(C.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(C=>this.sb(C)))}async sb(F){if(!F.affects(this.eb.userExtensionsLocation,1))return;const C=[];for(const f of F.rawAdded){if(this.qb.has(f)||!this.D.extUri.isEqual(this.D.extUri.dirname(f),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(f,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(f).startsWith(".")||!(await this.hb.stat(f)).isDirectory)continue;const S=await this.ab.scanUserExtensionAtLocation(f);S&&S.installedTimestamp===void 0&&(this.qb.add(f),C.push(S))}C.length&&(await this.tb(C.map(f=>[f,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",C.map(f=>f.identifier.id)))}async tb(F,C){const f=F.map(S=>S[0]);await this.ub(f),await this.fb.addExtensionsToProfile(F,C),this.s.fire(f.map(S=>({local:S,identifier:S.identifier,operation:1,profileLocation:C})))}async ub(F){const C=await this.ab.getUninstalledExtensions();for(const f of F){const S=n.$4o.create(f);C[S.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",S.id),await this.ab.setInstalled(S),this.F.info("Removed the extension from uninstalled list:",S.id))}}};e.$aq=X,e.$aq=X=$e([se(0,t.$Bo),se(1,he.$wl),se(2,oe.$pj),se(3,i.$di),se(4,o.$2p),se(5,s.$Xp),se(6,g.$go),se(7,Y.$7h),se(8,Q.$sk),se(9,re.$Hj),se(10,de.$3k),se(11,ae.$5k)],X);let M=class extends a.$Tc{constructor(F,C,f,S,z,U){super(),this.j=F,this.m=C,this.n=f,this.s=S,this.t=z,this.u=U,this.h=this.B(new k.$Wd),this.onExtract=this.h.event,this.c=(0,$.$Ig)(this.n.userExtensionsLocation,".obsolete"),this.g=new N.$ch}async cleanUp(){await this.H(),await this.G()}async scanExtensions(F,C){const f={includeInvalid:!0,profileLocation:C};let S=[];return F===null||F===0?S.push(...await this.n.scanAllExtensions({includeInvalid:!0},f,!1)):F===1&&S.push(...await this.n.scanUserExtensions(f)),S=F!==null?S.filter(z=>z.type===F):S,Promise.all(S.map(z=>this.F(z)))}async scanAllUserExtensions(F){const C=await this.n.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(C.map(f=>this.F(f)))}async scanUserExtensionAtLocation(F){try{const C=await this.n.scanExistingExtension(F,1,{includeInvalid:!0});if(C)return await this.F(C)}catch(C){this.u.error(C)}return null}async extractUserExtension(F,C,f,S,z){const U=F.toString(),H=b.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$rg)()}`)),G=b.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,U));let te=await this.m.exists(G);if(te&&S){try{await this.y(F.id,G,"removeExisting")}catch{throw new t.$Co(u.localize(4,null,G.fsPath,F.id),t.ExtensionManagementErrorCode.Delete)}te=!1}if(te)await this.n.updateMetadata(G,f);else try{try{this.u.trace(`Started extracting the extension from ${C} to ${G.fsPath}`),await(0,m.$Qp)(C,H.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${G}:`,F.id)}catch(le){let ue=t.ExtensionManagementErrorCode.Extract;throw le instanceof m.$Op&&(le.type==="CorruptZip"?ue=t.ExtensionManagementErrorCode.CorruptZip:le.type==="Incomplete"&&(ue=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$Co(le.message,ue)}await this.n.updateMetadata(H,f);try{this.u.trace(`Started renaming the extension from ${H.fsPath} to ${G.fsPath}`),await this.C(H.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(le){if(le.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.u.info(`Rename failed because of ${(0,A.$0)(le)}. Deleted from extracted location`,H),le}this.h.fire(G)}catch(le){try{await this.m.del(H,{recursive:!0})}catch{}throw le}return this.D(G,1)}async scanMetadata(F,C){return C?(await this.w(F,C))?.metadata:this.n.scanMetadata(F.location)}async w(F,C){return(await this.s.scanProfileExtensions(C)).find(S=>(0,n.$3o)(S.identifier,F.identifier))}async updateMetadata(F,C,f){return f?await this.s.updateMetadata([[F,C]],f):await this.n.updateMetadata(F.location,C),this.D(F.location,F.type,f)}getUninstalledExtensions(){return this.z()}async setUninstalled(...F){const C=F.map(f=>n.$4o.create(f));await this.z(f=>C.forEach(S=>{f[S.toString()]=!0,this.u.info("Marked extension as uninstalled",S.toString())}))}async setInstalled(F){await this.z(C=>delete C[F.toString()])}async removeExtension(F,C){if(this.t.extUri.isEqualOrParent(F.location,this.n.userExtensionsLocation))return this.y(F.identifier.id,F.location,C)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.z(C=>delete C[n.$4o.create(F).toString()])}async copyExtension(F,C,f,S){const z=await this.w(F,C),U=await this.w(F,f);if(S={...z?.metadata,...S},U)if(this.t.extUri.isEqual(U.location,F.location))await this.s.updateMetadata([[F,{...U.metadata,...S}]],f);else{const H=await this.D(U.location,F.type,f);await this.s.removeExtensionFromProfile(H,f),await this.s.addExtensionsToProfile([[F,{...U.metadata,...S}]],f)}else await this.s.addExtensionsToProfile([[F,S]],f);return this.D(F.location,F.type,f)}async copyExtensions(F,C){const f=await this.scanExtensions(1,F),S=await Promise.all(f.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,F)]));await this.s.addExtensionsToProfile(S,C)}async y(F,C,f){this.u.trace(`Deleting ${f} extension from disk`,F,C.fsPath);const S=this.t.extUri.joinPath(this.t.extUri.dirname(C),`${this.t.extUri.basename(C)}.${(0,h.$Vi)((0,c.$rg)()).toString(16)}${B}`);await this.C(C.fsPath,S.fsPath),await this.m.del(S,{recursive:!0}),this.u.info(`Deleted ${f} extension from disk`,F,C.fsPath)}async z(F){return this.g.queue(async()=>{let C;try{C=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(S){if((0,Q.$Jk)(S)!==1)throw S}let f={};if(C)try{f=JSON.parse(C)}catch{}return F&&(F(f),Object.keys(f).length?await this.m.writeFile(this.c,D.$ke.fromString(JSON.stringify(f))):await this.m.del(this.c)),f})}async C(F,C){try{await p.Promises.rename(F,C,2*60*1e3)}catch(f){throw new t.$Co(f.message||u.localize(5,null,F,C),f.code||t.ExtensionManagementErrorCode.Rename)}}async D(F,C,f){if(f){const z=(await this.n.scanUserExtensions({profileLocation:f})).find(U=>this.t.extUri.isEqual(U.location,F));if(z)return this.F(z)}else{const S=await this.n.scanExistingExtension(F,C,{includeInvalid:!0});if(S)return this.F(S)}throw new Error(u.localize(6,null,F.path))}async F(F){const C=await this.m.resolve(F.location);let f,S;return C.children&&(f=C.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,S=C.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:f,changelogUrl:S,publisherDisplayName:F.metadata?.publisherDisplayName||null,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!F.metadata?.hasPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned}}async G(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(F));const C=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),f=new Set;for(const z of C)F[n.$4o.create(z).toString()]||f.add(z.identifier.id.toLowerCase());try{const z=(0,n.$9o)(C,U=>U.identifier);await N.Promises.settled(z.map(async U=>{const H=U.sort((G,te)=>w.rcompare(G.manifest.version,te.manifest.version))[0];f.has(H.identifier.id.toLowerCase())||await this.j(await this.F(H))}))}catch(z){this.u.error(z)}const S=C.filter(z=>z.metadata&&F[n.$4o.create(z).toString()]);await Promise.allSettled(S.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.m.resolve(this.n.userExtensionsLocation)}catch(C){(0,Q.$Jk)(C)!==1&&this.u.error(C);return}if(F?.children)try{await Promise.allSettled(F.children.map(async C=>{if(!(!C.isDirectory||!C.name.endsWith(B))){this.u.trace("Deleting the temporarily deleted folder",C.resource.toString());try{await this.m.del(C.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",C.resource.toString())}catch(f){(0,Q.$Jk)(f)!==1&&this.u.error(f)}}}))}catch{}}};e.$bq=M,e.$bq=M=$e([se(1,Q.$sk),se(2,o.$2p),se(3,s.$Xp),se(4,de.$3k),se(5,oe.$pj)],M);class T extends r.$Vp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,P.$Qf)(this.options.operation)?this.l:this.options.operation}constructor(F,C,f,S,z,U,H,G,te){super(),this.identifier=F,this.source=C,this.options=f,this.m=S,this.n=z,this.o=U,this.p=H,this.q=G,this.s=te,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(F){const[C,f]=await this.x(F);return this.j=C.isBuiltin||C.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[C,f]],this.j),C}async u({zipPath:F,key:C,metadata:f},S,z){let U=await this.v(C);return U?U=await this.m.updateMetadata(U,f):(this.s.trace("Extracting extension...",C.id),U=await this.m.extractUserExtension(C,F,f,S,z),this.s.info("Extracting extension completed.",C.id)),U}async v(F){return await this.w(F)?(this.s.trace("Removing the extension from uninstalled list:",F.id),await this.m.setInstalled(F),this.s.info("Removed the extension from uninstalled list:",F.id),(await this.m.scanAllUserExtensions(!0)).find(S=>n.$4o.create(S).equals(F))):void 0}async w(F){return!!(await this.m.getUninstalledExtensions())[F.toString()]}}class W extends T{constructor(F,C,f,S,z,U,H,G,te,le){super(C.identifier,C,f,z,U,H,G,te,le),this.y=C,this.z=S}async x(F){let C;try{C=await this.m.scanExtensions(null,this.options.profileLocation)}catch(H){throw new t.$Co(H,t.ExtensionManagementErrorCode.Scanning)}const f=C.find(H=>(0,n.$3o)(H.identifier,this.y.identifier));f&&(this.l=3);const S={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||f?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||f?.isMachineScoped,isBuiltin:this.options.isBuiltin||f?.isBuiltin,isSystem:f?.type===0?!0:void 0,updated:!!f,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:f?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??f?.pinned,preRelease:(0,P.$Pf)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||f?.preRelease};if(f?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(f,S),S]}catch(H){throw new t.$Co((0,A.$0)(H),t.ExtensionManagementErrorCode.UpdateMetadata)}const{location:z,verificationStatus:U}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=U,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:n.$4o.create(this.y),metadata:S},!1,F),S]}catch(H){try{await this.z.delete(z)}catch(G){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,A.$0)(G))}throw H}}async B(F){try{await(0,I.$9p)(F)}catch(C){throw new t.$Co((0,r.$Tp)(C).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$cq=W;class Z extends T{constructor(F,C,f,S,z,U,H,G,te,le){super({id:(0,n.$8o)(F.publisher,F.name)},C,f,z,U,H,G,te,le),this.y=F,this.z=C,this.A=S}async h(F){const C=await super.h(F);return this.D(C,F),C}async x(F){const C=new n.$4o(this.identifier,this.y.version),S=(await this.m.scanExtensions(1,this.options.profileLocation)).find(H=>(0,n.$3o)(this.identifier,H.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||S?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||S?.isMachineScoped,isBuiltin:this.options.isBuiltin||S?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??S?.pinned};if(S)if(this.l=3,C.equals(new n.$4o(S.identifier,S.manifest.version)))try{await this.m.removeExtension(S,"existing")}catch{throw new Error(u.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&w.gt(S.manifest.version,this.y.version)&&await this.m.setUninstalled(S);else{const H=await this.v(C);if(H)try{await this.m.removeExtension(H,"existing")}catch{throw new Error(u.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$kc(this.z.fsPath),key:C,metadata:z},!0,F),z]}async D(F,C){try{let[f]=await this.A.getExtensions([{id:F.identifier.id,version:F.manifest.version}],C);if(f||([f]=await this.A.getExtensions([{id:F.identifier.id}],C)),f){const S={id:f.identifier.uuid,publisherDisplayName:f.publisherDisplayName,publisherId:f.publisherId,isPreReleaseVersion:f.properties.isPreReleaseVersion,hasPreReleaseVersion:F.hasPreReleaseVersion||f.properties.isPreReleaseVersion,preRelease:f.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(F,S,this.options.profileLocation)}}catch{}}}class K extends r.$Vp{constructor(F,C,f){super(),this.extension=F,this.j=C,this.k=f}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ie[160],ne([0,1,4,23,22,25,42,13,18,11]),function(J,e,N,D,R,L,A,k,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KO=void 0;let y=class extends A.$Yp{constructor(d,$,w,P,b,c){super(a.URI.file(d.extensionsPath),$,w,P,b,c)}};e.$KO=y,e.$KO=y=$e([se(0,h.$di),se(1,k.$sk),se(2,D.$5k),se(3,R.$3k),se(4,L.$wl),se(5,N.$pj)],y)}),define(ie[161],ne([0,1,11,18,42,52,13,10,4,32,22,23]),function(J,e,N,D,R,L,A,k,h,a,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z$b=void 0;let d=class extends L.$6p{constructor(w,P,b,c,p,m,u,g){super(N.URI.file(p.builtinExtensionsPath),N.URI.file(p.extensionsPath),p.userHome,w.defaultProfile,w,P,b,c,p,m,u,g)}};e.$z$b=d,e.$z$b=d=$e([se(0,E.$5k),se(1,R.$Xp),se(2,A.$sk),se(3,h.$pj),se(4,D.$di),se(5,a.$Hj),se(6,y.$3k),se(7,k.$7h)],d)}),define(ie[162],ne([0,1,9,6,2,127,3,88,10,23]),function(J,e,N,D,R,L,A,k,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$wp=e.$vp=e.$up=void 0,e.$up="__$__isNewStorageMarker",e.$vp="__$__targetStorageMarker",e.$wp=(0,h.$8h)("storageService");var y;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(y||(e.WillSaveStateReason=y={}));var E;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var d;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function $(p){const m=p.get(e.$vp);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}e.$xp=$;class w extends R.$Tc{static{this.a=60*1e3}constructor(m={flushInterval:w.a}){super(),this.m=m,this.b=this.B(new D.$Zd),this.c=this.B(new D.$Zd),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$Wd),this.onWillSaveState=this.f.event,this.h=this.B(new N.$hh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(m,u,g){return D.Event.filter(this.b.event,i=>i.scope===m&&(u===void 0||i.key===u),g)}n(){this.j.value=(0,N.$lh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(m,u){const{key:g,external:i}=u;if(g===e.$vp){switch(m){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:m})}else this.b.fire({scope:m,key:g,target:this.J(m)[g],external:i})}w(m){this.f.fire({reason:m})}get(m,u,g){return this.P(u)?.get(m,g)}getBoolean(m,u,g){return this.P(u)?.getBoolean(m,g)}getNumber(m,u,g){return this.P(u)?.getNumber(m,g)}getObject(m,u,g){return this.P(u)?.getObject(m,g)}storeAll(m,u){this.y(()=>{for(const g of m)this.store(g.key,g.value,g.scope,g.target,u)})}store(m,u,g,i,r=!1){if((0,A.$Sf)(u)){this.remove(m,g,r);return}this.y(()=>{this.z(m,g,i),this.P(g)?.set(m,u,r)})}remove(m,u,g=!1){this.y(()=>{this.z(m,u,void 0),this.P(u)?.delete(m,g)})}y(m){this.b.pause(),this.c.pause();try{m()}finally{this.b.resume(),this.c.resume()}}keys(m,u){const g=[],i=this.J(m);for(const r of Object.keys(i))i[r]===u&&g.push(r);return g}z(m,u,g,i=!1){const r=this.J(u);typeof g=="number"?r[m]!==g&&(r[m]=g,this.P(u)?.set(e.$vp,JSON.stringify(r),i)):typeof r[m]=="number"&&(delete r[m],this.P(u)?.set(e.$vp,JSON.stringify(r),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(m){switch(m){case-1:return this.I;case 0:return this.G;default:return this.D}}L(m){const u=this.P(m);return u?$(u):Object.create(null)}isNew(m){return this.getBoolean(e.$up,m)===!0}async flush(m=y.NONE){this.f.fire({reason:m});const u=this.P(-1),g=this.P(0),i=this.P(1);switch(m){case y.NONE:await N.Promises.settled([u?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await N.Promises.settled([u?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.P(-1)?.items??new Map,u=this.P(0)?.items??new Map,g=this.P(1)?.items??new Map;return c(m,u,g,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(m){return await this.flush(),this.P(m)?.optimize()}async switch(m,u){return this.w(y.NONE),(0,a.$4k)(m)?this.R(m,u):this.S(m,u)}M(m,u){return!(m.id===u.id||P(u)&&P(m))}N(m,u,g){this.y(()=>{const i=new Set;for(const[r,t]of m)i.add(r),u.get(r)!==t&&this.u(g,{key:r,external:!0});for(const[r]of u.items)i.has(r)||this.u(g,{key:r,external:!0})})}}e.$yp=w;function P(p){return p.isDefault||!!p.useDefaultFlags?.globalState}e.$zp=P;class b extends w{constructor(){super(),this.U=this.B(new k.$sp(new k.$tp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new k.$sp(new k.$tp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new k.$sp(new k.$tp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(m=>this.u(1,m))),this.B(this.W.onDidChangeStorage(m=>this.u(0,m))),this.B(this.U.onDidChangeStorage(m=>this.u(-1,m)))}P(m){switch(m){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(m){return!1}}e.$Ap=b;async function c(p,m,u,g,i,r){const t=q=>{try{return JSON.parse(q)}catch{return q}},n=new Map,s=new Map;p.forEach((q,Q)=>{n.set(Q,q),s.set(Q,t(q))});const o=new Map,l=new Map;m.forEach((q,Q)=>{o.set(Q,q),l.set(Q,t(q))});const O=new Map,I=new Map;u.forEach((q,Q)=>{O.set(Q,q),I.set(Q,t(q))}),console.group(g!==i?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const v=[];if(n.forEach((q,Q)=>{v.push({key:Q,value:q})}),console.table(v),console.groupEnd(),console.log(s),g!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const q=[];o.forEach((Q,Y)=>{q.push({key:Y,value:Q})}),console.table(q),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const j=[];O.forEach((q,Q)=>{j.push({key:Q,value:q})}),console.table(j),console.groupEnd(),console.log(I)}e.$Bp=c}),define(ie[163],ne([0,1,19,20,7,12,35,3,11,29,18,21,26,50,13,4,32,45,146,162,25,176]),function(J,e,N,D,R,L,A,k,h,a,y,E,d,$,w,P,b,c,p,m,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.$Ep=void 0;const i=L.$o?"web":(0,E.$xo)(L.$u,A.$ec),r="X-Market-Search-Activity-Id";var t;(function(S){S[S.None=0]="None",S[S.IncludeVersions=1]="IncludeVersions",S[S.IncludeFiles=2]="IncludeFiles",S[S.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",S[S.IncludeSharedAccounts=8]="IncludeSharedAccounts",S[S.IncludeVersionProperties=16]="IncludeVersionProperties",S[S.ExcludeNonValidated=32]="ExcludeNonValidated",S[S.IncludeInstallationTargets=64]="IncludeInstallationTargets",S[S.IncludeAssetUri=128]="IncludeAssetUri",S[S.IncludeStatistics=256]="IncludeStatistics",S[S.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",S[S.Unpublished=4096]="Unpublished",S[S.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...S){return String(S.reduce((z,U)=>z|U,0))}var s;(function(S){S[S.Tag=1]="Tag",S[S.ExtensionId=4]="ExtensionId",S[S.Category=5]="Category",S[S.ExtensionName=7]="ExtensionName",S[S.Target=8]="Target",S[S.Featured=9]="Featured",S[S.SearchText=10]="SearchText",S[S.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class v{constructor(z=I){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,U=this.d.pageSize){return new v({...this.d,pageNumber:z,pageSize:U})}withFilter(z,...U){const H=[...this.d.criteria,...U.length?U.map(G=>({filterType:z,value:G})):[{filterType:z}]];return new v({...this.d,criteria:H})}withSortBy(z){return new v({...this.d,sortBy:z})}withSortOrder(z){return new v({...this.d,sortOrder:z})}withFlags(...z){return new v({...this.d,flags:z.reduce((U,H)=>U|H,0)})}withAssetTypes(...z){return new v({...this.d,assetTypes:z})}withSource(z){return new v({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:U,pageSize:H,sortBy:G,sortOrder:te,flags:le,assetTypes:ue}=this.d;return{filters:[{criteria:z,pageNumber:U,pageSize:H,sortBy:G,sortOrder:te}],assetTypes:ue,flags:le}}get searchText(){const z=this.d.criteria.filter(U=>U.filterType===s.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function j(S,z){const U=(S||[]).filter(H=>H.statisticName===z)[0];return U?U.value:0}function q(S){const z="Microsoft.VisualStudio.Code.Translation.";return S.files.filter(H=>H.assetType.indexOf(z)===0).reduce((H,G)=>{const te=oe(S,G.assetType);return te&&H.push([G.assetType.substring(z.length),te]),H},[])}function Q(S){if(S.properties){const z=S.properties.filter(G=>G.key===o.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),H=z.filter(G=>U.test(G.value))[0];return H?{uri:H.value,fallbackUri:H.value}:null}return oe(S,o.Repository)}function Y(S){return{uri:`${S.fallbackAssetUri}/${o.VSIX}?redirect=true${S.targetPlatform?`&targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${o.VSIX}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}}function oe(S,z){return S.files.filter(H=>H.assetType===z)[0]?{uri:`${S.assetUri}/${z}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${z}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}:null}function re(S,z){const U=S.properties?S.properties.filter(G=>G.key===z):[],H=U.length>0&&U[0].value;return H?H.split(",").map(G=>(0,d.$7o)(G)):[]}function he(S){const z=S.properties?S.properties.filter(U=>U.key===l.Engine):[];return z.length>0&&z[0].value||""}function de(S){const z=S.properties?S.properties.filter(U=>U.key===l.PreRelease):[];return z.length>0&&z[0].value==="true"}function ae(S){const z=S.properties?S.properties.filter(H=>H.key===l.LocalizedLanguages):[],U=z.length>0&&z[0].value||"";return U?U.split(","):[]}function B(S){return S.properties?.find(z=>z.key===l.SponsorLink)?.value}function X(S){return S.properties?.find(z=>z.key===l.SupportLink)?.value}function M(S){return S.indexOf("preview")!==-1}function T(S){return S.targetPlatform?(0,E.$wo)(S.targetPlatform):"undefined"}function W(S){const z=(0,N.$Mb)(S.versions.map(T)),U=!!S.tags?.includes(E.$ro),H=z.indexOf("web");return U?H===-1&&z.push("web"):H!==-1&&z.splice(H,1),z}function Z(S,z){for(let U=0;U<S.length;U++){const H=S[U];if(H.version===S[U-1]?.version){let G=U;if(T(H)===z)for(;G>0&&S[G-1].version===H.version;)G--;G!==U&&(S.splice(U,1),S.splice(G,0,H))}}return S}e.$Ep=Z;function K(S,z,U){S.telemetryData={index:z,querySource:U,queryActivityId:S.queryContext?.[r]}}function _(S,z,U,H){const G=S.versions[0],te={manifest:oe(z,o.Manifest),readme:oe(z,o.Details),changelog:oe(z,o.Changelog),license:oe(z,o.License),repository:Q(z),download:Y(z),icon:oe(z,o.Icon),signature:oe(z,o.Signature),coreTranslations:q(z)};return{identifier:{id:(0,d.$8o)(S.publisher.publisherName,S.extensionName),uuid:S.extensionId},name:S.extensionName,version:z.version,displayName:S.displayName,publisherId:S.publisher.publisherId,publisher:S.publisher.publisherName,publisherDisplayName:S.publisher.displayName,publisherDomain:S.publisher.domain?{link:S.publisher.domain,verified:!!S.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(G),description:S.shortDescription||"",installCount:j(S.statistics,"install"),rating:j(S.statistics,"averagerating"),ratingCount:j(S.statistics,"ratingcount"),categories:S.categories||[],tags:S.tags||[],releaseDate:Date.parse(S.releaseDate),lastUpdated:Date.parse(S.lastUpdated),allTargetPlatforms:U,assets:te,properties:{dependencies:re(z,l.Dependency),extensionPack:re(z,l.ExtensionPack),engine:he(z),localizedLanguages:ae(z),targetPlatform:T(z),isPreReleaseVersion:de(z)},hasPreReleaseVersion:de(G),hasReleaseVersion:!0,preview:M(S.flags),isSigned:!!te.signature,queryContext:H,supportLink:X(G)}}let F=class{constructor(z,U,H,G,te,le,ue,me){this.k=U,this.l=H,this.n=G,this.o=te,this.q=le,this.u=ue,this.w=me;const we=ue.extensionsGallery,fe=we?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.d=fe?we.servicePPEUrl:we?.serviceUrl,this.g=fe?void 0:we?.searchUrl,this.h=we?.controlUrl,this.j=(0,p.$Dp)(ue.version,ue,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,U,H){const G=D.CancellationToken.isCancellationToken(U)?{}:U,te=D.CancellationToken.isCancellationToken(U)?U:H,le=[],ue=[],me=[],we=[];let fe=!0;for(const be of z){be.uuid?ue.push(be.uuid):le.push(be.id);const ke=!!(be.version||be.preRelease);me.push({id:be.id,uuid:be.uuid,includePreRelease:ke}),be.version&&we.push({id:be.id,uuid:be.uuid,version:be.version}),fe=fe&&!!be.hasPreRelease&&!ke}if(!ue.length&&!le.length)return[];let ce=new v().withPage(1,z.length);ue.length&&(ce=ce.withFilter(s.ExtensionId,...ue)),le.length&&(ce=ce.withFilter(s.ExtensionName,...le)),(G.queryAllVersions||fe)&&(ce=ce.withFlags(ce.flags,t.IncludeVersions)),G.source&&(ce=ce.withSource(G.source));const{extensions:pe}=await this.z(ce,{targetPlatform:G.targetPlatform??i,includePreRelease:me,versions:we,compatible:!!G.compatible},te);return G.source&&pe.forEach((be,ke)=>K(be,ke,G.source)),pe}async getCompatibleExtension(z,U,H){if((0,E.$yo)(z.allTargetPlatforms,H))return null;if(await this.isExtensionCompatible(z,U,H))return z;const G=new v().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,z.identifier.uuid),{extensions:te}=await this.z(G,{targetPlatform:H,compatible:!0,includePreRelease:U},D.CancellationToken.None);return te[0]||null}async isExtensionCompatible(z,U,H){if(!(0,E.$zo)(z.properties.targetPlatform,z.allTargetPlatforms,H)||!U&&z.properties.isPreReleaseVersion)return!1;let G=z.properties.engine;if(!G){const te=await this.getManifest(z,D.CancellationToken.None);if(!te)throw new Error("Manifest was not found");G=te.engines.vscode}return(0,$.$ip)(G,this.u.version,this.u.date)}async y(z,U,H,G,te){if(!(0,E.$zo)(T(z),G,te)||U!=="any"&&de(z)!==(U==="prerelease"))return!1;if(H)try{const le=await this.E(z);if(!(0,$.$ip)(le,this.u.version,this.u.date))return!1}catch(le){return this.l.error(`Error while getting the engine for the version ${z.version}.`,(0,R.$0)(le)),!1}return!0}async query(z,U){let H=z.text||"";const G=z.pageSize??50;let te=new v().withPage(1,G);H?(H=H.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,ce,pe)=>(te=te.withFilter(s.Category,pe||ce),"")),H=H.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,ce,pe)=>(te=te.withFilter(s.Tag,pe||ce),"")),H=H.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(s.Featured),"")),H=H.trim(),H&&(H=H.length<200?H:H.substring(0,200),te=te.withFilter(s.SearchText,H)),te=te.withSortBy(0)):z.ids?te=te.withFilter(s.ExtensionId,...z.ids):z.names?te=te.withFilter(s.ExtensionName,...z.names):te=te.withSortBy(4),typeof z.sortBy=="number"&&(te=te.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(te=te.withSortOrder(z.sortOrder)),z.source&&(te=te.withSource(z.source));const le=async(fe,ce)=>{const{extensions:pe,total:be}=await this.z(fe,{targetPlatform:i,compatible:!1,includePreRelease:!!z.includePreRelease},ce);return pe.forEach((ke,je)=>K(ke,(fe.pageNumber-1)*fe.pageSize+je,z.source)),{extensions:pe,total:be}},{extensions:ue,total:me}=await le(te,U),we=async(fe,ce)=>{if(ce.isCancellationRequested)throw new R.$5;const{extensions:pe}=await le(te.withPage(fe+1),ce);return pe};return{firstPage:ue,total:me,pageSize:te.pageSize,getPage:we}}async z(z,U,H){const G=z.flags;z.flags&t.IncludeLatestVersionOnly&&z.flags&t.IncludeVersions&&(z=z.withFlags(z.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(z.flags&t.IncludeLatestVersionOnly)&&!(z.flags&t.IncludeVersions)&&(z=z.withFlags(z.flags,t.IncludeLatestVersionOnly)),U.versions?.length&&(z=z.withFlags(z.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),z=z.withFlags(z.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:te,total:le,context:ue}=await this.B(z,H);if(!(z.flags&t.IncludeLatestVersionOnly)){const ce=[];for(const pe of te){const be=await this.A(pe,U,ue);be&&ce.push(be)}return{extensions:ce,total:le}}const we=[],fe=new Map;for(let ce=0;ce<te.length;ce++){const pe=te[ce],be={id:(0,d.$8o)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},ke=(0,k.$Pf)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(V=>(0,d.$3o)(V,be))?.includePreRelease;if(U.compatible&&(0,E.$yo)(W(pe),U.targetPlatform))continue;const je=await this.A(pe,U,ue);!je||je.properties.isPreReleaseVersion&&(!ke||!je.hasReleaseVersion)||!je.properties.isPreReleaseVersion&&je.properties.targetPlatform!==U.targetPlatform&&je.hasPreReleaseVersion?fe.set(pe.extensionId,ce):we.push([ce,je])}if(fe.size){const ce=new g.$Sd,pe=new v().withFlags(G&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,fe.size).withFilter(s.ExtensionId,...fe.keys()),{extensions:be}=await this.z(pe,U,H);this.o.publicLog2("galleryService:additionalQuery",{duration:ce.elapsed(),count:fe.size});for(const ke of be){const je=fe.get(ke.identifier.uuid);we.push([je,ke])}}return{extensions:we.sort((ce,pe)=>ce[0]-pe[0]).map(([,ce])=>ce),total:le}}async A(z,U,H){const G={id:(0,d.$8o)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},te=U.versions?.find(we=>(0,d.$3o)(we,G))?.version,le=(0,k.$Pf)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(we=>(0,d.$3o)(we,G))?.includePreRelease,ue=W(z),me=Z(z.versions,U.targetPlatform);if(U.compatible&&(0,E.$yo)(ue,U.targetPlatform))return null;for(let we=0;we<me.length;we++){const fe=me[we];if(!(te&&fe.version!==te)){if(await this.y(fe,le?"any":"release",U.compatible,ue,U.targetPlatform))return _(z,fe,ue,H);if(te&&fe.version===te)return null}}return te||U.compatible?null:_(z,z.versions[0],ue)}async B(z,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(t.Unpublished));const H=await this.j,G=JSON.stringify(z.raw),te={...H,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},le=new g.$Sd;let ue,me,we=0;try{if(ue=await this.k.request({type:"POST",url:this.g&&z.criteria.some(ce=>ce.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:te},U),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:we};const fe=await(0,c.$pp)(ue);if(fe){const ce=fe.results[0],pe=ce.extensions,be=ce.resultMetadata&&ce.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return we=be&&be.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:we,context:{[r]:ue.res.headers.activityid}}}return{galleryExtensions:[],total:we}}catch(fe){const ce=(0,R.$4)(fe)?E.ExtensionGalleryErrorCode.Cancelled:(0,R.$0)(fe).startsWith("XHR timeout")?E.ExtensionGalleryErrorCode.Timeout:E.ExtensionGalleryErrorCode.Failed;throw me=new E.$Do((0,R.$0)(fe),ce),me}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(G.length),duration:le.elapsed(),success:!!ue&&(0,c.$lp)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:me?.code,count:String(we)})}}async reportStatistic(z,U,H,G){if(!this.isEnabled())return;const te=L.$o?this.x(`/itemName/${z}.${U}/version/${H}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${U}/${H}/stats?statType=${G}`),le=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.j,Accept:le};try{await this.k.request({type:"POST",url:te,headers:me},D.CancellationToken.None)}catch{}}async download(z,U,H){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const G=(0,d.$$o)(z),te=new Date().getTime(),le=ce=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:ce}),ue=H===2?"install":H===3?"update":"",me=ue?{uri:`${z.assets.download.uri}${h.URI.parse(z.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${z.assets.download.fallbackUri}${h.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:z.assets.download,we=z.queryContext?.[r]?{[r]:z.queryContext[r]}:void 0,fe=await this.D(me,we?{headers:we}:void 0);await this.q.writeFile(U,fe.stream),le(new Date().getTime()-te)}async downloadSignatureArchive(z,U){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const H=await this.D(z.assets.signature);await this.q.writeFile(U,H.stream)}async getReadme(z,U){if(z.assets.readme){const H=await this.D(z.assets.readme,{},U);return await(0,c.$op)(H)||""}return""}async getManifest(z,U){if(z.assets.manifest){const H=await this.D(z.assets.manifest,{},U),G=await(0,c.$op)(H);return G?JSON.parse(G):null}return null}async C(z,U){const H=oe(z,o.Manifest);if(!H)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},te=await this.D(H,{headers:G});return await(0,c.$pp)(te)}async getCoreTranslation(z,U){const H=z.assets.coreTranslations.filter(G=>G[0]===U.toUpperCase())[0];if(H){const G=await this.D(H[1]),te=await(0,c.$op)(G);return te?JSON.parse(te):null}return null}async getChangelog(z,U){if(z.assets.changelog){const H=await this.D(z.assets.changelog,{},U);return await(0,c.$op)(H)||""}return""}async getAllCompatibleVersions(z,U,H){let G=new v().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?G=G.withFilter(s.ExtensionId,z.identifier.uuid):G=G.withFilter(s.ExtensionName,z.identifier.id);const{galleryExtensions:te}=await this.B(G,D.CancellationToken.None);if(!te.length)return[];const le=W(te[0]);if((0,E.$yo)(le,H))return[];const ue=[];await Promise.all(te[0].versions.map(async fe=>{try{await this.y(fe,U?"any":"release",!0,le,H)&&ue.push(fe)}catch{}}));const me=[],we=new Set;for(const fe of Z(ue,H))we.has(fe.version)||(we.add(fe.version),me.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:de(fe)}));return me}async D(z,U={},H=D.CancellationToken.None){const G=await this.j,te={type:"GET"},le={...G,...U.headers||{}};U={...U,...te,headers:le};const ue=z.uri,me=z.fallbackUri,we={...U,url:ue};try{const fe=await this.k.request(we,H);if(fe.res.statusCode===200)return fe;const ce=await(0,c.$op)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${ce}`)}catch(fe){if((0,R.$4)(fe))throw fe;const ce=(0,R.$0)(fe);this.o.publicLog2("galleryService:cdnFallback",{url:ue,message:ce});const pe={...U,url:me};return this.k.request(pe,H)}}async E(z){let U=he(z);if(!U){const H=await this.C(z,D.CancellationToken.None);if(!H)throw new Error("Manifest was not found");U=H.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,c.$pp)(z),H=[],G={},te=[];if(U){for(const le of U.malicious)H.push({id:le});if(U.migrateToPreRelease)for(const[le,ue]of Object.entries(U.migrateToPreRelease))(!ue.engine||(0,$.$ip)(ue.engine,this.u.version,this.u.date))&&(G[le.toLowerCase()]={disallowInstall:!0,extension:{id:ue.id,displayName:ue.displayName,autoMigrate:{storage:!!ue.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[le,ue]of Object.entries(U.deprecated))ue&&(G[le.toLowerCase()]=(0,k.$Pf)(ue)?{}:ue);if(U.search)for(const le of U.search)te.push(le)}return{malicious:H,deprecated:G,search:te}}};F=$e([se(1,c.$jp),se(2,P.$pj),se(3,y.$ci),se(4,u.$wl),se(5,w.$sk),se(6,b.$Hj),se(7,a.$Bi)],F);let C=class extends F{constructor(z,U,H,G,te,le,ue,me){super(z,U,H,G,te,le,ue,me)}};e.$Fp=C,e.$Fp=C=$e([se(0,m.$wp),se(1,c.$jp),se(2,P.$pj),se(3,y.$ci),se(4,u.$wl),se(5,w.$sk),se(6,b.$Hj),se(7,a.$Bi)],C);let f=class extends F{constructor(z,U,H,G,te,le,ue){super(void 0,z,U,H,G,te,le,ue)}};e.$Gp=f,e.$Gp=f=$e([se(0,c.$jp),se(1,P.$pj),se(2,y.$ci),se(3,u.$wl),se(4,w.$sk),se(5,b.$Hj),se(6,a.$Bi)],f)}),define(ie[164],ne([0,1,11,18,13,4,142,22,23,3,68]),function(J,e,N,D,R,L,A,k,h,a,y){"use strict";var E,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=e.$IO=e.$HO=void 0;let $=class extends h.$8k{static{E=this}static{this.a="profileAssociationsMigration"}constructor(c,p,m,u,g){super(m,u,p,g),this.U=c,this.W=m}O(){return this.U.getItem(E.b,[]).map(p=>({...p,location:(0,a.$Jf)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):N.URI.revive(p.location)}))}Q(){const c=this.U.getItem(E.c,{});return this.U.getItem(E.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(N.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$HO=$,e.$HO=$=E=$e([se(0,A.$CO),se(1,k.$3k),se(2,D.$di),se(3,R.$sk),se(4,L.$pj)],$);let w=d=class extends ${constructor(c,p,m,u,g){super(c,p,m,u,g),this.$=c}P(c){c.length?this.$.setItem(d.b,c.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem(d.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(d.c,c):this.$.removeItem(d.c)}Q(){const c="workspaceAndProfileInfo",p=this.$.getItem(c,void 0);if(p){this.$.removeItem(c);const u=p.reduce((g,{workspace:i,profile:r})=>(g[N.URI.revive(i).toString()]=N.URI.revive(r).toString(),g),{});this.$.setItem(d.c,{workspaces:u})}const m=super.Q();return this.$.getItem(d.a,!1)||(this.R(m),this.$.setItem(d.a,!0)),m}};e.$IO=w,e.$IO=w=d=$e([se(0,A.$DO),se(1,k.$3k),se(2,D.$di),se(3,R.$sk),se(4,L.$pj)],w);let P=class extends w{constructor(c,p,m,u){super(new y.$GO(0,p,u,m),c,p,m,u)}async init(){return await this.$.init(),super.init()}};e.$JO=P,e.$JO=P=$e([se(0,k.$3k),se(1,D.$di),se(2,R.$sk),se(3,L.$pj)],P)}),define(ie[165],ne([0,1,140,9,14,7,3,29,18,141,4,45,139,177]),function(J,e,N,D,R,L,A,k,h,a,y,E,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0;let w=class extends E.$kp{constructor(p,m,u,g){super(g),this.m=p,this.n=m,this.r=u,this.s(),this.B(p.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,m){const{f:u,g}=this;let i;try{i=await(0,a.$bm)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,L.$0)(n)))}const r={...process.env,...i},t=p.agent?p.agent:await(0,d.$or)(p.url||"",r,{proxyUrl:u,strictSSL:g});return p.agent=t,p.strictSSL=g,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>b(p,m))}async resolveProxy(p){}async loadCertificates(){return(await new Promise((m,u)=>{J(["@vscode/proxy-agent"],m,u)})).loadSystemCertificates({log:this.r})}};e.$pr=w,e.$pr=w=$e([se(0,k.$Bi),se(1,h.$di),se(2,y.$pj),se(3,y.$qj)],w);async function P(c){return((0,N.parse)(c.url).protocol==="https:"?await new Promise((u,g)=>{J(["https"],u,g)}):await new Promise((u,g)=>{J(["http"],u,g)})).request}async function b(c,p){return D.Promises.withAsyncBody(async(m,u)=>{const g=(0,N.parse)(c.url),i=c.getRawRequest?c.getRawRequest(c):await P(c),r={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,A.$Pf)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(r.auth=c.user+":"+c.password);const t=i(r,n=>{const s=(0,A.$Nf)(c.followRedirects)?c.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)b({...c,url:n.headers.location,followRedirects:s-1},p).then(m,u);else{let o=n;!c.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,$.createGunzip)())),m({res:n,stream:(0,R.$ze)(o)})}});t.on("error",u),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),p.onCancellationRequested(()=>{t.abort(),u(new L.$5)})})}e.$qr=b}),define(ie[178],ne([0,1,33,9,34,7,2,15,16,12,35,11,24,29,136,59,138,18,114,163,21,64,143,42,52,159,161,13,126,128,51,124,62,63,147,4,132,39,133,150,32,45,165,68,69,25,149,41,151,152,22,154,23,164,153,160,129,131,5,155]),function(J,e,N,D,R,L,A,k,h,a,y,E,d,$,w,P,b,c,p,m,u,g,i,r,t,n,s,o,l,O,I,v,j,q,Q,Y,oe,re,he,de,ae,B,X,M,T,W,Z,K,_,F,C,f,S,z,U,H,G,te,le,ue){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class me extends A.$Tc{constructor(ce){super(),this.b=ce,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[ce,pe]=await this.f();return ce.invokeFunction(async be=>{const ke=be.get(Y.$pj),je=be.get(o.$sk),V=be.get(c.$di),x=be.get(S.$5k);ke.info("CLI main",this.b),this.g(ke),await this.h(V,je,x,ce),await Promise.all(pe.map(ee=>{(0,D.$Yg)(ee.flush(),1e3)}))})}async f(){const ce=new j.$6h,pe={_serviceBrand:void 0,...de.default};ce.set(ae.$Hj,pe);const be=new p.$Em(this.b,pe);ce.set(c.$di,be),await Promise.all([be.appSettingsHome.with({scheme:k.Schemas.file}).fsPath,be.extensionsPath].map(Le=>Le?d.Promises.mkdir(Le,{recursive:!0}):void 0));const ke=new te.$BO((0,Y.$Dj)(be),be.logsHome);ce.set(Y.$qj,ke);const je=this.B(ke.createLogger("cli",{name:(0,le.localize)(0,null)})),V=[];ke.getLogLevel()===Y.LogLevel.Trace&&V.push(new Y.$xj(ke.getLogLevel()));const x=this.B(new G.$LO(je,V));ce.set(Y.$pj,x);const ee=this.B(new l.$eq(x));ce.set(o.$sk,ee);const ge=this.B(new O.$Dq(x));ee.registerProvider(k.Schemas.file,ge);const ye=new f.$4r(ee);ce.set(C.$3k,ye);const De=new M.$FO(1,be,x,ee),Se=new z.$HO(De,ye,be,ee,x);ce.set(S.$5k,Se),ee.registerProvider(k.Schemas.vscodeUserData,new ue.$1$b(k.Schemas.file,ge,k.Schemas.vscodeUserData,Se,ye,x));const ze=a.$i&&pe.win32RegValueName?this.B(new he.$Y$b(x,pe.win32RegValueName)):be.policyFile?this.B(new oe.$Z$b(be.policyFile,ee,x)):new re.$On;ce.set(re.$Mn,ze);const Ie=this.B(new w.$co(Se.defaultProfile.settingsResource,ee,ze,x));ce.set($.$Bi,Ie),await Promise.all([De.init(),Ie.initialize()]);let Ne;try{Ne=await(0,U.$C$b)(De,x)}catch(Le){Le.code!=="ENOENT"&&x.error(Le)}const Ue=await(0,U.$D$b)(De,x);Se.init(),ce.set(C.$3k,new f.$4r(ee));const Oe=new X.$pr(Ie,be,x,ke);ce.set(B.$jp,Oe),ce.set(P.$go,new I.$5h(b.$1O,void 0,!0)),ce.set(r.$Xp,new I.$5h(H.$KO,void 0,!0)),ce.set(t.$2p,new I.$5h(s.$z$b,void 0,!0)),ce.set(g.$Hp,new I.$5h(g.$Ip,void 0,!0)),ce.set(n.$_p,new I.$5h(n.$aq,void 0,!0)),ce.set(u.$Bo,new I.$5h(m.$Gp,void 0,!0)),ce.set(q.$jr,new I.$5h(Q.$lr,void 0,!1));const Ae=[],Ce=(0,K.$Zo)(pe,Ie);if((0,K.$Uo)(pe,be)){pe.aiConfig&&pe.aiConfig.ariaKey&&Ae.push(new _.$zO(Oe,Ce,"monacoworkbench",null,pe.aiConfig.ariaKey));const Le={appenders:Ae,sendErrorTelemetry:!1,commonProperties:(0,T.$Lo)((0,N.release)(),(0,N.hostname)(),process.arch,pe.commit,pe.version,Ne,Ue,Ce),piiPaths:(0,K.$1o)(be)};ce.set(W.$wl,new I.$5h(Z.$rr,[Le],!1))}else ce.set(W.$wl,K.$Po);return[new v.$Gq(ce),Ae]}g(ce){(0,L.setUnexpectedErrorHandler)(pe=>{const be=(0,R.$Si)(pe,!0);be&&ce.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",pe=>{(0,L.$Z)(pe)||(0,L.$1)(pe)}),process.on("unhandledRejection",pe=>(0,L.$1)(pe))}async h(ce,pe,be,ke){let je;if(ce.args.profile&&(je=be.profiles.find(x=>x.name===ce.args.profile),!je))throw new Error(`Profile '${ce.args.profile}' not found.`);const V=(je??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(i.$Jp,new Y.$xj(Y.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const x={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return ke.createInstance(i.$Jp,new Y.$xj(Y.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),x,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(i.$Jp,new Y.$xj(Y.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["update-extensions"])return ke.createInstance(i.$Jp,new Y.$xj(Y.LogLevel.Info,!1)).updateExtensions(V);if(this.b["locate-extension"])return ke.createInstance(i.$Jp,new Y.$xj(Y.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.$m_b)(ce.appRoot,ce.extensionsPath))}}j(ce){return ce.map(pe=>/\.vsix$/i.test(pe)?E.URI.file((0,h.$ic)(pe)?pe:(0,h.$jc)((0,y.cwd)(),pe)):pe)}}async function we(fe){const ce=new me(fe);try{await ce.run()}finally{ce.dispose()}}e.main=we})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2af613979f646fc4dcebfeaedc7d14f138c7b072/core/vs/code/node/cliProcessMain.js.map
