/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function($e){for(var e=[],D=0,N=$e.length;D<N;D++)e[D]=ke[$e[D]];return e};define(ke[157],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const h=new Map,P=new Map,A=new Map,p=new Map;function b(E,S){E.has(S.detail)||E.set(S.detail,-S.timestamp)}function k(E,S){const c=E.get(S.detail);c&&(c>=0||E.set(S.detail,c+S.timestamp))}let R=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(R=$e.getStats().slice(0).sort((E,S)=>E.timestamp-S.timestamp));for(const E of R)switch(E.type){case 10:b(h,E);break;case 11:case 12:k(h,E);break;case 21:b(P,E);break;case 22:k(P,E);break;case 33:b(A,E);break;case 34:k(A,E);break;case 31:b(p,E);break;case 32:k(p,E);break}let C=0;A.forEach(E=>C+=E);function w(E){const S=[];return E.forEach((c,m)=>S.push([m,c])),S}return{amdLoad:w(h),amdInvoke:w(P),nodeRequire:w(A),nodeEval:w(p),nodeRequireTotal:C}}static toMarkdownTable(h,P){let A="";const p=[];return h.forEach((b,k)=>{p[k]=b.length}),P.forEach(b=>{b.forEach((k,R)=>{typeof k>"u"&&(k=b[R]="-");const C=k.toString().length;p[R]=Math.max(C,p[R])})}),h.forEach((b,k)=>{A+=`| ${b+" ".repeat(p[k]-b.toString().length)} `}),A+=`|
`,h.forEach((b,k)=>{A+=`| ${"-".repeat(p[k])} `}),A+=`|
`,P.forEach(b=>{b.forEach((k,R)=>{typeof k<"u"&&(A+=`| ${k+" ".repeat(p[R]-k.toString().length)} `)}),A+=`|
`}),A}}e.$U=D}),define(ke[158],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(c,m,a){const i=N(c,m);if(i!==-1)return c[i]}e.$fb=D;function N(c,m,a=c.length-1){for(let i=a;i>=0;i--){const n=c[i];if(m(n))return i}return-1}e.$gb=N;function h(c,m){const a=P(c,m);return a===-1?void 0:c[a]}e.$hb=h;function P(c,m,a=0,i=c.length){let n=a,r=i;for(;n<r;){const s=Math.floor((n+r)/2);m(c[s])?n=s+1:r=s}return n-1}e.$ib=P;function A(c,m){const a=p(c,m);return a===c.length?void 0:c[a]}e.$jb=A;function p(c,m,a=0,i=c.length){let n=a,r=i;for(;n<r;){const s=Math.floor((n+r)/2);m(c[s])?r=s:n=s+1}return n}e.$kb=p;function b(c,m,a=0,i=c.length){const n=p(c,m,a,i);return n===c.length?-1:n}e.$lb=b;class k{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(k.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!m(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const a=P(this.e,m,this.c);return this.c=a+1,a===-1?void 0:this.e[a]}}e.$mb=k;function R(c,m){if(c.length===0)return;let a=c[0];for(let i=1;i<c.length;i++){const n=c[i];m(n,a)>0&&(a=n)}return a}e.$nb=R;function C(c,m){if(c.length===0)return;let a=c[0];for(let i=1;i<c.length;i++){const n=c[i];m(n,a)>=0&&(a=n)}return a}e.$ob=C;function w(c,m){return R(c,(a,i)=>-m(a,i))}e.$pb=w;function E(c,m){if(c.length===0)return-1;let a=0;for(let i=1;i<c.length;i++){const n=c[i];m(n,c[a])>0&&(a=i)}return a}e.$qb=E;function S(c,m){for(const a of c){const i=m(a);if(i!==void 0)return i}}e.$rb=S}),define(ke[73],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function D(A,p){const b=Object.create(null);for(const k of A){const R=p(k);let C=b[R];C||(C=b[R]=[]),C.push(k)}return b}e.$K=D;function N(A,p){const b=[],k=[];for(const R of A)p.has(R)||b.push(R);for(const R of p)A.has(R)||k.push(R);return{removed:b,added:k}}e.$L=N;function h(A,p){const b=[],k=[];for(const[R,C]of A)p.has(R)||b.push(C);for(const[R,C]of p)A.has(R)||k.push(C);return{removed:b,added:k}}e.$M=h;function P(A,p){const b=new Set;for(const k of p)A.has(k)&&b.add(k);return b}e.$N=P}),define(ke[52],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=void 0;function D(A){return(p,b,k)=>{let R=null,C=null;if(typeof k.value=="function"?(R="value",C=k.value):typeof k.get=="function"&&(R="get",C=k.get),!C)throw new Error("not supported");k[R]=A(C,b)}}function N(A,p,b){let k=null,R=null;if(typeof b.value=="function"?(k="value",R=b.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(k="get",R=b.get),!R)throw new Error("not supported");const C=`$memoize$${p}`;b[k]=function(...w){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,w)}),this[C]}}e.$zh=N;function h(A,p,b){return D((k,R)=>{const C=`$debounce$${R}`,w=`$debounce$result$${R}`;return function(...E){this[w]||(this[w]=b?b():void 0),clearTimeout(this[C]),p&&(this[w]=p(this[w],...E),E=[this[w]]),this[C]=setTimeout(()=>{k.apply(this,E),this[w]=b?b():void 0},A)}})}e.$Ah=h;function P(A,p,b){return D((k,R)=>{const C=`$throttle$timer$${R}`,w=`$throttle$result$${R}`,E=`$throttle$lastRun$${R}`,S=`$throttle$pending$${R}`;return function(...c){if(this[w]||(this[w]=b?b():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),p&&(this[w]=p(this[w],...c)),this[S])return;const m=this[E]+A;m<=Date.now()?(this[E]=Date.now(),k.apply(this,[this[w]]),this[w]=b?b():void 0):(this[S]=!0,this[C]=setTimeout(()=>{this[S]=!1,this[E]=Date.now(),k.apply(this,[this[w]]),this[w]=b?b():void 0},m-Date.now()))}})}e.$Bh=P}),define(ke[14],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(g=>{g(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function N(s){e.$X.setUnexpectedErrorHandler(s)}e.setUnexpectedErrorHandler=N;function h(s){if(!s||typeof s!="object")return!1;const t=s;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=h;function P(s){k(s)||e.$X.onUnexpectedError(s)}e.$1=P;function A(s){k(s)||e.$X.onUnexpectedExternalError(s)}e.$2=A;function p(s){if(s instanceof Error){const{name:t,message:g}=s,o=s.stacktrace||s.stack;return{$isError:!0,name:t,message:g,stack:o,noTelemetry:n.isErrorNoTelemetry(s)}}return s}e.$3=p;const b="Canceled";function k(s){return s instanceof R?!0:s instanceof Error&&s.name===b&&s.message===b}e.$4=k;class R extends Error{constructor(){super(b),this.name=this.message}}e.$5=R;function C(){const s=new Error(b);return s.name=s.message,s}e.$6=C;function w(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}e.$7=w;function E(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}e.$8=E;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=S;function c(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}e.$0=c;class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class a extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=a;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const g=new n;return g.message=t.message,g.stack=t.stack,g}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=n;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$cb=r}),define(ke[19],Se([1,0,14,158]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function h(he,fe=0){return he[he.length-(1+fe)]}e.$sb=h;function P(he){if(he.length===0)throw new Error("Invalid tail call");return[he.slice(0,he.length-1),he[he.length-1]]}e.$tb=P;function A(he,fe,ue=(me,V)=>me===V){if(he===fe)return!0;if(!he||!fe||he.length!==fe.length)return!1;for(let me=0,V=he.length;me<V;me++)if(!ue(he[me],fe[me]))return!1;return!0}e.$ub=A;function p(he,fe){const ue=he.length-1;fe<ue&&(he[fe]=he[ue]),he.pop()}e.$vb=p;function b(he,fe,ue){return k(he.length,me=>ue(he[me],fe))}e.$wb=b;function k(he,fe){let ue=0,me=he-1;for(;ue<=me;){const V=(ue+me)/2|0,Y=fe(V);if(Y<0)ue=V+1;else if(Y>0)me=V-1;else return V}return-(ue+1)}e.$xb=k;function R(he,fe,ue){if(he=he|0,he>=fe.length)throw new TypeError("invalid index");const me=fe[Math.floor(fe.length*Math.random())],V=[],Y=[],de=[];for(const we of fe){const Pe=ue(we,me);Pe<0?V.push(we):Pe>0?Y.push(we):de.push(we)}return he<V.length?R(he,V,ue):he<V.length+de.length?de[0]:R(he-(V.length+de.length),Y,ue)}e.$yb=R;function C(he,fe){const ue=[];let me;for(const V of he.slice(0).sort(fe))!me||fe(me[0],V)!==0?(me=[V],ue.push(me)):me.push(V);return ue}e.$zb=C;function*w(he,fe){let ue,me;for(const V of he)me!==void 0&&fe(me,V)?ue.push(V):(ue&&(yield ue),ue=[V]),me=V;ue&&(yield ue)}e.$Ab=w;function E(he,fe){for(let ue=0;ue<=he.length;ue++)fe(ue===0?void 0:he[ue-1],ue===he.length?void 0:he[ue])}e.$Bb=E;function S(he,fe){for(let ue=0;ue<he.length;ue++)fe(ue===0?void 0:he[ue-1],he[ue],ue+1===he.length?void 0:he[ue+1])}e.$Cb=S;function c(he,fe,ue){const me=[];function V(we,Pe,ve){if(Pe===0&&ve.length===0)return;const Ce=me[me.length-1];Ce&&Ce.start+Ce.deleteCount===we?(Ce.deleteCount+=Pe,Ce.toInsert.push(...ve)):me.push({start:we,deleteCount:Pe,toInsert:ve})}let Y=0,de=0;for(;;){if(Y===he.length){V(Y,0,fe.slice(de));break}if(de===fe.length){V(Y,he.length-Y,[]);break}const we=he[Y],Pe=fe[de],ve=ue(we,Pe);ve===0?(Y+=1,de+=1):ve<0?(V(Y,1,[]),Y+=1):ve>0&&(V(Y,0,[Pe]),de+=1)}return me}e.$Db=c;function m(he,fe,ue){const me=c(he,fe,ue),V=[],Y=[];for(const de of me)V.push(...he.slice(de.start,de.start+de.deleteCount)),Y.push(...de.toInsert);return{removed:V,added:Y}}e.$Eb=m;function a(he,fe,ue){if(ue===0)return[];const me=he.slice(0,ue).sort(fe);return n(he,fe,me,ue,he.length),me}e.top=a;function i(he,fe,ue,me,V){return ue===0?Promise.resolve([]):new Promise((Y,de)=>{(async()=>{const we=he.length,Pe=he.slice(0,ue).sort(fe);for(let ve=ue,Ce=Math.min(ue+me,we);ve<we;ve=Ce,Ce=Math.min(Ce+me,we)){if(ve>ue&&await new Promise(B=>setTimeout(B)),V&&V.isCancellationRequested)throw new D.$5;n(he,fe,Pe,ve,Ce)}return Pe})().then(Y,de)})}e.$Gb=i;function n(he,fe,ue,me,V){for(const Y=ue.length;me<V;me++){const de=he[me];if(fe(de,ue[Y-1])<0){ue.pop();const we=(0,N.$kb)(ue,Pe=>fe(de,Pe)<0);ue.splice(we,0,de)}}}function r(he){return he.filter(fe=>!!fe)}e.$Hb=r;function s(he){let fe=0;for(let ue=0;ue<he.length;ue++)he[ue]&&(he[fe]=he[ue],fe+=1);he.length=fe}e.$Ib=s;function t(he,fe,ue){he.splice(ue,0,he.splice(fe,1)[0])}e.$Jb=t;function g(he){return!Array.isArray(he)||he.length===0}e.$Kb=g;function o(he){return Array.isArray(he)&&he.length>0}e.$Lb=o;function d(he,fe=ue=>ue){const ue=new Set;return he.filter(me=>{const V=fe(me);return ue.has(V)?!1:(ue.add(V),!0)})}e.$Mb=d;function l(he){const fe=new Set;return ue=>{const me=he(ue);return fe.has(me)?!1:(fe.add(me),!0)}}e.$Nb=l;function u(he,fe){return he.length>0?he[0]:fe}e.$Ob=u;function v(he,fe){return he.length>0?he[he.length-1]:fe}e.$Pb=v;function I(he,fe,ue=(me,V)=>me===V){let me=0;for(let V=0,Y=Math.min(he.length,fe.length);V<Y&&ue(he[V],fe[V]);V++)me++;return me}e.$Qb=I;function $(he){return[].concat(...he)}e.$Rb=$;function f(he,fe){let ue=typeof fe=="number"?he:0;typeof fe=="number"?ue=he:(ue=0,fe=he);const me=[];if(ue<=fe)for(let V=ue;V<fe;V++)me.push(V);else for(let V=ue;V>fe;V--)me.push(V);return me}e.$Sb=f;function y(he,fe,ue){return he.reduce((me,V)=>(me[fe(V)]=ue?ue(V):V,me),Object.create(null))}e.$Tb=y;function L(he,fe){return he.push(fe),()=>T(he,fe)}e.$Ub=L;function T(he,fe){const ue=he.indexOf(fe);if(ue>-1)return he.splice(ue,1),fe}e.$Vb=T;function U(he,fe,ue){const me=he.slice(0,fe),V=he.slice(fe);return me.concat(ue,V)}e.$Wb=U;function j(he,fe){let ue;if(typeof fe=="number"){let me=fe;ue=()=>{const V=Math.sin(me++)*179426549;return V-Math.floor(V)}}else ue=Math.random;for(let me=he.length-1;me>0;me-=1){const V=Math.floor(ue()*(me+1)),Y=he[me];he[me]=he[V],he[V]=Y}}e.$Xb=j;function F(he,fe){const ue=he.indexOf(fe);ue>-1&&(he.splice(ue,1),he.unshift(fe))}e.$Yb=F;function M(he,fe){const ue=he.indexOf(fe);ue>-1&&(he.splice(ue,1),he.push(fe))}e.$Zb=M;function O(he,fe){for(const ue of fe)he.push(ue)}e.$1b=O;function z(he,fe){return Array.isArray(he)?he.map(fe):fe(he)}e.$2b=z;function J(he){return Array.isArray(he)?he:[he]}e.$3b=J;function te(he){return he[Math.floor(Math.random()*he.length)]}e.$4b=te;function x(he,fe,ue){const me=Z(he,fe),V=he.length,Y=ue.length;he.length=V+Y;for(let de=V-1;de>=me;de--)he[de+Y]=he[de];for(let de=0;de<Y;de++)he[de+me]=ue[de]}e.$5b=x;function X(he,fe,ue,me){const V=Z(he,fe);let Y=he.splice(V,ue);return Y===void 0&&(Y=[]),x(he,V,me),Y}e.$6b=X;function Z(he,fe){return fe<0?Math.max(fe+he.length,0):Math.min(fe,he.length)}var ae;(function(he){function fe(Y){return Y<0}he.isLessThan=fe;function ue(Y){return Y<=0}he.isLessThanOrEqual=ue;function me(Y){return Y>0}he.isGreaterThan=me;function V(Y){return Y===0}he.isNeitherLessOrGreaterThan=V,he.greaterThan=1,he.lessThan=-1,he.neitherLessOrGreaterThan=0})(ae||(e.CompareResult=ae={}));function _(he,fe){return(ue,me)=>fe(he(ue),he(me))}e.$7b=_;function ge(...he){return(fe,ue)=>{for(const me of he){const V=me(fe,ue);if(!ae.isNeitherLessOrGreaterThan(V))return V}return ae.neitherLessOrGreaterThan}}e.$8b=ge;const ne=(he,fe)=>he-fe;e.$9b=ne;const K=(he,fe)=>(0,e.$9b)(he?1:0,fe?1:0);e.$0b=K;function W(he){return(fe,ue)=>-he(fe,ue)}e.$$b=W;class re{constructor(fe){this.g=fe,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(fe){let ue=this.c;for(;ue<this.g.length&&fe(this.g[ue]);)ue++;const me=ue===this.c?null:this.g.slice(this.c,ue);return this.c=ue,me}takeFromEndWhile(fe){let ue=this.d;for(;ue>=0&&fe(this.g[ue]);)ue--;const me=ue===this.d?null:this.g.slice(ue+1,this.d+1);return this.d=ue,me}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const fe=this.g[this.c];return this.c++,fe}removeLast(){const fe=this.g[this.d];return this.d--,fe}takeCount(fe){const ue=this.g.slice(this.c,this.c+fe);return this.c+=fe,ue}}e.$_b=re;class ye{static{this.empty=new ye(fe=>{})}constructor(fe){this.iterate=fe}forEach(fe){this.iterate(ue=>(fe(ue),!0))}toArray(){const fe=[];return this.iterate(ue=>(fe.push(ue),!0)),fe}filter(fe){return new ye(ue=>this.iterate(me=>fe(me)?ue(me):!0))}map(fe){return new ye(ue=>this.iterate(me=>ue(fe(me))))}some(fe){let ue=!1;return this.iterate(me=>(ue=fe(me),!ue)),ue}findFirst(fe){let ue;return this.iterate(me=>fe(me)?(ue=me,!1):!0),ue}findLast(fe){let ue;return this.iterate(me=>(fe(me)&&(ue=me),!0)),ue}findLastMaxBy(fe){let ue,me=!0;return this.iterate(V=>((me||ae.isGreaterThan(fe(V,ue)))&&(me=!1,ue=V),!0)),ue}}e.$ac=ye}),define(ke[61],Se([1,0,14]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function N(k,R){if(!k)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=N;function h(k,R="Unreachable"){throw new Error(R)}e.$6c=h;function P(k){if(!k)throw new D.$cb("Assertion Failed")}e.$7c=P;function A(k){k||(0,D.$1)(new D.$cb("Assertion Failed"))}e.$8c=A;function p(k){if(!k()){debugger;k(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$9c=p;function b(k,R){let C=0;for(;C<k.length-1;){const w=k[C],E=k[C+1];if(!R(w,E))return!1;C++}return!0}e.$0c=b}),define(ke[74],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(N,h){const P=this;let A=!1,p;return function(){if(A)return p;if(A=!0,h)try{p=N.apply(P,arguments)}finally{h()}else p=N.apply(P,arguments);return p}}e.$db=D}),define(ke[121],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=e.$tN=void 0;class D{constructor(h){this.a=h,this.b=0}nextId(){return this.a+ ++this.b}}e.$tN=D,e.$uN=new D("id#")}),define(ke[53],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(N){function h(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=h;const P=Object.freeze([]);function A(){return P}N.empty=A;function*p(t){yield t}N.single=p;function b(t){return h(t)?t:p(t)}N.wrap=b;function k(t){return t||P}N.from=k;function*R(t){for(let g=t.length-1;g>=0;g--)yield t[g]}N.reverse=R;function C(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=C;function w(t){return t[Symbol.iterator]().next().value}N.first=w;function E(t,g){for(const o of t)if(g(o))return!0;return!1}N.some=E;function S(t,g){for(const o of t)if(g(o))return o}N.find=S;function*c(t,g){for(const o of t)g(o)&&(yield o)}N.filter=c;function*m(t,g){let o=0;for(const d of t)yield g(d,o++)}N.map=m;function*a(...t){for(const g of t)yield*g}N.concat=a;function i(t,g,o){let d=o;for(const l of t)d=g(d,l);return d}N.reduce=i;function*n(t,g,o=t.length){for(g<0&&(g+=t.length),o<0?o+=t.length:o>t.length&&(o=t.length);g<o;g++)yield t[g]}N.slice=n;function r(t,g=Number.POSITIVE_INFINITY){const o=[];if(g===0)return[o,t];const d=t[Symbol.iterator]();for(let l=0;l<g;l++){const u=d.next();if(u.done)return[o,N.empty()];o.push(u.value)}return[o,{[Symbol.iterator](){return d}}]}N.consume=r;async function s(t){const g=[];for await(const o of t)g.push(o);return Promise.resolve(g)}N.asyncToArray=s})(D||(e.Iterable=D={}))}),define(ke[159],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var h;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(h||(e.ParseErrorCode=h={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P||(e.ParseOptions=P={}));function A(t,g=!1){let o=0;const d=t.length;let l="",u=0,v=16,I=0;function $(F){let M=0,O=0;for(;M<F;){const z=t.charCodeAt(o);if(z>=48&&z<=57)O=O*16+z-48;else if(z>=65&&z<=70)O=O*16+z-65+10;else if(z>=97&&z<=102)O=O*16+z-97+10;else break;o++,M++}return M<F&&(O=-1),O}function f(F){o=F,l="",u=0,v=16,I=0}function y(){const F=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&k(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&k(t.charCodeAt(o)))for(o++;o<t.length&&k(t.charCodeAt(o));)o++;else return I=3,t.substring(F,o);let M=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&k(t.charCodeAt(o))){for(o++;o<t.length&&k(t.charCodeAt(o));)o++;M=o}else I=3;return t.substring(F,M)}function L(){let F="",M=o;for(;;){if(o>=d){F+=t.substring(M,o),I=2;break}const O=t.charCodeAt(o);if(O===34){F+=t.substring(M,o),o++;break}if(O===92){if(F+=t.substring(M,o),o++,o>=d){I=2;break}switch(t.charCodeAt(o++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const J=$(4);J>=0?F+=String.fromCharCode(J):I=4;break}default:I=5}M=o;continue}if(O>=0&&O<=31)if(b(O)){F+=t.substring(M,o),I=2;break}else I=6;o++}return F}function T(){if(l="",I=0,u=o,o>=d)return u=d,v=17;let F=t.charCodeAt(o);if(p(F)){do o++,l+=String.fromCharCode(F),F=t.charCodeAt(o);while(p(F));return v=15}if(b(F))return o++,l+=String.fromCharCode(F),F===13&&t.charCodeAt(o)===10&&(o++,l+=`
`),v=14;switch(F){case 123:return o++,v=1;case 125:return o++,v=2;case 91:return o++,v=3;case 93:return o++,v=4;case 58:return o++,v=6;case 44:return o++,v=5;case 34:return o++,l=L(),v=10;case 47:{const M=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<d&&!b(t.charCodeAt(o));)o++;return l=t.substring(M,o),v=12}if(t.charCodeAt(o+1)===42){o+=2;const O=d-1;let z=!1;for(;o<O;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,z=!0;break}o++}return z||(o++,I=1),l=t.substring(M,o),v=13}return l+=String.fromCharCode(F),o++,v=16}case 45:if(l+=String.fromCharCode(F),o++,o===d||!k(t.charCodeAt(o)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=y(),v=11;default:for(;o<d&&U(F);)o++,F=t.charCodeAt(o);if(u!==o){switch(l=t.substring(u,o),l){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return l+=String.fromCharCode(F),o++,v=16}}function U(F){if(p(F)||b(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let F;do F=T();while(F>=12&&F<=15);return F}return{setPosition:f,getPosition:()=>o,scan:g?j:T,getToken:()=>v,getTokenValue:()=>l,getTokenOffset:()=>u,getTokenLength:()=>o-u,getTokenError:()=>I}}e.$dn=A;function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function b(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function C(t,g){const o=[],d=new Object;let l;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function I($,f,y,L){u.value=$,u.offset=f,u.length=y,u.type=L,u.colonOffset=void 0,l=u}try{n(t,{onObjectBegin:($,f)=>{if(g<=$)throw d;l=void 0,v=g>$,o.push("")},onObjectProperty:($,f,y)=>{if(g<f||(I($,f,y,"property"),o[o.length-1]=$,g<=f+y))throw d},onObjectEnd:($,f)=>{if(g<=$)throw d;l=void 0,o.pop()},onArrayBegin:($,f)=>{if(g<=$)throw d;l=void 0,o.push(0)},onArrayEnd:($,f)=>{if(g<=$)throw d;l=void 0,o.pop()},onLiteralValue:($,f,y)=>{if(g<f||(I($,f,y,s($)),g<=f+y))throw d},onSeparator:($,f,y)=>{if(g<=f)throw d;if($===":"&&l&&l.type==="property")l.colonOffset=f,v=!1,l=void 0;else if($===","){const L=o[o.length-1];typeof L=="number"?o[o.length-1]=L+1:(v=!0,o[o.length-1]=""),l=void 0}}})}catch($){if($!==d)throw $}return{path:o,previousNode:l,isAtPropertyKey:v,matches:$=>{let f=0;for(let y=0;f<$.length&&y<o.length;y++)if($[f]===o[y]||$[f]==="*")f++;else if($[f]!=="**")return!1;return f===$.length}}}e.$en=C;function w(t,g=[],o=P.DEFAULT){let d=null,l=[];const u=[];function v($){Array.isArray(l)?l.push($):d!==null&&(l[d]=$)}return n(t,{onObjectBegin:()=>{const $={};v($),u.push(l),l=$,d=null},onObjectProperty:$=>{d=$},onObjectEnd:()=>{l=u.pop()},onArrayBegin:()=>{const $=[];v($),u.push(l),l=$,d=null},onArrayEnd:()=>{l=u.pop()},onLiteralValue:v,onError:($,f,y)=>{g.push({error:$,offset:f,length:y})}},o),l[0]}e.$fn=w;function E(t,g=[],o=P.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l($){d.type==="property"&&(d.length=$-d.offset,d=d.parent)}function u($){return d.children.push($),$}n(t,{onObjectBegin:$=>{d=u({type:"object",offset:$,length:-1,parent:d,children:[]})},onObjectProperty:($,f,y)=>{d=u({type:"property",offset:f,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:$,offset:f,length:y,parent:d})},onObjectEnd:($,f)=>{d.length=$+f-d.offset,d=d.parent,l($+f)},onArrayBegin:($,f)=>{d=u({type:"array",offset:$,length:-1,parent:d,children:[]})},onArrayEnd:($,f)=>{d.length=$+f-d.offset,d=d.parent,l($+f)},onLiteralValue:($,f,y)=>{u({type:s($),offset:f,length:y,parent:d,value:$}),l(f+y)},onSeparator:($,f,y)=>{d.type==="property"&&($===":"?d.colonOffset=f:$===","&&l(f))},onError:($,f,y)=>{g.push({error:$,offset:f,length:y})}},o);const I=d.children[0];return I&&delete I.parent,I}e.$gn=E;function S(t,g){if(!t)return;let o=t;for(const d of g)if(typeof d=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let l=!1;for(const u of o.children)if(Array.isArray(u.children)&&u.children[0].value===d){o=u.children[1],l=!0;break}if(!l)return}else{const l=d;if(o.type!=="array"||l<0||!Array.isArray(o.children)||l>=o.children.length)return;o=o.children[l]}return o}e.$hn=S;function c(t){if(!t.parent||!t.parent.children)return[];const g=c(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;g.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&g.push(o)}return g}e.$in=c;function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const g=Object.create(null);for(const o of t.children){const d=o.children[1];d&&(g[o.children[0].value]=m(d))}return g}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$jn=m;function a(t,g,o=!1){return g>=t.offset&&g<t.offset+t.length||o&&g===t.offset+t.length}e.$kn=a;function i(t,g,o=!1){if(a(t,g,o)){const d=t.children;if(Array.isArray(d))for(let l=0;l<d.length&&d[l].offset<=g;l++){const u=i(d[l],g,o);if(u)return u}return t}}e.$ln=i;function n(t,g,o=P.DEFAULT){const d=A(t,!1);function l(_){return _?()=>_(d.getTokenOffset(),d.getTokenLength()):()=>!0}function u(_){return _?ge=>_(ge,d.getTokenOffset(),d.getTokenLength()):()=>!0}const v=l(g.onObjectBegin),I=u(g.onObjectProperty),$=l(g.onObjectEnd),f=l(g.onArrayBegin),y=l(g.onArrayEnd),L=u(g.onLiteralValue),T=u(g.onSeparator),U=l(g.onComment),j=u(g.onError),F=o&&o.disallowComments,M=o&&o.allowTrailingComma;function O(){for(;;){const _=d.scan();switch(d.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:F||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(_){case 12:case 13:F?z(10):U();break;case 16:z(1);break;case 15:case 14:break;default:return _}}}function z(_,ge=[],ne=[]){if(j(_),ge.length+ne.length>0){let K=d.getToken();for(;K!==17;){if(ge.indexOf(K)!==-1){O();break}else if(ne.indexOf(K)!==-1)break;K=O()}}}function J(_){const ge=d.getTokenValue();return _?L(ge):I(ge),O(),!0}function te(){switch(d.getToken()){case 11:{let _=0;try{_=JSON.parse(d.getTokenValue()),typeof _!="number"&&(z(2),_=0)}catch{z(2)}L(_);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return O(),!0}function x(){return d.getToken()!==10?(z(3,[],[2,5]),!1):(J(!1),d.getToken()===6?(T(":"),O(),ae()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function X(){v(),O();let _=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(_||z(4,[],[]),T(","),O(),d.getToken()===2&&M)break}else _&&z(6,[],[]);x()||z(4,[],[2,5]),_=!0}return $(),d.getToken()!==2?z(7,[2],[]):O(),!0}function Z(){f(),O();let _=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(_||z(4,[],[]),T(","),O(),d.getToken()===4&&M)break}else _&&z(6,[],[]);ae()||z(4,[],[4,5]),_=!0}return y(),d.getToken()!==4?z(8,[4],[]):O(),!0}function ae(){switch(d.getToken()){case 3:return Z();case 1:return X();case 10:return J(!0);default:return te()}}return O(),d.getToken()===17?o.allowEmptyContent?!0:(z(4,[],[]),!1):ae()?(d.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.$mn=n;function r(t,g){const o=A(t),d=[];let l,u=0,v;do switch(v=o.getPosition(),l=o.scan(),l){case 12:case 13:case 17:u!==v&&d.push(t.substring(u,v)),g!==void 0&&d.push(o.getTokenValue().replace(/[^\r\n]/g,g)),u=o.getPosition();break}while(l!==17);return d.join("")}e.$nn=r;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$on=s}),define(ke[43],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(h){this.d=h,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(h){this.c=h}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(ke[75],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(P){this.element=P,this.next=D.Undefined,this.prev=D.Undefined}}class N{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let P=this.a;for(;P!==D.Undefined;){const A=P.next;P.prev=D.Undefined,P.next=D.Undefined,P=A}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(P){return this.d(P,!1)}push(P){return this.d(P,!0)}d(P,A){const p=new D(P);if(this.a===D.Undefined)this.a=p,this.b=p;else if(A){const k=this.b;this.b=p,p.prev=k,k.next=p}else{const k=this.a;this.a=p,p.next=k,k.prev=p}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(p))}}shift(){if(this.a!==D.Undefined){const P=this.a.element;return this.e(this.a),P}}pop(){if(this.b!==D.Undefined){const P=this.b.element;return this.e(this.b),P}}e(P){if(P.prev!==D.Undefined&&P.next!==D.Undefined){const A=P.prev;A.next=P.next,P.next.prev=A}else P.prev===D.Undefined&&P.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):P.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):P.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let P=this.a;for(;P!==D.Undefined;)yield P.element,P=P.next}}e.$4c=N}),define(ke[28],Se([1,0]),function($e,e){"use strict";var D,N,h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function P(n,r,s){let t=n.get(r);return t===void 0&&(t=s,n.set(r,t)),t}e.$xc=P;function A(n){const r=[];return n.forEach((s,t)=>{r.push(`${t} => ${s}`)}),`Map(${n.size}) {${r.join(", ")}}`}e.$yc=A;function p(n){const r=[];return n.forEach(s=>{r.push(s)}),`Set(${n.size}) {${r.join(", ")}}`}e.$zc=p;class b{constructor(r,s){this.uri=r,this.value=s}}function k(n){return Array.isArray(n)}class R{static{this.c=r=>r.toString()}constructor(r,s){if(this[D]="ResourceMap",r instanceof R)this.d=new Map(r.d),this.e=s??R.c;else if(k(r)){this.d=new Map,this.e=s??R.c;for(const[t,g]of r)this.set(t,g)}else this.d=new Map,this.e=r??R.c}set(r,s){return this.d.set(this.e(r),new b(r,s)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[t,g]of this.d)r(g.value,g.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Ac=R;class C{constructor(r,s){this[N]="ResourceSet",!r||typeof r=="function"?this.c=new R(r):(this.c=new R(s),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,s){this.c.forEach((t,g)=>r.call(s,g,g,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var w;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class E{constructor(){this[h]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,s=0){const t=this.c.get(r);if(t)return s!==0&&this.l(t,s),t.value}set(r,s,t=0){let g=this.c.get(r);if(g)g.value=s,t!==0&&this.l(g,t);else{switch(g={key:r,value:s,next:void 0,previous:void 0},t){case 0:this.j(g);break;case 1:this.i(g);break;case 2:this.j(g);break;default:this.j(g);break}this.c.set(r,g),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this.c.get(r);if(s)return this.c.delete(r),this.k(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.k(r),this.f--,r.value}forEach(r,s){const t=this.g;let g=this.d;for(;g;){if(s?r.bind(s)(g.value,g.key,this):r(g.value,g.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const r=this,s=this.g;let t=this.d;const g={[Symbol.iterator](){return g},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const o={value:t.key,done:!1};return t=t.next,o}else return{value:void 0,done:!0}}};return g}values(){const r=this,s=this.g;let t=this.d;const g={[Symbol.iterator](){return g},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const o={value:t.value,done:!1};return t=t.next,o}else return{value:void 0,done:!0}}};return g}entries(){const r=this,s=this.g;let t=this.d;const g={[Symbol.iterator](){return g},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const o={value:[t.key,t.value],done:!1};return t=t.next,o}else return{value:void 0,done:!0}}};return g}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this.d,t=this.size;for(;s&&t>r;)this.c.delete(s.key),s=s.next,t--;this.d=s,this.f=t,s&&(s.previous=void 0),this.g++}i(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}j(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}k(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const s=r.next,t=r.previous;if(!s||!t)throw new Error("Invalid list");s.previous=t,t.next=s}r.next=void 0,r.previous=void 0,this.g++}l(r,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this.d)return;const t=r.next,g=r.previous;r===this.e?(g.next=void 0,this.e=g):(t.previous=g,g.next=t),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(s===2){if(r===this.e)return;const t=r.next,g=r.previous;r===this.d?(t.previous=void 0,this.d=t):(t.previous=g,g.next=t),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((s,t)=>{r.push([t,s])}),r}fromJSON(r){this.clear();for(const[s,t]of r)this.set(s,t)}}e.$Cc=E;class S extends E{constructor(r,s=1){super(),this.m=r,this.n=Math.min(Math.max(0,s),1)}get limit(){return this.m}set limit(r){this.m=r,this.o()}get ratio(){return this.n}set ratio(r){this.n=Math.min(Math.max(0,r),1),this.o()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=S;class c{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let s=this.c.get(r)||0;return s===0?!1:(s--,s===0?this.c.delete(r):this.c.set(r,s),!0)}has(r){return this.c.has(r)}}e.$Ec=c;class m{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[s,t]of r)this.set(s,t)}clear(){this.c.clear(),this.d.clear()}set(r,s){this.c.set(r,s),this.d.set(s,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const s=this.c.get(r);return s===void 0?!1:(this.c.delete(r),this.d.delete(s),!0)}forEach(r,s){this.c.forEach((t,g)=>{r.call(s,t,g,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=m;class a{constructor(){this.c=new Map}add(r,s){let t=this.c.get(r);t||(t=new Set,this.c.set(r,t)),t.add(s)}delete(r,s){const t=this.c.get(r);t&&(t.delete(s),t.size===0&&this.c.delete(r))}forEach(r,s){const t=this.c.get(r);t&&t.forEach(s)}get(r){const s=this.c.get(r);return s||new Set}}e.$Gc=a;function i(n,r){if(n===r)return!0;if(n.size!==r.size)return!1;for(const[s,t]of n)if(!r.has(s)||r.get(s)!==t)return!1;for(const[s]of r)if(!n.has(s))return!1;return!0}e.$Hc=i}),define(ke[3],Se([1,0,19,73,28,74,53]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const p=!1;let b=null;class k{constructor(){this.b=new Map}static{this.a=0}c(L){let T=this.b.get(L);return T||(T={parent:null,source:null,isSingleton:!1,value:L,idx:k.a++},this.b.set(L,T)),T}trackDisposable(L){const T=this.c(L);T.source||(T.source=new Error().stack)}setParent(L,T){const U=this.c(L);U.parent=T}markAsDisposed(L){this.b.delete(L)}markAsSingleton(L){this.c(L).isSingleton=!0}f(L,T){const U=T.get(L);if(U)return U;const j=L.parent?this.f(this.c(L.parent),T):L;return T.set(L,j),j}getTrackedDisposables(){const L=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,L).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(L=10,T){let U;if(T)U=T;else{const z=new Map,J=[...this.b.values()].filter(x=>x.source!==null&&!this.f(x,z).isSingleton);if(J.length===0)return;const te=new Set(J.map(x=>x.value));if(U=J.filter(x=>!(x.parent&&te.has(x.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function j(z){function J(x,X){for(;x.length>0&&X.some(Z=>typeof Z=="string"?Z===x[0]:x[0].match(Z));)x.shift()}const te=z.source.split(`
`).map(x=>x.trim().replace("at ","")).filter(x=>x!=="");return J(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const F=new h.$Gc;for(const z of U){const J=j(z);for(let te=0;te<=J.length;te++)F.add(J.slice(0,te).join(`
`),z)}U.sort((0,D.$7b)(z=>z.idx,D.$9b));let M="",O=0;for(const z of U.slice(0,L)){O++;const J=j(z),te=[];for(let x=0;x<J.length;x++){let X=J[x];X=`(shared with ${F.get(J.slice(0,x+1).join(`
`)).size}/${U.length} leaks) at ${X}`;const ae=F.get(J.slice(0,x).join(`
`)),_=(0,N.$K)([...ae].map(ge=>j(ge)[x]),ge=>ge);delete _[J[x]];for(const[ge,ne]of Object.entries(_))te.unshift(`    - stacktraces of ${ne.length} other leaks continue with ${ge}`);te.unshift(X)}M+=`


==================== Leaking disposable ${O}/${U.length}: ${z.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return U.length>L&&(M+=`


... and ${U.length-L} more leaking disposables

`),{leaks:U,details:M}}}e.$Ic=k;function R(y){b=y}if(e.$Jc=R,p){const y="__is_disposable_tracked__";R(new class{trackDisposable(L){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[y]||console.log(T)},3e3)}setParent(L,T){if(L&&L!==t.None)try{L[y]=!0}catch{}}markAsDisposed(L){if(L&&L!==t.None)try{L[y]=!0}catch{}}markAsSingleton(L){}})}function C(y){return b?.trackDisposable(y),y}e.$Kc=C;function w(y){b?.markAsDisposed(y)}e.$Lc=w;function E(y,L){b?.setParent(y,L)}function S(y,L){if(b)for(const T of y)b.setParent(T,L)}function c(y){return b?.markAsSingleton(y),y}e.$Mc=c;function m(y){return typeof y.dispose=="function"&&y.dispose.length===0}e.$Nc=m;function a(y){if(A.Iterable.is(y)){const L=[];for(const T of y)if(T)try{T.dispose()}catch(U){L.push(U)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}e.$Oc=a;function i(y){for(const L of y)m(L)&&L.dispose();return[]}e.$Pc=i;function n(...y){const L=r(()=>a(y));return S(y,L),L}e.$Qc=n;function r(y){const L=C({dispose:(0,P.$db)(()=>{w(L),y()})});return L}e.$Rc=r;class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{a(this.f)}finally{this.f.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return E(L,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(L),L}delete(L){if(L){if(L===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(L),L.dispose()}}deleteAndLeak(L){L&&this.f.has(L)&&(this.f.delete(L),E(L,null))}}e.$Sc=s;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,C(this),E(this.q,this)}dispose(){w(this),this.q.dispose()}B(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(L)}}e.$Tc=t;class g{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(L){this.b||L===this.a||(this.a?.dispose(),L&&E(L,this),this.a=L)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const L=this.a;return this.a=void 0,L&&E(L,null),L}}e.$Uc=g;class o{constructor(L){this.a=new g,this.b=!1,this.a.value=L}get value(){return this.a.value}set value(L){this.b||L===this.a.value||(this.a.value=L)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=o;class d{constructor(L){this.b=L,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=d;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(L){let T=L;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,w(this))},this}}e.$Xc=l;class u{constructor(){this.a=new Map}acquire(L,...T){let U=this.a.get(L);U||(U={counter:0,object:this.b(L,...T)},this.a.set(L,U));const{object:j}=U,F=(0,P.$db)(()=>{--U.counter===0&&(this.c(L,U.object),this.a.delete(L))});return U.counter++,{object:j,dispose:F}}}e.$Yc=u;class v{constructor(L){this.a=L}async acquire(L,...T){const U=this.a.acquire(L,...T);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(j){throw U.dispose(),j}}}e.$Zc=v;class I{constructor(L){this.object=L}dispose(){}}e.$1c=I;function $(y){const L=new s;try{y(L)}finally{L.dispose()}}e.$2c=$;class f{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{a(this.a.values())}finally{this.a.clear()}}has(L){return this.a.has(L)}get size(){return this.a.size}get(L){return this.a.get(L)}set(L,T,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(L)?.dispose(),this.a.set(L,T)}deleteAndDispose(L){this.a.get(L)?.dispose(),this.a.delete(L)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=f}),function($e,e){typeof define=="function"&&define.amd?define(ke[160],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(fe,ue){for(var me=0;me<ue.length;me++){var V=ue[me];V.enumerable=V.enumerable||!1,V.configurable=!0,"value"in V&&(V.writable=!0),Object.defineProperty(fe,V.key,V)}}function D(fe,ue,me){return ue&&e(fe.prototype,ue),me&&e(fe,me),Object.defineProperty(fe,"prototype",{writable:!1}),fe}function N(fe,ue){if(fe){if(typeof fe=="string")return h(fe,ue);var me=Object.prototype.toString.call(fe).slice(8,-1);if(me==="Object"&&fe.constructor&&(me=fe.constructor.name),me==="Map"||me==="Set")return Array.from(fe);if(me==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(me))return h(fe,ue)}}function h(fe,ue){(ue==null||ue>fe.length)&&(ue=fe.length);for(var me=0,V=new Array(ue);me<ue;me++)V[me]=fe[me];return V}function P(fe,ue){var me=typeof Symbol<"u"&&fe[Symbol.iterator]||fe["@@iterator"];if(me)return(me=me.call(fe)).next.bind(me);if(Array.isArray(fe)||(me=N(fe))||ue&&fe&&typeof fe.length=="number"){me&&(fe=me);var V=0;return function(){return V>=fe.length?{done:!0}:{done:!1,value:fe[V++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=A();function p(fe){$e.defaults=fe}var b=/[&<>"']/,k=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(ue){return w[ue]};function S(fe,ue){if(ue){if(b.test(fe))return fe.replace(k,E)}else if(R.test(fe))return fe.replace(C,E);return fe}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(fe){return fe.replace(c,function(ue,me){return me=me.toLowerCase(),me==="colon"?":":me.charAt(0)==="#"?me.charAt(1)==="x"?String.fromCharCode(parseInt(me.substring(2),16)):String.fromCharCode(+me.substring(1)):""})}var a=/(^|[^\[])\^/g;function i(fe,ue){fe=typeof fe=="string"?fe:fe.source,ue=ue||"";var me={replace:function(Y,de){return de=de.source||de,de=de.replace(a,"$1"),fe=fe.replace(Y,de),me},getRegex:function(){return new RegExp(fe,ue)}};return me}var n=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function s(fe,ue,me){if(fe){var V;try{V=decodeURIComponent(m(me)).replace(n,"").toLowerCase()}catch{return null}if(V.indexOf("javascript:")===0||V.indexOf("vbscript:")===0||V.indexOf("data:")===0)return null}ue&&!r.test(me)&&(me=l(ue,me));try{me=encodeURI(me).replace(/%25/g,"%")}catch{return null}return me}var t={},g=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(fe,ue){t[" "+fe]||(g.test(fe)?t[" "+fe]=fe+"/":t[" "+fe]=$(fe,"/",!0)),fe=t[" "+fe];var me=fe.indexOf(":")===-1;return ue.substring(0,2)==="//"?me?ue:fe.replace(o,"$1")+ue:ue.charAt(0)==="/"?me?ue:fe.replace(d,"$1")+ue:fe+ue}var u={exec:function(){}};function v(fe){for(var ue=1,me,V;ue<arguments.length;ue++){me=arguments[ue];for(V in me)Object.prototype.hasOwnProperty.call(me,V)&&(fe[V]=me[V])}return fe}function I(fe,ue){var me=fe.replace(/\|/g,function(de,we,Pe){for(var ve=!1,Ce=we;--Ce>=0&&Pe[Ce]==="\\";)ve=!ve;return ve?"|":" |"}),V=me.split(/ \|/),Y=0;if(V[0].trim()||V.shift(),V.length>0&&!V[V.length-1].trim()&&V.pop(),V.length>ue)V.splice(ue);else for(;V.length<ue;)V.push("");for(;Y<V.length;Y++)V[Y]=V[Y].trim().replace(/\\\|/g,"|");return V}function $(fe,ue,me){var V=fe.length;if(V===0)return"";for(var Y=0;Y<V;){var de=fe.charAt(V-Y-1);if(de===ue&&!me)Y++;else if(de!==ue&&me)Y++;else break}return fe.slice(0,V-Y)}function f(fe,ue){if(fe.indexOf(ue[1])===-1)return-1;for(var me=fe.length,V=0,Y=0;Y<me;Y++)if(fe[Y]==="\\")Y++;else if(fe[Y]===ue[0])V++;else if(fe[Y]===ue[1]&&(V--,V<0))return Y;return-1}function y(fe){fe&&fe.sanitize&&!fe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(fe,ue){if(ue<1)return"";for(var me="";ue>1;)ue&1&&(me+=fe),ue>>=1,fe+=fe;return me+fe}function T(fe,ue,me,V){var Y=ue.href,de=ue.title?S(ue.title):null,we=fe[1].replace(/\\([\[\]])/g,"$1");if(fe[0].charAt(0)!=="!"){V.state.inLink=!0;var Pe={type:"link",raw:me,href:Y,title:de,text:we,tokens:V.inlineTokens(we)};return V.state.inLink=!1,Pe}return{type:"image",raw:me,href:Y,title:de,text:S(we)}}function U(fe,ue){var me=fe.match(/^(\s+)(?:```)/);if(me===null)return ue;var V=me[1];return ue.split(`
`).map(function(Y){var de=Y.match(/^\s+/);if(de===null)return Y;var we=de[0];return we.length>=V.length?Y.slice(V.length):Y}).join(`
`)}var j=function(){function fe(me){this.options=me||$e.defaults}var ue=fe.prototype;return ue.space=function(V){var Y=this.rules.block.newline.exec(V);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},ue.code=function(V){var Y=this.rules.block.code.exec(V);if(Y){var de=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?de:$(de,`
`)}}},ue.fences=function(V){var Y=this.rules.block.fences.exec(V);if(Y){var de=Y[0],we=U(de,Y[3]||"");return{type:"code",raw:de,lang:Y[2]?Y[2].trim():Y[2],text:we}}},ue.heading=function(V){var Y=this.rules.block.heading.exec(V);if(Y){var de=Y[2].trim();if(/#$/.test(de)){var we=$(de,"#");(this.options.pedantic||!we||/ $/.test(we))&&(de=we.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:de,tokens:this.lexer.inline(de)}}},ue.hr=function(V){var Y=this.rules.block.hr.exec(V);if(Y)return{type:"hr",raw:Y[0]}},ue.blockquote=function(V){var Y=this.rules.block.blockquote.exec(V);if(Y){var de=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(de,[]),text:de}}},ue.list=function(V){var Y=this.rules.block.list.exec(V);if(Y){var de,we,Pe,ve,Ce,B,Q,ee,H,oe,le,Re,je=Y[1].trim(),He=je.length>1,Qe={type:"list",raw:"",ordered:He,start:He?+je.slice(0,-1):"",loose:!1,items:[]};je=He?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=He?je:"[*+-]");for(var _e=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");V&&(Re=!1,!(!(Y=_e.exec(V))||this.rules.block.hr.test(V)));){if(de=Y[0],V=V.substring(de.length),ee=Y[2].split(`
`,1)[0],H=V.split(`
`,1)[0],this.options.pedantic?(ve=2,le=ee.trimLeft()):(ve=Y[2].search(/[^ ]/),ve=ve>4?1:ve,le=ee.slice(ve),ve+=Y[1].length),B=!1,!ee&&/^ *$/.test(H)&&(de+=H+`
`,V=V.substring(H.length+1),Re=!0),!Re)for(var at=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,ve-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:```|~~~)"),Le=new RegExp("^ {0,"+Math.min(3,ve-1)+"}#");V&&(oe=V.split(`
`,1)[0],ee=oe,this.options.pedantic&&(ee=ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(ee)||Le.test(ee)||at.test(ee)||st.test(V)));){if(ee.search(/[^ ]/)>=ve||!ee.trim())le+=`
`+ee.slice(ve);else if(!B)le+=`
`+ee;else break;!B&&!ee.trim()&&(B=!0),de+=oe+`
`,V=V.substring(oe.length+1)}Qe.loose||(Q?Qe.loose=!0:/\n *\n *$/.test(de)&&(Q=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(le),we&&(Pe=we[0]!=="[ ] ",le=le.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:de,task:!!we,checked:Pe,loose:!1,text:le}),Qe.raw+=de}Qe.items[Qe.items.length-1].raw=de.trimRight(),Qe.items[Qe.items.length-1].text=le.trimRight(),Qe.raw=Qe.raw.trimRight();var ze=Qe.items.length;for(Ce=0;Ce<ze;Ce++){this.lexer.state.top=!1,Qe.items[Ce].tokens=this.lexer.blockTokens(Qe.items[Ce].text,[]);var Ae=Qe.items[Ce].tokens.filter(function(ie){return ie.type==="space"}),Ze=Ae.every(function(ie){for(var se=ie.raw.split(""),Ie=0,qe=P(se),Ye;!(Ye=qe()).done;){var it=Ye.value;if(it===`
`&&(Ie+=1),Ie>1)return!0}return!1});!Qe.loose&&Ae.length&&Ze&&(Qe.loose=!0,Qe.items[Ce].loose=!0)}return Qe}},ue.html=function(V){var Y=this.rules.block.html.exec(V);if(Y){var de={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(Y[0]):S(Y[0]);de.type="paragraph",de.text=we,de.tokens=this.lexer.inline(we)}return de}},ue.def=function(V){var Y=this.rules.block.def.exec(V);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var de=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:de,raw:Y[0],href:Y[2],title:Y[3]}}},ue.table=function(V){var Y=this.rules.block.table.exec(V);if(Y){var de={type:"table",header:I(Y[1]).map(function(Q){return{text:Q}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(de.header.length===de.align.length){de.raw=Y[0];var we=de.align.length,Pe,ve,Ce,B;for(Pe=0;Pe<we;Pe++)/^ *-+: *$/.test(de.align[Pe])?de.align[Pe]="right":/^ *:-+: *$/.test(de.align[Pe])?de.align[Pe]="center":/^ *:-+ *$/.test(de.align[Pe])?de.align[Pe]="left":de.align[Pe]=null;for(we=de.rows.length,Pe=0;Pe<we;Pe++)de.rows[Pe]=I(de.rows[Pe],de.header.length).map(function(Q){return{text:Q}});for(we=de.header.length,ve=0;ve<we;ve++)de.header[ve].tokens=this.lexer.inline(de.header[ve].text);for(we=de.rows.length,ve=0;ve<we;ve++)for(B=de.rows[ve],Ce=0;Ce<B.length;Ce++)B[Ce].tokens=this.lexer.inline(B[Ce].text);return de}}},ue.lheading=function(V){var Y=this.rules.block.lheading.exec(V);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},ue.paragraph=function(V){var Y=this.rules.block.paragraph.exec(V);if(Y){var de=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:de,tokens:this.lexer.inline(de)}}},ue.text=function(V){var Y=this.rules.block.text.exec(V);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},ue.escape=function(V){var Y=this.rules.inline.escape.exec(V);if(Y)return{type:"escape",raw:Y[0],text:S(Y[1])}},ue.tag=function(V){var Y=this.rules.inline.tag.exec(V);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):S(Y[0]):Y[0]}},ue.link=function(V){var Y=this.rules.inline.link.exec(V);if(Y){var de=Y[2].trim();if(!this.options.pedantic&&/^</.test(de)){if(!/>$/.test(de))return;var we=$(de.slice(0,-1),"\\");if((de.length-we.length)%2===0)return}else{var Pe=f(Y[2],"()");if(Pe>-1){var ve=Y[0].indexOf("!")===0?5:4,Ce=ve+Y[1].length+Pe;Y[2]=Y[2].substring(0,Pe),Y[0]=Y[0].substring(0,Ce).trim(),Y[3]=""}}var B=Y[2],Q="";if(this.options.pedantic){var ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(B);ee&&(B=ee[1],Q=ee[3])}else Q=Y[3]?Y[3].slice(1,-1):"";return B=B.trim(),/^</.test(B)&&(this.options.pedantic&&!/>$/.test(de)?B=B.slice(1):B=B.slice(1,-1)),T(Y,{href:B&&B.replace(this.rules.inline._escapes,"$1"),title:Q&&Q.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},ue.reflink=function(V,Y){var de;if((de=this.rules.inline.reflink.exec(V))||(de=this.rules.inline.nolink.exec(V))){var we=(de[2]||de[1]).replace(/\s+/g," ");if(we=Y[we.toLowerCase()],!we||!we.href){var Pe=de[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return T(de,we,de[0],this.lexer)}},ue.emStrong=function(V,Y,de){de===void 0&&(de="");var we=this.rules.inline.emStrong.lDelim.exec(V);if(we&&!(we[3]&&de.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=we[1]||we[2]||"";if(!Pe||Pe&&(de===""||this.rules.inline.punctuation.exec(de))){var ve=we[0].length-1,Ce,B,Q=ve,ee=0,H=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,Y=Y.slice(-1*V.length+ve);(we=H.exec(Y))!=null;)if(Ce=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!Ce){if(B=Ce.length,we[3]||we[4]){Q+=B;continue}else if((we[5]||we[6])&&ve%3&&!((ve+B)%3)){ee+=B;continue}if(Q-=B,!(Q>0)){if(B=Math.min(B,B+Q+ee),Math.min(ve,B)%2){var oe=V.slice(1,ve+we.index+B);return{type:"em",raw:V.slice(0,ve+we.index+B+1),text:oe,tokens:this.lexer.inlineTokens(oe)}}var le=V.slice(2,ve+we.index+B-1);return{type:"strong",raw:V.slice(0,ve+we.index+B+1),text:le,tokens:this.lexer.inlineTokens(le)}}}}}},ue.codespan=function(V){var Y=this.rules.inline.code.exec(V);if(Y){var de=Y[2].replace(/\n/g," "),we=/[^ ]/.test(de),Pe=/^ /.test(de)&&/ $/.test(de);return we&&Pe&&(de=de.substring(1,de.length-1)),de=S(de,!0),{type:"codespan",raw:Y[0],text:de}}},ue.br=function(V){var Y=this.rules.inline.br.exec(V);if(Y)return{type:"br",raw:Y[0]}},ue.del=function(V){var Y=this.rules.inline.del.exec(V);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},ue.autolink=function(V,Y){var de=this.rules.inline.autolink.exec(V);if(de){var we,Pe;return de[2]==="@"?(we=S(this.options.mangle?Y(de[1]):de[1]),Pe="mailto:"+we):(we=S(de[1]),Pe=we),{type:"link",raw:de[0],text:we,href:Pe,tokens:[{type:"text",raw:we,text:we}]}}},ue.url=function(V,Y){var de;if(de=this.rules.inline.url.exec(V)){var we,Pe;if(de[2]==="@")we=S(this.options.mangle?Y(de[0]):de[0]),Pe="mailto:"+we;else{var ve;do ve=de[0],de[0]=this.rules.inline._backpedal.exec(de[0])[0];while(ve!==de[0]);we=S(de[0]),de[1]==="www."?Pe="http://"+we:Pe=we}return{type:"link",raw:de[0],text:we,href:Pe,tokens:[{type:"text",raw:we,text:we}]}}},ue.inlineText=function(V,Y){var de=this.rules.inline.text.exec(V);if(de){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):S(de[0]):de[0]:we=S(this.options.smartypants?Y(de[0]):de[0]),{type:"text",raw:de[0],text:we}}},fe}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=i(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=i(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=i(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=i(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=i(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=i(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=v({},F),F.gfm=v({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=i(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=i(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=v({},F.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:i(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=i(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=i(F._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=i(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=i(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=i(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=i(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=i(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=i(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=i(M.reflink).replace("label",M._label).replace("ref",F._label).getRegex(),M.nolink=i(M.nolink).replace("ref",F._label).getRegex(),M.reflinkSearch=i(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=v({},M),M.pedantic=v({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=v({},M.normal,{escape:i(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=i(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=v({},M.gfm,{br:i(M.br).replace("{2,}","*").getRegex(),text:i(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(fe){return fe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(fe){var ue="",me,V,Y=fe.length;for(me=0;me<Y;me++)V=fe.charCodeAt(me),Math.random()>.5&&(V="x"+V.toString(16)),ue+="&#"+V+";";return ue}var J=function(){function fe(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||$e.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var V={block:F.normal,inline:M.normal};this.options.pedantic?(V.block=F.pedantic,V.inline=M.pedantic):this.options.gfm&&(V.block=F.gfm,this.options.breaks?V.inline=M.breaks:V.inline=M.gfm),this.tokenizer.rules=V}fe.lex=function(V,Y){var de=new fe(Y);return de.lex(V)},fe.lexInline=function(V,Y){var de=new fe(Y);return de.inlineTokens(V)};var ue=fe.prototype;return ue.lex=function(V){V=V.replace(/\r\n|\r/g,`
`),this.blockTokens(V,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},ue.blockTokens=function(V,Y){var de=this;Y===void 0&&(Y=[]),this.options.pedantic?V=V.replace(/\t/g,"    ").replace(/^ +$/gm,""):V=V.replace(/^( *)(\t+)/gm,function(Q,ee,H){return ee+"    ".repeat(H.length)});for(var we,Pe,ve,Ce;V;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Q){return(we=Q.call({lexer:de},V,Y))?(V=V.substring(we.raw.length),Y.push(we),!0):!1}))){if(we=this.tokenizer.space(V)){V=V.substring(we.raw.length),we.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(we);continue}if(we=this.tokenizer.code(V)){V=V.substring(we.raw.length),Pe=Y[Y.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+we.raw,Pe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Y.push(we);continue}if(we=this.tokenizer.fences(V)){V=V.substring(we.raw.length),Y.push(we);continue}if(we=this.tokenizer.heading(V)){V=V.substring(we.raw.length),Y.push(we);continue}if(we=this.tokenizer.hr(V)){V=V.substring(we.raw.length),Y.push(we);continue}if(we=this.tokenizer.blockquote(V)){V=V.substring(we.raw.length),Y.push(we);continue}if(we=this.tokenizer.list(V)){V=V.substring(we.raw.length),Y.push(we);continue}if(we=this.tokenizer.html(V)){V=V.substring(we.raw.length),Y.push(we);continue}if(we=this.tokenizer.def(V)){V=V.substring(we.raw.length),Pe=Y[Y.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+we.raw,Pe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(V)){V=V.substring(we.raw.length),Y.push(we);continue}if(we=this.tokenizer.lheading(V)){V=V.substring(we.raw.length),Y.push(we);continue}if(ve=V,this.options.extensions&&this.options.extensions.startBlock&&function(){var Q=1/0,ee=V.slice(1),H=void 0;de.options.extensions.startBlock.forEach(function(oe){H=oe.call({lexer:this},ee),typeof H=="number"&&H>=0&&(Q=Math.min(Q,H))}),Q<1/0&&Q>=0&&(ve=V.substring(0,Q+1))}(),this.state.top&&(we=this.tokenizer.paragraph(ve))){Pe=Y[Y.length-1],Ce&&Pe.type==="paragraph"?(Pe.raw+=`
`+we.raw,Pe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Y.push(we),Ce=ve.length!==V.length,V=V.substring(we.raw.length);continue}if(we=this.tokenizer.text(V)){V=V.substring(we.raw.length),Pe=Y[Y.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+we.raw,Pe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Y.push(we);continue}if(V){var B="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(B);break}else throw new Error(B)}}return this.state.top=!0,Y},ue.inline=function(V,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:V,tokens:Y}),Y},ue.inlineTokens=function(V,Y){var de=this;Y===void 0&&(Y=[]);var we,Pe,ve,Ce=V,B,Q,ee;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(B=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)H.includes(B[0].slice(B[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,B.index)+"["+L("a",B[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(B=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,B.index)+"["+L("a",B[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(B=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,B.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;V;)if(Q||(ee=""),Q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(le){return(we=le.call({lexer:de},V,Y))?(V=V.substring(we.raw.length),Y.push(we),!0):!1}))){if(we=this.tokenizer.escape(V)){V=V.substring(we.raw.length),Y.push(we);continue}if(we=this.tokenizer.tag(V)){V=V.substring(we.raw.length),Pe=Y[Y.length-1],Pe&&we.type==="text"&&Pe.type==="text"?(Pe.raw+=we.raw,Pe.text+=we.text):Y.push(we);continue}if(we=this.tokenizer.link(V)){V=V.substring(we.raw.length),Y.push(we);continue}if(we=this.tokenizer.reflink(V,this.tokens.links)){V=V.substring(we.raw.length),Pe=Y[Y.length-1],Pe&&we.type==="text"&&Pe.type==="text"?(Pe.raw+=we.raw,Pe.text+=we.text):Y.push(we);continue}if(we=this.tokenizer.emStrong(V,Ce,ee)){V=V.substring(we.raw.length),Y.push(we);continue}if(we=this.tokenizer.codespan(V)){V=V.substring(we.raw.length),Y.push(we);continue}if(we=this.tokenizer.br(V)){V=V.substring(we.raw.length),Y.push(we);continue}if(we=this.tokenizer.del(V)){V=V.substring(we.raw.length),Y.push(we);continue}if(we=this.tokenizer.autolink(V,z)){V=V.substring(we.raw.length),Y.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(V,z))){V=V.substring(we.raw.length),Y.push(we);continue}if(ve=V,this.options.extensions&&this.options.extensions.startInline&&function(){var le=1/0,Re=V.slice(1),je=void 0;de.options.extensions.startInline.forEach(function(He){je=He.call({lexer:this},Re),typeof je=="number"&&je>=0&&(le=Math.min(le,je))}),le<1/0&&le>=0&&(ve=V.substring(0,le+1))}(),we=this.tokenizer.inlineText(ve,O)){V=V.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(ee=we.raw.slice(-1)),Q=!0,Pe=Y[Y.length-1],Pe&&Pe.type==="text"?(Pe.raw+=we.raw,Pe.text+=we.text):Y.push(we);continue}if(V){var oe="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(oe);break}else throw new Error(oe)}}return Y},D(fe,null,[{key:"rules",get:function(){return{block:F,inline:M}}}]),fe}(),te=function(){function fe(me){this.options=me||$e.defaults}var ue=fe.prototype;return ue.code=function(V,Y,de){var we=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(V,we);Pe!=null&&Pe!==V&&(de=!0,V=Pe)}return V=V.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+S(we,!0)+'">'+(de?V:S(V,!0))+`</code></pre>
`:"<pre><code>"+(de?V:S(V,!0))+`</code></pre>
`},ue.blockquote=function(V){return`<blockquote>
`+V+`</blockquote>
`},ue.html=function(V){return V},ue.heading=function(V,Y,de,we){if(this.options.headerIds){var Pe=this.options.headerPrefix+we.slug(de);return"<h"+Y+' id="'+Pe+'">'+V+"</h"+Y+`>
`}return"<h"+Y+">"+V+"</h"+Y+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(V,Y,de){var we=Y?"ol":"ul",Pe=Y&&de!==1?' start="'+de+'"':"";return"<"+we+Pe+`>
`+V+"</"+we+`>
`},ue.listitem=function(V){return"<li>"+V+`</li>
`},ue.checkbox=function(V){return"<input "+(V?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(V){return"<p>"+V+`</p>
`},ue.table=function(V,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+V+`</thead>
`+Y+`</table>
`},ue.tablerow=function(V){return`<tr>
`+V+`</tr>
`},ue.tablecell=function(V,Y){var de=Y.header?"th":"td",we=Y.align?"<"+de+' align="'+Y.align+'">':"<"+de+">";return we+V+("</"+de+`>
`)},ue.strong=function(V){return"<strong>"+V+"</strong>"},ue.em=function(V){return"<em>"+V+"</em>"},ue.codespan=function(V){return"<code>"+V+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(V){return"<del>"+V+"</del>"},ue.link=function(V,Y,de){if(V=s(this.options.sanitize,this.options.baseUrl,V),V===null)return de;var we='<a href="'+S(V)+'"';return Y&&(we+=' title="'+Y+'"'),we+=">"+de+"</a>",we},ue.image=function(V,Y,de){if(V=s(this.options.sanitize,this.options.baseUrl,V),V===null)return de;var we='<img src="'+V+'" alt="'+de+'"';return Y&&(we+=' title="'+Y+'"'),we+=this.options.xhtml?"/>":">",we},ue.text=function(V){return V},fe}(),x=function(){function fe(){}var ue=fe.prototype;return ue.strong=function(V){return V},ue.em=function(V){return V},ue.codespan=function(V){return V},ue.del=function(V){return V},ue.html=function(V){return V},ue.text=function(V){return V},ue.link=function(V,Y,de){return""+de},ue.image=function(V,Y,de){return""+de},ue.br=function(){return""},fe}(),X=function(){function fe(){this.seen={}}var ue=fe.prototype;return ue.serialize=function(V){return V.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(V,Y){var de=V,we=0;if(this.seen.hasOwnProperty(de)){we=this.seen[V];do we++,de=V+"-"+we;while(this.seen.hasOwnProperty(de))}return Y||(this.seen[V]=we,this.seen[de]=0),de},ue.slug=function(V,Y){Y===void 0&&(Y={});var de=this.serialize(V);return this.getNextSafeSlug(de,Y.dryrun)},fe}(),Z=function(){function fe(me){this.options=me||$e.defaults,this.options.renderer=this.options.renderer||new te,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new X}fe.parse=function(V,Y){var de=new fe(Y);return de.parse(V)},fe.parseInline=function(V,Y){var de=new fe(Y);return de.parseInline(V)};var ue=fe.prototype;return ue.parse=function(V,Y){Y===void 0&&(Y=!0);var de="",we,Pe,ve,Ce,B,Q,ee,H,oe,le,Re,je,He,Qe,_e,at,st,rt,Le,ze=V.length;for(we=0;we<ze;we++){if(le=V[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(Le=this.options.extensions.renderers[le.type].call({parser:this},le),Le!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(le.type))){de+=Le||"";continue}switch(le.type){case"space":continue;case"hr":{de+=this.renderer.hr();continue}case"heading":{de+=this.renderer.heading(this.parseInline(le.tokens),le.depth,m(this.parseInline(le.tokens,this.textRenderer)),this.slugger);continue}case"code":{de+=this.renderer.code(le.text,le.lang,le.escaped);continue}case"table":{for(H="",ee="",Ce=le.header.length,Pe=0;Pe<Ce;Pe++)ee+=this.renderer.tablecell(this.parseInline(le.header[Pe].tokens),{header:!0,align:le.align[Pe]});for(H+=this.renderer.tablerow(ee),oe="",Ce=le.rows.length,Pe=0;Pe<Ce;Pe++){for(Q=le.rows[Pe],ee="",B=Q.length,ve=0;ve<B;ve++)ee+=this.renderer.tablecell(this.parseInline(Q[ve].tokens),{header:!1,align:le.align[ve]});oe+=this.renderer.tablerow(ee)}de+=this.renderer.table(H,oe);continue}case"blockquote":{oe=this.parse(le.tokens),de+=this.renderer.blockquote(oe);continue}case"list":{for(Re=le.ordered,je=le.start,He=le.loose,Ce=le.items.length,oe="",Pe=0;Pe<Ce;Pe++)_e=le.items[Pe],at=_e.checked,st=_e.task,Qe="",_e.task&&(rt=this.renderer.checkbox(at),He?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=rt+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=rt+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:rt}):Qe+=rt),Qe+=this.parse(_e.tokens,He),oe+=this.renderer.listitem(Qe,st,at);de+=this.renderer.list(oe,Re,je);continue}case"html":{de+=this.renderer.html(le.text);continue}case"paragraph":{de+=this.renderer.paragraph(this.parseInline(le.tokens));continue}case"text":{for(oe=le.tokens?this.parseInline(le.tokens):le.text;we+1<ze&&V[we+1].type==="text";)le=V[++we],oe+=`
`+(le.tokens?this.parseInline(le.tokens):le.text);de+=Y?this.renderer.paragraph(oe):oe;continue}default:{var Ae='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return de},ue.parseInline=function(V,Y){Y=Y||this.renderer;var de="",we,Pe,ve,Ce=V.length;for(we=0;we<Ce;we++){if(Pe=V[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(ve=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),ve!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){de+=ve||"";continue}switch(Pe.type){case"escape":{de+=Y.text(Pe.text);break}case"html":{de+=Y.html(Pe.text);break}case"link":{de+=Y.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,Y));break}case"image":{de+=Y.image(Pe.href,Pe.title,Pe.text);break}case"strong":{de+=Y.strong(this.parseInline(Pe.tokens,Y));break}case"em":{de+=Y.em(this.parseInline(Pe.tokens,Y));break}case"codespan":{de+=Y.codespan(Pe.text);break}case"br":{de+=Y.br();break}case"del":{de+=Y.del(this.parseInline(Pe.tokens,Y));break}case"text":{de+=Y.text(Pe.text);break}default:{var B='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(B);return}else throw new Error(B)}}}return de},fe}();function ae(fe,ue,me){if(typeof fe>"u"||fe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");if(typeof ue=="function"&&(me=ue,ue=null),ue=v({},ae.defaults,ue||{}),y(ue),me){var V=ue.highlight,Y;try{Y=J.lex(fe,ue)}catch(Ce){return me(Ce)}var de=function(B){var Q;if(!B)try{ue.walkTokens&&ae.walkTokens(Y,ue.walkTokens),Q=Z.parse(Y,ue)}catch(ee){B=ee}return ue.highlight=V,B?me(B):me(null,Q)};if(!V||V.length<3||(delete ue.highlight,!Y.length))return de();var we=0;ae.walkTokens(Y,function(Ce){Ce.type==="code"&&(we++,setTimeout(function(){V(Ce.text,Ce.lang,function(B,Q){if(B)return de(B);Q!=null&&Q!==Ce.text&&(Ce.text=Q,Ce.escaped=!0),we--,we===0&&de()})},0))}),we===0&&de();return}function Pe(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+S(Ce.message+"",!0)+"</pre>";throw Ce}try{var ve=J.lex(fe,ue);if(ue.walkTokens){if(ue.async)return Promise.all(ae.walkTokens(ve,ue.walkTokens)).then(function(){return Z.parse(ve,ue)}).catch(Pe);ae.walkTokens(ve,ue.walkTokens)}return Z.parse(ve,ue)}catch(Ce){Pe(Ce)}}ae.options=ae.setOptions=function(fe){return v(ae.defaults,fe),p(ae.defaults),ae},ae.getDefaults=A,ae.defaults=$e.defaults,ae.use=function(){for(var fe=arguments.length,ue=new Array(fe),me=0;me<fe;me++)ue[me]=arguments[me];var V=v.apply(void 0,[{}].concat(ue)),Y=ae.defaults.extensions||{renderers:{},childTokens:{}},de;ue.forEach(function(we){if(we.extensions&&(de=!0,we.extensions.forEach(function(ve){if(!ve.name)throw new Error("extension name required");if(ve.renderer){var Ce=Y.renderers?Y.renderers[ve.name]:null;Ce?Y.renderers[ve.name]=function(){for(var B=arguments.length,Q=new Array(B),ee=0;ee<B;ee++)Q[ee]=arguments[ee];var H=ve.renderer.apply(this,Q);return H===!1&&(H=Ce.apply(this,Q)),H}:Y.renderers[ve.name]=ve.renderer}if(ve.tokenizer){if(!ve.level||ve.level!=="block"&&ve.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[ve.level]?Y[ve.level].unshift(ve.tokenizer):Y[ve.level]=[ve.tokenizer],ve.start&&(ve.level==="block"?Y.startBlock?Y.startBlock.push(ve.start):Y.startBlock=[ve.start]:ve.level==="inline"&&(Y.startInline?Y.startInline.push(ve.start):Y.startInline=[ve.start]))}ve.childTokens&&(Y.childTokens[ve.name]=ve.childTokens)})),we.renderer&&function(){var ve=ae.defaults.renderer||new te,Ce=function(ee){var H=ve[ee];ve[ee]=function(){for(var oe=arguments.length,le=new Array(oe),Re=0;Re<oe;Re++)le[Re]=arguments[Re];var je=we.renderer[ee].apply(ve,le);return je===!1&&(je=H.apply(ve,le)),je}};for(var B in we.renderer)Ce(B);V.renderer=ve}(),we.tokenizer&&function(){var ve=ae.defaults.tokenizer||new j,Ce=function(ee){var H=ve[ee];ve[ee]=function(){for(var oe=arguments.length,le=new Array(oe),Re=0;Re<oe;Re++)le[Re]=arguments[Re];var je=we.tokenizer[ee].apply(ve,le);return je===!1&&(je=H.apply(ve,le)),je}};for(var B in we.tokenizer)Ce(B);V.tokenizer=ve}(),we.walkTokens){var Pe=ae.defaults.walkTokens;V.walkTokens=function(ve){var Ce=[];return Ce.push(we.walkTokens.call(this,ve)),Pe&&(Ce=Ce.concat(Pe.call(this,ve))),Ce}}de&&(V.extensions=Y),ae.setOptions(V)})},ae.walkTokens=function(fe,ue){for(var me=[],V=function(){var Pe=de.value;switch(me=me.concat(ue.call(ae,Pe)),Pe.type){case"table":{for(var ve=P(Pe.header),Ce;!(Ce=ve()).done;){var B=Ce.value;me=me.concat(ae.walkTokens(B.tokens,ue))}for(var Q=P(Pe.rows),ee;!(ee=Q()).done;)for(var H=ee.value,oe=P(H),le;!(le=oe()).done;){var Re=le.value;me=me.concat(ae.walkTokens(Re.tokens,ue))}break}case"list":{me=me.concat(ae.walkTokens(Pe.items,ue));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[Pe.type]?ae.defaults.extensions.childTokens[Pe.type].forEach(function(je){me=me.concat(ae.walkTokens(Pe[je],ue))}):Pe.tokens&&(me=me.concat(ae.walkTokens(Pe.tokens,ue)))}},Y=P(fe),de;!(de=Y()).done;)V();return me},ae.parseInline=function(fe,ue){if(typeof fe>"u"||fe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");ue=v({},ae.defaults,ue||{}),y(ue);try{var me=J.lexInline(fe,ue);return ue.walkTokens&&ae.walkTokens(me,ue.walkTokens),Z.parseInline(me,ue)}catch(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+S(V.message+"",!0)+"</pre>";throw V}},ae.Parser=Z,ae.parser=Z.parse,ae.Renderer=te,ae.TextRenderer=x,ae.Lexer=J,ae.lexer=J.lex,ae.Tokenizer=j,ae.Slugger=X,ae.parse=ae;var _=ae.options,ge=ae.setOptions,ne=ae.use,K=ae.walkTokens,W=ae.parseInline,re=ae,ye=Z.parse,he=J.lex;$e.Lexer=J,$e.Parser=Z,$e.Renderer=te,$e.Slugger=X,$e.TextRenderer=x,$e.Tokenizer=j,$e.getDefaults=A,$e.lexer=he,$e.marked=ae,$e.options=_,$e.parse=re,$e.parseInline=W,$e.parser=ye,$e.setOptions=ge,$e.use=ne,$e.walkTokens=K,Object.defineProperty($e,"__esModule",{value:!0})}),define(ke[161],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tj=void 0;function D(c){const m=P(c);if(m&&m.length>0)return new Uint32Array(m)}e.$Tj=D;let N=0;const h=new Uint32Array(10);function P(c){if(N=0,A(c,C,4352),N>0||(A(c,w,4449),N>0)||(A(c,E,4520),N>0)||(A(c,S,12593),N))return h.subarray(0,N);if(c>=44032&&c<=55203){const m=c-44032,a=m%588,i=Math.floor(m/588),n=Math.floor(a/28),r=a%28-1;if(i<C.length?A(i,C,0):4352+i-12593<S.length&&A(4352+i,S,12593),n<w.length?A(n,w,0):4449+n-12593<S.length&&A(4449+n-12593,S,12593),r>=0&&(r<E.length?A(r,E,0):4520+r-12593<S.length&&A(4520+r-12593,S,12593)),N>0)return h.subarray(0,N)}}function A(c,m,a){c>=a&&c<a+m.length&&p(m[c-a])}function p(c){c!==0&&(h[N++]=c&255,c>>8&&(h[N++]=c>>8&255),c>>16&&(h[N++]=c>>16&255))}var b;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var k;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(k||(k={}));var R;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(R||(R={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),w=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),E=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),S=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[76],Se([1,0,28]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=void 0;const N=new D.$Dc(1e4);function h(k){return b(k,"NFC",N)}e.$Il=h;const P=new D.$Dc(1e4);function A(k){return b(k,"NFD",P)}e.$Jl=A;const p=/[^\u0000-\u0080]/;function b(k,R,C){if(!k)return k;const w=C.get(k);if(w)return w;let E;return p.test(k)?E=k.normalize(R):E=k,C.set(k,E),E}e.$Kl=function(){const k=/[\u0300-\u036f]/g;return function(R){return A(R).replace(k,"")}}()}),define(ke[122],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.rot=e.$9l=void 0;function D(p,b,k){return Math.min(Math.max(p,b),k)}e.$9l=D;function N(p,b){return(b+p%b)%b}e.rot=N;class h{constructor(){this.a=0}getNext(){return this.a++}}e.$$l=h;class P{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$_l=P;class A{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const k=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$am=A}),function(){function $e(h){const P=[];typeof h=="number"&&P.push("code/timeOrigin",h);function A(b){P.push(b,Date.now())}function p(){const b=[];for(let k=0;k<P.length;k+=2)b.push({name:P[k],startTime:P[k+1]});return b}return{mark:A,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(h){performance.mark(h)},getMarks(){let h=performance.timeOrigin;typeof h!="number"&&(h=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(h)}];for(const A of performance.getEntriesByType("mark"))P.push({name:A.name,startTime:Math.round(h+A.startTime)});return P}};if(typeof process=="object"){const h=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(h)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function D(h){return h.MonacoPerformanceMarks||(h.MonacoPerformanceMarks=e()),h.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=D(N))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var N in D)(typeof exports=="object"?exports:$e)[N]=D[N]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function D(N){if(e[N])return e[N].exports;var h=e[N]={i:N,l:!1,exports:{}};return $e[N].call(h.exports,h,h.exports,D),h.l=!0,h.exports}return D.m=$e,D.c=e,D.d=function(N,h,P){D.o(N,h)||Object.defineProperty(N,h,{enumerable:!0,get:P})},D.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},D.t=function(N,h){if(1&h&&(N=D(N)),8&h||4&h&&typeof N=="object"&&N&&N.__esModule)return N;var P=Object.create(null);if(D.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:N}),2&h&&typeof N!="string")for(var A in N)D.d(P,A,function(p){return N[p]}.bind(null,A));return P},D.n=function(N){var h=N&&N.__esModule?function(){return N.default}:function(){return N};return D.d(h,"a",h),h},D.o=function(N,h){return Object.prototype.hasOwnProperty.call(N,h)},D.p="",D(D.s=0)}([function($e,e,D){(function(N){var h;e=$e.exports=ne,h=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],b=e.src=[],k=0,R=k++;b[R]="0|[1-9]\\d*";var C=k++;b[C]="[0-9]+";var w=k++;b[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=k++;b[E]="("+b[R]+")\\.("+b[R]+")\\.("+b[R]+")";var S=k++;b[S]="("+b[C]+")\\.("+b[C]+")\\.("+b[C]+")";var c=k++;b[c]="(?:"+b[R]+"|"+b[w]+")";var m=k++;b[m]="(?:"+b[C]+"|"+b[w]+")";var a=k++;b[a]="(?:-("+b[c]+"(?:\\."+b[c]+")*))";var i=k++;b[i]="(?:-?("+b[m]+"(?:\\."+b[m]+")*))";var n=k++;b[n]="[0-9A-Za-z-]+";var r=k++;b[r]="(?:\\+("+b[n]+"(?:\\."+b[n]+")*))";var s=k++,t="v?"+b[E]+b[a]+"?"+b[r]+"?";b[s]="^"+t+"$";var g="[v=\\s]*"+b[S]+b[i]+"?"+b[r]+"?",o=k++;b[o]="^"+g+"$";var d=k++;b[d]="((?:<|>)?=?)";var l=k++;b[l]=b[C]+"|x|X|\\*";var u=k++;b[u]=b[R]+"|x|X|\\*";var v=k++;b[v]="[v=\\s]*("+b[u]+")(?:\\.("+b[u]+")(?:\\.("+b[u]+")(?:"+b[a]+")?"+b[r]+"?)?)?";var I=k++;b[I]="[v=\\s]*("+b[l]+")(?:\\.("+b[l]+")(?:\\.("+b[l]+")(?:"+b[i]+")?"+b[r]+"?)?)?";var $=k++;b[$]="^"+b[d]+"\\s*"+b[v]+"$";var f=k++;b[f]="^"+b[d]+"\\s*"+b[I]+"$";var y=k++;b[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=k++;b[L]="(?:~>?)";var T=k++;b[T]="(\\s*)"+b[L]+"\\s+",p[T]=new RegExp(b[T],"g");var U=k++;b[U]="^"+b[L]+b[v]+"$";var j=k++;b[j]="^"+b[L]+b[I]+"$";var F=k++;b[F]="(?:\\^)";var M=k++;b[M]="(\\s*)"+b[F]+"\\s+",p[M]=new RegExp(b[M],"g");var O=k++;b[O]="^"+b[F]+b[v]+"$";var z=k++;b[z]="^"+b[F]+b[I]+"$";var J=k++;b[J]="^"+b[d]+"\\s*("+g+")$|^$";var te=k++;b[te]="^"+b[d]+"\\s*("+t+")$|^$";var x=k++;b[x]="(\\s*)"+b[d]+"\\s*("+g+"|"+b[v]+")",p[x]=new RegExp(b[x],"g");var X=k++;b[X]="^\\s*("+b[v]+")\\s+-\\s+("+b[v]+")\\s*$";var Z=k++;b[Z]="^\\s*("+b[I]+")\\s+-\\s+("+b[I]+")\\s*$";var ae=k++;b[ae]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)h(_,b[_]),p[_]||(p[_]=new RegExp(b[_]));function ge(H,oe){if(H instanceof ne)return H;if(typeof H!="string"||H.length>P||!(oe?p[o]:p[s]).test(H))return null;try{return new ne(H,oe)}catch{return null}}function ne(H,oe){if(H instanceof ne){if(H.loose===oe)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof ne))return new ne(H,oe);h("SemVer",H,oe),this.loose=oe;var le=H.trim().match(oe?p[o]:p[s]);if(!le)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+le[1],this.minor=+le[2],this.patch=+le[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");le[4]?this.prerelease=le[4].split(".").map(function(Re){if(/^[0-9]+$/.test(Re)){var je=+Re;if(je>=0&&je<A)return je}return Re}):this.prerelease=[],this.build=le[5]?le[5].split("."):[],this.format()}e.parse=ge,e.valid=function(H,oe){var le=ge(H,oe);return le?le.version:null},e.clean=function(H,oe){var le=ge(H.trim().replace(/^[=v]+/,""),oe);return le?le.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(H){return h("SemVer.compare",this.version,this.loose,H),H instanceof ne||(H=new ne(H,this.loose)),this.compareMain(H)||this.comparePre(H)},ne.prototype.compareMain=function(H){return H instanceof ne||(H=new ne(H,this.loose)),W(this.major,H.major)||W(this.minor,H.minor)||W(this.patch,H.patch)},ne.prototype.comparePre=function(H){if(H instanceof ne||(H=new ne(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var oe=0;do{var le=this.prerelease[oe],Re=H.prerelease[oe];if(h("prerelease compare",oe,le,Re),le===void 0&&Re===void 0)return 0;if(Re===void 0)return 1;if(le===void 0)return-1;if(le!==Re)return W(le,Re)}while(++oe)},ne.prototype.inc=function(H,oe){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var le=this.prerelease.length;--le>=0;)typeof this.prerelease[le]=="number"&&(this.prerelease[le]++,le=-2);le===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,oe,le,Re){typeof le=="string"&&(Re=le,le=void 0);try{return new ne(H,le).inc(oe,Re).version}catch{return null}},e.diff=function(H,oe){if(fe(H,oe))return null;var le=ge(H),Re=ge(oe);if(le.prerelease.length||Re.prerelease.length){for(var je in le)if((je==="major"||je==="minor"||je==="patch")&&le[je]!==Re[je])return"pre"+je;return"prerelease"}for(var je in le)if((je==="major"||je==="minor"||je==="patch")&&le[je]!==Re[je])return je},e.compareIdentifiers=W;var K=/^[0-9]+$/;function W(H,oe){var le=K.test(H),Re=K.test(oe);return le&&Re&&(H=+H,oe=+oe),le&&!Re?-1:Re&&!le?1:H<oe?-1:H>oe?1:0}function re(H,oe,le){return new ne(H,le).compare(new ne(oe,le))}function ye(H,oe,le){return re(H,oe,le)>0}function he(H,oe,le){return re(H,oe,le)<0}function fe(H,oe,le){return re(H,oe,le)===0}function ue(H,oe,le){return re(H,oe,le)!==0}function me(H,oe,le){return re(H,oe,le)>=0}function V(H,oe,le){return re(H,oe,le)<=0}function Y(H,oe,le,Re){var je;switch(oe){case"===":typeof H=="object"&&(H=H.version),typeof le=="object"&&(le=le.version),je=H===le;break;case"!==":typeof H=="object"&&(H=H.version),typeof le=="object"&&(le=le.version),je=H!==le;break;case"":case"=":case"==":je=fe(H,le,Re);break;case"!=":je=ue(H,le,Re);break;case">":je=ye(H,le,Re);break;case">=":je=me(H,le,Re);break;case"<":je=he(H,le,Re);break;case"<=":je=V(H,le,Re);break;default:throw new TypeError("Invalid operator: "+oe)}return je}function de(H,oe){if(H instanceof de){if(H.loose===oe)return H;H=H.value}if(!(this instanceof de))return new de(H,oe);h("comparator",H,oe),this.loose=oe,this.parse(H),this.semver===we?this.value="":this.value=this.operator+this.semver.version,h("comp",this)}e.rcompareIdentifiers=function(H,oe){return W(oe,H)},e.major=function(H,oe){return new ne(H,oe).major},e.minor=function(H,oe){return new ne(H,oe).minor},e.patch=function(H,oe){return new ne(H,oe).patch},e.compare=re,e.compareLoose=function(H,oe){return re(H,oe,!0)},e.rcompare=function(H,oe,le){return re(oe,H,le)},e.sort=function(H,oe){return H.sort(function(le,Re){return e.compare(le,Re,oe)})},e.rsort=function(H,oe){return H.sort(function(le,Re){return e.rcompare(le,Re,oe)})},e.gt=ye,e.lt=he,e.eq=fe,e.neq=ue,e.gte=me,e.lte=V,e.cmp=Y,e.Comparator=de;var we={};function Pe(H,oe){if(H instanceof Pe)return H.loose===oe?H:new Pe(H.raw,oe);if(H instanceof de)return new Pe(H.value,oe);if(!(this instanceof Pe))return new Pe(H,oe);if(this.loose=oe,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(le){return this.parseRange(le.trim())},this).filter(function(le){return le.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function ve(H){return!H||H.toLowerCase()==="x"||H==="*"}function Ce(H,oe,le,Re,je,He,Qe,_e,at,st,rt,Le,ze){return((oe=ve(le)?"":ve(Re)?">="+le+".0.0":ve(je)?">="+le+"."+Re+".0":">="+oe)+" "+(_e=ve(at)?"":ve(st)?"<"+(+at+1)+".0.0":ve(rt)?"<"+at+"."+(+st+1)+".0":Le?"<="+at+"."+st+"."+rt+"-"+Le:"<="+_e)).trim()}function B(H,oe){for(var le=0;le<H.length;le++)if(!H[le].test(oe))return!1;if(oe.prerelease.length){for(le=0;le<H.length;le++)if(h(H[le].semver),H[le].semver!==we&&H[le].semver.prerelease.length>0){var Re=H[le].semver;if(Re.major===oe.major&&Re.minor===oe.minor&&Re.patch===oe.patch)return!0}return!1}return!0}function Q(H,oe,le){try{oe=new Pe(oe,le)}catch{return!1}return oe.test(H)}function ee(H,oe,le,Re){var je,He,Qe,_e,at;switch(H=new ne(H,Re),oe=new Pe(oe,Re),le){case">":je=ye,He=V,Qe=he,_e=">",at=">=";break;case"<":je=he,He=me,Qe=ye,_e="<",at="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Q(H,oe,Re))return!1;for(var st=0;st<oe.set.length;++st){var rt=oe.set[st],Le=null,ze=null;if(rt.forEach(function(Ae){Ae.semver===we&&(Ae=new de(">=0.0.0")),Le=Le||Ae,ze=ze||Ae,je(Ae.semver,Le.semver,Re)?Le=Ae:Qe(Ae.semver,ze.semver,Re)&&(ze=Ae)}),Le.operator===_e||Le.operator===at||(!ze.operator||ze.operator===_e)&&He(H,ze.semver)||ze.operator===at&&Qe(H,ze.semver))return!1}return!0}de.prototype.parse=function(H){var oe=this.loose?p[J]:p[te],le=H.match(oe);if(!le)throw new TypeError("Invalid comparator: "+H);this.operator=le[1],this.operator==="="&&(this.operator=""),le[2]?this.semver=new ne(le[2],this.loose):this.semver=we},de.prototype.toString=function(){return this.value},de.prototype.test=function(H){return h("Comparator.test",H,this.loose),this.semver===we||(typeof H=="string"&&(H=new ne(H,this.loose)),Y(H,this.operator,this.semver,this.loose))},de.prototype.intersects=function(H,oe){if(!(H instanceof de))throw new TypeError("a Comparator is required");var le;if(this.operator==="")return le=new Pe(H.value,oe),Q(this.value,le,oe);if(H.operator==="")return le=new Pe(this.value,oe),Q(H.semver,le,oe);var Re=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),He=this.semver.version===H.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),_e=Y(this.semver,"<",H.semver,oe)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),at=Y(this.semver,">",H.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return Re||je||He&&Qe||_e||at},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(H){var oe=this.loose;H=H.trim(),h("range",H,oe);var le=oe?p[Z]:p[X];H=H.replace(le,Ce),h("hyphen replace",H),H=H.replace(p[x],"$1$2$3"),h("comparator trim",H,p[x]),H=(H=(H=H.replace(p[T],"$1~")).replace(p[M],"$1^")).split(/\s+/).join(" ");var Re=oe?p[J]:p[te],je=H.split(" ").map(function(He){return function(Qe,_e){return h("comp",Qe),Qe=function(at,st){return at.trim().split(/\s+/).map(function(rt){return function(Le,ze){h("caret",Le,ze);var Ae=ze?p[z]:p[O];return Le.replace(Ae,function(Ze,ie,se,Ie,qe){var Ye;return h("caret",Le,Ze,ie,se,Ie,qe),ve(ie)?Ye="":ve(se)?Ye=">="+ie+".0.0 <"+(+ie+1)+".0.0":ve(Ie)?Ye=ie==="0"?">="+ie+"."+se+".0 <"+ie+"."+(+se+1)+".0":">="+ie+"."+se+".0 <"+(+ie+1)+".0.0":qe?(h("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ye=ie==="0"?se==="0"?">="+ie+"."+se+"."+Ie+qe+" <"+ie+"."+se+"."+(+Ie+1):">="+ie+"."+se+"."+Ie+qe+" <"+ie+"."+(+se+1)+".0":">="+ie+"."+se+"."+Ie+qe+" <"+(+ie+1)+".0.0"):(h("no pr"),Ye=ie==="0"?se==="0"?">="+ie+"."+se+"."+Ie+" <"+ie+"."+se+"."+(+Ie+1):">="+ie+"."+se+"."+Ie+" <"+ie+"."+(+se+1)+".0":">="+ie+"."+se+"."+Ie+" <"+(+ie+1)+".0.0"),h("caret return",Ye),Ye})}(rt,st)}).join(" ")}(Qe,_e),h("caret",Qe),Qe=function(at,st){return at.trim().split(/\s+/).map(function(rt){return function(Le,ze){var Ae=ze?p[j]:p[U];return Le.replace(Ae,function(Ze,ie,se,Ie,qe){var Ye;return h("tilde",Le,Ze,ie,se,Ie,qe),ve(ie)?Ye="":ve(se)?Ye=">="+ie+".0.0 <"+(+ie+1)+".0.0":ve(Ie)?Ye=">="+ie+"."+se+".0 <"+ie+"."+(+se+1)+".0":qe?(h("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ye=">="+ie+"."+se+"."+Ie+qe+" <"+ie+"."+(+se+1)+".0"):Ye=">="+ie+"."+se+"."+Ie+" <"+ie+"."+(+se+1)+".0",h("tilde return",Ye),Ye})}(rt,st)}).join(" ")}(Qe,_e),h("tildes",Qe),Qe=function(at,st){return h("replaceXRanges",at,st),at.split(/\s+/).map(function(rt){return function(Le,ze){Le=Le.trim();var Ae=ze?p[f]:p[$];return Le.replace(Ae,function(Ze,ie,se,Ie,qe,Ye){h("xRange",Le,Ze,ie,se,Ie,qe,Ye);var it=ve(se),nt=it||ve(Ie),Oe=nt||ve(qe);return ie==="="&&Oe&&(ie=""),it?Ze=ie===">"||ie==="<"?"<0.0.0":"*":ie&&Oe?(nt&&(Ie=0),Oe&&(qe=0),ie===">"?(ie=">=",nt?(se=+se+1,Ie=0,qe=0):Oe&&(Ie=+Ie+1,qe=0)):ie==="<="&&(ie="<",nt?se=+se+1:Ie=+Ie+1),Ze=ie+se+"."+Ie+"."+qe):nt?Ze=">="+se+".0.0 <"+(+se+1)+".0.0":Oe&&(Ze=">="+se+"."+Ie+".0 <"+se+"."+(+Ie+1)+".0"),h("xRange return",Ze),Ze})}(rt,st)}).join(" ")}(Qe,_e),h("xrange",Qe),Qe=function(at,st){return h("replaceStars",at,st),at.trim().replace(p[ae],"")}(Qe,_e),h("stars",Qe),Qe}(He,oe)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(He){return!!He.match(Re)})),je=je.map(function(He){return new de(He,oe)})},Pe.prototype.intersects=function(H,oe){if(!(H instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(le){return le.every(function(Re){return H.set.some(function(je){return je.every(function(He){return Re.intersects(He,oe)})})})})},e.toComparators=function(H,oe){return new Pe(H,oe).set.map(function(le){return le.map(function(Re){return Re.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new ne(H,this.loose));for(var oe=0;oe<this.set.length;oe++)if(B(this.set[oe],H))return!0;return!1},e.satisfies=Q,e.maxSatisfying=function(H,oe,le){var Re=null,je=null;try{var He=new Pe(oe,le)}catch{return null}return H.forEach(function(Qe){He.test(Qe)&&(Re&&je.compare(Qe)!==-1||(je=new ne(Re=Qe,le)))}),Re},e.minSatisfying=function(H,oe,le){var Re=null,je=null;try{var He=new Pe(oe,le)}catch{return null}return H.forEach(function(Qe){He.test(Qe)&&(Re&&je.compare(Qe)!==1||(je=new ne(Re=Qe,le)))}),Re},e.validRange=function(H,oe){try{return new Pe(H,oe).range||"*"}catch{return null}},e.ltr=function(H,oe,le){return ee(H,oe,"<",le)},e.gtr=function(H,oe,le){return ee(H,oe,">",le)},e.outside=ee,e.prerelease=function(H,oe){var le=ge(H,oe);return le&&le.prerelease.length?le.prerelease:null},e.intersects=function(H,oe,le){return H=new Pe(H,le),oe=new Pe(oe,le),H.intersects(oe)},e.coerce=function(H){if(H instanceof ne)return H;if(typeof H!="string")return null;var oe=H.match(p[y]);return oe==null?null:ge((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,D(1))},function($e,e){var D,N,h=$e.exports={};function P(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function p(m){if(D===setTimeout)return setTimeout(m,0);if((D===P||!D)&&setTimeout)return D=setTimeout,setTimeout(m,0);try{return D(m,0)}catch{try{return D.call(null,m,0)}catch{return D.call(this,m,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:P}catch{D=P}try{N=typeof clearTimeout=="function"?clearTimeout:A}catch{N=A}})();var b,k=[],R=!1,C=-1;function w(){R&&b&&(R=!1,b.length?k=b.concat(k):C=-1,k.length&&E())}function E(){if(!R){var m=p(w);R=!0;for(var a=k.length;a;){for(b=k,k=[];++C<a;)b&&b[C].run();C=-1,a=k.length}b=null,R=!1,function(i){if(N===clearTimeout)return clearTimeout(i);if((N===A||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(i);try{N(i)}catch{try{return N.call(null,i)}catch{return N.call(this,i)}}}(m)}}function S(m,a){this.fun=m,this.array=a}function c(){}h.nextTick=function(m){var a=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)a[i-1]=arguments[i];k.push(new S(m,a)),k.length!==1||R||p(E)},S.prototype.run=function(){this.fun.apply(null,this.array)},h.title="browser",h.browser=!0,h.env={},h.argv=[],h.version="",h.versions={},h.on=c,h.addListener=c,h.once=c,h.off=c,h.removeListener=c,h.removeAllListeners=c,h.emit=c,h.prependListener=c,h.prependOnceListener=c,h.listeners=function(m){return[]},h.binding=function(m){throw new Error("process.binding is not supported")},h.cwd=function(){return"/"},h.chdir=function(m){throw new Error("process.chdir is not supported")},h.umask=function(){return 0}}])}),define(ke[38],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(P){return new N(P)}constructor(P){this.c=D&&P===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Sd=N}),define(ke[4],Se([1,0,14,74,3,75,38]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.Event=void 0;const p=!1,b=!1;var k;(function($){$.None=()=>h.$Tc.None;function f(V){if(b){const{onDidAddListener:Y}=V,de=S.create();let we=0;V.onDidAddListener=()=>{++we===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),Y?.()}}}function y(V,Y){return te(V,()=>{},0,void 0,!0,void 0,Y)}$.defer=y;function L(V){return(Y,de=null,we)=>{let Pe=!1,ve;return ve=V(Ce=>{if(!Pe)return ve?ve.dispose():Pe=!0,Y.call(de,Ce)},null,we),Pe&&ve.dispose(),ve}}$.once=L;function T(V,Y,de){return z((we,Pe=null,ve)=>V(Ce=>we.call(Pe,Y(Ce)),null,ve),de)}$.map=T;function U(V,Y,de){return z((we,Pe=null,ve)=>V(Ce=>{Y(Ce),we.call(Pe,Ce)},null,ve),de)}$.forEach=U;function j(V,Y,de){return z((we,Pe=null,ve)=>V(Ce=>Y(Ce)&&we.call(Pe,Ce),null,ve),de)}$.filter=j;function F(V){return V}$.signal=F;function M(...V){return(Y,de=null,we)=>{const Pe=(0,h.$Qc)(...V.map(ve=>ve(Ce=>Y.call(de,Ce))));return J(Pe,we)}}$.any=M;function O(V,Y,de,we){let Pe=de;return T(V,ve=>(Pe=Y(Pe,ve),Pe),we)}$.reduce=O;function z(V,Y){let de;const we={onWillAddFirstListener(){de=V(Pe.fire,Pe)},onDidRemoveLastListener(){de?.dispose()}};Y||f(we);const Pe=new n(we);return Y?.add(Pe),Pe.event}function J(V,Y){return Y instanceof Array?Y.push(V):Y&&Y.add(V),V}function te(V,Y,de=100,we=!1,Pe=!1,ve,Ce){let B,Q,ee,H=0,oe;const le={leakWarningThreshold:ve,onWillAddFirstListener(){B=V(je=>{H++,Q=Y(Q,je),we&&!ee&&(Re.fire(Q),Q=void 0),oe=()=>{const He=Q;Q=void 0,ee=void 0,(!we||H>1)&&Re.fire(He),H=0},typeof de=="number"?(clearTimeout(ee),ee=setTimeout(oe,de)):ee===void 0&&(ee=0,queueMicrotask(oe))})},onWillRemoveListener(){Pe&&H>0&&oe?.()},onDidRemoveLastListener(){oe=void 0,B.dispose()}};Ce||f(le);const Re=new n(le);return Ce?.add(Re),Re.event}$.debounce=te;function x(V,Y=0,de){return $.debounce(V,(we,Pe)=>we?(we.push(Pe),we):[Pe],Y,void 0,!0,void 0,de)}$.accumulate=x;function X(V,Y=(we,Pe)=>we===Pe,de){let we=!0,Pe;return j(V,ve=>{const Ce=we||!Y(ve,Pe);return we=!1,Pe=ve,Ce},de)}$.latch=X;function Z(V,Y,de){return[$.filter(V,Y,de),$.filter(V,we=>!Y(we),de)]}$.split=Z;function ae(V,Y=!1,de=[],we){let Pe=de.slice(),ve=V(Q=>{Pe?Pe.push(Q):B.fire(Q)});we&&we.add(ve);const Ce=()=>{Pe?.forEach(Q=>B.fire(Q)),Pe=null},B=new n({onWillAddFirstListener(){ve||(ve=V(Q=>B.fire(Q)),we&&we.add(ve))},onDidAddFirstListener(){Pe&&(Y?setTimeout(Ce):Ce())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return we&&we.add(B),B.event}$.buffer=ae;function _(V,Y){return(we,Pe,ve)=>{const Ce=Y(new ne);return V(function(B){const Q=Ce.evaluate(B);Q!==ge&&we.call(Pe,Q)},void 0,ve)}}$.chain=_;const ge=Symbol("HaltChainable");class ne{constructor(){this.f=[]}map(Y){return this.f.push(Y),this}forEach(Y){return this.f.push(de=>(Y(de),de)),this}filter(Y){return this.f.push(de=>Y(de)?de:ge),this}reduce(Y,de){let we=de;return this.f.push(Pe=>(we=Y(we,Pe),we)),this}latch(Y=(de,we)=>de===we){let de=!0,we;return this.f.push(Pe=>{const ve=de||!Y(Pe,we);return de=!1,we=Pe,ve?Pe:ge}),this}evaluate(Y){for(const de of this.f)if(Y=de(Y),Y===ge)break;return Y}}function K(V,Y,de=we=>we){const we=(...B)=>Ce.fire(de(...B)),Pe=()=>V.on(Y,we),ve=()=>V.removeListener(Y,we),Ce=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:ve});return Ce.event}$.fromNodeEventEmitter=K;function W(V,Y,de=we=>we){const we=(...B)=>Ce.fire(de(...B)),Pe=()=>V.addEventListener(Y,we),ve=()=>V.removeEventListener(Y,we),Ce=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:ve});return Ce.event}$.fromDOMEventEmitter=W;function re(V){return new Promise(Y=>L(V)(Y))}$.toPromise=re;function ye(V){const Y=new n;return V.then(de=>{Y.fire(de)},()=>{Y.fire(void 0)}).finally(()=>{Y.dispose()}),Y.event}$.fromPromise=ye;function he(V,Y,de){return Y(de),V(we=>Y(we))}$.runAndSubscribe=he;class fe{constructor(Y,de){this._observable=Y,this.f=0,this.g=!1;const we={onWillAddFirstListener:()=>{Y.addObserver(this)},onDidRemoveLastListener:()=>{Y.removeObserver(this)}};de||f(we),this.emitter=new n(we),de&&de.add(this.emitter)}beginUpdate(Y){this.f++}handlePossibleChange(Y){}handleChange(Y,de){this.g=!0}endUpdate(Y){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ue(V,Y){return new fe(V,Y).emitter.event}$.fromObservable=ue;function me(V){return(Y,de,we)=>{let Pe=0,ve=!1;const Ce={beginUpdate(){Pe++},endUpdate(){Pe--,Pe===0&&(V.reportChanges(),ve&&(ve=!1,Y.call(de)))},handlePossibleChange(){},handleChange(){ve=!0}};V.addObserver(Ce),V.reportChanges();const B={dispose(){V.removeObserver(Ce)}};return we instanceof h.$Sc?we.add(B):Array.isArray(we)&&we.push(B),B}}$.fromObservableLight=me})(k||(e.Event=k={}));class R{static{this.all=new Set}static{this.f=0}constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${R.f++}`,R.all.add(this)}start(f){this.g=new A.$Sd,this.listenerCount=f}stop(){if(this.g){const f=this.g.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.g=void 0}}}e.$Ud=R;let C=-1;function w($){const f=C;return C=$,{dispose(){C=f}}}e.$Vd=w;class E{constructor(f,y=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=y,this.g=0}dispose(){this.f?.clear()}check(f,y){const L=this.threshold;if(L<=0||y<L)return;this.f||(this.f=new Map);const T=this.f.get(f.value)||0;if(this.f.set(f.value,T+1),this.g-=1,this.g<=0){this.g=L*.5;let U,j=0;for(const[F,M]of this.f)(!U||j<M)&&(U=F,j=M);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${j}):`),console.warn(U)}return()=>{const U=this.f.get(f.value)||0;this.f.set(f.value,U-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let c=0;class m{constructor(f){this.value=f,this.id=c++}}const a=2,i=($,f)=>{if($ instanceof m)f($);else for(let y=0;y<$.length;y++){const L=$[y];L&&f(L)}};class n{constructor(f){this.w=0,this.f=f,this.g=C>0||this.f?.leakWarningThreshold?new E(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(p){const f=this.t;queueMicrotask(()=>{i(f,y=>y.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(f,y,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),h.$Tc.None;if(this.m)return h.$Tc.None;y&&(f=f.bind(y));const T=new m(f);let U,j;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=S.create(),U=this.g.check(T.stack,this.w+1)),p&&(T.stack=j??S.create()),this.t?this.t instanceof m?(this.u??=new s,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const F=(0,h.$Rc)(()=>{U?.(),this.x(T)});return L instanceof h.$Sc?L.add(F):Array.isArray(L)&&L.push(F),F},this.q}x(f){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const y=this.t,L=y.indexOf(f);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,y[L]=void 0;const T=this.u.current===this;if(this.w*a<=y.length){let U=0;for(let j=0;j<y.length;j++)y[j]?y[U++]=y[j]:T&&(this.u.end--,U<this.u.i&&this.u.i--);y.length=U}}y(f,y){if(!f)return;const L=this.f?.onListenerError||D.$1;if(!L){f.value(y);return}try{f.value(y)}catch(T){L(T)}}z(f){const y=f.current.t;for(;f.i<f.end;)this.y(y[f.i++],f.value);f.reset()}fire(f){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,f);else{const y=this.u;y.enqueue(this,f,this.t.length),this.z(y)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Wd=n;const r=()=>new s;e.$Xd=r;class s{constructor(){this.i=-1,this.end=0}enqueue(f,y,L){this.i=0,this.end=L,this.current=f,this.value=y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(f,y,L){if(this.t)for(this.h||(this.h=new P.$4c),i(this.t,T=>this.h.push([T.value,f]));this.h.size>0&&!y.isCancellationRequested;){const[T,U]=this.h.shift(),j=[],F={...U,token:y,waitUntil:M=>{if(Object.isFrozen(j))throw new Error("waitUntil can NOT be called asynchronous");L&&(M=L(M,T)),j.push(M)}};try{T(F)}catch(M){(0,D.$1)(M);continue}Object.freeze(j),await Promise.allSettled(j).then(M=>{for(const O of M)O.status==="rejected"&&(0,D.$1)(O.reason)})}}}e.$Yd=t;class g extends n{get isPaused(){return this.h!==0}constructor(f){super(f),this.h=0,this.s=new P.$4c,this.A=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.A(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.w&&(this.h!==0?this.s.push(f):super.fire(f))}}e.$Zd=g;class o extends g{constructor(f){super(f),this.k=f.delay??100}fire(f){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(f)}}e.$1d=o;class d extends n{constructor(f){super(f),this.h=[],this.k=f?.merge}fire(f){this.hasListeners()&&(this.h.push(f),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(y=>super.fire(y)),this.h=[]}))}}e.$2d=d;class l{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(f){const y={event:f,listener:null};this.h.push(y),this.g&&this.m(y);const L=()=>{this.g&&this.o(y);const T=this.h.indexOf(y);this.h.splice(T,1)};return(0,h.$Rc)((0,N.$db)(L))}j(){this.g=!0,this.h.forEach(f=>this.m(f))}k(){this.g=!1,this.h.forEach(f=>this.o(f))}m(f){f.listener=f.event(y=>this.f.fire(y))}o(f){f.listener?.dispose(),f.listener=null}dispose(){this.f.dispose();for(const f of this.h)f.listener?.dispose();this.h=[]}}e.$3d=l;class u{constructor(f,y,L,T){this.f=new h.$Sc;const U=this.f.add(new l),j=this.f.add(new h.$3c);function F(M){j.set(M,U.add(T(M)))}for(const M of f)F(M);this.f.add(y(M=>{F(M)})),this.f.add(L(M=>{j.deleteAndDispose(M)})),this.event=U.event}dispose(){this.f.dispose()}}e.$4d=u;class v{constructor(){this.f=[]}wrapEvent(f){return(y,L,T)=>f(U=>{const j=this.f[this.f.length-1];j?j.push(()=>y.call(L,U)):y.call(L,U)},void 0,T)}bufferEvents(f){const y=[];this.f.push(y);const L=f();return this.f.pop(),y.forEach(T=>T()),L}}e.$5d=v;class I{constructor(){this.f=!1,this.g=k.None,this.h=h.$Tc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(f){this.g=f,this.f&&(this.h.dispose(),this.h=f(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$6d=I}),define(ke[22],Se([1,0,4]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.CancellationToken=void 0;const N=Object.freeze(function(p,b){const k=setTimeout(p.bind(b),0);return{dispose(){clearTimeout(k)}}});var h;(function(p){function b(k){return k===p.None||k===p.Cancelled||k instanceof P?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}p.isCancellationToken=b,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(h||(e.CancellationToken=h={}));class P{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new D.$Wd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new P),this.f}cancel(){this.f?this.f instanceof P&&this.f.cancel():this.f=h.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof P&&this.f.dispose():this.f=h.None}}e.$7d=A}),define(ke[162],Se([1,0,22]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=e.$Ge=e.$Fe=void 0;class N{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new D.$7d,b=this.b(p.token);return this.a={promise:b,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$Fe=N;class h{constructor(p){this.c=p,this.a=void 0,this.b=void 0}get(p){const b=JSON.stringify(p);return this.b!==b&&(this.b=b,this.a=this.c(p)),this.a}}e.$Ge=h;class P{get cachedValues(){return this.a}constructor(p){this.b=p,this.a=new Map}get(p){if(this.a.has(p))return this.a.get(p);const b=this.b(p);return this.a.set(p,b),b}}e.$He=P}),define(ke[99],Se([1,0,14,3]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function h(r){const s=r;return s?typeof s.read=="function":!1}e.$8d=h;function P(r){const s=r;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}e.$9d=P;function A(r){const s=r;return s?P(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.$0d=A;function p(r,s){return new b(r,s)}e.$$d=p;class b{constructor(s,t){this.e=s,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(t=>t(s))}h(s){this.c.error.length===0?(0,D.$1)(s):this.c.error.slice(0).forEach(t=>t(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,t){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(s,t){if(this.a.destroyed)return;let g;switch(s){case"data":g=this.c.data;break;case"end":g=this.c.end;break;case"error":g=this.c.error;break}if(g){const o=g.indexOf(t);o>=0&&g.splice(o,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(g=>g())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(r,s){const t=[];let g;for(;(g=r.read())!==null;)t.push(g);return s(t)}e.$_d=k;function R(r,s,t){const g=[];let o;for(;(o=r.read())!==null&&g.length<t;)g.push(o);return o===null&&g.length>0?s(g):{read:()=>{if(g.length>0)return g.shift();if(typeof o<"u"){const d=o;return o=void 0,d}return r.read()}}}e.$ae=R;function C(r,s){return new Promise((t,g)=>{const o=[];w(r,{onData:d=>{s&&o.push(d)},onError:d=>{s?g(d):t(void 0)},onEnd:()=>{t(s?s(o):void 0)}})})}e.$be=C;function w(r,s,t){r.on("error",g=>{t?.isCancellationRequested||s.onError(g)}),r.on("end",()=>{t?.isCancellationRequested||s.onEnd()}),r.on("data",g=>{t?.isCancellationRequested||s.onData(g)})}e.$ce=w;function E(r,s){return new Promise((t,g)=>{const o=new N.$Sc,d=[],l=I=>{if(d.push(I),d.length>s)return o.dispose(),r.pause(),t({stream:r,buffer:d,ended:!1})},u=I=>(o.dispose(),g(I)),v=()=>(o.dispose(),t({stream:r,buffer:d,ended:!0}));o.add((0,N.$Rc)(()=>r.removeListener("error",u))),r.on("error",u),o.add((0,N.$Rc)(()=>r.removeListener("end",v))),r.on("end",v),o.add((0,N.$Rc)(()=>r.removeListener("data",l))),r.on("data",l)})}e.$de=E;function S(r,s){const t=p(s);return t.end(r),t}e.$ee=S;function c(){const r=p(()=>{throw new Error("not supported")});return r.end(),r}e.$fe=c;function m(r){let s=!1;return{read:()=>s?null:(s=!0,r)}}e.$ge=m;function a(r,s,t){const g=p(t);return w(r,{onData:o=>g.write(s.data(o)),onError:o=>g.error(s.error?s.error(o):o),onEnd:()=>g.end()}),g}e.$he=a;function i(r,s,t){let g=!1;return{read:()=>{const o=s.read();return g?o:(g=!0,o!==null?t([r,o]):r)}}}e.$ie=i;function n(r,s,t){let g=!1;const o=p(t);return w(s,{onData:d=>g?o.write(d):(g=!0,o.write(t([r,d]))),onError:d=>o.error(d),onEnd:()=>{g||(g=!0,o.write(r)),o.end()}}),o}e.$je=n}),define(ke[21],Se([1,0,43,99]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const h=typeof Buffer<"u",P=new D.$V(()=>new Uint8Array(256));let A,p;class b{static alloc(y){return h?new b(Buffer.allocUnsafe(y)):new b(new Uint8Array(y))}static wrap(y){return h&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new b(y)}static fromString(y,L){return!(L?.dontUseNodeBuffer||!1)&&h?new b(Buffer.from(y)):(A||(A=new TextEncoder),new b(A.encode(y)))}static fromByteArray(y){const L=b.alloc(y.length);for(let T=0,U=y.length;T<U;T++)L.buffer[T]=y[T];return L}static concat(y,L){if(typeof L>"u"){L=0;for(let j=0,F=y.length;j<F;j++)L+=y[j].byteLength}const T=b.alloc(L);let U=0;for(let j=0,F=y.length;j<F;j++){const M=y[j];T.set(M,U),U+=M.byteLength}return T}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=b.alloc(this.byteLength);return y.set(this),y}toString(){return h?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(y,L){return new b(this.buffer.subarray(y,L))}set(y,L){if(y instanceof b)this.buffer.set(y.buffer,L);else if(y instanceof Uint8Array)this.buffer.set(y,L);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),L);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return w(this.buffer,y)}writeUInt32BE(y,L){E(this.buffer,y,L)}readUInt32LE(y){return S(this.buffer,y)}writeUInt32LE(y,L){c(this.buffer,y,L)}readUInt8(y){return m(this.buffer,y)}writeUInt8(y,L){a(this.buffer,y,L)}indexOf(y,L=0){return k(this.buffer,y instanceof b?y.buffer:y,L)}}e.$ke=b;function k(f,y,L=0){const T=y.byteLength,U=f.byteLength;if(T===0)return 0;if(T===1)return f.indexOf(y[0]);if(T>U-L)return-1;const j=P.value;j.fill(y.length);for(let z=0;z<y.length;z++)j[y[z]]=y.length-z-1;let F=L+y.length-1,M=F,O=-1;for(;F<U;)if(f[F]===y[M]){if(M===0){O=F;break}F--,M--}else F+=Math.max(y.length-M,j[f[F]]),M=y.length-1;return O}e.$le=k;function R(f,y){return f[y+0]<<0>>>0|f[y+1]<<8>>>0}e.$me=R;function C(f,y,L){f[L+0]=y&255,y=y>>>8,f[L+1]=y&255}e.$ne=C;function w(f,y){return f[y]*2**24+f[y+1]*2**16+f[y+2]*2**8+f[y+3]}e.$oe=w;function E(f,y,L){f[L+3]=y,y=y>>>8,f[L+2]=y,y=y>>>8,f[L+1]=y,y=y>>>8,f[L]=y}e.$pe=E;function S(f,y){return f[y+0]<<0>>>0|f[y+1]<<8>>>0|f[y+2]<<16>>>0|f[y+3]<<24>>>0}e.$qe=S;function c(f,y,L){f[L+0]=y&255,y=y>>>8,f[L+1]=y&255,y=y>>>8,f[L+2]=y&255,y=y>>>8,f[L+3]=y&255}e.$re=c;function m(f,y){return f[y]}e.$se=m;function a(f,y,L){f[L]=y}e.$te=a;function i(f){return N.$_d(f,y=>b.concat(y))}e.$ue=i;function n(f){return N.$ge(f)}e.$ve=n;function r(f){return N.$be(f,y=>b.concat(y))}e.$we=r;async function s(f){return f.ended?b.concat(f.buffer):b.concat([...f.buffer,await r(f.stream)])}e.$xe=s;function t(f){return N.$ee(f,y=>b.concat(y))}e.$ye=t;function g(f){return N.$he(f,{data:y=>typeof y=="string"?b.fromString(y):b.wrap(y)},y=>b.concat(y))}e.$ze=g;function o(f){return N.$$d(y=>b.concat(y),f)}e.$Ae=o;function d(f,y){return N.$ie(f,y,L=>b.concat(L))}e.$Be=d;function l(f,y){return N.$je(f,y,L=>b.concat(L))}e.$Ce=l;function u(f){let y=0,L=0,T=0;const U=new Uint8Array(Math.floor(f.length/4*3)),j=M=>{switch(L){case 3:U[T++]=y|M,L=0;break;case 2:U[T++]=y|M>>>2,y=M<<6,L=3;break;case 1:U[T++]=y|M>>>4,y=M<<4,L=2;break;default:y=M<<2,L=1}};for(let M=0;M<f.length;M++){const O=f.charCodeAt(M);if(O>=65&&O<=90)j(O-65);else if(O>=97&&O<=122)j(O-97+26);else if(O>=48&&O<=57)j(O-48+52);else if(O===43||O===45)j(62);else if(O===47||O===95)j(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${f[M]}`)}}const F=T;for(;L>0;)j(0);return b.wrap(U).slice(0,F)}e.$De=u;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function $({buffer:f},y=!0,L=!1){const T=L?I:v;let U="";const j=f.byteLength%3;let F=0;for(;F<f.byteLength-j;F+=3){const M=f[F+0],O=f[F+1],z=f[F+2];U+=T[M>>>2],U+=T[(M<<4|O>>>4)&63],U+=T[(O<<2|z>>>6)&63],U+=T[z&63]}if(j===1){const M=f[F+0];U+=T[M>>>2],U+=T[M<<4&63],y&&(U+="==")}else if(j===2){const M=f[F+0],O=f[F+1];U+=T[M>>>2],U+=T[(M<<4|O>>>4)&63],U+=T[O<<2&63],y&&(U+="=")}return U}e.$Ee=$}),define(ke[12],Se([1,0,162,43]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$If=e.$Hf=e.$Gf=e.$Ff=e.GraphemeBreakType=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=void 0;function h(Le){return!Le||typeof Le!="string"?!0:Le.trim().length===0}e.$Ke=h;const P=/{(\d+)}/g;function A(Le,...ze){return ze.length===0?Le:Le.replace(P,function(Ae,Ze){const ie=parseInt(Ze,10);return isNaN(ie)||ie<0||ie>=ze.length?Ae:ze[ie]})}e.$Le=A;const p=/{([^}]+)}/g;function b(Le,ze){return Object.keys(ze).length===0?Le:Le.replace(p,(Ae,Ze)=>ze[Ze]??Ae)}e.$Me=b;function k(Le){return Le.replace(/[<>"'&]/g,ze=>{switch(ze){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ze})}e.$Ne=k;function R(Le){return Le.replace(/[<>&]/g,function(ze){switch(ze){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ze}})}e.$Oe=R;function C(Le){return Le.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Pe=C;function w(Le,ze){let Ae=0;const Ze=ze.charCodeAt(0);for(let ie=Le.length-1;ie>=0;ie--)Le.charCodeAt(ie)===Ze&&Ae++;return Ae}e.$Qe=w;function E(Le,ze,Ae="\u2026"){return Le.length<=ze?Le:`${Le.substr(0,ze)}${Ae}`}e.$Re=E;function S(Le,ze,Ae="\u2026"){if(Le.length<=ze)return Le;const Ze=Math.ceil(ze/2)-Ae.length/2,ie=Math.floor(ze/2)-Ae.length/2;return`${Le.substr(0,Ze)}${Ae}${Le.substr(Le.length-ie)}`}e.$Se=S;function c(Le,ze=" "){const Ae=m(Le,ze);return a(Ae,ze)}e.$Te=c;function m(Le,ze){if(!Le||!ze)return Le;const Ae=ze.length;if(Ae===0||Le.length===0)return Le;let Ze=0;for(;Le.indexOf(ze,Ze)===Ze;)Ze=Ze+Ae;return Le.substring(Ze)}e.$Ue=m;function a(Le,ze){if(!Le||!ze)return Le;const Ae=ze.length,Ze=Le.length;if(Ae===0||Ze===0)return Le;let ie=Ze,se=-1;for(;se=Le.lastIndexOf(ze,ie-1),!(se===-1||se+Ae!==ie);){if(se===0)return"";ie=se}return Le.substring(0,ie)}e.$Ve=a;function i(Le){return Le.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$We=i;function n(Le){return Le.replace(/\*/g,"")}e.$Xe=n;function r(Le,ze,Ae={}){if(!Le)throw new Error("Cannot create regex from empty string");ze||(Le=C(Le)),Ae.wholeWord&&(/\B/.test(Le.charAt(0))||(Le="\\b"+Le),/\B/.test(Le.charAt(Le.length-1))||(Le=Le+"\\b"));let Ze="";return Ae.global&&(Ze+="g"),Ae.matchCase||(Ze+="i"),Ae.multiline&&(Ze+="m"),Ae.unicode&&(Ze+="u"),new RegExp(Le,Ze)}e.$Ye=r;function s(Le){return Le.source==="^"||Le.source==="^$"||Le.source==="$"||Le.source==="^\\s*$"?!1:!!(Le.exec("")&&Le.lastIndex===0)}e.$Ze=s;function t(Le){return Le.split(/\r\n|\r|\n/)}e.$1e=t;function g(Le){for(let ze=0,Ae=Le.length;ze<Ae;ze++){const Ze=Le.charCodeAt(ze);if(Ze!==32&&Ze!==9)return ze}return-1}e.$2e=g;function o(Le,ze=0,Ae=Le.length){for(let Ze=ze;Ze<Ae;Ze++){const ie=Le.charCodeAt(Ze);if(ie!==32&&ie!==9)return Le.substring(ze,Ze)}return Le.substring(ze,Ae)}e.$3e=o;function d(Le,ze=Le.length-1){for(let Ae=ze;Ae>=0;Ae--){const Ze=Le.charCodeAt(Ae);if(Ze!==32&&Ze!==9)return Ae}return-1}e.$4e=d;function l(Le,ze,Ae){const Ze=[];let ie=0;for(const se of Le.matchAll(ze)){if(Ze.push(Le.slice(ie,se.index)),se.index===void 0)throw new Error("match.index should be defined");ie=se.index+se[0].length,Ze.push(Ae(se[0],...se.slice(1),se.index,Le,se.groups))}return Ze.push(Le.slice(ie)),Promise.all(Ze).then(se=>se.join(""))}e.$5e=l;function u(Le,ze){return Le<ze?-1:Le>ze?1:0}e.$6e=u;function v(Le,ze,Ae=0,Ze=Le.length,ie=0,se=ze.length){for(;Ae<Ze&&ie<se;Ae++,ie++){const Ye=Le.charCodeAt(Ae),it=ze.charCodeAt(ie);if(Ye<it)return-1;if(Ye>it)return 1}const Ie=Ze-Ae,qe=se-ie;return Ie<qe?-1:Ie>qe?1:0}e.$7e=v;function I(Le,ze){return $(Le,ze,0,Le.length,0,ze.length)}e.$8e=I;function $(Le,ze,Ae=0,Ze=Le.length,ie=0,se=ze.length){for(;Ae<Ze&&ie<se;Ae++,ie++){let Ye=Le.charCodeAt(Ae),it=ze.charCodeAt(ie);if(Ye===it)continue;if(Ye>=128||it>=128)return v(Le.toLowerCase(),ze.toLowerCase(),Ae,Ze,ie,se);y(Ye)&&(Ye-=32),y(it)&&(it-=32);const nt=Ye-it;if(nt!==0)return nt}const Ie=Ze-Ae,qe=se-ie;return Ie<qe?-1:Ie>qe?1:0}e.$9e=$;function f(Le){return Le>=48&&Le<=57}e.$0e=f;function y(Le){return Le>=97&&Le<=122}e.$$e=y;function L(Le){return Le>=65&&Le<=90}e.$_e=L;function T(Le,ze){return Le.length===ze.length&&$(Le,ze)===0}e.$af=T;function U(Le,ze){const Ae=ze.length;return ze.length>Le.length?!1:$(Le,ze,0,Ae)===0}e.$bf=U;function j(Le,ze){const Ae=Math.min(Le.length,ze.length);let Ze;for(Ze=0;Ze<Ae;Ze++)if(Le.charCodeAt(Ze)!==ze.charCodeAt(Ze))return Ze;return Ae}e.$cf=j;function F(Le,ze){const Ae=Math.min(Le.length,ze.length);let Ze;const ie=Le.length-1,se=ze.length-1;for(Ze=0;Ze<Ae;Ze++)if(Le.charCodeAt(ie-Ze)!==ze.charCodeAt(se-Ze))return Ze;return Ae}e.$df=F;function M(Le){return 55296<=Le&&Le<=56319}e.$ef=M;function O(Le){return 56320<=Le&&Le<=57343}e.$ff=O;function z(Le,ze){return(Le-55296<<10)+(ze-56320)+65536}e.$gf=z;function J(Le,ze,Ae){const Ze=Le.charCodeAt(Ae);if(M(Ze)&&Ae+1<ze){const ie=Le.charCodeAt(Ae+1);if(O(ie))return z(Ze,ie)}return Ze}e.$hf=J;function te(Le,ze){const Ae=Le.charCodeAt(ze-1);if(O(Ae)&&ze>1){const Ze=Le.charCodeAt(ze-2);if(M(Ze))return z(Ze,Ae)}return Ae}class x{get offset(){return this.e}constructor(ze,Ae=0){this.c=ze,this.d=ze.length,this.e=Ae}setOffset(ze){this.e=ze}prevCodePoint(){const ze=te(this.c,this.e);return this.e-=ze>=65536?2:1,ze}nextCodePoint(){const ze=J(this.c,this.d,this.e);return this.e+=ze>=65536?2:1,ze}eol(){return this.e>=this.d}}e.$if=x;class X{get offset(){return this.c.offset}constructor(ze,Ae=0){this.c=new x(ze,Ae)}nextGraphemeLength(){const ze=Re.getInstance(),Ae=this.c,Ze=Ae.offset;let ie=ze.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const se=Ae.offset,Ie=ze.getGraphemeBreakType(Ae.nextCodePoint());if(oe(ie,Ie)){Ae.setOffset(se);break}ie=Ie}return Ae.offset-Ze}prevGraphemeLength(){const ze=Re.getInstance(),Ae=this.c,Ze=Ae.offset;let ie=ze.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const se=Ae.offset,Ie=ze.getGraphemeBreakType(Ae.prevCodePoint());if(oe(Ie,ie)){Ae.setOffset(se);break}ie=Ie}return Ze-Ae.offset}eol(){return this.c.eol()}}e.$jf=X;function Z(Le,ze){return new X(Le,ze).nextGraphemeLength()}e.$kf=Z;function ae(Le,ze){return new X(Le,ze).prevGraphemeLength()}e.$lf=ae;function _(Le,ze){ze>0&&O(Le.charCodeAt(ze))&&ze--;const Ae=ze+Z(Le,ze);return[Ae-ae(Le,Ae),Ae]}e.$mf=_;function ge(Le){const ze=new X(Le);let Ae=0;for(;!ze.eol();)Ae++,ze.nextGraphemeLength();return Ae}e.$nf=ge;let ne;function K(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(Le){return ne||(ne=K()),ne.test(Le)}e.$of=W;const re=/^[\t\n\r\x20-\x7E]*$/;function ye(Le){return re.test(Le)}e.$pf=ye,e.$qf=/[\u2028\u2029]/;function he(Le){return e.$qf.test(Le)}e.$rf=he;function fe(Le){return Le>=11904&&Le<=55215||Le>=63744&&Le<=64255||Le>=65281&&Le<=65374}e.$sf=fe;function ue(Le){return Le>=127462&&Le<=127487||Le===8986||Le===8987||Le===9200||Le===9203||Le>=9728&&Le<=10175||Le===11088||Le===11093||Le>=127744&&Le<=128591||Le>=128640&&Le<=128764||Le>=128992&&Le<=129008||Le>=129280&&Le<=129535||Le>=129648&&Le<=129782}e.$tf=ue;function me(Le,ze,Ae=""){const Ze=Le.trimStart();if(Ze.length<ze)return Ze;const ie=/\b/g;let se=0;for(;ie.test(Ze)&&!(Ze.length-ie.lastIndex<ze);)se=ie.lastIndex,ie.lastIndex+=1;return se===0?Ze:Ae+Ze.substring(se).trimStart()}e.$uf=me;const V=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Y=/\x1b\].*?\x07/g;function de(Le){return Le&&(Le=Le.replace(V,"").replace(Y,"")),Le}e.$vf=de,e.$wf=String.fromCharCode(65279);function we(Le){return!!(Le&&Le.length>0&&Le.charCodeAt(0)===65279)}e.$xf=we;function Pe(Le){return we(Le)?Le.substr(1):Le}e.$yf=Pe;function ve(Le,ze){if(!Le||!ze||Le.length<ze.length)return!1;const Ae=ze.length,Ze=Le.toLowerCase();let ie=0,se=-1;for(;ie<Ae;){const Ie=Ze.indexOf(ze[ie],se+1);if(Ie<0)return!1;se=Ie,ie++}return!0}e.$zf=ve;function Ce(Le,ze=!1){return Le?(ze&&(Le=Le.replace(/\\./g,"")),Le.toLowerCase()!==Le):!1}e.$Af=Ce;function B(Le){return Le.charAt(0).toUpperCase()+Le.slice(1)}e.$Bf=B;function Q(Le,ze=1){if(ze===0)return"";let Ae=-1;do Ae=Le.indexOf(`
`,Ae+1),ze--;while(ze>0&&Ae>=0);return Ae===-1?Le:(Le[Ae-1]==="\r"&&Ae--,Le.substr(0,Ae))}e.$Cf=Q;function ee(Le){return Le=Le%(2*26),Le<26?String.fromCharCode(97+Le):String.fromCharCode(65+Le-26)}e.$Df=ee;function H(Le){return Re.getInstance().getGraphemeBreakType(Le)}e.$Ef=H;function oe(Le,ze){return Le===0?ze!==5&&ze!==7:Le===2&&ze===3?!1:Le===4||Le===2||Le===3||ze===4||ze===2||ze===3?!0:!(Le===8&&(ze===8||ze===9||ze===11||ze===12)||(Le===11||Le===9)&&(ze===9||ze===10)||(Le===12||Le===10)&&ze===10||ze===5||ze===13||ze===7||Le===1||Le===13&&ze===14||Le===6&&ze===6)}var le;(function(Le){Le[Le.Other=0]="Other",Le[Le.Prepend=1]="Prepend",Le[Le.CR=2]="CR",Le[Le.LF=3]="LF",Le[Le.Control=4]="Control",Le[Le.Extend=5]="Extend",Le[Le.Regional_Indicator=6]="Regional_Indicator",Le[Le.SpacingMark=7]="SpacingMark",Le[Le.L=8]="L",Le[Le.V=9]="V",Le[Le.T=10]="T",Le[Le.LV=11]="LV",Le[Le.LVT=12]="LVT",Le[Le.ZWJ=13]="ZWJ",Le[Le.Extended_Pictographic=14]="Extended_Pictographic"})(le||(e.GraphemeBreakType=le={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=je()}getGraphemeBreakType(ze){if(ze<32)return ze===10?3:ze===13?2:4;if(ze<127)return 0;const Ae=this.d,Ze=Ae.length/3;let ie=1;for(;ie<=Ze;)if(ze<Ae[3*ie])ie=2*ie;else if(ze>Ae[3*ie+1])ie=2*ie+1;else return Ae[3*ie+2];return 0}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Le,ze){if(Le===0)return 0;const Ae=Qe(Le,ze);if(Ae!==void 0)return Ae;const Ze=new x(ze,Le);return Ze.prevCodePoint(),Ze.offset}e.$Ff=He;function Qe(Le,ze){const Ae=new x(ze,Le);let Ze=Ae.prevCodePoint();for(;_e(Ze)||Ze===65039||Ze===8419;){if(Ae.offset===0)return;Ze=Ae.prevCodePoint()}if(!ue(Ze))return;let ie=Ae.offset;return ie>0&&Ae.prevCodePoint()===8205&&(ie=Ae.offset),ie}function _e(Le){return 127995<=Le&&Le<=127999}var at;(function(Le){Le[Le.zwj=8205]="zwj",Le[Le.emojiVariantSelector=65039]="emojiVariantSelector",Le[Le.enclosingKeyCap=8419]="enclosingKeyCap"})(at||(at={})),e.$Gf="\xA0";class st{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Ge(ze=>{function Ae(nt){const Oe=new Map;for(let yt=0;yt<nt.length;yt+=2)Oe.set(nt[yt],nt[yt+1]);return Oe}function Ze(nt,Oe){const yt=new Map(nt);for(const[Dt,Tt]of Oe)yt.set(Dt,Tt);return yt}function ie(nt,Oe){if(!nt)return Oe;const yt=new Map;for(const[Dt,Tt]of nt)Oe.has(Dt)&&yt.set(Dt,Tt);return yt}const se=this.c.value;let Ie=ze.filter(nt=>!nt.startsWith("_")&&nt in se);Ie.length===0&&(Ie=["_default"]);let qe;for(const nt of Ie){const Oe=Ae(se[nt]);qe=ie(qe,Oe)}const Ye=Ae(se._common),it=Ze(Ye,qe);return new st(it)})}static getInstance(ze){return st.d.get(Array.from(ze))}static{this.e=new N.$V(()=>Object.keys(st.c.value).filter(ze=>!ze.startsWith("_")))}static getLocales(){return st.e.value}constructor(ze){this.f=ze}isAmbiguous(ze){return this.f.has(ze)}getPrimaryConfusable(ze){return this.f.get(ze)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Hf=st;class rt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(rt.c())),this.d}static isInvisibleCharacter(ze){return rt.e().has(ze)}static get codePoints(){return rt.e()}}e.$If=rt}),define(ke[123],Se([1,0,28,161,12]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=e.$9j=e.$8j=e.FuzzyScore=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.or=void 0;function P(...ve){return function(Ce,B){for(let Q=0,ee=ve.length;Q<ee;Q++){const H=ve[Q](Ce,B);if(H)return H}return null}}e.or=P,e.$Vj=A.bind(void 0,!1),e.$Wj=A.bind(void 0,!0);function A(ve,Ce,B){if(!B||B.length<Ce.length)return null;let Q;return ve?Q=h.$bf(B,Ce):Q=B.indexOf(Ce)===0,Q?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function p(ve,Ce){const B=Ce.toLowerCase().indexOf(ve.toLowerCase());return B===-1?null:[{start:B,end:B+ve.length}]}e.$Xj=p;function b(ve,Ce){return k(ve.toLowerCase(),Ce.toLowerCase(),0,0)}e.$Yj=b;function k(ve,Ce,B,Q){if(B===ve.length)return[];if(Q===Ce.length)return null;if(ve[B]===Ce[Q]){let ee=null;return(ee=k(ve,Ce,B+1,Q+1))?r({start:Q,end:Q+1},ee):null}return k(ve,Ce,B,Q+1)}function R(ve){return 97<=ve&&ve<=122}function C(ve){return 65<=ve&&ve<=90}e.$Zj=C;function w(ve){return 48<=ve&&ve<=57}function E(ve){return ve===32||ve===9||ve===10||ve===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ve=>S.add(ve.charCodeAt(0)));function c(ve){return E(ve)||S.has(ve)}function m(ve,Ce){return ve===Ce||c(ve)&&c(Ce)}const a=new Map;function i(ve){if(a.has(ve))return a.get(ve);let Ce;const B=(0,N.$Tj)(ve);return B&&(Ce=B),a.set(ve,Ce),Ce}function n(ve){return R(ve)||C(ve)||w(ve)}function r(ve,Ce){return Ce.length===0?Ce=[ve]:ve.end===Ce[0].start?Ce[0].start=ve.start:Ce.unshift(ve),Ce}function s(ve,Ce){for(let B=Ce;B<ve.length;B++){const Q=ve.charCodeAt(B);if(C(Q)||w(Q)||B>0&&!n(ve.charCodeAt(B-1)))return B}return ve.length}function t(ve,Ce,B,Q){if(B===ve.length)return[];if(Q===Ce.length)return null;if(ve[B]!==Ce[Q].toLowerCase())return null;{let ee=null,H=Q+1;for(ee=t(ve,Ce,B+1,Q+1);!ee&&(H=s(Ce,H))<Ce.length;)ee=t(ve,Ce,B+1,H),H++;return ee===null?null:r({start:Q,end:Q+1},ee)}}function g(ve){let Ce=0,B=0,Q=0,ee=0,H=0;for(let He=0;He<ve.length;He++)H=ve.charCodeAt(He),C(H)&&Ce++,R(H)&&B++,n(H)&&Q++,w(H)&&ee++;const oe=Ce/ve.length,le=B/ve.length,Re=Q/ve.length,je=ee/ve.length;return{upperPercent:oe,lowerPercent:le,alphaPercent:Re,numericPercent:je}}function o(ve){const{upperPercent:Ce,lowerPercent:B}=ve;return B===0&&Ce>.6}function d(ve){const{upperPercent:Ce,lowerPercent:B,alphaPercent:Q,numericPercent:ee}=ve;return B>.2&&Ce<.8&&Q>.6&&ee<.2}function l(ve){let Ce=0,B=0,Q=0,ee=0;for(let H=0;H<ve.length;H++)Q=ve.charCodeAt(H),C(Q)&&Ce++,R(Q)&&B++,E(Q)&&ee++;return(Ce===0||B===0)&&ee===0?ve.length<=30:Ce<=5}function u(ve,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!l(ve)||Ce.length>60)return null;const B=g(Ce);if(!d(B)){if(!o(B))return null;Ce=Ce.toLowerCase()}let Q=null,ee=0;for(ve=ve.toLowerCase();ee<Ce.length&&(Q=t(ve,Ce,0,ee))===null;)ee=s(Ce,ee+1);return Q}e.$1j=u;function v(ve,Ce,B=!1){if(!Ce||Ce.length===0)return null;let Q=null,ee=0;for(ve=ve.toLowerCase(),Ce=Ce.toLowerCase();ee<Ce.length&&(Q=I(ve,Ce,0,ee,B),Q===null);)ee=$(Ce,ee+1);return Q}e.$2j=v;function I(ve,Ce,B,Q,ee){let H=0;if(B===ve.length)return[];if(Q===Ce.length)return null;if(!m(ve.charCodeAt(B),Ce.charCodeAt(Q))){const Re=i(ve.charCodeAt(B));if(!Re)return null;for(let je=0;je<Re.length;je++)if(!m(Re[je],Ce.charCodeAt(Q+je)))return null;H+=Re.length-1}let oe=null,le=Q+H+1;if(oe=I(ve,Ce,B+1,le,ee),!ee)for(;!oe&&(le=$(Ce,le))<Ce.length;)oe=I(ve,Ce,B+1,le,ee),le++;if(!oe)return null;if(ve.charCodeAt(B)!==Ce.charCodeAt(Q)){const Re=i(ve.charCodeAt(B));if(!Re)return oe;for(let je=0;je<Re.length;je++)if(Re[je]!==Ce.charCodeAt(Q+je))return oe}return r({start:Q,end:Q+H+1},oe)}function $(ve,Ce){for(let B=Ce;B<ve.length;B++)if(c(ve.charCodeAt(B))||B>0&&c(ve.charCodeAt(B-1)))return B;return ve.length}const f=P(e.$Wj,u,p),y=P(e.$Wj,u,b),L=new D.$Dc(1e4);function T(ve,Ce,B=!1){if(typeof ve!="string"||typeof Ce!="string")return null;let Q=L.get(ve);Q||(Q=new RegExp(h.$We(ve),"i"),L.set(ve,Q));const ee=Q.exec(Ce);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:B?y(ve,Ce):f(ve,Ce)}e.$3j=T;function U(ve,Ce){const B=ue(ve,ve.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?F(B):null}e.$4j=U;function j(ve,Ce,B,Q,ee,H){const oe=Math.min(13,ve.length);for(;B<oe;B++){const le=ue(ve,Ce,B,Q,ee,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(le)return le}return[0,H]}e.$5j=j;function F(ve){if(typeof ve>"u")return[];const Ce=[],B=ve[1];for(let Q=ve.length-1;Q>1;Q--){const ee=ve[Q]+B,H=Ce[Ce.length-1];H&&H.end===ee?H.end=ee+1:Ce.push({start:ee,end:ee+1})}return Ce}e.$6j=F;const M=128;function O(){const ve=[],Ce=[];for(let B=0;B<=M;B++)Ce[B]=0;for(let B=0;B<=M;B++)ve.push(Ce.slice(0));return ve}function z(ve){const Ce=[];for(let B=0;B<=ve;B++)Ce[B]=0;return Ce}const J=z(2*M),te=z(2*M),x=O(),X=O(),Z=O(),ae=!1;function _(ve,Ce,B,Q,ee){function H(le,Re,je=" "){for(;le.length<Re;)le=je+le;return le}let oe=` |   |${Q.split("").map(le=>H(le,3)).join("|")}
`;for(let le=0;le<=B;le++)le===0?oe+=" |":oe+=`${Ce[le-1]}|`,oe+=ve[le].slice(0,ee+1).map(Re=>H(Re.toString(),3)).join("|")+`
`;return oe}function ge(ve,Ce,B,Q){ve=ve.substr(Ce),B=B.substr(Q),console.log(_(X,ve,ve.length,B,B.length)),console.log(_(Z,ve,ve.length,B,B.length)),console.log(_(x,ve,ve.length,B,B.length))}function ne(ve,Ce){if(Ce<0||Ce>=ve.length)return!1;const B=ve.codePointAt(Ce);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!h.$tf(B)}}function K(ve,Ce){if(Ce<0||Ce>=ve.length)return!1;switch(ve.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function W(ve,Ce,B){return Ce[ve]!==B[ve]}function re(ve,Ce,B,Q,ee,H,oe=!1){for(;Ce<B&&ee<H;)ve[Ce]===Q[ee]&&(oe&&(J[Ce]=ee),Ce+=1),ee+=1;return Ce===B}e.$7j=re;var ye;(function(ve){ve[ve.Diag=1]="Diag",ve[ve.Left=2]="Left",ve[ve.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var he;(function(ve){ve.Default=[-100,0];function Ce(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}ve.isDefault=Ce})(he||(e.FuzzyScore=he={}));class fe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,B){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=B}}e.$8j=fe;function ue(ve,Ce,B,Q,ee,H,oe=fe.default){const le=ve.length>M?M:ve.length,Re=Q.length>M?M:Q.length;if(B>=le||H>=Re||le-B>Re-H||!re(Ce,B,le,ee,H,Re,!0))return;me(le,Re,B,H,Ce,ee);let je=1,He=1,Qe=B,_e=H;const at=[!1];for(je=1,Qe=B;Qe<le;je++,Qe++){const Ae=J[Qe],Ze=te[Qe],ie=Qe+1<le?te[Qe+1]:Re;for(He=Ae-H+1,_e=Ae;_e<ie;He++,_e++){let se=Number.MIN_SAFE_INTEGER,Ie=!1;_e<=Ze&&(se=V(ve,Ce,Qe,B,Q,ee,_e,Re,H,x[je-1][He-1]===0,at));let qe=0;se!==Number.MAX_SAFE_INTEGER&&(Ie=!0,qe=se+X[je-1][He-1]);const Ye=_e>Ae,it=Ye?X[je][He-1]+(x[je][He-1]>0?-5:0):0,nt=_e>Ae+1&&x[je][He-1]>0,Oe=nt?X[je][He-2]+(x[je][He-2]>0?-5:0):0;if(nt&&(!Ye||Oe>=it)&&(!Ie||Oe>=qe))X[je][He]=Oe,Z[je][He]=3,x[je][He]=0;else if(Ye&&(!Ie||it>=qe))X[je][He]=it,Z[je][He]=2,x[je][He]=0;else if(Ie)X[je][He]=qe,Z[je][He]=1,x[je][He]=x[je-1][He-1]+1;else throw new Error("not possible")}}if(ae&&ge(ve,B,Q,H),!at[0]&&!oe.firstMatchCanBeWeak)return;je--,He--;const st=[X[je][He],H];let rt=0,Le=0;for(;je>=1;){let Ae=He;do{const Ze=Z[je][Ae];if(Ze===3)Ae=Ae-2;else if(Ze===2)Ae=Ae-1;else break}while(Ae>=1);rt>1&&Ce[B+je-1]===ee[H+He-1]&&!W(Ae+H-1,Q,ee)&&rt+1>x[je][Ae]&&(Ae=He),Ae===He?rt++:rt=1,Le||(Le=Ae),je--,He=Ae-1,st.push(He)}Re===le&&oe.boostFullMatch&&(st[0]+=2);const ze=Le-le;return st[0]-=ze,st}e.$9j=ue;function me(ve,Ce,B,Q,ee,H){let oe=ve-1,le=Ce-1;for(;oe>=B&&le>=Q;)ee[oe]===H[le]&&(te[oe]=le,oe--),le--}function V(ve,Ce,B,Q,ee,H,oe,le,Re,je,He){if(Ce[B]!==H[oe])return Number.MIN_SAFE_INTEGER;let Qe=1,_e=!1;return oe===B-Q?Qe=ve[B]===ee[oe]?7:5:W(oe,ee,H)&&(oe===0||!W(oe-1,ee,H))?(Qe=ve[B]===ee[oe]?7:5,_e=!0):ne(H,oe)&&(oe===0||!ne(H,oe-1))?Qe=5:(ne(H,oe-1)||K(H,oe-1))&&(Qe=5,_e=!0),Qe>1&&B===Q&&(He[0]=!0),_e||(_e=W(oe,ee,H)||ne(H,oe-1)||K(H,oe-1)),B===Q?oe>Re&&(Qe-=_e?3:5):je?Qe+=_e?2:0:Qe+=_e?0:1,oe+1===le&&(Qe-=_e?3:5),Qe}function Y(ve,Ce,B,Q,ee,H,oe){return we(ve,Ce,B,Q,ee,H,!0,oe)}e.$0j=Y;function de(ve,Ce,B,Q,ee,H,oe){return we(ve,Ce,B,Q,ee,H,!1,oe)}e.$$j=de;function we(ve,Ce,B,Q,ee,H,oe,le){let Re=ue(ve,Ce,B,Q,ee,H,le);if(Re&&!oe)return Re;if(ve.length>=3){const je=Math.min(7,ve.length-1);for(let He=B+1;He<je;He++){const Qe=Pe(ve,He);if(Qe){const _e=ue(Qe,Qe.toLowerCase(),B,Q,ee,H,le);_e&&(_e[0]-=3,(!Re||_e[0]>Re[0])&&(Re=_e))}}}return Re}function Pe(ve,Ce){if(Ce+1>=ve.length)return;const B=ve[Ce],Q=ve[Ce+1];if(B!==Q)return ve.slice(0,Ce)+Q+B+ve.slice(Ce+2)}}),define(ke[54],Se([1,0,12]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=void 0;function N(a){return h(a,0)}e.$Vi=N;function h(a,i){switch(typeof a){case"object":return a===null?P(349,i):Array.isArray(a)?b(a,i):k(a,i);case"string":return p(a,i);case"boolean":return A(a,i);case"number":return P(a,i);case"undefined":return P(937,i);default:return P(617,i)}}e.$Wi=h;function P(a,i){return(i<<5)-i+a|0}e.$Xi=P;function A(a,i){return P(a?433:863,i)}function p(a,i){i=P(149417,i);for(let n=0,r=a.length;n<r;n++)i=P(a.charCodeAt(n),i);return i}e.$Yi=p;function b(a,i){return i=P(104579,i),a.reduce((n,r)=>h(r,n),i)}function k(a,i){return i=P(181387,i),Object.keys(a).sort().reduce((n,r)=>(n=p(r,n),h(a[r],n)),i)}class R{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=h(i,this.g),this.g}}e.$Zi=R;var C;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function w(a,i,n=32){const r=n-i,s=~((1<<r)-1);return(a<<i|(s&a)>>>r)>>>0}function E(a,i=0,n=a.byteLength,r=0){for(let s=0;s<n;s++)a[i+s]=r}function S(a,i,n="0"){for(;a.length<i;)a=n+a;return a}function c(a,i=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(n=>n.toString(16).padStart(2,"0")).join(""):S((a>>>0).toString(16),i/4)}e.$1i=c;class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const r=this.p;let s=this.r,t=this.u,g,o;for(t!==0?(g=t,o=-1,t=0):(g=i.charCodeAt(0),o=0);;){let d=g;if(D.$ef(g))if(o+1<n){const l=i.charCodeAt(o+1);D.$ff(l)?(o++,d=D.$gf(g,l)):d=65533}else{t=g;break}else D.$ff(g)&&(d=65533);if(s=this.w(r,s,d),o++,o<n)g=i.charCodeAt(o);else break}this.r=s,this.u=t}w(i,n,r){return r<128?i[n++]=r:r<2048?(i[n++]=192|(r&1984)>>>6,i[n++]=128|(r&63)>>>0):r<65536?(i[n++]=224|(r&61440)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0):(i[n++]=240|(r&1835008)>>>18,i[n++]=128|(r&258048)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,E(this.p,this.r),this.r>56&&(this.y(),E(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=m.g,n=this.q;for(let v=0;v<64;v+=4)i.setUint32(v,n.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)i.setUint32(v,w(i.getUint32(v-12,!1)^i.getUint32(v-32,!1)^i.getUint32(v-56,!1)^i.getUint32(v-64,!1),1),!1);let r=this.h,s=this.l,t=this.m,g=this.n,o=this.o,d,l,u;for(let v=0;v<80;v++)v<20?(d=s&t|~s&g,l=1518500249):v<40?(d=s^t^g,l=1859775393):v<60?(d=s&t|s&g|t&g,l=2400959708):(d=s^t^g,l=3395469782),u=w(r,5)+d+o+l+i.getUint32(v*4,!1)&4294967295,o=g,g=t,t=w(s,30),s=r,r=u;this.h=this.h+r&4294967295,this.l=this.l+s&4294967295,this.m=this.m+t&4294967295,this.n=this.n+g&4294967295,this.o=this.o+o&4294967295}}e.$2i=m}),define(ke[39],Se([1,0,12]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(h){h[h.Ignore=0]="Ignore",h[h.Info=1]="Info",h[h.Warning=2]="Warning",h[h.Error=3]="Error"})(N||(N={})),function(h){const P="error",A="warning",p="warn",b="info",k="ignore";function R(w){return w?D.$af(P,w)?h.Error:D.$af(A,w)||D.$af(p,w)?h.Warning:D.$af(b,w)?h.Info:h.Ignore:h.Ignore}h.fromValue=R;function C(w){switch(w){case h.Error:return P;case h.Warning:return A;case h.Info:return b;default:return k}}h.toString=C}(N||(N={})),e.default=N}),define(ke[163],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define(ke[77],Se([1,0,19,12]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=void 0;class h{constructor(){this.b="",this.c=0}reset(E){return this.b=E,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(E){const S=E.charCodeAt(0),c=this.b.charCodeAt(this.c);return S-c}value(){return this.b[this.c]}}e.$0h=h;class P{constructor(E=!0){this.e=E}reset(E){return this.b=E,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let E=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(E)this.c++;else break;else E=!1;return this}cmp(E){return this.e?(0,N.$7e)(E,this.b,0,E.length,this.c,this.d):(0,N.$9e)(E,this.b,0,E.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$$h=P;class A{constructor(E=!0,S=!0){this.f=E,this.g=S}reset(E){this.d=0,this.e=0,this.b=E,this.c=E.length;for(let S=E.length-1;S>=0;S--,this.c--){const c=this.b.charCodeAt(S);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let E=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(E)this.d++;else break;else E=!1}return this}cmp(E){return this.g?(0,N.$7e)(E,this.b,0,E.length,this.d,this.e):(0,N.$9e)(E,this.b,0,E.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$_h=A;var p;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(p||(p={}));class b{constructor(E,S){this.f=E,this.g=S,this.d=[],this.e=0}reset(E){return this.c=E,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(E)),this.b.reset(E.path),this.b.value()&&this.d.push(3)),this.g(E)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(E){if(this.d[this.e]===1)return(0,N.$8e)(E,this.c.scheme);if(this.d[this.e]===2)return(0,N.$8e)(E,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(E);if(this.d[this.e]===4)return(0,N.$6e)(E,this.c.query);if(this.d[this.e]===5)return(0,N.$6e)(E,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ai=b;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(R||(R={}));class C{static forUris(E=()=>!1,S=()=>!1){return new C(new b(E,S))}static forPaths(E=!1){return new C(new A(void 0,!E))}static forStrings(){return new C(new h)}static forConfigKeys(){return new C(new P)}constructor(E){this.b=E}clear(){this.c=void 0}fill(E,S){if(S){const c=S.slice(0);(0,D.$Xb)(c);for(const m of c)this.set(m,E)}else{const c=E.slice(0);(0,D.$Xb)(c);for(const m of c)this.set(m[0],m[1])}}set(E,S){const c=this.b.reset(E);let m;this.c||(this.c=new k,this.c.segment=c.value());const a=[];for(m=this.c;;){const n=c.cmp(m.segment);if(n>0)m.left||(m.left=new k,m.left.segment=c.value()),a.push([-1,m]),m=m.left;else if(n<0)m.right||(m.right=new k,m.right.segment=c.value()),a.push([1,m]),m=m.right;else if(c.hasNext())c.next(),m.mid||(m.mid=new k,m.mid.segment=c.value()),a.push([0,m]),m=m.mid;else break}const i=m.value;m.value=S,m.key=E;for(let n=a.length-1;n>=0;n--){const r=a[n][1];r.updateHeight();const s=r.balanceFactor();if(s<-1||s>1){const t=a[n][0],g=a[n+1][0];if(t===1&&g===1)a[n][1]=r.rotateLeft();else if(t===-1&&g===-1)a[n][1]=r.rotateRight();else if(t===1&&g===-1)r.right=a[n+1][1]=a[n+1][1].rotateRight(),a[n][1]=r.rotateLeft();else if(t===-1&&g===1)r.left=a[n+1][1]=a[n+1][1].rotateLeft(),a[n][1]=r.rotateRight();else throw new Error;if(n>0)switch(a[n-1][0]){case-1:a[n-1][1].left=a[n][1];break;case 1:a[n-1][1].right=a[n][1];break;case 0:a[n-1][1].mid=a[n][1];break}else this.c=a[0][1]}}return i}get(E){return this.d(E)?.value}d(E){const S=this.b.reset(E);let c=this.c;for(;c;){const m=S.cmp(c.segment);if(m>0)c=c.left;else if(m<0)c=c.right;else if(S.hasNext())S.next(),c=c.mid;else break}return c}has(E){const S=this.d(E);return!(S?.value===void 0&&S?.mid===void 0)}delete(E){return this.e(E,!1)}deleteSuperstr(E){return this.e(E,!0)}e(E,S){const c=this.b.reset(E),m=[];let a=this.c;for(;a;){const i=c.cmp(a.segment);if(i>0)m.push([-1,a]),a=a.left;else if(i<0)m.push([1,a]),a=a.right;else if(c.hasNext())c.next(),m.push([0,a]),a=a.mid;else break}if(a){if(S?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const i=this.f(a.right);if(i.key){const{key:n,value:r,segment:s}=i;this.e(i.key,!1),a.key=n,a.value=r,a.segment=s}}else{const i=a.left??a.right;if(m.length>0){const[n,r]=m[m.length-1];switch(n){case-1:r.left=i;break;case 0:r.mid=i;break;case 1:r.right=i;break}}else this.c=i}for(let i=m.length-1;i>=0;i--){const n=m[i][1];n.updateHeight();const r=n.balanceFactor();if(r>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),m[i][1]=n.rotateLeft()):r<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),m[i][1]=n.rotateRight()),i>0)switch(m[i-1][0]){case-1:m[i-1][1].left=m[i][1];break;case 1:m[i-1][1].right=m[i][1];break;case 0:m[i-1][1].mid=m[i][1];break}else this.c=m[0][1]}}}f(E){for(;E.left;)E=E.left;return E}findSubstr(E){const S=this.b.reset(E);let c=this.c,m;for(;c;){const a=S.cmp(c.segment);if(a>0)c=c.left;else if(a<0)c=c.right;else if(S.hasNext())S.next(),m=c.value||m,c=c.mid;else break}return c&&c.value||m}findSuperstr(E){return this.g(E,!1)}g(E,S){const c=this.b.reset(E);let m=this.c;for(;m;){const a=c.cmp(m.segment);if(a>0)m=m.left;else if(a<0)m=m.right;else if(c.hasNext())c.next(),m=m.mid;else return m.mid?this.h(m.mid):S?m.value:void 0}}hasElementOrSubtree(E){return this.g(E,!0)!==void 0}forEach(E){for(const[S,c]of this)E(c,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(E){const S=[];return this.j(E,S),S[Symbol.iterator]()}j(E,S){E&&(E.left&&this.j(E.left,S),E.value&&S.push([E.key,E.value]),E.mid&&this.j(E.mid,S),E.right&&this.j(E.right,S))}_isBalanced(){const E=S=>{if(!S)return!0;const c=S.balanceFactor();return c<-1||c>1?!1:E(S.left)&&E(S.right)};return E(this.c)}}e.$bi=C}),define(ke[18],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=void 0;function D(s){return typeof s=="string"}e.$Jf=D;function N(s){return Array.isArray(s)&&s.every(t=>D(t))}e.$Kf=N;function h(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.$Lf=h;function P(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}e.$Mf=P;function A(s){return typeof s=="number"&&!isNaN(s)}e.$Nf=A;function p(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.$Of=p;function b(s){return s===!0||s===!1}e.$Pf=b;function k(s){return typeof s>"u"}e.$Qf=k;function R(s){return!C(s)}e.$Rf=R;function C(s){return k(s)||s===null}e.$Sf=C;function w(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Tf=w;function E(s){if(C(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.$Uf=E;function S(...s){const t=[];for(let g=0;g<s.length;g++){const o=s[g];if(C(o))throw new Error(`Assertion Failed: argument at index ${g} is undefined or null`);t.push(o)}return t}e.$Vf=S;const c=Object.prototype.hasOwnProperty;function m(s){if(!h(s))return!1;for(const t in s)if(c.call(s,t))return!1;return!0}e.$Wf=m;function a(s){return typeof s=="function"}e.$Xf=a;function i(...s){return s.length>0&&s.every(a)}e.$Yf=i;function n(s,t){const g=Math.min(s.length,t.length);for(let o=0;o<g;o++)r(s[o],t[o])}e.$Zf=n;function r(s,t){if(D(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(s instanceof t)return}catch{}if(!C(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$1f=r}),define(ke[78],Se([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=e.$_j=void 0;const N=Object.create(null);function h(p,b){if((0,D.$Jf)(b)){const k=N[b];if(k===void 0)throw new Error(`${p} references an unknown codicon: ${b}`);b=k}return N[p]=b,{id:p}}function P(){return N}e.$_j=P;function A(){return Object.values(e.$bk)}e.$ak=A,e.$bk={add:h("add",6e4),plus:h("plus",6e4),gistNew:h("gist-new",6e4),repoCreate:h("repo-create",6e4),lightbulb:h("lightbulb",60001),lightBulb:h("light-bulb",60001),repo:h("repo",60002),repoDelete:h("repo-delete",60002),gistFork:h("gist-fork",60003),repoForked:h("repo-forked",60003),gitPullRequest:h("git-pull-request",60004),gitPullRequestAbandoned:h("git-pull-request-abandoned",60004),recordKeys:h("record-keys",60005),keyboard:h("keyboard",60005),tag:h("tag",60006),tagAdd:h("tag-add",60006),tagRemove:h("tag-remove",60006),gitPullRequestLabel:h("git-pull-request-label",60006),person:h("person",60007),personFollow:h("person-follow",60007),personOutline:h("person-outline",60007),personFilled:h("person-filled",60007),gitBranch:h("git-branch",60008),gitBranchCreate:h("git-branch-create",60008),gitBranchDelete:h("git-branch-delete",60008),sourceControl:h("source-control",60008),mirror:h("mirror",60009),mirrorPublic:h("mirror-public",60009),star:h("star",60010),starAdd:h("star-add",60010),starDelete:h("star-delete",60010),starEmpty:h("star-empty",60010),comment:h("comment",60011),commentAdd:h("comment-add",60011),alert:h("alert",60012),warning:h("warning",60012),search:h("search",60013),searchSave:h("search-save",60013),logOut:h("log-out",60014),signOut:h("sign-out",60014),logIn:h("log-in",60015),signIn:h("sign-in",60015),eye:h("eye",60016),eyeUnwatch:h("eye-unwatch",60016),eyeWatch:h("eye-watch",60016),circleFilled:h("circle-filled",60017),primitiveDot:h("primitive-dot",60017),closeDirty:h("close-dirty",60017),debugBreakpoint:h("debug-breakpoint",60017),debugBreakpointDisabled:h("debug-breakpoint-disabled",60017),debugBreakpointPending:h("debug-breakpoint-pending",60377),debugHint:h("debug-hint",60017),primitiveSquare:h("primitive-square",60018),edit:h("edit",60019),pencil:h("pencil",60019),info:h("info",60020),issueOpened:h("issue-opened",60020),gistPrivate:h("gist-private",60021),gitForkPrivate:h("git-fork-private",60021),lock:h("lock",60021),mirrorPrivate:h("mirror-private",60021),close:h("close",60022),removeClose:h("remove-close",60022),x:h("x",60022),repoSync:h("repo-sync",60023),sync:h("sync",60023),clone:h("clone",60024),desktopDownload:h("desktop-download",60024),beaker:h("beaker",60025),microscope:h("microscope",60025),vm:h("vm",60026),deviceDesktop:h("device-desktop",60026),file:h("file",60027),fileText:h("file-text",60027),more:h("more",60028),ellipsis:h("ellipsis",60028),kebabHorizontal:h("kebab-horizontal",60028),mailReply:h("mail-reply",60029),reply:h("reply",60029),organization:h("organization",60030),organizationFilled:h("organization-filled",60030),organizationOutline:h("organization-outline",60030),newFile:h("new-file",60031),fileAdd:h("file-add",60031),newFolder:h("new-folder",60032),fileDirectoryCreate:h("file-directory-create",60032),trash:h("trash",60033),trashcan:h("trashcan",60033),history:h("history",60034),clock:h("clock",60034),folder:h("folder",60035),fileDirectory:h("file-directory",60035),symbolFolder:h("symbol-folder",60035),logoGithub:h("logo-github",60036),markGithub:h("mark-github",60036),github:h("github",60036),terminal:h("terminal",60037),console:h("console",60037),repl:h("repl",60037),zap:h("zap",60038),symbolEvent:h("symbol-event",60038),error:h("error",60039),stop:h("stop",60039),variable:h("variable",60040),symbolVariable:h("symbol-variable",60040),array:h("array",60042),symbolArray:h("symbol-array",60042),symbolModule:h("symbol-module",60043),symbolPackage:h("symbol-package",60043),symbolNamespace:h("symbol-namespace",60043),symbolObject:h("symbol-object",60043),symbolMethod:h("symbol-method",60044),symbolFunction:h("symbol-function",60044),symbolConstructor:h("symbol-constructor",60044),symbolBoolean:h("symbol-boolean",60047),symbolNull:h("symbol-null",60047),symbolNumeric:h("symbol-numeric",60048),symbolNumber:h("symbol-number",60048),symbolStructure:h("symbol-structure",60049),symbolStruct:h("symbol-struct",60049),symbolParameter:h("symbol-parameter",60050),symbolTypeParameter:h("symbol-type-parameter",60050),symbolKey:h("symbol-key",60051),symbolText:h("symbol-text",60051),symbolReference:h("symbol-reference",60052),goToFile:h("go-to-file",60052),symbolEnum:h("symbol-enum",60053),symbolValue:h("symbol-value",60053),symbolRuler:h("symbol-ruler",60054),symbolUnit:h("symbol-unit",60054),activateBreakpoints:h("activate-breakpoints",60055),archive:h("archive",60056),arrowBoth:h("arrow-both",60057),arrowDown:h("arrow-down",60058),arrowLeft:h("arrow-left",60059),arrowRight:h("arrow-right",60060),arrowSmallDown:h("arrow-small-down",60061),arrowSmallLeft:h("arrow-small-left",60062),arrowSmallRight:h("arrow-small-right",60063),arrowSmallUp:h("arrow-small-up",60064),arrowUp:h("arrow-up",60065),bell:h("bell",60066),bold:h("bold",60067),book:h("book",60068),bookmark:h("bookmark",60069),debugBreakpointConditionalUnverified:h("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:h("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:h("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:h("debug-breakpoint-data-unverified",60072),debugBreakpointData:h("debug-breakpoint-data",60073),debugBreakpointDataDisabled:h("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:h("debug-breakpoint-log-unverified",60074),debugBreakpointLog:h("debug-breakpoint-log",60075),debugBreakpointLogDisabled:h("debug-breakpoint-log-disabled",60075),briefcase:h("briefcase",60076),broadcast:h("broadcast",60077),browser:h("browser",60078),bug:h("bug",60079),calendar:h("calendar",60080),caseSensitive:h("case-sensitive",60081),check:h("check",60082),checklist:h("checklist",60083),chevronDown:h("chevron-down",60084),dropDownButton:h("drop-down-button",60084),chevronLeft:h("chevron-left",60085),chevronRight:h("chevron-right",60086),chevronUp:h("chevron-up",60087),chromeClose:h("chrome-close",60088),chromeMaximize:h("chrome-maximize",60089),chromeMinimize:h("chrome-minimize",60090),chromeRestore:h("chrome-restore",60091),circle:h("circle",60092),circleOutline:h("circle-outline",60092),debugBreakpointUnverified:h("debug-breakpoint-unverified",60092),circleSlash:h("circle-slash",60093),circuitBoard:h("circuit-board",60094),clearAll:h("clear-all",60095),clippy:h("clippy",60096),closeAll:h("close-all",60097),cloudDownload:h("cloud-download",60098),cloudUpload:h("cloud-upload",60099),code:h("code",60100),collapseAll:h("collapse-all",60101),colorMode:h("color-mode",60102),commentDiscussion:h("comment-discussion",60103),compareChanges:h("compare-changes",60157),creditCard:h("credit-card",60105),dash:h("dash",60108),dashboard:h("dashboard",60109),database:h("database",60110),debugContinue:h("debug-continue",60111),debugDisconnect:h("debug-disconnect",60112),debugPause:h("debug-pause",60113),debugRestart:h("debug-restart",60114),debugStart:h("debug-start",60115),debugStepInto:h("debug-step-into",60116),debugStepOut:h("debug-step-out",60117),debugStepOver:h("debug-step-over",60118),debugStop:h("debug-stop",60119),debug:h("debug",60120),deviceCameraVideo:h("device-camera-video",60121),deviceCamera:h("device-camera",60122),deviceMobile:h("device-mobile",60123),diffAdded:h("diff-added",60124),diffIgnored:h("diff-ignored",60125),diffModified:h("diff-modified",60126),diffRemoved:h("diff-removed",60127),diffRenamed:h("diff-renamed",60128),diff:h("diff",60129),discard:h("discard",60130),editorLayout:h("editor-layout",60131),emptyWindow:h("empty-window",60132),exclude:h("exclude",60133),extensions:h("extensions",60134),eyeClosed:h("eye-closed",60135),fileBinary:h("file-binary",60136),fileCode:h("file-code",60137),fileMedia:h("file-media",60138),filePdf:h("file-pdf",60139),fileSubmodule:h("file-submodule",60140),fileSymlinkDirectory:h("file-symlink-directory",60141),fileSymlinkFile:h("file-symlink-file",60142),fileZip:h("file-zip",60143),files:h("files",60144),filter:h("filter",60145),flame:h("flame",60146),foldDown:h("fold-down",60147),foldUp:h("fold-up",60148),fold:h("fold",60149),folderActive:h("folder-active",60150),folderOpened:h("folder-opened",60151),gear:h("gear",60152),gift:h("gift",60153),gistSecret:h("gist-secret",60154),gist:h("gist",60155),gitCommit:h("git-commit",60156),gitCompare:h("git-compare",60157),gitMerge:h("git-merge",60158),githubAction:h("github-action",60159),githubAlt:h("github-alt",60160),globe:h("globe",60161),grabber:h("grabber",60162),graph:h("graph",60163),gripper:h("gripper",60164),heart:h("heart",60165),home:h("home",60166),horizontalRule:h("horizontal-rule",60167),hubot:h("hubot",60168),inbox:h("inbox",60169),issueClosed:h("issue-closed",60324),issueReopened:h("issue-reopened",60171),issues:h("issues",60172),italic:h("italic",60173),jersey:h("jersey",60174),json:h("json",60175),bracket:h("bracket",60175),kebabVertical:h("kebab-vertical",60176),key:h("key",60177),law:h("law",60178),lightbulbAutofix:h("lightbulb-autofix",60179),linkExternal:h("link-external",60180),link:h("link",60181),listOrdered:h("list-ordered",60182),listUnordered:h("list-unordered",60183),liveShare:h("live-share",60184),loading:h("loading",60185),location:h("location",60186),mailRead:h("mail-read",60187),mail:h("mail",60188),markdown:h("markdown",60189),megaphone:h("megaphone",60190),mention:h("mention",60191),milestone:h("milestone",60192),gitPullRequestMilestone:h("git-pull-request-milestone",60192),mortarBoard:h("mortar-board",60193),move:h("move",60194),multipleWindows:h("multiple-windows",60195),mute:h("mute",60196),noNewline:h("no-newline",60197),note:h("note",60198),octoface:h("octoface",60199),openPreview:h("open-preview",60200),package:h("package",60201),paintcan:h("paintcan",60202),pin:h("pin",60203),play:h("play",60204),run:h("run",60204),plug:h("plug",60205),preserveCase:h("preserve-case",60206),preview:h("preview",60207),project:h("project",60208),pulse:h("pulse",60209),question:h("question",60210),quote:h("quote",60211),radioTower:h("radio-tower",60212),reactions:h("reactions",60213),references:h("references",60214),refresh:h("refresh",60215),regex:h("regex",60216),remoteExplorer:h("remote-explorer",60217),remote:h("remote",60218),remove:h("remove",60219),replaceAll:h("replace-all",60220),replace:h("replace",60221),repoClone:h("repo-clone",60222),repoForcePush:h("repo-force-push",60223),repoPull:h("repo-pull",60224),repoPush:h("repo-push",60225),report:h("report",60226),requestChanges:h("request-changes",60227),rocket:h("rocket",60228),rootFolderOpened:h("root-folder-opened",60229),rootFolder:h("root-folder",60230),rss:h("rss",60231),ruby:h("ruby",60232),saveAll:h("save-all",60233),saveAs:h("save-as",60234),save:h("save",60235),screenFull:h("screen-full",60236),screenNormal:h("screen-normal",60237),searchStop:h("search-stop",60238),server:h("server",60240),settingsGear:h("settings-gear",60241),settings:h("settings",60242),shield:h("shield",60243),smiley:h("smiley",60244),sortPrecedence:h("sort-precedence",60245),splitHorizontal:h("split-horizontal",60246),splitVertical:h("split-vertical",60247),squirrel:h("squirrel",60248),starFull:h("star-full",60249),starHalf:h("star-half",60250),symbolClass:h("symbol-class",60251),symbolColor:h("symbol-color",60252),symbolCustomColor:h("symbol-customcolor",60252),symbolConstant:h("symbol-constant",60253),symbolEnumMember:h("symbol-enum-member",60254),symbolField:h("symbol-field",60255),symbolFile:h("symbol-file",60256),symbolInterface:h("symbol-interface",60257),symbolKeyword:h("symbol-keyword",60258),symbolMisc:h("symbol-misc",60259),symbolOperator:h("symbol-operator",60260),symbolProperty:h("symbol-property",60261),wrench:h("wrench",60261),wrenchSubaction:h("wrench-subaction",60261),symbolSnippet:h("symbol-snippet",60262),tasklist:h("tasklist",60263),telescope:h("telescope",60264),textSize:h("text-size",60265),threeBars:h("three-bars",60266),thumbsdown:h("thumbsdown",60267),thumbsup:h("thumbsup",60268),tools:h("tools",60269),triangleDown:h("triangle-down",60270),triangleLeft:h("triangle-left",60271),triangleRight:h("triangle-right",60272),triangleUp:h("triangle-up",60273),twitter:h("twitter",60274),unfold:h("unfold",60275),unlock:h("unlock",60276),unmute:h("unmute",60277),unverified:h("unverified",60278),verified:h("verified",60279),versions:h("versions",60280),vmActive:h("vm-active",60281),vmOutline:h("vm-outline",60282),vmRunning:h("vm-running",60283),watch:h("watch",60284),whitespace:h("whitespace",60285),wholeWord:h("whole-word",60286),window:h("window",60287),wordWrap:h("word-wrap",60288),zoomIn:h("zoom-in",60289),zoomOut:h("zoom-out",60290),listFilter:h("list-filter",60291),listFlat:h("list-flat",60292),listSelection:h("list-selection",60293),selection:h("selection",60293),listTree:h("list-tree",60294),debugBreakpointFunctionUnverified:h("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:h("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:h("debug-breakpoint-function-disabled",60296),debugStackframeActive:h("debug-stackframe-active",60297),circleSmallFilled:h("circle-small-filled",60298),debugStackframeDot:h("debug-stackframe-dot",60298),debugStackframe:h("debug-stackframe",60299),debugStackframeFocused:h("debug-stackframe-focused",60299),debugBreakpointUnsupported:h("debug-breakpoint-unsupported",60300),symbolString:h("symbol-string",60301),debugReverseContinue:h("debug-reverse-continue",60302),debugStepBack:h("debug-step-back",60303),debugRestartFrame:h("debug-restart-frame",60304),callIncoming:h("call-incoming",60306),callOutgoing:h("call-outgoing",60307),menu:h("menu",60308),expandAll:h("expand-all",60309),feedback:h("feedback",60310),gitPullRequestReviewer:h("git-pull-request-reviewer",60310),groupByRefType:h("group-by-ref-type",60311),ungroupByRefType:h("ungroup-by-ref-type",60312),account:h("account",60313),gitPullRequestAssignee:h("git-pull-request-assignee",60313),bellDot:h("bell-dot",60314),debugConsole:h("debug-console",60315),library:h("library",60316),output:h("output",60317),runAll:h("run-all",60318),syncIgnored:h("sync-ignored",60319),pinned:h("pinned",60320),githubInverted:h("github-inverted",60321),debugAlt:h("debug-alt",60305),serverProcess:h("server-process",60322),serverEnvironment:h("server-environment",60323),pass:h("pass",60324),stopCircle:h("stop-circle",60325),playCircle:h("play-circle",60326),record:h("record",60327),debugAltSmall:h("debug-alt-small",60328),vmConnect:h("vm-connect",60329),cloud:h("cloud",60330),merge:h("merge",60331),exportIcon:h("export",60332),graphLeft:h("graph-left",60333),magnet:h("magnet",60334),notebook:h("notebook",60335),redo:h("redo",60336),checkAll:h("check-all",60337),pinnedDirty:h("pinned-dirty",60338),passFilled:h("pass-filled",60339),circleLargeFilled:h("circle-large-filled",60340),circleLarge:h("circle-large",60341),circleLargeOutline:h("circle-large-outline",60341),combine:h("combine",60342),gather:h("gather",60342),table:h("table",60343),variableGroup:h("variable-group",60344),typeHierarchy:h("type-hierarchy",60345),typeHierarchySub:h("type-hierarchy-sub",60346),typeHierarchySuper:h("type-hierarchy-super",60347),gitPullRequestCreate:h("git-pull-request-create",60348),runAbove:h("run-above",60349),runBelow:h("run-below",60350),notebookTemplate:h("notebook-template",60351),debugRerun:h("debug-rerun",60352),workspaceTrusted:h("workspace-trusted",60353),workspaceUntrusted:h("workspace-untrusted",60354),workspaceUnspecified:h("workspace-unspecified",60355),terminalCmd:h("terminal-cmd",60356),terminalDebian:h("terminal-debian",60357),terminalLinux:h("terminal-linux",60358),terminalPowershell:h("terminal-powershell",60359),terminalTmux:h("terminal-tmux",60360),terminalUbuntu:h("terminal-ubuntu",60361),terminalBash:h("terminal-bash",60362),arrowSwap:h("arrow-swap",60363),copy:h("copy",60364),personAdd:h("person-add",60365),filterFilled:h("filter-filled",60366),wand:h("wand",60367),debugLineByLine:h("debug-line-by-line",60368),inspect:h("inspect",60369),layers:h("layers",60370),layersDot:h("layers-dot",60371),layersActive:h("layers-active",60372),compass:h("compass",60373),compassDot:h("compass-dot",60374),compassActive:h("compass-active",60375),azure:h("azure",60376),issueDraft:h("issue-draft",60377),gitPullRequestClosed:h("git-pull-request-closed",60378),gitPullRequestDraft:h("git-pull-request-draft",60379),debugAll:h("debug-all",60380),debugCoverage:h("debug-coverage",60381),runErrors:h("run-errors",60382),folderLibrary:h("folder-library",60383),debugContinueSmall:h("debug-continue-small",60384),beakerStop:h("beaker-stop",60385),graphLine:h("graph-line",60386),graphScatter:h("graph-scatter",60387),pieChart:h("pie-chart",60388),bracketDot:h("bracket-dot",60389),bracketError:h("bracket-error",60390),lockSmall:h("lock-small",60391),azureDevops:h("azure-devops",60392),verifiedFilled:h("verified-filled",60393),newLine:h("newline",60394),layout:h("layout",60395),layoutActivitybarLeft:h("layout-activitybar-left",60396),layoutActivitybarRight:h("layout-activitybar-right",60397),layoutPanelLeft:h("layout-panel-left",60398),layoutPanelCenter:h("layout-panel-center",60399),layoutPanelJustify:h("layout-panel-justify",60400),layoutPanelRight:h("layout-panel-right",60401),layoutPanel:h("layout-panel",60402),layoutSidebarLeft:h("layout-sidebar-left",60403),layoutSidebarRight:h("layout-sidebar-right",60404),layoutStatusbar:h("layout-statusbar",60405),layoutMenubar:h("layout-menubar",60406),layoutCentered:h("layout-centered",60407),layoutSidebarRightOff:h("layout-sidebar-right-off",60416),layoutPanelOff:h("layout-panel-off",60417),layoutSidebarLeftOff:h("layout-sidebar-left-off",60418),target:h("target",60408),indent:h("indent",60409),recordSmall:h("record-small",60410),errorSmall:h("error-small",60411),arrowCircleDown:h("arrow-circle-down",60412),arrowCircleLeft:h("arrow-circle-left",60413),arrowCircleRight:h("arrow-circle-right",60414),arrowCircleUp:h("arrow-circle-up",60415),heartFilled:h("heart-filled",60420),map:h("map",60421),mapFilled:h("map-filled",60422),circleSmall:h("circle-small",60423),bellSlash:h("bell-slash",60424),bellSlashDot:h("bell-slash-dot",60425),commentUnresolved:h("comment-unresolved",60426),gitPullRequestGoToChanges:h("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:h("git-pull-request-new-changes",60428),searchFuzzy:h("search-fuzzy",60429),commentDraft:h("comment-draft",60430),send:h("send",60431),sparkle:h("sparkle",60432),insert:h("insert",60433),mic:h("mic",60434),thumbsDownFilled:h("thumbsdown-filled",60435),thumbsUpFilled:h("thumbsup-filled",60436),coffee:h("coffee",60437),snake:h("snake",60438),game:h("game",60439),vr:h("vr",60440),chip:h("chip",60441),piano:h("piano",60442),music:h("music",60443),micFilled:h("mic-filled",60444),gitFetch:h("git-fetch",60445),copilot:h("copilot",60446),lightbulbSparkle:h("lightbulb-sparkle",60447),lightbulbSparkleAutofix:h("lightbulb-sparkle-autofix",60447),robot:h("robot",60448),sparkleFilled:h("sparkle-filled",60449),diffSingle:h("diff-single",60450),diffMultiple:h("diff-multiple",60451),surroundWith:h("surround-with",60452),gitStash:h("git-stash",60454),gitStashApply:h("git-stash-apply",60455),gitStashPop:h("git-stash-pop",60456),dialogError:h("dialog-error","error"),dialogWarning:h("dialog-warning","warning"),dialogInfo:h("dialog-info","info"),dialogClose:h("dialog-close","close"),treeItemExpanded:h("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:h("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:h("tree-filter-on-type-off","list-selection"),treeFilterClear:h("tree-filter-clear","close"),treeItemLoading:h("tree-item-loading","loading"),menuSelection:h("menu-selection","check"),menuSubmenu:h("menu-submenu","chevron-right"),menuBarMore:h("menubar-more","more"),scrollbarButtonLeft:h("scrollbar-button-left","triangle-left"),scrollbarButtonRight:h("scrollbar-button-right","triangle-right"),scrollbarButtonUp:h("scrollbar-button-up","triangle-up"),scrollbarButtonDown:h("scrollbar-button-down","triangle-down"),toolBarMore:h("toolbar-more","more"),quickInputBack:h("quick-input-back","arrow-left")}}),define(ke[24],Se([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=void 0;function N(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const i=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([n,r])=>{i[n]=r&&typeof r=="object"?N(r):r}),i}e.$yn=N;function h(a){if(!a||typeof a!="object")return a;const i=[a];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const r in n)if(P.call(n,r)){const s=n[r];typeof s=="object"&&!Object.isFrozen(s)&&!(0,D.$Mf)(s)&&i.push(s)}}return a}e.$zn=h;const P=Object.prototype.hasOwnProperty;function A(a,i){return p(a,i,new Set)}e.$An=A;function p(a,i,n){if((0,D.$Sf)(a))return a;const r=i(a);if(typeof r<"u")return r;if(Array.isArray(a)){const s=[];for(const t of a)s.push(p(t,i,n));return s}if((0,D.$Lf)(a)){if(n.has(a))throw new Error("Cannot clone recursive data-structure");n.add(a);const s={};for(const t in a)P.call(a,t)&&(s[t]=p(a[t],i,n));return n.delete(a),s}return a}function b(a,i,n=!0){return(0,D.$Lf)(a)?((0,D.$Lf)(i)&&Object.keys(i).forEach(r=>{r in a?n&&((0,D.$Lf)(a[r])&&(0,D.$Lf)(i[r])?b(a[r],i[r],n):a[r]=i[r]):a[r]=i[r]}),a):i}e.$Bn=b;function k(a,i){if(a===i)return!0;if(a==null||i===null||i===void 0||typeof a!=typeof i||typeof a!="object"||Array.isArray(a)!==Array.isArray(i))return!1;let n,r;if(Array.isArray(a)){if(a.length!==i.length)return!1;for(n=0;n<a.length;n++)if(!k(a[n],i[n]))return!1}else{const s=[];for(r in a)s.push(r);s.sort();const t=[];for(r in i)t.push(r);if(t.sort(),!k(s,t))return!1;for(n=0;n<s.length;n++)if(!k(a[s[n]],i[s[n]]))return!1}return!0}e.$Cn=k;function R(a){const i=new Set;return JSON.stringify(a,(n,r)=>{if((0,D.$Lf)(r)||Array.isArray(r)){if(i.has(r))return"[Circular]";i.add(r)}return r})}e.$Dn=R;function C(a,i){const n=Object.create(null);return!a||!i||Object.keys(i).forEach(s=>{const t=a[s],g=i[s];k(t,g)||(n[s]=g)}),n}e.$En=C;function w(a,i){const n=i.toLowerCase(),r=Object.keys(a).find(s=>s.toLowerCase()===n);return r?a[r]:a[i]}e.$Fn=w;function E(a,i){const n=Object.create(null);for(const[r,s]of Object.entries(a))i(r,s)&&(n[r]=s);return n}e.$Gn=E;function S(a){let i=[];for(;Object.prototype!==a;)i=i.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return i}e.$Hn=S;function c(a){const i=[];for(const n of S(a))typeof a[n]=="function"&&i.push(n);return i}e.$In=c;function m(a,i){const n=s=>function(){const t=Array.prototype.slice.call(arguments,0);return i(s,t)},r={};for(const s of a)r[s]=n(s);return r}e.$Jn=m}),define(ke[55],Se([1,0,78]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ck=e.ThemeColor=void 0;var N;(function(A){function p(b){return b&&typeof b=="object"&&typeof b.id=="string"}A.isThemeColor=p})(N||(e.ThemeColor=N={}));function h(A){return{id:A}}e.$ck=h;var P;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function b(i){const n=p.exec(i.id);if(!n)return b(D.$bk.error);const[,r,s]=n,t=["codicon","codicon-"+r];return s&&t.push("codicon-modifier-"+s.substring(1)),t}A.asClassNameArray=b;function k(i){return b(i).join(" ")}A.asClassName=k;function R(i){return"."+b(i).join(".")}A.asCSSSelector=R;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||N.isThemeColor(i.color))}A.isThemeIcon=C;const w=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function E(i){const n=w.exec(i);if(!n)return;const[,r]=n;return{id:r}}A.fromString=E;function S(i){return{id:i}}A.fromId=S;function c(i,n){let r=i.id;const s=r.lastIndexOf("~");return s!==-1&&(r=r.substring(0,s)),n&&(r=`${r}~${n}`),{id:r}}A.modify=c;function m(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}A.getModifier=m;function a(i,n){return i.id===n.id&&i.color?.id===n.color?.id}A.isEqual=a})(P||(e.ThemeIcon=P={}))}),define(ke[164],Se([1,0,123,12,55]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=void 0;const P="$(",A=new RegExp(`\\$\\(${h.ThemeIcon.iconNameExpression}(?:${h.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${A.source}`,"g");function b(a){return a.replace(p,(i,n)=>n?i:`\\${i}`)}e.$dk=b;const k=new RegExp(`\\\\${A.source}`,"g");function R(a){return a.replace(k,i=>`\\${i}`)}e.$ek=R;const C=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function w(a){return a.indexOf(P)===-1?a:a.replace(C,(i,n,r,s)=>r?i:n||s||"")}e.$fk=w;function E(a){return a?a.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$gk=E;const S=new RegExp(`\\$\\(${h.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(a){S.lastIndex=0;let i="";const n=[];let r=0;for(;;){const s=S.lastIndex,t=S.exec(a),g=a.substring(s,t?.index);if(g.length>0){i+=g;for(let o=0;o<g.length;o++)n.push(r)}if(!t)break;r+=t[0].length}return{text:i,iconOffsets:n}}e.$hk=c;function m(a,i,n=!1){const{text:r,iconOffsets:s}=i;if(!s||s.length===0)return(0,D.$3j)(a,r,n);const t=(0,N.$Ue)(r," "),g=r.length-t.length,o=(0,D.$3j)(a,t,n);if(o)for(const d of o){const l=s[d.start+g]+g;d.start+=l,d.end+=l}return o}e.$ik=m}),define(ke[124],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=e.$Ie=e.Constants=void 0;var D;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function N(P){return P<0?0:P>255?255:P|0}e.$Ie=N;function h(P){return P<0?0:P>4294967295?4294967295:P|0}e.$Je=h}),define(ke[30],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(h){return D.test(h)}e.$qg=N,e.$rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let h;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?h=crypto.getRandomValues.bind(crypto):h=function(p){for(let b=0;b<p.length;b++)p[b]=Math.floor(Math.random()*256);return p};const P=new Uint8Array(16),A=[];for(let p=0;p<256;p++)A.push(p.toString(16).padStart(2,"0"));return function(){h(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let b=0,k="";return k+=A[P[b++]],k+=A[P[b++]],k+=A[P[b++]],k+=A[P[b++]],k+="-",k+=A[P[b++]],k+=A[P[b++]],k+="-",k+=A[P[b++]],k+=A[P[b++]],k+="-",k+=A[P[b++]],k+=A[P[b++]],k+="-",k+=A[P[b++]],k+=A[P[b++]],k+=A[P[b++]],k+=A[P[b++]],k+=A[P[b++]],k+=A[P[b++]],k}}()}),define(ke[165],Se([1,0,19,53,30]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=e.$rt=e.$qt=e.$pt=void 0;function P(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$pt=P;function A(C,w,E){const S={id:(0,h.$rg)(),name:C,uri:w,data:E};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$qt=A;class p{constructor(){this.a=new Map}get size(){let w=0;for(const E of this.a)w++;return w}has(w){return this.a.has(this.b(w))}matches(w){const E=[...this.a.keys()];return N.Iterable.some(this,([S,c])=>c.asFile())&&E.push("files"),R(b(w),E)}get(w){return this.a.get(this.b(w))?.[0]}append(w,E){const S=this.a.get(w);S?S.push(E):this.a.set(this.b(w),[E])}replace(w,E){this.a.set(this.b(w),[E])}delete(w){this.a.delete(this.b(w))}*[Symbol.iterator](){for(const[w,E]of this.a)for(const S of E)yield[w,S]}b(w){return b(w)}}e.$rt=p;function b(C){return C.toLowerCase()}function k(C,w){return R(b(C),w.map(b))}e.$st=k;function R(C,w){if(C==="*/*")return w.length>0;if(w.includes(C))return!0;const E=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[S,c,m]=E;return m==="*"?w.some(a=>a.startsWith(c+"/")):!1}e.$tt=Object.freeze({create:C=>(0,D.$Mb)(C.map(w=>w.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$tt.split(C).filter(w=>!w.startsWith("#"))})}),define(ke[166],Se([1,0,62]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vg=e.$ug=e.$tg=void 0;function N(p,b,k,R=1){let C=!1;return new Promise(w=>{const E=setTimeout(()=>{if(!C)return C=!0,w(0)},k);h(p,b,R,S=>{if(!C)return C=!0,clearTimeout(E),w(S)})})}e.$tg=N;function h(p,b,k,R){if(b===0)return R(0);const C=new D.Socket;C.once("connect",()=>(A(C),h(p+k,b-1,k,R))),C.once("data",()=>{}),C.once("error",w=>(A(C),w.code!=="ECONNREFUSED"?h(p+k,b-1,k,R):R(p))),C.connect(p,"127.0.0.1")}e.$ug={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(p,b,k,R="127.0.0.1"){let C=!1,w,E=1;const S=D.createServer({pauseOnConnect:!0});function c(m,a){C||(C=!0,S.removeAllListeners(),S.close(),w&&clearTimeout(w),a(m))}return new Promise(m=>{w=setTimeout(()=>{c(0,m)},k),S.on("listening",()=>{c(p,m)}),S.on("error",a=>{a&&(a.code==="EADDRINUSE"||a.code==="EACCES")&&E<b?(p++,E++,S.listen(p,R)):c(0,m)}),S.on("close",()=>{c(0,m)}),S.listen(p,R)})}e.$vg=P;function A(p){try{p.removeAllListeners("connect"),p.removeAllListeners("error"),p.end(),p.destroy(),p.unref()}catch(b){console.error(b)}}}),define(ke[125],Se([1,0,124]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=e.$ht=void 0;class N{constructor(p){const b=(0,D.$Ie)(p);this.c=b,this.a=N.d(b),this.b=new Map}static d(p){const b=new Uint8Array(256);return b.fill(p),b}set(p,b){const k=(0,D.$Ie)(b);p>=0&&p<256?this.a[p]=k:this.b.set(p,k)}get(p){return p>=0&&p<256?this.a[p]:this.b.get(p)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$ht=N;var h;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(h||(h={}));class P{constructor(){this.a=new N(0)}add(p){this.a.set(p,1)}has(p){return this.a.get(p)===1}clear(){return this.a.clear()}}e.$it=P}),define(ke[167],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.StringEOL=void 0;var D;(function(h){h[h.Unknown=0]="Unknown",h[h.Invalid=3]="Invalid",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function N(h){let P=0,A=0,p=0,b=0;for(let k=0,R=h.length;k<R;k++){const C=h.charCodeAt(k);C===13?(P===0&&(A=k),P++,k+1<R&&h.charCodeAt(k+1)===10?(b|=2,k++):b|=3,p=k+1):C===10&&(b|=1,P===0&&(A=k),P++,p=k+1)}return P===0&&(A=h.length),[P,A,h.length-p,b]}e.$wt=N}),define(ke[48],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0;class D{constructor(h,P){this.lineNumber=h,this.column=P}with(h=this.lineNumber,P=this.column){return h===this.lineNumber&&P===this.column?this:new D(h,P)}delta(h=0,P=0){return this.with(this.lineNumber+h,this.column+P)}equals(h){return D.equals(this,h)}static equals(h,P){return!h&&!P?!0:!!h&&!!P&&h.lineNumber===P.lineNumber&&h.column===P.column}isBefore(h){return D.isBefore(this,h)}static isBefore(h,P){return h.lineNumber<P.lineNumber?!0:P.lineNumber<h.lineNumber?!1:h.column<P.column}isBeforeOrEqual(h){return D.isBeforeOrEqual(this,h)}static isBeforeOrEqual(h,P){return h.lineNumber<P.lineNumber?!0:P.lineNumber<h.lineNumber?!1:h.column<=P.column}static compare(h,P){const A=h.lineNumber|0,p=P.lineNumber|0;if(A===p){const b=h.column|0,k=P.column|0;return b-k}return A-p}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(h){return new D(h.lineNumber,h.column)}static isIPosition(h){return h&&typeof h.lineNumber=="number"&&typeof h.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Vs=D}),define(ke[29],Se([1,0,48]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=void 0;class N{constructor(P,A,p,b){P>p||P===p&&A>b?(this.startLineNumber=p,this.startColumn=b,this.endLineNumber=P,this.endColumn=A):(this.startLineNumber=P,this.startColumn=A,this.endLineNumber=p,this.endColumn=b)}isEmpty(){return N.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return N.containsPosition(this,P)}static containsPosition(P,A){return!(A.lineNumber<P.startLineNumber||A.lineNumber>P.endLineNumber||A.lineNumber===P.startLineNumber&&A.column<P.startColumn||A.lineNumber===P.endLineNumber&&A.column>P.endColumn)}static strictContainsPosition(P,A){return!(A.lineNumber<P.startLineNumber||A.lineNumber>P.endLineNumber||A.lineNumber===P.startLineNumber&&A.column<=P.startColumn||A.lineNumber===P.endLineNumber&&A.column>=P.endColumn)}containsRange(P){return N.containsRange(this,P)}static containsRange(P,A){return!(A.startLineNumber<P.startLineNumber||A.endLineNumber<P.startLineNumber||A.startLineNumber>P.endLineNumber||A.endLineNumber>P.endLineNumber||A.startLineNumber===P.startLineNumber&&A.startColumn<P.startColumn||A.endLineNumber===P.endLineNumber&&A.endColumn>P.endColumn)}strictContainsRange(P){return N.strictContainsRange(this,P)}static strictContainsRange(P,A){return!(A.startLineNumber<P.startLineNumber||A.endLineNumber<P.startLineNumber||A.startLineNumber>P.endLineNumber||A.endLineNumber>P.endLineNumber||A.startLineNumber===P.startLineNumber&&A.startColumn<=P.startColumn||A.endLineNumber===P.endLineNumber&&A.endColumn>=P.endColumn)}plusRange(P){return N.plusRange(this,P)}static plusRange(P,A){let p,b,k,R;return A.startLineNumber<P.startLineNumber?(p=A.startLineNumber,b=A.startColumn):A.startLineNumber===P.startLineNumber?(p=A.startLineNumber,b=Math.min(A.startColumn,P.startColumn)):(p=P.startLineNumber,b=P.startColumn),A.endLineNumber>P.endLineNumber?(k=A.endLineNumber,R=A.endColumn):A.endLineNumber===P.endLineNumber?(k=A.endLineNumber,R=Math.max(A.endColumn,P.endColumn)):(k=P.endLineNumber,R=P.endColumn),new N(p,b,k,R)}intersectRanges(P){return N.intersectRanges(this,P)}static intersectRanges(P,A){let p=P.startLineNumber,b=P.startColumn,k=P.endLineNumber,R=P.endColumn;const C=A.startLineNumber,w=A.startColumn,E=A.endLineNumber,S=A.endColumn;return p<C?(p=C,b=w):p===C&&(b=Math.max(b,w)),k>E?(k=E,R=S):k===E&&(R=Math.min(R,S)),p>k||p===k&&b>R?null:new N(p,b,k,R)}equalsRange(P){return N.equalsRange(this,P)}static equalsRange(P,A){return!P&&!A?!0:!!P&&!!A&&P.startLineNumber===A.startLineNumber&&P.startColumn===A.startColumn&&P.endLineNumber===A.endLineNumber&&P.endColumn===A.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(P){return new D.$Vs(P.endLineNumber,P.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(P){return new D.$Vs(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,A){return new N(this.startLineNumber,this.startColumn,P,A)}setStartPosition(P,A){return new N(P,A,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(P){return new N(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(P){return new N(P.endLineNumber,P.endColumn,P.endLineNumber,P.endColumn)}delta(P){return new N(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static fromPositions(P,A=P){return new N(P.lineNumber,P.column,A.lineNumber,A.column)}static lift(P){return P?new N(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,A){return!(P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<A.startColumn||A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<P.startColumn)}static areIntersecting(P,A){return!(P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<=A.startColumn||A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,A){if(P&&A){const k=P.startLineNumber|0,R=A.startLineNumber|0;if(k===R){const C=P.startColumn|0,w=A.startColumn|0;if(C===w){const E=P.endLineNumber|0,S=A.endLineNumber|0;if(E===S){const c=P.endColumn|0,m=A.endColumn|0;return c-m}return E-S}return C-w}return k-R}return(P?1:0)-(A?1:0)}static compareRangesUsingEnds(P,A){return P.endLineNumber===A.endLineNumber?P.endColumn===A.endColumn?P.startLineNumber===A.startLineNumber?P.startColumn-A.startColumn:P.startLineNumber-A.startLineNumber:P.endColumn-A.endColumn:P.endLineNumber-A.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.$Ws=N}),define(ke[168],Se([1,0,29]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=void 0;class N{static insert(P,A){return{range:new D.$Ws(P.lineNumber,P.column,P.lineNumber,P.column),text:A,forceMoveMarkers:!0}}static delete(P){return{range:P,text:null}}static replace(P,A){return{range:P,text:A}}static replaceMove(P,A){return{range:P,text:A,forceMoveMarkers:!0}}}e.$Xs=N}),define(ke[169],Se([1,0,48,29]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=e.SelectionDirection=void 0;var h;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(h||(e.SelectionDirection=h={}));class P extends N.$Ws{constructor(p,b,k,R){super(p,b,k,R),this.selectionStartLineNumber=p,this.selectionStartColumn=b,this.positionLineNumber=k,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(p){return P.selectionsEqual(this,p)}static selectionsEqual(p,b){return p.selectionStartLineNumber===b.selectionStartLineNumber&&p.selectionStartColumn===b.selectionStartColumn&&p.positionLineNumber===b.positionLineNumber&&p.positionColumn===b.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(p,b){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,p,b):new P(p,b,this.startLineNumber,this.startColumn)}getPosition(){return new D.$Vs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$Vs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(p,b){return this.getDirection()===0?new P(p,b,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,p,b)}static fromPositions(p,b=p){return new P(p.lineNumber,p.column,b.lineNumber,b.column)}static fromRange(p,b){return b===0?new P(p.startLineNumber,p.startColumn,p.endLineNumber,p.endColumn):new P(p.endLineNumber,p.endColumn,p.startLineNumber,p.startColumn)}static liftSelection(p){return new P(p.selectionStartLineNumber,p.selectionStartColumn,p.positionLineNumber,p.positionColumn)}static selectionsArrEqual(p,b){if(p&&!b||!p&&b)return!1;if(!p&&!b)return!0;if(p.length!==b.length)return!1;for(let k=0,R=p.length;k<R;k++)if(!this.selectionsEqual(p[k],b[k]))return!1;return!0}static isISelection(p){return p&&typeof p.selectionStartLineNumber=="number"&&typeof p.selectionStartColumn=="number"&&typeof p.positionLineNumber=="number"&&typeof p.positionColumn=="number"}static createWithDirection(p,b,k,R,C){return C===0?new P(p,b,k,R):new P(k,R,p,b)}}e.$Ys=P}),define(ke[170],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0,e.$us={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[171],Se([1,0,125]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=e.$jt=e.WordCharacterClass=void 0;var N;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(N||(e.WordCharacterClass=N={}));class h extends D.$ht{constructor(p){super(0);for(let b=0,k=p.length;b<k;b++)this.set(p.charCodeAt(b),2);this.set(32,1),this.set(9,1)}}e.$jt=h;function P(A){const p={};return b=>(p.hasOwnProperty(b)||(p[b]=A(b)),p[b])}e.$kt=P(A=>new h(A))}),define(ke[126],Se([1,0,53,3,75]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=e.$ys=e.$xs=e.$ws=e.$vs=void 0,e.$vs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(C=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const E of e.$vs)C.indexOf(E)>=0||(w+="\\"+E);return w+="\\s]+)",new RegExp(w,"g")}e.$ws=P();function A(C){let w=e.$ws;if(C&&C instanceof RegExp)if(C.global)w=C;else{let E="g";C.ignoreCase&&(E+="i"),C.multiline&&(E+="m"),C.unicode&&(E+="u"),w=new RegExp(C.source,E)}return w.lastIndex=0,w}e.$xs=A;const p=new h.$4c;p.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function b(C){const w=p.unshift(C);return(0,N.$Rc)(w)}e.$ys=b;function k(C,w,E,S,c){if(w=A(w),c||(c=D.Iterable.first(p)),E.length>c.maxLen){let r=C-c.maxLen/2;return r<0?r=0:S+=r,E=E.substring(r,C+c.maxLen/2),k(C,w,E,S,c)}const m=Date.now(),a=C-1-S;let i=-1,n=null;for(let r=1;!(Date.now()-m>=c.timeBudget);r++){const s=a-c.windowSize*r;w.lastIndex=Math.max(0,s);const t=R(w,E,a,i);if(!t&&n||(n=t,s<=0))break;i=s}if(n){const r={word:n[0],startColumn:S+1+n.index,endColumn:S+1+n.index+n[0].length};return w.lastIndex=0,r}return null}e.$zs=k;function R(C,w,E,S){let c;for(;c=C.exec(w);){const m=c.index||0;if(m<=E&&C.lastIndex>=E)return c;if(S>0&&m>S)return null}return null}}),define(ke[172],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.$Tt=e.IndentAction=void 0;var D;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class N{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let b=0,k=p.notIn.length;b<k;b++)switch(p.notIn[b]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,b){if(p.getTokenCount()===0)return!0;const k=p.findTokenIndexAtOffset(b-2),R=p.getStandardTokenType(k);return this.isOK(R)}g(p,b){for(let k=p;k<=b;k++){const R=String.fromCharCode(k);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Tt=N;class h{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const b of p)P(this.autoClosingPairsOpenByStart,b.open.charAt(0),b),P(this.autoClosingPairsOpenByEnd,b.open.charAt(b.open.length-1),b),P(this.autoClosingPairsCloseByStart,b.close.charAt(0),b),P(this.autoClosingPairsCloseByEnd,b.close.charAt(b.close.length-1),b),b.close.length===1&&b.open.length===1&&P(this.autoClosingPairsCloseSingleChar,b.close,b)}}e.$Ut=h;function P(A,p,b){A.has(p)?A.get(p).push(b):A.set(p,[b])}}),define(ke[173],Se([1,0,125]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OZ=e.$NZ=e.$MZ=e.State=void 0;var N;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class h{constructor(S,c,m){const a=new Uint8Array(S*c);for(let i=0,n=S*c;i<n;i++)a[i]=m;this.a=a,this.rows=S,this.cols=c}get(S,c){return this.a[S*this.cols+c]}set(S,c,m){this.a[S*this.cols+c]=m}}class P{constructor(S){let c=0,m=0;for(let i=0,n=S.length;i<n;i++){const[r,s,t]=S[i];s>c&&(c=s),r>m&&(m=r),t>m&&(m=t)}c++,m++;const a=new h(m,c,0);for(let i=0,n=S.length;i<n;i++){const[r,s,t]=S[i];a.set(r,s,t)}this.a=a,this.b=c}nextState(S,c){return c<0||c>=this.b?0:this.a.get(S,c)}}e.$MZ=P;let A=null;function p(){return A===null&&(A=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var b;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(b||(b={}));let k=null;function R(){if(k===null){k=new D.$ht(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let c=0;c<E.length;c++)k.set(E.charCodeAt(c),1);const S=".,;:";for(let c=0;c<S.length;c++)k.set(S.charCodeAt(c),2)}return k}class C{static a(S,c,m,a,i){let n=i-1;do{const r=c.charCodeAt(n);if(S.get(r)!==2)break;n--}while(n>a);if(a>0){const r=c.charCodeAt(a-1),s=c.charCodeAt(n);(r===40&&s===41||r===91&&s===93||r===123&&s===125)&&n--}return{range:{startLineNumber:m,startColumn:a+1,endLineNumber:m,endColumn:n+2},url:c.substring(a,n+1)}}static computeLinks(S,c=p()){const m=R(),a=[];for(let i=1,n=S.getLineCount();i<=n;i++){const r=S.getLineContent(i),s=r.length;let t=0,g=0,o=0,d=1,l=!1,u=!1,v=!1,I=!1;for(;t<s;){let $=!1;const f=r.charCodeAt(t);if(d===13){let y;switch(f){case 40:l=!0,y=0;break;case 41:y=l?0:1;break;case 91:v=!0,u=!0,y=0;break;case 93:v=!1,y=u?0:1;break;case 123:I=!0,y=0;break;case 125:y=I?0:1;break;case 39:case 34:case 96:o===f?y=1:o===39||o===34||o===96?y=0:y=1;break;case 42:y=o===42?1:0;break;case 124:y=o===124?1:0;break;case 32:y=v?0:1;break;default:y=m.get(f)}y===1&&(a.push(C.a(m,r,i,g,t)),$=!0)}else if(d===12){let y;f===91?(u=!0,y=0):y=m.get(f),y===1?$=!0:d=13}else d=c.nextState(d,f),d===0&&($=!0);$&&(d=1,l=!1,u=!1,I=!1,g=t+1,o=f),t++}d===13&&a.push(C.a(m,r,i,g,s))}return a}}e.$NZ=C;function w(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:C.computeLinks(E)}e.$OZ=w}),define(ke[79],Se([1,0,24]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=e.ModelConstants=e.PositionAffinity=e.$dv=e.TrackedRangeStickiness=e.$cv=e.$bv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var N;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var h;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(h||(e.GlyphMarginLane=h={}));var P;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(P||(e.MinimapPosition=P={}));var A;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var p;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(p||(e.EndOfLinePreference=p={}));var b;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(b||(e.DefaultEndOfLine=b={}));var k;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(k||(e.EndOfLineSequence=k={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(s){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,s.tabSize|0),s.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,s.indentSize|0),this.a=!1),this.insertSpaces=!!s.insertSpaces,this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=!!s.trimAutoWhitespace,this.bracketPairColorizationOptions=s.bracketPairColorizationOptions}equals(s){return this.tabSize===s.tabSize&&this.a===s.a&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace&&(0,D.$Cn)(this.bracketPairColorizationOptions,s.bracketPairColorizationOptions)}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}e.$bv=R;class C{constructor(s,t){this._findMatchBrand=void 0,this.range=s,this.matches=t}}e.$cv=C;var w;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(w||(e.TrackedRangeStickiness=w={}));function E(r){return r&&typeof r.read=="function"}e.$dv=E;var S;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var c;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c||(e.ModelConstants=c={}));class m{constructor(s,t,g,o,d,l){this.identifier=s,this.range=t,this.text=g,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=d,this._isTracked=l}}e.$ev=m;class a{constructor(s,t,g){this.regex=s,this.wordSeparators=t,this.simpleSearch=g}}e.$fv=a;class i{constructor(s,t,g){this.reverseEdits=s,this.changes=t,this.trimAutoWhitespaceLineNumbers=g}}e.$gv=i;function n(r){return!r.isTooLargeForSyncing()&&!r.isForSimpleWidget}e.$hv=n}),define(ke[174],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4B=e.$3B=e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.NodeColor=e.$UB=void 0;class D{constructor(m,a){this.piece=m,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$VB)return h(this.right);let m=this;for(;m.parent!==e.$VB&&m.parent.left!==m;)m=m.parent;return m.parent===e.$VB?e.$VB:m.parent}prev(){if(this.left!==e.$VB)return P(this.left);let m=this;for(;m.parent!==e.$VB&&m.parent.right!==m;)m=m.parent;return m.parent===e.$VB?e.$VB:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$UB=D;var N;(function(c){c[c.Black=0]="Black",c[c.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$VB=new D(null,0),e.$VB.parent=e.$VB,e.$VB.left=e.$VB,e.$VB.right=e.$VB,e.$VB.color=0;function h(c){for(;c.left!==e.$VB;)c=c.left;return c}e.$WB=h;function P(c){for(;c.right!==e.$VB;)c=c.right;return c}e.$XB=P;function A(c){return c===e.$VB?0:c.size_left+c.piece.length+A(c.right)}function p(c){return c===e.$VB?0:c.lf_left+c.piece.lineFeedCnt+p(c.right)}function b(){e.$VB.parent=e.$VB}function k(c,m){const a=m.right;a.size_left+=m.size_left+(m.piece?m.piece.length:0),a.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=a.left,a.left!==e.$VB&&(a.left.parent=m),a.parent=m.parent,m.parent===e.$VB?c.root=a:m.parent.left===m?m.parent.left=a:m.parent.right=a,a.left=m,m.parent=a}e.$YB=k;function R(c,m){const a=m.left;m.left=a.right,a.right!==e.$VB&&(a.right.parent=m),a.parent=m.parent,m.size_left-=a.size_left+(a.piece?a.piece.length:0),m.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),m.parent===e.$VB?c.root=a:m===m.parent.right?m.parent.right=a:m.parent.left=a,a.right=m,m.parent=a}e.$ZB=R;function C(c,m){let a,i;if(m.left===e.$VB?(i=m,a=i.right):m.right===e.$VB?(i=m,a=i.left):(i=h(m.right),a=i.right),i===c.root){c.root=a,a.color=0,m.detach(),b(),c.root.parent=e.$VB;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=a:i.parent.right=a,i===m?(a.parent=i.parent,S(c,a)):(i.parent===m?a.parent=i:a.parent=i.parent,S(c,a),i.left=m.left,i.right=m.right,i.parent=m.parent,i.color=m.color,m===c.root?c.root=i:m===m.parent.left?m.parent.left=i:m.parent.right=i,i.left!==e.$VB&&(i.left.parent=i),i.right!==e.$VB&&(i.right.parent=i),i.size_left=m.size_left,i.lf_left=m.lf_left,S(c,i)),m.detach(),a.parent.left===a){const s=A(a),t=p(a);if(s!==a.parent.size_left||t!==a.parent.lf_left){const g=s-a.parent.size_left,o=t-a.parent.lf_left;a.parent.size_left=s,a.parent.lf_left=t,E(c,a.parent,g,o)}}if(S(c,a.parent),n){b();return}let r;for(;a!==c.root&&a.color===0;)a===a.parent.left?(r=a.parent.right,r.color===1&&(r.color=0,a.parent.color=1,k(c,a.parent),r=a.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,a=a.parent):(r.right.color===0&&(r.left.color=0,r.color=1,R(c,r),r=a.parent.right),r.color=a.parent.color,a.parent.color=0,r.right.color=0,k(c,a.parent),a=c.root)):(r=a.parent.left,r.color===1&&(r.color=0,a.parent.color=1,R(c,a.parent),r=a.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,a=a.parent):(r.left.color===0&&(r.right.color=0,r.color=1,k(c,r),r=a.parent.left),r.color=a.parent.color,a.parent.color=0,r.left.color=0,R(c,a.parent),a=c.root));a.color=0,b()}e.$1B=C;function w(c,m){for(S(c,m);m!==c.root&&m.parent.color===1;)if(m.parent===m.parent.parent.left){const a=m.parent.parent.right;a.color===1?(m.parent.color=0,a.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,k(c,m)),m.parent.color=0,m.parent.parent.color=1,R(c,m.parent.parent))}else{const a=m.parent.parent.left;a.color===1?(m.parent.color=0,a.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,R(c,m)),m.parent.color=0,m.parent.parent.color=1,k(c,m.parent.parent))}c.root.color=0}e.$2B=w;function E(c,m,a,i){for(;m!==c.root&&m!==e.$VB;)m.parent.left===m&&(m.parent.size_left+=a,m.parent.lf_left+=i),m=m.parent}e.$3B=E;function S(c,m){let a=0,i=0;if(m!==c.root){for(;m!==c.root&&m===m.parent.right;)m=m.parent;if(m!==c.root)for(m=m.parent,a=A(m.left)-m.size_left,i=p(m.left)-m.lf_left,m.size_left+=a,m.lf_left+=i;m!==c.root&&(a!==0||i!==0);)m.parent.left===m&&(m.parent.size_left+=a,m.parent.lf_left+=i),m=m.parent}}e.$4B=S}),define(ke[175],Se([1,0,19,124]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mv=e.$lv=e.$kv=void 0;class h{constructor(b){this.a=b,this.b=new Uint32Array(b.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(b,k){b=(0,N.$Je)(b);const R=this.a,C=this.b,w=k.length;return w===0?!1:(this.a=new Uint32Array(R.length+w),this.a.set(R.subarray(0,b),0),this.a.set(R.subarray(b),b+w),this.a.set(k,b),b-1<this.c[0]&&(this.c[0]=b-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue(b,k){return b=(0,N.$Je)(b),k=(0,N.$Je)(k),this.a[b]===k?!1:(this.a[b]=k,b-1<this.c[0]&&(this.c[0]=b-1),!0)}removeValues(b,k){b=(0,N.$Je)(b),k=(0,N.$Je)(k);const R=this.a,C=this.b;if(b>=R.length)return!1;const w=R.length-b;return k>=w&&(k=w),k===0?!1:(this.a=new Uint32Array(R.length-k),this.a.set(R.subarray(0,b),0),this.a.set(R.subarray(b+k),b),this.b=new Uint32Array(this.a.length),b-1<this.c[0]&&(this.c[0]=b-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(b){return b<0?0:(b=(0,N.$Je)(b),this.d(b))}d(b){if(b<=this.c[0])return this.b[b];let k=this.c[0]+1;k===0&&(this.b[0]=this.a[0],k++),b>=this.a.length&&(b=this.a.length-1);for(let R=k;R<=b;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],b),this.b[b]}getIndexOf(b){b=Math.floor(b),this.getTotalSum();let k=0,R=this.a.length-1,C=0,w=0,E=0;for(;k<=R;)if(C=k+(R-k)/2|0,w=this.b[C],E=w-this.a[C],b<E)R=C-1;else if(b>=w)k=C+1;else break;return new A(C,b-E)}}e.$kv=h;class P{constructor(b){this.a=b,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(b){return this.g(),b===0?0:this.d[b-1]}getIndexOf(b){this.g();const k=this.e[b],R=k>0?this.d[k-1]:0;return new A(k,b-R)}removeValues(b,k){this.a.splice(b,k),this.f(b)}insertValues(b,k){this.a=(0,D.$Wb)(this.a,b,k),this.f(b)}f(b){this.b=!1,this.c=Math.min(this.c,b-1)}g(){if(!this.b){for(let b=this.c+1,k=this.a.length;b<k;b++){const R=this.a[b],C=b>0?this.d[b-1]:0;this.d[b]=C+R;for(let w=0;w<R;w++)this.e[C+w]=b}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(b,k){this.a[b]!==k&&(this.a[b]=k,this.f(b))}}e.$lv=P;class A{constructor(b,k){this.index=b,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=b,this.remainder=k}}e.$mv=A}),define(ke[176],Se([1,0,12,48,175]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nv=void 0;class P{constructor(p,b,k,R){this.d=p,this.f=b,this.g=k,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(p){p.eol&&p.eol!==this.g&&(this.g=p.eol,this.j=null);const b=p.changes;for(const k of b)this.o(k.range),this.p(new N.$Vs(k.range.startLineNumber,k.range.startColumn),k.text);this.h=p.versionId,this.k=null}l(){if(!this.j){const p=this.g.length,b=this.f.length,k=new Uint32Array(b);for(let R=0;R<b;R++)k[R]=this.f[R].length+p;this.j=new h.$kv(k)}}n(p,b){this.f[p]=b,this.j&&this.j.setValue(p,this.f[p].length+this.g.length)}o(p){if(p.startLineNumber===p.endLineNumber){if(p.startColumn===p.endColumn)return;this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.startLineNumber-1].substring(p.endColumn-1));return}this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.endLineNumber-1].substring(p.endColumn-1)),this.f.splice(p.startLineNumber,p.endLineNumber-p.startLineNumber),this.j&&this.j.removeValues(p.startLineNumber,p.endLineNumber-p.startLineNumber)}p(p,b){if(b.length===0)return;const k=(0,D.$1e)(b);if(k.length===1){this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+k[0]+this.f[p.lineNumber-1].substring(p.column-1));return}k[k.length-1]+=this.f[p.lineNumber-1].substring(p.column-1),this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+k[0]);const R=new Uint32Array(k.length-1);for(let C=1;C<k.length;C++)this.f.splice(p.lineNumber+C-1,0,k[C]),R[C-1]=k[C].length+this.g.length;this.j&&this.j.insertValues(p.lineNumber,R)}}e.$nv=P}),define(ke[100],Se([1,0,12,171,48,29,79]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0B=e.$9B=e.$8B=e.$7B=e.$6B=e.$5B=void 0;const p=999;class b{constructor(i,n,r,s){this.searchString=i,this.isRegex=n,this.matchCase=r,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=k(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=D.$Ye(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let r=!this.isRegex&&!i;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new A.$fv(n,this.wordSeparators?(0,N.$kt)(this.wordSeparators):null,r?this.searchString:null)}}e.$5B=b;function k(a){if(!a||a.length===0)return!1;for(let i=0,n=a.length;i<n;i++){const r=a.charCodeAt(i);if(r===10)return!0;if(r===92){if(i++,i>=n)break;const s=a.charCodeAt(i);if(s===110||s===114||s===87)return!0}}return!1}e.$6B=k;function R(a,i,n){if(!n)return new A.$cv(a,null);const r=[];for(let s=0,t=i.length;s<t;s++)r[s]=i[s];return new A.$cv(a,r)}e.$7B=R;class C{constructor(i){const n=[];let r=0;for(let s=0,t=i.length;s<t;s++)i.charCodeAt(s)===10&&(n[r++]=s);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let r=0,s=n.length-1;if(s===-1||i<=n[0])return 0;for(;r<s;){const t=r+((s-r)/2>>0);n[t]>=i?s=t-1:n[t+1]>=i?(r=t,s=t):r=t+1}return r+1}}class w{static findMatches(i,n,r,s,t){const g=n.parseSearchRequest();return g?g.regex.multiline?this.b(i,r,new m(g.wordSeparators,g.regex),s,t):this.c(i,r,g,s,t):[]}static a(i,n,r,s,t,g){let o,d=0;s?(d=s.findLineFeedCountBeforeOffset(t),o=n+t+d):o=n+t;let l;if(s){const $=s.findLineFeedCountBeforeOffset(t+g.length)-d;l=o+g.length+$}else l=o+g.length;const u=i.getPositionAt(o),v=i.getPositionAt(l);return new P.$Ws(u.lineNumber,u.column,v.lineNumber,v.column)}static b(i,n,r,s,t){const g=i.getOffsetAt(n.getStartPosition()),o=i.getValueInRange(n,1),d=i.getEOL()===`\r
`?new C(o):null,l=[];let u=0,v;for(r.reset(0);v=r.next(o);)if(l[u++]=R(this.a(i,g,o,d,v.index,v[0]),v,s),u>=t)return l;return l}static c(i,n,r,s,t){const g=[];let o=0;if(n.startLineNumber===n.endLineNumber){const l=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return o=this.d(r,l,n.startLineNumber,n.startColumn-1,o,g,s,t),g}const d=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);o=this.d(r,d,n.startLineNumber,n.startColumn-1,o,g,s,t);for(let l=n.startLineNumber+1;l<n.endLineNumber&&o<t;l++)o=this.d(r,i.getLineContent(l),l,0,o,g,s,t);if(o<t){const l=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);o=this.d(r,l,n.endLineNumber,0,o,g,s,t)}return g}static d(i,n,r,s,t,g,o,d){const l=i.wordSeparators;if(!o&&i.simpleSearch){const I=i.simpleSearch,$=I.length,f=n.length;let y=-$;for(;(y=n.indexOf(I,y+$))!==-1;)if((!l||c(l,n,f,y,$))&&(g[t++]=new A.$cv(new P.$Ws(r,y+1+s,r,y+1+$+s),null),t>=d))return t;return t}const u=new m(i.wordSeparators,i.regex);let v;u.reset(0);do if(v=u.next(n),v&&(g[t++]=R(new P.$Ws(r,v.index+1+s,r,v.index+1+v[0].length+s),v,o),t>=d))return t;while(v);return t}static findNextMatch(i,n,r,s){const t=n.parseSearchRequest();if(!t)return null;const g=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,r,g,s):this.f(i,r,g,s)}static e(i,n,r,s){const t=new h.$Vs(n.lineNumber,1),g=i.getOffsetAt(t),o=i.getLineCount(),d=i.getValueInRange(new P.$Ws(t.lineNumber,t.column,o,i.getLineMaxColumn(o)),1),l=i.getEOL()===`\r
`?new C(d):null;r.reset(n.column-1);const u=r.next(d);return u?R(this.a(i,g,d,l,u.index,u[0]),u,s):n.lineNumber!==1||n.column!==1?this.e(i,new h.$Vs(1,1),r,s):null}static f(i,n,r,s){const t=i.getLineCount(),g=n.lineNumber,o=i.getLineContent(g),d=this.g(r,o,g,n.column,s);if(d)return d;for(let l=1;l<=t;l++){const u=(g+l-1)%t,v=i.getLineContent(u+1),I=this.g(r,v,u+1,1,s);if(I)return I}return null}static g(i,n,r,s,t){i.reset(s-1);const g=i.next(n);return g?R(new P.$Ws(r,g.index+1,r,g.index+1+g[0].length),g,t):null}static findPreviousMatch(i,n,r,s){const t=n.parseSearchRequest();if(!t)return null;const g=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,r,g,s):this.j(i,r,g,s)}static h(i,n,r,s){const t=this.b(i,new P.$Ws(1,1,n.lineNumber,n.column),r,s,10*p);if(t.length>0)return t[t.length-1];const g=i.getLineCount();return n.lineNumber!==g||n.column!==i.getLineMaxColumn(g)?this.h(i,new h.$Vs(g,i.getLineMaxColumn(g)),r,s):null}static j(i,n,r,s){const t=i.getLineCount(),g=n.lineNumber,o=i.getLineContent(g).substring(0,n.column-1),d=this.k(r,o,g,s);if(d)return d;for(let l=1;l<=t;l++){const u=(t+g-l-1)%t,v=i.getLineContent(u+1),I=this.k(r,v,u+1,s);if(I)return I}return null}static k(i,n,r,s){let t=null,g;for(i.reset(0);g=i.next(n);)t=R(new P.$Ws(r,g.index+1,r,g.index+1+g[0].length),g,s);return t}}e.$8B=w;function E(a,i,n,r,s){if(r===0)return!0;const t=i.charCodeAt(r-1);if(a.get(t)!==0||t===13||t===10)return!0;if(s>0){const g=i.charCodeAt(r);if(a.get(g)!==0)return!0}return!1}function S(a,i,n,r,s){if(r+s===n)return!0;const t=i.charCodeAt(r+s);if(a.get(t)!==0||t===13||t===10)return!0;if(s>0){const g=i.charCodeAt(r+s-1);if(a.get(g)!==0)return!0}return!1}function c(a,i,n,r,s){return E(a,i,n,r,s)&&S(a,i,n,r,s)}e.$9B=c;class m{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let r;do{if(this.b+this.c===n||(r=this.a.exec(i),!r))return null;const s=r.index,t=r[0].length;if(s===this.b&&t===this.c){if(t===0){D.$hf(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=s,this.c=t,!this._wordSeparators||c(this._wordSeparators,i,n,s,t))return r}while(r);return null}}e.$0B=m}),define(ke[127],Se([1,0,48,29,79,174,100]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=e.$bC=e.$aC=e.$_B=e.$$B=void 0;const p=65535;function b(a){let i;return a[a.length-1]<65536?i=new Uint16Array(a.length):i=new Uint32Array(a.length),i.set(a,0),i}class k{constructor(i,n,r,s,t){this.lineStarts=i,this.cr=n,this.lf=r,this.crlf=s,this.isBasicASCII=t}}function R(a,i=!0){const n=[0];let r=1;for(let s=0,t=a.length;s<t;s++){const g=a.charCodeAt(s);g===13?s+1<t&&a.charCodeAt(s+1)===10?(n[r++]=s+2,s++):n[r++]=s+1:g===10&&(n[r++]=s+1)}return i?b(n):n}e.$$B=R;function C(a,i){a.length=0,a[0]=0;let n=1,r=0,s=0,t=0,g=!0;for(let d=0,l=i.length;d<l;d++){const u=i.charCodeAt(d);u===13?d+1<l&&i.charCodeAt(d+1)===10?(t++,a[n++]=d+2,d++):(r++,a[n++]=d+1):u===10?(s++,a[n++]=d+1):g&&u!==9&&(u<32||u>126)&&(g=!1)}const o=new k(b(a),r,s,t,g);return a.length=0,o}e.$_B=C;class w{constructor(i,n,r,s,t){this.bufferIndex=i,this.start=n,this.end=r,this.lineFeedCnt=s,this.length=t}}e.$aC=w;class E{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$bC=E;class S{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==P.$VB&&i.iterate(i.root,r=>(r!==P.$VB&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class c{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartOffset<=i&&r.nodeStartOffset+r.node.piece.length>=i)return r}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<i&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=i)return r}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const r=this.b;for(let s=0;s<r.length;s++){const t=r[s];if(t.node.parent===null||t.nodeStartOffset>=i){r[s]=null,n=!0;continue}}if(n){const s=[];for(const t of r)t!==null&&s.push(t);this.b=s}}}class m{constructor(i,n,r){this.create(i,n,r)}create(i,n,r){this.a=[new E("",[0])],this.g={line:0,column:0},this.root=P.$VB,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=r;let s=null;for(let t=0,g=i.length;t<g;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=R(i[t].buffer));const o=new w(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),s=this.S(s,o)}this.h=new c(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=p,r=n-Math.floor(n/3),s=r*2;let t="",g=0;const o=[];if(this.iterate(this.root,d=>{const l=this.R(d),u=l.length;if(g<=r||g+u<s)return t+=l,g+=u,!0;const v=t.replace(/\r\n|\r|\n/g,i);return o.push(new E(v,R(v))),t=l,g=u,!0}),g>0){const d=t.replace(/\r\n|\r|\n/g,i);o.push(new E(d,R(d)))}this.create(o,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,s=>{if(s===P.$VB)return!0;const t=this.R(s),g=t.length,o=i.G(n),d=i.G(n+g),l=i.getValueInRange2(o,d);return n+=g,t===l})}getOffsetAt(i,n){let r=0,s=this.root;for(;s!==P.$VB;)if(s.left!==P.$VB&&s.lf_left+1>=i)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt+1>=i){r+=s.size_left;const t=this.B(s,i-s.lf_left-2);return r+=t+n-1}else i-=s.lf_left+s.piece.lineFeedCnt,r+=s.size_left+s.piece.length,s=s.right;return r}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,r=0;const s=i;for(;n!==P.$VB;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(r+=n.lf_left+t.index,t.index===0){const g=this.getOffsetAt(r+1,1),o=s-g;return new D.$Vs(r+1,o+1)}return new D.$Vs(r+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,r+=n.lf_left+n.piece.lineFeedCnt,n.right===P.$VB){const t=this.getOffsetAt(r+1,1),g=s-i-t;return new D.$Vs(r+1,g+1)}else n=n.right;return new D.$Vs(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const r=this.H(i.startLineNumber,i.startColumn),s=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(r,s);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const o=i.node,d=this.a[o.piece.bufferIndex].buffer,l=this.u(o.piece.bufferIndex,o.piece.start);return d.substring(l+i.remainder,l+n.remainder)}let r=i.node;const s=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let g=s.substring(t+i.remainder,t+r.piece.length);for(r=r.next();r!==P.$VB;){const o=this.a[r.piece.bufferIndex].buffer,d=this.u(r.piece.bufferIndex,r.piece.start);if(r===n.node){g+=o.substring(d,d+n.remainder);break}else g+=o.substr(d,r.piece.length);r=r.next()}return g}getLinesContent(){const i=[];let n=0,r="",s=!1;return this.iterate(this.root,t=>{if(t===P.$VB)return!0;const g=t.piece;let o=g.length;if(o===0)return!0;const d=this.a[g.bufferIndex].buffer,l=this.a[g.bufferIndex].lineStarts,u=g.start.line,v=g.end.line;let I=l[u]+g.start.column;if(s&&(d.charCodeAt(I)===10&&(I++,o--),i[n++]=r,r="",s=!1,o===0))return!0;if(u===v)return!this.f&&d.charCodeAt(I+o-1)===13?(s=!0,r+=d.substr(I,o-1)):r+=d.substr(I,o),!0;r+=this.f?d.substring(I,Math.max(I,l[u+1]-this.e)):d.substring(I,l[u+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;for(let $=u+1;$<v;$++)r=this.f?d.substring(l[$],l[$+1]-this.e):d.substring(l[$],l[$+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;return!this.f&&d.charCodeAt(l[v]+g.end.column-1)===13?(s=!0,g.end.column===0?n--:r=d.substr(l[v],g.end.column-1)):r=d.substr(l[v],g.end.column),!0}),s&&(i[n++]=r,r=""),i[n++]=r,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const r=this.a[n.piece.bufferIndex],s=this.u(n.piece.bufferIndex,n.piece.start);return r.buffer.charCodeAt(s)}else{const n=this.a[i.node.piece.bufferIndex],s=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(s)}}getLineCharCode(i,n){const r=this.H(i,n+1);return this.l(r)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,r,s,t,g,o,d,l,u,v){const I=this.a[i.piece.bufferIndex],$=this.u(i.piece.bufferIndex,i.piece.start),f=this.u(i.piece.bufferIndex,t),y=this.u(i.piece.bufferIndex,g);let L;const T={line:0,column:0};let U,j;n._wordSeparators?(U=I.buffer.substring(f,y),j=F=>F+f,n.reset(0)):(U=I.buffer,j=F=>F,n.reset(f));do if(L=n.next(U),L){if(j(L.index)>=y)return u;this.s(i,j(L.index)-$,T);const F=this.t(i.piece.bufferIndex,t,T),M=T.line===t.line?T.column-t.column+s:T.column+1,O=M+L[0].length;if(v[u++]=(0,A.$7B)(new N.$Ws(r+F,M,r+F,O),L,d),j(L.index)+L[0].length>=y||u>=l)return u}while(L);return u}findMatchesLineByLine(i,n,r,s){const t=[];let g=0;const o=new A.$0B(n.wordSeparators,n.regex);let d=this.H(i.startLineNumber,i.startColumn);if(d===null)return[];const l=this.H(i.endLineNumber,i.endColumn);if(l===null)return[];let u=this.s(d.node,d.remainder);const v=this.s(l.node,l.remainder);if(d.node===l.node)return this.findMatchesInNode(d.node,o,i.startLineNumber,i.startColumn,u,v,n,r,s,g,t),t;let I=i.startLineNumber,$=d.node;for(;$!==l.node;){const y=this.t($.piece.bufferIndex,u,$.piece.end);if(y>=1){const T=this.a[$.piece.bufferIndex].lineStarts,U=this.u($.piece.bufferIndex,$.piece.start),j=T[u.line+y],F=I===i.startLineNumber?i.startColumn:1;if(g=this.findMatchesInNode($,o,I,F,u,this.s($,j-U),n,r,s,g,t),g>=s)return t;I+=y}const L=I===i.startLineNumber?i.startColumn-1:0;if(I===i.endLineNumber){const T=this.getLineContent(I).substring(L,i.endColumn-1);return g=this.n(n,o,T,i.endLineNumber,L,g,t,r,s),t}if(g=this.n(n,o,this.getLineContent(I).substr(L),I,L,g,t,r,s),g>=s)return t;I++,d=this.H(I,1),$=d.node,u=this.s(d.node,d.remainder)}if(I===i.endLineNumber){const y=I===i.startLineNumber?i.startColumn-1:0,L=this.getLineContent(I).substring(y,i.endColumn-1);return g=this.n(n,o,L,i.endLineNumber,y,g,t,r,s),t}const f=I===i.startLineNumber?i.startColumn:1;return g=this.findMatchesInNode(l.node,o,I,f,u,v,n,r,s,g,t),t}n(i,n,r,s,t,g,o,d,l){const u=i.wordSeparators;if(!d&&i.simpleSearch){const I=i.simpleSearch,$=I.length,f=r.length;let y=-$;for(;(y=r.indexOf(I,y+$))!==-1;)if((!u||(0,A.$9B)(u,r,f,y,$))&&(o[g++]=new h.$cv(new N.$Ws(s,y+1+t,s,y+1+$+t),null),g>=l))return g;return g}let v;n.reset(0);do if(v=n.next(r),v&&(o[g++]=(0,A.$7B)(new N.$Ws(s,v.index+1+t,s,v.index+1+v[0].length+t),v,d),g>=l))return g;while(v);return g}insert(i,n,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==P.$VB){const{node:s,remainder:t,nodeStartOffset:g}=this.G(i),o=s.piece,d=o.bufferIndex,l=this.s(s,t);if(s.piece.bufferIndex===0&&o.end.line===this.g.line&&o.end.column===this.g.column&&g+o.length===i&&n.length<p){this.F(s,n),this.y();return}if(g===i)this.o(n,s),this.h.validate(i);else if(g+s.piece.length>i){const u=[];let v=new w(o.bufferIndex,l,o.end,this.t(o.bufferIndex,l,o.end),this.u(d,o.end)-this.u(d,l));if(this.K()&&this.M(n)&&this.I(s,t)===10){const y={line:v.start.line+1,column:0};v=new w(v.bufferIndex,y,v.end,this.t(v.bufferIndex,y,v.end),v.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(s,t-1)===13){const y=this.s(s,t-1);this.C(s,y),n="\r"+n,s.piece.length===0&&u.push(s)}else this.C(s,l);else this.C(s,l);const I=this.w(n);v.length>0&&this.S(s,v);let $=s;for(let f=0;f<I.length;f++)$=this.S($,I[f]);this.v(u)}else this.q(n,s)}else{const s=this.w(n);let t=this.T(null,s[0]);for(let g=1;g<s.length;g++)t=this.S(t,s[g])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===P.$VB)return;const r=this.G(i),s=this.G(i+n),t=r.node,g=s.node;if(t===g){const I=this.s(t,r.remainder),$=this.s(t,s.remainder);if(r.nodeStartOffset===i){if(n===t.piece.length){const f=t.next();(0,P.$1B)(this,t),this.N(f),this.y();return}this.D(t,$),this.h.validate(i),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===i+n){this.C(t,I),this.O(t),this.y();return}this.E(t,I,$),this.y();return}const o=[],d=this.s(t,r.remainder);this.C(t,d),this.h.validate(i),t.piece.length===0&&o.push(t);const l=this.s(g,s.remainder);this.D(g,l),g.piece.length===0&&o.push(g);const u=t.next();for(let I=u;I!==P.$VB&&I!==g;I=I.next())o.push(I);const v=t.piece.length===0?t.prev():t;this.v(o),this.O(v),this.y()}o(i,n){const r=[];if(this.K()&&this.M(i)&&this.L(n)){const g=n.piece,o={line:g.start.line+1,column:0},d=new w(g.bufferIndex,o,g.end,this.t(g.bufferIndex,o,g.end),g.length-1);n.piece=d,i+=`
`,(0,P.$3B)(this,n,-1,-1),n.piece.length===0&&r.push(n)}const s=this.w(i);let t=this.T(n,s[s.length-1]);for(let g=s.length-2;g>=0;g--)t=this.T(t,s[g]);this.N(t),this.v(r)}q(i,n){this.Q(i,n)&&(i+=`
`);const r=this.w(i),s=this.S(n,r[0]);let t=s;for(let g=1;g<r.length;g++)t=this.S(t,r[g]);this.N(s)}s(i,n,r){const s=i.piece,t=i.piece.bufferIndex,g=this.a[t].lineStarts,d=g[s.start.line]+s.start.column+n;let l=s.start.line,u=s.end.line,v=0,I=0,$=0;for(;l<=u&&(v=l+(u-l)/2|0,$=g[v],v!==u);)if(I=g[v+1],d<$)u=v-1;else if(d>=I)l=v+1;else break;return r?(r.line=v,r.column=d-$,null):{line:v,column:d-$}}t(i,n,r){if(r.column===0)return r.line-n.line;const s=this.a[i].lineStarts;if(r.line===s.length-1)return r.line-n.line;const t=s[r.line+1],g=s[r.line]+r.column;if(t>g+1)return r.line-n.line;const o=g-1;return this.a[i].buffer.charCodeAt(o)===13?r.line-n.line+1:r.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,P.$1B)(this,i[n])}w(i){if(i.length>p){const u=[];for(;i.length>p;){const I=i.charCodeAt(p-1);let $;I===13||I>=55296&&I<=56319?($=i.substring(0,p-1),i=i.substring(p-1)):($=i.substring(0,p),i=i.substring(p));const f=R($);u.push(new w(this.a.length,{line:0,column:0},{line:f.length-1,column:$.length-f[f.length-1]},f.length-1,$.length)),this.a.push(new E($,f))}const v=R(i);return u.push(new w(this.a.length,{line:0,column:0},{line:v.length-1,column:i.length-v[v.length-1]},v.length-1,i.length)),this.a.push(new E(i,v)),u}let n=this.a[0].buffer.length;const r=R(i,!1);let s=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},s=this.g;for(let u=0;u<r.length;u++)r[u]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let u=0;u<r.length;u++)r[u]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,g=this.a[0].lineStarts.length-1,o=t-this.a[0].lineStarts[g],d={line:g,column:o},l=new w(0,s,d,this.t(0,s,d),t-n);return this.g=d,[l]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let r=this.root,s="";const t=this.h.get2(i);if(t){r=t.node;const g=this.B(r,i-t.nodeStartLineNumber-1),o=this.a[r.piece.bufferIndex].buffer,d=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===i)s=o.substring(d+g,d+r.piece.length);else{const l=this.B(r,i-t.nodeStartLineNumber);return o.substring(d+g,d+l-n)}}else{let g=0;const o=i;for(;r!==P.$VB;)if(r.left!==P.$VB&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const d=this.B(r,i-r.lf_left-2),l=this.B(r,i-r.lf_left-1),u=this.a[r.piece.bufferIndex].buffer,v=this.u(r.piece.bufferIndex,r.piece.start);return g+=r.size_left,this.h.set({node:r,nodeStartOffset:g,nodeStartLineNumber:o-(i-1-r.lf_left)}),u.substring(v+d,v+l-n)}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const d=this.B(r,i-r.lf_left-2),l=this.a[r.piece.bufferIndex].buffer,u=this.u(r.piece.bufferIndex,r.piece.start);s=l.substring(u+d,u+r.piece.length);break}else i-=r.lf_left+r.piece.lineFeedCnt,g+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==P.$VB;){const g=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const o=this.B(r,0),d=this.u(r.piece.bufferIndex,r.piece.start);return s+=g.substring(d,d+o-n),s}else{const o=this.u(r.piece.bufferIndex,r.piece.start);s+=g.substr(o,r.piece.length)}r=r.next()}return s}y(){let i=this.root,n=1,r=0;for(;i!==P.$VB;)n+=i.lf_left+i.piece.lineFeedCnt,r+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=r,this.h.validate(this.c)}A(i,n){const r=i.piece,s=this.s(i,n),t=s.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===n){const g=this.t(i.piece.bufferIndex,r.start,s);if(g!==t)return{index:g,remainder:0}}return{index:t,remainder:s.column}}B(i,n){if(n<0)return 0;const r=i.piece,s=this.a[r.bufferIndex].lineStarts,t=r.start.line+n+1;return t>r.end.line?s[r.end.line]+r.end.column-s[r.start.line]-r.start.column:s[t]-s[r.start.line]-r.start.column}C(i,n){const r=i.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),g=n,o=this.u(r.bufferIndex,g),d=this.t(r.bufferIndex,r.start,g),l=d-s,u=o-t,v=r.length+u;i.piece=new w(r.bufferIndex,r.start,g,d,v),(0,P.$3B)(this,i,u,l)}D(i,n){const r=i.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),g=n,o=this.t(r.bufferIndex,g,r.end),d=this.u(r.bufferIndex,g),l=o-s,u=t-d,v=r.length+u;i.piece=new w(r.bufferIndex,g,r.end,o,v),(0,P.$3B)(this,i,u,l)}E(i,n,r){const s=i.piece,t=s.start,g=s.end,o=s.length,d=s.lineFeedCnt,l=n,u=this.t(s.bufferIndex,s.start,l),v=this.u(s.bufferIndex,n)-this.u(s.bufferIndex,t);i.piece=new w(s.bufferIndex,s.start,l,u,v),(0,P.$3B)(this,i,v-o,u-d);const I=new w(s.bufferIndex,r,g,this.t(s.bufferIndex,r,g),this.u(s.bufferIndex,g)-this.u(s.bufferIndex,r)),$=this.S(i,I);this.N($)}F(i,n){this.Q(n,i)&&(n+=`
`);const r=this.K()&&this.L(n)&&this.M(i),s=this.a[0].buffer.length;this.a[0].buffer+=n;const t=R(n,!1);for(let $=0;$<t.length;$++)t[$]+=s;if(r){const $=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:s-$}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const g=this.a[0].lineStarts.length-1,o=this.a[0].buffer.length-this.a[0].lineStarts[g],d={line:g,column:o},l=i.piece.length+n.length,u=i.piece.lineFeedCnt,v=this.t(0,i.piece.start,d),I=v-u;i.piece=new w(i.piece.bufferIndex,i.piece.start,d,v,l),this.g=d,(0,P.$3B)(this,i,n.length,I)}G(i){let n=this.root;const r=this.h.get(i);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:i-r.nodeStartOffset};let s=0;for(;n!==P.$VB;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){s+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:s};return this.h.set(t),t}else i-=n.size_left+n.piece.length,s+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let r=this.root,s=0;for(;r!==P.$VB;)if(r.left!==P.$VB&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const t=this.B(r,i-r.lf_left-2),g=this.B(r,i-r.lf_left-1);return s+=r.size_left,{node:r,remainder:Math.min(t+n-1,g),nodeStartOffset:s}}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const t=this.B(r,i-r.lf_left-2);if(t+n-1<=r.piece.length)return{node:r,remainder:t+n-1,nodeStartOffset:s};n-=r.piece.length-t;break}else i-=r.lf_left+r.piece.lineFeedCnt,s+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==P.$VB;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),g=this.J(r);return{node:r,remainder:Math.min(n-1,t),nodeStartOffset:g}}else if(r.piece.length>=n-1){const t=this.J(r);return{node:r,remainder:n-1,nodeStartOffset:t}}else n-=r.piece.length;r=r.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const r=this.a[i.piece.bufferIndex],s=this.u(i.piece.bufferIndex,i.piece.start)+n;return r.buffer.charCodeAt(s)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===P.$VB||i.piece.lineFeedCnt===0)return!1;const n=i.piece,r=this.a[n.bufferIndex].lineStarts,s=n.start.line,t=r[s]+n.start.column;return s===r.length-1||r[s+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===P.$VB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const r=[],s=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:s[i.piece.end.line]-s[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const g=i.piece.length-1,o=i.piece.lineFeedCnt-1;i.piece=new w(i.piece.bufferIndex,i.piece.start,t,o,g),(0,P.$3B)(this,i,-1,-1),i.piece.length===0&&r.push(i);const d={line:n.piece.start.line+1,column:0},l=n.piece.length-1,u=this.t(n.piece.bufferIndex,d,n.piece.end);n.piece=new w(n.piece.bufferIndex,d,n.piece.end,u,l),(0,P.$3B)(this,n,-1,-1),n.piece.length===0&&r.push(n);const v=this.w(`\r
`);this.S(i,v[0]);for(let I=0;I<r.length;I++)(0,P.$1B)(this,r[I])}Q(i,n){if(this.K()&&this.M(i)){const r=n.next();if(this.L(r)){if(i+=`
`,r.piece.length===1)(0,P.$1B)(this,r);else{const s=r.piece,t={line:s.start.line+1,column:0},g=s.length-1,o=this.t(s.bufferIndex,t,s.end);r.piece=new w(s.bufferIndex,t,s.end,o,g),(0,P.$3B)(this,r,-1,-1)}return!0}}return!1}iterate(i,n){if(i===P.$VB)return n(P.$VB);const r=this.iterate(i.left,n);return r&&n(i)&&this.iterate(i.right,n)}R(i){if(i===P.$VB)return"";const n=this.a[i.piece.bufferIndex],r=i.piece,s=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return n.buffer.substring(s,t)}getPieceContent(i){const n=this.a[i.bufferIndex],r=this.u(i.bufferIndex,i.start),s=this.u(i.bufferIndex,i.end);return n.buffer.substring(r,s)}S(i,n){const r=new P.$UB(n,1);if(r.left=P.$VB,r.right=P.$VB,r.parent=P.$VB,r.size_left=0,r.lf_left=0,this.root===P.$VB)this.root=r,r.color=0;else if(i.right===P.$VB)i.right=r,r.parent=i;else{const t=(0,P.$WB)(i.right);t.left=r,r.parent=t}return(0,P.$2B)(this,r),r}T(i,n){const r=new P.$UB(n,1);if(r.left=P.$VB,r.right=P.$VB,r.parent=P.$VB,r.size_left=0,r.lf_left=0,this.root===P.$VB)this.root=r,r.color=0;else if(i.left===P.$VB)i.left=r,r.parent=i;else{const s=(0,P.$XB)(i.left);s.right=r,r.parent=s}return(0,P.$2B)(this,r),r}U(i){let n="";return this.iterate(i,r=>(n+=this.R(r),!0)),n}}e.$cC=m}),define(ke[177],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C8=e.$B8=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(P){if(P&&this.a.has(P)){const A=this.a.get(P);return this.a.delete(P),A}}addDragOperationTransfer(P,A){this.a.set(P,A)}}e.$B8=D;class N{constructor(P){this.identifier=P}}e.$C8=N}),define(ke[178],Se([1,0,4,3]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0;class h{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Wd,this.onDidChange=this.c.event,this.d=null}handleChange(p){this.c.fire({changedLanguages:p,changedColorMap:!1})}register(p,b){return this.a.set(p,b),this.handleChange([p]),(0,N.$Rc)(()=>{this.a.get(p)===b&&(this.a.delete(p),this.handleChange([p]))})}get(p){return this.a.get(p)||null}registerFactory(p,b){this.b.get(p)?.dispose();const k=new P(this,p,b);return this.b.set(p,k),(0,N.$Rc)(()=>{const R=this.b.get(p);!R||R!==k||(this.b.delete(p),R.dispose())})}async getOrCreate(p){const b=this.get(p);if(b)return b;const k=this.b.get(p);return!k||k.isResolved?null:(await k.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const k=this.b.get(p);return!!(!k||k.isResolved)}setColorMap(p){this.d=p,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$vt=h;class P extends N.$Tc{get isResolved(){return this.c}constructor(p,b,k){super(),this.f=p,this.g=b,this.h=k,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const p=await this.h.tokenizationSupport;this.c=!0,p&&!this.a&&this.B(this.f.register(this.g,p))}}}),define(ke[179],Se([9,10]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(ke[180],Se([1,0,4,3,179]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class P extends N.$Tc{constructor(w,E="",S="",c=!0,m){super(),this.h=this.B(new D.$Wd),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=E,this.u=S,this.w=c,this.C=m}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,E){this.C&&await this.C(w)}}e.$Mi=P;class A extends N.$Tc{constructor(){super(...arguments),this.f=this.B(new D.$Wd),this.onWillRun=this.f.event,this.m=this.B(new D.$Wd),this.onDidRun=this.m.event}async run(w,E){if(!w.enabled)return;this.f.fire({action:w});let S;try{await this.u(w,E)}catch(c){S=c}this.m.fire({action:w,error:S})}async u(w,E){await w.run(E)}}e.$Ni=A;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let E=[];for(const S of w)S.length&&(E.length?E=[...E,new p,...S]:E=S);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$Oi=p;class b{get actions(){return this.a}constructor(w,E,S,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=E,this.class=c,this.a=S}async run(){}}e.$Pi=b;class k extends P{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,h.localize(0,null),void 0,!1)}}e.$Qi=k;function R(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked,run:async(...w)=>C.run(...w),tooltip:C.label}}e.$Ri=R}),define(ke[181],Se([9,10]),function($e,e){return $e.create("vs/base/common/date",e)}),define(ke[182],Se([1,0,181]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0;const N=60,h=N*60,P=h*24,A=P*7,p=P*30,b=P*365;function k(w,E,S,c){typeof w!="number"&&(w=w.getTime());const m=Math.round((new Date().getTime()-w)/1e3);if(m<-30)return(0,D.localize)(0,null,k(new Date().getTime()+m*1e3,!1));if(!c&&m<30)return(0,D.localize)(1,null);let a;return m<N?(a=m,E?a===1?S?(0,D.localize)(2,null,a):(0,D.localize)(3,null,a):S?(0,D.localize)(4,null,a):(0,D.localize)(5,null,a):a===1?S?(0,D.localize)(6,null,a):(0,D.localize)(7,null,a):S?(0,D.localize)(8,null,a):(0,D.localize)(9,null,a)):m<h?(a=Math.floor(m/N),E?a===1?S?(0,D.localize)(10,null,a):(0,D.localize)(11,null,a):S?(0,D.localize)(12,null,a):(0,D.localize)(13,null,a):a===1?S?(0,D.localize)(14,null,a):(0,D.localize)(15,null,a):S?(0,D.localize)(16,null,a):(0,D.localize)(17,null,a)):m<P?(a=Math.floor(m/h),E?a===1?S?(0,D.localize)(18,null,a):(0,D.localize)(19,null,a):S?(0,D.localize)(20,null,a):(0,D.localize)(21,null,a):a===1?S?(0,D.localize)(22,null,a):(0,D.localize)(23,null,a):S?(0,D.localize)(24,null,a):(0,D.localize)(25,null,a)):m<A?(a=Math.floor(m/P),E?a===1?(0,D.localize)(26,null,a):(0,D.localize)(27,null,a):a===1?(0,D.localize)(28,null,a):(0,D.localize)(29,null,a)):m<p?(a=Math.floor(m/A),E?a===1?S?(0,D.localize)(30,null,a):(0,D.localize)(31,null,a):S?(0,D.localize)(32,null,a):(0,D.localize)(33,null,a):a===1?S?(0,D.localize)(34,null,a):(0,D.localize)(35,null,a):S?(0,D.localize)(36,null,a):(0,D.localize)(37,null,a)):m<b?(a=Math.floor(m/p),E?a===1?S?(0,D.localize)(38,null,a):(0,D.localize)(39,null,a):S?(0,D.localize)(40,null,a):(0,D.localize)(41,null,a):a===1?S?(0,D.localize)(42,null,a):(0,D.localize)(43,null,a):S?(0,D.localize)(44,null,a):(0,D.localize)(45,null,a)):(a=Math.floor(m/b),E?a===1?S?(0,D.localize)(46,null,a):(0,D.localize)(47,null,a):S?(0,D.localize)(48,null,a):(0,D.localize)(49,null,a):a===1?S?(0,D.localize)(50,null,a):(0,D.localize)(51,null,a):S?(0,D.localize)(52,null,a):(0,D.localize)(53,null,a))}e.$xm=k;function R(w,E){const S=Math.abs(w/1e3);return S<1?E?(0,D.localize)(54,null,w):(0,D.localize)(55,null,w):S<N?E?(0,D.localize)(56,null,Math.round(w)/1e3):(0,D.localize)(57,null,Math.round(w)/1e3):S<h?E?(0,D.localize)(58,null,Math.round(w/(1e3*N))):(0,D.localize)(59,null,Math.round(w/(1e3*N))):S<P?E?(0,D.localize)(60,null,Math.round(w/(1e3*h))):(0,D.localize)(61,null,Math.round(w/(1e3*h))):(0,D.localize)(62,null,Math.round(w/(1e3*P)))}e.$ym=R;function C(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$zm=C}),define(ke[183],Se([9,10]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(ke[44],Se([1,0,19,18,183]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=void 0;function P(C,w){return w&&(C.stack||C.stacktrace)?h.localize(0,null,p(C),A(C.stack)||A(C.stacktrace)):p(C)}function A(C){return Array.isArray(C)?C.join(`
`):C}function p(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?h.localize(1,null,C.message):C.message||h.localize(2,null)}function b(C=null,w=!1){if(!C)return h.localize(3,null);if(Array.isArray(C)){const E=D.$Hb(C),S=b(E[0],w);return E.length>1?h.localize(4,null,S,E.length):S}if(N.$Jf(C))return C;if(C.detail){const E=C.detail;if(E.error)return P(E.error,w);if(E.exception)return P(E.exception,w)}return C.stack?P(C,w):C.message?C.message:h.localize(5,null)}e.$Si=b;function k(C){const w=C;return w instanceof Error&&Array.isArray(w.actions)}e.$Ti=k;function R(C,w){let E;return typeof C=="string"?E=new Error(C):E=C,E.actions=w,E}e.$Ui=R}),define(ke[184],Se([9,10]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(ke[11],Se([1,0,184]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let N=!1,h=!1,P=!1,A=!1,p=!1,b=!1,k=!1,R=!1,C=!1,w=!1,E,S=e.$g,c=e.$g,m,a;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const r=typeof n?.versions?.electron=="string",s=r&&n?.type==="renderer";if(typeof n=="object"){N=n.platform==="win32",h=n.platform==="darwin",P=n.platform==="linux",A=P&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,k=r,C=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=e.$g,S=e.$g;const f=n.env.VSCODE_NLS_CONFIG;if(f)try{const y=JSON.parse(f),L=y.availableLanguages["*"];E=y.locale,c=y.osLocale,S=L||e.$g,m=y._translationsConfigFile}catch{}p=!0}else typeof navigator=="object"&&!s?(a=navigator.userAgent,N=a.indexOf("Windows")>=0,h=a.indexOf("Macintosh")>=0,R=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=a.indexOf("Linux")>=0,w=a?.indexOf("Mobi")>=0,b=!0,E=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,S=E,c=navigator.language):console.error("Unable to resolve platform.");var t;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(t||(e.Platform=t={}));function g(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=g;let o=0;h?o=1:N?o=3:P&&(o=2),e.$i=N,e.$j=h,e.$k=P,e.$l=A,e.$m=p,e.$n=k,e.$o=b,e.$p=b&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=R,e.$s=w,e.$t=C,e.$u=o,e.$v=a,e.$w=S;var d;(function(f){function y(){return e.$w}f.value=y;function L(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}f.isDefaultVariant=L;function T(){return e.$w==="en"}f.isDefault=T})(d||(e.Language=d={})),e.$x=E,e.$y=c,e.$z=m,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const f=[];i.addEventListener("message",L=>{if(L.data&&L.data.vscodeScheduleAsyncWork)for(let T=0,U=f.length;T<U;T++){const j=f[T];if(j.id===L.data.vscodeScheduleAsyncWork){f.splice(T,1),j.callback();return}}});let y=0;return L=>{const T=++y;f.push({id:T,callback:L}),i.postMessage({vscodeScheduleAsyncWork:T},"*")}}return f=>setTimeout(f)})();var l;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=h||R?2:N?1:3;let u=!0,v=!1;function I(){if(!v){v=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,u=new Uint16Array(f.buffer)[0]===(2<<8)+1}return u}e.$D=I,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function $(f){return parseFloat(f)>=20}e.$J=$}),define(ke[49],Se([1,0,11]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let N;const h=globalThis.vscode;if(typeof h<"u"&&typeof h.process<"u"){const P=h.process;N={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$dc=N.platform,e.$ec=N.arch}),define(ke[17],Se([1,0,49]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const N=65,h=97,P=90,A=122,p=46,b=47,k=92,R=58,C=63;class w extends Error{constructor(g,o,d){let l;typeof o=="string"&&o.indexOf("not ")===0?(l="must not be",o=o.replace(/^not /,"")):l="must be";const u=g.indexOf(".")!==-1?"property":"argument";let v=`The "${g}" ${u} ${l} of type ${o}`;v+=`. Received type ${typeof d}`,super(v),this.code="ERR_INVALID_ARG_TYPE"}}function E(t,g){if(t===null||typeof t!="object")throw new w(g,"Object",t)}function S(t,g){if(typeof t!="string")throw new w(g,"string",t)}const c=D.$dc==="win32";function m(t){return t===b||t===k}function a(t){return t===b}function i(t){return t>=N&&t<=P||t>=h&&t<=A}function n(t,g,o,d){let l="",u=0,v=-1,I=0,$=0;for(let f=0;f<=t.length;++f){if(f<t.length)$=t.charCodeAt(f);else{if(d($))break;$=b}if(d($)){if(!(v===f-1||I===1))if(I===2){if(l.length<2||u!==2||l.charCodeAt(l.length-1)!==p||l.charCodeAt(l.length-2)!==p){if(l.length>2){const y=l.lastIndexOf(o);y===-1?(l="",u=0):(l=l.slice(0,y),u=l.length-1-l.lastIndexOf(o)),v=f,I=0;continue}else if(l.length!==0){l="",u=0,v=f,I=0;continue}}g&&(l+=l.length>0?`${o}..`:"..",u=2)}else l.length>0?l+=`${o}${t.slice(v+1,f)}`:l=t.slice(v+1,f),u=f-v-1;v=f,I=0}else $===p&&I!==-1?++I:I=-1}return l}function r(t,g){E(g,"pathObject");const o=g.dir||g.root,d=g.base||`${g.name||""}${g.ext||""}`;return o?o===g.root?`${o}${d}`:`${o}${t}${d}`:d}e.$fc={resolve(...t){let g="",o="",d=!1;for(let l=t.length-1;l>=-1;l--){let u;if(l>=0){if(u=t[l],S(u,"path"),u.length===0)continue}else g.length===0?u=D.cwd():(u=D.env[`=${g}`]||D.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==g.toLowerCase()&&u.charCodeAt(2)===k)&&(u=`${g}\\`));const v=u.length;let I=0,$="",f=!1;const y=u.charCodeAt(0);if(v===1)m(y)&&(I=1,f=!0);else if(m(y))if(f=!0,m(u.charCodeAt(1))){let L=2,T=L;for(;L<v&&!m(u.charCodeAt(L));)L++;if(L<v&&L!==T){const U=u.slice(T,L);for(T=L;L<v&&m(u.charCodeAt(L));)L++;if(L<v&&L!==T){for(T=L;L<v&&!m(u.charCodeAt(L));)L++;(L===v||L!==T)&&($=`\\\\${U}\\${u.slice(T,L)}`,I=L)}}}else I=1;else i(y)&&u.charCodeAt(1)===R&&($=u.slice(0,2),I=2,v>2&&m(u.charCodeAt(2))&&(f=!0,I=3));if($.length>0)if(g.length>0){if($.toLowerCase()!==g.toLowerCase())continue}else g=$;if(d){if(g.length>0)break}else if(o=`${u.slice(I)}\\${o}`,d=f,f&&g.length>0)break}return o=n(o,!d,"\\",m),d?`${g}\\${o}`:`${g}${o}`||"."},normalize(t){S(t,"path");const g=t.length;if(g===0)return".";let o=0,d,l=!1;const u=t.charCodeAt(0);if(g===1)return a(u)?"\\":t;if(m(u))if(l=!0,m(t.charCodeAt(1))){let I=2,$=I;for(;I<g&&!m(t.charCodeAt(I));)I++;if(I<g&&I!==$){const f=t.slice($,I);for($=I;I<g&&m(t.charCodeAt(I));)I++;if(I<g&&I!==$){for($=I;I<g&&!m(t.charCodeAt(I));)I++;if(I===g)return`\\\\${f}\\${t.slice($)}\\`;I!==$&&(d=`\\\\${f}\\${t.slice($,I)}`,o=I)}}}else o=1;else i(u)&&t.charCodeAt(1)===R&&(d=t.slice(0,2),o=2,g>2&&m(t.charCodeAt(2))&&(l=!0,o=3));let v=o<g?n(t.slice(o),!l,"\\",m):"";return v.length===0&&!l&&(v="."),v.length>0&&m(t.charCodeAt(g-1))&&(v+="\\"),d===void 0?l?`\\${v}`:v:l?`${d}\\${v}`:`${d}${v}`},isAbsolute(t){S(t,"path");const g=t.length;if(g===0)return!1;const o=t.charCodeAt(0);return m(o)||g>2&&i(o)&&t.charCodeAt(1)===R&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let g,o;for(let u=0;u<t.length;++u){const v=t[u];S(v,"path"),v.length>0&&(g===void 0?g=o=v:g+=`\\${v}`)}if(g===void 0)return".";let d=!0,l=0;if(typeof o=="string"&&m(o.charCodeAt(0))){++l;const u=o.length;u>1&&m(o.charCodeAt(1))&&(++l,u>2&&(m(o.charCodeAt(2))?++l:d=!1))}if(d){for(;l<g.length&&m(g.charCodeAt(l));)l++;l>=2&&(g=`\\${g.slice(l)}`)}return e.$fc.normalize(g)},relative(t,g){if(S(t,"from"),S(g,"to"),t===g)return"";const o=e.$fc.resolve(t),d=e.$fc.resolve(g);if(o===d||(t=o.toLowerCase(),g=d.toLowerCase(),t===g))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===k;)l++;let u=t.length;for(;u-1>l&&t.charCodeAt(u-1)===k;)u--;const v=u-l;let I=0;for(;I<g.length&&g.charCodeAt(I)===k;)I++;let $=g.length;for(;$-1>I&&g.charCodeAt($-1)===k;)$--;const f=$-I,y=v<f?v:f;let L=-1,T=0;for(;T<y;T++){const j=t.charCodeAt(l+T);if(j!==g.charCodeAt(I+T))break;j===k&&(L=T)}if(T!==y){if(L===-1)return d}else{if(f>y){if(g.charCodeAt(I+T)===k)return d.slice(I+T+1);if(T===2)return d.slice(I+T)}v>y&&(t.charCodeAt(l+T)===k?L=T:T===2&&(L=3)),L===-1&&(L=0)}let U="";for(T=l+L+1;T<=u;++T)(T===u||t.charCodeAt(T)===k)&&(U+=U.length===0?"..":"\\..");return I+=L,U.length>0?`${U}${d.slice(I,$)}`:(d.charCodeAt(I)===k&&++I,d.slice(I,$))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const g=e.$fc.resolve(t);if(g.length<=2)return t;if(g.charCodeAt(0)===k){if(g.charCodeAt(1)===k){const o=g.charCodeAt(2);if(o!==C&&o!==p)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(i(g.charCodeAt(0))&&g.charCodeAt(1)===R&&g.charCodeAt(2)===k)return`\\\\?\\${g}`;return t},dirname(t){S(t,"path");const g=t.length;if(g===0)return".";let o=-1,d=0;const l=t.charCodeAt(0);if(g===1)return m(l)?t:".";if(m(l)){if(o=d=1,m(t.charCodeAt(1))){let I=2,$=I;for(;I<g&&!m(t.charCodeAt(I));)I++;if(I<g&&I!==$){for($=I;I<g&&m(t.charCodeAt(I));)I++;if(I<g&&I!==$){for($=I;I<g&&!m(t.charCodeAt(I));)I++;if(I===g)return t;I!==$&&(o=d=I+1)}}}}else i(l)&&t.charCodeAt(1)===R&&(o=g>2&&m(t.charCodeAt(2))?3:2,d=o);let u=-1,v=!0;for(let I=g-1;I>=d;--I)if(m(t.charCodeAt(I))){if(!v){u=I;break}}else v=!1;if(u===-1){if(o===-1)return".";u=o}return t.slice(0,u)},basename(t,g){g!==void 0&&S(g,"ext"),S(t,"path");let o=0,d=-1,l=!0,u;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(o=2),g!==void 0&&g.length>0&&g.length<=t.length){if(g===t)return"";let v=g.length-1,I=-1;for(u=t.length-1;u>=o;--u){const $=t.charCodeAt(u);if(m($)){if(!l){o=u+1;break}}else I===-1&&(l=!1,I=u+1),v>=0&&($===g.charCodeAt(v)?--v===-1&&(d=u):(v=-1,d=I))}return o===d?d=I:d===-1&&(d=t.length),t.slice(o,d)}for(u=t.length-1;u>=o;--u)if(m(t.charCodeAt(u))){if(!l){o=u+1;break}}else d===-1&&(l=!1,d=u+1);return d===-1?"":t.slice(o,d)},extname(t){S(t,"path");let g=0,o=-1,d=0,l=-1,u=!0,v=0;t.length>=2&&t.charCodeAt(1)===R&&i(t.charCodeAt(0))&&(g=d=2);for(let I=t.length-1;I>=g;--I){const $=t.charCodeAt(I);if(m($)){if(!u){d=I+1;break}continue}l===-1&&(u=!1,l=I+1),$===p?o===-1?o=I:v!==1&&(v=1):o!==-1&&(v=-1)}return o===-1||l===-1||v===0||v===1&&o===l-1&&o===d+1?"":t.slice(o,l)},format:r.bind(null,"\\"),parse(t){S(t,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return g;const o=t.length;let d=0,l=t.charCodeAt(0);if(o===1)return m(l)?(g.root=g.dir=t,g):(g.base=g.name=t,g);if(m(l)){if(d=1,m(t.charCodeAt(1))){let L=2,T=L;for(;L<o&&!m(t.charCodeAt(L));)L++;if(L<o&&L!==T){for(T=L;L<o&&m(t.charCodeAt(L));)L++;if(L<o&&L!==T){for(T=L;L<o&&!m(t.charCodeAt(L));)L++;L===o?d=L:L!==T&&(d=L+1)}}}}else if(i(l)&&t.charCodeAt(1)===R){if(o<=2)return g.root=g.dir=t,g;if(d=2,m(t.charCodeAt(2))){if(o===3)return g.root=g.dir=t,g;d=3}}d>0&&(g.root=t.slice(0,d));let u=-1,v=d,I=-1,$=!0,f=t.length-1,y=0;for(;f>=d;--f){if(l=t.charCodeAt(f),m(l)){if(!$){v=f+1;break}continue}I===-1&&($=!1,I=f+1),l===p?u===-1?u=f:y!==1&&(y=1):u!==-1&&(y=-1)}return I!==-1&&(u===-1||y===0||y===1&&u===I-1&&u===v+1?g.base=g.name=t.slice(v,I):(g.name=t.slice(v,u),g.base=t.slice(v,I),g.ext=t.slice(u,I))),v>0&&v!==d?g.dir=t.slice(0,v-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(c){const t=/\\/g;return()=>{const g=D.cwd().replace(t,"/");return g.slice(g.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...t){let g="",o=!1;for(let d=t.length-1;d>=-1&&!o;d--){const l=d>=0?t[d]:s();S(l,"path"),l.length!==0&&(g=`${l}/${g}`,o=l.charCodeAt(0)===b)}return g=n(g,!o,"/",a),o?`/${g}`:g.length>0?g:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const g=t.charCodeAt(0)===b,o=t.charCodeAt(t.length-1)===b;return t=n(t,!g,"/",a),t.length===0?g?"/":o?"./":".":(o&&(t+="/"),g?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===b},join(...t){if(t.length===0)return".";let g;for(let o=0;o<t.length;++o){const d=t[o];S(d,"path"),d.length>0&&(g===void 0?g=d:g+=`/${d}`)}return g===void 0?".":e.$gc.normalize(g)},relative(t,g){if(S(t,"from"),S(g,"to"),t===g||(t=e.$gc.resolve(t),g=e.$gc.resolve(g),t===g))return"";const o=1,d=t.length,l=d-o,u=1,v=g.length-u,I=l<v?l:v;let $=-1,f=0;for(;f<I;f++){const L=t.charCodeAt(o+f);if(L!==g.charCodeAt(u+f))break;L===b&&($=f)}if(f===I)if(v>I){if(g.charCodeAt(u+f)===b)return g.slice(u+f+1);if(f===0)return g.slice(u+f)}else l>I&&(t.charCodeAt(o+f)===b?$=f:f===0&&($=0));let y="";for(f=o+$+1;f<=d;++f)(f===d||t.charCodeAt(f)===b)&&(y+=y.length===0?"..":"/..");return`${y}${g.slice(u+$)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const g=t.charCodeAt(0)===b;let o=-1,d=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===b){if(!d){o=l;break}}else d=!1;return o===-1?g?"/":".":g&&o===1?"//":t.slice(0,o)},basename(t,g){g!==void 0&&S(g,"ext"),S(t,"path");let o=0,d=-1,l=!0,u;if(g!==void 0&&g.length>0&&g.length<=t.length){if(g===t)return"";let v=g.length-1,I=-1;for(u=t.length-1;u>=0;--u){const $=t.charCodeAt(u);if($===b){if(!l){o=u+1;break}}else I===-1&&(l=!1,I=u+1),v>=0&&($===g.charCodeAt(v)?--v===-1&&(d=u):(v=-1,d=I))}return o===d?d=I:d===-1&&(d=t.length),t.slice(o,d)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===b){if(!l){o=u+1;break}}else d===-1&&(l=!1,d=u+1);return d===-1?"":t.slice(o,d)},extname(t){S(t,"path");let g=-1,o=0,d=-1,l=!0,u=0;for(let v=t.length-1;v>=0;--v){const I=t.charCodeAt(v);if(I===b){if(!l){o=v+1;break}continue}d===-1&&(l=!1,d=v+1),I===p?g===-1?g=v:u!==1&&(u=1):g!==-1&&(u=-1)}return g===-1||d===-1||u===0||u===1&&g===d-1&&g===o+1?"":t.slice(g,d)},format:r.bind(null,"/"),parse(t){S(t,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return g;const o=t.charCodeAt(0)===b;let d;o?(g.root="/",d=1):d=0;let l=-1,u=0,v=-1,I=!0,$=t.length-1,f=0;for(;$>=d;--$){const y=t.charCodeAt($);if(y===b){if(!I){u=$+1;break}continue}v===-1&&(I=!1,v=$+1),y===p?l===-1?l=$:f!==1&&(f=1):l!==-1&&(f=-1)}if(v!==-1){const y=u===0&&o?1:u;l===-1||f===0||f===1&&l===v-1&&l===u+1?g.base=g.name=t.slice(y,v):(g.name=t.slice(y,l),g.base=t.slice(y,v),g.ext=t.slice(l,v))}return u>0?g.dir=t.slice(0,u-1):o&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=c?e.$fc.normalize:e.$gc.normalize,e.$ic=c?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=c?e.$fc.join:e.$gc.join,e.$kc=c?e.$fc.resolve:e.$gc.resolve,e.$lc=c?e.$fc.relative:e.$gc.relative,e.$mc=c?e.$fc.dirname:e.$gc.dirname,e.$nc=c?e.$fc.basename:e.$gc.basename,e.$oc=c?e.$fc.extname:e.$gc.extname,e.$pc=c?e.$fc.format:e.$gc.format,e.$qc=c?e.$fc.parse:e.$gc.parse,e.$rc=c?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=c?e.$fc.sep:e.$gc.sep,e.$tc=c?e.$fc.delimiter:e.$gc.delimiter}),define(ke[128],Se([1,0,43,17]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=void 0;const h=new D.$V(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),P=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(I,$,f=!1){const y=I||"",L=$||"",T=h.value.collator.compare(y,L);return h.value.collatorIsNumeric&&T===0&&y!==L?y<L?-1:1:T}e.$Kq=p;function b(I,$){const f=P.value.collator;return I=I||"",$=$||"",r(f,I,$)}e.$Lq=b;function k(I,$){const f=P.value.collator;return I=I||"",$=$||"",o(I,$)||r(f,I,$)}e.$Mq=k;function R(I,$){const f=P.value.collator;return I=I||"",$=$||"",g(I,$)||r(f,I,$)}e.$Nq=R;function C(I,$){return I=I||"",$=$||"",I===$?0:I<$?-1:1}e.$Oq=C;function w(I,$){const[f,y]=i(I),[L,T]=i($);let U=h.value.collator.compare(y,T);if(U===0){if(h.value.collatorIsNumeric&&y!==T)return y<T?-1:1;if(U=h.value.collator.compare(f,L),h.value.collatorIsNumeric&&U===0&&f!==L)return f<L?-1:1}return U}e.$Pq=w;function E(I,$){I=I||"",$=$||"";const f=n(I),y=n($),L=P.value.collator,T=A.value.collator;return r(T,f,y)||r(L,I,$)}e.$Qq=E;function S(I,$){I=I||"",$=$||"";const f=n(I),y=n($),L=P.value.collator,T=A.value.collator;return r(T,f,y)||o(I,$)||r(L,I,$)}e.$Rq=S;function c(I,$){I=I||"",$=$||"";const f=n(I),y=n($),L=P.value.collator,T=A.value.collator;return r(T,f,y)||g(I,$)||r(L,I,$)}e.$Sq=c;function m(I,$){I=I||"",$=$||"";const f=n(I).toLowerCase(),y=n($).toLowerCase();return f!==y?f<y?-1:1:I!==$?I<$?-1:1:0}e.$Tq=m;const a=/^(.*?)(\.([^.]*))?$/;function i(I,$=!1){const f=I?a.exec(I):[];let y=[f&&f[1]||"",f&&f[3]||""];return $&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function n(I){const $=I?a.exec(I):[];return $&&$[1]&&$[1].charAt(0)!=="."&&$[3]||""}function r(I,$,f){const y=I.compare($,f);return y!==0?y:$.length!==f.length?$.length<f.length?-1:1:0}function s(I){const $=I.charAt(0);return $.toLocaleUpperCase()!==$}function t(I){const $=I.charAt(0);return $.toLocaleLowerCase()!==$}function g(I,$){return s(I)&&t($)?-1:t(I)&&s($)?1:0}function o(I,$){return t(I)&&s($)?-1:s(I)&&t($)?1:0}function d(I,$,f=!1){return f||(I=I&&I.toLowerCase(),$=$&&$.toLowerCase()),I===$?0:I<$?-1:1}function l(I,$,f=!1){const y=I.split(N.sep),L=$.split(N.sep),T=y.length-1,U=L.length-1;let j,F;for(let M=0;;M++){if(j=T===M,F=U===M,j&&F)return p(y[M],L[M],f);if(j)return-1;if(F)return 1;const O=d(y[M],L[M],f);if(O!==0)return O}}e.$Uq=l;function u(I,$,f){const y=I.toLowerCase(),L=$.toLowerCase(),T=v(I,$,f);if(T)return T;const U=y.endsWith(f),j=L.endsWith(f);if(U!==j)return U?-1:1;const F=p(y,L);return F!==0?F:y.localeCompare(L)}e.$Vq=u;function v(I,$,f){const y=I.toLowerCase(),L=$.toLowerCase(),T=y.startsWith(f),U=L.startsWith(f);if(T!==U)return T?-1:1;if(T&&U){if(y.length<L.length)return-1;if(y.length>L.length)return 1}return 0}e.$Wq=v}),define(ke[34],Se([1,0,17,11,12,18]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=void 0;function A(u){return u===47||u===92}e.$2f=A;function p(u){return u.replace(/[\\/]/g,D.$gc.sep)}e.$3f=p;function b(u){return u.indexOf("/")===-1&&(u=p(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.$4f=b;function k(u,v=D.$gc.sep){if(!u)return"";const I=u.length,$=u.charCodeAt(0);if(A($)){if(A(u.charCodeAt(1))&&!A(u.charCodeAt(2))){let y=3;const L=y;for(;y<I&&!A(u.charCodeAt(y));y++);if(L!==y&&!A(u.charCodeAt(y+1))){for(y+=1;y<I;y++)if(A(u.charCodeAt(y)))return u.slice(0,y+1).replace(/[\\/]/g,v)}}return v}else if(a($)&&u.charCodeAt(1)===58)return A(u.charCodeAt(2))?u.slice(0,2)+v:u.slice(0,2);let f=u.indexOf("://");if(f!==-1){for(f+=3;f<I;f++)if(A(u.charCodeAt(f)))return u.slice(0,f+1)}return""}e.$5f=k;function R(u){if(!N.$i||!u||u.length<5)return!1;let v=u.charCodeAt(0);if(v!==92||(v=u.charCodeAt(1),v!==92))return!1;let I=2;const $=I;for(;I<u.length&&(v=u.charCodeAt(I),v!==92);I++);return!($===I||(v=u.charCodeAt(I+1),isNaN(v)||v===92))}e.$6f=R;const C=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(u,v=N.$i){const I=v?C:w;return!(!u||u.length===0||/^\s+$/.test(u)||(I.lastIndex=0,I.test(u))||v&&E.test(u)||u==="."||u===".."||v&&u[u.length-1]==="."||v&&u.length!==u.trim().length||u.length>255)}e.$7f=S;function c(u,v,I){const $=u===v;return!I||$?$:!u||!v?!1:(0,h.$af)(u,v)}e.$8f=c;function m(u,v,I,$=D.sep){if(u===v)return!0;if(!u||!v||v.length>u.length)return!1;if(I){if(!(0,h.$bf)(u,v))return!1;if(v.length===u.length)return!0;let y=v.length;return v.charAt(v.length-1)===$&&y--,u.charAt(y)===$}return v.charAt(v.length-1)!==$&&(v+=$),u.indexOf(v)===0}e.$9f=m;function a(u){return u>=65&&u<=90||u>=97&&u<=122}e.$0f=a;function i(u,v){return N.$i&&u.endsWith(":")&&(u+=D.sep),(0,D.$ic)(u)||(u=(0,D.$jc)(v,u)),u=(0,D.$hc)(u),N.$i?(u=(0,h.$Ve)(u,D.sep),u.endsWith(":")&&(u+=D.sep)):(u=(0,h.$Ve)(u,D.sep),u||(u=D.sep)),u}e.$$f=i;function n(u){const v=(0,D.$hc)(u);return N.$i?u.length>3?!1:r(v)&&(u.length===2||v.charCodeAt(2)===92):v===D.$gc.sep}e.$_f=n;function r(u,v=N.$i){return v?a(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.$ag=r;function s(u,v=N.$i){return r(u,v)?u[0]:void 0}e.$bg=s;function t(u,v,I){return v.length>u.length?-1:u===v?0:(I&&(u=u.toLowerCase(),v=v.toLowerCase()),u.indexOf(v))}e.$cg=t;function g(u){const v=u.split(":");let I,$,f;for(const y of v){const L=Number(y);(0,P.$Nf)(L)?$===void 0?$=L:f===void 0&&(f=L):I=I?[I,y].join(":"):y}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:$!==void 0?$:void 0,column:f!==void 0?f:$!==void 0?1:void 0}}e.$dg=g;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(u,v,I=8){let $="";for(let y=0;y<I;y++){let L;y===0&&N.$i&&!v&&(I===3||I===4)?L=d:L=o,$+=L.charAt(Math.floor(Math.random()*L.length))}let f;return v?f=`${v}-${$}`:f=$,u?(0,D.$jc)(u,f):f}e.$eg=l}),define(ke[129],Se([1,0,128,123,54,17,11,12]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=void 0;const b=0,k=[b,[]];function R(z,J,te,x){if(!z||!J)return k;const X=z.length,Z=J.length;if(X<Z)return k;const ae=z.toLowerCase();return C(J,te,Z,z,ae,X,x)}e.$Xq=R;function C(z,J,te,x,X,Z,ae){const _=[],ge=[];for(let re=0;re<te;re++){const ye=re*Z,he=ye-Z,fe=re>0,ue=z[re],me=J[re];for(let V=0;V<Z;V++){const Y=V>0,de=ye+V,we=de-1,Pe=he+V-1,ve=Y?_[we]:0,Ce=fe&&Y?_[Pe]:0,B=fe&&Y?ge[Pe]:0;let Q;!Ce&&fe?Q=0:Q=w(ue,me,x,X,V,B),Q&&Ce+Q>=ve&&(ae||fe||X.startsWith(J,V))?(ge[de]=B+1,_[de]=Ce+Q):(ge[de]=b,_[de]=ve)}}const ne=[];let K=te-1,W=Z-1;for(;K>=0&&W>=0;){const re=K*Z+W;ge[re]===b||(ne.push(W),K--),W--}return[_[te*Z-1],ne.reverse()]}function w(z,J,te,x,X,Z){let ae=0;if(!E(J,x[X]))return ae;if(ae+=1,Z>0&&(ae+=Z*5),z===te[X]&&(ae+=1),X===0)ae+=8;else{const _=S(te.charCodeAt(X-1));_?ae+=_:(0,N.$Zj)(te.charCodeAt(X))&&Z===0&&(ae+=2)}return ae}function E(z,J){return z===J?!0:z==="/"||z==="\\"?J==="/"||J==="\\":!1}function S(z){switch(z){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function m(z,J,te=0,x=0){const X=J;return X.values&&X.values.length>1?a(z,X.values,te,x):i(z,J,te,x)}e.$Yq=m;function a(z,J,te,x){let X=0;const Z=[];for(const ae of J){const[_,ge]=i(z,ae,te,x);if(typeof _!="number")return c;X+=_,Z.push(...ge)}return[X,I(Z)]}function i(z,J,te,x){const X=(0,N.$9j)(J.original,J.originalLowercase,te,z,z.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return X?[X[0],(0,N.$6j)(X)]:c}const n=Object.freeze({score:0}),r=1<<18,s=1<<17,t=1<<16;function g(z,J,te,x){const X=x.values?x.values:[x];return(0,h.$Vi)({[x.normalized]:{values:X.map(ae=>({value:ae.normalized,expectContiguousMatch:ae.expectContiguousMatch})),label:z,description:J,allowNonContiguousMatches:te}})}function o(z,J,te,x,X){if(!z||!J.normalized)return n;const Z=x.getItemLabel(z);if(!Z)return n;const ae=x.getItemDescription(z),_=g(Z,ae,te,J),ge=X[_];if(ge)return ge;const ne=d(Z,ae,x.getItemPath(z),J,te);return X[_]=ne,ne}e.$Zq=o;function d(z,J,te,x,X){const Z=!te||!x.containsPathSeparator;return te&&(A.$k?x.pathNormalized===te:(0,p.$af)(x.pathNormalized,te))?{score:r,labelMatch:[{start:0,end:z.length}],descriptionMatch:J?[{start:0,end:J.length}]:void 0}:x.values&&x.values.length>1?l(z,J,te,x.values,Z,X):u(z,J,te,x,Z,X)}function l(z,J,te,x,X,Z){let ae=0;const _=[],ge=[];for(const ne of x){const{score:K,labelMatch:W,descriptionMatch:re}=u(z,J,te,ne,X,Z);if(K===b)return n;ae+=K,W&&_.push(...W),re&&ge.push(...re)}return{score:ae,labelMatch:I(_),descriptionMatch:I(ge)}}function u(z,J,te,x,X,Z){if(X||!J){const[ae,_]=R(z,x.normalized,x.normalizedLowercase,Z&&!x.expectContiguousMatch);if(ae){const ge=(0,N.$Wj)(x.normalized,z);let ne;if(ge){ne=s;const K=Math.round(x.normalized.length/z.length*100);ne+=K}else ne=t;return{score:ne+ae,labelMatch:ge||v(_)}}}if(J){let ae=J;te&&(ae=`${J}${P.sep}`);const _=ae.length,ge=`${ae}${z}`,[ne,K]=R(ge,x.normalized,x.normalizedLowercase,Z&&!x.expectContiguousMatch);if(ne){const W=v(K),re=[],ye=[];return W.forEach(he=>{he.start<_&&he.end>_?(re.push({start:0,end:he.end-_}),ye.push({start:he.start,end:_})):he.start>=_?re.push({start:he.start-_,end:he.end-_}):ye.push(he)}),{score:ne,labelMatch:re,descriptionMatch:ye}}}return n}function v(z){const J=[];if(!z)return J;let te;for(const x of z)te&&te.end===x?te.end+=1:(te={start:x,end:x+1},J.push(te));return J}function I(z){const J=z.sort((X,Z)=>X.start-Z.start),te=[];let x;for(const X of J)!x||!$(x,X)?(x=X,te.push(X)):(x.start=Math.min(x.start,X.start),x.end=Math.max(x.end,X.end));return te}function $(z,J){return!(z.end<J.start||J.end<z.start)}function f(z,J,te,x,X,Z){const ae=o(z,te,x,X,Z),_=o(J,te,x,X,Z),ge=ae.score,ne=_.score;if((ge===r||ne===r)&&ge!==ne)return ge===r?-1:1;if(ge>t||ne>t){if(ge!==ne)return ge>ne?-1:1;if(ge<s&&ne<s){const ue=L(ae.labelMatch,_.labelMatch);if(ue!==0)return ue}const he=X.getItemLabel(z)||"",fe=X.getItemLabel(J)||"";if(he.length!==fe.length)return he.length-fe.length}if(ge!==ne)return ge>ne?-1:1;const K=Array.isArray(ae.labelMatch)&&ae.labelMatch.length>0,W=Array.isArray(_.labelMatch)&&_.labelMatch.length>0;if(K&&!W)return-1;if(W&&!K)return 1;const re=y(z,ae,X),ye=y(J,_,X);return re&&ye&&re!==ye?ye>re?-1:1:T(z,J,te,X)}e.$1q=f;function y(z,J,te){let x=-1,X=-1;if(J.descriptionMatch&&J.descriptionMatch.length?x=J.descriptionMatch[0].start:J.labelMatch&&J.labelMatch.length&&(x=J.labelMatch[0].start),J.labelMatch&&J.labelMatch.length){if(X=J.labelMatch[J.labelMatch.length-1].end,J.descriptionMatch&&J.descriptionMatch.length){const Z=te.getItemDescription(z);Z&&(X+=Z.length)}}else J.descriptionMatch&&J.descriptionMatch.length&&(X=J.descriptionMatch[J.descriptionMatch.length-1].end);return X-x}function L(z,J){if(!z&&!J||(!z||!z.length)&&(!J||!J.length))return 0;if(!J||!J.length)return-1;if(!z||!z.length)return 1;const te=z[0].start,X=z[z.length-1].end-te,Z=J[0].start,_=J[J.length-1].end-Z;return X===_?0:_<X?1:-1}function T(z,J,te,x){const X=x.getItemLabel(z)||"",Z=x.getItemLabel(J)||"",ae=x.getItemDescription(z),_=x.getItemDescription(J),ge=X.length+(ae?ae.length:0),ne=Z.length+(_?_.length:0);if(ge!==ne)return ge-ne;const K=x.getItemPath(z),W=x.getItemPath(J);return K&&W&&K.length!==W.length?K.length-W.length:X!==Z?(0,D.$Vq)(X,Z,te.normalized):ae&&_&&ae!==_?(0,D.$Vq)(ae,_,te.normalized):K&&W&&K!==W?(0,D.$Vq)(K,W,te.normalized):0}function U(z){return z.startsWith('"')&&z.endsWith('"')}const j=" ";function F(z){typeof z!="string"&&(z="");const J=z.toLowerCase(),{pathNormalized:te,normalized:x,normalizedLowercase:X}=M(z),Z=te.indexOf(P.sep)>=0,ae=U(z);let _;const ge=z.split(j);if(ge.length>1)for(const ne of ge){const K=U(ne),{pathNormalized:W,normalized:re,normalizedLowercase:ye}=M(ne);re&&(_||(_=[]),_.push({original:ne,originalLowercase:ne.toLowerCase(),pathNormalized:W,normalized:re,normalizedLowercase:ye,expectContiguousMatch:K}))}return{original:z,originalLowercase:J,pathNormalized:te,normalized:x,normalizedLowercase:X,values:_,containsPathSeparator:Z,expectContiguousMatch:ae}}e.$2q=F;function M(z){let J;A.$i?J=z.replace(/\//g,P.sep):J=z.replace(/\\/g,P.sep);const te=(0,p.$Xe)(J).replace(/\s|"/g,"");return{pathNormalized:J,normalized:te,normalizedLowercase:te.toLowerCase()}}function O(z){return Array.isArray(z)?F(z.map(J=>J.original).join(j)):F(z.original)}e.$3q=O}),define(ke[101],Se([1,0,17]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.$is=e.$hs=void 0,e.$hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},h={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(R){const C=(0,D.$oc)(R),w=N[C.toLowerCase()];return w!==void 0?w:A(R)}e.$is=P;function A(R){const C=(0,D.$oc)(R);return h[C.toLowerCase()]}e.$js=A;function p(R){for(const C in h)if(h[C]===R)return C}e.$ks=p;const b=/^(.+)\/(.+?)(;.+)?$/;function k(R,C){const w=b.exec(R);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:C?void 0:R}e.$ls=k}),define(ke[102],Se([1,0,11]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0;var N;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(N||(e.Source=N={}));var h;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(h||(e.TerminateResponseCode=h={}));function P(p,...b){const k=b.reduce((w,E)=>(w[E]=!0,w),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(w=>!k[w]).forEach(w=>{for(let E=0;E<R.length;E++)if(w.search(R[E])!==-1){delete p[w];break}})}e.$Tl=P;function A(p){p&&(delete p.DEBUG,D.$j&&delete p.DYLD_LIBRARY_PATH,D.$k&&delete p.LD_PRELOAD)}e.$Ul=A}),define(ke[2],Se([1,0,17,11]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const h=/^\w[\w\d+.-]*$/,P=/^\//,A=/^\/\//;function p(d,l){if(!d.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!h.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!P.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(d,l){return!d&&!l?"file":d}function k(d,l){switch(d){case"https":case"http":case"file":l?l[0]!==C&&(l=C+l):l=C;break}return l}const R="",C="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{static isUri(l){return l instanceof E?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,u,v,I,$,f=!1){typeof l=="object"?(this.scheme=l.scheme||R,this.authority=l.authority||R,this.path=l.path||R,this.query=l.query||R,this.fragment=l.fragment||R):(this.scheme=b(l,f),this.authority=u||R,this.path=k(this.scheme,v||R),this.query=I||R,this.fragment=$||R,p(this,f))}get fsPath(){return r(this,!1)}with(l){if(!l)return this;let{scheme:u,authority:v,path:I,query:$,fragment:f}=l;return u===void 0?u=this.scheme:u===null&&(u=R),v===void 0?v=this.authority:v===null&&(v=R),I===void 0?I=this.path:I===null&&(I=R),$===void 0?$=this.query:$===null&&($=R),f===void 0?f=this.fragment:f===null&&(f=R),u===this.scheme&&v===this.authority&&I===this.path&&$===this.query&&f===this.fragment?this:new m(u,v,I,$,f)}static parse(l,u=!1){const v=w.exec(l);return v?new m(v[2]||R,o(v[4]||R),o(v[5]||R),o(v[7]||R),o(v[9]||R),u):new m(R,R,R,R,R)}static file(l){let u=R;if(N.$i&&(l=l.replace(/\\/g,C)),l[0]===C&&l[1]===C){const v=l.indexOf(C,2);v===-1?(u=l.substring(2),l=C):(u=l.substring(2,v),l=l.substring(v)||C)}return new m("file",u,l,R,R)}static from(l,u){return new m(l.scheme,l.authority,l.path,l.query,l.fragment,u)}static joinPath(l,...u){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return N.$i&&l.scheme==="file"?v=E.file(D.$fc.join(r(l,!0),...u)).path:v=D.$gc.join(l.path,...u),l.with({path:v})}toString(l=!1){return s(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof E)return l;{const u=new m(l);return u._formatted=l.external??null,u._fsPath=l._sep===c?l.fsPath??null:null,u}}else return l}}e.URI=E;function S(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}e.$vc=S;const c=N.$i?1:void 0;class m extends E{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(l=!1){return l?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=c),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const a={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(d,l,u){let v,I=-1;for(let $=0;$<d.length;$++){const f=d.charCodeAt($);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||l&&f===47||u&&f===91||u&&f===93||u&&f===58)I!==-1&&(v+=encodeURIComponent(d.substring(I,$)),I=-1),v!==void 0&&(v+=d.charAt($));else{v===void 0&&(v=d.substr(0,$));const y=a[f];y!==void 0?(I!==-1&&(v+=encodeURIComponent(d.substring(I,$)),I=-1),v+=y):I===-1&&(I=$)}}return I!==-1&&(v+=encodeURIComponent(d.substring(I))),v!==void 0?v:d}function n(d){let l;for(let u=0;u<d.length;u++){const v=d.charCodeAt(u);v===35||v===63?(l===void 0&&(l=d.substr(0,u)),l+=a[v]):l!==void 0&&(l+=d[u])}return l!==void 0?l:d}function r(d,l){let u;return d.authority&&d.path.length>1&&d.scheme==="file"?u=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?l?u=d.path.substr(1):u=d.path[1].toLowerCase()+d.path.substr(2):u=d.path,N.$i&&(u=u.replace(/\//g,"\\")),u}e.$wc=r;function s(d,l){const u=l?n:i;let v="",{scheme:I,authority:$,path:f,query:y,fragment:L}=d;if(I&&(v+=I,v+=":"),($||I==="file")&&(v+=C,v+=C),$){let T=$.indexOf("@");if(T!==-1){const U=$.substr(0,T);$=$.substr(T+1),T=U.lastIndexOf(":"),T===-1?v+=u(U,!1,!1):(v+=u(U.substr(0,T),!1,!1),v+=":",v+=u(U.substr(T+1),!1,!0)),v+="@"}$=$.toLowerCase(),T=$.lastIndexOf(":"),T===-1?v+=u($,!1,!0):(v+=u($.substr(0,T),!1,!0),v+=$.substr(T))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const T=f.charCodeAt(1);T>=65&&T<=90&&(f=`/${String.fromCharCode(T+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const T=f.charCodeAt(0);T>=65&&T<=90&&(f=`${String.fromCharCode(T+32)}:${f.substr(2)}`)}v+=u(f,!0,!1)}return y&&(v+="?",v+=u(y,!1,!1)),L&&(v+="#",v+=l?L:i(L,!1,!1)),v}function t(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+t(d.substr(3)):d}}const g=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(d){return d.match(g)?d.replace(g,l=>t(l)):d}}),define(ke[185],Se([1,0,2]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$qq=e.$pq=e.$oq=void 0;function N(k){const R=k;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$oq=N;function h(k){const R=[];let C;try{const w=JSON.parse(k.arguments),E=w[w.length-1];E&&E.__$stack&&(w.pop(),C=E.__$stack),R.push(...w)}catch{R.push("Unable to log remote console arguments",k.arguments)}return{args:R,stack:C}}e.$pq=h;function P(k){if(typeof k!="string")return P(h(k).stack);const R=k;if(R){const C=A(R),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(w&&w.length===4)return{uri:D.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.$qq=P;function A(k){if(!k)return k;const R=k.indexOf(`
`);return R===-1?k:k.substring(0,R)}function p(k,R){const{args:C,stack:w}=h(k),E=typeof C[0]=="string"&&C.length===1;let S=A(w);S&&(S=`(${S.trim()})`);let c=[];if(typeof C[0]=="string"?S&&E?c=[`%c[${R}] %c${C[0]} %c${S}`,b("blue"),b(""),b("grey")]:c=[`%c[${R}] %c${C[0]}`,b("blue"),b(""),...C.slice(1)]:c=[`%c[${R}]%`,b("blue"),...C],S&&!E&&c.push(S),typeof console[k.severity]!="function")throw new Error("Unknown console method");console[k.severity].apply(console,c)}e.log=p;function b(k){return`color: ${k}`}}),define(ke[56],Se([1,0,21,2]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=void 0;function h(b){return JSON.stringify(b,A)}e.$Ch=h;function P(b){let k=JSON.parse(b);return k=p(k),k}e.$Dh=P;function A(b,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function p(b,k=0){if(!b||k>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return N.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 17:return new Date(b.source)}if(b instanceof D.$ke||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let R=0;R<b.length;++R)b[R]=p(b[R],k+1);else for(const R in b)Object.hasOwnProperty.call(b,R)&&(b[R]=p(b[R],k+1))}return b}e.$Eh=p}),define(ke[16],Se([1,0,14,11,12,2]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.Schemas=void 0;var A;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={}));function p(w,E){return P.URI.isUri(w)?(0,h.$af)(w.scheme,E):(0,h.$bf)(w,E+":")}e.$fg=p;function b(w,...E){return E.some(S=>p(w,S))}e.$gg=b,e.$hg="vscode-tkn",e.$ig="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(E){this.d=E}setDelegate(E){this.e=E}setServerRootPath(E){this.f=`${E}/${A.vscodeRemoteResource}`}set(E,S,c){this.a[E]=S,this.b[E]=c}setConnectionToken(E,S){this.c[E]=S}getPreferredWebSchema(){return this.d}rewrite(E){if(this.e)try{return this.e(E)}catch(n){return D.$1(n),E}const S=E.authority;let c=this.a[S];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const m=this.b[S],a=this.c[S];let i=`path=${encodeURIComponent(E.path)}`;return typeof a=="string"&&(i+=`&${e.$ig}=${encodeURIComponent(a)}`),P.URI.from({scheme:N.$o?this.d:A.vscodeRemoteResource,authority:`${c}:${m}`,path:this.f,query:i})}}e.$jg=new k,e.$kg="vs/../../extensions",e.$lg="vs/../../node_modules",e.$mg="vs/../../node_modules.asar",e.$ng="vs/../../node_modules.asar.unpacked",e.$og="vscode-app";class R{static{this.a=e.$og}asBrowserUri(E){const S=this.b(E,$e);return this.uriToBrowserUri(S)}uriToBrowserUri(E){return E.scheme===A.vscodeRemote?e.$jg.rewrite(E):E.scheme===A.file&&(N.$m||N.$q===`${A.vscodeFileResource}://${R.a}`)?E.with({scheme:A.vscodeFileResource,authority:E.authority||R.a,query:null,fragment:null}):E}asFileUri(E){const S=this.b(E,$e);return this.uriToFileUri(S)}uriToFileUri(E){return E.scheme===A.vscodeFileResource?E.with({scheme:A.file,authority:E.authority!==R.a?E.authority:null,query:null,fragment:null}):E}b(E,S){return P.URI.isUri(E)?E:P.URI.parse(S.toUrl(E))}}e.$pg=new R;var C;(function(w){const E=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(E.get("3"));const S="vscode-coi";function c(a){let i;typeof a=="string"?i=new URL(a).searchParams:a instanceof URL?i=a.searchParams:P.URI.isUri(a)&&(i=new URL(a.toString(!0)).searchParams);const n=i?.get(S);if(n)return E.get(n)}w.getHeadersFromQuery=c;function m(a,i,n){if(!globalThis.crossOriginIsolated)return;const r=i&&n?"3":n?"2":"1";a instanceof URLSearchParams?a.set(S,r):a[S]=r}w.addSearchParam=m})(C||(e.COI=C={}))}),define(ke[186],Se([1,0,157,16,11,2]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jD=void 0;class A{constructor(w,E,S){this.id=w,this.dependencies=E,this.callback=S}}class p{static{this.INSTANCE=new p}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,E,S)=>{typeof w!="string"&&(S=E,E=w,w=null),(typeof E!="object"||!Array.isArray(E))&&(S=E,E=null),this.c.push(new A(w,E,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const E=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!E)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(E.dependencies)&&E.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${E.dependencies.join(", ")}`);return typeof E.callback=="function"?E.callback([]):E.callback}h(w){return new Promise((E,S)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const m=()=>{c.removeEventListener("load",a),c.removeEventListener("error",i)},a=n=>{m(),E(this.c.pop())},i=n=>{m(),S(n)};c.addEventListener("load",a),c.addEventListener("error",i),this.f&&(w=this.f.createScriptURL(w)),c.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(w){return new Promise((E,S)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),E(this.c.pop())}catch(c){S(c)}})}async j(w){try{const E=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,m=P.URI.parse(w).fsPath,a=E.readFileSync(m).toString(),i=c.wrap(a.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(E){throw E}}}const b=new Map;let k={};typeof globalThis.require=="object"&&(k=globalThis.require.paths??{});async function R(C,w,E){if(D.$T){E===void 0&&(E=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),k[C]&&(C=k[C]);const S=`${C}/${w}`;if(b.has(S))return b.get(S);let c;if(/^\w[\w\d+.-]*:\/\//.test(S))c=S;else{const n=`${E&&!h.$o?N.$mg:N.$lg}/${S}`;c=N.$pg.asBrowserUri(n).toString(!0)}const m=p.INSTANCE.load(c);return b.set(S,m),m}else return await new Promise((S,c)=>{$e([C],S,c)})}e.$jD=R}),define(ke[23],Se([1,0,34,16,17,11,12,2]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.DataUri=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=void 0;function b(E){return(0,p.$wc)(E,!0)}e.$wg=b;class k{constructor(S){this.a=S}compare(S,c,m=!1){return S===c?0:(0,A.$6e)(this.getComparisonKey(S,m),this.getComparisonKey(c,m))}isEqual(S,c,m=!1){return S===c?!0:!S||!c?!1:this.getComparisonKey(S,m)===this.getComparisonKey(c,m)}getComparisonKey(S,c=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,c,m=!1){if(S.scheme===c.scheme){if(S.scheme===N.Schemas.file)return D.$9f(b(S),b(c),this.a(S))&&S.query===c.query&&(m||S.fragment===c.fragment);if((0,e.$Ng)(S.authority,c.authority))return D.$9f(S.path,c.path,this.a(S),"/")&&S.query===c.query&&(m||S.fragment===c.fragment)}return!1}joinPath(S,...c){return p.URI.joinPath(S,...c)}basenameOrAuthority(S){return(0,e.$Fg)(S)||S.authority}basename(S){return h.$gc.basename(S.path)}extname(S){return h.$gc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let c;return S.scheme===N.Schemas.file?c=p.URI.file(h.$mc(b(S))).path:(c=h.$gc.dirname(S.path),S.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),c="/")),S.with({path:c})}normalizePath(S){if(!S.path.length)return S;let c;return S.scheme===N.Schemas.file?c=p.URI.file(h.$hc(b(S))).path:c=h.$gc.normalize(S.path),S.with({path:c})}relativePath(S,c){if(S.scheme!==c.scheme||!(0,e.$Ng)(S.authority,c.authority))return;if(S.scheme===N.Schemas.file){const i=h.$lc(b(S),b(c));return P.$i?D.$3f(i):i}let m=S.path||"/";const a=c.path||"/";if(this.a(S)){let i=0;for(const n=Math.min(m.length,a.length);i<n&&!(m.charCodeAt(i)!==a.charCodeAt(i)&&m.charAt(i).toLowerCase()!==a.charAt(i).toLowerCase());i++);m=a.substr(0,i)+m.substr(i)}return h.$gc.relative(m,a)}resolvePath(S,c){if(S.scheme===N.Schemas.file){const m=p.URI.file(h.$kc(b(S),c));return S.with({authority:m.authority,path:m.path})}return c=D.$4f(c),S.with({path:h.$gc.resolve(S.path,c)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,c){return S===c||S!==void 0&&c!==void 0&&(0,A.$af)(S,c)}hasTrailingPathSeparator(S,c=h.sep){if(S.scheme===N.Schemas.file){const m=b(S);return m.length>D.$5f(m).length&&m[m.length-1]===c}else{const m=S.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,c=h.sep){return(0,e.$Og)(S,c)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,c=h.sep){let m=!1;if(S.scheme===N.Schemas.file){const a=b(S);m=a!==void 0&&a.length===D.$5f(a).length&&a[a.length-1]===c}else{c="/";const a=S.path;m=a.length===1&&a.charCodeAt(a.length-1)===47}return!m&&!(0,e.$Og)(S,c)?S.with({path:S.path+"/"}):S}}e.$xg=k,e.$yg=new k(()=>!1),e.$zg=new k(E=>E.scheme===N.Schemas.file?!P.$k:!0),e.$Ag=new k(E=>!0),e.$Bg=e.$yg.isEqual.bind(e.$yg),e.$Cg=e.$yg.isEqualOrParent.bind(e.$yg),e.$Dg=e.$yg.getComparisonKey.bind(e.$yg),e.$Eg=e.$yg.basenameOrAuthority.bind(e.$yg),e.$Fg=e.$yg.basename.bind(e.$yg),e.$Gg=e.$yg.extname.bind(e.$yg),e.$Hg=e.$yg.dirname.bind(e.$yg),e.$Ig=e.$yg.joinPath.bind(e.$yg),e.$Jg=e.$yg.normalizePath.bind(e.$yg),e.$Kg=e.$yg.relativePath.bind(e.$yg),e.$Lg=e.$yg.resolvePath.bind(e.$yg),e.$Mg=e.$yg.isAbsolutePath.bind(e.$yg),e.$Ng=e.$yg.isEqualAuthority.bind(e.$yg),e.$Og=e.$yg.hasTrailingPathSeparator.bind(e.$yg),e.$Pg=e.$yg.removeTrailingPathSeparator.bind(e.$yg),e.$Qg=e.$yg.addTrailingPathSeparator.bind(e.$yg);function R(E,S){const c=[];for(let m=0;m<E.length;m++){const a=S(E[m]);E.some((i,n)=>n===m?!1:(0,e.$Cg)(a,S(i)))||c.push(E[m])}return c}e.$Rg=R;var C;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function S(c){const m=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(n=>{const[r,s]=n.split(":");r&&s&&m.set(r,s)});const i=c.path.substring(0,c.path.indexOf(";"));return i&&m.set(E.META_DATA_MIME,i),m}E.parseMetaData=S})(C||(e.DataUri=C={}));function w(E,S,c){if(S){let m=E.path;return m&&m[0]!==h.$gc.sep&&(m=h.$gc.sep+m),E.with({scheme:c,authority:S,path:m})}return E.with({scheme:c})}e.$Sg=w}),define(ke[8],Se([1,0,22,14,4,3,23,11,163,43]),function($e,e,D,N,h,P,A,p,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.Promises=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0;function R(me){return!!me&&typeof me.then=="function"}e.$Tg=R;function C(me){const V=new D.$7d,Y=me(V.token),de=new Promise((we,Pe)=>{const ve=V.token.onCancellationRequested(()=>{ve.dispose(),Pe(new N.$5)});Promise.resolve(Y).then(Ce=>{ve.dispose(),V.dispose(),we(Ce)},Ce=>{ve.dispose(),V.dispose(),Pe(Ce)})});return new class{cancel(){V.cancel(),V.dispose()}then(we,Pe){return de.then(we,Pe)}catch(we){return this.then(void 0,we)}finally(we){return de.finally(we)}}}e.$Ug=C;function w(me,V,Y){return new Promise((de,we)=>{const Pe=V.onCancellationRequested(()=>{Pe.dispose(),de(Y)});me.then(de,we).finally(()=>Pe.dispose())})}e.$Vg=w;function E(me,V){return new Promise((Y,de)=>{const we=V.onCancellationRequested(()=>{we.dispose(),de(new N.$5)});me.then(Y,de).finally(()=>we.dispose())})}e.$Wg=E;async function S(me){let V=-1;const Y=me.map((de,we)=>de.then(Pe=>(V=we,Pe)));try{return await Promise.race(Y)}finally{me.forEach((de,we)=>{we!==V&&de.cancel()})}}e.$Xg=S;function c(me,V,Y){let de;const we=setTimeout(()=>{de?.(void 0),Y?.()},V);return Promise.race([me.finally(()=>clearTimeout(we)),new Promise(Pe=>de=Pe)])}e.$Yg=c;function m(me){return new Promise((V,Y)=>{const de=me();R(de)?de.then(V,Y):V(de)})}e.$Zg=m;function a(){let me,V;return{promise:new Promise((de,we)=>{me=de,V=we}),resolve:me,reject:V}}e.$1g=a;class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(V){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=V,!this.b){const Y=()=>{if(this.b=null,this.f)return;const de=this.queue(this.d);return this.d=null,de};this.b=new Promise(de=>{this.a.then(Y,Y).then(de)})}return new Promise((Y,de)=>{this.b.then(Y,de)})}return this.a=V(),new Promise((Y,de)=>{this.a.then(we=>{this.a=null,Y(we)},we=>{this.a=null,de(we)})})}dispose(){this.f=!0}}e.$2g=i;class n{constructor(){this.a=Promise.resolve(null)}queue(V){return this.a=this.a.then(()=>V(),()=>V())}}e.$3g=n;class r{constructor(){this.a=new Map}queue(V,Y){const we=(this.a.get(V)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(V)===we&&this.a.delete(V)});return this.a.set(V,we),we}}e.$4g=r;const s=(me,V)=>{let Y=!0;const de=setTimeout(()=>{Y=!1,V()},me);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(de),Y=!1}}},t=me=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,me())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};class g{constructor(V){this.defaultDelay=V,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(V,Y=this.defaultDelay){this.g=V,this.h(),this.b||(this.b=new Promise((we,Pe)=>{this.d=we,this.f=Pe}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const de=()=>{this.a=null,this.d?.(null)};return this.a=Y===b.$Td?t(de):s(Y,de),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$5g=g;class o{constructor(V){this.a=new g(V),this.b=new i}trigger(V,Y){return this.a.trigger(()=>this.b.queue(V),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$6g=o;class d{constructor(){this.a=!1,this.b=new Promise((V,Y)=>{this.d=V})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$7g=d;class l extends d{constructor(V){super(),this.f=setTimeout(()=>this.open(),V)}open(){clearTimeout(this.f),super.open()}}e.$8g=l;function u(me,V){return V?new Promise((Y,de)=>{const we=setTimeout(()=>{Pe.dispose(),Y()},me),Pe=V.onCancellationRequested(()=>{clearTimeout(we),Pe.dispose(),de(new N.$5)})}):C(Y=>u(me,Y))}e.$9g=u;function v(me,V=0,Y){const de=setTimeout(()=>{me(),Y&&we.dispose()},V),we=(0,P.$Rc)(()=>{clearTimeout(de),Y?.deleteAndLeak(we)});return Y?.add(we),we}e.$0g=v;function I(me){const V=[];let Y=0;const de=me.length;function we(){return Y<de?me[Y++]():null}function Pe(ve){ve!=null&&V.push(ve);const Ce=we();return Ce?Ce.then(Pe):Promise.resolve(V)}return Promise.resolve(null).then(Pe)}e.$$g=I;function $(me,V=de=>!!de,Y=null){let de=0;const we=me.length,Pe=()=>{if(de>=we)return Promise.resolve(Y);const ve=me[de++];return Promise.resolve(ve()).then(B=>V(B)?Promise.resolve(B):Pe())};return Pe()}e.$_g=$;function f(me,V=de=>!!de,Y=null){if(me.length===0)return Promise.resolve(Y);let de=me.length;const we=()=>{de=-1;for(const Pe of me)Pe.cancel?.()};return new Promise((Pe,ve)=>{for(const Ce of me)Ce.then(B=>{--de>=0&&V(B)?(we(),Pe(B)):de===0&&Pe(Y)}).catch(B=>{--de>=0&&(we(),ve(B))})})}e.$ah=f;class y{constructor(V){this.a=0,this.b=!1,this.f=V,this.g=[],this.d=0,this.h=new h.$Wd}whenIdle(){return this.size>0?h.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(V){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,de)=>{this.g.push({factory:V,c:Y,e:de}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const V=this.g.shift();this.d++;const Y=V.factory();Y.then(V.c,V.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$bh=y;class L extends y{constructor(){super(1)}}e.$ch=L;class T{constructor(){this.a=new Z,this.b=0}queue(V){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,V())):this.a.run(this.b++,V())}}e.$dh=T;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const V=new ge;return this.b.add(V),V.p}g(){for(const[,V]of this.a)if(V.size>0)return!1;return!0}queueSize(V,Y=A.$yg){const de=Y.getComparisonKey(V);return this.a.get(de)?.size??0}queueFor(V,Y,de=A.$yg){const we=de.getComparisonKey(V);let Pe=this.a.get(we);if(!Pe){Pe=new L;const ve=this.f++,Ce=h.Event.once(Pe.onDrained)(()=>{Pe?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new P.$3c),this.d.set(ve,Ce),this.a.set(we,Pe)}return Pe.queue(Y)}h(){this.g()&&this.j()}j(){for(const V of this.b)V.complete();this.b.clear()}dispose(){for(const[,V]of this.a)V.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$eh=U;class j{constructor(V,Y){this.a=-1,typeof V=="function"&&typeof Y=="number"&&this.setIfNotSet(V,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(V,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,V()},Y)}setIfNotSet(V,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,V()},Y))}}e.$fh=j;class F{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(V,Y,de=globalThis){this.cancel();const we=de.setInterval(()=>{V()},Y);this.d=(0,P.$Rc)(()=>{de.clearInterval(we),this.d=void 0})}dispose(){this.cancel()}}e.$gh=F;class M{constructor(V,Y){this.b=-1,this.a=V,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(V=this.d){this.cancel(),this.b=setTimeout(this.f,V)}get delay(){return this.d}set delay(V){this.d=V}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$hh=M;class O{constructor(V,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=V,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(V=this.b){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(V/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ih=O;class z extends M{constructor(V,Y){super(V,Y),this.j=[]}work(V){this.j.push(V),this.isScheduled()||this.schedule()}h(){const V=this.j;this.j=[],this.a?.(V)}dispose(){this.j=[],super.dispose()}}e.$jh=z;class J extends P.$Tc{constructor(V,Y){super(),this.g=V,this.h=Y,this.a=[],this.b=this.B(new P.$Uc),this.f=!1}get pending(){return this.a.length}work(V){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+V.length>this.g.maxBufferedWork)return!1}else if(this.pending+V.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of V)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$kh=J,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$mh=(me,V)=>{(0,p.$B)(()=>{if(Y)return;const de=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$mh=(me,V,Y)=>{const de=me.requestIdleCallback(V,typeof Y=="number"?{timeout:Y}:void 0);let we=!1;return{dispose(){we||(we=!0,me.cancelIdleCallback(de))}}},e.$lh=me=>(0,e.$mh)(globalThis,me)}();class te{constructor(V,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(de){this.l=de}finally{this.g=!0}},this.f=(0,e.$mh)(V,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$nh=te;class x extends te{constructor(V){super(globalThis,V)}}e.$oh=x;async function X(me,V,Y){let de;for(let we=0;we<Y;we++)try{return await me()}catch(Pe){de=Pe,await u(V)}throw de}e.$ph=X;class Z{isRunning(V){return typeof V=="number"?this.a?.taskId===V:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(V,Y,de){return this.a={taskId:V,cancel:()=>de?.(),promise:Y},Y.then(()=>this.d(V),()=>this.d(V)),Y}d(V){this.a&&V===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const V=this.b;this.b=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}queue(V){if(this.b)this.b.run=V;else{const{promise:Y,resolve:de,reject:we}=a();this.b={run:V,promise:Y,promiseResolve:de,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$qh=Z;class ae{constructor(V,Y=()=>Date.now()){this.d=V,this.f=Y,this.a=0,this.b=0}increment(){const V=this.f();return V-this.a>this.d&&(this.a=V,this.b=0),this.b++,this.b}}e.$rh=ae;var _;(function(me){me[me.Resolved=0]="Resolved",me[me.Rejected=1]="Rejected"})(_||(_={}));class ge{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((V,Y)=>{this.a=V,this.b=Y})}complete(V){return new Promise(Y=>{this.a(V),this.d={outcome:0,value:V},Y()})}error(V){return new Promise(Y=>{this.b(V),this.d={outcome:1,value:V},Y()})}cancel(){return this.error(new N.$5)}}e.$sh=ge;var ne;(function(me){async function V(de){let we;const Pe=await Promise.all(de.map(ve=>ve.then(Ce=>Ce,Ce=>{we||(we=Ce)})));if(typeof we<"u")throw we;return Pe}me.settled=V;function Y(de){return new Promise(async(we,Pe)=>{try{await de(we,Pe)}catch(ve){Pe(ve)}})}me.withAsyncBody=Y})(ne||(e.Promises=ne={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(V){this.a=void 0,this.b=void 0,this.d=!1,this.promise=V.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$th=K;class W{constructor(V){this.b=V,this.a=new k.$V(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$uh=W;var re;(function(me){me[me.Initial=0]="Initial",me[me.DoneOK=1]="DoneOK",me[me.DoneError=2]="DoneError"})(re||(re={}));class ye{static fromArray(V){return new ye(Y=>{Y.emitMany(V)})}static fromPromise(V){return new ye(async Y=>{Y.emitMany(await V)})}static fromPromises(V){return new ye(async Y=>{await Promise.all(V.map(async de=>Y.emitOne(await de)))})}static merge(V){return new ye(async Y=>{await Promise.all(V.map(async de=>{for await(const we of de)Y.emitOne(we)}))})}static{this.EMPTY=ye.fromArray([])}constructor(V){this.a=0,this.b=[],this.d=null,this.f=new h.$Wd,queueMicrotask(async()=>{const Y={emitOne:de=>this.g(de),emitMany:de=>this.h(de),reject:de=>this.k(de)};try{await Promise.resolve(V(Y)),this.j()}catch(de){this.k(de)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(V<this.b.length)return{done:!1,value:this.b[V++]};if(this.a===1)return{done:!0,value:void 0};await h.Event.toPromise(this.f.event)}while(!0)}}}static map(V,Y){return new ye(async de=>{for await(const we of V)de.emitOne(Y(we))})}map(V){return ye.map(this,V)}static filter(V,Y){return new ye(async de=>{for await(const we of V)Y(we)&&de.emitOne(we)})}filter(V){return ye.filter(this,V)}static coalesce(V){return ye.filter(V,Y=>!!Y)}coalesce(){return ye.coalesce(this)}static async toPromise(V){const Y=[];for await(const de of V)Y.push(de);return Y}toPromise(){return ye.toPromise(this)}g(V){this.a===0&&(this.b.push(V),this.f.fire())}h(V){this.a===0&&(this.b=this.b.concat(V),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(V){this.a===0&&(this.a=2,this.d=V,this.f.fire())}}e.$vh=ye;class he extends ye{constructor(V,Y){super(Y),this.l=V}cancel(){this.l.cancel()}}e.$wh=he;function fe(me){const V=new D.$7d,Y=me(V.token);return new he(V,async de=>{const we=V.token.onCancellationRequested(()=>{we.dispose(),V.dispose(),de.reject(new N.$5)});try{for await(const Pe of Y){if(V.token.isCancellationRequested)return;de.emitOne(Pe)}we.dispose(),V.dispose()}catch(Pe){we.dispose(),V.dispose(),de.reject(Pe)}})}e.$xh=fe;class ue{constructor(){this.a=new ge,this.b=new ye(de=>{if(V){de.reject(V);return}return Y&&de.emitMany(Y),this.d=we=>de.reject(we),this.f=we=>de.emitOne(we),this.a.p});let V,Y;this.f=de=>{Y||(Y=[]),Y.push(de)},this.d=de=>{V||(V=de)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(V){this.d(V),this.a.complete()}emitOne(V){this.f(V)}}e.$yh=ue}),define(ke[35],Se([1,0,19,8,34,28,17,11,12]),function($e,e,D,N,h,P,A,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=void 0;function k(){return Object.create(null)}e.$Jj=k,e.$Kj="**",e.$Lj="/";const R="[/\\\\]",C="[^/\\\\]",w=/\//g;function E(te,x){switch(te){case 0:return"";case 1:return`${C}*?`;default:return`(?:${R}|${C}+${R}${x?`|${R}${C}+`:""})*?`}}function S(te,x){if(!te)return[];const X=[];let Z=!1,ae=!1,_="";for(const ge of te){switch(ge){case x:if(!Z&&!ae){X.push(_),_="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}_+=ge}return _&&X.push(_),X}e.$Mj=S;function c(te){if(!te)return"";let x="";const X=S(te,e.$Lj);if(X.every(Z=>Z===e.$Kj))x=".*";else{let Z=!1;X.forEach((ae,_)=>{if(ae===e.$Kj){if(Z)return;x+=E(2,_===X.length-1)}else{let ge=!1,ne="",K=!1,W="";for(const re of ae){if(re!=="}"&&ge){ne+=re;continue}if(K&&(re!=="]"||!W)){let ye;re==="-"?ye=re:(re==="^"||re==="!")&&!W?ye="^":re===e.$Lj?ye="":ye=(0,b.$Pe)(re),W+=ye;continue}switch(re){case"{":ge=!0;continue;case"[":K=!0;continue;case"}":{const he=`(?:${S(ne,",").map(fe=>c(fe)).join("|")})`;x+=he,ge=!1,ne="";break}case"]":{x+="["+W+"]",K=!1,W="";break}case"?":x+=C;continue;case"*":x+=E(1);continue;default:x+=(0,b.$Pe)(re)}}_<X.length-1&&(X[_+1]!==e.$Kj||_+2<X.length)&&(x+=R)}Z=ae===e.$Kj})}return x}const m=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.$Dc(1e4),g=function(){return!1},o=function(){return null};function d(te,x){if(!te)return o;let X;typeof te!="string"?X=te.pattern:X=te,X=X.trim();const Z=`${X}_${!!x.trimForExclusions}`;let ae=t.get(Z);if(ae)return l(ae,te);let _;return m.test(X)?ae=v(X.substr(4),X):(_=a.exec(u(X,x)))?ae=I(_[1],X):(x.trimForExclusions?n:i).test(X)?ae=$(X,x):(_=r.exec(u(X,x)))?ae=f(_[1].substr(1),X,!0):(_=s.exec(u(X,x)))?ae=f(_[1],X,!1):ae=y(X),t.set(Z,ae),l(ae,te)}function l(te,x){if(typeof x=="string")return te;const X=function(Z,ae){return(0,h.$9f)(Z,x.base,!p.$k)?te((0,b.$Ue)(Z.substr(x.base.length),A.sep),ae):null};return X.allBasenames=te.allBasenames,X.allPaths=te.allPaths,X.basenames=te.basenames,X.patterns=te.patterns,X}function u(te,x){return x.trimForExclusions&&te.endsWith("/**")?te.substr(0,te.length-2):te}function v(te,x){return function(X,Z){return typeof X=="string"&&X.endsWith(te)?x:null}}function I(te,x){const X=`/${te}`,Z=`\\${te}`,ae=function(ge,ne){return typeof ge!="string"?null:ne?ne===te?x:null:ge===te||ge.endsWith(X)||ge.endsWith(Z)?x:null},_=[te];return ae.basenames=_,ae.patterns=[x],ae.allBasenames=_,ae}function $(te,x){const X=z(te.slice(1,-1).split(",").map(ne=>d(ne,x)).filter(ne=>ne!==o),te),Z=X.length;if(!Z)return o;if(Z===1)return X[0];const ae=function(ne,K){for(let W=0,re=X.length;W<re;W++)if(X[W](ne,K))return te;return null},_=X.find(ne=>!!ne.allBasenames);_&&(ae.allBasenames=_.allBasenames);const ge=X.reduce((ne,K)=>K.allPaths?ne.concat(K.allPaths):ne,[]);return ge.length&&(ae.allPaths=ge),ae}function f(te,x,X){const Z=A.sep===A.$gc.sep,ae=Z?te:te.replace(w,A.sep),_=A.sep+ae,ge=A.$gc.sep+te;let ne;return X?ne=function(K,W){return typeof K=="string"&&(K===ae||K.endsWith(_)||!Z&&(K===te||K.endsWith(ge)))?x:null}:ne=function(K,W){return typeof K=="string"&&(K===ae||!Z&&K===te)?x:null},ne.allPaths=[(X?"*/":"./")+te],ne}function y(te){try{const x=new RegExp(`^${c(te)}$`);return function(X){return x.lastIndex=0,typeof X=="string"&&x.test(X)?te:null}}catch{return o}}function L(te,x,X){return!te||typeof x!="string"?!1:T(te)(x,void 0,X)}e.$Nj=L;function T(te,x={}){if(!te)return g;if(typeof te=="string"||U(te)){const X=d(te,x);if(X===o)return g;const Z=function(ae,_){return!!X(ae,_)};return X.allBasenames&&(Z.allBasenames=X.allBasenames),X.allPaths&&(Z.allPaths=X.allPaths),Z}return M(te,x)}e.$Oj=T;function U(te){const x=te;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.$Pj=U;function j(te){return te.allBasenames||[]}e.$Qj=j;function F(te){return te.allPaths||[]}e.$Rj=F;function M(te,x){const X=z(Object.getOwnPropertyNames(te).map(ne=>O(ne,te[ne],x)).filter(ne=>ne!==o)),Z=X.length;if(!Z)return o;if(!X.some(ne=>!!ne.requiresSiblings)){if(Z===1)return X[0];const ne=function(re,ye){let he;for(let fe=0,ue=X.length;fe<ue;fe++){const me=X[fe](re,ye);if(typeof me=="string")return me;(0,N.$Tg)(me)&&(he||(he=[]),he.push(me))}return he?(async()=>{for(const fe of he){const ue=await fe;if(typeof ue=="string")return ue}return null})():null},K=X.find(re=>!!re.allBasenames);K&&(ne.allBasenames=K.allBasenames);const W=X.reduce((re,ye)=>ye.allPaths?re.concat(ye.allPaths):re,[]);return W.length&&(ne.allPaths=W),ne}const ae=function(ne,K,W){let re,ye;for(let he=0,fe=X.length;he<fe;he++){const ue=X[he];ue.requiresSiblings&&W&&(K||(K=(0,A.$nc)(ne)),re||(re=K.substr(0,K.length-(0,A.$oc)(ne).length)));const me=ue(ne,K,re,W);if(typeof me=="string")return me;(0,N.$Tg)(me)&&(ye||(ye=[]),ye.push(me))}return ye?(async()=>{for(const he of ye){const fe=await he;if(typeof fe=="string")return fe}return null})():null},_=X.find(ne=>!!ne.allBasenames);_&&(ae.allBasenames=_.allBasenames);const ge=X.reduce((ne,K)=>K.allPaths?ne.concat(K.allPaths):ne,[]);return ge.length&&(ae.allPaths=ge),ae}function O(te,x,X){if(x===!1)return o;const Z=d(te,X);if(Z===o)return o;if(typeof x=="boolean")return Z;if(x){const ae=x.when;if(typeof ae=="string"){const _=(ge,ne,K,W)=>{if(!W||!Z(ge,ne))return null;const re=ae.replace("$(basename)",()=>K),ye=W(re);return(0,N.$Tg)(ye)?ye.then(he=>he?te:null):ye?te:null};return _.requiresSiblings=!0,_}}return Z}function z(te,x){const X=te.filter(ne=>!!ne.basenames);if(X.length<2)return te;const Z=X.reduce((ne,K)=>{const W=K.basenames;return W?ne.concat(W):ne},[]);let ae;if(x){ae=[];for(let ne=0,K=Z.length;ne<K;ne++)ae.push(x)}else ae=X.reduce((ne,K)=>{const W=K.patterns;return W?ne.concat(W):ne},[]);const _=function(ne,K){if(typeof ne!="string")return null;if(!K){let re;for(re=ne.length;re>0;re--){const ye=ne.charCodeAt(re-1);if(ye===47||ye===92)break}K=ne.substr(re)}const W=Z.indexOf(K);return W!==-1?ae[W]:null};_.basenames=Z,_.patterns=ae,_.allBasenames=Z;const ge=te.filter(ne=>!ne.basenames);return ge.push(_),ge}function J(te,x){return(0,D.$ub)(te,x,(X,Z)=>typeof X=="string"&&typeof Z=="string"?X===Z:typeof X!="string"&&typeof Z!="string"?X.base===Z.base&&X.pattern===Z.pattern:!1)}e.$Sj=J}),define(ke[80],Se([1,0,14,164,23,12,2]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.MarkdownStringTextNewlineStyle=void 0;var p;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class b{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,D.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=w(this.supportThemeIcons?(0,N.$dk)(i):i).replace(/([ \t]+)/g,(r,s)=>"&nbsp;".repeat(s.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${E(n,i)}
`,this}appendLink(i,n,r){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(i,n){const r=new RegExp((0,P.$Pe)(n),"g");return i.replace(r,(s,t)=>i.charAt(t-1)!=="\\"?`\\${s}`:s)}}e.$jk=b;function k(a){return R(a)?!a.value:Array.isArray(a)?a.every(k):!0}e.$kk=k;function R(a){return a instanceof b?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.$lk=R;function C(a,i){return a===i?!0:!a||!i?!1:a.value===i.value&&a.isTrusted===i.isTrusted&&a.supportThemeIcons===i.supportThemeIcons&&a.supportHtml===i.supportHtml&&(a.baseUri===i.baseUri||!!a.baseUri&&!!i.baseUri&&(0,h.$Bg)(A.URI.from(a.baseUri),A.URI.from(i.baseUri)))}e.$mk=C;function w(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$nk=w;function E(a,i){const n=a.match(/^`+/gm)?.reduce((s,t)=>s.length>t.length?s:t).length??0,r=n>=3?n+1:3;return[`${"`".repeat(r)}${i}`,a,`${"`".repeat(r)}`].join(`
`)}e.$ok=E;function S(a){return a.replace(/"/g,"&quot;")}e.$pk=S;function c(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$qk=c;function m(a){const i=[],n=a.split("|").map(s=>s.trim());a=n[0];const r=n[1];if(r){const s=/height=(\d+)/.exec(r),t=/width=(\d+)/.exec(r),g=s?s[1]:"",o=t?t[1]:"",d=isFinite(parseInt(o)),l=isFinite(parseInt(g));d&&i.push(`width="${o}"`),l&&i.push(`height="${g}"`)}return{href:a,dimensions:i}}e.$rk=m}),define(ke[103],Se([1,0,19,34,17,11,23,12]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=void 0;function b(d,l){const{os:u,tildify:v,relative:I}=l;if(I){const y=k(d,I,u);if(typeof y=="string")return y}let $=d.fsPath;if(u===1&&!P.$i?$=$.replace(/\//g,"\\"):u!==1&&P.$i&&($=$.replace(/\\/g,"/")),u!==1&&v?.userHome){const y=v.userHome.fsPath;let L;d.scheme!==v.userHome.scheme&&d.path[0]===h.$gc.sep&&d.path[1]!==h.$gc.sep?L=v.userHome.with({path:d.path}).fsPath:L=$,$=w(L,y,u)}return(u===1?h.$fc:h.$gc).normalize(R($,u===1))}e.$Xv=b;function k(d,l,u){const v=u===1?h.$fc:h.$gc,I=u===3?A.$yg:A.$Ag,$=l.getWorkspace(),f=(0,D.$Ob)($.folders);if(!f)return;d.scheme!==f.uri.scheme&&d.path[0]===h.$gc.sep&&d.path[1]!==h.$gc.sep&&(d=f.uri.with({path:d.path}));const y=l.getWorkspaceFolder(d);if(!y)return;let L;if(I.isEqual(y.uri,d)?L="":L=I.relativePath(y.uri,d)??"",L&&(L=v.normalize(L)),$.folders.length>1&&!l.noPrefix){const T=y.name?y.name:I.basenameOrAuthority(y.uri);L=L?`${T} \u2022 ${L}`:T}return L}function R(d,l=P.$i){return(0,N.$ag)(d,l)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$Yv=R;let C=Object.create(null);function w(d,l,u=P.OS){if(u===1||!d||!l)return d;let v=C.original===l?C.normalized:void 0;v||(v=l,P.$i&&(v=(0,N.$3f)(v)),v=`${(0,p.$Ve)(v,h.$gc.sep)}${h.$gc.sep}`,C={original:l,normalized:v});let I=d;return P.$i&&(I=(0,N.$3f)(I)),(u===3?I.startsWith(v):(0,p.$bf)(I,v))?`~/${I.substr(v.length)}`:d}e.$Zv=w;function E(d,l){return d.replace(/^~($|\/|\\)/,`${l}$1`)}e.$1v=E;const S="\u2026",c="\\\\",m="~";function a(d,l=h.sep){const u=new Array(d.length);let v=!1;for(let I=0;I<d.length;I++){const $=d[I];if($===""){u[I]=`.${l}`;continue}if(!$){u[I]=$;continue}v=!0;let f="",y=$;y.indexOf(c)===0?(f=y.substr(0,y.indexOf(c)+c.length),y=y.substr(y.indexOf(c)+c.length)):y.indexOf(l)===0?(f=y.substr(0,y.indexOf(l)+l.length),y=y.substr(y.indexOf(l)+l.length)):y.indexOf(m)===0&&(f=y.substr(0,y.indexOf(m)+m.length),y=y.substr(y.indexOf(m)+m.length));const L=y.split(l);for(let T=1;v&&T<=L.length;T++)for(let U=L.length-T;v&&U>=0;U--){v=!1;let j=L.slice(U,U+T).join(l);for(let F=0;!v&&F<d.length;F++)if(F!==I&&d[F]&&d[F].indexOf(j)>-1){const M=U+T===L.length,O=U>0&&d[F].indexOf(l)>-1?l+j:j,z=d[F].endsWith(O);v=!M||z}if(!v){let F="";(L[0].endsWith(":")||f!=="")&&(U===1&&(U=0,T++,j=L[0]+l+j),U>0&&(F=L[0]+l),F=f+F),U>0&&(F=F+S+l),F=F+j,U+T<L.length&&(F=F+l+S),u[I]=F}}v&&(u[I]=$)}return u}e.$2v=a;var i;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(d,l=Object.create(null)){const u=[];let v=!1,I="";for(const $ of d)if($==="$"||v&&$==="{")I&&u.push({value:I,type:i.TEXT}),I="",v=!0;else if($==="}"&&v){const f=l[I];if(typeof f=="string")f.length&&u.push({value:f,type:i.VARIABLE});else if(f){const y=u[u.length-1];(!y||y.type!==i.SEPARATOR)&&u.push({value:f.label,type:i.SEPARATOR})}I="",v=!1}else I+=$;return I&&!v&&u.push({value:I,type:i.TEXT}),u.filter(($,f)=>{if($.type===i.SEPARATOR){const y=u[f-1],L=u[f+1];return[y,L].every(T=>T&&(T.type===i.VARIABLE||T.type===i.TEXT)&&T.value.length>0)}return!0}).map($=>$.value).join("")}e.$3v=n;function r(d,l){return P.$j||l?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.$j?"&":"&&"):d.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.$4v=r;function s(d,l){return P.$j||l?d.replace(/\(&&\w\)|&&/g,""):P.$i?d.replace(/&&|&/g,u=>u==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$5v=s;function t(d){return d.replace(/&/g,"&&")}e.$6v=t;function g(d){if(d.endsWith("]")){const l=d.lastIndexOf(" [",d.length-2);if(l!==-1){const u=o(d.substring(0,l)),v=d.substring(l);return{name:u.name+v,parentPath:u.parentPath}}}return o(d)}e.$7v=g;function o(d){const l=d.indexOf("/")!==-1?h.$gc:h.$fc,u=l.basename(d),v=l.dirname(d);return u.length?{name:u,parentPath:v}:{name:v,parentPath:""}}}),define(ke[130],Se([1,0,21,2]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function h(C){return C.toJSON()}class P{constructor(w){this.a=w}transformIncoming(w){const E=this.a.transformIncoming(w);return E===w?w:h(N.URI.from(E))}transformOutgoing(w){const E=this.a.transformOutgoing(w);return E===w?w:h(N.URI.from(E))}transformOutgoingURI(w){const E=this.a.transformOutgoing(w);return E===w?w:N.URI.from(E)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$7m=P,e.$8m=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function A(C,w,E){if(!C||E>200)return null;if(typeof C=="object"){if(C instanceof N.URI)return w.transformOutgoing(C);for(const S in C)if(Object.hasOwnProperty.call(C,S)){const c=A(C[S],w,E+1);c!==null&&(C[S]=c)}}return null}function p(C,w){const E=A(C,w,0);return E===null?C:E}e.$9m=p;function b(C,w,E,S){if(!C||S>200)return null;if(typeof C=="object"){if(C.$mid===1)return E?N.URI.revive(w.transformIncoming(C)):w.transformIncoming(C);if(C instanceof D.$ke)return null;for(const c in C)if(Object.hasOwnProperty.call(C,c)){const m=b(C[c],w,E,S+1);m!==null&&(C[c]=m)}}return null}function k(C,w){const E=b(C,w,!1,0);return E===null?C:E}e.$0m=k;function R(C,w){const E=b(C,w,!0,0);return E===null?C:E}e.$$m=R}),define(ke[31],Se([1,0,57,63,386,8,34,76,17,11,23,2]),function($e,e,D,N,h,P,A,p,b,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function E(O,z=w.UNLINK,J){if((0,A.$_f)(O))throw new Error("rimraf - will refuse to recursively delete root");return z===w.UNLINK?c(O):S(O,J)}async function S(O,z=(0,A.$eg)((0,N.tmpdir)())){try{try{await D.promises.rename(O,z)}catch(J){return J.code==="ENOENT"?void 0:c(O)}c(z).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function c(O){return(0,h.promisify)(D.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function m(O){if((0,A.$_f)(O))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function a(O,z){return r(await(z?i(O):(0,h.promisify)(D.readdir)(O)))}async function i(O){try{return await(0,h.promisify)(D.readdir)(O,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const z=[],J=await a(O);for(const te of J){let x=!1,X=!1,Z=!1;try{const ae=await e.Promises.lstat((0,b.$jc)(O,te));x=ae.isFile(),X=ae.isDirectory(),Z=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}z.push({name:te,isFile:()=>x,isDirectory:()=>X,isSymbolicLink:()=>Z})}return z}function n(O){return r(D.readdirSync(O))}e.readdirSync=n;function r(O){return O.map(z=>typeof z=="string"?k.$j?(0,p.$Il)(z):z:(z.name=k.$j?(0,p.$Il)(z.name):z.name,z))}async function s(O){const z=await a(O),J=[];for(const te of z)await g.existsDirectory((0,b.$jc)(O,te))&&J.push(te);return J}function t(O,z=1e3){return new Promise(J=>{let te=!1;const x=setInterval(()=>{te||(te=!0,D.access(O,X=>{te=!1,X&&(clearInterval(x),J(void 0))}))},z)})}e.whenDeleted=t;var g;(function(O){async function z(x){let X;try{if(X=await e.Promises.lstat(x),!X.isSymbolicLink())return{stat:X}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:X?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};if(k.$i&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};throw ae}throw Z}}O.stat=z;async function J(x){try{const{stat:X,symbolicLink:Z}=await O.stat(x);return X.isFile()&&Z?.dangling!==!0}catch{}return!1}O.existsFile=J;async function te(x){try{const{stat:X,symbolicLink:Z}=await O.stat(x);return X.isDirectory()&&Z?.dangling!==!0}catch{}return!1}O.existsDirectory=te})(g||(e.SymlinkSupport=g={}));const o=new P.$eh;function d(O,z,J){return o.queueFor(C.URI.file(O),()=>{const te=$(J);return new Promise((x,X)=>v(O,z,te,Z=>Z?X(Z):x()))},R.$zg)}let l=!0;function u(O){l=O}e.configureFlushOnWrite=u;function v(O,z,J,te){if(!l)return D.writeFile(O,z,{mode:J.mode,flag:J.flag},te);D.open(O,J.flag,J.mode,(x,X)=>{if(x)return te(x);D.writeFile(X,z,Z=>{if(Z)return D.close(X,()=>te(Z));D.fdatasync(X,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),u(!1)),D.close(X,_=>te(_))))})})}function I(O,z,J){const te=$(J);if(!l)return D.writeFileSync(O,z,{mode:te.mode,flag:te.flag});const x=D.openSync(O,te.flag,te.mode);try{D.writeFileSync(x,z);try{D.fdatasyncSync(x)}catch(X){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",X),u(!1)}}finally{D.closeSync(x)}}e.writeFileSync=I;function $(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function f(O,z,J=6e4){if(O!==z)try{k.$i&&typeof J=="number"?await y(O,z,Date.now(),J):await(0,h.promisify)(D.rename)(O,z)}catch(te){if(O.toLowerCase()!==z.toLowerCase()&&te.code==="EXDEV"||O.endsWith("."))await L(O,z,{preserveSymlinks:!1}),await E(O,w.MOVE);else throw te}}async function y(O,z,J,te,x=0){try{return await(0,h.promisify)(D.rename)(O,z)}catch(X){if(X.code!=="EACCES"&&X.code!=="EPERM"&&X.code!=="EBUSY")throw X;if(Date.now()-J>=te)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${X}`),X;if(x===0){let Z=!1;try{const{stat:ae}=await g.stat(z);ae.isFile()||(Z=!0)}catch{}if(Z)throw X}return await(0,P.$9g)(Math.min(100,x*10)),y(O,z,J,te,x+1)}}async function L(O,z,J){return U(O,z,{root:{source:O,target:z},options:J,handledSourcePaths:new Set})}const T=511;async function U(O,z,J){if(J.handledSourcePaths.has(O))return;J.handledSourcePaths.add(O);const{stat:te,symbolicLink:x}=await g.stat(O);if(x){if(J.options.preserveSymlinks)try{return await M(O,z,J)}catch{}if(x.dangling)return}return te.isDirectory()?j(O,z,te.mode&T,J):F(O,z,te.mode&T)}async function j(O,z,J,te){await e.Promises.mkdir(z,{recursive:!0,mode:J});const x=await a(O);for(const X of x)await U((0,b.$jc)(O,X),(0,b.$jc)(z,X),te)}async function F(O,z,J){await e.Promises.copyFile(O,z),await e.Promises.chmod(z,J)}async function M(O,z,J){let te=await e.Promises.readlink(O);(0,A.$9f)(te,J.root.source,!k.$k)&&(te=(0,b.$jc)(J.root.target,te.substr(J.root.source.length+1))),await e.Promises.symlink(te,z)}e.Promises=new class{get access(){return(0,h.promisify)(D.access)}get stat(){return(0,h.promisify)(D.stat)}get lstat(){return(0,h.promisify)(D.lstat)}get utimes(){return(0,h.promisify)(D.utimes)}get read(){return(O,z,J,te,x)=>new Promise((X,Z)=>{D.read(O,z,J,te,x,(ae,_,ge)=>ae?Z(ae):X({bytesRead:_,buffer:ge}))})}get readFile(){return(0,h.promisify)(D.readFile)}get write(){return(O,z,J,te,x)=>new Promise((X,Z)=>{D.write(O,z,J,te,x,(ae,_,ge)=>ae?Z(ae):X({bytesWritten:_,buffer:ge}))})}get appendFile(){return(0,h.promisify)(D.appendFile)}get fdatasync(){return(0,h.promisify)(D.fdatasync)}get truncate(){return(0,h.promisify)(D.truncate)}get copyFile(){return(0,h.promisify)(D.copyFile)}get open(){return(0,h.promisify)(D.open)}get close(){return(0,h.promisify)(D.close)}get symlink(){return(0,h.promisify)(D.symlink)}get readlink(){return(0,h.promisify)(D.readlink)}get chmod(){return(0,h.promisify)(D.chmod)}get mkdir(){return(0,h.promisify)(D.mkdir)}get unlink(){return(0,h.promisify)(D.unlink)}get rmdir(){return(0,h.promisify)(D.rmdir)}get realpath(){return(0,h.promisify)(D.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return a}get readDirsInDir(){return s}get writeFile(){return d}get rm(){return E}get rename(){return f}get copy(){return L}}}),define(ke[104],Se([1,0,57,17,11,12,31]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=e.$vq=void 0;function p(w){if(h.$k)return w;const E=(0,N.$mc)(w);if(w===E)return w;const S=((0,N.$nc)(w)||w).toLowerCase();try{const m=(0,A.readdirSync)(E).filter(a=>a.toLowerCase()===S);if(m.length===1){const a=p(E);if(a)return(0,N.$jc)(a,m[0])}else if(m.length>1){const a=m.indexOf(S);if(a>=0){const i=p(E);if(i)return(0,N.$jc)(i,m[a])}}}catch{}return null}e.$vq=p;async function b(w){if(h.$k)return w;const E=(0,N.$mc)(w);if(w===E)return w;const S=((0,N.$nc)(w)||w).toLowerCase();try{const m=(await A.Promises.readdir(E)).filter(a=>a.toLowerCase()===S);if(m.length===1){const a=await b(E);if(a)return(0,N.$jc)(a,m[0])}else if(m.length>1){const a=m.indexOf(S);if(a>=0){const i=await b(E);if(i)return(0,N.$jc)(i,m[a])}}}catch{}return null}e.$wq=b;async function k(w){try{return await A.Promises.realpath(w)}catch{const S=C(w);return await A.Promises.access(S,D.constants.R_OK),S}}e.$xq=k;function R(w){try{return D.realpathSync(w)}catch{const S=C(w);return D.accessSync(S,D.constants.R_OK),S}}e.$yq=R;function C(w){return(0,P.$Ve)((0,N.$hc)(w),N.sep)}}),define(ke[105],Se([1,0,17,11,49,102,18,31]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Wl=e.$Vl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function b(C=h.env){return C.comspec||"cmd.exe"}e.$Vl=b;function k(C){let w=[],E=!1;const S=function(c){if(E){w.push(c);return}(!C.send(c,a=>{if(a&&console.error(a),E=!1,w.length>0){const i=w.slice(0);w=[],i.forEach(n=>S(n))}})||N.$i)&&(E=!0)};return{send:S}}e.$Wl=k;var R;(function(C){async function w(E,S,c){if(D.$ic(E))return E;if(S===void 0&&(S=h.cwd()),D.$mc(E)!=="."||(c===void 0&&A.$Jf(h.env.PATH)&&(c=h.env.PATH.split(D.$tc)),c===void 0||c.length===0))return D.$jc(S,E);async function a(i){if(await p.Promises.exists(i)){let n;try{n=await p.Promises.stat(i)}catch(r){r.message.startsWith("EACCES")&&(n=await p.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of c){let n;if(D.$ic(i)?n=D.$jc(i,E):n=D.$jc(S,i,E),await a(n))return n;let r=n+".com";if(await a(r)||(r=n+".exe",await a(r)))return r}return D.$jc(S,E)}C.findExecutable=w})(R||(e.win32=R={}))});var Ge=this&&this.__decorate||function($e,e,D,N){var h=arguments.length,P=h<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,D):N,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate($e,e,D,N);else for(var p=$e.length-1;p>=0;p--)(A=$e[p])&&(P=(h<3?A(P):h>3?A(e,D,P):A(e,D))||P);return h>3&&P&&Object.defineProperty(e,D,P),P};define(ke[81],Se([1,0,19,8,21,22,52,14,4,3,56,12,18]),function($e,e,D,N,h,P,A,p,b,k,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.ProxyChannel=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.RequestInitiator=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=void 0;var E;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(E||(E={}));function S(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(c||(c={}));function m(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(a||(a={}));function i(x){let X=0;for(let Z=0;;Z+=7){const ae=x.read(1);if(X|=(ae.buffer[0]&127)<<Z,!(ae.buffer[0]&128))return X}}const n=o(0);function r(x,X){if(X===0){x.write(n);return}let Z=0;for(let _=X;_!==0;_=_>>>7)Z++;const ae=h.$ke.alloc(Z);for(let _=0;X!==0;_++)ae.buffer[_]=X&127,X=X>>>7,X>0&&(ae.buffer[_]|=128);x.write(ae)}class s{constructor(X){this.b=X,this.a=0}read(X){const Z=this.b.slice(this.a,this.a+X);return this.a+=Z.byteLength,Z}}e.$Fh=s;class t{constructor(){this.a=[]}get buffer(){return h.$ke.concat(this.a)}write(X){this.a.push(X)}}e.$Gh=t;var g;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(g||(g={}));function o(x){const X=h.$ke.alloc(1);return X.writeUInt8(x,0),X}const d={Undefined:o(g.Undefined),String:o(g.String),Buffer:o(g.Buffer),VSBuffer:o(g.VSBuffer),Array:o(g.Array),Object:o(g.Object),Uint:o(g.Int)},l=typeof Buffer<"u";function u(x,X){if(typeof X>"u")x.write(d.Undefined);else if(typeof X=="string"){const Z=h.$ke.fromString(X);x.write(d.String),r(x,Z.byteLength),x.write(Z)}else if(l&&Buffer.isBuffer(X)){const Z=h.$ke.wrap(X);x.write(d.Buffer),r(x,Z.byteLength),x.write(Z)}else if(X instanceof h.$ke)x.write(d.VSBuffer),r(x,X.byteLength),x.write(X);else if(Array.isArray(X)){x.write(d.Array),r(x,X.length);for(const Z of X)u(x,Z)}else if(typeof X=="number"&&(X|0)===X)x.write(d.Uint),r(x,X);else{const Z=h.$ke.fromString(JSON.stringify(X));x.write(d.Object),r(x,Z.byteLength),x.write(Z)}}e.$Hh=u;function v(x){switch(x.read(1).readUInt8(0)){case g.Undefined:return;case g.String:return x.read(i(x)).toString();case g.Buffer:return x.read(i(x)).buffer;case g.VSBuffer:return x.read(i(x));case g.Array:{const Z=i(x),ae=[];for(let _=0;_<Z;_++)ae.push(v(x));return ae}case g.Object:return JSON.parse(x.read(i(x)).toString());case g.Int:return i(x)}}e.$Ih=v;class I{constructor(X,Z,ae=null,_=1e3){this.h=X,this.j=Z,this.k=ae,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ge=>this.q(ge)),this.m({type:200})}registerChannel(X,Z){this.b.set(X,Z),setTimeout(()=>this.w(X),0)}m(X){switch(X.type){case 200:{const Z=this.o([X.type]);this.k?.logOutgoing(Z,0,1,m(X.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([X.type,X.id],X.data);this.k?.logOutgoing(Z,X.id,1,m(X.type),X.data);return}}}o(X,Z=void 0){const ae=new t;return u(ae,X),u(ae,Z),this.p(ae.buffer)}p(X){try{return this.h.send(X),X.byteLength}catch{return 0}}q(X){const Z=new s(X),ae=v(Z),_=v(Z),ge=ae[0];switch(ge){case 100:return this.k?.logIncoming(X.byteLength,ae[1],1,`${S(ge)}: ${ae[2]}.${ae[3]}`,_),this.s({type:ge,id:ae[1],channelName:ae[2],name:ae[3],arg:_});case 102:return this.k?.logIncoming(X.byteLength,ae[1],1,`${S(ge)}: ${ae[2]}.${ae[3]}`,_),this.t({type:ge,id:ae[1],channelName:ae[2],name:ae[3],arg:_});case 101:return this.k?.logIncoming(X.byteLength,ae[1],1,`${S(ge)}`),this.u({type:ge,id:ae[1]});case 103:return this.k?.logIncoming(X.byteLength,ae[1],1,`${S(ge)}`),this.u({type:ge,id:ae[1]})}}s(X){const Z=this.b.get(X.channelName);if(!Z){this.v(X);return}const ae=new P.$7d;let _;try{_=Z.call(this.j,X.name,X.arg,ae.token)}catch(K){_=Promise.reject(K)}const ge=X.id;_.then(K=>{this.m({id:ge,data:K,type:201})},K=>{K instanceof Error?this.m({id:ge,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:ge,data:K,type:203})}).finally(()=>{ne.dispose(),this.d.delete(X.id)});const ne=(0,k.$Rc)(()=>ae.cancel());this.d.set(X.id,ne)}t(X){const Z=this.b.get(X.channelName);if(!Z){this.v(X);return}const ae=X.id,ge=Z.listen(this.j,X.name,X.arg)(ne=>this.m({id:ae,data:ne,type:204}));this.d.set(X.id,ge)}u(X){const Z=this.d.get(X.id);Z&&(Z.dispose(),this.d.delete(X.id))}v(X){let Z=this.g.get(X.channelName);Z||(Z=[],this.g.set(X.channelName,Z));const ae=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.m({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:X,timeoutTimer:ae})}w(X){const Z=this.g.get(X);if(Z){for(const ae of Z)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.s(ae.request);break;case 102:this.t(ae.request);break}this.g.delete(X)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,k.$Oc)(this.d.values()),this.d.clear()}}e.$Jh=I;var $;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})($||(e.RequestInitiator=$={}));class f{constructor(X,Z=null){this.l=X,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$Wd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ae=>this.s(ae)),this.j=Z}getChannel(X){const Z=this;return{call(ae,_,ge){return Z.a?Promise.reject(new p.$5):Z.m(X,ae,_,ge)},listen(ae,_){return Z.a?b.Event.None:Z.o(X,ae,_)}}}m(X,Z,ae,_=P.CancellationToken.None){const ge=this.g++,K={id:ge,type:100,channelName:X,name:Z,arg:ae};if(_.isCancellationRequested)return Promise.reject(new p.$5);let W;return new Promise((ye,he)=>{if(_.isCancellationRequested)return he(new p.$5);const fe=()=>{const Y=de=>{switch(de.type){case 201:this.f.delete(ge),ye(de.data);break;case 202:{this.f.delete(ge);const we=new Error(de.data.message);we.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,we.name=de.data.name,he(we);break}case 203:this.f.delete(ge),he(de.data);break}};this.f.set(ge,Y),this.p(K)};let ue=null;this.b===a.Idle?fe():(ue=(0,N.$Ug)(Y=>this.u()),ue.then(()=>{ue=null,fe()}));const me=()=>{ue?(ue.cancel(),ue=null):this.p({id:ge,type:101}),he(new p.$5)},V=_.onCancellationRequested(me);W=(0,k.$Qc)((0,k.$Rc)(me),V),this.d.add(W)}).finally(()=>{W.dispose(),this.d.delete(W)})}o(X,Z,ae){const _=this.g++,ne={id:_,type:102,channelName:X,name:Z,arg:ae};let K=null;const W=new b.$Wd({onWillAddFirstListener:()=>{K=(0,N.$Ug)(ye=>this.u()),K.then(()=>{K=null,this.d.add(W),this.p(ne)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(W),this.p({id:_,type:103}))}}),re=ye=>W.fire(ye.data);return this.f.set(_,re),W.event}p(X){switch(X.type){case 100:case 102:{const Z=this.q([X.type,X.id,X.channelName,X.name],X.arg);this.j?.logOutgoing(Z,X.id,0,`${S(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const Z=this.q([X.type,X.id]);this.j?.logOutgoing(Z,X.id,0,S(X.type));return}}}q(X,Z=void 0){const ae=new t;return u(ae,X),u(ae,Z),this.r(ae.buffer)}r(X){try{return this.l.send(X),X.byteLength}catch{return 0}}s(X){const Z=new s(X),ae=v(Z),_=v(Z),ge=ae[0];switch(ge){case 200:return this.j?.logIncoming(X.byteLength,0,0,m(ge)),this.t({type:ae[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(X.byteLength,ae[1],0,m(ge),_),this.t({type:ae[0],id:ae[1],data:_})}}t(X){if(X.type===200){this.b=a.Idle,this.k.fire();return}this.f.get(X.id)?.(X)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,k.$Oc)(this.d.values()),this.d.clear()}}e.$Kh=f,Ge([A.$zh],f.prototype,"onDidInitializePromise",null);class y{get connections(){const X=[];return this.f.forEach(Z=>X.push(Z)),X}constructor(X){this.a=new Map,this.f=new Set,this.g=new b.$Wd,this.onDidAddConnection=this.g.event,this.h=new b.$Wd,this.onDidRemoveConnection=this.h.event,this.j=new k.$Sc,this.j.add(X(({protocol:Z,onDidClientDisconnect:ae})=>{const _=b.Event.once(Z.onMessage);this.j.add(_(ge=>{const ne=new s(ge),K=v(ne),W=new I(Z,K),re=new f(Z);this.a.forEach((he,fe)=>W.registerChannel(fe,he));const ye={channelServer:W,channelClient:re,ctx:K};this.f.add(ye),this.g.fire(ye),this.j.add(ae(()=>{W.dispose(),re.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(X,Z){const ae=this;return{call(_,ge,ne){let K;if((0,w.$Xf)(Z)){const re=(0,D.$4b)(ae.connections.filter(Z));K=re?Promise.resolve(re):b.Event.toPromise(b.Event.filter(ae.onDidAddConnection,Z))}else K=Z.routeCall(ae,_,ge);const W=K.then(re=>re.channelClient.getChannel(X));return T(W).call(_,ge,ne)},listen(_,ge){if((0,w.$Xf)(Z))return ae.k(X,Z,_,ge);const ne=Z.routeEvent(ae,_,ge).then(K=>K.channelClient.getChannel(X));return T(ne).listen(_,ge)}}}k(X,Z,ae,_){const ge=this;let ne;const K=new b.$Wd({onWillAddFirstListener:()=>{ne=new k.$Sc;const W=new b.$3d,re=new Map,ye=fe=>{const me=fe.channelClient.getChannel(X).listen(ae,_),V=W.add(me);re.set(fe,V)},he=fe=>{const ue=re.get(fe);ue&&(ue.dispose(),re.delete(fe))};ge.connections.filter(Z).forEach(ye),b.Event.filter(ge.onDidAddConnection,Z)(ye,void 0,ne),ge.onDidRemoveConnection(he,void 0,ne),W.event(K.fire,K,ne),ne.add(W)},onDidRemoveLastListener:()=>{ne?.dispose(),ne=void 0}});return K.event}registerChannel(X,Z){this.a.set(X,Z);for(const ae of this.f)ae.channelServer.registerChannel(X,Z)}dispose(){this.j.dispose();for(const X of this.f)X.channelClient.dispose(),X.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Lh=y;class L{constructor(X,Z,ae=null){const _=new t;u(_,Z),X.send(_.buffer),this.a=new f(X,ae),this.d=new I(X,Z,ae)}getChannel(X){return this.a.getChannel(X)}registerChannel(X,Z){this.d.registerChannel(X,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Mh=L;function T(x){return{call(X,Z,ae){return x.then(_=>_.call(X,Z,ae))},listen(X,Z){const ae=new b.$6d;return x.then(_=>ae.input=_.listen(X,Z)),ae.event}}}e.$Nh=T;function U(x){let X=!1;return{call(Z,ae,_){return X?x.call(Z,ae,_):(0,N.$9g)(0).then(()=>X=!0).then(()=>x.call(Z,ae,_))},listen(Z,ae){if(X)return x.listen(Z,ae);const _=new b.$6d;return(0,N.$9g)(0).then(()=>X=!0).then(()=>_.input=x.listen(Z,ae)),_.event}}}e.$Oh=U;class j{constructor(X){this.a=X}routeCall(X){return this.b(X)}routeEvent(X){return this.b(X)}async b(X){for(const Z of X.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await b.Event.toPromise(X.onDidAddConnection),await this.b(X)}}e.$Ph=j;var F;(function(x){function X(ge,ne,K){const W=ge,re=K&&K.disableMarshalling,ye=new Map;for(const he in W)ae(he)&&ye.set(he,b.Event.buffer(W[he],!0,void 0,ne));return new class{listen(he,fe,ue){const me=ye.get(fe);if(me)return me;if(_(fe)){const V=W[fe];if(typeof V=="function")return V.call(W,ue)}throw new p.$bb(`Event not found: ${fe}`)}call(he,fe,ue){const me=W[fe];if(typeof me=="function"){if(!re&&Array.isArray(ue))for(let Y=0;Y<ue.length;Y++)ue[Y]=(0,R.$Eh)(ue[Y]);let V=me.apply(W,ue);return V instanceof Promise||(V=Promise.resolve(V)),V}throw new p.$bb(`Method not found: ${fe}`)}}}x.fromService=X;function Z(ge,ne){const K=ne&&ne.disableMarshalling;return new Proxy({},{get(W,re){if(typeof re=="string")return ne?.properties?.has(re)?ne.properties.get(re):_(re)?function(ye){return ge.listen(re,ye)}:ae(re)?ge.listen(re):async function(...ye){let he;ne&&!(0,w.$Sf)(ne.context)?he=[ne.context,...ye]:he=ye;const fe=await ge.call(re,he);return K?fe:(0,R.$Eh)(fe)};throw new p.$bb(`Property not found: ${String(re)}`)}})}x.toService=Z;function ae(ge){return ge[0]==="o"&&ge[1]==="n"&&C.$_e(ge.charCodeAt(2))}function _(ge){return/^onDynamic/.test(ge)&&C.$_e(ge.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const X=x.toString();if(X!=="[object Object]")return X}return x}function z(x){return Array.isArray(x)?x.map(O):O(x)}function J(x,X,Z,ae,_,ge,ne){ne=z(ne);const K=M[_],W=K[ae%K.length];let re=[`%c[${x}]%c[${String(X).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${ge}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(ge)?(re=re.concat(ne),re.push(")")):re.push(ne),console.log.apply(console,re)}class te{constructor(X,Z){this.d=X,this.f=Z,this.a=0,this.b=0}logOutgoing(X,Z,ae,_,ge){this.b+=X,J(this.d,this.b,X,Z,ae,_,ge)}logIncoming(X,Z,ae,_,ge){this.a+=X,J(this.f,this.a,X,Z,ae,_,ge)}}e.$Qh=te}),define(ke[82],Se([1,0,21,4,3,81]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.ProtocolConstants=e.$Rh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(d){d.Created="created",d.Read="read",d.Write="write",d.Open="open",d.Error="error",d.Close="close",d.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",d.NodeEndReceived="nodeEndReceived",d.NodeEndSent="nodeEndSent",d.NodeDrainBegin="nodeDrainBegin",d.NodeDrainEnd="nodeDrainEnd",d.zlibInflateError="zlibInflateError",d.zlibInflateData="zlibInflateData",d.zlibInflateInitialWrite="zlibInflateInitialWrite",d.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",d.zlibInflateWrite="zlibInflateWrite",d.zlibInflateFlushFired="zlibInflateFlushFired",d.zlibDeflateError="zlibDeflateError",d.zlibDeflateData="zlibDeflateData",d.zlibDeflateWrite="zlibDeflateWrite",d.zlibDeflateFlushFired="zlibDeflateFlushFired",d.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",d.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",d.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",d.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",d.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",d.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",d.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",d.ProtocolHeaderRead="protocolHeaderRead",d.ProtocolMessageRead="protocolMessageRead",d.ProtocolHeaderWrite="protocolHeaderWrite",d.ProtocolMessageWrite="protocolMessageWrite",d.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var p;(function(d){d.enableDiagnostics=!1,d.records=[];const l=new WeakMap;let u=0;function v($,f){if(!l.has($)){const y=String(++u);l.set($,y)}return l.get($)}function I($,f,y,L){if(!d.enableDiagnostics)return;const T=v($,f);if(L instanceof D.$ke||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const U=D.$ke.alloc(L.byteLength);U.set(L),d.records.push({timestamp:Date.now(),id:T,label:f,type:y,buff:U})}else d.records.push({timestamp:Date.now(),id:T,label:f,type:y,data:L})}d.traceSocketEvent=I})(p||(e.SocketDiagnostics=p={}));var b;(function(d){d[d.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",d[d.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let k=null;function R(){return k||(k=D.$ke.alloc(0)),k}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(l){this.a.push(l),this.b+=l.byteLength}read(l){return this.c(l,!0)}peek(l){return this.c(l,!1)}c(l,u){if(l===0)return R();if(l>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===l){const f=this.a[0];return u&&(this.a.shift(),this.b-=l),f}if(this.a[0].byteLength>l){const f=this.a[0].slice(0,l);return u&&(this.a[0]=this.a[0].slice(l),this.b-=l),f}const v=D.$ke.alloc(l);let I=0,$=0;for(;l>0;){const f=this.a[$];if(f.byteLength>l){const y=f.slice(0,l);v.set(y,I),I+=l,u&&(this.a[$]=f.slice(l),this.b-=l),l-=l}else v.set(f,I),I+=f.byteLength,u?(this.a.shift(),this.b-=f.byteLength):$++,l-=f.byteLength}return v}}e.$Rh=C;var w;(function(d){d[d.None=0]="None",d[d.Regular=1]="Regular",d[d.Control=2]="Control",d[d.Ack=3]="Ack",d[d.Disconnect=5]="Disconnect",d[d.ReplayRequest=6]="ReplayRequest",d[d.Pause=7]="Pause",d[d.Resume=8]="Resume",d[d.KeepAlive=9]="KeepAlive"})(w||(w={}));function E(d){switch(d){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(d){d[d.HeaderLength=13]="HeaderLength",d[d.AcknowledgeTime=2e3]="AcknowledgeTime",d[d.TimeoutTime=2e4]="TimeoutTime",d[d.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",d[d.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",d[d.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class c{constructor(l,u,v,I){this.type=l,this.id=u,this.ack=v,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends h.$Tc{constructor(l){super(),this.f=this.B(new N.$Wd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=l,this.b=!1,this.c=new C,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(l);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const v=this.g.messageType,I=this.g.id,$=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",u),this.f.fire(new c(v,I,$,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class a{constructor(l){this.k=null,this.a=!1,this.b=!1,this.c=l,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(l){if(this.a)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=D.$ke.alloc(13);u.writeUInt8(l.type,0),u.writeUInt32BE(l.id,1),u.writeUInt32BE(l.ack,5),u.writeUInt32BE(l.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",l.data),this.j(u,l.data)}g(l,u){const v=this.f===0;return this.d.push(l,u),this.f+=l.byteLength+u.byteLength,v}h(){const l=D.$ke.concat(this.d,this.f);return this.d.length=0,this.f=0,l}j(l,u){this.g(l,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const l=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:l.byteLength}),this.c.write(l)}}class i extends h.$Tc{constructor(l){super(),this.f=new N.$Wd,this.onMessage=this.f.event,this.g=new N.$Wd,this.onDidDispose=this.g.event,this.a=l,this.b=this.B(new a(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(u=>{u.type===1&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(l){this.b.write(new c(1,0,0,l))}}e.$Sh=i;class n extends P.$Mh{static fromSocket(l,u){return new n(new i(l),u)}get onDidDispose(){return this.b.onDidDispose}constructor(l,u,v=null){super(l,u,v),this.b=l}dispose(){super.dispose();const l=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),l.end()}}e.$Th=n;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$Wd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(l){this.b?this.d.length>0?this.d.push(l):this.a.fire(l):this.d.push(l)}flushBuffer(){this.d=[]}}e.$Uh=r;class s{constructor(l){this.data=l,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let l=0,u=this.a;for(;u;)u=u.next,l++;return l}peek(){return this.a?this.a.data:null}toArray(){const l=[];let u=0,v=this.a;for(;v;)l[u++]=v.data,v=v.next;return l}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(l){const u=new s(l);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class g{static{this.a=10}static{this.b=null}static getInstance(){return g.b||(g.b=new g),g.b}constructor(){this.c=[];const l=Date.now();for(let u=0;u<g.a;u++)this.c[u]=l-1e3*u;setInterval(()=>{for(let u=g.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const l=Date.now(),u=(1+g.a)*1e3;let v=0;for(let I=0;I<g.a;I++)l-this.c[I]<=u&&v++;return 1-v/g.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.c-this.d}constructor(l){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=l.loadEstimator??g.getInstance(),this.t=l.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new h.$Sc,this.o=l.socket,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),l.initialChunk&&this.q.acceptChunk(l.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const l=new c(5,0,0,R());this.p.write(l),this.p.flush()}sendPause(){const l=new c(7,0,0,R());this.p.write(l)}sendResume(){const l=new c(8,0,0,R());this.p.write(l)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(l,u){this.a=!0,this.r.dispose(),this.r=new h.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=l,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(v=>this.z(v))),this.r.add(this.o.onClose(v=>this.x.fire(v))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const l=new c(3,0,this.h,R());this.p.write(l);const u=this.b.toArray();for(let v=0,I=u.length;v<I;v++)this.p.write(u[v]);this.B()}acceptDisconnect(){this.w.fire()}z(l){if(l.ack>this.d){this.d=l.ack;do{const u=this.b.peek();if(u&&u.id<=l.ack)this.b.pop();else break}while(!0)}switch(l.type){case 0:break;case 1:{if(l.id>this.g)if(l.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new c(6,0,0,R())))}else this.g=l.id,this.j=Date.now(),this.A(),this.v.fire(l.data);break}case 2:{this.u.fire(l.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const u=this.b.toArray();for(let v=0,I=u.length;v<I;v++)this.p.write(u[v]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(l){const u=++this.c;this.h=this.g;const v=new c(1,u,this.h,l);this.b.push(v),this.a||(this.p.write(v),this.B())}sendControl(l){const u=new c(2,0,0,l);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const l=Date.now()-this.j;if(l>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-l+5)}B(){if(this.c<=this.d||this.f||this.a)return;const l=this.b.peek(),u=Date.now()-l.writtenTime,v=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(u>=2e4&&v>=2e4&&I>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:v});return}const $=Math.max(2e4-u,2e4-v,2e4-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},$)}C(){if(this.g<=this.h)return;this.h=this.g;const l=new c(3,0,this.h,R());this.p.write(l)}D(){this.h=this.g;const l=new c(9,0,this.h,R());this.p.write(l)}}e.$Vh=o}),define(ke[187],Se([1,0,50,8,21,22,185,14,4,3,24,105,102,81]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=void 0;class S extends E.$Jh{constructor(a){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",i=>h.$ke.wrap(Buffer.from(i,"base64")))},a),process.once("disconnect",()=>this.dispose())}}e.$sq=S;class c{constructor(a,i){this.i=a,this.j=i,this.c=new Set,this.g=new Map,this.h=new b.$Wd,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new N.$5g(n),this.d=null,this.f=null}getChannel(a){const i=this;return{call(n,r,s){return i.k(a,n,r,s)},listen(n,r){return i.l(a,n,r)}}}k(a,i,n,r=P.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(p.$6());this.b.cancel();const s=this.n(a),t=(0,N.$Ug)(d=>s.call(i,n,d)),g=r.onCancellationRequested(()=>t.cancel()),o=(0,k.$Rc)(()=>t.cancel());return this.c.add(o),t.finally(()=>{g.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(a,i,n){if(!this.b)return b.Event.None;this.b.cancel();let r;const s=new b.$Wd({onWillAddFirstListener:()=>{r=this.n(a).listen(i,n)(s.fire,s),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const a=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,R.$yn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,w.$Ul)(i.env),this.d=(0,D.fork)(this.i,a,i);const n=new b.$Wd;b.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,A.$oq)(l)){(0,A.log)(l,`IPC Library: ${this.j.serverName}`);return}n.fire(h.$ke.wrap(Buffer.from(l,"base64")))});const s=this.j.useQueue?(0,C.$Wl)(this.d):this.d,t=l=>this.d&&this.d.connected&&s.send(l.buffer.toString("base64")),g=n.event,o={send:t,onMessage:g};this.f=new E.$Kh(o);const d=()=>this.o();process.once("exit",d),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,u)=>{process.removeListener("exit",d),this.c.forEach(v=>(0,k.$Oc)(v)),this.c.clear(),l!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:u})})}return this.f}n(a){let i=this.g.get(a);return i||(i=this.m.getChannel(a),this.g.set(a,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$tq=c}),define(ke[188],Se([1,0,8,4,3,56,18]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.StorageState=e.$rp=e.StorageHint=void 0;var p;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function b(w){const E=w;return E?.changed instanceof Map||E?.deleted instanceof Set}e.$rp=b;var k;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(k||(e.StorageState=k={}));class R extends h.$Tc{static{this.a=100}constructor(E,S=Object.create(null)){super(),this.r=E,this.s=S,this.b=this.B(new N.$Zd),this.onDidChangeStorage=this.b.event,this.c=k.None,this.f=new Map,this.g=this.B(new D.$6g(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((S,c)=>this.w(c,S)),E.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(E,S){if(this.c===k.Closed)return;let c=!1;(0,A.$Sf)(S)?c=this.f.delete(E):this.f.get(E)!==S&&(this.f.set(E,S),c=!0),c&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===k.None&&(this.c=k.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,S){const c=this.f.get(E);return(0,A.$Sf)(c)?S:c}getBoolean(E,S){const c=this.get(E);return(0,A.$Sf)(c)?S:c==="true"}getNumber(E,S){const c=this.get(E);return(0,A.$Sf)(c)?S:parseInt(c,10)}getObject(E,S){const c=this.get(E);return(0,A.$Sf)(c)?S:(0,P.$Dh)(c)}async set(E,S,c=!1){if(this.c===k.Closed)return;if((0,A.$Sf)(S))return this.delete(E,c);const m=(0,A.$Lf)(S)||Array.isArray(S)?(0,P.$Ch)(S):String(S);if(this.f.get(E)!==m)return this.f.set(E,m),this.j.set(E,m),this.h.delete(E),this.b.fire({key:E,external:c}),this.D()}async delete(E,S=!1){if(!(this.c===k.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:S}),this.D()}async optimize(){if(this.c!==k.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=k.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(this.z)return this.D(E)}async D(E){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$sp=R;class C{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((S,c)=>this.a.set(c,S)),E.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$tp=C}),define(ke[189],Se([1,0,12,11,21]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=void 0;let P;function A(){return P||(P=new TextDecoder("UTF-16LE")),P}let p;function b(){return p||(p=new TextDecoder("UTF-16BE")),p}let k;function R(){return k||(k=N.$D()?A():b()),k}e.$ct=R;function C(S,c,m){const a=new Uint16Array(S.buffer,c,m);return m>0&&(a[0]===65279||a[0]===65534)?w(S,c,m):A().decode(a)}e.$dt=C;function w(S,c,m){const a=[];let i=0;for(let n=0;n<m;n++){const r=h.$me(S,c);c+=2,a[i++]=String.fromCharCode(r)}return a.join("")}class E{constructor(c){this.a=c|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const c=new Uint16Array(this.b.buffer,0,this.d);return R().decode(c)}f(){const c=this.e();this.d=0,this.c===null?this.c=[c]:this.c[this.c.length]=c}appendCharCode(c){const m=this.a-this.d;m<=1&&(m===0||D.$ef(c))&&this.f(),this.b[this.d++]=c}appendASCIICharCode(c){this.d===this.a&&this.f(),this.b[this.d++]=c}appendString(c){const m=c.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=c;return}for(let a=0;a<m;a++)this.b[this.d++]=c.charCodeAt(a)}}e.$et=E}),define(ke[190],Se([1,0,21,189]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=void 0;function h(b){return b.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class P{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,R,C,w){this.oldPosition=k,this.oldText=R,this.newPosition=C,this.newText=w}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${h(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${h(this.oldText)}")`:`(replace@${this.oldPosition} "${h(this.oldText)}" with "${h(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,R,C){const w=R.length;D.$pe(k,w,C),C+=4;for(let E=0;E<w;E++)D.$ne(k,R.charCodeAt(E),C),C+=2;return C}static d(k,R){const C=D.$oe(k,R);return R+=4,(0,N.$dt)(k,R,C)}writeSize(){return 4+4+P.a(this.oldText)+P.a(this.newText)}write(k,R){return D.$pe(k,this.oldPosition,R),R+=4,D.$pe(k,this.newPosition,R),R+=4,R=P.c(k,this.oldText,R),R=P.c(k,this.newText,R),R}static read(k,R,C){const w=D.$oe(k,R);R+=4;const E=D.$oe(k,R);R+=4;const S=P.d(k,R);R+=P.a(S);const c=P.d(k,R);return R+=P.a(c),C.push(new P(w,S,E,c)),R}}e.$ft=P;function A(b,k){return b===null||b.length===0?k:new p(b,k).compress()}e.$gt=A;class p{constructor(k,R){this.a=k,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,R=0,C=this.n(k),w=this.l(R);for(;k<this.f||R<this.h;){if(C===null){this.k(w),w=this.l(++R);continue}if(w===null){this.m(C),C=this.n(++k);continue}if(w.oldEnd<=C.newPosition){this.k(w),w=this.l(++R);continue}if(C.newEnd<=w.oldPosition){this.m(C),C=this.n(++k);continue}if(w.oldPosition<C.newPosition){const[a,i]=p.r(w,C.newPosition-w.oldPosition);this.k(a),w=i;continue}if(C.newPosition<w.oldPosition){const[a,i]=p.q(C,w.oldPosition-C.newPosition);this.m(a),C=i;continue}let c,m;if(w.oldEnd===C.newEnd)c=C,m=w,C=this.n(++k),w=this.l(++R);else if(w.oldEnd<C.newEnd){const[a,i]=p.q(C,w.oldLength);c=a,m=w,C=i,w=this.l(++R)}else{const[a,i]=p.r(w,C.newLength);c=C,m=a,C=this.n(++k),w=i}this.d[this.e++]=new P(c.oldPosition,c.oldText,m.newPosition,m.newText),this.g+=c.newLength-c.oldLength,this.j+=m.newLength-m.oldLength}const E=p.s(this.d);return p.t(E)}k(k){this.d[this.e++]=p.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=p.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,R){return new P(R.oldPosition-k,R.oldText,R.newPosition,R.newText)}static p(k,R){return new P(R.oldPosition,R.oldText,R.newPosition+k,R.newText)}static q(k,R){const C=k.newText.substr(0,R),w=k.newText.substr(R);return[new P(k.oldPosition,k.oldText,k.newPosition,C),new P(k.oldEnd,"",k.newPosition+R,w)]}static r(k,R){const C=k.oldText.substr(0,R),w=k.oldText.substr(R);return[new P(k.oldPosition,C,k.newPosition,k.newText),new P(k.oldPosition+R,w,k.newEnd,"")]}static s(k){if(k.length===0)return k;const R=[];let C=0,w=k[0];for(let E=1;E<k.length;E++){const S=k[E];w.oldEnd===S.oldPosition?w=new P(w.oldPosition,w.oldText+S.oldText,w.newPosition,w.newText+S.newText):(R[C++]=w,w=S)}return R[C++]=w,R}static t(k){if(k.length===0)return k;const R=[];let C=0;for(let w=0;w<k.length;w++){const E=k[w];E.oldText!==E.newText&&(R[C++]=E)}return R}}}),define(ke[191],Se([1,0,35,17]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=void 0;function h(P,A,p,b,k,R){if(Array.isArray(P)){let C=0;for(const w of P){const E=h(w,A,p,b,k,R);if(E===10)return E;E>C&&(C=E)}return C}else{if(typeof P=="string")return b?P==="*"?5:P===p?10:0:0;if(P){const{language:C,pattern:w,scheme:E,hasAccessToAllModels:S,notebookType:c}=P;if(!b&&!S)return 0;c&&k&&(A=k);let m=0;if(E)if(E===A.scheme)m=10;else if(E==="*")m=5;else return 0;if(C)if(C===p)m=10;else if(C==="*")m=Math.max(m,5);else return 0;if(c)if(c===R)m=10;else if(c==="*"&&R!==void 0)m=Math.max(m,5);else return 0;if(w){let a;if(typeof w=="string"?a=w:a={...w,base:(0,N.$hc)(w.base)},a===A.fsPath||(0,D.$Nj)(a,A.fsPath))m=10;else return 0}return m}else return 0}}e.$Dt=h}),define(ke[192],Se([1,0,4,12,29,79,127,167,190,3]),function($e,e,D,N,h,P,A,p,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=void 0;class R extends k.$Tc{constructor(w,E,S,c,m,a,i){super(),this.m=this.B(new D.$Wd),this.onDidChangeContent=this.m.event,this.f=E,this.j=!a,this.g=c,this.h=m,this.c=new A.$cC(w,S,i)}equals(w){return!(w instanceof R)||this.f!==w.f||this.getEOL()!==w.getEOL()?!1:this.c.equal(w.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(w){return this.c.createSnapshot(w?this.f:"")}getOffsetAt(w,E){return this.c.getOffsetAt(w,E)}getPositionAt(w){return this.c.getPositionAt(w)}getRangeAt(w,E){const S=w+E,c=this.getPositionAt(w),m=this.getPositionAt(S);return new h.$Ws(c.lineNumber,c.column,m.lineNumber,m.column)}getValueInRange(w,E=0){if(w.isEmpty())return"";const S=this.n(E);return this.c.getValueInRange(w,S)}getValueLengthInRange(w,E=0){if(w.isEmpty())return 0;if(w.startLineNumber===w.endLineNumber)return w.endColumn-w.startColumn;const S=this.getOffsetAt(w.startLineNumber,w.startColumn),c=this.getOffsetAt(w.endLineNumber,w.endColumn);let m=0;const a=this.n(E),i=this.getEOL();if(a.length!==i.length){const n=a.length-i.length,r=w.endLineNumber-w.startLineNumber;m=n*r}return c-S+m}getCharacterCountInRange(w,E=0){if(this.j){let S=0;const c=w.startLineNumber,m=w.endLineNumber;for(let a=c;a<=m;a++){const i=this.getLineContent(a),n=a===c?w.startColumn-1:0,r=a===m?w.endColumn-1:i.length;for(let s=n;s<r;s++)N.$ef(i.charCodeAt(s))?(S=S+1,s=s+1):S=S+1}return S+=this.n(E).length*(m-c),S}return this.getValueLengthInRange(w,E)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(w){return this.c.getLineContent(w)}getLineCharCode(w,E){return this.c.getLineCharCode(w,E)}getCharCode(w){return this.c.getCharCode(w)}getLineLength(w){return this.c.getLineLength(w)}getLineMinColumn(w){return 1}getLineMaxColumn(w){return this.getLineLength(w)+1}getLineFirstNonWhitespaceColumn(w){const E=N.$2e(this.getLineContent(w));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(w){const E=N.$4e(this.getLineContent(w));return E===-1?0:E+2}n(w){switch(w){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(w){this.c.setEOL(w)}applyEdits(w,E,S){let c=this.g,m=this.h,a=this.j,i=!0,n=[];for(let l=0;l<w.length;l++){const u=w[l];i&&u._isTracked&&(i=!1);const v=u.range;if(u.text){let L=!0;a||(L=!N.$pf(u.text),a=L),!c&&L&&(c=N.$of(u.text)),!m&&L&&(m=N.$rf(u.text))}let I="",$=0,f=0,y=0;if(u.text){let L;[$,f,y,L]=(0,p.$wt)(u.text);const T=this.getEOL();L===0||L===(T===`\r
`?2:1)?I=u.text:I=u.text.replace(/\r\n|\r|\n/g,T)}n[l]={sortIndex:l,identifier:u.identifier||null,range:v,rangeOffset:this.getOffsetAt(v.startLineNumber,v.startColumn),rangeLength:this.getValueLengthInRange(v),text:I,eolCount:$,firstLineLength:f,lastLineLength:y,forceMoveMarkers:!!u.forceMoveMarkers,isAutoWhitespaceEdit:u.isAutoWhitespaceEdit||!1}}n.sort(R.u);let r=!1;for(let l=0,u=n.length-1;l<u;l++){const v=n[l].range.getEndPosition(),I=n[l+1].range.getStartPosition();if(I.isBeforeOrEqual(v)){if(I.isBefore(v))throw new Error("Overlapping ranges are not allowed!");r=!0}}i&&(n=this.s(n));const s=S||E?R._getInverseEditRanges(n):[],t=[];if(E)for(let l=0;l<n.length;l++){const u=n[l],v=s[l];if(u.isAutoWhitespaceEdit&&u.range.isEmpty())for(let I=v.startLineNumber;I<=v.endLineNumber;I++){let $="";I===v.startLineNumber&&($=this.getLineContent(u.range.startLineNumber),N.$2e($)!==-1)||t.push({lineNumber:I,oldContent:$})}}let g=null;if(S){let l=0;g=[];for(let u=0;u<n.length;u++){const v=n[u],I=s[u],$=this.getValueInRange(v.range),f=v.rangeOffset+l;l+=v.text.length-$.length,g[u]={sortIndex:v.sortIndex,identifier:v.identifier,range:I,text:$,textChange:new b.$ft(v.rangeOffset,$,f,v.text)}}r||g.sort((u,v)=>u.sortIndex-v.sortIndex)}this.g=c,this.h=m,this.j=a;const o=this.t(n);let d=null;if(E&&t.length>0){t.sort((l,u)=>u.lineNumber-l.lineNumber),d=[];for(let l=0,u=t.length;l<u;l++){const v=t[l].lineNumber;if(l>0&&t[l-1].lineNumber===v)continue;const I=t[l].oldContent,$=this.getLineContent(v);$.length===0||$===I||N.$2e($)!==-1||d.push(v)}}return this.m.fire(),new P.$gv(g,o,d)}s(w){return w.length<1e3?w:[this._toSingleEditOperation(w)]}_toSingleEditOperation(w){let E=!1;const S=w[0].range,c=w[w.length-1].range,m=new h.$Ws(S.startLineNumber,S.startColumn,c.endLineNumber,c.endColumn);let a=S.startLineNumber,i=S.startColumn;const n=[];for(let o=0,d=w.length;o<d;o++){const l=w[o],u=l.range;E=E||l.forceMoveMarkers,n.push(this.getValueInRange(new h.$Ws(a,i,u.startLineNumber,u.startColumn))),l.text.length>0&&n.push(l.text),a=u.endLineNumber,i=u.endColumn}const r=n.join(""),[s,t,g]=(0,p.$wt)(r);return{sortIndex:0,identifier:w[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,0),text:r,eolCount:s,firstLineLength:t,lastLineLength:g,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(w){w.sort(R.w);const E=[];for(let S=0;S<w.length;S++){const c=w[S],m=c.range.startLineNumber,a=c.range.startColumn,i=c.range.endLineNumber,n=c.range.endColumn;if(m===i&&a===n&&c.text.length===0)continue;c.text?(this.c.delete(c.rangeOffset,c.rangeLength),this.c.insert(c.rangeOffset,c.text,!0)):this.c.delete(c.rangeOffset,c.rangeLength);const r=new h.$Ws(m,a,i,n);E.push({range:r,rangeLength:c.rangeLength,text:c.text,rangeOffset:c.rangeOffset,forceMoveMarkers:c.forceMoveMarkers})}return E}findMatchesLineByLine(w,E,S,c){return this.c.findMatchesLineByLine(w,E,S,c)}getPieceTree(){return this.c}static _getInverseEditRange(w,E){const S=w.startLineNumber,c=w.startColumn,[m,a,i]=(0,p.$wt)(E);let n;if(E.length>0){const r=m+1;r===1?n=new h.$Ws(S,c,S,c+a):n=new h.$Ws(S,c,S+r-1,i+1)}else n=new h.$Ws(S,c,S,c);return n}static _getInverseEditRanges(w){const E=[];let S=0,c=0,m=null;for(let a=0,i=w.length;a<i;a++){const n=w[a];let r,s;m?m.range.endLineNumber===n.range.startLineNumber?(r=S,s=c+(n.range.startColumn-m.range.endColumn)):(r=S+(n.range.startLineNumber-m.range.endLineNumber),s=n.range.startColumn):(r=n.range.startLineNumber,s=n.range.startColumn);let t;if(n.text.length>0){const g=n.eolCount+1;g===1?t=new h.$Ws(r,s,r,s+n.firstLineLength):t=new h.$Ws(r,s,r+g-1,n.lastLineLength+1)}else t=new h.$Ws(r,s,r,s);S=t.endLineNumber,c=t.endColumn,E.push(t),m=n}return E}static u(w,E){const S=h.$Ws.compareRangesUsingEnds(w.range,E.range);return S===0?w.sortIndex-E.sortIndex:S}static w(w,E){const S=h.$Ws.compareRangesUsingEnds(w.range,E.range);return S===0?E.sortIndex-w.sortIndex:-S}}e.$dC=R}),define(ke[193],Se([1,0,12,127,192]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=void 0;class P{constructor(b,k,R,C,w,E,S,c,m){this.a=b,this.b=k,this.c=R,this.d=C,this.e=w,this.f=E,this.g=S,this.h=c,this.j=m}k(b){const k=this.c+this.d+this.e,R=this.c+this.e;return k===0?b===1?`
`:`\r
`:R>k/2?`\r
`:`
`}create(b){const k=this.k(b),R=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let w=0,E=R.length;w<E;w++){const S=R[w].buffer.replace(/\r\n|\r|\n/g,k),c=(0,N.$$B)(S);R[w]=new N.$bC(S,c)}const C=new h.$dC(R,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText(b){return this.a[0].buffer.substr(0,b).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(b){if(b.length===0)return;this.a.length===0&&D.$xf(b)&&(this.b=D.$wf,b=b.substr(1));const k=b.charCodeAt(b.length-1);k===13||k>=55296&&k<=56319?(this.m(b.substr(0,b.length-1),!1),this.c=!0,this.d=k):(this.m(b,!1),this.c=!1,this.d=k)}m(b,k){!k&&b.length===0||(this.c?this.n(String.fromCharCode(this.d)+b):this.n(b))}n(b){const k=(0,N.$_B)(this.e,b);this.a.push(new N.$bC(b,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=D.$of(b)),this.k||(this.k=D.$rf(b)))}finish(b=!0){return this.o(),new P(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,b)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const b=this.a[this.a.length-1];b.buffer+=String.fromCharCode(this.d);const k=(0,N.$$B)(b.buffer);b.lineStarts=k,this.d===13&&this.f++}}}e.$eC=A}),define(ke[131],Se([1,0,21,11]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L$=e.$K$=void 0;var h;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(h||(h={}));function P(C){for(let w=0,E=C.length;w<E;w+=4){const S=C[w+0],c=C[w+1],m=C[w+2],a=C[w+3];C[w+0]=a,C[w+1]=m,C[w+2]=c,C[w+3]=S}}function A(C){const w=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return N.$D()||P(w),D.$ke.wrap(w)}function p(C){const w=C.buffer;if(N.$D()||P(w),w.byteOffset%4===0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const E=new Uint8Array(w.byteLength);return E.set(w),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function b(C){const w=new Uint32Array(k(C));let E=0;if(w[E++]=C.id,C.type==="full")w[E++]=1,w[E++]=C.data.length,w.set(C.data,E),E+=C.data.length;else{w[E++]=2,w[E++]=C.deltas.length;for(const S of C.deltas)w[E++]=S.start,w[E++]=S.deleteCount,S.data?(w[E++]=S.data.length,w.set(S.data,E),E+=S.data.length):w[E++]=0}return A(w)}e.$K$=b;function k(C){let w=0;if(w+=1+1,C.type==="full")w+=1+C.data.length;else{w+=1,w+=(1+1+1)*C.deltas.length;for(const E of C.deltas)E.data&&(w+=E.data.length)}return w}function R(C){const w=p(C);let E=0;const S=w[E++];if(w[E++]===1){const i=w[E++],n=w.subarray(E,E+i);return E+=i,{id:S,type:"full",data:n}}const m=w[E++],a=[];for(let i=0;i<m;i++){const n=w[E++],r=w[E++],s=w[E++];let t;s>0&&(t=w.subarray(E,E+s),E+=s),a[i]={start:n,deleteCount:r,data:t}}return{id:S,type:"delta",deltas:a}}e.$L$=R}),define(ke[194],Se([9,10]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(ke[132],Se([1,0,19,24,11,170,126,194]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var b;(function(ie){ie[ie.None=0]="None",ie[ie.Keep=1]="Keep",ie[ie.Brackets=2]="Brackets",ie[ie.Advanced=3]="Advanced",ie[ie.Full=4]="Full"})(b||(e.EditorAutoIndentStrategy=b={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(se){this.c=se}hasChanged(se){return this.c[se]}}e.ConfigurationChangedEvent=k;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class C{constructor(se,Ie,qe,Ye){this.id=se,this.name=Ie,this.defaultValue=qe,this.schema=Ye}applyUpdate(se,Ie){return E(se,Ie)}compute(se,Ie,qe){return qe}}class w{constructor(se,Ie){this.newValue=se,this.didChange=Ie}}e.ApplyUpdateResult=w;function E(ie,se){if(typeof ie!="object"||typeof se!="object"||!ie||!se)return new w(se,ie!==se);if(Array.isArray(ie)||Array.isArray(se)){const qe=Array.isArray(ie)&&Array.isArray(se)&&D.$ub(ie,se);return new w(se,!qe)}let Ie=!1;for(const qe in se)if(se.hasOwnProperty(qe)){const Ye=E(ie[qe],se[qe]);Ye.didChange&&(ie[qe]=Ye.newValue,Ie=!0)}return new w(ie,Ie)}class S{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Ie){return E(se,Ie)}validate(se){return this.defaultValue}}class c{constructor(se,Ie,qe,Ye){this.id=se,this.name=Ie,this.defaultValue=qe,this.schema=Ye}applyUpdate(se,Ie){return E(se,Ie)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Ie,qe){return qe}}function m(ie,se){return typeof ie>"u"?se:ie==="false"?!1:!!ie}e.boolean=m;class a extends c{constructor(se,Ie,qe,Ye=void 0){typeof Ye<"u"&&(Ye.type="boolean",Ye.default=qe),super(se,Ie,qe,Ye)}validate(se){return m(se,this.defaultValue)}}function i(ie,se,Ie,qe){if(typeof ie>"u")return se;let Ye=parseInt(ie,10);return isNaN(Ye)?se:(Ye=Math.max(Ie,Ye),Ye=Math.min(qe,Ye),Ye|0)}e.clampedInt=i;class n extends c{static clampedInt(se,Ie,qe,Ye){return i(se,Ie,qe,Ye)}constructor(se,Ie,qe,Ye,it,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=qe,nt.minimum=Ye,nt.maximum=it),super(se,Ie,qe,nt),this.minimum=Ye,this.maximum=it}validate(se){return n.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}function r(ie,se,Ie,qe){if(typeof ie>"u")return se;const Ye=s.float(ie,se);return s.clamp(Ye,Ie,qe)}e.clampedFloat=r;class s extends c{static clamp(se,Ie,qe){return se<Ie?Ie:se>qe?qe:se}static float(se,Ie){if(typeof se=="number")return se;if(typeof se>"u")return Ie;const qe=parseFloat(se);return isNaN(qe)?Ie:qe}constructor(se,Ie,qe,Ye,it){typeof it<"u"&&(it.type="number",it.default=qe),super(se,Ie,qe,it),this.validationFn=Ye}validate(se){return this.validationFn(s.float(se,this.defaultValue))}}class t extends c{static string(se,Ie){return typeof se!="string"?Ie:se}constructor(se,Ie,qe,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.default=qe),super(se,Ie,qe,Ye)}validate(se){return t.string(se,this.defaultValue)}}function g(ie,se,Ie,qe){return typeof ie!="string"?se:qe&&ie in qe?qe[ie]:Ie.indexOf(ie)===-1?se:ie}e.stringSet=g;class o extends c{constructor(se,Ie,qe,Ye,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Ye,it.default=qe),super(se,Ie,qe,it),this.c=Ye}validate(se){return g(se,this.defaultValue,this.c)}}class d extends C{constructor(se,Ie,qe,Ye,it,nt,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.enum=it,Oe.default=Ye),super(se,Ie,qe,Oe),this.c=it,this.d=nt}validate(se){return typeof se!="string"?this.defaultValue:this.c.indexOf(se)===-1?this.defaultValue:this.d(se)}}function l(ie){switch(ie){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Ie,qe){return qe===0?se.accessibilitySupport:qe}}class v extends C{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:p.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{insertSpace:m(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(ie){ie[ie.Hidden=0]="Hidden",ie[ie.Blink=1]="Blink",ie[ie.Smooth=2]="Smooth",ie[ie.Phase=3]="Phase",ie[ie.Expand=4]="Expand",ie[ie.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function $(ie){switch(ie){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(ie){ie[ie.Line=1]="Line",ie[ie.Block=2]="Block",ie[ie.Underline=3]="Underline",ie[ie.LineThin=4]="LineThin",ie[ie.BlockOutline=5]="BlockOutline",ie[ie.UnderlineThin=6]="UnderlineThin"})(f||(e.TextEditorCursorStyle=f={}));function y(ie){switch(ie){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function L(ie){switch(ie){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class T extends S{constructor(){super(140)}compute(se,Ie,qe){const Ye=["monaco-editor"];return Ie.get(39)&&Ye.push(Ie.get(39)),se.extraEditorClassName&&Ye.push(se.extraEditorClassName),Ie.get(73)==="default"?Ye.push("mouse-default"):Ie.get(73)==="copy"&&Ye.push("mouse-copy"),Ie.get(110)&&Ye.push("showUnused"),Ie.get(138)&&Ye.push("showDeprecated"),Ye.join(" ")}}class U extends a{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(se,Ie,qe){return qe&&se.emptySelectionClipboard}}class j extends C{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:p.localize(16,null),included:h.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:p.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{cursorMoveOnType:m(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":g(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":g(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(Ie.loop,this.defaultValue.loop)}}}class F extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"||se.length===0?F.OFF:se==="true"?F.ON:se:se?F.ON:F.OFF}}e.EditorFontLigatures=F;class M extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?M.OFF:se==="true"?M.TRANSLATE:se:se?M.TRANSLATE:M.OFF}compute(se,Ie,qe){return se.fontInfo.fontVariationSettings}}e.EditorFontVariations=M;class O extends S{constructor(){super(50)}compute(se,Ie,qe){return se.fontInfo}}class z extends c{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(se){const Ie=s.float(se,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(Ie,6,100)}compute(se,Ie,qe){return se.fontInfo.fontSize}}class J extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:J.d,maximum:J.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:J.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(se){return se==="normal"||se==="bold"?se:String(n.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,J.d,J.e))}}class te extends C{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:qe,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:qe,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:qe,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:qe,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:qe,description:p.localize(41,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{multiple:g(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??g(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??g(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??g(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??g(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??g(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends C{constructor(){const se={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:se.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:se.above,description:p.localize(46,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:m(Ie.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(Ie.above,this.defaultValue.above)}}}var X;(function(ie){ie[ie.None=0]="None",ie[ie.Text=1]="Text",ie[ie.Blocks=2]="Blocks"})(X||(e.RenderMinimap=X={}));class Z extends S{constructor(){super(143)}compute(se,Ie,qe){return Z.computeLayout(Ie,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio,glyphMarginDecorationLaneCount:se.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(se){const Ie=se.height/se.lineHeight,qe=Math.floor(se.paddingTop/se.lineHeight);let Ye=Math.floor(se.paddingBottom/se.lineHeight);se.scrollBeyondLastLine&&(Ye=Math.max(Ye,Ie-1));const it=(qe+se.viewLineCount+Ye)/(se.pixelRatio*se.height),nt=Math.floor(se.viewLineCount/it);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:Ye,desiredRatio:it,minimapLineCount:nt}}static c(se,Ie){const qe=se.outerWidth,Ye=se.outerHeight,it=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const nt=Ie.stableMinimapLayoutInput,Oe=nt&&se.outerHeight===nt.outerHeight&&se.lineHeight===nt.lineHeight&&se.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&se.pixelRatio===nt.pixelRatio&&se.scrollBeyondLastLine===nt.scrollBeyondLastLine&&se.paddingTop===nt.paddingTop&&se.paddingBottom===nt.paddingBottom&&se.minimap.enabled===nt.minimap.enabled&&se.minimap.side===nt.minimap.side&&se.minimap.size===nt.minimap.size&&se.minimap.showSlider===nt.minimap.showSlider&&se.minimap.renderCharacters===nt.minimap.renderCharacters&&se.minimap.maxColumn===nt.minimap.maxColumn&&se.minimap.scale===nt.minimap.scale&&se.verticalScrollbarWidth===nt.verticalScrollbarWidth&&se.isViewportWrapping===nt.isViewportWrapping,yt=se.lineHeight,Dt=se.typicalHalfwidthCharacterWidth,Tt=se.scrollBeyondLastLine,Ft=se.minimap.renderCharacters;let Et=it>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const Ht=se.minimap.maxColumn,Ot=se.minimap.size,Yt=se.minimap.side,Vt=se.verticalScrollbarWidth,Ut=se.viewLineCount,et=se.remainingWidth,Gt=se.isViewportWrapping,Jt=Ft?2:3;let ht=Math.floor(it*Ye);const $t=ht/it;let Bt=!1,Qt=!1,kt=Jt*Et,ft=Et/it,It=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:gt,extraLinesBeforeFirstLine:Nt,extraLinesBeyondLastLine:Pt,desiredRatio:Wt,minimapLineCount:Me}=Z.computeContainedMinimapLineCount({viewLineCount:Ut,scrollBeyondLastLine:Tt,paddingTop:se.paddingTop,paddingBottom:se.paddingBottom,height:Ye,lineHeight:yt,pixelRatio:it});if(Ut/Me>1)Bt=!0,Qt=!0,Et=1,kt=1,ft=Et/it;else{let De=!1,ce=Et+1;if(Ot==="fit"){const Te=Math.ceil((Nt+Ut+Pt)*kt);Gt&&Oe&&et<=Ie.stableFitRemainingWidth?(De=!0,ce=Ie.stableFitMaxMinimapScale):De=Te>ht}if(Ot==="fill"||De){Bt=!0;const Te=Et;kt=Math.min(yt*it,Math.max(1,Math.floor(1/Wt))),Gt&&Oe&&et<=Ie.stableFitRemainingWidth&&(ce=Ie.stableFitMaxMinimapScale),Et=Math.min(ce,Math.max(1,Math.floor(kt/Jt))),Et>Te&&(It=Math.min(2,Et/Te)),ft=Et/it/It,ht=Math.ceil(Math.max(gt,Nt+Ut+Pt)*kt),Gt?(Ie.stableMinimapLayoutInput=se,Ie.stableFitRemainingWidth=et,Ie.stableFitMaxMinimapScale=Et):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const _t=Math.floor(Ht*ft),At=Math.min(_t,Math.max(0,Math.floor((et-Vt-2)*ft/(Dt+ft)))+e.MINIMAP_GUTTER_WIDTH);let Je=Math.floor(it*At);const Mt=Je/it;Je=Math.floor(Je*It);const jt=Ft?1:2,Zt=Yt==="left"?0:qe-At-Vt;return{renderMinimap:jt,minimapLeft:Zt,minimapWidth:At,minimapHeightIsEditorHeight:Bt,minimapIsSampling:Qt,minimapScale:Et,minimapLineHeight:kt,minimapCanvasInnerWidth:Je,minimapCanvasInnerHeight:ht,minimapCanvasOuterWidth:Mt,minimapCanvasOuterHeight:$t}}static computeLayout(se,Ie){const qe=Ie.outerWidth|0,Ye=Ie.outerHeight|0,it=Ie.lineHeight|0,nt=Ie.lineNumbersDigitCount|0,Oe=Ie.typicalHalfwidthCharacterWidth,yt=Ie.maxDigitWidth,Dt=Ie.pixelRatio,Tt=Ie.viewLineCount,Ft=se.get(135),Et=Ft==="inherit"?se.get(134):Ft,Ht=Et==="inherit"?se.get(130):Et,Ot=se.get(133),Yt=Ie.isDominatedByLongLines,Vt=se.get(57),Ut=se.get(67).renderType!==0,et=se.get(68),Gt=se.get(104),Jt=se.get(83),ht=se.get(72),$t=se.get(102),Bt=$t.verticalScrollbarSize,Qt=$t.verticalHasArrows,kt=$t.arrowSize,ft=$t.horizontalScrollbarSize,It=se.get(43),_t=se.get(109)!=="never";let At=se.get(65);It&&_t&&(At+=16);let Je=0;if(Ut){const xe=Math.max(nt,et);Je=Math.round(xe*yt)}let Mt=0;Vt&&(Mt=it*Ie.glyphMarginDecorationLaneCount);let jt=0,Zt=jt+Mt,gt=Zt+Je,Nt=gt+At;const Pt=qe-Mt-Je-At;let Wt=!1,Me=!1,Fe=-1;Et==="inherit"&&Yt?(Wt=!0,Me=!0):Ht==="on"||Ht==="bounded"?Me=!0:Ht==="wordWrapColumn"&&(Fe=Ot);const De=Z.c({outerWidth:qe,outerHeight:Ye,lineHeight:it,typicalHalfwidthCharacterWidth:Oe,pixelRatio:Dt,scrollBeyondLastLine:Gt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:ht,verticalScrollbarWidth:Bt,viewLineCount:Tt,remainingWidth:Pt,isViewportWrapping:Me},Ie.memory||new R);De.renderMinimap!==0&&De.minimapLeft===0&&(jt+=De.minimapWidth,Zt+=De.minimapWidth,gt+=De.minimapWidth,Nt+=De.minimapWidth);const ce=Pt-De.minimapWidth,Te=Math.max(1,Math.floor((ce-Bt-2)/Oe)),Be=Qt?kt:0;return Me&&(Fe=Math.max(1,Te),Ht==="bounded"&&(Fe=Math.min(Fe,Ot))),{width:qe,height:Ye,glyphMarginLeft:jt,glyphMarginWidth:Mt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Zt,lineNumbersWidth:Je,decorationsLeft:gt,decorationsWidth:At,contentLeft:Nt,contentWidth:ce,minimap:De,viewportColumn:Te,isWordWrapMinified:Wt,isViewportWrapping:Me,wrappingColumn:Fe,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:ft,overviewRuler:{top:Be,width:Bt,height:Ye-2*Be,right:0}}}}e.EditorLayoutInfoComputer=Z;class ae extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(se){return g(se,"simple",["simple","advanced"])}compute(se,Ie,qe){return Ie.get(2)===2?"advanced":qe}}var _;(function(ie){ie.Off="off",ie.OnCode="onCode",ie.On="on"})(_||(e.ShowLightbulbIconMode=_={}));class ge extends C{constructor(){const se={enabled:_.OnCode};super(64,"lightbulb",se,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[_.Off,_.OnCode,_.On],default:se.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:g(se.enabled,this.defaultValue.enabled,[_.Off,_.OnCode,_.On])}}}class ne extends C{constructor(){const se={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:se.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:se.scrollWithEditor,description:p.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:g(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class K extends C{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,h.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,h.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:p.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:g(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:m(Ie.padding,this.defaultValue.padding)}}}class W extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(se){return typeof se=="string"&&/^\d+(\.\d+)?ch$/.test(se)?-parseFloat(se.substring(0,se.length-2)):n.clampedInt(se,this.defaultValue,0,1e3)}compute(se,Ie,qe){return qe<0?n.clampedInt(-qe*se.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class re extends s{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>s.clamp(se,0,150),{markdownDescription:p.localize(66,null)})}compute(se,Ie,qe){return se.fontInfo.lineHeight}}class ye extends C{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:se.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:p.localize(77,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),autohide:m(Ie.autohide,this.defaultValue.autohide),size:g(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(Ie.side,this.defaultValue.side,["right","left"]),showSlider:g(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ie.scale,1,1,3),maxColumn:n.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function he(ie){return ie==="ctrlCmd"?h.$j?"metaKey":"ctrlKey":"altKey"}class fe extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(79,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{top:n.clampedInt(Ie.top,0,0,1e3),bottom:n.clampedInt(Ie.bottom,0,0,1e3)}}}class ue extends C{constructor(){const se={enabled:!0,cycle:!0};super(85,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:p.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:p.localize(81,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),cycle:m(Ie.cycle,this.defaultValue.cycle)}}}class me extends S{constructor(){super(141)}compute(se,Ie,qe){return se.pixelRatio}}class V extends C{constructor(){const se={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(82,null),p.localize(83,null),p.localize(84,null)]}];super(88,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:se.strings,description:p.localize(85,null)},comments:{anyOf:Ie,default:se.comments,description:p.localize(86,null)},other:{anyOf:Ie,default:se.other,description:p.localize(87,null)}},default:se,markdownDescription:p.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const Dt=se?"on":"off";return{comments:Dt,strings:Dt,other:Dt}}if(!se||typeof se!="object")return this.defaultValue;const{other:Ie,comments:qe,strings:Ye}=se,it=["on","inline","off"];let nt,Oe,yt;return typeof Ie=="boolean"?nt=Ie?"on":"off":nt=g(Ie,this.defaultValue.other,it),typeof qe=="boolean"?Oe=qe?"on":"off":Oe=g(qe,this.defaultValue.comments,it),typeof Ye=="boolean"?yt=Ye?"on":"off":yt=g(Ye,this.defaultValue.strings,it),{other:nt,comments:Oe,strings:yt}}}var Y;(function(ie){ie[ie.Off=0]="Off",ie[ie.On=1]="On",ie[ie.Relative=2]="Relative",ie[ie.Interval=3]="Interval",ie[ie.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class de extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(89,null),p.localize(90,null),p.localize(91,null),p.localize(92,null)],default:"on",description:p.localize(93,null)})}validate(se){let Ie=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Ie=4,qe=se):se==="interval"?Ie=3:se==="relative"?Ie=2:se==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:qe}}}function we(ie){const se=ie.get(97);return se==="editable"?ie.get(90):se!=="on"}e.filterValidationDecorations=we;class Pe extends C{constructor(){const se=[],Ie={type:"number",description:p.localize(94,null)};super(101,"rulers",se,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:p.localize(95,null),format:"color-hex"}}}]},default:se,description:p.localize(96,null)})}validate(se){if(Array.isArray(se)){const Ie=[];for(const qe of se)if(typeof qe=="number")Ie.push({column:n.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const Ye=qe;Ie.push({column:n.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return Ie.sort((qe,Ye)=>qe.column-Ye.column),Ie}return this.defaultValue}}class ve extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(se){return!se||typeof se!="object"?this.defaultValue:se}}function Ce(ie,se){if(typeof ie!="string")return se;switch(ie){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends C{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(97,null),p.localize(98,null),p.localize(99,null)],default:"auto",description:p.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(101,null),p.localize(102,null),p.localize(103,null)],default:"auto",description:p.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:p.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:p.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:p.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:se.ignoreHorizontalScrollbarInContentHeight,description:p.localize(108,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se,qe=n.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=n.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(Ie.vertical,this.defaultValue.vertical),horizontal:Ce(Ie.horizontal,this.defaultValue.horizontal),useShadows:m(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:n.clampedInt(Ie.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:n.clampedInt(Ie.verticalSliderSize,Ye,0,1e3),scrollByPage:m(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends C{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:p.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:p.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:p.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:p.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:p.localize(115,null)}})}applyUpdate(se,Ie){let qe=!1;Ie.allowedCharacters&&se&&(N.$Cn(se.allowedCharacters,Ie.allowedCharacters)||(se={...se,allowedCharacters:Ie.allowedCharacters},qe=!0)),Ie.allowedLocales&&se&&(N.$Cn(se.allowedLocales,Ie.allowedLocales)||(se={...se,allowedLocales:Ie.allowedLocales},qe=!0));const Ye=super.applyUpdate(se,Ie);return qe?new w(Ye.newValue,!0):Ye}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{nonBasicASCII:le(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:le(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:le(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(se.allowedLocales,this.defaultValue.allowedLocales)}}c(se,Ie){if(typeof se!="object"||!se)return Ie;const qe={};for(const[Ye,it]of Object.entries(se))it===!0&&(qe[Ye]=!0);return qe}}class ee extends C{constructor(){const se={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:p.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:se.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(117,null),p.localize(118,null),p.localize(119,null)],description:p.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:se.suppressSuggestions,description:p.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:se.fontFamily,description:p.localize(122,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),mode:g(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:g(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(Ie.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily)}}}class H extends C{constructor(){const se={enabled:P.$us.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.$us.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:p.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:p.localize(124,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class oe extends C{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(125,null),p.localize(126,null),p.localize(127,null)],default:se.bracketPairs,description:p.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(129,null),p.localize(130,null),p.localize(131,null)],default:se.bracketPairsHorizontal,description:p.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:p.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:p.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:se.highlightActiveIndentation,description:p.localize(138,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{bracketPairs:le(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:le(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:le(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function le(ie,se,Ie){const qe=Ie.indexOf(ie);return qe===-1?se:Ie[qe]}class Re extends C{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(139,null),p.localize(140,null)],default:se.insertMode,description:p.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:p.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:p.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:p.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null),p.localize(148,null)],default:se.selectionMode,markdownDescription:p.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:p.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:p.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:p.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:p.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:p.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{insertMode:g(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:g(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:m(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:m(Ie.preview,this.defaultValue.preview),previewMode:g(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(Ie.showMethods,this.defaultValue.showMethods),showFunctions:m(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:m(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(Ie.showFields,this.defaultValue.showFields),showVariables:m(Ie.showVariables,this.defaultValue.showVariables),showClasses:m(Ie.showClasses,this.defaultValue.showClasses),showStructs:m(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:m(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:m(Ie.showModules,this.defaultValue.showModules),showProperties:m(Ie.showProperties,this.defaultValue.showProperties),showEvents:m(Ie.showEvents,this.defaultValue.showEvents),showOperators:m(Ie.showOperators,this.defaultValue.showOperators),showUnits:m(Ie.showUnits,this.defaultValue.showUnits),showValues:m(Ie.showValues,this.defaultValue.showValues),showConstants:m(Ie.showConstants,this.defaultValue.showConstants),showEnums:m(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:m(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(Ie.showKeywords,this.defaultValue.showKeywords),showWords:m(Ie.showWords,this.defaultValue.showWords),showColors:m(Ie.showColors,this.defaultValue.showColors),showFiles:m(Ie.showFiles,this.defaultValue.showFiles),showReferences:m(Ie.showReferences,this.defaultValue.showReferences),showFolders:m(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:m(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:m(Ie.showUsers,this.defaultValue.showUsers),showIssues:m(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(188,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(se.selectSubwords,this.defaultValue.selectSubwords)}}}var He;(function(ie){ie[ie.None=0]="None",ie[ie.Same=1]="Same",ie[ie.Indent=2]="Indent",ie[ie.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class Qe extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(189,null),p.localize(190,null),p.localize(191,null),p.localize(192,null)],description:p.localize(193,null),default:"same"}})}validate(se){switch(se){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(se,Ie,qe){return Ie.get(2)===2?0:qe}}class _e extends S{constructor(){super(144)}compute(se,Ie,qe){const Ye=Ie.get(143);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}class at extends C{constructor(){const se={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:p.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(196,null),p.localize(197,null)],default:"afterDrop"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),showDropSelector:g(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends C{constructor(){const se={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",se,{"editor.pasteAs.enabled":{type:"boolean",default:se.enabled,markdownDescription:p.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(200,null),p.localize(201,null)],default:"afterPaste"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),showPasteSelector:g(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",Le="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:h.$j?Le:h.$k?ze:rt,fontWeight:"normal",fontSize:h.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ae(ie){return e.editorOptionsRegistry[ie.id]=ie,ie}var Ze;(function(ie){ie[ie.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ie[ie.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ie[ie.accessibilitySupport=2]="accessibilitySupport",ie[ie.accessibilityPageSize=3]="accessibilityPageSize",ie[ie.ariaLabel=4]="ariaLabel",ie[ie.ariaRequired=5]="ariaRequired",ie[ie.autoClosingBrackets=6]="autoClosingBrackets",ie[ie.autoClosingComments=7]="autoClosingComments",ie[ie.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ie[ie.autoClosingDelete=9]="autoClosingDelete",ie[ie.autoClosingOvertype=10]="autoClosingOvertype",ie[ie.autoClosingQuotes=11]="autoClosingQuotes",ie[ie.autoIndent=12]="autoIndent",ie[ie.automaticLayout=13]="automaticLayout",ie[ie.autoSurround=14]="autoSurround",ie[ie.bracketPairColorization=15]="bracketPairColorization",ie[ie.guides=16]="guides",ie[ie.codeLens=17]="codeLens",ie[ie.codeLensFontFamily=18]="codeLensFontFamily",ie[ie.codeLensFontSize=19]="codeLensFontSize",ie[ie.colorDecorators=20]="colorDecorators",ie[ie.colorDecoratorsLimit=21]="colorDecoratorsLimit",ie[ie.columnSelection=22]="columnSelection",ie[ie.comments=23]="comments",ie[ie.contextmenu=24]="contextmenu",ie[ie.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ie[ie.cursorBlinking=26]="cursorBlinking",ie[ie.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ie[ie.cursorStyle=28]="cursorStyle",ie[ie.cursorSurroundingLines=29]="cursorSurroundingLines",ie[ie.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ie[ie.cursorWidth=31]="cursorWidth",ie[ie.disableLayerHinting=32]="disableLayerHinting",ie[ie.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ie[ie.domReadOnly=34]="domReadOnly",ie[ie.dragAndDrop=35]="dragAndDrop",ie[ie.dropIntoEditor=36]="dropIntoEditor",ie[ie.emptySelectionClipboard=37]="emptySelectionClipboard",ie[ie.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ie[ie.extraEditorClassName=39]="extraEditorClassName",ie[ie.fastScrollSensitivity=40]="fastScrollSensitivity",ie[ie.find=41]="find",ie[ie.fixedOverflowWidgets=42]="fixedOverflowWidgets",ie[ie.folding=43]="folding",ie[ie.foldingStrategy=44]="foldingStrategy",ie[ie.foldingHighlight=45]="foldingHighlight",ie[ie.foldingImportsByDefault=46]="foldingImportsByDefault",ie[ie.foldingMaximumRegions=47]="foldingMaximumRegions",ie[ie.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ie[ie.fontFamily=49]="fontFamily",ie[ie.fontInfo=50]="fontInfo",ie[ie.fontLigatures=51]="fontLigatures",ie[ie.fontSize=52]="fontSize",ie[ie.fontWeight=53]="fontWeight",ie[ie.fontVariations=54]="fontVariations",ie[ie.formatOnPaste=55]="formatOnPaste",ie[ie.formatOnType=56]="formatOnType",ie[ie.glyphMargin=57]="glyphMargin",ie[ie.gotoLocation=58]="gotoLocation",ie[ie.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ie[ie.hover=60]="hover",ie[ie.inDiffEditor=61]="inDiffEditor",ie[ie.inlineSuggest=62]="inlineSuggest",ie[ie.letterSpacing=63]="letterSpacing",ie[ie.lightbulb=64]="lightbulb",ie[ie.lineDecorationsWidth=65]="lineDecorationsWidth",ie[ie.lineHeight=66]="lineHeight",ie[ie.lineNumbers=67]="lineNumbers",ie[ie.lineNumbersMinChars=68]="lineNumbersMinChars",ie[ie.linkedEditing=69]="linkedEditing",ie[ie.links=70]="links",ie[ie.matchBrackets=71]="matchBrackets",ie[ie.minimap=72]="minimap",ie[ie.mouseStyle=73]="mouseStyle",ie[ie.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ie[ie.mouseWheelZoom=75]="mouseWheelZoom",ie[ie.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ie[ie.multiCursorModifier=77]="multiCursorModifier",ie[ie.multiCursorPaste=78]="multiCursorPaste",ie[ie.multiCursorLimit=79]="multiCursorLimit",ie[ie.occurrencesHighlight=80]="occurrencesHighlight",ie[ie.overviewRulerBorder=81]="overviewRulerBorder",ie[ie.overviewRulerLanes=82]="overviewRulerLanes",ie[ie.padding=83]="padding",ie[ie.pasteAs=84]="pasteAs",ie[ie.parameterHints=85]="parameterHints",ie[ie.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ie[ie.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ie[ie.quickSuggestions=88]="quickSuggestions",ie[ie.quickSuggestionsDelay=89]="quickSuggestionsDelay",ie[ie.readOnly=90]="readOnly",ie[ie.readOnlyMessage=91]="readOnlyMessage",ie[ie.renameOnType=92]="renameOnType",ie[ie.renderControlCharacters=93]="renderControlCharacters",ie[ie.renderFinalNewline=94]="renderFinalNewline",ie[ie.renderLineHighlight=95]="renderLineHighlight",ie[ie.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ie[ie.renderValidationDecorations=97]="renderValidationDecorations",ie[ie.renderWhitespace=98]="renderWhitespace",ie[ie.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ie[ie.roundedSelection=100]="roundedSelection",ie[ie.rulers=101]="rulers",ie[ie.scrollbar=102]="scrollbar",ie[ie.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ie[ie.scrollBeyondLastLine=104]="scrollBeyondLastLine",ie[ie.scrollPredominantAxis=105]="scrollPredominantAxis",ie[ie.selectionClipboard=106]="selectionClipboard",ie[ie.selectionHighlight=107]="selectionHighlight",ie[ie.selectOnLineNumbers=108]="selectOnLineNumbers",ie[ie.showFoldingControls=109]="showFoldingControls",ie[ie.showUnused=110]="showUnused",ie[ie.snippetSuggestions=111]="snippetSuggestions",ie[ie.smartSelect=112]="smartSelect",ie[ie.smoothScrolling=113]="smoothScrolling",ie[ie.stickyScroll=114]="stickyScroll",ie[ie.stickyTabStops=115]="stickyTabStops",ie[ie.stopRenderingLineAfter=116]="stopRenderingLineAfter",ie[ie.suggest=117]="suggest",ie[ie.suggestFontSize=118]="suggestFontSize",ie[ie.suggestLineHeight=119]="suggestLineHeight",ie[ie.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ie[ie.suggestSelection=121]="suggestSelection",ie[ie.tabCompletion=122]="tabCompletion",ie[ie.tabIndex=123]="tabIndex",ie[ie.unicodeHighlighting=124]="unicodeHighlighting",ie[ie.unusualLineTerminators=125]="unusualLineTerminators",ie[ie.useShadowDOM=126]="useShadowDOM",ie[ie.useTabStops=127]="useTabStops",ie[ie.wordBreak=128]="wordBreak",ie[ie.wordSeparators=129]="wordSeparators",ie[ie.wordWrap=130]="wordWrap",ie[ie.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ie[ie.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ie[ie.wordWrapColumn=133]="wordWrapColumn",ie[ie.wordWrapOverride1=134]="wordWrapOverride1",ie[ie.wordWrapOverride2=135]="wordWrapOverride2",ie[ie.wrappingIndent=136]="wrappingIndent",ie[ie.wrappingStrategy=137]="wrappingStrategy",ie[ie.showDeprecated=138]="showDeprecated",ie[ie.inlayHints=139]="inlayHints",ie[ie.editorClassName=140]="editorClassName",ie[ie.pixelRatio=141]="pixelRatio",ie[ie.tabFocusMode=142]="tabFocusMode",ie[ie.layoutInfo=143]="layoutInfo",ie[ie.wrappingInfo=144]="wrappingInfo",ie[ie.defaultColorDecorators=145]="defaultColorDecorators",ie[ie.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ie[ie.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Ze||(e.EditorOption=Ze={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ae(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(202,null)})),acceptSuggestionOnEnter:Ae(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(203,null),""],markdownDescription:p.localize(204,null)})),accessibilitySupport:Ae(new u),accessibilityPageSize:Ae(new n(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(205,null),tags:["accessibility"]})),ariaLabel:Ae(new t(4,"ariaLabel",p.localize(206,null))),ariaRequired:Ae(new a(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ae(new a(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Ae(new o(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(208,null),p.localize(209,null),""],description:p.localize(210,null)})),autoClosingComments:Ae(new o(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(211,null),p.localize(212,null),""],description:p.localize(213,null)})),autoClosingDelete:Ae(new o(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(214,null),""],description:p.localize(215,null)})),autoClosingOvertype:Ae(new o(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(216,null),""],description:p.localize(217,null)})),autoClosingQuotes:Ae(new o(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(218,null),p.localize(219,null),""],description:p.localize(220,null)})),autoIndent:Ae(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[p.localize(221,null),p.localize(222,null),p.localize(223,null),p.localize(224,null),p.localize(225,null)],description:p.localize(226,null)})),automaticLayout:Ae(new a(13,"automaticLayout",!1)),autoSurround:Ae(new o(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(227,null),p.localize(228,null),p.localize(229,null),""],description:p.localize(230,null)})),bracketPairColorization:Ae(new H),bracketPairGuides:Ae(new oe),stickyTabStops:Ae(new a(115,"stickyTabStops",!1,{description:p.localize(231,null)})),codeLens:Ae(new a(17,"codeLens",!0,{description:p.localize(232,null)})),codeLensFontFamily:Ae(new t(18,"codeLensFontFamily","",{description:p.localize(233,null)})),codeLensFontSize:Ae(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(234,null)})),colorDecorators:Ae(new a(20,"colorDecorators",!0,{description:p.localize(235,null)})),colorDecoratorActivatedOn:Ae(new o(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(236,null),p.localize(237,null),p.localize(238,null)],description:p.localize(239,null)})),colorDecoratorsLimit:Ae(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(240,null)})),columnSelection:Ae(new a(22,"columnSelection",!1,{description:p.localize(241,null)})),comments:Ae(new v),contextmenu:Ae(new a(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ae(new a(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(242,null)})),cursorBlinking:Ae(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],$,{description:p.localize(243,null)})),cursorSmoothCaretAnimation:Ae(new o(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(244,null),p.localize(245,null),p.localize(246,null)],description:p.localize(247,null)})),cursorStyle:Ae(new d(28,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:p.localize(248,null)})),cursorSurroundingLines:Ae(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(249,null)})),cursorSurroundingLinesStyle:Ae(new o(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(250,null),p.localize(251,null)],markdownDescription:p.localize(252,null)})),cursorWidth:Ae(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(253,null)})),disableLayerHinting:Ae(new a(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ae(new a(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ae(new a(34,"domReadOnly",!1)),dragAndDrop:Ae(new a(35,"dragAndDrop",!0,{description:p.localize(254,null)})),emptySelectionClipboard:Ae(new U),dropIntoEditor:Ae(new at),stickyScroll:Ae(new ne),experimentalWhitespaceRendering:Ae(new o(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(255,null),p.localize(256,null),p.localize(257,null)],description:p.localize(258,null)})),extraEditorClassName:Ae(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ae(new s(40,"fastScrollSensitivity",5,ie=>ie<=0?5:ie,{markdownDescription:p.localize(259,null)})),find:Ae(new j),fixedOverflowWidgets:Ae(new a(42,"fixedOverflowWidgets",!1)),folding:Ae(new a(43,"folding",!0,{description:p.localize(260,null)})),foldingStrategy:Ae(new o(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(261,null),p.localize(262,null)],description:p.localize(263,null)})),foldingHighlight:Ae(new a(45,"foldingHighlight",!0,{description:p.localize(264,null)})),foldingImportsByDefault:Ae(new a(46,"foldingImportsByDefault",!1,{description:p.localize(265,null)})),foldingMaximumRegions:Ae(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(266,null)})),unfoldOnClickAfterEndOfLine:Ae(new a(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(267,null)})),fontFamily:Ae(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(268,null)})),fontInfo:Ae(new O),fontLigatures2:Ae(new F),fontSize:Ae(new z),fontWeight:Ae(new J),fontVariations:Ae(new M),formatOnPaste:Ae(new a(55,"formatOnPaste",!1,{description:p.localize(269,null)})),formatOnType:Ae(new a(56,"formatOnType",!1,{description:p.localize(270,null)})),glyphMargin:Ae(new a(57,"glyphMargin",!0,{description:p.localize(271,null)})),gotoLocation:Ae(new te),hideCursorInOverviewRuler:Ae(new a(59,"hideCursorInOverviewRuler",!1,{description:p.localize(272,null)})),hover:Ae(new x),inDiffEditor:Ae(new a(61,"inDiffEditor",!1)),letterSpacing:Ae(new s(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ie=>s.clamp(ie,-5,20),{description:p.localize(273,null)})),lightbulb:Ae(new ge),lineDecorationsWidth:Ae(new W),lineHeight:Ae(new re),lineNumbers:Ae(new de),lineNumbersMinChars:Ae(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ae(new a(69,"linkedEditing",!1,{description:p.localize(274,null)})),links:Ae(new a(70,"links",!0,{description:p.localize(275,null)})),matchBrackets:Ae(new o(71,"matchBrackets","always",["always","near","never"],{description:p.localize(276,null)})),minimap:Ae(new ye),mouseStyle:Ae(new o(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ae(new s(74,"mouseWheelScrollSensitivity",1,ie=>ie===0?1:ie,{markdownDescription:p.localize(277,null)})),mouseWheelZoom:Ae(new a(75,"mouseWheelZoom",!1,{markdownDescription:h.$j?p.localize(278,null):p.localize(279,null)})),multiCursorMergeOverlapping:Ae(new a(76,"multiCursorMergeOverlapping",!0,{description:p.localize(280,null)})),multiCursorModifier:Ae(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[p.localize(281,null),p.localize(282,null)],markdownDescription:p.localize(283,null)})),multiCursorPaste:Ae(new o(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(284,null),p.localize(285,null)],markdownDescription:p.localize(286,null)})),multiCursorLimit:Ae(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(287,null)})),occurrencesHighlight:Ae(new o(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(288,null),p.localize(289,null),p.localize(290,null)],markdownDescription:p.localize(291,null)})),overviewRulerBorder:Ae(new a(81,"overviewRulerBorder",!0,{description:p.localize(292,null)})),overviewRulerLanes:Ae(new n(82,"overviewRulerLanes",3,0,3)),padding:Ae(new fe),pasteAs:Ae(new st),parameterHints:Ae(new ue),peekWidgetDefaultFocus:Ae(new o(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(293,null),p.localize(294,null)],description:p.localize(295,null)})),definitionLinkOpensInPeek:Ae(new a(87,"definitionLinkOpensInPeek",!1,{description:p.localize(296,null)})),quickSuggestions:Ae(new V),quickSuggestionsDelay:Ae(new n(89,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(297,null)})),readOnly:Ae(new a(90,"readOnly",!1)),readOnlyMessage:Ae(new ve),renameOnType:Ae(new a(92,"renameOnType",!1,{description:p.localize(298,null),markdownDeprecationMessage:p.localize(299,null)})),renderControlCharacters:Ae(new a(93,"renderControlCharacters",!0,{description:p.localize(300,null),restricted:!0})),renderFinalNewline:Ae(new o(94,"renderFinalNewline",h.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(301,null)})),renderLineHighlight:Ae(new o(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(302,null)],description:p.localize(303,null)})),renderLineHighlightOnlyWhenFocus:Ae(new a(96,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(304,null)})),renderValidationDecorations:Ae(new o(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ae(new o(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(305,null),p.localize(306,null),p.localize(307,null),""],description:p.localize(308,null)})),revealHorizontalRightPadding:Ae(new n(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ae(new a(100,"roundedSelection",!0,{description:p.localize(309,null)})),rulers:Ae(new Pe),scrollbar:Ae(new B),scrollBeyondLastColumn:Ae(new n(103,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(310,null)})),scrollBeyondLastLine:Ae(new a(104,"scrollBeyondLastLine",!0,{description:p.localize(311,null)})),scrollPredominantAxis:Ae(new a(105,"scrollPredominantAxis",!0,{description:p.localize(312,null)})),selectionClipboard:Ae(new a(106,"selectionClipboard",!0,{description:p.localize(313,null),included:h.$k})),selectionHighlight:Ae(new a(107,"selectionHighlight",!0,{description:p.localize(314,null)})),selectOnLineNumbers:Ae(new a(108,"selectOnLineNumbers",!0)),showFoldingControls:Ae(new o(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(315,null),p.localize(316,null),p.localize(317,null)],description:p.localize(318,null)})),showUnused:Ae(new a(110,"showUnused",!0,{description:p.localize(319,null)})),showDeprecated:Ae(new a(138,"showDeprecated",!0,{description:p.localize(320,null)})),inlayHints:Ae(new K),snippetSuggestions:Ae(new o(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(321,null),p.localize(322,null),p.localize(323,null),p.localize(324,null)],description:p.localize(325,null)})),smartSelect:Ae(new je),smoothScrolling:Ae(new a(113,"smoothScrolling",!1,{description:p.localize(326,null)})),stopRenderingLineAfter:Ae(new n(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ae(new Re),inlineSuggest:Ae(new ee),inlineCompletionsAccessibilityVerbose:Ae(new a(147,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(327,null)})),suggestFontSize:Ae(new n(118,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ae(new n(119,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ae(new a(120,"suggestOnTriggerCharacters",!0,{description:p.localize(330,null)})),suggestSelection:Ae(new o(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(331,null),p.localize(332,null),p.localize(333,null)],description:p.localize(334,null)})),tabCompletion:Ae(new o(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(335,null),p.localize(336,null),p.localize(337,null)],description:p.localize(338,null)})),tabIndex:Ae(new n(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ae(new Q),unusualLineTerminators:Ae(new o(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(339,null),p.localize(340,null),p.localize(341,null)],description:p.localize(342,null)})),useShadowDOM:Ae(new a(126,"useShadowDOM",!0)),useTabStops:Ae(new a(127,"useTabStops",!0,{description:p.localize(343,null)})),wordBreak:Ae(new o(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),wordSeparators:Ae(new t(129,"wordSeparators",A.$vs,{description:p.localize(347,null)})),wordWrap:Ae(new o(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(348,null),p.localize(349,null),p.localize(350,null),p.localize(351,null)],description:p.localize(352,null)})),wordWrapBreakAfterCharacters:Ae(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ae(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ae(new n(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(353,null)})),wordWrapOverride1:Ae(new o(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ae(new o(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ae(new T),defaultColorDecorators:Ae(new a(145,"defaultColorDecorators",!1,{markdownDescription:p.localize(354,null)})),pixelRatio:Ae(new me),tabFocusMode:Ae(new a(142,"tabFocusMode",!1,{markdownDescription:p.localize(355,null)})),layoutInfo:Ae(new Z),wrappingInfo:Ae(new _e),wrappingIndent:Ae(new Qe),wrappingStrategy:Ae(new ae)}}),define(ke[195],Se([9,10]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(ke[83],Se([1,0,78,2,168,29,178,195]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$Ot=e.$Nt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$Mt=e.$Lt=e.SymbolKinds=e.SymbolTag=e.$Kt=e.$Jt=e.SymbolKind=e.$It=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$Ht=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Gt=e.$Ft=e.$Et=void 0;class b{constructor(F,M,O){this.offset=F,this.type=M,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Et=b;class k{constructor(F,M){this.tokens=F,this.endState=M,this._tokenizationResultBrand=void 0}}e.$Ft=k;class R{constructor(F,M){this.tokens=F,this.endState=M,this._encodedTokenizationResultBrand=void 0}}e.$Gt=R;var C;(function(j){j[j.Method=0]="Method",j[j.Function=1]="Function",j[j.Constructor=2]="Constructor",j[j.Field=3]="Field",j[j.Variable=4]="Variable",j[j.Class=5]="Class",j[j.Struct=6]="Struct",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Event=10]="Event",j[j.Operator=11]="Operator",j[j.Unit=12]="Unit",j[j.Value=13]="Value",j[j.Constant=14]="Constant",j[j.Enum=15]="Enum",j[j.EnumMember=16]="EnumMember",j[j.Keyword=17]="Keyword",j[j.Text=18]="Text",j[j.Color=19]="Color",j[j.File=20]="File",j[j.Reference=21]="Reference",j[j.Customcolor=22]="Customcolor",j[j.Folder=23]="Folder",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue",j[j.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var w;(function(j){const F=new Map;F.set(0,D.$bk.symbolMethod),F.set(1,D.$bk.symbolFunction),F.set(2,D.$bk.symbolConstructor),F.set(3,D.$bk.symbolField),F.set(4,D.$bk.symbolVariable),F.set(5,D.$bk.symbolClass),F.set(6,D.$bk.symbolStruct),F.set(7,D.$bk.symbolInterface),F.set(8,D.$bk.symbolModule),F.set(9,D.$bk.symbolProperty),F.set(10,D.$bk.symbolEvent),F.set(11,D.$bk.symbolOperator),F.set(12,D.$bk.symbolUnit),F.set(13,D.$bk.symbolValue),F.set(15,D.$bk.symbolEnum),F.set(14,D.$bk.symbolConstant),F.set(15,D.$bk.symbolEnum),F.set(16,D.$bk.symbolEnumMember),F.set(17,D.$bk.symbolKeyword),F.set(27,D.$bk.symbolSnippet),F.set(18,D.$bk.symbolText),F.set(19,D.$bk.symbolColor),F.set(20,D.$bk.symbolFile),F.set(21,D.$bk.symbolReference),F.set(22,D.$bk.symbolCustomColor),F.set(23,D.$bk.symbolFolder),F.set(24,D.$bk.symbolTypeParameter),F.set(25,D.$bk.account),F.set(26,D.$bk.issues);function M(J){let te=F.get(J);return te||(console.info("No codicon found for CompletionItemKind "+J),te=D.$bk.symbolProperty),te}j.toIcon=M;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function z(J,te){let x=O.get(J);return typeof x>"u"&&!te&&(x=9),x}j.fromString=z})(w||(e.CompletionItemKinds=w={}));var E;(function(j){j[j.Deprecated=1]="Deprecated"})(E||(e.CompletionItemTag=E={}));var S;(function(j){j[j.None=0]="None",j[j.KeepWhitespace=1]="KeepWhitespace",j[j.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var c;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(e.CompletionTriggerKind=c={}));var m;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(m||(e.InlineCompletionTriggerKind=m={}));class a{constructor(F,M,O,z){this.range=F,this.text=M,this.completionKind=O,this.isSnippetText=z}equals(F){return P.$Ws.lift(this.range).equalsRange(F.range)&&this.text===F.text&&this.completionKind===F.completionKind&&this.isSnippetText===F.isSnippetText}}e.$Ht=a;var i;(function(j){j[j.Invoke=1]="Invoke",j[j.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var r;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(r||(e.DocumentHighlightKind=r={}));function s(j){return j&&N.URI.isUri(j.uri)&&P.$Ws.isIRange(j.range)&&(P.$Ws.isIRange(j.originSelectionRange)||P.$Ws.isIRange(j.targetSelectionRange))}e.$It=s;var t;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$Jt={[17]:(0,p.localize)(0,null),[16]:(0,p.localize)(1,null),[4]:(0,p.localize)(2,null),[13]:(0,p.localize)(3,null),[8]:(0,p.localize)(4,null),[9]:(0,p.localize)(5,null),[21]:(0,p.localize)(6,null),[23]:(0,p.localize)(7,null),[7]:(0,p.localize)(8,null),[0]:(0,p.localize)(9,null),[11]:(0,p.localize)(10,null),[10]:(0,p.localize)(11,null),[19]:(0,p.localize)(12,null),[5]:(0,p.localize)(13,null),[1]:(0,p.localize)(14,null),[2]:(0,p.localize)(15,null),[20]:(0,p.localize)(16,null),[15]:(0,p.localize)(17,null),[18]:(0,p.localize)(18,null),[24]:(0,p.localize)(19,null),[3]:(0,p.localize)(20,null),[6]:(0,p.localize)(21,null),[14]:(0,p.localize)(22,null),[22]:(0,p.localize)(23,null),[25]:(0,p.localize)(24,null),[12]:(0,p.localize)(25,null)};function g(j,F){return(0,p.localize)(26,null,j,e.$Jt[F])}e.$Kt=g;var o;(function(j){j[j.Deprecated=1]="Deprecated"})(o||(e.SymbolTag=o={}));var d;(function(j){const F=new Map;F.set(0,D.$bk.symbolFile),F.set(1,D.$bk.symbolModule),F.set(2,D.$bk.symbolNamespace),F.set(3,D.$bk.symbolPackage),F.set(4,D.$bk.symbolClass),F.set(5,D.$bk.symbolMethod),F.set(6,D.$bk.symbolProperty),F.set(7,D.$bk.symbolField),F.set(8,D.$bk.symbolConstructor),F.set(9,D.$bk.symbolEnum),F.set(10,D.$bk.symbolInterface),F.set(11,D.$bk.symbolFunction),F.set(12,D.$bk.symbolVariable),F.set(13,D.$bk.symbolConstant),F.set(14,D.$bk.symbolString),F.set(15,D.$bk.symbolNumber),F.set(16,D.$bk.symbolBoolean),F.set(17,D.$bk.symbolArray),F.set(18,D.$bk.symbolObject),F.set(19,D.$bk.symbolKey),F.set(20,D.$bk.symbolNull),F.set(21,D.$bk.symbolEnumMember),F.set(22,D.$bk.symbolStruct),F.set(23,D.$bk.symbolEvent),F.set(24,D.$bk.symbolOperator),F.set(25,D.$bk.symbolTypeParameter);function M(O){let z=F.get(O);return z||(console.info("No codicon found for SymbolKind "+O),z=D.$bk.symbolProperty),z}j.toIcon=M})(d||(e.SymbolKinds=d={}));class l{static asEditOperation(F){return h.$Xs.replace(P.$Ws.lift(F.range),F.text)}}e.$Lt=l;class u{static{this.Comment=new u("comment")}static{this.Imports=new u("imports")}static{this.Region=new u("region")}static fromValue(F){switch(F){case"comment":return u.Comment;case"imports":return u.Imports;case"region":return u.Region}return new u(F)}constructor(F){this.value=F}}e.$Mt=u;var v;(function(j){function F(M){return!M||typeof M!="object"?!1:typeof M.id=="string"&&typeof M.title=="string"}j.is=F})(v||(e.Command=v={}));var I;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(I||(e.CommentThreadCollapsibleState=I={}));var $;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})($||(e.CommentThreadState=$={}));var f;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(f||(e.CommentMode=f={}));var y;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(y||(e.CommentState=y={}));var L;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(L||(e.InlayHintKind=L={}));class T{constructor(F){this.b=F,this.a=null}dispose(){this.a&&this.a.then(F=>{F&&F.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Nt=T,e.$Ot=new A.$vt;var U;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(U||(e.ExternalUriOpenerPriority=U={}))}),define(ke[196],Se([9,10]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[197],Se([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[198],Se([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(ke[199],Se([9,10]),function($e,e){return $e.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[200],Se([9,10]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[201],Se([9,10]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[202],Se([9,10]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[203],Se([9,10]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(ke[204],Se([9,10]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(ke[205],Se([9,10]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[206],Se([9,10]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(ke[207],Se([9,10]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[208],Se([9,10]),function($e,e){return $e.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[209],Se([9,10]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(ke[210],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[211],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[212],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[213],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[214],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[215],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[216],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[217],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[218],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[219],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[220],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[221],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[222],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[223],Se([9,10]),function($e,e){return $e.create("vs/workbench/common/configuration",e)}),define(ke[224],Se([9,10]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(ke[225],Se([9,10]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(ke[226],Se([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[227],Se([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[228],Se([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[229],Se([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[230],Se([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[231],Se([9,10]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[232],Se([9,10]),function($e,e){return $e.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[233],Se([9,10]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[234],Se([9,10]),function($e,e){return $e.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[235],Se([9,10]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[236],Se([1,0,14,198]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.TokenType=void 0;var h;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(h||(e.TokenType=h={}));function P(...k){switch(k.length){case 1:return(0,N.localize)(0,null,k[0]);case 2:return(0,N.localize)(1,null,k[0],k[1]);case 3:return(0,N.localize)(2,null,k[0],k[1],k[2]);default:return}}const A=(0,N.localize)(3,null),p=(0,N.localize)(4,null);class b{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(P("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(P("&&"));break;case 124:this.h(124)?this.k(16):this.l(P("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const C=this.d,w=this.c.substring(this.d,this.e),E={type:19,offset:this.d,lexeme:w};this.g.push({offset:C,lexeme:w,additionalInfo:R}),this.f.push(E)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const C=this.c.substring(this.d,this.e),w=b.b.get(C);w?this.k(w):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,C=!1,w=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(p);return}const S=this.c.charCodeAt(R);if(C)C=!1;else if(S===47&&!w){R++;break}else S===91?w=!0:S===92?C=!0:S===93&&(w=!1);R++}for(;R<this.c.length&&b.a.has(this.c.charCodeAt(R));)R++;this.e=R;const E=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:E,offset:this.d})}r(){return this.e>=this.c.length}}e.$3i=b}),define(ke[237],Se([1,0,23,39,201,387]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function b(a){return a=a.trim(),a==="*"||A.test(a)}e.$cp=b;function k(a){if(!b(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=a.match(A);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$dp=k;function R(a){if(!a)return null;const i=a.majorBase,n=a.majorMustEqual,r=a.minorBase;let s=a.minorMustEqual;const t=a.patchBase;let g=a.patchMustEqual;a.hasCaret&&(i===0||(s=!1),g=!1);let o=0;if(a.preRelease){const d=p.exec(a.preRelease);if(d){const[,l,u,v]=d;o=Date.UTC(Number(l),Number(u)-1,Number(v))}}return{majorBase:i,majorMustEqual:n,minorBase:r,minorMustEqual:s,patchBase:t,patchMustEqual:g,isMinimum:a.hasGreaterEquals,notBefore:o}}e.$ep=R;function C(a,i,n){let r;typeof a=="string"?r=R(k(a)):r=a;let s;i instanceof Date?s=i.getTime():typeof i=="string"&&(s=new Date(i).getTime());let t;if(typeof n=="string"?t=R(k(n)):t=n,!r||!t)return!1;const g=r.majorBase,o=r.minorBase,d=r.patchBase;let l=t.majorBase,u=t.minorBase,v=t.patchBase;const I=t.notBefore;let $=t.majorMustEqual,f=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?g>l?!0:g<l?!1:o>u?!0:o<u||s&&s<I?!1:d>=v:(g===1&&l===0&&(!$||!f||!y)&&(l=1,u=0,v=0,$=!0,f=!1,y=!1),g<l?!1:g>l?!$:o<u?!1:o>u?!f:d<v?!1:d>v?!y:!(s&&s<I))}e.$fp=C;function w(a,i,n,r,s){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([N.default.Error,h.localize(0,null)]),t;if(typeof r.name!="string")return t.push([N.default.Error,h.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([N.default.Error,h.localize(2,null,"version")]),t;if(!r.engines)return t.push([N.default.Error,h.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([N.default.Error,h.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!m(r.extensionDependencies))return t.push([N.default.Error,h.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!m(r.activationEvents))return t.push([N.default.Error,h.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([N.default.Error,h.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([N.default.Warning,h.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([N.default.Error,h.localize(9,null,"main")]),t;{const d=(0,D.$Ig)(n,r.main);(0,D.$Cg)(d,n)||t.push([N.default.Warning,h.localize(10,null,d.path,n.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([N.default.Error,h.localize(11,null,"browser")]),t;{const d=(0,D.$Ig)(n,r.browser);(0,D.$Cg)(d,n)||t.push([N.default.Warning,h.localize(12,null,d.path,n.path)])}}if(!P.valid(r.version))return t.push([N.default.Error,h.localize(13,null)]),t;const g=[];if(!E(a,i,r,s,g))for(const d of g)t.push([N.default.Error,d]);return t}e.$gp=w;function E(a,i,n,r,s){return r||typeof n.main>"u"&&typeof n.browser>"u"?!0:c(a,i,n.engines.vscode,s)}e.$hp=E;function S(a,i,n){return a==="*"||c(i,n,a)}e.$ip=S;function c(a,i,n,r=[]){const s=R(k(n));if(!s)return r.push(h.localize(14,null,n)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return r.push(h.localize(15,null,n)),!1}else if(!s.majorMustEqual)return r.push(h.localize(16,null,n)),!1;return C(a,i,s)?!0:(r.push(h.localize(17,null,a,n)),!1)}function m(a){if(!Array.isArray(a))return!1;for(let i=0,n=a.length;i<n;i++)if(typeof a[i]!="string")return!1;return!0}}),define(ke[106],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=void 0;class D{constructor(h,P=[],A=!1){this.ctor=h,this.staticArguments=P,this.supportsDelayedInstantiation=A}}e.$5h=D}),define(ke[84],Se([1,0,106]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.InstantiationType=void 0;const N=[];var h;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(h||(e.InstantiationType=h={}));function P(p,b,k){b instanceof D.$5h||(b=new D.$5h(b,[],!!k)),N.push([p,b])}e.$1r=P;function A(){return N}e.$2r=A}),define(ke[238],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;class D{constructor(P,A){this.key=P,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Eq=D;class N{constructor(P){this.b=P,this.a=new Map}roots(){const P=[];for(const A of this.a.values())A.outgoing.size===0&&P.push(A);return P}insertEdge(P,A){const p=this.lookupOrInsertNode(P),b=this.lookupOrInsertNode(A);p.outgoing.set(b.key,b),b.incoming.set(p.key,p)}removeNode(P){const A=this.b(P);this.a.delete(A);for(const p of this.a.values())p.outgoing.delete(A),p.incoming.delete(A)}lookupOrInsertNode(P){const A=this.b(P);let p=this.a.get(A);return p||(p=new D(A,P),this.a.set(A,p)),p}lookup(P){return this.a.get(this.b(P))}isEmpty(){return this.a.size===0}toString(){const P=[];for(const[A,p]of this.a)P.push(`${A}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,A]of this.a){const p=new Set([P]),b=this.c(A,p);if(b)return b}}c(P,A){for(const[p,b]of P.outgoing){if(A.has(p))return[...A,p].join(" -> ");A.add(p);const k=this.c(b,A);if(k)return k;A.delete(p)}}}e.$Fq=N}),define(ke[5],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e._util=void 0;var D;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function p(b){return b[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=p})(D||(e._util=D={})),e.$7h=h("instantiationService");function N(A,p,b){p[D.DI_TARGET]===p?p[D.DI_DEPENDENCIES].push({id:A,index:b}):(p[D.DI_DEPENDENCIES]=[{id:A,index:b}],p[D.DI_TARGET]=p)}function h(A){if(D.serviceIds.has(A))return D.serviceIds.get(A);const p=function(b,k,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(p,b,R)};return p.toString=()=>A,D.serviceIds.set(A,p),p}e.$8h=h;function P(A){return A}e.$9h=P}),define(ke[51],Se([1,0,18,2,5]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.ConfigurationTarget=e.$Di=e.$Ci=e.$Bi=void 0,e.$Bi=(0,h.$8h)("configurationService");function P(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof N.URI)}e.$Ci=P;function A(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof N.URI)}e.$Di=A;var p;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function b(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ei=b;function k(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}e.$Fi=k;function R(a,i){const n=Object.create(null);for(const r in a)C(n,r,a[r],i);return n}e.$Gi=R;function C(a,i,n,r){const s=i.split("."),t=s.pop();let g=a;for(let o=0;o<s.length;o++){const d=s[o];let l=g[d];switch(typeof l){case"undefined":l=g[d]=Object.create(null);break;case"object":break;default:r(`Ignoring ${i} as ${s.slice(0,o+1).join(".")} is ${JSON.stringify(l)}`);return}g=l}if(typeof g=="object"&&g!==null)try{g[t]=n}catch{r(`Ignoring ${i} as ${s.join(".")} is ${JSON.stringify(g)}`)}else r(`Ignoring ${i} as ${s.join(".")} is ${JSON.stringify(g)}`)}e.$Hi=C;function w(a,i){const n=i.split(".");E(a,n)}e.$Ii=w;function E(a,i){const n=i.shift();if(i.length===0){delete a[n];return}if(Object.keys(a).indexOf(n)!==-1){const r=a[n];typeof r=="object"&&!Array.isArray(r)&&(E(r,i),Object.keys(r).length===0&&delete a[n])}}function S(a,i,n){function r(g,o){let d=g;for(const l of o){if(typeof d!="object"||d===null)return;d=d[l]}return d}const s=i.split("."),t=r(a,s);return typeof t>"u"?n:t}e.$Ji=S;function c(a,i,n){Object.keys(i).forEach(r=>{r!=="__proto__"&&(r in a?D.$Lf(a[r])&&D.$Lf(i[r])?c(a[r],i[r],n):n&&(a[r]=i[r]):a[r]=i[r])})}e.$Ki=c;function m(a){return a.replace(/[\[\]]/g,"")}e.$Li=m}),define(ke[45],Se([1,0,11,12,236,5,197,14]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.ContextKeyExprType=e.$4i=void 0;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",D.$j),b.set("isLinux",D.$k),b.set("isWindows",D.$i),b.set("isWeb",D.$o),b.set("isMacNative",D.$j&&!D.$o),b.set("isEdge",D.$H),b.set("isFirefox",D.$F),b.set("isChrome",D.$E),b.set("isSafari",D.$G);function k(K,W){if(b.get(K)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(K,W)}e.$4i=k;const R=Object.prototype.hasOwnProperty;var C;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const w={regexParsingWithErrorRecovery:!0},E=(0,A.localize)(0,null),S=(0,A.localize)(1,null),c=(0,A.localize)(2,null),m=(0,A.localize)(3,null),a=(0,A.localize)(4,null),i=(0,A.localize)(5,null),n=(0,A.localize)(6,null),r=(0,A.localize)(7,null);class s{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=w){this.k=W,this.d=new h.$3i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:E,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const re=this.l();if(!this.E()){const ye=this.D(),he=ye.type===17?i:void 0;throw this.h.push({message:a,offset:ye.offset,lexeme:h.$3i.getLexeme(ye),additionalInfo:he}),s.c}return re}catch(re){if(re!==s.c)throw re;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const re=this.o();W.push(re)}return W.length===1?W[0]:t.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const re=this.s();W.push(re)}return W.length===1?W[0]:t.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),l.INSTANCE;case 12:return this.z(),u.INSTANCE;case 0:{this.z();const re=this.l();return this.A(1,m),re?.negate()}case 17:return this.z(),L.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const re=this.l();return this.A(1,m),re}case 17:{const re=W.lexeme;if(this.z(),this.y(9)){const he=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),he.type!==10)throw this.B("REGEX",he);const fe=he.lexeme,ue=fe.lastIndexOf("/"),me=ue===fe.length-1?void 0:this.w(fe.substring(ue+1));let V;try{V=new RegExp(fe.substring(1,ue),me)}catch{throw this.B("REGEX",he)}return O.create(re,V)}switch(he.type){case 10:case 19:{const fe=[he.lexeme];this.z();let ue=this.D(),me=0;for(let Pe=0;Pe<he.lexeme.length;Pe++)he.lexeme.charCodeAt(Pe)===40?me++:he.lexeme.charCodeAt(Pe)===41&&me--;for(;!this.E()&&ue.type!==15&&ue.type!==16;){switch(ue.type){case 0:me++;break;case 1:me--;break;case 10:case 18:for(let Pe=0;Pe<ue.lexeme.length;Pe++)ue.lexeme.charCodeAt(Pe)===40?me++:he.lexeme.charCodeAt(Pe)===41&&me--}if(me<0)break;fe.push(h.$3i.getLexeme(ue)),this.z(),ue=this.D()}const V=fe.join(""),Y=V.lastIndexOf("/"),de=Y===V.length-1?void 0:this.w(V.substring(Y+1));let we;try{we=new RegExp(V.substring(1,Y),de)}catch{throw this.B("REGEX",he)}return t.regex(re,we)}case 18:{const fe=he.lexeme;this.z();let ue=null;if(!(0,N.$Ke)(fe)){const me=fe.indexOf("/"),V=fe.lastIndexOf("/");if(me!==V&&me>=0){const Y=fe.slice(me+1,V),de=fe[V+1]==="i"?"i":"";try{ue=new RegExp(Y,de)}catch{throw this.B("REGEX",he)}}}if(ue===null)throw this.B("REGEX",he);return O.create(re,ue)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,c);const he=this.u();return t.notIn(re,he)}switch(this.D().type){case 3:{this.z();const he=this.u();if(this.x().type===18)return t.equals(re,he);switch(he){case"true":return t.has(re);case"false":return t.not(re);default:return t.equals(re,he)}}case 4:{this.z();const he=this.u();if(this.x().type===18)return t.notEquals(re,he);switch(he){case"true":return t.not(re);case"false":return t.has(re);default:return t.notEquals(re,he)}}case 5:return this.z(),F.create(re,this.u());case 6:return this.z(),M.create(re,this.u());case 7:return this.z(),U.create(re,this.u());case 8:return this.z(),j.create(re,this.u());case 13:return this.z(),t.in(re,this.u());default:return t.has(re)}}case 20:throw this.h.push({message:n,offset:W.offset,lexeme:"",additionalInfo:r}),s.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,re){if(this.C(W))return this.z();throw this.B(re,this.D())}B(W,re,ye){const he=(0,A.localize)(8,null,W,h.$3i.getLexeme(re)),fe=re.offset,ue=h.$3i.getLexeme(re);return this.h.push({message:he,offset:fe,lexeme:ue,additionalInfo:ye}),s.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$5i=s;class t{static false(){return l.INSTANCE}static true(){return u.INSTANCE}static has(W){return v.create(W)}static equals(W,re){return I.create(W,re)}static notEquals(W,re){return y.create(W,re)}static regex(W,re){return O.create(W,re)}static in(W,re){return $.create(W,re)}static notIn(W,re){return f.create(W,re)}static not(W){return L.create(W)}static and(...W){return te.create(W,null,!0)}static or(...W){return x.create(W,null,!0)}static greater(W,re){return U.create(W,re)}static greaterEquals(W,re){return j.create(W,re)}static smaller(W,re){return F.create(W,re)}static smallerEquals(W,re){return M.create(W,re)}static{this.c=new s({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$6i=t;function g(K){const W=new s({regexParsingWithErrorRecovery:!1});return K.map(re=>(W.parse(re),W.lexingErrors.length>0?W.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,A.localize)(9,null,ye.additionalInfo):(0,A.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.$7i=g;function o(K,W){const re=K?K.substituteConstants():void 0,ye=W?W.substituteConstants():void 0;return!re&&!ye?!0:!re||!ye?!1:re.equals(ye)}e.$8i=o;function d(K,W){return K.cmp(W)}class l{static{this.INSTANCE=new l}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return u.INSTANCE}}e.$9i=l;class u{static{this.INSTANCE=new u}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return l.INSTANCE}}e.$0i=u;class v{static create(W,re=null){const ye=b.get(W);return typeof ye=="boolean"?ye?u.INSTANCE:l.INSTANCE:new v(W,re)}constructor(W,re){this.key=W,this.c=re,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:Z(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=b.get(this.key);return typeof W=="boolean"?W?u.INSTANCE:l.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$$i=v;class I{static create(W,re,ye=null){if(typeof re=="boolean")return re?v.create(W,ye):L.create(W,ye);const he=b.get(W);return typeof he=="boolean"?re===(he?"true":"false")?u.INSTANCE:l.INSTANCE:new I(W,re,ye)}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:ae(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=b.get(this.c);if(typeof W=="boolean"){const re=W?"true":"false";return this.d===re?u.INSTANCE:l.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$_i=I;class ${static create(W,re){return new $(W,re)}constructor(W,re){this.d=W,this.f=re,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:ae(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const re=W.getValue(this.f),ye=W.getValue(this.d);return Array.isArray(re)?re.includes(ye):typeof ye=="string"&&typeof re=="object"&&re!==null?R.call(re,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$aj=$;class f{static create(W,re){return new f(W,re)}constructor(W,re){this.d=W,this.f=re,this.type=11,this.c=$.create(W,re)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$bj=f;class y{static create(W,re,ye=null){if(typeof re=="boolean")return re?L.create(W,ye):v.create(W,ye);const he=b.get(W);return typeof he=="boolean"?re===(he?"true":"false")?l.INSTANCE:u.INSTANCE:new y(W,re,ye)}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:ae(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=b.get(this.c);if(typeof W=="boolean"){const re=W?"true":"false";return this.d===re?l.INSTANCE:u.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$cj=y;class L{static create(W,re=null){const ye=b.get(W);return typeof ye=="boolean"?ye?l.INSTANCE:u.INSTANCE:new L(W,re)}constructor(W,re){this.c=W,this.d=re,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:Z(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=b.get(this.c);return typeof W=="boolean"?W?l.INSTANCE:u.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$dj=L;function T(K,W){if(typeof K=="string"){const re=parseFloat(K);isNaN(re)||(K=re)}return typeof K=="string"||typeof K=="number"?W(K):l.INSTANCE}class U{static create(W,re,ye=null){return T(re,he=>new U(W,he,ye))}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:ae(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$ej=U;class j{static create(W,re,ye=null){return T(re,he=>new j(W,he,ye))}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:ae(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$fj=j;class F{static create(W,re,ye=null){return T(re,he=>new F(W,he,ye))}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:ae(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$gj=F;class M{static create(W,re,ye=null){return T(re,he=>new M(W,he,ye))}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:ae(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$hj=M;class O{static create(W,re){return new O(W,re)}constructor(W,re){this.d=W,this.f=re,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const re=this.f?this.f.source:"",ye=W.f?W.f.source:"";return re<ye?-1:re>ye?1:0}equals(W){if(W.type===this.type){const re=this.f?this.f.source:"",ye=W.f?W.f.source:"";return this.d===W.d&&re===ye}return!1}substituteConstants(){return this}evaluate(W){const re=W.getValue(this.d);return this.f?this.f.test(re):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=z.create(this)),this.c}}e.$ij=O;class z{static create(W){return new z(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new z(this.c.map(W))}negate(){return this.c}}e.$jj=z;function J(K){let W=null;for(let re=0,ye=K.length;re<ye;re++){const he=K[re].substituteConstants();if(K[re]!==he&&W===null){W=[];for(let fe=0;fe<re;fe++)W[fe]=K[fe]}W!==null&&(W[re]=he)}return W===null?K:W}class te{static create(W,re,ye){return te.d(W,re,ye)}constructor(W,re){this.expr=W,this.c=re,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let re=0,ye=this.expr.length;re<ye;re++){const he=d(this.expr[re],W.expr[re]);if(he!==0)return he}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].equals(W.expr[re]))return!1;return!0}return!1}substituteConstants(){const W=J(this.expr);return W===this.expr?this:te.create(W,this.c,!1)}evaluate(W){for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].evaluate(W))return!1;return!0}static d(W,re,ye){const he=[];let fe=!1;for(const ue of W)if(ue){if(ue.type===1){fe=!0;continue}if(ue.type===0)return l.INSTANCE;if(ue.type===6){he.push(...ue.expr);continue}he.push(ue)}if(he.length===0&&fe)return u.INSTANCE;if(he.length!==0){if(he.length===1)return he[0];he.sort(d);for(let ue=1;ue<he.length;ue++)he[ue-1].equals(he[ue])&&(he.splice(ue,1),ue--);if(he.length===1)return he[0];for(;he.length>1;){const ue=he[he.length-1];if(ue.type!==9)break;he.pop();const me=he.pop(),V=he.length===0,Y=x.create(ue.expr.map(de=>te.create([de,me],null,ye)),null,V);Y&&(he.push(Y),he.sort(d))}if(he.length===1)return he[0];if(ye){for(let ue=0;ue<he.length;ue++)for(let me=ue+1;me<he.length;me++)if(he[ue].negate().equals(he[me]))return l.INSTANCE;if(he.length===1)return he[0]}return new te(he,re)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const re of this.expr)W.push(...re.keys());return W}map(W){return new te(this.expr.map(re=>re.map(W)),null)}negate(){if(!this.c){const W=[];for(const re of this.expr)W.push(re.negate());this.c=x.create(W,this,!0)}return this.c}}e.$kj=te;class x{static create(W,re,ye){return x.d(W,re,ye)}constructor(W,re){this.expr=W,this.c=re,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let re=0,ye=this.expr.length;re<ye;re++){const he=d(this.expr[re],W.expr[re]);if(he!==0)return he}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].equals(W.expr[re]))return!1;return!0}return!1}substituteConstants(){const W=J(this.expr);return W===this.expr?this:x.create(W,this.c,!1)}evaluate(W){for(let re=0,ye=this.expr.length;re<ye;re++)if(this.expr[re].evaluate(W))return!0;return!1}static d(W,re,ye){let he=[],fe=!1;if(W){for(let ue=0,me=W.length;ue<me;ue++){const V=W[ue];if(V){if(V.type===0){fe=!0;continue}if(V.type===1)return u.INSTANCE;if(V.type===9){he=he.concat(V.expr);continue}he.push(V)}}if(he.length===0&&fe)return l.INSTANCE;he.sort(d)}if(he.length!==0){if(he.length===1)return he[0];for(let ue=1;ue<he.length;ue++)he[ue-1].equals(he[ue])&&(he.splice(ue,1),ue--);if(he.length===1)return he[0];if(ye){for(let ue=0;ue<he.length;ue++)for(let me=ue+1;me<he.length;me++)if(he[ue].negate().equals(he[me]))return u.INSTANCE;if(he.length===1)return he[0]}return new x(he,re)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const re of this.expr)W.push(...re.keys());return W}map(W){return new x(this.expr.map(re=>re.map(W)),null)}negate(){if(!this.c){const W=[];for(const re of this.expr)W.push(re.negate());for(;W.length>1;){const re=W.shift(),ye=W.shift(),he=[];for(const fe of ne(re))for(const ue of ne(ye))he.push(te.create([fe,ue],null,!1));W.unshift(x.create(he,null,!1))}this.c=x.create(W,this,!0)}return this.c}}e.$lj=x;class X extends v{static{this.d=[]}static all(){return X.d.values()}constructor(W,re,ye){super(W,null),this.f=re,typeof ye=="object"?X.d.push({...ye,key:W}):ye!==!0&&X.d.push({key:W,description:ye,type:re!=null?typeof re:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return I.create(this.key,W)}notEqualsTo(W){return y.create(this.key,W)}}e.$mj=X,e.$nj=(0,P.$8h)("contextKeyService");function Z(K,W){return K<W?-1:K>W?1:0}function ae(K,W,re,ye){return K<re?-1:K>re?1:W<ye?-1:W>ye?1:0}function _(K,W){if(K.type===0||W.type===1)return!0;if(K.type===9)return W.type===9?ge(K.expr,W.expr):!1;if(W.type===9){for(const re of W.expr)if(_(K,re))return!0;return!1}if(K.type===6){if(W.type===6)return ge(W.expr,K.expr);for(const re of K.expr)if(_(re,W))return!0;return!1}return K.equals(W)}e.$oj=_;function ge(K,W){let re=0,ye=0;for(;re<K.length&&ye<W.length;){const he=K[re].cmp(W[ye]);if(he<0)return!1;he===0&&re++,ye++}return re===K.length}function ne(K){return K.type===9?K.expr:[K]}}),define(ke[239],Se([1,0,23,39,199,5,103,11,24]),function($e,e,D,N,h,P,A,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_v=e.$$v=e.ConfirmResult=e.$0v=e.$9v=e.$8v=void 0,e.$8v=(0,P.$8h)("dialogService");var k;(function(c){c[c.Confirmation=1]="Confirmation",c[c.Prompt=2]="Prompt",c[c.Input=3]="Input"})(k||(k={}));class R{a(m){return this.d(m,k.Confirmation)}b(m){return this.d(m,k.Prompt)}c(m){return this.d(m,k.Input)}d(m,a){const i=[];switch(a){case k.Confirmation:{const n=m;n.primaryButton?i.push(n.primaryButton):i.push((0,h.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,h.localize)(1,null));break}case k.Prompt:{const n=m;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(r=>r.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,h.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,h.localize)(3,null))),i.length===0&&i.push((0,h.localize)(4,null));break}case k.Input:{const n=m;n.primaryButton?i.push(n.primaryButton):i.push((0,h.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,h.localize)(6,null));break}}return i}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===N.default.Info?"info":m===N.default.Error?"error":m===N.default.Warning?"warning":"none"}f(m,a,i){const n=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&n.push(m.cancelButton);let r=n[a]?.run({checkboxChecked:i});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:i}}}e.$9v=R,e.$0v=(0,P.$8h)("fileDialogService");var C;(function(c){c[c.SAVE=0]="SAVE",c[c.DONT_SAVE=1]="DONT_SAVE",c[c.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const w=10;function E(c){const m=[];return m.push(...c.slice(0,w).map(a=>typeof a=="string"?a:(0,D.$Fg)(a))),c.length>w&&(c.length-w===1?m.push((0,h.localize)(7,null)):m.push((0,h.localize)(8,null,c.length-w))),m.push(""),m.join(`
`)}e.$$v=E;function S(c,m){const a=(0,b.$yn)(c);let i=(a.buttons??[]).map(t=>(0,A.$5v)(t)),n=(c.buttons||[]).map((t,g)=>g),r=0,s=a.cancelId??i.length-1;if(i.length>1){const t=typeof s=="number"?i[s]:void 0;if(p.$k||p.$j){if(typeof t=="string"&&i.length>1&&s!==1){i.splice(s,1),i.splice(1,0,t);const g=n[s];n.splice(s,1),n.splice(1,0,g),s=1}p.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),r=i.length-1,typeof t=="string"&&(s=r-1))}else if(p.$i&&typeof t=="string"&&i.length>1&&s!==i.length-1){i.splice(s,1),i.push(t);const g=n[s];n.splice(s,1),n.push(g),s=i.length-1}}return a.buttons=i,a.defaultId=r,a.cancelId=s,a.noLink=!0,a.title=a.title||m.nameLong,{options:a,buttonIndeces:n}}e.$_v=S}),define(ke[133],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=void 0,e.$ci=(0,D.$8h)("environmentService"),e.$di=(0,D.$9h)(e.$ci)}),define(ke[134],Se([1,0,200,5]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ExtensionGalleryErrorCode=e.$Co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0,e.$po="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$qo=new RegExp(e.$po),e.$ro="__web_extension",e.$so="skipWalkthrough",e.$to="extensionsSync",e.$uo="dependecyOrPackExtensionInstall";function h(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$vo=h;function P(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$wo=P;function A(n,r){switch(n){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$xo=A;function p(n,r){return r==="web"&&!n.includes("web")}e.$yo=p;function b(n,r,s){return p(r,s)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===s}e.$zo=b;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.$Ao=k;var R;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var C;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var w;(function(n){n.Install="install",n.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var E;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$Bo=(0,N.$8h)("extensionGalleryService");var S;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Unknown="Unknown",n.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var c;(function(n){n.UnknownError="UnknownError",n.PackageIsInvalidZip="PackageIsInvalidZip",n.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class m extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$Co=m;var a;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(a||(e.ExtensionGalleryErrorCode=a={}));class i extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$Do=i,e.$Eo=(0,N.$8h)("extensionManagementService"),e.$Fo="extensionsIdentifiers/disabled",e.$Go="extensionsIdentifiers/enabled",e.$Ho=(0,N.$8h)("IGlobalExtensionEnablementService"),e.$Io=(0,N.$8h)("IExtensionTipsService"),e.$Jo=(0,D.localize2)(0,"Extensions"),e.$Ko=(0,D.localize2)(1,"Preferences")}),define(ke[240],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I2b=e.$H2b=void 0,e.$H2b=(0,D.$8h)("externalTerminal"),e.$I2b="Terminal.app"}),define(ke[241],Se([1,0,50,52,16,17,11,102,31,105,202,240]),function($e,e,D,N,h,P,A,p,b,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L0b=e.$K0b=e.$J0b=void 0;const w=R.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends E{static{this.b="cmd.exe"}openTerminal(s,t){return this.spawnTerminal(D,s,k.$Vl(),t)}spawnTerminal(s,t,g,o){const d=t.windowsExec||S.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const l=P.$nc(d,".exe").toLowerCase();if(l==="cmder")return s.spawn(d,o?[o]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return d.indexOf(" ")>=0&&u.push('""'),u.push(d),l==="wt"&&u.push("-d ."),new Promise((v,I)=>{const $=a(process),f=s.spawn(g,u,{cwd:o,env:$,detached:!0});f.on("error",I),f.on("exit",()=>v())})}async runInTerminal(s,t,g,o,d){const l="windowsExec"in d&&d.windowsExec?d.windowsExec:S.getDefaultTerminalWindows(),u=await S.f();return new Promise((v,I)=>{const $=`"${t} - ${w}"`,f=`""${g.join('" "')}" & pause"`,y=Object.assign({},a(process),o);Object.keys(y).filter(F=>y[F]===null).forEach(F=>delete y[F]);const L={cwd:t,env:y,windowsVerbatimArguments:!0};let T,U;P.$nc(l,".exe")==="wt"?(T=l,U=["-d",".",S.b,"/c",f]):u?(T=u,U=["-d",t,l,"/c",f]):(T=S.b,U=["/c","start",$,"/wait",l,"/c",f]),D.spawn(T,U,L).on("error",F=>{I(i(F))}),v(void 0)})}static getDefaultTerminalWindows(){if(!S.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return S.d}static async f(){try{const s=await k.win32.findExecutable("wt");return await b.Promises.exists(s)?s:void 0}catch{return}}}e.$J0b=S,Ge([N.$zh],S,"f",null);class c extends E{static{this.b="/usr/bin/osascript"}openTerminal(s,t){return this.spawnTerminal(D,s,t)}runInTerminal(s,t,g,o,d){const l=d.osxExec||C.$I2b;return new Promise((u,v)=>{if(l===C.$I2b||l==="iTerm.app"){const I=l===C.$I2b?"TerminalHelper":"iTermHelper",f=[h.$pg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${I}.scpt`).fsPath,"-t",s||w,"-w",t];for(const T of g)f.push("-a"),f.push(T);if(o){const T=Object.assign({},a(process),o);for(const U in T){const j=T[U];j===null?(f.push("-u"),f.push(U)):(f.push("-e"),f.push(`${U}=${j}`))}}let y="";const L=D.spawn(c.b,f);L.on("error",T=>{v(i(T))}),L.stderr.on("data",T=>{y+=T.toString()}),L.on("exit",T=>{if(T===0)u(void 0);else if(y){const U=y.split(`
`,1);v(new Error(U[0]))}else v(new Error(R.localize(1,null,I,T)))})}else v(new Error(R.localize(2,null,l)))})}spawnTerminal(s,t,g){const o=t.osxExec||C.$I2b;return new Promise((d,l)=>{const u=["-a",o];g&&u.push(g);const v=a(process),I=s.spawn("/usr/bin/open",u,{cwd:g,env:v});I.on("error",l),I.on("exit",()=>d())})}}e.$K0b=c;class m extends E{static{this.b=R.localize(3,null)}openTerminal(s,t){return this.spawnTerminal(D,s,t)}runInTerminal(s,t,g,o,d){const l=d.linuxExec?Promise.resolve(d.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((u,v)=>{const I=[];l.then($=>{$.indexOf("gnome-terminal")>=0?I.push("-x"):I.push("-e"),I.push("bash"),I.push("-c");const f=`${n(g)}; echo; read -p "${m.b}" -n1;`;I.push(`''${f}''`);const y=Object.assign({},a(process),o);Object.keys(y).filter(j=>y[j]===null).forEach(j=>delete y[j]);const L={cwd:t,env:y};let T="";const U=D.spawn($,I,L);U.on("error",j=>{v(i(j))}),U.stderr.on("data",j=>{T+=j.toString()}),U.on("exit",j=>{if(j===0)u(void 0);else if(T){const F=T.split(`
`,1);v(new Error(F[0]))}else v(new Error(R.localize(4,null,$,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!A.$k)m.d=Promise.resolve("xterm");else{const s=await b.Promises.exists("/etc/debian_version");m.d=new Promise(t=>{s?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m.d}spawnTerminal(s,t,g){const o=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((d,l)=>{o.then(u=>{const v=a(process),I=s.spawn(u,[],{cwd:g,env:v});I.on("error",l),I.on("exit",()=>d())})})}}e.$L0b=m;function a(r){const s={...r.env};return(0,p.$Tl)(s),s}function i(r){return"errno"in r&&r.errno==="ENOENT"&&"path"in r&&typeof r.path=="string"?new Error(R.localize(5,null,r.path)):r}function n(r){let s="";for(const t of r)t.indexOf(" ")>=0?s+='"'+t+'"':s+=t,s+=" ";return s}}),define(ke[32],Se([1,0,77,17,12,18,2,203,5,11,16,43]),function($e,e,D,N,h,P,A,p,b,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.FileKind=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.FileOperationResult=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileChangeType=e.$Kk=e.FileOperation=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderErrorCode=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileSystemProviderCapabilities=e.$uk=e.FilePermission=e.FileType=e.$tk=e.$sk=void 0,e.$sk=(0,b.$8h)("fileService");function w(_){return _.create===!0}e.$tk=w;var E;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var S;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function c(_){const ge=_;return!!ge&&typeof ge.onDidChange=="function"}e.$uk=c;var m;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function a(_){return!!(_.capabilities&2)}e.$vk=a;function i(_){return!!(_.capabilities&8)}e.$wk=i;function n(_){return!!(_.capabilities&131072)}e.$xk=n;function r(_){return!!(_.capabilities&4)}e.$yk=r;function s(_){return!!(_.capabilities&16)}e.$zk=s;function t(_){return a(_)?!!(_.capabilities&16384):!1}e.$Ak=t;function g(_){return a(_)?!!(_.capabilities&32768):!1}e.$Bk=g;function o(_){return!!(_.capabilities&65536)}e.$Ck=o;function d(_){return!!(_.capabilities&2048)}e.$Dk=d;var l;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class u extends Error{static create(ge,ne){const K=new u(ge.toString(),ne);return $(K,ne),K}constructor(ge,ne){super(ge),this.code=ne}}e.$Ek=u;function v(_,ge){return u.create(_,ge)}e.$Fk=v;function I(_){return _||v((0,p.localize)(0,null),l.Unknown)}e.$Gk=I;function $(_,ge){return _.name=ge?`${ge} (FileSystemError)`:"FileSystemError",_}e.$Hk=$;function f(_){if(!_)return l.Unknown;if(_ instanceof u)return _.code;const ge=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!ge)return l.Unknown;switch(ge[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.$Ik=f;function y(_){if(_ instanceof M)return _.fileOperationResult;switch(f(_)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}e.$Jk=y;var L;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class T{constructor(ge,ne,K){this.resource=ge,this.operation=ne,this.target=K}isOperation(ge){return this.operation===ge}}e.$Kk=T;var U;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class j{static{this.a=null}constructor(ge,ne){this.c=ne,this.b=void 0,this.d=new C.$V(()=>{const K=D.$bi.forUris(()=>this.c);return K.fill(this.rawAdded.map(W=>[W,!0])),K}),this.f=new C.$V(()=>{const K=D.$bi.forUris(()=>this.c);return K.fill(this.rawUpdated.map(W=>[W,!0])),K}),this.g=new C.$V(()=>{const K=D.$bi.forUris(()=>this.c);return K.fill(this.rawDeleted.map(W=>[W,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of ge){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==j.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(ge,...ne){return this.h(ge,{includeChildren:!1},...ne)}affects(ge,...ne){return this.h(ge,{includeChildren:!0},...ne)}h(ge,ne,...K){if(!ge)return!1;const W=K.length>0;return!!((!W||K.includes(1))&&(this.d.value.get(ge)||ne.includeChildren&&this.d.value.findSuperstr(ge))||(!W||K.includes(0))&&(this.f.value.get(ge)||ne.includeChildren&&this.f.value.findSuperstr(ge))||(!W||K.includes(2))&&(this.g.value.findSubstr(ge)||ne.includeChildren&&this.g.value.findSuperstr(ge)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ge){return this.b===ge}hasCorrelation(){return typeof this.b=="number"}}e.$Lk=j;function F(_,ge,ne){return!_||!ge||_===ge||ge.length>_.length?!1:(ge.charAt(ge.length-1)!==N.sep&&(ge+=N.sep),ne?(0,h.$bf)(_,ge):_.indexOf(ge)===0)}e.$Mk=F;class M extends Error{constructor(ge,ne,K){super(ge),this.fileOperationResult=ne,this.options=K}}e.$Nk=M;class O extends M{constructor(ge,ne,K,W){super(ge,ne,W),this.fileOperationResult=ne,this.size=K}}e.$Ok=O;class z extends M{constructor(ge,ne,K){super(ge,2,K),this.stat=ne}}e.$Pk=z;var J;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$Qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Sk="files.associations",e.$Tk="files.exclude",e.$Uk="files.readonlyInclude",e.$Vk="files.readonlyExclude",e.$Wk="files.readonlyFromPermissions";var te;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(te||(e.FileKind=te={})),e.$Xk="";function x(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Yk=x;async function X(_,ge){if(!ge.hasProvider(A.URI.from({scheme:_.scheme})))return new Promise(ne=>{const K=ge.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===_.scheme&&W.added&&(K.dispose(),ne())})})}e.$Zk=X;class Z{static{this.KB=1024}static{this.MB=Z.KB*Z.KB}static{this.GB=Z.MB*Z.KB}static{this.TB=Z.GB*Z.KB}static formatSize(ge){return(0,P.$Nf)(ge)||(ge=0),ge<Z.KB?(0,p.localize)(1,null,ge.toFixed(0)):ge<Z.MB?(0,p.localize)(2,null,(ge/Z.KB).toFixed(2)):ge<Z.GB?(0,p.localize)(3,null,(ge/Z.MB).toFixed(2)):ge<Z.TB?(0,p.localize)(4,null,(ge/Z.GB).toFixed(2)):(0,p.localize)(5,null,(ge/Z.TB).toFixed(2))}}e.$1k=Z;function ae(_){const ge=typeof _=="string"||_?.scheme===R.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===R.Schemas.file?1024*Z.MB:ge?10*Z.MB:k.$o?50*Z.MB:1024*Z.MB}e.$2k=ae}),define(ke[242],Se([1,0,21,14,204,32]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;async function A(R,C,w,E,S,c){let m;try{await p(R,C,w,E,S,c)}catch(a){m=a}finally{m&&S.errorTransformer&&(m=S.errorTransformer(m)),typeof m<"u"&&w.error(m),w.end()}}e.$dq=A;async function p(R,C,w,E,S,c){b(c);const m=await R.open(C,{create:!1});try{b(c);let a=0,i=0,n=S&&typeof S.length=="number"?S.length:void 0,r=D.$ke.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),s=S&&typeof S.position=="number"?S.position:0,t=0;do i=await R.read(m,s,r.buffer,t,r.byteLength-t),s+=i,t+=i,a+=i,typeof n=="number"&&(n-=i),t===r.byteLength&&(await w.write(E(r)),r=D.$ke.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&b(c)&&k(a,S));if(t>0){let g=t;typeof n=="number"&&(g=Math.min(t,n)),w.write(E(r.slice(0,g)))}}catch(a){throw(0,P.$Gk)(a)}finally{await R.close(m)}}function b(R){if(R.isCancellationRequested)throw(0,N.$6)();return!0}function k(R,C){if(typeof C?.limits?.size=="number"&&R>C.limits.size)throw(0,P.$Fk)((0,h.localize)(0,null),P.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[85],Se([1,0,35,3,17,11,2,32]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=void 0;function b(a){return a.recursive===!0}e.$fq=b;class k extends N.$Tc{static{this.a=5}constructor(i,n,r,s){super(),this.h=i,this.j=n,this.m=r,this.n=s,this.c=this.B(new N.$Uc),this.f=void 0,this.g=0}s(){const i=new N.$Sc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<k.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$gq=k;class R extends k{constructor(i,n,r){super(i,n,r,{type:"node.js",restartOnError:!1})}}e.$hq=R;class C extends k{constructor(i,n,r){super(i,n,r,{type:"universal",restartOnError:!0})}}e.$iq=C;function w(a){return a.map(i=>({type:i.type,resource:A.URI.revive(i.resource),cId:i.cId}))}e.$jq=w;function E(a){const i=new m;for(const n of a)i.processEvent(n);return i.coalesce()}e.$kq=E;function S(a,i){return typeof i=="string"&&!i.startsWith(D.$Kj)&&!(0,h.$ic)(i)?{base:a,pattern:i}:i}e.$lq=S;function c(a,i){const n=[];for(const r of i)n.push((0,D.$Oj)(S(a,r)));return n}e.$mq=c;class m{constructor(){this.a=new Set,this.b=new Map}c(i){return P.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let r=!1;if(n){const s=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?r=!0:s===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):s===2&&t===1?n.type=0:s===1&&t===0||(n.type=t)}else r=!0;r&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(r=>r.type!==2?(i.push(r),!1):!0).sort((r,s)=>r.resource.fsPath.length-s.resource.fsPath.length).filter(r=>n.some(s=>(0,p.$Mk)(r.resource.fsPath,s,!P.$k))?!1:(n.push(r.resource.fsPath),!0)).concat(i)}}}),define(ke[243],Se([1,0,57,8,22,34,3,76,17,11,23,2,104,31,85]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=void 0;class c extends A.$Tc{static{this.a=100}static{this.b=75}constructor(i,n,r,s){super(),this.m=i,this.n=n,this.r=r,this.s=s,this.c=this.B(new N.$kh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new N.$jh(t=>this.z(t),c.b)),this.g=(0,S.$mq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$mq)(this.m.path,this.m.includes):void 0,this.j=new h.$7d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await E.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await E.Promises.realpath(i.path),i.path===n&&(n=await(0,w.$wq)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(k.$j&&(0,P.$9f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Tc.None;const r=new h.$7d(this.j.token),s=new A.$Sc;try{const t=C.URI.file(this.m.path),g=(0,b.$nc)(i),o=(0,D.watch)(i);s.add((0,A.$Rc)(()=>{o.removeAllListeners(),o.close()})),this.G(`Started watching: '${i}'`);const d=new Set;if(n)try{for(const u of await E.Promises.readdir(i))d.add(u)}catch(u){this.D(u)}const l=new Map;s.add((0,A.$Rc)(()=>{for(const[,u]of l)u.dispose();l.clear()})),o.on("error",(u,v)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${u}, ${v})`),this.dispose()}),o.on("change",(u,v)=>{if(r.token.isCancellationRequested)return;this.G(`[raw] ["${u}"] ${v}`);let I="";if(v&&(I=v.toString(),k.$j&&(I=(0,p.$Il)(I))),!(!I||u!=="change"&&u!=="rename"))if(n)if(u==="rename"){l.get(I)?.dispose();const $=setTimeout(async()=>{if(l.delete(I),I===g&&!await E.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const f=await this.C((0,b.$jc)(i,I));if(r.token.isCancellationRequested)return;let y;f?d.has(I)?y=0:(y=1,d.add(I)):(d.delete(I),y=2),this.y({resource:(0,R.$Ig)(t,I),type:y,cId:this.m.correlationId})},c.a);l.set(I,(0,A.$Rc)(()=>clearTimeout($)))}else{let $;d.has(I)?$=0:($=1,d.add(I)),this.y({resource:(0,R.$Ig)(t,I),type:$,cId:this.m.correlationId})}else if(u==="rename"||I!==g){const $=setTimeout(async()=>{const f=await E.Promises.exists(i);r.token.isCancellationRequested||(f?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),s.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},c.a);s.clear(),s.add((0,A.$Rc)(()=>clearTimeout($)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await E.Promises.exists(i)&&!r.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Rc)(()=>{r.dispose(!0),s.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,S.$kq)(i);if(n.length>0){if(this.s)for(const s of n)this.G(` >> normalized ${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(k.$k)return E.Promises.exists(i);try{const n=(0,b.$nc)(i);return(await E.Promises.readdir((0,b.$mc)(i))).some(s=>s===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$zq=c;async function m(a,i,n,r,s=512){const t=await E.Promises.open(a,"r"),g=Buffer.allocUnsafe(s),o=new h.$7d(r);let d,l=!1;const u={path:a,excludes:[],recursive:!1},v=new c(u,I=>{(async()=>{for(const{type:$}of I)if($===0){if(l)return;l=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:f}=await E.Promises.read(t,g,0,s,null);if(!f||o.token.isCancellationRequested)break;i(g.slice(0,f))}}catch(f){d=new Error(f),o.dispose(!0)}finally{l=!1}}})()});return await v.ready,n(),new Promise((I,$)=>{o.token.onCancellationRequested(async()=>{v.dispose();try{await E.Promises.close(t)}catch(f){d=new Error(f)}d?$(d):I()})})}e.$Aq=m}),define(ke[244],Se([1,0,4,35,3,11,243]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class p extends h.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$Wd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Wd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(k){const R=this.j(k),C=R.filter(E=>{const S=this.c.get(E.path);return S?!(0,N.$Sj)(S.request.excludes,E.excludes)||!(0,N.$Sj)(S.request.includes,E.includes):!0}),w=Array.from(this.c.values()).filter(({request:E})=>!R.find(S=>S.path===E.path&&(0,N.$Sj)(S.excludes,E.excludes)&&(0,N.$Sj)(S.includes,E.includes))).map(({request:E})=>E.path);C.length&&this.m(`Request to start watching: ${C.map(E=>`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`).join(",")}`),w.length&&this.m(`Request to stop watching: ${w.join(",")}`);for(const E of w)this.h(E);for(const E of C)this.g(E)}g(k){const R=new A.$zq(k,w=>this.a.fire(w),w=>this.b.fire(w),this.f),C={request:k,instance:R};this.c.set(k.path,C)}async stop(){for(const[k]of this.c)this.h(k);this.c.clear()}h(k){const R=this.c.get(k);R&&(this.c.delete(k),R.instance.dispose())}j(k){const R=new Map;for(const C of k){const w=P.$k?C.path:C.path.toLowerCase();let E=R.get(C.correlationId);E||(E=new Map,R.set(C.correlationId,E)),E.set(w,C)}return Array.from(R.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(k){this.f=k;for(const[,R]of this.c)R.instance.setVerboseLogging(k)}m(k){this.f&&this.b.fire({type:"trace",message:this.n(k)})}n(k,R){return R?`[File Watcher (node.js)] ${k} (path: ${R.request.path})`:`[File Watcher (node.js)] ${k}`}}e.$Bq=p}),define(ke[245],Se([1,0,85,244]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class h extends D.$hq{constructor(A,p,b){super(A,p,b),this.s()}r(A){return A.add(new N.$Bq)}}e.$Cq=h}),define(ke[246],Se([1,0,16,81,187,85]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;class A extends P.$iq{constructor(b,k,R){super(b,k,R),this.s()}r(b){const k=b.add(new h.$tq(D.$pg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(k.onDidProcessExit(({code:R,signal:C})=>this.t(`terminated by itself with code ${R}, signal: ${C}`))),N.ProxyChannel.toService((0,N.$Oh)(k.getChannel("watcher")))}}e.$uq=A}),define(ke[107],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=void 0;class D{constructor(...h){this.a=new Map;for(const[P,A]of h)this.set(P,A)}set(h,P){const A=this.a.get(h);return this.a.set(h,P),A}has(h){return this.a.has(h)}get(h){return this.a.get(h)}}e.$6h=D}),define(ke[247],Se([1,0,8,14,3,106,238,5,107,75]),function($e,e,D,N,h,P,A,p,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;const R=!1;class C extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class w{constructor(m=new b.$6h,a=!1,i,n=R){this.f=m,this.g=a,this.h=i,this.i=n,this.o=new Set,this.f.set(p.$7h,this),this._globalGraph=n?i?._globalGraph??new A.$Fq(r=>r):void 0}createChild(m){return new w(m,this.g,this,this.i)}invokeFunction(m,...a){const i=S.traceInvocation(this.i,m);let n=!1;try{return m({get:s=>{if(n)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(s,i);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...a)}finally{n=!0,i.stop()}}createInstance(m,...a){let i,n;return m instanceof P.$5h?(i=S.traceCreation(this.i,m.ctor),n=this.j(m.ctor,m.staticArguments.concat(a),i)):(i=S.traceCreation(this.i,m),n=this.j(m,a,i)),i.stop(),n}j(m,a=[],i){const n=p._util.getServiceDependencies(m).sort((t,g)=>t.index-g.index),r=[];for(const t of n){const g=this.m(t.id,i);g||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(g)}const s=n.length>0?n[0].index:a.length;if(a.length!==s){console.trace(`[createInstance] First service dependency of ${m.name} at position ${s+1} conflicts with ${a.length} static arguments`);const t=s-a.length;t>0?a=a.concat(new Array(t)):a=a.slice(0,s)}return Reflect.construct(m,a.concat(r))}k(m,a){if(this.f.get(m)instanceof P.$5h)this.f.set(m,a);else if(this.h)this.h.k(m,a);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const a=this.f.get(m);return!a&&this.h?this.h.l(m):a}m(m,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const i=this.l(m);return i instanceof P.$5h?this.q(m,i,a.branch(m,!0)):(a.branch(m,!1),i)}q(m,a,i){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,a,i)}finally{this.o.delete(m)}}r(m,a,i){const n=new A.$Fq(t=>t.id.toString());let r=0;const s=[{id:m,desc:a,_trace:i}];for(;s.length;){const t=s.pop();if(n.lookupOrInsertNode(t),r++>1e3)throw new C(n);for(const g of p._util.getServiceDependencies(t.desc.ctor)){const o=this.l(g.id);if(o||this.u(`[createInstance] ${m} depends on ${g.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(g.id)),o instanceof P.$5h){const d={id:g.id,desc:o,_trace:t._trace.branch(g.id,!0)};n.insertEdge(t,d),s.push(d)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new C(n);break}for(const{data:g}of t){if(this.l(g.id)instanceof P.$5h){const d=this.s(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this.k(g.id,d)}n.removeNode(g)}}return this.l(m)}s(m,a,i=[],n,r){if(this.f.get(m)instanceof P.$5h)return this.t(m,a,i,n,r);if(this.h)return this.h.s(m,a,i,n,r);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}t(m,a,i=[],n,r){if(n){const s=new w(void 0,this.g,this,this.i);s.c=String(m);const t=new Map,g=new D.$oh(()=>{const o=s.j(a,i,r);for(const[d,l]of t){const u=o[d];if(typeof u=="function")for(const v of l)v.disposable=u.apply(o,v.listener)}return t.clear(),o});return new Proxy(Object.create(null),{get(o,d){if(!g.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let v=t.get(d);return v||(v=new k.$4c,t.set(d,v)),($,f,y)=>{if(g.isInitialized)return g.value[d]($,f,y);{const L={listener:[$,f,y],disposable:void 0},T=v.push(L);return(0,h.$Rc)(()=>{T(),L.disposable?.dispose()})}}}if(d in o)return o[d];const l=g.value;let u=l[d];return typeof u!="function"||(u=u.bind(l),o[d]=u),u},set(o,d,l){return g.value[d]=l,!0},getPrototypeOf(o){return a.prototype}})}else return this.j(a,i,r)}u(m,a){if(a&&console.warn(m),this.g)throw new Error(m)}}e.$Gq=w;var E;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(E||(E={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,a){return m?new S(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(m,a){return m?new S(1,a.name):S.c}static{this.f=0}constructor(m,a){this.type=m,this.name=a,this.g=Date.now(),this.h=[]}branch(m,a){const i=new S(3,m.toString());return this.h.push([m,a,i]),i}stop(){const m=Date.now()-this.g;S.f+=m;let a=!1;function i(r,s){const t=[],g=new Array(r+1).join("	");for(const[o,d,l]of s.h)if(d&&l){a=!0,t.push(`${g}CREATES -> ${o}`);const u=i(r+1,l);u&&t.push(u)}else t.push(`${g}uses -> ${o}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(m>2||a)&&S.all.add(n.join(`
`))}}e.$Hq=S}),define(ke[13],Se([1,0,44,4,54,3,28,11,23,18,2,45,5]),function($e,e,D,N,h,P,A,p,b,k,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.log=e.$sj=e.LogLevel=e.$rj=e.$qj=e.$pj=void 0,e.$pj=(0,w.$8h)("logService"),e.$qj=(0,w.$8h)("loggerService");function E(){return new Date().toISOString()}function S($){return(0,k.$Nf)($)}e.$rj=S;var c;(function($){$[$.Off=0]="Off",$[$.Trace=1]="Trace",$[$.Debug=2]="Debug",$[$.Info=3]="Info",$[$.Warning=4]="Warning",$[$.Error=5]="Error"})(c||(e.LogLevel=c={})),e.$sj=c.Info;function m($,f,y){switch(f){case c.Trace:$.trace(y);break;case c.Debug:$.debug(y);break;case c.Info:$.info(y);break;case c.Warning:$.warn(y);break;case c.Error:$.error(y);break;case c.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=m;function a($,f=!1){let y="";for(let L=0;L<$.length;L++){let T=$[L];if(T instanceof Error&&(T=(0,D.$Si)(T,f)),typeof T=="object")try{T=JSON.stringify(T)}catch{}y+=(L>0?" ":"")+T}return y}class i extends P.$Tc{constructor(){super(...arguments),this.b=e.$sj,this.c=this.B(new N.$Wd),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==c.Off&&this.b<=f}}e.$uj=i;class n extends i{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...y){this.f(c.Trace)&&this.g(c.Trace,a([f,...y],!0))}debug(f,...y){this.f(c.Debug)&&this.g(c.Debug,a([f,...y]))}info(f,...y){this.f(c.Info)&&this.g(c.Info,a([f,...y]))}warn(f,...y){this.f(c.Warning)&&this.g(c.Warning,a([f,...y]))}error(f,...y){if(this.f(c.Error))if(f instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=f.stack,this.g(c.Error,a(L))}else this.g(c.Error,a([f,...y]))}flush(){}}e.$vj=n;class r extends i{constructor(f=e.$sj){super(),this.setLevel(f),this.g=!p.$i}trace(f,...y){this.f(c.Trace)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,f,...y):console.log(`[main ${E()}]`,f,...y))}debug(f,...y){this.f(c.Debug)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,f,...y):console.log(`[main ${E()}]`,f,...y))}info(f,...y){this.f(c.Info)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,f,...y):console.log(`[main ${E()}]`,f,...y))}warn(f,...y){this.f(c.Warning)&&(this.g?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,f,...y):console.warn(`[main ${E()}]`,f,...y))}error(f,...y){this.f(c.Error)&&(this.g?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,f,...y):console.error(`[main ${E()}]`,f,...y))}flush(){}}e.$wj=r;class s extends i{constructor(f=e.$sj,y=!0){super(),this.g=y,this.setLevel(f)}trace(f,...y){this.f(c.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...y):console.log(f,...y))}debug(f,...y){this.f(c.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...y):console.log(f,...y))}info(f,...y){this.f(c.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...y):console.log(f,...y))}warn(f,...y){this.f(c.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...y):console.log(f,...y))}error(f,...y){this.f(c.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...y):console.error(f,...y))}flush(){}}e.$xj=s;class t extends i{constructor(f,y=e.$sj){super(),this.g=f,this.setLevel(y)}trace(f,...y){this.f(c.Trace)&&this.g.log(c.Trace,[this.h(f),...y])}debug(f,...y){this.f(c.Debug)&&this.g.log(c.Debug,[this.h(f),...y])}info(f,...y){this.f(c.Info)&&this.g.log(c.Info,[this.h(f),...y])}warn(f,...y){this.f(c.Warning)&&this.g.log(c.Warning,[this.h(f),...y])}error(f,...y){this.f(c.Error)&&this.g.log(c.Error,[this.h(f),...y])}h(f){return typeof f=="string"?f:(0,D.$Si)(f,this.f(c.Trace))}flush(){}}e.$yj=t;class g extends i{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const y of this.g)y.setLevel(f);super.setLevel(f)}trace(f,...y){for(const L of this.g)L.trace(f,...y)}debug(f,...y){for(const L of this.g)L.debug(f,...y)}info(f,...y){for(const L of this.g)L.info(f,...y)}warn(f,...y){for(const L of this.g)L.warn(f,...y)}error(f,...y){for(const L of this.g)L.error(f,...y)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose();super.dispose()}}e.$zj=g;class o extends P.$Tc{constructor(f,y,L){if(super(),this.h=f,this.j=y,this.b=new A.$Ac,this.c=this.B(new N.$Wd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Wd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Wd),this.onDidChangeVisibility=this.g.event,L)for(const T of L)this.b.set(T.resource,{logger:void 0,info:T})}m(f){return(0,k.$Jf)(f)?[...this.b.values()].find(y=>y.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,y){const L=this.n(f),T=(0,k.$Jf)(f)?f:y?.id??(0,h.$Vi)(L.toString()).toString(16);let U=this.b.get(L)?.logger;const j=y?.logLevel==="always"?c.Trace:y?.logLevel;U||(U=this.s(L,j??this.getLogLevel(L)??this.h,{...y,id:T}));const F={logger:U,info:{resource:L,id:T,logLevel:j,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(F.info),this.b.set(L,F),U}n(f){return(0,k.$Jf)(f)?(0,b.$Ig)(this.j,`${f}.log`):f}setLogLevel(f,y){if(R.URI.isUri(f)){const L=f,T=y,U=this.b.get(L);U&&T!==U.info.logLevel&&(U.info.logLevel=T===this.h?void 0:T,U.logger?.setLevel(T),this.b.set(U.info.resource,U),this.f.fire([L,T]))}else{this.h=f;for(const[L,T]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,y){const L=this.m(f);L&&y!==!L.info.hidden&&(L.info.hidden=!y,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,y]))}getLogLevel(f){let y;return f&&(y=this.b.get(f)?.info.logLevel),y??this.h}registerLogger(f){const y=this.b.get(f.resource);y?y.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const y=this.b.get(f);y&&(y.logger&&y.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Aj=o;class d{constructor(){this.onDidChangeLogLevel=new N.$Wd().event}setLevel(f){}getLevel(){return c.Info}trace(f,...y){}debug(f,...y){}info(f,...y){}warn(f,...y){}error(f,...y){}critical(f,...y){}dispose(){}flush(){}}e.$Bj=d;class l extends d{}e.$Cj=l;function u($){if($.verbose)return c.Trace;if(typeof $.logLevel=="string"){const f=I($.logLevel.toLowerCase());if(f!==void 0)return f}return e.$sj}e.$Dj=u;function v($){switch($){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Off:return"off"}}e.$Ej=v;function I($){switch($){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Error;case"off":return c.Off}}e.$Fj=I,e.$Gj=new C.$mj("logLevel",v(c.Info))}),define(ke[248],Se([1,0,19,8,14,4,3,17,85,13]),function($e,e,D,N,h,P,A,p,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class R extends A.$Tc{constructor(w,E){super(),this.a=w,this.b=E,this.c=this.B(new P.$Wd),this.onDidChangeFile=this.c.event,this.g=this.B(new P.$Wd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$6g(0)),this.w=[],this.y=this.B(new N.$6g(0))}watch(w,E){return E.recursive||this.b?.watcher?.forceUniversal?this.n(w,E):this.z(w,E)}n(w,E){const S={path:this.H(w),excludes:E.excludes,includes:E.includes,recursive:E.recursive,correlationId:E.correlationId},c=(0,D.$Ub)(this.j,S);return this.r(),(0,A.$Rc)(()=>{c(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,h.$1)(w))}s(){this.h||(this.h=this.B(this.t(E=>this.c.fire((0,b.$jq)(E)),E=>this.G(E),this.a.getLevel()===k.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===k.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const E of this.j)(0,b.$fq)(E)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const E of this.j)(0,b.$fq)(E)&&w.includes(E.path)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,E){const S={path:this.H(w),excludes:E.excludes,includes:E.includes,recursive:!1,correlationId:E.correlationId},c=(0,D.$Ub)(this.w,S);return this.C(),(0,A.$Rc)(()=>{c(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,h.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,b.$jq)(w)),w=>this.G(w),this.a.getLevel()===k.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===k.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}H(w){return(0,p.$hc)(w.fsPath)}}e.$nq=R}),define(ke[249],Se([1,0,57,388,8,28,21,4,34,3,17,11,23,99,31,205,32,242,248,44,246,245]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i,n,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0,(()=>{try{(0,N.gracefulify)(D)}catch(g){console.error(`Error enabling graceful-fs: ${(0,n.$Si)(g)}`)}})();class t extends i.$nq{static{this.I=!1}constructor(o,d){super(o,d),this.onDidChangeCapabilities=p.Event.None,this.N=new P.$Ac(l=>w.$zg.getComparisonKey(l)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(o){try{const{stat:d,symbolicLink:l}=await S.SymlinkSupport.stat(this.H(o));return{type:this.M(d,l),ctime:d.birthtime.getTime(),mtime:d.mtime.getTime(),size:d.size,permissions:d.mode&128?void 0:m.FilePermission.Locked}}catch(d){throw this.fb(d)}}async L(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const d=await S.Promises.readdir(this.H(o),{withFileTypes:!0}),l=[];return await Promise.all(d.map(async u=>{try{let v;u.isSymbolicLink()?v=(await this.stat((0,w.$Ig)(o,u.name))).type:v=this.M(u),l.push([u.name,v])}catch(v){this.a.trace(v)}})),l}catch(d){throw this.fb(d)}}M(o,d){let l;return d?.dangling?l=m.FileType.Unknown:o.isFile()?l=m.FileType.File:o.isDirectory()?l=m.FileType.Directory:l=m.FileType.Unknown,d&&(l|=m.FileType.SymbolicLink),l}async O(o){const d=this.H(o);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${d})`);let l;for(;l=this.N.get(o);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${d})`),await l.wait();const u=new h.$7g;return this.N.set(o,u),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${d})`),(0,k.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${d})`),this.N.get(o)===u&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${d})`),this.N.delete(o)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${d})`),u.open()})}async readFile(o,d){let l;try{d?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(o)})`),l=await this.O(o));const u=this.H(o);return await S.Promises.readFile(u)}catch(u){throw this.fb(u)}finally{l?.dispose()}}P(o){t.I&&this.a.trace(o)}readFileStream(o,d,l){const u=(0,E.$$d)(v=>A.$ke.concat(v.map(I=>A.$ke.wrap(I))).buffer);return(0,a.$dq)(this,o,u,v=>v.buffer,{...d,bufferSize:256*1024},l),u}async writeFile(o,d,l){return l?.atomic!==!1&&l?.atomic?.postfix&&await this.Q(o)?this.R(o,(0,w.$Ig)((0,w.$Hg)(o),`${(0,w.$Fg)(o)}${l.atomic.postfix}`),d,l):this.S(o,d,l)}async Q(o){try{const d=this.H(o),{symbolicLink:l}=await S.SymlinkSupport.stat(d);if(l)return!1}catch{}return!0}async R(o,d,l,u){const v=new k.$Sc;try{v.add(await this.O(o)),v.add(await this.O(d)),await this.S(d,l,u,!0);try{await this.rename(d,o,{overwrite:!0})}catch(I){try{await this.delete(d,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw I}}finally{v.dispose()}}async S(o,d,l,u){let v;try{const I=this.H(o);if(!l.create||!l.overwrite){if(await S.Promises.exists(I)){if(!l.overwrite)throw(0,m.$Fk)((0,c.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,m.$Fk)((0,c.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}v=await this.open(o,{create:!0,unlock:l.unlock},u),await this.write(v,0,d,0,d.byteLength)}catch(I){throw await this.gb(o,I)}finally{typeof v=="number"&&await this.close(v)}}static{this.Y=!0}static configureFlushOnWrite(o){t.Y=o}async open(o,d,l){const u=this.H(o);let v;(0,m.$tk)(d)&&!l&&(v=await this.O(o));let I;try{if((0,m.$tk)(d)&&d.unlock)try{const{stat:f}=await S.SymlinkSupport.stat(u);f.mode&128||await S.Promises.chmod(u,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let $;if((0,m.$tk)(d)){if(C.$i)try{await S.Promises.truncate(u,0),$="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}$||($="w")}else $="r";I=await S.Promises.open(u,$)}catch($){throw v?.dispose(),(0,m.$tk)(d)?await this.gb(o,$):this.fb($)}if(this.U.set(I,0),(0,m.$tk)(d)&&this.X.set(I,o),v){const $=this.W.get(I);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${I} (${u})`),this.W.set(I,v),$&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${I} (${u})`),$.dispose())}return I}async close(o){const d=this.W.get(o);try{if(this.U.delete(o),this.X.delete(o)&&t.Y)try{await S.Promises.fdatasync(o)}catch(l){t.configureFlushOnWrite(!1),this.a.error(l)}return await S.Promises.close(o)}catch(l){throw this.fb(l)}finally{d&&(this.W.get(o)===d&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.W.delete(o)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),d.dispose())}}async read(o,d,l,u,v){const I=this.Z(o,d);let $=null;try{$=(await S.Promises.read(o,l,u,v,I)).bytesRead}catch(f){throw this.fb(f)}finally{this.$(o,I,$)}return $}Z(o,d){return d===this.U.get(o)?null:d}$(o,d,l){const u=this.U.get(o);typeof u=="number"&&(typeof d=="number"||(typeof l=="number"?this.U.set(o,u+l):this.U.delete(o)))}async write(o,d,l,u,v){return(0,h.$ph)(()=>this.ab(o,d,l,u,v),100,3)}async ab(o,d,l,u,v){const I=this.Z(o,d);let $=null;try{$=(await S.Promises.write(o,l,u,v,I)).bytesWritten}catch(f){throw await this.gb(this.X.get(o),f)}finally{this.$(o,I,$)}return $}async mkdir(o){try{await S.Promises.mkdir(this.H(o))}catch(d){throw this.fb(d)}}async delete(o,d){try{const l=this.H(o);if(d.recursive){let u;d?.atomic!==!1&&d.atomic.postfix&&(u=(0,R.$jc)((0,R.$mc)(l),`${(0,R.$nc)(l)}${d.atomic.postfix}`)),await S.Promises.rm(l,S.RimRafMode.MOVE,u)}else try{await S.Promises.unlink(l)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let v=!1;try{const{stat:I,symbolicLink:$}=await S.SymlinkSupport.stat(l);v=I.isDirectory()&&!$}catch{}if(v)await S.Promises.rmdir(l);else throw u}else throw u}}catch(l){throw this.fb(l)}}async rename(o,d,l){const u=this.H(o),v=this.H(d);if(u!==v)try{await this.bb(o,d,"move",l.overwrite),await S.Promises.rename(u,v)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,c.localize)(2,null,(0,R.$nc)(u),(0,R.$nc)((0,R.$mc)(v)),I.toString()))),this.fb(I)}}async copy(o,d,l){const u=this.H(o),v=this.H(d);if(u!==v)try{await this.bb(o,d,"copy",l.overwrite),await S.Promises.copy(u,v,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,c.localize)(3,null,(0,R.$nc)(u),(0,R.$nc)((0,R.$mc)(v)),I.toString()))),this.fb(I)}}async bb(o,d,l,u){const v=this.H(o),I=this.H(d);let $=!1;if(!!(this.capabilities&1024)||($=(0,b.$8f)(v,I,!0)),$){if(l==="copy")throw(0,m.$Fk)((0,c.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(l==="move")return}const y=await this.L(o);if(!y)throw(0,m.$Fk)((0,c.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(d);if(L){if(!u)throw(0,m.$Fk)((0,c.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);y.type&m.FileType.File&&L.type&m.FileType.File||await this.delete(d,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,d){return this.cb(o,d,!1)}async cb(o,d,l){const u=this.H(o),v=this.H(d),I=!!(this.capabilities&1024);if((0,b.$8f)(u,v,!I))return;const $=new k.$Sc;try{$.add(await this.O(o)),$.add(await this.O(d)),l&&await S.Promises.mkdir((0,R.$mc)(v),{recursive:!0}),await S.Promises.copyFile(u,v)}catch(f){if(f.code==="ENOENT"&&!l)return this.cb(o,d,!0);throw this.fb(f)}finally{$.dispose()}}t(o,d,l){return new r.$uq(u=>o(u),u=>d(u),l)}F(o,d,l){return new s.$Cq(u=>o(u),u=>d(u),l)}fb(o){if(o instanceof m.$Ek)return o;let d=o,l;switch(o.code){case"ENOENT":l=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":d=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,l=m.FileSystemProviderErrorCode.Unknown;break;default:l=m.FileSystemProviderErrorCode.Unknown}return(0,m.$Fk)(d,l)}async gb(o,d){let l=this.fb(d);if(o&&l.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await S.SymlinkSupport.stat(this.H(o));u.mode&128||(l=(0,m.$Fk)(d,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return l}}e.$Dq=t}),define(ke[250],Se([1,0,3,13]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=void 0;class h extends D.$Tc{constructor(A,p=[]){super(),this.a=new N.$zj([A,...p]),this.B(A.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...p){this.a.trace(A,...p)}debug(A,...p){this.a.debug(A,...p)}info(A,...p){this.a.info(A,...p)}warn(A,...p){this.a.warn(A,...p)}error(A,...p){this.a.error(A,...p)}flush(){this.a.flush()}}e.$LO=h}),define(ke[251],Se([1,0,32,13]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AO=void 0;var h;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(h||(h={}));async function P(k,R,C,w,E){try{const S=await new Promise((m,a)=>{$e(["@vscode/spdlog"],m,a)});S.setFlushOn(h.Trace);const c=await S.createAsyncRotatingLogger(k,R,C,w);return E?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(S){console.error(S)}return null}function A(k,R,C){switch(R){case N.LogLevel.Trace:k.trace(C);break;case N.LogLevel.Debug:k.debug(C);break;case N.LogLevel.Info:k.info(C);break;case N.LogLevel.Warning:k.warn(C);break;case N.LogLevel.Error:k.error(C);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function p(k,R){switch(R){case N.LogLevel.Trace:k.setLevel(h.Trace);break;case N.LogLevel.Debug:k.setLevel(h.Debug);break;case N.LogLevel.Info:k.setLevel(h.Info);break;case N.LogLevel.Warning:k.setLevel(h.Warning);break;case N.LogLevel.Error:k.setLevel(h.Error);break;case N.LogLevel.Off:k.setLevel(h.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class b extends N.$vj{constructor(R,C,w,E,S){super(),this.m=[],this.setLevel(S),this.n=this.s(R,C,w,E),this.B(this.onDidChangeLogLevel(c=>{this.r&&p(this.r,c)}))}async s(R,C,w,E){const S=w?6:1,c=30/S*D.$1k.MB,m=await P(R,C,c,S,E);if(m){this.r=m,p(this.r,this.getLevel());for(const{level:a,message:i}of this.m)A(this.r,a,i);this.m=[]}}g(R,C){this.r?A(this.r,R,C):this.getLevel()<=R&&this.m.push({level:R,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$AO=b}),define(ke[135],Se([1,0,39,206,5]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(P||(e.MarkerTag=P={}));var A;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(b){function k(S,c){return c-S}b.compare=k;const R=Object.create(null);R[b.Error]=(0,N.localize)(0,null),R[b.Warning]=(0,N.localize)(1,null),R[b.Info]=(0,N.localize)(2,null);function C(S){return R[S]||""}b.toString=C;function w(S){switch(S){case D.default.Error:return b.Error;case D.default.Warning:return b.Warning;case D.default.Info:return b.Info;case D.default.Ignore:return b.Hint}}b.fromSeverity=w;function E(S){switch(S){case b.Error:return D.default.Error;case b.Warning:return D.default.Warning;case b.Info:return D.default.Info;case b.Hint:return D.default.Ignore}}b.toSeverity=E}(A||(e.MarkerSeverity=A={}));var p;(function(b){const k="";function R(w){return C(w,!0)}b.makeKey=R;function C(w,E){const S=[k];return w.source?S.push(w.source.replace("\xA6","\\\xA6")):S.push(k),w.code?typeof w.code=="string"?S.push(w.code.replace("\xA6","\\\xA6")):S.push(w.code.value.replace("\xA6","\\\xA6")):S.push(k),w.severity!==void 0&&w.severity!==null?S.push(A.toString(w.severity)):S.push(k),w.message&&E?S.push(w.message.replace("\xA6","\\\xA6")):S.push(k),w.startLineNumber!==void 0&&w.startLineNumber!==null?S.push(w.startLineNumber.toString()):S.push(k),w.startColumn!==void 0&&w.startColumn!==null?S.push(w.startColumn.toString()):S.push(k),w.endLineNumber!==void 0&&w.endLineNumber!==null?S.push(w.endLineNumber.toString()):S.push(k),w.endColumn!==void 0&&w.endColumn!==null?S.push(w.endColumn.toString()):S.push(k),S.push(k),S.join("\xA6")}b.makeKeyOptionalMessage=C})(p||(e.IMarkerData=p={})),e.$Ct=(0,h.$8h)("markerService")}),define(ke[252],Se([1,0,4,39,5]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.NotificationsFilter=e.$sv=e.NeverShowAgainScope=e.NotificationPriority=e.$rv=e.Severity=void 0,e.Severity=N.default,e.$rv=(0,h.$8h)("notificationService");var P;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(P||(e.NotificationPriority=P={}));var A;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function p(C){if(C){const w=C;return typeof w.id=="string"&&typeof w.label=="string"}return!1}e.$sv=p;var b;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})(b||(e.NotificationsFilter=b={}));class k{constructor(){this.progress=new R,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(w){}updateMessage(w){}updateActions(w){}close(){}}e.$tv=k;class R{infinite(){}done(){}total(w){}worked(w){}}e.$uv=R}),define(ke[253],Se([1,0,49]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const h=globalThis.vscode;if(typeof h<"u"&&typeof h.context<"u"){const P=h.context.configuration();if(P)N=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const P=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:P.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ke[136],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=void 0,e.$Hj=(0,D.$8h)("productService"),e.$Ij="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function($e,e){return function(D,N){e(D,N,$e)}};define(ke[86],Se([1,0,8,22,3,5]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.ProgressLocation=e.$vv=void 0,e.$vv=(0,P.$8h)("progressService");var A;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$wv=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(w){this.b=w}report(w){this.a=w,this.b(this.a)}}e.$xv=p;class b{get value(){return this.a}constructor(w){this.e=w}report(w){this.b?this.b.push(w):this.b=[w],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const w=this.b.shift();this.a=w,await this.e(this.a)}}finally{this.c=!1;const w=this.d;this.d=void 0,w?.()}}drain(){return this.c?new Promise(w=>{const E=this.d;this.d=()=>{E?.(),w()}}):Promise.resolve()}}e.$yv=b;let k=class extends h.$Tc{constructor(w,E){super(),this.a=new D.$sh,E.withProgress(w,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,h.$Rc)(()=>this.a.complete()))}report(w){this.b?this.b.report(w):this.c=w}};e.$zv=k,e.$zv=k=Ge([Ve(1,e.$vv)],k);class R extends h.$Tc{constructor(w){super(),this.g=w,this.a=0,this.b=this.B(new h.$Sc)}start(w){this.stop();const E=++this.a,S=new N.$7d;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},w),this.b.add((0,h.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,h.$Rc)(()=>S.cancel())),this.b.add((0,h.$Rc)(()=>this.c?this.c.done():void 0)),{id:E,token:S.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(w){this.a===w&&this.b.clear()}}e.$Av=R,e.$Bv=(0,P.$8h)("editorProgressService")}),define(ke[37],Se([1,0,61,18]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class h{constructor(){this.a=new Map}add(A,p){D.ok(N.$Jf(A)),D.ok(N.$Lf(p)),D.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,p)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Kn=new h}),define(ke[108],Se([1,0,4,37]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=void 0,e.$Ln={JSONContribution:"base.contributions.json"};function h(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class P{constructor(){this.b=new D.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,k){this.a[h(b)]=k,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const A=new P;N.$Kn.add(e.$Ln.JSONContribution,A)}),define(ke[87],Se([1,0,19,4,18,196,51,108,37]),function($e,e,D,N,h,P,A,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.ConfigurationScope=e.$Pn=e.EditPresentationTypes=void 0;var k;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$Pn={Configuration:"base.contributions.configuration"};var R;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn={properties:{},patternProperties:{}},e.$Un={properties:{},patternProperties:{}},e.$Vn={properties:{},patternProperties:{}},e.$Wn="vscode://schemas/settings/resourceLanguage",e.$Xn="vscode://schemas/settings/configurationDefaults";const C=b.$Kn.as(p.$Ln.JSONContribution);class w{constructor(){this.h=new Set,this.i=new N.$Wd,this.onDidSchemaChange=this.i.event,this.j=new N.$Wd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$Wn,this.g),this.v()}registerConfiguration(t,g=!0){this.registerConfigurations([t],g)}registerConfigurations(t,g=!0){const o=new Set;this.n(t,g,o),C.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(t){const g=new Set;this.o(t,g),C.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:g})}updateConfigurations({add:t,remove:g}){const o=new Set;this.o(g,o),this.n(t,!1,o),C.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(t){const g=new Set;this.k(t,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}k(t,g){const o=[];for(const{overrides:d,source:l}of t)for(const u in d)if(g.add(u),e.$Zn.test(u)){const v=this.a.get(u),I=v?.valuesSources??new Map;if(l)for(const L of Object.keys(d[u]))I.set(L,l);const $={...v?.value||{},...d[u]};this.a.set(u,{source:l,value:$,valuesSources:I});const f=(0,A.$Li)(u),y={type:"object",default:$,description:P.localize(1,null,f),$ref:e.$Wn,defaultDefaultValue:$,source:h.$Jf(l)?void 0:l,defaultValueSource:l};o.push(...c(u)),this.d[u]=y,this.b.properties[u]=y}else{this.a.set(u,{value:d[u],source:l});const v=this.d[u];v&&(this.w(u,v),this.r(u,v))}this.m(o)}deregisterDefaultConfigurations(t){const g=new Set;this.l(t,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}l(t,g){for(const{overrides:o,source:d}of t)for(const l in o){const u=this.a.get(l),v=h.$Jf(d)?d:d?.id,I=h.$Jf(u?.source)?u?.source:u?.source?.id;if(v===I)if(g.add(l),this.a.delete(l),e.$Zn.test(l))delete this.d[l],delete this.b.properties[l];else{const $=this.d[l];$&&(this.w(l,$),this.r(l,$))}}this.u()}deltaConfiguration(t){let g=!1;const o=new Set;t.removedDefaults&&(this.l(t.removedDefaults,o),g=!0),t.addedDefaults&&(this.k(t.addedDefaults,o),g=!0),t.removedConfigurations&&this.o(t.removedConfigurations,o),t.addedConfigurations&&this.n(t.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:g})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const g of t)this.h.add(g);this.u()}n(t,g,o){t.forEach(d=>{this.p(d,g,d.extensionInfo,d.restrictedProperties,void 0,o),this.c.push(d),this.q(d)})}o(t,g){const o=d=>{if(d.properties)for(const l in d.properties){g.add(l);const u=this.d[l];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[l],this.s(l,d.properties[l])}d.allOf?.forEach(l=>o(l))};for(const d of t){o(d);const l=this.c.indexOf(d);l!==-1&&this.c.splice(l,1)}}p(t,g=!0,o,d,l=3,u){l=h.$Sf(t.scope)?l:t.scope;const v=t.properties;if(v)for(const $ in v){const f=v[$];if(g&&n($,f)){delete v[$];continue}if(f.source=o,f.defaultDefaultValue=v[$].default,this.w($,f),e.$Zn.test($)?f.scope=void 0:(f.scope=h.$Sf(f.scope)?l:f.scope,f.restricted=h.$Sf(f.restricted)?!!d?.includes($):f.restricted),v[$].hasOwnProperty("included")&&!v[$].included){this.f[$]=v[$],delete v[$];continue}else this.d[$]=v[$],v[$].policy?.name&&this.e.set(v[$].policy.name,$);!v[$].deprecationMessage&&v[$].markdownDeprecationMessage&&(v[$].deprecationMessage=v[$].markdownDeprecationMessage),u.add($)}const I=t.allOf;if(I)for(const $ of I)this.p($,g,o,d,l,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const g=o=>{const d=o.properties;if(d)for(const u in d)this.r(u,d[u]);o.allOf?.forEach(g)};g(t)}r(t,g){switch(e.$Qn.properties[t]=g,g.scope){case 1:e.$Rn.properties[t]=g;break;case 2:e.$Sn.properties[t]=g;break;case 6:e.$Tn.properties[t]=g;break;case 3:e.$Un.properties[t]=g;break;case 4:e.$Vn.properties[t]=g;break;case 5:e.$Vn.properties[t]=g,this.g.properties[t]=g;break}}s(t,g){switch(delete e.$Qn.properties[t],g.scope){case 1:delete e.$Rn.properties[t];break;case 2:delete e.$Sn.properties[t];break;case 6:delete e.$Tn.properties[t];break;case 3:delete e.$Un.properties[t];break;case 4:case 5:delete e.$Vn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const g=`[${t}]`,o={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.$Wn};this.w(g,o),e.$Qn.properties[g]=o,e.$Rn.properties[g]=o,e.$Sn.properties[g]=o,e.$Tn.properties[g]=o,e.$Un.properties[g]=o,e.$Vn.properties[g]=o}}v(){const t={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.$Wn};e.$Qn.patternProperties[e.$Yn]=t,e.$Rn.patternProperties[e.$Yn]=t,e.$Sn.patternProperties[e.$Yn]=t,e.$Tn.patternProperties[e.$Yn]=t,e.$Un.patternProperties[e.$Yn]=t,e.$Vn.patternProperties[e.$Yn]=t,this.i.fire()}w(t,g){const o=this.a.get(t);let d=o?.value,l=o?.source;h.$Qf(d)&&(d=g.defaultDefaultValue,l=void 0),h.$Qf(d)&&(d=a(g.type)),g.default=d,g.defaultValueSource=l}}const E="\\[([^\\]]+)\\]",S=new RegExp(E,"g");e.$Yn=`^(${E})+$`,e.$Zn=new RegExp(e.$Yn);function c(s){const t=[];if(e.$Zn.test(s)){let g=S.exec(s);for(;g?.length;){const o=g[1].trim();o&&t.push(o),g=S.exec(s)}}return(0,D.$Mb)(t)}e.$1n=c;function m(s){return s.reduce((t,g)=>`${t}[${g}]`,"")}e.$2n=m;function a(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$3n=a;const i=new w;b.$Kn.add(e.$Pn.Configuration,i);function n(s,t){return s.trim()?e.$Zn.test(s)?P.localize(7,null,s):i.getConfigurationProperties()[s]!==void 0?P.localize(8,null,s):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?P.localize(9,null,s,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:P.localize(6,null)}e.$4n=n;function r(){const s=[],t=i.getConfigurationProperties();for(const g of Object.keys(t))s.push([g,t[g].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.$5n=r}),define(ke[254],Se([1,0,19,4,159,3,28,24,18,2,51,87,37]),function($e,e,D,N,h,P,A,p,b,k,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=void 0;function E(g){return Object.isFrozen(g)?g:p.$zn(g)}class S{constructor(o={},d=[],l=[],u){this.b=o,this.c=d,this.d=l,this.raw=u,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(d=>{if(d instanceof S)return d;const l=new c("");return l.parseRaw(d),l.configurationModel});this.f=o.reduce((d,l)=>l===d?l:d.merge(l),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,R.$Ji)(this.contents,o):this.contents}inspect(o,d){const l=this;return{get value(){return E(l.rawConfiguration.getValue(o))},get override(){return d?E(l.rawConfiguration.getOverrideValue(o,d)):void 0},get merged(){return E(d?l.rawConfiguration.override(d).getValue(o):l.rawConfiguration.getValue(o))},get overrides(){const u=[];for(const{contents:v,identifiers:I,keys:$}of l.rawConfiguration.overrides){const f=new S(v,$).getValue(o);f!==void 0&&u.push({identifiers:I,value:f})}return u.length?E(u):void 0}}}getOverrideValue(o,d){const l=this.i(d);return l?o?(0,R.$Ji)(l,o):l:void 0}getKeysForOverrideIdentifier(o){const d=[];for(const l of this.overrides)l.identifiers.includes(o)&&d.push(...l.keys);return D.$Mb(d)}getAllOverrideIdentifiers(){const o=[];for(const d of this.overrides)o.push(...d.identifiers);return D.$Mb(o)}override(o){let d=this.a.get(o);return d||(d=this.g(o),this.a.set(o,d)),d}merge(...o){const d=p.$yn(this.contents),l=p.$yn(this.overrides),u=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const I of o)if(v.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(d,I.contents);for(const $ of I.overrides){const[f]=l.filter(y=>D.$ub(y.identifiers,$.identifiers));f?(this.h(f.contents,$.contents),f.keys.push(...$.keys),f.keys=D.$Mb(f.keys)):l.push(p.$yn($))}for(const $ of I.keys)u.indexOf($)===-1&&u.push($)}return new S(d,u,l,v.every(I=>I instanceof S)?void 0:v)}g(o){const d=this.i(o);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const l={};for(const u of D.$Mb([...Object.keys(this.contents),...Object.keys(d)])){let v=this.contents[u];const I=d[u];I&&(typeof v=="object"&&typeof I=="object"?(v=p.$yn(v),this.h(v,I)):v=I),l[u]=v}return new S(l,this.keys,this.overrides)}h(o,d){for(const l of Object.keys(d)){if(l in o&&b.$Lf(o[l])&&b.$Lf(d[l])){this.h(o[l],d[l]);continue}o[l]=p.$yn(d[l])}}i(o){let d=null,l=null;const u=v=>{v&&(l?this.h(l,v):l=p.$yn(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===o?d=v.contents:v.identifiers.includes(o)&&u(v.contents);return u(d),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,d){this.j(o,d,!0)}setValue(o,d){this.j(o,d,!1)}removeValue(o){const d=this.keys.indexOf(o);d!==-1&&(this.keys.splice(d,1),(0,R.$Ii)(this.contents,o),C.$Zn.test(o)&&this.overrides.splice(this.overrides.findIndex(l=>D.$ub(l.identifiers,(0,C.$1n)(o))),1))}j(o,d,l){(0,R.$Hi)(this.contents,o,d,u=>console.error(u)),l=l||this.keys.indexOf(o)===-1,l&&this.keys.push(o),C.$Zn.test(o)&&this.overrides.push({identifiers:(0,C.$1n)(o),keys:Object.keys(this.contents[o]),contents:(0,R.$Gi)(this.contents[o],u=>console.error(u))})}}e.$6n=S;class c{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,d){if(!b.$Sf(o)){const l=this.g(o);this.parseRaw(l,d)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,d){this.a=o;const{contents:l,keys:u,overrides:v,restricted:I,hasExcludedProperties:$}=this.h(o,d);this.b=new S(l,u,v,$?[o]:void 0),this.c=I||[]}g(o){let d={},l=null,u=[];const v=[],I=[];function $(y){Array.isArray(u)?u.push(y):l!==null&&(u[l]=y)}const f={onObjectBegin:()=>{const y={};$(y),v.push(u),u=y,l=null},onObjectProperty:y=>{l=y},onObjectEnd:()=>{u=v.pop()},onArrayBegin:()=>{const y=[];$(y),v.push(u),u=y,l=null},onArrayEnd:()=>{u=v.pop()},onLiteralValue:$,onError:(y,L,T)=>{I.push({error:y,offset:L,length:T})}};if(o)try{h.$mn(o,f),d=u[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return d}h(o,d){const l=w.$Kn.as(C.$Pn.Configuration).getConfigurationProperties(),u=this.i(o,l,!0,d);o=u.raw;const v=(0,R.$Gi)(o,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),I=Object.keys(o),$=this.j(o,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:v,keys:I,overrides:$,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}i(o,d,l,u){let v=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:v};const I={},$=[];for(const f in o)if(C.$Zn.test(f)&&l){const y=this.i(o[f],d,!1,u);I[f]=y.raw,v=v||y.hasExcludedProperties,$.push(...y.restricted)}else{const y=d[f],L=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&$.push(f),!u.exclude?.includes(f)&&(u.include?.includes(f)||(L===void 0||u.scopes===void 0||u.scopes.includes(L))&&!(u.skipRestricted&&y?.restricted))?I[f]=o[f]:v=!0}return{raw:I,restricted:$,hasExcludedProperties:v}}j(o,d){const l=[];for(const u of Object.keys(o))if(C.$Zn.test(u)){const v={};for(const I in o[u])v[I]=o[u][I];l.push({identifiers:(0,C.$1n)(u),keys:Object.keys(v),contents:(0,R.$Gi)(v,d)})}return l}}e.$7n=c;class m extends P.$Tc{constructor(o,d,l,u){super(),this.c=o,this.f=d,this.g=u,this.b=this.B(new N.$Wd),this.onDidChange=this.b.event,this.a=new c(this.c.toString()),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(0)||v.isOperation(3)||v.isOperation(1)||v.isOperation(4))&&l.isEqual(v.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$8n=m;class a{constructor(o,d,l,u,v,I,$,f,y,L,T,U,j){this.a=o,this.b=d,this.c=l,this.overrideIdentifiers=u,this.d=v,this.f=I,this.g=$,this.h=f,this.i=y,this.j=L,this.k=T,this.l=U,this.m=j}get value(){return E(this.c)}n(o){return o?.value!==void 0||o?.override!==void 0||o?.overrides!==void 0?o:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(o,d,l,u,v=new S,I=new S,$=new A.$Ac,f=new S,y=new A.$Ac){this.c=o,this.d=d,this.f=l,this.g=u,this.h=v,this.i=I,this.j=$,this.l=f,this.m=y,this.a=null,this.b=new A.$Ac,this.n=null}getValue(o,d,l){return this.p(o,d,l).getValue(o)}updateValue(o,d,l={}){let u;l.resource?(u=this.m.get(l.resource),u||(u=new S,this.m.set(l.resource,u))):u=this.l,d===void 0?u.removeValue(o):u.setValue(o,d),l.resource||(this.a=null)}inspect(o,d,l){const u=this.p(o,d,l),v=this.t(d.resource,l),I=d.resource?this.m.get(d.resource)||this.l:this.l,$=new Set;for(const f of u.overrides)for(const y of f.identifiers)u.getOverrideValue(o,y)!==void 0&&$.add(y);return new a(o,d,u.getValue(o),$.size?[...$]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.i:void 0,v||void 0,I)}keys(o){const d=this.t(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,d){this.j.set(o,d),this.b.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,d){const l=[];if(!d){const{added:u,updated:v,removed:I}=s(this.c,o);d=[...u,...v,...I]}for(const u of d)for(const v of(0,C.$1n)(u)){const I=this.c.getKeysForOverrideIdentifier(v),$=o.getKeysForOverrideIdentifier(v),f=[...$.filter(y=>I.indexOf(y)===-1),...I.filter(y=>$.indexOf(y)===-1),...I.filter(y=>!p.$Cn(this.c.override(v).getValue(y),o.override(v).getValue(y)))];l.push([v,f])}return this.updateDefaultConfiguration(o),{keys:d,overrides:l}}compareAndUpdatePolicyConfiguration(o){const{added:d,updated:l,removed:u}=s(this.d,o),v=[...d,...l,...u];return v.length&&this.updatePolicyConfiguration(o),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:d,updated:l,removed:u,overrides:v}=s(this.applicationConfiguration,o),I=[...d,...l,...u];return I.length&&this.updateApplicationConfiguration(o),{keys:I,overrides:v}}compareAndUpdateLocalUserConfiguration(o){const{added:d,updated:l,removed:u,overrides:v}=s(this.localUserConfiguration,o),I=[...d,...l,...u];return I.length&&this.updateLocalUserConfiguration(o),{keys:I,overrides:v}}compareAndUpdateRemoteUserConfiguration(o){const{added:d,updated:l,removed:u,overrides:v}=s(this.remoteUserConfiguration,o),I=[...d,...l,...u];return I.length&&this.updateRemoteUserConfiguration(o),{keys:I,overrides:v}}compareAndUpdateWorkspaceConfiguration(o){const{added:d,updated:l,removed:u,overrides:v}=s(this.workspaceConfiguration,o),I=[...d,...l,...u];return I.length&&this.updateWorkspaceConfiguration(o),{keys:I,overrides:v}}compareAndUpdateFolderConfiguration(o,d){const l=this.folderConfigurations.get(o),{added:u,updated:v,removed:I,overrides:$}=s(l,d),f=[...u,...v,...I];return(f.length||!l)&&this.updateFolderConfiguration(o,d),{keys:f,overrides:$}}compareAndDeleteFolderConfiguration(o){const d=this.folderConfigurations.get(o);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:l,updated:u,removed:v,overrides:I}=s(d,void 0);return{keys:[...l,...u,...v],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(o,d,l){let u=this.q(d,l);return d.overrideIdentifier&&(u=u.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(u=u.merge(this.d)),u}q({resource:o},d){let l=this.r();if(d&&o){const u=d.getFolder(o);u&&(l=this.s(u.uri)||l);const v=this.m.get(o);v&&(l=l.merge(v))}return l}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(o){let d=this.b.get(o);if(!d){const l=this.r(),u=this.j.get(o);u?(d=l.merge(u),this.b.set(o,d)):d=l}return d}t(o,d){if(d&&o){const l=d.getFolder(o);if(l)return this.j.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,d)=>{const{contents:l,overrides:u,keys:v}=this.j.get(d);return o.push([d,{contents:l,overrides:u,keys:v}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(d=>o.add(d)),this.userConfiguration.keys.forEach(d=>o.add(d)),this.i.keys.forEach(d=>o.add(d)),this.j.forEach(d=>d.keys.forEach(l=>o.add(l))),[...o.values()]}u(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>o.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>o.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>o.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(l=>o.add(l))),[...o.values()]}v(o){const d=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(l=>d.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(l=>d.add(l)),this.i.getKeysForOverrideIdentifier(o).forEach(l=>d.add(l)),this.j.forEach(l=>l.getKeysForOverrideIdentifier(o).forEach(u=>d.add(u))),[...d.values()]}static parse(o){const d=this.w(o.defaults),l=this.w(o.policy),u=this.w(o.application),v=this.w(o.user),I=this.w(o.workspace),$=o.folders.reduce((f,y)=>(f.set(k.URI.revive(y[0]),this.w(y[1])),f),new A.$Ac);return new i(d,l,u,v,new S,I,$,new S,new A.$Ac)}static w(o){return new S(o.contents,o.keys,o.overrides)}}e.$9n=i;function n(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const o=new Set,d=new Map;for(const u of g)u.keys.forEach(v=>o.add(v)),u.overrides.forEach(([v,I])=>{const $=(0,A.$xc)(d,v,new Set);I.forEach(f=>$.add(f))});const l=[];return d.forEach((u,v)=>l.push([v,[...u.values()]])),{keys:[...o.values()],overrides:l}}e.$0n=n;class r{constructor(o,d,l,u){this.change=o,this.f=d,this.g=l,this.h=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const v of o.keys)this.affectedKeys.add(v);for(const[,v]of o.overrides)for(const I of v)this.affectedKeys.add(I);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(o,d){const l=this.a+o,u=this.d.indexOf(l);if(u<0)return!1;const v=u+l.length;if(v>=this.d.length)return!1;const I=this.d.charCodeAt(v);if(I!==this.b&&I!==this.c)return!1;if(d){const $=this.previousConfiguration?this.previousConfiguration.getValue(o,d,this.f?.workspace):void 0,f=this.g.getValue(o,d,this.h);return!p.$Cn($,f)}return!0}}e.$$n=r;function s(g,o){const{added:d,removed:l,updated:u}=t(o?.rawConfiguration,g?.rawConfiguration),v=[],I=g?.getAllOverrideIdentifiers()||[],$=o?.getAllOverrideIdentifiers()||[];if(o){const f=$.filter(y=>!I.includes(y));for(const y of f)v.push([y,o.getKeysForOverrideIdentifier(y)])}if(g){const f=I.filter(y=>!$.includes(y));for(const y of f)v.push([y,g.getKeysForOverrideIdentifier(y)])}if(o&&g){for(const f of I)if($.includes(f)){const y=t({contents:g.getOverrideValue(void 0,f)||{},keys:g.getKeysForOverrideIdentifier(f)},{contents:o.getOverrideValue(void 0,f)||{},keys:o.getKeysForOverrideIdentifier(f)});v.push([f,[...y.added,...y.removed,...y.updated]])}}return{added:d,removed:l,updated:u,overrides:v}}function t(g,o){const d=g?o?g.keys.filter(v=>o.keys.indexOf(v)===-1):[...g.keys]:[],l=o?g?o.keys.filter(v=>g.keys.indexOf(v)===-1):[...o.keys]:[],u=[];if(g&&o){for(const v of o.keys)if(g.keys.indexOf(v)!==-1){const I=(0,R.$Ji)(o.contents,v),$=(0,R.$Ji)(g.contents,v);p.$Cn(I,$)||u.push(v)}}return{added:d,removed:l,updated:u}}}),define(ke[255],Se([1,0,21,4,3,82]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fsb=e.$esb=e.$dsb=e.$csb=void 0;const A=(k,R,C)=>{const w=new Uint8Array(16);for(let c=0;c<16;c++)w[c]=Math.round(Math.random()*256);const E=(0,D.$Ee)(D.$ke.wrap(w));return[`GET ws://localhost${k}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`].join(`\r
`)+`\r
\r
`};e.$csb=A,e.$dsb=D.$ke.fromString(`\r
\r
`);async function p(k,R,C,w,E){k.write(D.$ke.fromString((0,e.$csb)(R,C,w)));const S=new h.$Sc;try{return await new Promise((c,m)=>{let a;S.add(k.onData(i=>{a?a=D.$ke.concat([a,i],a.byteLength+i.byteLength):a=i;const n=a.indexOf(e.$dsb);if(n===-1)return;c(k),k.pauseData();const r=a.slice(n+e.$dsb.byteLength);r.byteLength&&E.onData.fire(r)})),S.add(k.onClose(i=>m(i??new Error("socket closed")))),S.add(k.onEnd(()=>m(new Error("socket ended"))))})}catch(c){throw k.dispose(),c}finally{S.dispose()}}e.$esb=p;class b extends h.$Tc{constructor(R,C){super(),this.g=R,this.a=this.B(new N.$Zd),this.onData=(...w)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...w)),this.b=this.B(new N.$Wd),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(w=>this.a.fire(w))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,C){P.SocketDiagnostics.traceSocketEvent(this,this.g,R,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$fsb=b}),define(ke[64],Se([1,0,14,5]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.RemoteAuthorityResolverErrorCode=e.$_k=e.$$k=e.RemoteConnectionType=e.$0k=void 0,e.$0k=(0,N.$8h)("remoteAuthorityResolverService");var h;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(h||(e.RemoteConnectionType=h={}));class P{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$$k=P;class A{constructor(C,w){this.host=C,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$_k=A;var p;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class b extends D.$bb{static isNotAvailable(C){return C instanceof b&&C._code===p.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof b&&C._code===p.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof b&&C._code===p.NoResolverFound}static isInvalidAuthority(C){return C instanceof b&&C._code===p.InvalidAuthority}static isHandled(C){return C instanceof b&&C.isHandled}constructor(C,w=p.Unknown,E){super(C),this._message=C,this._code=w,this._detail=E,this.isHandled=w===p.NotAvailable&&E===!0,Object.setPrototypeOf(this,b.prototype)}}e.$al=b;function k(R){const C=R.indexOf("+");return C===-1?R:R.substring(0,C)}e.$bl=k}),define(ke[65],Se([1,0,16]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0;function N(k){return k.scheme===D.Schemas.vscodeRemote?k.authority:void 0}e.$cl=N;function h(k){if(!k)return;const R=k.indexOf("+");return R<0?k:k.substr(0,R)}e.$dl=h;function P(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.$el=P;function A(k){const{host:R,port:C}=b(k);if(typeof C>"u")throw new Error(`Invalid remote authority: ${k}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:R,port:C}}e.$fl=A;function p(k,R){let{host:C,port:w}=b(k);return typeof w>"u"&&(w=R),{host:C,port:w}}e.$gl=p;function b(k){const R=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const C=k.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const w=k.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:k,port:void 0}}}),define(ke[25],Se([1,0,12,5,65]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.TargetPlatform=e.ExtensionType=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=void 0,e.$hm="extensions.user.cache",e.$im="extensions.builtin.cache",e.$jm="undefined_publisher",e.$km=["ui","workspace","web"];function P(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$lm=P,e.$mm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(A||(e.ExtensionType=A={}));var p;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class b{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,a){if(typeof m>"u"||m===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof m=="string"||typeof a=="string"){const i=typeof m=="string"?m:m.value,n=typeof a=="string"?a:a.value;return D.$af(i,n)}return m._lower===a._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$nm=b;class k{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const a of m)this.add(a)}add(m){this.c.add(b.toKey(m))}delete(m){return this.c.delete(b.toKey(m))}has(m){return this.c.has(b.toKey(m))}}e.$om=k;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(b.toKey(m))}get(m){return this.c.get(b.toKey(m))}has(m){return this.c.has(b.toKey(m))}set(m,a){this.c.set(b.toKey(m),a)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pm=R;function C(c){return w(c)}e.$qm=C;function w(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.$rm=w;function E(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.$sm=E;function S(c,m){if(m){const a=`onResolveRemoteAuthority:${(0,h.$dl)(m)}`;return!!c.activationEvents?.includes(a)}return!1}e.$tm=S,e.$um=(0,N.$8h)("IBuiltinExtensionsScannerService")}),define(ke[137],Se([1,0,14,25]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=void 0;class h{constructor(){this.a=new Map,this.b=new WeakMap}register(A,p){this.a.set(A,p)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const p=Object.create(null);for(const b of A){const k=this.readActivationEvents(b);k.length>0&&(p[N.$nm.toKey(b.identifier)]=k)}return p}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const p=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let b=0;b<p.length;b++)p[b]==="onUri"&&(p[b]=`onUri:${N.$nm.toKey(A.identifier)}`);if(!A.contributes)return p;for(const b in A.contributes){const k=this.a.get(b);if(!k)continue;const R=A.contributes[b],C=Array.isArray(R)?R:[R];try{k(C,p)}catch(w){(0,D.$1)(w)}}return p}}e.$pF=h,e.$qF=new h}),define(ke[256],Se([1,0,8,21,22,14,4,3,58,38,30,82,64,65]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.PersistentConnectionEventType=e.$nl=e.$ml=e.$ll=e.ConnectionType=void 0;const S=30*1e3;var c;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(c||(e.ConnectionType=c={}));function m(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function a(K){const W=new h.$7d;return setTimeout(()=>W.cancel(),K),W.token}function i(K,W){if(K.isCancellationRequested||W.isCancellationRequested)return h.CancellationToken.Cancelled;const re=new h.$7d;return K.onCancellationRequested(()=>re.cancel()),W.onCancellationRequested(()=>re.cancel()),re.token}class n{get didTimeout(){return this.c==="timedout"}constructor(W){this.c="pending",this.d=new p.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,D.$1g)(),W.isCancellationRequested?this.h():this.d.add(W.onCancellationRequested(()=>this.h()))}registerDisposable(W){this.c==="pending"?this.d.add(W):W.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(W))}reject(W){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(W))}}function r(K,W){const re=new n(W);return re.registerDisposable(K.onControlMessage(ye=>{const he=JSON.parse(ye.toString()),fe=X(he);fe?re.reject(fe):re.resolve(he)})),re.promise}function s(K,W,re,ye,he,fe,ue,me){const V=new n(me),Y=k.$Sd.create(!1);return K.info(`Creating a socket (${ue})...`),b.mark(`code/willCreateSocket/${fe}`),W.connect(re,ye,he,ue).then(de=>{V.didTimeout?(b.mark(`code/didCreateSocketError/${fe}`),K.info(`Creating a socket (${ue}) finished after ${Y.elapsed()} ms, but this is too late and has timed out already.`),de?.dispose()):(b.mark(`code/didCreateSocketOK/${fe}`),K.info(`Creating a socket (${ue}) was successful after ${Y.elapsed()} ms.`),V.resolve(de))},de=>{b.mark(`code/didCreateSocketError/${fe}`),K.info(`Creating a socket (${ue}) returned an error after ${Y.elapsed()} ms.`),K.error(de),V.reject(de)}),V.promise}function t(K,W){const re=new n(W);return K.then(ye=>{re.didTimeout||re.resolve(ye)},ye=>{re.didTimeout||re.reject(ye)}),re.promise}async function g(K,W,re,ye){const he=ge(K,W);K.logService.trace(`${he} 1/6. invoking socketFactory.connect().`);let fe;try{fe=await s(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,E.$el)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,m(W),`renderer-${m(W)}-${K.reconnectionToken}`,ye)}catch(de){throw K.logService.error(`${he} socketFactory.connect() failed or timed out. Error:`),K.logService.error(de),de}K.logService.trace(`${he} 2/6. socketFactory.connect() was successful.`);let ue,me;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(fe,null),ue=K.reconnectionProtocol,me=!1):(ue=new C.$Vh({socket:fe}),me=!0),K.logService.trace(`${he} 3/6. sending AuthRequest control message.`);const V=await t(K.signService.createNewMessage((0,R.$rg)()),ye),Y={type:"auth",auth:K.connectionToken||"00000000000000000000",data:V.data};ue.sendControl(N.$ke.fromString(JSON.stringify(Y)));try{const de=await r(ue,i(ye,a(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(K.logService.trace(`${he} 4/6. received SignRequest control message.`),!await t(K.signService.validate(V,de.signedData),ye)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const Pe=await t(K.signService.sign(de.data),ye),ve={type:"connectionType",commit:K.commit,signedData:Pe,desiredConnectionType:W};return re&&(ve.args=re),K.logService.trace(`${he} 5/6. sending ConnectionTypeRequest control message.`),ue.sendControl(N.$ke.fromString(JSON.stringify(ve))),{protocol:ue,ownsProtocol:me}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(K.logService.error(`${he} the handshake timed out. Error:`),K.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${he} received error control message when negotiating connection. Error:`),K.logService.error(de)),me&&x(ue),de}}async function o(K,W,re,ye){const he=Date.now(),fe=ge(K,W),{protocol:ue,ownsProtocol:me}=await g(K,W,re,ye),V=new n(ye);return V.registerDisposable(ue.onControlMessage(Y=>{const de=JSON.parse(Y.toString()),we=X(de);we?(K.logService.error(`${fe} received error control message when negotiating connection. Error:`),K.logService.error(we),me&&x(ue),V.reject(we)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${fe} 6/6. handshake finished, connection is up and running after ${ne(he)}!`),V.resolve({protocol:ue,firstMessage:de}))})),V.promise}async function d(K,W){const{protocol:re}=await o(K,1,void 0,W);return{protocol:re}}async function l(K,W,re){const{protocol:ye,firstMessage:he}=await o(K,2,W,re),fe=he&&he.debugPort;return{protocol:ye,debugPort:fe}}async function u(K,W,re){const ye=Date.now(),he=ge(K,3),{protocol:fe}=await g(K,3,W,re);return K.logService.trace(`${he} 6/6. handshake finished, connection is up and running after ${ne(ye)}!`),fe}async function v(K,W,re){const{connectTo:ye,connectionToken:he}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:ye,connectionToken:he,reconnectionToken:W,reconnectionProtocol:re,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function I(K,W,re){return f(K,async ye=>{const{protocol:he}=await d(ye,h.CancellationToken.None);return new J(K,W,re,ye.reconnectionToken,he)})}e.$ll=I;async function $(K,W){return f(K,async re=>{const{protocol:ye,debugPort:he}=await l(re,W,h.CancellationToken.None);return new te(K,W,re.reconnectionToken,ye,he)})}e.$ml=$;async function f(K,W){for(let ye=1;;ye++)try{const he=(0,R.$rg)(),fe=await v(K,he,null);return await W(fe)}catch(he){if(ye<5)K.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(he);else throw K.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(he),z.triggerPermanentFailure(0,0,w.$al.isHandled(he)),he}}async function y(K,W,re){const ye=await v(K,(0,R.$rg)(),null);return await u(ye,{host:W,port:re},h.CancellationToken.None)}e.$nl=y;function L(K){return(0,D.$Ug)(W=>new Promise((re,ye)=>{const he=setTimeout(re,K*1e3);W.onCancellationRequested(()=>{clearTimeout(he),re()})}))}var T;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class U{constructor(W,re){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.type=0}}e.$ol=U;class j{constructor(W,re,ye,he){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.durationSeconds=ye,this.c=he,this.type=1}skipWait(){this.c.cancel()}}e.$pl=j;class F{constructor(W,re,ye){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.attempt=ye,this.type=2}}e.$ql=F;class M{constructor(W,re,ye){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.attempt=ye,this.type=4}}e.$rl=M;class O{constructor(W,re,ye,he){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.attempt=ye,this.handled=he,this.type=3}}e.$sl=O;class z extends p.$Tc{static triggerPermanentFailure(W,re,ye){this._permanentFailure=!0,this.f=W,this.g=re,this.h=ye,this.j.forEach(he=>he.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(W=>W.y())}static debugPauseSocketWriting(){this.j.forEach(W=>W.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||z._permanentFailure}constructor(W,re,ye,he,fe){super(),this.t=W,this.u=re,this.reconnectionToken=ye,this.protocol=he,this.w=fe,this.m=this.B(new A.$Wd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new M(this.reconnectionToken,0,0)),this.B(he.onSocketClose(ue=>{const me=_(this.t,this.reconnectionToken,!0);ue?ue.type===0?(this.u.logService.info(`${me} received socket close event (hadError: ${ue.hadError}).`),ue.error&&this.u.logService.error(ue.error)):(this.u.logService.info(`${me} received socket close event (wasClean: ${ue.wasClean}, code: ${ue.code}, reason: ${ue.reason}).`),ue.event&&this.u.logService.error(ue.event)):this.u.logService.info(`${me} received socket close event.`),this.y()})),this.B(he.onSocketTimeout(ue=>{const me=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${me} received socket timeout event (unacknowledgedMsgCount: ${ue.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ue.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ue.timeSinceLastReceivedSomeData}).`),this.y()})),z.j.push(this),this.B((0,p.$Rc)(()=>{const ue=z.j.indexOf(this);ue>=0&&z.j.splice(ue,1)})),this.n&&this.D(z.f,z.g,z.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const W=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const re=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const he=ye<re.length?re[ye]:re[re.length-1];try{if(he>0){const ue=L(he);this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),he,ue)),this.u.logService.info(`${W} waiting for ${he} seconds before reconnecting...`);try{await ue}catch{}}if(this.n){this.u.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this.u.logService.info(`${W} resolving connection...`);const fe=await v(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${W} connecting to ${fe.connectTo}...`),await this.G(fe,a(S)),this.u.logService.info(`${W} reconnected!`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(fe){if(fe.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(fe),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this.u.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(fe),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(w.$al.isTemporarilyNotAvailable(fe)){this.u.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(fe);continue}if((fe.code==="ETIMEDOUT"||fe.code==="ENETUNREACH"||fe.code==="ECONNREFUSED"||fe.code==="ECONNRESET")&&fe.syscall==="connect"){this.u.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(fe);continue}if((0,P.$4)(fe)){this.u.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(fe);continue}if(fe instanceof w.$al){this.u.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(fe),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,w.$al.isHandled(fe));break}this.u.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(fe),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this.n&&!this.s)}C(W,re,ye){this.w?z.triggerPermanentFailure(W,re,ye):this.D(W,re,ye)}D(W,re,ye){this.m.fire(new O(this.reconnectionToken,W,re,ye)),x(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$tl=z;class J extends z{constructor(W,re,ye,he,fe){super(1,W,he,fe,!0),this.client=this.B(new C.$Th(fe,{remoteAuthority:re,clientId:ye},W.ipcLogger))}async G(W,re){await d(W,re)}}e.$ul=J;class te extends z{constructor(W,re,ye,he,fe){super(2,W,ye,he,!1),this.H=re,this.debugPort=fe}async G(W,re){await l(W,this.H,re)}}e.$vl=te;function x(K){try{K.acceptDisconnect();const W=K.getSocket();K.dispose(),W.dispose()}catch(W){(0,P.$1)(W)}}function X(K){if(K&&K.type==="error"){const W=new Error(`Connection error: ${K.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function Z(K,W){for(;K.length<W;)K+=" ";return K}function ae(K,W){return`[remote-connection][${Z(m(K),13)}][${W.substr(0,5)}\u2026]`}function _(K,W,re){return`${ae(K,W)}[${re?"reconnect":"initial"}]`}function ge(K,W){return`${_(W,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function ne(K){return`${Date.now()-K} ms`}}),define(ke[257],Se([1,0,3,5]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=void 0,e.$hl=(0,N.$8h)("remoteSocketFactoryService");class h{constructor(){this.a={}}register(A,p){return this.a[A]??=[],this.a[A].push(p),(0,D.$Rc)(()=>{const b=this.a[A]?.indexOf(p);typeof b=="number"&&b>=0&&this.a[A]?.splice(b,1)})}b(A){return(this.a[A.type]||[]).find(b=>b.supports(A))}connect(A,p,b,k){const R=this.b(A);if(!R)throw new Error(`No socket factory found for ${A}`);return R.connect(A,p,b,k)}}e.$il=h}),define(ke[258],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(h){try{const P=await this.c();if(P){const A=String(D.a++);return this.b.set(A,P),{id:A,data:P.createNewMessage(h)}}}catch{}return{id:"",data:h}}async validate(h,P){if(!h.id)return!0;const A=this.b.get(h.id);if(!A)return!1;this.b.delete(h.id);try{return A.validate(P)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(h){try{return await this.d(h)}catch{}return h}}e.$36b=D}),define(ke[109],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=void 0,e.$jl="signService",e.$kl=(0,D.$8h)(e.$jl)}),define(ke[138],Se([1,0,258]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X$b=void 0;class N extends D.$36b{c(){return this.h().then(P=>new P.validator)}d(P){return this.h().then(A=>new A.signer().sign(P))}h(){return new Promise((P,A)=>$e(["vsda"],P,A))}}e.$X$b=N}),define(ke[259],Se([1,0,11,49,30]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=void 0;function P(b){if(D.$u===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}function A(b,k,R,C,w,E,S,c,m){const a=Object.create(null);a["common.machineId"]=E,a["common.sqmId"]=S,a.sessionID=(0,h.$rg)()+Date.now(),a.commitHash=C,a.version=w,a["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,D.$h)(D.$u),a["common.nodePlatform"]=N.$dc,a["common.nodeArch"]=R,a["common.product"]=m||"desktop",c&&(a["common.msftInternal"]=c);let i=0;const n=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$l&&(a["common.snap"]="true");const r=P(k);return r&&(a["common.platformDetail"]=r),a}e.$Lo=A;function p(b){const k=N.env.USERDNSDOMAIN;if(!k)return!1;const R=k.toLowerCase();return b.some(C=>R===C)}e.$Mo=p}),define(ke[260],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=void 0,e.$wl=(0,D.$8h)("telemetryService"),e.$xl=(0,D.$8h)("customEndpointTelemetryService"),e.$yl="telemetry.currentSessionDate",e.$zl="telemetry.firstSessionDate",e.$Al="telemetry.lastSessionDate",e.$Bl="telemetry.machineId",e.$Cl="telemetry.sqmId",e.$Dl="telemetry",e.$El="telemetry.telemetryLevel",e.$Fl="telemetry.enableCrashReporter",e.$Gl="telemetry.enableTelemetry";var N;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var h;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(h||(e.TelemetryConfiguration=h={}))}),define(ke[88],Se([1,0,24,18,65,259,260]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;class p{constructor(g){this.value=g,this.isTrustedTelemetryValue=!0}}e.$No=p;class b{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Oo=b,e.$Po=new b;class k{async publicLog(g,o,d){}async publicLogError(g,o,d){}}e.$Qo=k,e.$Ro="telemetry",e.$So="extensionTelemetryLog",e.$To={log:()=>null,flush:()=>Promise.resolve(null)};function R(t,g){return!g.isBuilt&&!g.disableTelemetry?!0:!(g.disableTelemetry||!t.enableTelemetry)}e.$Uo=R;function C(t,g){return g.extensionTestsLocationURI?!0:!(g.isBuilt||g.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$Vo=C;function w(t){const g=t.getValue(A.$El),o=t.getValue(A.$Fl);if(t.getValue(A.$Gl)===!1||o===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Wo=w;function E(t){const g={},o={},d={};m(t,d);for(let l in d){l=l.length>150?l.substr(l.length-149):l;const u=d[l];typeof u=="number"?o[l]=u:typeof u=="boolean"?o[l]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${u.length}`),g[l]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(g[l]=u)}return{properties:g,measurements:o}}e.$Xo=E;const S=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const g=(0,h.$dl)(t);return S.has(g)?g:"other"}e.$Yo=c;function m(t,g,o=0,d){if(t)for(const l of Object.getOwnPropertyNames(t)){const u=t[l],v=d?d+l:l;Array.isArray(u)?g[v]=(0,D.$Dn)(u):u instanceof Date?g[v]=u.toISOString():(0,N.$Lf)(u)?o<2?m(u,g,o+1,v+"."):g[v]=(0,D.$Dn)(u):g[v]=u}}function a(t,g){const o=t.msftInternalDomains||[],d=g.getValue("telemetry.internalTesting");return(0,P.$Mo)(o)||d}e.$Zo=a;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$1o=i;function n(t,g){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let o=t;const d=[];for(const I of g)for(;;){const $=I.exec(t);if(!$)break;d.push([$.index,I.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(o="";;){const I=u.exec(t);if(!I)break;const $=d.some(([f,y])=>I.index<y&&f<u.lastIndex);!l.test(I[0])&&!$&&(o+=t.substring(v,I.index)+"<REDACTED: user-file-path>",v=u.lastIndex)}return v<t.length&&(o+=t.substr(v)),o}function r(t){if(!t)return t;const g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of g)if(o.regex.test(t))return`<REDACTED: ${o.label}>`;return t}function s(t,g){return(0,D.$An)(t,o=>{if(o instanceof p||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let d=o.replaceAll("%20"," ");d=n(d,g);for(const l of g)d=d.replace(l,"");return d=r(d),d}})}e.$2o=s}),define(ke[261],Se([1,0,12,134,25,11,2,14,49,88]),function($e,e,D,N,h,P,A,p,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0;function R(o,d){return o.uuid&&d.uuid?o.uuid===d.uuid:o.id===d.id?!0:(0,D.$8e)(o.id,d.id)===0}e.$3o=R;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(d){const l=d.manifest?d.manifest.version:d.version,u=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new w(d.identifier,l,u)}static parse(d){const l=C.exec(d);return l&&l[1]&&l[2]?new w({id:l[1]},l[2],l[4]||void 0):null}constructor(d,l,u="undefined"){this.version=l,this.targetPlatform=u,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof w?R(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$4o=w;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(o){const d=E.exec(o);return d&&d[1]?[m(d[1]),d[2]]:[m(o),void 0]}e.$5o=S;function c(o,d){return`${o}.${d}`}e.$6o=c;function m(o){return o.toLowerCase()}e.$7o=m;function a(o,d){return m(c(o??h.$jm,d))}e.$8o=a;function i(o,d){const l=[],u=v=>{for(const I of l)if(I.some($=>R(d($),d(v))))return I;return null};for(const v of o){const I=u(v);I?I.push(v):l.push([v])}return l}e.$9o=i;function n(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.$0o=n;function r(o){return{id:new k.$No(o.identifier.id),name:new k.$No(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$$o=r,e.$_o=new h.$nm("pprice.better-merge");function s(o,d){const l=[],u=d.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const v=u.shift();if(v&&l.every(I=>!R(I.identifier,{id:v}))){const I=o.filter($=>R($.identifier,{id:v}));I.length===1&&(l.push(I[0]),u.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.$ap=s;async function t(o,d){if(!P.$k)return!1;let l;try{l=(await o.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await o.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){d.debug("Error while getting the os-release file.",(0,p.$0)(v))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function g(o,d){const l=await t(o,d),u=(0,N.$xo)(l?"alpine":P.$u,b.$ec);return d.debug("ComputeTargetPlatform:",u),u}e.$bp=g}),define(ke[262],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=e.$Pr=e.$Or=void 0;function D(b){return[...b.entries()]}e.$Or=D;function N(b){return b?[...b.entries()]:[]}e.$Pr=N;function h(b){return new Map(b)}e.$Qr=h;function P(b){return new Map(b??[])}e.$Rr=P;function A(b){return Array.from(b.entries()).map(k=>[k[0],D(k[1].map),N(k[1].descriptionMap)])}e.$Sr=A;function p(b){return new Map(b.map(k=>[k[0],{map:h(k[1]),descriptionMap:P(k[2])}]))}e.$Tr=p}),define(ke[263],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wsb=void 0;class D{constructor(h){this.b=h,this.a=new Map}dispose(){for(const h of this.a.values())h.dispose()}startBuffering(h,P,A=5){const p=P(b=>{const k=typeof b=="string"?b:b.data;let R=this.a.get(h);if(R){R.data.push(k);return}const C=setTimeout(()=>this.flushBuffer(h),A);R={data:[k],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(h),p.dispose()}},this.a.set(h,R)});return p}stopBuffering(h){this.a.get(h)?.dispose()}flushBuffer(h){const P=this.a.get(h);P&&(this.a.delete(h),this.b(h,P.data.join("")))}}e.$wsb=D}),define(ke[264],Se([1,0,8,78,55,4,18,2,207,108,37]),function($e,e,D,N,h,P,A,p,b,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gw=e.$Fw=e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.IconFontDefinition=e.IconContribution=e.$yw=void 0,e.$yw={IconContribution:"base.contributions.icons"};var C;(function(r){function s(t,g){let o=t.defaults;for(;h.ThemeIcon.isThemeIcon(o);){const d=S.getIcon(o.id);if(!d)return;o=d.defaults}return o}r.getDefinition=s})(C||(e.IconContribution=C={}));var w;(function(r){function s(g){return{weight:g.weight,style:g.style,src:g.src.map(o=>({format:o.format,location:o.location.toString()}))}}r.toJSONObject=s;function t(g){const o=d=>(0,A.$Jf)(d)?d:void 0;if(g&&Array.isArray(g.src)&&g.src.every(d=>(0,A.$Jf)(d.format)&&(0,A.$Jf)(d.location)))return{weight:o(g.weight),style:o(g.style),src:g.src.map(d=>({format:d.format,location:p.URI.parse(d.location)}))}}r.fromJSONObject=t})(w||(e.IconFontDefinition=w={}));class E{constructor(){this.a=new P.$Wd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,b.localize)(0,null)},fontCharacter:{type:"string",description:(0,b.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${h.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(s,t,g,o){const d=this.b[s];if(d){if(g&&!d.description){d.description=g,this.d.properties[s].markdownDescription=`${g} $(${s})`;const v=this.e.enum.indexOf(s);v!==-1&&(this.e.enumDescriptions[v]=g),this.a.fire()}return d}const l={id:s,description:g,defaults:t,deprecationMessage:o};this.b[s]=l;const u={$ref:"#/definitions/icons"};return o&&(u.deprecationMessage=o),g&&(u.markdownDescription=`${g}: $(${s})`),this.d.properties[s]=u,this.e.enum.push(s),this.e.enumDescriptions.push(g||""),this.a.fire(),{id:s}}deregisterIcon(s){delete this.b[s],delete this.d.properties[s];const t=this.e.enum.indexOf(s);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(s=>this.b[s])}getIcon(s){return this.b[s]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(s,t){const g=this.f[s];return g||(this.f[s]=t,this.a.fire(),t)}deregisterIconFont(s){delete this.f[s]}getIconFont(s){return this.f[s]}toString(){const s=(d,l)=>d.id.localeCompare(l.id),t=d=>{for(;h.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},g=[];g.push("| preview     | identifier                        | default codicon ID                | description"),g.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.b).map(d=>this.b[d]);for(const d of o.filter(l=>!!l.description).sort(s))g.push(`|<i class="${t(d)}"></i>|${d.id}|${h.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);g.push("| preview     | identifier                        "),g.push("| ----------- | --------------------------------- |");for(const d of o.filter(l=>!h.ThemeIcon.isThemeIcon(l.defaults)).sort(s))g.push(`|<i class="${t(d)}"></i>|${d.id}|`);return g.join(`
`)}}const S=new E;R.$Kn.add(e.$yw.IconContribution,S);function c(r,s,t,g){return S.registerIcon(r,s,t,g)}e.$zw=c;function m(){return S}e.$Aw=m;function a(){const r=(0,N.$_j)();for(const s in r){const t="\\"+r[s].toString(16);S.registerIcon(s,{fontCharacter:t})}}a(),e.$Bw="vscode://schemas/icons";const i=R.$Kn.as(k.$Ln.JSONContribution);i.registerSchema(e.$Bw,S.getIconSchema());const n=new D.$hh(()=>i.notifySchemaChanged(e.$Bw),200);S.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$Cw=c("widget-close",N.$bk.close,(0,b.localize)(2,null)),e.$Dw=c("goto-previous-location",N.$bk.arrowUp,(0,b.localize)(3,null)),e.$Ew=c("goto-next-location",N.$bk.arrowDown,(0,b.localize)(4,null)),e.$Fw=h.ThemeIcon.modify(N.$bk.sync,"spin"),e.$Gw=h.ThemeIcon.modify(N.$bk.loading,"spin")}),define(ke[89],Se([1,0,4,51,5,13]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.ProvidedOnAutoForward=e.$Ev=e.TunnelPrivacyId=e.TunnelProtocol=e.$Dv=e.$Cv=void 0,e.$Cv=(0,h.$8h)("tunnelService"),e.$Dv=(0,h.$8h)("sharedTunnelsService");var A;(function(m){m.Http="http",m.Https="https"})(A||(e.TunnelProtocol=A={}));var p;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(p||(e.TunnelPrivacyId=p={}));function b(m){return!!m.forwardPort}e.$Ev=b;var k;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(k||(e.ProvidedOnAutoForward=k={}));function R(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(a)return{address:a[1],port:+a[2]}}e.$Fv=R,e.$Gv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(m){return e.$Gv.indexOf(m)>=0}e.$Hv=C,e.$Iv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(m){return e.$Iv.indexOf(m)>=0}e.$Jv=w;function E(m,a,i,n){if(i===1)return!1;if(i===2&&w(a)){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(r?.length===4&&parseInt(r[1])>=18)return!1}return m<1024}e.$Kv=E;class S{constructor(a,i,n){this.remoteAddress=a,this.localAddress=i,this.b=n,this.a=new D.$Wd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lv=S;let c=class{constructor(a,i){this.k=a,this.l=i,this.a=new D.$Wd,this.onTunnelOpened=this.a.event,this.b=new D.$Wd,this.onTunnelClosed=this.b.event,this.c=new D.$Wd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const a=this.l.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(a){return this.f=a,a?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this.g=a.elevation,this.i=a.privacyOptions,this.h=a.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const a=[],i=Array.from(this.e.values());for(const n of i){const r=Array.from(n.values());for(const s of r){const t=await s.value;t&&typeof t!="string"&&a.push(t)}}return a}async dispose(){for(const a of this.e.values()){for(const{value:i}of a.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);a.clear()}this.e.clear()}setEnvironmentTunnel(a,i,n,r,s){this.q(a,i,Promise.resolve({tunnelRemoteHost:a,tunnelRemotePort:i,localAddress:n,privacy:r,protocol:s,dispose:()=>Promise.resolve()}))}async getExistingTunnel(a,i){(w(a)||C(a))&&(a=e.$Gv[0]);const n=this.s(a,i);if(n)return++n.refcount,n.value}openTunnel(a,i,n,r,s,t=!1,g,o){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${s}.`);const d=this.f??a;if(!d)return;if(i||(i="localhost"),r||(r=this.m),this.f&&this.j.has(n)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.t(d,i,n,r,s,t,g,o);return l?l.then(u=>{if(u){if(typeof u=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(i,n),u}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(i,n);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.o(u);return(u.tunnelRemoteHost!==i||u.tunnelRemotePort!==n)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),g&&u.privacy!==g&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}o(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const i=this.e.get(a.tunnelRemoteHost);if(i){const n=i.get(a.tunnelRemotePort);n&&(n.refcount--,await this.p(a.tunnelRemoteHost,a.tunnelRemotePort,n))}}}}async p(a,i,n){if(n.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${i}.`);const r=n.value.then(async s=>{s&&typeof s!="string"&&(await s.dispose(!0),this.b.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this.e.has(a)&&this.e.get(a).delete(i),r}}async closeTunnel(a,i){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${i} `);const n=this.e.get(a);if(n&&n.has(i)){const r=n.get(i);r.refcount=0,await this.p(a,i,r)}}q(a,i,n){this.e.has(a)||this.e.set(a,new Map),this.e.get(a).set(i,{refcount:1,value:n})}async r(a,i){const n=this.e.get(a);if(n){const r=n.get(i),s=r?await r.value:void 0;(!s||typeof s=="string")&&n.delete(i),n.size===0&&this.e.delete(a)}}s(a,i){const n=[a];C(a)?(n.push(...e.$Gv),n.push(...e.$Iv)):w(a)&&n.push(...e.$Iv);const r=n.map(s=>this.e.get(s));for(const s of r){const t=s?.get(i);if(t)return t}}canTunnel(a){return!!R(a)}u(a,i,n,r,s,t,g){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${r}.`);const o=n;this.j.add(o);const d=r===void 0?n:r,l={elevationRequired:s?this.isPortPrivileged(d):!1},u={remoteAddress:{host:i,port:n},localAddressPort:r,privacy:t,public:t?t!==p.Private:void 0,protocol:g},v=a.forwardPort(u,l);return v?(this.q(i,n,v),v.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(o)})):this.j.delete(o),v}};e.$Mv=c,e.$Mv=c=Ge([Ve(0,P.$pj),Ve(1,N.$Bi)],c)}),define(ke[265],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=void 0,e.$3k=(0,D.$8h)("IUriIdentityService")}),define(ke[266],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Nv=void 0,e.$Nv=(0,D.$8h)("editSessionIdentityService");var N;(function(h){h[h.Complete=100]="Complete",h[h.Partial=50]="Partial",h[h.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(ke[267],Se([1,0,16]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=void 0;function N(b){return b.scheme!==D.Schemas.file&&b.scheme!==D.Schemas.vscodeRemote}e.$SK=N;function h(b){if(b.folders.length)return b.folders.every(k=>N(k.uri))?b.folders[0].uri:void 0;if(b.configuration&&N(b.configuration))return b.configuration}e.$TK=h;function P(b){return h(b)?.scheme}e.$UK=P;function A(b){return h(b)?.authority}e.$VK=A;function p(b){return h(b)!==void 0}e.$WK=p}),define(ke[40],Se([1,0,209,17,77,23,2,5,16]),function($e,e,D,N,h,P,A,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.WorkbenchState=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0,e.$ei=(0,p.$8h)("contextService");function k(d){const l=d;return typeof l?.id=="string"&&A.URI.isUri(l.uri)}e.$fi=k;function R(d){return typeof d?.id=="string"&&!k(d)&&!w(d)}e.$gi=R,e.$hi={id:"ext-dev"},e.$ii={id:"empty-window"};function C(d,l){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,N.$nc)(d)}:l?e.$hi:e.$ii;const u=d;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}e.$ji=C;function w(d){const l=d;return typeof l?.id=="string"&&A.URI.isUri(l.configPath)}e.$ki=w;function E(d){const l=d;if(l?.uri)return{id:l.id,uri:A.URI.revive(l.uri)};const u=d;if(u?.configPath)return{id:u.id,configPath:A.URI.revive(u.configPath)};if(d?.id)return{id:d.id}}e.$li=E;var S;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function c(d){const l=d;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.$mi=c;function m(d){const l=d;return!!(l&&typeof l=="object"&&A.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.$ni=m;class a{constructor(l,u,v,I,$){this.h=l,this.j=v,this.k=I,this.l=$,this.c=h.$bi.forUris(this.l,()=>!0),this.folders=u}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=h.$bi.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$oi=a;class i{constructor(l,u){this.raw=u,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,P.$Ig)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$pi=i;function n(d){return new i({uri:d,index:0,name:(0,P.$Eg)(d)},{uri:d.toString()})}e.$qi=n,e.$ri="code-workspace",e.$si=`.${e.$ri}`,e.$ti=[{name:(0,D.localize)(0,null),extensions:[e.$ri]}],e.$ui="workspace.json";function r(d,l){return P.$zg.isEqualOrParent(d,l.untitledWorkspacesHome)}e.$vi=r;function s(d){let l;return A.URI.isUri(d)?l=d:l=d.configuration,l?.scheme===b.Schemas.tmp}e.$wi=s,e.$xi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(d){return d.id===e.$xi}e.$yi=t;function g(d,l){return!r(d,l)&&!s(d)}e.$zi=g;function o(d){return(typeof d=="string"?(0,N.$oc)(d):(0,P.$Gg)(d))===e.$si}e.$Ai=o}),define(ke[268],Se([1,0,54,4,3,23,2,208,133,32,5,13,40,28,265,8,30,12,18]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.ProfileResourceType=void 0;var n;(function(d){d.Settings="settings",d.Keybindings="keybindings",d.Snippets="snippets",d.Tasks="tasks",d.Extensions="extensions",d.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function r(d){const l=d;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&A.URI.isUri(l.location)&&A.URI.isUri(l.globalStorageHome)&&A.URI.isUri(l.settingsResource)&&A.URI.isUri(l.keybindingsResource)&&A.URI.isUri(l.tasksResource)&&A.URI.isUri(l.snippetsHome)&&A.URI.isUri(l.extensionsResource))}e.$4k=r,e.$5k=(0,R.$8h)("IUserDataProfilesService");function s(d,l){return{id:d.id,isDefault:d.isDefault,name:d.name,shortName:d.shortName,icon:d.icon,location:A.URI.revive(d.location).with({scheme:l}),globalStorageHome:A.URI.revive(d.globalStorageHome).with({scheme:l}),settingsResource:A.URI.revive(d.settingsResource).with({scheme:l}),keybindingsResource:A.URI.revive(d.keybindingsResource).with({scheme:l}),tasksResource:A.URI.revive(d.tasksResource).with({scheme:l}),snippetsHome:A.URI.revive(d.snippetsHome).with({scheme:l}),extensionsResource:A.URI.revive(d.extensionsResource).with({scheme:l}),cacheHome:A.URI.revive(d.cacheHome).with({scheme:l}),useDefaultFlags:d.useDefaultFlags,isTransient:d.isTransient}}e.$6k=s;function t(d,l,u,v,I,$){return{id:d,name:l,location:u,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:$&&I?.useDefaultFlags?.globalState?$.globalStorageHome:(0,P.$Ig)(u,"globalStorage"),settingsResource:$&&I?.useDefaultFlags?.settings?$.settingsResource:(0,P.$Ig)(u,"settings.json"),keybindingsResource:$&&I?.useDefaultFlags?.keybindings?$.keybindingsResource:(0,P.$Ig)(u,"keybindings.json"),tasksResource:$&&I?.useDefaultFlags?.tasks?$.tasksResource:(0,P.$Ig)(u,"tasks.json"),snippetsHome:$&&I?.useDefaultFlags?.snippets?$.snippetsHome:(0,P.$Ig)(u,"snippets"),extensionsResource:$&&I?.useDefaultFlags?.extensions?$.extensionsResource:(0,P.$Ig)(u,"extensions.json"),cacheHome:(0,P.$Ig)(v,d),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.$7k=t;let g=class extends h.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(l,u,v,I){super(),this.t=l,this.u=u,this.w=v,this.y=I,this.f=!0,this.h=this.B(new N.$Wd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$Wd),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$Wd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$Wd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new E.$Ac,emptyWindows:new Map},this.profilesHome=(0,P.$Ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,P.$Ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(l){this.f!==l&&(this.z=void 0,this.f=l)}isEnabled(){return this.f}get C(){if(!this.z){const l=this.D(),u=[l];if(this.f)try{for(const $ of this.O()){if(!$.name||!(0,i.$Jf)($.name)||!$.location){this.y.warn("Skipping the invalid stored profile",$.location||$.name);continue}u.push(t((0,P.$Fg)($.location),$.name,$.location,this.g,{shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags},l))}}catch($){this.y.error($)}const v=new E.$Ac,I=new Map;if(u.length)try{const $=this.Q();if($.workspaces)for(const[f,y]of Object.entries($.workspaces)){const L=A.URI.parse(f),T=u.find(U=>U.id===y);T&&v.set(L,T)}if($.emptyWindows)for(const[f,y]of Object.entries($.emptyWindows)){const L=u.find(T=>T.id===y);L&&I.set(f,L)}}catch($){this.y.error($)}this.z={profiles:u,workspaces:v,emptyWindows:I}}return this.z}D(){const l=t("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...l,extensionsResource:this.S()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const u="Temp",v=new RegExp(`${(0,a.$Pe)(u)}\\s(\\d+)`);let I=0;for(const f of this.profiles){const y=v.exec(f.name),L=y?parseInt(y[1]):0;I=L>I?L:I}const $=`${u} ${I+1}`;return this.createProfile((0,D.$Vi)((0,m.$rg)()).toString(16),$,{transient:!0},l)}async createNamedProfile(l,u,v){return this.createProfile((0,D.$Vi)((0,m.$rg)()).toString(16),l,u,v)}async createProfile(l,u,v,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=await this.F(l,u,v);return I&&await this.setProfileForWorkspace(I,$),$}async F(l,u,v){if(!(0,i.$Jf)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(u);return I||(I=(async()=>{try{const $=this.profiles.find(L=>L.name===u||L.id===l);if($)return $;const f=t(l,u,(0,P.$Ig)(this.profilesHome,l),this.g,v,this.defaultProfile);await this.u.createFolder(f.location);const y=[];return this.j.fire({profile:f,join(L){y.push(L)}}),await c.Promises.settled(y),this.I([f],[],[]),f}finally{this.r.delete(u)}})(),this.r.set(u,I)),I}async updateProfile(l,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let v=this.profiles.find(I=>I.id===l.id);if(!v)throw new Error(`Profile '${l.name}' does not exist`);return v=t(v.id,u.name??v.name,v.location,this.g,{shortName:u.shortName??v.shortName,icon:u.icon===null?void 0:u.icon??v.icon,transient:u.transient??v.isTransient,useDefaultFlags:u.useDefaultFlags??v.useDefaultFlags},this.defaultProfile),this.I([],[],[v]),v}async removeProfile(l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(I=>I.id===l.id);if(!u)throw new Error(`Profile '${l.name}' does not exist`);const v=[];this.m.fire({profile:u,join(I){v.push(I)}});try{await Promise.allSettled(v)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(I){(0,k.$Jk)(I)!==1&&this.y.error(I)}}async setProfileForWorkspace(l,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=this.profiles.find(I=>I.id===u.id);if(!v)throw new Error(`Profile '${u.name}' does not exist`);this.L(l,v)}unsetWorkspace(l,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(l,void 0,u)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const l=await this.u.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(u=>u.isDirectory&&this.profiles.every(v=>!this.w.extUri.isEqual(v.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const l=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(l.map(u=>this.removeProfile(u)))}getProfileForWorkspace(l){const u=this.G(l);return A.URI.isUri(u)?this.s.workspaces.get(u)??this.C.workspaces.get(u):this.s.emptyWindows.get(u)??this.C.emptyWindows.get(u)}G(l){return(0,w.$fi)(l)?l.uri:(0,w.$ki)(l)?l.configPath:l.id}H(l){return!!([...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,l.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,l.location))||[...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,l.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,l.location)))}I(l,u,v){const I=[...this.profiles,...l],$=[];this.s.profiles=[];for(let f of I)f.isDefault||u.some(y=>f.id===y.id)||(f=v.find(y=>f.id===y.id)??f,f.isTransient?this.s.profiles.push(f):$.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.P($),this.z=void 0,this.J(l,u,v)}J(l,u,v){this.h.fire({added:l,removed:u,updated:v,all:this.profiles})}L(l,u,v){v=u?.isTransient?!0:v,v||this.L(l,void 0,!0);const I=this.G(l),$=v?this.s:this.C;A.URI.isUri(I)?($.workspaces.delete(I),u&&$.workspaces.set(I,u)):($.emptyWindows.delete(I),u&&$.emptyWindows.set(I,u)),v||this.M()}M(){const l={};for(const[v,I]of this.C.workspaces.entries())l[v.toString()]=I.id;const u={};for(const[v,I]of this.C.emptyWindows.entries())u[v.toString()]=I.id;this.R({workspaces:l,emptyWindows:u}),this.z=void 0}N(l){const u={},v=this.D();if(l.workspaces)for(const[$,f]of Object.entries(l.workspaces)){const y=A.URI.parse(f);u[$]=this.w.extUri.isEqual(y,v.location)?v.id:this.w.extUri.basename(y)}const I={};if(l.emptyWindows)for(const[$,f]of Object.entries(l.emptyWindows)){const y=A.URI.parse(f);I[$]=this.w.extUri.isEqual(y,v.location)?v.id:this.w.extUri.basename(y)}return{workspaces:u,emptyWindows:I}}O(){return[]}P(l){throw new Error("not implemented")}Q(){return{}}R(l){throw new Error("not implemented")}S(){}};e.$8k=g,e.$8k=g=Ge([Ve(0,b.$ci),Ve(1,k.$sk),Ve(2,S.$3k),Ve(3,C.$pj)],g);class o extends g{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(l){this.a=l}Q(){return this.X}R(l){this.X=l}}e.$9k=o}),define(ke[269],Se([1,0,8,4,3,58,18,188,5,268]),function($e,e,D,N,h,P,A,p,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$wp=e.$vp=e.$up=void 0,e.$up="__$__isNewStorageMarker",e.$vp="__$__targetStorageMarker",e.$wp=(0,b.$8h)("storageService");var R;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var w;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function E(i){const n=i.get(e.$vp);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$xp=E;class S extends h.$Tc{static{this.a=60*1e3}constructor(n={flushInterval:S.a}){super(),this.m=n,this.b=this.B(new N.$Zd),this.c=this.B(new N.$Zd),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$Wd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$hh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new h.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,r,s){return N.Event.filter(this.b.event,t=>t.scope===n&&(r===void 0||t.key===r),s)}n(){this.j.value=(0,D.$lh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,h.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.O()}finally{(0,P.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,r){const{key:s,external:t}=r;if(s===e.$vp){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:s,target:this.J(n)[s],external:t})}w(n){this.f.fire({reason:n})}get(n,r,s){return this.P(r)?.get(n,s)}getBoolean(n,r,s){return this.P(r)?.getBoolean(n,s)}getNumber(n,r,s){return this.P(r)?.getNumber(n,s)}getObject(n,r,s){return this.P(r)?.getObject(n,s)}storeAll(n,r){this.y(()=>{for(const s of n)this.store(s.key,s.value,s.scope,s.target,r)})}store(n,r,s,t,g=!1){if((0,A.$Sf)(r)){this.remove(n,s,g);return}this.y(()=>{this.z(n,s,t),this.P(s)?.set(n,r,g)})}remove(n,r,s=!1){this.y(()=>{this.z(n,r,void 0),this.P(r)?.delete(n,s)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,r){const s=[],t=this.J(n);for(const g of Object.keys(t))t[g]===r&&s.push(g);return s}z(n,r,s,t=!1){const g=this.J(r);typeof s=="number"?g[n]!==s&&(g[n]=s,this.P(r)?.set(e.$vp,JSON.stringify(g),t)):typeof g[n]=="number"&&(delete g[n],this.P(r)?.set(e.$vp,JSON.stringify(g),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const r=this.P(n);return r?E(r):Object.create(null)}isNew(n){return this.getBoolean(e.$up,n)===!0}async flush(n=R.NONE){this.f.fire({reason:n});const r=this.P(-1),s=this.P(0),t=this.P(1);switch(n){case R.NONE:await D.Promises.settled([r?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await D.Promises.settled([r?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,s=this.P(1)?.items??new Map;return a(n,r,s,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,r){return this.w(R.NONE),(0,k.$4k)(n)?this.R(n,r):this.S(n,r)}M(n,r){return!(n.id===r.id||c(r)&&c(n))}N(n,r,s){this.y(()=>{const t=new Set;for(const[g,o]of n)t.add(g),r.get(g)!==o&&this.u(s,{key:g,external:!0});for(const[g]of r.items)t.has(g)||this.u(s,{key:g,external:!0})})}}e.$yp=S;function c(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$zp=c;class m extends S{constructor(){super(),this.U=this.B(new p.$sp(new p.$tp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$sp(new p.$tp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$sp(new p.$tp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$Ap=m;async function a(i,n,r,s,t,g){const o=L=>{try{return JSON.parse(L)}catch{return L}},d=new Map,l=new Map;i.forEach((L,T)=>{d.set(T,L),l.set(T,o(L))});const u=new Map,v=new Map;n.forEach((L,T)=>{u.set(T,L),v.set(T,o(L))});const I=new Map,$=new Map;r.forEach((L,T)=>{I.set(T,L),$.set(T,o(L))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const f=[];if(d.forEach((L,T)=>{f.push({key:T,value:L})}),console.table(f),console.groupEnd(),console.log(l),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const L=[];u.forEach((T,U)=>{L.push({key:U,value:T})}),console.table(L),console.groupEnd(),console.log(v)}console.group(`Storage: Workspace (path: ${g})`);const y=[];I.forEach((L,T)=>{y.push({key:T,value:L})}),console.table(y),console.groupEnd(),console.log($)}e.$Bp=a}),define(ke[110],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=void 0;class D{static{this.a=!1}constructor(h){this.d=h,this.b=new Map,this.c=1}add(h){const P=this.c++;return this.b.set(P,h),this.e(),P}get(h,P){return this.b.has(h)?this.b.get(h)[P]:void 0}delete(h){this.b.delete(h),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Ufc=D}),define(ke[59],Se([1,0,16,23,5]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=e.$Xfc=void 0;class P{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new N.$xg(p=>{const b=this.b.get(p.scheme);return!(b===void 0||b&1024)})}$acceptProviderInfos(p,b){b===null?this.b.delete(p.scheme):this.b.set(p.scheme,b)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Xfc=P,e.$Yfc=(0,h.$8h)("IExtHostFileSystemInfo")}),define(ke[27],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=void 0,e.$EN=(0,D.$8h)("IExtHostInitDataService")}),define(ke[270],Se([1,0,214,13,250,27]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=void 0;let A=class extends h.$LO{constructor(b,k,R){const C=R.remote.isRemote?"remoteexthost":b?"workerexthost":"exthost",w=R.remote.isRemote?(0,D.localize)(0,null):b?(0,D.localize)(1,null):(0,D.localize)(2,null);super(k.createLogger(C,{name:w}))}};e.$5hc=A,e.$5hc=A=Ge([Ve(1,N.$qj),Ve(2,P.$EN)],A)}),define(ke[271],Se([1,0,8]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=e.$Ggc=void 0;class N{constructor(A,p,b){this.h=new Map,this.a=A,this.b=p,this.c=b,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new D.$hh(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of k.values())R.complete()}catch(R){for(const C of k.values())C.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,p){let b=this.f[A];return typeof b>"u"&&(b=p),b}update(A,p){this.f[A]=p;const b=this.h.get(A);if(b!==void 0)return b.p;const k=new D.$sh;return this.h.set(A,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$Ggc=N;class h extends N{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,p){super(A.identifier.value,!0,p),this.j=A}}e.$Hgc=h}),define(ke[272],Se([1,0,4,2]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=void 0;class h{constructor(A){this.c=A,this.a=new D.$Wd,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Wd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,p,b,k){const C=this.c.getNotebookDocument(N.URI.revive(A)).acceptModelChanged(p.value,b,k);this.b.fire(C)}$acceptDirtyStateChanged(A,p){this.c.getNotebookDocument(N.URI.revive(A)).acceptDirty(p)}$acceptModelSaved(A){const p=this.c.getNotebookDocument(N.URI.revive(A));this.a.fire(p.apiNotebook)}}e.$uhc=h}),define(ke[20],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pN=e.$oN=void 0,e.$oN=(0,D.$8h)("IExtHostRpcService");class N{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.$pN=N}),define(ke[273],Se([1,0,25,4]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=void 0;class h{#e;constructor(A,p){this.b=new N.$Wd,this.onDidChange=this.b.event,this.a=D.$nm.toKey(A.identifier),this.#e=p,this.#e.onDidChangePassword(b=>{b.extensionId===this.a&&this.b.fire({key:b.key})})}get(A){return this.#e.get(this.a,A)}store(A,p){return this.#e.store(this.a,A,p)}delete(A){return this.#e.delete(this.a,A)}}e.$Ogc=h}),define(ke[66],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=e.$egc=void 0,e.$egc=(0,D.$8h)("IURITransformerService");class N{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$fgc=N}),define(ke[274],Se([1,0,21]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Elb=e.$Dlb=void 0;class N{constructor(){this.buffers=[]}add(b){let k=this.buffers.indexOf(b);return k<0&&(k=this.buffers.length,this.buffers.push(b)),k}}function h(p,b){if(b.serializeBuffersForPostMessage){const k=new N,C=JSON.stringify(p,(E,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(S)};if(ArrayBuffer.isView(S)){const c=P(S);if(c)return{$$vscode_array_buffer_reference$$:!0,index:k.add(S.buffer),view:{type:c,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),w=k.buffers.map(E=>{const S=new Uint8Array(E);return D.$ke.wrap(S)});return{message:C,buffers:w}}else return{message:JSON.stringify(p),buffers:[]}}e.$Dlb=h;function P(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(p,b){const k=b.map(w=>{const E=new ArrayBuffer(w.byteLength);return new Uint8Array(E).set(w.buffer),E}),R=b.length?(w,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const S=E,{index:c}=S,m=k[c];if(S.view)switch(S.view.type){case 1:return new Int8Array(m,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return E}:void 0;return{message:JSON.parse(p,R),arrayBuffers:k}}e.$Elb=A}),define(ke[275],Se([1,0,276,389,390,62,2,13,391]),function($e,e,D,N,h,P,A,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=void 0;const k=!1;function R(n,r,s,t,g,o){const d=o.environment.useHostProxy,l=typeof d=="boolean"?d:!o.remote.isRemote,u={resolveProxy:$=>n.resolveProxy($),lookupProxyAuthorization:m.bind(void 0,t,g,r,{},o.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>w(r),addCertificatesV2:()=>E(r),log:t,getLogLevel:()=>{const $=t.getLevel();switch($){case p.LogLevel.Trace:return b.LogLevel.Trace;case p.LogLevel.Debug:return b.LogLevel.Debug;case p.LogLevel.Info:return b.LogLevel.Info;case p.LogLevel.Warning:return b.LogLevel.Warning;case p.LogLevel.Error:return b.LogLevel.Error;case p.LogLevel.Off:return b.LogLevel.Off;default:return f($)}function f(y){return t.error("Unknown log level",y),b.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:l,loadAdditionalCertificates:async()=>{const $=[];if(o.remote.isRemote&&$.push((0,b.loadSystemCertificates)({log:t})),l){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const f=n.loadCertificates();f.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),$.push(f)}return(await Promise.all($)).flat()},env:process.env},v=(0,b.createProxyResolver)(u),I=C(u,v);return c(s,I)}e.$Aic=R;function C(n,r){return{http:Object.assign(D,(0,b.createHttpPatch)(n,D,r)),https:Object.assign(N,(0,b.createHttpPatch)(n,N,r)),net:Object.assign(P,(0,b.createNetPatch)(n,P)),tls:Object.assign(h,(0,b.createTlsPatch)(n,h))}}function w(n){const r=n.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",k)&&!!r.get("systemCertificates")}function E(n){const r=n.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",k)&&!!r.get("systemCertificates")}const S=new Map;function c(n,r){return n.getExtensionPathIndex().then(s=>{const t=globalThis._VSCODE_NODE_MODULES.module,g=t._load;t._load=function(d,l,u){if(d==="net")return r.net;if(d==="tls")return r.tls;if(d!=="http"&&d!=="https")return g.apply(this,arguments);const v=s.findSubstr(A.URI.file(l.filename));let I=S.get(v);if(I||S.set(v,I={}),!I[d]){const $=r[d];I[d]={...$}}return I[d]}})}async function m(n,r,s,t,g,o,d,l){const u=t[o];d&&(t[o]=d),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${o}`,`proxyAuthenticate:${d}`,`proxyAuthenticateCache:${u}`);const v=d||u,I=Array.isArray(v)?v:typeof v=="string"?[v]:[];if(i(r,I,g),I.some($=>/^(Negotiate|Kerberos)( |$)/i.test($))&&!l.kerberosRequested)try{l.kerberosRequested=!0;const $=await new Promise((U,j)=>{$e(["kerberos"],U,j)}),f=new URL(o),y=s.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${f.hostname}`:`HTTP@${f.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${o}`,`spn:${y}`),"Negotiate "+await(await $.initializeClient(y)).step("")}catch($){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",$)}}let a=!1;function i(n,r,s){a||!r.length||(a=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:s?"remote":"local"}))}}),define(ke[277],Se([1,0,130]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=void 0;function N(P){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:P,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function h(P){return new D.$7m(N(P))}e.$5r=h}),define(ke[139],Se([1,0,224,18,2,3,5,37,32,16,44,180,39]),function($e,e,D,N,h,P,A,p,b,k,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9E=e.$8E=e.$7E=e.EditorsOrder=e.$6E=e.CloseDirection=e.$5E=e.$4E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.EditorInputCapabilities=e.$UE=e.SaveReason=e.Verbosity=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=void 0,e.$HE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$IE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$JE="workbench.editor.sidebysideEditor",e.$KE="workbench.editors.textDiffEditor",e.$LE="workbench.editors.binaryResourceDiffEditor";var E;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var S;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function c(ne){const K=ne;return!!K&&typeof K.getSelection=="function"&&!!K.onDidChangeSelection}e.$ME=c;function m(ne,K,W){for(const re of W.visibleEditorPanes)if(re.group.id===K&&ne.matches(re.input))return re.getViewState()}e.$NE=m;function a(ne){if(v(ne))return!1;const K=ne;return h.URI.isUri(K?.resource)}e.$OE=a;function i(ne){if(v(ne))return!1;const K=ne;return K?.original!==void 0&&K.modified!==void 0}e.$PE=i;function n(ne){if(v(ne))return!1;const K=ne;return!K||K.resources&&!Array.isArray(K.resources)?!1:!!K.resources||!!K.multiDiffSource}e.$QE=n;function r(ne){if(v(ne)||i(ne))return!1;const K=ne;return K?.primary!==void 0&&K.secondary!==void 0}e.$RE=r;function s(ne){if(v(ne))return!1;const K=ne;return K?K.resource===void 0||K.resource.scheme===k.Schemas.untitled||K.forceUntitled===!0:!1}e.$SE=s;function t(ne){if(v(ne))return!1;const K=ne;return h.URI.isUri(K?.base?.resource)&&h.URI.isUri(K?.input1?.resource)&&h.URI.isUri(K?.input2?.resource)&&h.URI.isUri(K?.result?.resource)}e.$TE=t;var g;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(g||(e.Verbosity=g={}));var o;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o||(e.SaveReason=o={}));class d{constructor(){this.a=new Map}registerSource(K,W){let re=this.a.get(K);return re||(re={source:K,label:W},this.a.set(K,re)),re.source}getSourceLabel(K){return this.a.get(K)?.label??K}}e.$UE=new d;var l;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad",ne[ne.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(l||(e.EditorInputCapabilities=l={}));class u extends P.$Tc{}e.$VE=u;function v(ne){return ne instanceof u}e.$WE=v;function I(ne){const K=ne;return h.URI.isUri(K?.preferredResource)}function $(ne){const K=ne;return v(K?.primary)&&v(K?.secondary)}e.$XE=$;function f(ne){const K=ne;return v(K?.modified)&&v(K?.original)}e.$YE=f;function y(ne,K,W,re,ye){return ge(re,[(0,C.$Ri)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const he={...W,limits:{size:Number.MAX_VALUE}};ne.openEditor(K,he)}}),(0,C.$Ri)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}e.$ZE=y;function L(ne){return v(ne?.editor)}e.$1E=L;function T(ne){const K=ne;return L(ne)&&K?.group!==void 0}e.$2E=T;function U(ne){const K=ne;return typeof K?.groupId=="number"&&v(K.editor)}e.$3E=U;var j;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(j||(e.EditorCloseContext=j={}));var F;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_STICKY=11]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=12]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var M;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(M||(e.SideBySideEditor=M={}));class O{getOriginalUri(K,W){if(!K)return;if(t(K))return e.$5E.getOriginalUri(K.result,W);if(W?.supportSideBySide){const{primary:ye,secondary:he}=this.a(K);if(ye&&he){if(W?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(he,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===M.ANY)return this.getOriginalUri(ye,{filterByScheme:W.filterByScheme})??this.getOriginalUri(he,{filterByScheme:W.filterByScheme});K=W.supportSideBySide===M.PRIMARY?ye:he}}if(i(K)||n(K)||r(K)||t(K))return;const re=I(K)?K.preferredResource:K.resource;return!re||!W||!W.filterByScheme?re:this.b(re,W.filterByScheme)}a(K){return $(K)||r(K)?{primary:K.primary,secondary:K.secondary}:f(K)||i(K)?{primary:K.modified,secondary:K.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(K,W){if(!K)return;if(t(K))return e.$5E.getCanonicalUri(K.result,W);if(W?.supportSideBySide){const{primary:ye,secondary:he}=this.a(K);if(ye&&he){if(W?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(he,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===M.ANY)return this.getCanonicalUri(ye,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(he,{filterByScheme:W.filterByScheme});K=W.supportSideBySide===M.PRIMARY?ye:he}}if(i(K)||n(K)||r(K)||t(K))return;const re=K.resource;return!re||!W||!W.filterByScheme?re:this.b(re,W.filterByScheme)}b(K,W){if(Array.isArray(W)){if(W.some(re=>K.scheme===re))return K}else if(W===K.scheme)return K}}var z;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(z||(e.EditorCloseMethod=z={}));function J(ne,K,W,re){if(!ne.isSticky(K))return!1;switch(re.preventPinnedEditorClose){case"keyboardAndMouse":return W===z.MOUSE||W===z.KEYBOARD;case"mouse":return W===z.MOUSE;case"keyboard":return W===z.KEYBOARD}return!1}e.$4E=J,e.$5E=new O;var te;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(te||(e.CloseDirection=te={}));class x{constructor(){this.c=new Map,this.d=new Map}start(K){const W=this.a=K.get(A.$7h);for(const[re,ye]of this.c)this.e(re,ye,W);this.c.clear()}e(K,W,re){const ye=re.createInstance(W);this.d.set(K,ye)}registerFileEditorFactory(K){if(this.b)throw new Error("Can only register one file editor factory.");this.b=K}getFileEditorFactory(){return(0,N.$Uf)(this.b)}registerEditorSerializer(K,W){if(this.c.has(K)||this.d.has(K))throw new Error(`A editor serializer with type ID '${K}' was already registered.`);return this.a?this.e(K,W,this.a):this.c.set(K,W),(0,P.$Rc)(()=>{this.c.delete(K),this.d.delete(K)})}getEditorSerializer(K){return this.d.get(typeof K=="string"?K:K.typeId)}}p.$Kn.add(e.$HE.EditorFactory,new x);async function X(ne,K,W){return!ne||!ne.length?[]:await Promise.all(ne.map(async re=>{const ye=h.URI.revive(re.fileUri);if(!ye){W.info("Cannot resolve the path because it is not valid.",re);return}if(!await K.canHandleResource(ye)){W.info("Cannot resolve the path because it cannot be handled",re);return}let fe=re.exists,ue=re.type;if(typeof fe!="boolean"||typeof ue!="number")try{ue=(await K.stat(ye)).isDirectory?b.FileType.Directory:b.FileType.Unknown,fe=!0}catch(V){W.error(V),fe=!1}if(!fe&&re.openOnlyIfExists){W.info("Cannot resolve the path because it does not exist",re);return}if(ue===b.FileType.Directory){W.info("Cannot resolve the path because it is a directory",re);return}const me={...re.options,pinned:!0};return fe?{resource:ye,options:me}:{resource:ye,options:me,forceUntitled:!0}}))}e.$6E=X;var Z;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(Z||(e.EditorsOrder=Z={}));function ae(ne){const K=ne;if(!K)return!1;const W=K;if(W.modified)return ae(W.modified);const re=K;return!!(re.contributionsState&&re.viewState&&Array.isArray(re.cursorState))}e.$7E=ae;function _(ne){return(0,R.$Ti)(ne)}e.$8E=_;function ge(ne,K,W){const re=(0,R.$Ui)(ne,K);return re.forceMessage=W?.forceMessage,re.forceSeverity=W?.forceSeverity,re.allowDialog=W?.allowDialog,re}e.$9E=ge}),define(ke[278],Se([1,0,4,225,5,3,28,37,19,24,78,264]),function($e,e,D,N,h,P,A,p,b,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.$dF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$cF=e.ViewContentGroups=e.$bF=e.$aF=e.ViewContainerLocation=e.Extensions=e.$_E=e.$$E=e.$0E=void 0,e.$0E="views",e.$$E=(0,N.localize)(0,null),e.$_E=(0,C.$zw)("default-view-icon",R.$bk.window,(0,N.localize)(1,null));var w;(function(g){g.ViewContainersRegistry="workbench.registry.view.containers",g.ViewsRegistry="workbench.registry.view"})(w||(e.Extensions=w={}));var E;(function(g){g[g.Sidebar=0]="Sidebar",g[g.Panel=1]="Panel",g[g.AuxiliaryBar=2]="AuxiliaryBar"})(E||(e.ViewContainerLocation=E={})),e.$aF=[0,1,2];function S(g){switch(g){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$bF=S;class c extends P.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$Wd),this.onDidRegister=this.c.event,this.f=this.B(new D.$Wd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,b.$Rb)([...this.g.values()])}registerViewContainer(o,d,l){const u=this.get(o.id);if(u)return u;const v=o;return v.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:v.openCommandActionDescriptor??{id:v.id},(0,A.$xc)(this.g,d,[]).push(v),l?.isDefault&&this.h.push(v),this.c.fire({viewContainer:v,viewContainerLocation:d}),v}deregisterViewContainer(o){for(const d of this.g.keys()){const l=this.g.get(d),u=l?.indexOf(o);if(u!==-1){l?.splice(u,1),l.length===0&&this.g.delete(d),this.f.fire({viewContainer:o,viewContainerLocation:d});return}}}get(o){return this.all.filter(d=>d.id===o)[0]}getViewContainers(o){return[...this.g.get(o)||[]]}getViewContainerLocation(o){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(l=>l?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.h.find(d=>this.getViewContainerLocation(d)===o)}}p.$Kn.add(w.ViewContainersRegistry,new c);var m;(function(g){g.Open="2_open",g.Debug="4_debug",g.SCM="5_scm",g.More="9_more"})(m||(e.ViewContentGroups=m={}));function a(g,o){const d=g.group??m.More,l=o.group??m.More;return d!==l?d.localeCompare(l):(g.order??5)-(o.order??5)}class i extends P.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$Wd),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Wd),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Wd),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Wd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(o,d){this.registerViews2([{views:o,viewContainer:d}])}registerViews2(o){o.forEach(({views:d,viewContainer:l})=>this.r(d,l)),this.c.fire(o)}deregisterViews(o,d){const l=this.s(o,d);l.length&&this.f.fire({views:l,viewContainer:d})}moveViews(o,d){for(const l of this.m.keys())if(l!==d){const u=this.s(o,l);u.length&&(this.r(u,d),this.g.fire({views:u,from:l,to:d}))}}getViews(o){return this.m.get(o)||[]}getView(o){for(const d of this.j){const l=(this.m.get(d)||[]).filter(u=>u.id===o)[0];if(l)return l}return null}getViewContainer(o){for(const d of this.j)if((this.m.get(d)||[]).filter(u=>u.id===o)[0])return d;return null}registerViewWelcomeContent(o,d){return this.n.add(o,d),this.h.fire(o),(0,P.$Rc)(()=>{this.n.delete(o,d),this.h.fire(o)})}registerViewWelcomeContent2(o,d){const l=new Map;for(const[u,v]of d)this.n.add(o,v),l.set(u,(0,P.$Rc)(()=>{this.n.delete(o,v),this.h.fire(o)}));return this.h.fire(o),l}getViewWelcomeContent(o){const d=[];return this.n.forEach(o,l=>d.push(l)),d.sort(a)}r(o,d){let l=this.m.get(d);l||(l=[],this.m.set(d,l),this.j.push(d));for(const u of o){if(this.getView(u.id)!==null)throw new Error((0,N.localize)(2,null,u.id));l.push(u)}}s(o,d){const l=this.m.get(d);if(!l)return[];const u=[],v=[];for(const I of l)o.includes(I)?u.push(I):v.push(I);return u.length&&(v.length?this.m.set(d,v):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),u}}p.$Kn.add(w.ViewsRegistry,new i),e.$cF=(0,h.$8h)("viewDescriptorService");var n;(function(g){g[g.Default=0]="Default",g[g.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var r;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class s{constructor(o,d){this.c=!1,this.d=!1,(0,k.$Bn)(this,o),this.d=!!d,this.resolve=async l=>{if(d&&!this.c){const u=await d(l);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$dF=s;class t extends Error{constructor(o){super((0,N.localize)(3,null,o)),this.name="NoTreeViewError"}static is(o){return o.name==="NoTreeViewError"}}e.$eF=t}),define(ke[279],Se([1,0,2,29,5]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oF=e.$nF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$mF=e.$lF=void 0;function P(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof D.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(N.$Ws.isIRange)}e.$lF=P;function A(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(P)}e.$mF=A;var p;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var b;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})(b||(e.ChatAgentCopyKind=b={})),e.$nF=(0,h.$8h)("IChatService"),e.$oF="accessibility.voice.keywordActivation"}),define(ke[140],Se([1,0,4,8,226]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lb=void 0;class P{constructor(){this.f=new Map,this.k=[],this.m=new D.$Wd,this.n=new D.$Wd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(p){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=p}onEvent(p){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=p}onRequest(p){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.s("response",p)}sendRequest(p,b,k,R){const C={command:p};if(b&&Object.keys(b).length>0&&(C.arguments=b),this.s("request",C),typeof R=="number"){const w=setTimeout(()=>{clearTimeout(w);const E=this.f.get(C.seq);if(E){this.f.delete(C.seq);const S={type:"response",seq:0,request_seq:C.seq,success:!1,command:p,message:(0,h.localize)(0,null,R,p)};E(S)}},R)}return k&&this.f.set(C.seq,k),C.seq}acceptMessage(p){this.j?this.j(p):(this.k.push(p),this.k.length===1&&this.q())}o(p,b){return p.type!=="event"||b.type!=="event"}async q(){let p;for(;this.k.length;){if((!p||this.o(this.k[0],p))&&await(0,N.$9g)(0),p=this.k.shift(),!p)return;switch(p.type){case"event":this.i?.(p);break;case"request":this.g?.(p);break;case"response":{const b=p,k=this.f.get(b.request_seq);k&&(this.f.delete(b.request_seq),k(b));break}}}}s(p,b){b.type=p,b.seq=this.d++,this.sendMessage(b)}async u(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach((b,k)=>p.set(k,b)),await(0,N.$9g)(500),p.forEach((b,k)=>{b({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$0lb=P}),define(ke[280],Se([1,0,2,227,45,5]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$VH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$UH=e.MemoryRangeType=e.$TH=e.State=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=void 0,e.$NG="workbench.view.debug",e.$OG="workbench.debug.variablesView",e.$PG="workbench.debug.watchExpressionsView",e.$QG="workbench.debug.callStackView",e.$RG="workbench.debug.loadedScriptsView",e.$SG="workbench.debug.breakPointsView",e.$TG="workbench.debug.disassemblyView",e.$UG="workbench.panel.repl",e.$VG="workbench.panel.repl.view",e.$WG=new h.$mj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$XG=new h.$mj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$YG=new h.$mj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$ZG="debugUx",e.$1G=new h.$mj(e.$ZG,"default",{type:"string",description:N.localize(3,null)}),e.$2G=new h.$mj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$3G=new h.$mj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$4G=new h.$mj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$5G=new h.$mj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$6G=new h.$mj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$7G=new h.$mj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$8G=new h.$mj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$9G=new h.$mj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$0G=new h.$mj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$$G=new h.$mj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$_G=new h.$mj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$aH=new h.$mj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$bH=new h.$mj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$cH=new h.$mj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$dH=new h.$mj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$eH=new h.$mj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$fH=new h.$mj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$gH=new h.$mj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$hH=new h.$mj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(22,null)}),e.$iH=new h.$mj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(23,null)}),e.$jH=new h.$mj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(24,null)}),e.$kH=new h.$mj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(25,null)}),e.$lH=new h.$mj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(26,null)}),e.$mH=new h.$mj("stepBackSupported",!1,{type:"boolean",description:N.localize(27,null)}),e.$nH=new h.$mj("restartFrameSupported",!1,{type:"boolean",description:N.localize(28,null)}),e.$oH=new h.$mj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(29,null)}),e.$pH=new h.$mj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$qH=new h.$mj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(31,null)}),e.$rH=new h.$mj("breakpointsExist",!1,{type:"boolean",description:N.localize(32,null)}),e.$sH=new h.$mj("debuggersAvailable",!1,{type:"boolean",description:N.localize(33,null)}),e.$tH=new h.$mj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(34,null)}),e.$uH=new h.$mj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(35,null)}),e.$vH=new h.$mj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(36,null)}),e.$wH=new h.$mj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(37,null)}),e.$xH=new h.$mj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$yH=new h.$mj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$zH=new h.$mj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$AH=new h.$mj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$BH=new h.$mj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$CH=new h.$mj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(43,null)}),e.$DH=new h.$mj("variableIsReadonly",!1,{type:"boolean",description:N.localize(44,null)}),e.$EH=new h.$mj("variableValue",!1,{type:"string",description:N.localize(45,null)}),e.$FH=new h.$mj("variableType",!1,{type:"string",description:N.localize(46,null)}),e.$GH=new h.$mj("variableName",!1,{type:"string",description:N.localize(47,null)}),e.$HH=new h.$mj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(48,null)}),e.$IH=new h.$mj("multiSessionRepl",!1,{type:"boolean",description:N.localize(49,null)}),e.$JH=new h.$mj("multiSessionDebug",!1,{type:"boolean",description:N.localize(50,null)}),e.$KH=new h.$mj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(51,null)}),e.$LH=new h.$mj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(52,null)}),e.$MH=new h.$mj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(53,null)}),e.$NH=new h.$mj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(54,null)});const A=c=>N.localize(55,null,c);e.$OH=A,e.$PH="editor.contrib.debug",e.$QH="editor.contrib.breakpoint",e.$RH="debug",e.$SH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(56,null)};var p;(function(c){c[c.Inactive=0]="Inactive",c[c.Initializing=1]="Initializing",c[c.Stopped=2]="Stopped",c[c.Running=3]="Running"})(p||(e.State=p={}));function b(c){switch(c){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$TH=b;var k;(function(c){c[c.Valid=0]="Valid",c[c.Unreadable=1]="Unreadable",c[c.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$UH="vscode-debug-memory";var R;(function(c){c[c.Initial=1]="Initial",c[c.Dynamic=2]="Dynamic"})(R||(e.DebugConfigurationProviderTriggerKind=R={}));var C;(function(c){c.UnverifiedBreakpoints="unverifiedBreakpoints"})(C||(e.DebuggerString=C={})),e.$VH=(0,P.$8h)("debugService");var w;(function(c){c[c.CONDITION=0]="CONDITION",c[c.HIT_COUNT=1]="HIT_COUNT",c[c.LOG_MESSAGE=2]="LOG_MESSAGE",c[c.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var E;(function(c){c[c.Command=0]="Command",c[c.Tree=1]="Tree"})(E||(e.DebugVisualizationType=E={}));var S;(function(c){c.deserialize=m=>({id:m.id,name:m.name,iconPath:m.iconPath&&{light:D.URI.revive(m.iconPath.light),dark:D.URI.revive(m.iconPath.dark)},iconClass:m.iconClass,visualization:m.visualization}),c.serialize=m=>m})(S||(e.IDebugVisualization=S={}))}),define(ke[281],Se([1,0,12,2,17,24,16,29,22,19]),function($e,e,D,N,h,P,A,p,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=void 0;const R=/{([^}]+)}/g;function C(I,$,f){return I.replace(R,function(y,L){return $&&L.length>0&&L[0]!=="_"?y:f&&f.hasOwnProperty(L)?f[L]:y})}e.$cG=C;function w(I){const $={};for(const f of Object.keys(I))f.startsWith("!")||($[f]=I[f]);return $}e.$dG=w;function E(I){return I.configuration.request==="attach"&&!S(I)&&(!I.parentSession||E(I.parentSession))}e.$eG=E;function S(I){let $=I.configuration.type;if($)return $==="vslsShare"&&($=I.configuration.adapterProxy.configuration.type),(0,D.$af)($,"extensionhost")||(0,D.$af)($,"pwa-extensionhost")?I:I.parentSession?S(I.parentSession):void 0}e.$fG=S;function c(I){return I.type&&(I.label||I.program||I.runtime)}e.$gG=c;function m(I,$,f){let y,L=0;const T=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let U=null;for(;U=T.exec(I);){const j=U.index+1,F=j+U[0].length;if(j<=$&&F>=f){y=U[0],L=j;break}}if(y){const j=/\w+/g;let F=null;for(;(F=j.exec(y))&&!(F.index+1+L+F[0].length>=f););F&&(y=y.substring(0,j.lastIndex))}return y?{start:L,end:L+y.length-1}:{start:0,end:0}}e.$hG=m;async function a(I,$,f,y){if(I.evaluatableExpressionProvider.has($)){const L=I.evaluatableExpressionProvider.ordered($),T=(0,k.$Hb)(await Promise.all(L.map(async U=>{try{return await U.provideEvaluatableExpression($,f,y??b.CancellationToken.None)}catch{return}})));if(T.length>0){let U=T[0].expression;const j=T[0].range;return U||(U=$.getLineContent(f.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:U}}}else{const L=$.getLineContent(f.lineNumber),{start:T,end:U}=m(L,f.column,f.column),j=L.substring(T-1,U);return{matchingExpression:j,range:new p.$Ws(f.lineNumber,T,f.lineNumber,T+j.length)}}return null}e.$iG=a;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(I){return!!(I&&I.match(i))}e.$jG=n;function r(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(n(I.path))return N.URI.parse(I.path);if((0,h.$ic)(I.path))return N.URI.file(I.path)}return I.path}function s(I){if(typeof I.path=="object"){const $=N.URI.revive(I.path);if($)return $.scheme===A.Schemas.file?$.fsPath:$.toString()}return I.path}function t(I,$){const f=$?r:s,y=(0,P.$yn)(I);return o(y,(L,T)=>{L&&T&&(T.path=f(T))}),y}e.$kG=t;function g(I,$){const f=$?r:s,y=(0,P.$yn)(I);return o(y,(L,T)=>{!L&&T&&(T.path=f(T))}),y}e.$lG=g;function o(I,$){switch(I.type){case"event":{const f=I;switch(f.event){case"output":$(!1,f.body.source);break;case"loadedSource":$(!1,f.body.source);break;case"breakpoint":$(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=I;switch(f.command){case"setBreakpoints":$(!0,f.arguments.source);break;case"breakpointLocations":$(!0,f.arguments.source);break;case"source":$(!0,f.arguments.source);break;case"gotoTargets":$(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(y=>$(!1,y));break;default:break}break}case"response":{const f=I;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(y=>$(!1,y.source));break;case"loadedSources":f.body.sources.forEach(y=>$(!1,y));break;case"scopes":f.body.scopes.forEach(y=>$(!1,y.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(y=>$(!1,y.source));break;case"setBreakpoints":f.body.breakpoints.forEach(y=>$(!1,y.source));break;case"disassemble":f.body?.instructions.forEach(L=>$(!1,L.location));break;default:break}break}}}function d(I){return I.filter($=>!$.presentation?.hidden).sort(($,f)=>$.presentation?f.presentation?$.presentation.group?f.presentation.group?$.presentation.group!==f.presentation.group?$.presentation.group.localeCompare(f.presentation.group):l($.presentation.order,f.presentation.order):-1:f.presentation.group?1:l($.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.$mG=d;function l(I,$){return typeof I!="number"?typeof $!="number"?0:1:typeof $!="number"?-1:I-$}async function u(I,$){const f=I.getValue("debug.saveBeforeStart",{overrideIdentifier:$.activeTextEditorLanguageId});if(f!=="none"&&(await $.saveAll(),f==="allEditorsInActiveGroup")){const y=$.activeEditorPane;y&&y.input.resource?.scheme===A.Schemas.untitled&&await $.save({editor:y.input,groupId:y.group.id})}await I.reloadConfiguration()}e.$nG=u;const v=(I,$)=>!I||!$?I===$:I.name===$.name&&I.path===$.path&&I.sourceReference===$.sourceReference;e.$oG=v}),define(ke[282],Se([1,0,50,62,24,17,11,12,31,228,140]),function($e,e,D,N,h,P,A,p,b,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=e.$bic=e.$aic=e.$_hc=e.$$hc=void 0;class C extends R.$0lb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(a,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,a.on("data",n=>this.w(n))}sendMessage(a){if(this.p){const i=JSON.stringify(a);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}w(a){for(this.r=Buffer.concat([this.r,a]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.m.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.r.indexOf(C.a);if(i!==-1){const r=this.r.toString("utf8",0,i).split(C.b);for(const s of r){const t=s.split(C.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+C.a.length);continue}}break}}}e.$$hc=C;class w extends C{startSession(){return new Promise((a,i)=>{let n=!1;this.x=this.y(()=>{this.v(this.x,this.x),a(),n=!0}),this.x.on("close",()=>{n?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",r=>{n?this.m.fire(r):i(r)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$_hc=w;class E extends w{constructor(a){super(),this.z=a}y(a){return N.createConnection(this.z.port,this.z.host||"127.0.0.1",a)}}e.$aic=E;class S extends w{constructor(a){super(),this.z=a}y(a){return N.createConnection(this.z.path,a)}}e.$bic=S;class c extends C{constructor(a,i){super(),this.y=a,this.z=i}async startSession(){const a=this.y.command,i=this.y.args,n=this.y.options||{};try{if(a)if(P.$ic(a)){if(!await b.Promises.exists(a))throw new Error(k.localize(0,null,a))}else a.indexOf("/")<0&&a.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.z));let r=process.env;if(n.env&&Object.keys(n.env).length>0&&(r=h.$Bn(h.$yn(process.env),n.env)),a==="node")if(Array.isArray(i)&&i.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const g=D.fork(i[0],i.slice(1),t);if(!g.pid)throw new Error(k.localize(2,null,i[0]));this.x=g}else throw new Error(k.localize(3,null));else{const s={env:r};n.cwd&&(s.cwd=n.cwd),this.x=D.spawn(a,i,s)}this.x.on("error",s=>{this.m.fire(s)}),this.x.on("exit",(s,t)=>{this.n.fire(s)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",s=>{this.m.fire(s)}),this.x.stdin.on("error",s=>{this.m.fire(s)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(r){this.m.fire(r)}}async stopSession(){return this.x?(await this.u(),A.$i?new Promise((a,i)=>{const n=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,s,t){if(r)return i(r)});n.on("exit",a),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(a,i){if(!a)return;const n=Object.create(null);a.runtime&&(a.runtime.indexOf("./")===0?n.runtime=P.$jc(i,a.runtime):n.runtime=a.runtime),a.runtimeArgs&&(n.runtimeArgs=a.runtimeArgs),a.program&&(P.$ic(a.program)?n.program=a.program:n.program=P.$jc(i,a.program)),a.args&&(n.args=a.args);const r=a;return r.win&&(n.win=c.A(r.win,i)),r.winx86&&(n.winx86=c.A(r.winx86,i)),r.windows&&(n.windows=c.A(r.windows,i)),r.osx&&(n.osx=c.A(r.osx,i)),r.linux&&(n.linux=c.A(r.linux,i)),n}static platformAdapterExecutable(a,i){let n=Object.create(null);i=i.toLowerCase();for(const d of a)if(d.contributes){const l=d.contributes.debuggers;l&&l.length>0&&l.filter(u=>typeof u.type=="string"&&p.$af(u.type,i)).forEach(u=>{const v=c.A(u,d.extensionLocation.fsPath);n=h.$Bn(n,v,d.isBuiltin)})}let r;A.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=n.winx86||n.win||n.windows:A.$i?r=n.win||n.windows:A.$j?r=n.osx:A.$k&&(r=n.linux),r=r||n;const s=r.program||n.program,t=r.args||n.args,g=r.runtime||n.runtime,o=r.runtimeArgs||n.runtimeArgs;if(g)return{type:"executable",command:g,args:(o||[]).concat(typeof s=="string"?[s]:[]).concat(t||[])};if(s)return{type:"executable",command:s,args:t||[]}}}e.$cic=c}),define(ke[283],Se([1,0,50,34,11]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=e.$dic=void 0;function P(k,R){return new Promise((C,w)=>{let E="";const S=D.spawn(k,R);S.pid&&S.stdout.on("data",c=>{E+=c.toString()}),S.on("error",c=>{w(c)}),S.on("close",c=>{C(E)})})}async function A(k){if(k)if(h.$i){const R=await new Promise((C,w)=>{$e(["@vscode/windows-process-tree"],C,w)});return new Promise(C=>{R.getProcessTree(k,w=>{C(!!w&&w.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(k)]).then(R=>{const C=R.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.$dic=A;var p;(function(k){k[k.cmd=0]="cmd",k[k.powershell=1]="powershell",k[k.bash=2]="bash"})(p||(p={}));function b(k,R,C,w,E){k=k.trim().toLowerCase();let S;k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0?S=1:k.indexOf("cmd.exe")>=0?S=0:k.indexOf("bash")>=0?S=2:h.$i?S=0:S=2;let c,m=" ";switch(S){case 1:if(c=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),w){const a=(0,N.$bg)(w);a&&(m+=`${a}:; `),m+=`cd ${c(w)}; `}if(E)for(const a in E){const i=E[a];i===null?m+=`Remove-Item env:${a}; `:m+=`\${env:${a}}='${i}'; `}if(R.length>0){const a=R.shift(),i=C?a:c(a);m+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of R)m+=n==="<"||n===">"||C?n:c(n),m+=" "}break;case 0:if(c=a=>(a=a.replace(/\"/g,'""'),a=a.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>a.includes(i))||a.length===0?`"${a}"`:a),w){const a=(0,N.$bg)(w);a&&(m+=`${a}: && `),m+=`cd ${c(w)} && `}if(E){m+='cmd /C "';for(const a in E){let i=E[a];i===null?m+=`set "${a}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),m+=`set "${a}=${i}" && `)}}for(const a of R)m+=a==="<"||a===">"||C?a:c(a),m+=" ";E&&(m+='"');break;case 2:{c=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const a=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(w&&(m+=`cd ${c(w)} ; `),E){m+="/usr/bin/env";for(const i in E){const n=E[i];n===null?m+=` -u ${a(i)}`:m+=` ${a(`${i}=${n}`)}`}m+=" "}for(const i of R)m+=i==="<"||i===">"||C?i:c(i),m+=" ";break}}return m}e.$eic=b}),define(ke[284],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.CellExecutionUpdateType=void 0;var N;(function(h){h[h.Output=1]="Output",h[h.OutputItems=2]="OutputItems",h[h.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$qJ=(0,D.$8h)("INotebookExecutionService")}),define(ke[285],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfb=e.$Afb=e.ProxyKernelState=e.$zfb=void 0,e.$zfb=100;var N;(function(h){h[h.Disconnected=1]="Disconnected",h[h.Connected=2]="Connected",h[h.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$Afb=(0,D.$8h)("INotebookKernelService"),e.$Bfb=(0,D.$8h)("INotebookKernelHistoryService")}),define(ke[286],Se([1,0,3,29,193,100]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BRb=void 0;class A extends D.$Tc{constructor(b,k,R){super(),this._source=b,this.b=k,this.c=R,this.a=void 0}f(b){const k=b.getLineCount();return new N.$Ws(1,1,k,this.g(b,k))}g(b,k){if(k<1||k>b.getLineCount())throw new Error("Illegal value for lineNumber");return b.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const b=new h.$eC;b.acceptChunk(this._source);const k=b.finish(!0),{textBuffer:R,disposable:C}=k.create(1);this.b=R,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(b=>{const k=new h.$eC;k.acceptChunk(b);const R=k.finish(!0),{textBuffer:C,disposable:w}=R.create(1);return this.B(w),C})),this.a}findInInputs(b){const R=new P.$5B(b,!1,!1,null).parseSearchRequest();if(!R)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,R,!0,5e3)}findInOutputs(b){const R=new P.$5B(b,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(C=>{const w=C.findMatchesLineByLine(this.f(C),R,!0,5e3);if(w.length!==0)return{textBuffer:C,matches:w}}).filter(C=>!!C):[]}}e.$BRb=A}),define(ke[67],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(P){P.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var N;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class h{static fromExtHostTestItem(A,p,b=A.parent){if(A._isRoot)return new h([p]);const k=[A.id];for(let R=b;R&&R.id!==p;R=R.parent)k.push(R.id);return k.push(p),new h(k.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const p=A.indexOf("\0");return p===-1?A:A.slice(0,p)}static fromString(A){return new h(A.split("\0"))}static join(A,p){return new h([...A.path,p])}static joinToString(A,p){return A.toString()+"\0"+p}static parentId(A){const p=A.lastIndexOf("\0");return p===-1?void 0:A.slice(0,p)}static localId(A){const p=A.lastIndexOf("\0");return p===-1?A:A.slice(p+1)}static isChild(A,p){return p.startsWith(A)&&p[A.length]==="\0"}static compare(A,p){return A===p?0:h.isChild(A,p)?2:h.isChild(p,A)?3:1}constructor(A,p=A.length){if(this.path=A,this.d=p,A.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new h(this.path,1)}get parentId(){return this.d>1?new h(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new h(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new h(this.path,A)}compare(A){if(typeof A=="string")return h.compare(this.toString(),A);for(let p=0;p<A.d&&p<this.d;p++)if(A.path[p]!==this.path[p])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$bK=h}),define(ke[90],Se([1,0,2,48,29,67]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$iK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$hK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$gK=e.$fK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$eK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$dK=e.$cK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var p;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var b;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.$cK=[2,4,8,16,32,64];const k=M=>"runId"in M;e.$dK=k;var R;(function(M){M.serialize=O=>({range:O.range.toJSON(),uri:O.uri.toJSON()}),M.deserialize=(O,z)=>({range:h.$Ws.lift(z.range),uri:O.asCanonicalUri(D.URI.revive(z.uri))})})(R||(e.IRichLocation=R={}));var C;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(C||(e.TestMessageType=C={}));var w;(function(M){M.serialize=O=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&R.serialize(O.location)}),M.deserialize=(O,z)=>({message:z.message,type:0,expected:z.expected,actual:z.actual,contextValue:z.contextValue,location:z.location&&R.deserialize(O,z.location)})})(w||(e.ITestErrorMessage=w={}));const E=(M,O)=>`${O?"s":"e"}${M}`;e.$eK=E;var S;(function(M){M.serialize=O=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&R.serialize(O.location)}),M.deserialize=(O,z)=>({message:z.message,type:1,offset:z.offset,length:z.length,location:z.location&&R.deserialize(O,z.location)})})(S||(e.ITestOutputMessage=S={}));var c;(function(M){M.serialize=O=>O.type===0?w.serialize(O):S.serialize(O),M.deserialize=(O,z)=>z.type===0?w.deserialize(O,z):S.deserialize(O,z)})(c||(e.ITestMessage=c={}));var m;(function(M){M.serializeWithoutMessages=O=>({state:O.state,duration:O.duration,messages:[]}),M.serialize=O=>({state:O.state,duration:O.duration,messages:O.messages.map(c.serialize)}),M.deserialize=(O,z)=>({state:z.state,duration:z.duration,messages:z.messages.map(J=>c.deserialize(O,J))})})(m||(e.ITestTaskState=m={}));const a="\0",i=(M,O)=>M+a+O;e.$fK=i;const n=M=>{const O=M.indexOf(a);return{ctrlId:M.slice(0,O),tagId:M.slice(O+1)}};e.$gK=n;var r;(function(M){M.serialize=O=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?.toJSON(),range:O.range?.toJSON()||null,description:O.description,error:O.error,sortText:O.sortText}),M.deserialize=(O,z)=>({extId:z.extId,label:z.label,tags:z.tags,busy:z.busy,children:void 0,uri:z.uri?O.asCanonicalUri(D.URI.revive(z.uri)):void 0,range:z.range?h.$Ws.lift(z.range):null,description:z.description,error:z.error,sortText:z.sortText})})(r||(e.ITestItem=r={}));var s;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(s||(e.TestItemExpandState=s={}));var t;(function(M){M.serialize=O=>({expand:O.expand,item:r.serialize(O.item)}),M.deserialize=(O,z)=>({controllerId:P.$bK.root(z.item.extId),expand:z.expand,item:r.deserialize(O,z.item)})})(t||(e.InternalTestItem=t={}));var g;(function(M){M.serialize=O=>{let z;return O.item&&(z={},O.item.label!==void 0&&(z.label=O.item.label),O.item.tags!==void 0&&(z.tags=O.item.tags),O.item.busy!==void 0&&(z.busy=O.item.busy),O.item.uri!==void 0&&(z.uri=O.item.uri?.toJSON()),O.item.range!==void 0&&(z.range=O.item.range?.toJSON()),O.item.description!==void 0&&(z.description=O.item.description),O.item.error!==void 0&&(z.error=O.item.error),O.item.sortText!==void 0&&(z.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:z}},M.deserialize=O=>{let z;return O.item&&(z={},O.item.label!==void 0&&(z.label=O.item.label),O.item.tags!==void 0&&(z.tags=O.item.tags),O.item.busy!==void 0&&(z.busy=O.item.busy),O.item.range!==void 0&&(z.range=O.item.range?h.$Ws.lift(O.item.range):null),O.item.description!==void 0&&(z.description=O.item.description),O.item.error!==void 0&&(z.error=O.item.error),O.item.sortText!==void 0&&(z.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:z}}})(g||(e.ITestItemUpdate=g={}));const o=(M,O)=>{O.expand!==void 0&&(M.expand=O.expand),O.item!==void 0&&(M.item=M.item?Object.assign(M.item,O.item):O.item)};e.$hK=o;var d;(function(M){M.serializeWithoutMessages=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(m.serializeWithoutMessages)}),M.serialize=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(m.serialize)}),M.deserialize=(O,z)=>({...t.deserialize(O,z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(J=>m.deserialize(O,J)),retired:!0})})(d||(e.TestResultItem=d={}));var l;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(O,z)=>{O.covered+=z.covered,O.total+=z.total}})(l||(e.ICoveredCount=l={}));var u;(function(M){M.serialize=O=>({statement:O.statement,branch:O.branch,function:O.function,details:O.details?.map(f.serialize),uri:O.uri.toJSON()}),M.deserialize=(O,z)=>({statement:z.statement,branch:z.branch,function:z.function,details:z.details?.map(f.deserialize),uri:O.asCanonicalUri(D.URI.revive(z.uri))})})(u||(e.IFileCoverage=u={}));function v(M){return{...M,location:M.location?.toJSON()}}function I(M){return M.location=M.location?N.$Vs.isIPosition(M.location)?N.$Vs.lift(M.location):h.$Ws.lift(M.location):void 0,M}e.$iK=3;var $;(function(M){M[M.Function=0]="Function",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})($||(e.DetailType=$={}));var f;(function(M){M.serialize=O=>O.type===0?L.serialize(O):T.serialize(O),M.deserialize=O=>O.type===0?L.deserialize(O):T.deserialize(O)})(f||(e.CoverageDetails=f={}));var y;(function(M){M.serialize=v,M.deserialize=I})(y||(e.IBranchCoverage=y={}));var L;(function(M){M.serialize=v,M.deserialize=I})(L||(e.IFunctionCoverage=L={}));var T;(function(M){M.serialize=O=>({...v(O),branches:O.branches?.map(y.serialize)}),M.deserialize=O=>({...I(O),branches:O.branches?.map(y.deserialize)})})(T||(e.IStatementCoverage=T={}));var U;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(U||(e.TestDiffOpType=U={}));var j;(function(M){M.deserialize=(O,z)=>z.op===0?{op:z.op,item:t.deserialize(O,z.item)}:z.op===1?{op:z.op,item:g.deserialize(z.item)}:z.op===2?{op:z.op,uri:O.asCanonicalUri(D.URI.revive(z.uri)),docv:z.docv}:z,M.serialize=O=>O.op===0?{op:O.op,item:t.serialize(O.item)}:O.op===1?{op:O.op,item:g.serialize(O.item)}:O})(j||(e.TestsDiffOp=j={}));class F{constructor(O){this.k=O,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(O){const z=this.v();for(const J of O)switch(J.op){case 0:this.l(t.deserialize(this.k,J.item),z);break;case 1:this.o(g.deserialize(J.item),z);break;case 3:this.p(J.itemId,z);break;case 5:this.q(J.itemId);break;case 4:this.updatePendingRoots(J.amount);break;case 6:this.c.set(J.tag.id,J.tag);break;case 7:this.c.delete(J.id);break}z.complete?.()}l(O,z){const J=P.$bK.parentId(O.item.extId)?.toString();let te;if(!J)te=this.w(O),this.g.add(te),this.f.set(O.item.extId,te);else if(this.f.has(J)){const x=this.f.get(J);x.children.add(O.item.extId),te=this.w(O,x),this.f.set(O.item.extId,te)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(O)}`);return}return z.add?.(te),O.expand===2&&this.h++,te}o(O,z){const J=this.f.get(O.extId);if(J)return O.expand!==void 0&&(J.expand===2&&this.h--,O.expand===2&&this.h++),(0,e.$hK)(J,O),z.update?.(J),J}p(O,z){const J=this.f.get(O);if(!J)return;const te=P.$bK.parentId(J.item.extId)?.toString();te?this.f.get(te).children.delete(J.item.extId):this.g.delete(J);const x=[[O]];for(;x.length;)for(const X of x.pop()){const Z=this.f.get(X);Z&&(x.push(Z.children),this.f.delete(X),z.remove?.(Z,Z!==J),Z.expand===2&&this.h--)}}q(O){}updatePendingRoots(O){this.j+=O}v(){return{}}}e.$jK=F}),define(ke[111],Se([1,0,8,4,3,61,90,67]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.TestItemEventOp=void 0;var b;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(b||(e.TestItemEventOp=b={}));const k=(i,n)=>i===n,C=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:k,label:k,description:k,error:k,sortText:k,tags:(i,n)=>!(i.length!==n.length||i.some(r=>!n.includes(r)))}),w=(i,n)=>{let r;for(const[s,t]of C)t(i[s],n[s])||(r?r[s]=n[s]:r={[s]:n[s]});return r};class E extends h.$Tc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new D.$hh(()=>this.flushDiff(),200)),this.g=this.B(new N.$Wd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===n.uri){r.docv=n.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===n.item.extId){(0,A.$hK)(r.item,n.item);return}if(r.op===0&&r.item.item.extId===n.item.extId){(0,A.$hK)(r.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,r){const s=this.tree.get(n);if(s){if((s.expandLevels===void 0||r>s.expandLevels)&&(s.expandLevels=r),s.expand===1){const t=this.M(s);return t.isOpen()?this.L(s,r-1):t.wait().then(()=>this.L(s,r-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.L(s,r-1)):this.L(s,r-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,r){switch(r.op){case 3:this.O(p.$bK.joinToString(n.fullId,r.id));break;case 0:this.z(r.item,n);break;case 5:for(const s of r.ops)this.w(n,s);break;case 1:this.C(r.new,r.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:r.update}});break;case 6:this.y(n.actual.uri);break;default:(0,P.$6c)(r)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,r){const s=p.$bK.fromExtHostTestItem(n,this.root.id,r?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(n.id);let g=this.tree.get(s.toString());if(!g){g={fullId:s,actual:n,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(g.fullId.toString(),g),this.G(n,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:g.expand,item:this.s.toITestItem(n)}}),this.I(n,g,r);return}if(g.actual===n){this.H(n,g,r);return}if(g.actual.uri?.toString()!==n.uri?.toString())return this.O(s.toString()),this.z(n,r);const o=this.s.getChildren(g.actual),d=g.actual,l=w(this.s.toITestItem(d),this.s.toITestItem(n));this.s.getApiFor(d).listener=void 0,g.actual=n,g.expand=0,l&&(l.hasOwnProperty("tags")&&(this.C(n.tags,d.tags,s.toString()),delete l.tags),this.w(g,{op:4,update:l})),this.I(n,g,r);for(const[u,v]of o)this.s.getChildren(n).get(v.id)||this.O(p.$bK.joinToString(s,v.id));this.y(g.actual.uri)}C(n,r,s){const t=new Set(r.map(g=>g.id));for(const g of n)t.delete(g.id)||this.D(g);this.pushDiff({op:1,item:{extId:s,item:{tags:n.map(g=>(0,A.$fK)(this.s.controllerId,g.id))}}}),t.forEach(this.F,this)}D(n){const r=this.j.get(n.id);r?r.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$fK)(this.s.controllerId,n.id)}}))}F(n){const r=this.j.get(n);r&&!--r.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,A.$fK)(this.s.controllerId,n)}))}G(n,r){this.s.getApiFor(n).parent=r&&r.actual!==this.root?r.actual:void 0}H(n,r,s){this.G(n,s);const t=this.s.getApiFor(n);t.parent=s?.actual,t.listener=g=>this.w(r,g),this.J(r)}I(n,r,s){this.H(n,r,s);for(const[t,g]of this.s.getChildren(n))this.z(g,r)}J(n){let r;this.h?n.resolveBarrier?r=n.resolveBarrier.isOpen()?3:2:r=n.actual.canResolveChildren?1:0:r=0,r!==n.expand&&(n.expand=r,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:r}}),r===1&&n.expandLevels!==void 0&&this.M(n))}L(n,r){if(r<0)return;const s=[];for(const[t,g]of this.s.getChildren(n.actual)){const o=this.expand(p.$bK.joinToString(n.fullId,g.id),r);(0,D.$Tg)(o)&&s.push(o)}if(s.length)return Promise.all(s).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const g=new D.$7g;return g.open(),g}n.expand=2,this.N(n);const r=n.resolveBarrier=new D.$7g,s=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,g)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(g){s(g)}return(0,D.$Tg)(t)?t.catch(s).then(()=>{r.open(),this.J(n)}):(r.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const r=this.tree.get(n);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const s=[r];for(;s.length;){const t=s.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const g of t.actual.tags)this.F(g.id);this.tree.delete(t.fullId.toString());for(const[g,o]of this.s.getChildren(t.actual))s.push(this.tree.get(p.$bK.joinToString(t.fullId,o.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$eN=E;class S extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$fN=S;class c extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$gN=c;class m extends Error{constructor(n,r,s){super(`TestItem with ID "${n}" is from controller "${r}" and cannot be added as a child of an item from controller "${s}".`)}}e.$hN=m;const a=(i,n,r)=>{let s=new Map;return{get size(){return s.size},forEach(t,g){for(const o of s.values())t.call(g,o,this)},[Symbol.iterator](){return s.entries()},replace(t){const g=new Map,o=new Set(s.keys()),d={op:5,ops:[]};for(const l of t){if(!(l instanceof r))throw new c(l.id);const u=n(l).controllerId;if(u!==i.controllerId)throw new m(l.id,u,i.controllerId);if(g.has(l.id))throw new S(l.id);g.set(l.id,l),o.delete(l.id),d.ops.push({op:0,item:l})}for(const l of o.keys())d.ops.push({op:3,id:l});i.listener?.(d),s=g},add(t){if(!(t instanceof r))throw new c(t.id);s.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){s.delete(t)&&i.listener?.({op:3,id:t})},get(t){return s.get(t)},toJSON(){return Array.from(s.values())}}};e.$iN=a}),define(ke[141],Se([1,0,111]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=void 0;const N=new WeakMap,h=(A,p)=>{const b={controllerId:p};return N.set(A,b),b};e.$jN=h;const P=A=>{const p=N.get(A);if(!p)throw new D.$gN(A?.id||"<unknown>");return p};e.$kN=P}),define(ke[112],Se([1,0,16,2]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lwb=e.$kwb=e.$jwb=e.$iwb=e.$hwb=void 0,e.$hwb="vscode-cdn.net",e.$iwb=`vscode-resource.${e.$hwb}`,e.$jwb=`'self' https://*.${e.$hwb}`;function h(p,b){return p.scheme===D.Schemas.http||p.scheme===D.Schemas.https?p:(b&&b.authority&&b.isRemote&&p.scheme===D.Schemas.file&&(p=N.URI.from({scheme:D.Schemas.vscodeRemote,authority:b.authority,path:p.path})),N.URI.from({scheme:D.Schemas.https,authority:`${p.scheme}+${P(p.authority)}.${e.$iwb}`,path:p.path,fragment:p.fragment,query:p.query}))}e.$kwb=h;function P(p){return p.replace(/./g,b=>{const k=b.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?b:"-"+k.toString(16).padStart(4,"0")})}function A(p){return p.replace(/-([0-9a-f]{4})/g,(b,k)=>String.fromCharCode(parseInt(k,16)))}e.$lwb=A}),define(ke[287],Se([1,0,4,3,112]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;class P{constructor(p,b,k){this.d=p,this.e=b,this.f=k,this.a=0,this.b=new N.$Sc,this.c=new Map,this.b.add(b.onDidChangeVisibleTextEditors(()=>{const R=b.getVisibleTextEditors();for(const C of this.c.values())R.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,b,k,R,C){let w;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===p){w=n;break}if(!w)throw new Error("not a visible editor");const E=this,S=this.a++,c=new D.$Wd,m=new D.$Wd,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,h.$kwb)(n,E.f)}get cspSource(){return h.$jwb}set options(n){this.b=n,E.d.$setOptions(S,n)}get options(){return this.b}set html(n){this.a=n,E.d.$setHtml(S,n)}get html(){return this.a}get onDidReceiveMessage(){return c.event}postMessage(n){return E.d.$postMessage(S,n)}},i=new class{constructor(){this.editor=p,this.line=b,this.height=k,this.webview=a,this.onDidDispose=m.event}dispose(){E.c.has(S)&&(E.c.delete(S),E.d.$disposeEditorInset(S),m.fire(),m.dispose(),c.dispose())}};return this.d.$createEditorInset(S,w.id,w.value.document.uri,b+1,k,R||{},C.identifier,C.extensionLocation),this.c.set(S,{editor:p,inset:i,onDidReceiveMessage:c}),i}$onDidDispose(p){const b=this.c.get(p);b&&b.inset.dispose()}$onDidReceiveMessage(p,b){this.c.get(p)?.onDidReceiveMessage.fire(b)}}e.$cgc=P}),define(ke[288],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bO=e.VariableKind=e.$aO=void 0,e.$aO=(0,D.$8h)("configurationResolverService");var N;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator",P.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class h extends Error{constructor(A,p){super(p),this.variable=A}}e.$bO=h}),define(ke[289],Se([1,0,17,49,18,24,11,103,231,288,12]),function($e,e,D,N,h,P,A,p,b,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pO=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,S,c,m){this.h=new Map,this.a=E,this.b=S,this.g=c,m&&(this.c=m.then(a=>this.i(a)))}i(E){if(A.$i){const S=Object.create(null);return Object.keys(E).forEach(c=>{S[c.toLowerCase()]=E[c]}),S}return E}resolveWithEnvironment(E,S,c){return this.l({env:this.i(E),userHome:void 0},S?S.uri:void 0,c)}async resolveAsync(E,S){const c={env:await this.c,userHome:await this.g};return this.l(c,E?E.uri:void 0,S)}async j(E,S,c,m){const a=P.$yn(S);A.$i&&a.windows?Object.keys(a.windows).forEach(n=>a[n]=a.windows[n]):A.$j&&a.osx?Object.keys(a.osx).forEach(n=>a[n]=a.osx[n]):A.$k&&a.linux&&Object.keys(a.linux).forEach(n=>a[n]=a.linux[n]),delete a.windows,delete a.osx,delete a.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,E?E.uri:void 0,a,c,m)}async resolveAnyAsync(E,S,c){return this.j(E,S,c)}async resolveAnyMap(E,S,c){const m=new Map;return{newConfig:await this.j(E,S,c,m),resolvedVariables:m}}resolveWithInteractionReplace(E,S,c,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,S,c,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,S){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,S)}async l(E,S,c,m,a){if(h.$Jf(c))return this.m(E,S,c,m,a);if(Array.isArray(c))return Promise.all(c.map(i=>this.l(E,S,i,m,a)));if(h.$Lf(c)){const i=Object.create(null),n=await Promise.all(Object.keys(c).map(async r=>[await this.m(E,S,r,m,a),await this.l(E,S,c[r],m,a)]));for(const[r,s]of n)i[r]=s;return i}return c}m(E,S,c,m,a){return(0,R.$5e)(c,C.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(C.VARIABLE_LHS))return i;let r=await this.o(E,i,n,S,m);return a?.set(n,r),r!==i&&h.$Jf(r)&&r.match(C.VARIABLE_REGEXP)&&(r=await this.m(E,S,r,m,a)),r})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,S,c,m,a){let i;const n=c.split(":");n.length>1&&(c=n[0],i=n[1]);const r=g=>{const o=this.a.getFilePath();if(o)return(0,p.$Yv)(o);throw new k.$bO(g,(0,b.localize)(0,null,S))},s=g=>{const o=r(g);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,p.$Yv)(d)}throw new k.$bO(g,(0,b.localize)(1,null,S,D.$nc(o)))},t=g=>{if(i){const o=this.a.getFolderUri(i);if(o)return o;throw new k.$bO(g,(0,b.localize)(2,null,S,i))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new k.$bO(g,(0,b.localize)(3,null,S)):new k.$bO(g,(0,b.localize)(4,null,S))};switch(c){case"env":if(i){if(E.env){const g=E.env[A.$i?i.toLowerCase():i];if(h.$Jf(g))return g}return""}throw new k.$bO(k.VariableKind.Env,(0,b.localize)(5,null,S));case"config":if(i){const g=this.a.getConfigurationValue(m,i);if(h.$Sf(g))throw new k.$bO(k.VariableKind.Config,(0,b.localize)(6,null,S,i));if(h.$Lf(g))throw new k.$bO(k.VariableKind.Config,(0,b.localize)(7,null,S,i));return g}throw new k.$bO(k.VariableKind.Config,(0,b.localize)(8,null,S));case"command":return this.p(k.VariableKind.Command,S,i,a,"command");case"input":return this.p(k.VariableKind.Input,S,i,a,"input");case"extensionInstallFolder":if(i){const g=await this.a.getExtension(i);if(!g)throw new k.$bO(k.VariableKind.ExtensionInstallFolder,(0,b.localize)(9,null,S,i));return this.n(g.extensionLocation)}throw new k.$bO(k.VariableKind.ExtensionInstallFolder,(0,b.localize)(10,null,S));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,p.$Yv)(this.n(t(k.VariableKind.WorkspaceFolder)));case"cwd":return m||i?(0,p.$Yv)(this.n(t(k.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$Yv)(D.$nc(this.n(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new k.$bO(k.VariableKind.UserHome,(0,b.localize)(11,null,S))}case"lineNumber":{const g=this.a.getLineNumber();if(g)return g;throw new k.$bO(k.VariableKind.LineNumber,(0,b.localize)(12,null,S))}case"selectedText":{const g=this.a.getSelectedText();if(g)return g;throw new k.$bO(k.VariableKind.SelectedText,(0,b.localize)(13,null,S))}case"file":return r(k.VariableKind.File);case"fileWorkspaceFolder":return s(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$nc(s(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||i?D.$lc(this.n(t(k.VariableKind.RelativeFile)),r(k.VariableKind.RelativeFile)):r(k.VariableKind.RelativeFile);case"relativeFileDirname":{const g=D.$mc(r(k.VariableKind.RelativeFileDirname));if(m||i){const o=D.$lc(this.n(t(k.VariableKind.RelativeFileDirname)),g);return o.length===0?".":o}return g}case"fileDirname":return D.$mc(r(k.VariableKind.FileDirname));case"fileExtname":return D.$oc(r(k.VariableKind.FileExtname));case"fileBasename":return D.$nc(r(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const g=D.$nc(r(k.VariableKind.FileBasenameNoExtension));return g.slice(0,g.length-D.$oc(g).length)}case"fileDirnameBasename":return D.$nc(D.$mc(r(k.VariableKind.FileDirnameBasename)));case"execPath":{const g=this.a.getExecPath();return g||S}case"execInstallFolder":{const g=this.a.getAppRoot();return g||S}case"pathSeparator":case"/":return D.sep;default:try{const g=i?`${c}:${i}`:c;return this.p(k.VariableKind.Unknown,S,g,a,void 0)}catch{return S}}}}p(E,S,c,m,a){if(c&&m){const i=a===void 0?m[c]:m[a+":"+c];if(typeof i=="string")return i;throw new k.$bO(E,(0,b.localize)(14,null,S))}return S}}e.$pO=C}),define(ke[142],Se([1,0,5,139]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dD=e.$cD=e.OpenEditorContext=e.GroupsOrder=e.$bD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$aD=void 0,e.$aD=(0,D.$8h)("editorGroupsService");var h;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(h||(e.GroupDirection=h={}));var P;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(P||(e.GroupOrientation=P={}));var A;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var p;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var b;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function k(S){const c=S;return(0,N.$WE)(c?.editor)&&(0,N.$WE)(c?.replacement)}e.$bD=k;var R;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var C;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function w(S){const c=S;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}e.$cD=w;function E(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$dD=E}),define(ke[290],Se([1,0,5,142]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=e.$hD=e.$gD=e.$fD=e.$eD=void 0,e.$eD=(0,D.$8h)("editorService"),e.$fD=-1,e.$gD=-2,e.$hD=-3;function h(P){const A=P;return typeof P=="number"||(0,N.$cD)(A)}e.$iD=h}),define(ke[143],Se([1,0,5,133]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GK=void 0,e.$GK=(0,D.$9h)(N.$ci)}),define(ke[144],Se([1,0,25,4,17,3,8]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$67b=e.$57b=e.$47b=e.$37b=e.$27b=void 0;class p{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$27b=p;class b{static isHostExtension(i,n,r){if(n.getExtensionDescription(i))return!1;const s=r.getExtensionDescription(i);return s?!!((s.main||s.browser)&&s.api==="none"):!1}constructor(i,n){this.j=i,this.c=new N.$Wd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(c),this.f=new D.$pm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const r of n)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=m(this.e,n),this.e=this.e.concat(i);const r=b.l(this.e);return this.e=m(this.e,r.map(s=>s.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,r)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(o){this.d.has(o)||(this.d.add(o),this.e.push(o))}addArc(o,d){this.addNode(o),this.addNode(d),this.c.has(o)?this.c.get(o).push(d):this.c.set(o,[d])}getArcs(o){return this.c.has(o)?this.c.get(o):[]}hasOnlyGoodArcs(o,d){const l=n.getArcs(o);for(let u=0;u<l.length;u++)if(!d.has(l[u]))return!1;return!0}getNodes(){return this.e}},r=new D.$pm;for(const o of i)if(r.set(o.identifier,o),o.extensionDependencies)for(const d of o.extensionDependencies)n.addArc(D.$nm.toKey(o.identifier),D.$nm.toKey(d));const s=new Set;n.getNodes().filter(o=>n.getArcs(o).length===0).forEach(o=>s.add(o));const t=n.getNodes().filter(o=>!s.has(o));let g;do{g=!1;for(let o=0;o<t.length;o++){const d=t[o];n.hasOnlyGoodArcs(d,s)&&(t.splice(o,1),o--,s.add(d),g=!0)}}while(g);return t.map(o=>r.get(o))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$37b=b;class k{constructor(i,n){this.versionId=i,this.extensions=n}}e.$47b=k;class R{constructor(i){this.d=new E,this.c=new b(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new C(this,n)}deltaExtensions(i,n,r){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,r)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$57b=R;class C extends P.$Tc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$67b=C;class w{constructor(i){this.name=i;const n=(0,A.$1g)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class E{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new w(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const r=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),s=()=>{n&&(clearTimeout(r),n=!1,this.d=!1,this.e())};i.resolve((0,P.$Rc)(s))}}var S;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(S||(S={}));function c(a,i){const n=a.isBuiltin?0:a.isUnderDevelopment?2:1,r=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==r)return n-r;const s=h.$gc.basename(a.extensionLocation.path),t=h.$gc.basename(i.extensionLocation.path);return s<t?-1:s>t?1:0}function m(a,i){const n=new D.$om(i);return a.filter(r=>!n.has(r.identifier))}}),define(ke[291],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.ExtHostConnectionType=void 0;var D;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class N{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[N.ENV_KEY]=this.pipeName}}e.$Sm=N;class h{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[h.ENV_KEY]="1"}}e.$Tm=h;class P{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[P.ENV_KEY]="1"}}e.$Um=P;function A(R){delete R[N.ENV_KEY],delete R[h.ENV_KEY],delete R[P.ENV_KEY]}function p(R,C){A(C),R.serialize(C)}e.$Vm=p;function b(R){if(R[N.ENV_KEY])return k(R,new N(R[N.ENV_KEY]));if(R[h.ENV_KEY])return k(R,new h);if(R[P.ENV_KEY])return k(R,new P);throw new Error("No connection information defined in environment!")}e.$Wm=b;function k(R,C){return A(R),C}}),define(ke[113],Se([1,0,21]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$wm=e.$vm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var N;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(N||(e.UIKind=N={}));var h;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(h||(e.ExtensionHostExitCode=h={}));var P;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(P||(e.MessageType=P={}));function A(k){const R=D.$ke.alloc(1);switch(k){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$vm=A;function p(k,R){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$wm=p;var b;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(b||(e.NativeLogMarkers=b={}))}),define(ke[91],Se([1,0,5,4,13,27,113,65,88,24,2,3,217]),function($e,e,D,N,h,P,A,p,b,k,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=e.$HN=e.$GN=e.$FN=void 0;let E=class extends C.$Tc{constructor(a,i){super(),this.s=a,this.t=i,this.a=this.B(new N.$Wd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$Wd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:b.$So,name:(0,w.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,h.$rj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===h.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,i,n){const r=this.getTelemetryDetails(),s=new S(i,n,a,this.n,this.j,this.getBuiltInCommonProperties(a),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(a.identifier.value)??[];return this.r.set(a.identifier.value,[...t,s]),s.apiTelemetryLogger}$initializeTelemetryLevel(a,i,n){this.f=a,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(a){const i=Object.create(null);switch(i["common.extname"]=`${a.publisher}.${a.name}`,i["common.extversion"]=a.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:i["common.uikind"]="web";break;case A.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$dl)((0,b.$Yo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const i=this.getTelemetryDetails();this.r.forEach((n,r)=>{const s=n.filter(t=>!t.isDisposed);s.length===0?this.r.delete(r):this.r.set(r,s)}),this.r.forEach(n=>{for(const r of n)r.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(a,i){const r=this.r.get(a.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(a.value),!1;let s=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(i),s=!0);return s}};e.$FN=E,e.$FN=E=Ge([Ve(0,P.$EN),Ve(1,h.$qj)],E);class S{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,i,n,r,s,t,g){this.g=n,this.h=r,this.i=s,this.j=t,this.a=new N.$Wd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(a,i){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let i="properties"in a?a.properties??{}:a;return i=(0,b.$2o)(i,[]),this.c&&(i=(0,k.$Bn)(i,this.c)),this.b||(i=(0,k.$Bn)(i,this.j)),"properties"in a?a.properties=i:a=i,a}k(a,i){this.f&&(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(a,i),this.h.trace(a,i))}logUsage(a,i){this.d.isUsageEnabled&&this.k(a,i)}logError(a,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof a=="string")this.k(a,i);else{const n={name:a.name,message:a.message,stack:a.stack,cause:a.cause},r=(0,b.$2o)(n,[]),s=new Error(r.message,{cause:r.cause});s.stack=r.stack,s.name=r.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(s,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const a=this,i={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.$GN=S;function c(m){const a=Date.now()-new Date(m).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.$HN=c,e.$IN=(0,D.$8h)("IExtHostTelemetry")}),define(ke[26],Se([1,0,4,2,261,137,25,5]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QF=e.$PF=e.$OF=e.ActivationKind=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.ExtensionHostStartup=e.$IF=e.$HF=e.$GF=e.$FF=void 0,e.$FF=Object.freeze({identifier:new A.$nm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$GF="extensions.webWorker",e.$HF=(0,p.$8h)("extensionService");class b{constructor(s){this.dependency=s}}e.$IF=b;var k;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(s,t,g){this.c=s,this.d=t.slice(0),this.e=g.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:P.$qF.createActivationEventsMap(this.d)}}set(s,t,g){if(this.c>s)throw new Error(`ExtensionHostExtensions: invalid versionId ${s} (current: ${this.c})`);const o=[],d=[],l=[],u=[],v=C(this.d),I=C(t),$=(U,j)=>U.extensionLocation.toString()===j.extensionLocation.toString()||U.isBuiltin===j.isBuiltin||U.isUserBuiltin===j.isUserBuiltin||U.isUnderDevelopment===j.isUnderDevelopment;for(const U of this.d){const j=I.get(U.identifier);if(!j){o.push(U.identifier),v.delete(U.identifier);continue}if(!$(U,j)){o.push(U.identifier),v.delete(U.identifier);continue}}for(const U of t){const j=v.get(U.identifier);if(!j){d.push(U);continue}if(!$(j,U)){o.push(j.identifier),v.delete(j.identifier);continue}}const f=new A.$om(this.e),y=new A.$om(g);for(const U of this.e)y.has(U)||l.push(U);for(const U of g)f.has(U)||u.push(U);const L=P.$qF.createActivationEventsMap(d),T={versionId:s,toRemove:o,toAdd:d,addActivationEvents:L,myToRemove:l,myToAdd:u};return this.delta(T),T}delta(s){if(this.c>=s.versionId)return null;const{toRemove:t,toAdd:g,myToRemove:o,myToAdd:d}=s,l=new A.$om(t),u=new A.$om(o);for(let v=0;v<this.d.length;v++)l.has(this.d[v].identifier)&&(this.d.splice(v,1),v--);for(let v=0;v<this.e.length;v++)u.has(this.e[v])&&(this.e.splice(v,1),v--);for(const v of g)this.d.push(v);for(const v of d)this.e.push(v);return this.f=null,s}containsExtension(s){for(const t of this.e)if(A.$nm.equals(t,s))return!0;return!1}containsActivationEvent(s){return this.f||(this.f=this.g()),this.f.has(s)}g(){const s=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const g=P.$qF.readActivationEvents(t);for(const o of g)s.add(o)}return s}}e.$JF=R;function C(r){const s=new A.$pm;for(const t of r)s.set(t.identifier,t);return s}function w(r,s){return r.enabledApiProposals?r.enabledApiProposals.includes(s):!1}e.$KF=w;function E(r,s){if(!w(r,s))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${s}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${s}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.$LF=E;class S{constructor(s,t,g,o){this.codeLoadingTime=s,this.activateCallTime=t,this.activateResolvedTime=g,this.activationReason=o}}e.$MF=S;class c{constructor(s,t){this.description=s,this.value=t}}e.$NF=c;var m;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function a(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,h.$8o)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.$OF=a;function i(r,s){return{identifier:new A.$nm((0,h.$6o)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!s,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}e.$PF=i;class n{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(s){return Promise.resolve(void 0)}activateById(s,t){return Promise.resolve(void 0)}activationEventIsDone(s){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(s){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(s,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(s){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$QF=n}),define(ke[292],Se([1,0,14,144,25,26,13,8]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=e.$Cgc=e.$Bgc=e.$Agc=e.$zgc=e.$ygc=void 0;class b{static{this.NONE=new b(!1,-1,-1,-1)}constructor(a,i,n,r){this.startup=a,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=r}}e.$ygc=b;class k{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,i){return a===-1||i===-1?-1:i-a}build(){return new b(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$zgc=k;class R{constructor(a,i,n,r,s,t){this.activationFailed=a,this.activationFailedError=i,this.activationTimes=n,this.module=r,this.exports=s,this.subscriptions=t}}e.$Agc=R;class C extends R{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Bgc=C;class w extends R{constructor(){super(!1,null,b.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Cgc=w;class E extends R{constructor(a){super(!0,a,b.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(a,i,n,r){this.g=r,this.a=a,this.b=i,this.c=n,this.d=new h.$pm,this.f=Object.create(null)}dispose(){for(const[a,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const a=[];for(const[i,n]of this.d)a.push(n.wait());await Promise.all(a)}isActivated(a){const i=this.d.get(a);return!!(i&&i.value)}getActivatedExtension(a){const i=this.d.get(a);if(!i||!i.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return i.value}async activateByEvent(a,i){if(this.f[a])return;const n=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(n.map(r=>({id:r.identifier,reason:{startup:i,extensionId:r.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,i){const n=this.a.getExtensionDescription(a);if(!n)throw new Error(`Extension '${a}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(a){const i=a.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const i=this.a.getExtensionDescription(a.id);if(!i){const s=new Error(`Cannot activate unknown extension '${a.id.value}'`),t=this.k(a,null,[],new E(s));return this.c.onExtensionActivationError(a.id,s,new P.$IF(a.id.value)),t}const n=[],r=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const s of r){if(this.m(s))continue;const t=this.d.get(s);if(t){n.push(t);continue}if(this.l(s)){n.push(this.j({id:this.b.getExtensionDescription(s).identifier,reason:a.reason}));continue}const g=this.a.getExtensionDescription(s);if(g){if(!g.main&&!g.browser)continue;n.push(this.j({id:g.identifier,reason:a.reason}));continue}const o=i.displayName||i.identifier.value,d=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${s}'`),l=this.k(a,i.displayName,[],new E(d));return this.c.onExtensionActivationError(i.identifier,d,new P.$IF(s)),l}return this.k(a,i.displayName,n,null)}k(a,i,n,r){const s=new c(a.id,i,a.reason,n,r,this.c,this.g);return this.d.set(a.id,s),s}l(a){return N.$37b.isHostExtension(a,this.a,this.b)}m(a){const i=this.b.getExtensionDescription(a);return i?!i.main&&!i.browser:!1}};e.$Dgc=S,e.$Dgc=S=Ge([Ve(3,A.$pj)],S);let c=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,i,n,r,s,t,g){this.c=a,this.d=i,this.f=n,this.g=r,this.h=s,this.j=t,this.k=g,this.a=new p.$7g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const i=this.g[a];if(i.value&&!i.value.activationFailed){this.g.splice(a,1),a--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new E(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const i=new Error;if(a&&a.name&&(i.name=a.name),a&&a.message?i.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(i.stack=a.stack),this.h=new E(i),this.b&&D.$4(a))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};c=Ge([Ve(6,A.$pj)],c)}),define(ke[293],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[294],Se([1,0,233,14,39,134,108,37,25,293,136,137]),function($e,e,D,N,h,P,A,p,b,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=void 0;const w=p.$Kn.as(A.$Ln.JSONContribution);class E{constructor(s,t,g){this.a=s,this.b=t,this.c=g}d(s,t){this.a({type:s,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(s){this.d(h.default.Error,s)}warn(s){this.d(h.default.Warning,s)}info(s){this.d(h.default.Info,s)}}e.$zF=E;class S{static a(s){const t=new b.$om;for(let g=0,o=s.length;g<o;g++)t.add(s[g].description.identifier);return t}static compute(s,t){if(!s||!s.length)return new S(t,[]);if(!t||!t.length)return new S([],s);const g=this.a(s),o=this.a(t),d=t.filter(u=>!g.has(u.description.identifier)),l=s.filter(u=>!o.has(u.description.identifier));return new S(d,l)}constructor(s,t){this.added=s,this.removed=t}}e.$AF=S;class c{constructor(s,t){this.name=s,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(s){if(this.a!==null)throw new Error("Handler already set!");this.a=s,this.d()}acceptUsers(s){this.c=S.compute(this.b,s),this.b=s,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(s){(0,N.$1)(s)}}}e.$BF=c;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$CF={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.$mm},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$po}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$po}},extensionKind:{description:D.localize(52,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(s){if(this.a.has(s.extensionPoint))throw new Error("Duplicate extension point: "+s.extensionPoint);const t=new c(s.extensionPoint,s.defaultExtensionKind);return this.a.set(s.extensionPoint,t),s.activationEventsGenerator&&C.$qF.register(s.extensionPoint,s.activationEventsGenerator),e.$CF.properties.contributes.properties[s.extensionPoint]=s.jsonSchema,w.registerSchema(a,e.$CF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$DF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};p.$Kn.add(n.ExtensionsRegistry,new i),e.$EF=p.$Kn.as(n.ExtensionsRegistry),w.registerSchema(a,e.$CF),w.registerSchema(R.$Ij,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(ke[295],Se([1,0,229,18,24,294,45,4]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CG=void 0;const b={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var k;(function(w){function E(S,c,m){if(!S)return;const a=N.$Jf(S.type)?S.type:void 0;if(!a||a.length===0){m.error(D.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const n of S.required)N.$Jf(n)&&i.push(n);return{extensionId:c.value,taskType:a,required:i,properties:S.properties?h.$yn(S.properties):{},when:S.when?A.$6i.deserialize(S.when):void 0}}w.from=E})(k||(k={}));const R=P.$EF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(w,E)=>{for(const S of w)S.type&&E.push(`onTaskType:${S.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:b}});class C{constructor(){this.d=new p.$Wd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,S)=>{R.setHandler((c,m)=>{this.c=void 0;try{for(const a of m.removed){const i=a.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const a of m.added){const i=a.value;for(const n of i){const r=k.from(n,a.description.identifier,a.collector);r&&(this.a[r.taskType]=r)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const S of this.all()){const c={type:"object",additionalProperties:!1};S.required.length>0&&(c.required=S.required.slice(0)),S.properties!==void 0?c.properties=h.$yn(S.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[S.taskType]},E.push(c)}this.c={oneOf:E}}return this.c}}e.$CG=new C}),define(ke[296],Se([1,0,230,18,23,24,45,295]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$MG=e.JsonSchemaVersion=e.ExecutionEngine=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$GG=e.ShellQuoting=e.$FG=e.$EG=e.$DG=void 0,e.$DG="settings",e.$EG=new A.$mj("taskRunning",!1,D.localize(0,null)),e.$FG=D.localize2(2,"Tasks");var b;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(b||(e.ShellQuoting=b={})),e.$GG="$customized",function(M){function O(z){if(!z)return M.Strong;switch(z.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=O}(b||(e.ShellQuoting=b={}));var k;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var R;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(R||(e.RevealKind=R={})),function(M){function O(z){switch(z.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=O}(R||(e.RevealKind=R={}));var C;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(M){function O(z){switch(z.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=O}(C||(e.RevealProblemKind=C={}));var w;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(w||(e.PanelKind=w={})),function(M){function O(z){switch(z.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=O}(w||(e.PanelKind=w={}));var E;(function(M){M.defaults={echo:!0,reveal:R.Always,revealProblems:C.Never,focus:!1,panel:w.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var S;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(M){function O(J){switch(J.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=O;function z(J){switch(J){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=z}(S||(e.RuntimeType=S={}));var c;(function(M){function O(z){return N.$Jf(z)?z:z.value}M.value=O})(c||(e.CommandString=c={}));var m;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function O(J){return J===M.Clean._id||J===M.Build._id||J===M.Rebuild._id||J===M.Test._id}M.is=O;function z(J){if(J!==void 0)return N.$Jf(J)?O(J)?{_id:J,isDefault:!1}:void 0:J}M.from=z})(m||(e.TaskGroup=m={}));var a;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(a||(e.TaskScope=a={}));var i;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function O(z){switch(z){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=O})(i||(e.TaskSourceKind=i={}));var n;(function(M){M.parallel="parallel",M.sequence="sequence"})(n||(e.DependsOrder=n={}));var r;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var s;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(s||(e.RunOptions=s={}));class t{constructor(O,z,J,te,x,X){this._label="",this._id=O,z&&(this._label=z),J&&(this.type=J),this.runOptions=te,this.configurationProperties=x,this._source=X}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,z=!1){if(O===void 0)return!1;if(N.$Jf(O))return O===this._label||O===this.configurationProperties.identifier||z&&O===this._id;const J=this.getDefinition(!0);return J!==void 0&&J._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$HG=t;class g extends t{constructor(O,z,J,te,x,X,Z,ae){super(O,J,void 0,Z,ae,z),this.command={},this._source=z,this.hasDefinedMatchers=X,x&&(this.command=x)}clone(){return new g(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case S.Shell:z="shell";break;case S.Process:z="process";break;case S.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(O){return O instanceof g}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$DG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(z+=this._source.kind);const J={type:e.$GG,folder:O,id:z};return JSON.stringify(J)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?h.$Fg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new g(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$IG=g;class o extends t{constructor(O,z,J,te,x,X,Z){super(O,J,te,X,Z,z),this._source=z,this.configures=x}static is(O){return O instanceof o}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?h.$Fg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$DG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(z+=this._source.kind);const J={type:e.$GG,folder:O,id:z};return JSON.stringify(J)}}e.$JG=o;class d extends t{constructor(O,z,J,te,x,X,Z,ae,_){super(O,J,te,ae,_,z),this.defines=x,this.hasDefinedMatchers=Z,this.command=X,this.icon=_.icon,this.hide=_.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof d}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new d(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$KG=d;class l extends t{constructor(O,z,J,te,x,X){super(O,J,te,x,X,z),this._source=z}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new l(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$LG=l;var u;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(u||(e.ExecutionEngine=u={})),function(M){M._default=M.Terminal}(u||(e.ExecutionEngine=u={}));var v;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class I{constructor(O){this.c=new Map;for(let z=0;z<O.length;z++)this.c.set(O[z].uri.toString(),z)}compare(O,z){const J=O.getWorkspaceFolder(),te=z.getWorkspaceFolder();if(J&&te){let x=this.c.get(J.uri.toString());x=x===void 0?0:x+1;let X=this.c.get(te.uri.toString());return X=X===void 0?0:X+1,x===X?O._label.localeCompare(z._label):x-X}else return!J&&te?-1:J&&!te?1:0}}e.$MG=I;var $;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})($||(e.TaskEventKind=$={}));var f;(function(M){M.SingleRun="singleRun",M.Background="background"})(f||(e.TaskRunType=f={}));var y;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var L;(function(M){function O(ae){return{taskId:ae._id,taskName:ae.configurationProperties.name,runType:ae.configurationProperties.isBackground?"background":"singleRun",group:ae.configurationProperties.group,__task:ae}}function z(ae,_,ge){return{...O(ae),kind:"start",terminalId:_,resolvedVariables:ge}}M.start=z;function J(ae,_,ge){return{...O(ae),kind:"processStarted",terminalId:_,processId:ge}}M.processStarted=J;function te(ae,_,ge){return{...O(ae),kind:"processEnded",terminalId:_,exitCode:ge}}M.processEnded=te;function x(ae,_,ge){return{...O(ae),kind:"terminated",exitReason:ge,terminalId:_}}M.terminated=x;function X(ae,_,ge){return{...O(_),kind:ae,terminalId:ge}}M.general=X;function Z(){return{kind:"changed"}}M.changed=Z})(L||(e.TaskEvent=L={}));var T;(function(M){function O(J){const te=Object.keys(J).sort();let x="";for(const X of te){let Z=J[X];Z instanceof Object?Z=O(Z):typeof Z=="string"&&(Z=Z.replace(/,/g,",,")),x+=X+","+Z+","}return x}function z(J){const x={_key:O(J),type:J.taskType};return Object.assign(x,J),x}M.create=z})(T||(e.KeyedTaskIdentifier=T={}));var U;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(U||(e.TaskSettingId=U={}));var j;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var F;(function(M){function O(z,J){const te=p.$CG.get(z.type);if(te===void 0){const ae=P.$yn(z);return delete ae._key,T.create(ae)}const x=Object.create(null);x.type=te.taskType;const X=new Set;te.required.forEach(ae=>X.add(ae));const Z=te.properties;for(const ae of Object.keys(Z)){const _=z[ae];if(_!=null)x[ae]=_;else if(X.has(ae)){const ge=Z[ae];if(ge.default!==void 0)x[ae]=P.$yn(ge.default);else switch(ge.type){case"boolean":x[ae]=!1;break;case"number":case"integer":x[ae]=0;break;case"string":x[ae]="";break;default:J.error(D.localize(1,null,JSON.stringify(z,void 0,0),ae));return}}}return T.create(x)}M.createTaskIdentifier=O})(F||(e.TaskDefinition=F={}))}),define(ke[297],Se([1,0,14]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$87b=e.$77b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,p)=>{this.b=A,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,D.$1)(A))}then(A,p){return this.j().then(A,p)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$77b=N;class h extends N{constructor(){super(),this.h=!0,this.i=new D.$5}}e.$87b=h}),define(ke[68],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vv=e.$Uv=e.$Tv=e.$Sv=void 0;class D{static{this.count=0}constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++D.count}}e.$Sv=D;const N=[];function h(p){const b=new D(p);return N[b.nid]=b,b}e.$Tv=h;function P(p){return N[p].sid}e.$Uv=P;class A{constructor(b){this.value=b}}e.$Vv=A}),define(ke[6],Se([1,0,68]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$jL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$iL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var h;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput"})(h||(e.TabInputKind=h={}));var P;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var A;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var p;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var b;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(b||(e.CellOutputKind=b={}));var k;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var R;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class C{static{this.a=0}static mixin(m){return m._id=C.a++,m}}e.$iL=C;var w;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var E;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var S;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$jL={MainThreadAuthentication:(0,D.$Tv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$Tv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$Tv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$Tv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$Tv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$Tv)("MainThreadClipboard"),MainThreadCommands:(0,D.$Tv)("MainThreadCommands"),MainThreadComments:(0,D.$Tv)("MainThreadComments"),MainThreadConfiguration:(0,D.$Tv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$Tv)("MainThreadConsole"),MainThreadDebugService:(0,D.$Tv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$Tv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$Tv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$Tv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$Tv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$Tv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$Tv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$Tv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$Tv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$Tv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$Tv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$Tv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$Tv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$Tv)("MainThreadLanguages"),MainThreadLogger:(0,D.$Tv)("MainThreadLogger"),MainThreadMessageService:(0,D.$Tv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$Tv)("MainThreadOutputService"),MainThreadProgress:(0,D.$Tv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$Tv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$Tv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$Tv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$Tv)("MainThreadSecretState"),MainThreadStorage:(0,D.$Tv)("MainThreadStorage"),MainThreadSpeech:(0,D.$Tv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$Tv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$Tv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$Tv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$Tv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$Tv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$Tv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$Tv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$Tv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$Tv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$Tv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$Tv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$Tv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$Tv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$Tv)("MainThreadSCM"),MainThreadSearch:(0,D.$Tv)("MainThreadSearch"),MainThreadShare:(0,D.$Tv)("MainThreadShare"),MainThreadTask:(0,D.$Tv)("MainThreadTask"),MainThreadWindow:(0,D.$Tv)("MainThreadWindow"),MainThreadLabelService:(0,D.$Tv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$Tv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$Tv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$Tv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$Tv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$Tv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$Tv)("MainThreadInteractive"),MainThreadChat:(0,D.$Tv)("MainThreadChat"),MainThreadInlineChat:(0,D.$Tv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$Tv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$Tv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$Tv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$Tv)("MainThreadTimeline"),MainThreadTesting:(0,D.$Tv)("MainThreadTesting"),MainThreadLocalization:(0,D.$Tv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$Tv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$Tv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$Tv)("MainThreadIssueReporter")},e.$kL={ExtHostCommands:(0,D.$Tv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$Tv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$Tv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$Tv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$Tv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$Tv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$Tv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$Tv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$Tv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$Tv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$Tv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$Tv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$Tv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$Tv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$Tv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$Tv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$Tv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$Tv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$Tv)("ExtHostStatusBar"),ExtHostShare:(0,D.$Tv)("ExtHostShare"),ExtHostExtensionService:(0,D.$Tv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$Tv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$Tv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$Tv)("ExtHostSCM"),ExtHostSearch:(0,D.$Tv)("ExtHostSearch"),ExtHostTask:(0,D.$Tv)("ExtHostTask"),ExtHostWorkspace:(0,D.$Tv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$Tv)("ExtHostWindow"),ExtHostWebviews:(0,D.$Tv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$Tv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$Tv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$Tv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$Tv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$Tv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$Tv)("ExtHostProgress"),ExtHostComments:(0,D.$Tv)("ExtHostComments"),ExtHostSecretState:(0,D.$Tv)("ExtHostSecretState"),ExtHostStorage:(0,D.$Tv)("ExtHostStorage"),ExtHostUrls:(0,D.$Tv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$Tv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$Tv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$Tv)("ExtHostOutputService"),ExtHostLabelService:(0,D.$Tv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$Tv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$Tv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$Tv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$Tv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$Tv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$Tv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$Tv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$Tv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$Tv)("ExtHostChat"),ExtHostChatAgents2:(0,D.$Tv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$Tv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$Tv)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$Tv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$Tv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$Tv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$Tv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$Tv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$Tv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$Tv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$Tv)("ExtHostTimeline"),ExtHostTesting:(0,D.$Tv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$Tv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$Tv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$Tv)("ExtHostIssueReporter")}}),define(ke[92],Se([1,0,5,13,6,20]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=e.$3fc=e.$2fc=void 0,e.$2fc=(0,D.$8h)("IExtHostApiDeprecationService");let A=class{constructor(b,k){this.c=k,this.a=new Set,this.b=b.getProxy(h.$jL.MainThreadTelemetry)}report(b,k,R){const C=this.d(b,k);this.a.has(C)||(this.a.add(C),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${b}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:b}))}d(b,k){return`${b}-${k.identifier.value}`}};e.$3fc=A,e.$3fc=A=Ge([Ve(0,P.$oN),Ve(1,N.$pj)],A),e.$4fc=Object.freeze(new class{report(p,b,k){}})}),define(ke[298],Se([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;class N{constructor(P){const A=P.getProxy(D.$jL.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(p){return A.$writeText(p)}})}}e.$agc=N}),define(ke[299],Se([1,0,24,6,27,20]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;let A=class{constructor(R,C){this.a=R.getProxy(N.$jL.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,C){const w=this,E=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){w.e(R,C,E,arguments)}})}e(R,C,w,E){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:b(E,this.b)}),this.c&&this.f(R,w,E)}};e.$4hc=A,e.$4hc=A=Ge([Ve(0,P.$oN),Ve(1,h.$EN)],A);const p=1e5;function b(k,R){const C=[];if(k.length)for(let w=0;w<k.length;w++){let E=k[w];if(typeof E>"u")E="undefined";else if(E instanceof Error){const S=E;S.stack?E=S.stack:E=S.toString()}C.push(E)}if(R){const w=new Error().stack;w&&C.push({__$stack:w.split(`
`).slice(3).join(`
`)})}try{const w=(0,D.$Dn)(C);return w.length>p?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}),define(ke[300],Se([1,0,2,6,26]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0;class P{constructor(p){this.a=p.getProxy(N.$jL.MainThreadDialogs)}showOpenDialog(p,b){return b?.allowUIResources&&(0,h.$LF)(p,"showLocal"),this.a.$showOpenDialog(b).then(k=>k?k.map(R=>D.URI.revive(R)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then(b=>b?D.URI.revive(b):void 0)}}e.$8gc=P}),define(ke[301],Se([1,0,3,6]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=void 0;class h{constructor(A){this.b=0,this.a=A.getProxy(N.$jL.MainThreadLabelService)}$registerResourceLabelFormatter(A){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,A),(0,D.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$qhc=h}),define(ke[114],Se([1,0,11,12,2,5,13,6,27,20]),function($e,e,D,N,h,P,A,p,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=e.$Pgc=void 0;let R=class{constructor(w,E,S){this.f=S,this.d=new Map,this.a=E.getProxy(p.$jL.MainThreadLocalization),this.b=w.environment.appLanguage,this.c=this.b===D.$g}getMessage(w,E){const{message:S,args:c,comment:m}=E;if(this.c)return(0,N.$Me)(S,c??{});let a=S;m&&m.length>0&&(a+=`/${Array.isArray(m)?m.join(""):m}`);const i=this.d.get(w)?.contents[a];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,N.$Me)(i??S,c??{})}getBundle(w){return this.d.get(w)?.contents}getBundleUri(w){return this.d.get(w)?.uri}async initializeLocalizedMessages(w){if(this.c||!w.l10n&&!w.isBuiltin||this.d.has(w.identifier.value))return;let E;const S=await this.g(w);if(!S){this.f.error(`No bundle location found for extension ${w.identifier.value}`);return}try{const c=await this.a.$fetchBundleContents(S),m=JSON.parse(c);E=w.isBuiltin?m.contents?.bundle:m}catch(c){this.f.error(`Failed to load translations for ${w.identifier.value} from ${S}: ${c.message}`);return}E&&this.d.set(w.identifier.value,{contents:E,uri:S})}async g(w){if(w.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(w.identifier.value,this.b);return h.URI.revive(E)}return w.l10n?h.URI.joinPath(w.extensionLocation,w.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Pgc=R,e.$Pgc=R=Ge([Ve(0,b.$EN),Ve(1,k.$oN),Ve(2,A.$pj)],R),e.$Qgc=(0,P.$8h)("IExtHostLocalizationService")}),define(ke[145],Se([1,0,13,6,27,20,2,56]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=void 0;let b=class extends D.$Aj{constructor(C,w){super(w.logLevel,w.logsLocation,w.loggers.map(E=>(0,p.$Eh)(E))),this.r=C.getProxy(N.$jL.MainThreadLogger)}$setLogLevel(C,w){w?this.setLogLevel(A.URI.revive(w),C):this.setLogLevel(C)}setVisibility(C,w){super.setVisibility(C,w),this.r.$setVisibility(C,w)}s(C,w,E){return new k(this.r,C,w,E)}};e.$3hc=b,e.$3hc=b=Ge([Ve(0,P.$oN),Ve(1,h.$EN)],b);class k extends D.$vj{constructor(C,w,E,S){super(S?.logLevel==="always"),this.r=C,this.s=w,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(w,S).then(()=>{this.u(this.n),this.m=!0})}g(C,w){const E=[[C,w]];this.m?this.u(E):this.n.push(...E)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(ke[115],Se([1,0,6,5,3,20,21]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=e.$Rgc=void 0,e.$Rgc=(0,N.$8h)("IExtHostManagedSockets");let p=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(D.$jL.MainThreadManagedSockets)}setFactory(C,w){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new b(C,w),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const w=++this.b,E=await this.c.makeConnection(),S=new h.$Sc;return this.d.set(w,new k(w,E,S)),S.add((0,h.$Rc)(()=>this.d.delete(w))),S.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(w),S.dispose()})),S.add(E.onDidClose(c=>{this.a.$onDidManagedSocketClose(w,c?.stack??c?.message),S.dispose()})),S.add(E.onDidReceiveMessage(c=>this.a.$onDidManagedSocketHaveData(w,A.$ke.wrap(c)))),w}$remoteSocketWrite(C,w){this.d.get(C)?.actual.send(w.buffer)}$remoteSocketEnd(C){const w=this.d.get(C);w&&(w.actual.end(),w.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$Sgc=p,e.$Sgc=p=Ge([Ve(0,P.$oN)],p);class b{constructor(C,w){this.socketFactoryId=C,this.makeConnection=w}}class k extends h.$Tc{constructor(C,w,E){super(),this.socketId=C,this.actual=w,this.B(E)}}}),define(ke[302],Se([1,0,6,13,26]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=void 0;function P(p){return p&&p.title}let A=class{constructor(b,k){this.b=k,this.a=b.getProxy(D.$jL.MainThreadMessageService)}showMessage(b,k,R,C,w){const E={source:{identifier:b.identifier,label:b.displayName||b.name}};let S;typeof C=="string"||P(C)?S=[C,...w]:(E.modal=C?.modal,E.useCustom=C?.useCustom,E.detail=C?.detail,S=w),E.useCustom&&(0,h.$LF)(b,"resolvers");const c=[];let m=!1;for(let a=0;a<S.length;a++){const i=S[a];if(typeof i=="string")c.push({title:i,handle:a,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:r}=i;c.push({title:n,isCloseAffordance:!!r,handle:a}),r&&(m?this.b.warn(`[${b.identifier}] Only one message item can have 'isCloseAffordance':`,i):m=!0)}else this.b.warn(`[${b.identifier}] Invalid message item:`,i)}return this.a.$showMessage(k,R,E,c).then(a=>{if(typeof a=="number")return S[a]})}};e.$shc=A,e.$shc=A=Ge([Ve(1,N.$pj)],A)}),define(ke[303],Se([1,0,3,18,2,26,6]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=void 0;class p{constructor(k){this.b=new Map,this.a=k.getProxy(A.$jL.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,R,C){if((0,P.$LF)(k,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,C),this.a.$registerProfileContentHandler(R,C.name,C.description,k.identifier.value),(0,D.$Rc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(k,R,C,w){const E=this.b.get(k);if(!E)throw new Error(`Unknown handler with id: ${k}`);return E.saveProfile(R,C,w)}async $readProfile(k,R,C){const w=this.b.get(k);if(!w)throw new Error(`Unknown handler with id: ${k}`);return w.readProfile((0,N.$Jf)(R)?R:h.URI.revive(R),C)}}e.$Bhc=p}),define(ke[116],Se([1,0,6,4,5]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=e.$Mgc=void 0;class P{constructor(p){this.b=new N.$Wd,this.onDidChangePassword=this.b.event,this.a=p.getProxy(D.$jL.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,b){return this.a.$getPassword(p,b)}store(p,b,k){return this.a.$setPassword(p,b,k)}delete(p,b){return this.a.$deletePassword(p,b)}}e.$Mgc=P,e.$Ngc=(0,h.$8h)("IExtHostSecretState")}),define(ke[304],Se([1,0,22,3,6]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=void 0;class P{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(h.$jL.MainThreadSpeech)}async $createSpeechToTextSession(p,b){const k=this.c.get(p);if(!k)return;const R=new N.$Sc,C=new D.$7d;this.d.set(b,C);const w=R.add(k.provideSpeechToTextSession(C.token));R.add(w.onDidChange(E=>{C.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(b,E)})),R.add(C.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createKeywordRecognitionSession(p,b){const k=this.c.get(p);if(!k)return;const R=new N.$Sc,C=new D.$7d;this.d.set(b,C);const w=R.add(k.provideKeywordRecognitionSession(C.token));R.add(w.onDidChange(E=>{C.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(b,E)})),R.add(C.token.onCancellationRequested(()=>R.dispose()))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,b,k){const R=P.a++;return this.c.set(R,k),this.b.$registerProvider(R,b,{extension:p,displayName:p.value}),(0,N.$Rc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$Ihc=P}),define(ke[117],Se([1,0,6,4,5]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=e.$Egc=void 0;class P{constructor(p,b){this.c=b,this.b=new N.$Wd,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(D.$jL.MainThreadStorage)}registerExtensionStorageKeysToSync(p,b){this.a.$registerExtensionStorageKeysToSync(p,b)}async initializeExtensionStorage(p,b,k){const R=await this.a.$initializeExtensionStorage(p,b);let C;return R&&(C=this.d(p,b,R)),C||k}setValue(p,b,k){return this.a.$setValue(p,b,k)}$acceptValue(p,b,k){const R=this.d(p,b,k);R&&this.b.fire({shared:p,key:b,value:R})}d(p,b,k){try{return JSON.parse(k)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${b}, global: ${p}): ${R}`)}}}e.$Egc=P,e.$Fgc=(0,h.$8h)("IExtHostStorage")}),define(ke[305],Se([1,0,3,16,2,6]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;class A{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor(b){this.c=new Map,this.b=b.getProxy(P.$jL.MainThreadUriOpeners)}registerExternalUriOpener(b,k,R,C){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const w=C.schemes.find(E=>!A.a.has(E));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this.c.set(k,R),this.b.$registerUriOpener(k,C.schemes,b,C.label),(0,D.$Rc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(b,k,R){const C=this.c.get(b);if(!C)throw new Error(`Unknown opener with id: ${b}`);const w=h.URI.revive(k);return C.canOpenExternalUri(w,R)}async $openUri(b,k,R){const C=this.c.get(b);if(!C)throw new Error(`Unknown opener id: '${b}'`);return C.openExternalUri(h.URI.revive(k.resolvedUri),{sourceUri:h.URI.revive(k.sourceUri)},R)}}e.$Whc=A}),define(ke[306],Se([1,0,6,2,3,14,25]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;class p{static{this.a=0}constructor(k){this.c=new A.$om,this.d=new Map,this.b=k.getProxy(D.$jL.MainThreadUrls)}registerUriHandler(k,R){const C=k.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const w=p.a++;return this.c.add(C),this.d.set(w,R),this.b.$registerUriHandler(w,C,k.displayName||k.name),(0,h.$Rc)(()=>{this.c.delete(C),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(k,R){const C=this.d.get(k);if(!C)return Promise.resolve(void 0);try{C.handleUri(N.URI.revive(R))}catch(w){(0,P.$1)(w)}return Promise.resolve(void 0)}async createAppUri(k){return N.URI.revive(await this.b.$createAppUri(k))}}e.$Xhc=p}),define(ke[93],Se([1,0,4,3,16,24,2,237,274,112,6]),function($e,e,D,N,h,P,A,p,b,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=e.$sgc=e.$rgc=e.$qgc=e.$pgc=void 0;class C{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,s,t,g,o,d,l){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new D.$Wd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Wd,this._onDidDispose=this.#h.event,this.#e=r,this.#t=s,this.#o=t,this.#n=g,this.#s=o,this.#r=d,this.#l=w(d),this.#d=E(d),this.#i=l}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,k.$kwb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===h.Schemas.https||r.scheme===h.Schemas.http){let s=r.toString();return s.endsWith("/")||(s+="/"),s+" "+k.$jwb}return k.$jwb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),P.$Cn(this.#o,r)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const s=(0,b.$Dlb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,s.message,...s.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const s=this.#r.extensionLocation?.scheme===h.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===h.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,o,d,l,u,v)=>{const I=A.URI.from({scheme:l||"file",path:decodeURIComponent(u)}),$=(0,k.$kwb)(I,{isRemote:s,authority:t}).toString();return`${o}${$}${v}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,o,d,l,u,v)=>{const I=A.URI.from({scheme:l||"file",path:decodeURIComponent(u)}),$=(0,k.$kwb)(I,{isRemote:s,authority:t}).toString();return`${o}${$}${v}`})}}e.$pgc=C;function w(n){try{const r=(0,p.$ep)((0,p.$dp)(n.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}e.$qgc=w;function E(n){try{const r=(0,p.$ep)((0,p.$dp)(n.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class S extends N.$Tc{constructor(r,s,t,g,o){super(),this.c=s,this.f=t,this.g=g,this.h=o,this.b=new Map,this.a=r.getProxy(R.$jL.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,s,t){const g=this.j(r);if(g){const{message:o}=(0,b.$Elb)(s,t.value);g._onMessageEmitter.fire(o)}}$onMissingCsp(r,s){this.g.warn(`${s} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,s,t){const g=new C(r,this.a,a(s),this.c,this.f,t,this.h);this.b.set(r,g);const o=g._onDidDispose(()=>{o.dispose(),this.deleteWebview(r)});return g}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$rgc=S;function c(n){return{id:n.identifier,location:n.extensionLocation}}e.$sgc=c;function m(n,r,s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots||i(n,r)}}e.$tgc=m;function a(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(r=>A.URI.from(r))}}function i(n,r){return[...(r?.getWorkspaceFolders()||[]).map(s=>s.uri),n.extensionLocation]}}),define(ke[146],Se([1,0,4,6,2,16,12,5,20,26]),function($e,e,D,N,h,P,A,p,b,k){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=e.$Zhc=void 0;let C=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(E){const S=this.d;return{get focused(){return S.focused},get active(){return(0,k.$LF)(E,"windowActivity"),S.active}}}constructor(E){this.c=new D.$Wd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=E.getProxy(N.$jL.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:c})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",c)})}$onDidChangeWindowFocus(E){this.onDidChangeWindowProperty("focused",E)}$onDidChangeWindowActive(E){this.onDidChangeWindowProperty("active",E)}onDidChangeWindowProperty(E,S){S!==this.d[E]&&(this.d={...this.d,[E]:S},this.c.fire(this.d))}openUri(E,S){let c;if(typeof E=="string"){c=E;try{E=h.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,A.$Ke)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this.b.$openUri(E,c,S)}async asExternalUri(E,S){if((0,A.$Ke)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const c=await this.b.$asExternalUri(E,S);return h.URI.from(c)}};e.$Zhc=C,e.$Zhc=C=R=Ge([Ve(0,b.$oN)],C),e.$1hc=(0,p.$8h)("IExtHostWindow")}),define(ke[307],Se([1,0,299,27,20]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=void 0;const P=1024*1024;let A=class extends D.$4hc{constructor(b,k){super(b,k),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(b,k,R){const C=b==="error"||b==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),k.apply(console,R),C.write(`
END_NATIVE_LOG
`),this.g=!1}j(b,k){const R=process[b],C=R.write;let w="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(E,S,c)=>{if(!this.g){w+=E.toString(S);const m=w.length>P?w.length:w.lastIndexOf(`
`);m!==-1&&(console[k](w.slice(0,m)),w=w.slice(m+1))}C.call(R,E,S,c)}})}};e.$Cic=A,e.$Cic=A=Ge([Ve(0,h.$oN),Ve(1,N.$EN)],A)}),define(ke[308],Se([1,0,145,16,251,30]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oic=void 0;class A extends D.$3hc{s(b,k,R){return b.scheme===N.Schemas.file?new h.$AO(R?.name||(0,P.$rg)(),b.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,k):super.s(b,k,R)}registerLogger(b){super.registerLogger(b),this.r.$registerLogger(b)}deregisterLogger(b){super.deregisterLogger(b),this.r.$deregisterLogger(b)}}e.$Oic=A}),define(ke[309],Se([1,0,8,21,22,14,4,3,130,297,68]),function($e,e,D,N,h,P,A,p,b,k,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$$7b=e.ResponsiveState=e.RequestInitiator=e.$07b=e.$97b=void 0;function w(y,L){try{return JSON.stringify(y,L)}catch{return"null"}}const E="$$ref$$",S={[E]:-1};class c{constructor(L,T){this.jsonString=L,this.referencedBuffers=T}}function m(y,L=null,T=!1){const U=[];return{jsonString:(T?w:JSON.stringify)(y,(F,M)=>{if(typeof M>"u")return S;if(typeof M=="object"){if(M instanceof N.$ke){const O=U.push(M)-1;return{[E]:O}}if(L)return L(F,M)}return M}),referencedBuffers:U}}e.$97b=m;function a(y,L,T){return JSON.parse(y,(U,j)=>{if(j){const F=j[E];if(typeof F=="number")return L[F];if(T&&j.$mid===1)return T.transformIncoming(j)}return j})}e.$07b=a;function i(y,L){return JSON.stringify(y,L)}function n(y){return y?(L,T)=>T&&T.$mid===1?y.transformOutgoing(T):T:null}var r;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var s;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const t=()=>{},g=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class d extends p.$Tc{static{C=g}static{this.a=3*1e3}constructor(L,T=null,U=null){super(),this[C]=!0,this.b=this.B(new A.$Wd),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=T,this.g=U,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,F=R.$Sv.count;j<F;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$hh(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(L=>{const T=this.w[L];delete this.w[L],T.resolveErr(P.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(L){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(L){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(L){this.y!==L&&(this.y=L,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(L){return this.g?(0,b.$0m)(L,this.g):L}getProxy(L){const{nid:T,sid:U}=L;return this.s[T]||(this.s[T]=this.J(T,U)),this.s[T]}J(L,T){const U={get:(j,F)=>(typeof F=="string"&&!j[F]&&F.charCodeAt(0)===36&&(j[F]=(...M)=>this.U(L,F,M)),F===o?T:j[F])};return new Proxy(Object.create(null),U)}set(L,T){return this.m[L.nid]=T,T}assertRegistered(L){for(let T=0,U=L.length;T<U;T++){const j=L[T];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(L){if(this.j)return;const T=L.byteLength,U=u.read(L,0),j=U.readUInt8(),F=U.readUInt32();switch(j){case 1:case 2:{let{rpcId:M,method:O,args:z}=I.deserializeRequestJSONArgs(U);this.g&&(z=(0,b.$0m)(z,this.g)),this.M(T,F,M,O,z,j===2);break}case 3:case 4:{let{rpcId:M,method:O,args:z}=I.deserializeRequestMixedArgs(U);this.g&&(z=(0,b.$0m)(z,this.g)),this.M(T,F,M,O,z,j===4);break}case 5:{this.f?.logIncoming(T,F,0,"ack"),this.G(F);break}case 6:{this.N(T,F);break}case 7:{this.O(T,F,void 0);break}case 9:{let M=I.deserializeReplyOKJSON(U);this.g&&(M=(0,b.$0m)(M,this.g)),this.O(T,F,M);break}case 10:{const M=I.deserializeReplyOKJSONWithBuffers(U,this.g);this.O(T,F,M);break}case 8:{const M=I.deserializeReplyOKVSBuffer(U);this.O(T,F,M);break}case 11:{let M=I.deserializeReplyErrError(U);this.g&&(M=(0,b.$0m)(M,this.g)),this.P(T,F,M);break}case 12:{this.P(T,F,void 0);break}default:console.error("received unexpected message"),console.error(L)}}M(L,T,U,j,F,M){this.f?.logIncoming(L,T,1,`receiveRequest ${(0,R.$Uv)(U)}.${j}(`,F);const O=String(T);let z,J;if(M){const x=new h.$7d;F.push(x.token),z=this.Q(U,j,F),J=()=>x.cancel()}else z=this.Q(U,j,F),J=t;this.u[O]=J;const te=I.serializeAcknowledged(T);this.f?.logOutgoing(te.byteLength,T,1,"ack"),this.c.send(te),z.then(x=>{delete this.u[O];const X=I.serializeReplyOK(T,x,this.h);this.f?.logOutgoing(X.byteLength,T,1,"reply:",x),this.c.send(X)},x=>{delete this.u[O];const X=I.serializeReplyErr(T,x);this.f?.logOutgoing(X.byteLength,T,1,"replyErr:",x),this.c.send(X)})}N(L,T){this.f?.logIncoming(L,T,1,"receiveCancel");const U=String(T);this.u[U]?.()}O(L,T,U){this.f?.logIncoming(L,T,0,"receiveReply:",U);const j=String(T);if(!this.w.hasOwnProperty(j))return;const F=this.w[j];delete this.w[j],F.resolveOk(U)}P(L,T,U){this.f?.logIncoming(L,T,0,"receiveReplyErr:",U);const j=String(T);if(!this.w.hasOwnProperty(j))return;const F=this.w[j];delete this.w[j];let M;U&&(U.$isError?(M=new Error,M.name=U.name,M.message=U.message,M.stack=U.stack):M=U),F.resolveErr(M)}Q(L,T,U){try{return Promise.resolve(this.S(L,T,U))}catch(j){return Promise.reject(j)}}S(L,T,U){const j=this.m[L];if(!j)throw new Error("Unknown actor "+(0,R.$Uv)(L));const F=j[T];if(typeof F!="function")throw new Error("Unknown method "+T+" on actor "+(0,R.$Uv)(L));return F.apply(j,U)}U(L,T,U){if(this.j)return new k.$87b;let j=null;if(U.length>0&&h.CancellationToken.isCancellationToken(U[U.length-1])&&(j=U.pop()),j&&j.isCancellationRequested)return Promise.reject(P.$6());const F=I.serializeRequestArguments(U,this.h),M=++this.t,O=String(M),z=new k.$77b,J=new p.$Sc;j&&J.add(j.onCancellationRequested(()=>{const x=I.serializeCancel(M);this.f?.logOutgoing(x.byteLength,M,0,"cancel"),this.c.send(I.serializeCancel(M))})),this.w[O]=new l(z,J),this.F(M);const te=I.serializeRequest(M,L,T,F,!!j);return this.f?.logOutgoing(te.byteLength,M,0,`request: ${(0,R.$Uv)(L)}.${T}(`,U),this.c.send(te),z}}e.$$7b=d;class l{constructor(L,T){this.a=L,this.b=T}resolveOk(L){this.a.resolveOk(L),this.b.dispose()}resolveErr(L){this.a.resolveErr(L),this.b.dispose()}}class u{static alloc(L,T,U){const j=new u(N.$ke.alloc(U+1+4),0);return j.writeUInt8(L),j.writeUInt32(T),j}static read(L,T){return new u(L,T)}get buffer(){return this.a}constructor(L,T){this.a=L,this.b=T}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const U=this.a.slice(this.b,this.b+L).toString();return this.b+=L,U}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+L).toString();return this.b+=L,U}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const T=this.a.slice(this.b,this.b+L);return this.b+=L,T}static sizeMixedArray(L){let T=0;T+=1;for(let U=0,j=L.length;U<j;U++){const F=L[U];switch(T+=1,F.type){case 1:T+=this.sizeLongString(F.value);break;case 2:T+=this.sizeVSBuffer(F.value);break;case 3:T+=this.sizeUInt32,T+=this.sizeLongString(F.value);for(let M=0;M<F.buffers.length;++M)T+=this.sizeVSBuffer(F.buffers[M]);break;case 4:break}}return T}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let T=0,U=L.length;T<U;T++){const j=L[T];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let F=0;F<j.buffers.length;++F)this.writeBuffer(j.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const T=new Array(L);for(let U=0;U<L;U++)switch(this.readUInt8()){case 1:T[U]=this.readLongString();break;case 2:T[U]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),M=this.readLongString(),O=[];for(let z=0;z<F;++z)O.push(this.readVSBuffer());T[U]=new R.$Vv(a(M,O,null));break}case 4:T[U]=void 0;break}return T}}var v;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(v||(v={}));class I{static a(L){for(let T=0,U=L.length;T<U;T++)if(L[T]instanceof N.$ke||L[T]instanceof R.$Vv||typeof L[T]>"u")return!0;return!1}static serializeRequestArguments(L,T){if(this.a(L)){const U=[];for(let j=0,F=L.length;j<F;j++){const M=L[j];if(M instanceof N.$ke)U[j]={type:2,value:M};else if(typeof M>"u")U[j]={type:4};else if(M instanceof R.$Vv){const{jsonString:O,referencedBuffers:z}=m(M.value,T);U[j]={type:3,value:N.$ke.fromString(O),buffers:z}}else U[j]={type:1,value:N.$ke.fromString(i(M,T))}}return{type:1,args:U}}return{type:0,args:i(L,T)}}static serializeRequest(L,T,U,j,F){switch(j.type){case 0:return this.b(L,T,U,j.args,F);case 1:return this.c(L,T,U,j.args,F)}}static b(L,T,U,j,F){const M=N.$ke.fromString(U),O=N.$ke.fromString(j);let z=0;z+=u.sizeUInt8(),z+=u.sizeShortString(M),z+=u.sizeLongString(O);const J=u.alloc(F?2:1,L,z);return J.writeUInt8(T),J.writeShortString(M),J.writeLongString(O),J.buffer}static deserializeRequestJSONArgs(L){const T=L.readUInt8(),U=L.readShortString(),j=L.readLongString();return{rpcId:T,method:U,args:JSON.parse(j)}}static c(L,T,U,j,F){const M=N.$ke.fromString(U);let O=0;O+=u.sizeUInt8(),O+=u.sizeShortString(M),O+=u.sizeMixedArray(j);const z=u.alloc(F?4:3,L,O);return z.writeUInt8(T),z.writeShortString(M),z.writeMixedArray(j),z.buffer}static deserializeRequestMixedArgs(L){const T=L.readUInt8(),U=L.readShortString(),j=L.readMixedArray(),F=new Array(j.length);for(let M=0,O=j.length;M<O;M++){const z=j[M];typeof z=="string"?F[M]=JSON.parse(z):F[M]=z}return{rpcId:T,method:U,args:F}}static serializeAcknowledged(L){return u.alloc(5,L,0).buffer}static serializeCancel(L){return u.alloc(6,L,0).buffer}static serializeReplyOK(L,T,U){if(typeof T>"u")return this.d(L);if(T instanceof N.$ke)return this.e(L,T);if(T instanceof R.$Vv){const{jsonString:j,referencedBuffers:F}=m(T.value,U,!0);return this.g(L,j,F)}else return this.f(L,w(T,U))}static d(L){return u.alloc(7,L,0).buffer}static e(L,T){let U=0;U+=u.sizeVSBuffer(T);const j=u.alloc(8,L,U);return j.writeVSBuffer(T),j.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,T){const U=N.$ke.fromString(T);let j=0;j+=u.sizeLongString(U);const F=u.alloc(9,L,j);return F.writeLongString(U),F.buffer}static g(L,T,U){const j=N.$ke.fromString(T);let F=0;F+=u.sizeUInt32,F+=u.sizeLongString(j);for(const O of U)F+=u.sizeVSBuffer(O);const M=u.alloc(10,L,F);M.writeUInt32(U.length),M.writeLongString(j);for(const O of U)M.writeBuffer(O);return M.buffer}static deserializeReplyOKJSON(L){const T=L.readLongString();return JSON.parse(T)}static deserializeReplyOKJSONWithBuffers(L,T){const U=L.readUInt32(),j=L.readLongString(),F=[];for(let M=0;M<U;++M)F.push(L.readVSBuffer());return new R.$Vv(a(j,F,T))}static serializeReplyErr(L,T){const U=T?w(P.$3(T),null):void 0;if(typeof U!="string")return this.h(L);const j=N.$ke.fromString(U);let F=0;F+=u.sizeLongString(j);const M=u.alloc(11,L,F);return M.writeLongString(j),M.buffer}static deserializeReplyErrError(L){const T=L.readLongString();return JSON.parse(T)}static h(L){return u.alloc(12,L,0).buffer}}var $;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var f;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(f||(f={}))}),define(ke[310],Se([1,0,21,28,16,84,5]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9I=e.$8I=e.$7I=e.$6I=void 0,e.$6I=(0,A.$8h)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],b=new RegExp(`^[${p.join("")}]+`),k=7;function R(E){if(E.scheme!==h.Schemas.vscodeNotebookCell)return;const S=E.fragment.indexOf("s");if(S<0)return;const c=parseInt(E.fragment.substring(0,S).replace(b,""),k),m=(0,D.$De)(E.fragment.substring(S+1)).toString();if(!isNaN(c))return{handle:c,notebook:E.with({scheme:m,fragment:null})}}e.$7I=R;function C(E,S){const c=S.toString(k),a=`${c.length<p.length?p[c.length-1]:"z"}${c}s${(0,D.$Ee)(D.$ke.fromString(E.scheme),!0,!0)}`;return E.with({scheme:h.Schemas.vscodeNotebookCell,fragment:a})}e.$8I=C;class w{constructor(){this.a=new N.$Ac}getNotebook(S){if(S.scheme===h.Schemas.vscodeNotebookCell){const c=R(S);if(c){const m=this.a.get(c.notebook);if(m)return m}}return this.a.get(S)}addNotebookDocument(S){this.a.set(S.uri,S)}removeNotebookDocument(S){this.a.delete(S.uri)}}e.$9I=w,(0,P.$1r)(e.$6I,w,1)}),define(ke[118],Se([1,0,21,35,53,101,16,17,11,45,310]),function($e,e,D,N,h,P,A,p,b,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.CellStatusbarAlignment=e.$kJ=e.$jJ=e.$iJ=e.NotebookEditorPriority=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.CellKind=e.$_I=e.$$I=e.$0I=void 0,e.$0I="workbench.editor.notebook",e.$$I="workbench.editor.notebookTextDiffEditor",e.$_I="workbench.editor.interactive";var C;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(C||(e.CellKind=C={})),e.$aJ=["application/json","application/javascript","text/html","image/svg+xml",P.$hs.latex,P.$hs.markdown,"image/png","image/jpeg",P.$hs.text],e.$bJ=[P.$hs.latex,P.$hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",P.$hs.text],e.$cJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$dJ="_notAvailable";var w;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(w||(e.NotebookRunState=w={}));var E;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var S;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var c;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var m;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var a;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var i;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var r;(function(z){z.scheme=A.Schemas.vscodeNotebookCell;function J(_,ge){return(0,R.$8I)(_,ge)}z.generate=J;function te(_){return(0,R.$7I)(_)}z.parse=te;function x(_,ge){return _.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ge??""},${_.scheme!==A.Schemas.file?_.scheme:""}`})}z.generateCellOutputUri=x;function X(_){if(_.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ge=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(_.fragment);if(!ge)return;const ne=ge[1]&&ge[1]!==""?ge[1]:void 0,K=ge[2];return{outputId:ne,notebook:_.with({scheme:K||A.Schemas.file,fragment:null})}}z.parseCellOutputUri=X;function Z(_,ge,ne){return z.generate(_,ge).with({scheme:ne})}z.generateCellPropertyUri=Z;function ae(_,ge){if(_.scheme===ge)return z.parse(_.with({scheme:z.scheme}))}z.parseCellPropertyUri=ae})(r||(e.CellUri=r={}));const s=z=>b.$i?z.replace(/\//g,"\\"):z;class t{constructor(J=[],te=e.$aJ){this.e=te,this.d=[...new Set(J)].map(x=>({pattern:x,matches:N.$Oj(s(x))}))}sort(J){const te=new Map(h.Iterable.map(J,X=>[X,s(X)]));let x=[];for(const{matches:X}of this.d)for(const[Z,ae]of te)if(X(ae)){x.push(Z),te.delete(Z);break}return te.size&&(x=x.concat([...te.keys()].sort((X,Z)=>this.e.indexOf(X)-this.e.indexOf(Z)))),x}prioritize(J,te){const x=this.f(J);if(x===-1){this.d.unshift({pattern:J,matches:N.$Oj(s(J))});return}const X=new Set(te.map(ae=>this.f(ae,x)));X.delete(-1);const Z=Array.from(X).sort();this.d.splice(x+1,0,...Z.map(ae=>this.d[ae]));for(let ae=Z.length-1;ae>=0;ae--)this.d.splice(Z[ae],1)}toArray(){return this.d.map(J=>J.pattern)}f(J,te=this.d.length){const x=s(J);for(let X=0;X<te;X++)if(this.d[X].matches(x))return X;return-1}}e.$eJ=t;function g(z,J,te,x=(X,Z)=>X===Z){const X=[];function Z(ge,ne,K){if(ne===0&&K.length===0)return;const W=X[X.length-1];W&&W.start+W.deleteCount===ge?(W.deleteCount+=ne,W.toInsert.push(...K)):X.push({start:ge,deleteCount:ne,toInsert:K})}let ae=0,_=0;for(;;){if(ae===z.length){Z(ae,0,J.slice(_));break}if(_===J.length){Z(ae,z.length-ae,[]);break}const ge=z[ae],ne=J[_];if(x(ge,ne)){ae+=1,_+=1;continue}te(ne)?(Z(ae,1,[]),ae+=1):(Z(ae,0,[ne]),_+=1)}return X}e.$fJ=g,e.$gJ=new k.$mj("notebookEditorCursorAtBoundary","none"),e.$hJ=new k.$mj("notebookEditorCursorAtLineBoundary","none");var o;(function(z){z.default="default",z.option="option"})(o||(e.NotebookEditorPriority=o={}));function d(z){const J=z;return!!((typeof J.include=="string"||N.$Pj(J.include))&&(typeof J.exclude=="string"||N.$Pj(J.exclude)))}e.$iJ=d;function l(z,J,te){if(Array.isArray(z.viewType)&&z.viewType.indexOf(J)>=0||z.viewType===J)return!0;if(z.filenamePattern){const x=d(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,X=d(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(N.$Nj(x,(0,p.$nc)(te.fsPath).toLowerCase()))return!(X&&N.$Nj(X,(0,p.$nc)(te.fsPath).toLowerCase()))}return!1}e.$jJ=l,e.$kJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var u;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(u||(e.CellStatusbarAlignment=u={}));class v{static{this.d="notebook/"}static create(J){return`${v.d}${J}`}static parse(J){if(J.startsWith(v.d))return J.substring(v.d.length)}}e.$lJ=v;function I(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.$mJ=I;const $=new TextDecoder;function f(z){const J=[];let te=!1;for(const ae of z)(J.length===0||te)&&(J.push(ae),te=!0);let x=T(J);const X=D.$ke.concat(J.map(ae=>D.$ke.wrap(ae))),Z=O(X);return x=x||Z.byteLength!==X.byteLength,{data:Z,didCompression:x}}e.$nJ=f,e.$oJ=`${String.fromCharCode(27)}[A`;const y=e.$oJ.split("").map(z=>z.charCodeAt(0)),L=10;function T(z){let J=!1;return z.forEach((te,x)=>{if(x===0||te.length<e.$oJ.length)return;const X=z[x-1],Z=te.subarray(0,e.$oJ.length);if(Z[0]===y[0]&&Z[1]===y[1]&&Z[2]===y[2]){const ae=X.lastIndexOf(L);if(ae===-1)return;J=!0,z[x-1]=X.subarray(0,ae),z[x]=te.subarray(e.$oJ.length)}}),J}function U(z){let J=z;do z=J,J=z.replace(/[^\n]\x08/gm,"");while(J.length<z.length);return z}function j(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const J=z.match(/^(.*)\r+/m)[1];let te=z.match(/\r+(.*)$/m)[1];te=te+J.slice(te.length,J.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,te)}return z}const F="\b".charCodeAt(0),M="\r".charCodeAt(0);function O(z){return!z.buffer.includes(F)&&!z.buffer.includes(M)?z:D.$ke.fromString(j(U($.decode(z.buffer))))}}),define(ke[7],Se([1,0,19,14,80,28,101,12,18,2,30,25,32,64,118]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S){"use strict";var c,m,a,i,n,r,s,t,g,o,d,l,u,v,I,$,f;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$dN=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$cN=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.TestRunProfileKind=e.TestResultState=e.$UM=e.$TM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$SM=e.NotebookVariablesRequestKind=e.$RM=e.$QM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$PM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.ColorThemeKind=e.$JM=e.$IM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$HM=e.$GM=e.DebugConsoleMode=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$AM=e.$zM=e.FileChangeType=e.$yM=e.$xM=e.$wM=e.$vM=e.InlineCompletionTriggerKind=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.ConfigurationTarget=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$$L=e.ViewBadge=e.ProgressLocation=e.$0L=e.$9L=e.TaskScope=e.ShellQuoting=e.$8L=e.$7L=e.$6L=e.TaskPanelKind=e.TaskRevealKind=e.$5L=e.TerminalLocation=e.$4L=e.$3L=e.$2L=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$1L=e.$ZL=e.$YL=e.$XL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$WL=e.StatusBarAlignment=e.ViewColumn=e.$VL=e.$UL=e.$TL=e.$SL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$RL=e.$QL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.LanguageStatusSeverity=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.CodeActionTriggerKind=e.$EL=e.$DL=e.SymbolTag=e.SymbolKind=e.$CL=e.$BL=e.DocumentHighlightKind=e.$AL=e.$zL=e.$yL=e.$xL=e.DiagnosticSeverity=e.DiagnosticTag=e.$wL=e.$vL=e.FileEditType=e.$uL=e.$tL=e.$sL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function y(G){return Object.assign(G,{apply:function(...pe){if(pe.length===0)return Reflect.construct(G,[]);{const Ne=pe.length===1?[]:pe[1];return Reflect.construct(G,Ne,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(G,[]);{const[Ne,...Xe]=pe;return Reflect.construct(G,Xe,Ne.constructor)}}})}var L;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(L||(e.TerminalOutputAnchor=L={}));var T;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(T||(e.TerminalQuickFixType=T={}));let U=c=class{static from(...q){let pe=q;return new c(function(){if(pe){for(const Ne of pe)Ne&&typeof Ne.dispose=="function"&&Ne.dispose();pe=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$lL=U,e.$lL=U=c=Ge([y],U);let j=m=class{static Min(...q){if(q.length===0)throw new TypeError;let pe=q[0];for(let Ne=1;Ne<q.length;Ne++){const Xe=q[Ne];Xe.isBefore(pe)&&(pe=Xe)}return pe}static Max(...q){if(q.length===0)throw new TypeError;let pe=q[0];for(let Ne=1;Ne<q.length;Ne++){const Xe=q[Ne];Xe.isAfter(pe)&&(pe=Xe)}return pe}static isPosition(q){if(!q)return!1;if(q instanceof m)return!0;const{line:pe,character:Ne}=q;return typeof pe=="number"&&typeof Ne=="number"}static of(q){if(q instanceof m)return q;if(this.isPosition(q))return new m(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,pe){if(q<0)throw(0,N.$7)("line must be non-negative");if(pe<0)throw(0,N.$7)("character must be non-negative");this.c=q,this.e=pe}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,pe=0){if(q===null||pe===null)throw(0,N.$7)();let Ne;return typeof q>"u"?Ne=0:typeof q=="number"?Ne=q:(Ne=typeof q.lineDelta=="number"?q.lineDelta:0,pe=typeof q.characterDelta=="number"?q.characterDelta:0),Ne===0&&pe===0?this:new m(this.line+Ne,this.character+pe)}with(q,pe=this.character){if(q===null||pe===null)throw(0,N.$7)();let Ne;return typeof q>"u"?Ne=this.line:typeof q=="number"?Ne=q:(Ne=typeof q.line=="number"?q.line:this.line,pe=typeof q.character=="number"?q.character:this.character),Ne===this.line&&pe===this.character?this:new m(Ne,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$mL=j,e.$mL=j=m=Ge([y],j);let F=a=class{static isRange(q){return q instanceof a?!0:q?j.isPosition(q.start)&&j.isPosition(q.end):!1}static of(q){if(q instanceof a)return q;if(this.isRange(q))return new a(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,pe,Ne,Xe){let tt,lt;if(typeof q=="number"&&typeof pe=="number"&&typeof Ne=="number"&&typeof Xe=="number"?(tt=new j(q,pe),lt=new j(Ne,Xe)):j.isPosition(q)&&j.isPosition(pe)&&(tt=j.of(q),lt=j.of(pe)),!tt||!lt)throw new Error("Invalid arguments");tt.isBefore(lt)?(this.c=tt,this.e=lt):(this.c=lt,this.e=tt)}contains(q){return a.isRange(q)?this.contains(q.start)&&this.contains(q.end):j.isPosition(q)?!(j.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const pe=j.Max(q.start,this.c),Ne=j.Min(q.end,this.e);if(!pe.isAfter(Ne))return new a(pe,Ne)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const pe=j.Min(q.start,this.c),Ne=j.Max(q.end,this.end);return new a(pe,Ne)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,pe=this.end){if(q===null||pe===null)throw(0,N.$7)();let Ne;return q?j.isPosition(q)?Ne=q:(Ne=q.start||this.start,pe=q.end||this.end):Ne=this.start,Ne.isEqual(this.c)&&pe.isEqual(this.end)?this:new a(Ne,pe)}toJSON(){return[this.start,this.end]}};e.$nL=F,e.$nL=F=a=Ge([y],F);let M=i=class extends F{static isSelection(q){return q instanceof i?!0:q?F.isRange(q)&&j.isPosition(q.anchor)&&j.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,pe,Ne,Xe){let tt,lt;if(typeof q=="number"&&typeof pe=="number"&&typeof Ne=="number"&&typeof Xe=="number"?(tt=new j(q,pe),lt=new j(Ne,Xe)):j.isPosition(q)&&j.isPosition(pe)&&(tt=j.of(q),lt=j.of(pe)),!tt||!lt)throw new Error("Invalid arguments");super(tt,lt),this.f=tt,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$oL=M,e.$oL=M=i=Ge([y],M);const O=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,N.$7)("connectionToken")};class z{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,pe,Ne){if(typeof q!="string"||q.length===0)throw(0,N.$7)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,N.$7)("port");typeof Ne<"u"&&O(Ne),this.host=q,this.port=Math.round(pe),this.connectionToken=Ne}}e.$pL=z;class J{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,pe){this.makeConnection=q,this.connectionToken=pe,typeof pe<"u"&&O(pe)}}e.$qL=J;class te extends Error{static NotAvailable(q,pe){return new te(q,E.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(q){return new te(q,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,pe=E.RemoteAuthorityResolverErrorCode.Unknown,Ne){super(q),this._message=q,this._code=pe,this._detail=Ne,Object.setPrototypeOf(this,te.prototype)}}e.$rL=te;var x;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(x||(e.EndOfLine=x={}));var X;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(X||(e.EnvironmentVariableMutatorType=X={}));let Z=n=class{static isTextEdit(q){return q instanceof n?!0:q?F.isRange(q)&&typeof q.newText=="string":!1}static replace(q,pe){return new n(q,pe)}static insert(q,pe){return n.replace(new F(q,q),pe)}static delete(q){return n.replace(q,"")}static setEndOfLine(q){const pe=new n(new F(new j(0,0),new j(0,0)),"");return pe.newEol=q,pe}get range(){return this.c}set range(q){if(q&&!F.isRange(q))throw(0,N.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,N.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,N.$7)("newEol");this.f=q}constructor(q,pe){this.c=q,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$sL=Z,e.$sL=Z=n=Ge([y],Z);let ae=r=class{static isNotebookCellEdit(q){return q instanceof r?!0:q?ni.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,pe){return new r(q,pe)}static insertCells(q,pe){return new r(new ni(q,q),pe)}static deleteCells(q){return new r(q,[])}static updateCellMetadata(q,pe){const Ne=new r(new ni(q,q),[]);return Ne.newCellMetadata=pe,Ne}static updateNotebookMetadata(q){const pe=new r(new ni(0,0),[]);return pe.newNotebookMetadata=q,pe}constructor(q,pe){this.range=q,this.newCells=pe}};e.$tL=ae,e.$tL=ae=r=Ge([y],ae);class _{static isSnippetTextEdit(q){return q instanceof _?!0:q?F.isRange(q.range)&&K.isSnippetString(q.snippet):!1}static replace(q,pe){return new _(q,pe)}static insert(q,pe){return _.replace(new F(q,q),pe)}constructor(q,pe){this.range=q,this.snippet=pe}}e.$uL=_;var ge;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(ge||(e.FileEditType=ge={}));let ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,pe,Ne,Xe){this.c.push({_type:1,from:q,to:pe,options:Ne,metadata:Xe})}createFile(q,pe,Ne){this.c.push({_type:1,from:void 0,to:q,options:pe,metadata:Ne})}deleteFile(q,pe,Ne){this.c.push({_type:1,from:q,to:void 0,options:pe,metadata:Ne})}e(q,pe,Ne){this.c.push({_type:3,metadata:Ne,uri:q,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(q,pe,Ne,Xe){const tt=pe.start,lt=pe.end;(tt!==lt||Ne.length>0)&&this.c.push({_type:5,uri:q,index:tt,count:lt-tt,cells:Ne,metadata:Xe})}g(q,pe,Ne,Xe){this.c.push({_type:3,metadata:Xe,uri:q,edit:{editType:3,index:pe,metadata:Ne}})}replace(q,pe,Ne,Xe){this.c.push({_type:2,uri:q,edit:new Z(pe,Ne),metadata:Xe})}insert(q,pe,Ne,Xe){this.replace(q,new F(pe,pe),Ne,Xe)}delete(q,pe,Ne){this.replace(q,pe,"",Ne)}has(q){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===q.toString())}set(q,pe){if(pe)for(const Ne of pe){if(!Ne)continue;let Xe,tt;Array.isArray(Ne)?(Xe=Ne[0],tt=Ne[1]):Xe=Ne,ae.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.g(q,Xe.range.start,Xe.newCellMetadata,tt):Xe.newNotebookMetadata?this.e(q,Xe.newNotebookMetadata,tt):this.f(q,Xe.range,Xe.newCells,tt):_.isSnippetTextEdit(Xe)?this.c.push({_type:6,uri:q,range:Xe.range,edit:Xe.snippet,metadata:tt}):this.c.push({_type:2,uri:q,edit:Xe,metadata:tt})}else{for(let Ne=0;Ne<this.c.length;Ne++){const Xe=this.c[Ne];switch(Xe._type){case 2:case 6:case 3:case 5:Xe.uri.toString()===q.toString()&&(this.c[Ne]=void 0);break}}(0,D.$Ib)(this.c)}}get(q){const pe=[];for(const Ne of this.c)Ne._type===2&&Ne.uri.toString()===q.toString()&&pe.push(Ne.edit);return pe}entries(){const q=new P.$Ac;for(const pe of this.c)if(pe._type===2){let Ne=q.get(pe.uri);Ne||(Ne=[pe.uri,[]],q.set(pe.uri,Ne)),Ne[1].push(pe.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$vL=ne,e.$vL=ne=Ge([y],ne);let K=s=class{static isSnippetString(q){return q instanceof s?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=s.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,pe=this.e++){if(typeof q=="function"){const Ne=new s;Ne.e=this.e,q(Ne),this.e=Ne.e,q=Ne.value}else q=s.c(q);return this.value+="${",this.value+=pe,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,pe=this.e++){const Ne=q.map(Xe=>Xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Ne,this.value+="|}",this}appendVariable(q,pe){if(typeof pe=="function"){const Ne=new s;Ne.e=this.e,pe(Ne),this.e=Ne.e,pe=Ne.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$wL=K,e.$wL=K=s=Ge([y],K);var W;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var re;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(re||(e.DiagnosticSeverity=re={}));let ye=t=class{static isLocation(q){return q instanceof t?!0:q?F.isRange(q.range)&&k.URI.isUri(q.uri):!1}constructor(q,pe){if(this.uri=q,pe)if(F.isRange(pe))this.range=F.of(pe);else if(j.isPosition(pe))this.range=new F(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$xL=ye,e.$xL=ye=t=Ge([y],ye);let he=class{static is(q){return q?typeof q.message=="string"&&q.location&&F.isRange(q.location.range)&&k.URI.isUri(q.location.uri):!1}constructor(q,pe){this.location=q,this.message=pe}static isEqual(q,pe){return q===pe?!0:!q||!pe?!1:q.message===pe.message&&q.location.range.isEqual(pe.location.range)&&q.location.uri.toString()===pe.location.uri.toString()}};e.$yL=he,e.$yL=he=Ge([y],he);let fe=class{constructor(q,pe,Ne=re.Error){if(!F.isRange(q))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=q,this.message=pe,this.severity=Ne}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,pe){return q===pe?!0:!q||!pe?!1:q.message===pe.message&&q.severity===pe.severity&&q.code===pe.code&&q.severity===pe.severity&&q.source===pe.source&&q.range.isEqual(pe.range)&&(0,D.$ub)(q.tags,pe.tags)&&(0,D.$ub)(q.relatedInformation,pe.relatedInformation,he.isEqual)}};e.$zL=fe,e.$zL=fe=Ge([y],fe);let ue=class{constructor(q,pe){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=pe}};e.$AL=ue,e.$AL=ue=Ge([y],ue);var me;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(me||(e.DocumentHighlightKind=me={}));let V=class{constructor(q,pe=me.Text){this.range=q,this.kind=pe}toJSON(){return{range:this.range,kind:me[this.kind]}}};e.$BL=V,e.$BL=V=Ge([y],V);let Y=class{constructor(q,pe){this.uri=q,this.highlights=pe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$CL=Y,e.$CL=Y=Ge([y],Y);var de;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(de||(e.SymbolKind=de={}));var we;(function(G){G[G.Deprecated=1]="Deprecated"})(we||(e.SymbolTag=we={}));let Pe=g=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,pe,Ne,Xe,tt){this.name=q,this.kind=pe,this.containerName=tt,typeof Ne=="string"&&(this.containerName=Ne),Xe instanceof ye?this.location=Xe:Ne instanceof F&&(this.location=new ye(Xe,Ne)),g.validate(this)}toJSON(){return{name:this.name,kind:de[this.kind],location:this.location,containerName:this.containerName}}};e.$DL=Pe,e.$DL=Pe=g=Ge([y],Pe);let ve=o=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(o.validate)}constructor(q,pe,Ne,Xe,tt){this.name=q,this.detail=pe,this.kind=Ne,this.range=Xe,this.selectionRange=tt,this.children=[],o.validate(this)}};e.$EL=ve,e.$EL=ve=o=Ge([y],ve);var Ce;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let B=class{constructor(q,pe){this.title=q,this.kind=pe}};e.$FL=B,e.$FL=B=Ge([y],B);let Q=class{static{d=this}static{this.c="."}constructor(q){this.value=q}append(q){return new d(this.value?this.value+d.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+d.c)}};e.$GL=Q,e.$GL=Q=d=Ge([y],Q),Q.Empty=new Q(""),Q.QuickFix=Q.Empty.append("quickfix"),Q.Refactor=Q.Empty.append("refactor"),Q.RefactorExtract=Q.Refactor.append("extract"),Q.RefactorInline=Q.Refactor.append("inline"),Q.RefactorMove=Q.Refactor.append("move"),Q.RefactorRewrite=Q.Refactor.append("rewrite"),Q.Source=Q.Empty.append("source"),Q.SourceOrganizeImports=Q.Source.append("organizeImports"),Q.SourceFixAll=Q.Source.append("fixAll"),Q.Notebook=Q.Empty.append("notebook");let ee=class{constructor(q,pe){if(this.range=q,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$HL=ee,e.$HL=ee=Ge([y],ee);class H{constructor(q,pe,Ne,Xe,tt,lt){this.kind=q,this.name=pe,this.detail=Ne,this.uri=Xe,this.range=tt,this.selectionRange=lt}}e.$IL=H;class oe{constructor(q,pe){this.fromRanges=pe,this.from=q}}e.$JL=oe;class le{constructor(q,pe){this.fromRanges=pe,this.to=q}}e.$KL=le;var Re;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Re||(e.LanguageStatusSeverity=Re={}));let je=class{constructor(q,pe){this.range=q,this.command=pe}get isResolved(){return!!this.command}};e.$LL=je,e.$LL=je=Ge([y],je);let He=l=class{#e;static isMarkdownString(q){return q instanceof l?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,pe=!1){this.#e=new h.$jk(q,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,pe){return this.#e.appendCodeblock(pe??"",q),this}};e.$ML=He,e.$ML=He=l=Ge([y],He);let Qe=class{constructor(q,pe){this.label=q,this.documentation=pe}};e.$NL=Qe,e.$NL=Qe=Ge([y],Qe);let _e=class{constructor(q,pe){this.label=q,this.documentation=pe,this.parameters=[]}};e.$OL=_e,e.$OL=_e=Ge([y],_e);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$PL=at,e.$PL=at=Ge([y],at);var st;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(st||(e.SignatureHelpTriggerKind=st={}));var rt;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let Le=class{constructor(q){this.value=q}};e.$QL=Le,e.$QL=Le=Ge([y],Le);let ze=class{constructor(q,pe,Ne){this.position=q,this.label=pe,this.kind=Ne}};e.$RL=ze,e.$RL=ze=Ge([y],ze);var Ae;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ae||(e.CompletionTriggerKind=Ae={}));var Ze;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Ze||(e.CompletionItemKind=Ze={}));var ie;(function(G){G[G.Deprecated=1]="Deprecated"})(ie||(e.CompletionItemTag=ie={}));let se=class{constructor(q,pe){this.label=q,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&Ze[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$SL=se,e.$SL=se=Ge([y],se);let Ie=class{constructor(q=[],pe=!1){this.items=q,this.isIncomplete=pe}};e.$TL=Ie,e.$TL=Ie=Ge([y],Ie);let qe=class{constructor(q,pe,Ne){this.insertText=q,this.range=pe,this.command=Ne}};e.$UL=qe,e.$UL=qe=Ge([y],qe);let Ye=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$VL=Ye,e.$VL=Ye=Ge([y],Ye);var it;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var nt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(nt||(e.StatusBarAlignment=nt={}));function Oe(G,q){return`${C.$nm.toKey(G)}.${q}`}e.$WL=Oe;var yt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(yt||(e.TextEditorLineNumbersStyle=yt={}));var Dt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Dt||(e.TextDocumentSaveReason=Dt={}));var Tt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Tt||(e.TextEditorRevealType=Tt={}));var Ft;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Ft||(e.TextEditorSelectionChangeKind=Ft={}));var Et;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(Et||(e.TextDocumentChangeReason=Et={}));var Ht;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Ht||(e.DecorationRangeBehavior=Ht={})),function(G){function q(pe){switch(pe){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=q}(Ft||(e.TextEditorSelectionChangeKind=Ft={}));var Ot;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Ot||(e.SyntaxTokenType=Ot={})),function(G){function q(pe){switch(pe){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=q}(Ot||(e.SyntaxTokenType=Ot={}));let Yt=class{constructor(q,pe){if(pe&&!k.URI.isUri(pe))throw(0,N.$7)("target");if(!F.isRange(q)||q.isEmpty)throw(0,N.$7)("range");this.range=q,this.target=pe}};e.$XL=Yt,e.$XL=Yt=Ge([y],Yt);let Vt=class{constructor(q,pe,Ne,Xe){this.red=q,this.green=pe,this.blue=Ne,this.alpha=Xe}};e.$YL=Vt,e.$YL=Vt=Ge([y],Vt);let Ut=class{constructor(q,pe){if(pe&&!(pe instanceof Vt))throw(0,N.$7)("color");if(!F.isRange(q)||q.isEmpty)throw(0,N.$7)("range");this.range=q,this.color=pe}};e.$ZL=Ut,e.$ZL=Ut=Ge([y],Ut);let et=class{constructor(q){if(!q||typeof q!="string")throw(0,N.$7)("label");this.label=q}};e.$1L=et,e.$1L=et=Ge([y],et);var Gt;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Jt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var ht;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(ht||(e.TerminalExitReason=ht={}));class $t{constructor(q,pe,Ne){if(this.startIndex=q,this.length=pe,this.tooltip=Ne,typeof q!="number"||q<0)throw(0,N.$7)("startIndex");if(typeof pe!="number"||pe<1)throw(0,N.$7)("length");if(Ne!==void 0&&typeof Ne!="string")throw(0,N.$7)("tooltip")}}e.$2L=$t;class Bt{constructor(q){this.uri=q}}e.$3L=Bt;class Qt{constructor(q){this.terminalCommand=q}}e.$4L=Qt;var kt;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class ft{constructor(q){if(this.options=q,typeof q!="object")throw(0,N.$7)("options")}}e.$5L=ft;var It;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(It||(e.TaskRevealKind=It={}));var _t;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(_t||(e.TaskPanelKind=_t={}));let At=class{static{u=this}static{this.Clean=new u("clean","Clean")}static{this.Build=new u("build","Build")}static{this.Rebuild=new u("rebuild","Rebuild")}static{this.Test=new u("test","Test")}static from(q){switch(q){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}constructor(q,pe){if(this.label=pe,typeof q!="string"||typeof pe!="string")throw(0,N.$7)("name");this.c=q}get id(){return this.c}};e.$6L=At,e.$6L=At=u=Ge([y],At);function Je(G){let q="";for(let pe=0;pe<G.length;pe++)q+=G[pe].replace(/,/g,",,")+",";return q}let Mt=class{constructor(q,pe,Ne){if(typeof q!="string")throw(0,N.$7)("process");this.e=[],this.c=q,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Ne):this.f=pe)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,N.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)q.push(pe);return Je(q)}};e.$7L=Mt,e.$7L=Mt=Ge([y],Mt);let jt=class{constructor(q,pe,Ne){if(this.f=[],Array.isArray(pe)){if(!q)throw(0,N.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,N.$7)("command");this.e=q,this.f=pe,this.g=Ne}else{if(typeof q!="string")throw(0,N.$7)("commandLine");this.c=q,this.g=pe}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,N.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,N.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)q.push(typeof pe=="string"?pe:pe.value);return Je(q)}};e.$8L=jt,e.$8L=jt=Ge([y],jt);var Zt;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(Zt||(e.ShellQuoting=Zt={}));var gt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Nt{constructor(q){this.c=q}computeId(){return"customExecution"+(0,R.$rg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$9L=Nt;let Pt=class{static{v=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,pe,Ne,Xe,tt,lt){this.k=!1,this.l=this.definition=q;let mt;typeof pe=="string"?(this.o=this.name=pe,this.w=this.source=Ne,this.execution=Xe,mt=tt,this.k=!0):pe===gt.Global||pe===gt.Workspace?(this.target=pe,this.o=this.name=Ne,this.w=this.source=Xe,this.execution=tt,mt=lt):(this.target=pe,this.o=this.name=Ne,this.w=this.source=Xe,this.execution=tt,mt=lt),typeof mt=="string"?(this.r=[mt],this.t=!0):Array.isArray(mt)?(this.r=mt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Mt?this.l={type:v.e,id:this.q.computeId()}:this.q instanceof jt?this.l={type:v.f,id:this.q.computeId()}:this.q instanceof Nt?this.l={type:v.c,id:this.q.computeId()}:this.l={type:v.g,id:(0,R.$rg)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=q}get scope(){return this.m}set target(q){this.B(),this.m=q}get name(){return this.o}set name(q){if(typeof q!="string")throw(0,N.$7)("name");this.B(),this.o=q}get execution(){return this.q}set execution(q){q===null&&(q=void 0),this.B(),this.q=q;const pe=this.l.type;(v.g===pe||v.e===pe||v.f===pe||v.c===pe)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(q){if(Array.isArray(q))this.B(),this.r=q,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.B(),this.u=q}get source(){return this.w}set source(q){if(typeof q!="string"||q.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=q}get group(){return this.x}set group(q){q===null&&(q=void 0),this.B(),this.x=q}get detail(){return this.A}set detail(q){q===null&&(q=void 0),this.A=q}get presentationOptions(){return this.y}set presentationOptions(q){q==null&&(q=Object.create(null)),this.B(),this.y=q}get runOptions(){return this.z}set runOptions(q){q==null&&(q=Object.create(null)),this.B(),this.z=q}};e.$0L=Pt,e.$0L=Pt=v=Ge([y],Pt);var Wt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(Wt||(e.ProgressLocation=Wt={}));var Me;(function(G){function q(pe){const Ne=pe;return(0,b.$Nf)(Ne.value)?Ne.tooltip&&!(0,b.$Jf)(Ne.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ne.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ne.value),!1)}G.isViewBadge=q})(Me||(e.ViewBadge=Me={}));let Fe=I=class{static isTreeItem(q,pe){const Ne=q;if(Ne.checkboxState!==void 0){const Xe=(0,b.$Nf)(Ne.checkboxState)?Ne.checkboxState:(0,b.$Lf)(Ne.checkboxState)&&(0,b.$Nf)(Ne.checkboxState.state)?Ne.checkboxState.state:void 0,tt=!(0,b.$Nf)(Ne.checkboxState)&&(0,b.$Lf)(Ne.checkboxState)?Ne.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==ce.Checked&&Xe!==ce.Unchecked||tt!==void 0&&!(0,b.$Jf)(tt))return console.log("INVALID tree item, invalid checkboxState",Ne.checkboxState),!1}if(q instanceof I)return!0;if(Ne.label!==void 0&&!(0,b.$Jf)(Ne.label)&&!Ne.label?.label)return console.log("INVALID tree item, invalid label",Ne.label),!1;if(Ne.id!==void 0&&!(0,b.$Jf)(Ne.id))return console.log("INVALID tree item, invalid id",Ne.id),!1;if(Ne.iconPath!==void 0&&!(0,b.$Jf)(Ne.iconPath)&&!k.URI.isUri(Ne.iconPath)&&(!Ne.iconPath||!(0,b.$Jf)(Ne.iconPath.id))){const Xe=Ne.iconPath;if(!Xe||!(0,b.$Jf)(Xe.light)&&!k.URI.isUri(Xe.light)&&!(0,b.$Jf)(Xe.dark)&&!k.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Ne.iconPath),!1}return Ne.description!==void 0&&!(0,b.$Jf)(Ne.description)&&typeof Ne.description!="boolean"?(console.log("INVALID tree item, invalid description",Ne.description),!1):Ne.resourceUri!==void 0&&!k.URI.isUri(Ne.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ne.resourceUri),!1):Ne.tooltip!==void 0&&!(0,b.$Jf)(Ne.tooltip)&&!(Ne.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Ne.tooltip),!1):Ne.command!==void 0&&!Ne.command.command?(console.log("INVALID tree item, invalid command",Ne.command),!1):Ne.collapsibleState!==void 0&&Ne.collapsibleState<De.None&&Ne.collapsibleState>De.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ne.collapsibleState),!1):Ne.contextValue!==void 0&&!(0,b.$Jf)(Ne.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ne.contextValue),!1):Ne.accessibilityInformation!==void 0&&!Ne.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ne.accessibilityInformation),!1):!0}constructor(q,pe=De.None){this.collapsibleState=pe,k.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$$L=Fe,e.$$L=Fe=I=Ge([y],Fe);var De;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(De||(e.TreeItemCollapsibleState=De={}));var ce;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(ce||(e.TreeItemCheckboxState=ce={}));let Te=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$_L=Te,e.$_L=Te=Ge([y],Te);class Be extends Te{}e.$aM=Be;class xe extends Be{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$bM=xe;class Ke{constructor(q,pe,Ne,Xe){this.name=q,this.uri=pe,this._itemId=Ne,this.c=Xe}data(){return this.c()}}e.$cM=Ke;let ut=class{#e=new Map;constructor(q){for(const[pe,Ne]of q??[]){const Xe=this.#e.get(this.#t(pe));Xe?Xe.push(Ne):this.#e.set(this.#t(pe),[Ne])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,pe){this.#e.set(this.#t(q),[pe])}forEach(q,pe){for(const[Ne,Xe]of this.#e)for(const tt of Xe)q.call(pe,tt,Ne,this)}*[Symbol.iterator](){for(const[q,pe]of this.#e)for(const Ne of pe)yield[q,Ne]}#t(q){return q.toLowerCase()}};e.$dM=ut,e.$dM=ut=Ge([y],ut);let vt=class{constructor(q){this.insertText=q}};e.$eM=vt,e.$eM=vt=Ge([y],vt);let Kt=class{constructor(q,pe){this.label=pe,this.insertText=q}};e.$fM=Kt,e.$fM=Kt=Ge([y],Kt);let St=class{constructor(q,pe){this.id=q,this.color=pe}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$gM=St,e.$gM=St=Ge([y],St),St.File=new St("file"),St.Folder=new St("folder");let Ct=class{constructor(q){this.id=q}};e.$hM=Ct,e.$hM=Ct=Ge([y],Ct);var pt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(pt||(e.ConfigurationTarget=pt={}));let Si=class{get base(){return this.c}set base(q){this.c=q,this.e=k.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,pe){if(typeof q!="string"&&(!q||!k.URI.isUri(q)&&!k.URI.isUri(q.uri)))throw(0,N.$7)("base");if(typeof pe!="string")throw(0,N.$7)("pattern");typeof q=="string"?this.baseUri=k.URI.file(q):k.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$iM=Si,e.$iM=Si=Ge([y],Si);const Ki=new WeakMap;function Lt(G,q){Ki.set(G,q)}e.$jM=Lt;let si=class{constructor(q,pe,Ne,Xe){this.enabled=typeof q=="boolean"?q:!0,typeof pe=="string"&&(this.condition=pe),typeof Ne=="string"&&(this.hitCondition=Ne),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this.c||(this.c=Ki.get(this)??(0,R.$rg)()),this.c}};e.$kM=si,e.$kM=si=Ge([y],si);let mi=class extends si{constructor(q,pe,Ne,Xe,tt){if(super(pe,Ne,Xe,tt),q===null)throw(0,N.$7)("location");this.location=q}};e.$lM=mi,e.$lM=mi=Ge([y],mi);let ui=class extends si{constructor(q,pe,Ne,Xe,tt){super(pe,Ne,Xe,tt),this.functionName=q}};e.$mM=ui,e.$mM=ui=Ge([y],ui);let Di=class extends si{constructor(q,pe,Ne,Xe,tt,lt,mt){if(super(Xe,tt,lt,mt),!pe)throw(0,N.$7)("dataId");this.label=q,this.dataId=pe,this.canPersist=Ne}};e.$nM=Di,e.$nM=Di=Ge([y],Di);let Ci=class{constructor(q,pe,Ne){this.command=q,this.args=pe||[],this.options=Ne}};e.$oM=Ci,e.$oM=Ci=Ge([y],Ci);let zt=class{constructor(q,pe){this.port=q,this.host=pe}};e.$pM=zt,e.$pM=zt=Ge([y],zt);let $i=class{constructor(q){this.path=q}};e.$qM=$i,e.$qM=$i=Ge([y],$i);let Ii=class{constructor(q){this.implementation=q}};e.$rM=Ii,e.$rM=Ii=Ge([y],Ii);let li=class{constructor(q,pe,Ne){this.session=q,this.threadId=pe,this.frameId=Ne}};e.$sM=li,e.$sM=li=Ge([y],li);let hi=class{constructor(q,pe){this.session=q,this.threadId=pe}};e.$tM=hi,e.$tM=hi=Ge([y],hi);let dt=class{constructor(q,pe){this.range=q,this.expression=pe}};e.$uM=dt,e.$uM=dt=Ge([y],dt);var Ji;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let ei=class{constructor(q,pe){this.range=q,this.text=pe}};e.$vM=ei,e.$vM=ei=Ge([y],ei);let oi=class{constructor(q,pe,Ne=!0){this.range=q,this.variableName=pe,this.caseSensitiveLookup=Ne}};e.$wM=oi,e.$wM=oi=Ge([y],oi);let bi=class{constructor(q,pe){this.range=q,this.expression=pe}};e.$xM=bi,e.$xM=bi=Ge([y],bi);let Pi=class{constructor(q,pe){this.frameId=q,this.stoppedLocation=pe}};e.$yM=Pi,e.$yM=Pi=Ge([y],Pi);var Qi;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Li=$=class extends Error{static FileExists(q){return new $(q,w.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(q){return new $(q,w.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(q){return new $(q,w.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(q){return new $(q,w.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(q){return new $(q,w.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(q){return new $(q,w.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(q,pe=w.FileSystemProviderErrorCode.Unknown,Ne){super(k.URI.isUri(q)?q.toString(!0):q),this.code=Ne?.name??"Unknown",(0,w.$Hk)(this,pe),Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof Ne=="function"&&Error.captureStackTrace(this,Ne)}};e.$zM=Li,e.$zM=Li=$=Ge([y],Li);let wi=class{constructor(q,pe,Ne){this.start=q,this.end=pe,this.kind=Ne}};e.$AM=wi,e.$AM=wi=Ge([y],wi);var Zi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(Zi||(e.FoldingRangeKind=Zi={}));var Ai;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var di;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(di||(e.CommentMode=di={}));var Yi;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Yi||(e.CommentState=Yi={}));var pi;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(pi||(e.CommentThreadState=pi={}));class Ri{constructor(q,pe=[]){this.tokenTypes=q,this.tokenModifiers=pe}}e.$BM=Ri;function ln(G){return typeof G>"u"||(0,b.$Kf)(G)}class Mi{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let pe=0,Ne=q.tokenTypes.length;pe<Ne;pe++)this.k.set(q.tokenTypes[pe],pe);for(let pe=0,Ne=q.tokenModifiers.length;pe<Ne;pe++)this.l.set(q.tokenModifiers[pe],pe)}}push(q,pe,Ne,Xe,tt){if(typeof q=="number"&&typeof pe=="number"&&typeof Ne=="number"&&typeof Xe=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.q(q,pe,Ne,Xe,tt);if(F.isRange(q)&&typeof pe=="string"&&ln(Ne))return this.o(q,pe,Ne);throw(0,N.$7)()}o(q,pe,Ne){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(pe))throw new Error("`tokenType` is not in the provided legend");const Xe=q.start.line,tt=q.start.character,lt=q.end.character-q.start.character,mt=this.k.get(pe);let qt=0;if(Ne)for(const xt of Ne){if(!this.l.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(xt);qt|=1<<ii>>>0}this.q(Xe,tt,lt,mt,qt)}q(q,pe,Ne,Xe,tt){if(this.f&&(q<this.c||q===this.c&&pe<this.e)){this.f=!1;const qt=this.g.length/5|0;let xt=0,ii=0;for(let ri=0;ri<qt;ri++){let ci=this.g[5*ri],Hi=this.g[5*ri+1];ci===0?(ci=xt,Hi+=ii):ci+=xt,this.g[5*ri]=ci,this.g[5*ri+1]=Hi,xt=ci,ii=Hi}}let lt=q,mt=pe;this.f&&this.j>0&&(lt-=this.c,lt===0&&(mt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=mt,this.g[this.j++]=Ne,this.g[this.j++]=Xe,this.g[this.j++]=tt,this.c=q,this.e=pe}static r(q){const pe=[],Ne=q.length/5|0;for(let mt=0;mt<Ne;mt++)pe[mt]=mt;pe.sort((mt,qt)=>{const xt=q[5*mt],ii=q[5*qt];if(xt===ii){const ri=q[5*mt+1],ci=q[5*qt+1];return ri-ci}return xt-ii});const Xe=new Uint32Array(q.length);let tt=0,lt=0;for(let mt=0;mt<Ne;mt++){const qt=5*pe[mt],xt=q[qt+0],ii=q[qt+1],ri=q[qt+2],ci=q[qt+3],Hi=q[qt+4],In=xt-tt,Un=In===0?ii-lt:ii,Gi=5*mt;Xe[Gi+0]=In,Xe[Gi+1]=Un,Xe[Gi+2]=ri,Xe[Gi+3]=ci,Xe[Gi+4]=Hi,tt=xt,lt=ii}return Xe}build(q){return this.f?new ai(new Uint32Array(this.g),q):new ai(Mi.r(this.g),q)}}e.$CM=Mi;class ai{constructor(q,pe){this.resultId=pe,this.data=q}}e.$DM=ai;class hn{constructor(q,pe,Ne){this.start=q,this.deleteCount=pe,this.data=Ne}}e.$EM=hn;class dn{constructor(q,pe){this.resultId=pe,this.edits=q}}e.$FM=dn;var Xi;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Xi||(e.DebugConsoleMode=Xi={}));class Ni{constructor(q){this.name=q}}e.$GM=Ni;let Ti=class{static{this.Back={iconPath:new St("arrow-left")}}constructor(){}};e.$HM=Ti,e.$HM=Ti=Ge([y],Ti);var xi;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var vi;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(vi||(e.InputBoxValidationSeverity=vi={}));var Fi;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Fi||(e.ExtensionKind=Fi={}));class fn{static validate(q){if(typeof q.badge=="string"){let pe=(0,p.$kf)(q.badge,0);if(pe<q.badge.length&&(pe+=(0,p.$kf)(q.badge,pe)),q.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!St.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,pe,Ne){this.badge=q,this.tooltip=pe,this.color=Ne}}e.$IM=fn;let yi=class{constructor(q){this.kind=q}};e.$JM=yi,e.$JM=yi=Ge([y],yi);var Oi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Oi||(e.ColorThemeKind=Oi={}));class ni{static isNotebookRange(q){return q instanceof ni?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,pe){if(q<0)throw(0,N.$7)("start must be positive");if(pe<0)throw(0,N.$7)("end must be positive");q<=pe?(this.c=q,this.e=pe):(this.c=pe,this.e=q)}with(q){let pe=this.c,Ne=this.e;return q.start!==void 0&&(pe=q.start),q.end!==void 0&&(Ne=q.end),pe===this.c&&Ne===this.e?this:new ni(pe,Ne)}}e.$KM=ni;class Ei{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(pe=>Ei.isNotebookCellData(pe))}static isNotebookCellData(q){return!0}constructor(q,pe,Ne,Xe,tt,lt,mt){this.kind=q,this.value=pe,this.languageId=Ne,this.mime=Xe,this.outputs=tt??[],this.metadata=lt,this.executionSummary=mt,Ei.validate(this)}}e.$LM=Ei;class gn{constructor(q){this.cells=q}}e.$MM=gn;class Xt{static isNotebookCellOutputItem(q){return q instanceof Xt?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const pe={name:q.name,message:q.message,stack:q.stack};return Xt.json(pe,"application/vnd.code.notebook.error")}static stdout(q){return Xt.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return Xt.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,pe="application/octet-stream"){return new Xt(q,pe)}static#e=new TextEncoder;static text(q,pe=A.$hs.text){const Ne=Xt.#e.encode(String(q));return new Xt(Ne,pe)}static json(q,pe="text/x-json"){const Ne=JSON.stringify(q,void 0,"	");return Xt.text(Ne,pe)}constructor(q,pe){this.data=q,this.mime=pe;const Ne=(0,A.$ls)(pe,!0);if(!Ne)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ne}}e.$NM=Xt;class fi{static isNotebookCellOutput(q){return q instanceof fi?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,pe=!1){const Ne=new Set,Xe=new Set;for(let tt=0;tt<q.length;tt++){const lt=q[tt],mt=(0,A.$ls)(lt.mime);if(!Ne.has(mt)||(0,S.$mJ)(mt)){Ne.add(mt);continue}Xe.add(tt),pe&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Xe.size===0?q:q.filter((tt,lt)=>!Xe.has(lt))}constructor(q,pe,Ne){this.items=fi.ensureUniqueMimeTypes(q,!0),typeof pe=="string"?(this.id=pe,this.metadata=Ne):(this.id=(0,R.$rg)(),this.metadata=pe??Ne)}}e.$OM=fi;var ji;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(ji||(e.NotebookCellKind=ji={}));var We;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(We||(e.NotebookCellExecutionState=We={}));var ti;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(ti||(e.NotebookCellStatusBarAlignment=ti={}));var zi;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(zi||(e.NotebookEditorRevealType=zi={}));class ot{constructor(q,pe){this.text=q,this.alignment=pe}}e.$PM=ot;var bt;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(bt||(e.NotebookControllerAffinity=bt={}));var _i;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(_i||(e.NotebookControllerAffinity2=_i={}));class mn{constructor(q,pe=[]){this.uri=q,this.provides=(0,D.$3b)(pe)}}e.$QM=mn;class en{constructor(q){this.label=q}}e.$RM=en;var tn;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(tn||(e.NotebookVariablesRequestKind=tn={}));let gi=class{constructor(q,pe){this.label=q,this.timestamp=pe}};e.$SM=gi,e.$SM=gi=Ge([y],gi);var nn;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(nn||(e.ExtensionMode=nn={}));var rn;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(rn||(e.ExtensionRuntime=rn={}));var sn;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(sn||(e.StandardTokenType=sn={}));class on{constructor(q,pe){this.ranges=q,this.wordPattern=pe}}e.$TM=on;class $n{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$UM=$n;var an;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var cn;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Ui=class{constructor(q=void 0,pe=void 0,Ne=void 0,Xe=!1){this.include=q,this.exclude=pe,this.profile=Ne,this.continuous=Xe}};e.$VM=Ui,e.$VM=Ui=Ge([y],Ui);let Bi=f=class{static diff(q,pe,Ne){const Xe=new f(q);return Xe.expectedOutput=pe,Xe.actualOutput=Ne,Xe}constructor(q){this.message=q}};e.$WM=Bi,e.$WM=Bi=f=Ge([y],Bi);let Wi=class{constructor(q){this.id=q}};e.$XM=Wi,e.$XM=Wi=Ge([y],Wi);class ki{constructor(q,pe){this.covered=q,this.total=pe}}e.$YM=ki;const Vi=G=>{if(G&&G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`)};class qi{static fromDetails(q,pe){const Ne=new ki(0,0),Xe=new ki(0,0),tt=new ki(0,0);for(const mt of pe)if("branches"in mt){Ne.total+=1,Ne.covered+=mt.executed?1:0;for(const qt of mt.branches)Xe.total+=1,Xe.covered+=qt.executed?1:0}else tt.total+=1,tt.covered+=mt.executed?1:0;const lt=new qi(q,Ne,Xe.total>0?Xe:void 0,tt.total>0?tt:void 0);return lt.detailedCoverage=pe,lt}constructor(q,pe,Ne,Xe){this.uri=q,this.statementCoverage=pe,this.branchCoverage=Ne,this.functionCoverage=Xe,Vi(pe),Vi(Ne),Vi(Xe)}}e.$ZM=qi;class bn{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,pe,Ne=[]){this.executed=q,this.location=pe,this.branches=Ne}}e.$1M=bn;class be{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,pe,Ne){this.executed=q,this.location=pe,this.label=Ne}}e.$2M=be;class Ee{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,pe,Ne){this.name=q,this.executed=pe,this.location=Ne}}e.$3M=Ee;var Ue;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(Ue||(e.ExternalUriOpenerPriority=Ue={}));var ct;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(ct||(e.WorkspaceTrustState=ct={}));var wt;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(wt||(e.PortAutoForwardAction=wt={}));class Rt{constructor(q,pe,Ne,Xe,tt,lt){this.kind=q,this.name=pe,this.detail=Ne,this.uri=Xe,this.range=tt,this.selectionRange=lt}}e.$4M=Rt;class un{constructor(q){this.uri=q}}e.$5M=un;class Pn{constructor(q,pe){this.original=q,this.modified=pe}}e.$6M=Pn;class Ln{constructor(q,pe,Ne,Xe){this.base=q,this.input1=pe,this.input2=Ne,this.result=Xe}}e.$7M=Ln;class An{constructor(q,pe){this.uri=q,this.viewType=pe}}e.$8M=An;class Rn{constructor(q){this.viewType=q}}e.$9M=Rn;class Mn{constructor(q,pe){this.uri=q,this.notebookType=pe}}e.$0M=Mn;class Nn{constructor(q,pe,Ne){this.original=q,this.modified=pe,this.notebookType=Ne}}e.$$M=Nn;class Tn{constructor(){}}e.$_M=Tn;class Fn{constructor(q,pe){this.uri=q,this.inputBoxUri=pe}}e.$aN=Fn;class On{constructor(q){this.providerId=q}}e.$bN=On;var wn;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var pn;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(pn||(e.ChatAgentCopyKind=pn={}));var vn;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class jn{constructor(q,pe){this.label=q,this.values=pe}}e.$cN=jn;var yn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(G){G[G.System=0]="System",G[G.User=1]="User",G[G.Assistant=2]="Assistant",G[G.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class zn{constructor(q,pe){this.role=q,this.content=pe}}e.$dN=zn;var kn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Sn;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var Dn;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}));var Cn;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(Cn||(e.KeywordRecognitionStatus=Cn={}))}),define(ke[311],Se([1,0,6,7]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=void 0;class h{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(D.$jL.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,p,b){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(A);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(p,b)??[]}getRelatedInformation(A,p,b){return this.c.$getAiRelatedInformation(p,b)}registerRelatedInformationProvider(A,p,b){const k=this.b;return this.b++,this.a.set(k,b),this.c.$registerAiRelatedInformationProvider(k,p),new N.$lL(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$Vfc=h}),define(ke[312],Se([1,0,4,6,7,25]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;class A{constructor(k){this.b=new Map,this.c=new D.$Wd,this.onDidChangeSessions=this.c.event,this.d=new p,this.f=new p,this.a=k.getProxy(N.$jL.MainThreadAuthentication)}async getSession(k,R,C,w={}){const E=P.$nm.toKey(k.identifier),S=[...C].sort().join(" ");return await this.d.getOrCreate(`${E} ${R} ${S}`,async()=>{await this.a.$ensureProvider(R);const c=k.displayName||k.name;return this.a.$getSession(R,C,E,c,w)})}async getSessions(k,R,C){const w=P.$nm.toKey(k.identifier),E=[...C].sort().join(" ");return await this.f.getOrCreate(`${w} ${E}`,async()=>{await this.a.$ensureProvider(R);const S=k.displayName||k.name;return this.a.$getSessions(R,C,w,S)})}async removeSession(k,R){const C=this.b.get(k);return C?C.provider.removeSession(R):this.a.$removeSession(k,R)}registerAuthenticationProvider(k,R,C,w){if(this.b.get(k))throw new Error(`An authentication provider with id '${k}' is already registered.`);this.b.set(k,{label:R,provider:C,options:w??{supportsMultipleAccounts:!1}});const E=C.onDidChangeSessions(S=>this.a.$sendDidChangeSessions(k,S));return this.a.$registerAuthenticationProvider(k,R,w?.supportsMultipleAccounts??!1),new h.$lL(()=>{E.dispose(),this.b.delete(k),this.a.$unregisterAuthenticationProvider(k)})}$createSession(k,R,C){const w=this.b.get(k);if(w)return Promise.resolve(w.provider.createSession(R,C));throw new Error(`Unable to find authentication provider with handle: ${k}`)}$removeSession(k,R){const C=this.b.get(k);if(C)return Promise.resolve(C.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${k}`)}$getSessions(k,R){const C=this.b.get(k);if(C)return Promise.resolve(C.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${k}`)}$onDidChangeAuthenticationSessions(k,R){return this.c.fire({provider:{id:k,label:R}}),Promise.resolve()}}e.$7fc=A;class p{constructor(){this.a=new Map}getOrCreate(k,R){const C=this.a.get(k);if(C)return C;const w=R().finally(()=>this.a.delete(k));return this.a.set(k,w),w}}}),define(ke[147],Se([1,0,2,6,7,5,20,13,19,12,17,26]),function($e,e,D,N,h,P,A,p,b,k,R,C){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=e.$6gc=void 0;let E=class{static{w=this}static{this.c=0}static{this.d=250}constructor(c,m){this.h=m,this.f=new Map,this.g=c.getProxy(N.$jL.MainThreadDecorations)}registerFileDecorationProvider(c,m){const a=w.c++;this.f.set(a,{provider:c,extensionDescription:m}),this.g.$registerDecorationProvider(a,m.identifier.value);const i=c.onDidChangeFileDecorations&&c.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(a,null);return}const r=(0,b.$3b)(n);if(r.length<=w.d){this.g.$onDidChange(a,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,r.length);const s=r.map(o=>({uri:o,rank:(0,k.$Qe)(o.path,"/")})),t=(0,b.$zb)(s,(o,d)=>o.rank-d.rank||(0,k.$6e)(o.uri.path,d.uri.path)),g=[];e:for(const o of t){let d;for(const l of o){const u=(0,R.$mc)(l.uri.path);if(d!==u&&(d=u,g.push(l.uri)>=w.d))break e}}this.g.$onDidChange(a,g)});return new h.$lL(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(c,m,a){if(!this.f.has(c))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:r}=this.f.get(c);return await Promise.all(m.map(async s=>{try{const{uri:t,id:g}=s,o=await Promise.resolve(n.provideFileDecoration(D.URI.revive(t),a));if(!o)return;try{h.$IM.validate(o),o.badge&&typeof o.badge!="string"&&(0,C.$LF)(r,"codiconDecoration"),i[g]=[o.propagate,o.tooltip,o.badge,o.color]}catch(d){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${d}`)}}catch(t){this.h.error(t)}})),i}};e.$6gc=E,e.$6gc=E=w=Ge([Ve(0,A.$oN),Ve(1,p.$pj)],E),e.$7gc=(0,P.$8h)("IExtHostDecorations")}),define(ke[313],Se([1,0,14,2,7,6,16,22,12]),function($e,e,D,N,h,P,A,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=void 0;class k{static{this.a=0}constructor(C,w,E){this.d=w,this.e=E,this.b=new Map,this.c=C.getProxy(P.$jL.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,w){if(Object.keys(A.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const E=k.a++;this.b.set(E,w),this.c.$registerTextContentProvider(E,C);let S;if(typeof w.onDidChange=="function"){let c;S=w.onDidChange(async m=>{if(m.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;c&&await c;const a=this.$provideTextDocumentContent(E,m).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(m);if(!n)return;const r=(0,b.$1e)(i);if(!n.equalLines(r))return this.c.$onVirtualDocumentChange(m,i)}).catch(D.$1).finally(()=>{c===a&&(c=void 0)});c=a})}return new h.$lL(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(C,w){const E=this.b.get(C);return E?Promise.resolve(E.provideTextDocumentContent(N.URI.revive(w),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.$9gc=k}),define(ke[148],Se([1,0,61,16,12,176,126,7,19]),function($e,e,D,N,h,P,A,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=e.$rN=e.$qN=void 0;const k=new Map;function R(S,c){c?k.set(S,c):k.delete(S)}e.$qN=R;function C(S){return k.get(S)}class w extends P.$nv{constructor(c,m,a,i,n,r,s,t){super(m,a,i,n),this.c=c,this.m=r,this.q=s,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(c){return(0,b.$ub)(this.f,c)}get document(){if(!this.a){const c=this;this.a={get uri(){return c.d},get fileName(){return c.d.fsPath},get isUntitled(){return c.d.scheme===N.Schemas.untitled},get languageId(){return c.m},get version(){return c.h},get isClosed(){return c.b},get isDirty(){return c.q},save(){return c.r()},getText(m){return m?c.s(m):c.getText()},get eol(){return c.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return c.f.length},lineAt(m){return c.t(m)},offsetAt(m){return c.u(m)},positionAt(m){return c.v(m)},validateRange(m){return c.w(m)},validatePosition(m){return c.x(m)},getWordRangeAtPosition(m,a){return c.y(m,a)}}}return Object.freeze(this.a)}_acceptLanguageId(c){(0,D.ok)(!this.b),this.m=c}_acceptIsDirty(c){(0,D.ok)(!this.b),this.q=c}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(c){const m=this.w(c);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const a=this.g,i=m.start.line,n=m.end.line,r=[];r.push(this.f[i].substring(m.start.character));for(let s=i+1;s<n;s++)r.push(this.f[s]);return r.push(this.f[n].substring(0,m.end.character)),r.join(a)}t(c){let m;if(c instanceof p.$mL?m=c.line:typeof c=="number"&&(m=c),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new E(m,this.f[m],m===this.f.length-1)}u(c){return c=this.x(c),this.l(),this.j.getPrefixSum(c.line-1)+c.character}v(c){c=Math.floor(c),c=Math.max(0,c),this.l();const m=this.j.getIndexOf(c),a=this.f[m.index].length;return new p.$mL(m.index,Math.min(m.remainder,a))}w(c){if(!(c instanceof p.$nL))throw new Error("Invalid argument");const m=this.x(c.start),a=this.x(c.end);return m===c.start&&a===c.end?c:new p.$nL(m.line,m.character,a.line,a.character)}x(c){if(!(c instanceof p.$mL))throw new Error("Invalid argument");if(this.f.length===0)return c.with(0,0);let{line:m,character:a}=c,i=!1;if(m<0)m=0,a=0,i=!0;else if(m>=this.f.length)m=this.f.length-1,a=this.f[m].length,i=!0;else{const n=this.f[m].length;a<0?(a=0,i=!0):a>n&&(a=n,i=!0)}return i?new p.$mL(m,a):c}y(c,m){const a=this.x(c);if(!m)m=C(this.m);else if((0,h.$Ze)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const i=(0,A.$zs)(a.character+1,(0,A.$xs)(m),this.f[a.line],0);if(i)return new p.$nL(a.line,i.startColumn-1,a.line,i.endColumn-1)}}e.$rN=w;class E{constructor(c,m,a){this.a=c,this.b=m,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$nL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$nL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$sN=E}),define(ke[314],Se([1,0,6,7]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=void 0;class h{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(D.$jL.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,p,b){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(A);if(!k)throw new Error("Embedding vector provider not found");const R=await k.provideEmbeddingVector(p,b);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,p,b){const k=this.b;return this.b++,this.a.set(k,b),this.c.$registerAiEmbeddingVectorProvider(p,k),new N.$lL(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$$gc=h}),define(ke[69],Se([1,0,6,32,7,21,5,20,59,3,8,23,16]),function($e,e,D,N,h,P,A,p,b,k,R,C,w){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=e.$lgc=void 0;let S=E=class{constructor(m,a){this.b=new Map,this.c=new R.$eh,this.a=m.getProxy(D.$jL.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let r;const s=i.b.get(n.scheme);return s?(await i.a.$ensureActivation(n.scheme),r=await s.impl.stat(n)):r=await i.a.$stat(n),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===N.FilePermission.Readonly?1:void 0}}catch(r){E.e(r)}},async readDirectory(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(r){return E.e(r)}},async createDirectory(n){try{const r=i.b.get(n.scheme);return r&&!r.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(r.impl,r.extUri,n)):await i.a.$mkdir(n)}catch(r){return E.e(r)}},async readFile(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(r){return E.e(r)}},async writeFile(n,r){try{const s=i.b.get(n.scheme);return s&&!s.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(s.impl,s.extUri,s.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(s.impl.writeFile(n,r,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,P.$ke.wrap(r))}catch(s){return E.e(s)}},async delete(n,r){try{const s=i.b.get(n.scheme);return s&&!s.isReadonly&&!r?.useTrash?(await i.a.$ensureActivation(n.scheme),await s.impl.delete(n,{recursive:!1,...r})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(s){return E.e(s)}},async rename(n,r,s){try{return await i.a.$rename(n,r,{overwrite:!1,...s})}catch(t){return E.e(t)}},async copy(n,r,s){try{return await i.a.$copy(n,r,{overwrite:!1,...s})}catch(t){return E.e(t)}},isWritableFileSystem(n){const r=a.getCapabilities(n);if(typeof r=="number")return!(r&2048)}})}async d(m,a,i){const n=[];for(;!a.isEqual(i,a.dirname(i));)try{if(!((await m.stat(i)).type&N.FileType.Directory))throw h.$zM.FileExists(`Unable to create folder '${i.scheme===w.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(N.$Ik(r)!==N.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(a.basename(i)),i=a.dirname(i)}for(let r=n.length-1;r>=0;r--){i=a.joinPath(i,n[r]);try{await m.createDirectory(i)}catch(s){if(N.$Ik(s)!==N.FileSystemProviderErrorCode.FileExists)throw s}}}static e(m){if(m instanceof h.$zM)throw m;if(m instanceof N.$Ek)switch(m.code){case N.FileSystemProviderErrorCode.FileExists:throw h.$zM.FileExists(m.message);case N.FileSystemProviderErrorCode.FileNotFound:throw h.$zM.FileNotFound(m.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw h.$zM.FileNotADirectory(m.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw h.$zM.FileIsADirectory(m.message);case N.FileSystemProviderErrorCode.NoPermissions:throw h.$zM.NoPermissions(m.message);case N.FileSystemProviderErrorCode.Unavailable:throw h.$zM.Unavailable(m.message);default:throw new h.$zM(m.message,m.name)}if(!(m instanceof Error))throw new h.$zM(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw h.$zM.Unavailable(m.message);switch(m.name){case N.FileSystemProviderErrorCode.FileExists:throw h.$zM.FileExists(m.message);case N.FileSystemProviderErrorCode.FileNotFound:throw h.$zM.FileNotFound(m.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw h.$zM.FileNotADirectory(m.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw h.$zM.FileIsADirectory(m.message);case N.FileSystemProviderErrorCode.NoPermissions:throw h.$zM.NoPermissions(m.message);case N.FileSystemProviderErrorCode.Unavailable:throw h.$zM.Unavailable(m.message);default:throw new h.$zM(m.message,m.name)}}addFileSystemProvider(m,a,i){return this.b.set(m,{impl:a,extUri:i?.isCaseSensitive?C.$yg:C.$Ag,isReadonly:!!i?.isReadonly}),(0,k.$Rc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??C.$yg}};e.$lgc=S,e.$lgc=S=E=Ge([Ve(0,p.$oN),Ve(1,b.$Yfc)],S),e.$mgc=(0,A.$8h)("IExtHostConsumerFileSystem")}),define(ke[315],Se([1,0,6,7]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=void 0;class h{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(D.$jL.MainThreadIssueReporter)}async $getIssueReporterUri(A,p){if(this.a.size===0)throw new Error("No issue request handlers registered");const b=this.a.get(A);if(!b)throw new Error("Issue request handler not found");const k=await b.handleIssueUrlRequest();if(!k)throw new Error("Issue request handler returned no result");return k}async $getIssueReporterData(A,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const b=this.b.get(A);if(!b)throw new Error("Issue data provider not found");const k=await b.provideIssueData(p);if(!k)throw new Error("Issue data provider returned no result");return k}async $getIssueReporterTemplate(A,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const b=this.b.get(A);if(!b)throw new Error("Issue data provider not found");const k=await b.provideIssueTemplate(p);if(!k)throw new Error("Issue template provider returned no result");return k}registerIssueUriRequestHandler(A,p){const b=A.identifier.value;return this.a.set(b,p),this.c.$registerIssueUriRequestHandler(b),new N.$lL(()=>{this.c.$unregisterIssueUriRequestHandler(b),this.a.delete(b)})}registerIssueDataProvider(A,p){const b=A.identifier.value;return this.b.set(b,p),this.c.$registerIssueDataProvider(b),new N.$lL(()=>{this.c.$unregisterIssueDataProvider(b),this.b.delete(b)})}}e.$phc=h}),define(ke[94],Se([1,0,5,27,13,69,2]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=e.$ngc=void 0,e.$ngc=(0,D.$8h)("IExtensionStoragePaths");let p=class{constructor(k,R,C){this.d=R,this.f=C,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(w=>this.c=w)}async g(k){return A.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,R=await this.g(k);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(k){if(this.c)return A.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return A.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$ogc=p,e.$ogc=p=Ge([Ve(0,N.$EN),Ve(1,h.$pj),Ve(2,P.$mgc)],p)}),define(ke[316],Se([1,0,7,20,4]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=void 0;let P=class{constructor(p){this.a=new D.$JM(D.ColorThemeKind.Dark),this.b=new h.$Wd}get activeColorTheme(){return this.a}$onColorThemeChange(p){let b;switch(p){case"light":b=D.ColorThemeKind.Light;break;case"hcDark":b=D.ColorThemeKind.HighContrast;break;case"hcLight":b=D.ColorThemeKind.HighContrastLight;break;default:b=D.ColorThemeKind.Dark}this.a=new D.$JM(b),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Shc=P,e.$Shc=P=Ge([Ve(0,N.$oN)],P)}),define(ke[70],Se([1,0,22,4,3,220,5,13,89,6,27,20,7]),function($e,e,D,N,h,P,A,p,b,k,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ezb=e.$dzb=e.TunnelDtoConverter=void 0;class E extends b.$Lv{}var S;(function(m){function a(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?b.TunnelPrivacyId.Public:b.TunnelPrivacyId.Private),protocol:n.protocol}}m.fromApiTunnel=a;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==b.TunnelPrivacyId.ConstantPrivate&&n.privacy!==b.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}m.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$dzb=(0,A.$8h)("IExtHostTunnelService");let c=class extends h.$Tc{constructor(a,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$Wd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(k.$jL.MainThreadTunnelService)}async openTunnel(a,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,a.displayName);if(n){const r=new E(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,i){const n=this.u();return this.r.set(n,{selector:a,provider:i}),this.a.$registerPortsAttributesProvider(a,n),new w.$lL(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(a,i,n,r,s){const t=[];for(const o of a){const d=this.r.get(o);if(!d)return[];t.push(...await Promise.all(i.map(async l=>{let u;try{u=await d.provider.providePortAttributes({port:l,pid:n,commandLine:r},s)}catch{u=await d.provider.providePortAttributes(l,n,r,s)}return{providedAttributes:u,port:l}})))}const g=t.filter(o=>!!o.providedAttributes);return g.length>0?g.map(o=>({autoForwardAction:o.providedAttributes.autoForwardAction,port:o.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,s)=>await a.provideTunnel(r,s,new D.$7d().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,h.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,i){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const n=a.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let r=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:P.localize(0,null),themeIcon:"lock"},{id:"public",label:P.localize(1,null),themeIcon:"eye"}]);const s=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(s)}}else this.b=void 0;return(0,h.$Rc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,i){if(this.g.has(a.host)){const n=this.g.get(a.host);n.has(a.port)&&(i&&n.get(a.port).disposeListener.dispose(),await n.get(a.port).tunnel.dispose(),n.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(a,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const r=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const s=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:r,disposeListener:s}),S.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(a){const i=await Promise.all(a.map(r=>this.f(r.host,r.port,r.detail??""))),n=a.filter((r,s)=>i[s]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(r=>r.port).join(", ")} to ${n.map(r=>r.port).join(", ")}`),n}};e.$ezb=c,e.$ezb=c=Ge([Ve(0,C.$oN),Ve(1,R.$EN),Ve(2,p.$pj)],c)}),define(ke[15],Se([1,0,19,21,165,74,80,28,160,56,101,24,18,2,29,83,135,141,139,118,67,90,290,26,7]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i,n,r,s,t,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatAgentRequest=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$nN=e.$mN=e.MarkdownString=e.$lN=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var d;(function(Me){function Fe(ce){const{selectionStartLineNumber:Te,selectionStartColumn:Be,positionLineNumber:xe,positionColumn:Ke}=ce,ut=new o.$mL(Te-1,Be-1),vt=new o.$mL(xe-1,Ke-1);return new o.$oL(ut,vt)}Me.to=Fe;function De(ce){const{anchor:Te,active:Be}=ce;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Me.from=De})(d||(e.Selection=d={}));var l;(function(Me){function Fe(ce){if(!ce)return;const{start:Te,end:Be}=ce;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Me.from=Fe;function De(ce){if(!ce)return;const{startLineNumber:Te,startColumn:Be,endLineNumber:xe,endColumn:Ke}=ce;return new o.$nL(Te-1,Be-1,xe-1,Ke-1)}Me.to=De})(l||(e.Range=l={}));var u;(function(Me){function Fe(De){return new o.$xL(E.URI.revive(De.uri),l.to(De.range))}Me.to=Fe})(u||(e.Location=u={}));var v;(function(Me){function Fe(De){switch(De){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Me.to=Fe})(v||(e.TokenType=v={}));var I;(function(Me){function Fe(ce){return new o.$mL(ce.lineNumber-1,ce.column-1)}Me.to=Fe;function De(ce){return{lineNumber:ce.line+1,column:ce.character+1}}Me.from=De})(I||(e.Position=I={}));var $;(function(Me){function Fe(Te,Be,xe){return(0,D.$Hb)((0,D.$3b)(Te).map(Ke=>De(Ke,Be,xe)))}Me.from=Fe;function De(Te,Be,xe){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:xe?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:ce(Te.scheme,Be),pattern:se.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:xe?.isBuiltin}}function ce(Te,Be){return Be&&typeof Te=="string"?Be.transformOutgoingScheme(Te):Te}})($||(e.DocumentSelector=$={}));var f;(function(Me){function Fe(ce){switch(ce){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Me.from=Fe;function De(ce){switch(ce){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Me.to=De})(f||(e.DiagnosticTag=f={}));var y;(function(Me){function Fe(ce){let Te;return ce.code&&((0,w.$Jf)(ce.code)||(0,w.$Nf)(ce.code)?Te=String(ce.code):Te={value:String(ce.code.value),target:ce.code.target}),{...l.from(ce.range),message:ce.message,source:ce.source,code:Te,severity:T.from(ce.severity),relatedInformation:ce.relatedInformation&&ce.relatedInformation.map(L.from),tags:Array.isArray(ce.tags)?(0,D.$Hb)(ce.tags.map(f.from)):void 0}}Me.from=Fe;function De(ce){const Te=new o.$zL(l.to(ce),ce.message,T.to(ce.severity));return Te.source=ce.source,Te.code=(0,w.$Jf)(ce.code)?ce.code:ce.code?.value,Te.relatedInformation=ce.relatedInformation&&ce.relatedInformation.map(L.to),Te.tags=ce.tags&&(0,D.$Hb)(ce.tags.map(f.to)),Te}Me.to=De})(y||(e.Diagnostic=y={}));var L;(function(Me){function Fe(ce){return{...l.from(ce.location.range),message:ce.message,resource:ce.location.uri}}Me.from=Fe;function De(ce){return new o.$yL(new o.$xL(ce.resource,l.to(ce)),ce.message)}Me.to=De})(L||(e.DiagnosticRelatedInformation=L={}));var T;(function(Me){function Fe(ce){switch(ce){case o.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}Me.from=Fe;function De(ce){switch(ce){case m.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Me.to=De})(T||(e.DiagnosticSeverity=T={}));var U;(function(Me){function Fe(ce){return typeof ce=="number"&&ce>=o.ViewColumn.One?ce-1:ce===o.ViewColumn.Beside?t.$gD:t.$fD}Me.from=Fe;function De(ce){if(typeof ce=="number"&&ce>=0)return ce+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=De})(U||(e.ViewColumn=U={}));function j(Me){return typeof Me.range<"u"}function F(Me){return Me.length===0?!0:!!j(Me[0])}e.$lN=F;var M;(function(Me){function Fe(Ke){return Ke.map(Me.from)}Me.fromMany=Fe;function De(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function ce(Ke){let ut;if(De(Ke)){const{language:Ct,value:pt}=Ke;ut={value:"```"+Ct+`
`+pt+"\n```\n"}}else o.$ML.isMarkdownString(Ke)?ut={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?ut={value:Ke}:ut={value:""};const vt=Object.create(null);ut.uris=vt;const Kt=Ct=>{try{let pt=E.URI.parse(Ct,!0);pt=pt.with({query:Te(pt.query,vt)}),vt[Ct]=pt}catch{}return""},St=new b.marked.Renderer;return St.link=Kt,St.image=Ct=>typeof Ct=="string"?Kt(A.$rk(Ct).href):"",(0,b.marked)(ut.value,{renderer:St}),ut}Me.from=ce;function Te(Ke,ut){if(!Ke)return Ke;let vt;try{vt=(0,k.$Dh)(Ke)}catch{}if(!vt)return Ke;let Kt=!1;return vt=(0,C.$An)(vt,St=>{if(E.URI.isUri(St)){const Ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Ct]=St,Kt=!0,Ct}else return}),Kt?JSON.stringify(vt):Ke}function Be(Ke){const ut=new o.$ML(Ke.value,Ke.supportThemeIcons);return ut.isTrusted=Ke.isTrusted,ut.supportHtml=Ke.supportHtml,ut.baseUri=Ke.baseUri?E.URI.from(Ke.baseUri):void 0,ut}Me.to=Be;function xe(Ke){if(Ke)return typeof Ke=="string"?Ke:Me.from(Ke)}Me.fromStrict=xe})(M||(e.MarkdownString=M={}));function O(Me){return F(Me)?Me.map(Fe=>({range:l.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?M.fromMany(Fe.hoverMessage):Fe.hoverMessage?M.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Me.map(Fe=>({range:l.from(Fe)}))}e.$mN=O;function z(Me){return typeof Me>"u"?Me:typeof Me=="string"?E.URI.file(Me):Me}e.$nN=z;var J;(function(Me){function Fe(De){return typeof De>"u"?De:{contentText:De.contentText,contentIconPath:De.contentIconPath?z(De.contentIconPath):void 0,border:De.border,borderColor:De.borderColor,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,color:De.color,backgroundColor:De.backgroundColor,margin:De.margin,width:De.width,height:De.height}}Me.from=Fe})(J||(e.ThemableDecorationAttachmentRenderOptions=J={}));var te;(function(Me){function Fe(De){return typeof De>"u"?De:{backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?z(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?J.from(De.before):void 0,after:De.after?J.from(De.after):void 0}}Me.from=Fe})(te||(e.ThemableDecorationRenderOptions=te={}));var x;(function(Me){function Fe(De){if(typeof De>"u")return De;switch(De){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Fe})(x||(e.DecorationRangeBehavior=x={}));var X;(function(Me){function Fe(De){return{isWholeLine:De.isWholeLine,rangeBehavior:De.rangeBehavior?x.from(De.rangeBehavior):void 0,overviewRulerLane:De.overviewRulerLane,light:De.light?te.from(De.light):void 0,dark:De.dark?te.from(De.dark):void 0,backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?z(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?J.from(De.before):void 0,after:De.after?J.from(De.after):void 0}}Me.from=Fe})(X||(e.DecorationRenderOptions=X={}));var Z;(function(Me){function Fe(ce){return{text:ce.newText,eol:ce.newEol&&Le.from(ce.newEol),range:l.from(ce.range)}}Me.from=Fe;function De(ce){const Te=new o.$sL(l.to(ce.range),ce.text);return Te.newEol=typeof ce.eol>"u"?void 0:Le.to(ce.eol),Te}Me.to=De})(Z||(e.TextEdit=Z={}));var ae;(function(Me){function Fe(ce,Te){const Be={edits:[]};if(ce instanceof o.$vL){const xe=new p.$Bc;for(const Ke of ce._allEntries())Ke._type===1&&E.URI.isUri(Ke.to)&&Ke.from===void 0&&xe.add(Ke.to);for(const Ke of ce._allEntries())if(Ke._type===1){let ut;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?ut={type:"base64",value:(0,N.$Ee)(N.$ke.wrap(Ke.options.contents))}:ut={type:"dataTransferItem",id:Ke.options.contents._itemId}),Be.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:ut},metadata:Ke.metadata})}else Ke._type===2?Be.edits.push({resource:Ke.uri,textEdit:Z.from(Ke.edit),versionId:xe.has(Ke.uri)?void 0:Te?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?Be.edits.push({resource:Ke.uri,textEdit:{range:l.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:xe.has(Ke.uri)?void 0:Te?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?Be.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&Be.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(Dt.from)}})}return Be}Me.from=Fe;function De(ce){const Te=new o.$vL,Be=new p.$Ac;for(const xe of ce.edits)if(xe.textEdit){const Ke=xe,ut=E.URI.revive(Ke.resource),vt=l.to(Ke.textEdit.range),Kt=Ke.textEdit.text,St=Ke.textEdit.insertAsSnippet;let Ct;St?Ct=o.$uL.replace(vt,new o.$wL(Kt)):Ct=o.$sL.replace(vt,Kt);const pt=Be.get(ut);pt?pt.push(Ct):Be.set(ut,[Ct])}else Te.renameFile(E.URI.revive(xe.oldResource),E.URI.revive(xe.newResource),xe.options);for(const[xe,Ke]of Be)Te.set(xe,Ke);return Te}Me.to=De})(ae||(e.WorkspaceEdit=ae={}));var _;(function(Me){const Fe=Object.create(null);Fe[o.SymbolKind.File]=0,Fe[o.SymbolKind.Module]=1,Fe[o.SymbolKind.Namespace]=2,Fe[o.SymbolKind.Package]=3,Fe[o.SymbolKind.Class]=4,Fe[o.SymbolKind.Method]=5,Fe[o.SymbolKind.Property]=6,Fe[o.SymbolKind.Field]=7,Fe[o.SymbolKind.Constructor]=8,Fe[o.SymbolKind.Enum]=9,Fe[o.SymbolKind.Interface]=10,Fe[o.SymbolKind.Function]=11,Fe[o.SymbolKind.Variable]=12,Fe[o.SymbolKind.Constant]=13,Fe[o.SymbolKind.String]=14,Fe[o.SymbolKind.Number]=15,Fe[o.SymbolKind.Boolean]=16,Fe[o.SymbolKind.Array]=17,Fe[o.SymbolKind.Object]=18,Fe[o.SymbolKind.Key]=19,Fe[o.SymbolKind.Null]=20,Fe[o.SymbolKind.EnumMember]=21,Fe[o.SymbolKind.Struct]=22,Fe[o.SymbolKind.Event]=23,Fe[o.SymbolKind.Operator]=24,Fe[o.SymbolKind.TypeParameter]=25;function De(Te){return typeof Fe[Te]=="number"?Fe[Te]:6}Me.from=De;function ce(Te){for(const Be in Fe)if(Fe[Be]===Te)return Number(Be);return o.SymbolKind.Property}Me.to=ce})(_||(e.SymbolKind=_={}));var ge;(function(Me){function Fe(ce){switch(ce){case o.SymbolTag.Deprecated:return 1}}Me.from=Fe;function De(ce){switch(ce){case 1:return o.SymbolTag.Deprecated}}Me.to=De})(ge||(e.SymbolTag=ge={}));var ne;(function(Me){function Fe(ce){return{name:ce.name,kind:_.from(ce.kind),tags:ce.tags&&ce.tags.map(ge.from),containerName:ce.containerName,location:he.from(ce.location)}}Me.from=Fe;function De(ce){const Te=new o.$DL(ce.name,_.to(ce.kind),ce.containerName,he.to(ce.location));return Te.tags=ce.tags&&ce.tags.map(ge.to),Te}Me.to=De})(ne||(e.WorkspaceSymbol=ne={}));var K;(function(Me){function Fe(ce){const Te={name:ce.name||"!!MISSING: name!!",detail:ce.detail,range:l.from(ce.range),selectionRange:l.from(ce.selectionRange),kind:_.from(ce.kind),tags:ce.tags?.map(ge.from)??[]};return ce.children&&(Te.children=ce.children.map(Fe)),Te}Me.from=Fe;function De(ce){const Te=new o.$EL(ce.name,ce.detail,_.to(ce.kind),l.to(ce.range),l.to(ce.selectionRange));return(0,D.$Lb)(ce.tags)&&(Te.tags=ce.tags.map(ge.to)),ce.children&&(Te.children=ce.children.map(De)),Te}Me.to=De})(K||(e.DocumentSymbol=K={}));var W;(function(Me){function Fe(ce){const Te=new o.$IL(_.to(ce.kind),ce.name,ce.detail||"",E.URI.revive(ce.uri),l.to(ce.range),l.to(ce.selectionRange));return Te._sessionId=ce._sessionId,Te._itemId=ce._itemId,Te}Me.to=Fe;function De(ce,Te,Be){if(Te=Te??ce._sessionId,Be=Be??ce._itemId,Te===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Be,name:ce.name,detail:ce.detail,kind:_.from(ce.kind),uri:ce.uri,range:l.from(ce.range),selectionRange:l.from(ce.selectionRange),tags:ce.tags?.map(ge.from)}}Me.from=De})(W||(e.CallHierarchyItem=W={}));var re;(function(Me){function Fe(De){return new o.$JL(W.to(De.from),De.fromRanges.map(ce=>l.to(ce)))}Me.to=Fe})(re||(e.CallHierarchyIncomingCall=re={}));var ye;(function(Me){function Fe(De){return new o.$KL(W.to(De.to),De.fromRanges.map(ce=>l.to(ce)))}Me.to=Fe})(ye||(e.CallHierarchyOutgoingCall=ye={}));var he;(function(Me){function Fe(ce){return{range:ce.range&&l.from(ce.range),uri:ce.uri}}Me.from=Fe;function De(ce){return new o.$xL(E.URI.revive(ce.uri),l.to(ce.range))}Me.to=De})(he||(e.location=he={}));var fe;(function(Me){function Fe(ce){const Te=ce,Be=ce;return{originSelectionRange:Te.originSelectionRange?l.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Be.uri,range:l.from(Te.targetRange?Te.targetRange:Be.range),targetSelectionRange:Te.targetSelectionRange?l.from(Te.targetSelectionRange):void 0}}Me.from=Fe;function De(ce){return{targetUri:E.URI.revive(ce.uri),targetRange:l.to(ce.range),targetSelectionRange:ce.targetSelectionRange?l.to(ce.targetSelectionRange):void 0,originSelectionRange:ce.originSelectionRange?l.to(ce.originSelectionRange):void 0}}Me.to=De})(fe||(e.DefinitionLink=fe={}));var ue;(function(Me){function Fe(ce){return{range:l.from(ce.range),contents:M.fromMany(ce.contents)}}Me.from=Fe;function De(ce){return new o.$AL(ce.contents.map(M.to),l.to(ce.range))}Me.to=De})(ue||(e.Hover=ue={}));var me;(function(Me){function Fe(ce){return{range:l.from(ce.range),expression:ce.expression}}Me.from=Fe;function De(ce){return new o.$uM(l.to(ce.range),ce.expression)}Me.to=De})(me||(e.EvaluatableExpression=me={}));var V;(function(Me){function Fe(ce){if(ce instanceof o.$vM)return{type:"text",range:l.from(ce.range),text:ce.text};if(ce instanceof o.$wM)return{type:"variable",range:l.from(ce.range),variableName:ce.variableName,caseSensitiveLookup:ce.caseSensitiveLookup};if(ce instanceof o.$xM)return{type:"expression",range:l.from(ce.range),expression:ce.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Fe;function De(ce){switch(ce.type){case"text":return{range:l.to(ce.range),text:ce.text};case"variable":return{range:l.to(ce.range),variableName:ce.variableName,caseSensitiveLookup:ce.caseSensitiveLookup};case"expression":return{range:l.to(ce.range),expression:ce.expression}}}Me.to=De})(V||(e.InlineValue=V={}));var Y;(function(Me){function Fe(ce){return{frameId:ce.frameId,stoppedLocation:l.from(ce.stoppedLocation)}}Me.from=Fe;function De(ce){return new o.$yM(ce.frameId,l.to(ce.stoppedLocation))}Me.to=De})(Y||(e.InlineValueContext=Y={}));var de;(function(Me){function Fe(ce){return{range:l.from(ce.range),kind:ce.kind}}Me.from=Fe;function De(ce){return new o.$BL(l.to(ce.range),ce.kind)}Me.to=De})(de||(e.DocumentHighlight=de={}));var we;(function(Me){function Fe(ce){return{uri:ce.uri,highlights:ce.highlights.map(de.from)}}Me.from=Fe;function De(ce){return new o.$CL(E.URI.revive(ce.uri),ce.highlights.map(de.to))}Me.to=De})(we||(e.MultiDocumentHighlight=we={}));var Pe;(function(Me){function Fe(De){switch(De){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Me.to=Fe})(Pe||(e.CompletionTriggerKind=Pe={}));var ve;(function(Me){function Fe(De){return{triggerKind:Pe.to(De.triggerKind),triggerCharacter:De.triggerCharacter}}Me.to=Fe})(ve||(e.CompletionContext=ve={}));var Ce;(function(Me){function Fe(ce){switch(ce){case o.CompletionItemTag.Deprecated:return 1}}Me.from=Fe;function De(ce){switch(ce){case 1:return o.CompletionItemTag.Deprecated}}Me.to=De})(Ce||(e.CompletionItemTag=Ce={}));var B;(function(Me){const Fe=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function De(Be){return Fe.get(Be)??9}Me.from=De;const ce=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Te(Be){return ce.get(Be)??o.CompletionItemKind.Property}Me.to=Te})(B||(e.CompletionItemKind=B={}));var Q;(function(Me){function Fe(De,ce){const Te=new o.$SL(De.label);return Te.insertText=De.insertText,Te.kind=B.to(De.kind),Te.tags=De.tags?.map(Ce.to),Te.detail=De.detail,Te.documentation=A.$lk(De.documentation)?M.to(De.documentation):De.documentation,Te.sortText=De.sortText,Te.filterText=De.filterText,Te.preselect=De.preselect,Te.commitCharacters=De.commitCharacters,S.$Ws.isIRange(De.range)?Te.range=l.to(De.range):typeof De.range=="object"&&(Te.range={inserting:l.to(De.range.insert),replacing:l.to(De.range.replace)}),Te.keepWhitespace=typeof De.insertTextRules>"u"?!1:!!(De.insertTextRules&1),typeof De.insertTextRules<"u"&&De.insertTextRules&4?Te.insertText=new o.$wL(De.insertText):(Te.insertText=De.insertText,Te.textEdit=Te.range instanceof o.$nL?new o.$sL(Te.range,Te.insertText):void 0),De.additionalTextEdits&&De.additionalTextEdits.length>0&&(Te.additionalTextEdits=De.additionalTextEdits.map(Be=>Z.to(Be))),Te.command=ce&&De.command?ce.fromInternal(De.command):void 0,Te}Me.to=Fe})(Q||(e.CompletionItem=Q={}));var ee;(function(Me){function Fe(ce){if(typeof ce.label!="string"&&!Array.isArray(ce.label))throw new TypeError("Invalid label");return{label:ce.label,documentation:M.fromStrict(ce.documentation)}}Me.from=Fe;function De(ce){return{label:ce.label,documentation:A.$lk(ce.documentation)?M.to(ce.documentation):ce.documentation}}Me.to=De})(ee||(e.ParameterInformation=ee={}));var H;(function(Me){function Fe(ce){return{label:ce.label,documentation:M.fromStrict(ce.documentation),parameters:Array.isArray(ce.parameters)?ce.parameters.map(ee.from):[],activeParameter:ce.activeParameter}}Me.from=Fe;function De(ce){return{label:ce.label,documentation:A.$lk(ce.documentation)?M.to(ce.documentation):ce.documentation,parameters:Array.isArray(ce.parameters)?ce.parameters.map(ee.to):[],activeParameter:ce.activeParameter}}Me.to=De})(H||(e.SignatureInformation=H={}));var oe;(function(Me){function Fe(ce){return{activeSignature:ce.activeSignature,activeParameter:ce.activeParameter,signatures:Array.isArray(ce.signatures)?ce.signatures.map(H.from):[]}}Me.from=Fe;function De(ce){return{activeSignature:ce.activeSignature,activeParameter:ce.activeParameter,signatures:Array.isArray(ce.signatures)?ce.signatures.map(H.to):[]}}Me.to=De})(oe||(e.SignatureHelp=oe={}));var le;(function(Me){function Fe(De,ce){const Te=new o.$RL(I.to(ce.position),typeof ce.label=="string"?ce.label:ce.label.map(Re.to.bind(void 0,De)),ce.kind&&je.to(ce.kind));return Te.textEdits=ce.textEdits&&ce.textEdits.map(Z.to),Te.tooltip=A.$lk(ce.tooltip)?M.to(ce.tooltip):ce.tooltip,Te.paddingLeft=ce.paddingLeft,Te.paddingRight=ce.paddingRight,Te}Me.to=Fe})(le||(e.InlayHint=le={}));var Re;(function(Me){function Fe(De,ce){const Te=new o.$QL(ce.label);return Te.tooltip=A.$lk(ce.tooltip)?M.to(ce.tooltip):ce.tooltip,c.Command.is(ce.command)&&(Te.command=De.fromInternal(ce.command)),ce.location&&(Te.location=he.to(ce.location)),Te}Me.to=Fe})(Re||(e.InlayHintLabelPart=Re={}));var je;(function(Me){function Fe(ce){return ce}Me.from=Fe;function De(ce){return ce}Me.to=De})(je||(e.InlayHintKind=je={}));var He;(function(Me){function Fe(ce){return{range:l.from(ce.range),url:ce.target,tooltip:ce.tooltip}}Me.from=Fe;function De(ce){let Te;if(ce.url)try{Te=typeof ce.url=="string"?E.URI.parse(ce.url,!0):E.URI.revive(ce.url)}catch{}return new o.$XL(l.to(ce.range),Te)}Me.to=De})(He||(e.DocumentLink=He={}));var Qe;(function(Me){function Fe(ce){const Te=new o.$1L(ce.label);return ce.textEdit&&(Te.textEdit=Z.to(ce.textEdit)),ce.additionalTextEdits&&(Te.additionalTextEdits=ce.additionalTextEdits.map(Be=>Z.to(Be))),Te}Me.to=Fe;function De(ce){return{label:ce.label,textEdit:ce.textEdit?Z.from(ce.textEdit):void 0,additionalTextEdits:ce.additionalTextEdits?ce.additionalTextEdits.map(Te=>Z.from(Te)):void 0}}Me.from=De})(Qe||(e.ColorPresentation=Qe={}));var _e;(function(Me){function Fe(ce){return new o.$YL(ce[0],ce[1],ce[2],ce[3])}Me.to=Fe;function De(ce){return[ce.red,ce.green,ce.blue,ce.alpha]}Me.from=De})(_e||(e.Color=_e={}));var at;(function(Me){function Fe(ce){return{range:l.from(ce.range)}}Me.from=Fe;function De(ce){return new o.$HL(l.to(ce.range))}Me.to=De})(at||(e.SelectionRange=at={}));var st;(function(Me){function Fe(De){switch(De){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Me.to=Fe})(st||(e.TextDocumentSaveReason=st={}));var rt;(function(Me){function Fe(ce){switch(ce){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.Interval:return 3;case o.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Fe;function De(ce){switch(ce){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 3:return o.TextEditorLineNumbersStyle.Interval;case 1:default:return o.TextEditorLineNumbersStyle.On}}Me.to=De})(rt||(e.TextEditorLineNumbersStyle=rt={}));var Le;(function(Me){function Fe(ce){if(ce===o.EndOfLine.CRLF)return 1;if(ce===o.EndOfLine.LF)return 0}Me.from=Fe;function De(ce){if(ce===1)return o.EndOfLine.CRLF;if(ce===0)return o.EndOfLine.LF}Me.to=De})(Le||(e.EndOfLine=Le={}));var ze;(function(Me){function Fe(De){if(typeof De=="object")return De.viewId;switch(De){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Fe})(ze||(e.ProgressLocation=ze={}));var Ae;(function(Me){function Fe(ce){const Te={start:ce.start+1,end:ce.end+1};return ce.kind&&(Te.kind=Ze.from(ce.kind)),Te}Me.from=Fe;function De(ce){const Te={start:ce.start-1,end:ce.end-1};return ce.kind&&(Te.kind=Ze.to(ce.kind)),Te}Me.to=De})(Ae||(e.FoldingRange=Ae={}));var Ze;(function(Me){function Fe(ce){if(ce)switch(ce){case o.FoldingRangeKind.Comment:return c.$Mt.Comment;case o.FoldingRangeKind.Imports:return c.$Mt.Imports;case o.FoldingRangeKind.Region:return c.$Mt.Region}}Me.from=Fe;function De(ce){if(ce)switch(ce.value){case c.$Mt.Comment.value:return o.FoldingRangeKind.Comment;case c.$Mt.Imports.value:return o.FoldingRangeKind.Imports;case c.$Mt.Region.value:return o.FoldingRangeKind.Region}}Me.to=De})(Ze||(e.FoldingRangeKind=Ze={}));var ie;(function(Me){function Fe(De){if(De)return{pinned:typeof De.preview=="boolean"?!De.preview:void 0,inactive:De.background,preserveFocus:De.preserveFocus,selection:typeof De.selection=="object"?l.from(De.selection):void 0,override:typeof De.override=="boolean"?i.$IE.id:void 0}}Me.from=Fe})(ie||(e.TextEditorOpenOptions=ie={}));var se;(function(Me){function Fe(Be){return Be instanceof o.$iM?Be.toJSON():typeof Be=="string"?Be:De(Be)||ce(Be)?new o.$iM(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Me.from=Fe;function De(Be){const xe=Be;return xe?E.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function ce(Be){const xe=Be;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Te(Be){return typeof Be=="string"?Be:new o.$iM(E.URI.revive(Be.baseUri),Be.pattern)}Me.to=Te})(se||(e.GlobPattern=se={}));var Ie;(function(Me){function Fe(De){if(De){if(Array.isArray(De))return De.map(Fe);if(typeof De=="string")return De;{const ce=De;return{language:ce.language,scheme:ce.scheme,pattern:se.from(ce.pattern),exclusive:ce.exclusive,notebookType:ce.notebookType}}}else return}Me.from=Fe})(Ie||(e.LanguageSelector=Ie={}));var qe;(function(Me){function Fe(ce){return!!ce&&typeof ce=="object"&&"documents"in ce&&Array.isArray(ce.documents)&&ce.documents.every(Te=>Array.isArray(Te)&&Te.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&E.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(xe=>xe instanceof o.$nL)))}Me.is=Fe;function De(ce){return{documents:ce.documents.map(Te=>Te.map(Be=>({uri:E.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(xe=>l.from(xe))})))}}Me.from=De})(qe||(e.MappedEditsContext=qe={}));var Ye;(function(Me){function Fe(ce){return{start:ce.start,end:ce.end}}Me.from=Fe;function De(ce){return new o.$KM(ce.start,ce.end)}Me.to=De})(Ye||(e.NotebookRange=Ye={}));var it;(function(Me){function Fe(ce){return{timing:typeof ce.runStartTime=="number"&&typeof ce.runEndTime=="number"?{startTime:ce.runStartTime,endTime:ce.runEndTime}:void 0,executionOrder:ce.executionOrder,success:ce.lastRunSuccess}}Me.to=Fe;function De(ce){return{lastRunSuccess:ce.success,runStartTime:ce.timing?.startTime,runEndTime:ce.timing?.endTime,executionOrder:ce.executionOrder}}Me.from=De})(it||(e.NotebookCellExecutionSummary=it={}));var nt;(function(Me){function Fe(De){if(De===n.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(De===n.NotebookCellExecutionState.Pending)return;if(De===n.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${De}`)}Me.to=Fe})(nt||(e.NotebookCellExecutionState=nt={}));var Oe;(function(Me){function Fe(ce){switch(ce){case o.NotebookCellKind.Markup:return n.CellKind.Markup;case o.NotebookCellKind.Code:default:return n.CellKind.Code}}Me.from=Fe;function De(ce){switch(ce){case n.CellKind.Markup:return o.NotebookCellKind.Markup;case n.CellKind.Code:default:return o.NotebookCellKind.Code}}Me.to=De})(Oe||(e.NotebookCellKind=Oe={}));var yt;(function(Me){function Fe(ce){const Te={metadata:ce.metadata??Object.create(null),cells:[]};for(const Be of ce.cells)o.$LM.validate(Be),Te.cells.push(Dt.from(Be));return Te}Me.from=Fe;function De(ce){const Te=new o.$MM(ce.cells.map(Dt.to));return(0,w.$Wf)(ce.metadata)||(Te.metadata=ce.metadata),Te}Me.to=De})(yt||(e.NotebookData=yt={}));var Dt;(function(Me){function Fe(ce){return{cellKind:Oe.from(ce.kind),language:ce.languageId,mime:ce.mime,source:ce.value,metadata:ce.metadata,internalMetadata:it.from(ce.executionSummary??{}),outputs:ce.outputs?ce.outputs.map(Ft.from):[]}}Me.from=Fe;function De(ce){return new o.$LM(Oe.to(ce.cellKind),ce.source,ce.language,ce.mime,ce.outputs?ce.outputs.map(Ft.to):void 0,ce.metadata,ce.internalMetadata?it.to(ce.internalMetadata):void 0)}Me.to=De})(Dt||(e.NotebookCellData=Dt={}));var Tt;(function(Me){function Fe(ce){return{mime:ce.mime,valueBytes:N.$ke.wrap(ce.data)}}Me.from=Fe;function De(ce){return new o.$NM(ce.valueBytes.buffer,ce.mime)}Me.to=De})(Tt||(e.NotebookCellOutputItem=Tt={}));var Ft;(function(Me){function Fe(ce){return{outputId:ce.id,items:ce.items.map(Tt.from),metadata:ce.metadata}}Me.from=Fe;function De(ce){const Te=ce.items.map(Tt.to);return new o.$OM(Te,ce.outputId,ce.metadata)}Me.to=De})(Ft||(e.NotebookCellOutput=Ft={}));var Et;(function(Me){function Fe(Te){return ce(Te)?{include:se.from(Te.include)??void 0,exclude:se.from(Te.exclude)??void 0}:se.from(Te)??void 0}Me.from=Fe;function De(Te){return ce(Te)?{include:se.to(Te.include),exclude:se.to(Te.exclude)}:se.to(Te)}Me.to=De;function ce(Te){const Be=Te;return Be?!(0,w.$Sf)(Be.include)&&!(0,w.$Sf)(Be.exclude):!1}})(Et||(e.NotebookExclusiveDocumentPattern=Et={}));var Ht;(function(Me){function Fe(De,ce,Te){const Be=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{alignment:De.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:ce.toInternal(Be,Te),text:De.text,tooltip:De.tooltip,accessibilityInformation:De.accessibilityInformation,priority:De.priority}}Me.from=Fe})(Ht||(e.NotebookStatusBarItem=Ht={}));var Ot;(function(Me){function Fe(De,ce,Te){const Be=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{command:ce.toInternal(Be,Te),label:De.label,description:De.description,detail:De.detail,documentation:De.documentation}}Me.from=Fe})(Ot||(e.NotebookKernelSourceAction=Ot={}));var Yt;(function(Me){function Fe(De){return{transientOutputs:De?.transientOutputs??!1,transientCellMetadata:De?.transientCellMetadata??{},transientDocumentMetadata:De?.transientDocumentMetadata??{},cellContentMetadata:De?.cellContentMetadata??{}}}Me.from=Fe})(Yt||(e.NotebookDocumentContentOptions=Yt={}));var Vt;(function(Me){function Fe(ce){return{uri:ce.uri,provides:ce.provides}}Me.from=Fe;function De(ce){return new o.$QM(E.URI.revive(ce.uri),ce.provides)}Me.to=De})(Vt||(e.NotebookRendererScript=Vt={}));var Ut;(function(Me){function Fe(ce){return{message:M.fromStrict(ce.message)||"",type:0,expected:ce.expectedOutput,actual:ce.actualOutput,contextValue:ce.contextValue,location:ce.location&&{range:l.from(ce.location.range),uri:ce.location.uri}}}Me.from=Fe;function De(ce){const Te=new o.$WM(typeof ce.message=="string"?ce.message:M.to(ce.message));return Te.actualOutput=ce.actual,Te.expectedOutput=ce.expected,Te.contextValue=ce.contextValue,Te.location=ce.location?he.to(ce.location):void 0,Te}Me.to=De})(Ut||(e.TestMessage=Ut={}));var et;(function(Me){Me.namespace=s.$fK,Me.denamespace=s.$gK})(et||(e.TestTag=et={}));var Gt;(function(Me){function Fe(ce){const Te=(0,a.$kN)(ce).controllerId;return{extId:r.$bK.fromExtHostTestItem(ce,Te).toString(),label:ce.label,uri:E.URI.revive(ce.uri),busy:ce.busy,tags:ce.tags.map(Be=>et.namespace(Te,Be.id)),range:S.$Ws.lift(l.from(ce.range)),description:ce.description||null,sortText:ce.sortText||null,error:ce.error&&M.fromStrict(ce.error)||null}}Me.from=Fe;function De(ce){return{parent:void 0,error:void 0,id:r.$bK.fromString(ce.extId).localId,label:ce.label,uri:E.URI.revive(ce.uri),tags:(ce.tags||[]).map(Te=>{const{tagId:Be}=et.denamespace(Te);return new o.$XM(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(ce.range||void 0),canResolveChildren:!1,busy:ce.busy,description:ce.description||void 0,sortText:ce.sortText||void 0}}Me.toPlain=De})(Gt||(e.TestItem=Gt={})),function(Me){function Fe(ce){return{id:ce.id}}Me.from=Fe;function De(ce){return new o.$XM(ce.id)}Me.to=De}(et||(e.TestTag=et={}));var Jt;(function(Me){const Fe=(ce,Te)=>{const Be=[];for(const[Ke,ut]of Te)r.$bK.compare(ut.item.extId,Ke)===2&&(Te.delete(Ke),Be.push(ut));const xe={...Gt.toPlain(ce.item),parent:void 0,taskStates:ce.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(ut=>ut.type===0).map(Ut.to)})),children:Be.map(Ke=>Fe(Ke,Te))};for(const Ke of xe.children)Ke.parent=xe;return xe};function De(ce){const Te=[],Be=new Map;for(const xe of ce.items){Be.set(xe.item.extId,xe);const Ke=r.$bK.root(xe.item.extId);ce.request.targets.some(ut=>ut.controllerId===Ke&&ut.testIds.includes(xe.item.extId))&&Te.push(xe)}return{completedAt:ce.completedAt,results:Te.map(xe=>Fe(xe,Be))}}Me.to=De})(Jt||(e.TestResults=Jt={}));var ht;(function(Me){function Fe(Be){return{covered:Be.covered,total:Be.total}}function De(Be){return"line"in Be?I.from(Be):l.from(Be)}function ce(Be){return"branches"in Be?{count:Be.executed,location:De(Be.location),type:1,branches:Be.branches.length?Be.branches.map(xe=>({count:xe.executed,location:xe.location&&De(xe.location),label:xe.label})):void 0}:{type:0,name:Be.name,count:Be.executed,location:De(Be.location)}}Me.fromDetailed=ce;function Te(Be){return{uri:Be.uri,statement:Fe(Be.statementCoverage),branch:Be.branchCoverage&&Fe(Be.branchCoverage),function:Be.functionCoverage&&Fe(Be.functionCoverage),details:Be.detailedCoverage?.map(ce)}}Me.fromFile=Te})(ht||(e.TestCoverage=ht={}));var $t;(function(Me){function Fe(De){switch(De){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Me.to=Fe})($t||(e.CodeActionTriggerKind=$t={}));var Bt;(function(Me){function Fe(ce){const Te=new o.$4M(_.to(ce.kind),ce.name,ce.detail||"",E.URI.revive(ce.uri),l.to(ce.range),l.to(ce.selectionRange));return Te._sessionId=ce._sessionId,Te._itemId=ce._itemId,Te}Me.to=Fe;function De(ce,Te,Be){if(Te=Te??ce._sessionId,Be=Be??ce._itemId,Te===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Be,kind:_.from(ce.kind),name:ce.name,detail:ce.detail??"",uri:ce.uri,range:l.from(ce.range),selectionRange:l.from(ce.selectionRange),tags:ce.tags?.map(ge.from)}}Me.from=De})(Bt||(e.TypeHierarchyItem=Bt={}));var Qt;(function(Me){function Fe(De){if(De)return{value:De.value,tooltip:De.tooltip}}Me.from=Fe})(Qt||(e.ViewBadge=Qt={}));var kt;(function(Me){function Fe(Be,xe,Ke){const ut=xe.fileData;return ut?new o.$bM(new o.$cM(ut.name,E.URI.revive(ut.uri),ut.id,(0,P.$db)(()=>Ke(ut.id)))):Be===R.$hs.uriList&&xe.uriListData?new o.$aM(Te(xe.uriListData)):new o.$aM(xe.asString)}Me.to=Fe;async function De(Be,xe){const Ke=await xe.asString();if(Be===R.$hs.uriList)return{asString:Ke,fileData:void 0,uriListData:ce(Ke)};const ut=xe.asFile();return{asString:Ke,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}Me.from=De;function ce(Be){return h.$tt.split(Be).map(xe=>{if(xe.startsWith("#"))return xe;try{return E.URI.parse(xe)}catch{}return xe})}function Te(Be){return h.$tt.create(Be.map(xe=>typeof xe=="string"?xe:E.URI.revive(xe)))}})(kt||(e.DataTransferItem=kt={}));var ft;(function(Me){function Fe(ce,Te){const Be=ce.items.map(([xe,Ke])=>[xe,kt.to(xe,Ke,Te)]);return new o.$dM(Be)}Me.toDataTransfer=Fe;async function De(ce){const Te={items:[]},Be=[];for(const[xe,Ke]of ce)Be.push((async()=>{Te.items.push([xe,await kt.from(xe,Ke)])})());return await Promise.all(Be),Te}Me.from=De})(ft||(e.DataTransfer=ft={}));var It;(function(Me){function Fe(De){return{kind:"reply",message:De.message,title:De.title,tooltip:De.tooltip}}Me.from=Fe})(It||(e.ChatReplyFollowup=It={}));var _t;(function(Me){function Fe(De){return typeof De=="string"?{title:De,message:De,kind:"reply"}:"commandId"in De?{kind:"command",title:De.title??"",commandId:De.commandId??"",when:De.when??"",args:De.args}:It.from(De)}Me.from=Fe})(_t||(e.ChatFollowup=_t={}));var At;(function(Me){function Fe(ce){const Te=new o.$dN(Je.to(ce.role),ce.content);return Te.name=ce.name,Te}Me.to=Fe;function De(ce){return{role:Je.from(ce.role),content:ce.content,name:ce.name}}Me.from=De})(At||(e.ChatMessage=At={}));var Je;(function(Me){function Fe(ce){switch(ce){case 0:return o.ChatMessageRole.System;case 1:return o.ChatMessageRole.User;case 2:return o.ChatMessageRole.Assistant;case 3:return o.ChatMessageRole.Function}}Me.to=Fe;function De(ce){switch(ce){case o.ChatMessageRole.System:return 0;case o.ChatMessageRole.Assistant:return 2;case o.ChatMessageRole.Function:return 3;case o.ChatMessageRole.User:default:return 1}}Me.from=De})(Je||(e.ChatMessageRole=Je={}));var Mt;(function(Me){function Fe(Te){const Be={};for(const xe of Object.keys(Te))Be[xe]=Te[xe].map(Me.to);return Be}Me.objectTo=Fe;function De(Te){return{level:jt.to(Te.level),kind:Te.kind,value:(0,E.$vc)(Te.value)?E.URI.revive(Te.value):Te.value,description:Te.description}}Me.to=De;function ce(Te){return{level:jt.from(Te.level),kind:Te.kind,value:Te.value,description:Te.description}}Me.from=ce})(Mt||(e.ChatVariable=Mt={}));var jt;(function(Me){function Fe(ce){switch(ce){case"short":return o.ChatVariableLevel.Short;case"medium":return o.ChatVariableLevel.Medium;case"full":default:return o.ChatVariableLevel.Full}}Me.to=Fe;function De(ce){switch(ce){case o.ChatVariableLevel.Short:return"short";case o.ChatVariableLevel.Medium:return"medium";case o.ChatVariableLevel.Full:default:return"full"}}Me.from=De})(jt||(e.ChatVariableLevel=jt={}));var Zt;(function(Me){function Fe(De){switch(De){case 1:return o.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return o.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return o.InteractiveEditorResponseFeedbackKind.Undone;case 3:return o.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return o.InteractiveEditorResponseFeedbackKind.Bug}}Me.to=Fe})(Zt||(e.InteractiveEditorResponseFeedbackKind=Zt={}));var gt;(function(Me){function Fe(Te,Be){return"markdownContent"in Be?((0,g.$LF)(Te,"chatAgents2Additions"),{content:M.from(Be.markdownContent),kind:"markdownContent"}):"content"in Be?"vulnerabilities"in Be&&Be.vulnerabilities?((0,g.$LF)(Te,"chatAgents2Additions"),{content:Be.content,vulnerabilities:Be.vulnerabilities,kind:"vulnerability"}):typeof Be.content=="string"?{content:Be.content,kind:"content"}:((0,g.$LF)(Te,"chatAgents2Additions"),{content:M.from(Be.content),kind:"markdownContent"}):"documents"in Be?{documents:Be.documents.map(xe=>({uri:xe.uri,version:xe.version,ranges:xe.ranges.map(Ke=>l.from(Ke))})),kind:"usedContext"}:"reference"in Be?{reference:"uri"in Be.reference?{uri:Be.reference.uri,range:l.from(Be.reference.range)}:Be.reference,kind:"reference"}:"inlineReference"in Be?{inlineReference:"uri"in Be.inlineReference?{uri:Be.inlineReference.uri,range:l.from(Be.inlineReference.range)}:Be.inlineReference,name:Be.title,kind:"inlineReference"}:"agentName"in Be?((0,g.$LF)(Te,"chatAgents2Additions"),{agentName:Be.agentName,command:Be.command,kind:"agentDetection"}):"treeData"in Be?{treeData:Be.treeData,kind:"treeData"}:"message"in Be?{content:M.from(Be.message),kind:"progressMessage"}:void 0}Me.from=Fe;function De(Te){switch(Te.kind){case"markdownContent":case"inlineReference":case"treeData":return Me.to(Te);case"content":return{content:Te.content};case"usedContext":return{documents:Te.documents.map(Be=>({uri:E.URI.revive(Be.uri),version:Be.version,ranges:Be.ranges.map(xe=>l.to(xe))}))};case"reference":return{reference:(0,E.$vc)(Te.reference)?E.URI.revive(Te.reference):u.to(Te.reference)};case"agentDetection":return;case"progressMessage":return{message:Te.content.value};case"vulnerability":return{content:Te.content,vulnerabilities:Te.vulnerabilities};default:return}}Me.to=De;function ce(Te){switch(Te.kind){case"markdownContent":return{content:Te.content.value};case"inlineReference":return{inlineReference:(0,E.$vc)(Te.inlineReference)?E.URI.revive(Te.inlineReference):u.to(Te.inlineReference),title:Te.name};case"treeData":return{treeData:(0,k.$Eh)(Te.treeData)};default:return}}Me.toProgressContent=ce})(gt||(e.ChatResponseProgress=gt={}));var Nt;(function(Me){function Fe(De){return{prompt:De.message,variables:Mt.objectTo(De.variables),subCommand:De.command,agentId:De.agentId}}Me.to=Fe})(Nt||(e.ChatAgentRequest=Nt={}));var Pt;(function(Me){function Fe(De){return{label:De.label,values:De.values.map(Mt.from),insertText:De.insertText,detail:De.detail,documentation:De.documentation}}Me.from=Fe})(Pt||(e.ChatAgentCompletionItem=Pt={}));var Wt;(function(Me){function Fe(De,ce,Te){return"terminalCommand"in De?{terminalCommand:De.terminalCommand,shouldExecute:De.shouldExecute}:"uri"in De?{uri:De.uri}:ce.toInternal(De,Te)}Me.from=Fe})(Wt||(e.TerminalQuickFix=Wt={}))}),define(ke[317],Se([1,0,6,20,15]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=void 0;let P=class{constructor(p,b){this.a=p.getProxy(D.$jL.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>b.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,b,k){const R=h.WorkspaceEdit.from(p,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,k?.isRefactoring??!1)}};e.$8fc=P,e.$8fc=P=Ge([Ve(0,N.$oN)],P)}),define(ke[318],Se([1,0,53,3,6,15]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=void 0;class A{static{this.a=0}constructor(k,R){this.extension=k,this.provider=R,this.handle=A.a++}}class p{static{this.a=0}constructor(k){this.b=new Map,this.c=new Map,this.d=k.getProxy(h.$jL.MainThreadChat)}registerChatProvider(k,R,C){const w=new A(k,C);return this.b.set(w.handle,w),this.d.$registerChatProvider(w.handle,R),(0,N.$Rc)(()=>{this.d.$unregisterChatProvider(w.handle),this.b.delete(w.handle)})}transferChatSession(k,R){const C=D.Iterable.find(this.c.keys(),w=>this.c.get(w)===k)??0;typeof C=="number"&&this.d.$transferChatSession(C,R)}sendInteractiveRequestToProvider(k,R){this.d.$sendRequestToProvider(k,R)}async $prepareChat(k,R){const C=this.b.get(k);if(!C)return;const w=await C.provider.prepareSession(R);if(!w)return;const E=p.a++;return this.c.set(E,w),{id:E,requesterUsername:w.requester?.name,requesterAvatarIconUri:w.requester?.icon,responderUsername:w.responder?.name,responderAvatarIconUri:w.responder?.icon,inputPlaceholder:w.inputPlaceholder}}async $provideWelcomeMessage(k,R){const C=this.b.get(k);if(!C||!C.provider.provideWelcomeMessage)return;const w=await C.provider.provideWelcomeMessage(R);if(w)return w.map(E=>typeof E=="string"?E:Array.isArray(E)?E.map(S=>P.ChatReplyFollowup.from(S)):P.MarkdownString.from(E))}async $provideSampleQuestions(k,R){const C=this.b.get(k);if(!C||!C.provider.provideSampleQuestions)return;const w=await C.provider.provideSampleQuestions(R);if(w)return w?.map(E=>P.ChatReplyFollowup.from(E))}$releaseSession(k){this.c.delete(k)}}e.$9fc=p}),define(ke[319],Se([1,0,19,8,44,4,38,2,210,86,6,15,7,279,26]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=void 0;class c{static{this.a=0}constructor(i,n,r){this.j=n,this.k=r,this.b=new Map,this.g=new Map,this.i=new Map,this.d=i.getProxy(R.$jL.MainThreadChatAgents2)}createChatAgent(i,n,r){const s=c.a++,t=new m(i,n,this.d,s,r);return this.b.set(s,t),this.d.$registerAgent(s,n,{}),t.apiAgent}async $invokeAgent(i,n,r,s){this.g.delete(n.sessionId);const t=this.b.get(i);if(!t)throw new Error(`[CHAT](${i}) CANNOT invoke agent because the agent is not registered`);let g=!1;function o(){if(g)throw new Error("Only valid while executing the command")}const d=new N.$sh;s.onCancellationRequested(()=>d.complete()),this.j.allowListExtensionWhile(t.extension.identifier,d.p);const l=A.$Sd.create(!1);let u;try{const v=await this.l(t,n,r),I=t.invoke(C.ChatAgentRequest.to(n),{history:v},new k.$xv($=>{o(),typeof u>"u"&&"content"in $&&(u=l.elapsed());const f=C.ChatResponseProgress.from(t.extension,$);if(!f){this.k.error("Unknown progress type: "+JSON.stringify($));return}"placeholder"in $&&"resolvedContent"in $||this.d.$handleProgressChunk(n.requestId,f)}),s);return await(0,N.$Vg)(Promise.resolve(I).then($=>{if($){this.g.set(n.sessionId,$);let f=this.i.get(n.sessionId);f||(f=new Map,this.i.set(n.sessionId,f)),f.set(n.requestId,$);const y={firstProgress:u,totalElapsed:l.elapsed()};return{errorDetails:$.errorDetails,timings:y}}else this.g.delete(n.sessionId)}),s)}catch(v){return this.k.error(v,t.extension),{errorDetails:{message:(0,b.localize)(0,null,(0,h.$Si)(v)),responseIsIncomplete:!0}}}finally{g=!0,d.complete()}}async l(i,n,r){return(0,D.$Hb)(await Promise.all(r.history.map(async s=>{const t=n.agentId===s.request.agentId&&this.i.get(n.sessionId)?.get(s.request.requestId)||s.result;return{request:C.ChatAgentRequest.to(s.request),response:(0,D.$Hb)(s.response.map(g=>C.ChatResponseProgress.toProgressContent(g))),result:t}})))}$releaseSession(i){this.g.delete(i),this.i.delete(i)}async $provideSlashCommands(i,n){const r=this.b.get(i);return r?r.provideSlashCommands(n):[]}$provideFollowups(i,n,r){const s=this.b.get(i);if(!s)return Promise.resolve([]);const t=this.g.get(n);return t?s.provideFollowups(t,r):Promise.resolve([])}$acceptFeedback(i,n,r,s,t){const g=this.b.get(i);if(!g)return;const o=this.i.get(n)?.get(r);if(!o)return;let d;switch(s){case E.InteractiveSessionVoteDirection.Down:d=w.ChatAgentResultFeedbackKind.Unhelpful;break;case E.InteractiveSessionVoteDirection.Up:d=w.ChatAgentResultFeedbackKind.Helpful;break}g.acceptFeedback(Object.freeze(t?{result:o,kind:d,reportIssue:t}:{result:o,kind:d}))}$acceptAction(i,n,r,s){const t=this.b.get(i);if(!t)return;const g=this.i.get(n)?.get(r);g&&s.action.kind!=="vote"&&t.acceptAction(Object.freeze({action:s.action,result:g}))}async $invokeCompletionProvider(i,n,r){const s=this.b.get(i);return s?(await s.invokeCompletionProvider(n,r)).map(C.ChatAgentCompletionItem.from):[]}}e.$$fc=c;class m{constructor(i,n,r,s,t){this.extension=i,this.id=n,this.u=r,this.w=s,this.x=t,this.o=new P.$Wd,this.q=new P.$Wd}acceptFeedback(i){this.o.fire(i)}acceptAction(i){this.q.fire(i)}async invokeCompletionProvider(i,n){return this.t?await this.t.provider.provideCompletionItems(i,n)??[]:[]}async provideSlashCommands(i){if(!this.a)return[];const n=await this.a.provideSubCommands(i);return n?n.map(r=>({name:r.name,description:r.description,followupPlaceholder:r.followupPlaceholder,shouldRepopulate:r.shouldRepopulate,sampleRequest:r.sampleRequest})):[]}async provideFollowups(i,n){if(!this.b)return[];const r=await this.b.provideFollowups(i,n);return r?r.map(s=>C.ChatFollowup.from(s)):[]}get apiAgent(){let i=!1,n=!1;const r=()=>{i||n||(n=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.d??"",fullName:this.g,icon:this.i?this.i instanceof p.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof w.$gM?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.b!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:C.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:C.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.s}),n=!1}))},s=this;return{get name(){return s.id},get description(){return s.d??""},set description(t){s.d=t,r()},get fullName(){return s.g??s.extension.displayName??s.extension.name},set fullName(t){s.g=t,r()},get iconPath(){return s.i},set iconPath(t){s.i=t,r()},get subCommandProvider(){return s.a},set subCommandProvider(t){s.a=t,r()},get followupProvider(){return s.b},set followupProvider(t){s.b=t,r()},get isDefault(){return(0,S.$LF)(s.extension,"defaultChatAgent"),s.j},set isDefault(t){(0,S.$LF)(s.extension,"defaultChatAgent"),s.j=t,r()},get helpTextPrefix(){return(0,S.$LF)(s.extension,"defaultChatAgent"),s.k},set helpTextPrefix(t){if((0,S.$LF)(s.extension,"defaultChatAgent"),!s.j)throw new Error("helpTextPrefix is only available on the default chat agent");s.k=t,r()},get helpTextPostfix(){return(0,S.$LF)(s.extension,"defaultChatAgent"),s.l},set helpTextPostfix(t){if((0,S.$LF)(s.extension,"defaultChatAgent"),!s.j)throw new Error("helpTextPostfix is only available on the default chat agent");s.l=t,r()},get isSecondary(){return(0,S.$LF)(s.extension,"defaultChatAgent"),s.n},set isSecondary(t){(0,S.$LF)(s.extension,"defaultChatAgent"),s.n=t,r()},get sampleRequest(){return s.m},set sampleRequest(t){s.m=t,r()},get supportIssueReporting(){return(0,S.$LF)(s.extension,"chatAgents2Additions"),s.s},set supportIssueReporting(t){(0,S.$LF)(s.extension,"chatAgents2Additions"),s.s=t,r()},get onDidReceiveFeedback(){return s.o.event},set agentVariableProvider(t){if(s.t=t,t){if(!t.triggerCharacters.length)throw new Error("triggerCharacters are required");s.u.$registerAgentCompletionsProvider(s.w,t.triggerCharacters)}else s.u.$unregisterAgentCompletionsProvider(s.w)},get agentVariableProvider(){return s.t},onDidPerformAction:(0,S.$KF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){i=!0,s.a=void 0,s.b=void 0,s.o.dispose(),s.u.$unregisterAgent(s.w)}}}invoke(i,n,r,s){return this.x(i,n,r,s)}}}),define(ke[320],Se([1,0,22,3,6,15,86,25,8,4]),function($e,e,D,N,h,P,A,p,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0;class R{constructor(S,c){this.stream=new b.$yh,this.stream=c??new b.$yh;const m=this;this.apiObj={option:S,response:m.stream.asyncIterable}}}class C{constructor(S,c){this.a=new k.$Wd,this.b=new Map,this.c=new b.$yh,this.d=!1;const m=this;this.apiObject={result:S,response:m.c.asyncIterable,onDidStartResponseStream:m.a.event,cancel(){c.cancel()}},S.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,a]of this.b)a.stream.resolve();else this.c.resolve()})}handleFragment(S){if(this.d)return;let c=this.b.get(S.index);c||(this.b.size===0?c=new R(S.index,this.c):c=new R(S.index),this.b.set(S.index,c),this.a.fire(c.apiObj)),c.stream.emitOne(S.part)}}class w{static{this.a=1}constructor(S,c){this.d=c,this.c=new Map,this.e=new Map,this.f=new p.$pm,this.b=S.getProxy(h.$jL.MainThreadChatProvider)}registerProvider(S,c,m,a){const i=w.a++;return this.c.set(i,{extension:S,provider:m}),this.b.$registerProvider(i,c,{extension:S,model:a.name??""}),(0,N.$Rc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(S,c,m,a,i){const n=this.c.get(S);if(!n)return;const r=new A.$xv(async s=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${n.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(c,{index:s.index,part:s.part})});return n.provider.provideChatResponse(m.map(P.ChatMessage.to),a,r,i)}allowListExtensionWhile(S,c){this.f.set(S,c),c.finally(()=>this.f.delete(S))}async requestChatResponseProvider(S,c){if(!this.f.has(S))throw new Error("Extension is NOT allowed to make chat requests");const m=await this.b.$prepareChatAccess(c);if(!m)throw new Error(`ChatAccess '${c}' NOT found`);const a=this;return{get model(){return m.model},get isRevoked(){return!a.f.has(S)},makeRequest(i,n,r){if(!a.f.has(S))throw new Error("Access to chat has been revoked");const s=new D.$7d(r),t=Math.random()*1e6|0,g=a.b.$fetchResponse(S,c,t,i.map(P.ChatMessage.from),n??{},s.token),o=new C(g,s);return a.e.set(t,{res:o}),g.finally(()=>{a.e.delete(t)}),o.apiObject}}}async $handleResponseFragment(S,c){const m=this.e.get(S);m&&m.res.handleFragment(c)}}e.$0fc=w}),define(ke[321],Se([1,0,3,6,14,15]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;class A{static{this.a=0}constructor(b){this.b=new Map,this.c=b.getProxy(N.$jL.MainThreadChatVariables)}async $resolveVariable(b,k,R){const C=this.b.get(b);if(C)try{const w=await C.resolver.resolve(C.data.name,{prompt:k},R);if(w)return w.map(P.ChatVariable.from)}catch(w){(0,h.$2)(w)}}registerVariableResolver(b,k,R,C){const w=A.a++;return this.b.set(w,{extension:b.identifier,data:{name:k,description:R},resolver:C}),this.c.$registerVariable(w,{name:k,description:R}),(0,D.$Rc)(()=>{this.b.delete(w),this.c.$unregisterVariable(w)})}}e.$_fc=A}),define(ke[322],Se([1,0,8,52,4,3,2,83,25,15,7,6,26]),function($e,e,D,N,h,P,A,p,b,k,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;function E(S,c,m){const a=S.getProxy(C.$jL.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new b.$pm,c.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const v=this.b.get(u.handle);return v?v.value:u}else if(u&&u.$mid===7){const v=this.b.get(u.commentControlHandle);if(!v)return u;const I=v.getCommentThread(u.commentThreadHandle);return I?I.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const v=this.b.get(u.thread.commentControlHandle);if(!v)return u;const I=v.getCommentThread(u.thread.commentThreadHandle);return I?u.$mid===8?I.value:{thread:I.value,text:u.text}:u}else if(u&&u.$mid===10){const v=this.b.get(u.thread.commentControlHandle);if(!v)return u;const I=v.getCommentThread(u.thread.commentThreadHandle);if(!I)return u;const $=u.commentUniqueId,f=I.getCommentByUniqueId($);return f||u}else if(u&&u.$mid===11){const v=this.b.get(u.thread.commentControlHandle);if(!v)return u;const I=v.getCommentThread(u.thread.commentThreadHandle);if(!I)return u;const $=u.text,f=u.commentUniqueId,y=I.getCommentByUniqueId(f);return y?(typeof y.body=="string"?y.body=$:y.body=new R.$ML($),y):u}return u}})}createCommentController(u,v,I){const $=i.a++,f=new r(u,$,v,I);this.b.set(f.handle,f);const y=this.c.get(u.identifier)||[];return y.push(f),this.c.set(u.identifier,y),f.value}async $createCommentThreadTemplate(u,v,I){const $=this.b.get(u);$&&$.$createCommentThreadTemplate(v,I)}async $updateCommentThreadTemplate(u,v,I){const $=this.b.get(u);$&&$.$updateCommentThreadTemplate(v,I)}$deleteCommentThread(u,v){this.b.get(u)?.$deleteCommentThread(v)}$provideCommentingRanges(u,v,I){const $=this.b.get(u);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const f=m.getDocument(A.URI.revive(v));return(0,D.$Zg)(async()=>{const y=await $.commentingRangeProvider.provideCommentingRanges(f,I);let L;return Array.isArray(y)?L={ranges:y,fileComments:!1}:y?L={ranges:y.ranges||[],fileComments:y.fileComments||!1}:L=y??void 0,L}).then(y=>{let L;return y&&(L={ranges:y.ranges.map(T=>k.Range.from(T)),fileComments:y.fileComments}),L})}$toggleReaction(u,v,I,$,f){const y=this.b.get(u);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,D.$Zg)(()=>{const L=y.getCommentThread(v);if(L){const T=L.getCommentByUniqueId($.uniqueIdInThread);if(y!==void 0&&T&&y.reactionHandler)return y.reactionHandler(T,g(f))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){(u===void 0!=(this.p===void 0)||!u||!this.p||!u.isEqual(this.p))&&(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return this.h}set state(u){this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,v,I,$,f,y,L,T){this.m=v,this.n=I,this.o=$,this.p=f,this.q=y,this.extensionDescription=L,this.r=T,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new h.$Wd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new P.$Uc,this.l.value=new P.$Sc,this.n===void 0&&(this.n=`${u}.${this.handle}`),a.$createCommentThread(v,this.handle,this.n,this.o,k.Range.from(this.p),L.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{a.$deleteCommentThread(v,this.handle)}});const U=this;this.value={get uri(){return U.uri},get range(){return U.range},set range(j){U.range=j},get comments(){return U.comments},set comments(j){U.comments=j},get collapsibleState(){return U.collapsibleState},set collapsibleState(j){U.collapsibleState=j},get canReply(){return U.canReply},set canReply(j){U.canReply=j},get contextValue(){return U.contextValue},set contextValue(j){U.contextValue=j},get label(){return U.label},set label(j){U.label=j},get state(){return U.state},set state(j){U.state=j},dispose:()=>{U.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new P.$Sc);const u=I=>Object.prototype.hasOwnProperty.call(this.b,I),v={};u("range")&&(v.range=k.Range.from(this.p)),u("label")&&(v.label=this.label),u("contextValue")&&(v.contextValue=this.contextValue??null),u("comments")&&(v.comments=this.q.map(I=>s(this,I,this.k,this.extensionDescription))),u("collapsibleState")&&(v.collapseState=o(this.g)),u("canReply")&&(v.canReply=this.canReply),u("state")&&(v.state=d(this.h)),u("isTemplate")&&(v.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,v)}getCommentByUniqueId(u){for(const v of this.k){const I=v[0],$=v[1];if(u===$)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}Ge([(0,N.$Ah)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,a.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,v,I,$){this.f=u,this.g=v,this.h=I,this.i=$,this.a=new Map,a.$registerCommentController(this.handle,I,$,this.f.identifier.value);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(y){f.options=y},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(y){f.commentingRangeProvider=y},get reactionHandler(){return f.reactionHandler},set reactionHandler(y){f.reactionHandler=y},createCommentThread(y,L,T){return f.createCommentThread(y,L,T).value},dispose:()=>{f.dispose()}}),this.e=[],this.e.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(u,v,I){v===void 0&&(0,w.$LF)(this.f,"fileComments");const $=new n(this.id,this.handle,void 0,u,v,I,this.f,!1);return this.a.set($.handle,$),$}$createCommentThreadTemplate(u,v){const I=new n(this.id,this.handle,void 0,A.URI.revive(u),k.Range.to(v),[],this.f,!0);return I.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(u,v){const I=this.a.get(u);I&&(I.range=k.Range.to(v))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function s(l,u,v,I){let $=v.get(u);return $||($=++l.commentHandle,v.set(u,$)),u.state!==void 0&&(0,w.$LF)(I,"commentsDraftState"),u.reactions?.some(f=>f.reactors!==void 0)&&(0,w.$LF)(I,"commentReactor"),{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:$,body:typeof u.body=="string"?u.body:k.MarkdownString.from(u.body),userName:u.author.name,userIconPath:u.author.iconPath,label:u.label,commentReactions:u.reactions?u.reactions.map(f=>t(f)):void 0,state:u.state,timestamp:u.timestamp?.toJSON()}}function t(l){return{label:l.label,iconPath:l.iconPath?k.$nN(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted,reactors:l.reactors&&l.reactors.length>0&&typeof l.reactors[0]!="string"?l.reactors.map(u=>u.name):l.reactors}}function g(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?A.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1,reactors:l.reactors?.map(u=>({name:u}))}}function o(l){if(l!==void 0)switch(l){case R.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function d(l){if(l!==void 0)switch(l){case R.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}return new i}e.$dgc=E}),define(ke[323],Se([1,0,22,54,3,16,23,2,15,93,110,6,7]),function($e,e,D,N,h,P,A,p,b,k,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;class E{constructor(g,o){this.document=g,this.b=o,this.a=1,this.c=new R.$Ufc("custom documents")}addEdit(g){return this.c.add([g])}async undo(g,o){await this.f(g).undo(),o||this.disposeBackup()}async redo(g,o){await this.f(g).redo(),o||this.disposeBackup()}disposeEdits(g){for(const o of g)this.c.delete(o)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const g=s(this.document.uri)+this.a++;return(0,A.$Ig)(this.b,g)}updateBackup(g){this.d?.delete(),this.d=g}disposeBackup(){this.d?.delete(),this.d=void 0}f(g){const o=this.c.get(g,0);if(!o)throw new Error("No edit found");return o}}class S{constructor(){this.a=new Map}get(g,o){return this.a.get(this.b(g,o))}add(g,o,d){const l=this.b(g,o.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${g} resource:${o.uri}`);const u=new E(o,d);return this.a.set(l,u),u}delete(g,o){const d=this.b(g,o.uri);this.a.delete(d)}b(g,o){return`${g}@@@${o}`}}var c;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(c||(c={}));class m{constructor(){this.a=new Map}addTextProvider(g,o,d){return this.b(0,g,o,d)}addCustomProvider(g,o,d){return this.b(1,g,o,d)}get(g){return this.a.get(g)}b(g,o,d,l){if(this.a.has(o))throw new Error(`Provider for viewType:${o} already registered`);return this.a.set(o,{type:g,extension:d,provider:l}),new w.$lL(()=>this.a.delete(o))}}class a{constructor(g,o,d,l,u){this.d=o,this.f=d,this.g=l,this.h=u,this.b=new m,this.c=new S,this.a=g.getProxy(C.$jL.MainThreadCustomEditors)}registerCustomEditorProvider(g,o,d,l){const u=new h.$Sc;return n(d)?(u.add(this.b.addTextProvider(o,g,d)),this.a.$registerTextEditorProvider((0,k.$sgc)(g),o,l.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,k.$qgc)(g))):(u.add(this.b.addCustomProvider(o,g,d)),i(d)&&u.add(d.onDidChangeCustomDocument(v=>{const I=this.i(o,v.document.uri);if(r(v)){const $=I.addEdit(v);this.a.$onDidEdit(v.document.uri,o,$,v.label)}else this.a.$onContentChange(v.document.uri,o)})),this.a.$registerCustomEditorProvider((0,k.$sgc)(g),o,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,k.$qgc)(g))),w.$lL.from(u,new w.$lL(()=>{this.a.$unregisterEditorProvider(o)}))}async $createCustomDocument(g,o,d,l,u){const v=this.b.get(o);if(!v)throw new Error(`No provider found for '${o}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${o}'`);const I=p.URI.revive(g),$=await v.provider.openCustomDocument(I,{backupId:d,untitledDocumentData:l?.buffer},u);let f;return i(v.provider)&&this.f&&(f=this.f.workspaceValue(v.extension)??this.f.globalValue(v.extension)),this.c.add(o,$,f),{editable:i(v.provider)}}async $disposeCustomDocument(g,o){const d=this.b.get(o);if(!d)throw new Error(`No provider found for '${o}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${o}'`);const l=p.URI.revive(g),{document:u}=this.i(o,l);this.c.delete(o,u),u.dispose()}async $resolveCustomEditor(g,o,d,l,u,v){const I=this.b.get(d);if(!I)throw new Error(`No provider found for '${d}'`);const $=b.ViewColumn.to(u),f=this.g.createNewWebview(o,l.contentOptions,I.extension),y=this.h.createNewWebviewPanel(o,d,l.title,$,l.options,f,l.active),L=p.URI.revive(g);switch(I.type){case 1:{const{document:T}=this.i(d,L);return I.provider.resolveCustomEditor(T,y,v)}case 0:{const T=this.d.getDocument(L);return I.provider.resolveCustomTextEditor(T,y,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(g,o,d){this.i(o,g).disposeEdits(d)}async $onMoveCustomEditor(g,o,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const u=this.h.getWebviewPanel(g);if(!u)throw new Error("No webview found");const v=p.URI.revive(o),I=this.d.getDocument(v);await l.provider.moveCustomTextEditor(I,u,D.CancellationToken.None)}async $undo(g,o,d,l){return this.i(o,g).undo(d,l)}async $redo(g,o,d,l){return this.i(o,g).redo(d,l)}async $revert(g,o,d){const l=this.i(o,g);await this.j(o).revertCustomDocument(l.document,d),l.disposeBackup()}async $onSave(g,o,d){const l=this.i(o,g);await this.j(o).saveCustomDocument(l.document,d),l.disposeBackup()}async $onSaveAs(g,o,d,l){const u=this.i(o,g);return this.j(o).saveCustomDocumentAs(u.document,p.URI.revive(d),l)}async $backup(g,o,d){const l=this.i(o,g),v=await this.j(o).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},d);return l.updateBackup(v),v.id}i(g,o){const d=this.c.get(g,p.URI.revive(o));if(!d)throw new Error("No custom document found");return d}j(g){const d=this.b.get(g)?.provider;if(!d||!i(d))throw new Error("Custom document is not editable");return d}}e.$vgc=a;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function s(t){const g=t.scheme===P.Schemas.file||t.scheme===P.Schemas.untitled?t.fsPath:t.toString();return(0,N.$Vi)(g)+""}}),define(ke[324],Se([1,0,211,135,2,6,7,15,4,13,28,59]),function($e,e,D,N,h,P,A,p,b,k,R,C){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=e.$Zfc=void 0;class E{#e;#t;#i;constructor(m,a,i,n,r,s,t,g){this.d=m,this.e=a,this.f=i,this.g=n,this.h=r,this.c=!1,this.f=Math.max(n,i),this.#i=new R.$Ac(o=>s.getComparisonKey(o)),this.#e=t,this.#t=g}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,a){if(!m){this.clear();return}this.j();let i=[];if(h.URI.isUri(m)){if(!a){this.delete(m);return}this.#i.set(m,a.slice()),i=[m]}else if(Array.isArray(m)){i=[];let s;m=[...m].sort(E.k);for(const t of m){const[g,o]=t;if((!s||g.toString()!==s.toString())&&(s&&this.#i.get(s).length===0&&this.#i.delete(s),s=g,i.push(g),this.#i.set(g,[])),o)this.#i.get(g)?.push(...o);else{const d=this.#i.get(g);d&&(d.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let r=0;for(const s of i){let t=[];const g=this.#i.get(s);if(g)if(g.length>this.g){t=[];const o=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const l of g)if(l.severity===o[d]&&t.push({...p.Diagnostic.from(l),modelVersionId:this.h(s)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,D.localize)(0,null,g.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=g.map(o=>({...p.Diagnostic.from(o),modelVersionId:this.h(s)}));if(n.push([s,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,n)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,a){this.j();for(const[i,n]of this)m.call(a,i,n,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const a=this.#i.get(m);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,a){return m[0].toString()<a[0].toString()?-1:m[0].toString()>a[0].toString()?1:0}}e.$Zfc=E;let S=class{static{w=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*w.d}static _mapper(m){const a=new R.$Ac;for(const i of m)a.set(i,i);return{uris:Object.freeze(Array.from(a.values()))}}constructor(m,a,i,n){this.j=a,this.k=i,this.l=n,this.g=new Map,this.h=new b.$1d({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this.h.event,w._mapper),this.f=m.getProxy(P.$jL.MainThreadDiagnostics)}createDiagnosticCollection(m,a){const{g:i,f:n,h:r,j:s,k:t,l:g}=this,o=new class{$changeMany(u,v){n.$changeMany(u,v),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,u,v.length===0?"CLEARING":v)}$clear(u){n.$clear(u),s.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,u)}dispose(){n.dispose()}};let d;if(!a)a="_generated_diagnostic_collection_name_#"+w.c++,d=a;else if(!i.has(a))d=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do d=a+w.c++;while(i.has(d))}return new class extends E{constructor(){super(a,d,w.e,w.d,u=>g.getDocument(u)?.version,t.extUri,o,r),i.set(d,this)}dispose(){super.dispose(),i.delete(d)}}}getDiagnostics(m){if(m)return this.m(m);{const a=new Map,i=[];for(const n of this.g.values())n.forEach((r,s)=>{let t=a.get(r.toString());typeof t>"u"&&(t=i.length,a.set(r.toString(),t),i.push([r,[]])),i[t][1]=i[t][1].concat(...s)});return i}}m(m){let a=[];for(const i of this.g.values())i.has(m)&&(a=a.concat(i.get(m)));return a}$acceptMarkersChange(m){if(!this.n){const a="_generated_mirror",i=new E(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(a,i),this.n=i}for(const[a,i]of m)this.n.set(h.URI.revive(a),i.map(p.Diagnostic.to))}};e.$1fc=S,e.$1fc=S=w=Ge([Ve(1,k.$pj),Ve(2,C.$Yfc)],S)}),define(ke[325],Se([1,0,2,14,7,15,75]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=void 0;class p{constructor(k,R,C,w={timeout:1500,errors:3}){this.c=k,this.d=R,this.f=C,this.g=w,this.a=new A.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(R,C,w)=>{const S={dispose:this.a.push([R,C,k])};return Array.isArray(w)&&w.push(S),S}}async $participateInSave(k,R){const C=D.URI.revive(k);let w=!1;const E=setTimeout(()=>w=!0,this.g.timeout),S=[];try{for(const c of[...this.a]){if(w)break;const m=this.d.getDocument(C),a=await this.h(c,{document:m,reason:P.TextDocumentSaveReason.to(R)});S.push(a)}}finally{clearTimeout(E)}return S}h([k,R,C],w){const E=this.b.get(k);return typeof E=="number"&&E>this.g.errors?Promise.resolve(!1):this.i(C,k,R,w).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const c=this.b.get(k);this.b.set(k,c?c+1:1),typeof c=="number"&&c>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,R,C,w){const E=[],S=Date.now(),{document:c,reason:m}=w,{version:a}=c,i=Object.freeze({document:c,reason:m,waitUntil(n){if(Object.isFrozen(E))throw(0,N.$8)("waitUntil can not be called async");E.push(Promise.resolve(n))}});try{R.apply(C,[i])}catch(n){return Promise.reject(n)}return Object.freeze(E),new Promise((n,r)=>{const s=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(E).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(s),n(t)}).catch(t=>{clearTimeout(s),r(t)})}).then(n=>{const r={edits:[]};for(const s of n)if(Array.isArray(s)&&s.every(t=>t instanceof h.$sL))for(const{newText:t,newEol:g,range:o}of s)r.edits.push({resource:c.uri,versionId:void 0,textEdit:{range:o&&P.Range.from(o),text:t,eol:g&&P.EndOfLine.from(g)}});if(r.edits.length!==0)return a===c.version?this.f.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.$0gc=p}),define(ke[326],Se([1,0,4,3,2,6,148,15,18,24,7]),function($e,e,D,N,h,P,A,p,b,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wfc=void 0;class C{constructor(E,S){this.a=new D.$Wd,this.b=new D.$Wd,this.c=new D.$Wd,this.d=new D.$Wd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Sc,this.h=new Map,this.f=E.getProxy(P.$jL.MainThreadDocuments),this.g=S,this.g.onDidRemoveDocuments(c=>{for(const m of c)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(c=>{for(const m of c)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const S=this.g.getDocument(E);if(S)return S}getDocument(E){const S=this.getDocumentData(E);if(!S?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return S.document}ensureDocumentData(E){const S=this.g.getDocument(E);if(S)return Promise.resolve(S);let c=this.h.get(E.toString());return c||(c=this.f.$tryOpenDocument(E).then(m=>{this.h.delete(E.toString());const a=h.URI.revive(m);return(0,b.$Uf)(this.g.getDocument(a))},m=>(this.h.delete(E.toString()),Promise.reject(m))),this.h.set(E.toString(),c)),c}createDocumentData(E){return this.f.$tryCreateDocument(E).then(S=>h.URI.revive(S))}$acceptModelLanguageChanged(E,S){const c=h.URI.revive(E),m=this.g.getDocument(c);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(S),this.a.fire(m.document)}$acceptModelSaved(E){const S=h.URI.revive(E),c=this.g.getDocument(S);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(c.document)}$acceptDirtyStateChanged(E,S){const c=h.URI.revive(E),m=this.g.getDocument(c);if(!m)throw new Error("unknown document");m._acceptIsDirty(S),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,S,c){const m=h.URI.revive(E),a=this.g.getDocument(m);if(!a)throw new Error("unknown document");a._acceptIsDirty(c),a.onEvents(S);let i;S.isUndoing?i=R.TextDocumentChangeReason.Undo:S.isRedoing&&(i=R.TextDocumentChangeReason.Redo),this.c.fire((0,k.$zn)({document:a.document,contentChanges:S.changes.map(n=>({range:p.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(E,S){(0,A.$qN)(E,S)}}e.$Wfc=C}),define(ke[71],Se([1,0,73,4,18,2,5,6,20,15,7]),function($e,e,D,N,h,P,A,p,b,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=e.$wgc=void 0,e.$wgc=(0,A.$8h)("IExtHostEditorTabs");class C{constructor(m,a,i){this.e=i,this.d=a,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,a={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$5M(P.URI.revive(this.b.input.uri));case 2:return new R.$6M(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified));case 3:return new R.$7M(P.URI.revive(this.b.input.base),P.URI.revive(this.b.input.input1),P.URI.revive(this.b.input.input2),P.URI.revive(this.b.input.result));case 6:return new R.$8M(P.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$9M(this.b.input.viewType);case 4:return new R.$0M(P.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$$M(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$_M;case 9:return new R.$aN(P.URI.revive(this.b.input.uri),P.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$bN(this.b.input.providerId);default:return}}}class w{constructor(m,a){this.c=[],this.d="",this.b=m,this.e=a;for(const i of m.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,a={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return k.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(i=>i.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(i=>i.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const i=new C(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,i),m.tabDto.isActive&&(this.d=i.tabId),i}else if(m.kind===1){const i=this.c.splice(m.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(m.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,i),i}const a=this.c.find(i=>i.tabId===m.tabDto.id);if(!a)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(m.tabDto),a}activeTabId(){return this.d}}let E=class{constructor(m){this.b=new N.$Wd,this.c=new N.$Wd,this.e=[],this.a=m.getProxy(p.$jL.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,a={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(i=>i.apiObject))},get activeTabGroup(){const i=m.d;return(0,h.$Uf)(m.e.find(r=>r.groupId===i)?.apiObject)},close:async(i,n)=>{const r=Array.isArray(i)?i:[i];return r.length?S(r[0])?this.j(r,n):this.i(r,n):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(m){const a=new Set(this.e.map(o=>o.groupId)),i=new Set(m.map(o=>o.groupId)),n=(0,D.$L)(a,i),r=this.e.filter(o=>n.removed.includes(o.groupId)).map(o=>o.apiObject),s=[],t=[];this.e=m.map(o=>{const d=new w(o,()=>this.d);return n.added.includes(d.groupId)?s.push(d.apiObject):t.push(d.apiObject),d});const g=(0,h.$Uf)(m.find(o=>o.isActive===!0)?.groupId);g!==void 0&&this.d!==g&&(this.d=g),this.c.fire(Object.freeze({opened:s,closed:r,changed:t}))}$acceptTabGroupUpdate(m){const a=this.e.find(i=>i.groupId===m.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const a=this.e.find(n=>n.groupId===m.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const i=a.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(m){for(const a of this.e)for(const i of a.tabs)if(i.apiObject===m)return i}h(m){return this.e.find(a=>a.apiObject===m)}async i(m,a){const i=[];for(const n of m){const r=this.g(n);if(!r)throw new Error("Tab close: Invalid tab not found!");i.push(r.tabId)}return this.a.$closeTab(i,a)}async j(m,a){const i=[];for(const n of m){const r=this.h(n);if(!r)throw new Error("Group close: Invalid group not found!");i.push(r.groupId)}return this.a.$closeGroup(i,a)}};e.$xgc=E,e.$xgc=E=Ge([Ve(0,b.$oN)],E);function S(c){return c.tabs!==void 0}}),define(ke[327],Se([1,0,2,6,3,7,15,173,12,21,26,80]),function($e,e,D,N,h,P,A,p,b,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=void 0;class w{constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const m=this.a.indexOf(c);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),m=[];let a,i,n=14,r=14;for(const s of c){let t=a?(0,b.$cf)(a,s):0;for(t===0?i=1:i=r;t<s.length;t++)t+1===s.length?(n=r,r=9):r+=1,m.push([i,s.toUpperCase().charCodeAt(t),r]),m.push([i,s.toLowerCase().charCodeAt(t),r]),i=r;a=s,r=n}m.push([9,58,10]),m.push([10,47,12]),this.b=new p.$MZ(m)}}provideDocumentLinks(c){this.c();const m=[],a=p.$NZ.computeLinks({getLineContent(i){return c.lineAt(i-1).text},getLineCount(){return c.lineCount}},this.b);for(const i of a){const n=A.DocumentLink.to(i);n.target&&m.push(n)}return m}}class E{constructor(c,m){this.i=m,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(N.$jL.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,m,a,i={}){if(E.j(a),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const n=this.h++;this.b.add(m),this.d.add(m),this.c.set(n,a);let r=2;i.isCaseSensitive&&(r+=1024),i.isReadonly&&(r+=2048),typeof a.copy=="function"&&(r+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&((0,R.$LF)(c,"fsChunks"),r+=4);let s;i.isReadonly&&(0,C.$lk)(i.isReadonly)&&i.isReadonly.value!==""&&(s={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,m,r,s).catch(g=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${m}`),console.error(g)});const t=a.onDidChangeFile(g=>{const o=[];for(const d of g){const{uri:l,type:u}=d;if(l.scheme!==m)continue;let v;switch(u){case P.FileChangeType.Changed:v=0;break;case P.FileChangeType.Created:v=1;break;case P.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:l,type:v})}this.a.$onFileSystemChange(n,o)});return(0,h.$Rc)(()=>{t.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:m,ctime:a,mtime:i,size:n,permissions:r}=c;return{type:m,ctime:a,mtime:i,size:n,permissions:r}}$stat(c,m){return Promise.resolve(this.l(c).stat(D.URI.revive(m))).then(a=>E.k(a))}$readdir(c,m){return Promise.resolve(this.l(c).readDirectory(D.URI.revive(m)))}$readFile(c,m){return Promise.resolve(this.l(c).readFile(D.URI.revive(m))).then(a=>k.$ke.wrap(a))}$writeFile(c,m,a,i){return Promise.resolve(this.l(c).writeFile(D.URI.revive(m),a.buffer,i))}$delete(c,m,a){return Promise.resolve(this.l(c).delete(D.URI.revive(m),a))}$rename(c,m,a,i){return Promise.resolve(this.l(c).rename(D.URI.revive(m),D.URI.revive(a),i))}$copy(c,m,a,i){const n=this.l(c);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(D.URI.revive(m),D.URI.revive(a),i))}$mkdir(c,m){return Promise.resolve(this.l(c).createDirectory(D.URI.revive(m)))}$watch(c,m,a,i){const n=this.l(c).watch(D.URI.revive(a),i);this.f.set(m,n)}$unwatch(c,m){const a=this.f.get(m);a&&(a.dispose(),this.f.delete(m))}$open(c,m,a){const i=this.l(c);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(m),a))}$close(c,m){const a=this.l(c);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(m))}$read(c,m,a,i){const n=this.l(c);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const r=k.$ke.alloc(i);return Promise.resolve(n.read(m,a,r.buffer,0,i)).then(s=>r.slice(0,s))}$write(c,m,a,i){const n=this.l(c);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(m,a,i.buffer,0,i.byteLength))}l(c){const m=this.c.get(c);if(!m){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return m}}e.$_gc=E}),define(ke[328],Se([1,0,4,35,2,6,15,7,43]),function($e,e,D,N,h,P,A,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(E,S,c,m,a,i){this.a=Math.random(),this.b=new D.$Wd,this.c=new D.$Wd,this.d=new D.$Wd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,N.$Oj)(a),r=typeof a=="string",s=i?.correlate,t=m(g=>{if(!(typeof g.session=="number"&&g.session!==this.a)&&!(s&&typeof g.session>"u")){if(!i?.ignoreCreateEvents)for(const o of g.created){const d=h.URI.revive(o);n(d.fsPath)&&(!r||S.getWorkspaceFolder(d))&&this.b.fire(d)}if(!i?.ignoreChangeEvents)for(const o of g.changed){const d=h.URI.revive(o);n(d.fsPath)&&(!r||S.getWorkspaceFolder(d))&&this.c.fire(d)}if(!i?.ignoreDeleteEvents)for(const o of g.deleted){const d=h.URI.revive(o);n(d.fsPath)&&(!r||S.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=p.$lL.from(this.i(E,c,a,i,i?.correlate),this.b,this.c,this.d,t)}i(E,S,c,m,a){const i=p.$lL.from();if(typeof c=="string")return i;const n=E.getProxy(P.$jL.MainThreadFileSystemEventService);let r=!1;return(c.pattern.includes(N.$Kj)||c.pattern.includes(N.$Lj))&&(r=!0),n.$watch(S.identifier.value,this.a,c.baseUri,{recursive:r,excludes:m?.excludes??[]},!!a),p.$lL.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(E){this.a=E,this.session=this.a.session,this.b=new b.$V(()=>this.a.created.map(h.URI.revive)),this.c=new b.$V(()=>this.a.changed.map(h.URI.revive)),this.d=new b.$V(()=>this.a.deleted.map(h.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(E,S,c){this.j=E,this.k=S,this.l=c,this.a=new D.$Wd,this.b=new D.$Wd,this.c=new D.$Wd,this.d=new D.$Wd,this.g=new D.$Yd,this.h=new D.$Yd,this.i=new D.$Yd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,S,c,m){return new k(this.j,E,S,this.a.event,A.GlobPattern.from(c),m)}$onFileEvent(E){this.a.fire(new R(E))}$onDidRunFileOperation(E,S){switch(E){case 2:this.b.fire(Object.freeze({files:S.map(c=>({oldUri:h.URI.revive(c.source),newUri:h.URI.revive(c.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(c=>h.URI.revive(c.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(c=>h.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,S){return(c,m,a)=>{const i=function(r){c.call(m,r)};return i.extension=E,S.event(i,void 0,a)}}async $onWillRunFileOperation(E,S,c,m){switch(E){case 2:return await this.n(this.g,{files:S.map(a=>({oldUri:h.URI.revive(a.source),newUri:h.URI.revive(a.target)}))},c,m);case 1:return await this.n(this.i,{files:S.map(a=>h.URI.revive(a.target))},c,m);case 0:case 3:return await this.n(this.h,{files:S.map(a=>h.URI.revive(a.target))},c,m)}}async n(E,S,c,m){const a=new Set,i=[];if(await E.fireAsync(S,m,async(r,s)=>{const t=Date.now(),g=await Promise.resolve(r);g instanceof p.$vL&&(i.push([s.extension,g]),a.add(s.extension.displayName??s.extension.identifier.value)),Date.now()-t>c&&this.k.warn("SLOW file-participant",s.extension.identifier)}),m.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,r]of i){const{edits:s}=A.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(s)}return{edit:n,extensionNames:Array.from(a)}}}e.$ahc=C}),define(ke[329],Se([1,0,2,24,15,7,83,6,12,29,19,18,169,22,25,3,131,121,110,38,14,8,26,213]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i,n,r,s,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;class o{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentSymbols(B,Q){const ee=this.d.getDocument(B),H=await this.e.provideDocumentSymbols(ee,Q);if(!(0,R.$Kb)(H))return H[0]instanceof P.$EL?H.map(h.DocumentSymbol.from):o.f(H)}static f(B){B=B.slice(0).sort((H,oe)=>{let le=H.location.range.start.compareTo(oe.location.range.start);return le===0&&(le=oe.location.range.end.compareTo(H.location.range.end)),le});const Q=[],ee=[];for(const H of B){const oe={name:H.name||"!!MISSING: name!!",kind:h.SymbolKind.from(H.kind),tags:H.tags?.map(h.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:h.Range.from(H.location.range),selectionRange:h.Range.from(H.location.range),children:[]};for(;;){if(ee.length===0){ee.push(oe),Q.push(oe);break}const le=ee[ee.length-1];if(k.$Ws.containsRange(le.range,oe.range)&&!k.$Ws.equalsRange(le.range,oe.range)){le.children?.push(oe),ee.push(oe);break}ee.pop()}}return Q}}class d{constructor(B,Q,ee,H,oe,le){this.f=B,this.g=Q,this.h=ee,this.j=H,this.k=oe,this.l=le,this.d=new i.$Ufc("CodeLens"),this.e=new Map}async provideCodeLenses(B,Q){const ee=this.f.getDocument(B),H=await this.h.provideCodeLenses(ee,Q);if(!H||Q.isCancellationRequested)return;const oe=this.d.add(H),le=new c.$Sc;this.e.set(oe,le);const Re={cacheId:oe,lenses:[]};for(let je=0;je<H.length;je++)Re.lenses.push({cacheId:[oe,je],range:h.Range.from(H[je].range),command:this.g.toInternal(H[je].command,le)});return Re}async resolveCodeLens(B,Q){const ee=B.cacheId&&this.d.get(...B.cacheId);if(!ee)return;let H;if(typeof this.h.resolveCodeLens!="function"||ee.isResolved?H=ee:H=await this.h.resolveCodeLens(ee,Q),H||(H=ee),Q.isCancellationRequested)return;const oe=B.cacheId&&this.e.get(B.cacheId[0]);if(oe){if(!H.command){const le=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,le),this.l.error(le);return}return B.command=this.g.toInternal(H.command,oe),B}}releaseCodeLenses(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}}function l(Ce){return Array.isArray(Ce)?Ce.map(h.DefinitionLink.from):Ce?[h.DefinitionLink.from(Ce)]:[]}class u{constructor(B,Q){this.d=B,this.e=Q}async provideDefinition(B,Q,ee){const H=this.d.getDocument(B),oe=h.Position.to(Q),le=await this.e.provideDefinition(H,oe,ee);return l(le)}}class v{constructor(B,Q){this.d=B,this.e=Q}async provideDeclaration(B,Q,ee){const H=this.d.getDocument(B),oe=h.Position.to(Q),le=await this.e.provideDeclaration(H,oe,ee);return l(le)}}class I{constructor(B,Q){this.d=B,this.e=Q}async provideImplementation(B,Q,ee){const H=this.d.getDocument(B),oe=h.Position.to(Q),le=await this.e.provideImplementation(H,oe,ee);return l(le)}}class ${constructor(B,Q){this.d=B,this.e=Q}async provideTypeDefinition(B,Q,ee){const H=this.d.getDocument(B),oe=h.Position.to(Q),le=await this.e.provideTypeDefinition(H,oe,ee);return l(le)}}class f{constructor(B,Q){this.d=B,this.e=Q}async provideHover(B,Q,ee){const H=this.d.getDocument(B),oe=h.Position.to(Q),le=await this.e.provideHover(H,oe,ee);if(!(!le||(0,R.$Kb)(le.contents)))return le.range||(le.range=H.getWordRangeAtPosition(oe)),le.range||(le.range=new P.$nL(oe,oe)),h.Hover.from(le)}}class y{constructor(B,Q){this.d=B,this.e=Q}async provideEvaluatableExpression(B,Q,ee){const H=this.d.getDocument(B),oe=h.Position.to(Q),le=await this.e.provideEvaluatableExpression(H,oe,ee);if(le)return h.EvaluatableExpression.from(le)}}class L{constructor(B,Q){this.d=B,this.e=Q}async provideInlineValues(B,Q,ee,H){const oe=this.d.getDocument(B),le=await this.e.provideInlineValues(oe,h.Range.to(Q),h.InlineValueContext.to(ee),H);if(Array.isArray(le))return le.map(Re=>h.InlineValue.from(Re))}}class T{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentHighlights(B,Q,ee){const H=this.d.getDocument(B),oe=h.Position.to(Q),le=await this.e.provideDocumentHighlights(H,oe,ee);if(Array.isArray(le))return le.map(h.DocumentHighlight.from)}}class U{constructor(B,Q){this.d=B,this.e=Q}async provideMultiDocumentHighlights(B,Q,ee,H){const oe=this.d.getDocument(B),le=ee.map(He=>this.d.getDocument(He)),Re=h.Position.to(Q),je=await this.e.provideMultiDocumentHighlights(oe,Re,le,H);if(Array.isArray(je))return je.map(h.MultiDocumentHighlight.from)}}class j{constructor(B,Q){this.d=B,this.e=Q}async provideLinkedEditingRanges(B,Q,ee){const H=this.d.getDocument(B),oe=h.Position.to(Q),le=await this.e.provideLinkedEditingRanges(H,oe,ee);if(le&&Array.isArray(le.ranges))return{ranges:(0,R.$Hb)(le.ranges.map(h.Range.from)),wordPattern:le.wordPattern}}}class F{constructor(B,Q){this.d=B,this.e=Q}async provideReferences(B,Q,ee,H){const oe=this.d.getDocument(B),le=h.Position.to(Q),Re=await this.e.provideReferences(oe,le,ee,H);if(Array.isArray(Re))return Re.map(h.location.from)}}class M{static{this.d=1e3}constructor(B,Q,ee,H,oe,le,Re){this.g=B,this.h=Q,this.j=ee,this.k=H,this.l=oe,this.m=le,this.n=Re,this.e=new i.$Ufc("CodeAction"),this.f=new Map}async provideCodeActions(B,Q,ee,H){const oe=this.g.getDocument(B),le=w.$Ys.isISelection(Q)?h.Selection.to(Q):h.Range.to(Q),Re=[];for(const st of this.j.getDiagnostics(B))if(le.intersection(st.range)&&Re.push(st)>M.d)break;const je={diagnostics:Re,only:ee.only?new P.$GL(ee.only):void 0,triggerKind:h.CodeActionTriggerKind.to(ee.trigger)},He=await this.k.provideCodeActions(oe,le,je,H);if(!(0,R.$Lb)(He)||H.isCancellationRequested)return;const Qe=this.e.add(He),_e=new c.$Sc;this.f.set(Qe,_e);const at=[];for(let st=0;st<He.length;st++){const rt=He[st];if(rt)if(M.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,_e)});else{je.only&&(rt.kind?je.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Le=rt.ranges??[];at.push({cacheId:[Qe,st],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,_e),diagnostics:rt.diagnostics&&rt.diagnostics.map(h.Diagnostic.from),edit:rt.edit&&h.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$KF)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,t.$KF)(this.m,"codeActionRanges")?(0,R.$Hb)(Le.map(h.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:Qe,actions:at}}async resolveCodeAction(B,Q){const[ee,H]=B,oe=this.e.get(ee,H);if(!oe||M.o(oe))return{};if(!this.k.resolveCodeAction)return{};const le=await this.k.resolveCodeAction(oe,Q)??oe;let Re;le.edit&&(Re=h.WorkspaceEdit.from(le.edit,void 0));let je;if(le.command){const He=this.f.get(ee);He&&(je=this.h.toInternal(le.command,He))}return{edit:Re,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class O{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,ee,H,oe){this.d=B,this.e=Q,this.f=ee,this.g=H,this.h=oe}async prepareDocumentPaste(B,Q,ee,H){if(!this.f.prepareDocumentPaste)return;const oe=this.e.getDocument(B),le=Q.map(He=>h.Range.to(He)),Re=h.DataTransfer.toDataTransfer(ee,()=>{throw new r.$$});if(await this.f.prepareDocumentPaste(oe,le,Re,H),H.isCancellationRequested)return;const je=Array.from(Re).filter(([,He])=>!(He instanceof P.$aM));return h.DataTransfer.from(je)}async providePasteEdits(B,Q,ee,H,oe){if(!this.f.provideDocumentPasteEdits)return;const le=this.e.getDocument(Q),Re=ee.map(Qe=>h.Range.to(Qe)),je=h.DataTransfer.toDataTransfer(H,async Qe=>(await this.d.$resolvePasteFileData(this.g,B,Qe)).buffer),He=await this.f.provideDocumentPasteEdits(le,Re,je,oe);if(He)return{label:He.label??(0,g.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:He.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:O.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?h.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class z{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentFormattingEdits(B,Q,ee){const H=this.d.getDocument(B),oe=await this.e.provideDocumentFormattingEdits(H,Q,ee);if(Array.isArray(oe))return oe.map(h.TextEdit.from)}}class J{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeFormattingEdits(B,Q,ee,H){const oe=this.d.getDocument(B),le=h.Range.to(Q),Re=await this.e.provideDocumentRangeFormattingEdits(oe,le,ee,H);if(Array.isArray(Re))return Re.map(h.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,Q,ee,H){(0,C.$Tf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const oe=this.d.getDocument(B),le=Q.map(h.Range.to),Re=await this.e.provideDocumentRangesFormattingEdits(oe,le,ee,H);if(Array.isArray(Re))return Re.map(h.TextEdit.from)}}class te{constructor(B,Q){this.d=B,this.e=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,Q,ee,H,oe){const le=this.d.getDocument(B),Re=h.Position.to(Q),je=await this.e.provideOnTypeFormattingEdits(le,Re,ee,H,oe);if(Array.isArray(je))return je.map(h.TextEdit.from)}}class x{constructor(B,Q){this.e=B,this.f=Q,this.d=new i.$Ufc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,Q){const ee=await this.e.provideWorkspaceSymbols(B,Q);if(!(0,R.$Lb)(ee))return{symbols:[]};const H=this.d.add(ee),oe={cacheId:H,symbols:[]};for(let le=0;le<ee.length;le++){const Re=ee[le];if(!Re||!Re.name){this.f.warn("INVALID SymbolInformation",Re);continue}oe.symbols.push({...h.WorkspaceSymbol.from(Re),cacheId:[H,le]})}return oe}async resolveWorkspaceSymbol(B,Q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const ee=this.d.get(...B.cacheId);if(ee){const H=await this.e.resolveWorkspaceSymbol(ee,Q);return H&&(0,N.$Bn)(B,h.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class X{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,Q,ee){this.d=B,this.e=Q,this.f=ee}async provideRenameEdits(B,Q,ee,H){const oe=this.d.getDocument(B),le=h.Position.to(Q);try{const Re=await this.e.provideRenameEdits(oe,le,ee,H);return Re?h.WorkspaceEdit.from(Re):void 0}catch(Re){const je=X.g(Re);return je?{rejectReason:je,edits:void 0}:Promise.reject(Re)}}async resolveRenameLocation(B,Q,ee){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(B),oe=h.Position.to(Q);try{const le=await this.e.prepareRename(H,oe,ee);let Re,je;if(P.$nL.isRange(le)?(Re=le,je=H.getText(le)):(0,C.$Lf)(le)&&(Re=le.range,je=le.placeholder),!Re||!je)return;if(Re.start.line>oe.line||Re.end.line<oe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:h.Range.from(Re),text:je}}catch(le){const Re=X.g(le);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(le)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Z{constructor(B,Q){this.resultId=B,this.tokens=Q}}class ae{constructor(B,Q){this.f=B,this.g=Q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,Q,ee){const H=this.f.getDocument(B),oe=Q!==0?this.d.get(Q):null;let le=typeof oe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,oe.resultId,ee):await this.g.provideDocumentSemanticTokens(H,ee);return oe&&this.d.delete(Q),le?(le=ae.h(le),this.o(ae.n(oe,le),le)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return ae.j(B)?ae.k(B)?B:new P.$DM(new Uint32Array(B.data),B.resultId):ae.l(B)?ae.m(B)?B:new P.$FM(B.edits.map(Q=>new P.$EM(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const Q of B.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static n(B,Q){if(!ae.j(Q)||!B||!B.tokens)return Q;const ee=B.tokens,H=ee.length,oe=Q.data,le=oe.length;let Re=0;const je=Math.min(H,le);for(;Re<je&&ee[Re]===oe[Re];)Re++;if(Re===H&&Re===le)return new P.$FM([],Q.resultId);let He=0;const Qe=je-Re;for(;He<Qe&&ee[H-He-1]===oe[le-He-1];)He++;return new P.$FM([{start:Re,deleteCount:H-Re-He,data:oe.subarray(Re,le-He)}],Q.resultId)}o(B,Q){if(ae.j(B)){const ee=this.e++;return this.d.set(ee,new Z(B.resultId,B.data)),(0,m.$K$)({id:ee,type:"full",data:B.data})}if(ae.l(B)){const ee=this.e++;return ae.j(Q)?this.d.set(ee,new Z(Q.resultId,Q.data)):this.d.set(ee,new Z(B.resultId)),(0,m.$K$)({id:ee,type:"delta",deltas:(B.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class _{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeSemanticTokens(B,Q,ee){const H=this.d.getDocument(B),oe=await this.e.provideDocumentRangeSemanticTokens(H,h.Range.to(Q),ee);return oe?this.f(oe):null}f(B){return(0,m.$K$)({id:0,type:"full",data:B.data})}}class ge{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,Q,ee,H,oe){this.f=B,this.g=Q,this.h=ee,this.j=H,this.k=oe,this.d=new i.$Ufc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,Q,ee,H){const oe=this.f.getDocument(B),le=h.Position.to(Q),Re=oe.getWordRangeAtPosition(le)||new P.$nL(le,le),je=Re.with({end:le}),He=new n.$Sd,Qe=await this.h.provideCompletionItems(oe,le,H,h.CompletionContext.to(ee));if(!Qe||H.isCancellationRequested)return;const _e=Array.isArray(Qe)?new P.$TL(Qe):Qe,at=ge.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),st=new c.$Sc;this.e.set(at,st);const rt=[],Le={x:at,b:rt,a:{replace:h.Range.from(Re),insert:h.Range.from(je)},c:_e.isIncomplete||void 0,d:He.elapsed()};for(let ze=0;ze<_e.items.length;ze++){const Ae=_e.items[ze],Ze=this.l(Ae,[at,ze],je,Re);rt.push(Ze)}return Le}async resolveCompletionItem(B,Q){if(typeof this.h.resolveCompletionItem!="function")return;const ee=this.d.get(...B);if(!ee)return;const H=this.l(ee,B),oe=await this.h.resolveCompletionItem(ee,Q);if(!oe)return;const le=this.l(oe,B);return(H.h!==le.h||H.i!==le.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==le.n||H.o!==le.o||!(0,N.$Cn)(H.p,le.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:le.d,c:le.c,l:le.l,h:le.h,i:le.i,n:le.n,o:le.o,p:le.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q,ee,H){const oe=this.e.get(Q[0]);if(!oe)throw Error("DisposableStore is missing...");const le=this.g.toInternal(B.command,oe),Re={x:Q,a:B.label,b:B.kind!==void 0?h.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(h.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:h.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(h.TextEdit.from),n:le?.$ident,o:le?.id,p:le?.$ident?void 0:le?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re.h=B.textEdit.newText):typeof B.insertText=="string"?Re.h=B.insertText:B.insertText instanceof P.$wL&&(Re.h=B.insertText.value,Re.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),P.$nL.isRange(je)?Re.j=h.Range.from(je):je&&(!ee?.isEqual(je.inserting)||!H?.isEqual(je.replacing))&&(Re.j={insert:h.Range.from(je.inserting),replace:h.Range.from(je.replacing)}),Re}}class ne{async provideInlineCompletions(B,Q,ee,H){}disposeCompletions(B){}handleDidShowCompletionItem(B,Q,ee){}handlePartialAccept(B,Q,ee){}}class K extends ne{constructor(B,Q,ee,H){super(),this.f=B,this.g=Q,this.h=ee,this.j=H,this.d=new W,this.e=(0,t.$KF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$KF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,Q,ee,H){const oe=this.g.getDocument(B),le=h.Position.to(Q),Re=await this.h.provideInlineCompletionItems(oe,le,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:h.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ee.triggerKind]},H);if(!Re||H.isCancellationRequested)return;const je=Array.isArray(Re)?Re:Re.items,He=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],Qe=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:je}),items:je.map((st,rt)=>{let Le;st.command&&(_e||(_e=new c.$Sc),Le=this.j.toInternal(st.command,_e));const ze=st.insertText;return{insertText:typeof ze=="string"?ze:{snippet:ze.value},filterText:st.filterText,range:st.range?h.Range.from(st.range):void 0,command:Le,idx:rt,completeBracketPairs:this.e?st.completeBracketPairs:!1}}),commands:He.map(st=>(_e||(_e=new c.$Sc),this.j.toInternal(st,_e))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,Q,ee){const H=this.d.get(B)?.items[Q];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,ee)}handlePartialAccept(B,Q,ee){const H=this.d.get(B)?.items[Q];H&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(H,ee)}}class W{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const Q=this.e++;return this.d.set(Q,B),Q}disposeReferenceId(B){const Q=this.d.get(B);return this.d.delete(B),Q}get(B){return this.d.get(B)}}class re{constructor(B,Q){this.e=B,this.f=Q,this.d=new i.$Ufc("SignatureHelp")}async provideSignatureHelp(B,Q,ee,H){const oe=this.e.getDocument(B),le=h.Position.to(Q),Re=this.g(ee),je=await this.f.provideSignatureHelp(oe,le,H,Re);if(je){const He=this.d.add([je]);return{...h.SignatureHelp.from(je),id:He}}}g(B){let Q;if(B.activeSignatureHelp){const ee=h.SignatureHelp.to(B.activeSignatureHelp),H=this.d.get(B.activeSignatureHelp.id,0);H?(Q=H,Q.activeSignature=ee.activeSignature,Q.activeParameter=ee.activeParameter):Q=ee}return{...B,activeSignatureHelp:Q}}releaseSignatureHelp(B){this.d.delete(B)}}class ye{constructor(B,Q,ee,H,oe){this.f=B,this.g=Q,this.h=ee,this.j=H,this.k=oe,this.d=new i.$Ufc("InlayHints"),this.e=new Map}async provideInlayHints(B,Q,ee){const H=this.f.getDocument(B),oe=h.Range.to(Q),le=await this.h.provideInlayHints(H,oe,ee);if(!Array.isArray(le)||le.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`);return}if(ee.isCancellationRequested)return;const Re=this.d.add(le);this.e.set(Re,new c.$Sc);const je={hints:[],cacheId:Re};for(let He=0;He<le.length;He++)this.l(le[He],oe)&&je.hints.push(this.m(le[He],[Re,He]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`),je}async resolveInlayHint(B,Q){if(typeof this.h.resolveInlayHint!="function")return;const ee=this.d.get(...B);if(!ee)return;const H=await this.h.resolveInlayHint(ee,Q);if(H&&this.l(H))return this.m(H,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q){return B.label.length===0||Array.isArray(B.label)&&B.label.every(ee=>ee.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(Q&&!Q.contains(B.position))}m(B,Q){const ee=this.e.get(Q[0]);if(!ee)throw Error("DisposableStore is missing...");const H={label:"",cacheId:Q,tooltip:h.MarkdownString.fromStrict(B.tooltip),position:h.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(h.TextEdit.from),kind:B.kind&&h.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")H.label=B.label;else{const oe=[];H.label=oe;for(const le of B.label){if(!le.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Re={label:le.value,tooltip:h.MarkdownString.fromStrict(le.tooltip)};P.$xL.isLocation(le.location)&&(Re.location=h.location.from(le.location)),le.command&&(Re.command=this.g.toInternal(le.command,ee)),oe.push(Re)}}return H}}class he{constructor(B,Q){this.e=B,this.f=Q,this.d=new i.$Ufc("DocumentLink")}async provideLinks(B,Q){const ee=this.e.getDocument(B),H=await this.f.provideDocumentLinks(ee,Q);if(!(!Array.isArray(H)||H.length===0)&&!Q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(he.g).map(h.DocumentLink.from)};{const oe=this.d.add(H),le={links:[],cacheId:oe};for(let Re=0;Re<H.length;Re++){if(!he.g(H[Re]))continue;const je=h.DocumentLink.from(H[Re]);je.cacheId=[oe,Re],le.links.push(je)}return le}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,Q){if(typeof this.f.resolveDocumentLink!="function")return;const ee=this.d.get(...B);if(!ee)return;const H=await this.f.resolveDocumentLink(ee,Q);if(!(!H||!he.g(H)))return h.DocumentLink.from(H)}releaseLinks(B){this.d.delete(B)}}class fe{constructor(B,Q){this.d=B,this.e=Q}async provideColors(B,Q){const ee=this.d.getDocument(B),H=await this.e.provideDocumentColors(ee,Q);return Array.isArray(H)?H.map(le=>({color:h.Color.from(le.color),range:h.Range.from(le.range)})):[]}async provideColorPresentations(B,Q,ee){const H=this.d.getDocument(B),oe=h.Range.to(Q.range),le=h.Color.to(Q.color),Re=await this.e.provideColorPresentations(le,{document:H,range:oe},ee);if(Array.isArray(Re))return Re.map(h.ColorPresentation.from)}}class ue{constructor(B,Q){this.d=B,this.e=Q}async provideFoldingRanges(B,Q,ee){const H=this.d.getDocument(B),oe=await this.e.provideFoldingRanges(H,Q,ee);if(Array.isArray(oe))return oe.map(h.FoldingRange.from)}}class me{constructor(B,Q,ee){this.d=B,this.e=Q,this.f=ee}async provideSelectionRanges(B,Q,ee){const H=this.d.getDocument(B),oe=Q.map(h.Position.to),le=await this.e.provideSelectionRanges(H,oe,ee);if(!(0,R.$Lb)(le))return[];if(le.length!==oe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let je=0;je<oe.length;je++){const He=[];Re.push(He);let Qe=oe[je],_e=le[je];for(;;){if(!_e.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(He.push(h.SelectionRange.from(_e)),!_e.parent)break;Qe=_e.range,_e=_e.parent}}return Re}}class V{constructor(B,Q){this.f=B,this.g=Q,this.d=new a.$tN(""),this.e=new Map}async prepareSession(B,Q,ee){const H=this.f.getDocument(B),oe=h.Position.to(Q),le=await this.g.prepareCallHierarchy(H,oe,ee);if(!le)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(le)?le.map(je=>this.h(Re,je)):[this.h(Re,le)]}async provideCallsTo(B,Q,ee){const H=this.j(B,Q);if(!H)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyIncomingCalls(H,ee);if(oe)return oe.map(le=>({from:this.h(B,le.from),fromRanges:le.fromRanges.map(Re=>h.Range.from(Re))}))}async provideCallsFrom(B,Q,ee){const H=this.j(B,Q);if(!H)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyOutgoingCalls(H,ee);if(oe)return oe.map(le=>({to:this.h(B,le.to),fromRanges:le.fromRanges.map(Re=>h.Range.from(Re))}))}releaseSession(B){this.e.delete(B)}h(B,Q){const ee=this.e.get(B),H=h.CallHierarchyItem.from(Q,B,ee.size.toString(36));return ee.set(H._itemId,Q),H}j(B,Q){return this.e.get(B)?.get(Q)}}class Y{constructor(B,Q){this.f=B,this.g=Q,this.d=new a.$tN(""),this.e=new Map}async prepareSession(B,Q,ee){const H=this.f.getDocument(B),oe=h.Position.to(Q),le=await this.g.prepareTypeHierarchy(H,oe,ee);if(!le)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(le)?le.map(je=>this.h(Re,je)):[this.h(Re,le)]}async provideSupertypes(B,Q,ee){const H=this.j(B,Q);if(!H)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySupertypes(H,ee);if(oe)return oe.map(le=>this.h(B,le))}async provideSubtypes(B,Q,ee){const H=this.j(B,Q);if(!H)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySubtypes(H,ee);if(oe)return oe.map(le=>this.h(B,le))}releaseSession(B){this.e.delete(B)}h(B,Q){const ee=this.e.get(B),H=h.TypeHierarchyItem.from(Q,B,ee.size.toString(36));return ee.set(H._itemId,Q),H}j(B,Q){return this.e.get(B)?.get(Q)}}class de{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,ee,H,oe){this.d=B,this.e=Q,this.f=ee,this.g=H,this.h=oe}async provideDocumentOnDropEdits(B,Q,ee,H,oe){const le=this.e.getDocument(Q),Re=h.Position.to(ee),je=h.DataTransfer.toDataTransfer(H,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,Qe)).buffer),He=await this.f.provideDocumentDropEdits(le,Re,je,oe);if(He)return{label:He.label??(0,g.localize)(1,null,this.h.displayName||this.h.name),yieldTo:He.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:de.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?h.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class we{constructor(B,Q){this.d=B,this.e=Q}async provideMappedEdits(B,Q,ee,H){const oe=D.URI.revive(B),le=this.d.getDocument(oe),Re=ee.documents.map(Qe=>Qe.map(_e=>({uri:D.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(at=>h.Range.to(at))}))),je={documents:Re,selections:Re[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(le,Q,je,H);return He?h.WorkspaceEdit.from(He):null}}class Pe{constructor(B,Q){this.adapter=B,this.extension=Q}}class ve{static{this.d=0}constructor(B,Q,ee,H,oe,le,Re,je){this.g=Q,this.h=ee,this.j=H,this.k=oe,this.l=le,this.m=Re,this.n=je,this.f=new Map,this.e=B.getProxy(p.$jL.MainThreadLanguageFeatures)}o(B,Q){return h.DocumentSelector.from(B,this.g,Q)}p(B){return new P.$lL(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return ve.d++}async s(B,Q,ee,H,oe,le=!1){const Re=this.f.get(B);if(!Re||!(Re.adapter instanceof Q))return H;const je=Date.now();le||this.l.trace(`[${Re.extension.identifier.value}] INVOKE provider '${ee.toString().replace(/[\r\n]/g,"")}'`);const He=ee(Re.adapter,Re.extension);return Promise.resolve(He).catch(Qe=>{(0,r.$4)(Qe)||(this.l.error(`[${Re.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(Re.extension.identifier,Qe))}).finally(()=>{le||this.l.trace(`[${Re.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),E.CancellationToken.isCancellationToken(oe)?(0,s.$Wg)(He,oe):He}t(B,Q){const ee=this.q();return this.f.set(ee,new Pe(B,Q)),ee}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,Q,ee,H){const oe=this.t(new o(this.h,ee),B),le=H&&H.label||ve.u(B);return this.e.$registerDocumentSymbolProvider(oe,this.o(Q,B),le),this.p(oe)}$provideDocumentSymbols(B,Q,ee){return this.s(B,o,H=>H.provideDocumentSymbols(D.URI.revive(Q),ee),void 0,ee)}registerCodeLensProvider(B,Q,ee){const H=this.q(),oe=typeof ee.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Pe(new d(this.h,this.j.converter,ee,B,this.n,this.l),B)),this.e.$registerCodeLensSupport(H,this.o(Q,B),oe);let le=this.p(H);if(oe!==void 0){const Re=ee.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(oe));le=P.$lL.from(le,Re)}return le}$provideCodeLenses(B,Q,ee){return this.s(B,d,H=>H.provideCodeLenses(D.URI.revive(Q),ee),void 0,ee)}$resolveCodeLens(B,Q,ee){return this.s(B,d,H=>H.resolveCodeLens(Q,ee),void 0,void 0)}$releaseCodeLenses(B,Q){this.s(B,d,ee=>Promise.resolve(ee.releaseCodeLenses(Q)),void 0,void 0)}registerDefinitionProvider(B,Q,ee){const H=this.t(new u(this.h,ee),B);return this.e.$registerDefinitionSupport(H,this.o(Q,B)),this.p(H)}$provideDefinition(B,Q,ee,H){return this.s(B,u,oe=>oe.provideDefinition(D.URI.revive(Q),ee,H),[],H)}registerDeclarationProvider(B,Q,ee){const H=this.t(new v(this.h,ee),B);return this.e.$registerDeclarationSupport(H,this.o(Q,B)),this.p(H)}$provideDeclaration(B,Q,ee,H){return this.s(B,v,oe=>oe.provideDeclaration(D.URI.revive(Q),ee,H),[],H)}registerImplementationProvider(B,Q,ee){const H=this.t(new I(this.h,ee),B);return this.e.$registerImplementationSupport(H,this.o(Q,B)),this.p(H)}$provideImplementation(B,Q,ee,H){return this.s(B,I,oe=>oe.provideImplementation(D.URI.revive(Q),ee,H),[],H)}registerTypeDefinitionProvider(B,Q,ee){const H=this.t(new $(this.h,ee),B);return this.e.$registerTypeDefinitionSupport(H,this.o(Q,B)),this.p(H)}$provideTypeDefinition(B,Q,ee,H){return this.s(B,$,oe=>oe.provideTypeDefinition(D.URI.revive(Q),ee,H),[],H)}registerHoverProvider(B,Q,ee,H){const oe=this.t(new f(this.h,ee),B);return this.e.$registerHoverProvider(oe,this.o(Q,B)),this.p(oe)}$provideHover(B,Q,ee,H){return this.s(B,f,oe=>oe.provideHover(D.URI.revive(Q),ee,H),void 0,H)}registerEvaluatableExpressionProvider(B,Q,ee,H){const oe=this.t(new y(this.h,ee),B);return this.e.$registerEvaluatableExpressionProvider(oe,this.o(Q,B)),this.p(oe)}$provideEvaluatableExpression(B,Q,ee,H){return this.s(B,y,oe=>oe.provideEvaluatableExpression(D.URI.revive(Q),ee,H),void 0,H)}registerInlineValuesProvider(B,Q,ee,H){const oe=typeof ee.onDidChangeInlineValues=="function"?this.q():void 0,le=this.t(new L(this.h,ee),B);this.e.$registerInlineValuesProvider(le,this.o(Q,B),oe);let Re=this.p(le);if(oe!==void 0){const je=ee.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(oe));Re=P.$lL.from(Re,je)}return Re}$provideInlineValues(B,Q,ee,H,oe){return this.s(B,L,le=>le.provideInlineValues(D.URI.revive(Q),ee,H,oe),void 0,oe)}registerDocumentHighlightProvider(B,Q,ee){const H=this.t(new T(this.h,ee),B);return this.e.$registerDocumentHighlightProvider(H,this.o(Q,B)),this.p(H)}registerMultiDocumentHighlightProvider(B,Q,ee){const H=this.t(new U(this.h,ee),B);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(Q,B)),this.p(H)}$provideDocumentHighlights(B,Q,ee,H){return this.s(B,T,oe=>oe.provideDocumentHighlights(D.URI.revive(Q),ee,H),void 0,H)}$provideMultiDocumentHighlights(B,Q,ee,H,oe){return this.s(B,U,le=>le.provideMultiDocumentHighlights(D.URI.revive(Q),ee,H.map(Re=>D.URI.revive(Re)),oe),void 0,oe)}registerLinkedEditingRangeProvider(B,Q,ee){const H=this.t(new j(this.h,ee),B);return this.e.$registerLinkedEditingRangeProvider(H,this.o(Q,B)),this.p(H)}$provideLinkedEditingRanges(B,Q,ee,H){return this.s(B,j,async oe=>{const le=await oe.provideLinkedEditingRanges(D.URI.revive(Q),ee,H);if(le)return{ranges:le.ranges,wordPattern:le.wordPattern?ve.w(le.wordPattern):void 0}},void 0,H)}registerReferenceProvider(B,Q,ee){const H=this.t(new F(this.h,ee),B);return this.e.$registerReferenceSupport(H,this.o(Q,B)),this.p(H)}$provideReferences(B,Q,ee,H,oe){return this.s(B,F,le=>le.provideReferences(D.URI.revive(Q),ee,H,oe),void 0,oe)}registerCodeActionProvider(B,Q,ee,H){const oe=new c.$Sc,le=this.t(new M(this.h,this.j.converter,this.k,ee,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(le,this.o(Q,B),{providedKinds:H?.providedCodeActionKinds?.map(Re=>Re.value),documentation:H?.documentation?.map(Re=>({kind:Re.kind.value,command:this.j.converter.toInternal(Re.command,oe)}))},ve.u(B),!!ee.resolveCodeAction),oe.add(this.p(le)),oe}$provideCodeActions(B,Q,ee,H,oe){return this.s(B,M,le=>le.provideCodeActions(D.URI.revive(Q),ee,H,oe),void 0,oe)}$resolveCodeAction(B,Q,ee){return this.s(B,M,H=>H.resolveCodeAction(Q,ee),{},void 0)}$releaseCodeActions(B,Q){this.s(B,M,ee=>Promise.resolve(ee.releaseCodeActions(Q)),void 0,void 0)}registerDocumentFormattingEditProvider(B,Q,ee){const H=this.t(new z(this.h,ee),B);return this.e.$registerDocumentFormattingSupport(H,this.o(Q,B),B.identifier,B.displayName||B.name),this.p(H)}$provideDocumentFormattingEdits(B,Q,ee,H){return this.s(B,z,oe=>oe.provideDocumentFormattingEdits(D.URI.revive(Q),ee,H),void 0,H)}registerDocumentRangeFormattingEditProvider(B,Q,ee){const H=typeof ee.provideDocumentRangesFormattingEdits=="function",oe=this.t(new J(this.h,ee),B);return this.e.$registerRangeFormattingSupport(oe,this.o(Q,B),B.identifier,B.displayName||B.name,H),this.p(oe)}$provideDocumentRangeFormattingEdits(B,Q,ee,H,oe){return this.s(B,J,le=>le.provideDocumentRangeFormattingEdits(D.URI.revive(Q),ee,H,oe),void 0,oe)}$provideDocumentRangesFormattingEdits(B,Q,ee,H,oe){return this.s(B,J,le=>le.provideDocumentRangesFormattingEdits(D.URI.revive(Q),ee,H,oe),void 0,oe)}registerOnTypeFormattingEditProvider(B,Q,ee,H){const oe=this.t(new te(this.h,ee),B);return this.e.$registerOnTypeFormattingSupport(oe,this.o(Q,B),H,B.identifier),this.p(oe)}$provideOnTypeFormattingEdits(B,Q,ee,H,oe,le){return this.s(B,te,Re=>Re.provideOnTypeFormattingEdits(D.URI.revive(Q),ee,H,oe,le),void 0,le)}registerWorkspaceSymbolProvider(B,Q){const ee=this.t(new x(Q,this.l),B);return this.e.$registerNavigateTypeSupport(ee,typeof Q.resolveWorkspaceSymbol=="function"),this.p(ee)}$provideWorkspaceSymbols(B,Q,ee){return this.s(B,x,H=>H.provideWorkspaceSymbols(Q,ee),{symbols:[]},ee)}$resolveWorkspaceSymbol(B,Q,ee){return this.s(B,x,H=>H.resolveWorkspaceSymbol(Q,ee),void 0,void 0)}$releaseWorkspaceSymbols(B,Q){this.s(B,x,ee=>ee.releaseWorkspaceSymbols(Q),void 0,void 0)}registerRenameProvider(B,Q,ee){const H=this.t(new X(this.h,ee,this.l),B);return this.e.$registerRenameSupport(H,this.o(Q,B),X.supportsResolving(ee)),this.p(H)}$provideRenameEdits(B,Q,ee,H,oe){return this.s(B,X,le=>le.provideRenameEdits(D.URI.revive(Q),ee,H,oe),void 0,oe)}$resolveRenameLocation(B,Q,ee,H){return this.s(B,X,oe=>oe.resolveRenameLocation(D.URI.revive(Q),ee,H),void 0,H)}registerDocumentSemanticTokensProvider(B,Q,ee,H){const oe=this.t(new ae(this.h,ee),B),le=typeof ee.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(oe,this.o(Q,B),H,le);let Re=this.p(oe);if(le){const je=ee.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(le));Re=P.$lL.from(Re,je)}return Re}$provideDocumentSemanticTokens(B,Q,ee,H){return this.s(B,ae,oe=>oe.provideDocumentSemanticTokens(D.URI.revive(Q),ee,H),null,H)}$releaseDocumentSemanticTokens(B,Q){this.s(B,ae,ee=>ee.releaseDocumentSemanticColoring(Q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,Q,ee,H){const oe=this.t(new _(this.h,ee),B);return this.e.$registerDocumentRangeSemanticTokensProvider(oe,this.o(Q,B),H),this.p(oe)}$provideDocumentRangeSemanticTokens(B,Q,ee,H){return this.s(B,_,oe=>oe.provideDocumentRangeSemanticTokens(D.URI.revive(Q),ee,H),null,H)}registerCompletionItemProvider(B,Q,ee,H){const oe=this.t(new ge(this.h,this.j.converter,ee,this.m,B),B);return this.e.$registerCompletionsProvider(oe,this.o(Q,B),H,ge.supportsResolving(ee),B.identifier),this.p(oe)}$provideCompletionItems(B,Q,ee,H,oe){return this.s(B,ge,le=>le.provideCompletionItems(D.URI.revive(Q),ee,H,oe),void 0,oe)}$resolveCompletionItem(B,Q,ee){return this.s(B,ge,H=>H.resolveCompletionItem(Q,ee),void 0,ee)}$releaseCompletionItems(B,Q){this.s(B,ge,ee=>ee.releaseCompletionItems(Q),void 0,void 0)}registerInlineCompletionsProvider(B,Q,ee,H){const oe=new K(B,this.h,ee,this.j.converter),le=this.t(oe,B);return this.e.$registerInlineCompletionsSupport(le,this.o(Q,B),oe.supportsHandleEvents,S.$nm.toKey(B.identifier.value),H?.yieldTo?.map(Re=>S.$nm.toKey(Re))||[]),this.p(le)}$provideInlineCompletions(B,Q,ee,H,oe){return this.s(B,ne,le=>le.provideInlineCompletions(D.URI.revive(Q),ee,H,oe),void 0,oe)}$handleInlineCompletionDidShow(B,Q,ee,H){this.s(B,ne,async oe=>{oe.handleDidShowCompletionItem(Q,ee,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,Q,ee,H){this.s(B,ne,async oe=>{oe.handlePartialAccept(Q,ee,H)},void 0,void 0)}$freeInlineCompletionsList(B,Q){this.s(B,ne,async ee=>{ee.disposeCompletions(Q)},void 0,void 0)}registerSignatureHelpProvider(B,Q,ee,H){const oe=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,le=this.t(new re(this.h,ee),B);return this.e.$registerSignatureHelpProvider(le,this.o(Q,B),oe),this.p(le)}$provideSignatureHelp(B,Q,ee,H,oe){return this.s(B,re,le=>le.provideSignatureHelp(D.URI.revive(Q),ee,H,oe),void 0,oe)}$releaseSignatureHelp(B,Q){this.s(B,re,ee=>ee.releaseSignatureHelp(Q),void 0,void 0)}registerInlayHintsProvider(B,Q,ee){const H=typeof ee.onDidChangeInlayHints=="function"?this.q():void 0,oe=this.t(new ye(this.h,this.j.converter,ee,this.l,B),B);this.e.$registerInlayHintsProvider(oe,this.o(Q,B),typeof ee.resolveInlayHint=="function",H,ve.u(B));let le=this.p(oe);if(H!==void 0){const Re=ee.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(H));le=P.$lL.from(le,Re)}return le}$provideInlayHints(B,Q,ee,H){return this.s(B,ye,oe=>oe.provideInlayHints(D.URI.revive(Q),ee,H),void 0,H)}$resolveInlayHint(B,Q,ee){return this.s(B,ye,H=>H.resolveInlayHint(Q,ee),void 0,ee)}$releaseInlayHints(B,Q){this.s(B,ye,ee=>ee.releaseHints(Q),void 0,void 0)}registerDocumentLinkProvider(B,Q,ee){const H=this.t(new he(this.h,ee),B);return this.e.$registerDocumentLinkProvider(H,this.o(Q,B),typeof ee.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(B,Q,ee){return this.s(B,he,H=>H.provideLinks(D.URI.revive(Q),ee),void 0,ee,Q.scheme==="output")}$resolveDocumentLink(B,Q,ee){return this.s(B,he,H=>H.resolveLink(Q,ee),void 0,void 0,!0)}$releaseDocumentLinks(B,Q){this.s(B,he,ee=>ee.releaseLinks(Q),void 0,void 0,!0)}registerColorProvider(B,Q,ee){const H=this.t(new fe(this.h,ee),B);return this.e.$registerDocumentColorProvider(H,this.o(Q,B)),this.p(H)}$provideDocumentColors(B,Q,ee){return this.s(B,fe,H=>H.provideColors(D.URI.revive(Q),ee),[],ee)}$provideColorPresentations(B,Q,ee,H){return this.s(B,fe,oe=>oe.provideColorPresentations(D.URI.revive(Q),ee,H),void 0,H)}registerFoldingRangeProvider(B,Q,ee){const H=this.q(),oe=typeof ee.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Pe(new ue(this.h,ee),B)),this.e.$registerFoldingRangeProvider(H,this.o(Q,B),B.identifier,oe);let le=this.p(H);if(oe!==void 0){const Re=ee.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(oe));le=P.$lL.from(le,Re)}return le}$provideFoldingRanges(B,Q,ee,H){return this.s(B,ue,oe=>oe.provideFoldingRanges(D.URI.revive(Q),ee,H),void 0,H)}registerSelectionRangeProvider(B,Q,ee){const H=this.t(new me(this.h,ee,this.l),B);return this.e.$registerSelectionRangeProvider(H,this.o(Q,B)),this.p(H)}$provideSelectionRanges(B,Q,ee,H){return this.s(B,me,oe=>oe.provideSelectionRanges(D.URI.revive(Q),ee,H),[],H)}registerCallHierarchyProvider(B,Q,ee){const H=this.t(new V(this.h,ee),B);return this.e.$registerCallHierarchyProvider(H,this.o(Q,B)),this.p(H)}$prepareCallHierarchy(B,Q,ee,H){return this.s(B,V,oe=>Promise.resolve(oe.prepareSession(D.URI.revive(Q),ee,H)),void 0,H)}$provideCallHierarchyIncomingCalls(B,Q,ee,H){return this.s(B,V,oe=>oe.provideCallsTo(Q,ee,H),void 0,H)}$provideCallHierarchyOutgoingCalls(B,Q,ee,H){return this.s(B,V,oe=>oe.provideCallsFrom(Q,ee,H),void 0,H)}$releaseCallHierarchy(B,Q){this.s(B,V,ee=>Promise.resolve(ee.releaseSession(Q)),void 0,void 0)}registerTypeHierarchyProvider(B,Q,ee){const H=this.t(new Y(this.h,ee),B);return this.e.$registerTypeHierarchyProvider(H,this.o(Q,B)),this.p(H)}$prepareTypeHierarchy(B,Q,ee,H){return this.s(B,Y,oe=>Promise.resolve(oe.prepareSession(D.URI.revive(Q),ee,H)),void 0,H)}$provideTypeHierarchySupertypes(B,Q,ee,H){return this.s(B,Y,oe=>oe.provideSupertypes(Q,ee,H),void 0,H)}$provideTypeHierarchySubtypes(B,Q,ee,H){return this.s(B,Y,oe=>oe.provideSubtypes(Q,ee,H),void 0,H)}$releaseTypeHierarchy(B,Q){this.s(B,Y,ee=>Promise.resolve(ee.releaseSession(Q)),void 0,void 0)}registerDocumentOnDropEditProvider(B,Q,ee,H){const oe=this.q();this.f.set(oe,new Pe(new de(this.e,this.h,ee,oe,B),B));const le=(0,t.$KF)(B,"dropMetadata")&&H?de.toInternalProviderId(B.identifier.value,H.id):void 0;return this.e.$registerDocumentOnDropEditProvider(oe,this.o(Q,B),le,(0,t.$KF)(B,"dropMetadata")?H:void 0),this.p(oe)}$provideDocumentOnDropEdits(B,Q,ee,H,oe,le){return this.s(B,de,Re=>Promise.resolve(Re.provideDocumentOnDropEdits(Q,D.URI.revive(ee),H,oe,le)),void 0,void 0)}registerMappedEditsProvider(B,Q,ee){const H=this.t(new we(this.h,ee),B);return this.e.$registerMappedEditsProvider(H,this.o(Q,B)),this.p(H)}$provideMappedEdits(B,Q,ee,H,oe){return this.s(B,we,le=>Promise.resolve(le.provideMappedEdits(Q,ee,H,oe)),null,oe)}registerDocumentPasteEditProvider(B,Q,ee,H){const oe=this.q();this.f.set(oe,new Pe(new O(this.e,this.h,ee,oe,B),B));const le=O.toInternalProviderId(B.identifier.value,H.id);return this.e.$registerPasteEditProvider(oe,this.o(Q,B),le,{supportsCopy:!!ee.prepareDocumentPaste,supportsPaste:!!ee.provideDocumentPasteEdits,copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(oe)}$prepareDocumentPaste(B,Q,ee,H,oe){return this.s(B,O,le=>le.prepareDocumentPaste(D.URI.revive(Q),ee,H,oe),void 0,oe)}$providePasteEdits(B,Q,ee,H,oe,le){return this.s(B,O,Re=>Re.providePasteEdits(Q,D.URI.revive(ee),H,oe,le),void 0,le)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:ve.w(B.decreaseIndentPattern),increaseIndentPattern:ve.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?ve.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?ve.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:ve.w(B.beforeText),afterText:B.afterText?ve.w(B.afterText):void 0,previousLineText:B.previousLineText?ve.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(ve.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(Q=>P.SyntaxTokenType.toString(Q)):void 0}}static D(B){return B.map(ve.C)}setLanguageConfiguration(B,Q,ee){const{wordPattern:H}=ee;if(H&&(0,b.$Ze)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(Q,H):this.h.setWordDefinitionFor(Q,void 0),ee.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),ee.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const oe=this.q(),le={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?ve.w(ee.wordPattern):void 0,indentationRules:ee.indentationRules?ve.y(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?ve.B(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport,autoClosingPairs:ee.autoClosingPairs?ve.D(ee.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(oe,Q,le),this.p(oe)}$setWordDefinitions(B){for(const Q of B)this.h.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.$5fc=ve}),define(ke[330],Se([1,0,6,15,7,39,8,3,26]),function($e,e,D,N,h,P,A,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0;class k{constructor(C,w,E,S){this.c=w,this.d=E,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(D.$jL.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,w){await this.a.$changeLanguage(C,w);const E=this.c.getDocumentData(C);if(!E)throw new Error(`document '${C.toString()}' NOT found`);return E.document}async tokenAtPosition(C,w){const E=C.version,S=N.Position.from(w),c=await this.a.$tokensAtPosition(C.uri,S),m={type:h.StandardTokenType.Other,range:C.getWordRangeAtPosition(w)??new h.$nL(w.line,w.character,w.line,w.character)};if(!c)return m;const a={range:N.Range.to(c.range),type:N.TokenType.to(c.type)};return!a.range.contains(w)||E!==C.version?m:a}createLanguageStatusItem(C,w,E){const S=this.f++,c=this.a,m=this.g,a=`${C.identifier.value}/${w}`;if(m.has(a))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);m.add(a);const i={selector:E,id:w,name:C.displayName??C.name,severity:h.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const r=new p.$Sc,s=()=>{if(n?.dispose(),!m.has(a)){console.warn(`LanguageStatusItem (${w}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,A.$0g)(()=>{r.clear(),this.a.$setLanguageStatus(S,{id:a,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:N.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===h.LanguageStatusSeverity.Error?P.default.Error:i.severity===h.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:i.command&&this.d.toInternal(i.command,r),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){r.dispose(),n?.dispose(),c.$removeLanguageStatus(S),m.delete(a)},get id(){return i.id},get name(){return i.name},set name(g){i.name=g,s()},get selector(){return i.selector},set selector(g){i.selector=g,s()},get text(){return i.text},set text(g){i.text=g,s()},set text2(g){(0,b.$LF)(C,"languageStatusText"),i.text=g,s()},get text2(){return(0,b.$LF)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(g){i.detail=g,s()},get severity(){return i.severity},set severity(g){i.severity=g,s()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(g){i.accessibilityInformation=g,s()},get command(){return i.command},set command(g){i.command=g,s()},get busy(){return i.busy},set busy(g){i.busy=g,s()}};return s(),t}}e.$rhc=k}),define(ke[331],Se([1,0,16,2,15,7,118]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=e.$chc=void 0;class p{constructor(C,w,E,S){this.start=C,this.deletedCount=w,this.deletedItems=E,this.items=S}asApiEvent(){return{range:new P.$KM(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class b{static asModelAddData(C,w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,w,E){this.notebook=C,this.h=w,this.j=E,this.handle=E.handle,this.uri=N.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(h.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(h.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,w=this.h.getDocument(this.uri);if(!w)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:h.NotebookCellKind.to(this.j.cellKind),document:w.document,get mime(){return C.g},set mime(S){C.g=S},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(E)}return this.f}setOutputs(C){this.a=C.map(h.NotebookCellOutput.to)}setOutputItems(C,w,E){const S=E.map(h.NotebookCellOutputItem.to),c=this.a.find(m=>m.id===C);if(c&&(w||(c.items.length=0),c.items.push(...S),c.items.length>1&&c.items.every(m=>A.$mJ(m.mime)))){const m=new Map,a=[];c.items.forEach(i=>{let n;m.has(i.mime)?n=m.get(i.mime):(n=[],m.set(i.mime,n),a.push(i.mime)),n.push(i.data)}),c.items.length=0,a.forEach(i=>{const n=A.$nJ(m.get(i));c.items.push({mime:i,data:n.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(h.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$chc=b;class k{static{this.a=0}constructor(C,w,E,S,c){this.k=C,this.l=w,this.m=E,this.uri=S,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=c.viewType,this.f=Object.freeze(c.metadata??Object.create(null)),this.r([[0,0,c.cells]],!0,void 0),this.g=c.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,w={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===D.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(E){return E=C.n(E),C.b[E].apiCell},getCells(E){return(E?C.p(E):C.b).map(c=>c.apiCell)},save(){return C.q()}};this.e=Object.freeze(w)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,w,E){this.g=C.versionId,this.h=w,this.acceptDocumentPropertiesChanged({metadata:E});const S={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},c=[];for(const a of C.rawEvents)a.kind===A.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,S.contentChanges):a.kind===A.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,S.contentChanges):a.kind===A.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),c.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),c.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),c.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===A.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),c.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),c.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const m=new Map;for(let a=0;a<c.length;a++){const i=c[a],n=m.get(i.cell);if(n===void 0){const r=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});m.set(i.cell,r-1)}else S.cellChanges[n]={...S.cellChanges[n],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let w=C.start|0,E=C.end|0;return w<0&&(w=0),E>this.b.length&&(E=this.b.length),C.with({start:w,end:E})}p(C){C=this.o(C);const w=[];for(let E=C.start;E<C.end;E++)w.push(this.b[E]);return w}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,w,E){if(this.j)return;const S=[],c=[],m=[];if(C.reverse().forEach(a=>{const n=a[2].map(t=>{const g=new b(this,this.l,t);return w||c.push(b.asModelAddData(this.apiNotebook,t)),g}),r=new p(a[0],a[1],[],n),s=this.b.splice(a[0],a[1],...n);for(const t of s)m.push(t.uri),r.deletedItems.push(t.apiCell);S.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:m}),E)for(const a of S)E.push(a.asApiEvent())}s(C,w,E,S){const c=this.b.splice(C,w);this.b.splice(E,0,...c);const m=[new p(C,w,c.map(a=>a.apiCell),[]),new p(E,0,[],c)];for(const a of m)S.push(a.asApiEvent())}t(C,w){this.b[C].setOutputs(w)}u(C,w,E,S){this.b[C].setOutputItems(w,E,S)}v(C,w){const E=this.b[C];E.apiCell.document.languageId!==w&&this.m.$acceptModelLanguageChanged(E.uri,w)}w(C,w){const E=this.b[C];E.apiCell.mime=w}x(C,w){this.b[C].setMetadata(w)}y(C,w){this.b[C].setInternalMetadata(w)}getCellFromApiCell(C){return this.b.find(w=>w.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(w=>w.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$dhc=k}),define(ke[332],Se([1,0,4,2,15,7]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=void 0;class A{constructor(b,k,R,C={timeout:1500,errors:3}){this.b=b,this.c=k,this.d=R,this.f=C,this.a=new D.$Yd}dispose(){}getOnWillSaveNotebookDocumentEvent(b){return(k,R,C)=>{const w=function(S){k.call(R,S)};return w.extension=b,this.a.event(w,void 0,C)}}async $participateInSave(b,k,R){const C=N.URI.revive(b),w=this.c.getNotebookDocument(C);if(!w)throw new Error("Unable to resolve notebook document");const E=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:h.TextDocumentSaveReason.to(k)},R,async(c,m)=>{const a=Date.now(),i=await await Promise.resolve(c);Date.now()-a>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier),!R.isCancellationRequested&&i&&(i instanceof P.$vL?E.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(E.length===0)return!0;const S={edits:[]};for(const c of E){const{edits:m}=h.WorkspaceEdit.from(c);S.edits=S.edits.concat(m)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$thc=A}),define(ke[149],Se([1,0,14,15,7]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0;class P{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,b,k,R,C,w){this.id=p,this.f=b,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=R,this.c=w}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection(b){this.selections=[b]},get selections(){return p.a},set selections(b){if(!Array.isArray(b)||!b.every(h.$KM.isNotebookRange))throw(0,D.$7)("selections");p.a=b,p.g(b)},get visibleRanges(){return p.b},revealRange(b,k){p.f.$tryRevealRange(p.id,N.NotebookRange.from(b),k??h.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},P.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(N.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$ehc=P}),define(ke[333],Se([1,0,4,13,15]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=void 0;let P=class{constructor(p,b){this.c=p,this.d=b,this.a=new D.$Wd,this.b=new D.$Wd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,b){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,b);const k=this.d.getEditorById(p);b.visibleRanges&&k._acceptVisibleRanges(b.visibleRanges.ranges.map(h.NotebookRange.to)),b.selections&&k._acceptSelections(b.selections.selections.map(h.NotebookRange.to)),b.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),b.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const b in p)this.d.getEditorById(b)._acceptViewColumn(h.ViewColumn.to(p[b]))}};e.$vhc=P,e.$vhc=P=Ge([Ve(0,N.$pj)],P)}),define(ke[334],Se([1,0,4,6,149]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=void 0;class P{constructor(p,b){this.c=b,this.a=new Map,this.b=p.getProxy(N.$jL.MainThreadNotebookRenderers)}$postRendererMessage(p,b,k){const R=this.c.getEditorById(p);this.a.get(b)?.fire({editor:R.apiEditor,message:k})}createRendererMessaging(p,b){if(!p.contributes?.notebookRenderer?.some(R=>R.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);return{onDidReceiveMessage:(R,C,w)=>this.d(b).event(R,C,w),postMessage:(R,C)=>{h.$ehc.apiEditorsToExtHost.has(R)&&([R,C]=[C,R]);const w=C&&h.$ehc.apiEditorsToExtHost.get(C);return this.b.$postMessage(w?.id,b,R)}}}d(p){let b=this.a.get(p);return b||(b=new D.$Wd({onDidRemoveLastListener:()=>{b?.dispose(),this.a.delete(p)}}),this.a.set(p,b),b)}}e.$yhc=P}),define(ke[335],Se([1,0,15,86,22,52,14]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;class p{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,w,E){const S=this.b++,{title:c,location:m,cancellable:a}=w,i={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(S,{location:D.ProgressLocation.from(m),title:c,source:i,cancellable:a},C.isUnderDevelopment?void 0:C.identifier.value).catch(A.$2),this.d(S,E,!!a)}d(C,w,E){let S;E&&(S=new h.$7d,this.c.set(C,S));const c=a=>{this.a.$progressEnd(a),this.c.delete(a),S?.dispose()};let m;try{m=w(new k(this.a,C),E&&S?S.token:h.CancellationToken.None)}catch(a){throw c(C),a}return m.then(a=>c(C),a=>c(C)),m}$acceptProgressCanceled(C){const w=this.c.get(C);w&&(w.cancel(),this.c.delete(C))}}e.$Chc=p;function b(R,C){return R.message=C.message,typeof C.increment=="number"&&(typeof R.increment=="number"?R.increment+=C.increment:R.increment=C.increment),R}class k extends N.$xv{constructor(C,w){super(E=>this.throttledReport(E)),this.c=C,this.d=w}throttledReport(C){this.c.$progressReport(this.d,C)}}Ge([(0,P.$Bh)(100,(R,C)=>b(R,C),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(ke[336],Se([1,0,2,6,8,15]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;class A{static{this.a=0}constructor(b,k){this.d=k,this.c=new Map,this.b=b.getProxy(N.$jL.MainThreadQuickDiff)}$provideOriginalResource(b,k,R){const C=D.URI.revive(k),w=this.c.get(b);return w?(0,h.$Zg)(()=>w.provideOriginalResource(C,R)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(b,k,R,C){const w=A.a++;return this.c.set(w,k),this.b.$registerQuickDiffProvider(w,P.DocumentSelector.from(b,this.d),R,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(w),this.c.delete(w)}}}}e.$Dhc=A}),define(ke[337],Se([1,0,22,4,3,6,2,7,14,19,39,55,26,15]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=void 0;function S(c,m,a){const i=c.getProxy(P.$jL.MainThreadQuickOpen);class n{constructor(v,I){this.e=new Map,this.f=0,this.a=v,this.b=I}showQuickPick(v,I,$,f=D.CancellationToken.None){this.c=void 0;const y=Promise.resolve(I),L=++this.f,T=i.$show(L,{title:$?.title,placeHolder:$?.placeHolder,matchOnDescription:$?.matchOnDescription,matchOnDetail:$?.matchOnDetail,ignoreFocusLost:$?.ignoreFocusOut,canPickMany:$?.canPickMany},f),U={},j=T.then(()=>U);return Promise.race([j,y]).then(F=>{if(F===U)return;const M=(0,w.$KF)(v,"quickPickItemTooltip");return y.then(O=>{const z=[];for(let J=0;J<O.length;J++){const te=O[J];if(typeof te=="string")z.push({label:te,handle:J});else if(te.kind===p.QuickPickItemKind.Separator)z.push({type:"separator",label:te.label});else{te.tooltip&&!M&&console.warn(`Extension '${v.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`);const x=te.iconPath?o(te.iconPath):void 0;z.push({label:te.label,iconPath:x?.iconPath,iconClass:x?.iconClass,description:te.description,detail:te.detail,picked:te.picked,alwaysShow:te.alwaysShow,tooltip:M?E.MarkdownString.fromStrict(te.tooltip):void 0,handle:J})}}return $&&typeof $.onDidSelectItem=="function"&&(this.c=J=>{$.onDidSelectItem(O[J])}),i.$setItems(L,z),T.then(J=>{if(typeof J=="number")return O[J];if(Array.isArray(J))return J.map(te=>O[te])})})}).then(void 0,F=>{if(!(0,b.$4)(F))return i.$setError(L,F),Promise.reject(F)})}$onItemSelected(v){this.c?.(v)}showInput(v,I=D.CancellationToken.None){return this.d=v?.validateInput,i.$input(v,typeof this.d=="function",I).then(void 0,$=>{if(!(0,b.$4)($))return Promise.reject($)})}async $validateInput(v){if(!this.d)return;const I=await this.d(v);if(!I||typeof I=="string")return I;let $;switch(I.severity){case p.InputBoxValidationSeverity.Info:$=R.default.Info;break;case p.InputBoxValidationSeverity.Warning:$=R.default.Warning;break;case p.InputBoxValidationSeverity.Error:$=R.default.Error;break;default:$=I.message?R.default.Error:R.default.Ignore;break}return{content:I.message,severity:$}}async showWorkspaceFolderPick(v,I=D.CancellationToken.None){const $=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[v]);if(!$)return;const f=await this.a.getWorkspaceFolders2();if(f)return f.find(y=>y.uri.toString()===$.uri.toString())}createQuickPick(v){const I=new d(v,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(v){const I=new l(v,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(v,I){this.e.get(v)?._fireDidChangeValue(I)}$onDidAccept(v){this.e.get(v)?._fireDidAccept()}$onDidChangeActive(v,I){const $=this.e.get(v);$ instanceof d&&$._fireDidChangeActive(I)}$onDidChangeSelection(v,I){const $=this.e.get(v);$ instanceof d&&$._fireDidChangeSelection(I)}$onDidTriggerButton(v,I){this.e.get(v)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(v,I,$){const f=this.e.get(v);f instanceof d&&f._fireDidTriggerItemButton(I,$)}$onDidHide(v){this.e.get(v)?._fireDidHide()}}class r{static{this.a=1}constructor(v,I){this.x=v,this.y=I,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$Wd,this.q=new N.$Wd,this.r=new N.$Wd,this.s=new N.$Wd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(v){this.b=v,this.z({title:v})}get step(){return this.c}set step(v){this.c=v,this.z({step:v})}get totalSteps(){return this.d}set totalSteps(v){this.d=v,this.z({totalSteps:v})}get enabled(){return this.g}set enabled(v){this.g=v,this.z({enabled:v})}get busy(){return this.j}set busy(v){this.j=v,this.z({busy:v})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(v){this.k=v,this.z({ignoreFocusOut:v})}get value(){return this.l}set value(v){this.l=v,this.z({value:v})}get placeholder(){return this.m}set placeholder(v){this.m=v,this.z({placeholder:v})}get buttons(){return this.n}set buttons(v){this.n=v.slice(),this.o.clear(),v.forEach((I,$)=>{const f=I===p.$HM.Back?-1:$;this.o.set(f,I)}),this.z({buttons:v.map((I,$)=>({...o(I.iconPath),tooltip:I.tooltip,handle:I===p.$HM.Back?-1:$}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(v){this.l=v,this.q.fire(v)}_fireDidTriggerButton(v){const I=this.o.get(v);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,h.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(v){if(!this.v){for(const I of Object.keys(v)){const $=v[I];this.u[I]=$===void 0?null:$}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function s(u){if(u instanceof p.$gM)return{id:u.id};const v=g(u),I=t(u);return{dark:typeof v=="string"?A.URI.file(v):v,light:typeof I=="string"?A.URI.file(I):I}}function t(u){return typeof u=="object"&&"light"in u?u.light:u}function g(u){return typeof u=="object"&&"dark"in u?u.dark:u}function o(u){const v=s(u);let I,$;return"id"in v?$=C.ThemeIcon.asClassName(v):I=v,{iconPath:I,iconClass:$}}class d extends r{constructor(v,I){super(v.identifier,I),this.O=v,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$Wd,this.L=[],this.M=new N.$Wd,this.N=new N.$Wd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(v){this.B=v.slice(),this.C.clear(),this.D.clear(),v.forEach((f,y)=>{this.C.set(y,f),this.D.set(f,y)});const I=(0,w.$KF)(this.O,"quickPickItemTooltip"),$=[];for(let f=0;f<v.length;f++){const y=v[f];if(y.kind===p.QuickPickItemKind.Separator)$.push({type:"separator",label:y.label});else{y.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const L=y.iconPath?o(y.iconPath):void 0;$.push({handle:f,label:y.label,iconPath:L?.iconPath,iconClass:L?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:I?E.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((T,U)=>({...o(T.iconPath),tooltip:T.tooltip,handle:U}))})}}this.z({items:$})}get canSelectMany(){return this.E}set canSelectMany(v){this.E=v,this.z({canSelectMany:v})}get matchOnDescription(){return this.F}set matchOnDescription(v){this.F=v,this.z({matchOnDescription:v})}get matchOnDetail(){return this.G}set matchOnDetail(v){this.G=v,this.z({matchOnDetail:v})}get sortByLabel(){return this.H}set sortByLabel(v){this.H=v,this.z({sortByLabel:v})}get keepScrollPosition(){return this.I}set keepScrollPosition(v){this.I=v,this.z({keepScrollPosition:v})}get activeItems(){return this.J}set activeItems(v){this.J=v.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(v){this.L=v.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(v){const I=(0,k.$Hb)(v.map($=>this.C.get($)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(v){const I=(0,k.$Hb)(v.map($=>this.C.get($)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(v,I){const $=this.C.get(v);if(!$||!$.buttons||!$.buttons.length)return;const f=$.buttons[I];f&&this.N.fire({button:f,item:$})}}class l extends r{constructor(v,I){super(v.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(v){this.B=v,this.z({password:v})}get prompt(){return this.C}set prompt(v){this.C=v,this.z({prompt:v})}get valueSelection(){return this.D}set valueSelection(v){this.D=v,this.z({valueSelection:v})}get validationMessage(){return this.E}set validationMessage(v){this.E=v,v?typeof v=="string"?this.z({validationMessage:v,severity:R.default.Error}):this.z({validationMessage:v.message,severity:v.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new n(m,a)}e.$Ehc=S}),define(ke[338],Se([1,0,2,4,52,3,8,6,19,128,13,25,55,15,26,16,11]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=e.$Fhc=void 0;function i(L){return L instanceof D.URI}function n(L,T){return L.scheme===c.Schemas.file&&T.scheme===c.Schemas.file&&m.$k?L.toString()===T.toString():L.toString().toLowerCase()===T.toString().toLowerCase()}function r(L){if(L)return typeof L.iconPath=="string"?D.URI.file(L.iconPath):D.URI.isUri(L.iconPath)||w.ThemeIcon.isThemeIcon(L.iconPath)?L.iconPath:void 0}function s(L){if(L.icon){if(D.URI.isUri(L.icon))return L.icon;if(w.ThemeIcon.isThemeIcon(L.icon))return L.icon;{const T=L.icon;return{light:T.light,dark:T.dark}}}else return}function t(L,T){if(!L.iconPath&&!T.iconPath)return 0;if(L.iconPath){if(!T.iconPath)return 1}else return-1;const U=typeof L.iconPath=="string"?L.iconPath:D.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id,j=typeof T.iconPath=="string"?T.iconPath:D.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id;return(0,k.$Uq)(U,j)}function g(L,T){let U=0;if(L.strikeThrough!==T.strikeThrough)return L.strikeThrough?1:-1;if(L.faded!==T.faded)return L.faded?1:-1;if(L.tooltip!==T.tooltip)return(L.tooltip||"").localeCompare(T.tooltip||"");if(U=t(L,T),U!==0)return U;if(L.light&&T.light)U=t(L.light,T.light);else{if(L.light)return 1;if(T.light)return-1}if(U!==0)return U;if(L.dark&&T.dark)U=t(L.dark,T.dark);else{if(L.dark)return 1;if(T.dark)return-1}return U}function o(L,T){if(L.command!==T.command)return L.command<T.command?-1:1;if(L.title!==T.title)return L.title<T.title?-1:1;if(L.tooltip!==T.tooltip){if(L.tooltip!==void 0&&T.tooltip!==void 0)return L.tooltip<T.tooltip?-1:1;if(L.tooltip!==void 0)return 1;if(T.tooltip!==void 0)return-1}if(L.arguments===T.arguments)return 0;if(L.arguments)if(T.arguments){if(L.arguments.length!==T.arguments.length)return L.arguments.length-T.arguments.length}else return 1;else return-1;for(let U=0;U<L.arguments.length;U++){const j=L.arguments[U],F=T.arguments[U];if(j!==F&&!(i(j)&&i(F)&&n(j,F)))return j<F?-1:1}return 0}function d(L,T){let U=(0,k.$Uq)(L.resourceUri.fsPath,T.resourceUri.fsPath,!0);if(U!==0)return U;if(L.command&&T.command)U=o(L.command,T.command);else{if(L.command)return 1;if(T.command)return-1}if(U!==0)return U;if(L.decorations&&T.decorations)U=g(L.decorations,T.decorations);else{if(L.decorations)return 1;if(T.decorations)return-1}if(L.multiFileDiffEditorModifiedUri&&T.multiFileDiffEditorModifiedUri)U=(0,k.$Uq)(L.multiFileDiffEditorModifiedUri.fsPath,T.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(L.multiFileDiffEditorModifiedUri)return 1;if(T.multiFileDiffEditorModifiedUri)return-1}if(L.multiDiffEditorOriginalUri&&T.multiDiffEditorOriginalUri)U=(0,k.$Uq)(L.multiDiffEditorOriginalUri.fsPath,T.multiDiffEditorOriginalUri.fsPath,!0);else{if(L.multiDiffEditorOriginalUri)return 1;if(T.multiDiffEditorOriginalUri)return-1}return U}function l(L,T){for(let U=0;U<L.length;U++)if(L[U]!==T[U])return!1;return!0}function u(L,T){return L.command===T.command&&L.title===T.title&&L.tooltip===T.tooltip&&(L.arguments&&T.arguments?l(L.arguments,T.arguments):L.arguments===T.arguments)}function v(L,T){return(0,b.$ub)(L,T,u)}class I{#e;#t;get value(){return this.d}set value(T){T=T??"",this.#e.$setInputBoxValue(this.l,T),this.n(T)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(T){this.#e.$setInputBoxPlaceholder(this.l,T),this.f=T}get validateInput(){return(0,S.$LF)(this.k,"scmValidation"),this.g}set validateInput(T){if((0,S.$LF)(this.k,"scmValidation"),T&&typeof T!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=T,this.#e.$setValidationProviderIsEnabled(this.l,!!T)}get enabled(){return this.h}set enabled(T){T=!!T,this.h!==T&&(this.h=T,this.#e.$setInputBoxEnablement(this.l,T))}get visible(){return this.j}set visible(T){T=!!T,this.j!==T&&(this.j=T,this.#e.$setInputBoxVisibility(this.l,T))}get document(){return(0,S.$LF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(T,U,j,F,M){this.k=T,this.l=F,this.m=M,this.d="",this.e=new N.$Wd,this.f="",this.h=!0,this.j=!0,this.#t=U,this.#e=j}showValidationMessage(T,U){(0,S.$LF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,T,U)}$onInputBoxValueChange(T){this.n(T)}n(T){this.d=T,this.e.fire(T)}}e.$Fhc=I;class ${static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(T){this.v=T,this.q.$updateGroupLabel(this.t,this.handle,T)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(T){this.p=T,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(T){this.f=[...T],this.k.fire()}constructor(T,U,j,F,M,O,z){this.q=T,this.s=U,this.t=j,this.u=F,this.v=M,this.multiDiffEditorEnableViewChanges=O,this.w=z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$Wd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$Wd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=$.d++}getResourceState(T){return this.g.get(T)}$executeResourceCommand(T,U){const j=this.h.get(T);return j?(0,A.$Zg)(()=>this.s.executeCommand(j.command,...j.arguments||[],U)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const T=[...this.f].sort(d),j=(0,b.$Db)(this.o,T,d).map(O=>{const z=O.toInsert.map(J=>{const te=this.e++;this.g.set(te,J);const x=J.resourceUri;let X;if(J.command)if(J.command.command==="vscode.open"||J.command.command==="vscode.diff"||J.command.command==="vscode.changes"){const me=new P.$Sc;X=this.s.converter.toInternal(J.command,me),this.j.set(te,me)}else this.h.set(te,J.command);const Z=(0,S.$KF)(this.w,"scmMultiDiffEditor"),ae=Z?J.multiDiffEditorOriginalUri:void 0,_=Z?J.multiFileDiffEditorModifiedUri:void 0,ge=r(J.decorations),ne=J.decorations&&r(J.decorations.light)||ge,K=J.decorations&&r(J.decorations.dark)||ge,W=[ne,K],re=J.decorations&&J.decorations.tooltip||"",ye=J.decorations&&!!J.decorations.strikeThrough,he=J.decorations&&!!J.decorations.faded,fe=J.contextValue||"";return{rawResource:[te,x,W,re,ye,he,fe,X,ae,_],handle:te}});return{start:O.start,deleteCount:O.deleteCount,toInsert:z}}),F=j.map(({start:O,deleteCount:z,toInsert:J})=>[O,z,J.map(te=>te.rawResource)]),M=j.reverse();for(const{start:O,deleteCount:z,toInsert:J}of M){const te=J.map(X=>X.handle),x=this.n.splice(O,z,...te);for(const X of x)this.g.delete(X),this.h.delete(X),this.j.get(X)?.dispose(),this.j.delete(X)}return this.o=T,F}dispose(){this.l=!0,this.m.fire()}}class f{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(T){this.g!==T&&(this.g=T,this.#e.$updateSourceControl(this.w,{count:T}))}get quickDiffProvider(){return this.h}set quickDiffProvider(T){this.h=T;let U;(0,S.$KF)(this.x,"quickDiffProvider")&&(U=T?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!T,quickDiffLabel:U})}get historyProvider(){return(0,S.$LF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(T){(0,S.$LF)(this.x,"scmHistoryProvider"),this.j=T,this.k.value=new P.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!T}),T&&this.k.value.add(T.onDidChangeCurrentHistoryItemGroup(()=>{this.l=T?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(T){T!==this.m&&(this.m=T,this.#e.$updateSourceControl(this.w,{commitTemplate:T}))}get acceptInputCommand(){return this.o}set acceptInputCommand(T){this.n.value=new P.$Sc,this.o=T;const U=this.y.converter.toInternal(T,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:U})}get actionButton(){return(0,S.$LF)(this.x,"scmActionButton"),this.q}set actionButton(T){(0,S.$LF)(this.x,"scmActionButton"),this.p.value=new P.$Sc,this.q=T;const U=T!==void 0?{command:this.y.converter.toInternal(T.command,this.p.value),secondaryCommands:T.secondaryCommands?.map(j=>j.map(F=>this.y.converter.toInternal(F,this.p.value))),description:T.description,enabled:T.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:U??null})}get statusBarCommands(){return this.t}set statusBarCommands(T){if(this.t&&T&&v(this.t,T))return;this.s.value=new P.$Sc,this.t=T;const U=(T||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:U})}get selected(){return this.u}constructor(T,U,j,F,M,O,z){this.x=T,this.y=F,this.z=M,this.A=O,this.B=z,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new P.$Uc,this.m=void 0,this.n=new P.$Uc,this.o=void 0,this.p=new P.$Uc,this.s=new P.$Uc,this.t=void 0,this.u=!1,this.v=new N.$Wd,this.onDidChangeSelection=this.v.event,this.w=f.d++,this.C=new Map,this.D=new Set,this.#e=j;const J=D.URI.from({scheme:c.Schemas.vscodeSourceControl,path:`${M}/scm${this.w}/input`,query:z?`rootUri=${encodeURIComponent(z.toString())}`:void 0});this.f=new I(T,U,this.#e,this.w,J),this.#e.$registerSourceControl(this.w,M,O,z,J)}createResourceGroup(T,U,j){const F=(0,S.$KF)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,M=new $(this.#e,this.y,this.w,T,U,F,this.x),O=N.Event.once(M.onDidDispose)(()=>this.C.delete(M));return this.C.set(M,O),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const T=[],U=[];for(const[j,F]of this.C){F.dispose();const M=j.onDidUpdateResourceStates(()=>{this.D.add(j),this.eventuallyUpdateResourceStates()});N.Event.once(j.onDidDispose)(()=>{this.D.delete(j),M.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),T.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const O=j._takeResourceStateSnapshot();O.length>0&&U.push([j.handle,O]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,T,U),this.C.clear()}eventuallyUpdateResourceStates(){const T=[];this.D.forEach(U=>{const j=U._takeResourceStateSnapshot();j.length!==0&&T.push([U.handle,j])}),T.length>0&&this.#e.$spliceResourceStates(this.w,T),this.D.clear()}getResourceGroup(T){return this.e.get(T)}setSelectionState(T){this.u=T,this.v.fire(T)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(T=>T.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ge([(0,h.$Ah)(100)],f.prototype,"eventuallyAddResourceGroups",null),Ge([(0,h.$Ah)(100)],f.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{a=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(T,U,j,F){this.l=U,this.m=j,this.n=F,this.g=new Map,this.h=new C.$pm,this.j=new N.$Wd,this.e=T.getProxy(p.$jL.MainThreadSCM),this.f=T.getProxy(p.$jL.MainThreadTelemetry),U.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const O=this.g.get(M.sourceControlHandle);if(!O)return M;const z=O.getResourceGroup(M.groupHandle);return z?z.getResourceState(M.handle):M}else if(M&&M.$mid===4){const O=this.g.get(M.sourceControlHandle);return O?O.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const O=this.g.get(M.handle);return O||M}return M}})}createSourceControl(T,U,j,F){this.n.trace("ExtHostSCM#createSourceControl",T.identifier.value,U,j,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:T.identifier.value});const M=a.d++,O=new f(T,this.m,this.e,this.l,U,j,F);this.g.set(M,O);const z=this.h.get(T.identifier)||[];return z.push(O),this.h.set(T.identifier,z),O}getLastInputBox(T){this.n.trace("ExtHostSCM#getLastInputBox",T.identifier.value);const U=this.h.get(T.identifier),j=U&&U[U.length-1];return j&&j.inputBox}$provideOriginalResource(T,U,j){const F=D.URI.revive(U);this.n.trace("ExtHostSCM#$provideOriginalResource",T,F.toString());const M=this.g.get(T);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Zg)(()=>M.quickDiffProvider.provideOriginalResource(F,j)).then(O=>O||null)}$onInputBoxValueChange(T,U){this.n.trace("ExtHostSCM#$onInputBoxValueChange",T);const j=this.g.get(T);return j&&j.inputBox.$onInputBoxValueChange(U),Promise.resolve(void 0)}$executeResourceCommand(T,U,j,F){this.n.trace("ExtHostSCM#$executeResourceCommand",T,U,j);const M=this.g.get(T);if(!M)return Promise.resolve(void 0);const O=M.getResourceGroup(U);return O?O.$executeResourceCommand(j,F):Promise.resolve(void 0)}$validateInput(T,U,j){this.n.trace("ExtHostSCM#$validateInput",T);const F=this.g.get(T);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Zg)(()=>F.inputBox.validateInput(U,j)).then(M=>{if(!M)return Promise.resolve(void 0);const O=E.MarkdownString.fromStrict(M.message);return O?Promise.resolve([O,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(T){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",T),T!==void 0&&this.g.get(T)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=T,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(T,U,j,F){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(U,j,F)??void 0}async $provideHistoryItems(T,U,j,F){return(await this.g.get(T)?.historyProvider?.provideHistoryItems(U,j,F))?.map(z=>({...z,icon:s(z)}))??void 0}async $provideHistoryItemSummary(T,U,j,F){const M=this.g.get(T)?.historyProvider;if(typeof M?.provideHistoryItemSummary!="function")return;const O=await M.provideHistoryItemSummary(U,j,F);return O?{...O,icon:s(O)}:void 0}async $provideHistoryItemChanges(T,U,j,F){return await this.g.get(T)?.historyProvider?.provideHistoryItemChanges(U,j,F)??void 0}};e.$Ghc=y,e.$Ghc=y=a=Ge([Ve(3,R.$pj)],y)}),define(ke[339],Se([1,0,6,15,2]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;class P{static{this.a=0}constructor(p,b){this.d=b,this.c=new Map,this.b=p.getProxy(D.$jL.MainThreadShare)}async $provideShare(p,b,k){return await this.c.get(p)?.provideShare({selection:N.Range.to(b.selection),resourceUri:h.URI.revive(b.resourceUri)},k)??void 0}registerShareProvider(p,b){const k=P.a++;return this.c.set(k,b),this.b.$registerShareProvider(k,N.DocumentSelector.from(p,this.d),b.id,b.label,b.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$Hhc=P}),define(ke[340],Se([1,0,7,6,216,3,15,18]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=e.$Jhc=void 0;class b{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$hM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$hM("statusBarItem.warningForeground")]])}#e;#t;constructor(w,E,S,c,m,a=D.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new P.$Sc,this.#e=w,this.#t=E,m&&c){this.c=(0,D.$WL)(c.identifier,m);const n=S.get(this.c);n&&(a=n.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(b.a++);this.e=c,this.f=m,this.g=a,this.h=this.u(i)}u(w){if((0,p.$Nf)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(w){this.k=w,this.v()}set name(w){this.m=w,this.v()}set tooltip(w){this.l=w,this.v()}set color(w){this.n=w,this.v()}set backgroundColor(w){w&&!b.b.has(w.id)&&(w=void 0),this.o=w,this.v()}set command(w){this.r?.fromApi!==w&&(this.p&&this.q.add(this.p),this.p=new P.$Sc,typeof w=="string"?this.r={fromApi:w,internal:this.#t.toInternal({title:"",command:w},this.p)}:w?this.r={fromApi:w,internal:this.#t.toInternal(w,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(w){this.t=w,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let w;this.e?this.f?w=`${this.e.identifier.value}.${this.f}`:w=this.e.identifier.value:w=this.f;let E;this.m?E=this.m:E=(0,h.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=b.b.get(this.o.id));const c=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,w,this.e?.identifier.value,E,this.k,c,this.r?.internal,S,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Jhc=b;class k{constructor(w){this.b=[],this.a=w.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,h.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(w){const E={message:w};return this.b.unshift(E),this.c(),new D.$lL(()=>{const S=this.b.indexOf(E);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(w,E){this.e=new Map,this.a=w.getProxy(N.$jL.MainThreadStatusBar),this.b=E,this.c=new k(this)}$acceptStaticEntries(w){for(const E of w)this.e.set(E.entryId,E)}createStatusBarEntry(w,E,S,c){return new b(this.a,this.b,this.e,w,E,S,c)}setStatusBarMessage(w,E){const S=this.c.setMessage(w);let c;return typeof E=="number"?c=setTimeout(()=>S.dispose(),E):typeof E<"u"&&E.then(()=>S.dispose(),()=>S.dispose()),new D.$lL(()=>{S.dispose(),clearTimeout(c)})}}e.$Khc=R}),define(ke[150],Se([1,0,29,141,67,111,90,15,2]),function($e,e,D,N,h,P,A,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=e.$CN=e.$BN=e.$AN=void 0;const k=(n,r,s,t)=>{let g=r;return{enumerable:!0,configurable:!1,get(){return g},set(o){if(!s(g,o)){const d=g;g=o,n.listener?.(t(o,d))}}}},R=(n,r)=>n===r,C={range:(n,r)=>n===r?!0:!n||!r?!1:n.isEqual(r),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(n,r)=>!(n.length!==r.length||n.some(s=>!r.find(t=>s.id===t.id)))},w=n=>r=>({op:4,update:n(r)}),E=(n,r)=>({range:(()=>{let s;const t=w(g=>({range:D.$Ws.lift(p.Range.from(g))}));return{enumerable:!0,configurable:!1,get(){return s},set(g){n.listener?.({op:6}),C.range(s,g)||(s=g,n.listener?.(t(g)))}}})(),label:k(n,r,C.label,w(s=>({label:s}))),description:k(n,void 0,C.description,w(s=>({description:s}))),sortText:k(n,void 0,C.sortText,w(s=>({sortText:s}))),canResolveChildren:k(n,!1,C.canResolveChildren,s=>({op:2,state:s})),busy:k(n,!1,C.busy,w(s=>({busy:s}))),error:k(n,void 0,C.error,w(s=>({error:p.MarkdownString.fromStrict(s)||null}))),tags:k(n,[],C.tags,(s,t)=>({op:1,new:s.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),S=n=>{const r=h.$bK.fromString(n.extId),s=new m(r.controllerId,r.localId,n.label,b.URI.revive(n.uri)||void 0);return s.range=p.Range.to(n.range||void 0),s.description=n.description||void 0,s.sortText=n.sortText||void 0,s.tags=n.tags.map(t=>p.TestTag.to({id:(0,A.$gK)(t).tagId})),s},c=n=>{let r;for(const s of n.tests){const t=S(s.item);(0,N.$kN)(t).parent=r,r=t}return r};e.$AN=c;class m{constructor(r,s,t,g){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const o=(0,N.$jN)(this,r);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:g,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof a?void 0:o.parent}},children:{value:(0,P.$iN)(o,N.$kN,m),enumerable:!0,writable:!1},...E(o,t)})}}e.$BN=m;class a extends m{constructor(r,s){super(r,r,s,void 0),this._isRoot=!0}}e.$CN=a;class i extends P.$eN{constructor(r,s,t){super({controllerId:r,getDocumentVersion:g=>g&&t.getDocument(g)?.version,getApiFor:N.$kN,getChildren:g=>g.children,root:new a(r,s),toITestItem:p.TestItem.from})}}e.$DN=i}),define(ke[33],Se([1,0,18,7,15,24,6,19,13,56,29,48,2,3,5,20,150,21,68,44,38,88,91,30]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i,n,r,s,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=void 0;let o=class{#e;#t;#i;constructor($,f,y){this.b=new Map,this.c=new Map,this.#e=$.getProxy(A.$jL.MainThreadCommands),this.d=f,this.#i=y,this.#t=$.getProxy(A.$jL.MainThreadTelemetry),this.converter=new d(this,L=>{const T=this.c.get(L);return T?.result===u.Void?T:void 0},f),this.f=[{processArgument(L){return(0,k.$Eh)(L)}},{processArgument(L){return(0,P.$An)(L,function(T){if(R.$Ws.isIRange(T))return h.Range.to(T);if(C.$Vs.isIPosition(T))return h.Position.to(T);if(R.$Ws.isIRange(T.range)&&w.URI.isUri(T.uri))return h.location.to(T);if(T instanceof a.$ke)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor($){this.f.push($)}registerApiCommand($){const f=this.registerCommand(!1,$.id,async(...y)=>{const L=$.args.map((U,j)=>{if(!U.validate(y[j]))throw new Error(`Invalid argument '${U.name}' when running '${$.id}', received: ${typeof y[j]=="object"?JSON.stringify(y[j],null,"	"):y[j]} `);return U.convert(y[j])}),T=await this.executeCommand($.internalId,...L);return $.result.convert(T,y,this.converter)},void 0,{description:$.description,args:$.args,returns:$.result.description});return this.c.set($.id,$),new N.$lL(()=>{f.dispose(),this.c.delete($.id)})}registerCommand($,f,y,L,T,U){if(this.d.trace("ExtHostCommands#registerCommand",f),!f.trim().length)throw new Error("invalid id");if(this.b.has(f))throw new Error(`command '${f}' already exists`);return this.b.set(f,{callback:y,thisArg:L,metadata:T,extension:U}),$&&this.#e.$registerCommand(f),new N.$lL(()=>{this.b.delete(f)&&$&&this.#e.$unregisterCommand(f)})}executeCommand($,...f){return this.d.trace("ExtHostCommands#executeCommand",$),this.g($,f,!0)}async g($,f,y){if(this.b.has($))return this.#e.$fireCommandActivationEvent($),this.h($,f,!1);{let L=!1;const T=(0,P.$An)(f,function(U){if(U instanceof N.$mL)return h.Position.from(U);if(U instanceof N.$nL)return h.Range.from(U);if(U instanceof N.$xL)return h.location.from(U);if(N.$KM.isNotebookRange(U))return h.NotebookRange.from(U);if(U instanceof ArrayBuffer)return L=!0,a.$ke.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return L=!0,a.$ke.wrap(U);if(U instanceof a.$ke)return L=!0,U;if(!Array.isArray(U))return U});try{const U=await this.#e.$executeCommand($,L?new i.$Vv(T):T,y);return(0,k.$Eh)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g($,f,!1);throw U}}}async h($,f,y){const L=this.b.get($);if(!L)throw new Error("Unknown command");const{callback:T,thisArg:U,metadata:j}=L;if(j?.args)for(let M=0;M<j.args.length;M++)try{(0,D.$1f)(f[M],j.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${$}' failed. Illegal argument '${j.args[M].name}' - ${j.args[M].description}`)}const F=r.$Sd.create();try{return await T.apply(U,f)}catch(M){if($===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...f);O&&($=O.command)}if(this.d.error(M,$,L.extension?.identifier),!y)throw M;if(L.extension?.identifier){const O=this.#i.onExtensionError(L.extension.identifier,M);this.d.trace("forwarded error to extension?",O,L.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Si)(M)),this.id=$,this.source=L.extension?.displayName??L.extension?.name}}}finally{this.j(L,$,F.elapsed())}}j($,f,y){$.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:$.extension.identifier.value,id:new s.$No(f),duration:y})}$executeContributedCommand($,...f){this.d.trace("ExtHostCommands#$executeContributedCommand",$);const y=this.b.get($);return y?(f=f.map(L=>this.f.reduce((T,U)=>U.processArgument(T,y.extension?.identifier),L)),this.h($,f,!0)):Promise.reject(new Error(`Contributed command '${$}' does not exist.`))}getCommands($=!1){return this.d.trace("ExtHostCommands#getCommands",$),this.#e.$getCommands().then(f=>($&&(f=f.filter(y=>y[0]!=="_")),f))}$getContributedCommandMetadata(){const $=Object.create(null);for(const[f,y]of this.b){const{metadata:L}=y;L&&($[f]=L)}return Promise.resolve($)}};e.$JN=o,e.$JN=o=Ge([Ve(0,c.$oN),Ve(1,b.$pj),Ve(2,t.$IN)],o),e.$KN=(0,S.$8h)("IExtHostCommands");class d{constructor($,f,y){this.d=$,this.f=f,this.g=y,this.delegatingCommandId=`__vsc${(0,g.$rg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal($,f){if(!$)return;const y={$ident:void 0,id:$.command,title:$.title,tooltip:$.tooltip};if(!$.command)return y;const L=this.f($.command);if(L)y.id=L.internalId,y.arguments=L.args.map((T,U)=>T.convert($.arguments&&$.arguments[U]));else if((0,p.$Lb)($.arguments)){const T=`${$.command} /${++this.c}`;this.b.set(T,$),f.add((0,E.$Rc)(()=>{this.b.delete(T),this.g.trace("CommandsConverter#DISPOSE",T)})),y.$ident=T,y.id=this.delegatingCommandId,y.arguments=[T],this.g.trace("CommandsConverter#CREATE",$.command,T)}return y}fromInternal($){return typeof $.$ident=="string"?this.b.get($.$ident):{command:$.id,title:$.title,arguments:$.arguments}}getActualCommand(...$){return this.b.get($[0])}h(...$){const f=this.getActualCommand(...$);return this.g.trace("CommandsConverter#EXECUTE",$[0],f?f.command:"MISSING"),f?this.d.executeCommand(f.command,...f.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${$[0]}`)}}e.$LN=d;class l{static{this.Uri=new l("uri","Uri of a text document",$=>w.URI.isUri($),$=>$)}static{this.Position=new l("position","A position in a text document",$=>N.$mL.isPosition($),h.Position.from)}static{this.Range=new l("range","A range in a text document",$=>N.$nL.isRange($),h.Range.from)}static{this.Selection=new l("selection","A selection in a text document",$=>N.$oL.isSelection($),h.Selection.from)}static{this.Number=new l("number","",$=>typeof $=="number",$=>$)}static{this.String=new l("string","",$=>typeof $=="string",$=>$)}static{this.StringArray=l.Arr(l.String)}static Arr($){return new l(`${$.name}_array`,`Array of ${$.name}, ${$.description}`,f=>Array.isArray(f)&&f.every(y=>$.validate(y)),f=>f.map(y=>$.convert(y)))}static{this.CallHierarchyItem=new l("item","A call hierarchy item",$=>$ instanceof N.$IL,h.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new l("item","A type hierarchy item",$=>$ instanceof N.$4M,h.TypeHierarchyItem.from)}static{this.TestItem=new l("testItem","A VS Code TestItem",$=>$ instanceof m.$BN,h.TestItem.from)}constructor($,f,y,L){this.name=$,this.description=f,this.validate=y,this.convert=L}optional(){return new l(this.name,`(optional) ${this.description}`,$=>$==null||this.validate($),$=>$===void 0?void 0:$===null?null:this.convert($))}with($,f){return new l($??this.name,f??this.description,this.validate,this.convert)}}e.$MN=l;class u{static{this.Void=new u("no result",$=>$)}constructor($,f){this.description=$,this.convert=f}}e.$NN=u;class v{constructor($,f,y,L,T){this.id=$,this.internalId=f,this.description=y,this.args=L,this.result=T}}e.$ON=v}),define(ke[341],Se([1,0,19,16,2,83,131,45,33,15,7]),function($e,e,D,N,h,P,A,p,b,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;const C=[new b.$ON("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.$MN.Uri,b.$MN.Position],new b.$NN("A promise that resolves to an array of DocumentHighlight-instances.",E(k.DocumentHighlight.to))),new b.$ON("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.$MN.Uri],new b.$NN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,m)=>{if((0,D.$Kb)(c))return;class a extends R.$DL{static to(n){const r=new a(n.name,k.SymbolKind.to(n.kind),n.containerName||"",new R.$xL(m[0],k.Range.to(n.range)));return r.detail=n.detail,r.range=r.location.range,r.selectionRange=k.Range.to(n.selectionRange),r.children=n.children?n.children.map(a.to):[],r}}return c.map(a.to)})),new b.$ON("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.$MN.Uri,new b.$MN("options","Formatting options",c=>!0,c=>c)],new b.$NN("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new b.$ON("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.$MN.Uri,b.$MN.Range,new b.$MN("options","Formatting options",c=>!0,c=>c)],new b.$NN("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new b.$ON("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.$MN.Uri,b.$MN.Position,new b.$MN("ch","Trigger character",c=>typeof c=="string",c=>c),new b.$MN("options","Formatting options",c=>!0,c=>c)],new b.$NN("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new b.$ON("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.$MN.Uri,b.$MN.Position],new b.$NN("A promise that resolves to an array of Location or LocationLink instances.",S)),new b.$ON("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.$MN.Uri,b.$MN.Position],new b.$NN("A promise that resolves to an array of Location or LocationLink instances.",S)),new b.$ON("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.$MN.Uri,b.$MN.Position],new b.$NN("A promise that resolves to an array of Location or LocationLink instances.",S)),new b.$ON("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.$MN.Uri,b.$MN.Position],new b.$NN("A promise that resolves to an array of Location or LocationLink instances.",S)),new b.$ON("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.$MN.Uri,b.$MN.Position],new b.$NN("A promise that resolves to an array of Location-instances.",E(k.location.to))),new b.$ON("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.$MN.Uri,b.$MN.Position],new b.$NN("A promise that resolves to an array of Hover-instances.",E(k.Hover.to))),new b.$ON("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.$MN.Uri,new b.$MN("position","A position in a text document",c=>Array.isArray(c)&&c.every(m=>R.$mL.isPosition(m)),c=>c.map(k.Position.from))],new b.$NN("A promise that resolves to an array of ranges.",c=>c.map(m=>{let a;for(const i of m.reverse())a=new R.$HL(k.Range.to(i),a);return a}))),new b.$ON("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.$MN.String.with("query","Search string")],new b.$NN("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(k.WorkspaceSymbol.to))),new b.$ON("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.$MN.Uri,b.$MN.Position],new b.$NN("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(k.CallHierarchyItem.to))),new b.$ON("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.$MN.CallHierarchyItem],new b.$NN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(k.CallHierarchyIncomingCall.to))),new b.$ON("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.$MN.CallHierarchyItem],new b.$NN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(k.CallHierarchyOutgoingCall.to))),new b.$ON("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.$MN.Uri,b.$MN.Position],new b.$NN("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:k.Range.to(c.range),placeholder:c.text}})),new b.$ON("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.$MN.Uri,b.$MN.Position,b.$MN.String.with("newName","The new symbol name")],new b.$NN("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return k.WorkspaceEdit.to(c)}})),new b.$ON("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.$MN.Uri,b.$MN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.$NN("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(k.DocumentLink.to))),new b.$ON("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.$MN.Uri],new b.$NN("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new R.$BM(c.tokenTypes,c.tokenModifiers)})),new b.$ON("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.$MN.Uri],new b.$NN("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,A.$L$)(c);if(m.type==="full")return new R.$DM(m.data,void 0)})),new b.$ON("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.$MN.Uri,b.$MN.Range.optional()],new b.$NN("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new R.$BM(c.tokenTypes,c.tokenModifiers)})),new b.$ON("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.$MN.Uri,b.$MN.Range],new b.$NN("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,A.$L$)(c);if(m.type==="full")return new R.$DM(m.data,void 0)})),new b.$ON("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.$MN.Uri,b.$MN.Position,b.$MN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.$MN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.$NN("A promise that resolves to a CompletionList-instance.",(c,m,a)=>{if(!c)return new R.$TL([]);const i=c.suggestions.map(n=>k.CompletionItem.to(n,a));return new R.$TL(i,c.incomplete)})),new b.$ON("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.$MN.Uri,b.$MN.Position,b.$MN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.$NN("A promise that resolves to SignatureHelp.",c=>{if(c)return k.SignatureHelp.to(c)})),new b.$ON("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.$MN.Uri,b.$MN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.$NN("A promise that resolves to an array of CodeLens-instances.",(c,m,a)=>E(i=>new R.$LL(k.Range.to(i.range),i.command&&a.fromInternal(i.command)))(c))),new b.$ON("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.$MN.Uri,new b.$MN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>R.$nL.isRange(c),c=>R.$oL.isSelection(c)?k.Selection.from(c):k.Range.from(c)),b.$MN.String.with("kind","Code action kind to return code actions for").optional(),b.$MN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.$NN("A promise that resolves to an array of Command-instances.",(c,m,a)=>E(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(i.command)}else{const n=new R.$FL(i.title,i.kind?new R.$GL(i.kind):void 0);return i.edit&&(n.edit=k.WorkspaceEdit.to(i.edit)),i.command&&(n.command=a.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(c))),new b.$ON("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.$MN.Uri],new b.$NN("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(m=>new R.$ZL(k.Range.to(m.range),k.Color.to(m.color))):[])),new b.$ON("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.$MN("color","The color to show and insert",c=>c instanceof R.$YL,k.Color.from),new b.$MN("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:k.Range.from(c.range)}))],new b.$NN("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(k.ColorPresentation.to):[])),new b.$ON("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.$MN.Uri,b.$MN.Range],new b.$NN("A promise that resolves to an array of Inlay objects",(c,m,a)=>c.map(k.InlayHint.to.bind(void 0,a)))),new b.$ON("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.$MN.Uri],new b.$NN("A promise that resolves to an array of FoldingRange objects",(c,m)=>{if(c)return c.map(k.FoldingRange.to)})),new b.$ON("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.$NN("A promise that resolves to an array of NotebookContentProvider static info objects.",E(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(m=>k.NotebookExclusiveDocumentPattern.to(m))})))),new b.$ON("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.$MN.Uri,b.$MN.Range,new b.$MN("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof R.$nL,c=>k.InlineValueContext.from(c))],new b.$NN("A promise that resolves to an array of InlineValue objects",c=>c.map(k.InlineValue.to))),new b.$ON("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.$MN("uriOrString","Uri-instance or string (only http/https)",c=>h.URI.isUri(c)||typeof c=="string"&&(0,N.$gg)(c,N.Schemas.http,N.Schemas.https),c=>c),new b.$MN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[k.ViewColumn.from(c),void 0]:[k.ViewColumn.from(c.viewColumn),k.TextEditorOpenOptions.from(c)])).optional(),b.$MN.String.with("label","").optional()],b.$NN.Void),new b.$ON("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.$MN.Uri.with("resource","Resource to open"),b.$MN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new b.$MN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[k.ViewColumn.from(c),void 0]:[k.ViewColumn.from(c.viewColumn),k.TextEditorOpenOptions.from(c)])).optional()],b.$NN.Void),new b.$ON("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.$MN.Uri.with("left","Left-hand side resource of the diff editor"),b.$MN.Uri.with("right","Right-hand side resource of the diff editor"),b.$MN.String.with("title","Human readable title for the diff editor").optional(),new b.$MN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[k.ViewColumn.from(c.viewColumn),k.TextEditorOpenOptions.from(c)]).optional()],b.$NN.Void),new b.$ON("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[b.$MN.String.with("title","Human readable title for the changes editor"),new b.$MN("resourceList","List of resources to compare",c=>{for(const m of c){if(m.length!==3)return!1;const[a,i,n]=m;if(!h.URI.isUri(a)||!h.URI.isUri(i)&&i!==void 0&&i!==null||!h.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},c=>c)],b.$NN.Void),new b.$ON("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.$MN.Uri,b.$MN.Position],new b.$NN("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(k.TypeHierarchyItem.to))),new b.$ON("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.$MN.TypeHierarchyItem],new b.$NN("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(k.TypeHierarchyItem.to))),new b.$ON("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.$MN.TypeHierarchyItem],new b.$NN("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(k.TypeHierarchyItem.to))),new b.$ON("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.$MN.TestItem],b.$NN.Void),new b.$ON("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.$MN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.$NN.Void),new b.$ON("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.$MN.String.with("name","The context key name"),new b.$MN("value","The context key value",()=>!0,c=>c)],b.$NN.Void),new b.$ON("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[b.$MN.Uri,b.$MN.StringArray,new b.$MN("MappedEditsContext","Mapped Edits Context",c=>k.MappedEditsContext.is(c),c=>k.MappedEditsContext.from(c))],new b.$NN("A promise that resolves to a workspace edit or null",c=>c?k.WorkspaceEdit.to(c):null))];class w{static register(m){C.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",p.$7i)}}e.$6fc=w;function E(c){return m=>{if(Array.isArray(m))return m.map(c)}}function S(c){if(!Array.isArray(c))return;const m=[];for(const a of c)P.$It(a)?m.push(k.DefinitionLink.to(a)):m.push(k.location.to(a));return m}}),define(ke[342],Se([1,0,3,2,6,15,7,33,8]),function($e,e,D,N,h,P,A,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;class k{static{this.a=0}constructor(E,S){this.extension=E,this.provider=S,this.handle=k.a++}}class R{constructor(E){this.session=E,this.responses=[]}}class C{static{this.a=0}constructor(E,S,c,m){this.f=c,this.g=m,this.b=new Map,this.d=new Map,this.e=E.getProxy(h.$jL.MainThreadInlineChat),S.registerApiCommand(new p.$ON("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$MN("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?P.Range.from(a.initialRange):void 0,initialSelection:A.$oL.isSelection(a.initialSelection)?P.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?P.Position.from(a.position):void 0}})],p.$NN.Void))}registerProvider(E,S,c){const m=new k(E,S);return this.b.set(m.handle,m),this.e.$registerInteractiveEditorProvider(m.handle,c?.label??E.displayName??E.name,E.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function",typeof S.provideFollowups=="function",c?.supportReportIssue??!1),(0,D.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(m.handle),this.b.delete(m.handle)})}async $prepareSession(E,S,c,m){const a=this.b.get(E);if(!a){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(N.URI.revive(S)),n=P.Selection.to(c),r=await a.provider.prepareInteractiveEditorSession({document:i,selection:n},m);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const s=C.a++;return this.d.set(s,new R(r)),{id:s,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:P.Range.from(r.wholeRange),message:r.message}}async $provideResponse(E,S,c,m){const a=this.b.get(E);if(!a)return;const i=this.d.get(S.id);if(!i)return;const n={prompt:c.prompt,selection:P.Selection.to(c.selection),wholeRange:P.Range.to(c.wholeRange),attempt:c.attempt,live:c.live,previewDocument:this.f.getDocument(N.URI.revive(c.previewDocument)),withIntentDetection:c.withIntentDetection};let r=!1;const s={report:async I=>{if(!c.live&&I.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||m.isCancellationRequested||await this.e.$handleProgressChunk(c.requestId,{message:I.message,edits:I.edits?.map(P.TextEdit.from),editsShouldBeInstant:I.editsShouldBeInstant,slashCommand:I.slashCommand?.command,markdownFragment:A.$ML.isMarkdownString(I.content)?I.content.value:I.content})}},t=Promise.resolve(a.provider.provideInteractiveEditorResponse(i.session,n,s,m));let g;try{g=await(0,b.$Vg)(t,m)}finally{r=!0}if(!g)return;const o=i.responses.push(g)-1,d={wholeRange:P.Range.from(g.wholeRange),placeholder:g.placeholder};if(!C.h(g))return{...d,id:o,type:"editorEdit",message:P.MarkdownString.from(g.contents),edits:[]};const{edits:l,contents:u}=g,v=u!==void 0?P.MarkdownString.from(u):void 0;return l instanceof A.$vL?{...d,id:o,type:"bulkEdit",edits:P.WorkspaceEdit.from(l),message:v}:{...d,id:o,type:"editorEdit",edits:l.map(P.TextEdit.from),message:v}}async $provideFollowups(E,S,c,m){const a=this.b.get(E),i=this.d.get(S),n=i?.responses[c];if(a&&n&&a.provider.provideFollowups){const r=Promise.resolve(a.provider.provideFollowups(i.session,n,m));return(await(0,b.$Vg)(r,m))?.map(P.ChatFollowup.from)}}$handleFeedback(E,S,c,m){const a=this.b.get(E),i=this.d.get(S),n=i?.responses[c];if(a&&n){const r=P.InteractiveEditorResponseFeedbackKind.to(m);a.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,r)}}$releaseSession(E,S){}static h(E){return typeof E=="object"&&typeof E.edits=="object"}}e.$bhc=C}),define(ke[343],Se([1,0,2,33]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=void 0;class h{constructor(A,p,b,k,R){this.a=p,this.b=b,this.c=k;const C=new N.$ON("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$MN("showOptions","Show Options",w=>!0,w=>w),new N.$MN("resource","Interactive resource Uri",w=>!0,w=>w),new N.$MN("controllerId","Notebook controller Id",w=>!0,w=>w),new N.$MN("title","Interactive editor title",w=>!0,w=>w)],new N.$NN("Notebook and input URI",w=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",w.notebookEditorId),w.notebookEditorId!==void 0){const E=this.a.getEditorById(w.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:D.URI.revive(w.notebookUri),inputUri:D.URI.revive(w.inputUri),notebookEditor:E.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",w.notebookUri,w.inputUri),{notebookUri:D.URI.revive(w.notebookUri),inputUri:D.URI.revive(w.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(A,p,b,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:b,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$ohc=h}),define(ke[344],Se([1,0,19,8,22,4,3,28,2,25,13,6,33,15,7,112,284,26,68,285]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=e.$whc=void 0;let r=class{constructor(v,I,$,f,y){this.m=I,this.n=$,this.o=f,this.q=y,this.b=new p.$Ac,this.c=new p.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new P.$Wd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=v.getProxy(C.$jL.MainThreadNotebookKernels);const L=new w.$ON("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new w.$MN("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const U=this.n.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:U}}else if(T&&"notebookEditor"in T){const U=this.n.getIdByEditor(T.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:U}}return T})],w.$NN.Void);this.o.registerApiCommand(L)}createNotebookController(v,I,$,f,y,L){for(const ge of this.j.values())if(ge.controller.id===I&&k.$nm.equals(v.identifier,ge.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const T=this.k++,U=this;this.q.trace(`NotebookController[${T}], CREATED by ${v.identifier.value}, ${I}`);const j=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${v.identifier}'`);let F=!1;const M=new P.$Wd,O=new P.$Wd,z={id:l(v.identifier,I),notebookType:$,extensionId:v.identifier,extensionLocation:v.extensionLocation,label:f||v.identifier.value,preloads:L?L.map(E.NotebookRendererScript.from):[]};let J=y??j,te,x;this.a.$addKernel(T,z).catch(ge=>{console.log(ge),F=!0});let X=0;const Z=()=>{if(F)return;const ge=++X;Promise.resolve().then(()=>{ge===X&&this.a.$updateKernel(T,z)})},ae=new p.$Ac,_={get id(){return I},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return z.label},set label(ge){z.label=ge??v.displayName??v.name,Z()},get detail(){return z.detail??""},set detail(ge){z.detail=ge,Z()},get description(){return z.description??""},set description(ge){z.description=ge,Z()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(ge){z.supportedLanguages=ge,Z()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(ge){z.supportsExecutionOrder=ge,Z()},get rendererScripts(){return z.preloads?z.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return J},set executeHandler(ge){J=ge??j},get interruptHandler(){return te},set interruptHandler(ge){te=ge,z.supportsInterrupt=!!ge,Z()},set variableProvider(ge){(0,a.$LF)(v,"notebookVariableProvider"),x=ge,z.hasVariableProvider=!!ge,ge?.onDidChangeVariables(ne=>U.a.$variablesUpdated(ne.uri)),Z()},get variableProvider(){return x},createNotebookCellExecution(ge){if(F)throw new Error("notebook controller is DISPOSED");if(!ae.has(ge.notebook.uri))throw U.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(ne=>ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.notebook.uri.toString()}`);return U._createNotebookCellExecution(ge,l(v.identifier,this.id))},createNotebookExecution(ge){if((0,a.$LF)(v,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!ae.has(ge.uri))throw U.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(ne=>ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.uri.toString()}`);return U._createNotebookExecution(ge,l(v.identifier,this.id))},dispose:()=>{F||(this.q.trace(`NotebookController[${T}], DISPOSED`),F=!0,this.j.delete(T),M.dispose(),O.dispose(),this.a.$removeKernel(T))},updateNotebookAffinity(ge,ne){ne===S.NotebookControllerAffinity2.Hidden&&(0,a.$LF)(v,"notebookControllerAffinityHidden"),U.a.$updateNotebookPriority(T,ge.uri,ne)},onDidReceiveMessage:O.event,postMessage(ge,ne){return(0,a.$LF)(v,"notebookMessaging"),U.a.$postMessage(T,ne&&U.n.getIdByEditor(ne),ge)},asWebviewUri(ge){return(0,a.$LF)(v,"notebookMessaging"),(0,c.$kwb)(ge,U.m.remote)}};return this.j.set(T,{extensionId:v.identifier,controller:_,onDidReceiveMessage:O,onDidChangeSelection:M,associatedNotebooks:ae}),_}getIdByController(v){for(const[I,$]of this.j)if($.controller===v)return l($.extensionId,v.id);return null}createNotebookControllerDetectionTask(v,I){const $=this.g++,f=this;this.q.trace(`NotebookControllerDetectionTask[${$}], CREATED by ${v.identifier.value}`),this.a.$addKernelDetectionTask($,I);const y={dispose:()=>{this.f.delete($),f.a.$removeKernelDetectionTask($)}};return this.f.set($,y),y}registerKernelSourceActionProvider(v,I,$){const f=this.i++,y=typeof $.onDidChangeNotebookKernelSourceActions=="function"?f:void 0,L=this;this.h.set(f,$),this.q.trace(`NotebookKernelSourceActionProvider[${f}], CREATED by ${v.identifier.value}`),this.a.$addKernelSourceActionProvider(f,f,I);let T;return y!==void 0&&(T=$.onDidChangeNotebookKernelSourceActions(U=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(f),L.a.$removeKernelSourceActionProvider(f,f),T?.dispose()}}}async $provideKernelSourceActions(v,I){const $=this.h.get(v);if($){const f=new A.$Sc;return(await $.provideNotebookKernelSourceActions(I)??[]).map(L=>E.NotebookKernelSourceAction.from(L,this.o.converter,f))}return[]}$acceptNotebookAssociation(v,I,$){const f=this.j.get(v);if(f){const y=this.n.getNotebookDocument(b.URI.revive(I));$?f.associatedNotebooks.set(y.uri,!0):f.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${v}] ASSOCIATE notebook`,y.uri.toString(),$),f.onDidChangeSelection.fire({selected:$,notebook:y.apiNotebook})}}async $executeCells(v,I,$){const f=this.j.get(v);if(!f)return;const y=this.n.getNotebookDocument(b.URI.revive(I)),L=[];for(const T of $){const U=y.getCell(T);U&&L.push(U.apiCell)}try{this.q.trace(`NotebookController[${v}] EXECUTE cells`,y.uri.toString(),L.length),await f.controller.executeHandler.call(f.controller,L,y.apiNotebook,f.controller)}catch(T){this.q.error(`NotebookController[${v}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(v,I,$){const f=this.j.get(v);if(!f)return;const y=this.n.getNotebookDocument(b.URI.revive(I));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,y.apiNotebook);else for(const L of $){const T=y.getCell(L);T&&this.b.get(T.uri)?.cancel()}if(f.controller.interruptHandler){const L=this.c.get(y.uri);$.length&&Array.isArray(L)&&L.length&&L.forEach(T=>T.dispose())}}async $provideVariables(v,I,$,f,y,L,T){const U=this.j.get(v);if(!U)return;const j=this.n.getNotebookDocument(b.URI.revive($)),F=U.controller.variableProvider;if(!F)return;let M;if(f!==void 0){if(M=this.s[f],!M)return}else this.s={};const O=y==="named"?S.NotebookVariablesRequestKind.Named:S.NotebookVariablesRequestKind.Indexed,z=F.provideVariables(j.apiNotebook,M,O,L,T);let J=0;for await(const te of z){if(T.isCancellationRequested)return;const x={id:this.r++,name:te.variable.name,value:te.variable.value,type:te.variable.type,hasNamedChildren:te.hasNamedChildren,indexedChildrenCount:te.indexedChildrenCount};if(this.s[x.id]=te.variable,this.a.$receiveVariable(I,x),J++>=n.$zfb)return}}$acceptKernelMessageFromRenderer(v,I,$){const f=this.j.get(v);if(!f)return;const y=this.n.getEditorById(I);f.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:$}))}$cellExecutionChanged(v,I,$){const y=this.n.getNotebookDocument(b.URI.revive(v)).getCell(I);if(y){const L=$?E.NotebookCellExecutionState.to($):S.NotebookCellExecutionState.Idle;L!==void 0&&this.l.fire({cell:y.apiCell,state:L})}}_createNotebookCellExecution(v,I){if(v.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const f=this.n.getNotebookDocument(v.notebook.uri).getCellFromApiCell(v);if(!f)throw new Error("invalid cell");if(this.b.has(f.uri))throw new Error(`duplicate execution for ${f.uri}`);const y=new t(I,f,this.a);this.b.set(f.uri,y);const L=y.onDidChangeState(()=>{y.state===s.Resolved&&(y.dispose(),L.dispose(),this.b.delete(f.uri))});return y.asApiObject()}_createNotebookExecution(v,I){const $=this.n.getNotebookDocument(v.uri),f=v.getCells().find(T=>{const U=$.getCellFromApiCell(T);return U&&this.b.has(U.uri)});if(f)throw new Error(`duplicate cell execution for ${f.document.uri}`);if(this.c.has($.uri))throw new Error(`duplicate notebook execution for ${$.uri}`);const y=new o(I,$,this.a),L=y.onDidChangeState(()=>{y.state===g.Resolved&&(y.dispose(),L.dispose(),this.c.delete($.uri))});return this.c.set($.uri,[y,L]),y.asApiObject()}};e.$whc=r,e.$whc=r=Ge([Ve(4,R.$pj)],r);var s;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(s||(s={}));class t extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(v,I,$){super(),this.m=I,this.n=$,this.b=t.a++,this.c=new P.$Wd,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new h.$7d),this.h=new d(10,f=>this.s(f)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,v,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(v){await this.h.addItem(v)}async s(v){const I=Array.isArray(v)?v:[v];return this.n.$updateExecution(this.b,new i.$Vv(I))}t(){if(this.f===s.Init)throw new Error("Must call start before modifying cell output");if(this.f===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(v){let I=this.m;if(v&&(I=this.m.notebook.getCellFromApiCell(v)),!I)throw new Error("INVALID cell");return I.handle}y(v){return v.map(I=>{const $=S.$OM.ensureUniqueMimeTypes(I.items,!0);return $===I.items?E.NotebookCellOutput.from(I):E.NotebookCellOutput.from({items:$,id:I.id,metadata:I.metadata})})}async z(v,I,$){const f=this.w(I),y=this.y((0,D.$3b)(v));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:f,append:$,outputs:y})}async C(v,I,$){return v=S.$OM.ensureUniqueMimeTypes((0,D.$3b)(v),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:v.map(E.NotebookCellOutputItem.from),outputId:I.id,append:$})}asApiObject(){const v=this;return Object.freeze({get token(){return v.g.token},get cell(){return v.m.apiCell},get executionOrder(){return v.j},set executionOrder($){v.j=$,v.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:v.j}])},start($){if(v.f===s.Resolved||v.f===s.Started)throw new Error("Cannot call start again");v.f=s.Started,v.c.fire(),v.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:$})},end($,f){if(v.f===s.Resolved)throw new Error("Cannot call resolve twice");v.f=s.Resolved,v.c.fire(),v.h.flush(),v.n.$completeExecution(v.b,new i.$Vv({runEndTime:f,lastRunSuccess:$}))},clearOutput($){return v.t(),v.z([],$,!1)},appendOutput($,f){return v.t(),v.z($,f,!0)},replaceOutput($,f){return v.t(),v.z($,f,!1)},appendOutputItems($,f){return v.t(),v.C($,f,!0)},replaceOutputItems($,f){return v.t(),v.C($,f,!1)}})}}var g;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(g||(g={}));class o extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(v,I,$){super(),this.h=I,this.j=$,this.b=o.a++,this.c=new P.$Wd,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new h.$7d),this.j.$createNotebookExecution(this.b,v,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===g.Resolved||this.f===g.Started)throw new Error("Cannot call start again");this.f=g.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===g.Resolved)throw new Error("Cannot call resolve twice");this.f=g.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(v,I){this.f=v,this.g=I,this.a=[],this.b=Date.now()}addItem(v){return this.a.push(v),this.c||(this.c=new N.$sh,this.b=Date.now(),(0,N.$9g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const v=this.c;this.c=void 0;const I=this.a;return this.a=[],this.g(I).finally(()=>v.complete())}}function l(u,v){return`${u.value}/${v}`}e.$xhc=l}),define(ke[46],Se([1,0,4,6,5,2,20,3,7,218,14,262,22,30,263,55,8,15,33]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=e.$Kgc=e.$Jgc=e.$Igc=void 0,e.$Igc=(0,h.$8h)("IExtHostTerminalService");class n{constructor($,f,y,L){this.l=$,this._id=f,this.m=y,this.n=L,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(U=>this.f=U);const T=this;this.value={get name(){return T.n||""},get processId(){return T.b},get creationOptions(){return T.m},get exitStatus(){return T.h},get state(){return T.j},get selection(){return T.k},sendText(U,j=!0){T.q(),T.l.$sendText(T._id,U,j)},show(U){T.q(),T.l.$show(T._id,U)},hide(){T.q(),T.l.$hide(T._id)},dispose(){T.a||(T.a=!0,T.l.$dispose(T._id))},get dimensions(){if(!(T.d===void 0||T.g===void 0))return{columns:T.d,rows:T.g}}}}async create($,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??f?.cwd??void 0,env:$.env??void 0,icon:l($.iconPath)??void 0,color:c.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,isFeatureTerminal:f?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:f?.useShellEnvironment??void 0,location:f?.location||this.o($.location,f?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,f,y,L,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:L,color:c.ThemeColor.isThemeColor(T)?T.id:void 0,location:f?.location||this.o($,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o($,f){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in $?{viewColumn:a.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.n=$}setExitStatus($,f){this.h=Object.freeze({code:$,reason:f})}setDimensions($,f){return $===this.d&&f===this.g||$===0||f===0?!1:(this.d=$,this.g=f,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection($){this.k=$}_setProcessId($){this.f?(this.f($),this.f=void 0):this.b.then(f=>{f!==$&&(this.b=Promise.resolve($))})}}e.$Jgc=n;class r{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new D.$Wd,this.onProcessData=this.a.event,this.b=new D.$Wd,this.d=new D.$Wd,this.onDidChangeProperty=this.d.event,this.f=new D.$Wd,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,f){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${f}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,f){this.g.setDimensions?.({columns:$,rows:f})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(f=>this.a.fire(f)),this.g.onDidClose?.((f=void 0)=>{this.f.fire(f===void 0?void 0:f)}),this.g.onDidOverrideDimensions?.(f=>{f&&this.d.fire({type:"overrideDimensions",value:{cols:f.columns,rows:f.rows}})}),this.g.onDidChangeName?.(f=>{this.d.fire({type:"title",value:f})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,t=class extends p.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,f,y){super(),this.Q=f,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Wd,this.onDidCloseTerminal=this.H.event,this.I=new D.$Wd,this.onDidOpenTerminal=this.I.event,this.J=new D.$Wd,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Wd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Wd,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Wd,this.onDidChangeShell=this.N.event,this.O=new D.$Wd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Wd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(N.$jL.MainThreadTerminalService),this.y=new S.$wsb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:L=>{const T=U=>{const j=U;return this.W(j.instanceId)?.value};switch(L?.$mid){case 15:return T(L);default:{if(Array.isArray(L))for(let U=0;U<L.length&&L[U].$mid===15;U++)L[U]=T(L[U]);return L}}}}),this.B({dispose:()=>{for(const[L,T]of this.g)T.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,f){const y=new n(this.a,(0,E.$rg)(),$,$.name),L=new r($.pty);return y.createExtensionTerminal($.location,f,this.R($,f).resolvedExtHostIdentifier,l($.iconPath),u($.color)).then(T=>{const U=this.S(T,L);this.h[T]=U}),this.f.push(y),y.value}R($,f){if(f=f||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const y=$.location.parentTerminal;if(y){const L=this.f.find(T=>T.value===y);L&&(f.resolvedExtHostIdentifier=L._id)}}else $.location&&typeof $.location!="object"?f.location=$.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal($,f){if(!this.W($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const L=new r(f),T=this.S($,L);this.h[$]=T}async $acceptActiveTerminalChanged($){const f=this.b;if($===null){this.b=void 0,f!==this.b&&this.J.fire(this.b);return}const y=this.W($);y&&(this.b=y,f!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,f){const y=this.W($);y&&this.O.fire({terminal:y.value,data:f})}async $acceptTerminalDimensions($,f,y){const L=this.W($);L&&L.setDimensions(f,y)&&this.L.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand($,f){const y=this.W($);y&&this.P.fire({terminal:y.value,...f})}async $acceptTerminalMaximumDimensions($,f,y){this.g.get($)?.resize(f,y)}async $acceptTerminalTitleChange($,f){const y=this.W($);y&&(y.name=f)}async $acceptTerminalClosed($,f,y){const L=this.Y(this.f,$);if(L!==null){const T=this.f.splice(L,1)[0];T.setExitStatus(f,y),this.H.fire(T.value)}}$acceptTerminalOpened($,f,y,L){if(f){const j=this.Y(this.f,f);if(j!==null){this.f[j]._id=$,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const T={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:P.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},U=new n(this.a,$,T,y);this.f.push(U),this.I.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId($,f){this.W($)?._setProcessId(f)}async $startExtensionTerminal($,f){const y=this.W($);if(!y)return{message:(0,k.localize)(0,null,$)};y.isOpen||await new Promise(T=>{const U=this.onDidOpenTerminal(async j=>{j===y.value&&(U.dispose(),T())})});const L=this.g.get($);L?L.startSendingEvents(f):this.j[$]={initialDimensions:f}}S($,f){const y=new p.$Sc;y.add(f.onProcessReady(T=>this.a.$sendProcessReady($,T.pid,T.cwd,T.windowsPty))),y.add(f.onDidChangeProperty(T=>this.a.$sendProcessProperty($,T))),this.y.startBuffering($,f.onProcessData),y.add(f.onProcessExit(T=>this.U($,T))),this.g.set($,f);const L=this.j[$];return L&&f instanceof r&&(f.startSendingEvents(L.initialDimensions),delete this.j[$]),y}$acceptProcessAckDataEvent($,f){this.g.get($)?.acknowledgeDataEvent(f)}$acceptProcessInput($,f){this.g.get($)?.input(f)}$acceptTerminalInteraction($){const f=this.W($);f?.setInteractedWith()&&this.M.fire(f.value)}$acceptTerminalSelection($,f){this.W($)?.setSelection(f)}$acceptProcessResize($,f,y){try{this.g.get($)?.resize(f,y)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown($,f){this.g.get($)?.shutdown(f)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(f=>this.a.$sendProcessProperty($,{type:"initialCwd",value:f}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(f=>this.a.$sendProcessProperty($,{type:"cwd",value:f}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new b.$lL(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,f,y){if(this.C.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this.C.set(f,y),this.a.$registerProfileProvider(f,$.identifier.value),new b.$lL(()=>{this.C.delete(f),this.a.$unregisterProfileProvider(f)})}registerTerminalQuickFixProvider($,f,y){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,y),this.a.$registerQuickFixProvider($,f),new b.$lL(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,f){const y=new w.$7d().token;if(y.isCancellationRequested)return;const L=this.D.get($);if(!L)return;const T=await L.provideTerminalQuickFixes(f,y);if(T===null||Array.isArray(T)&&T.length===0)return;const U=new p.$Sc;if(this.w.value=U,!Array.isArray(T))return T?a.TerminalQuickFix.from(T,this.Q.converter,U):void 0;const j=[];for(const F of T){const M=a.TerminalQuickFix.from(F,this.Q.converter,U);M&&j.push(M)}return j}async $createContributedProfileTerminal($,f){const y=new w.$7d().token;let L=await this.C.get($)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,f);return}this.createTerminalFromOptions(L.options,f)}}async $provideLinks($,f){const y=this.W($);if(!y)return[];this.F.delete($),this.G.get($)?.dispose(!0);const T=new w.$7d;this.G.set($,T);const U=[],j={terminal:y.value,line:f},F=[];for(const z of this.z)F.push(m.Promises.withAsyncBody(async J=>{T.token.onCancellationRequested(()=>J({provider:z,links:[]}));const te=await z.provideTerminalLinks(j,T.token)||[];T.token.isCancellationRequested||J({provider:z,links:te})}));const M=await Promise.all(F);if(T.token.isCancellationRequested)return[];const O=new Map;for(const z of M)z&&z.links.length>0&&U.push(...z.links.map(J=>{const te={id:s++,startIndex:J.startIndex,length:J.length,label:J.tooltip};return O.set(te.id,{provider:z.provider,link:J}),te}));return this.F.set($,O),U}$activateLink($,f){const y=this.F.get($)?.get(f);y&&y.provider.handleTerminalLink(y.link)}U($,f){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const y=this.h[$];y&&(y.dispose(),delete this.h[$]),this.a.$sendProcessExit($,f)}W($){return this.X(this.f,$)}X($,f){const y=this.Y($,f);return y!==null?$[y]:null}Y($,f){const y=$.findIndex(L=>L._id===f);return y===-1?null:y}getEnvironmentVariableCollection($){let f=this.n.get($.identifier.value);return f||(f=new g,this.$($.identifier.value,f)),f.getScopedEnvironmentVariableCollection(void 0)}Z($,f){const y=(0,C.$Or)(f.map),L=(0,C.$Pr)(f.descriptionMap);this.a.$setEnvironmentVariableCollection($,f.persistent,y.length===0?void 0:y,L)}$initEnvironmentVariableCollections($){$.forEach(f=>{const y=f[0],L=new g(f[1]);this.$(y,L)})}$acceptDefaultProfile($,f){const y=this.s;this.s=$,this.u=f,y?.path!==$.path&&this.N.fire($.path)}$($,f){this.n.set($,f),f.onDidChangeCollection(()=>{this.Z($,f)})}};e.$Kgc=t,e.$Kgc=t=Ge([Ve(1,i.$KN),Ve(2,A.$oN)],t);class g{get persistent(){return this.b}set persistent($){this.b=$,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor($){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Wd,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const f=this.h($);let y=this.a.get(f);return y||(y=new o(this,$),this.a.set(f,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace($,f,y,L){this.f($,{value:f,type:b.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:L})}append($,f,y,L){this.f($,{value:f,type:b.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:L})}prepend($,f,y,L){this.f($,{value:f,type:b.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:L})}f($,f){if(f.options&&f.options.applyAtProcessCreation===!1&&!f.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g($,f.scope),L=this.map.get(y),T=f.options?{applyAtProcessCreation:f.options.applyAtProcessCreation??!1,applyAtShellIntegration:f.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==f.value||L.type!==f.type||L.options?.applyAtProcessCreation!==T.applyAtProcessCreation||L.options?.applyAtShellIntegration!==T.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index){const U=this.g($,f.scope),j={variable:$,...f,options:T};this.map.set(U,j),this.d.fire()}}get($,f){const y=this.g($,f),L=this.map.get(y);return L?v(L):void 0}g($,f){const y=this.h(f);return y.length?`${$}:::${y}`:$}h($){return this.j($?.workspaceFolder)??""}j($){return $?$.uri.toString():void 0}getVariableMap($){const f=new Map;for(const[y,L]of this.map)this.h(L.scope)===this.h($)&&f.set(L.variable,v(L));return f}delete($,f){const y=this.g($,f);this.map.delete(y),this.d.fire()}clear($){if($?.workspaceFolder){for(const[f,y]of this.map)y.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(f);this.k($)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription($,f){const y=this.h(f),L=this.descriptionMap.get(y);if(!L||L.description!==$){let T;typeof $=="string"?T=$:T=$?.value.split(`

`)[0];const U={description:T,scope:f};this.descriptionMap.set(y,U),this.d.fire()}}getDescription($){const f=this.h($);return this.descriptionMap.get(f)?.description}k($){const f=this.h($);this.descriptionMap.delete(f)}}class o{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,f){this.b=$,this.d=f,this.a=new D.$Wd}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,f,y){this.b.replace($,f,y,this.d)}append($,f,y){this.b.append($,f,y,this.d)}prepend($,f,y){this.b.prepend($,f,y,this.d)}get($){return this.b.get($,this.d)}forEach($,f){this.b.getVariableMap(this.d).forEach((y,L)=>$.call(f,L,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends t{constructor($,f){super(!1,$,f)}createTerminal($,f,y){throw new R.$_}createTerminalFromOptions($,f){throw new R.$_}};e.$Lgc=d,e.$Lgc=d=Ge([Ve(0,i.$KN),Ve(1,A.$oN)],d);function l(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function u(I){return c.ThemeColor.isThemeColor(I)?I:void 0}function v(I){const $={...I};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(ke[345],Se([1,0,8,21,22,4,74,54,3,24,18,30,13,6,20,150,15,7,67,111,90,26]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i,n,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=e.$Qhc=e.$Phc=e.$Ohc=void 0;let t=class extends b.$Tc{constructor(F,M,O,z){super(),this.w=z,this.f=this.B(new P.$Wd),this.g=new Map,this.s=this.B(new P.$Wd),this.onResultsChanged=this.f.event,this.results=[],this.h=F.getProxy(E.$jL.MainThreadTesting),this.m=new y(this.h),this.j=new l(this.h,M),O.registerArgumentProcessor({processArgument:J=>{switch(J?.$mid){case 16:{const te=J,x=te.tests[te.tests.length-1].item.extId;return this.g.get(i.$bK.root(x))?.collection.tree.get(x)?.actual??(0,c.$AN)(J)}case 18:{const{extId:te,message:x}=J;return{test:this.g.get(i.$bK.root(te))?.collection.tree.get(te)?.actual,message:m.TestMessage.to(x)}}default:return J}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const J=await O.executeCommand("_testing.getExplorerSelection"),te=x=>{const X=this.g.get(i.$bK.root(x));if(X)return i.$bK.isRoot(x)?X.controller:X.collection.tree.get(x)?.actual};return{include:J?.include.map(te).filter(R.$Rf)||[],exclude:J?.exclude.map(te).filter(R.$Rf)||[]}})}createTestController(F,M,O,z){if(this.g.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const J=new b.$Sc,te=J.add(new c.$DN(M,O,this.w));te.root.label=O;const x=new Map,X=new Set,Z=this.h,ae={items:te.root.children,get label(){return O},set label(ge){O=ge,te.root.label=ge,Z.$updateController(M,{label:O})},get refreshHandler(){return z},set refreshHandler(ge){z=ge,Z.$updateController(M,{canRefresh:!!ge})},get id(){return M},createRunProfile:(ge,ne,K,W,re,ye)=>{let he=(0,p.$Vi)(ge);for(;x.has(he);)he++;return new T(this.h,x,X,this.s.event,M,he,ge,ne,K,W,re,ye)},createTestItem(ge,ne,K){return new c.$BN(M,ge,ne,K)},createTestRun:(ge,ne,K=!0)=>this.j.createTestRun(F,M,te,ge,ne,K),invalidateTestResults:ge=>{if(ge===void 0)this.h.$markTestRetired(void 0);else{const ne=ge instanceof Array?ge:[ge];this.h.$markTestRetired(ne.map(K=>i.$bK.fromExtHostTestItem(K,M).toString()))}},set resolveHandler(ge){te.resolveHandler=ge},get resolveHandler(){return te.resolveHandler},dispose:()=>{J.dispose()}};Z.$registerTestController(M,O,!!z),J.add((0,b.$Rc)(()=>Z.$unregisterTestController(M)));const _={controller:ae,collection:te,profiles:x,extension:F,activeProfiles:X};return this.g.set(M,_),J.add((0,b.$Rc)(()=>this.g.delete(M))),J.add(te.onDidGenerateDiff(ge=>Z.$publishDiff(M,ge.map(r.TestsDiffOp.serialize)))),ae}createTestObserver(){return this.m.checkout()}async runTests(F,M=h.CancellationToken.None){const O=u(F);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.g.get(O.controllerId);if(!z)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:F.include?.map(J=>i.$bK.fromExtHostTestItem(J,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:U[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:F.exclude?.map(J=>J.id)},M)}$syncTests(){for(const{collection:F}of this.g.values())F.flushDiff();return Promise.resolve()}async $provideFileCoverage(F,M,O){return await this.j.getCoverageReport(F,M)?.provideFileCoverage(O)??[]}async $resolveFileCoverage(F,M,O,z){return await this.j.getCoverageReport(F,M)?.resolveFileCoverage(O,z)??[]}$configureRunProfile(F,M){this.g.get(F)?.profiles.get(M)?.configureHandler?.()}$setDefaultRunProfiles(F){const M=new Map;for(const[O,z]of Object.entries(F)){const J=this.g.get(O);if(!J)continue;const te=new Map,x=z.filter(Z=>!J.activeProfiles.has(Z)),X=[...J.activeProfiles].filter(Z=>!z.includes(Z));for(const Z of x)te.set(Z,!0),J.activeProfiles.add(Z);for(const Z of X)te.set(Z,!1),J.activeProfiles.delete(Z);te.size&&M.set(O,te)}this.s.fire(M)}async $refreshTests(F,M){await this.g.get(F)?.controller.refreshHandler?.(M)}$publishTestResults(F){this.results=Object.freeze(F.map(M=>(0,k.$zn)(m.TestResults.to(M))).concat(this.results).sort((M,O)=>O.completedAt-M.completedAt).slice(0,32)),this.f.fire()}async $expandTest(F,M){const O=this.g.get(i.$bK.fromString(F).controllerId)?.collection;O&&(await O.expand(F,M<0?1/0:M),O.flushDiff())}$acceptDiff(F){this.m.applyDiff(F.map(M=>r.TestsDiffOp.deserialize({asCanonicalUri:O=>O},M)))}async $runControllerTests(F,M){return Promise.all(F.map(O=>this.y(O,!1,M)))}async $startContinuousRun(F,M){const O=new h.$7d(M),z=await Promise.all(F.map(J=>this.y(J,!0,O.token)));return!M.isCancellationRequested&&!z.some(J=>J.error)&&await new Promise(J=>M.onCancellationRequested(J)),O.dispose(!0),z}async y(F,M,O){const z=this.g.get(F.controllerId);if(!z)return{};const{collection:J,profiles:te,extension:x}=z,X=te.get(F.profileId);if(!X)return{};const Z=F.testIds.map(ne=>J.tree.get(ne)).filter(R.$Rf),ae=F.excludeExtIds.map(ne=>z.collection.tree.get(ne)).filter(R.$Rf).filter(ne=>Z.some(K=>K.fullId.compare(ne.fullId)===2));if(!Z.length)return{};const _=new a.$VM(Z.some(ne=>ne.actual instanceof c.$CN)?void 0:Z.map(ne=>ne.actual),ae.map(ne=>ne.actual),X,M),ge=(0,r.$dK)(F)&&this.j.prepareForMainThreadTestRun(_,v.fromInternal(F,z.collection),x,O);try{return await X.runHandler(_,O),{}}catch(ne){return{error:String(ne)}}finally{ge&&(ge.hasRunningTasks&&!O.isCancellationRequested&&await P.Event.toPromise(ge.onEnd),ge.dispose())}}$cancelExtensionTestRun(F){F===void 0?this.j.cancelAllRuns():this.j.cancelRunById(F)}};e.$Ohc=t,e.$Ohc=t=Ge([Ve(0,S.$oN),Ve(1,w.$pj)],t);const g=1e4;var o;(function(j){j[j.Running=0]="Running",j[j.Cancelling=1]="Cancelling",j[j.Ended=2]="Ended"})(o||(o={}));class d extends b.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(F,M,O,z,J){super(),this.s=F,this.w=M,this.y=O,this.z=z,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new P.$Wd),this.m=this.B(new P.$Wd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new h.$7d(J));const te=this.B(new D.$hh(()=>this.C(),g));this.B(this.h.token.onCancellationRequested(()=>te.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(F){const M=this.s.id,O=this.s.controllerId,z=(0,C.$rg)(),J=this.y,te=this.m;let x;const X=ge=>(ne,...K)=>{if(ae){this.z.warn(`Setting the state of test "${ne.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ne)&&(this.F(ne),ge(ne,...K))},Z=(ge,ne)=>{const K=ne instanceof Array?ne.map(m.TestMessage.from):[m.TestMessage.from(ne)];if(ge.uri&&ge.range){const W={range:m.Range.from(ge.range),uri:ge.uri};for(const re of K)re.location=re.location||W}this.w.$appendTestMessagesInRun(M,z,i.$bK.fromExtHostTestItem(ge,O).toString(),K)};let ae=!1;const _={isPersisted:this.s.isPersisted,token:this.h.token,name:F,get coverageProvider(){return x?.provider},set coverageProvider(ge){(0,s.$LF)(J,"testCoverage"),x=ge&&new I(ge),te.fire({taskId:z,runId:M,coverage:x})},enqueued:X(ge=>{this.w.$updateTestStateInRun(M,z,i.$bK.fromExtHostTestItem(ge,O).toString(),1)}),skipped:X(ge=>{this.w.$updateTestStateInRun(M,z,i.$bK.fromExtHostTestItem(ge,O).toString(),5)}),started:X(ge=>{this.w.$updateTestStateInRun(M,z,i.$bK.fromExtHostTestItem(ge,O).toString(),2)}),errored:X((ge,ne,K)=>{Z(ge,ne),this.w.$updateTestStateInRun(M,z,i.$bK.fromExtHostTestItem(ge,O).toString(),6,K)}),failed:X((ge,ne,K)=>{Z(ge,ne),this.w.$updateTestStateInRun(M,z,i.$bK.fromExtHostTestItem(ge,O).toString(),4,K)}),passed:X((ge,ne)=>{this.w.$updateTestStateInRun(M,z,i.$bK.fromExtHostTestItem(ge,this.s.controllerId).toString(),3,ne)}),appendOutput:(ge,ne,K)=>{ae||(K&&(this.s.isIncluded(K)?this.F(K):K=void 0),this.w.$appendOutputToRun(M,z,N.$ke.fromString(ge),ne&&m.location.from(ne),K&&i.$bK.fromExtHostTestItem(K,O).toString()))},end:()=>{ae||(ae=!0,this.w.$finishedTestRunTask(M,z),this.f.delete(z),this.f.size||this.D())}};return this.f.set(z,{run:_}),this.w.$startedTestRunTask(M,{id:z,name:F,running:!0}),_}C(){for(const{run:F}of this.f.values())F.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(F){if(!(F instanceof c.$BN))throw new n.$gN(F.id);if(this.g.has(i.$bK.fromExtHostTestItem(F,this.s.controllerId).toString()))return;const M=[],O=this.s.colllection.root;for(;;){const z=m.TestItem.from(F);if(M.unshift(z),this.g.has(z.extId)||(this.g.add(z.extId),F===O))break;F=F.parent||O}this.w.$addTestsToRun(this.s.controllerId,this.s.id,M)}dispose(){this.D(),super.dispose()}}class l{get trackers(){return this.c.values()}constructor(F,M){this.g=F,this.h=M,this.c=new Map,this.f=[]}getCoverageReport(F,M){return this.f.find(O=>O.runId===F)?.coverage.get(M)}prepareForMainThreadTestRun(F,M,O,z){return this.j(F,M,O,z)}cancelRunById(F){for(const M of this.c.values())if(M.id===F){M.cancel();return}}cancelAllRuns(){for(const F of this.c.values())F.cancel()}createTestRun(F,M,O,z,J,te){const x=this.c.get(z);if(x)return x.createRun(J);const X=v.fromPublic(M,O,z,te),Z=u(z);this.g.$startedExtensionTestRun({controllerId:M,continuous:!!z.continuous,profile:Z&&{group:U[Z.kind],id:Z.profileId},exclude:z.exclude?.map(_=>i.$bK.fromExtHostTestItem(_,O.root.id).toString())??[],id:X.id,include:z.include?.map(_=>i.$bK.fromExtHostTestItem(_,O.root.id).toString())??[O.root.id],persist:te});const ae=this.j(z,X,F);return P.Event.once(ae.onEnd)(()=>{this.g.$finishedExtensionTestRun(X.id),ae.dispose()}),ae.createRun(J)}j(F,M,O,z){const J=new d(M,this.g,O,this.h,z);this.c.set(F,J);let te;const x=J.onDidCoverage(({runId:X,taskId:Z,coverage:ae})=>{te||(te={runId:X,coverage:new Map},this.f.unshift(te),this.f.length>r.$iK&&this.f.pop()),te.coverage.set(Z,ae),this.g.$signalCoverageAvailable(X,Z,!!ae)});return P.Event.once(J.onEnd)(()=>{this.c.delete(F),x.dispose()}),J}}e.$Phc=l;const u=j=>{if(j.profile){if(!(j.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class v{static fromPublic(F,M,O,z){return new v(F,(0,C.$rg)(),O.include?.map(J=>i.$bK.fromExtHostTestItem(J,F).toString())??[F],O.exclude?.map(J=>i.$bK.fromExtHostTestItem(J,F).toString())??[],z,M)}static fromInternal(F,M){return new v(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,M)}constructor(F,M,O,z,J,te){this.controllerId=F,this.id=M,this.isPersisted=J,this.colllection=te,this.c=O.map(x=>x+"\0"),this.f=z.map(x=>x+"\0")}isIncluded(F){const M=i.$bK.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const O of this.f)if(M===O||M.startsWith(O))return!1;for(const O of this.c)if(M===O||M.startsWith(O))return!0;return!1}}e.$Qhc=v;class I{constructor(F){this.provider=F}async provideFileCoverage(F){this.c||(this.c=(async()=>this.provider.provideFileCoverage(F))());try{return(await this.c)?.map(m.TestCoverage.fromFile)??[]}catch(M){throw this.c=void 0,M}}async resolveFileCoverage(F,M){const O=await this.c;let z=O?.[F];return!this.provider||!O||!z?[]:(z.detailedCoverage||(z=O[F]=await this.provider.resolveFileCoverage?.(z,M)??z),z.detailedCoverage?.map(m.TestCoverage.fromDetailed)??[])}}class ${get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(F){this.j=F,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(F){this.c.add(F)}update(F){Object.assign(F.revived,m.TestItem.toPlain(F.item)),this.c.has(F)||this.f.add(F)}remove(F){if(this.c.has(F)){this.c.delete(F);return}this.f.delete(F);const M=i.$bK.parentId(F.item.extId);if(M&&this.h.has(M.toString())){this.h.add(F.item.extId);return}this.g.add(F)}getChangeEvent(){const{c:F,f:M,g:O}=this;return{get added(){return[...F].map(z=>z.revived)},get updated(){return[...M].map(z=>z.revived)},get removed(){return[...O].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class f extends r.$jK{constructor(){super(...arguments),this.s=new P.$Wd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(F){return this.f.get(F)}getMirroredTestDataByReference(F){return this.f.get(F.id)}w(F,M){return{...F,revived:m.TestItem.toPlain(F.item),depth:M?M.depth+1:0,children:new Set}}v(){return new $(this.s)}}class y{constructor(F){this.f=F}checkout(){this.c||(this.c=this.g());const F=this.c;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(M=>M.revived)},dispose:(0,A.$db)(()=>{--F.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(F){return this.c?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.c?.tests.apply(F)}g(){const F=new f({asCanonicalUri:M=>M});return this.f.$subscribeToDiffs(),{observers:0,tests:F}}}const L=(j,F,M,O)=>{M?Object.assign(M,O):F.$updateTestRunConfig(j.controllerId,j.profileId,O)};class T{#e;#t;#i;#n;#s;get label(){return this.f}set label(F){F!==this.f&&(this.f=F,L(this,this.#e,this.#n,{label:F}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(F){F!==this.g&&(this.g=F,L(this,this.#e,this.#n,{supportsContinuousRun:F}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(F){F!==this.isDefault&&(F?this.#t.add(this.profileId):this.#t.delete(this.profileId),L(this,this.#e,this.#n,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,L(this,this.#e,this.#n,{tag:F?m.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this.c}set configureHandler(F){F!==this.c&&(this.c=F,L(this,this.#e,this.#n,{hasConfigurationHandler:!!F}))}get onDidChangeDefault(){return P.Event.chain(this.#i,F=>F.map(M=>M.get(this.controllerId)?.get(this.profileId)).filter(R.$Rf))}constructor(F,M,O,z,J,te,x,X,Z,ae=!1,_=void 0,ge=!1){this.controllerId=J,this.profileId=te,this.f=x,this.kind=X,this.runHandler=Z,this._tag=_,this.g=ge,this.#e=F,this.#s=M,this.#t=O,this.#i=z,M.set(te,this);const ne=U[X];if(typeof ne!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);ae&&O.add(te),this.#n={profileId:te,controllerId:J,tag:_?m.TestTag.namespace(this.controllerId,_.id):null,label:x,group:ne,isDefault:ae,hasConfigurationHandler:!1,supportsContinuousRun:ge},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Rhc=T;const U={[a.TestRunProfileKind.Coverage]:8,[a.TestRunProfileKind.Debug]:4,[a.TestRunProfileKind.Run]:2}}),define(ke[151],Se([1,0,61,14,121,15,7]),function($e,e,D,N,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=e.$wN=e.$vN=void 0;class p{static{this.c=new h.$tN("TextEditorDecorationType")}constructor(w,E,S){const c=p.c.nextId();w.$registerTextEditorDecorationType(E.identifier,c,P.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:c,dispose(){w.$removeTextEditorDecorationType(c)}})}}e.$vN=p;class b{constructor(w,E){this.g=[],this.h=void 0,this.j=!1,this.c=w,this.d=w.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(w,E){this.k();let S=null;if(w instanceof A.$mL)S=new A.$nL(w,w);else if(w instanceof A.$nL)S=w;else throw new Error("Unrecognized location");this.l(S,E,!1)}insert(w,E){this.k(),this.l(new A.$nL(w,w),E,!0)}delete(w){this.k();let E=null;if(w instanceof A.$nL)E=w;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(w,E,S){const c=this.c.validateRange(w);this.g.push({range:c,text:E,forceMoveMarkers:S})}setEndOfLine(w){if(this.k(),w!==A.EndOfLine.LF&&w!==A.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=w}}class k{constructor(w,E,S,c){this.c=w,this.d=E,this._accept(S),this.e=c;const m=this;this.value={get tabSize(){return m.f},set tabSize(a){m.n(a)},get indentSize(){return m.g},set indentSize(a){m.p(a)},get insertSpaces(){return m.j},set insertSpaces(a){m.s(a)},get cursorStyle(){return m.k},set cursorStyle(a){m.t(a)},get lineNumbers(){return m.l},set lineNumbers(a){m.u(a)}}}_accept(w){this.f=w.tabSize,this.g=w.indentSize,this.h=w.originalIndentSize,this.j=w.insertSpaces,this.k=w.cursorStyle,this.l=P.TextEditorLineNumbersStyle.to(w.lineNumbers)}m(w){if(w==="auto")return"auto";if(typeof w=="number"){const E=Math.floor(w);return E>0?E:null}if(typeof w=="string"){const E=parseInt(w,10);return isNaN(E)?null:E>0?E:null}return null}n(w){const E=this.m(w);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(w){if(w==="tabSize")return"tabSize";if(typeof w=="number"){const E=Math.floor(w);return E>0?E:null}if(typeof w=="string"){const E=parseInt(w,10);return isNaN(E)?null:E>0?E:null}return null}p(w){const E=this.o(w);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(w){return w==="auto"?"auto":w==="false"?!1:!!w}s(w){const E=this.q(w);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(w){this.k!==w&&(this.k=w,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:w})))}u(w){this.l!==w&&(this.l=w,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:P.TextEditorLineNumbersStyle.from(w)})))}assign(w){const E={};let S=!1;if(typeof w.tabSize<"u"){const c=this.m(w.tabSize);c==="auto"?(S=!0,E.tabSize=c):typeof c=="number"&&this.f!==c&&(this.f=c,S=!0,E.tabSize=c)}if(typeof w.indentSize<"u"){const c=this.o(w.indentSize);c==="tabSize"?(S=!0,E.indentSize=c):typeof c=="number"&&this.h!==c&&(this.g=c,this.h=c,S=!0,E.indentSize=c)}if(typeof w.insertSpaces<"u"){const c=this.q(w.insertSpaces);c==="auto"?(S=!0,E.insertSpaces=c):this.j!==c&&(this.j=c,S=!0,E.insertSpaces=c)}typeof w.cursorStyle<"u"&&this.k!==w.cursorStyle&&(this.k=w.cursorStyle,S=!0,E.cursorStyle=w.cursorStyle),typeof w.lineNumbers<"u"&&this.l!==w.lineNumbers&&(this.l=w.lineNumbers,S=!0,E.lineNumbers=P.TextEditorLineNumbersStyle.from(w.lineNumbers)),S&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(w,E){E.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${w}' failed:'`),this.e.warn(S)})}}e.$wN=k;class R{constructor(w,E,S,c,m,a,i,n){this.id=w,this.j=E,this.k=S,this.g=!1,this.h=new Set,this.c=m,this.d=new k(this.j,this.id,a,S),this.e=i,this.f=n;const r=this;this.value=Object.freeze({get document(){return c.value},set document(s){throw new N.$9("document")},get selection(){return r.c&&r.c[0]},set selection(s){if(!(s instanceof A.$oL))throw(0,N.$7)("selection");r.c=[s],r.l()},get selections(){return r.c},set selections(s){if(!Array.isArray(s)||s.some(t=>!(t instanceof A.$oL)))throw(0,N.$7)("selections");r.c=s,r.l()},get visibleRanges(){return r.e},set visibleRanges(s){throw new N.$9("visibleRanges")},get options(){return r.d.value},set options(s){r.g||r.d.assign(s)},get viewColumn(){return r.f},set viewColumn(s){throw new N.$9("viewColumn")},edit(s,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const g=new b(c.value,t);return s(g),r.m(g)},insertSnippet(s,t,g={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=r.c.map(d=>P.Range.from(d));else if(t instanceof A.$mL){const{lineNumber:d,column:l}=P.Position.from(t);o=[{startLineNumber:d,startColumn:l,endLineNumber:d,endColumn:l}]}else if(t instanceof A.$nL)o=[P.Range.from(t)];else{o=[];for(const d of t)if(d instanceof A.$nL)o.push(P.Range.from(d));else{const{lineNumber:l,column:u}=P.Position.from(d);o.push({startLineNumber:l,startColumn:u,endLineNumber:l,endColumn:u})}}return E.$tryInsertSnippet(w,c.value.version,s.value,o,g)},setDecorations(s,t){const g=t.length===0;g&&!r.h.has(s.key)||(g?r.h.delete(s.key):r.h.add(s.key),r.n(()=>{if(P.$lN(t))return E.$trySetDecorations(w,s.key,P.$mN(t));{const o=new Array(4*t.length);for(let d=0,l=t.length;d<l;d++){const u=t[d];o[4*d]=u.start.line+1,o[4*d+1]=u.start.character+1,o[4*d+2]=u.end.line+1,o[4*d+3]=u.end.character+1}return E.$trySetDecorationsFast(w,s.key,o)}}))},revealRange(s,t){r.n(()=>E.$tryRevealRange(w,P.Range.from(s),t||A.TextEditorRevealType.Default))},show(s){E.$tryShowEditor(w,P.ViewColumn.from(s))},hide(){E.$tryHideEditor(w)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(w){(0,D.ok)(!this.g),this.d._accept(w)}_acceptVisibleRanges(w){(0,D.ok)(!this.g),this.e=w}_acceptViewColumn(w){(0,D.ok)(!this.g),this.f=w}_acceptSelections(w){(0,D.ok)(!this.g),this.c=w}async l(){const w=this.c.map(P.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,w)),this.value}m(w){const E=w.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const S=E.edits.map(m=>m.range);S.sort((m,a)=>m.end.line===a.end.line?m.end.character===a.end.character?m.start.line===a.start.line?m.start.character-a.start.character:m.start.line-a.start.line:m.end.character-a.end.character:m.end.line-a.end.line);for(let m=0,a=S.length-1;m<a;m++){const i=S[m].end;if(S[m+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=E.edits.map(m=>({range:P.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,c,{setEndOfLine:typeof E.setEndOfLine=="number"?P.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(w){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$xN=R}),define(ke[72],Se([1,0,61,4,3,2,5,6,148,20,151,15,13,28,16,53,43]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zN=e.$yN=void 0;class a{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(r,s){this.h=r,this.i=s,this.a=null,this.b=new Map,this.c=new E.$Ac,this.d=new N.$Wd,this.e=new N.$Wd,this.f=new N.$Wd,this.g=new N.$Wd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const s=[],t=[],g=[];if(r.removedDocuments)for(const o of r.removedDocuments){const d=P.URI.revive(o),l=this.c.get(d);l?.unref()&&(this.c.delete(d),s.push(l.value))}if(r.addedDocuments)for(const o of r.addedDocuments){const d=P.URI.revive(o.uri);let l=this.c.get(d);if(l&&d.scheme!==S.Schemas.vscodeNotebookCell&&d.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);l||(l=new a(new b.$rN(this.h.getProxy(p.$jL.MainThreadDocuments),d,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this.c.set(d,l),t.push(l.value)),l.ref()}if(r.removedEditors)for(const o of r.removedEditors){const d=this.b.get(o);this.b.delete(o),d&&g.push(d)}if(r.addedEditors)for(const o of r.addedEditors){const d=P.URI.revive(o.documentUri);D.ok(this.c.has(d),`document '${d}' does not exist`),D.ok(!this.b.has(o.id),`editor '${o.id}' already exists!`);const l=this.c.get(d).value,u=new R.$xN(o.id,this.h.getProxy(p.$jL.MainThreadTextEditors),this.i,new m.$V(()=>l.document),o.selections.map(C.Selection.to),o.options,o.visibleRanges.map(v=>C.Range.to(v)),typeof o.editorPosition=="number"?C.ViewColumn.to(o.editorPosition):void 0);this.b.set(o.id,u)}r.newActiveEditor!==void 0&&(D.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,h.$Oc)(s),(0,h.$Oc)(g),r.removedDocuments&&this.e.fire(s),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(o=>o.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return c.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const s=this.b.get(this.a);return r?s:s?.value}allEditors(){return[...this.b.values()]}};e.$yN=i,e.$yN=i=Ge([Ve(0,k.$oN),Ve(1,w.$pj)],i),e.$zN=(0,A.$8h)("IExtHostDocumentsAndEditors")}),define(ke[346],Se([1,0,19,4,6,151,15,7]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;class b{constructor(R,C){this.i=C,this.a=new N.$Wd,this.b=new N.$Wd,this.c=new N.$Wd,this.d=new N.$Wd,this.f=new N.$Wd,this.g=new N.$Wd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy(h.$jL.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(w=>this.g.fire(w)),this.i.onDidChangeActiveTextEditor(w=>this.f.fire(w))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const C=this.i.allEditors();return R?C:C.map(w=>w.value)}async showTextDocument(R,C,w){let E;typeof C=="number"?E={position:A.ViewColumn.from(C),preserveFocus:w}:typeof C=="object"?E={position:A.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?A.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:E={preserveFocus:!1};const S=await this.h.$tryShowTextDocument(R.uri,E),c=S&&this.i.getEditor(S);if(c)return c.value;throw S?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,C){return new P.$vN(this.h,R,C).value}$acceptEditorPropertiesChanged(R,C){const w=this.i.getEditor(R);if(!w)throw new Error("unknown text editor");if(C.options&&w._acceptOptions(C.options),C.selections){const E=C.selections.selections.map(A.Selection.to);w._acceptSelections(E)}if(C.visibleRanges){const E=D.$Hb(C.visibleRanges.map(A.Range.to));w._acceptVisibleRanges(E)}if(C.options&&this.b.fire({textEditor:w.value,options:{...C.options,lineNumbers:A.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const E=p.TextEditorSelectionChangeKind.fromValue(C.selections.source),S=C.selections.selections.map(A.Selection.to);this.a.fire({textEditor:w.value,selections:S,kind:E})}if(C.visibleRanges){const E=D.$Hb(C.visibleRanges.map(A.Range.to));this.c.fire({textEditor:w.value,visibleRanges:E})}}$acceptEditorPositionData(R){for(const C in R){const w=this.i.getEditor(C);if(!w)throw new Error("Unknown text editor");const E=A.ViewColumn.to(R[C]);w.value.viewColumn!==E&&(w._acceptViewColumn(E),this.d.fire({textEditor:w.value,viewColumn:E}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.$bgc=b}),define(ke[347],Se([1,0,2,5,6,3,7,15,25,18]),function($e,e,D,N,h,P,A,p,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=e.$Thc=void 0,e.$Thc=(0,N.$8h)("IExtHostTimeline");class R{constructor(E,S){this.b=new Map,this.c=new Map,this.a=E.getProxy(h.$jL.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(c,m)=>{if(c&&c.$mid===12)if(this.b.get(c.source)&&b.$nm.equals(m,this.b.get(c.source)?.extension)){const a=c.uri===void 0?void 0:D.URI.revive(c.uri);return this.c.get(c.source)?.get(C(a))?.get(c.handle)}else return;return c}})}async $getTimeline(E,S,c,m){return this.b.get(E)?.provider.provideTimeline(D.URI.revive(S),c,m)}registerTimelineProvider(E,S,c,m){const a=new P.$Sc,i=this.d(S.id,m,a).bind(this);let n;S.onDidChange&&(n=S.onDidChange(s=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...s,id:S.id}),this));const r=this.c;return this.f({...S,scheme:E,onDidChange:void 0,async provideTimeline(s,t,g){t?.resetCache&&(a.clear(),r.get(S.id)?.clear());const o=await S.provideTimeline(s,t,g);if(o==null)return;const d=i(s,t);return{...o,source:S.id,items:o.items.map(d)}},dispose(){for(const s of r.values())s.get(S.id)?.clear();n?.dispose(),a.dispose()}},c)}d(E,S,c){return(m,a)=>{let i;if(a?.cacheResults){let n=this.c.get(E);n===void 0&&(n=new Map,this.c.set(E,n));const r=C(m);i=n.get(r),i===void 0&&(i=new Map,n.set(r,i))}return n=>{const{iconPath:r,...s}=n,t=`${E}|${n.id??n.timestamp}`;i?.set(t,n);let g,o,d;n.iconPath&&(r instanceof A.$gM?d={id:r.id,color:r.color}:D.URI.isUri(r)?(g=r,o=r):{light:g,dark:o}=r);let l;return A.$ML.isMarkdownString(s.tooltip)?l=p.MarkdownString.from(s.tooltip):(0,k.$Jf)(s.tooltip)?l=s.tooltip:A.$ML.isMarkdownString(s.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=p.MarkdownString.from(s.detail)):(0,k.$Jf)(s.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=s.detail),{...s,id:s.id??void 0,handle:t,source:E,command:n.command?S.toInternal(n.command,c):void 0,icon:g,iconDark:o,themeIcon:d,tooltip:l,accessibilityInformation:n.accessibilityInformation}}}}f(E,S){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,{provider:E,extension:S}),(0,P.$Rc)(()=>{for(const m of this.c.values())m.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.$Uhc=R;function C(w){return w?.toString()}}),define(ke[348],Se([1,0,219,23,2,4,3,278,8,7,18,19,15,80,22,177,26]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;function a(r,s){if((0,R.$Jf)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class i extends A.$Tc{constructor(s,t,g){super(),this.f=s,this.g=t,this.h=g,this.a=new Map,this.b=new c.$B8;function o(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:d=>o(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(l=>o(l)?this.r(l):l):d})}registerTreeDataProvider(s,t,g){const o=this.createTreeView(s,{treeDataProvider:t},g);return{dispose:()=>o.dispose()}}createTreeView(s,t,g){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=t.dragAndDropController?.dropMimeTypes??[],d=t.dragAndDropController?.dragMimeTypes??[],l=!!t.dragAndDropController?.handleDrag,u=!!t.dragAndDropController?.handleDrop,v=this.m(s,t,g),I={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:o,dragMimeTypes:d,hasHandleDrag:l,hasHandleDrop:u,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},$=this.f.$registerTreeViewDataProvider(s,I),f={get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get activeItem(){return(0,m.$LF)(g,"treeViewActiveItem"),v.focusedElement},get onDidChangeActiveItem(){return(0,m.$LF)(g,"treeViewActiveItem"),v.onDidChangeActiveItem},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get onDidChangeCheckboxState(){return v.onDidChangeCheckboxState},get message(){return v.message},set message(y){(0,E.$lk)(y)&&(0,m.$LF)(g,"treeViewMarkdownMessage"),v.message=y},get title(){return v.title},set title(y){v.title=y},get description(){return v.description},set description(y){v.description=y},get badge(){return v.badge},set badge(y){y!==void 0&&k.ViewBadge.isViewBadge(y)?v.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(v.badge=void 0)},reveal:(y,L)=>v.reveal(y,L),dispose:async()=>{await $,this.a.delete(s),v.dispose()}};return this.B(f),f}$getChildren(s,t){const g=this.a.get(s);return g?g.getChildren(t):Promise.reject(new p.$eF(s))}async $handleDrop(s,t,g,o,d,l,u,v){const I=this.a.get(s);if(!I)return Promise.reject(new p.$eF(s));const $=w.DataTransfer.toDataTransfer(g,async f=>(await this.f.$resolveDropFileData(s,t,f)).buffer);return u===s&&v&&await this.j($,I,v,d,l),I.onDrop($,o,d)}async j(s,t,g,o,d){const l=this.b.removeDragOperationTransfer(d);if(l)(await l)?.forEach((u,v)=>{u&&s.set(v,u)});else if(d&&t.handleDrag){const u=t.handleDrag(g,s,o);this.b.addDragOperationTransfer(d,u),await u}return s}async $handleDrag(s,t,g,o){const d=this.a.get(s);if(!d)return Promise.reject(new p.$eF(s));const l=await this.j(new k.$dM,d,t,o,g);if(!(!l||o.isCancellationRequested))return w.DataTransfer.from(l)}async $hasResolve(s){const t=this.a.get(s);if(!t)throw new p.$eF(s);return t.hasResolve}$resolve(s,t,g){const o=this.a.get(s);if(!o)throw new p.$eF(s);return o.resolveTreeItem(t,g)}$setExpanded(s,t,g){const o=this.a.get(s);if(!o)throw new p.$eF(s);o.setExpanded(t,g)}$setSelectionAndFocus(s,t,g){const o=this.a.get(s);if(!o)throw new p.$eF(s);o.setSelectionAndFocus(t,g)}$setVisible(s,t){const g=this.a.get(s);if(!g){if(!t)return;throw new p.$eF(s)}g.setVisible(t)}$changeCheckboxState(s,t){const g=this.a.get(s);if(!g)throw new p.$eF(s);g.setCheckboxState(t)}m(s,t,g){const o=this.B(new n(s,t,this.f,this.g.converter,this.h,g));return this.a.set(s,o),o}r(s){const t=this.a.get(s.$treeViewId);return t&&"$treeItemHandle"in s?t.getExtensionElement(s.$treeItemHandle):t&&"$focusedTreeItem"in s&&s.$focusedTreeItem?t.focusedElement:null}}e.$Vhc=i;class n extends A.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(s=>this.getExtensionElement(s)).filter(s=>!(0,R.$Sf)(s))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(s,t,g,o,d,l){if(super(),this.I=s,this.J=g,this.L=o,this.M=d,this.N=l,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new P.$Wd),this.onDidExpandElement=this.u.event,this.w=this.B(new P.$Wd),this.onDidCollapseElement=this.w.event,this.y=this.B(new P.$Wd),this.onDidChangeSelection=this.y.event,this.z=this.B(new P.$Wd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new P.$Wd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new P.$Wd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new P.$Wd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$7d,l.contributes&&l.contributes.views)for(const $ in l.contributes.views)for(const f of l.contributes.views[$])f.id===s&&(this.P=f.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData($=>this.F.fire({message:!1,element:$})));let u,v;const I=P.Event.debounce(this.F.event,($,f)=>($||($={message:!1,elements:[]}),f.element!==!1&&(u||(u=new Promise(y=>v=y),this.G=this.G.then(()=>u)),Array.isArray(f.element)?$.elements.push(...f.element):$.elements.push(f.element)),f.message&&($.message=!0),$),200,!0);this.B(I(({message:$,elements:f})=>{f.length&&(this.H=this.H.then(()=>{const y=v;return u=null,this.$(f).then(()=>y())})),$&&this.J.$setMessage(this.I,w.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(s){const t=s?this.getExtensionElement(s):void 0;if(s&&!t)return this.M.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let g=this.X(s);return g||(g=await this.Y(t)),g?g.map(o=>o.item):void 0}getExtensionElement(s){return this.j.get(s)}reveal(s,t){t=t||{select:!0,focus:!1};const g=(0,R.$Sf)(t.select)?!0:t.select,o=(0,R.$Sf)(t.focus)?!1:t.focus,d=(0,R.$Sf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.G.then(()=>this.S(s)).then(l=>this.W(s,l[l.length-1]).then(u=>this.J.$reveal(this.I,{item:u.item,parentChain:l.map(v=>v.item)},{select:g,focus:o,expand:d})),l=>this.M.error(l)):this.J.$reveal(this.I,void 0,{select:g,focus:o,expand:d})}get message(){return this.O}set message(s){this.O=s,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(s){this.P=s,this.J.$setTitle(this.I,s,this.Q)}get description(){return this.Q}set description(s){this.Q=s,this.J.$setTitle(this.I,this.P,s)}get badge(){return this.R}set badge(s){this.R?.value===s?.value&&this.R?.tooltip===s?.tooltip||(this.R=w.ViewBadge.from(s),this.J.$setBadge(this.I,s))}setExpanded(s,t){const g=this.getExtensionElement(s);g&&(t?this.u.fire(Object.freeze({element:g})):this.w.fire(Object.freeze({element:g})))}setSelectionAndFocus(s,t){const g=!(0,C.$ub)(this.s,s);this.s=s;const o=this.t!==t;this.t=t,g&&this.y.fire(Object.freeze({selection:this.selectedElements})),o&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(s){s!==this.r&&(this.r=s,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(s){const t=(await Promise.all(s.map(async g=>{const o=this.getExtensionElement(g.treeItemHandle);return o?{extensionItem:o,treeItem:await this.f.getTreeItem(o),newState:g.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(g=>g!==void 0);t.forEach(g=>{g.treeItem.checkboxState=g.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(g=>[g.extensionItem,g.newState])})}async handleDrag(s,t,g){const o=[];for(const d of s){const l=this.getExtensionElement(d);l&&o.push(l)}if(!(!this.g?.handleDrag||o.length===0))return await this.g.handleDrag(o,t,g),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(s,t,g){const o=t?this.getExtensionElement(t):void 0;if(!(!o&&t||!this.g?.handleDrop))return(0,b.$Zg)(()=>this.g?.handleDrop?this.g.handleDrop(o,s,g):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(s,t){if(!this.f.resolveTreeItem)return;const g=this.j.get(s);if(g){const o=this.m.get(g);if(o){const d=await this.f.resolveTreeItem(o.extensionItem,g,t)??o.extensionItem;return this.hb(d),o.item.tooltip=this.eb(d.tooltip),o.item.command=this.fb(o.disposableStore,d.command),o.item}}}S(s){return this.U(s).then(t=>t?this.S(t).then(g=>this.W(t,g[g.length-1]).then(o=>(g.push(o),g))):Promise.resolve([]))}U(s){const t=this.m.get(s);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,b.$Zg)(()=>this.f.getParent(s))}W(s,t){const g=this.m.get(s);return g?Promise.resolve(g):(0,b.$Zg)(()=>this.f.getTreeItem(s)).then(o=>this.kb(s,o,t,!0)).then(o=>this.getChildren(t?t.item.handle:void 0).then(()=>{const d=this.getExtensionElement(o);if(d){const l=this.m.get(d);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${o} from extension ${this.N.identifier.value}`)}))}X(s){if(s){let t;if(typeof s=="string"){const g=this.getExtensionElement(s);t=g?this.m.get(g):void 0}else t=s;return t&&t.children||void 0}return this.h}async Y(s){this.rb(s);const t=new S.$7d(this.Z.token);try{const g=s?this.m.get(s):void 0,o=await this.f.getChildren(s);if(t.token.isCancellationRequested)return;const d=(0,C.$Hb)(o||[]),l=await Promise.all((0,C.$Hb)(d).map(v=>this.f.getTreeItem(v)));if(t.token.isCancellationRequested)return;const u=l.map((v,I)=>v?this.db(d[I],v,g):null);return(0,C.$Hb)(u)}finally{t.dispose()}}$(s){if(s.some(g=>!g))return this.Z.dispose(!0),this.Z=new S.$7d,this.tb(),this.J.$refresh(this.I);{const g=this.ab(s);if(g.length)return this.bb(g)}return Promise.resolve(void 0)}ab(s){const t=new Set,g=s.map(d=>this.m.get(d));for(const d of g)if(d&&!t.has(d.item.handle)){let l=d;for(;l&&l.parent&&g.findIndex(u=>l&&l.parent&&u&&u.item.handle===l.parent.item.handle)===-1;){const u=this.j.get(l.parent.item.handle);l=u?this.m.get(u):void 0}l&&!l.parent&&t.add(d.item.handle)}const o=[];return t.forEach(d=>{const l=this.j.get(d);if(l){const u=this.m.get(l);u&&(!u.parent||!t.has(u.parent.item.handle))&&o.push(d)}}),o}bb(s){const t={};return Promise.all(s.map(g=>this.cb(g).then(o=>{o&&(t[g]=o.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(s){const t=this.getExtensionElement(s);if(t){const g=this.m.get(t);if(g)return this.rb(t),(0,b.$Zg)(()=>this.f.getTreeItem(t)).then(o=>{if(o){const d=this.ib(t,o,g.parent);return this.pb(t,d,g,g.parent),g.dispose(),d}return null})}return Promise.resolve(null)}db(s,t,g){const o=this.ib(s,t,g);if(t.id&&this.j.has(o.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(s,o),this.qb(o,g),o}eb(s){return k.$ML.isMarkdownString(s)?w.MarkdownString.from(s):s}fb(s,t){return t?{...this.L.toInternal(t,s),originalId:t.command}:void 0}gb(s){if(s.checkboxState===void 0)return;let t,g,o;return typeof s.checkboxState=="number"?t=s.checkboxState:(t=s.checkboxState.state,g=s.checkboxState.tooltip,o=s.checkboxState.accessibilityInformation),{isChecked:t===k.TreeItemCheckboxState.Checked,tooltip:g,accessibilityInformation:o}}hb(s){if(!k.$$L.isTreeItem(s,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(s,t,g){this.hb(t);const o=this.B(new A.$Sc),d=this.kb(s,t,g),l=this.lb(t);return{item:{handle:d,parentHandle:g?g.item.handle:void 0,label:a(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(o,t.command),contextValue:t.contextValue,icon:l,iconDark:this.mb(t)||l,themeIcon:this.jb(t),collapsibleState:(0,R.$Sf)(t.collapsibleState)?k.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:g,children:void 0,disposableStore:o,dispose(){o.dispose()}}}jb(s){return s.iconPath instanceof k.$gM?s.iconPath:void 0}kb(s,{id:t,label:g,resourceUri:o},d,l){if(t)return`${n.b}/${t}`;const u=a(g,this.N),v=d?d.item.handle:n.a;let I=u?u.label:o?(0,N.$Fg)(o):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const $=this.m.has(s)?this.m.get(s).item.handle:void 0,f=this.X(d)||[];let y,L=0;do{if(y=`${v}/${L}:${I}`,l||!this.j.has(y)||$===y)break;L++}while(L<=f.length);return y}lb(s){if(s.iconPath&&!(s.iconPath instanceof k.$gM))return typeof s.iconPath=="string"||h.URI.isUri(s.iconPath)?this.nb(s.iconPath):this.nb(s.iconPath.light)}mb(s){if(s.iconPath&&!(s.iconPath instanceof k.$gM)&&s.iconPath.dark)return this.nb(s.iconPath.dark)}nb(s){return h.URI.isUri(s)?s:h.URI.file(s)}ob(s,t){this.j.set(t.item.handle,s),this.m.set(s,t)}pb(s,t,g,o){this.j.delete(t.item.handle),this.m.delete(s),t.item.handle!==g.item.handle&&this.j.delete(g.item.handle),this.ob(s,t);const d=this.X(o)||[],l=d.filter(u=>u.item.handle===g.item.handle)[0];l&&d.splice(d.indexOf(l),1,t)}qb(s,t){t?(t.children||(t.children=[]),t.children.push(s)):(this.h||(this.h=[]),this.h.push(s))}rb(s){if(s){const t=this.m.get(s);if(t){if(t.children)for(const g of t.children){const o=this.j.get(g.item.handle);o&&this.sb(o)}t.children=void 0}}else this.tb()}sb(s){const t=this.m.get(s);if(t){if(t.children)for(const g of t.children){const o=this.j.get(g.item.handle);o&&this.sb(o)}this.m.delete(s),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(s=>s.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[349],Se([1,0,4,3,2,30,15,93,6,7]),function($e,e,D,N,h,P,A,p,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;class R extends N.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(S,c,m,a){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new D.$Wd),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Wd),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=c,this.#n=m,this.#i=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#u=a.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(S){this.c(),this.#r!==S&&(this.#r=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,h.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(S){this.#l||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#u=S.active,this.#c=S.visible,this.#o=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,c){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:A.ViewColumn.from(S),preserveFocus:!!c})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends N.$Tc{static c(){return(0,P.$rg)()}constructor(S,c,m){super(),this.j=c,this.m=m,this.g=new Map,this.h=new Map,this.f=S.getProxy(b.$jL.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,c,m,a,i={}){const n=typeof a=="object"?a.viewColumn:a,r={viewColumn:A.ViewColumn.from(n),preserveFocus:typeof a=="object"&&!!a.preserveFocus},s=(0,p.$qgc)(S),t=C.c();this.f.$createWebviewPanel((0,p.$sgc)(S),t,c,{title:m,panelOptions:w(i),webviewOptions:(0,p.$tgc)(S,this.m,i),serializeBuffersForPostMessage:s},r);const g=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,c,m,n,i,g,!0)}$onDidChangeWebviewPanelViewStates(S){const c=Object.keys(S);c.sort((m,a)=>{const i=S[m],n=S[a];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const m of c){const a=this.getWebviewPanel(m);if(!a)continue;const i=S[m];a._updateViewState({active:i.active,visible:i.visible,viewColumn:A.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,c,m){if(this.h.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.h.set(c,{serializer:m,extension:S}),this.f.$registerSerializer(c,{serializeBuffersForPostMessage:(0,p.$qgc)(S)}),new k.$lL(()=>{this.h.delete(c),this.f.$unregisterSerializer(c)})}async $deserializeWebviewPanel(S,c,m,a){const i=this.h.get(c);if(!i)throw new Error(`No serializer found for '${c}'`);const{serializer:n,extension:r}=i,s=this.j.createNewWebview(S,m.webviewOptions,r),t=this.createNewWebviewPanel(S,c,m.title,a,m.panelOptions,s,m.active);await n.deserializeWebviewPanel(t,m.state)}createNewWebviewPanel(S,c,m,a,i,n,r){const s=new R(S,this.f,n,{viewType:c,title:m,viewColumn:a,panelOptions:i,active:r});return this.g.set(S,s),s}getWebviewPanel(S){return this.g.get(S)}}e.$ugc=C;function w(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(ke[350],Se([1,0,4,3,93,15,6,7]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=void 0;class b extends N.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(C,w,E,S,c,m){super(),this.#s=!1,this.#u=this.B(new D.$Wd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new D.$Wd),this.onDidDispose=this.#l.event,this.#i=E,this.#a=S,this.#e=C,this.#t=w,this.#n=c,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#o}set description(C){this.a(),this.#o!==C&&(this.#o=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(C){C===this.#r||this.#s||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=P.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(C,w){this.d=w,this.b=new Map,this.c=new Map,this.a=C.getProxy(A.$jL.MainThreadWebviewViews)}registerWebviewViewProvider(C,w,E,S){if(this.b.has(w))throw new Error(`View provider for '${w}' already registered`);return this.b.set(w,{provider:E,extension:C}),this.a.$registerWebviewViewProvider((0,h.$sgc)(C),w,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,h.$qgc)(C)}),new p.$lL(()=>{this.b.delete(w),this.a.$unregisterWebviewViewProvider(w)})}async $resolveWebviewView(C,w,E,S,c){const m=this.b.get(w);if(!m)throw new Error(`No view provider found for '${w}'`);const{provider:a,extension:i}=m,n=this.d.createNewWebview(C,{},i),r=new b(C,this.a,w,E,n,!0);this.c.set(C,r),await a.resolveWebviewView(r,{state:S},c)}async $onDidChangeWebviewViewVisibility(C,w){this.e(C)._setVisible(w)}async $disposeWebviewView(C){const w=this.e(C);this.c.delete(C),w.dispose(),this.d.deleteWebview(C)}e(C){const w=this.c.get(C);if(!w)throw new Error("No webview found");return w}}e.$Yhc=k}),define(ke[351],Se([1,0,69,16,13,249,32,11]),function($e,e,D,N,h,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=void 0;let b=class{constructor(C,w){C.addFileSystemProvider(N.Schemas.file,new k(w),{isCaseSensitive:p.$k})}};e.$Dic=b,e.$Dic=b=Ge([Ve(0,D.$mgc),Ve(1,h.$pj)],b);class k{constructor(C){this.b=C,this.a=new P.$Dq(this.b)}async stat(C){const w=await this.a.stat(C);return{type:w.type,ctime:w.ctime,mtime:w.mtime,size:w.size,permissions:w.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,w,E){return this.a.writeFile(C,w,{...E,unlock:!1,atomic:!1})}delete(C,w){return this.a.delete(C,{...w,useTrash:!1,atomic:!1})}rename(C,w,E){return this.a.rename(C,w,E)}copy(C,w,E){return this.a.copy(C,w,E)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,w){throw new Error("Method not implemented.")}}}),define(ke[352],Se([1,0,17,63,30,33,3,6,2,20]),function($e,e,D,N,h,P,A,p,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=void 0;let R=class extends A.$Tc{constructor(w,E){super();const S=w.getProxy(p.$jL.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async c=>{const m=b.URI.file((0,D.$jc)((0,N.tmpdir)(),(0,h.$rg)()));return await S.$download(c,m),m})}};e.$Bic=R,e.$Bic=R=Ge([Ve(0,k.$oN),Ve(1,P.$KN)],R)}),define(ke[353],Se([1,0,57,17,2,94,3,16,8,31]),function($e,e,D,N,h,P,A,p,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=void 0;class R extends P.$ogc{constructor(){super(...arguments),this.i=null}async g(t){const g=await super.g(t);if(g.scheme!==p.Schemas.file)return g;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${g.fsPath}.`),g;const o=g.fsPath;let d=0;do{let l;d===0?l=o:l=/[/\\]$/.test(o)?`${o.substr(0,o.length-1)}-${d}`:`${o}-${d}`,await C(l);const u=N.$jc(l,"vscode.lock"),v=await c(this.d,u,!1);if(v)return this.i=v,process.on("exit",()=>{v.dispose()}),h.URI.file(l);d++}while(d<10);return g}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Nic=R;async function C(s){try{await k.Promises.stat(s);return}catch{}try{await k.Promises.mkdir(s,{recursive:!0})}catch{}}const w=1e3,E=10*60*1e3;class S extends A.$Tc{constructor(t,g){super(),this.b=t,this.c=g,this.a=this.B(new b.$gh),this.a.cancelAndSet(async()=>{const o=await m(t,g);(!o||o.pid!==process.pid)&&(t.info(`Lock '${g}': The lock was lost unexpectedly.`),this.a.cancel());try{await k.Promises.utimes(g,new Date,new Date)}catch(d){t.error(d),t.info(`Lock '${g}': Could not update mtime.`)}},w)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const g={pid:process.pid,willReleaseAt:Date.now()+t};await k.Promises.writeFile(this.c,JSON.stringify(g),{flag:"w"})}catch(g){this.b.error(g)}}}async function c(s,t,g){try{const d={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(t,JSON.stringify(d),{flag:"wx"})}catch(d){s.error(d)}const o=await m(s,t);return!o||o.pid!==process.pid?g?(s.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(s.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(s,t)):(s.info(`Lock '${t}': Lock acquired.`),new S(s,t))}async function m(s,t){let g;try{g=await k.Promises.readFile(t)}catch(o){return s.error(o),null}try{return JSON.parse(String(g))}catch(o){return s.error(o),null}}async function a(s,t){let g;try{g=await k.Promises.stat(t)}catch(o){return s.error(o),0}return g.mtime.getTime()}function i(s){try{return process.kill(s,0),!0}catch{return!1}}async function n(s,t){const g=await m(s,t);if(!g)return s.info(`Lock '${t}': Could not read pid of lock holder.`),r(s,t);if(g.willReleaseAt){let v=g.willReleaseAt-Date.now();if(v<5e3){for(v>0?s.info(`Lock '${t}': The lockfile is scheduled to be released in ${v} ms.`):s.info(`Lock '${t}': The lockfile is scheduled to have been released.`);v>0;){if(await(0,b.$9g)(Math.min(100,v)),await a(s,t)===0)return r(s,t);v=g.willReleaseAt-Date.now()}return r(s,t)}}if(!i(g.pid))return s.info(`Lock '${t}': The pid ${g.pid} appears to be gone.`),r(s,t);const o=await a(s,t),d=Date.now()-o;if(d<=E)return s.info(`Lock '${t}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null;s.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,b.$9g)(2e3);const l=await a(s,t),u=Date.now()-l;return u<=E?(s.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(s.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(s,t))}async function r(s,t){s.info(`Lock '${t}': Deleting a stale lock.`);try{await k.Promises.unlink(t)}catch{}return c(s,t,!0)}}),define(ke[354],Se([1,0,30,20,46,33]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;let A=class extends h.$Kgc{constructor(b,k){super(!0,b,k)}createTerminal(b,k,R){return this.createTerminalFromOptions({name:b,shellPath:k,shellArgs:R})}createTerminalFromOptions(b,k){const R=new h.$Jgc(this.a,(0,D.$rg)(),b,b.name);return this.f.push(R),R.create(b,this.R(b,k)),R.value}};e.$9hc=A,e.$9hc=A=Ge([Ve(0,P.$KN),Ve(1,N.$oN)],A)}),define(ke[355],Se([1,0,4,37,45,5]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FK=e.$EK=e.OutputChannelUpdateMode=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=void 0,e.$uK="text/x-code-output",e.$vK="output",e.$wK="Log",e.$xK="text/x-code-log-output",e.$yK="log",e.$zK="workbench.panel.output",e.$AK=new h.$mj("inOutput",!1),e.$BK=new h.$mj("activeLogOutput",!1),e.$CK=new h.$mj("outputView.scrollLock",!1),e.$DK=(0,P.$8h)("outputService");var A;(function(b){b[b.Append=1]="Append",b[b.Replace=2]="Replace",b[b.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$EK={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new D.$Wd,this.onDidRegisterChannel=this.b.event,this.c=new D.$Wd,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(R=>k.push(R)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}N.$Kn.add(e.$EK.OutputChannels,new p),e.$FK=new h.$mj("activeOutputChannel","")}),define(ke[152],Se([1,0,6,5,20,25,13,355,69,27,59,182,21,18,32,4,3]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=e.$zhc=void 0;class a extends A.$vj{get disposed(){return this.n}constructor(s,t,g,o,d){super(),this.id=s,this.name=t,this.r=g,this.s=o,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(g.getLevel()),this.B(g.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s)}clear(){const s=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,s)}replace(s){const t=this.m;this.info(s),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(s,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof s=="boolean"?s:t))}hide(){this.s.$close(this.id)}g(s,t){this.m+=w.$ke.fromString(t).byteLength,(0,A.log)(this.r,s,t),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends a{appendLine(s){this.append(s)}}let n=class{constructor(s,t,g,o,d,l){this.i=t,this.j=g,this.k=o,this.l=d,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=s.getProxy(D.$jL.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$zm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.h=s;for(const[t,g]of this.g)g.visible=t===this.h}createOutputChannel(s,t,g){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const o=typeof t=="object"&&t.log,d=(0,E.$Jf)(t)?t:void 0;if((0,E.$Jf)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const u=this.i.environment.extensionLogLevel?.find(([I])=>P.$nm.equals(g.identifier,I))?.[1];u&&(l=(0,A.$Fj)(u));const v=o?this.o(s,l,g):this.n(s,d,g);return v.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),o?this.r(s,l??this.m.getLevel(),v):this.q(s,v)}async n(s,t,g){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const o=await this.c,d=this.k.extUri.joinPath(o,`${this.f++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),u=await this.a.$register(s,d,t,g.identifier.value);return new a(u,s,l,this.a,g)}async o(s,t,g){const o=await this.p(g),d=s.replace(/[\\/:\*\?"<>\|]/g,""),l=this.k.extUri.joinPath(o,`${d}.log`),u=`${g.identifier.value}.${d}`,v=this.l.createLogger(l,{id:u,name:s,logLevel:t,extensionId:g.identifier.value});return new i(u,s,v,this.a,g)}p(s){let t=this.d.get(s.identifier.value);if(!t){const g=this.k.extUri.joinPath(this.i.logsLocation,s.identifier.value);this.d.set(s.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(g)}catch(o){if((0,S.$Ik)(o)!==S.FileSystemProviderErrorCode.FileExists)throw o}return g})())}return t}q(s,t){let g=!1;const o=()=>{if(g)throw new Error("Channel has been closed")};return{get name(){return s},append(d){o(),t.then(l=>l.append(d))},appendLine(d){o(),t.then(l=>l.appendLine(d))},clear(){o(),t.then(d=>d.clear())},replace(d){o(),t.then(l=>l.replace(d))},show(d,l){o(),t.then(u=>u.show(d,l))},hide(){o(),t.then(d=>d.hide())},dispose(){g=!0,t.then(d=>d.dispose())}}}r(s,t,g){const o=new m.$Sc,d=()=>{if(o.isDisposed)throw new Error("Channel has been closed")},l=o.add(new c.$Wd);function u(v){t=v,l.fire(v)}return g.then(v=>{o.add(v),v.logLevel!==t&&u(v.logLevel),o.add(v.onDidChangeLogLevel(I=>u(I)))}),{...this.q(s,g),get logLevel(){return t},onDidChangeLogLevel:l.event,trace(v,...I){d(),g.then($=>$.trace(v,...I))},debug(v,...I){d(),g.then($=>$.debug(v,...I))},info(v,...I){d(),g.then($=>$.info(v,...I))},warn(v,...I){d(),g.then($=>$.warn(v,...I))},error(v,...I){d(),g.then($=>$.error(v,...I))},dispose(){o.dispose()}}}};e.$zhc=n,e.$zhc=n=Ge([Ve(0,h.$oN),Ve(1,k.$EN),Ve(2,b.$mgc),Ve(3,R.$Yfc),Ve(4,A.$qj),Ve(5,A.$pj)],n),e.$Ahc=(0,N.$8h)("IExtHostOutputService")}),define(ke[153],Se([1,0,5,8]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=void 0,e.$Om=(0,D.$8h)("remoteAgentService"),e.$Pm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(h){let P=1/0;for(let p=0;p<this.maxSampleCount;p++){const b=await h.getRoundTripTime();if(b===void 0)return;P=Math.min(P,b/2),await(0,N.$9g)(this.sampleDelay)}this.average.push(P),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(P):A=this.initial.reduce((p,b)=>p+b,0)/this.initial.length,this.lastMeasurement={initial:A,current:P,average:this.average.reduce((p,b)=>p+b,0)/this.average.length,high:(()=>typeof A>"u"?!1:P>this.highLatencyMaxThreshold||P>this.highLatencyMinThreshold&&P>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(ke[356],Se([1,0,223,87,37,40,51,3,4,153,11,24]),function($e,e,D,N,h,P,A,p,b,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=void 0,e.$3H=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$4H=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$5H=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$6H=Object.freeze({id:"problems",title:(0,D.localize)(3,null),type:"object",order:101}),e.$7H={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new b.$Wd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(a){this.migrations.push(...a)}}const E=new w;h.$Kn.add(e.$7H.ConfigurationMigration,E);let S=class extends p.$Tc{constructor(a,i){super(),this.a=a,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const r of n.added)await this.f(r,E.migrations)})),this.c(E.migrations),this.B(E.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(a){await this.f(void 0,a);for(const i of this.b.getWorkspace().folders)await this.f(i,a)}async f(a,i){await Promise.all([i.map(n=>this.g(n,a?.uri))])}async g(a,i){const n=this.a.inspect(a.key,{resource:i}),r=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[s,t]of r){const g=n[s];if(!g)continue;const o=[];if(g.value!==void 0){const d=await this.h(a,s,g.value,i,void 0);for(const l of d??[])o.push([l,[]])}for(const{identifiers:d,value:l}of g.overrides??[])if(l!==void 0){const u=await this.h(a,s,l,i,d);for(const v of u??[])o.push([v,d])}o.length&&await Promise.allSettled(o.map(async([[d,l],u])=>this.a.updateValue(d,l.value,{resource:i,overrideIdentifiers:u},t)))}}async h(a,i,n,r,s){const t=o=>{const l=this.a.inspect(o,{resource:r})[i];if(l)return s?l.overrides?.find(({identifiers:u})=>(0,C.$Cn)(u,s))?.value:l.value},g=await a.migrateFn(n,t);return Array.isArray(g)?g:[[a.key,g]]}};e.$8H=S,e.$8H=S=Ge([Ve(0,A.$Bi),Ve(1,P.$ei)],S);let c=class extends p.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchConfiguration"}constructor(a){super(),(async()=>{if(!R.$i&&(await a.getEnvironment())?.os!==1)return;h.$Kn.as(N.$Pn.Configuration).registerConfiguration({...e.$5H,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(4,null)},default:[],markdownDescription:(0,D.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(6,null),scope:2}}})})()}};e.$9H=c,e.$9H=c=Ge([Ve(0,k.$Om)],c)}),define(ke[357],Se([1,0,35,16,17,23,232,356,87,5,37]),function($e,e,D,N,h,P,A,p,b,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddb=e.$Cdb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Bdb=e.$Adb=void 0,e.$Adb=(0,k.$8h)("editorResolverService"),e.$Bdb="workbench.editorAssociations";const C=R.$Kn.as(b.$Pn.Configuration),w={...p.$4H,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(w);var E;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(E||(e.RegisteredEditorPriority=E={}));var S;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function c(a){switch(a){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}e.$Cdb=c;function m(a,i){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(i.scheme))return!1;const s=typeof a=="string"&&a.indexOf(h.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,P.$Fg)(i);return D.$Nj(typeof a=="string"?a.toLowerCase():a,s.toLowerCase())}e.$Ddb=m}),define(ke[358],Se([1,0,34,16,17,11,23,2,5,267,40,143,153]),function($e,e,D,N,h,P,A,p,b,k,R,C,w){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$YK=e.$XK=void 0,e.$XK=(0,b.$8h)("pathService");let S=E=class{constructor(m,a,i,n){this.d=m,this.e=a,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||P.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??m})()}hasValidBasename(m,a,i){return typeof a=="string"||typeof a>"u"?this.a.then(n=>this.h(m,n,a)):this.h(m,a,i)}h(m,a,i){return m.scheme===N.Schemas.file||m.scheme===N.Schemas.vscodeRemote?(0,D.$7f)(i??(0,A.$Fg)(m),a===1):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,a){if(m.remoteAuthority)return N.Schemas.vscodeRemote;const i=(0,k.$UK)(a.getWorkspace());if(i)return i;const n=a.getWorkspace().folders[0];if(n)return n.uri.scheme;const r=a.getWorkspace().configuration;return r?r.scheme:N.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?h.$fc:h.$gc)}async fileURI(m){let a="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const n=m.indexOf("/",2);n===-1?(a=m.substring(2),m="/"):(a=m.substring(2,n),m=m.substring(n)||"/")}return p.URI.from({scheme:N.Schemas.file,authority:a,path:m,query:"",fragment:""})}};e.$YK=S,e.$YK=S=E=Ge([Ve(1,w.$Om),Ve(2,C.$GK),Ve(3,R.$ei)],S)}),define(ke[359],Se([1,0,234,19,52,4,54,3,2,51,239,13,64,269,89,40,143,26,22,18,24,45]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i,n,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RK=e.$QK=e.$PK=e.OnPortForward=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.TunnelSource=e.TunnelCloseReason=e.$JK=e.$IK=e.$HK=void 0;const t=10*1e3,g="remote.tunnels.toRestore",o="remote.tunnels.toRestoreExpiration",d=1e3*60*60*24*14;e.$HK="onTunnel",e.$IK=new s.$mj("forwardedPortsViewEnabled",!1,D.localize(0,null));function l(j){const F=j.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(F)return{host:F[1]?.substring(0,F[1].length-1)||"localhost",port:Number(F[2])}}e.$JK=l;var u;(function(j){j.Other="Other",j.User="User",j.AutoForwardEnd="AutoForwardEnd"})(u||(e.TunnelCloseReason=u={}));var v;(function(j){j[j.User=0]="User",j[j.Auto=1]="Auto",j[j.Extension=2]="Extension"})(v||(e.TunnelSource=v={})),e.$KK={source:v.User,description:D.localize(1,null)},e.$LK={source:v.Auto,description:D.localize(2,null)};function I(j,F,M){const O=j.get(f(F,M));if(O)return O;if((0,S.$Hv)(F))for(const z of S.$Gv){const J=f(z,M);if(j.has(J))return j.get(J)}else if((0,S.$Jv)(F))for(const z of S.$Iv){const J=f(z,M);if(j.has(J))return j.get(J)}}e.$MK=I;function $(j,F,M){const O=I(j,F,M);if(O)return O;const z=(0,S.$Jv)(F)?"localhost":(0,S.$Hv)(F)?"0.0.0.0":void 0;if(z)return I(j,z,M)}e.$NK=$;function f(j,F){return j+":"+F}e.$OK=f;var y;(function(j){j.Notify="notify",j.OpenBrowser="openBrowser",j.OpenBrowserOnce="openBrowserOnce",j.OpenPreview="openPreview",j.Silent="silent",j.Ignore="ignore"})(y||(e.OnPortForward=y={}));function L(j){return j&&"host"in j&&typeof j.host=="string"&&"port"in j&&typeof j.port=="number"&&(!("detail"in j)||typeof j.detail=="string")&&(!("pid"in j)||typeof j.pid=="string")}e.$PK=L;class T extends p.$Tc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(F){super(),this.r=F,this.j=[],this.n=new P.$Wd,this.onDidChangeAttributes=this.n.event,this.B(F.onDidChangeConfiguration(M=>{(M.affectsConfiguration(T.c)||M.affectsConfiguration(T.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(F,M,O){let z=this.w(F,M,O,this.j,0);const J={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;z>=0;){const te=this.j[z];te.key===F?(J.onAutoForward=te.onAutoForward??J.onAutoForward,J.elevateIfNeeded=te.elevateIfNeeded!==void 0?te.elevateIfNeeded:J.elevateIfNeeded,J.label=te.label??J.label,J.requireLocalPort=te.requireLocalPort,J.protocol=te.protocol):(J.onAutoForward=J.onAutoForward??te.onAutoForward,J.elevateIfNeeded=J.elevateIfNeeded!==void 0?J.elevateIfNeeded:te.elevateIfNeeded,J.label=J.label??te.label,J.requireLocalPort=J.requireLocalPort!==void 0?J.requireLocalPort:void 0,J.protocol=J.protocol??te.protocol),z=this.w(F,M,O,this.j,z+1)}return J.onAutoForward!==void 0||J.elevateIfNeeded!==void 0||J.label!==void 0||J.requireLocalPort!==void 0||J.protocol!==void 0?J:this.C()}t(F){return F.start!==void 0&&F.end!==void 0}u(F){return F.host!==void 0&&F.port!==void 0&&(0,n.$Jf)(F.host)&&(0,n.$Nf)(F.port)}w(F,M,O,z,J){if(J>=z.length)return-1;const te=!(0,S.$Hv)(M)&&!(0,S.$Jv)(M),X=z.slice(J).findIndex(Z=>(0,n.$Nf)(Z.key)?te?!1:Z.key===F:this.t(Z.key)?te?!1:F>=Z.key.start&&F<=Z.key.end:this.u(Z.key)?F===Z.key.port&&M===Z.key.host:O?Z.key.test(O):!1);return X>=0?X+J:-1}y(){const F=this.r.getValue(T.c);if(!F||!(0,n.$Lf)(F))return[];const M=[];for(const z in F){if(z===void 0)continue;const J=F[z];let te;if(Number(z))te=Number(z);else if((0,n.$Jf)(z))if(T.g.test(z)){const x=z.match(T.g);te={start:Number(x[1]),end:Number(x[2])}}else if(T.h.test(z)){const x=z.match(T.h);te={host:x[1],port:Number(x[2])}}else{let x;try{x=RegExp(z)}catch{}x&&(te=x)}te&&M.push({key:te,elevateIfNeeded:J.elevateIfNeeded,onAutoForward:J.onAutoForward,label:J.label,requireLocalPort:J.requireLocalPort,protocol:J.protocol})}const O=this.r.getValue(T.f);return O&&(this.m={elevateIfNeeded:O.elevateIfNeeded,label:O.label,onAutoForward:O.onAutoForward,requireLocalPort:O.requireLocalPort,protocol:O.protocol}),this.z(M)}z(F){function M(O,z){return(0,n.$Nf)(O.key)?O.key:z.t(O.key)?O.key.start:z.u(O.key)?O.key.port:Number.MAX_VALUE}return F.sort((O,z)=>M(O,this)-M(z,this))}C(){return this.m}static providedActionToAction(F){switch(F){case S.ProvidedOnAutoForward.Notify:return y.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case S.ProvidedOnAutoForward.Silent:return y.Silent;case S.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(F,M,O){const J=this.r.inspect(T.c).userRemoteValue;let te;!J||!(0,n.$Lf)(J)?te={}:te=(0,r.$yn)(J),te[`${F}`]||(te[`${F}`]={});for(const x in M)te[`${F}`][x]=M[x];return this.r.updateValue(T.c,te,O)}}e.$QK=T;let U=class extends p.$Tc{constructor(F,M,O,z,J,te,x,X,Z,ae){super(),this.H=F,this.I=M,this.J=O,this.L=z,this.M=J,this.N=te,this.O=x,this.P=X,this.Q=Z,this.R=ae,this.c=new Map,this.g=new P.$Wd,this.onForwardPort=this.g.event,this.h=new P.$Wd,this.onClosePort=this.h.event,this.j=new P.$Wd,this.onPortName=this.j.event,this.n=new P.$Wd,this.onCandidatesChanged=this.n.event,this.t=new P.$Wd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new P.$Wd,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new T(O),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async _=>{const ge=await this.getAttributes(_.map(ne=>({port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost})));for(const ne of _)if(ne.localAddress){const K=f(ne.tunnelRemoteHost,ne.tunnelRemotePort),W=$(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort);this.forwarded.set(K,{remotePort:ne.tunnelRemotePort,remoteHost:ne.tunnelRemoteHost,localAddress:ne.localAddress,protocol:ge?.get(ne.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,ge?.get(ne.tunnelRemotePort)),localPort:ne.tunnelLocalPort,runningProcess:W?.detail,hasRunningProcess:!!W,pid:W?.pid,privacy:ne.privacy,source:e.$KK}),this.f.set(K,ne)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async _=>{const ge=f(_.tunnelRemoteHost,_.tunnelRemotePort);if(!$(this.forwarded,_.tunnelRemoteHost,_.tunnelRemotePort)&&!$(this.detected,_.tunnelRemoteHost,_.tunnelRemotePort)&&!$(this.c,_.tunnelRemoteHost,_.tunnelRemotePort)&&_.localAddress){const ne=$(this.m??new Map,_.tunnelRemoteHost,_.tunnelRemotePort),K=(await this.getAttributes([{port:_.tunnelRemotePort,host:_.tunnelRemoteHost}]))?.get(_.tunnelRemotePort);this.forwarded.set(ge,{remoteHost:_.tunnelRemoteHost,remotePort:_.tunnelRemotePort,localAddress:_.localAddress,protocol:K?.protocol??S.TunnelProtocol.Http,localUri:await this.X(_.localAddress,K),localPort:_.tunnelLocalPort,closeable:!0,runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,privacy:_.privacy,source:e.$KK})}await this.cb(),this.f.set(ge,_),this.g.fire(this.forwarded.get(ge))})),this.B(this.H.onTunnelClosed(_=>this.W(_,u.Other))),this.U()}S(){return this.Q.extensions.find(F=>F.activationEvents?.includes(e.$HK))?(this.R.createKey(e.$IK.key,!0),!0):!1}U(){if(this.S())return;const F=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&F.dispose()}))}async W(F,M){const O=f(F.host,F.port);this.forwarded.has(O)&&(this.forwarded.delete(O),await this.cb(),this.h.fire(F))}X(F,M){if(F.startsWith("http"))return b.URI.parse(F);const O=M?.protocol??"http";return b.URI.parse(`${O}://${F}`)}async Y(F){const M=this.N.getWorkspace(),O=M.configuration?(0,A.$Vi)(M.configuration.path):M.folders.length>0?(0,A.$Vi)(M.folders[0].uri.path):void 0;if(O===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${F}.${this.L.remoteAuthority}.${O}`}async Z(){return this.Y(g)}async $(){return this.Y(o)}async ab(){const F=this.I.get(g,1);if(F)return this.I.remove(g,1),await this.cb(),F;const M=await this.Z();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const F=await this.s;if(F&&F!==this.y){const M=JSON.parse(F)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(O=>O.remotePort).join(", ")}`);for(const O of M){const z=$(this.detected,O.remoteHost,O.remotePort);O.source.source!==v.Extension&&!z||O.source.source===v.Extension&&z?await this.fb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,elevateIfNeeded:!0,source:O.source}):O.source.source===v.Extension&&!z&&this.D.set(f(O.remoteHost,O.remotePort),O)}}}if(this.z=!0,this.C.fire(),!this.w){const F=await this.Z();this.w=this.B(new p.$Sc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===F&&(this.s=Promise.resolve(this.I.get(F,0)),await this.restoreForwarded())}))}}bb(){const F=this.I.keys(0,0).filter(M=>M.startsWith(o));for(const M of F){const O=this.I.getNumber(M,0);if(O&&O<Date.now()){this.s=Promise.resolve(void 0);const z=M.replace(o,g);this.I.remove(M,0),this.I.remove(z,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const F=Array.from(this.forwarded.values()),M=F.map(te=>({remoteHost:te.remoteHost,remotePort:te.remotePort,localPort:te.localPort,name:te.name,localAddress:te.localAddress,localUri:te.localUri,protocol:te.protocol,source:te.source}));let O;F.length>0&&(O=JSON.stringify(M));const z=await this.Z(),J=await this.$();!O&&z&&J?(this.I.remove(z,0),this.I.remove(J,0)):O!==this.y&&z&&J&&(this.I.store(z,O,0,0),this.I.store(J,Date.now()+d,0,0)),this.y=O}}async eb(F,M,O){if(!F.tunnelLocalPort||!O?.requireLocalPort||F.tunnelLocalPort===M)return;const z=new Date;if(this.db.getTime()+t>z.getTime())return;this.db=z;const J=D.localize(3,null,M,F.tunnelRemotePort,F.tunnelLocalPort);return this.P.info(J)}async forward(F,M){return!this.z&&this.L.remoteAuthority&&await P.Event.toPromise(this.C.event),this.fb(F,M)}async fb(F,M){await this.Q.activateByEvent(e.$HK);const O=$(this.forwarded,F.remote.host,F.remote.port);M=M??(M!==null?(await this.getAttributes([F.remote]))?.get(F.remote.port):void 0);const z=F.local!==void 0?F.local:F.remote.port;let J;if(O)return this.hb(O,F,M);{const te=this.L.remoteAuthority,x=te?{getAddress:async()=>(await this.M.resolveAuthority(te)).authority}:void 0,X=f(F.remote.host,F.remote.port);this.c.set(X,!0),F=this.gb(X,F);const Z=await this.H.openTunnel(x,F.remote.host,F.remote.port,void 0,z,F.elevateIfNeeded?F.elevateIfNeeded:M?.elevateIfNeeded,F.privacy,M?.protocol);if(typeof Z=="string")J=Z;else if(Z&&Z.localAddress){const ae=$(this.m??new Map,F.remote.host,F.remote.port),_=Z.protocol?Z.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:M?.protocol??S.TunnelProtocol.Http,ge={remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localPort:Z.tunnelLocalPort,name:M?.label??F.name,closeable:!0,localAddress:Z.localAddress,protocol:_,localUri:await this.X(Z.localAddress,M),runningProcess:ae?.detail,hasRunningProcess:!!ae,pid:ae?.pid,source:F.source??e.$KK,privacy:Z.privacy};return this.forwarded.set(X,ge),this.f.set(X,Z),this.c.delete(X),await this.cb(),await this.eb(Z,z,M),this.g.fire(ge),Z}this.c.delete(X)}return J}gb(F,M){const O=this.D.has(F)?this.D:this.F.has(F)?this.F:void 0;if(O){const z=O.get(F);O.delete(F),z&&(M.name=z.name??M.name,M.local=("local"in z?z.local:"localPort"in z?z.localPort:void 0)??M.local,M.privacy=M.privacy)}return M}async hb(F,M,O){const z=O?.label??M.name;let J;(function(x){x[x.None=0]="None",x[x.Fire=1]="Fire",x[x.Reopen=2]="Reopen"})(J||(J={}));let te=J.None;switch(z!==F.name&&(F.name=z,te=J.Fire),(O?.protocol||F.protocol!==S.TunnelProtocol.Http)&&O?.protocol!==F.protocol&&(M.source=F.source,te=J.Reopen),M.privacy&&F.privacy!==M.privacy&&(te=J.Reopen),te){case J.Fire:{this.g.fire();break}case J.Reopen:await this.close(F.remoteHost,F.remotePort,u.User),await this.fb(M,O)}return $(this.f,M.remote.host,M.remote.port)}async name(F,M,O){const z=$(this.forwarded,F,M),J=f(F,M);if(z){z.name=O,await this.cb(),this.j.fire({host:F,port:M});return}else this.detected.has(J)&&(this.detected.get(J).name=O,this.j.fire({host:F,port:M}))}async close(F,M,O){const z=f(F,M),J=this.forwarded.get(z);return O===u.AutoForwardEnd&&J&&J.source.source===v.Auto&&this.F.set(z,{local:J.localPort,name:J.name,privacy:J.privacy}),await this.H.closeTunnel(F,M),this.W({host:F,port:M},O)}address(F,M){const O=f(F,M);return(this.forwarded.get(O)||this.detected.get(O))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(F){if(F)for(const M of F){const O=$(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),z=typeof M.localAddress=="string"?M.localAddress:f(M.localAddress.host,M.localAddress.port);this.detected.set(f(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:z,protocol:S.TunnelProtocol.Http,localUri:this.X(z),closeable:!1,runningProcess:O?.detail,hasRunningProcess:!!O,pid:O?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:v.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,z,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(F){this.r=F}async setCandidates(F){let M=F;this.r&&(M=await this.r(F));const O=this.ib(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(O.values()).map(z=>z.port).join(", ")}`),this.n.fire(O)}ib(F){const M=this.m??new Map,O=new Map;return this.m=O,F.forEach(z=>{const J=f(z.host,z.port);O.set(J,{host:z.host,port:z.port,detail:z.detail,pid:z.pid}),M.has(J)&&M.delete(J);const te=$(this.forwarded,z.host,z.port);te&&(te.runningProcess=z.detail,te.hasRunningProcess=!0,te.pid=z.pid)}),M.forEach((z,J)=>{const te=l(J);if(!te)return;const x=$(this.forwarded,te.host,te.port);x&&(x.runningProcess=void 0,x.hasRunningProcess=!1,x.pid=void 0);const X=$(this.detected,te.host,te.port);X&&(X.runningProcess=void 0,X.hasRunningProcess=!1,X.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const F=Array.from(this.forwarded.values()),M=await this.getAttributes(F.map(O=>({port:O.remotePort,host:O.remoteHost})),!1);if(M)for(const O of F){const z=M.get(O.remotePort);(z?.protocol||O.protocol!==S.TunnelProtocol.Http)&&z?.protocol!==O.protocol&&await this.fb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,source:O.source},z),z&&z.label&&z.label!==O.name&&await this.name(O.remoteHost,O.remotePort,z.label)}}async getAttributes(F,M=!0){const O=new Map,z=new Map;F.forEach(Z=>{const ae=$(this.m??new Map,S.$Gv[0],Z.port)??Z;if(ae){O.set(Z.port,ae);const _=L(ae)?ae.pid:void 0;z.has(_)||z.set(_,[]),z.get(_)?.push(Z.port)}});const J=new Map;if(F.forEach(Z=>{const ae=this.configPortsAttributes.getAttributes(Z.port,Z.host,O.get(Z.port)?.detail);ae&&J.set(Z.port,ae)}),this.G.length===0||!M)return J.size>0?J:void 0;const te=await Promise.all((0,N.$Rb)(this.G.map(Z=>Array.from(z.entries()).map(ae=>{const _=ae[1],ge=O.get(_[0]);return Z.providePortAttributes(_,ge?.pid,ge?.detail,new i.$7d().token)})))),x=new Map;if(te.forEach(Z=>Z.forEach(ae=>{ae&&x.set(ae.port,ae)})),!J&&!x)return;const X=new Map;return F.forEach(Z=>{const ae=J.get(Z.port),_=x.get(Z.port);X.set(Z.port,{elevateIfNeeded:ae?.elevateIfNeeded,label:ae?.label,onAutoForward:ae?.onAutoForward??T.providedActionToAction(_?.autoForwardAction),requireLocalPort:ae?.requireLocalPort,protocol:ae?.protocol})}),X}addAttributesProvider(F){this.G.push(F)}};e.$RK=U,Ge([(0,h.$Ah)(1e3)],U.prototype,"cb",null),e.$RK=U=Ge([Ve(0,S.$Cv),Ve(1,E.$wp),Ve(2,k.$Bi),Ve(3,m.$GK),Ve(4,w.$0k),Ve(5,c.$ei),Ve(6,C.$pj),Ve(7,R.$8v),Ve(8,a.$HF),Ve(9,s.$nj)],U)}),define(ke[95],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$zJ=e.$yJ=void 0;class D{constructor(A,p){this.line=A,this.character=p}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,p){return new D(0,0)}with(A){return new D(0,0)}}e.$yJ=D;class N{constructor(A,p,b,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(A,p),this.end=new D(b,k)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new N(0,0,0,0)}with(A){return new N(0,0,0,0)}}e.$zJ=N;var h;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(h||(e.TextSearchCompleteMessageType=h={}))}),define(ke[36],Se([1,0,19,35,24,34,12,5,17,14,95,8]),function($e,e,D,N,h,P,A,p,b,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.SearchErrorCode=e.$OJ=e.$NJ=e.SearchSortOrder=e.ViewMode=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.SearchCompletionExitCode=e.$IJ=e.$HJ=e.$GJ=e.QueryType=e.SearchProviderType=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$AJ="workbench.view.search",e.$BJ="workbench.panel.search",e.$CJ="workbench.view.search",e.$DJ="search-result",e.$EJ="search.exclude";const w="\u27EA ",E=" characters skipped \u27EB",S=(w.length+E.length+5)*2;e.$FJ=(0,p.$8h)("searchService");var c;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text"})(c||(e.SearchProviderType=c={}));var m;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text"})(m||(e.QueryType=m={}));function a(Z){return!!Z.preview}e.$GJ=a;function i(Z){return!!Z.resource}e.$HJ=i;function n(Z){return!!Z.message}e.$IJ=n;var r;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class s{constructor(ae){this.resource=ae,this.results=[]}}e.$JJ=s;class t{constructor(ae,_,ge,ne){this.ranges=_,this.webviewIndex=ne;const K=Array.isArray(_)?_:[_];if(ge&&ge.matchLines===1&&g(K)){ae=(0,A.$Cf)(ae,ge.matchLines);let W="",re=0,ye=0;const he=Math.floor(ge.charsPerLine/5),fe=[];for(const ue of K){const me=Math.max(ue.startColumn-he,0),V=ue.startColumn+ge.charsPerLine;if(me>ye+he+S){const Y=w+(me-ye)+E;W+=Y+ae.slice(me,V),re+=me-(ye+Y.length)}else W+=ae.slice(ye,V);fe.push(new d(0,ue.startColumn-re,ue.endColumn-re)),ye=V}this.preview={text:W,matches:Array.isArray(this.ranges)?fe:fe[0]}}else{const W=Array.isArray(_)?_[0].startLineNumber:_.startLineNumber;this.preview={text:ae,matches:(0,D.$2b)(_,re=>new o(re.startLineNumber-W,re.startColumn,re.endLineNumber-W,re.endColumn))}}}}e.$KJ=t;function g(Z){const ae=Z[0].startLineNumber;for(const _ of Z)if(_.startLineNumber!==ae||_.endLineNumber!==ae)return!1;return!0}class o{constructor(ae,_,ge,ne){this.startLineNumber=ae,this.startColumn=_,this.endLineNumber=ge,this.endColumn=ne}}e.$LJ=o;class d extends o{constructor(ae,_,ge){super(ae,_,ae,ge)}}e.$MJ=d;var l;(function(Z){Z.List="list",Z.Tree="tree"})(l||(e.ViewMode=l={}));var u;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(u||(e.SearchSortOrder=u={}));function v(Z,ae=!0){const _=Z&&Z.files&&Z.files.exclude,ge=ae&&Z&&Z.search&&Z.search.exclude;if(!_&&!ge)return;if(!_||!ge)return _||ge;let ne=Object.create(null);return ne=h.$Bn(ne,h.$yn(_)),ne=h.$Bn(ne,h.$yn(ge),!0),ne}e.$NJ=v;function I(Z,ae){return Z.excludePattern&&N.$Nj(Z.excludePattern,ae)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&N.$Nj(Z.includePattern,ae)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(_=>{const ge=_.folder.fsPath;if(P.$9f(ae,ge)){const ne=b.$lc(ge,ae);return!_.includePattern||!!N.$Nj(_.includePattern,ne)}else return!1}):!1:!0}e.$OJ=I;var $;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})($||(e.SearchErrorCode=$={}));class f extends Error{constructor(ae,_){super(ae),this.code=_}}e.$PJ=f;function y(Z){const ae=Z.message;if((0,k.$4)(Z))return new f(ae,$.canceled);try{const _=JSON.parse(ae);return new f(_.message,_.code)}catch{return new f(ae,$.other)}}e.$QJ=y;function L(Z){const ae={message:Z.message,code:Z.code};return new Error(JSON.stringify(ae))}e.$RJ=L;function T(Z){return Z.type==="error"?!0:Z.type==="success"}e.$SJ=T;function U(Z){return Z.type==="success"}e.$TJ=U;function j(Z){return!!Z.path}e.$UJ=j;function F(Z,ae){const _=Z.searchPath?Z.searchPath:Z.relativePath;return(0,A.$zf)(_,ae)}e.$VJ=F;class M{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$WJ=M;function O(Z,ae){const _={...Z||{},...ae||{}};return Object.keys(_).filter(ge=>{const ne=_[ge];return typeof ne=="boolean"&&ne})}e.$XJ=O;class z{constructor(ae,_){this.c=null,this.a={...ae.excludePattern||{},..._.excludePattern||{}},this.b=N.$Oj(this.a);let ge=ae.includePattern;_.includePattern&&(ge?ge={...ge,..._.includePattern}:ge=_.includePattern),ge&&(this.c=N.$Oj(ge))}matchesExcludesSync(ae,_,ge){return!!(this.b&&this.b(ae,_,ge))}includedInQuerySync(ae,_,ge){return!(this.b&&this.b(ae,_,ge)||this.c&&!this.c(ae,_,ge))}includedInQuery(ae,_,ge){const ne=this.b(ae,_,ge),K=()=>this.c?!!this.c(ae,_,ge):!0;return(0,C.$Tg)(ne)?ne.then(W=>W?!1:K()):K()}hasSiblingExcludeClauses(){return J(this.a)}}e.$YJ=z;function J(Z){for(const ae in Z)if(typeof Z[ae]!="boolean")return!0;return!1}function te(Z){if(!Z)return;let ae;return _=>(ae||(ae=(Z()||Promise.resolve([])).then(ge=>ge?X(ge):{})),ae.then(ge=>!!ge[_]))}e.$ZJ=te;function x(Z){if(!Z)return;let ae;return _=>{if(!ae){const ge=Z();ae=ge?X(ge):{}}return!!ae[_]}}e.$1J=x;function X(Z){const ae={};for(const _ of Z)ae[_]=!0;return ae}}),define(ke[41],Se([1,0,19,8,22,4,3,77,16,122,23,12,2,221,5,13,252,40,59,27,20,15,7,66,36,6,56]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i,n,r,s,t,g,o,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=e.$ggc=void 0;function u(U,j,F){return new R.$xg(M=>f(M,F)).isEqual(U,j)}function v(U,j,F){return u(U.uri,j.uri,F)?0:(0,C.$6e)(U.uri.toString(),j.uri.toString())}function I(U,j,F){return U.index!==j.index?U.index<j.index?-1:1:u(U.uri,j.uri,F)?(0,C.$6e)(U.name,j.name):(0,C.$6e)(U.uri.toString(),j.uri.toString())}function $(U,j,F,M){const O=U.slice(0).sort((J,te)=>F(J,te,M)),z=j.slice(0).sort((J,te)=>F(J,te,M));return(0,D.$Eb)(O,z,(J,te)=>F(J,te,M))}function f(U,j){const F=j.getCapabilities(U.scheme);return!(F&&F&1024)}class y extends a.$oi{static toExtHostWorkspace(j,F,M,O){if(!j)return{workspace:null,added:[],removed:[]};const{id:z,name:J,folders:te,configuration:x,transient:X,isUntitled:Z}=j,ae=[],_=F;F?te.forEach((W,re)=>{const ye=w.URI.revive(W.uri),he=y.o(M||F,ye,O);he?(he.name=W.name,he.index=W.index,ae.push(he)):ae.push({uri:ye,name:W.name,index:re})}):ae.push(...te.map(({uri:W,name:re,index:ye})=>({uri:w.URI.revive(W),name:re,index:ye}))),ae.sort((W,re)=>W.index<re.index?-1:1);const ge=new y(z,J,ae,!!X,x?w.URI.revive(x):null,!!Z,W=>f(W,O)),{added:ne,removed:K}=$(_?_.workspaceFolders:[],ge.workspaceFolders,v,O);return{workspace:ge,added:ne,removed:K}}static o(j,F,M){for(let O=0;O<j.folders.length;O++){const z=j.workspaceFolders[O];if(u(z.uri,F,M))return z}}constructor(j,F,M,O,z,J,te){super(j,M.map(x=>new a.$pi(x)),O,z,te),this.t=F,this.u=J,this.q=[],this.s=p.$bi.forUris(te),M.forEach(x=>{this.q.push(x),this.s.set(x.uri,x)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,F){return F&&this.s.get(j)&&(j=(0,R.$Hg)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let L=class{constructor(j,F,M,O,z){this.c=new P.$Wd,this.onDidChangeWorkspace=this.c.event,this.g=new P.$Wd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new P.$Yd,this.B=new Map,this.h=O,this.s=M,this.t=z,this.j=new k.$$l,this.k=new N.$7g,this.o=j.getProxy(d.$jL.MainThreadWorkspace),this.q=j.getProxy(d.$jL.MainThreadMessageService);const J=F.workspace;this.l=J?new y(J.id,J.name,[],!!J.transient,J.configuration?w.URI.revive(J.configuration):null,!!J.isUntitled,te=>f(te,M)):void 0}$initializeWorkspace(j,F){this.v=F,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?w.URI.from({scheme:b.Schemas.untitled,path:(0,R.$Fg)((0,R.$Hg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,F,M,...O){const z=[];if(Array.isArray(O)&&O.forEach(Z=>{w.URI.isUri(Z.uri)&&!z.some(ae=>u(ae.uri,Z.uri,this.s))&&z.push({uri:Z.uri,name:Z.name||(0,R.$Eg)(Z.uri)})}),this.n||[F,M].some(Z=>typeof Z!="number"||Z<0)||M===0&&z.length===0)return!1;const J=this.x?this.x.workspaceFolders:[];if(F+M>J.length)return!1;const te=J.slice(0);te.splice(F,M,...z.map(Z=>({uri:Z.uri,name:Z.name||(0,R.$Eg)(Z.uri),index:void 0})));for(let Z=0;Z<te.length;Z++){const ae=te[Z];if(te.some((_,ge)=>ge!==Z&&u(ae.uri,_.uri,this.s)))return!1}te.forEach((Z,ae)=>Z.index=ae);const{added:x,removed:X}=$(J,te,I,this.s);if(x.length===0&&X.length===0)return!1;if(this.o){const Z=j.displayName||j.name;this.o.$updateWorkspaceFolders(Z,F,M,z).then(void 0,ae=>{this.n=void 0;const _={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(m.Severity.Error,(0,E.localize)(0,null,Z,ae.toString()),_,[])})}return this.y(te),!0}getWorkspaceFolder(j,F){if(this.x)return this.x.getWorkspaceFolder(j,F)}async getWorkspaceFolder2(j,F){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,F)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,F){let M,O="";if(typeof j=="string"?(M=w.URI.file(j),O=j):typeof j<"u"&&(M=j,O=j.fsPath),!M)return O;const z=this.getWorkspaceFolder(M,!0);if(!z)return O;typeof F>"u"&&this.x&&(F=this.x.folders.length>1);let J=(0,R.$Kg)(z.uri,M);return F&&z.name&&(J=`${z.name}/${J}`),J}y(j){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:F,added:M,removed:O}=y.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=F||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:O}))}findFiles(j,F,M,O,z=h.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let J;if(F===null?J=!1:F&&(typeof F=="string"?J=F:J=F.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:te,folder:x}=T(s.GlobPattern.from(j));return this.o.$startFileSearch(te??null,x??null,J??null,M??null,z).then(X=>Array.isArray(X)?X.map(Z=>w.URI.revive(Z)):[])}async findTextInFiles(j,F,M,O,z=h.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const J=this.j.getNext(),te=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:x,folder:X}=T(s.GlobPattern.from(F.include)),Z=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,ae={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:te,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:x,excludePattern:Z},_=!1;if(this.u[J]=ge=>{if(_)return;const ne=w.URI.revive(ge.resource);ge.results.forEach(K=>{const W=(0,l.$Eh)(K);(0,o.$GJ)(W)?M({uri:ne,preview:{text:W.preview.text,matches:(0,D.$2b)(W.preview.matches,re=>new t.$nL(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))},ranges:(0,D.$2b)(W.ranges,re=>new t.$nL(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))}):M({uri:ne,text:W.text,lineNumber:W.lineNumber})})},z.isCancellationRequested)return{};try{const ge=await this.o.$startTextSearch(j,X??null,ae,J,z);return delete this.u[J],ge||{}}catch(ge){throw delete this.u[J],ge}}$handleTextSearchResult(j,F){this.u[F]?.(j)}async save(j){const F=await this.o.$save(j,{saveAs:!1});return w.URI.revive(F)}async saveAs(j){const F=await this.o.$save(j,{saveAs:!0});return w.URI.revive(F)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,F){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,F);const M=this.t.transformOutgoingScheme(j),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,M),(0,A.$Rc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(j,F){this.h.info("Getting edit session identifier for workspaceFolder",j);const M=await this.resolveWorkspaceFolder(w.URI.revive(j));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const O=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!O),!O)return;const z=await O.provideEditSessionIdentity(M,F);if(this.h.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(j,F,M,O){this.h.info("Getting edit session identifier for workspaceFolder",j);const z=await this.resolveWorkspaceFolder(w.URI.revive(j));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const J=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!J),!J)return;const te=await J.provideEditSessionIdentityMatch?.(F,M,O);if(this.h.info("Provider returned edit session identifier match result: ",te),!!te)return te}getOnWillCreateEditSessionIdentityEvent(j){return(F,M,O)=>{const z=function(te){F.call(M,te)};return z.extension=j,this.A.event(z,void 0,O)}}async $onWillCreateEditSessionIdentity(j,F,M){const O=await this.resolveWorkspaceFolder(w.URI.revive(j));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},F,async(z,J)=>{const te=Date.now();await Promise.resolve(z),Date.now()-te>M&&this.h.warn("SLOW edit session create-participant",J.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(j,F){if(this.B.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.B.set(j,F);const M=this.t.transformOutgoingScheme(j),O=this.z++;return this.o.$registerCanonicalUriProvider(O,M),(0,A.$Rc)(()=>{this.B.delete(j),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(j,F,M){const O=this.B.get(j.scheme);if(!O)return;const z=await O.provideCanonicalUri?.(w.URI.revive(j),F,M);if(z)return z}async $provideCanonicalUri(j,F,M){return this.provideCanonicalUri(w.URI.revive(j),{targetScheme:F},M)}};e.$ggc=L,e.$ggc=L=Ge([Ve(0,r.$oN),Ve(1,n.$EN),Ve(2,i.$Yfc),Ve(3,c.$pj),Ve(4,g.$egc)],L),e.$hgc=(0,S.$8h)("IExtHostWorkspace");function T(U){let j,F;return U&&(typeof U=="string"?j=U:(j=U.pattern,F=w.URI.revive(U.baseUri))),{includePattern:j,folder:F}}}),define(ke[42],Se([1,0,24,4,41,6,7,254,87,18,8,5,20,13,2]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=e.$jgc=e.$igc=void 0;function c(g,o){if(o){const d=o.split(".");let l=g;for(let u=0;l&&u<d.length;u++)l=l[d[u]];return l}}function m(g){return g instanceof S.URI}function a(g){return g&&g.uri instanceof S.URI&&g.languageId&&typeof g.languageId=="string"}function i(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function n(g){return g&&g.uri instanceof S.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function r(g){if(m(g))return{resource:g};if(a(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(i(g))return{overrideIdentifier:g.languageId};if(n(g))return{resource:g.uri};if(g===null)return{resource:null}}let s=class{constructor(o,d,l){this.a=o.getProxy(P.$jL.MainThreadConfiguration),this.c=d,this.b=l,this.d=new R.$7g,this.e=null}getConfigProvider(){return this.d.wait().then(o=>this.e)}$initializeConfiguration(o){this.e=new t(this.a,this.c,o,this.b),this.d.open()}$acceptConfigurationChanged(o,d){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(o,d))}};e.$igc=s,e.$igc=s=Ge([Ve(0,w.$oN),Ve(1,h.$hgc),Ve(2,E.$pj)],s);class t{constructor(o,d,l,u){this.a=new N.$Wd,this.b=o,this.f=u,this.c=d,this.e=p.$9n.parse(l),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(o,d){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$9n.parse(o),this.d=this.k(o.configurationScopes),this.a.fire(this.j(d,l))}getConfiguration(o,d,l){const u=r(d)||{},v=this.g(o?c(this.e.getValue(void 0,u,this.c.workspace),o):this.e.getValue(void 0,u,this.c.workspace));o&&this.h(o,u,l?.identifier);function I(f){if(f==null)return null;if(typeof f=="boolean")return f?2:5;switch(f){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const $={has(f){return typeof c(v,f)<"u"},get:(f,y)=>{this.h(o?`${o}.${f}`:f,u,l?.identifier);let L=c(v,f);if(typeof L>"u")L=y;else{let T;const U=(j,F)=>{if((0,k.$Lf)(j)){let M;const O=()=>{T=T||(0,D.$yn)(v),M=M||c(T,F)};return new Proxy(j,{get:(z,J)=>{if(typeof J=="string"&&J.toLowerCase()==="tojson")return O(),()=>M;if(T)return M=M||c(T,F),M[J];const te=z[J];return typeof J=="string"?U(te,`${F}.${J}`):te},set:(z,J,te)=>(O(),M&&(M[J]=te),!0),deleteProperty:(z,J)=>(O(),M&&delete M[J],!0),defineProperty:(z,J,te)=>(O(),M&&Object.defineProperty(M,J,te),!0)})}return Array.isArray(j)?(0,D.$yn)(j):j};L=U(L,f)}return L},update:(f,y,L,T)=>{f=o?`${o}.${f}`:f;const U=I(L);return y!==void 0?this.b.$updateConfigurationOption(U,f,y,u,T):this.b.$removeConfigurationOption(U,f,u,T)},inspect:f=>{f=o?`${o}.${f}`:f;const y=this.e.inspect(f,u,this.c.workspace);if(y)return{key:f,defaultValue:(0,D.$yn)(y.policy?.value??y.default?.value),globalValue:(0,D.$yn)(y.user?.value??y.application?.value),workspaceValue:(0,D.$yn)(y.workspace?.value),workspaceFolderValue:(0,D.$yn)(y.workspaceFolder?.value),defaultLanguageValue:(0,D.$yn)(y.default?.override),globalLanguageValue:(0,D.$yn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,D.$yn)(y.workspace?.override),workspaceFolderLanguageValue:(0,D.$yn)(y.workspaceFolder?.override),languageIds:(0,D.$yn)(y.overrideIdentifiers)}}};return typeof v=="object"&&(0,D.$Bn)($,v,!1),Object.freeze($)}g(o){const d=l=>(0,k.$Lf)(l)?new Proxy(l,{get:(u,v)=>d(u[v]),set:(u,v,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(u,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(u,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return d(o)}h(o,d,l){const u=b.$Zn.test(o)?4:this.d.get(o),v=l?`[${l.value}] `:"";if(u===4){typeof d?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){d?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(o,d){const l=new p.$$n(o,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,v)=>l.affectsConfiguration(u,r(v))})}k(o){return o.reduce((d,l)=>(d.set(l[0],l[1]),d),new Map)}}e.$jgc=t,e.$kgc=(0,C.$8h)("IExtHostConfiguration")}),define(ke[96],Se([1,0,2,8,4,6,7,41,72,42,22,46,20,27,5,16,11,13,92,296,14]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=e.$Mhc=e.$Lhc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(U){function j(M){if(M!=null)return M}U.from=j;function F(M){if(M!=null)return M}U.to=F})(s||(s={}));var t;(function(U){function j(M){if(M!=null)return M}U.from=j;function F(M){if(M!=null)return M}U.to=F})(t||(t={}));var g;(function(U){function j(M){if(M!=null)return M}U.from=j;function F(M){if(M!=null)return M}U.to=F})(g||(g={}));var o;(function(U){function j(O){if(O){const z=O;return z&&!!z.process}else return!1}U.is=j;function F(O){if(O==null)return;const z={process:O.process,args:O.args};return O.options&&(z.options=g.from(O.options)),z}U.from=F;function M(O){if(O!=null)return new A.$7L(O.process,O.args,O.options)}U.to=M})(o||(o={}));var d;(function(U){function j(M){if(M!=null)return M}U.from=j;function F(M){if(M!=null)return M}U.to=F})(d||(d={}));var l;(function(U){function j(O){if(O){const z=O;return z&&(!!z.commandLine||!!z.command)}else return!1}U.is=j;function F(O){if(O==null)return;const z={};return O.commandLine!==void 0?z.commandLine=O.commandLine:(z.command=O.command,z.args=O.args),O.options&&(z.options=d.from(O.options)),z}U.from=F;function M(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new A.$8L(O.commandLine,O.options):new A.$8L(O.command,O.args?O.args:[],O.options)}U.to=M})(l||(l={}));var u;(function(U){function j(O){if(O){const z=O;return z&&z.customExecution==="customExecution"}else return!1}U.is=j;function F(O){return{customExecution:"customExecution"}}U.from=F;function M(O,z){return z.get(O)}U.to=M})(u||(e.CustomExecutionDTO=u={}));var v;(function(U){function j(F,M){let O;return F.scope!==void 0&&typeof F.scope!="number"?O=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===A.TaskScope.Workspace&&M&&M.workspaceFile?O=M.workspaceFile:O=n.$DG),{id:F._id,workspaceFolder:O}}U.from=j})(v||(e.TaskHandleDTO=v={}));var I;(function(U){function j(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}U.from=j})(I||(I={}));var $;(function(U){function j(O,z){if(O==null)return[];const J=[];for(const te of O){const x=F(te,z);x&&J.push(x)}return J}U.fromMany=j;function F(O,z){if(O==null)return;let J;O.execution instanceof A.$7L?J=o.from(O.execution):O.execution instanceof A.$8L?J=l.from(O.execution):O.execution&&O.execution instanceof A.$9L&&(J=u.from(O.execution));const te=s.from(O.definition);let x;return O.scope?typeof O.scope=="number"?x=O.scope:x=O.scope.uri:x=A.TaskScope.Workspace,!te||!x?void 0:{_id:O._id,definition:te,name:O.name,source:{extensionId:z.identifier.value,label:O.source,scope:x},execution:J,isBackground:O.isBackground,group:I.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}U.from=F;async function M(O,z,J){if(O==null)return;let te;o.is(O.execution)?te=o.to(O.execution):l.is(O.execution)?te=l.to(O.execution):u.is(O.execution)&&(te=u.to(O._id,J));const x=s.to(O.definition);let X;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?X=O.source.scope:X=await z.resolveWorkspaceFolder(D.URI.revive(O.source.scope)):X=A.TaskScope.Workspace),!x||!X)return;const Z=new A.$0L(x,X,O.name,O.source.label,te,O.problemMatchers);return O.isBackground!==void 0&&(Z.isBackground=O.isBackground),O.group!==void 0&&(Z.group=A.$6L.from(O.group._id),Z.group&&O.group.isDefault&&(Z.group=new A.$6L(Z.group.id,Z.group.label),O.group.isDefault===!0&&(Z.group.isDefault=O.group.isDefault))),O.presentationOptions&&(Z.presentationOptions=t.to(O.presentationOptions)),O._id&&(Z._id=O._id),O.detail&&(Z.detail=O.detail),Z}U.to=M})($||(e.TaskDTO=$={}));var f;(function(U){function j(M){return M}U.from=j;function F(M){if(M)return Object.assign(Object.create(null),M)}U.to=F})(f||(f={}));class y{#e;constructor(j,F,M){this._id=F,this.a=M,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let L=class{constructor(j,F,M,O,z,J,te,x){this.q=new h.$Wd,this.r=new h.$Wd,this.s=new h.$Wd,this.u=new h.$Wd,this.a=j.getProxy(P.$jL.MainThreadTask),this.b=M,this.c=O,this.d=z,this.e=J,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=te,this.g=x,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,F,M){if(!M)return new A.$lL(()=>{});const O=this.x();return this.j.set(O,{type:F,provider:M,extension:j}),this.a.$registerTaskProvider(O,F),new A.$lL(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(j,F){this.a.$registerTaskSystem(j,F)}fetchTasks(j){return this.a.$fetchTasks(f.from(j)).then(async F=>{const M=[];for(const O of F){const z=await $.to(O,this.b,this.m);z&&M.push(z)}return M})}get taskExecutions(){const j=[];return this.k.forEach(F=>j.push(F)),j}terminateTask(j){if(!(j instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,F,M){const O=this.m.get(j.id);O&&(this.o.set(j.id,O),this.e.attachPtyToTerminal(F,await O.callback(M))),this.p=j.id,this.q.fire({execution:await this.z(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){if(!this.l.has(j.id))return;const F=await this.z(j);this.l.delete(j.id),this.k.delete(j.id),this.B(j),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const F=await this.z(j.id);this.s.fire({execution:F,processId:j.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(j){const F=await this.z(j.id);this.u.fire({execution:F,exitCode:j.exitCode})}$provideTasks(j,F){const M=this.j.get(j);if(!M)return Promise.reject(new Error("no handler found"));const O=[],z=(0,N.$Zg)(()=>M.provider.provideTasks(R.CancellationToken.None)).then(J=>this.v(F,O,M,J));return new Promise(J=>{z.then(te=>{Promise.all(O).then(()=>{J(te)})})})}async $resolveTask(j,F){const M=this.j.get(j);if(!M)return Promise.reject(new Error("no handler found"));if(F.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${M.type}].`);const O=await $.to(F,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const z=await M.provider.resolveTask(O,R.CancellationToken.None);if(!z)return;this.A(z,M);const J=$.from(z,M.extension);if(!J)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return u.is(J.execution)&&await this.y(J,z,!0),await this.w(J)}x(){return this.h++}async y(j,F,M){const O=await this.a.$createTaskId(j);!M&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,F.execution)),this.m.set(O,F.execution)}async z(j,F){if(typeof j=="string"){const z=this.l.get(j);if(!z)throw new r.$bb("Unexpected: The specified task is missing an execution");return z}const M=this.l.get(j.id);if(M)return M;let O;return F?O=Promise.resolve(new y(this,j.id,F)):O=$.to(j.task,this.b,this.m).then(z=>{if(!z)throw new r.$bb("Unexpected: Task does not exist.");return new y(this,j.id,z)}),this.l.set(j.id,O),O.then(z=>(this.k.set(j.id,z),z))}A(j,F){j._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}B(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const M=this.n.values();let O=M.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=M.next()}};e.$Lhc=L,e.$Lhc=L=Ge([Ve(0,w.$oN),Ve(1,E.$EN),Ve(2,p.$hgc),Ve(3,b.$zN),Ve(4,k.$kgc),Ve(5,C.$Igc),Ve(6,a.$pj),Ve(7,i.$2fc)],L);let T=class extends L{constructor(j,F,M,O,z,J,te,x){super(j,F,M,O,z,J,te,x),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:m.$h(0)})}async executeTask(j,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const M=$.from(F,j);if(M===void 0)throw new Error("Task is not valid");if(u.is(M.execution))await this.y(M,F,!1);else throw new r.$_;const O=await this.z(await this.a.$getTaskExecution(M),F);return this.a.$executeTask(M).catch(z=>{throw new Error(z)}),O}v(j,F,M,O){const z=[];if(O)for(const J of O){if(this.A(J,M),!J.definition||!j[J.definition.type]){const x=J.source?J.source:"No task source";this.f.warn(`The task [${x}, ${J.name}] uses an undefined task type. The task will be ignored in the future.`)}const te=$.from(J,M.extension);te&&u.is(te.execution)?(z.push(te),F.push(this.y(te,J,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:z,extension:M.extension}}async w(j){if(u.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,F,M){}};e.$Mhc=T,e.$Mhc=T=Ge([Ve(0,w.$oN),Ve(1,E.$EN),Ve(2,p.$hgc),Ve(3,b.$zN),Ve(4,k.$kgc),Ve(5,C.$Igc),Ve(6,a.$pj),Ve(7,i.$2fc)],T),e.$Nhc=(0,S.$8h)("IExtHostTask")}),define(ke[360],Se([1,0,36,29]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9J=e.$8J=e.$7J=void 0;function h(A){return"cellResults"in A}e.$7J=h,e.$8J="rawCell#";function P(A,p){let b=-1;const k=[];let R=[];return A.forEach(w=>{w.range.startLineNumber!==b&&R.length>0&&(k.push([...R]),R=[]),R.push(w),b=w.range.endLineNumber}),R.length>0&&k.push([...R]),k.map(w=>{const E=[],S=w[0].range.startLineNumber,c=w[w.length-1].range.endLineNumber;for(let m=S;m<=c;m++)E.push(p.getLineContent(m));return new D.$KJ(E.join(`
`)+`
`,w.map(m=>new N.$Ws(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}e.$9J=P}),define(ke[361],Se([1,0,215,21,4,3,28,12,18,2,32,110,6,33,15,7,68,331,149,24,16,286,360,357]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i,n,r,s,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=void 0;class o{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(l=>l.apiEditor)}constructor(l,u,v,I,$,f){this.q=v,this.r=I,this.s=$,this.t=f,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new h.$Wd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new h.$Wd,this.onDidOpenNotebookDocument=this.m.event,this.n=new h.$Wd,this.onDidCloseNotebookDocument=this.n.event,this.o=new h.$Wd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$Ufc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=l.getProxy(w.$jL.MainThreadNotebook),this.c=l.getProxy(w.$jL.MainThreadNotebookDocuments),this.d=l.getProxy(w.$jL.MainThreadNotebookEditors),this.i=u.converter,u.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const L=y.notebookEditor?.notebookUri,T=y.cell.handle,j=this.g.get(L)?.getCell(T);if(j)return j.apiCell}if(y&&y.$mid===14){const L=y.uri,T=this.g.get(L);if(T)return T.apiNotebook}return y}}),o.B(u)}getEditorById(l){const u=this.h.get(l);if(!u)throw new Error(`unknown text editor: ${l}. known editors: ${[...this.h.keys()]} `);return u}getIdByEditor(l){for(const[u,v]of this.h)if(v.apiEditor===l)return u}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(l,u){const v=this.g.get(l);if(!v&&!u)throw new Error(`NO notebook document for '${l}'`);return v}static u(l,u){if(!u)return;const v=u.filenamePattern.map(I=>S.NotebookExclusiveDocumentPattern.from(I)).filter(I=>I!==void 0);if(u.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:u.displayName,filenamePattern:v,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,u,v){const I=o.a++,$=typeof v.onDidChangeCellStatusBarItems=="function"?o.a++:void 0;this.f.set(I,v),this.b.$registerNotebookCellStatusBarItemProvider(I,$,u);let f;return $!==void 0&&(f=v.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent($))),new c.$lL(()=>{this.f.delete(I),this.b.$unregisterNotebookCellStatusBarItemProvider(I,$),f?.dispose()})}async createNotebookDocument(l){const u=await this.c.$tryCreateNotebook({viewType:l.viewType,content:l.content&&S.NotebookData.from(l.content)});return k.URI.revive(u)}async openNotebookDocument(l){const u=this.g.get(l);if(u)return u.apiNotebook;const v=await this.c.$tryOpenNotebook(l),I=this.g.get(k.URI.revive(v));return(0,b.$Uf)(I?.apiNotebook)}async showNotebookDocument(l,u){k.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let v;typeof u=="object"?v={position:S.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(S.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:v={preserveFocus:!1};const I=await this.d.$tryShowNotebookDocument(l.uri,l.notebookType,v),$=I&&this.h.get(I)?.apiEditor;if($)return $;throw I?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,u,v,I){const $=this.f.get(l),f=k.URI.revive(u),y=this.g.get(f);if(!y||!$)return;const L=y.getCellFromIndex(v);if(!L)return;const T=await $.provideCellStatusBarItems(L.apiCell,I);if(!T)return;const U=new P.$Sc,j=this.p.add([U]),M=(Array.isArray(T)?T:[T]).map(O=>S.NotebookStatusBarItem.from(O,this.i,U));return{cacheId:j,items:M}}$releaseNotebookCellStatusBarItems(l){this.p.delete(l)}registerNotebookSerializer(l,u,v,I,$){if((0,p.$Ke)(u))throw new Error("viewType cannot be empty or just whitespace");const f=this.w++;return this.x.set(f,{viewType:u,serializer:v,options:I}),this.b.$registerNotebookSerializer(f,{id:l.identifier,location:l.extensionLocation},u,S.NotebookDocumentContentOptions.from(I),o.u(l,$)),(0,P.$Rc)(()=>{this.b.$unregisterNotebookSerializer(f)})}async $dataToNotebook(l,u,v){const I=this.x.get(l);if(!I)throw new Error("NO serializer found");const $=await I.serializer.deserializeNotebook(u.buffer,v);return new m.$Vv(S.NotebookData.from($))}async $notebookToData(l,u,v){const I=this.x.get(l);if(!I)throw new Error("NO serializer found");const $=await I.serializer.serializeNotebook(S.NotebookData.to(u.value),v);return N.$ke.wrap($)}async $saveNotebook(l,u,v,I,$){const f=k.URI.revive(u),y=this.x.get(l);if(!y)throw new Error("NO serializer found");const L=this.g.get(f);if(!L)throw new Error("Document NOT found");if(L.versionId!==v)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(f.scheme))throw new R.$Nk((0,D.localize)(0,null,this.z(f)),6);await this.y(f,I);const T={metadata:(0,n.$Gn)(L.apiNotebook.metadata,O=>!(y.options?.transientDocumentMetadata??{})[O]),cells:[]};for(const O of L.apiNotebook.getCells()){const z=new c.$LM(O.kind,O.document.getText(),O.document.languageId,O.mime,y.options?.transientOutputs?[]:[...O.outputs],O.metadata,O.executionSummary);z.metadata=(0,n.$Gn)(O.metadata,J=>!(y.options?.transientCellMetadata??{})[J]),T.cells.push(z)}const U=await y.serializer.serializeNotebook(T,$);await this.s.value.writeFile(f,U);const j=this.s.getFileSystemProviderExtUri(f.scheme),F=await this.s.value.stat(f);return{name:j.basename(f),isFile:(F.type&R.FileType.File)!==0,isDirectory:(F.type&R.FileType.Directory)!==0,isSymbolicLink:(F.type&R.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(f.scheme),locked:!!((F.permissions??0)&R.FilePermission.Locked),etag:R.$Yk({mtime:F.mtime,size:F.size}),children:void 0}}async $searchInNotebooks(l,u,v,I,$){const f=this.x.get(l)?.serializer;if(!f)return{limitHit:!1,results:[]};const y=new A.$Bc;await(async(F,M,O)=>{await Promise.all(F.map(async z=>await Promise.all(z.filenamePatterns.map(J=>{const te={_reason:O._reason,folderQueries:O.folderQueries,includePattern:O.includePattern,excludePattern:O.excludePattern,maxResults:O.maxResults,type:1,filePattern:J};return this.t.doInternalFileSearchWithCustomCallback(te,M,x=>{x.forEach(X=>{y.has(X)||I.some(ae=>z.isFromSettings&&!ae.isFromSettings?!1:ae.filenamePatterns.some(_=>(0,g.$Ddb)(_,X)))||y.add(X)})})}))))})(v,$,u);const T=new A.$Ac;let U=!1;const j=Array.from(y).map(async F=>{const M=[];try{if($.isCancellationRequested)return;if(u.maxResults&&[...T.values()].reduce((te,x)=>te+x.cellResults.length,0)>u.maxResults){U=!0;return}const O=[],z=this.g.get(F);if(z)z.apiNotebook.getCells().forEach(x=>O.push({input:x.document.getText(),outputs:x.outputs.flatMap(X=>X.items.map(Z=>Z.data.toString()))}));else{const te=await this.s.value.readFile(F),x=N.$ke.fromString(te.toString()),X=await f.deserializeNotebook(x.buffer,$);if($.isCancellationRequested)return;S.NotebookData.from(X).cells.forEach(ae=>O.push({input:ae.source,outputs:ae.outputs.flatMap(_=>_.items.map(ge=>ge.valueBytes.toString()))}))}if($.isCancellationRequested)return;O.forEach((te,x)=>{const X=u.contentPattern.pattern,Z=new s.$BRb(te.input,void 0,te.outputs),ae=Z.findInInputs(X),_=Z.findInOutputs(X),ge=_.flatMap(ne=>(0,t.$9J)(ne.matches,ne.textBuffer)).map((ne,K)=>(ne.webviewIndex=K,ne));if(ae.length>0||_.length>0){const ne={index:x,contentResults:(0,t.$9J)(ae,Z.inputTextBuffer),webviewResults:ge};M.push(ne)}});const J={resource:F,cellResults:M};T.set(F,J);return}catch{return}});return await Promise.all(j),{limitHit:U,results:[...T.values()]}}async y(l,u){const v=await this.s.value.stat(l);if(typeof u?.mtime=="number"&&typeof u.etag=="string"&&u.etag!==R.$Xk&&typeof v.mtime=="number"&&typeof v.size=="number"&&u.mtime<v.mtime&&u.etag!==R.$Yk({mtime:u.mtime,size:v.size}))throw new R.$Nk((0,D.localize)(1,null),3,u)}z(l){return l.scheme===r.Schemas.file?l.fsPath:l.toString()}A(l,u,v){if(this.h.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const I=new i.$ehc(u,this.d,l,v.visibleRanges.map(S.NotebookRange.to),v.selections.map(S.NotebookRange.to),typeof v.viewColumn=="number"?S.ViewColumn.to(v.viewColumn):void 0);this.h.set(u,I)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const v of l.value.removedDocuments){const I=k.URI.revive(v),$=this.g.get(I);$&&($.dispose(),this.g.delete(I),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:$.apiNotebook.getCells().map(f=>f.document.uri)}),this.n.fire($.apiNotebook));for(const f of this.h.values())f.notebookData.uri.toString()===I.toString()&&this.h.delete(f.id)}if(l.value.addedDocuments){const v=[];for(const I of l.value.addedDocuments){const $=k.URI.revive(I.uri);if(this.g.has($))throw new Error(`adding EXISTING notebook ${$} `);const f=new a.$dhc(this.c,this.q,this.r,$,I);v.push(...I.cells.map(y=>a.$chc.asModelAddData(f.apiNotebook,y))),this.g.get($)?.dispose(),this.g.set($,f),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(f.apiNotebook)}}if(l.value.addedEditors)for(const v of l.value.addedEditors){if(this.h.has(v.id))return;const I=k.URI.revive(v.documentUri),$=this.g.get(I);$&&this.A($,v.id,v)}const u=[];if(l.value.removedEditors)for(const v of l.value.removedEditors){const I=this.h.get(v);I&&(this.h.delete(v),this.k?.id===I.id&&(this.k=void 0),u.push(I))}if(l.value.visibleEditors){this.l=l.value.visibleEditors.map(I=>this.h.get(I)).filter(I=>!!I);const v=new Set;this.l.forEach(I=>v.add(I.id));for(const I of this.h.values()){const $=v.has(I.id);I._acceptVisibility($)}this.l=[...this.h.values()].map(I=>I).filter(I=>I.visible),this.o.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this.k=void 0:l.value.newActiveEditor&&(this.h.get(l.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${l.value.newActiveEditor}`),this.k=this.h.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(l){const u=E.$MN.String.with("notebookType","A notebook type"),v=new E.$ON("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[u,new E.$MN("data","Bytes to convert to data",$=>$ instanceof Uint8Array,$=>N.$ke.wrap($))],new E.$NN("Notebook Data",$=>S.NotebookData.to($.value))),I=new E.$ON("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[u,new E.$MN("NotebookData","Notebook data to convert to bytes",$=>!0,$=>new m.$Vv(S.NotebookData.from($)))],new E.$NN("Bytes",$=>$.buffer));l.registerApiCommand(v),l.registerApiCommand(I)}}e.$nhc=o}),define(ke[362],Se([1,0,17,22,44,35,23,38,36]),function($e,e,D,N,h,P,A,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;class k{constructor(w,E,S){this.k=w,this.l=E,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=w.filePattern,this.b=w.includePattern&&P.$Oj(w.includePattern),this.c=w.maxResults||void 0,this.d=w.exists,this.h=new Set,this.j=w.excludePattern&&P.$Oj(w.excludePattern)}cancel(){this.g=!0,this.h.forEach(w=>w.cancel()),this.h=new Set}search(w){const E=this.k.folderQueries||[];return new Promise((S,c)=>{const m=a=>{this.f++,w(a)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const i=a.toString(),n=D.$nc(i);this.j&&this.j(i,n)||this.v(m,{base:a,basename:n})}),Promise.all(E.map(a=>this.p(a,m))).then(a=>{S({limitHit:this.e,stats:a[0]||void 0})},a=>{c(new Error((0,h.$Si)(a)))})})}async p(w,E){const S=new N.$7d,c=this.q(w),m=this.r(),a=new b.$YJ(this.k,w),i=!a.hasSiblingExcludeClauses();let n;try{this.h.add(S),n=p.$Sd.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},c,S.token),s=n.elapsed(),t=p.$Sd.create();return this.g&&!this.e||(r&&r.forEach(g=>{const o=D.$gc.relative(w.folder.path,g.path);if(i){const d=D.$nc(g.path);this.v(E,{base:w.folder,relativePath:o,basename:d});return}this.s(m,w.folder,o,E)}),this.g&&!this.e)?null:(this.u(m,a,E),{providerTime:s,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(w){const E=(0,b.$XJ)(this.k.includePattern,w.includePattern),S=(0,b.$XJ)(this.k.excludePattern,w.excludePattern);return{folder:w.folder,excludes:S,includes:E,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}s({pathToEntries:w},E,S,c){if(S===this.a){const a=D.$nc(this.a);this.v(c,{base:E,relativePath:this.a,basename:a})}function m(a){const i=D.$nc(a),n=D.$mc(a);let r=w[n];r||(r=w[n]=[],m(n)),r.push({base:E,relativePath:a,basename:i})}m(S)}u({rootEntries:w,pathToEntries:E},S,c){const m=this,a=this.a;function i(n){const r=(0,b.$1J)(()=>n.map(s=>s.basename));for(let s=0,t=n.length;s<t;s++){const g=n[s],{relativePath:o,basename:d}=g;if(S.matchesExcludesSync(o,d,a!==d?r:void 0))continue;const l=E[o];if(l)i(l);else{if(o===a)continue;m.v(c,g)}if(m.e)break}}i(w)}v(w,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||w(E))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(w,E,S,c){const m=this.c(w.cacheKey),a=new k(w,E,m&&m.token);let i=0;const n=r=>{i+=r.length,S(r.map(s=>this.d(s)))};return this.e(a,R.a,n,c).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:r.stats}}))}clearCache(w){this.c(w)?.cancel()}c(w){if(w)return this.b.has(w)||this.b.set(w,new N.$7d),this.b.get(w)}d(w){return w.relativePath?{resource:A.$Ig(w.base,w.relativePath)}:{resource:w.base}}e(w,E,S,c){const m=c.onCancellationRequested(()=>{w.cancel()}),a=n=>{n&&(i.push(n),E>0&&i.length>=E&&(S(i),i=[]))};let i=[];return w.search(a).then(n=>(i.length&&S(i),m.dispose(),n),n=>(i.length&&S(i),m.dispose(),Promise.reject(n)))}}e.$fhc=R}),define(ke[363],Se([1,0,19,73,35,103,28,16,17,23,12,18,2,100,235,51,13,40,142,358,36]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1K=e.$ZK=void 0;let s=class{constructor(f,y,L,T,U){this.a=f,this.b=y,this.c=L,this.d=T,this.e=U}text(f,y,L={}){f=this.f(f,L);const T=this.a.getValue(),U=y&&y.some(F=>!this.a.getValue({resource:F}).search.useRipgrep);return{...this.h(y?.map(a.$qi),L),type:2,contentPattern:f,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:T.search.usePCRE2||U||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(f,y){const L=this.a.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const T={...f,wordSeparators:L.editor.wordSeparators};return this.j(f,y)&&(T.isCaseSensitive=!0),this.k(f)&&(T.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),T}file(f,y={}){return{...this.h(f,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}g(f,y){return f?(f=Array.isArray(f)?f.map(l):l(f),y?this.parseSearchPaths(f):{pattern:g(...Array.isArray(f)?f:[f])}):{}}h(f=[],y={}){const L=this.g(y.includePattern,y.expandPatterns),T=this.g(y.excludePattern,y.expandPatterns),U=f.length>1,j=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(O=>this.q(O,y,T)):f.map(O=>this.r(O,y,T,U))).filter(O=>!!O),F={_reason:y._reason,folderQueries:j,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:T.pattern,includePattern:L.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const O=D.$Hb(D.$Rb(this.c.groups.map(te=>te.editors.map(x=>x.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const z=O.filter(te=>(0,r.$OJ)(F,te.fsPath)),J=this.i(z);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(J)),{...F,...J}}const M=y.extraFileResources&&y.extraFileResources.filter(O=>(0,r.$OJ)(F,O.fsPath));return F.extraFileResources=M&&M.length?M:void 0,F}i(f){const y=[],L=new A.$Ac,T={};let U=!1;return f.forEach(j=>{if(j.scheme===p.Schemas.walkThrough)return;if((0,k.$Mg)(j)){const M=this.b.getWorkspaceFolder(j)?.uri??j.with({path:b.$mc(j.fsPath)});let O=L.get(M);O||(U=!0,O={folder:M,includePattern:{}},y.push(O),L.set(M,O));const z=b.$lc(M.fsPath,j.fsPath);(0,C.$Uf)(O.includePattern)[z.replace(/\\/g,"/")]=!0}else j.fsPath&&(U=!0,T[j.fsPath]=!0)}),{folderQueries:y,includePattern:T,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}j(f,y){if(y.isSmartCase){if(f.isRegExp){if(R.$Af(f.pattern,!0))return!0}else if(R.$Af(f.pattern))return!0}return!!f.isCaseSensitive}k(f){return f.isMultiline||f.isRegExp&&(0,E.$6B)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const y=J=>b.$ic(J)||/^\.\.?([\/\\]|$)/.test(J),T=(Array.isArray(f)?f:o(f)).map(J=>{const te=this.e.resolvedUserHome;return te?(0,P.$1v)(J,te.scheme===p.Schemas.file?te.fsPath:te.path):J}),U=N.$K(T,J=>y(J)?"searchPaths":"exprSegments"),j=(U.exprSegments||[]).map(J=>R.$Ve(J,"/")).map(J=>R.$Ve(J,"\\")).map(J=>(J[0]==="."&&(J="*"+J),d(J))),F={},M=this.m(U.searchPaths||[]);M&&M.length&&(F.searchPaths=M);const O=D.$Rb(j),z=g(...O);return z&&(F.pattern=z),F}l(f,y){return y.disregardExcludeSettings?void 0:(0,r.$NJ)(f,!y.disregardSearchExcludeSettings)}m(f){if(!f||!f.length)return[];const y=f.flatMap(T=>{let{pathPortion:U,globPortion:j}=t(T);return j&&(j=u(j)),this.n(U).flatMap(M=>this.o(M,j))}),L=new Map;return y.forEach(T=>{const U=T.searchPath.toString(),j=L.get(U);j?T.pattern&&(j.pattern=j.pattern||{},j.pattern[T.pattern]=!0):L.set(U,{searchPath:T.searchPath,pattern:T.pattern?g(T.pattern):void 0})}),Array.from(L.values())}n(f){if(b.$ic(f)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==p.Schemas.file?[{searchPath:y[0].uri.with({path:f})}]:[{searchPath:w.URI.file(b.$hc(f))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(f=l(f),f.startsWith("../")||f===".."){const T=b.$gc.resolve(y.path,f);return[{searchPath:y.with({path:T})}]}const L=u(f);return[{searchPath:y,pattern:L}]}else{if(f==="./"||f===".\\")return[];{const y=f.replace(/^\.[\/\\]/,""),T=this.b.getWorkspace().folders.map(U=>{const j=y.match(new RegExp(`^${R.$Pe(U.name)}(?:/(.*)|$)`));return j?{match:j,folder:U}:null}).filter(C.$Rf);if(T.length)return T.map(U=>{const j=U.match[1];return{searchPath:U.folder.uri,pattern:j&&u(j)}});{const U=f.match(/\.[\/\\](.+)[\/\\]?/),j=U?U[1]:f,F=S.localize(0,null,j);throw new Error(F)}}}}o(f,y){const L=f.pattern&&y?`${f.pattern}/${y}`:f.pattern||y,T=[{searchPath:f.searchPath,pattern:L}];return L&&!L.endsWith("**")&&T.push({searchPath:f.searchPath,pattern:L+"/**"}),T}q(f,y,L){const T=this.r((0,a.$qi)(f.searchPath),y,L,!1);return T?{...T,includePattern:f.pattern}:null}r(f,y,L,T){let U;const j=w.URI.isUri(f)?f:f.uri;if(L.searchPaths){const J=L.searchPaths.filter(te=>(0,k.$Bg)(te.searchPath,j))[0];if(J&&!J.pattern)return null;J&&(U=J.pattern)}const F=this.a.getValue({resource:j}),O={...this.l(F,y)||{},...U||{}},z=w.URI.isUri(f)?(0,k.$Fg)(f):f.name;return{folder:j,folderName:T?z:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!F.search.followSymlinks}}};e.$ZK=s,e.$ZK=s=Ge([Ve(0,c.$Bi),Ve(1,a.$ei),Ve(2,i.$aD),Ve(3,m.$pj),Ve(4,n.$XK)],s);function t($){const f=$.match(/[\*\{\}\(\)\[\]\?]/);if(f){const y=f.index,L=$.substr(0,y).match(/[/|\\][^/\\]*$/);if(L){let T=$.substr(0,L.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:$.substr((L.index||0)+1)}}}return{pathPortion:$}}function g(...$){return $.length?$.reduce((f,y)=>(f[y]=!0,f),Object.create(null)):void 0}function o($){return h.$Mj($,",").map(f=>f.trim()).filter(f=>!!f.length)}function d($){return[`**/${$}/**`,`**/${$}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function l($){return $.replace(/\\/g,"/")}function u($){return l($).replace(/^\.\//,"").replace(/\/+$/g,"")}function v($){return $.replace(/([?*[\]])/g,"[$1]")}function I($,f){$=D.$Mb($,T=>T.toString());const y=[],L=f.getWorkspace();return $&&$.forEach(T=>{let U;if(f.getWorkbenchState()===2)U=(0,k.$Kg)(L.folders[0].uri,T),U&&U!=="."&&(U="./"+U);else{const j=f.getWorkspaceFolder(T);if(j){const F=j.name;if(L.folders.filter(O=>O.name===F).length===1){const O=(0,k.$Kg)(j.uri,T);O===""?U=`./${j.name}`:U=`./${j.name}/${O}`}else U=T.fsPath}}U&&y.push(v(U))}),y}e.$1K=I}),define(ke[364],Se([1,0,23,2,22,14,5,363,36,40,8]),function($e,e,D,N,h,P,A,p,b,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dtb=e.$ctb=void 0;const C=7e3;function w(m,a){const i=a.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],r=[];for(const l of i)if(/^workspaceContains:/.test(l)){const u=l.substr(18);u.indexOf("*")>=0||u.indexOf("?")>=0||m.forceUsingSearch?r.push(u):n.push(u)}if(n.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:s,resolve:t}=(0,R.$1g)(),g=l=>t({activationEvent:l}),o=Promise.all(n.map(l=>E(m,l,g))).then(()=>{}),d=S(m,a.identifier,r,g);return Promise.all([o,d]).then(()=>{t(void 0)}),s}e.$ctb=w;async function E(m,a,i){for(const n of m.folders)if(await m.exists(D.$Ig(N.URI.revive(n),a))){i(`workspaceContains:${a}`);return}}async function S(m,a,i,n){if(i.length===0)return Promise.resolve(void 0);const r=new h.$7d,s=m.checkExists(m.folders,i,r.token),t=setTimeout(async()=>{r.cancel(),m.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},C);let g=!1;try{g=await s}catch(o){P.$4(o)||P.$1(o)}r.dispose(),clearTimeout(t),g&&n(`workspaceContains:${i.join(",")}`)}function c(m,a,i,n){const r=m.get(A.$7h),s=m.get(b.$FJ),g=r.createInstance(p.$ZK).file(a.map(o=>(0,k.$qi)(N.URI.revive(o))),{_reason:"checkExists",includePattern:i,exists:!0});return s.fileSearch(g,n).then(o=>!!o.limitHit,o=>P.$4(o)?!1:Promise.reject(o))}e.$dtb=c}),define(ke[47],Se([1,0,212,17,58,23,8,3,77,2,13,6,42,292,117,41,26,144,14,25,21,271,7,64,5,27,94,20,107,70,46,4,364,116,273,16,114,38,11,115]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i,n,r,s,t,g,o,d,l,u,v,I,$,f,y,L,T,U,j,F,M,O){"use strict";var z;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=e.$Wgc=e.$Vgc=e.$Ugc=e.$Tgc=void 0,e.$Tgc=(0,o.$8h)("IHostUtils");let J=z=class extends p.$Tc{constructor(K,W,re,ye,he,fe,ue,me,V,Y,de,we){super(),this.X=we,this.a=this.B(new f.$Wd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=W,this.g=re,this.f=ue,this.j=ye,this.m=he,this.s=fe,this.t=V,this.u=Y,this.w=de,this.y=this.g.getProxy(C.$jL.MainThreadWorkspace),this.z=this.g.getProxy(C.$jL.MainThreadTelemetry),this.C=this.g.getProxy(C.$jL.MainThreadExtensionService),this.D=new A.$7g,this.F=new A.$7g,this.G=new A.$7g,this.H=new A.$7g,this.I=new ge(this.f.extensions.activationEvents),this.L=new a.$37b(this.I,this.f.extensions.allExtensions);const Pe=new n.$om(this.f.extensions.myExtensions);this.J=new a.$37b(this.I,ae(this.L,Pe)),M.$t&&(this.s.info(`Creating extension host with the following global extensions: ${X(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${X(this.J)}`)),this.M=new S.$Egc(this.g,this.s),this.N=new L.$Mgc(this.g),this.O=me,this.h=K.createChild(new v.$6h([S.$Fgc,this.M],[L.$Ngc,this.N])),this.P=this.B(new E.$Dgc(this.J,this.L,{onExtensionActivationError:(ve,Ce,B)=>{this.C.$onExtensionActivationError(ve,i.$3(Ce),B)},actualActivateExtension:async(ve,Ce)=>{if(a.$37b.isHostExtension(ve,this.J,this.L))return await this.C.$activateExtension(ve,Ce),new E.$Cgc;const B=this.J.getExtensionDescription(ve);return this.db(B,Ce)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),h.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(K){i.$1(K)}}async Y(){this.O.onWillDeactivateAll();let K=[];try{K=this.J.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this.cb(he))}catch{}await Promise.all(K)}terminate(K,W=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${K}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const re=this.Y();Promise.race([(0,A.$9g)(5e3),re]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(K){return this.G.isOpen()?this.P.isActivated(K):!1}async getExtension(K){const W=await this.C.$getExtension(K);return W&&{...W,identifier:new n.$nm(W.identifier.value),extensionLocation:k.URI.revive(W.extensionLocation)}}Z(K,W){return this.P.activateByEvent(K,W)}$(K,W){return this.P.activateById(K,W)}activateByIdWithErrors(K,W){return this.$(K,W).then(()=>{const re=this.P.getActivatedExtension(K);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(K=>this.J)}getExtensionExports(K){if(this.G.isOpen())return this.P.getActivatedExtension(K).exports;try{return this.P.getActivatedExtension(K).exports}catch{return null}}async ab(K){if(K.scheme===U.Schemas.file&&this.c.fsRealpath){const W=await this.c.fsRealpath(K.fsPath);return k.URI.file(W)}return K}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(K=>new _(K))),this.Q}async bb(K){const W=b.$bi.forUris(re=>P.$zg.ignorePathCasing(re));return await Promise.all(K.map(async re=>{if(this.ub(re)){const ye=await this.ab(re.extensionLocation);W.set(ye,re)}})),W}cb(K){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(K))return W;const re=this.P.getActivatedExtension(K);if(!re)return W;try{typeof re.module.deactivate=="function"&&(W=Promise.resolve(re.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${K.value}':`),this.s.error(ye)}try{(0,p.$Oc)(re.subscriptions)}catch(ye){this.s.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this.s.error(ye)}return W}async db(K,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(K.identifier):await this.C.$onWillActivateExtension(K.identifier),this.fb(K,W).then(re=>{const ye=re.activationTimes;return this.C.$onDidActivateExtension(K.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,W),this.eb(K,W,"success",ye),re},re=>{throw this.eb(K,W,"failure"),re})}eb(K,W,re,ye){const he=x(K,W);this.z.$publicLog2("extensionActivationTimes",{...he,...ye||{},outcome:re})}fb(K,W){const re=x(K,W);this.z.$publicLog2("activatePlugin",re);const ye=this.ub(K);if(!ye)return Promise.resolve(new E.$Bgc(E.$ygc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${K.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const he=new E.$zgc(W.startup);return Promise.all([this.vb(K,(0,P.$Ig)(K.extensionLocation,ye),he),this.gb(K)]).then(fe=>(h.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),z.hb(this.s,K.identifier,fe[0],fe[1],he))).then(fe=>(h.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),fe))}gb(K){const W=new s.$Hgc(K,this.M),re=new s.$Ggc(K.identifier.value,!1,this.M),ye=new T.$Ogc(K,this.N),he=K.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,fe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([W.whenReady,re.whenReady,this.O.whenReady]).then(()=>{const ue=this;let me,V;const Y=(0,m.$KF)(K,"ipc")?this.f.messagePorts?.get(n.$nm.toKey(K.identifier)):void 0;return Object.freeze({globalState:W,workspaceState:re,secrets:ye,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(de){return N.$jc(K.extensionLocation.fsPath,de)},get storagePath(){return ue.O.workspaceValue(K)?.fsPath},get globalStoragePath(){return ue.O.globalValue(K).fsPath},get logPath(){return N.$jc(ue.f.logsLocation.fsPath,K.identifier.value)},get logUri(){return k.URI.joinPath(ue.f.logsLocation,K.identifier.value)},get storageUri(){return ue.O.workspaceValue(K)},get globalStorageUri(){return ue.O.globalValue(K)},get extensionMode(){return he},get extension(){return me===void 0&&(me=new Z(ue,K.identifier,K,fe,!1)),me},get extensionRuntime(){return(0,m.$LF)(K,"extensionRuntime"),ue.extensionRuntime},get environmentVariableCollection(){return ue.u.getEnvironmentVariableCollection(K)},get messagePassingProtocol(){if(!V){if(!Y)return;const de=f.Event.buffer(f.Event.fromDOMEventEmitter(Y,"message",we=>we.data));Y.start(),V={onDidReceiveMessage:de,postMessage:Y.postMessage.bind(Y)}}return V}})})}static hb(K,W,re,ye,he){return re=re||{activate:void 0,deactivate:void 0},this.ib(K,W,re,ye,he).then(fe=>new E.$Agc(!1,null,he.build(),re,fe,ye.subscriptions))}static ib(K,W,re,ye,he){if(typeof re.activate=="function")try{he.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${W.value}`);const fe=typeof global=="object"?global:self,ue=re.activate.apply(fe,[ye]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(ue).then(me=>(he.activateResolveStop(),me))}catch(fe){return Promise.reject(fe)}else return Promise.resolve(re)}jb(K,W){this.$(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:W}).then(void 0,re=>{this.s.error(re)})}kb(K,W=0){const ye=Date.now();(0,M.$B)(()=>{for(let he=W;he<K.length;he+=1){const fe=K[he];for(const ue of fe.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-ye>50){this.kb(K,he);break}else this.jb(fe,ue)}})}lb(){this.C.$setPerformanceMarks(h.getMarks()),this.m.getConfigProvider().then(K=>{const W=K.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),re=this.J.getAllExtensionDescriptions();if(W)this.kb(re);else for(const ye of re)if(ye.activationEvents)for(const he of ye.activationEvents)he==="onStartupFinished"&&this.jb(ye,he)})}mb(){const K=this.Z("*",!0).then(void 0,fe=>{this.s.error(fe)});this.B(this.j.onDidChangeWorkspace(fe=>this.nb(fe.added)));const W=this.j.workspace?this.j.workspace.folders:[],re=this.nb(W),ye=this.pb(),he=Promise.all([ye,K,re]).then(()=>{});return Promise.race([he,(0,A.$9g)(1e4)]).then(()=>{this.lb()}),he}nb(K){return K.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.ob(K,W))).then(()=>{})}async ob(K,W){if(this.isActivated(W.identifier))return;const re=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:K.map(fe=>fe.uri),forceUsingSearch:re||!this.c.fsExists,exists:fe=>this.c.fsExists(fe.fsPath),checkExists:(fe,ue,me)=>this.y.$checkExists(fe,ue,me)},he=await(0,y.$ctb)(ye,W);if(he)return this.$(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:he.activationEvent}).then(void 0,fe=>this.s.error(fe))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(K){throw console.error(K),K}}async qb(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:W}=this.f.environment;if(!K||!W)throw new Error(D.localize(0,null));const re=await this.vb(null,W,new E.$zgc(!1));if(!re||typeof re.run!="function")throw new Error(D.localize(1,null,W.toString()));return new Promise((ye,he)=>{const fe=(V,Y)=>{V?(M.$t&&this.s.error("Test runner called back with error",V),he(V)):(M.$t&&(Y?this.s.info(`Test runner called back with ${Y} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof Y=="number"&&Y>0?1:0))},ue=(0,P.$wg)(W),me=re.run(ue,fe);me&&me.then&&me.then(()=>{M.$t&&this.s.info("Test runner finished successfully."),ye(0)}).catch(V=>{M.$t&&this.s.error("Test runner finished with error",V),he(V instanceof Error&&V.stack?V.stack:String(V))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$9g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,W){return this.R[K]=W,(0,p.$Rc)(()=>{delete this.R[K]})}async getRemoteExecServer(K){const{resolver:W}=await this.sb(K);return W?.resolveExecServer?.(K,{resolveAttempt:0})}async sb(K){const W=K.indexOf("+");if(W===-1)throw new t.$rL("Not an authority that can be resolved!",g.RemoteAuthorityResolverErrorCode.InvalidAuthority);const re=K.substr(0,W);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${re}`,!1),{authorityPrefix:re,resolver:this.R[re]}}async $resolveAuthority(K,W){const re=F.$Sd.create(!1),ye=()=>`[resolveAuthority(${(0,g.$bl)(K)},${W})][${re.elapsed()}ms] `,he=ee=>this.s.info(`${ye()}${ee}`),fe=ee=>this.s.warn(`${ye()}${ee}`),ue=(ee,H=void 0)=>this.s.error(`${ye()}${ee}`,H),me=ee=>{if(ee instanceof t.$rL)return{type:"error",error:{code:ee._code,message:ee._message,detail:ee._detail}};throw ee},V=async ee=>{he(`activating resolver for ${ee}...`);const{resolver:H,authorityPrefix:oe}=await this.sb(ee);if(!H)throw ue(`no resolver for ${oe}`),new t.$rL(`No remote extension installed to resolve ${oe}.`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:oe,remoteAuthority:ee}},Y=K.split(/@|%40/g).reverse();he(`activating remote resolvers ${Y.join(" -> ")}`);let de;try{de=await Promise.all(Y.map(V)).catch(async ee=>{if(!(ee instanceof t.$rL)||ee._code!==g.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ee;return fe(`resolving nested authorities failed: ${ee.message}`),[await V(K)]})}catch(ee){return me(ee)}const we=new A.$gh;we.cancelAndSet(()=>he("waiting..."),1e3);let Pe,ve;for(const[ee,{authorityPrefix:H,resolver:oe,remoteAuthority:le}]of de.entries())try{if(ee===de.length-1)he("invoking final resolve()..."),h.mark(`code/extHost/willResolveAuthority/${H}`),Pe=await oe.resolve(le,{resolveAttempt:W,execServer:ve}),h.mark(`code/extHost/didResolveAuthorityOK/${H}`),he("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(oe,t.$qL.isManagedResolvedAuthority(Pe)?Pe:void 0));else{if(he(`invoking resolveExecServer() for ${le}`),h.mark(`code/extHost/willResolveExecServer/${H}`),ve=await oe.resolveExecServer?.(le,{resolveAttempt:W,execServer:ve}),!ve)throw new t.$rL(`Exec server was not available for ${le}`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);h.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(Re){return h.mark(`code/extHost/didResolveAuthorityError/${H}`),ue("returned an error",Re),we.dispose(),me(Re)}we.dispose();const Ce={environmentTunnels:Pe.environmentTunnels,features:Pe.tunnelFeatures?{elevation:Pe.tunnelFeatures.elevation,privacyOptions:Pe.tunnelFeatures.privacyOptions,protocol:Pe.tunnelFeatures.protocol===void 0?!0:Pe.tunnelFeatures.protocol}:void 0},B={extensionHostEnv:Pe.extensionHostEnv,isTrusted:Pe.isTrusted,authenticationSession:Pe.authenticationSessionForInitializingExtensions?{id:Pe.authenticationSessionForInitializingExtensions.id,providerId:Pe.authenticationSessionForInitializingExtensions.providerId}:void 0};he(`returned ${t.$qL.isManagedResolvedAuthority(Pe)?"managed authority":`${Pe.host}:${Pe.port}`}`);let Q;if(t.$qL.isManagedResolvedAuthority(Pe)){const ee=W;this.X.setFactory(ee,Pe.makeConnection),Q={authority:K,connectTo:new g.$$k(ee),connectionToken:Pe.connectionToken}}else Q={authority:K,connectTo:new g.$_k(Pe.host,Pe.port),connectionToken:Pe.connectionToken};return{type:"ok",value:{authority:Q,options:B,tunnelInformation:Ce}}}async $getCanonicalURI(K,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,g.$bl)(K)})`);const{resolver:re}=await this.sb(K);if(!re)return null;const ye=k.URI.revive(W);if(typeof re.getCanonicalURI>"u")return ye;const he=await(0,A.$Zg)(()=>re.getCanonicalURI(ye));return he||ye}$startExtensionHost(K){K.toAdd.forEach(ye=>ye.extensionLocation=k.URI.revive(ye.extensionLocation));const{globalRegistry:W,myExtensions:re}=te(this.I,this.L,this.J,K);return this.L.set(W.getAllExtensionDescriptions()),this.J.set(re),M.$t&&(this.s.info(`$startExtensionHost: global extensions: ${X(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${X(this.J)}`)),this.rb()}$activateByEvent(K,W){return W===1?this.D.wait().then(re=>this.Z(K,!1)):this.G.wait().then(re=>this.Z(K,!1))}async $activate(K,W){return await this.G.wait(),this.J.getExtensionDescription(K)?(await this.$(K,W),!0):!1}async $deltaExtensions(K){K.toAdd.forEach(fe=>fe.extensionLocation=k.URI.revive(fe.extensionLocation));const{globalRegistry:W,myExtensions:re}=te(this.I,this.L,this.J,K),ye=await this.bb(re);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(W.getAllExtensionDescriptions()),this.J.set(re),M.$t&&(this.s.info(`$deltaExtensions: global extensions: ${X(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${X(this.J)}`)),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){const W=r.$ke.alloc(K),re=Math.random()%256;for(let ye=0;ye<K;ye++)W.writeUInt8(re,ye);return W}async $updateRemoteConnectionData(K){this.W=K,this.a.fire()}};e.$Ugc=J,e.$Ugc=J=z=Ge([Ve(0,o.$7h),Ve(1,e.$Tgc),Ve(2,u.$oN),Ve(3,c.$hgc),Ve(4,w.$kgc),Ve(5,R.$pj),Ve(6,d.$EN),Ve(7,l.$ngc),Ve(8,I.$dzb),Ve(9,$.$Igc),Ve(10,j.$Qgc),Ve(11,O.$Rgc)],J);function te(ne,K,W,re){ne.addActivationEvents(re.addActivationEvents);const ye=new a.$37b(ne,K.getAllExtensionDescriptions());ye.deltaExtensions(re.toAdd,re.toRemove);const he=new n.$om(W.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of re.myToRemove)he.delete(ue);for(const ue of re.myToAdd)he.add(ue);const fe=ae(ye,he);return{globalRegistry:ye,myExtensions:fe}}function x(ne,K){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}function X(ne){return ne.getAllExtensionDescriptions().map(K=>K.identifier.value).join(",")}e.$Vgc=(0,o.$8h)("IExtHostExtensionService");class Z{#e;#t;#i;constructor(K,W,re,ye,he){this.#e=K,this.#t=W,this.#i=re.identifier,this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=N.$hc((0,P.$wg)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=ye,this.isFromDifferentExtensionHost=he}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Wgc=Z;function ae(ne,K){return ne.getAllExtensionDescriptions().filter(W=>K.has(W.identifier))}class _{constructor(K){this.a=K}setSearchTree(K){this.a=K}findSubstr(K){return this.a.findSubstr(K)}forEach(K){return this.a.forEach(K)}}e.$Xgc=_;class ge{constructor(K){this.a=new n.$pm,this.addActivationEvents(K)}readActivationEvents(K){return this.a.get(K.identifier)??[]}addActivationEvents(K){for(const W of Object.keys(K))this.a.set(W,K[W])}}}),define(ke[365],Se([1,0,58,2,6,42,26,25,20,27,5,47,13,12]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;let c=class{constructor(r,s,t,g,o,d,l){this.c=r,this.d=s,this.e=t,this.f=g,this.g=o,this.h=d,this.i=l,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new a(this.c,s,this.d,r,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,s,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const s of r.nodeModuleName)this.a.set(s,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(s=>r.alternativeModuleName(s))}};e.$6hc=c,e.$6hc=c=Ge([Ve(2,R.$7h),Ve(3,P.$kgc),Ve(4,C.$Vgc),Ve(5,k.$EN),Ve(6,w.$pj)],c);let m=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&S.a.size){const s=(0,E.$Pe)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",g=`@${t}+\\/${t}+|${t}+`,o="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${o}\\/)(${g})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const s=this.b.exec(this.c(r));if(!s)return;const[,t,g,o]=s,d=S.a.get(g);if(d!==void 0)return console.warn(`${g} as been renamed to ${d}, please update your imports`),t+d+o}c(r){return r.replace(/\\/g,"/")}};m=S=Ge([Ve(0,k.$EN)],m);class a{constructor(r,s,t,g,o){this.c=r,this.d=s,this.e=t,this.f=g,this.g=o,this.nodeModuleName="vscode",this.a=new p.$pm}load(r,s){const t=this.d.findSubstr(s);if(t){let g=this.a.get(t.identifier);return g||(g=this.c(t,this.e,this.f),this.a.set(t.identifier,g)),g}if(!this.b){let g="";this.d.forEach((o,d)=>g+=`	${d} -> ${o.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${g}`),this.b=this.c(A.$FF,this.e,this.f)}return this.b}}let i=class{constructor(r,s,t){this.e=r,this.f=s,this.nodeModuleName=["open","opn"],this.d=t.getProxy(h.$jL.MainThreadTelemetry);const g=t.getProxy(h.$jL.MainThreadWindow);this.c=(o,d)=>{const l=N.URI.parse(o);return d?this.g(o,d):l.scheme==="http"||l.scheme==="https"?g.$openUri(l,o,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this.f?g.$openUri(l,o,{}):this.g(o,d)}}load(r,s,t){const g=this.e.findSubstr(s);return g&&(this.a=g.identifier.value,this.h()),this.b=t(r),this.c}g(r,s){return this.i(),this.b(r,s)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Ge([Ve(2,b.$oN)],i)}),define(ke[60],Se([1,0,43,3,17,49,5,72,71,47,7,41,289,42]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=e.$Ygc=void 0,e.$Ygc=(0,A.$8h)("IExtHostVariableResolverProvider");class S extends w.$pO{constructor(a,i,n,r,s,t,g){function o(){if(n){const d=n.activeEditor();if(d)return d.document.uri;const l=r.tabGroups.all.find(u=>u.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof R.$6M||l.input instanceof R.$$M)return l.input.modified;if(l.input instanceof R.$5M||l.input instanceof R.$0M||l.input instanceof R.$8M)return l.input.uri}}}super({getFolderUri:d=>{const l=t.folders.filter(u=>u.name===d);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(d,l)=>s.getConfiguration(void 0,d).get(l),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=o();if(d)return h.$hc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const d=o();if(d){const l=i.getWorkspaceFolder(d);if(l)return h.$hc(l.uri.fsPath)}}},getSelectedText:()=>{if(n){const d=n.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(n){const d=n.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>a.getExtension(d)},void 0,g?Promise.resolve(g):void 0,Promise.resolve(P.env))}}let c=class extends N.$Tc{constructor(a,i,n,r,s){super(),this.b=a,this.c=i,this.g=n,this.h=r,this.j=s,this.a=new D.$V(async()=>{const t=await this.h.getConfigProvider(),o={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{o.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,o,this.m())})}getResolver(){return this.a.value}m(){}};e.$Zgc=c,e.$Zgc=c=Ge([Ve(0,k.$Vgc),Ve(1,C.$hgc),Ve(2,p.$zN),Ve(3,E.$kgc),Ve(4,b.$wgc)],c)}),define(ke[97],Se([1,0,8,4,2,25,5,6,71,47,20,7,41,140,281,42,60,3,55,33]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=e.$4gc=e.$3gc=e.$2gc=e.$1gc=void 0,e.$1gc=(0,A.$8h)("IExtHostDebugService");let r=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q?.api}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.w.value}constructor(u,v,I,$,f,y,L){this.I=v,this.J=I,this.K=$,this.L=f,this.M=y,this.N=L,this.l=new Map,this.E=new Map,this.G=new Map,this.H=0,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.C=new Map,this.D=new Map,this.m=new N.$Wd,this.n=new N.$Wd,this.o=new N.$Wd,this.u=new N.$Wd,this.k=u.getProxy(p.$jL.MainThreadDebugService),this.z=new N.$Wd,this.B=new N.$Wd,this.w=new t(this.k),this.y=new Map,this.J.getExtensionRegistry().then(T=>{T.onDidChange(U=>{this.O(T)}),this.O(T)})}asDebugSourceUri(u,v){const I=u;if(typeof I.sourceReference=="number"&&I.sourceReference>0){let $=`debug:${encodeURIComponent(I.path||"")}`,f="?";return v&&($+=`${f}session=${encodeURIComponent(v.id)}`,f="&"),$+=`${f}ref=${I.sourceReference}`,h.URI.parse($)}else{if(I.path)return h.URI.file(I.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}O(u){const v=[];for(const I of u.getAllExtensionDescriptions())if(I.contributes){const $=I.contributes.debuggers;if($&&$.length>0)for(const f of $)(0,S.$gG)(f)&&v.push(f.type)}this.k.$registerDebugTypes(v)}get stackFrameFocus(){return this.A}get onDidChangeStackFrameFocus(){return this.B.event}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){const u=[];return this.y.forEach(v=>u.push(v)),u}async $resolveDebugVisualizer(u,v){const I=this.G.get(u);if(!I)throw new Error(`No debug visualizer found with id '${u}'`);let{v:$,provider:f}=I;if($.visualization||($=await f.resolveDebugVisualization?.($,v)||$,I.v=$),!$.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${f}'`);return this.db($.visualization)}async $executeDebugVisualizerCommand(u){const v=this.G.get(u);if(!v)throw new Error(`No debug visualizer found with id '${u}'`);const I=v.v.visualization;I&&"command"in I&&this.N.executeCommand(I.command,...I.arguments||[])}async $provideDebugVisualizers(u,v,I,$){const f=this.l.get(I.sessionId),y=this.cb(u,v),L=this.E.get(y);if(!f||!L)return[];const T=await L.provideDebugVisualization({session:f.api,variable:I.variable,containerId:I.containerId,frameId:I.frameId,threadId:I.threadId},$);return T?T.map(U=>{const j=++this.H;this.G.set(j,{v:U,provider:L});const F=U.iconPath?this.eb(U.iconPath):void 0;return{id:j,name:U.name,iconClass:F?.iconClass,iconPath:F?.iconPath,visualization:this.db(U.visualization)}}):[]}$disposeDebugVisualizers(u){for(const v of u)this.G.delete(v)}registerDebugVisualizationProvider(u,v,I){if(!u.contributes?.debugVisualizers?.some(y=>y.id===v))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${v})`);const $=P.$nm.toKey(u.identifier),f=this.cb($,v);if(this.E.has(f))throw new Error(`A debug visualization provider with id '${v}' is already registered`);return this.E.set(f,I),this.k.$registerDebugVisualizer($,v),(0,a.$Rc)(()=>{this.k.$unregisterDebugVisualizer($,v),this.E.delete(v)})}addBreakpoints(u){const v=u.filter(f=>{const y=f.id;return this.y.has(y)?!1:(this.y.set(y,f),!0)});this.$(v,[],[]);const I=[],$=new Map;for(const f of v)if(f instanceof C.$lM){let y=$.get(f.location.uri.toString());y||(y={type:"sourceMulti",uri:f.location.uri,lines:[]},$.set(f.location.uri.toString(),y),I.push(y)),y.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof C.$mM&&I.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this.k.$registerBreakpoints(I)}removeBreakpoints(u){const v=u.filter(y=>this.y.delete(y.id));this.$([],v,[]);const I=v.filter(y=>y instanceof C.$lM).map(y=>y.id),$=v.filter(y=>y instanceof C.$mM).map(y=>y.id),f=v.filter(y=>y instanceof C.$nM).map(y=>y.id);return this.k.$unregisterBreakpoints(I,$,f)}startDebugging(u,v,I){return this.k.$startDebugging(u?u.uri:void 0,v,{parentSessionID:I.parentSession?I.parentSession.id:void 0,lifecycleManagedByParent:I.lifecycleManagedByParent,repl:I.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:I.noDebug,compact:I.compact,suppressSaveBeforeStart:I.suppressSaveBeforeStart,suppressDebugStatusbar:I.suppressDebugStatusbar??I.debugUI?.simple,suppressDebugToolbar:I.suppressDebugToolbar??I.debugUI?.simple,suppressDebugView:I.suppressDebugView??I.debugUI?.simple})}stopDebugging(u){return this.k.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,v,I){if(!v)return new C.$lL(()=>{});const $=this.d++;return this.f.push({type:u,handle:$,provider:v}),this.k.$registerDebugConfigurationProvider(u,I,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,$),new C.$lL(()=>{this.f=this.f.filter(f=>f.provider!==v),this.k.$unregisterDebugConfigurationProvider($)})}registerDebugAdapterDescriptorFactory(u,v,I){if(!I)return new C.$lL(()=>{});if(!this.W(u,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.S(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const $=this.g++;return this.h.push({type:v,handle:$,factory:I}),this.k.$registerDebugAdapterDescriptorFactory(v,$),new C.$lL(()=>{this.h=this.h.filter(f=>f.factory!==I),this.k.$unregisterDebugAdapterDescriptorFactory($)})}registerDebugAdapterTrackerFactory(u,v){if(!v)return new C.$lL(()=>{});const I=this.i++;return this.j.push({type:u,handle:I,factory:v}),new C.$lL(()=>{this.j=this.j.filter($=>$.factory!==v)})}async $runInTerminal(u,v){return Promise.resolve(void 0)}async $substituteVariables(u,v){let I;const $=await this.bb(u);return $&&(I={uri:$.uri,name:$.name,index:$.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.M.getResolver()).resolveAnyAsync(I,v)}P(u,v){if(u.type==="implementation")return new o(u.implementation)}Q(){}async $startDASession(u,v){const I=this,$=await this.ab(v);return this.Y(this.S($.type),$).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${$.type}' (extension might have failed to activate)`);const y=this.R(f),L=this.P(y,$);if(!L)throw new Error(`Couldn't create a debug adapter for type '${$.type}'.`);const T=L;return this.C.set(u,T),this.X($).then(U=>(U&&this.D.set(u,U),T.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const F=j,M={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this.F||(this.F=this.Q());try{if(this.F){const O=await this.F.sign(F.arguments.value);M.body={signature:O},T.sendResponse(M)}else throw new Error("no signer")}catch(O){M.success=!1,M.message=O.message,T.sendResponse(M)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(j),j=(0,S.$lG)(j,!0),I.k.$acceptDAMessage(u,j)}),T.onError(j=>{U&&U.onError&&U.onError(j),this.k.$acceptDAError(u,j.name,j.message,j.stack)}),T.onExit(j=>{U&&U.onExit&&U.onExit(j??void 0,void 0),this.k.$acceptDAExit(u,j??void 0,void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),T.startSession()))})}$sendDAMessage(u,v){v=(0,S.$kG)(v,!1);const I=this.D.get(u);I&&I.onWillReceiveMessage&&I.onWillReceiveMessage(v),this.C.get(u)?.sendMessage(v)}$stopDASession(u){const v=this.D.get(u);this.D.delete(u),v&&v.onWillStopSession&&v.onWillStopSession();const I=this.C.get(u);return this.C.delete(u),I?I.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const v=[],I=[],$=[];if(u.added)for(const f of u.added){const y=f.id;if(y&&!this.y.has(y)){let L;if(f.type==="function")L=new C.$mM(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")L=new C.$nM(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const T=h.URI.revive(f.uri);L=new C.$lM(new C.$xL(T,new C.$mL(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,C.$jM)(L,y),this.y.set(y,L),v.push(L)}}if(u.removed)for(const f of u.removed){const y=this.y.get(f);y&&(this.y.delete(f),I.push(y))}if(u.changed){for(const f of u.changed)if(f.id){const y=this.y.get(f.id);if(y){if(y instanceof C.$mM&&f.type==="function"){const L=y;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.functionName=f.functionName}else if(y instanceof C.$lM&&f.type==="source"){const L=y;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.location=new C.$xL(h.URI.revive(f.uri),new C.$mL(f.line,f.character))}$.push(y)}}}this.$(v,I,$)}async $acceptStackFrameFocus(u){let v;const I=u.sessionId?await this.ab(u.sessionId):void 0;if(!I)throw new Error("no DebugSession found for debug focus context");u.kind==="thread"?v=new C.$tM(I.api,u.threadId):v=new C.$sM(I.api,u.threadId,u.frameId),this.A=v,this.B.fire(this.A)}$provideDebugConfigurations(u,v,I){return(0,D.$Zg)(async()=>{const $=this.V(u);if(!$)throw new Error("no DebugConfigurationProvider found");if(!$.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.bb(v);return $.provideDebugConfigurations(f,I)}).then($=>{if(!$)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return $})}$resolveDebugConfiguration(u,v,I,$){return(0,D.$Zg)(async()=>{const f=this.V(u);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const y=await this.bb(v);return f.resolveDebugConfiguration(y,I,$)})}$resolveDebugConfigurationWithSubstitutedVariables(u,v,I,$){return(0,D.$Zg)(async()=>{const f=this.V(u);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const y=await this.bb(v);return f.resolveDebugConfigurationWithSubstitutedVariables(y,I,$)})}async $provideDebugAdapter(u,v){const I=this.U(u);if(!I)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const $=await this.ab(v);return this.Y(I,$).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${$.type}'`);return this.R(f)})}async $acceptDebugSessionStarted(u){const v=await this.ab(u);this.m.fire(v.api)}async $acceptDebugSessionTerminated(u){const v=await this.ab(u);v&&(this.n.fire(v.api),this.l.delete(v.id))}async $acceptDebugSessionActiveChanged(u){this.q=u?await this.ab(u):void 0,this.o.fire(this.q?.api)}async $acceptDebugSessionNameChanged(u,v){(await this.ab(u))?._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(u,v){const $={session:(await this.ab(u)).api,event:v.event,body:v.body};this.u.fire($)}R(u){if(u instanceof C.$oM)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof C.$pM)return{type:"server",port:u.port,host:u.host};if(u instanceof C.$qM)return{type:"pipeServer",path:u.path};if(u instanceof C.$rM)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}S(u){const v=this.h.filter(I=>I.type===u);if(v.length>0)return v[0].factory}U(u){const v=this.h.filter(I=>I.handle===u);if(v.length>0)return v[0].factory}V(u){const v=this.f.filter(I=>I.handle===u);if(v.length>0)return v[0].provider}W(u,v){if(u.contributes){const I=u.contributes.debuggers;if(I&&I.length>0){for(const $ of I)if($.label&&$.type&&$.type===v)return!0}}return!1}X(u){const I=u.configuration.type,$=this.j.filter(f=>f.type===I||f.type==="*").map(f=>(0,D.$Zg)(()=>f.factory.createDebugAdapterTracker(u.api)).then(y=>y,y=>null));return Promise.race([Promise.all($).then(f=>{const y=f.filter(L=>!!L);if(y.length>0)return new g(y)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async Y(u,v){const I=v.configuration.debugServer;if(typeof I=="number")return Promise.resolve(new C.$pM(I));if(u){const f=await this.J.getExtensionRegistry();return(0,D.$Zg)(()=>u.createDebugAdapterDescriptor(v.api,this.Z(v,f))).then(y=>{if(y)return y})}const $=await this.J.getExtensionRegistry();return Promise.resolve(this.Z(v,$))}Z(u,v){}$(u,v,I){(u.length>0||v.length>0||I.length>0)&&this.z.fire(Object.freeze({added:u,removed:v,changed:I}))}async ab(u){if(u)if(typeof u=="string"){const v=this.l.get(u);if(v)return v}else{let v=this.l.get(u.id);if(!v){const I=await this.bb(u.folderUri),$=u.parent?this.l.get(u.parent):void 0;v=new s(this.k,u.id,u.type,u.name,I,u.configuration,$?.api),this.l.set(v.id,v),this.k.$sessionCached(v.id)}return v}throw new Error("cannot find session")}bb(u){if(u){const v=h.URI.revive(u);return this.I.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}cb(u,v){return`${u}\0${v}`}db(u){if(u){if("title"in u&&"command"in u)return{type:0};throw new Error("Unsupported debug visualization type")}}eb(u){const v=this.fb(u);let I,$;return"id"in v?$=i.ThemeIcon.asClassName(v):I=v,{iconPath:I,iconClass:$}}fb(u){if(u instanceof C.$gM)return{id:u.id};const v=typeof u=="object"&&"dark"in u?u.dark:u,I=typeof u=="object"&&"light"in u?u.light:u;return{dark:typeof v=="string"?h.URI.file(v):v,light:typeof I=="string"?h.URI.file(I):I}}};e.$2gc=r,e.$2gc=r=Ge([Ve(0,R.$oN),Ve(1,w.$hgc),Ve(2,k.$Vgc),Ve(3,c.$kgc),Ve(4,b.$wgc),Ve(5,m.$Ygc),Ve(6,n.$KN)],r);class s{constructor(u,v,I,$,f,y,L){this.d=u,this.f=v,this.g=I,this.h=$,this.i=f,this.j=y,this.k=L}get api(){const u=this;return Object.freeze({id:u.f,type:u.g,get name(){return u.h},set name(v){u.h=v,u.d.$setDebugSessionName(u.f,v)},parentSession:u.k,workspaceFolder:u.i,configuration:u.j,customRequest(v,I){return u.d.$customDebugAdapterRequest(u.f,v,I)},getDebugProtocolBreakpoint(v){return u.d.$getDebugProtocolBreakpoint(u.f,v.id)}})}get id(){return this.f}get type(){return this.g}_acceptNameChanged(u){this.h=u}get configuration(){return this.j}}e.$3gc=s;class t{constructor(u){this.value=Object.freeze({append(v){u.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.$4gc=t;class g{constructor(u){this.d=u}onWillStartSession(){this.d.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.d.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.d.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(u):void 0)}onWillStopSession(){this.d.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.d.forEach(v=>v.onError?v.onError(u):void 0)}onExit(u,v){this.d.forEach(I=>I.onExit?I.onExit(u,v):void 0)}}class o extends E.$0lb{constructor(u){super(),this.h=u,u.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.h.handleMessage(u)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let d=class extends r{constructor(u,v,I,$,f,y,L){super(u,v,I,$,f,y,L)}};e.$5gc=d,e.$5gc=d=Ge([Ve(0,R.$oN),Ve(1,w.$hgc),Ve(2,k.$Vgc),Ve(3,c.$kgc),Ve(4,b.$wgc),Ve(5,m.$Ygc),Ve(6,n.$KN)],d)}),define(ke[366],Se([1,0,14,58,2,6,309,13,84,107,27,247,20,66,47,91]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=e.$7hc=void 0;class m{static async installEarlyHandler(n){Error.stackTraceLimit=100;const r=n.get(p.$pj),t=n.get(w.$oN).getProxy(P.$jL.MainThreadErrors);D.setUnexpectedErrorHandler(g=>{r.error(g);const o=D.$3(g);t.$onUnexpectedError(o)})}static async installFullHandler(n){const r=n.get(p.$pj),s=n.get(w.$oN),t=n.get(S.$Vgc),g=n.get(c.$IN),o=s.getProxy(P.$jL.MainThreadExtensionService),d=s.getProxy(P.$jL.MainThreadErrors),l=await t.getExtensionPathIndex(),u=new WeakMap;function v(f,y){if(u.has(f))return u.get(f).stack;let L="",T,U;for(const F of y)L+=`
	at ${F.toString()}`,U=F.getFileName(),!T&&U&&(T=l.findSubstr(h.URI.file(U)));const j=`${f.name||"Error"}: ${f.message||""}${L}`;return u.set(f,{extensionIdentifier:T?.identifier,stack:j}),j}const I=Symbol("prepareStackTrace wrapped");let $=v;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return $},set(f){if(f===v||!f||f[I]){$=f||v;return}$=function(y,L){return v(y,L),f.call(Error,y,L)},Object.assign($,{[I]:!0})}}),D.setUnexpectedErrorHandler(f=>{r.error(f);const y=D.$3(f),L=u.get(f);if(!L?.extensionIdentifier){d.$onUnexpectedError(y);return}o.$onExtensionRuntimeError(L.extensionIdentifier,y);const T=g.onExtensionError(L.extensionIdentifier,f);r.trace("forwarded error to extension?",T,L)})}}e.$7hc=m;class a{constructor(n,r,s,t,g){this.a=s,this.b=new A.$$7b(n,null,t),r=a.e(r,this.b);const o=new k.$6h(...(0,b.$2r)());o.set(R.$EN,{_serviceBrand:void 0,...r,messagePorts:g}),o.set(w.$oN,new w.$pN(this.b)),o.set(E.$egc,new E.$fgc(t)),o.set(S.$Tgc,s);const d=new C.$Gq(o,!0);d.invokeFunction(m.installEarlyHandler),this.d=d.invokeFunction(l=>l.get(p.$pj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=d.invokeFunction(l=>l.get(S.$Vgc)),this.c.initialize(),d.invokeFunction(m.installFullHandler)}async asBrowserUri(n){const r=this.b.getProxy(P.$jL.MainThreadExtensionService);return h.URI.revive(await r.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,r){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=h.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=h.URI.revive(r.transformIncomingURIs(n.environment.appRoot));const s=n.environment.extensionDevelopmentLocationURI;return s&&(n.environment.extensionDevelopmentLocationURI=s.map(t=>h.URI.revive(r.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=h.URI.revive(r.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=h.URI.revive(r.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=h.URI.revive(r.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=h.URI.revive(r.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=h.URI.revive(r.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=h.URI.revive(r.transformIncomingURIs(n.logsLocation)),n.workspace=r.transformIncomingURIs(n.workspace),n}}e.$8hc=a}),define(ke[367],Se([1,0,8,11,222,241,138,97,71,47,20,46,7,60,41,282,283,42,33]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=void 0;let n=class extends p.$2gc{constructor(o,d,l,u,v,I,$,f){super(o,d,l,u,I,$,f),this.ib=v,this.gb=new t}P(o,d){switch(o.type){case"server":return new c.$aic(o);case"pipeServer":return new c.$bic(o);case"executable":return new c.$cic(o,d.type)}return super.P(o,d)}Z(o,d){const l=c.$cic.platformAdapterExecutable(d.getAllExtensionDescriptions(),o.type);if(l)return new w.$oM(l.command,l.args,l.options)}Q(){return new A.$X$b}async $runInTerminal(o,d){if(o.kind==="integrated"){this.hb||(this.hb=this.ib.onDidCloseTerminal(F=>{this.gb.onTerminalClosed(F)}));const l=await this.K.getConfigProvider(),u=this.ib.getDefaultShell(!0),v=this.ib.getDefaultShellArgs(!0),I=o.title||h.localize(0,null),$=JSON.stringify({shell:u,shellArgs:v});let f=await this.gb.checkout($,I),y,L=!1;if(f)y=o.cwd;else{const F={shellPath:u,shellArgs:v,cwd:o.cwd,name:I,iconPath:new w.$gM("debug")};L=!0,f=this.ib.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.gb.insert(f,$)}f.show(!0);const T=await f.processId;L?await new Promise(F=>setTimeout(F,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0||u.indexOf("cmd.exe")>=0?f.sendText("cls"):u.indexOf("bash")>=0?f.sendText("clear"):N.$i?f.sendText("cls"):f.sendText("clear"));const U=(0,m.$eic)(u,o.args,!!o.argsCanBeInterpretedByShell,y,o.env);f.sendText(U);const j=this.onDidTerminateDebugSession(F=>{F.id===d&&(this.gb.free(f),j.dispose())});return T}else if(o.kind==="external")return s(o,await this.K.getConfigProvider());return super.$runInTerminal(o,d)}};e.$fic=n,e.$fic=n=Ge([Ve(0,R.$oN),Ve(1,S.$hgc),Ve(2,k.$Vgc),Ve(3,a.$kgc),Ve(4,C.$Igc),Ve(5,b.$wgc),Ve(6,E.$Ygc),Ve(7,i.$KN)],n);let r;function s(g,o){if(!r)if(N.$i)r=new P.$J0b;else if(N.$j)r=new P.$K0b;else if(N.$k)r=new P.$L0b;else throw new Error("external terminals not supported on this platform");const d=o.getConfiguration("terminal");return r.runInTerminal(g.title,g.cwd,g.args,g.env||{},d.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(o,d){const u=[...this.b.entries()].map(([v,I])=>(0,D.$Ug)(async $=>{if(v.name!==d||I.lastUsedAt!==-1&&await(0,m.$dic)(await v.processId))return null;const f=Date.now();return I.lastUsedAt+t.a>f||$.isCancellationRequested||I.config!==o?null:(I.lastUsedAt=f,v)}));return await(0,D.$ah)(u,v=>!!v)}insert(o,d){this.b.set(o,{lastUsedAt:Date.now(),config:d})}free(o){const d=this.b.get(o);d&&(d.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}}),define(ke[368],Se([1,0,17,2,105,41,72,42,40,46,20,27,96,16,13,92,23,63,60]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;let n=class extends w.$Lhc{constructor(s,t,g,o,d,l,u,v,I){super(s,t,g,o,d,l,u,v),this.C=g,this.D=I,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(E.Schemas.file,{scheme:E.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,t){const g=t;if(!t.execution&&g._id===void 0)throw new Error("Tasks to execute must include an execution");if(g._id!==void 0){const o=w.TaskHandleDTO.from(g,this.C),d=await this.a.$getTaskExecution(o);if(d.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.z(d,t);return this.a.$executeTask(o).catch(()=>{}),l}else{const o=w.TaskDTO.from(t,s);if(o===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(o.execution)&&await this.y(o,t,!1);const d=await this.z(await this.a.$getTaskExecution(o),t);return this.a.$executeTask(o).catch(()=>{}),d}}v(s,t,g,o){const d=[];if(o)for(const l of o){this.A(l,g),(!l.definition||!s[l.definition.type])&&this.f.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const u=w.TaskDTO.from(l,g.extension);u&&(d.push(u),w.CustomExecutionDTO.is(u.execution)&&t.push(this.y(u,l,!0)))}return{tasks:d,extension:g.extension}}async w(s){return s}async G(s){let t=s&&s.length>0?s[0]:void 0;if(!t){const g=N.URI.file((0,a.homedir)());t=new b.$pi({uri:g,name:m.$Fg(g),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,t){const g=N.URI.revive(s),o={process:void 0,variables:Object.create(null)},d=await this.b.resolveWorkspaceFolder(g),l=await this.b.getWorkspaceFolders2()??[],u=await this.D.getResolver(),v=d?{uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(l);for(const I of t.variables)o.variables[I]=await u.resolveAsync(v,I);if(t.process!==void 0){let I;if(t.process.path!==void 0){I=t.process.path.split(D.$tc);for(let $=0;$<I.length;$++)I[$]=await u.resolveAsync(v,I[$])}o.process=await h.win32.findExecutable(await u.resolveAsync(v,t.process.name),t.process.cwd!==void 0?await u.resolveAsync(v,t.process.cwd):void 0,I)}return o}async $jsonTasksSupported(){return!0}async $findExecutable(s,t,g){return h.win32.findExecutable(s,t,g)}};e.$0hc=n,e.$0hc=n=Ge([Ve(0,R.$oN),Ve(1,C.$EN),Ve(2,P.$hgc),Ve(3,A.$zN),Ve(4,p.$kgc),Ve(5,k.$Igc),Ve(6,S.$pj),Ve(7,c.$2fc),Ve(8,i.$Ygc)],n)}),define(ke[369],Se([1,0,63,60]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=void 0;class h extends N.$Zgc{m(){return(0,D.homedir)()}}e.$Pic=h}),define(ke[154],Se([1,0,19,8,22,44,16,17,23,2,36]),function($e,e,D,N,h,P,A,p,b,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=e.$ihc=e.$hhc=e.$ghc=void 0;class C{constructor(i,n,r,s){this.d=i,this.e=n,this.f=r,this.g=s,this.a=null,this.b=!1,this.c=0}search(i,n){const r=this.d.folderQueries||[],s=new h.$7d(n);return new Promise((t,g)=>{this.a=new E(i);let o=!1;const d=(l,u)=>{if(!o&&!this.b){const v=this.h(l);c(l)&&typeof this.d.maxResults=="number"&&this.c+v>this.d.maxResults&&(this.b=!0,o=!0,s.cancel(),l=this.j(l,this.d.maxResults-this.c));const I=this.h(l);this.c+=I,(I>0||!c(l))&&this.a.add(l,u)}};Promise.all(r.map((l,u)=>this.k(l,v=>d(v,u),s.token))).then(l=>{s.dispose(),this.a.flush();const u=l.some(v=>!!v&&!!v.limitHit);t({limitHit:this.b||u,messages:(0,D.$Rb)(l.map(v=>v?.message?Array.isArray(v.message)?v.message:[v.message]:[])),stats:{type:this.g}})},l=>{s.dispose();const u=(0,P.$Si)(l);g(new Error(u))})})}h(i){return c(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const r=Array.isArray(i.ranges)?i.ranges:[i.ranges],s=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:r.slice(0,n),preview:{matches:s.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,r){const s=new R.$YJ(this.d,i),t=[],g={report:l=>{if(!this.l(l))return;const u=i.folder.scheme===A.Schemas.file?(0,R.$ZJ)(()=>this.f.readdir(b.$Hg(l.uri))):void 0,v=b.$Kg(i.folder,l.uri);if(v){const I=s.includedInQuery(v,p.$nc(v),u);(0,N.$Tg)(I)?t.push(I.then($=>{$&&n(l)})):I&&n(l)}}},o=this.n(i),d=await this.e.provideTextSearchResults(w(this.d.contentPattern),o,g,r);return t.length&&await Promise.all(t),d}l(i){if(c(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,R.$XJ)(this.d.includePattern,i.includePattern),r=(0,R.$XJ)(this.d.excludePattern,i.excludePattern),s={folder:k.URI.from(i.folder),excludes:r,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return s.usePCRE2=this.d.usePCRE2,s}}e.$ghc=C;function w(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class E{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new m(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!b.$Bg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$hhc=E;function S(a){return c(a)?{preview:{matches:(0,D.$2b)(a.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:a.preview.text},ranges:(0,D.$2b)(a.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function c(a){return!!a.preview}e.$ihc=c;class m{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$jhc=m}),define(ke[98],Se([1,0,3,6,5,362,20,66,13,2,154]),function($e,e,D,N,h,P,A,p,b,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=e.$lhc=e.$khc=void 0,e.$khc=(0,h.$8h)("IExtHostSearch");let C=class{constructor(c,m,a){this.k=c,this.l=m,this.n=a,this.c=this.k.getProxy(N.$jL.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new P.$fhc}o(c){return this.l.transformOutgoingScheme(c)}registerTextSearchProvider(c,m){if(this.g.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this.g.add(c);const a=this.d++;return this.e.set(a,m),this.c.$registerTextSearchProvider(a,this.o(c)),(0,D.$Rc)(()=>{this.g.delete(c),this.e.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(c,m){if(this.i.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this.i.add(c);const a=this.d++;return this.h.set(a,m),this.c.$registerFileSearchProvider(a,this.o(c)),(0,D.$Rc)(()=>{this.i.delete(c),this.h.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(c,m,a,i){const n=w(a),r=this.h.get(c);if(r)return this.j.fileSearch(n,r,s=>{this.c.$handleFileMatch(c,m,s.map(t=>t.resource))},i);throw new Error("unknown provider: "+c)}async doInternalFileSearchWithCustomCallback(c,m,a){return{messages:[]}}$clearCache(c){return this.j.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,m,a,i){const n=this.e.get(c);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const r=w(a);return this.q(r,n).search(t=>this.c.$handleTextMatch(c,m,t),i)}$enableExtensionHostSearch(){}q(c,m){return new R.$ghc(c,m,{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}};e.$lhc=C,e.$lhc=C=Ge([Ve(0,A.$oN),Ve(1,p.$egc),Ve(2,b.$pj)],C);function w(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(E),extraFileResources:S.extraFileResources&&S.extraFileResources.map(c=>k.URI.revive(c))}}e.$mhc=w;function E(S){return{...S,folder:k.URI.revive(S.folder)}}}),define(ke[370],Se([1,0,22,14,4,3,16,39,2,132,191,172,79,25,32,13,65,88,266,6,311,341,92,312,317,318,319,320,321,298,287,33,322,42,323,97,147,324,300,313,325,326,72,71,314,47,327,69,328,59,27,342,343,315,301,329,330,114,115,302,361,332,272,333,344,334,152,303,335,336,337,20,338,98,116,339,304,340,117,94,96,91,46,345,346,316,347,348,70,15,7,305,66,306,93,349,350,146,41,280,113,26,95]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i,n,r,s,t,g,o,d,l,u,v,I,$,f,y,L,T,U,j,F,M,O,z,J,te,x,X,Z,ae,_,ge,ne,K,W,re,ye,he,fe,ue,me,V,Y,de,we,Pe,ve,Ce,B,Q,ee,H,oe,le,Re,je,He,Qe,_e,at,st,rt,Le,ze,Ae,Ze,ie,se,Ie,qe,Ye,it,nt,Oe,yt,Dt,Tt,Ft,Et,Ht,Ot,Yt,Vt,Ut,et,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0;function Jt(ht){const $t=ht.get(K.$EN),Bt=ht.get(ne.$Yfc),Qt=ht.get(_.$mgc),kt=ht.get(Z.$Vgc),ft=ht.get(Yt.$hgc),It=ht.get(Ae.$IN),_t=ht.get(L.$kgc),At=ht.get(Dt.$egc),Je=ht.get(Re.$oN),Mt=ht.get(rt.$Fgc),jt=ht.get(Le.$ngc),Zt=ht.get(c.$qj),gt=ht.get(c.$pj),Nt=ht.get(it.$dzb),Pt=ht.get(t.$2fc),Wt=ht.get(Ot.$1hc),Me=ht.get(Qe.$Ngc),Fe=ht.get(x.$wgc),De=ht.get(V.$Rgc);Je.set(n.$kL.ExtHostFileSystemInfo,Bt),Je.set(n.$kL.ExtHostLogLevelServiceShape,Zt),Je.set(n.$kL.ExtHostWorkspace,ft),Je.set(n.$kL.ExtHostConfiguration,_t),Je.set(n.$kL.ExtHostExtensionService,kt),Je.set(n.$kL.ExtHostStorage,Mt),Je.set(n.$kL.ExtHostTunnelService,Nt),Je.set(n.$kL.ExtHostWindow,Wt),Je.set(n.$kL.ExtHostSecretState,Me),Je.set(n.$kL.ExtHostTelemetry,It),Je.set(n.$kL.ExtHostEditorTabs,Fe),Je.set(n.$kL.ExtHostManagedSockets,De);const ce=Je.set(n.$kL.ExtHostDecorations,ht.get(j.$7gc)),Te=Je.set(n.$kL.ExtHostDocumentsAndEditors,ht.get(te.$zN)),Be=Je.set(n.$kL.ExtHostCommands,ht.get(f.$KN)),xe=Je.set(n.$kL.ExtHostTerminalService,ht.get(Ze.$Igc)),Ke=Je.set(n.$kL.ExtHostDebugService,ht.get(U.$1gc)),ut=Je.set(n.$kL.ExtHostSearch,ht.get(He.$khc)),vt=Je.set(n.$kL.ExtHostTask,ht.get(ze.$Nhc)),Kt=Je.set(n.$kL.ExtHostOutputService,ht.get(Q.$Ahc)),St=Je.set(n.$kL.ExtHostLocalization,ht.get(me.$Qgc)),Ct=Je.set(n.$kL.ExtHostUrls,new Tt.$Xhc(Je)),pt=Je.set(n.$kL.ExtHostDocuments,new J.$Wfc(Je,Te)),Si=Je.set(n.$kL.ExtHostDocumentContentProviders,new O.$9gc(Je,Te,gt)),Ki=Je.set(n.$kL.ExtHostDocumentSaveParticipant,new z.$0gc(gt,pt,Je.getProxy(n.$jL.MainThreadBulkEdits))),Lt=Je.set(n.$kL.ExtHostNotebook,new de.$nhc(Je,Be,Te,pt,Qt,ut)),si=Je.set(n.$kL.ExtHostNotebookDocuments,new Pe.$uhc(Lt)),mi=Je.set(n.$kL.ExtHostNotebookEditors,new ve.$vhc(gt,Lt)),ui=Je.set(n.$kL.ExtHostNotebookKernels,new Ce.$whc(Je,$t,Lt,Be,gt)),Di=Je.set(n.$kL.ExtHostNotebookRenderers,new B.$yhc(Je,Lt)),Ci=Je.set(n.$kL.ExtHostNotebookDocumentSaveParticipant,new we.$thc(gt,Lt,Je.getProxy(n.$jL.MainThreadBulkEdits))),zt=Je.set(n.$kL.ExtHostEditors,new se.$bgc(Je,Te)),$i=Je.set(n.$kL.ExtHostTreeViews,new Ye.$Vhc(Je.getProxy(n.$jL.MainThreadTreeViews),Be,gt)),Ii=Je.set(n.$kL.ExtHostEditorInsets,new $.$cgc(Je.getProxy(n.$jL.MainThreadEditorInsets),zt,$t.remote)),li=Je.set(n.$kL.ExtHostDiagnostics,new F.$1fc(Je,gt,Bt,Te)),hi=Je.set(n.$kL.ExtHostLanguages,new ue.$rhc(Je,pt,Be.converter,At)),dt=Je.set(n.$kL.ExtHostLanguageFeatures,new fe.$5fc(Je,At,pt,Be,li,gt,Pt,It)),Ji=Je.set(n.$kL.ExtHostFileSystem,new ae.$_gc(Je,dt)),ei=Je.set(n.$kL.ExtHostFileSystemEventService,new ge.$ahc(Je,gt,Te)),oi=Je.set(n.$kL.ExtHostQuickOpen,(0,le.$Ehc)(Je,ft,Be)),bi=Je.set(n.$kL.ExtHostSCM,new je.$Ghc(Je,Be,pt,gt)),Pi=Je.set(n.$kL.ExtHostQuickDiff,new oe.$Dhc(Je,At)),Qi=Je.set(n.$kL.ExtHostShare,new _e.$Hhc(Je,At)),Li=Je.set(n.$kL.ExtHostComments,(0,y.$dgc)(Je,Be,pt)),wi=Je.set(n.$kL.ExtHostProgress,new H.$Chc(Je.getProxy(n.$jL.MainThreadProgress))),Zi=Je.set(n.$kL.ExtHostLabelService,new he.$qhc(Je)),Ai=Je.set(n.$kL.ExtHostTheming,new Ie.$Shc(Je)),di=Je.set(n.$kL.ExtHostAuthentication,new g.$7fc(Je)),Yi=Je.set(n.$kL.ExtHostTimeline,new qe.$Uhc(Je,Be)),pi=Je.set(n.$kL.ExtHostWebviews,new Ft.$rgc(Je,$t.remote,ft,gt,Pt)),Ri=Je.set(n.$kL.ExtHostWebviewPanels,new Et.$ugc(Je,pi,ft)),ln=Je.set(n.$kL.ExtHostCustomEditors,new T.$vgc(Je,pt,jt,pi,Ri)),Mi=Je.set(n.$kL.ExtHostWebviewViews,new Ht.$Yhc(Je,pi)),ai=Je.set(n.$kL.ExtHostTesting,new ie.$Ohc(Je,gt,Be,Te)),hn=Je.set(n.$kL.ExtHostUriOpeners,new yt.$Whc(Je)),dn=Je.set(n.$kL.ExtHostProfileContentHandlers,new ee.$Bhc(Je));Je.set(n.$kL.ExtHostInteractive,new re.$ohc(Je,Lt,Te,Be,gt));const Xi=Je.set(n.$kL.ExtHostInlineChat,new W.$bhc(Je,Be,pt,gt)),Ni=Je.set(n.$kL.ExtHostChatProvider,new u.$0fc(Je,gt)),Ti=Je.set(n.$kL.ExtHostChatAgents2,new l.$$fc(Je,Ni,gt)),xi=Je.set(n.$kL.ExtHostChatVariables,new v.$_fc(Je)),vi=Je.set(n.$kL.ExtHostChat,new d.$9fc(Je)),Fi=Je.set(n.$kL.ExtHostAiRelatedInformation,new r.$Vfc(Je)),fn=Je.set(n.$kL.ExtHostAiEmbeddingVector,new X.$$gc(Je)),yi=Je.set(n.$kL.ExtHostIssueReporter,new ye.$phc(Je)),Oi=Je.set(n.$kL.ExtHostStatusBar,new st.$Khc(Je,Be.converter)),ni=Je.set(n.$kL.ExtHostSpeech,new at.$Ihc(Je)),Ei=Object.values(n.$kL);Je.assertRegistered(Ei);const gn=new o.$8fc(Je,Te),Xt=new I.$agc(Je),fi=new Y.$shc(Je,gt),ji=new M.$8gc(Je);return s.$6fc.register(Be),function(We,ti,zi){function ot(be){return(Ee,Ue,ct)=>{const wt=be(Rt=>{try{Ee.call(Ue,Rt)}catch(un){N.$2(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event`,{cause:un})),It.onExtensionError(We.identifier,un)}});return ct?.push(wt),wt}}const bt=function(){let be=!We.isUnderDevelopment;function Ee(){be||(gt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),be=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")Ee();else{const wt=ct;typeof wt.scheme>"u"&&Ee(),typeof wt.exclusive=="boolean"&&(0,et.$LF)(We,"documentFiltersExclusive")}return ct}}(),_i={getSession(be,Ee,Ue){return di.getSession(We,be,Ee,Ue)},getSessions(be,Ee){return(0,et.$LF)(We,"authGetSessions"),di.getSessions(We,be,Ee)},async hasSession(be,Ee){return(0,et.$LF)(We,"authSession"),!!await di.getSession(We,be,Ee,{silent:!0})},get onDidChangeSessions(){return ot(di.onDidChangeSessions)},registerAuthenticationProvider(be,Ee,Ue,ct){return di.registerAuthenticationProvider(be,Ee,Ue,ct)}},mn={registerCommand(be,Ee,Ue){return Be.registerCommand(!0,be,Ee,Ue,void 0,We)},registerTextEditorCommand(be,Ee,Ue){return Be.registerCommand(!0,be,(...ct)=>{const wt=zt.getActiveTextEditor();if(!wt){gt.warn("Cannot execute "+be+" because there is no active text editor.");return}return wt.edit(Rt=>{Ee.apply(Ue,[wt,Rt,...ct])}).then(Rt=>{Rt||gt.warn("Edits from command "+be+" were not applied.")},Rt=>{gt.warn("An error occurred while running command "+be,Rt)})},void 0,void 0,We)},registerDiffInformationCommand:(be,Ee,Ue)=>((0,et.$LF)(We,"diffCommand"),Be.registerCommand(!0,be,async(...ct)=>{const wt=Te.activeEditor(!0);if(!wt){gt.warn("Cannot execute "+be+" because there is no active text editor.");return}const Rt=await zt.getDiffInformation(wt.id);Ee.apply(Ue,[Rt,...ct])},void 0,void 0,We)),executeCommand(be,...Ee){return Be.executeCommand(be,...Ee)},getCommands(be=!1){return Be.getCommands(be)}},en={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Xt.value},get shell(){return xe.getDefaultShell(!1)},get onDidChangeShell(){return ot(xe.onDidChangeShell)},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(It.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$LF)(We,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$LF)(We,"telemetry"),ot(It.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Ae.$HN)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(be,Ee){return Ae.$GN.validateSender(be),It.instantiateLogger(We,be,Ee)},openExternal(be,Ee){return Wt.openUri(be,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(be){if(be.scheme===$t.environment.appUriScheme)return Ct.createAppUri(be);try{return await Wt.asExternalUri(be,{allowTunneling:!!$t.remote.authority})}catch(Ee){if((0,A.$fg)(be,A.Schemas.http)||(0,A.$fg)(be,A.Schemas.https))return be;throw Ee}},get remoteName(){return(0,m.$dl)($t.remote.authority)},get remoteAuthority(){return(0,et.$LF)(We,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return ot(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler(be){return(0,et.$LF)(We,"handleIssueUri"),yi.registerIssueUriRequestHandler(We,be)},registerIssueDataProvider(be){return(0,et.$LF)(We,"handleIssueUri"),yi.registerIssueDataProvider(We,be)},get appQuality(){return(0,et.$LF)(We,"resolvers"),$t.quality},get appCommit(){return(0,et.$LF)(We,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(en);const tn={createTestController(be,Ee,Ue){return ai.createTestController(We,be,Ee,Ue)},createTestObserver(){return(0,et.$LF)(We,"testObserver"),ai.createTestObserver()},runTests(be){return(0,et.$LF)(We,"testObserver"),ai.runTests(be)},get onDidChangeTestResults(){return(0,et.$LF)(We,"testObserver"),ot(ai.onResultsChanged)},get testResults(){return(0,et.$LF)(We,"testObserver"),ai.results}},gi=$t.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,nn={getExtension(be,Ee){(0,et.$KF)(We,"extensionsAny")||(Ee=!1);const Ue=ti.mine.getExtensionDescription(be);if(Ue)return new Z.$Wgc(kt,We.identifier,Ue,gi,!1);if(Ee){const ct=ti.all.getExtensionDescription(be);if(ct)return new Z.$Wgc(kt,We.identifier,ct,gi,!0)}},get all(){const be=[];for(const Ee of ti.mine.getAllExtensionDescriptions())be.push(new Z.$Wgc(kt,We.identifier,Ee,gi,!1));return be},get allAcrossExtensionHosts(){(0,et.$LF)(We,"extensionsAny");const be=new E.$om(ti.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),Ee=[];for(const Ue of ti.all.getAllExtensionDescriptions()){const ct=!be.has(Ue.identifier);Ee.push(new Z.$Wgc(kt,We.identifier,Ue,gi,ct))}return Ee},get onDidChange(){return(0,et.$KF)(We,"extensionsAny")?ot(h.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):ot(ti.mine.onDidChange)}},rn={createDiagnosticCollection(be){return li.createDiagnosticCollection(We.identifier,be)},get onDidChangeDiagnostics(){return ot(li.onDidChangeDiagnostics)},getDiagnostics:be=>li.getDiagnostics(be),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage(be,Ee){return hi.changeLanguage(be.uri,Ee)},match(be,Ee){const Ue=pt.getDocumentData(Ee.uri)?.notebook;return(0,R.$Dt)(nt.LanguageSelector.from(be),Ee.uri,Ee.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(be,Ee,Ue){return dt.registerCodeActionProvider(We,bt(be),Ee,Ue)},registerDocumentPasteEditProvider(be,Ee,Ue){return(0,et.$LF)(We,"documentPaste"),dt.registerDocumentPasteEditProvider(We,bt(be),Ee,Ue)},registerCodeLensProvider(be,Ee){return dt.registerCodeLensProvider(We,bt(be),Ee)},registerDefinitionProvider(be,Ee){return dt.registerDefinitionProvider(We,bt(be),Ee)},registerDeclarationProvider(be,Ee){return dt.registerDeclarationProvider(We,bt(be),Ee)},registerImplementationProvider(be,Ee){return dt.registerImplementationProvider(We,bt(be),Ee)},registerTypeDefinitionProvider(be,Ee){return dt.registerTypeDefinitionProvider(We,bt(be),Ee)},registerHoverProvider(be,Ee){return dt.registerHoverProvider(We,bt(be),Ee,We.identifier)},registerEvaluatableExpressionProvider(be,Ee){return dt.registerEvaluatableExpressionProvider(We,bt(be),Ee,We.identifier)},registerInlineValuesProvider(be,Ee){return dt.registerInlineValuesProvider(We,bt(be),Ee,We.identifier)},registerDocumentHighlightProvider(be,Ee){return dt.registerDocumentHighlightProvider(We,bt(be),Ee)},registerMultiDocumentHighlightProvider(be,Ee){return dt.registerMultiDocumentHighlightProvider(We,bt(be),Ee)},registerLinkedEditingRangeProvider(be,Ee){return dt.registerLinkedEditingRangeProvider(We,bt(be),Ee)},registerReferenceProvider(be,Ee){return dt.registerReferenceProvider(We,bt(be),Ee)},registerRenameProvider(be,Ee){return dt.registerRenameProvider(We,bt(be),Ee)},registerDocumentSymbolProvider(be,Ee,Ue){return dt.registerDocumentSymbolProvider(We,bt(be),Ee,Ue)},registerWorkspaceSymbolProvider(be){return dt.registerWorkspaceSymbolProvider(We,be)},registerDocumentFormattingEditProvider(be,Ee){return dt.registerDocumentFormattingEditProvider(We,bt(be),Ee)},registerDocumentRangeFormattingEditProvider(be,Ee){return dt.registerDocumentRangeFormattingEditProvider(We,bt(be),Ee)},registerOnTypeFormattingEditProvider(be,Ee,Ue,...ct){return dt.registerOnTypeFormattingEditProvider(We,bt(be),Ee,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(be,Ee,Ue){return dt.registerDocumentSemanticTokensProvider(We,bt(be),Ee,Ue)},registerDocumentRangeSemanticTokensProvider(be,Ee,Ue){return dt.registerDocumentRangeSemanticTokensProvider(We,bt(be),Ee,Ue)},registerSignatureHelpProvider(be,Ee,Ue,...ct){return typeof Ue=="object"?dt.registerSignatureHelpProvider(We,bt(be),Ee,Ue):dt.registerSignatureHelpProvider(We,bt(be),Ee,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(be,Ee,...Ue){return dt.registerCompletionItemProvider(We,bt(be),Ee,Ue)},registerInlineCompletionItemProvider(be,Ee,Ue){return Ee.handleDidShowCompletionItem&&(0,et.$LF)(We,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,et.$LF)(We,"inlineCompletionsAdditions"),Ue&&(0,et.$LF)(We,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(We,bt(be),Ee,Ue)},registerDocumentLinkProvider(be,Ee){return dt.registerDocumentLinkProvider(We,bt(be),Ee)},registerColorProvider(be,Ee){return dt.registerColorProvider(We,bt(be),Ee)},registerFoldingRangeProvider(be,Ee){return dt.registerFoldingRangeProvider(We,bt(be),Ee)},registerSelectionRangeProvider(be,Ee){return dt.registerSelectionRangeProvider(We,be,Ee)},registerCallHierarchyProvider(be,Ee){return dt.registerCallHierarchyProvider(We,be,Ee)},registerTypeHierarchyProvider(be,Ee){return dt.registerTypeHierarchyProvider(We,be,Ee)},setLanguageConfiguration:(be,Ee)=>dt.setLanguageConfiguration(We,be,Ee),getTokenInformationAtPosition(be,Ee){return(0,et.$LF)(We,"tokenInformation"),hi.tokenAtPosition(be,Ee)},registerInlayHintsProvider(be,Ee){return dt.registerInlayHintsProvider(We,be,Ee)},createLanguageStatusItem(be,Ee){return hi.createLanguageStatusItem(We,be,Ee)},registerDocumentDropEditProvider(be,Ee,Ue){return dt.registerDocumentOnDropEditProvider(We,be,Ee,(0,et.$KF)(We,"dropMetadata")?Ue:void 0)}},sn={get activeTextEditor(){return zt.getActiveTextEditor()},get visibleTextEditors(){return zt.getVisibleTextEditors()},get activeTerminal(){return xe.activeTerminal},get terminals(){return xe.terminals},async showTextDocument(be,Ee,Ue){b.URI.isUri(be)&&be.scheme===A.Schemas.vscodeRemote&&!be.authority&&Pt.report("workspace.showTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await(b.URI.isUri(be)?Promise.resolve(on.openTextDocument(be)):Promise.resolve(be));return zt.showTextDocument(ct,Ee,Ue)},createTextEditorDecorationType(be){return zt.createTextEditorDecorationType(We,be)},onDidChangeActiveTextEditor(be,Ee,Ue){return ot(zt.onDidChangeActiveTextEditor)(be,Ee,Ue)},onDidChangeVisibleTextEditors(be,Ee,Ue){return ot(zt.onDidChangeVisibleTextEditors)(be,Ee,Ue)},onDidChangeTextEditorSelection(be,Ee,Ue){return ot(zt.onDidChangeTextEditorSelection)(be,Ee,Ue)},onDidChangeTextEditorOptions(be,Ee,Ue){return ot(zt.onDidChangeTextEditorOptions)(be,Ee,Ue)},onDidChangeTextEditorVisibleRanges(be,Ee,Ue){return ot(zt.onDidChangeTextEditorVisibleRanges)(be,Ee,Ue)},onDidChangeTextEditorViewColumn(be,Ee,Ue){return ot(zt.onDidChangeTextEditorViewColumn)(be,Ee,Ue)},onDidCloseTerminal(be,Ee,Ue){return ot(xe.onDidCloseTerminal)(be,Ee,Ue)},onDidOpenTerminal(be,Ee,Ue){return ot(xe.onDidOpenTerminal)(be,Ee,Ue)},onDidChangeActiveTerminal(be,Ee,Ue){return ot(xe.onDidChangeActiveTerminal)(be,Ee,Ue)},onDidChangeTerminalDimensions(be,Ee,Ue){return(0,et.$LF)(We,"terminalDimensions"),ot(xe.onDidChangeTerminalDimensions)(be,Ee,Ue)},onDidChangeTerminalState(be,Ee,Ue){return ot(xe.onDidChangeTerminalState)(be,Ee,Ue)},onDidWriteTerminalData(be,Ee,Ue){return(0,et.$LF)(We,"terminalDataWriteEvent"),ot(xe.onDidWriteTerminalData)(be,Ee,Ue)},onDidExecuteTerminalCommand(be,Ee,Ue){return(0,et.$LF)(We,"terminalExecuteCommandEvent"),ot(xe.onDidExecuteTerminalCommand)(be,Ee,Ue)},get state(){return Wt.getState(We)},onDidChangeWindowState(be,Ee,Ue){return ot(Wt.onDidChangeWindowState)(be,Ee,Ue)},showInformationMessage(be,...Ee){return fi.showMessage(We,p.default.Info,be,Ee[0],Ee.slice(1))},showWarningMessage(be,...Ee){return fi.showMessage(We,p.default.Warning,be,Ee[0],Ee.slice(1))},showErrorMessage(be,...Ee){return fi.showMessage(We,p.default.Error,be,Ee[0],Ee.slice(1))},showQuickPick(be,Ee,Ue){return oi.showQuickPick(We,be,Ee,Ue)},showWorkspaceFolderPick(be){return oi.showWorkspaceFolderPick(be)},showInputBox(be,Ee){return oi.showInput(be,Ee)},showOpenDialog(be){return ji.showOpenDialog(We,be)},showSaveDialog(be){return ji.showSaveDialog(be)},createStatusBarItem(be,Ee,Ue){let ct,wt,Rt;return typeof be=="string"?(ct=be,wt=Ee,Rt=Ue):(wt=be,Rt=Ee),Oi.createStatusBarEntry(We,ct,wt,Rt)},setStatusBarMessage(be,Ee){return Oi.setStatusBarMessage(be,Ee)},withScmProgress(be){return Pt.report("window.withScmProgress",We,"Use 'withProgress' instead."),wi.withProgress(We,{location:Oe.ProgressLocation.SourceControl},(Ee,Ue)=>be({report(ct){}}))},withProgress(be,Ee){return wi.withProgress(We,be,Ee)},createOutputChannel(be,Ee){return Kt.createOutputChannel(be,Ee,We)},createWebviewPanel(be,Ee,Ue,ct){return Ri.createWebviewPanel(We,be,Ee,Ue,ct)},createWebviewTextEditorInset(be,Ee,Ue,ct){return(0,et.$LF)(We,"editorInsets"),Ii.createWebviewEditorInset(be,Ee,Ue,ct,We)},createTerminal(be,Ee,Ue){return typeof be=="object"?"pty"in be?xe.createExtensionTerminal(be):xe.createTerminalFromOptions(be):xe.createTerminal(be,Ee,Ue)},registerTerminalLinkProvider(be){return xe.registerLinkProvider(be)},registerTerminalProfileProvider(be,Ee){return xe.registerProfileProvider(We,be,Ee)},registerTerminalQuickFixProvider(be,Ee){return(0,et.$LF)(We,"terminalQuickFixProvider"),xe.registerTerminalQuickFixProvider(be,We.identifier.value,Ee)},registerTreeDataProvider(be,Ee){return $i.registerTreeDataProvider(be,Ee,We)},createTreeView(be,Ee){return $i.createTreeView(be,Ee,We)},registerWebviewPanelSerializer:(be,Ee)=>Ri.registerWebviewPanelSerializer(We,be,Ee),registerCustomEditorProvider:(be,Ee,Ue={})=>ln.registerCustomEditorProvider(We,be,Ee,Ue),registerFileDecorationProvider(be){return ce.registerFileDecorationProvider(be,We)},registerUriHandler(be){return Ct.registerUriHandler(We,be)},createQuickPick(){return oi.createQuickPick(We)},createInputBox(){return oi.createInputBox(We)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(be,Ee,Ue){return ot(Ai.onDidChangeActiveColorTheme)(be,Ee,Ue)},registerWebviewViewProvider(be,Ee,Ue){return Mi.registerWebviewViewProvider(We,be,Ee,Ue?.webviewOptions)},get activeNotebookEditor(){return Lt.activeNotebookEditor},onDidChangeActiveNotebookEditor(be,Ee,Ue){return ot(Lt.onDidChangeActiveNotebookEditor)(be,Ee,Ue)},get visibleNotebookEditors(){return Lt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Lt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(be,Ee,Ue){return ot(mi.onDidChangeNotebookEditorSelection)(be,Ee,Ue)},onDidChangeNotebookEditorVisibleRanges(be,Ee,Ue){return ot(mi.onDidChangeNotebookEditorVisibleRanges)(be,Ee,Ue)},showNotebookDocument(be,Ee){return Lt.showNotebookDocument(be,Ee)},registerExternalUriOpener(be,Ee,Ue){return(0,et.$LF)(We,"externalUriOpener"),hn.registerExternalUriOpener(We.identifier,be,Ee,Ue)},registerProfileContentHandler(be,Ee){return(0,et.$LF)(We,"profileContentHandlers"),dn.registerProfileContentHandler(We,be,Ee)},registerQuickDiffProvider(be,Ee,Ue,ct){return(0,et.$LF)(We,"quickDiffProvider"),Pi.registerQuickDiffProvider(bt(be),Ee,Ue,ct)},get tabGroups(){return Fe.tabGroups},registerShareProvider(be,Ee){return(0,et.$LF)(We,"shareProvider"),Qi.registerShareProvider(bt(be),Ee)}},on={get rootPath(){return Pt.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(be){throw new N.$9("rootPath")},getWorkspaceFolder(be){return ft.getWorkspaceFolder(be)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(be){throw new N.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(be){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(be,Ee,...Ue)=>ft.updateWorkspaceFolders(We,be,Ee||0,...Ue),onDidChangeWorkspaceFolders:function(be,Ee,Ue){return ot(ft.onDidChangeWorkspace)(be,Ee,Ue)},asRelativePath:(be,Ee)=>ft.getRelativePath(be,Ee),findFiles:(be,Ee,Ue,ct)=>ft.findFiles(be,Ee,Ue,We.identifier,ct),findTextInFiles:(be,Ee,Ue,ct)=>{(0,et.$LF)(We,"findTextInFiles");let wt,Rt;return typeof Ee=="object"?(wt=Ee,Rt=Ue):(wt={},Rt=Ee,ct=Ue),ft.findTextInFiles(be,wt||{},Rt,We.identifier,ct)},save:be=>ft.save(be),saveAs:be=>ft.saveAs(be),saveAll:be=>ft.saveAll(be),applyEdit(be,Ee){return gn.applyWorkspaceEdit(be,We,Ee)},createFileSystemWatcher:(be,Ee,Ue,ct)=>{let wt;return typeof Ee=="boolean"?wt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ct,correlate:!1}:Ee&&((0,et.$LF)(We,"createFileSystemWatcher"),wt={...Ee,correlate:!0}),ei.createFileSystemWatcher(ft,We,be,wt)},get textDocuments(){return pt.getAllDocumentData().map(be=>be.document)},set textDocuments(be){throw new N.$9("textDocuments")},openTextDocument(be){let Ee;const Ue=be;if(typeof be=="string")Ee=Promise.resolve(b.URI.file(be));else if(b.URI.isUri(be))Ee=Promise.resolve(be);else if(!Ue||typeof Ue=="object")Ee=pt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ct=>(ct.scheme===A.Schemas.vscodeRemote&&!ct.authority&&Pt.report("workspace.openTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority."),pt.ensureDocumentData(ct).then(wt=>wt.document)))},onDidOpenTextDocument:(be,Ee,Ue)=>ot(pt.onDidAddDocument)(be,Ee,Ue),onDidCloseTextDocument:(be,Ee,Ue)=>ot(pt.onDidRemoveDocument)(be,Ee,Ue),onDidChangeTextDocument:(be,Ee,Ue)=>ot(pt.onDidChangeDocument)(be,Ee,Ue),onDidSaveTextDocument:(be,Ee,Ue)=>ot(pt.onDidSaveDocument)(be,Ee,Ue),onWillSaveTextDocument:(be,Ee,Ue)=>ot(Ki.getOnWillSaveTextDocumentEvent(We))(be,Ee,Ue),get notebookDocuments(){return Lt.notebookDocuments.map(be=>be.apiNotebook)},async openNotebookDocument(be,Ee){let Ue;if(b.URI.isUri(be))Ue=be,await Lt.openNotebookDocument(be);else if(typeof be=="string")Ue=b.URI.revive(await Lt.createNotebookDocument({viewType:be,content:Ee}));else throw new Error("Invalid arguments");return Lt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(be,Ee,Ue){return ot(si.onDidSaveNotebookDocument)(be,Ee,Ue)},onDidChangeNotebookDocument(be,Ee,Ue){return ot(si.onDidChangeNotebookDocument)(be,Ee,Ue)},onWillSaveNotebookDocument(be,Ee,Ue){return ot(Ci.getOnWillSaveNotebookDocumentEvent(We))(be,Ee,Ue)},get onDidOpenNotebookDocument(){return ot(Lt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Lt.onDidCloseNotebookDocument)},registerNotebookSerializer(be,Ee,Ue,ct){return Lt.registerNotebookSerializer(We,be,Ee,Ue,(0,et.$KF)(We,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(be,Ee,Ue)=>ot(zi.onDidChangeConfiguration)(be,Ee,Ue),getConfiguration(be,Ee){return Ee=arguments.length===1?void 0:Ee,zi.getConfiguration(be,Ee,We)},registerTextDocumentContentProvider(be,Ee){return Si.registerTextDocumentContentProvider(be,Ee)},registerTaskProvider:(be,Ee)=>(Pt.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(We,be,Ee)),registerFileSystemProvider(be,Ee,Ue){return(0,P.$Qc)(Ji.registerFileSystemProvider(We,be,Ee,Ue),Qt.addFileSystemProvider(be,Ee,Ue))},get fs(){return Qt.value},registerFileSearchProvider:(be,Ee)=>((0,et.$LF)(We,"fileSearchProvider"),ut.registerFileSearchProvider(be,Ee)),registerTextSearchProvider:(be,Ee)=>((0,et.$LF)(We,"textSearchProvider"),ut.registerTextSearchProvider(be,Ee)),registerRemoteAuthorityResolver:(be,Ee)=>((0,et.$LF)(We,"resolvers"),kt.registerRemoteAuthorityResolver(be,Ee)),registerResourceLabelFormatter:be=>((0,et.$LF)(We,"resolvers"),Zi.$registerResourceLabelFormatter(be)),getRemoteExecServer:be=>((0,et.$LF)(We,"resolvers"),kt.getRemoteExecServer(be)),onDidCreateFiles:(be,Ee,Ue)=>ot(ei.onDidCreateFile)(be,Ee,Ue),onDidDeleteFiles:(be,Ee,Ue)=>ot(ei.onDidDeleteFile)(be,Ee,Ue),onDidRenameFiles:(be,Ee,Ue)=>ot(ei.onDidRenameFile)(be,Ee,Ue),onWillCreateFiles:(be,Ee,Ue)=>ot(ei.getOnWillCreateFileEvent(We))(be,Ee,Ue),onWillDeleteFiles:(be,Ee,Ue)=>ot(ei.getOnWillDeleteFileEvent(We))(be,Ee,Ue),onWillRenameFiles:(be,Ee,Ue)=>ot(ei.getOnWillRenameFileEvent(We))(be,Ee,Ue),openTunnel:be=>((0,et.$LF)(We,"tunnels"),Nt.openTunnel(We,be).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,et.$LF)(We,"tunnels"),Nt.getTunnels()},onDidChangeTunnels:(be,Ee,Ue)=>((0,et.$LF)(We,"tunnels"),ot(Nt.onDidChangeTunnels)(be,Ee,Ue)),registerPortAttributesProvider:(be,Ee)=>((0,et.$LF)(We,"portsAttributes"),Nt.registerPortsAttributesProvider(be,Ee)),registerTunnelProvider:(be,Ee)=>((0,et.$LF)(We,"tunnelFactory"),Nt.registerTunnelProvider(be,Ee)),registerTimelineProvider:(be,Ee)=>((0,et.$LF)(We,"timeline"),Yi.registerTimelineProvider(be,Ee,We.identifier,Be.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:be=>((0,et.$LF)(We,"workspaceTrust"),ft.requestWorkspaceTrust(be)),onDidGrantWorkspaceTrust:(be,Ee,Ue)=>ot(ft.onDidGrantWorkspaceTrust)(be,Ee,Ue),registerEditSessionIdentityProvider:(be,Ee)=>((0,et.$LF)(We,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(be,Ee)),onWillCreateEditSessionIdentity:(be,Ee,Ue)=>((0,et.$LF)(We,"editSessionIdentityProvider"),ot(ft.getOnWillCreateEditSessionIdentityEvent(We))(be,Ee,Ue)),registerCanonicalUriProvider:(be,Ee)=>((0,et.$LF)(We,"canonicalUriProvider"),ft.registerCanonicalUriProvider(be,Ee)),getCanonicalUri:(be,Ee,Ue)=>((0,et.$LF)(We,"canonicalUriProvider"),ft.provideCanonicalUri(be,Ee,Ue))},$n={get inputBox(){return Pt.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(We)},createSourceControl(be,Ee,Ue){return bi.createSourceControl(We,be,Ee,Ue)}},an={createCommentController(be,Ee){return Li.createCommentController(We,be,Ee)}},cn={get activeDebugSession(){return Ke.activeDebugSession},get activeDebugConsole(){return Ke.activeDebugConsole},get breakpoints(){return Ke.breakpoints},get stackFrameFocus(){return Ke.stackFrameFocus},registerDebugVisualizationProvider(be,Ee){return(0,et.$LF)(We,"debugVisualization"),Ke.registerDebugVisualizationProvider(We,be,Ee)},onDidStartDebugSession(be,Ee,Ue){return ot(Ke.onDidStartDebugSession)(be,Ee,Ue)},onDidTerminateDebugSession(be,Ee,Ue){return ot(Ke.onDidTerminateDebugSession)(be,Ee,Ue)},onDidChangeActiveDebugSession(be,Ee,Ue){return ot(Ke.onDidChangeActiveDebugSession)(be,Ee,Ue)},onDidReceiveDebugSessionCustomEvent(be,Ee,Ue){return ot(Ke.onDidReceiveDebugSessionCustomEvent)(be,Ee,Ue)},onDidChangeBreakpoints(be,Ee,Ue){return ot(Ke.onDidChangeBreakpoints)(be,Ee,Ue)},onDidChangeStackFrameFocus(be,Ee,Ue){return(0,et.$LF)(We,"debugFocus"),ot(Ke.onDidChangeStackFrameFocus)(be,Ee,Ue)},registerDebugConfigurationProvider(be,Ee,Ue){return Ke.registerDebugConfigurationProvider(be,Ee,Ue||Vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(be,Ee){return Ke.registerDebugAdapterDescriptorFactory(We,be,Ee)},registerDebugAdapterTrackerFactory(be,Ee){return Ke.registerDebugAdapterTrackerFactory(be,Ee)},startDebugging(be,Ee,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Ke.startDebugging(be,Ee,{parentSession:Ue}):Ke.startDebugging(be,Ee,Ue||{})},stopDebugging(be){return Ke.stopDebugging(be)},addBreakpoints(be){return Ke.addBreakpoints(be)},removeBreakpoints(be){return Ke.removeBreakpoints(be)},asDebugSourceUri(be,Ee){return Ke.asDebugSourceUri(be,Ee)}},Ui={registerTaskProvider:(be,Ee)=>vt.registerTaskProvider(We,be,Ee),fetchTasks:be=>vt.fetchTasks(be),executeTask:be=>vt.executeTask(We,be),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(be,Ee,Ue)=>ot(vt.onDidStartTask)(be,Ee,Ue),onDidEndTask:(be,Ee,Ue)=>ot(vt.onDidEndTask)(be,Ee,Ue),onDidStartTaskProcess:(be,Ee,Ue)=>ot(vt.onDidStartTaskProcess)(be,Ee,Ue),onDidEndTaskProcess:(be,Ee,Ue)=>ot(vt.onDidEndTaskProcess)(be,Ee,Ue)},Bi={createNotebookController(be,Ee,Ue,ct,wt){return ui.createNotebookController(We,be,Ee,Ue,ct,(0,et.$KF)(We,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(be,Ee)=>Lt.registerNotebookCellStatusBarItemProvider(We,be,Ee),createRendererMessaging(be){return Di.createRendererMessaging(We,be)},createNotebookControllerDetectionTask(be){return(0,et.$LF)(We,"notebookKernelSource"),ui.createNotebookControllerDetectionTask(We,be)},registerKernelSourceActionProvider(be,Ee){return(0,et.$LF)(We,"notebookKernelSource"),ui.registerKernelSourceActionProvider(We,be,Ee)},onDidChangeNotebookCellExecutionState(be,Ee,Ue){return(0,et.$LF)(We,"notebookCellExecutionState"),ot(ui.onDidChangeNotebookCellExecutionState)(be,Ee,Ue)}},Wi={t(...be){if(typeof be[0]=="string"){const Ee=be.shift(),Ue=!be||typeof be[0]!="object"?be:be[0];return St.getMessage(We.identifier.value,{message:Ee,args:Ue})}return St.getMessage(We.identifier.value,be[0])},get bundle(){return St.getBundle(We.identifier.value)},get uri(){return St.getBundleUri(We.identifier.value)}},ki={_version:1,registerInteractiveEditorSessionProvider(be,Ee){return(0,et.$LF)(We,"interactive"),Xi.registerProvider(We,be,Ee)},registerInteractiveSessionProvider(be,Ee){return(0,et.$LF)(We,"interactive"),vi.registerChatProvider(We,be,Ee)},sendInteractiveRequestToProvider(be,Ee){return(0,et.$LF)(We,"interactive"),vi.sendInteractiveRequestToProvider(be,Ee)},transferChatSession(be,Ee){return(0,et.$LF)(We,"interactive"),vi.transferChatSession(be,Ee)}},Vi={getRelatedInformation(be,Ee){return(0,et.$LF)(We,"aiRelatedInformation"),Fi.getRelatedInformation(We,be,Ee)},registerRelatedInformationProvider(be,Ee){return(0,et.$LF)(We,"aiRelatedInformation"),Fi.registerRelatedInformationProvider(We,be,Ee)},registerEmbeddingVectorProvider(be,Ee){return(0,et.$LF)(We,"aiRelatedInformation"),fn.registerEmbeddingVectorProvider(We,be,Ee)}},qi={registerChatResponseProvider(be,Ee,Ue){return(0,et.$LF)(We,"chatProvider"),Ni.registerProvider(We.identifier,be,Ee,Ue)},requestChatAccess(be){return(0,et.$LF)(We,"chatRequestAccess"),Ni.requestChatResponseProvider(We.identifier,be)},registerVariable(be,Ee,Ue){return(0,et.$LF)(We,"chatAgents2"),xi.registerVariableResolver(We,be,Ee,Ue)},registerMappedEditsProvider(be,Ee){return(0,et.$LF)(We,"mappedEditsProvider"),dt.registerMappedEditsProvider(We,be,Ee)},createChatAgent(be,Ee){return(0,et.$LF)(We,"chatAgents2"),Ti.createChatAgent(We,be,Ee)}},bn={registerSpeechProvider(be,Ee){return(0,et.$LF)(We,"speech"),ni.registerProvider(We.identifier,be,Ee)}};return{version:$t.version,ai:Vi,authentication:_i,commands:mn,comments:an,chat:qi,debug:cn,env:en,extensions:nn,interactive:ki,l10n:Wi,languages:rn,notebooks:Bi,scm:$n,speech:bn,tasks:Ui,tests:tn,window:sn,workspace:on,Breakpoint:Oe.$kM,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Oe.ChatAgentResultFeedbackKind,ChatMessage:Oe.$dN,ChatMessageRole:Oe.ChatMessageRole,ChatVariableLevel:Oe.ChatVariableLevel,ChatAgentCompletionItem:Oe.$cN,CallHierarchyIncomingCall:Oe.$JL,CallHierarchyItem:Oe.$IL,CallHierarchyOutgoingCall:Oe.$KL,CancellationError:N.$5,CancellationTokenSource:D.$7d,CandidatePortSource:n.CandidatePortSource,CodeAction:Oe.$FL,CodeActionKind:Oe.$GL,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$LL,Color:Oe.$YL,ColorInformation:Oe.$ZL,ColorPresentation:Oe.$1L,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CompletionItem:Oe.$SL,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$TL,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$9L,DebugAdapterExecutable:Oe.$oM,DebugAdapterInlineImplementation:Oe.$rM,DebugAdapterNamedPipeServer:Oe.$qM,DebugAdapterServer:Oe.$pM,DebugConfigurationProviderTriggerKind:Vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DebugVisualization:Oe.$GM,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$zL,DiagnosticRelatedInformation:Oe.$yL,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$lL,DocumentHighlight:Oe.$BL,DocumentHighlightKind:Oe.DocumentHighlightKind,MultiDocumentHighlight:Oe.$CL,DocumentLink:Oe.$XL,DocumentSymbol:Oe.$EL,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$uM,InlineValueText:Oe.$vM,InlineValueVariableLookup:Oe.$wM,InlineValueEvaluatableExpression:Oe.$xM,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:h.$Wd,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$IM,FileDecoration2:Oe.$IM,FileSystemError:Oe.$zM,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:Oe.$AM,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$mM,InlineCompletionItem:Oe.$UL,InlineCompletionList:Oe.$VL,Hover:Oe.$AL,IndentAction:C.IndentAction,Location:Oe.$xL,MarkdownString:Oe.$ML,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:Oe.$NL,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$mL,ProcessExecution:Oe.$7L,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$HM,Range:Oe.$nL,RelativePattern:Oe.$iM,Selection:Oe.$oL,SelectionRange:Oe.$HL,SemanticTokens:Oe.$DM,SemanticTokensBuilder:Oe.$CM,SemanticTokensEdit:Oe.$EM,SemanticTokensEdits:Oe.$FM,SemanticTokensLegend:Oe.$BM,ShellExecution:Oe.$8L,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$PL,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$OL,SnippetString:Oe.$wL,SourceBreakpoint:Oe.$lM,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$DL,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$0L,TaskGroup:Oe.$6L,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$2L,TerminalQuickFixTerminalCommand:Oe.$4L,TerminalQuickFixOpener:Oe.$3L,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$5L,TerminalExitReason:Oe.TerminalExitReason,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$sL,SnippetTextEdit:Oe.$uL,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$hM,ThemeIcon:Oe.$gM,TreeItem:Oe.$$L,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$4M,UIKind:Ut.UIKind,Uri:b.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$vL,DocumentDropEdit:Oe.$eM,DocumentPasteEdit:Oe.$fM,InlayHint:Oe.$RL,InlayHintLabelPart:Oe.$QL,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$rL,ResolvedAuthority:Oe.$pL,ManagedResolvedAuthority:Oe.$qL,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$SM,NotebookRange:Oe.$KM,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$LM,NotebookData:Oe.$MM,NotebookRendererScript:Oe.$QM,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$OM,NotebookCellOutputItem:Oe.$NM,NotebookCellStatusBarItem:Oe.$PM,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$tL,NotebookKernelSourceAction:Oe.$RM,NotebookVariablesRequestKind:Oe.NotebookVariablesRequestKind,PortAttributes:Oe.$UM,LinkedEditingRanges:Oe.$TM,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$VM,TestMessage:Oe.$WM,TestMessage2:Oe.$WM,TestTag:Oe.$XM,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:Oe.$dM,DataTransferItem:Oe.$_L,CoveredCount:Oe.$YM,FileCoverage:Oe.$ZM,StatementCoverage:Oe.$1M,BranchCoverage:Oe.$2M,FunctionCoverage:Oe.$3M,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$5M,TabInputTextDiff:Oe.$6M,TabInputTextMerge:Oe.$7M,TabInputCustom:Oe.$8M,TabInputNotebook:Oe.$0M,TabInputNotebookDiff:Oe.$$M,TabInputWebview:Oe.$9M,TabInputTerminal:Oe.$_M,TabInputInteractiveWindow:Oe.$aN,TabInputChat:Oe.$bN,TelemetryTrustedValue:a.$No,LogLevel:c.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,ChatAgentCopyKind:Oe.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Oe.$sM,ThreadFocus:Oe.$tM,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus,KeywordRecognitionStatus:Oe.KeywordRecognitionStatus}}}e.$2hc=Jt}),define(ke[371],Se([1,0,84,152,41,147,42,33,72,46,96,97,98,117,70,92,146,69,59,116,91,71,145,13,60,114,115]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i,n,r,s,t,g,o,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$1r)(d.$Qgc,d.$Pgc,1),(0,D.$1r)(g.$qj,t.$3hc,1),(0,D.$1r)(c.$2fc,c.$3fc,1),(0,D.$1r)(p.$KN,p.$JN,0),(0,D.$1r)(A.$kgc,A.$igc,0),(0,D.$1r)(a.$mgc,a.$lgc,0),(0,D.$1r)(C.$1gc,C.$5gc,0),(0,D.$1r)(P.$7gc,P.$6gc,0),(0,D.$1r)(b.$zN,b.$yN,0),(0,D.$1r)(l.$Rgc,l.$Sgc,0),(0,D.$1r)(i.$Yfc,i.$Xfc,0),(0,D.$1r)(N.$Ahc,N.$zhc,1),(0,D.$1r)(w.$khc,w.$lhc,0),(0,D.$1r)(E.$Fgc,E.$Egc,0),(0,D.$1r)(R.$Nhc,R.$Mhc,0),(0,D.$1r)(k.$Igc,k.$Lgc,0),(0,D.$1r)(S.$dzb,S.$ezb,0),(0,D.$1r)(m.$1hc,m.$Zhc,0),(0,D.$1r)(h.$hgc,h.$ggc,0),(0,D.$1r)(n.$Ngc,n.$Mgc,0),(0,D.$1r)(r.$IN,r.$FN,0),(0,D.$1r)(s.$wgc,s.$xgc,0),(0,D.$1r)(o.$Ygc,o.$Zgc,0)}),define(ke[119],Se([1,0,19,13,36,95]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iic=e.$hic=e.$gic=void 0;function A(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$gic=A;function p(C,w,E,S){const c=(0,D.$2b)(E,b),m=new h.$KJ(w,c,S),a=m.preview.matches;return{ranges:(0,D.$2b)(c,k),uri:C,preview:{text:m.preview.text,matches:(0,D.$2b)(a,k)}}}e.$hic=p;function b(C){return new h.$LJ(C.start.line,C.start.character,C.end.line,C.end.character)}function k(C){return new P.$zJ(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let R=class{constructor(w,E){this.a=w,this.b=E}appendLine(w){this.b.debug(`${this.a}#search`,w)}};e.$iic=R,e.$iic=R=Ge([Ve(1,N.$pj)],R)}),define(ke[372],Se([1,0,50,17,76,34,11,12,119,373]),function($e,e,D,N,h,P,A,p,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=e.$kic=e.$jic=void 0;const R=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(n,r,s,t){const g=w(n,r,s,t),o=r.folder.fsPath;return{cmd:D.spawn(R,g.args,{cwd:o}),rgDiskPath:R,siblingClauses:g.siblingClauses,rgArgs:g,cwd:o}}e.$jic=C;function w(n,r,s,t){const g=["--files","--hidden","--case-sensitive","--no-require-git"];S([r],s,!1).forEach(d=>{const l=(0,b.$gic)(d);if(g.push("-g",l),A.$j){const u=(0,h.$Jl)(l);u!==l&&g.push("-g",u)}});const o=E([r],t,void 0,!1);return o.globArgs.forEach(d=>{const l=`!${(0,b.$gic)(d)}`;if(g.push("-g",l),A.$j){const u=(0,h.$Jl)(l);u!==l&&g.push("-g",u)}}),r.disregardIgnoreFiles!==!1?g.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&g.push("--no-ignore-parent"),r.ignoreSymlinks||g.push("--follow"),n.exists&&g.push("--quiet"),g.push("--no-config"),r.disregardGlobalIgnoreFiles&&g.push("--no-ignore-global"),{args:g,siblingClauses:o.siblingClauses}}function E(n,r,s,t=!0){const g=[];let o={};return n.forEach(d=>{const l=Object.assign({},d.excludePattern||{},r||{}),u=c(l,t?d.folder.fsPath:void 0,s);g.push(...u.globArgs),u.siblingClauses&&(o=Object.assign(o,u.siblingClauses))}),{globArgs:g,siblingClauses:o}}function S(n,r,s=!0){const t=[];return n.forEach(g=>{const o=Object.assign({},r||{},g.includePattern||{}),d=c(o,s?g.folder.fsPath:void 0);t.push(...d.globArgs)}),t}function c(n,r,s){const t=[],g={};return Object.keys(n).forEach(o=>{if(s&&s.has(o)||!o)return;const d=n[o];o=a(r?m(r,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof d=="boolean"&&d?(o.startsWith("\\\\")&&(o+="**"),t.push(i(o))):d&&d.when&&(g[o]=d)}),{globArgs:t,siblingClauses:g}}function m(n,r){return N.$ic(r)?r:N.$jc(n,r)}e.$kic=m;function a(n){return n=p.$Ve(n,"\\"),p.$Ve(n,"/")}function i(n){return P.$5f(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$lic=i}),define(ke[374],Se([1,0,50,57,17,375,19,44,35,76,34,11,38,12,18,31,36,372,129]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=e.$mic=void 0;const n=new Set;process.on("exit",()=>{n.forEach(o=>o())});class r{constructor(d){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=d,this.b=d.filePattern||"",this.d=d.includePattern&&b.$Oj(d.includePattern),this.f=d.maxResults||null,this.g=!!d.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$2q)(this.b).normalizedLowercase),this.u=d.excludePattern&&b.$Oj(d.excludePattern),this.t=new Map,d.folderQueries.forEach(l=>{const u=Object.assign({},l.excludePattern||{},this.a.excludePattern||{}),v=l.folder.fsPath;d.folderQueries.map(I=>I.folder.fsPath).filter(I=>I!==v).forEach(I=>{(0,R.$9f)(I,v)&&(u[h.$lc(v,I)]=!0)}),this.t.set(v,new t(u,v))})}cancel(){this.l=!0,n.forEach(d=>d())}walk(d,l,u,v,I){if(this.m=w.$Sd.create(!1),this.l)return I(null,this.j);l.forEach($=>{const f=h.$nc($.fsPath);this.u&&this.u($.fsPath,f)||this.J(u,{relativePath:$.fsPath,searchPath:void 0})}),this.r=w.$Sd.create(!1),this.w(d,($,f)=>{this.x(this.y,this,$,u,v,y=>{if(y){const L=(0,p.$Si)(y);console.error(L),this.q.push(L),f(y,void 0)}else f(null,void 0)})},($,f)=>{this.m.stop();const y=$?A.$Hb($)[0]:null;I(y,this.j)})}w(d,l,u){const v=new Array(d.length),I=new Array(d.length);let $=!1,f=0;if(d.length===0)return u(null,[]);d.forEach((y,L)=>{l(y,(T,U)=>{if(T?($=!0,v[L]=null,I[L]=T):(v[L]=U,I[L]=null),++f===d.length)return u($?I:null,v)})})}x(d,l,...u){try{d.apply(l,u)}catch(v){u[u.length-1](v)}}y(d,l,u,v){const I=d.folder.fsPath,$=C.$j,f=()=>j&&j.kill();n.add(f);let y=z=>{n.delete(f),y=()=>{},v(z)},L="";const T=this.D(),U=(0,a.$jic)(this.a,d,this.a.includePattern,this.t.get(d.folder.fsPath).expression),j=U.cmd,F=!Object.keys(U.siblingClauses).length,M=U.rgArgs.args.map(z=>z.match(/^-/)?z:`'${z}'`).join(" ");let O=`${U.rgDiskPath} ${M}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),u({message:O}),this.s=0,this.z(j,"utf8",u,(z,J,te)=>{if(z){y(z);return}if(this.j){y();return}const X=(L+($?k.$Il(J||""):J)).split(`
`);if(te){const Z=X.length;X[Z-1]=X[Z-1].trim(),X[Z-1]||X.pop()}else L=X.pop()||"";if(X.length&&X[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.s+=X.length,F){for(const Z of X)if(this.J(l,{base:I,relativePath:Z,searchPath:this.N(d,Z)}),this.j){f();break}(te||this.j)&&y();return}this.G(d,T,I,X,l),te&&(this.H(T,I,l),y())})}spawnFindCmd(d){const l=this.t.get(d.folder.fsPath),u=l.getBasenameTerms(),v=l.getPathTerms(),I=["-L","."];if(u.length||v.length){I.push("-not","(","(");for(const $ of u)I.push("-name",$),I.push("-o");for(const $ of v)I.push("-path",$),I.push("-o");I.pop(),I.push(")","-prune",")")}return I.push("-type","f"),D.spawn("find",I,{cwd:d.folder.fsPath})}readStdout(d,l,u){let v="";this.z(d,l,()=>{},(I,$,f)=>{if(I){u(I);return}v+=$,f&&u(null,v)})}z(d,l,u,v){let I=(y,L,T)=>{(y||T)&&(I=()=>{},this.r?.stop()),v(y,L,T)},$=!1;d.stdout?(this.A(d.stdout,l,I),d.stdout.once("data",()=>$=!0)):u({message:"stdout is null"});let f;d.stderr?f=this.B(d.stderr):u({message:"stderr is null"}),d.on("error",y=>{I(y)}),d.on("close",y=>{let L;!$&&(L=this.C(f,l))&&g(L)?I(new Error(`command failed with error code ${y}: ${this.C(f,l)}`)):(this.g&&y===0&&(this.j=!0),I(null,"",!0))})}A(d,l,u){const v=new P.StringDecoder(l);return d.on("data",I=>{u(null,v.write(I))}),v}B(d){const l=[];return d.on("data",u=>{l.push(u)}),l}C(d,l){const u=new P.StringDecoder(l);return d.map(v=>u.write(v)).join("")}D(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}G(d,{pathToEntries:l},u,v,I){v.indexOf(this.b)!==-1&&this.J(I,{base:u,relativePath:this.b,searchPath:this.N(d,this.b)});const $=f=>{const y=h.$nc(f),L=h.$mc(f);let T=l[L];T||(T=l[L]=[],$(L)),T.push({base:u,relativePath:f,basename:y,searchPath:this.N(d,f)})};v.forEach($)}H({rootEntries:d,pathToEntries:l},u,v){const I=this,$=this.t.get(u),f=this.b;function y(L){I.o++;const T=(0,m.$1J)(()=>L.map(U=>U.basename));for(let U=0,j=L.length;U<j;U++){const F=L[U],{relativePath:M,basename:O}=F;if($.test(M,O,f!==O?T:void 0))continue;const z=l[M];if(z)y(z);else{if(I.p++,M===f)continue;I.J(v,F)}if(I.j)break}}y(d)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(d,l,u,v,I){const $=d.folder,f=(0,m.$1J)(()=>u);this.w(u,(y,L)=>{if(this.l||this.j)return L(null);const T=l?[l,y].join(h.sep):y;if(this.t.get(d.folder.fsPath).test(T,y,this.a.filePattern!==y?f:void 0))return L(null);const U=[$.fsPath,T].join(h.sep);N.lstat(U,(j,F)=>{if(j||this.l||this.j)return L(null);this.L(U,F,(M,O)=>M||this.l||this.j?L(null):O.isDirectory()?(this.o++,this.M(U,F,(z,J)=>z||this.l||this.j||(J=J||"",this.v[J])?L(null):(this.v[J]=!0,c.Promises.readdir(U).then(te=>{if(this.l||this.j)return L(null);this.I(d,T,te,v,x=>L(x||null))},te=>{L(null)})))):(this.p++,T===this.b||this.h&&S.$Nf(O.size)&&O.size>this.h||this.J(v,{base:$.fsPath,relativePath:T,searchPath:this.N(d,T)}),L(null,void 0)))})},y=>{const L=y&&A.$Hb(y);return I(L&&L.length>0?L[0]:void 0)})}J(d,l){this.K(l)&&(!this.d||this.d(l.relativePath,h.$nc(l.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||d(l))}K(d){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$VJ)(d,this.c)}return!0}L(d,l,u){return l.isSymbolicLink()?N.stat(d,u):u(null,l)}M(d,l,u){return l.isSymbolicLink()?N.realpath(d,(v,I)=>v?u(v):u(null,I)):u(null,d)}N(d,l){return d.folderName?h.$jc(d.folderName,l):l}}e.$mic=r;class s{constructor(d){this.a=d.folderQueries,this.b=d.extraFileResources||[],this.c=new r(d)}search(d,l,u){this.c.walk(this.a,this.b,d,l,(v,I)=>{u(v,{limitHit:I,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$nic=s;class t{constructor(d,l){this.expression=d,this.c=l,this.d(d)}d(d){let l,u;Object.keys(d).filter(v=>d[v]).forEach(v=>{h.$ic(v)?(l=l||b.$Jj(),l[v]=d[v]):(u=u||b.$Jj(),u[v]=d[v])}),this.a=l&&b.$Oj(l,{trimForExclusions:!0}),this.b=u&&b.$Oj(u,{trimForExclusions:!0})}test(d,l,u){return this.b&&this.b(d,l,u)||this.a&&this.a(h.$jc(this.c,d),l,u)}getBasenameTerms(){const d=[];return this.a&&d.push(...b.$Qj(this.a)),this.b&&d.push(...b.$Qj(this.b)),d}getPathTerms(){const d=[];return this.a&&d.push(...b.$Rj(this.a)),this.b&&d.push(...b.$Rj(this.b)),d}}function g(o){const d=o.trim().split(`
`),l=d[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return E.$Bf(d[d.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(ke[376],Se([1,0,99,21,186,22]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AD=e.$zD=e.$yD=e.$xD=e.$wD=e.$vD=e.$uD=e.$tD=e.$sD=e.DecodeStreamErrorKind=e.$rD=e.$qD=e.$pD=e.$oD=e.$nD=e.$mD=e.$lD=e.$kD=void 0,e.$kD="utf8",e.$lD="utf8bom",e.$mD="utf16be",e.$nD="utf16le";function A(l){return[e.$kD,e.$lD,e.$mD,e.$nD].some(u=>u===l)}e.$oD=A,e.$pD=[254,255],e.$qD=[255,254],e.$rD=[239,187,191];const p=512,b=512,k=512*8,R=512*128;var C;(function(l){l[l.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class w extends Error{constructor(u,v){super(u),this.decodeStreamErrorKind=v}}e.$sD=w;class E{static async create(u){let v;if(u!==e.$kD)v=(await(0,h.$jD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(a(u));else{const I=new TextDecoder;v={write($){return I.decode($,{stream:!0})},end(){return I.decode()}}}return new E(v)}constructor(u){this.a=u}write(u){return this.a.write(u)}end(){return this.a.end()}}function S(l,u){const v=u.minBytesRequiredForDetection??u.guessEncoding?k:b;return new Promise((I,$)=>{const f=(0,D.$$d)(F=>F.join("")),y=[];let L=0,T;const U=new P.$7d,j=async()=>{try{const F=await d({buffer:N.$ke.concat(y),bytesRead:L},u.guessEncoding);if(F.seemsBinary&&u.acceptTextOnly)throw new w("Stream is binary but only text is accepted for decoding",1);F.encoding=await u.overwriteEncoding(F.encoding),T=await E.create(F.encoding);const M=T.write(N.$ke.concat(y).buffer);f.write(M),y.length=0,L=0,I({stream:f,detected:F})}catch(F){U.cancel(),f.destroy(),$(F)}};(0,D.$ce)(l,{onData:async F=>{T?f.write(T.write(F.buffer)):(y.push(F),L+=F.byteLength,L>=v&&(l.pause(),await j(),setTimeout(()=>l.resume())))},onError:F=>f.error(F),onEnd:async()=>{T||await j(),f.end(T?.end())}},U.token)})}e.$tD=S;async function c(l,u,v){const $=(await(0,h.$jD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(a(u),v);let f=!1,y=!1;return{read(){if(y)return null;const L=l.read();if(typeof L!="string"){if(y=!0,!f&&v?.addBOM)switch(u){case e.$kD:case e.$lD:return N.$ke.wrap(Uint8Array.from(e.$rD));case e.$mD:return N.$ke.wrap(Uint8Array.from(e.$pD));case e.$nD:return N.$ke.wrap(Uint8Array.from(e.$qD))}const T=$.end();return T&&T.length>0?(f=!0,N.$ke.wrap(T)):null}return f=!0,N.$ke.wrap($.write(L))}}}e.$uD=c;async function m(l){return(await(0,h.$jD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(a(l))}e.$vD=m;function a(l){return l===e.$lD||l===null?e.$kD:l}e.$wD=a;function i(l,u){if(!l||u<e.$pD.length)return null;const v=l.readUInt8(0),I=l.readUInt8(1);if(v===e.$pD[0]&&I===e.$pD[1])return e.$mD;if(v===e.$qD[0]&&I===e.$qD[1])return e.$nD;if(u<e.$rD.length)return null;const $=l.readUInt8(2);return v===e.$rD[0]&&I===e.$rD[1]&&$===e.$rD[2]?e.$lD:null}e.$xD=i;const n=["ascii","utf-16","utf-32"];async function r(l){const u=await(0,h.$jD)("jschardet","dist/jschardet.min.js"),v=l.slice(0,R),I=g(v.buffer),$=u.detect(I);if(!$||!$.encoding)return null;const f=$.encoding.toLowerCase();return 0<=n.indexOf(f)?null:t($.encoding)}const s={ibm866:"cp866",big5:"cp950"};function t(l){const u=l.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[u]||u}function g(l){let u="";for(let v=0;v<l.length;v++)u+=String.fromCharCode(l[v]);return u}function o(l){switch(l){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=l.match(/windows(\d+)/);return u?"windows-"+u[1]:l}}}e.$yD=o;function d({buffer:l,bytesRead:u},v){let I=i(l,u),$=!1;if(I!==e.$mD&&I!==e.$nD&&l){let f=!0,y=!0,L=!1;for(let T=0;T<u&&T<p;T++){const U=T%2===1,j=l.readUInt8(T)===0;if(j&&(L=!0),f&&(U&&!j||!U&&j)&&(f=!1),y&&(U&&j||!U&&!j)&&(y=!1),j&&!f&&!y)break}L&&(f?I=e.$nD:y?I=e.$mD:$=!0)}return v&&!$&&!I&&l?r(l.slice(0,u)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:$,encoding:I}}e.$zD=d,e.$AD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[155],Se([1,0,376,31,154]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=void 0;class P extends h.$ghc{constructor(p,b,k=N,R="searchProcess"){super(p,b,{readdir:C=>k.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,D.$yD)(C)},R)}}e.$vic=P}),define(ke[156],Se([1,0,50,392,375,19,73,35,12,2,36,95,393,373,119]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=e.$tic=e.$sic=e.$ric=e.$qic=e.$pic=e.$oic=void 0;const c=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(f){this.a=f}provideTextSearchResults(f,y,L,T){return this.a.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((U,j)=>{T.onCancellationRequested(()=>X());const F=t(f,y),M=y.folder.fsPath,O=F.map(ne=>ne.match(/^-/)?ne:`'${ne}'`).join(" ");this.a.appendLine(`${c} ${O}
 - cwd: ${M}`);let z=D.spawn(c,F,{cwd:M});z.on("error",ne=>{console.error(ne),this.a.appendLine("Error: "+(ne&&ne.message)),j((0,R.$RJ)(new R.$PJ(ne&&ne.message,R.SearchErrorCode.rgProcessError)))});let J=!1;const te=new n(y.maxResults,y.folder,y.previewOptions);te.on("result",ne=>{J=!0,ae="",L.report(ne)});let x=!1;const X=()=>{x=!0,z?.kill(),te?.cancel()};let Z=!1;te.on("hitLimit",()=>{Z=!0,X()});let ae="";z.stdout.on("data",ne=>{te.handleData(ne),J||(ae+=ne)});let _=!1;z.stdout.once("data",()=>_=!0);let ge="";z.stderr.on("data",ne=>{const K=ne.toString();this.a.appendLine(K),ge.length+K.length<1e6&&(ge+=K)}),z.on("close",()=>{if(this.a.appendLine(_?"Got data from stdout":"No data from stdout"),this.a.appendLine(J?"Got result from parser":"No result from parser"),ae&&this.a.appendLine(`Got data without result: ${ae}`),this.a.appendLine(""),x)U({limitHit:Z});else{te.flush(),z=null;let ne;ge&&!_&&(ne=a(ge))?j((0,R.$RJ)(new R.$PJ(ne.message,ne.code))):U({limitHit:Z})}})})}}e.$oic=m;function a($){const f=$.split(`
`),y=f[0].trim();if(f.some(T=>T.startsWith("regex parse error")))return new R.$PJ(i(f),R.SearchErrorCode.regexParseError);const L=y.match(/grep config error: unknown encoding: (.*)/);if(L)return new R.$PJ(`Unknown encoding: ${L[1]}`,R.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new R.$PJ(y.charAt(0).toUpperCase()+y.substr(1),R.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new R.$PJ(y.charAt(0).toUpperCase()+y.substr(1),R.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new R.$PJ(y,R.SearchErrorCode.regexParseError)}function i($){const f=["Regex parse error"],y=$.filter(L=>L.startsWith("PCRE2:"));if(y.length>=1){const L=y[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const T=L.split(":")[1];f.push(":"+T)}}return f.join("")}class n extends N.EventEmitter{constructor(f,y,L){super(),this.g=f,this.h=y,this.j=L,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new h.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(f,y){return super.on(f,y),this}handleData(f){if(this.b)return;const y=typeof f=="string"?f:this.d.write(f);this.k(y)}k(f){let y=f.indexOf(`
`);const L=this.a+f;if(y>=0)y+=this.a.length;else{this.a=L;return}let T=0;for(;y>=0;)this.m(L.substring(T,y).trim()),T=y+1,y=L.indexOf(`
`,T);this.a=L.substring(T)}m(f){if(this.b||!f)return;let y;try{y=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(y.type==="match"){const L=r(y.data.path),T=k.URI.joinPath(this.h,L),U=this.n(y.data,T);this.p(U),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const L=r(y.data.path),T=k.URI.joinPath(this.h,L);this.o(y.data,T).forEach(j=>this.p(j))}}n(f,y){const L=f.line_number-1,T=r(f.lines),U=Buffer.from(T);let j=0,F=0,M=L;f.submatches.length===0&&f.submatches.push(T.length?{start:0,end:1,match:{text:T[0]}}:{start:0,end:0,match:{text:""}});const O=(0,P.$Hb)(f.submatches.map((z,J)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const te=r(z.match),x=U.slice(j,z.start).toString(),X=s(x),Z=X.numLines>0?X.lastLineLength:X.lastLineLength+F,ae=s(te),_=X.numLines+M,ge=ae.numLines+_,ne=ae.numLines>0?ae.lastLineLength:ae.lastLineLength+Z;return j=z.end,F=ne,M=ge,new C.$zJ(_,Z,ge,ne)}));return(0,S.$hic)(y,T,O,this.j)}o(f,y){const L=r(f.lines),T=f.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((U,j)=>({text:U,uri:y,lineNumber:T+j}))}p(f){this.emit("result",f)}}e.$pic=n;function r($){return $.bytes?Buffer.from($.bytes,"base64").toString():$.text}function s($){const f=/\n/g;let y=0,L=-1,T;for(;T=f.exec($);)y++,L=T.index;const U=L>=0?$.length-L-1:$.length;return{numLines:y,lastLineLength:U}}function t($,f){const y=["--hidden","--no-require-git"];y.push($.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:T}=(0,A.$K)(f.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(T&&T.length){const j=new Set;T.forEach(F=>{j.add(F)}),y.push("-g","!*"),j.forEach(F=>{g(F).map(S.$gic).forEach(M=>{y.push("-g",M)})})}L&&L.length&&L.forEach(j=>{y.push("-g",j)}),f.excludes.map(S.$gic).forEach(j=>y.push("-g",`!${j}`)),f.maxFileSize&&y.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?f.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),f.followSymlinks&&y.push("--follow"),f.encoding&&f.encoding!=="utf8"&&y.push("--encoding",f.encoding),$.pattern==="--"&&($.isRegExp=!0,$.pattern="\\-\\-"),$.isMultiline&&!$.isRegExp&&($.pattern=(0,b.$Pe)($.pattern),$.isRegExp=!0),f.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),$.isRegExp&&($.pattern=o($.pattern),y.push("--engine","auto"));let U;if($.isWordMatch){const F=(0,b.$Ye)($.pattern,!!$.isRegExp,{wholeWord:$.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",F)}else if($.isRegExp){let j=l($.pattern);j=u(j),y.push("--regexp",j)}else U=$.pattern,y.push("--fixed-strings");return y.push("--no-config"),f.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),$.isMultiline&&y.push("--multiline"),f.beforeContext&&y.push("--before-context",f.beforeContext+""),f.afterContext&&y.push("--after-context",f.afterContext+""),y.push("--"),U&&y.push(U),y.push("."),y}e.$qic=t;function g($){return I($).flatMap(y=>{const L=(0,p.$Mj)(y,"/");return L.map((T,U)=>L.slice(0,U+1).join("/"))})}function o($){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;$.match(f);)$=$.replace(f,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;$.match(y);)$=$.replace(y,"$1\\x{$2}");return $}e.$ric=o;const d=$=>$.type==="Assertion"&&$.kind==="lookbehind";function l($){let f;try{f=new w.RegExpParser().parsePattern($)}catch{return $}let y="",L=0;const T=(F,M,O)=>{y+=$.slice(L,F)+O,L=M},U=[];return new w.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const M=U[0];if(!M)T(F.start,F.end,"\\r?\\n");else if(!U.some(d))if(M.type==="CharacterClass")if(M.negate){const O=$.slice(M.start+2,F.start)+$.slice(F.end,M.end-1);M.parent?.type==="Quantifier"?T(M.start,M.end,O?`[^${O}]`:"."):T(M.start,M.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=$.slice(M.start+1,F.start)+$.slice(F.end,M.end-1);T(M.start,M.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else M.type==="Quantifier"&&T(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){U.unshift(F)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(F){U.unshift(F)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(F){U.unshift(F)},onCharacterClassLeave(){U.shift()},onAssertionEnter(F){d(F)&&U.push(F)},onAssertionLeave(F){U[0]===F&&U.shift()}}).visit(f),y+=$.slice(L),y}e.$sic=l;function u($){return $.replace(/\n/g,"\\r?\\n")}e.$tic=u;function v($){let f=!1,y=!1,L="",T="";for(let U=0;U<$.length;U++){const j=$[U];switch(j){case"\\":y?(f?T+="\\"+j:L+="\\"+j,y=!1):y=!0;break;case"{":if(y)f?T+=j:L+=j,y=!1;else{if(f)return{strInBraces:L+"{"+T+"{"+$.substring(U+1)};f=!0}break;case"}":if(y)f?T+=j:L+=j,y=!1;else{if(f)return{fixedStart:L,strInBraces:T,fixedEnd:$.substring(U+1)};L+=j}break;default:f?T+=(y?"\\":"")+j:L+=(y?"\\":"")+j,y=!1;break}}return{strInBraces:L+(f?"{"+T:"")}}function I($){const{fixedStart:f,strInBraces:y,fixedEnd:L}=v($);if(f===void 0||L===void 0)return[y];let T=(0,p.$Mj)(y,",");T.length||(T=[""]);const U=I(L);return T.flatMap(j=>{const F=f+j;return U.map(M=>F+M)})}e.$uic=I}),define(ke[377],Se([1,0,22,156,86,16]),function($e,e,D,N,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=void 0;class A{constructor(k){this.b=k,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(k,R,C,w){const E=new N.$oic(this.b);if(R.folder.scheme===P.Schemas.vscodeUserData){const S={...R,folder:R.folder.with({scheme:P.Schemas.file})},c=new h.$xv(m=>C.report({...m,uri:m.uri.with({scheme:R.folder.scheme})}));return this.c(w,m=>E.provideTextSearchResults(k,S,c,m))}else return this.c(w,S=>E.provideTextSearchResults(k,R,C,S))}async c(k,R){const C=p(k);this.a.add(C);const w=await R(C.token);return this.a.delete(C),w}d(){this.a.forEach(k=>k.cancel())}}e.$yic=A;function p(b){const k=new D.$7d;return b.onCancellationRequested(()=>k.cancel()),k}}),define(ke[378],Se([1,0,31,156,155]),function($e,e,D,N,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=void 0;class P{constructor(b){this.a=b}search(b,k,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(E){R({message:E})}},w=new h.$vic(this.a,new N.$oic(C),D);return new Promise((E,S)=>w.search(c=>{k(c.map(A))},b).then(c=>E({limitHit:c.limitHit,type:"success",stats:c.stats}),S))}}e.$wic=P;function A(p){return{path:p.resource&&p.resource.fsPath,results:p.results,numMatches:(p.results||[]).reduce((b,k)=>{if(k.ranges){const R=k;return b+(Array.isArray(R.ranges)?R.ranges.length:1)}else return b+1},0)}}}),define(ke[379],Se([1,0,19,8,14,4,129,17,38,2,32,36,374,378]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=void 0;class S{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let s;const t=a(r),g=new P.$Wd({onDidAddFirstListener:()=>{s=(0,N.$Ug)(o=>this.doFileSearchWithEngine(w.$nic,t,d=>g.fire(d),o)),s.then(o=>g.fire(o),o=>g.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return g.event}textSearch(r){let s;const t=a(r),g=new P.$Wd({onDidAddFirstListener:()=>{s=(0,N.$Ug)(o=>this.f(t,d=>g.fire(d),o)),s.then(o=>g.fire(o),o=>g.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return g.event}f(r,s,t){return r.maxFileSize=this.g().maxFileSize,new E.$wic(r).search(t,s,s)}g(){return{maxFileSize:16*R.$1k.GB}}doFileSearch(r,s,t){return this.doFileSearchWithEngine(w.$nic,r,s,t)}doFileSearchWithEngine(r,s,t,g,o=S.a){let d=0;const l=v=>{Array.isArray(v)?(d+=v.length,t(v.map(I=>this.h(I)))):v.relativePath?(d++,t(this.h(v))):t(v)};if(s.sortByScore){let v=this.l(s,l,g);if(!v){const I=s.maxResults?Object.assign({},s,{maxResults:null}):s,$=new r(I);v=this.j($,s,t,l,g)}return new Promise((I,$)=>{v.then(([f,y])=>{const L=y.map(T=>this.h(T));this.o(L,t,o),I(f)},$)})}const u=new r(s);return this.r(u,l,o,g).then(v=>({limitHit:v.limitHit,type:"success",stats:{detailStats:v.stats,type:this.d,fromCache:!1,resultCount:d,sortingTime:void 0}}))}h(r){return{path:r.base?(0,p.$jc)(r.base,r.relativePath):r.relativePath}}j(r,s,t,g,o){const d=new P.$Wd;let l=(0,N.$Ug)(v=>{let I=[];const $=f=>{Array.isArray(f)?I=f:(g(f),d.fire(f))};return this.r(r,$,-1,v).then(f=>[f,I])}),u;if(s.cacheKey){u=this.k(s.cacheKey);const v={promise:l,event:d.event,resolved:!1};u.resultsToSearchCache[s.filePattern||""]=v,l.then(()=>{v.resolved=!0},I=>{delete u.resultsToSearchCache[s.filePattern||""]}),l=this.s(l)}return l.then(([v,I])=>{const $=u?u.scorerCache:Object.create(null),f=(typeof s.maxResults!="number"||s.maxResults>0)&&b.$Sd.create(!1);return this.n(s,I,$,o).then(y=>{const L=f?f.elapsed():-1;return[{type:"success",stats:{detailStats:v.stats,sortingTime:L,fromCache:!1,type:this.d,workspaceFolderCount:s.folderQueries.length,resultCount:y.length},messages:v.messages,limitHit:v.limitHit||typeof s.maxResults=="number"&&I.length>s.maxResults},y]})})}k(r){const s=this.b[r];return s||(this.b[r]=new c)}l(r,s,t){const g=r.cacheKey&&this.b[r.cacheKey];if(!g)return;const o=this.q(g,r.filePattern||"",s,t);if(o)return o.then(([d,l,u])=>{const v=b.$Sd.create(!1);return this.n(r,l,g.scorerCache,t).then(I=>{const $=v.elapsed(),f={fromCache:!0,detailStats:u,type:this.d,resultCount:l.length,sortingTime:$};return[{type:"success",limitHit:d.limitHit||typeof r.maxResults=="number"&&l.length>r.maxResults,stats:f},I]})})}n(r,s,t,g){const o=(0,A.$2q)(r.filePattern||""),d=(u,v)=>(0,A.$1q)(u,v,o,!0,m,t),l=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return D.$Gb(s,d,l,1e4,g)}o(r,s,t){if(t&&t>0)for(let g=0;g<r.length;g+=t)s(r.slice(g,g+t));else s(r)}q(r,s,t,g){const o=b.$Sd.create(!1),d=s.indexOf(p.sep)>=0;let l;for(const $ in r.resultsToSearchCache)if(s.startsWith($)){if(d&&$.indexOf(p.sep)<0&&$!=="")continue;const f=r.resultsToSearchCache[$];l={promise:this.s(f.promise),event:f.event,resolved:f.resolved};break}if(!l)return null;const u=o.elapsed(),v=b.$Sd.create(!1),I=l.event(t);return g&&g.onCancellationRequested(()=>{I.dispose()}),l.promise.then(([$,f])=>{if(g&&g.isCancellationRequested)throw(0,h.$6)();const y=[],L=(0,A.$2q)(s).normalizedLowercase;for(const T of f)(0,C.$VJ)(T,L)&&y.push(T);return[$,y,{cacheWasResolved:l.resolved,cacheLookupTime:u,cacheFilterTime:v.elapsed(),cacheEntryCount:f.length}]})}r(r,s,t,g){return new Promise((o,d)=>{let l=[];g?.onCancellationRequested(()=>r.cancel()),r.search(u=>{u&&(t?(l.push(u),t>0&&l.length>=t&&(s(l),l=[])):s(u))},u=>{s(u)},(u,v)=>{l.length&&s(l),u?(s({message:"Search finished. Error: "+u.message}),d(u)):(s({message:"Search finished. Stats: "+JSON.stringify(v.stats)}),o(v))})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,t){return r.then(s,t)}catch(s){return this.then(void 0,s)}finally(s){return r.finally(s)}}}}e.$xic=S;class c{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(n){return(0,p.$nc)(n.relativePath)}getItemDescription(n){return(0,p.$mc)(n.relativePath)}getItemPath(n){return n.relativePath}};function a(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(r=>k.URI.revive(r))}}function i(n){return{...n,folder:k.URI.revive(n.folder)}}}),define(ke[380],Se([1,0,3,16,2,31,13,27,20,98,66,36,379,377,119,155]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=void 0;let m=class extends k.$lhc{constructor(i,n,r,s){super(i,r,s),this.s=P,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Sc;const t=new S.$iic("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new E.$yic(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$iic("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(N.Schemas.file,new E.$yic(i))),this.x.add(this.z(N.Schemas.file,new w.$xic("fileSearchProvider")))}z(i,n){const r=this.d++;return this.v=n,this.t=r,this.c.$registerFileSearchProvider(r,this.o(i)),(0,D.$Rc)(()=>{this.v=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(i,n,r,s){const t=(0,k.$mhc)(r);if(i===this.t){const g=Date.now();return this.A(i,n,t,s).then(o=>{const d=Date.now()-g;return this.n.debug(`Ext host file search time: ${d}ms`),o})}return super.$provideFileSearchResults(i,n,r,s)}doInternalFileSearchWithCustomCallback(i,n,r){const s=t=>{if((0,C.$UJ)(t)&&(t=[t]),Array.isArray(t)){r(t.map(g=>h.URI.file(g.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,s,n)}async A(i,n,r,s){return this.doInternalFileSearchWithCustomCallback(r,s,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new c.$vic(i,n,void 0,"textSearchProvider")}};e.$zic=m,e.$zic=m=Ge([Ve(0,b.$oN),Ve(1,p.$EN),Ve(2,R.$egc),Ve(3,A.$pj)],m)}),define(ke[120],Se([1,0,394,62,63,395,21,14,4,3,17,11,30,81,82]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0;class c{traceSocketEvent(f,y){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,y)}constructor(f,y=""){this.f=!0,this.debugLabel=y,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,p.$1)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const y=L=>{this.traceSocketEvent("read",L),f(A.$ke.wrap(L))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(f){const y=L=>{f({type:0,hadError:L,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(f){const y=()=>{f()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,p.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,p.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$Wh=c;var m;(function($){$[$.MinHeaderByteSize=2]="MinHeaderByteSize",$[$.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var a;(function($){$[$.PeekHeader=1]="PeekHeader",$[$.ReadHeader=2]="ReadHeader",$[$.ReadBody=3]="ReadBody",$[$.Fin=4]="Fin"})(a||(a={}));class i extends k.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,y){this.socket.traceSocketEvent(f,y)}constructor(f,y,L,T){super(),this.f=this.B(new b.$Wd),this.g=this.B(new b.$Wd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:L?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new n(this,y,L,T,this.f,(U,j)=>this.m(U,j))),this.B(this.a.onError(U=>{console.error(U),(0,p.$1)(U),this.g.fire({type:0,hadError:!0,error:U})})),this.b=new S.$Rh,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let y=0;for(;y<f.byteLength;)this.a.writeMessage(f.slice(y,Math.min(y+262144,f.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(f,{compressed:y,opcode:L}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let T=2;f.byteLength<126?T+=0:f.byteLength<2**16?T+=2:T+=8;const U=A.$ke.alloc(T),j=y?64:0,F=L&15;if(U.writeUInt8(128|j|F,0),f.byteLength<126)U.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){U.writeUInt8(126,1);let M=1;U.writeUInt8(f.byteLength>>>8&255,++M),U.writeUInt8(f.byteLength>>>0&255,++M)}else{U.writeUInt8(127,1);let M=1;U.writeUInt8(0,++M),U.writeUInt8(0,++M),U.writeUInt8(0,++M),U.writeUInt8(0,++M),U.writeUInt8(f.byteLength>>>24&255,++M),U.writeUInt8(f.byteLength>>>16&255,++M),U.writeUInt8(f.byteLength>>>8&255,++M),U.writeUInt8(f.byteLength>>>0&255,++M)}this.socket.write(A.$ke.concat([U,f]))}end(){this.h=!0,this.socket.end()}n(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),L=y.readUInt8(0),T=(L&128)>>>7,U=(L&64)>>>6,j=L&15,F=y.readUInt8(1),M=(F&128)>>>7,O=F&127;this.j.state=2,this.j.readLen=2+(M?4:0)+(O===126?2:0)+(O===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),L=y.readUInt8(1),T=(L&128)>>>7;let U=L&127,j=1;U===126?U=y.readUInt8(++j)*2**8+y.readUInt8(++j):U===127&&(U=y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*2**24+y.readUInt8(++j)*2**16+y.readUInt8(++j)*2**8+y.readUInt8(++j));let F=0;T&&(F=y.readUInt8(++j)*2**24+y.readUInt8(++j)*2**16+y.readUInt8(++j)*2**8+y.readUInt8(++j)),this.j.state=3,this.j.readLen=U,this.j.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Xh=i;class n extends k.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$ke.alloc(0)}constructor(f,y,L,T,U,j){super(),this.n=f,this.r=U,this.s=j,this.a=this.B(new b.$Wd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$Wd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$Wd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new r(this.n,T,L,{windowBits:15})),this.f=this.B(new s(this.n,{windowBits:15})),this.B(this.b.onError(F=>this.a.fire(F))),this.B(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(f,y){this.g.push({data:f,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:f,options:y}=this.g.shift();if(this.f&&y.compressed){const L=await this.w(this.f,f);this.s(L,y)}else this.s(f,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(f,y){return new Promise((L,T)=>{f.write(y),f.flush(U=>L(U))})}acceptFrame(f,y,L){this.h.push({data:f,isCompressed:y,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const y=await this.C(this.b,f.data,f.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(f.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(f,y,L){return new Promise((T,U)=>{f.write(y),L&&f.write(A.$ke.fromByteArray([0,0,255,255])),f.flush(j=>T(j))})}}class r extends k.$Tc{get recordedInflateBytes(){return this.j?A.$ke.concat(this.f):A.$ke.alloc(0)}constructor(f,y,L,T){super(),this.h=f,this.j=y,this.a=this.B(new b.$Wd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,P.createInflateRaw)(T),this.b.on("error",U=>{this.h.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent("zlibInflateData",U),this.g.push(A.$ke.wrap(U))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=A.$ke.concat(this.g);this.g.length=0,f(y)})}}class s extends k.$Tc{constructor(f,y){super(),this.g=f,this.a=this.B(new b.$Wd),this.onError=this.a.event,this.f=[],this.b=(0,P.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(A.$ke.wrap(L))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=A.$ke.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),f(y)})}}function t($,f){if(f===0)return;const y=$.byteLength>>>2;for(let M=0;M<y;M++){const O=$.readUInt32BE(M*4);$.writeUInt32BE(O^f,M*4)}const L=y*4,T=$.byteLength-L,U=f>>>24&255,j=f>>>16&255,F=f>>>8&255;T>=1&&$.writeUInt8($.readUInt8(L)^U,L),T>=2&&$.writeUInt8($.readUInt8(L+1)^j,L+1),T>=3&&$.writeUInt8($.readUInt8(L+2)^F,L+2)}e.$Yh=process.env.XDG_RUNTIME_DIR;const g={[2]:107,[1]:103};function o(){const $=(0,w.$rg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${$}-sock`;const f=process.platform!=="darwin"&&e.$Yh?e.$Yh:(0,h.tmpdir)(),y=(0,R.$jc)(f,`vscode-ipc-${$}.sock`);return l(y),y}e.$Zh=o;function d($,f,y){const T=(0,D.createHash)("sha256").update($).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${y}-${f}-sock`;const U=y.substr(0,4),j=f.substr(0,6);let F;return process.platform!=="darwin"&&e.$Yh&&!process.env.VSCODE_PORTABLE?F=(0,R.$jc)(e.$Yh,`vscode-${T}-${U}-${j}.sock`):F=(0,R.$jc)($,`${U}-${j}.sock`),l(F),F}e.$1h=d;function l($){const f=g[C.$u];typeof f=="number"&&$.length>=f&&console.warn(`WARNING: IPC handle "${$}" is longer than ${f} chars, try a shorter --user-data-dir`)}class u extends E.$Lh{static b(f){const y=b.Event.fromNodeEventEmitter(f,"connection");return b.Event.map(y,L=>({protocol:new S.$Sh(new c(L,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(L,"close"))}))}constructor(f){super(u.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$2h=u;function v($){return new Promise((f,y)=>{const L=(0,N.createServer)();L.on("error",y),L.listen($,()=>{L.removeListener("error",y),f(new u(L))})})}e.$3h=v;function I($,f){return new Promise((y,L)=>{const T=(0,N.createConnection)($,()=>{T.removeListener("error",L),y(S.$Th.fromSocket(new c(T,`ipc-client${f}`),f))});T.once("error",L)})}e.$4h=I}),define(ke[381],Se([1,0,62,63,166,120,8,3,11,51,13,136,256,257,109,89,21]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V$b=e.$U$b=e.$T$b=e.$S$b=void 0;async function a(t,g,o,d,l){let u;for(let v=3;v&&(u?.dispose(),u=await new i(t,g,o,d,l).waitForReady(),!(l&&h.$ug[l]||!h.$ug[u.tunnelLocalPort]));v--);return u}class i extends p.$Tc{constructor(g,o,d,l,u){super(),this.m=o,this.n=u,this.privacy=c.TunnelPrivacyId.Private,this.j=new Map,this.a=g,this.b=D.createServer(),this.c=new A.$7g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=v=>this.r(v),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=l,this.tunnelRemoteHost=d}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const g=this.n??this.tunnelRemotePort,o=(0,c.$Jv)(this.m)?"0.0.0.0":"127.0.0.1";let d=await(0,h.$vg)(g,2,1e3,o),l=null;return this.b.listen(d,this.m),await this.c.wait(),l=this.b.address(),l||(d=0,this.b.listen(d,this.m),await this.c.wait(),l=this.b.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async r(g){g.pause();const o=(0,c.$Hv)(this.tunnelRemoteHost)||(0,c.$Jv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,d=await(0,w.$nl)(this.a,o,this.tunnelRemotePort),l=d.getSocket(),u=d.readEntireBuffer();d.dispose(),u.byteLength>0&&g.write(u.buffer),g.on("end",()=>{g.localAddress&&this.j.delete(g.localAddress),l.end()}),g.on("close",()=>l.end()),g.on("error",()=>{g.localAddress&&this.j.delete(g.localAddress),l instanceof P.$Wh?l.socket.destroy():l.end()}),l instanceof P.$Wh?this.t(g,l):this.s(g,l),g.localAddress&&this.j.set(g.localAddress,()=>{g.end(),l.end()})}s(g,o){o.onClose(()=>g.destroy()),o.onEnd(()=>g.end()),o.onData(d=>g.write(d.buffer)),g.on("data",d=>o.write(m.$ke.wrap(d))),g.resume()}t(g,o){const d=o.socket;d.on("end",()=>g.end()),d.on("close",()=>g.end()),d.on("error",()=>{g.destroy()}),d.pipe(g),g.pipe(d)}}e.$S$b=i;let n=class extends c.$Mv{constructor(g,o,d,l,u){super(o,u),this.v=g,this.w=d,this.y=l}isPortPrivileged(g){return(0,c.$Kv)(g,this.m,b.OS,N.release())}t(g,o,d,l,u,v,I,$){const f=this.s(o,d);if(f)return++f.refcount,f.value;if((0,c.$Ev)(g))return this.u(g,o,d,u,v,I,$);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${d} on local port ${u}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:g,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},L=a(y,l,o,d,u);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(o,d,L),L}}};e.$T$b=n,e.$T$b=n=Ge([Ve(0,E.$hl),Ve(1,R.$pj),Ve(2,S.$kl),Ve(3,C.$Hj),Ve(4,k.$Bi)],n);let r=class extends n{constructor(g,o,d,l,u){super(g,o,d,l,u)}};e.$U$b=r,e.$U$b=r=Ge([Ve(0,E.$hl),Ve(1,R.$pj),Ve(2,S.$kl),Ve(3,C.$Hj),Ve(4,k.$Bi)],r);let s=class extends p.$Tc{constructor(g,o,d,l,u){super(),this.b=g,this.c=o,this.f=d,this.g=l,this.h=u,this.a=new Map}async openTunnel(g,o,d,l,u,v,I,$,f){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${d}:${l} on local port ${v}.`),!this.a.has(g)){const y=new r(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(g,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(g))})}return this.a.get(g).openTunnel(o,d,l,u,v,I,$,f)}};e.$V$b=s,e.$V$b=s=Ge([Ve(0,E.$hl),Ve(1,R.$pj),Ve(2,C.$Hj),Ve(3,S.$kl),Ve(4,k.$Bi)],s)}),define(ke[382],Se([1,0,120,276,57,33,2,13,40]),function($e,e,D,N,h,P,A,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QN=e.$PN=void 0;class k{constructor(w,E,S){this.b=w,this.c=E,this.f=S,this.a=N.createServer((c,m)=>this.h(c,m)),this.g().catch(c=>(E.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,E){const S=(m,a)=>{E.writeHead(m,{"content-type":"application/json"}),E.end(JSON.stringify(a||null),i=>i&&this.c.error(i))},c=[];w.setEncoding("utf8"),w.on("data",m=>c.push(m)),w.on("end",async()=>{try{const m=JSON.parse(c.join(""));let a;switch(m.type){case"open":a=await this.i(m);break;case"openExternal":a=await this.j(m);break;case"status":a=await this.l(m);break;case"extensionManagement":a=await this.k(m);break;default:S(404,`Unknown message type: ${m.type}`);break}S(200,a)}catch(m){const a=m instanceof Error?m.message:JSON.stringify(m);S(500,a),this.c.error("Error while processing pipe request",m)}})}async i(w){const{fileURIs:E,folderURIs:S,forceNewWindow:c,diffMode:m,mergeMode:a,addMode:i,forceReuseWindow:n,gotoLineMode:r,waitMarkerFilePath:s,remoteAuthority:t}=w,g=[];if(Array.isArray(S))for(const u of S)try{g.push({folderUri:A.URI.parse(u)})}catch{}if(Array.isArray(E))for(const u of E)try{(0,b.$Ai)(u)?g.push({workspaceUri:A.URI.parse(u)}):g.push({fileUri:A.URI.parse(u)})}catch{}const o=s?A.URI.file(s):void 0,l={forceNewWindow:c,diffMode:m,mergeMode:a,addMode:i,gotoLineMode:r,forceReuseWindow:n,preferNewWindow:!n&&!o&&!i,waitMarkerFileURI:o,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",g,l)}async j(w){for(const E of w.uris){const S=A.URI.parse(E),c=S.scheme==="file"?S:E;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(w){const E=c=>c?.map(m=>/\.vsix$/i.test(m)?A.URI.parse(m):m),S={list:w.list,install:E(w.install),uninstall:E(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&h.existsSync(this.f)&&h.unlinkSync(this.f)}}e.$PN=k;let R=class extends k{constructor(w,E){super(w,E,(0,D.$Zh)())}};e.$QN=R,e.$QN=R=Ge([Ve(0,P.$KN),Ve(1,p.$pj)],R)}),define(ke[383],Se([1,0,58,370,365,275,47,352,2,16,7,382,104,307,351]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=void 0;class c extends h.$6hc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,r=n._load;n._load=function(o,d,l){return o=t(o),i.a.has(o)?i.a.get(o).load(o,b.URI.file((0,w.$yq)(d.filename)),u=>r.apply(this,[u,d,l])):r.apply(this,arguments)};const s=n._resolveLookupPaths;n._resolveLookupPaths=(g,o)=>s.call(this,t(g),o);const t=g=>{for(const o of i.b){const d=o(g);if(d){g=d;break}}return g}}}class m extends A.$Ugc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async tb(){this.h.createInstance(E.$Cic);const i=this.h.invokeFunction(N.$2hc);if(this.h.createInstance(p.$Bic),this.f.remote.isRemote&&this.f.remote.authority){const s=this.h.createInstance(C.$QN);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}this.h.createInstance(S.$Dic),await this.h.createInstance(c,i,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,P.$Aic)(this.j,r,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,n,r){if(n.scheme!==k.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let s=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),s=$e.__$__nodeRequire(n.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return s}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const r=i[n];r===null?delete process.env[n]:process.env[n]=r}}}e.$Eic=m}),define(ke[384],Se([1,0,50,21,4,3,122,11,23,2,31,13,255,64,109,89,381,27,20,70,359]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mic=e.$Lic=e.$Kic=e.$Jic=e.$Iic=e.$Hic=e.$Gic=e.$Fic=void 0;function s(f){const y=f.trim().split(`
`),L=[];return y.forEach(U=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(U);j&&j.length>=3&&L.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),L.reduce((U,j)=>(U[j.socket]=j,U),{})}e.$Fic=s;function t(...f){const y=[].concat(...f.map(o));return[...new Map(y.filter(L=>L.st==="0A").map(L=>{const T=L.local_address.split(":");return{socket:parseInt(L.inode,10),ip:g(T[0]),port:parseInt(T[1],16)}}).map(L=>[L.ip+":"+L.port,L])).values()]}e.$Gic=t;function g(f){let y="";if(f.length===8)for(let L=f.length-2;L>=0;L-=2)y+=parseInt(f.substr(L,2),16),L!==0&&(y+=".");else for(let L=0;L<f.length;L+=8){const T=f.substring(L,L+8);let U="";for(let j=8;j>=2;j-=2)U+=T.substring(j-2,j),(j===6||j===2)&&(U=parseInt(U,16).toString(16),y+=`${U}`,U="",L+j!==f.length-6&&(y+=":"))}return y}e.$Hic=g;function o(f){const y=f.trim().split(`
`),L=y.shift().trim().split(/\s+/).filter(U=>U!=="rx_queue"&&U!=="tm->when");return y.map(U=>U.trim().split(/\s+/).reduce((j,F,M)=>(j[L[M]||M]=F,j),{}))}e.$Iic=o;function d(f){return!!f.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||f.indexOf("out/server-main.js")!==-1||f.indexOf("_productName=VSCode")!==-1}function l(f){const y=f.trim().split(`
`),L=[];return y.forEach(T=>{const U=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(T);U&&U.length>=4&&L.push({pid:parseInt(U[1],10),ppid:parseInt(U[2]),cmd:U[3]})}),L}e.$Jic=l;async function u(f,y,L){const T=L.reduce((j,F)=>(j[F.pid]=F,j),{}),U=[];return f.forEach(({socket:j,ip:F,port:M})=>{const O=y[j]?y[j].pid:void 0,z=O?T[O]?.cmd:void 0;O&&z&&!d(z)&&U.push({host:F,port:M,detail:z,pid:O})}),U}e.$Kic=u;function v(f,y,L){const T=new Map,U=l(y);for(const j of f){const F=L.get(j.port);if(F){T.set(j.port,F);continue}const M=U.find(O=>O.cmd.includes(`${j.port}`));if(M){let O=M,z;do z=U.find(J=>J.ppid===O.pid),z&&(O=z);while(z);T.set(j.port,{host:j.ip,port:j.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else T.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return T}e.$Lic=v;let I=class extends n.$ezb{constructor(y,L,T,U){super(y,L,T),this.D=L,this.F=U,this.y=void 0,this.z=new Map,this.C=!1,p.$k&&L.remote.isRemote&&L.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let L;this.y&&(L=this.y,await this.a.$onFoundNewCandidates(this.y));const T=new A.$_l;let U=0;for(;this.C;){const j=new Date().getTime(),F=(await this.I()).filter(z=>(0,c.$Hv)(z.host)||(0,c.$Jv)(z.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(z=>z.port).join(", ")}`);const M=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${M} ms.`),U++>3&&T.update(M),(!L||JSON.stringify(L)!==JSON.stringify(F))&&(L=F,await this.a.$onFoundNewCandidates(L));const O=this.G(T.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(z=>setTimeout(()=>z(),O))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",L="";try{y=await R.Promises.readFile("/proc/net/tcp","utf8"),L=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const T=t(y,L),U=await new Promise(x=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(X,Z,ae)=>{x(Z)})}),j=s(U),F=await R.Promises.readdir("/proc"),M=[];for(const x of F)try{const X=Number(x),Z=b.$Ig(k.URI.file("/proc"),x);if((await R.Promises.stat(Z.fsPath)).isDirectory()&&!isNaN(X)){const _=await R.Promises.readlink(b.$Ig(Z,"cwd").fsPath),ge=await R.Promises.readFile(b.$Ig(Z,"cmdline").fsPath,"utf8");M.push({pid:X,cwd:_,cmd:ge})}}catch{}const O=[],z=T.filter(x=>{const X=j[x.socket];return X||O.push(x),X}),J=u(z,j,M);let te;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const x=await new Promise(X=>{(0,D.exec)("ps -F -A -l | grep root",(Z,ae,_)=>{X(ae)})});this.z=v(O,x,this.z),te=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${te.map(X=>X.port).join(", ")}`)}return J.then(x=>te?x.concat(te):x)}w(y){return async L=>{const T=new m.$S$b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,F,M,O){const z=await y.makeConnection();return $.connect(z,F,M,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new E.$$k(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",L.remoteAddress.host||"localhost",L.remoteAddress.port,L.localAddressPort);await T.waitForReady();const U=new h.$Wd;return{localAddress:(0,r.$JK)(T.localAddress)??T.localAddress,remoteAddress:{port:T.tunnelRemotePort,host:T.tunnelRemoteHost},onDidDispose:U.event,dispose:()=>{T.dispose(),U.fire(),U.dispose()}}}}};e.$Mic=I,e.$Mic=I=Ge([Ve(0,i.$oN),Ve(1,a.$EN),Ve(2,C.$pj),Ve(3,S.$kl)],I);class $ extends w.$fsb{static connect(y,L,T,U){const j=new P.$Sc,F={onClose:j.add(new h.$Wd),onData:j.add(new h.$Wd),onEnd:j.add(new h.$Wd)};j.add(y.onDidReceiveMessage(O=>F.onData.fire(N.$ke.wrap(O)))),j.add(y.onDidEnd(()=>F.onEnd.fire())),j.add(y.onDidClose(O=>F.onClose.fire({type:0,error:O,hadError:!!O})));const M=new $(y,U,F);return M.B(j),(0,w.$esb)(M,L,T,U,F)}constructor(y,L,T){super(L,T),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[385],Se([1,0,84,354,368,367,380,383,384,97,47,98,96,46,70,94,353,308,13,369,60,270,106,109,138]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a,i,n,r,s,t,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$1r)(R.$Vgc,p.$Eic,0),(0,D.$1r)(i.$qj,a.$Oic,1),(0,D.$1r)(i.$pj,new t.$5h(s.$5hc,[!1],!0)),(0,D.$1r)(g.$kl,o.$X$b,1),(0,D.$1r)(c.$ngc,m.$Nic,0),(0,D.$1r)(k.$1gc,P.$fic,0),(0,D.$1r)(C.$khc,A.$zic,0),(0,D.$1r)(w.$Nhc,h.$0hc,0),(0,D.$1r)(E.$Igc,N.$9hc,0),(0,D.$1r)(S.$dzb,b.$Mic,0),(0,D.$1r)(r.$Ygc,n.$Pic,0)}),define(ke[396],Se([1,0,62,397,58,14,82,120,253,113,366,21,31,104,8,132,277,291,371,385]),function($e,e,D,N,h,P,A,p,b,k,R,C,w,E,S,c,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let v=0;v<process.execArgv.length;v++)process.execArgv[v]==="--inspect-port=0"&&(process.execArgv.splice(v,1),v--)}();const i=N(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const u=globalThis._VSCODE_NODE_MODULES.module,v=u._load;u._load=function(I){if(I==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return v.apply(this,arguments)}})();const n=process.exit.bind(process),r=process.on.bind(process);function s(u){process.exit=function(v){if(u)n(v);else{const I=new Error("An extension called process.exit() and this was prevented.");console.warn(I.stack)}},process.crash=function(){const v=new Error("An extension called process.crash() and this was prevented.");console.warn(v.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(v,I){v==="uncaughtException"&&(I=function(){try{return I.call(void 0,arguments)}catch{}}),r(v,I)}}let t=function(u){n()};function g(){const u=(0,a.$Wm)(process.env);if(u.type===3)return new Promise((v,I)=>{const $=f=>{const y=f[0],L=new A.$Uh;y.on("message",T=>L.fire(C.$ke.wrap(T.data))),y.on("close",()=>{t("renderer closed the MessagePort")}),y.start(),v({onMessage:L.event,send:T=>y.postMessage(T.buffer)})};process.parentPort.on("message",f=>$(f.ports))});if(u.type===2)return new Promise((v,I)=>{let $=null;const f=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,L=3e5,T=new S.$ih(()=>t("renderer disconnected for too long (1)"),y),U=new S.$ih(()=>t("renderer disconnected for too long (2)"),L);process.on("message",(F,M)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){M.setNoDelay(!0);const O=C.$ke.wrap(Buffer.from(F.initialDataChunk,"base64"));let z;if(F.skipWebSocketFrames)z=new p.$Wh(M,"extHost-socket");else{const J=C.$ke.wrap(Buffer.from(F.inflateBytes,"base64"));z=new p.$Xh(new p.$Wh(M,"extHost-socket"),F.permessageDeflate,J,!1)}$?(T.cancel(),U.cancel(),$.beginAcceptReconnection(z,O),$.endAcceptReconnection(),$.sendResume()):(clearTimeout(f),$=new A.$Vh({socket:z,initialChunk:O}),$.sendResume(),$.onDidDispose(()=>t("renderer disconnected")),v($),$.onSocketClose(()=>{T.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(U.isScheduled())return;T.isScheduled()&&U.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const v=u.pipeName;return new Promise((I,$)=>{const f=D.createConnection(v,()=>{f.removeListener("error",$);const y=new A.$Vh({socket:new p.$Wh(f,"extHost-renderer")});y.sendResume(),I(y)});f.once("error",$),f.on("close",()=>{t("renderer closed the socket")})})}}async function o(){const u=await g();return new class{constructor(){this.a=new A.$Uh,this.onMessage=this.a.event,this.b=!1,u.onMessage(v=>{(0,k.$wm)(v,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(v)})}send(v){this.b||u.send(v)}async drain(){if(u.drain)return u.drain()}}}function d(u){return new Promise(v=>{const I=u.onMessage($=>{I.dispose();const f=JSON.parse($.toString()),y=f.commit,L=b.default.commit;if(y&&L&&y!==L&&n(55),f.parentPid){let T=0;setInterval(function(){try{process.kill(f.parentPid,0),T=0}catch(j){j&&j.code==="EPERM"?(T++,T>=3&&t(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):t(`parent process ${f.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let U;try{U=globalThis._VSCODE_NODE_MODULES["native-watchdog"],U.start(f.parentPid)}catch(j){(0,P.$1)(j)}}u.send((0,k.$vm)(0)),v({protocol:u,initData:f})});u.send((0,k.$vm)(1))})}async function l(){const u=[];process.on("unhandledRejection",(T,U)=>{u.push(U),setTimeout(()=>{const j=u.indexOf(U);j>=0&&U.catch(F=>{u.splice(j,1),(0,P.$4)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),T&&(0,P.$1)(T))})},1e3)}),process.on("rejectionHandled",T=>{const U=u.indexOf(T);U>=0&&u.splice(U,1)}),process.on("uncaughtException",function(T){(0,P.$Z)(T)||(0,P.$1)(T)}),h.mark("code/extHost/willConnectToRenderer");const v=await o();h.mark("code/extHost/didConnectToRenderer");const I=await d(v);h.mark("code/extHost/didWaitForInitData");const{initData:$}=I;s(!!$.environment.extensionTestsLocationURI),$.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,$.environment.skipWorkspaceStorageLock=(0,c.boolean)(i.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(U){n(U)}fsExists(U){return w.Promises.exists(U)}fsRealpath(U){return(0,E.$xq)(U)}};let y=null;$.remote.authority&&i.transformURIs&&(y=(0,m.$5r)($.remote.authority));const L=new R.$8hc(I.protocol,$,f,y);t=T=>L.terminate(T)}l().catch(u=>console.log(u))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2af613979f646fc4dcebfeaedc7d14f138c7b072/core/vs/workbench/api/node/extensionHostProcess.js.map
