/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var G=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/assert","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],V=function(H){for(var e=[],L=0,T=H.length;L<T;L++)e[L]=G[H[L]];return e};define(G[22],V([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class L{static get(){const y=new Map,N=new Map,s=new Map,f=new Map;function t(h,i){h.has(i.detail)||h.set(i.detail,-i.timestamp)}function d(h,i){const n=h.get(i.detail);n&&(n>=0||h.set(i.detail,n+i.timestamp))}let $=[];typeof H=="function"&&typeof H.getStats=="function"&&($=H.getStats().slice(0).sort((h,i)=>h.timestamp-i.timestamp));for(const h of $)switch(h.type){case 10:t(y,h);break;case 11:case 12:d(y,h);break;case 21:t(N,h);break;case 22:d(N,h);break;case 33:t(s,h);break;case 34:d(s,h);break;case 31:t(f,h);break;case 32:d(f,h);break}let l=0;s.forEach(h=>l+=h);function u(h){const i=[];return h.forEach((n,r)=>i.push([r,n])),i}return{amdLoad:u(y),amdInvoke:u(N),nodeRequire:u(s),nodeEval:u(f),nodeRequireTotal:l}}static toMarkdownTable(y,N){let s="";const f=[];return y.forEach((t,d)=>{f[d]=t.length}),N.forEach(t=>{t.forEach((d,$)=>{typeof d>"u"&&(d=t[$]="-");const l=d.toString().length;f[$]=Math.max(l,f[$])})}),y.forEach((t,d)=>{s+=`| ${t+" ".repeat(f[d]-t.toString().length)} `}),s+=`|
`,y.forEach((t,d)=>{s+=`| ${"-".repeat(f[d])} `}),s+=`|
`,N.forEach(t=>{t.forEach((d,$)=>{typeof d<"u"&&(s+=`| ${d+" ".repeat(f[$]-d.toString().length)} `)}),s+=`|
`}),s}}e.$U=L}),define(G[4],V([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vd=e.$ud=e.$td=void 0;let L;function T(n){L=n}e.$td=T;function y(){return L}e.$ud=y;class N{constructor(){this.a=0,this.d=new WeakMap}b(r){return s([f(h("|  ",this.a)),r])}c(r){return r.hadValue?r.didChange?[f(" "),d($(r.oldValue,70),{color:"red",strikeThrough:!0}),f(" "),d($(r.newValue,60),{color:"green"})]:[f(" (unchanged)")]:[f(" "),d($(r.newValue,60),{color:"green"}),f(" (initial)")]}handleObservableChanged(r,m){console.log(...this.b([t("observable value changed"),d(r.debugName,{color:"BlueViolet"}),...this.c(m)]))}formatChanges(r){if(r.size!==0)return d(" (changed deps: "+[...r].map(m=>m.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const m=r.handleChange;this.d.set(r,new Set),r.handleChange=(k,M)=>(this.d.get(r).add(k),m.apply(r,[k,M]))}handleDerivedRecomputed(r,m){const k=this.d.get(r);console.log(...this.b([t("derived recomputed"),d(r.debugName,{color:"BlueViolet"}),...this.c(m),this.formatChanges(k),{data:[{fn:r._computeFn}]}])),k.clear()}handleFromEventObservableTriggered(r,m){console.log(...this.b([t("observable from event triggered"),d(r.debugName,{color:"BlueViolet"}),...this.c(m),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const m=r.handleChange;this.d.set(r,new Set),r.handleChange=(k,M)=>(this.d.get(r).add(k),m.apply(r,[k,M]))}handleAutorunTriggered(r){const m=this.d.get(r);console.log(...this.b([t("autorun"),d(r.debugName,{color:"BlueViolet"}),this.formatChanges(m),{data:[{fn:r._runFn}]}])),m.clear(),this.a++}handleAutorunFinished(r){this.a--}handleBeginTransaction(r){let m=r.getDebugName();m===void 0&&(m=""),console.log(...this.b([t("transaction"),d(m,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$vd=N;function s(n){const r=new Array,m=[];let k="";function M(S){if("length"in S)for(const g of S)g&&M(g);else"text"in S?(k+=`%c${S.text}`,r.push(S.style),S.data&&m.push(...S.data)):"data"in S&&m.push(...S.data)}M(n);const P=[k,...r];return P.push(...m),P}function f(n){return d(n,{color:"black"})}function t(n){return d(i(`${n}: `,10),{color:"black",bold:!0})}function d(n,r={color:"black"}){function m(M){return Object.entries(M).reduce((P,[S,g])=>`${P}${S}:${g};`,"")}const k={color:r.color};return r.strikeThrough&&(k["text-decoration"]="line-through"),r.bold&&(k["font-weight"]="bold"),{text:n,style:m(k)}}function $(n,r){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=r?`"${n}"`:`"${n.substr(0,r-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?l(n,r):u(n,r);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function l(n,r){let m="[ ",k=!0;for(const M of n){if(k||(m+=", "),m.length-5>r){m+="...";break}k=!1,m+=`${$(M,r-m.length)}`}return m+=" ]",m}function u(n,r){let m="{ ",k=!0;for(const[M,P]of Object.entries(n)){if(k||(m+=", "),m.length-5>r){m+="...";break}k=!1,m+=`${M}: ${$(P,r-m.length)}`}return m+=" }",m}function h(n,r){let m="";for(let k=1;k<=r;k++)m+=n;return m}function i(n,r){for(;n.length<r;)n+=" ";return n}}),define(G[5],V([0,1,4]),function(H,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=void 0;let T;function y(C){T=C}e.$Cd=y;let N;function s(C){N=C}e.$Dd=s;let f;function t(C){f=C}e.$Ed=t;class d{get TChange(){return null}reportChanges(){this.get()}read(b){return b?b.readObservable(this):this.get()}map(b,a){const I=a===void 0?void 0:b,F=a===void 0?b:a;return f({owner:I,debugName:()=>{const q=z(F);if(q!==void 0)return q;const W=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(F.toString());if(W)return`${this.debugName}.${W[2]}`;if(!I)return`${this.debugName} (mapped)`}},q=>F(this.read(q),q))}recomputeInitiallyAndOnChange(b,a){return b.add(T(this,a)),this}keepObserved(b){return b.add(N(this)),this}}e.$Fd=d;class $ extends d{constructor(){super(...arguments),this.c=new Set}addObserver(b){const a=this.c.size;this.c.add(b),a===0&&this.f()}removeObserver(b){this.c.delete(b)&&this.c.size===0&&this.g()}f(){}g(){}}e.$Gd=$;function l(C,b){const a=new r(C,b);try{C(a)}finally{a.finish()}}e.$Hd=l;let u;function h(C){if(u)C(u);else{const b=new r(C,void 0);u=b;try{C(b)}finally{b.finish(),u=void 0}}}e.$Id=h;async function i(C,b){const a=new r(C,b);try{await C(a)}finally{a.finish()}}e.$Jd=i;function n(C,b,a){C?b(C):l(b,a)}e.$Kd=n;class r{constructor(b,a){this._fn=b,this.b=a,this.a=[],(0,L.$ud)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():z(this._fn)}updateObserver(b,a){this.a.push({observer:b,observable:a}),b.beginUpdate(a)}finish(){const b=this.a;for(let a=0;a<b.length;a++){const{observer:I,observable:F}=b[a];I.endUpdate(F)}this.a=null,(0,L.$ud)()?.handleEndTransaction()}}e.$Ld=r;const m=new Map,k=new WeakMap;function M(C,b,a,I){const F=k.get(C);if(F)return F;const q=P(C,b,a,I);if(q){let K=m.get(q)??0;K++,m.set(q,K);const W=K===1?q:`${q}#${K}`;return k.set(C,W),W}}e.$Md=M;function P(C,b,a,I){const F=k.get(C);if(F)return F;const q=I?v(I)+".":"";let K;if(b!==void 0)if(typeof b=="function"){if(K=b(),K!==void 0)return q+K}else return q+b;if(a!==void 0&&(K=z(a),K!==void 0))return q+K;if(I!==void 0){for(const W in I)if(I[W]===C)return q+W}}const S=new Map,g=new WeakMap;function v(C){const b=g.get(C);if(b)return b;const a=O(C);let I=S.get(a)??0;I++,S.set(a,I);const F=I===1?a:`${a}#${I}`;return g.set(C,F),F}function O(C){const b=C.constructor;return b?b.name:"Object"}function z(C){const b=C.toString(),I=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(b);return(I?I[1]:void 0)?.trim()}e.$Nd=z;function D(C,b){return typeof C=="string"?new c(void 0,C,b):new c(C,void 0,b)}e.$Od=D;class c extends ${get debugName(){return M(this,this.d,void 0,this.b)??"ObservableValue"}constructor(b,a,I){super(),this.b=b,this.d=a,this.a=I}get(){return this.a}set(b,a,I){if(this.a===b)return;let F;a||(a=F=new r(()=>{},()=>`Setting ${this.debugName}`));try{const q=this.a;this.e(b),(0,L.$ud)()?.handleObservableChanged(this,{oldValue:q,newValue:b,change:I,didChange:!0,hadValue:!0});for(const K of this.c)a.updateObserver(K,this),K.handleChange(this,I)}finally{F&&F.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(b){this.a=b}}e.$Pd=c;function E(C,b){return typeof C=="string"?new j(void 0,C,b):new j(C,void 0,b)}e.$Qd=E;class j extends c{e(b){this.a!==b&&(this.a&&this.a.dispose(),this.a=b)}dispose(){this.a?.dispose()}}e.$Rd=j}),define(G[9],V([0,1,23,2,5,4]),function(H,e,L,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ed=e.$dd=e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=void 0;function s(i){return new u(void 0,i,void 0,void 0)}e.$$c=s;function f(i,n){return new u(i.debugName,n,void 0,void 0)}e.$_c=f;function t(i,n){return new u(i.debugName,n,i.createEmptyChangeSummary,i.handleChange)}e.$ad=t;function d(i,n){const r=new T.$Sc,m=t({debugName:i.debugName??(()=>(0,y.$Nd)(n)),createEmptyChangeSummary:i.createEmptyChangeSummary,handleChange:i.handleChange},(k,M)=>{r.clear(),n(k,M,r)});return(0,T.$Rc)(()=>{m.dispose(),r.dispose()})}e.$bd=d;function $(i){const n=new T.$Sc,r=f({debugName:()=>(0,y.$Nd)(i)||"(anonymous)"},m=>{n.clear(),i(m,n)});return(0,T.$Rc)(()=>{r.dispose(),n.dispose()})}e.$cd=$;var l;(function(i){i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(l||(l={}));class u{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const r=this.h();if(r!==void 0)return r}const n=(0,y.$Nd)(this._runFn);return n!==void 0?n:"(anonymous)"}constructor(n,r,m,k){this.h=n,this._runFn=r,this.i=m,this.j=k,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,N.$ud)()?.handleAutorunCreated(this),this.k(),(0,T.$Kc)(this)}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear(),(0,T.$Lc)(this)}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3;const r=this.c;try{if(!r){(0,N.$ud)()?.handleAutorunTriggered(this);const m=this.g;this.g=this.i?.(),this._runFn(this,m)}}finally{r||(0,N.$ud)()?.handleAutorunFinished(this);for(const m of this.f)m.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,L.$9c)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,r){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:r,didChange:k=>k===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const r=n.get();return this.e.add(n),this.f.delete(n),r}}e.$dd=u,function(i){i.Observer=u}(s||(e.$$c=s={}));function h(i,n){let r;return f({debugName:()=>(0,y.$Nd)(n)},m=>{const k=i.read(m),M=r;r=k,n({lastValue:M,newValue:k})})}e.$ed=h}),define(G[10],V([0,1,23,2,5,4]),function(H,e,L,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=void 0;const s=(i,n)=>i===n;function f(i,n){return n!==void 0?new h(i,void 0,n,void 0,void 0,void 0,s):new h(void 0,void 0,i,void 0,void 0,void 0,s)}e.$wd=f;function t(i,n){return new h(i.owner,i.debugName,n,void 0,void 0,i.onLastObserverRemoved,i.equalityComparer??s)}e.$xd=t;function d(i,n){return new h(i.owner,i.debugName,n,i.createEmptyChangeSummary,i.handleChange,void 0,i.equalityComparer??s)}e.$yd=d;function $(i,n){let r,m;n===void 0?(r=i,m=void 0):(m=i,r=n);const k=new T.$Sc;return new h(m,()=>(0,y.$Nd)(r)??"(anonymous)",M=>(k.clear(),r(M,k)),void 0,void 0,()=>k.dispose(),s)}e.$zd=$;function l(i,n){let r,m;n===void 0?(r=i,m=void 0):(m=i,r=n);const k=new T.$Sc;return new h(m,()=>(0,y.$Nd)(r)??"(anonymous)",M=>{k.clear();const P=r(M);return P&&k.add(P),P},void 0,void 0,()=>k.dispose(),s)}e.$Ad=l,(0,y.$Ed)(t);var u;(function(i){i[i.initial=0]="initial",i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(u||(u={}));class h extends y.$Gd{get debugName(){return(0,y.$Md)(this,this.p,this._computeFn,this.n)??"(anonymous)"}constructor(n,r,m,k,M,P=void 0,S){super(),this.n=n,this.p=r,this._computeFn=m,this.q=k,this.s=M,this.t=P,this.u=S,this.e=0,this.h=void 0,this.j=0,this.k=new Set,this.l=new Set,this.m=void 0,this.m=this.q?.(),(0,N.$ud)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.k)n.removeObserver(this);this.k.clear(),this.t?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.q?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.k)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.w()}while(this.e!==3);return this.h}}w(){if(this.e===3)return;const n=this.l;this.l=this.k,this.k=n;const r=this.e!==0,m=this.h;this.e=3;const k=this.m;this.m=this.q?.();try{this.h=this._computeFn(this,k)}finally{for(const P of this.l)P.removeObserver(this);this.l.clear()}const M=r&&!this.u(m,this.h);if((0,N.$ud)()?.handleDerivedRecomputed(this,{oldValue:m,newValue:this.h,change:void 0,didChange:M,hadValue:r}),M)for(const P of this.c)P.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.j++;const r=this.j===1;if(this.e===3&&(this.e=1,!r))for(const m of this.c)m.handlePossibleChange(this);if(r)for(const m of this.c)m.beginUpdate(this)}endUpdate(n){if(this.j--,this.j===0){const r=[...this.c];for(const m of r)m.endUpdate(this)}(0,L.$9c)(()=>this.j>=0)}handlePossibleChange(n){if(this.e===3&&this.k.has(n)&&!this.l.has(n)){this.e=1;for(const r of this.c)r.handlePossibleChange(this)}}handleChange(n,r){if(this.k.has(n)&&!this.l.has(n)){const m=this.s?this.s({changedObservable:n,change:r,didChange:M=>M===n},this.m):!0,k=this.e===3;if(m&&(this.e===1||k)&&(this.e=2,k))for(const M of this.c)M.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const r=n.get();return this.k.add(n),this.l.delete(n),r}addObserver(n){const r=!this.c.has(n)&&this.j>0;super.addObserver(n),r&&n.beginUpdate(this)}removeObserver(n){const r=this.c.has(n)&&this.j>0;super.removeObserver(n),r&&n.endUpdate(this)}}e.$Bd=h}),define(G[24],V([0,1,2,9,5,10,4]),function(H,e,L,T,y,N,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=void 0;function f(D){return new t(D)}e.$fd=f;class t extends y.$Fd{constructor(c){super(),this.a=c}get debugName(){return this.toString()}get(){return this.a}addObserver(c){}removeObserver(c){}toString(){return`Const: ${this.a}`}}function d(D){const c=(0,y.$Od)("promiseValue",{});return D.then(E=>{c.set({value:E},void 0)}),c}e.$gd=d;function $(D,c){return new Promise(E=>{let j=!1,C=!1;const b=D.map(I=>({isFinished:c(I),state:I})),a=(0,T.$$c)(I=>{const{isFinished:F,state:q}=b.read(I);F&&(j?a.dispose():C=!0,E(q))});j=!0,C&&a.dispose()})}e.$hd=$;function l(D,c){return new u(D,c)}e.$id=l;class u extends y.$Gd{constructor(c,E){super(),this.h=c,this._getValue=E,this.b=!1,this.l=j=>{const C=this._getValue(j),b=this.a,a=!this.b||b!==C;let I=!1;a&&(this.a=C,this.b&&(I=!0,(0,y.$Kd)(u.globalTransaction,F=>{(0,s.$ud)()?.handleFromEventObservableTriggered(this,{oldValue:b,newValue:C,change:void 0,didChange:a,hadValue:this.b});for(const q of this.c)F.updateObserver(q,this),q.handleChange(this,void 0)},()=>{const F=this.j();return"Event fired"+(F?`: ${F}`:"")})),this.b=!0),I||(0,s.$ud)()?.handleFromEventObservableTriggered(this,{oldValue:b,newValue:C,change:void 0,didChange:a,hadValue:this.b})}}j(){return(0,y.$Nd)(this._getValue)}get debugName(){const c=this.j();return"From Event"+(c?`: ${c}`:"")}f(){this.e=this.h(this.l)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.l(void 0),this.a):this._getValue(void 0)}}e.$jd=u,function(D){D.Observer=u;function c(E,j){let C=!1;u.globalTransaction===void 0&&(u.globalTransaction=E,C=!0);try{j()}finally{C&&(u.globalTransaction=void 0)}}D.batchEventsGlobally=c}(l||(e.$id=l={}));function h(D,c){return new i(D,c)}e.$kd=h;class i extends y.$Gd{constructor(c,E){super(),this.debugName=c,this.b=E,this.h=()=>{(0,y.$Hd)(j=>{for(const C of this.c)j.updateObserver(C,this),C.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function n(D){return typeof D=="string"?new r(D):new r(void 0,D)}e.$ld=n;class r extends y.$Gd{get debugName(){return(0,y.$Md)(this,this.a,void 0,this.b)??"Observable Signal"}constructor(c,E){super(),this.a=c,this.b=E}trigger(c,E){if(!c){(0,y.$Hd)(j=>{this.trigger(j,E)},()=>`Trigger signal ${this.debugName}`);return}for(const j of this.c)c.updateObserver(j,this),j.handleChange(this,E)}get(){}}function m(D,c,E){const j=(0,y.$Od)("debounced",void 0);let C;return E.add((0,T.$$c)(b=>{const a=D.read(b);C&&clearTimeout(C),C=setTimeout(()=>{(0,y.$Hd)(I=>{j.set(a,I)})},c)})),j}e.$md=m;function k(D,c,E){const j=(0,y.$Od)("triggeredRecently",!1);let C;return E.add(D(()=>{j.set(!0,void 0),C&&clearTimeout(C),C=setTimeout(()=>{j.set(!1,void 0)},c)})),j}e.$nd=k;function M(D){const c=new S(!1,void 0);return D.addObserver(c),(0,L.$Rc)(()=>{D.removeObserver(c)})}e.$od=M,(0,y.$Dd)(M);function P(D,c){const E=new S(!0,c);return D.addObserver(E),c?c(D.get()):D.reportChanges(),(0,L.$Rc)(()=>{D.removeObserver(E)})}e.$pd=P,(0,y.$Cd)(P);class S{constructor(c,E){this.b=c,this.c=E,this.a=0}beginUpdate(c){this.a++}endUpdate(c){this.a--,this.a===0&&this.b&&(this.c?this.c(c.get()):c.reportChanges())}handlePossibleChange(c){}handleChange(c,E){}}function g(D){let c;return(0,N.$wd)(j=>(c=D(j,c),c))}e.$qd=g;function v(D,c){let E;const j=(0,y.$Od)("derivedObservableWithWritableCache.counter",0),C=(0,N.$wd)(D,b=>(j.read(b),E=c(b,E),E));return Object.assign(C,{clearCache:b=>{E=void 0,j.set(j.get()+1,b)}})}e.$rd=v;function O(D,c,E,j){let C=new z(E,j);return(0,N.$xd)({debugName:()=>(0,y.$Md)(C,void 0,E,D),owner:D,onLastObserverRemoved:()=>{C.dispose(),C=new z(E)}},a=>(C.setItems(c.read(a)),C.getItems()))}e.$sd=O;class z{constructor(c,E){this.c=c,this.e=E,this.a=new Map,this.b=[]}dispose(){this.a.forEach(c=>c.store.dispose()),this.a.clear()}setItems(c){const E=[],j=new Set(this.a.keys());for(const C of c){const b=this.e?this.e(C):C;let a=this.a.get(b);if(a)j.delete(b);else{const I=new L.$Sc;a={out:this.c(C,I),store:I},this.a.set(b,a)}E.push(a.out)}for(const C of j)this.a.get(C).store.dispose(),this.a.delete(C);this.b=E}getItems(){return this.b}}}),define(G[11],V([0,1,5,10,9,24,4]),function(H,e,L,T,y,N,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return L.$Od}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return L.$Qd}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return L.$Hd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return L.$Kd}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return T.$wd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return T.$xd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return T.$yd}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return T.$zd}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return y.$$c}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return y.$ed}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return y.$ad}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return y.$cd}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return y.$_c}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return y.$bd}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return N.$fd}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return N.$md}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return N.$qd}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return N.$rd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return N.$od}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return N.$pd}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return N.$id}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return N.$gd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return N.$ld}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return N.$kd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return N.$hd}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return N.$nd}}),!1&&(0,s.$td)(new s.$vd)}),define(G[25],V([0,1,6,2]),function(H,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function y(P){const S=P;return S?typeof S.read=="function":!1}e.$8d=y;function N(P){const S=P;return S?[S.on,S.pause,S.resume,S.destroy].every(g=>typeof g=="function"):!1}e.$9d=N;function s(P){const S=P;return S?N(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.$0d=s;function f(P,S){return new t(P,S)}e.$$d=f;class t{constructor(S,g){this.e=S,this.f=g,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(g=>this.d.push(g))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(g=>g(S))}h(S){this.c.error.length===0?(0,L.$1)(S):this.c.error.slice(0).forEach(g=>g(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,g){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(g),this.resume();break;case"end":this.c.end.push(g),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(g),this.a.flowing&&this.k();break}}removeListener(S,g){if(this.a.destroyed)return;let v;switch(S){case"data":v=this.c.data;break;case"end":v=this.c.end;break;case"error":v=this.c.error;break}if(v){const O=v.indexOf(g);O>=0&&v.splice(O,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const g=[...this.d];this.d.length=0,g.forEach(v=>v())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(P,S){const g=[];let v;for(;(v=P.read())!==null;)g.push(v);return S(g)}e.$_d=d;function $(P,S,g){const v=[];let O;for(;(O=P.read())!==null&&v.length<g;)v.push(O);return O===null&&v.length>0?S(v):{read:()=>{if(v.length>0)return v.shift();if(typeof O<"u"){const z=O;return O=void 0,z}return P.read()}}}e.$ae=$;function l(P,S){return new Promise((g,v)=>{const O=[];u(P,{onData:z=>{S&&O.push(z)},onError:z=>{S?v(z):g(void 0)},onEnd:()=>{g(S?S(O):void 0)}})})}e.$be=l;function u(P,S,g){P.on("error",v=>{g?.isCancellationRequested||S.onError(v)}),P.on("end",()=>{g?.isCancellationRequested||S.onEnd()}),P.on("data",v=>{g?.isCancellationRequested||S.onData(v)})}e.$ce=u;function h(P,S){return new Promise((g,v)=>{const O=new T.$Sc,z=[],D=j=>{if(z.push(j),z.length>S)return O.dispose(),P.pause(),g({stream:P,buffer:z,ended:!1})},c=j=>(O.dispose(),v(j)),E=()=>(O.dispose(),g({stream:P,buffer:z,ended:!0}));O.add((0,T.$Rc)(()=>P.removeListener("error",c))),P.on("error",c),O.add((0,T.$Rc)(()=>P.removeListener("end",E))),P.on("end",E),O.add((0,T.$Rc)(()=>P.removeListener("data",D))),P.on("data",D)})}e.$de=h;function i(P,S){const g=f(S);return g.end(P),g}e.$ee=i;function n(){const P=f(()=>{throw new Error("not supported")});return P.end(),P}e.$fe=n;function r(P){let S=!1;return{read:()=>S?null:(S=!0,P)}}e.$ge=r;function m(P,S,g){const v=f(g);return u(P,{onData:O=>v.write(S.data(O)),onError:O=>v.error(S.error?S.error(O):O),onEnd:()=>v.end()}),v}e.$he=m;function k(P,S,g){let v=!1;return{read:()=>{const O=S.read();return v?O:(v=!0,O!==null?g([P,O]):P)}}}e.$ie=k;function M(P,S,g){let v=!1;const O=f(g);return u(S,{onData:z=>v?O.write(z):(v=!0,O.write(g([P,z]))),onError:z=>O.error(z),onEnd:()=>{v||(v=!0,O.write(P)),O.end()}}),O}e.$je=M}),define(G[12],V([0,1,26,25]),function(H,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const y=typeof Buffer<"u",N=new L.$V(()=>new Uint8Array(256));let s,f;class t{static alloc(a){return y?new t(Buffer.allocUnsafe(a)):new t(new Uint8Array(a))}static wrap(a){return y&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new t(a)}static fromString(a,I){return!(I?.dontUseNodeBuffer||!1)&&y?new t(Buffer.from(a)):(s||(s=new TextEncoder),new t(s.encode(a)))}static fromByteArray(a){const I=t.alloc(a.length);for(let F=0,q=a.length;F<q;F++)I.buffer[F]=a[F];return I}static concat(a,I){if(typeof I>"u"){I=0;for(let K=0,W=a.length;K<W;K++)I+=a[K].byteLength}const F=t.alloc(I);let q=0;for(let K=0,W=a.length;K<W;K++){const p=a[K];F.set(p,q),q+=p.byteLength}return F}constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}clone(){const a=t.alloc(this.byteLength);return a.set(this),a}toString(){return y?this.buffer.toString():(f||(f=new TextDecoder),f.decode(this.buffer))}slice(a,I){return new t(this.buffer.subarray(a,I))}set(a,I){if(a instanceof t)this.buffer.set(a.buffer,I);else if(a instanceof Uint8Array)this.buffer.set(a,I);else if(a instanceof ArrayBuffer)this.buffer.set(new Uint8Array(a),I);else if(ArrayBuffer.isView(a))this.buffer.set(new Uint8Array(a.buffer,a.byteOffset,a.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(a){return u(this.buffer,a)}writeUInt32BE(a,I){h(this.buffer,a,I)}readUInt32LE(a){return i(this.buffer,a)}writeUInt32LE(a,I){n(this.buffer,a,I)}readUInt8(a){return r(this.buffer,a)}writeUInt8(a,I){m(this.buffer,a,I)}indexOf(a,I=0){return d(this.buffer,a instanceof t?a.buffer:a,I)}}e.$ke=t;function d(b,a,I=0){const F=a.byteLength,q=b.byteLength;if(F===0)return 0;if(F===1)return b.indexOf(a[0]);if(F>q-I)return-1;const K=N.value;K.fill(a.length);for(let Q=0;Q<a.length;Q++)K[a[Q]]=a.length-Q-1;let W=I+a.length-1,p=W,_=-1;for(;W<q;)if(b[W]===a[p]){if(p===0){_=W;break}W--,p--}else W+=Math.max(a.length-p,K[b[W]]),p=a.length-1;return _}e.$le=d;function $(b,a){return b[a+0]<<0>>>0|b[a+1]<<8>>>0}e.$me=$;function l(b,a,I){b[I+0]=a&255,a=a>>>8,b[I+1]=a&255}e.$ne=l;function u(b,a){return b[a]*2**24+b[a+1]*2**16+b[a+2]*2**8+b[a+3]}e.$oe=u;function h(b,a,I){b[I+3]=a,a=a>>>8,b[I+2]=a,a=a>>>8,b[I+1]=a,a=a>>>8,b[I]=a}e.$pe=h;function i(b,a){return b[a+0]<<0>>>0|b[a+1]<<8>>>0|b[a+2]<<16>>>0|b[a+3]<<24>>>0}e.$qe=i;function n(b,a,I){b[I+0]=a&255,a=a>>>8,b[I+1]=a&255,a=a>>>8,b[I+2]=a&255,a=a>>>8,b[I+3]=a&255}e.$re=n;function r(b,a){return b[a]}e.$se=r;function m(b,a,I){b[I]=a}e.$te=m;function k(b){return T.$_d(b,a=>t.concat(a))}e.$ue=k;function M(b){return T.$ge(b)}e.$ve=M;function P(b){return T.$be(b,a=>t.concat(a))}e.$we=P;async function S(b){return b.ended?t.concat(b.buffer):t.concat([...b.buffer,await P(b.stream)])}e.$xe=S;function g(b){return T.$ee(b,a=>t.concat(a))}e.$ye=g;function v(b){return T.$he(b,{data:a=>typeof a=="string"?t.fromString(a):t.wrap(a)},a=>t.concat(a))}e.$ze=v;function O(b){return T.$$d(a=>t.concat(a),b)}e.$Ae=O;function z(b,a){return T.$ie(b,a,I=>t.concat(I))}e.$Be=z;function D(b,a){return T.$je(b,a,I=>t.concat(I))}e.$Ce=D;function c(b){let a=0,I=0,F=0;const q=new Uint8Array(Math.floor(b.length/4*3)),K=p=>{switch(I){case 3:q[F++]=a|p,I=0;break;case 2:q[F++]=a|p>>>2,a=p<<6,I=3;break;case 1:q[F++]=a|p>>>4,a=p<<4,I=2;break;default:a=p<<2,I=1}};for(let p=0;p<b.length;p++){const _=b.charCodeAt(p);if(_>=65&&_<=90)K(_-65);else if(_>=97&&_<=122)K(_-97+26);else if(_>=48&&_<=57)K(_-48+52);else if(_===43||_===45)K(62);else if(_===47||_===95)K(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${b[p]}`)}}const W=F;for(;I>0;)K(0);return t.wrap(q).slice(0,W)}e.$De=c;const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:b},a=!0,I=!1){const F=I?j:E;let q="";const K=b.byteLength%3;let W=0;for(;W<b.byteLength-K;W+=3){const p=b[W+0],_=b[W+1],Q=b[W+2];q+=F[p>>>2],q+=F[(p<<4|_>>>4)&63],q+=F[(_<<2|Q>>>6)&63],q+=F[Q&63]}if(K===1){const p=b[W+0];q+=F[p>>>2],q+=F[p<<4&63],a&&(q+="==")}else if(K===2){const p=b[W+0],_=b[W+1];q+=F[p>>>2],q+=F[(p<<4|_>>>4)&63],q+=F[_<<2&63],a&&(q+="=")}return q}e.$Ee=C}),define(G[27],V([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define(G[13],V([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.StringEOL=void 0;var L;(function(y){y[y.Unknown=0]="Unknown",y[y.Invalid=3]="Invalid",y[y.LF=1]="LF",y[y.CRLF=2]="CRLF"})(L||(e.StringEOL=L={}));function T(y){let N=0,s=0,f=0,t=0;for(let d=0,$=y.length;d<$;d++){const l=y.charCodeAt(d);l===13?(N===0&&(s=d),N++,d+1<$&&y.charCodeAt(d+1)===10?(t|=2,d++):t|=3,f=d+1):l===10&&(t|=1,N===0&&(s=d),N++,f=d+1)}return N===0&&(s=y.length),[N,s,y.length-f,t]}e.$wt=T}),define(G[14],V([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var L;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(L||(e.LanguageId=L={}));var T;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(T||(e.FontStyle=T={}));var y;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(y||(e.ColorId=y={}));var N;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(N||(e.StandardTokenType=N={}));var s;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(s||(e.MetadataConsts=s={}));class f{static getLanguageId(d){return(d&255)>>>0}static getTokenType(d){return(d&768)>>>8}static containsBalancedBrackets(d){return(d&1024)!==0}static getFontStyle(d){return(d&30720)>>>11}static getForeground(d){return(d&16744448)>>>15}static getBackground(d){return(d&4278190080)>>>24}static getClassNameFromMetadata(d){let l="mtk"+this.getForeground(d);const u=this.getFontStyle(d);return u&1&&(l+=" mtki"),u&2&&(l+=" mtkb"),u&4&&(l+=" mtku"),u&8&&(l+=" mtks"),l}static getInlineStyleFromMetadata(d,$){const l=this.getForeground(d),u=this.getFontStyle(d);let h=`color: ${$[l]};`;u&1&&(h+="font-style: italic;"),u&2&&(h+="font-weight: bold;");let i="";return u&4&&(i+=" underline"),u&8&&(i+=" line-through"),i&&(h+=`text-decoration:${i};`),h}static getPresentationFromMetadata(d){const $=this.getForeground(d),l=this.getFontStyle(d);return{foreground:$,italic:!!(l&1),bold:!!(l&2),underline:!!(l&4),strikethrough:!!(l&8)}}}e.$ut=f}),define(G[28],V([0,1,29]),function(H,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iC=void 0;class T{constructor(s){this.b=s,this.a=[]}get(s){return s<this.a.length?this.a[s]:this.b}set(s,f){for(;s>=this.a.length;)this.a[this.a.length]=this.b;this.a[s]=f}replace(s,f,t){if(s>=this.a.length)return;if(f===0){this.insert(s,t);return}else if(t===0){this.delete(s,f);return}const d=this.a.slice(0,s),$=this.a.slice(s+f),l=y(t,this.b);this.a=d.concat(l,$)}delete(s,f){f===0||s>=this.a.length||this.a.splice(s,f)}insert(s,f){if(f===0||s>=this.a.length)return;const t=[];for(let d=0;d<f;d++)t[d]=this.b;this.a=(0,L.$Wb)(this.a,s,t)}}e.$iC=T;function y(N,s){const f=[];for(let t=0;t<N;t++)f[t]=s;return f}}),define(G[7],V([0,1,14]),function(H,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=void 0;class T{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(s,f){const t=T.defaultTokenMetadata,d=new Uint32Array(2);return d[0]=s.length,d[1]=t,new T(d,s,f)}constructor(s,f,t){this._lineTokensBrand=void 0,this.a=s,this.b=this.a.length>>>1,this.c=f,this.d=t}equals(s){return s instanceof T?this.slicedEquals(s,0,this.b):!1}slicedEquals(s,f,t){if(this.c!==s.c||this.b!==s.b)return!1;const d=f<<1,$=d+(t<<1);for(let l=d;l<$;l++)if(this.a[l]!==s.a[l])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(s){return s>0?this.a[s-1<<1]:0}getMetadata(s){return this.a[(s<<1)+1]}getLanguageId(s){const f=this.a[(s<<1)+1],t=L.$ut.getLanguageId(f);return this.d.decodeLanguageId(t)}getStandardTokenType(s){const f=this.a[(s<<1)+1];return L.$ut.getTokenType(f)}getForeground(s){const f=this.a[(s<<1)+1];return L.$ut.getForeground(f)}getClassName(s){const f=this.a[(s<<1)+1];return L.$ut.getClassNameFromMetadata(f)}getInlineStyle(s,f){const t=this.a[(s<<1)+1];return L.$ut.getInlineStyleFromMetadata(t,f)}getPresentation(s){const f=this.a[(s<<1)+1];return L.$ut.getPresentationFromMetadata(f)}getEndOffset(s){return this.a[s<<1]}findTokenIndexAtOffset(s){return T.findIndexInTokensArray(this.a,s)}inflate(){return this}sliceAndInflate(s,f,t){return new y(this,s,f,t)}static convertToEndOffset(s,f){const d=(s.length>>>1)-1;for(let $=0;$<d;$++)s[$<<1]=s[$+1<<1];s[d<<1]=f}static findIndexInTokensArray(s,f){if(s.length<=2)return 0;let t=0,d=(s.length>>>1)-1;for(;t<d;){const $=t+Math.floor((d-t)/2),l=s[$<<1];if(l===f)return $+1;l<f?t=$+1:l>f&&(d=$)}return t}withInserted(s){if(s.length===0)return this;let f=0,t=0,d="";const $=new Array;let l=0;for(;;){const u=f<this.b?this.a[f<<1]:-1,h=t<s.length?s[t]:null;if(u!==-1&&(h===null||u<=h.offset)){d+=this.c.substring(l,u);const i=this.a[(f<<1)+1];$.push(d.length,i),f++,l=u}else if(h){if(h.offset>l){d+=this.c.substring(l,h.offset);const i=this.a[(f<<1)+1];$.push(d.length,i),l=h.offset}d+=h.text,$.push(d.length,h.tokenMetadata),t++}else break}return new T(new Uint32Array($),d,this.d)}}e.$xt=T;class y{constructor(s,f,t,d){this.a=s,this.b=f,this.c=t,this.d=d,this.e=s.findTokenIndexAtOffset(f),this.f=0;for(let $=this.e,l=s.getCount();$<l&&!(s.getStartOffset($)>=t);$++)this.f++}getMetadata(s){return this.a.getMetadata(this.e+s)}getLanguageId(s){return this.a.getLanguageId(this.e+s)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(s){return s instanceof y?this.b===s.b&&this.c===s.c&&this.d===s.d&&this.a.slicedEquals(s.a,this.e,this.f):!1}getCount(){return this.f}getForeground(s){return this.a.getForeground(this.e+s)}getEndOffset(s){const f=this.a.getEndOffset(this.e+s);return Math.min(this.c,f)-this.b+this.d}getClassName(s){return this.a.getClassName(this.e+s)}getInlineStyle(s,f){return this.a.getInlineStyle(this.e+s,f)}getPresentation(s){return this.a.getPresentation(this.e+s)}findTokenIndexAtOffset(s){return this.a.findTokenIndexAtOffset(s+this.b-this.d)-this.e}}}),define(G[30],V([0,1,7]),function(H,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.$zt=e.$yt=void 0,e.$yt=new Uint32Array(0).buffer;class T{static deleteBeginning(s,f){return s===null||s===e.$yt?s:T.delete(s,0,f)}static deleteEnding(s,f){if(s===null||s===e.$yt)return s;const t=y(s),d=t[t.length-2];return T.delete(s,f,d)}static delete(s,f,t){if(s===null||s===e.$yt||f===t)return s;const d=y(s),$=d.length>>>1;if(f===0&&d[d.length-2]===t)return e.$yt;const l=L.$xt.findIndexInTokensArray(d,f),u=l>0?d[l-1<<1]:0,h=d[l<<1];if(t<h){const k=t-f;for(let M=l;M<$;M++)d[M<<1]-=k;return s}let i,n;u!==f?(d[l<<1]=f,i=l+1<<1,n=f):(i=l<<1,n=u);const r=t-f;for(let k=l+1;k<$;k++){const M=d[k<<1]-r;M>n&&(d[i++]=M,d[i++]=d[(k<<1)+1],n=M)}if(i===d.length)return s;const m=new Uint32Array(i);return m.set(d.subarray(0,i),0),m.buffer}static append(s,f){if(f===e.$yt)return s;if(s===e.$yt)return f;if(s===null)return s;if(f===null)return null;const t=y(s),d=y(f),$=d.length>>>1,l=new Uint32Array(t.length+d.length);l.set(t,0);let u=t.length;const h=t[t.length-2];for(let i=0;i<$;i++)l[u++]=d[i<<1]+h,l[u++]=d[(i<<1)+1];return l.buffer}static insert(s,f,t){if(s===null||s===e.$yt)return s;const d=y(s),$=d.length>>>1;let l=L.$xt.findIndexInTokensArray(d,f);l>0&&d[l-1<<1]===f&&l--;for(let u=l;u<$;u++)d[u<<1]+=t;return s}}e.$zt=T;function y(N){return N instanceof Uint32Array?N:new Uint32Array(N)}e.$At=y}),define(G[31],V([0,1,29,12,44,13,30,15]),function(H,e,L,T,y,N,s,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=void 0;class t{static deserialize($,l,u){const h=new Uint32Array($.buffer),i=(0,T.$oe)($,l);l+=4;const n=(0,T.$oe)($,l);l+=4;const r=[];for(let m=0;m<n;m++){const k=(0,T.$oe)($,l);l+=4,r.push(h.subarray(l/4,l/4+k/4)),l+=k}return u.push(new t(i,r)),l}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor($,l){this.a=$,this.b=l}getLineRange(){return new f.$6s(this.a,this.a+this.b.length)}getLineTokens($){return this.b[$-this.a]}appendLineTokens($){this.b.push($)}serializeSize(){let $=0;$+=4,$+=4;for(let l=0;l<this.b.length;l++){const u=this.b[l];if(!(u instanceof Uint32Array))throw new Error("Not supported!");$+=4,$+=u.byteLength}return $}serialize($,l){(0,T.$pe)($,this.a,l),l+=4,(0,T.$pe)($,this.b.length,l),l+=4;for(let u=0;u<this.b.length;u++){const h=this.b[u];if(!(h instanceof Uint32Array))throw new Error("Not supported!");(0,T.$pe)($,h.byteLength,l),l+=4,$.set(new Uint8Array(h.buffer),l),l+=h.byteLength}return l}applyEdit($,l){const[u,h]=(0,N.$wt)(l);this.c($),this.d(new y.$Vs($.startLineNumber,$.startColumn),u,h)}c($){if($.startLineNumber===$.endLineNumber&&$.startColumn===$.endColumn)return;const l=$.startLineNumber-this.a,u=$.endLineNumber-this.a;if(u<0){const h=u-l;this.a-=h;return}if(!(l>=this.b.length)){if(l<0&&u>=this.b.length){this.a=0,this.b=[];return}if(l===u){this.b[l]=s.$zt.delete(this.b[l],$.startColumn-1,$.endColumn-1);return}if(l>=0)if(this.b[l]=s.$zt.deleteEnding(this.b[l],$.startColumn-1),u<this.b.length){const h=s.$zt.deleteBeginning(this.b[u],$.endColumn-1);this.b[l]=s.$zt.append(this.b[l],h),this.b.splice(l+1,u-l)}else this.b[l]=s.$zt.append(this.b[l],null),this.b=this.b.slice(0,l+1);else{const h=-l;this.a-=h,this.b[u]=s.$zt.deleteBeginning(this.b[u],$.endColumn-1),this.b=this.b.slice(u)}}}d($,l,u){if(l===0&&u===0)return;const h=$.lineNumber-this.a;if(h<0){this.a+=l;return}if(!(h>=this.b.length)){if(l===0){this.b[h]=s.$zt.insert(this.b[h],$.column-1,u);return}this.b[h]=s.$zt.deleteEnding(this.b[h],$.column-1),this.b[h]=s.$zt.insert(this.b[h],$.column-1,u),this.e($.lineNumber,l)}}e($,l){if(l===0)return;const u=[];for(let h=0;h<l;h++)u[h]=null;this.b=L.$Wb(this.b,$,u)}}e.$Bt=t}),define(G[16],V([0,1,12,31]),function(H,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jC=void 0;class y{static deserialize(s){let f=0;const t=(0,L.$oe)(s,f);f+=4;const d=[];for(let $=0;$<t;$++)f=T.$Bt.deserialize(s,f,d);return d}constructor(){this.a=[]}add(s,f){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===s){t.appendLineTokens(f);return}}this.a.push(new T.$Bt(s,[f]))}finalize(){return this.a}serialize(){const s=this.b(),f=new Uint8Array(s);return this.c(f),f}b(){let s=0;s+=4;for(let f=0;f<this.a.length;f++)s+=this.a[f].serializeSize();return s}c(s){let f=0;(0,L.$pe)(s,this.a.length,f),f+=4;for(let t=0;t<this.a.length;t++)f=this.a[t].serialize(s,f)}}e.$jC=y}),define(G[32],V([0,1,33,3,17,45]),function(H,e,L,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=void 0;function s(c){return c===47||c===92}e.$2f=s;function f(c){return c.replace(/[\\/]/g,L.$gc.sep)}e.$3f=f;function t(c){return c.indexOf("/")===-1&&(c=f(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.$4f=t;function d(c,E=L.$gc.sep){if(!c)return"";const j=c.length,C=c.charCodeAt(0);if(s(C)){if(s(c.charCodeAt(1))&&!s(c.charCodeAt(2))){let a=3;const I=a;for(;a<j&&!s(c.charCodeAt(a));a++);if(I!==a&&!s(c.charCodeAt(a+1))){for(a+=1;a<j;a++)if(s(c.charCodeAt(a)))return c.slice(0,a+1).replace(/[\\/]/g,E)}}return E}else if(m(C)&&c.charCodeAt(1)===58)return s(c.charCodeAt(2))?c.slice(0,2)+E:c.slice(0,2);let b=c.indexOf("://");if(b!==-1){for(b+=3;b<j;b++)if(s(c.charCodeAt(b)))return c.slice(0,b+1)}return""}e.$5f=d;function $(c){if(!T.$i||!c||c.length<5)return!1;let E=c.charCodeAt(0);if(E!==92||(E=c.charCodeAt(1),E!==92))return!1;let j=2;const C=j;for(;j<c.length&&(E=c.charCodeAt(j),E!==92);j++);return!(C===j||(E=c.charCodeAt(j+1),isNaN(E)||E===92))}e.$6f=$;const l=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function i(c,E=T.$i){const j=E?l:u;return!(!c||c.length===0||/^\s+$/.test(c)||(j.lastIndex=0,j.test(c))||E&&h.test(c)||c==="."||c===".."||E&&c[c.length-1]==="."||E&&c.length!==c.trim().length||c.length>255)}e.$7f=i;function n(c,E,j){const C=c===E;return!j||C?C:!c||!E?!1:(0,y.$af)(c,E)}e.$8f=n;function r(c,E,j,C=L.sep){if(c===E)return!0;if(!c||!E||E.length>c.length)return!1;if(j){if(!(0,y.$bf)(c,E))return!1;if(E.length===c.length)return!0;let a=E.length;return E.charAt(E.length-1)===C&&a--,c.charAt(a)===C}return E.charAt(E.length-1)!==C&&(E+=C),c.indexOf(E)===0}e.$9f=r;function m(c){return c>=65&&c<=90||c>=97&&c<=122}e.$0f=m;function k(c,E){return T.$i&&c.endsWith(":")&&(c+=L.sep),(0,L.$ic)(c)||(c=(0,L.$jc)(E,c)),c=(0,L.$hc)(c),T.$i?(c=(0,y.$Ve)(c,L.sep),c.endsWith(":")&&(c+=L.sep)):(c=(0,y.$Ve)(c,L.sep),c||(c=L.sep)),c}e.$$f=k;function M(c){const E=(0,L.$hc)(c);return T.$i?c.length>3?!1:P(E)&&(c.length===2||E.charCodeAt(2)===92):E===L.$gc.sep}e.$_f=M;function P(c,E=T.$i){return E?m(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.$ag=P;function S(c,E=T.$i){return P(c,E)?c[0]:void 0}e.$bg=S;function g(c,E,j){return E.length>c.length?-1:c===E?0:(j&&(c=c.toLowerCase(),E=E.toLowerCase()),c.indexOf(E))}e.$cg=g;function v(c){const E=c.split(":");let j,C,b;for(const a of E){const I=Number(a);(0,N.$Nf)(I)?C===void 0?C=I:b===void 0&&(b=I):j=j?[j,a].join(":"):a}if(!j)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:j,line:C!==void 0?C:void 0,column:b!==void 0?b:C!==void 0?1:void 0}}e.$dg=v;const O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",z="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(c,E,j=8){let C="";for(let a=0;a<j;a++){let I;a===0&&T.$i&&!E&&(j===3||j===4)?I=z:I=O,C+=I.charAt(Math.floor(Math.random()*I.length))}let b;return E?b=`${E}-${C}`:b=C,c?(0,L.$jc)(c,b):b}e.$eg=D}),define(G[18],V([0,1,6,3,17,8]),function(H,e,L,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.Schemas=void 0;var s;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(s||(e.Schemas=s={}));function f(u,h){return N.URI.isUri(u)?(0,y.$af)(u.scheme,h):(0,y.$bf)(u,h+":")}e.$fg=f;function t(u,...h){return h.some(i=>f(u,i))}e.$gg=t,e.$hg="vscode-tkn",e.$ig="tkn";class d{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${s.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${s.vscodeRemoteResource}`}set(h,i,n){this.a[h]=i,this.b[h]=n}setConnectionToken(h,i){this.c[h]=i}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(M){return L.$1(M),h}const i=h.authority;let n=this.a[i];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const r=this.b[i],m=this.c[i];let k=`path=${encodeURIComponent(h.path)}`;return typeof m=="string"&&(k+=`&${e.$ig}=${encodeURIComponent(m)}`),N.URI.from({scheme:T.$o?this.d:s.vscodeRemoteResource,authority:`${n}:${r}`,path:this.f,query:k})}}e.$jg=new d,e.$kg="vs/../../extensions",e.$lg="vs/../../node_modules",e.$mg="vs/../../node_modules.asar",e.$ng="vs/../../node_modules.asar.unpacked",e.$og="vscode-app";class ${static{this.a=e.$og}asBrowserUri(h){const i=this.b(h,H);return this.uriToBrowserUri(i)}uriToBrowserUri(h){return h.scheme===s.vscodeRemote?e.$jg.rewrite(h):h.scheme===s.file&&(T.$m||T.$q===`${s.vscodeFileResource}://${$.a}`)?h.with({scheme:s.vscodeFileResource,authority:h.authority||$.a,query:null,fragment:null}):h}asFileUri(h){const i=this.b(h,H);return this.uriToFileUri(i)}uriToFileUri(h){return h.scheme===s.vscodeFileResource?h.with({scheme:s.file,authority:h.authority!==$.a?h.authority:null,query:null,fragment:null}):h}b(h,i){return N.URI.isUri(h)?h:N.URI.parse(i.toUrl(h))}}e.$pg=new $;var l;(function(u){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(h.get("3"));const i="vscode-coi";function n(m){let k;typeof m=="string"?k=new URL(m).searchParams:m instanceof URL?k=m.searchParams:N.URI.isUri(m)&&(k=new URL(m.toString(!0)).searchParams);const M=k?.get(i);if(M)return h.get(M)}u.getHeadersFromQuery=n;function r(m,k,M){if(!globalThis.crossOriginIsolated)return;const P=k&&M?"3":M?"2":"1";m instanceof URLSearchParams?m.set(i,P):m[i]=P}u.addSearchParam=r})(l||(e.COI=l={}))}),define(G[34],V([0,1,22,18,3,8]),function(H,e,L,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jD=void 0;class s{constructor(u,h,i){this.id=u,this.dependencies=h,this.callback=i}}class f{static{this.INSTANCE=new f}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(u,h,i)=>{typeof u!="string"&&(i=h,h=u,u=null),(typeof h!="object"||!Array.isArray(h))&&(i=h,h=null),this.c.push(new s(u,h,i))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){if(u.startsWith(window.location.origin)||u.startsWith("vscode-file://vscode-app"))return u;throw new Error(`[trusted_script_src] Invalid script url: ${u}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){return u}})))}async load(u){this.g();const h=await(this.a?this.i(u):this.b?this.h(u):this.j(u));if(!h)throw new Error(`Did not receive a define call from script ${u}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${u}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(u){return new Promise((h,i)=>{const n=document.createElement("script");n.setAttribute("async","async"),n.setAttribute("type","text/javascript");const r=()=>{n.removeEventListener("load",m),n.removeEventListener("error",k)},m=M=>{r(),h(this.c.pop())},k=M=>{r(),i(M)};n.addEventListener("load",m),n.addEventListener("error",k),this.f&&(u=this.f.createScriptURL(u)),n.setAttribute("src",u),window.document.getElementsByTagName("head")[0].appendChild(n)})}i(u){return new Promise((h,i)=>{try{this.f&&(u=this.f.createScriptURL(u)),importScripts(u),h(this.c.pop())}catch(n){i(n)}})}async j(u){try{const h=globalThis._VSCODE_NODE_MODULES.fs,i=globalThis._VSCODE_NODE_MODULES.vm,n=globalThis._VSCODE_NODE_MODULES.module,r=N.URI.parse(u).fsPath,m=h.readFileSync(r).toString(),k=n.wrap(m.replace(/^#!.*/,""));return new i.Script(k).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const t=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function $(l,u,h){if(L.$T){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[l]&&(l=d[l]);const i=`${l}/${u}`;if(t.has(i))return t.get(i);let n;if(/^\w[\w\d+.-]*:\/\//.test(i))n=i;else{const M=`${h&&!y.$o?T.$mg:T.$lg}/${i}`;n=T.$pg.asBrowserUri(M).toString(!0)}const r=f.INSTANCE.load(n);return t.set(i,r),r}else return await new Promise((i,n)=>{H([l],i,n)})}e.$jD=$}),define(G[19],V([0,1,32,18,33,3,17,8]),function(H,e,L,T,y,N,s,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.DataUri=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=void 0;function t(h){return(0,f.$wc)(h,!0)}e.$wg=t;class d{constructor(i){this.a=i}compare(i,n,r=!1){return i===n?0:(0,s.$6e)(this.getComparisonKey(i,r),this.getComparisonKey(n,r))}isEqual(i,n,r=!1){return i===n?!0:!i||!n?!1:this.getComparisonKey(i,r)===this.getComparisonKey(n,r)}getComparisonKey(i,n=!1){return i.with({path:this.a(i)?i.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(i){return this.a(i)}isEqualOrParent(i,n,r=!1){if(i.scheme===n.scheme){if(i.scheme===T.Schemas.file)return L.$9f(t(i),t(n),this.a(i))&&i.query===n.query&&(r||i.fragment===n.fragment);if((0,e.$Ng)(i.authority,n.authority))return L.$9f(i.path,n.path,this.a(i),"/")&&i.query===n.query&&(r||i.fragment===n.fragment)}return!1}joinPath(i,...n){return f.URI.joinPath(i,...n)}basenameOrAuthority(i){return(0,e.$Fg)(i)||i.authority}basename(i){return y.$gc.basename(i.path)}extname(i){return y.$gc.extname(i.path)}dirname(i){if(i.path.length===0)return i;let n;return i.scheme===T.Schemas.file?n=f.URI.file(y.$mc(t(i))).path:(n=y.$gc.dirname(i.path),i.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),n="/")),i.with({path:n})}normalizePath(i){if(!i.path.length)return i;let n;return i.scheme===T.Schemas.file?n=f.URI.file(y.$hc(t(i))).path:n=y.$gc.normalize(i.path),i.with({path:n})}relativePath(i,n){if(i.scheme!==n.scheme||!(0,e.$Ng)(i.authority,n.authority))return;if(i.scheme===T.Schemas.file){const k=y.$lc(t(i),t(n));return N.$i?L.$3f(k):k}let r=i.path||"/";const m=n.path||"/";if(this.a(i)){let k=0;for(const M=Math.min(r.length,m.length);k<M&&!(r.charCodeAt(k)!==m.charCodeAt(k)&&r.charAt(k).toLowerCase()!==m.charAt(k).toLowerCase());k++);r=m.substr(0,k)+r.substr(k)}return y.$gc.relative(r,m)}resolvePath(i,n){if(i.scheme===T.Schemas.file){const r=f.URI.file(y.$kc(t(i),n));return i.with({authority:r.authority,path:r.path})}return n=L.$4f(n),i.with({path:y.$gc.resolve(i.path,n)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,n){return i===n||i!==void 0&&n!==void 0&&(0,s.$af)(i,n)}hasTrailingPathSeparator(i,n=y.sep){if(i.scheme===T.Schemas.file){const r=t(i);return r.length>L.$5f(r).length&&r[r.length-1]===n}else{const r=i.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,n=y.sep){return(0,e.$Og)(i,n)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,n=y.sep){let r=!1;if(i.scheme===T.Schemas.file){const m=t(i);r=m!==void 0&&m.length===L.$5f(m).length&&m[m.length-1]===n}else{n="/";const m=i.path;r=m.length===1&&m.charCodeAt(m.length-1)===47}return!r&&!(0,e.$Og)(i,n)?i.with({path:i.path+"/"}):i}}e.$xg=d,e.$yg=new d(()=>!1),e.$zg=new d(h=>h.scheme===T.Schemas.file?!N.$k:!0),e.$Ag=new d(h=>!0),e.$Bg=e.$yg.isEqual.bind(e.$yg),e.$Cg=e.$yg.isEqualOrParent.bind(e.$yg),e.$Dg=e.$yg.getComparisonKey.bind(e.$yg),e.$Eg=e.$yg.basenameOrAuthority.bind(e.$yg),e.$Fg=e.$yg.basename.bind(e.$yg),e.$Gg=e.$yg.extname.bind(e.$yg),e.$Hg=e.$yg.dirname.bind(e.$yg),e.$Ig=e.$yg.joinPath.bind(e.$yg),e.$Jg=e.$yg.normalizePath.bind(e.$yg),e.$Kg=e.$yg.relativePath.bind(e.$yg),e.$Lg=e.$yg.resolvePath.bind(e.$yg),e.$Mg=e.$yg.isAbsolutePath.bind(e.$yg),e.$Ng=e.$yg.isEqualAuthority.bind(e.$yg),e.$Og=e.$yg.hasTrailingPathSeparator.bind(e.$yg),e.$Pg=e.$yg.removeTrailingPathSeparator.bind(e.$yg),e.$Qg=e.$yg.addTrailingPathSeparator.bind(e.$yg);function $(h,i){const n=[];for(let r=0;r<h.length;r++){const m=i(h[r]);h.some((k,M)=>M===r?!1:(0,e.$Cg)(m,i(k)))||n.push(h[r])}return n}e.$Rg=$;var l;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function i(n){const r=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(M=>{const[P,S]=M.split(":");P&&S&&r.set(P,S)});const k=n.path.substring(0,n.path.indexOf(";"));return k&&r.set(h.META_DATA_MIME,k),r}h.parseMetaData=i})(l||(e.DataUri=l={}));function u(h,i,n){if(i){let r=h.path;return r&&r[0]!==y.$gc.sep&&(r=y.$gc.sep+r),h.with({scheme:n,authority:i,path:r})}return h.with({scheme:n})}e.$Sg=u}),define(G[20],V([0,1,46,6,35,2,19,3,27,26]),function(H,e,L,T,y,N,s,f,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.Promises=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0;function $(R){return!!R&&typeof R.then=="function"}e.$Tg=$;function l(R){const o=new L.$7d,w=R(o.token),A=new Promise((U,B)=>{const Y=o.token.onCancellationRequested(()=>{Y.dispose(),B(new T.$5)});Promise.resolve(w).then(J=>{Y.dispose(),o.dispose(),U(J)},J=>{Y.dispose(),o.dispose(),B(J)})});return new class{cancel(){o.cancel(),o.dispose()}then(U,B){return A.then(U,B)}catch(U){return this.then(void 0,U)}finally(U){return A.finally(U)}}}e.$Ug=l;function u(R,o,w){return new Promise((A,U)=>{const B=o.onCancellationRequested(()=>{B.dispose(),A(w)});R.then(A,U).finally(()=>B.dispose())})}e.$Vg=u;function h(R,o){return new Promise((w,A)=>{const U=o.onCancellationRequested(()=>{U.dispose(),A(new T.$5)});R.then(w,A).finally(()=>U.dispose())})}e.$Wg=h;async function i(R){let o=-1;const w=R.map((A,U)=>A.then(B=>(o=U,B)));try{return await Promise.race(w)}finally{R.forEach((A,U)=>{U!==o&&A.cancel()})}}e.$Xg=i;function n(R,o,w){let A;const U=setTimeout(()=>{A?.(void 0),w?.()},o);return Promise.race([R.finally(()=>clearTimeout(U)),new Promise(B=>A=B)])}e.$Yg=n;function r(R){return new Promise((o,w)=>{const A=R();$(A)?A.then(o,w):o(A)})}e.$Zg=r;function m(){let R,o;return{promise:new Promise((A,U)=>{R=A,o=U}),resolve:R,reject:o}}e.$1g=m;class k{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(o){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=o,!this.b){const w=()=>{if(this.b=null,this.f)return;const A=this.queue(this.d);return this.d=null,A};this.b=new Promise(A=>{this.a.then(w,w).then(A)})}return new Promise((w,A)=>{this.b.then(w,A)})}return this.a=o(),new Promise((w,A)=>{this.a.then(U=>{this.a=null,w(U)},U=>{this.a=null,A(U)})})}dispose(){this.f=!0}}e.$2g=k;class M{constructor(){this.a=Promise.resolve(null)}queue(o){return this.a=this.a.then(()=>o(),()=>o())}}e.$3g=M;class P{constructor(){this.a=new Map}queue(o,w){const U=(this.a.get(o)??Promise.resolve()).catch(()=>{}).then(w).finally(()=>{this.a.get(o)===U&&this.a.delete(o)});return this.a.set(o,U),U}}e.$4g=P;const S=(R,o)=>{let w=!0;const A=setTimeout(()=>{w=!1,o()},R);return{isTriggered:()=>w,dispose:()=>{clearTimeout(A),w=!1}}},g=R=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,R())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class v{constructor(o){this.defaultDelay=o,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(o,w=this.defaultDelay){this.g=o,this.h(),this.b||(this.b=new Promise((U,B)=>{this.d=U,this.f=B}).then(()=>{if(this.b=null,this.d=null,this.g){const U=this.g;return this.g=null,U()}}));const A=()=>{this.a=null,this.d?.(null)};return this.a=w===t.$Td?g(A):S(w,A),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$5g=v;class O{constructor(o){this.a=new v(o),this.b=new k}trigger(o,w){return this.a.trigger(()=>this.b.queue(o),w)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$6g=O;class z{constructor(){this.a=!1,this.b=new Promise((o,w)=>{this.d=o})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$7g=z;class D extends z{constructor(o){super(),this.f=setTimeout(()=>this.open(),o)}open(){clearTimeout(this.f),super.open()}}e.$8g=D;function c(R,o){return o?new Promise((w,A)=>{const U=setTimeout(()=>{B.dispose(),w()},R),B=o.onCancellationRequested(()=>{clearTimeout(U),B.dispose(),A(new T.$5)})}):l(w=>c(R,w))}e.$9g=c;function E(R,o=0,w){const A=setTimeout(()=>{R(),w&&U.dispose()},o),U=(0,N.$Rc)(()=>{clearTimeout(A),w?.deleteAndLeak(U)});return w?.add(U),U}e.$0g=E;function j(R){const o=[];let w=0;const A=R.length;function U(){return w<A?R[w++]():null}function B(Y){Y!=null&&o.push(Y);const J=U();return J?J.then(B):Promise.resolve(o)}return Promise.resolve(null).then(B)}e.$$g=j;function C(R,o=A=>!!A,w=null){let A=0;const U=R.length,B=()=>{if(A>=U)return Promise.resolve(w);const Y=R[A++];return Promise.resolve(Y()).then(X=>o(X)?Promise.resolve(X):B())};return B()}e.$_g=C;function b(R,o=A=>!!A,w=null){if(R.length===0)return Promise.resolve(w);let A=R.length;const U=()=>{A=-1;for(const B of R)B.cancel?.()};return new Promise((B,Y)=>{for(const J of R)J.then(X=>{--A>=0&&o(X)?(U(),B(X)):A===0&&B(w)}).catch(X=>{--A>=0&&(U(),Y(X))})})}e.$ah=b;class a{constructor(o){this.a=0,this.b=!1,this.f=o,this.g=[],this.d=0,this.h=new y.$Wd}whenIdle(){return this.size>0?y.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(o){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((w,A)=>{this.g.push({factory:o,c:w,e:A}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const o=this.g.shift();this.d++;const w=o.factory();w.then(o.c,o.e),w.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$bh=a;class I extends a{constructor(){super(1)}}e.$ch=I;class F{constructor(){this.a=new te,this.b=0}queue(o){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,o())):this.a.run(this.b++,o())}}e.$dh=F;class q{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const o=new x;return this.b.add(o),o.p}g(){for(const[,o]of this.a)if(o.size>0)return!1;return!0}queueSize(o,w=s.$yg){const A=w.getComparisonKey(o);return this.a.get(A)?.size??0}queueFor(o,w,A=s.$yg){const U=A.getComparisonKey(o);let B=this.a.get(U);if(!B){B=new I;const Y=this.f++,J=y.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(U),this.h(),this.d?.deleteAndDispose(Y),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$3c),this.d.set(Y,J),this.a.set(U,B)}return B.queue(w)}h(){this.g()&&this.j()}j(){for(const o of this.b)o.complete();this.b.clear()}dispose(){for(const[,o]of this.a)o.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$eh=q;class K{constructor(o,w){this.a=-1,typeof o=="function"&&typeof w=="number"&&this.setIfNotSet(o,w)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(o,w){this.cancel(),this.a=setTimeout(()=>{this.a=-1,o()},w)}setIfNotSet(o,w){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,o()},w))}}e.$fh=K;class W{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(o,w,A=globalThis){this.cancel();const U=A.setInterval(()=>{o()},w);this.d=(0,N.$Rc)(()=>{A.clearInterval(U),this.d=void 0})}dispose(){this.cancel()}}e.$gh=W;class p{constructor(o,w){this.b=-1,this.a=o,this.d=w,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(o=this.d){this.cancel(),this.b=setTimeout(this.f,o)}get delay(){return this.d}set delay(o){this.d=o}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$hh=p;class _{constructor(o,w){w%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${w}ms is not a multiple of 1000ms.`),this.a=o,this.b=w,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(o=this.b){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(o/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ih=_;class Q extends p{constructor(o,w){super(o,w),this.j=[]}work(o){this.j.push(o),this.isScheduled()||this.schedule()}h(){const o=this.j;this.j=[],this.a?.(o)}dispose(){this.j=[],super.dispose()}}e.$jh=Q;class he extends N.$Tc{constructor(o,w){super(),this.g=o,this.h=w,this.a=[],this.b=this.B(new N.$Uc),this.f=!1}get pending(){return this.a.length}work(o){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+o.length>this.g.maxBufferedWork)return!1}else if(this.pending+o.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const w of o)this.a.push(w);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new p(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$kh=he,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$mh=(R,o)=>{(0,f.$B)(()=>{if(w)return;const A=Date.now()+15;o(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,A-Date.now())}}))});let w=!1;return{dispose(){w||(w=!0)}}}:e.$mh=(R,o,w)=>{const A=R.requestIdleCallback(o,typeof w=="number"?{timeout:w}:void 0);let U=!1;return{dispose(){U||(U=!0,R.cancelIdleCallback(A))}}},e.$lh=R=>(0,e.$mh)(globalThis,R)}();class ee{constructor(o,w){this.g=!1,this.d=()=>{try{this.j=w()}catch(A){this.l=A}finally{this.g=!0}},this.f=(0,e.$mh)(o,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$nh=ee;class ue extends ee{constructor(o){super(globalThis,o)}}e.$oh=ue;async function oe(R,o,w){let A;for(let U=0;U<w;U++)try{return await R()}catch(B){A=B,await c(o)}throw A}e.$ph=oe;class te{isRunning(o){return typeof o=="number"?this.a?.taskId===o:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(o,w,A){return this.a={taskId:o,cancel:()=>A?.(),promise:w},w.then(()=>this.d(o),()=>this.d(o)),w}d(o){this.a&&o===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const o=this.b;this.b=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}queue(o){if(this.b)this.b.run=o;else{const{promise:w,resolve:A,reject:U}=m();this.b={run:o,promise:w,promiseResolve:A,promiseReject:U}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$qh=te;class ce{constructor(o,w=()=>Date.now()){this.d=o,this.f=w,this.a=0,this.b=0}increment(){const o=this.f();return o-this.a>this.d&&(this.a=o,this.b=0),this.b++,this.b}}e.$rh=ce;var ne;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((o,w)=>{this.a=o,this.b=w})}complete(o){return new Promise(w=>{this.a(o),this.d={outcome:0,value:o},w()})}error(o){return new Promise(w=>{this.b(o),this.d={outcome:1,value:o},w()})}cancel(){return this.error(new T.$5)}}e.$sh=x;var ie;(function(R){async function o(A){let U;const B=await Promise.all(A.map(Y=>Y.then(J=>J,J=>{U||(U=J)})));if(typeof U<"u")throw U;return B}R.settled=o;function w(A){return new Promise(async(U,B)=>{try{await A(U,B)}catch(Y){B(Y)}})}R.withAsyncBody=w})(ie||(e.Promises=ie={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(o){this.a=void 0,this.b=void 0,this.d=!1,this.promise=o.then(w=>(this.a=w,this.d=!0,w),w=>{throw this.b=w,this.d=!0,w})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$th=se;class de{constructor(o){this.b=o,this.a=new d.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$uh=de;var re;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(re||(re={}));class Z{static fromArray(o){return new Z(w=>{w.emitMany(o)})}static fromPromise(o){return new Z(async w=>{w.emitMany(await o)})}static fromPromises(o){return new Z(async w=>{await Promise.all(o.map(async A=>w.emitOne(await A)))})}static merge(o){return new Z(async w=>{await Promise.all(o.map(async A=>{for await(const U of A)w.emitOne(U)}))})}static{this.EMPTY=Z.fromArray([])}constructor(o){this.a=0,this.b=[],this.d=null,this.f=new y.$Wd,queueMicrotask(async()=>{const w={emitOne:A=>this.g(A),emitMany:A=>this.h(A),reject:A=>this.k(A)};try{await Promise.resolve(o(w)),this.j()}catch(A){this.k(A)}finally{w.emitOne=void 0,w.emitMany=void 0,w.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(o<this.b.length)return{done:!1,value:this.b[o++]};if(this.a===1)return{done:!0,value:void 0};await y.Event.toPromise(this.f.event)}while(!0)}}}static map(o,w){return new Z(async A=>{for await(const U of o)A.emitOne(w(U))})}map(o){return Z.map(this,o)}static filter(o,w){return new Z(async A=>{for await(const U of o)w(U)&&A.emitOne(U)})}filter(o){return Z.filter(this,o)}static coalesce(o){return Z.filter(o,w=>!!w)}coalesce(){return Z.coalesce(this)}static async toPromise(o){const w=[];for await(const A of o)w.push(A);return w}toPromise(){return Z.toPromise(this)}g(o){this.a===0&&(this.b.push(o),this.f.fire())}h(o){this.a===0&&(this.b=this.b.concat(o),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(o){this.a===0&&(this.a=2,this.d=o,this.f.fire())}}e.$vh=Z;class ae extends Z{constructor(o,w){super(w),this.l=o}cancel(){this.l.cancel()}}e.$wh=ae;function le(R){const o=new L.$7d,w=R(o.token);return new ae(o,async A=>{const U=o.token.onCancellationRequested(()=>{U.dispose(),o.dispose(),A.reject(new T.$5)});try{for await(const B of w){if(o.token.isCancellationRequested)return;A.emitOne(B)}U.dispose(),o.dispose()}catch(B){U.dispose(),o.dispose(),A.reject(B)}})}e.$xh=le;class fe{constructor(){this.a=new x,this.b=new Z(A=>{if(o){A.reject(o);return}return w&&A.emitMany(w),this.d=U=>A.reject(U),this.f=U=>A.emitOne(U),this.a.p});let o,w;this.f=A=>{w||(w=[]),w.push(A)},this.d=A=>{o||(o=A)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(o){this.d(o),this.a.complete()}emitOne(o){this.f(o)}}e.$yh=fe}),define(G[21],V([0,1,36]),function(H,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hC=e.$gC=e.$fC=void 0,e.$fC=new class{clone(){return this}equals(N){return this===N}};function T(N,s){return new L.$Ft([new L.$Et(0,"",N)],s)}e.$gC=T;function y(N,s){const f=new Uint32Array(2);return f[0]=0,f[1]=(N<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new L.$Gt(f,s===null?e.$fC:s)}e.$hC=y}),define(G[37],V([0,1,20,6,3,38,13,15,47,21,28,16,7]),function(H,e,L,T,y,N,s,f,t,d,$,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pC=e.$oC=e.$nC=e.$mC=e.$lC=e.$kC=void 0;var h;(function(S){S[S.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(h||(h={}));class i{constructor(g,v){this.tokenizationSupport=v,this.a=this.tokenizationSupport.getInitialState(),this.store=new r(g)}getStartState(g){return this.store.getStartState(g,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$kC=i;class n extends i{constructor(g,v,O,z){super(g,v),this._textModel=O,this._languageIdCodec=z}updateTokensUntilLine(g,v){const O=this._textModel.getLanguageId();for(;;){const z=this.getFirstInvalidLine();if(!z||z.lineNumber>v)break;const D=this._textModel.getLineContent(z.lineNumber),c=M(this._languageIdCodec,O,this.tokenizationSupport,D,!0,z.startState);g.add(z.lineNumber,c.tokens),this.store.setEndState(z.lineNumber,c.endState)}}getTokenTypeIfInsertingCharacter(g,v){const O=this.getStartState(g.lineNumber);if(!O)return 0;const z=this._textModel.getLanguageId(),D=this._textModel.getLineContent(g.lineNumber),c=D.substring(0,g.column-1)+v+D.substring(g.column-1),E=M(this._languageIdCodec,z,this.tokenizationSupport,c,!0,O),j=new u.$xt(E.tokens,c,this._languageIdCodec);if(j.getCount()===0)return 0;const C=j.findTokenIndexAtOffset(g.column-1);return j.getStandardTokenType(C)}tokenizeLineWithEdit(g,v,O){const z=g.lineNumber,D=g.column,c=this.getStartState(z);if(!c)return null;const E=this._textModel.getLineContent(z),j=E.substring(0,D-1)+O+E.substring(D-1+v),C=this._textModel.getLanguageIdAtPosition(z,0),b=M(this._languageIdCodec,C,this.tokenizationSupport,j,!0,c);return new u.$xt(b.tokens,j,this._languageIdCodec)}isCheapToTokenize(g){const v=this.store.getFirstInvalidEndStateLineNumberOrMax();return g<v||g===v&&this._textModel.getLineLength(g)<2048}tokenizeHeuristically(g,v,O){if(O<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(v<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(g,O),{heuristicTokens:!1};let z=this.b(v);const D=this._textModel.getLanguageId();for(let c=v;c<=O;c++){const E=this._textModel.getLineContent(c),j=M(this._languageIdCodec,D,this.tokenizationSupport,E,!0,z);g.add(c,j.tokens),z=j.endState}return{heuristicTokens:!0}}b(g){let v=this._textModel.getLineFirstNonWhitespaceColumn(g);const O=[];let z=null;for(let E=g-1;v>1&&E>=1;E--){const j=this._textModel.getLineFirstNonWhitespaceColumn(E);if(j!==0&&j<v&&(O.push(this._textModel.getLineContent(E)),v=j,z=this.getStartState(E),z))break}z||(z=this.tokenizationSupport.getInitialState()),O.reverse();const D=this._textModel.getLanguageId();let c=z;for(const E of O)c=M(this._languageIdCodec,D,this.tokenizationSupport,E,!1,c).endState;return c}}e.$lC=n;class r{constructor(g){this.d=g,this.a=new m,this.b=new k,this.b.addRange(new t.$4s(1,g+1))}getEndState(g){return this.a.getEndState(g)}setEndState(g,v){if(!v)throw new T.$cb("Cannot set null/undefined state");this.b.delete(g);const O=this.a.setEndState(g,v);return O&&g<this.d&&this.b.addRange(new t.$4s(g+1,g+2)),O}acceptChange(g,v){this.d+=v-g.length,this.a.acceptChange(g,v),this.b.addRangeAndResize(new t.$4s(g.startLineNumber,g.endLineNumberExclusive),v)}acceptChanges(g){for(const v of g){const[O]=(0,s.$wt)(v.text);this.acceptChange(new f.$6s(v.range.startLineNumber,v.range.endLineNumber+1),O+1)}}invalidateEndStateRange(g){this.b.addRange(new t.$4s(g.startLineNumber,g.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(g,v){return g===1?v:this.getEndState(g-1)}getFirstInvalidLine(g){const v=this.getFirstInvalidEndStateLineNumber();if(v===null)return null;const O=this.getStartState(v,g);if(!O)throw new T.$cb("Start state must be defined");return{lineNumber:v,startState:O}}}e.$mC=r;class m{constructor(){this.a=new $.$iC(null)}getEndState(g){return this.a.get(g)}setEndState(g,v){const O=this.a.get(g);return O&&O.equals(v)?!1:(this.a.set(g,v),!0)}acceptChange(g,v){let O=g.length;v>0&&O>0&&(O--,v--),this.a.replace(g.startLineNumber,O,v)}acceptChanges(g){for(const v of g){const[O]=(0,s.$wt)(v.text);this.acceptChange(new f.$6s(v.range.startLineNumber,v.range.endLineNumber+1),O+1)}}}e.$nC=m;class k{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const g=this.a[0];return g.start+1===g.endExclusive?this.a.shift():this.a[0]=new t.$4s(g.start+1,g.endExclusive),g.start}delete(g){const v=this.a.findIndex(O=>O.contains(g));if(v!==-1){const O=this.a[v];O.start===g?O.endExclusive===g+1?this.a.splice(v,1):this.a[v]=new t.$4s(g+1,O.endExclusive):O.endExclusive===g+1?this.a[v]=new t.$4s(O.start,g):this.a.splice(v,1,new t.$4s(O.start,g),new t.$4s(g+1,O.endExclusive))}}addRange(g){t.$4s.addRange(g,this.a)}addRangeAndResize(g,v){let O=0;for(;!(O>=this.a.length||g.start<=this.a[O].endExclusive);)O++;let z=O;for(;!(z>=this.a.length||g.endExclusive<this.a[z].start);)z++;const D=v-g.length;for(let c=z;c<this.a.length;c++)this.a[c]=this.a[c].delta(D);if(O===z){const c=new t.$4s(g.start,g.start+v);c.isEmpty||this.a.splice(O,0,c)}else{const c=Math.min(g.start,this.a[O].start),E=Math.max(g.endExclusive,this.a[z-1].endExclusive),j=new t.$4s(c,E+D);j.isEmpty?this.a.splice(O,z-O):this.a.splice(O,z-O,j)}}toString(){return this.a.map(g=>g.toString()).join(" + ")}}e.$oC=k;function M(S,g,v,O,z,D){let c=null;if(v)try{c=v.tokenizeEncoded(O,z,D.clone())}catch(E){(0,T.$1)(E)}return c||(c=(0,d.$hC)(S.encodeLanguageId(g),D)),u.$xt.convertToEndOffset(c.tokens,O.length),c}class P{constructor(g,v){this.b=g,this.d=v,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,L.$lh)(g=>{this.f=!1,this.h(g)}))}h(g){const v=Date.now()+g.timeRemaining(),O=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<v?(0,y.$B)(O):this.g())};O()}j(){const g=this.b._textModel.getLineCount(),v=new l.$jC,O=N.$Sd.create(!1);do if(O.elapsed()>1||this.l(v)>=g)break;while(this.k());this.d.setTokens(v.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(g){const v=this.b?.getFirstInvalidLine();return v?(this.b.updateTokensUntilLine(g,v.lineNumber),v.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(g,v){this.b.store.invalidateEndStateRange(new f.$6s(g,v))}}e.$pC=P}),define(G[39],V([0,1,35,2,38,14,36]),function(H,e,L,T,y,N,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GHb=void 0;class f extends T.$Tc{constructor(d,$,l,u,h,i,n){super(),this.c=d,this.f=$,this.g=l,this.h=u,this.j=h,this.m=i,this.n=n,this.a=[],this.b=this.B(new L.$Wd),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(d,$,l){throw new Error("Not supported!")}createBackgroundTokenizer(d,$){if(this.h)return this.h(d,$)}tokenizeEncoded(d,$,l){const u=Math.random()*1e4<1,h=this.n||u,i=h?new y.$Sd(!0):void 0,n=this.c.tokenizeLine2(d,l,500);if(h){const m=i.elapsed();(u||m>32)&&this.m(m,d.length,u)}if(n.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${d.substring(0,100)}`),new s.$Gt(n.tokens,l);if(this.g){const m=this.a,k=n.tokens;for(let M=0,P=k.length>>>1;M<P;M++){const S=k[(M<<1)+1],g=N.$ut.getLanguageId(S);m[g]||(m[g]=!0,this.b.fire(g))}}let r;return l.equals(n.ruleStack)?r=l:r=n.ruleStack,new s.$Gt(n.tokens,r)}}e.$GHb=f}),define(G[40],V([0,1,21,2,11]),function(H,e,L,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HHb=void 0;class N extends T.$Tc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(f,t,d){super(),this.a=f,this.b=t,this.c=d,this.B((0,y.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(f,t,d){throw new Error("Not supported!")}tokenizeEncoded(f,t,d){return f.length>=this.c.get()?(0,L.$hC)(this.a,d):this.b.tokenizeEncoded(f,t,d)}createBackgroundTokenizer(f,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(f,t)}}e.$HHb=N}),define(G[41],V([0,1,34,20,11,3,15,48,37,16,7,39,40]),function(H,e,L,T,y,N,s,f,t,d,$,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MHb=void 0;class h extends f.$nv{constructor(r,m,k,M,P,S,g,v){super(r,m,k,M),this.s=P,this.t=S,this.u=g,this.a=null,this.b=!1,this.c=(0,y.observableValue)(this,-1),this.q=new T.$hh(()=>this.w(),10),this.c.set(v,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(r,m){this.t=r,this.u=m,this.v()}onEvents(r){super.onEvents(r),this.a?.store.acceptChanges(r.changes),this.q.schedule()}acceptMaxTokenizationLineLength(r){this.c.set(r,void 0)}retokenize(r,m){this.a&&(this.a.store.invalidateEndStateRange(new s.$6s(r,m)),this.q.schedule())}async v(){this.a=null;const r=this.t,m=this.u,k=await this.s.getOrCreateGrammar(r,m);if(!(this.b||r!==this.t||m!==this.u||!k)){if(k.grammar){const M=new u.$HHb(this.u,new l.$GHb(k.grammar,k.initialState,!1,void 0,()=>!1,(P,S,g)=>{this.s.reportTokenizationTime(P,r,k.sourceExtensionId,S,g)},!1),this.c);this.a=new t.$kC(this.f.length,M)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:m}=await(0,L.$jD)("vscode-textmate","release/main.js");this.m=m}const r=new Date().getTime();for(;;){let m=0;const k=new d.$jC,M=new i;for(;;){const g=this.a.getFirstInvalidLine();if(g===null||m>200)break;m++;const v=this.f[g.lineNumber-1],O=this.a.tokenizationSupport.tokenizeEncoded(v,!0,g.startState);if(this.a.store.setEndState(g.lineNumber,O.endState)){const D=this.m(g.startState,O.endState);M.setState(g.lineNumber,D)}else M.setState(g.lineNumber,null);if($.$xt.convertToEndOffset(O.tokens,v.length),k.add(g.lineNumber,O.tokens),new Date().getTime()-r>20)break}if(m===0)break;const P=M.getStateDeltas();if(this.s.setTokensAndStates(this.h,k.serialize(),P),new Date().getTime()-r>20){(0,N.$B)(()=>this.w());return}}}}e.$MHb=h;class i{constructor(){this.a=-1,this.b=[]}setState(r,m){r===this.a+1?this.b[this.b.length-1].stateDeltas.push(m):this.b.push({startLineNumber:r,stateDeltas:[m]}),this.a=r}getStateDeltas(){return this.b}}}),define(G[42],V([0,1,19]),function(H,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JHb=void 0;class T{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(N){if(this.a[N.scopeName]){const s=this.a[N.scopeName];L.$Bg(s.location,N.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${N.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${N.location.toString()}`)}this.a[N.scopeName]=N}getGrammarDefinition(N){return this.a[N]||null}}e.$JHb=T}),define(G[43],V([0,1,2,42]),function(H,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LHb=e.$KHb=void 0,e.$KHb="No TM Grammar registered for this language.";class y extends L.$Tc{constructor(s,f,t,d){super(),this.a=s,this.b=t.INITIAL,this.c=new T.$JHb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:d,loadGrammar:async $=>{const l=this.c.getGrammarDefinition($);if(!l)return this.a.logTrace(`No grammar found for scope ${$}`),null;const u=l.location;try{const h=await this.a.readFile(u);return t.parseRawGrammar(h,u.path)}catch(h){return this.a.logError(`Unable to load and parse grammar for scope ${$} from ${u}`,h),null}},getInjections:$=>{const l=$.split(".");let u=[];for(let h=1;h<=l.length;h++){const i=l.slice(0,h).join(".");u=[...u,...this.f[i]||[]]}return u}}));for(const $ of f){if(this.c.register($),$.injectTo){for(const l of $.injectTo){let u=this.f[l];u||(this.f[l]=u=[]),u.push($.scopeName)}if($.embeddedLanguages)for(const l of $.injectTo){let u=this.g[l];u||(this.g[l]=u=[]),u.push($.embeddedLanguages)}}$.language&&this.h.set($.language,$.scopeName)}}has(s){return this.h.has(s)}setTheme(s,f){this.j.setTheme(s,f)}getColorMap(){return this.j.getColorMap()}async createGrammar(s,f){const t=this.h.get(s);if(typeof t!="string")throw new Error(e.$KHb);const d=this.c.getGrammarDefinition(t);if(!d)throw new Error(e.$KHb);const $=d.embeddedLanguages;if(this.g[t]){const h=this.g[t];for(const i of h)for(const n of Object.keys(i))$[n]=i[n]}const l=Object.keys($).length>0;let u;try{u=await this.j.loadGrammarWithConfiguration(t,f,{embeddedLanguages:$,tokenTypes:d.tokenTypes,balancedBracketSelectors:d.balancedBracketSelectors,unbalancedBracketSelectors:d.unbalancedBracketSelectors})}catch(h){throw h.message&&h.message.startsWith("No grammar provided for")?new Error(e.$KHb):h}return{languageId:s,grammar:u,initialState:this.b,containsEmbeddedLanguages:l,sourceExtensionId:d.sourceExtensionId}}}e.$LHb=y}),define(G[49],V([0,1,8,43,41]),function(H,e,L,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function N(f,t){return new s(f,t)}e.create=N;class s{constructor(t,d){this.f=d,this.b=new Map,this.c=[],this.a=t.host;const $=d.grammarDefinitions.map(l=>({location:L.URI.revive(l.location),language:l.language,scopeName:l.scopeName,embeddedLanguages:l.embeddedLanguages,tokenTypes:l.tokenTypes,injectTo:l.injectTo,balancedBracketSelectors:l.balancedBracketSelectors,unbalancedBracketSelectors:l.unbalancedBracketSelectors,sourceExtensionId:l.sourceExtensionId}));this.d=this.g($)}async g(t){const d=this.f.textmateMainUri,$=await new Promise((n,r)=>{H([d],n,r)}),l=await new Promise((n,r)=>{H([this.f.onigurumaMainUri],n,r)}),h=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await l.loadWASM(h);const i=Promise.resolve({createOnigScanner:n=>l.createOnigScanner(n),createOnigString:n=>l.createOnigString(n)});return new T.$LHb({logTrace:n=>{},logError:(n,r)=>console.error(n,r),readFile:n=>this.a.readFile(n)},t,$,i)}acceptNewModel(t){const d=L.URI.revive(t.uri),$=this;this.b.set(t.controllerId,new y.$MHb(d,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(l,u){const h=await $.d;return h?($.c[u]||($.c[u]=h.createGrammar(l,u)),$.c[u]):Promise.resolve(null)},setTokensAndStates(l,u,h){$.a.setTokensAndStates(t.controllerId,l,u,h)},reportTokenizationTime(l,u,h,i,n){$.a.reportTokenizationTime(l,u,h,i,n)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,d){this.b.get(t).onEvents(d)}retokenize(t,d,$){this.b.get(t).retokenize(d,$)}acceptModelLanguageChanged(t,d,$){this.b.get(t).onLanguageId(d,$)}acceptRemovedModel(t){const d=this.b.get(t);d&&(d.dispose(),this.b.delete(t))}async acceptTheme(t,d){(await this.d)?.setTheme(t,d)}acceptMaxTokenizationLineLength(t,d){this.b.get(t).acceptMaxTokenizationLineLength(d)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2af613979f646fc4dcebfeaedc7d14f138c7b072/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
